/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(438718),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36405),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50633),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53154),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53318),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61064),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(86179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(97147), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(104671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(114753),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(115244),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(115735),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(116003),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(116153),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(116644), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(116677),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(125615),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(126665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(129714), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(143240),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(144591),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(145583),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(146575),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(148067), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(149559),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(150551),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(151543),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(152535),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(153527),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(154519),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(155511), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(156216),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(156921),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(157626),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(158331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(159036), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(159087),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(264319), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(275835),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(276125),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(277562),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(277682), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(277923),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(279821),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(281475),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(284254),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(285079),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(285517), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(286342),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(286472), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(287014), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(294791), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(295836),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(296320),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(296804),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(297234),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(299568),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(299998), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(301346),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(303144),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(303882),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(307978), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(324251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(324867),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(328374),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(328622),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(328810),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(329787),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(330764),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(335392),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(339398),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(339718),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(340038), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(340895),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(341177),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(341555),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(341933),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(342283),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(342633),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(343336), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(344039),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(344443),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(344847),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(345251),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(345655),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(346470),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(346636),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(346735), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(346751),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(352123),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(385045), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(387963), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(390283), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(390435), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(391109),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(391269),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(391583),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(391737), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(392228),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(392528),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(393019),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(393510), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(394001),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(395127),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(395743),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(399465), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(400081),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(415688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(415988),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(416002),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(416023), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(416048), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(416358),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(416529),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(416700),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(416871),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(417042), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(418171),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(418374),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(418577),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(418780), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(418983), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(419123),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(420111),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(421934),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(422189),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(422444),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(422590),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(422769),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(424419),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(424978),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(426070),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(427162),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(427316),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(427492),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(427766),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(427972),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(428371),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(428741),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(428858),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(430091),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(430871),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(431651),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(431857),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(432724),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(433094),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(433211),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(434444),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(435224),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(436004),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(436702),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(437158),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(437938),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36404),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11616),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15224),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21126),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24624),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30802),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31652),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35954), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36326), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36352), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36378),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13277 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13277,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13714 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13714,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15568 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15568,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15580 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15580,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15592 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15592,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2649 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2649,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 9991 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 9991,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10003 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10003,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10015 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10015,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15611 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15611,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15612 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15612,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15613 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15613,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15614 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15614,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10107 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10107,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10108 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10108,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10109 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10109,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10110 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10110,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13281 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13281,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13854 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13854,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3918 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3918,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13279 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13279,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11615),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5389 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5389,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5388 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5388,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5398 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5398,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5387 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5387,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5386 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5386,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6943 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6943,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14012 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14012,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13278 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13278,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3970 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3970,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3968 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3968,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3969 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3969,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13864 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13864,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13862 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13862,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13863 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13863,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13289 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13289,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13290 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13290,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13709 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13709,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15563 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15563,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15575 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15575,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15587 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15587,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8445), // Rule ID 2646 //
     /*   8392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8419 */     // MIs[1] pattern
     /*   8419 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8422 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8429 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8443 */     GIR_RootConstrainSelectedInstOperands,
     /*   8444 */     // GIR_Coverage, 2646,
     /*   8444 */     GIR_EraseRootFromParent_Done,
     /*   8445 */   // Label 219: @8445
     /*   8445 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8503), // Rule ID 9988 //
     /*   8450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8477 */     // MIs[1] pattern
     /*   8477 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8480 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8487 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 9988,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 220: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8561), // Rule ID 10000 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8535 */     // MIs[1] pattern
     /*   8535 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8538 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8545 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8559 */     GIR_RootConstrainSelectedInstOperands,
     /*   8560 */     // GIR_Coverage, 10000,
     /*   8560 */     GIR_EraseRootFromParent_Done,
     /*   8561 */   // Label 221: @8561
     /*   8561 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8619), // Rule ID 10012 //
     /*   8566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8593 */     // MIs[1] pattern
     /*   8593 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8596 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8603 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8617 */     GIR_RootConstrainSelectedInstOperands,
     /*   8618 */     // GIR_Coverage, 10012,
     /*   8618 */     GIR_EraseRootFromParent_Done,
     /*   8619 */   // Label 222: @8619
     /*   8619 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8782), // Rule ID 13984 //
     /*   8624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8666 */     // MIs[1] Operand 2
     /*   8666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8683 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8781 */     // GIR_Coverage, 13984,
     /*   8781 */     GIR_EraseRootFromParent_Done,
     /*   8782 */   // Label 223: @8782
     /*   8782 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8945), // Rule ID 13981 //
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8829 */     // MIs[1] Operand 2
     /*   8829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8846 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8944 */     // GIR_Coverage, 13981,
     /*   8944 */     GIR_EraseRootFromParent_Done,
     /*   8945 */   // Label 224: @8945
     /*   8945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9095), // Rule ID 13990 //
     /*   8950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8983 */     // MIs[1] Operand 2
     /*   8983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9000 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9094 */     // GIR_Coverage, 13990,
     /*   9094 */     GIR_EraseRootFromParent_Done,
     /*   9095 */   // Label 225: @9095
     /*   9095 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9245), // Rule ID 13993 //
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9133 */     // MIs[1] Operand 2
     /*   9133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9150 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9244 */     // GIR_Coverage, 13993,
     /*   9244 */     GIR_EraseRootFromParent_Done,
     /*   9245 */   // Label 226: @9245
     /*   9245 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9395), // Rule ID 13989 //
     /*   9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9283 */     // MIs[1] Operand 2
     /*   9283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9300 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9326 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9394 */     // GIR_Coverage, 13989,
     /*   9394 */     GIR_EraseRootFromParent_Done,
     /*   9395 */   // Label 227: @9395
     /*   9395 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9558), // Rule ID 5371 //
     /*   9400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     // MIs[1] Operand 2
     /*   9446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9459 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9557 */     // GIR_Coverage, 5371,
     /*   9557 */     GIR_EraseRootFromParent_Done,
     /*   9558 */   // Label 228: @9558
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9721), // Rule ID 5368 //
     /*   9563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9609 */     // MIs[1] Operand 2
     /*   9609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9622 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9648 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9655 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9720 */     // GIR_Coverage, 5368,
     /*   9720 */     GIR_EraseRootFromParent_Done,
     /*   9721 */   // Label 229: @9721
     /*   9721 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9871), // Rule ID 5395 //
     /*   9726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9763 */     // MIs[1] Operand 2
     /*   9763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9776 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9870 */     // GIR_Coverage, 5395,
     /*   9870 */     GIR_EraseRootFromParent_Done,
     /*   9871 */   // Label 230: @9871
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10021), // Rule ID 5401 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9913 */     // MIs[1] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9926 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10020 */     // GIR_Coverage, 5401,
     /*  10020 */     GIR_EraseRootFromParent_Done,
     /*  10021 */   // Label 231: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10171), // Rule ID 5394 //
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10063 */     // MIs[1] Operand 2
     /*  10063 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10076 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10170 */     // GIR_Coverage, 5394,
     /*  10170 */     GIR_EraseRootFromParent_Done,
     /*  10171 */   // Label 232: @10171
     /*  10171 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10204), // Rule ID 13282 //
     /*  10176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10191 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10202 */     GIR_RootConstrainSelectedInstOperands,
     /*  10203 */     // GIR_Coverage, 13282,
     /*  10203 */     GIR_EraseRootFromParent_Done,
     /*  10204 */   // Label 233: @10204
     /*  10204 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10240), // Rule ID 13855 //
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10224 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10238 */     GIR_RootConstrainSelectedInstOperands,
     /*  10239 */     // GIR_Coverage, 13855,
     /*  10239 */     GIR_EraseRootFromParent_Done,
     /*  10240 */   // Label 234: @10240
     /*  10240 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10273), // Rule ID 98 //
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10260 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10271 */     GIR_RootConstrainSelectedInstOperands,
     /*  10272 */     // GIR_Coverage, 98,
     /*  10272 */     GIR_EraseRootFromParent_Done,
     /*  10273 */   // Label 235: @10273
     /*  10273 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10309), // Rule ID 3919 //
     /*  10278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10293 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10307 */     GIR_RootConstrainSelectedInstOperands,
     /*  10308 */     // GIR_Coverage, 3919,
     /*  10308 */     GIR_EraseRootFromParent_Done,
     /*  10309 */   // Label 236: @10309
     /*  10309 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10342), // Rule ID 13280 //
     /*  10314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10329 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10340 */     GIR_RootConstrainSelectedInstOperands,
     /*  10341 */     // GIR_Coverage, 13280,
     /*  10341 */     GIR_EraseRootFromParent_Done,
     /*  10342 */   // Label 237: @10342
     /*  10342 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10405), // Rule ID 15603 //
     /*  10347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10381 */     // MIs[1] pred
     /*  10381 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10392 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10403 */     GIR_RootConstrainSelectedInstOperands,
     /*  10404 */     // GIR_Coverage, 15603,
     /*  10404 */     GIR_EraseRootFromParent_Done,
     /*  10405 */   // Label 238: @10405
     /*  10405 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10468), // Rule ID 15604 //
     /*  10410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10444 */     // MIs[1] pred
     /*  10444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10455 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10466 */     GIR_RootConstrainSelectedInstOperands,
     /*  10467 */     // GIR_Coverage, 15604,
     /*  10467 */     GIR_EraseRootFromParent_Done,
     /*  10468 */   // Label 239: @10468
     /*  10468 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10531), // Rule ID 15605 //
     /*  10473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10507 */     // MIs[1] pred
     /*  10507 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10518 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10529 */     GIR_RootConstrainSelectedInstOperands,
     /*  10530 */     // GIR_Coverage, 15605,
     /*  10530 */     GIR_EraseRootFromParent_Done,
     /*  10531 */   // Label 240: @10531
     /*  10531 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10594), // Rule ID 15606 //
     /*  10536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10551 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10554 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10570 */     // MIs[1] pred
     /*  10570 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10581 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10592 */     GIR_RootConstrainSelectedInstOperands,
     /*  10593 */     // GIR_Coverage, 15606,
     /*  10593 */     GIR_EraseRootFromParent_Done,
     /*  10594 */   // Label 241: @10594
     /*  10594 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10627), // Rule ID 96 //
     /*  10599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10614 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10625 */     GIR_RootConstrainSelectedInstOperands,
     /*  10626 */     // GIR_Coverage, 96,
     /*  10626 */     GIR_EraseRootFromParent_Done,
     /*  10627 */   // Label 242: @10627
     /*  10627 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10690), // Rule ID 10099 //
     /*  10632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10651 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10654 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10670 */     // MIs[1] pred
     /*  10670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10677 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10688 */     GIR_RootConstrainSelectedInstOperands,
     /*  10689 */     // GIR_Coverage, 10099,
     /*  10689 */     GIR_EraseRootFromParent_Done,
     /*  10690 */   // Label 243: @10690
     /*  10690 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10753), // Rule ID 10100 //
     /*  10695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10733 */     // MIs[1] pred
     /*  10733 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10740 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10751 */     GIR_RootConstrainSelectedInstOperands,
     /*  10752 */     // GIR_Coverage, 10100,
     /*  10752 */     GIR_EraseRootFromParent_Done,
     /*  10753 */   // Label 244: @10753
     /*  10753 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10816), // Rule ID 10101 //
     /*  10758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10796 */     // MIs[1] pred
     /*  10796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10803 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 10101,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 245: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10879), // Rule ID 10102 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10859 */     // MIs[1] pred
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 10102,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 246: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10935), // Rule ID 13388 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13388,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 247: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10991), // Rule ID 13400 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10978 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10989 */     GIR_RootConstrainSelectedInstOperands,
     /*  10990 */     // GIR_Coverage, 13400,
     /*  10990 */     GIR_EraseRootFromParent_Done,
     /*  10991 */   // Label 248: @10991
     /*  10991 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11058), // Rule ID 13616 //
     /*  10996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     // MIs[1] imm
     /*  11020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11032 */     // MIs[2] Operand 1
     /*  11032 */     // No operand predicates
     /*  11032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11042 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11056 */     GIR_RootConstrainSelectedInstOperands,
     /*  11057 */     // GIR_Coverage, 13616,
     /*  11057 */     GIR_EraseRootFromParent_Done,
     /*  11058 */   // Label 249: @11058
     /*  11058 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11125), // Rule ID 13619 //
     /*  11063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     // MIs[1] imm
     /*  11087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11099 */     // MIs[2] Operand 1
     /*  11099 */     // No operand predicates
     /*  11099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11109 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 13619,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 250: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11181), // Rule ID 997 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 997,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 251: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11237), // Rule ID 1058 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11224 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11235 */     GIR_RootConstrainSelectedInstOperands,
     /*  11236 */     // GIR_Coverage, 1058,
     /*  11236 */     GIR_EraseRootFromParent_Done,
     /*  11237 */   // Label 252: @11237
     /*  11237 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11304), // Rule ID 2121 //
     /*  11242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11270 */     // MIs[1] imm
     /*  11270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11288 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11302 */     GIR_RootConstrainSelectedInstOperands,
     /*  11303 */     // GIR_Coverage, 2121,
     /*  11303 */     GIR_EraseRootFromParent_Done,
     /*  11304 */   // Label 253: @11304
     /*  11304 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11371), // Rule ID 2130 //
     /*  11309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11337 */     // MIs[1] imm
     /*  11337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11349 */     // MIs[2] Operand 1
     /*  11349 */     // No operand predicates
     /*  11349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11355 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11369 */     GIR_RootConstrainSelectedInstOperands,
     /*  11370 */     // GIR_Coverage, 2130,
     /*  11370 */     GIR_EraseRootFromParent_Done,
     /*  11371 */   // Label 254: @11371
     /*  11371 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11419), // Rule ID 13387 //
     /*  11376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11406 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11417 */     GIR_RootConstrainSelectedInstOperands,
     /*  11418 */     // GIR_Coverage, 13387,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 255: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11467), // Rule ID 13399 //
     /*  11424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11454 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11465 */     GIR_RootConstrainSelectedInstOperands,
     /*  11466 */     // GIR_Coverage, 13399,
     /*  11466 */     GIR_EraseRootFromParent_Done,
     /*  11467 */   // Label 256: @11467
     /*  11467 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11515), // Rule ID 996 //
     /*  11472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11502 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11513 */     GIR_RootConstrainSelectedInstOperands,
     /*  11514 */     // GIR_Coverage, 996,
     /*  11514 */     GIR_EraseRootFromParent_Done,
     /*  11515 */   // Label 257: @11515
     /*  11515 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11563), // Rule ID 1057 //
     /*  11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 1057,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 258: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11587), // Rule ID 94 //
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11580 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11585 */     GIR_RootConstrainSelectedInstOperands,
     /*  11586 */     // GIR_Coverage, 94,
     /*  11586 */     GIR_Done,
     /*  11587 */   // Label 259: @11587
     /*  11587 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11614), // Rule ID 1607 //
     /*  11592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11612 */     GIR_RootConstrainSelectedInstOperands,
     /*  11613 */     // GIR_Coverage, 1607,
     /*  11613 */     GIR_Done,
     /*  11614 */   // Label 260: @11614
     /*  11614 */   GIM_Reject,
     /*  11615 */ // Label 195: @11615
     /*  11615 */ GIM_Reject,
     /*  11616 */ // Label 157: @11616
     /*  11616 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15223),
     /*  11621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11627 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11815), // Rule ID 6964 //
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11669 */     // MIs[2] Operand 2
     /*  11669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11688 */     // MIs[3] Rn
     /*  11688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11693 */     // MIs[3] Operand 2
     /*  11693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11728 */     // MIs[5] Rn
     /*  11728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11733 */     // MIs[5] Operand 2
     /*  11733 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11752 */     // MIs[6] Rn
     /*  11752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11757 */     // MIs[6] Operand 2
     /*  11757 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11770 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11814 */     // GIR_Coverage, 6964,
     /*  11814 */     GIR_EraseRootFromParent_Done,
     /*  11815 */   // Label 262: @11815
     /*  11815 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12003), // Rule ID 14023 //
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11857 */     // MIs[2] Operand 2
     /*  11857 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11876 */     // MIs[3] Rn
     /*  11876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11881 */     // MIs[3] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11916 */     // MIs[5] Rn
     /*  11916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11921 */     // MIs[5] Operand 2
     /*  11921 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11936 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[6] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[6] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11956 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11958 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12002 */     // GIR_Coverage, 14023,
     /*  12002 */     GIR_EraseRootFromParent_Done,
     /*  12003 */   // Label 263: @12003
     /*  12003 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12139), // Rule ID 5385 //
     /*  12008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12041 */     // MIs[1] Operand 2
     /*  12041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12076 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12081 */     // MIs[3] Operand 2
     /*  12081 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12092 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12094 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12138 */     // GIR_Coverage, 5385,
     /*  12138 */     GIR_EraseRootFromParent_Done,
     /*  12139 */   // Label 264: @12139
     /*  12139 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12275), // Rule ID 5384 //
     /*  12144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12177 */     // MIs[1] Operand 2
     /*  12177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12212 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12217 */     // MIs[3] Operand 2
     /*  12217 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12230 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12274 */     // GIR_Coverage, 5384,
     /*  12274 */     GIR_EraseRootFromParent_Done,
     /*  12275 */   // Label 265: @12275
     /*  12275 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12411), // Rule ID 5397 //
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12313 */     // MIs[1] Operand 2
     /*  12313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12348 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12353 */     // MIs[3] Operand 2
     /*  12353 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12366 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12410 */     // GIR_Coverage, 5397,
     /*  12410 */     GIR_EraseRootFromParent_Done,
     /*  12411 */   // Label 266: @12411
     /*  12411 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12547), // Rule ID 5383 //
     /*  12416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12449 */     // MIs[1] Operand 2
     /*  12449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     // MIs[3] Operand 2
     /*  12489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12502 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12546 */     // GIR_Coverage, 5383,
     /*  12546 */     GIR_EraseRootFromParent_Done,
     /*  12547 */   // Label 267: @12547
     /*  12547 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12683), // Rule ID 5382 //
     /*  12552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12585 */     // MIs[1] Operand 2
     /*  12585 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12620 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     // MIs[3] Operand 2
     /*  12625 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12638 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12682 */     // GIR_Coverage, 5382,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 268: @12683
     /*  12683 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12846), // Rule ID 13983 //
     /*  12688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     // MIs[1] Operand 2
     /*  12730 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12747 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12845 */     // GIR_Coverage, 13983,
     /*  12845 */     GIR_EraseRootFromParent_Done,
     /*  12846 */   // Label 269: @12846
     /*  12846 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13009), // Rule ID 13980 //
     /*  12851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12893 */     // MIs[1] Operand 2
     /*  12893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12910 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13008 */     // GIR_Coverage, 13980,
     /*  13008 */     GIR_EraseRootFromParent_Done,
     /*  13009 */   // Label 270: @13009
     /*  13009 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13159), // Rule ID 13988 //
     /*  13014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13047 */     // MIs[1] Operand 2
     /*  13047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13064 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 13988,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 271: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13309), // Rule ID 13992 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13308 */     // GIR_Coverage, 13992,
     /*  13308 */     GIR_EraseRootFromParent_Done,
     /*  13309 */   // Label 272: @13309
     /*  13309 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13459), // Rule ID 13987 //
     /*  13314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13347 */     // MIs[1] Operand 2
     /*  13347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13364 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13458 */     // GIR_Coverage, 13987,
     /*  13458 */     GIR_EraseRootFromParent_Done,
     /*  13459 */   // Label 273: @13459
     /*  13459 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13622), // Rule ID 5370 //
     /*  13464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13510 */     // MIs[1] Operand 2
     /*  13510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13523 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13523 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13526 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13530 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13549 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13556 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13621 */     // GIR_Coverage, 5370,
     /*  13621 */     GIR_EraseRootFromParent_Done,
     /*  13622 */   // Label 274: @13622
     /*  13622 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13785), // Rule ID 5367 //
     /*  13627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13673 */     // MIs[1] Operand 2
     /*  13673 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13686 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13712 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13784 */     // GIR_Coverage, 5367,
     /*  13784 */     GIR_EraseRootFromParent_Done,
     /*  13785 */   // Label 275: @13785
     /*  13785 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13935), // Rule ID 5393 //
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13827 */     // MIs[1] Operand 2
     /*  13827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13934 */     // GIR_Coverage, 5393,
     /*  13934 */     GIR_EraseRootFromParent_Done,
     /*  13935 */   // Label 276: @13935
     /*  13935 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14085), // Rule ID 5400 //
     /*  13940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13977 */     // MIs[1] Operand 2
     /*  13977 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13990 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14084 */     // GIR_Coverage, 5400,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 277: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14235), // Rule ID 5392 //
     /*  14090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14127 */     // MIs[1] Operand 2
     /*  14127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14140 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14234 */     // GIR_Coverage, 5392,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 278: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14304), // Rule ID 13422 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14287 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14302 */     GIR_RootConstrainSelectedInstOperands,
     /*  14303 */     // GIR_Coverage, 13422,
     /*  14303 */     GIR_EraseRootFromParent_Done,
     /*  14304 */   // Label 279: @14304
     /*  14304 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14373), // Rule ID 13434 //
     /*  14309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14356 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13434,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 280: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14429), // Rule ID 13384 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13384,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 281: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14485), // Rule ID 13396 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14472 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14483 */     GIR_RootConstrainSelectedInstOperands,
     /*  14484 */     // GIR_Coverage, 13396,
     /*  14484 */     GIR_EraseRootFromParent_Done,
     /*  14485 */   // Label 282: @14485
     /*  14485 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14552), // Rule ID 13636 //
     /*  14490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     // MIs[1] imm
     /*  14514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14526 */     // MIs[2] Operand 1
     /*  14526 */     // No operand predicates
     /*  14526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14536 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 13636,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 283: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14619), // Rule ID 13657 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     // MIs[1] imm
     /*  14581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14593 */     // MIs[2] Operand 1
     /*  14593 */     // No operand predicates
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14603 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14617 */     GIR_RootConstrainSelectedInstOperands,
     /*  14618 */     // GIR_Coverage, 13657,
     /*  14618 */     GIR_EraseRootFromParent_Done,
     /*  14619 */   // Label 284: @14619
     /*  14619 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14688), // Rule ID 1365 //
     /*  14624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14671 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 1365,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 285: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14757), // Rule ID 1488 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14740 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 1488,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 286: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14813), // Rule ID 993 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 993,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 287: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14869), // Rule ID 1054 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14837 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14840 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14856 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14867 */     GIR_RootConstrainSelectedInstOperands,
     /*  14868 */     // GIR_Coverage, 1054,
     /*  14868 */     GIR_EraseRootFromParent_Done,
     /*  14869 */   // Label 288: @14869
     /*  14869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14936), // Rule ID 2238 //
     /*  14874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14902 */     // MIs[1] imm
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14914 */     // MIs[2] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14920 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14934 */     GIR_RootConstrainSelectedInstOperands,
     /*  14935 */     // GIR_Coverage, 2238,
     /*  14935 */     GIR_EraseRootFromParent_Done,
     /*  14936 */   // Label 289: @14936
     /*  14936 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15003), // Rule ID 2297 //
     /*  14941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14969 */     // MIs[1] imm
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14981 */     // MIs[2] Operand 1
     /*  14981 */     // No operand predicates
     /*  14981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14987 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15001 */     GIR_RootConstrainSelectedInstOperands,
     /*  15002 */     // GIR_Coverage, 2297,
     /*  15002 */     GIR_EraseRootFromParent_Done,
     /*  15003 */   // Label 290: @15003
     /*  15003 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15051), // Rule ID 13383 //
     /*  15008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15038 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15049 */     GIR_RootConstrainSelectedInstOperands,
     /*  15050 */     // GIR_Coverage, 13383,
     /*  15050 */     GIR_EraseRootFromParent_Done,
     /*  15051 */   // Label 291: @15051
     /*  15051 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15099), // Rule ID 13395 //
     /*  15056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15086 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 13395,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 292: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15147), // Rule ID 992 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15134 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15145 */     GIR_RootConstrainSelectedInstOperands,
     /*  15146 */     // GIR_Coverage, 992,
     /*  15146 */     GIR_EraseRootFromParent_Done,
     /*  15147 */   // Label 293: @15147
     /*  15147 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15195), // Rule ID 1053 //
     /*  15152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15182 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15193 */     GIR_RootConstrainSelectedInstOperands,
     /*  15194 */     // GIR_Coverage, 1053,
     /*  15194 */     GIR_EraseRootFromParent_Done,
     /*  15195 */   // Label 294: @15195
     /*  15195 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15222), // Rule ID 1104 //
     /*  15200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15215 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 1104,
     /*  15221 */     GIR_Done,
     /*  15222 */   // Label 295: @15222
     /*  15222 */   GIM_Reject,
     /*  15223 */ // Label 261: @15223
     /*  15223 */ GIM_Reject,
     /*  15224 */ // Label 158: @15224
     /*  15224 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21125),
     /*  15229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15235 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15353), // Rule ID 13565 //
     /*  15240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15308 */     // MIs[4] Operand 1
     /*  15308 */     // No operand predicates
     /*  15308 */     // MIs[2] Operand 2
     /*  15308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15332 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15351 */     GIR_RootConstrainSelectedInstOperands,
     /*  15352 */     // GIR_Coverage, 13565,
     /*  15352 */     GIR_EraseRootFromParent_Done,
     /*  15353 */   // Label 297: @15353
     /*  15353 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15471), // Rule ID 13566 //
     /*  15358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15422 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15426 */     // MIs[4] Operand 1
     /*  15426 */     // No operand predicates
     /*  15426 */     // MIs[2] Operand 2
     /*  15426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15450 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15469 */     GIR_RootConstrainSelectedInstOperands,
     /*  15470 */     // GIR_Coverage, 13566,
     /*  15470 */     GIR_EraseRootFromParent_Done,
     /*  15471 */   // Label 298: @15471
     /*  15471 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15589), // Rule ID 13601 //
     /*  15476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15544 */     // MIs[4] Operand 1
     /*  15544 */     // No operand predicates
     /*  15544 */     // MIs[2] Operand 2
     /*  15544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15587 */     GIR_RootConstrainSelectedInstOperands,
     /*  15588 */     // GIR_Coverage, 13601,
     /*  15588 */     GIR_EraseRootFromParent_Done,
     /*  15589 */   // Label 299: @15589
     /*  15589 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15707), // Rule ID 13602 //
     /*  15594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15662 */     // MIs[4] Operand 1
     /*  15662 */     // No operand predicates
     /*  15662 */     // MIs[2] Operand 2
     /*  15662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15686 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13602,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 300: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15825), // Rule ID 2042 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15784 */     // MIs[4] Operand 1
     /*  15784 */     // No operand predicates
     /*  15784 */     // MIs[2] Operand 2
     /*  15784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15804 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15823 */     GIR_RootConstrainSelectedInstOperands,
     /*  15824 */     // GIR_Coverage, 2042,
     /*  15824 */     GIR_EraseRootFromParent_Done,
     /*  15825 */   // Label 301: @15825
     /*  15825 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15943), // Rule ID 13564 //
     /*  15830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15902 */     // MIs[4] Operand 1
     /*  15902 */     // No operand predicates
     /*  15902 */     // MIs[2] Operand 2
     /*  15902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15941 */     GIR_RootConstrainSelectedInstOperands,
     /*  15942 */     // GIR_Coverage, 13564,
     /*  15942 */     GIR_EraseRootFromParent_Done,
     /*  15943 */   // Label 302: @15943
     /*  15943 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16061), // Rule ID 2094 //
     /*  15948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16016 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16020 */     // MIs[4] Operand 1
     /*  16020 */     // No operand predicates
     /*  16020 */     // MIs[2] Operand 2
     /*  16020 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16059 */     GIR_RootConstrainSelectedInstOperands,
     /*  16060 */     // GIR_Coverage, 2094,
     /*  16060 */     GIR_EraseRootFromParent_Done,
     /*  16061 */   // Label 303: @16061
     /*  16061 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16179), // Rule ID 13600 //
     /*  16066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16134 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16138 */     // MIs[4] Operand 1
     /*  16138 */     // No operand predicates
     /*  16138 */     // MIs[2] Operand 2
     /*  16138 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16149 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16158 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 13600,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 304: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16266), // Rule ID 13466 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16211 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16214 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16223 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16247 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 13466,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 305: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16353), // Rule ID 13494 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16298 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16301 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16351 */     GIR_RootConstrainSelectedInstOperands,
     /*  16352 */     // GIR_Coverage, 13494,
     /*  16352 */     GIR_EraseRootFromParent_Done,
     /*  16353 */   // Label 306: @16353
     /*  16353 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16440), // Rule ID 1699 //
     /*  16358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16389 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16392 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16401 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16421 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16438 */     GIR_RootConstrainSelectedInstOperands,
     /*  16439 */     // GIR_Coverage, 1699,
     /*  16439 */     GIR_EraseRootFromParent_Done,
     /*  16440 */   // Label 307: @16440
     /*  16440 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16527), // Rule ID 1777 //
     /*  16445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16508 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16525 */     GIR_RootConstrainSelectedInstOperands,
     /*  16526 */     // GIR_Coverage, 1777,
     /*  16526 */     GIR_EraseRootFromParent_Done,
     /*  16527 */   // Label 308: @16527
     /*  16527 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16642), // Rule ID 13560 //
     /*  16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16600 */     // MIs[4] Operand 1
     /*  16600 */     // No operand predicates
     /*  16600 */     // MIs[2] Operand 2
     /*  16600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16622 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16640 */     GIR_RootConstrainSelectedInstOperands,
     /*  16641 */     // GIR_Coverage, 13560,
     /*  16641 */     GIR_EraseRootFromParent_Done,
     /*  16642 */   // Label 309: @16642
     /*  16642 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16757), // Rule ID 13559 //
     /*  16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16716 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16720 */     // MIs[4] Operand 1
     /*  16720 */     // No operand predicates
     /*  16720 */     // MIs[2] Operand 2
     /*  16720 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16737 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16755 */     GIR_RootConstrainSelectedInstOperands,
     /*  16756 */     // GIR_Coverage, 13559,
     /*  16756 */     GIR_EraseRootFromParent_Done,
     /*  16757 */   // Label 310: @16757
     /*  16757 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16872), // Rule ID 13596 //
     /*  16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16826 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16830 */     // MIs[4] Operand 1
     /*  16830 */     // No operand predicates
     /*  16830 */     // MIs[2] Operand 2
     /*  16830 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16870 */     GIR_RootConstrainSelectedInstOperands,
     /*  16871 */     // GIR_Coverage, 13596,
     /*  16871 */     GIR_EraseRootFromParent_Done,
     /*  16872 */   // Label 311: @16872
     /*  16872 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16987), // Rule ID 13595 //
     /*  16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16950 */     // MIs[4] Operand 1
     /*  16950 */     // No operand predicates
     /*  16950 */     // MIs[2] Operand 2
     /*  16950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16965 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16967 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16985 */     GIR_RootConstrainSelectedInstOperands,
     /*  16986 */     // GIR_Coverage, 13595,
     /*  16986 */     GIR_EraseRootFromParent_Done,
     /*  16987 */   // Label 312: @16987
     /*  16987 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17056), // Rule ID 1801 //
     /*  16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17039 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17054 */     GIR_RootConstrainSelectedInstOperands,
     /*  17055 */     // GIR_Coverage, 1801,
     /*  17055 */     GIR_EraseRootFromParent_Done,
     /*  17056 */   // Label 313: @17056
     /*  17056 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17125), // Rule ID 1800 //
     /*  17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17108 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17123 */     GIR_RootConstrainSelectedInstOperands,
     /*  17124 */     // GIR_Coverage, 1800,
     /*  17124 */     GIR_EraseRootFromParent_Done,
     /*  17125 */   // Label 314: @17125
     /*  17125 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17194), // Rule ID 1717 //
     /*  17130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17177 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17192 */     GIR_RootConstrainSelectedInstOperands,
     /*  17193 */     // GIR_Coverage, 1717,
     /*  17193 */     GIR_EraseRootFromParent_Done,
     /*  17194 */   // Label 315: @17194
     /*  17194 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17263), // Rule ID 1799 //
     /*  17199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17246 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 1799,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 316: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17332), // Rule ID 1798 //
     /*  17268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17315 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17330 */     GIR_RootConstrainSelectedInstOperands,
     /*  17331 */     // GIR_Coverage, 1798,
     /*  17331 */     GIR_EraseRootFromParent_Done,
     /*  17332 */   // Label 317: @17332
     /*  17332 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17447), // Rule ID 13558 //
     /*  17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17409 */     // MIs[4] Operand 1
     /*  17409 */     // No operand predicates
     /*  17409 */     // MIs[2] Operand 2
     /*  17409 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17427 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17445 */     GIR_RootConstrainSelectedInstOperands,
     /*  17446 */     // GIR_Coverage, 13558,
     /*  17446 */     GIR_EraseRootFromParent_Done,
     /*  17447 */   // Label 318: @17447
     /*  17447 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17562), // Rule ID 2040 //
     /*  17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17525 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17529 */     // MIs[4] Operand 1
     /*  17529 */     // No operand predicates
     /*  17529 */     // MIs[2] Operand 2
     /*  17529 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17542 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17560 */     GIR_RootConstrainSelectedInstOperands,
     /*  17561 */     // GIR_Coverage, 2040,
     /*  17561 */     GIR_EraseRootFromParent_Done,
     /*  17562 */   // Label 319: @17562
     /*  17562 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17677), // Rule ID 13594 //
     /*  17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17639 */     // MIs[4] Operand 1
     /*  17639 */     // No operand predicates
     /*  17639 */     // MIs[2] Operand 2
     /*  17639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17657 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 13594,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 320: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17792), // Rule ID 2092 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17755 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17759 */     // MIs[4] Operand 1
     /*  17759 */     // No operand predicates
     /*  17759 */     // MIs[2] Operand 2
     /*  17759 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17772 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 2092,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 321: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17859), // Rule ID 13478 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17840 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17857 */     GIR_RootConstrainSelectedInstOperands,
     /*  17858 */     // GIR_Coverage, 13478,
     /*  17858 */     GIR_EraseRootFromParent_Done,
     /*  17859 */   // Label 322: @17859
     /*  17859 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17926), // Rule ID 13512 //
     /*  17864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17907 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17924 */     GIR_RootConstrainSelectedInstOperands,
     /*  17925 */     // GIR_Coverage, 13512,
     /*  17925 */     GIR_EraseRootFromParent_Done,
     /*  17926 */   // Label 323: @17926
     /*  17926 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17993), // Rule ID 1729 //
     /*  17931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17974 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17991 */     GIR_RootConstrainSelectedInstOperands,
     /*  17992 */     // GIR_Coverage, 1729,
     /*  17992 */     GIR_EraseRootFromParent_Done,
     /*  17993 */   // Label 324: @17993
     /*  17993 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18060), // Rule ID 1819 //
     /*  17998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18041 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 1819,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 325: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18141), // Rule ID 13464 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18124 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18139 */     GIR_RootConstrainSelectedInstOperands,
     /*  18140 */     // GIR_Coverage, 13464,
     /*  18140 */     GIR_EraseRootFromParent_Done,
     /*  18141 */   // Label 326: @18141
     /*  18141 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18222), // Rule ID 13492 //
     /*  18146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18173 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18176 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18205 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18220 */     GIR_RootConstrainSelectedInstOperands,
     /*  18221 */     // GIR_Coverage, 13492,
     /*  18221 */     GIR_EraseRootFromParent_Done,
     /*  18222 */   // Label 327: @18222
     /*  18222 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18303), // Rule ID 1697 //
     /*  18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18258 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18261 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18270 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18286 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 1697,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 328: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18384), // Rule ID 1775 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18339 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18342 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18351 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18367 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18382 */     GIR_RootConstrainSelectedInstOperands,
     /*  18383 */     // GIR_Coverage, 1775,
     /*  18383 */     GIR_EraseRootFromParent_Done,
     /*  18384 */   // Label 329: @18384
     /*  18384 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18476), // Rule ID 13563 //
     /*  18389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18445 */     // MIs[3] Operand 1
     /*  18445 */     // No operand predicates
     /*  18445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18456 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18474 */     GIR_RootConstrainSelectedInstOperands,
     /*  18475 */     // GIR_Coverage, 13563,
     /*  18475 */     GIR_EraseRootFromParent_Done,
     /*  18476 */   // Label 330: @18476
     /*  18476 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18568), // Rule ID 13562 //
     /*  18481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18542 */     // MIs[3] Operand 1
     /*  18542 */     // No operand predicates
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18548 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18566 */     GIR_RootConstrainSelectedInstOperands,
     /*  18567 */     // GIR_Coverage, 13562,
     /*  18567 */     GIR_EraseRootFromParent_Done,
     /*  18568 */   // Label 331: @18568
     /*  18568 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18660), // Rule ID 13599 //
     /*  18573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18629 */     // MIs[3] Operand 1
     /*  18629 */     // No operand predicates
     /*  18629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18640 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18658 */     GIR_RootConstrainSelectedInstOperands,
     /*  18659 */     // GIR_Coverage, 13599,
     /*  18659 */     GIR_EraseRootFromParent_Done,
     /*  18660 */   // Label 332: @18660
     /*  18660 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18752), // Rule ID 13598 //
     /*  18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18726 */     // MIs[3] Operand 1
     /*  18726 */     // No operand predicates
     /*  18726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18732 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18750 */     GIR_RootConstrainSelectedInstOperands,
     /*  18751 */     // GIR_Coverage, 13598,
     /*  18751 */     GIR_EraseRootFromParent_Done,
     /*  18752 */   // Label 333: @18752
     /*  18752 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18844), // Rule ID 13561 //
     /*  18757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18817 */     // MIs[3] Operand 1
     /*  18817 */     // No operand predicates
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18842 */     GIR_RootConstrainSelectedInstOperands,
     /*  18843 */     // GIR_Coverage, 13561,
     /*  18843 */     GIR_EraseRootFromParent_Done,
     /*  18844 */   // Label 334: @18844
     /*  18844 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18936), // Rule ID 2041 //
     /*  18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18914 */     // MIs[3] Operand 1
     /*  18914 */     // No operand predicates
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18916 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18934 */     GIR_RootConstrainSelectedInstOperands,
     /*  18935 */     // GIR_Coverage, 2041,
     /*  18935 */     GIR_EraseRootFromParent_Done,
     /*  18936 */   // Label 335: @18936
     /*  18936 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19028), // Rule ID 13597 //
     /*  18941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19001 */     // MIs[3] Operand 1
     /*  19001 */     // No operand predicates
     /*  19001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19026 */     GIR_RootConstrainSelectedInstOperands,
     /*  19027 */     // GIR_Coverage, 13597,
     /*  19027 */     GIR_EraseRootFromParent_Done,
     /*  19028 */   // Label 336: @19028
     /*  19028 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19120), // Rule ID 2093 //
     /*  19033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19098 */     // MIs[3] Operand 1
     /*  19098 */     // No operand predicates
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19118 */     GIR_RootConstrainSelectedInstOperands,
     /*  19119 */     // GIR_Coverage, 2093,
     /*  19119 */     GIR_EraseRootFromParent_Done,
     /*  19120 */   // Label 337: @19120
     /*  19120 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19171), // Rule ID 13506 //
     /*  19125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19157 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19169 */     GIR_RootConstrainSelectedInstOperands,
     /*  19170 */     // GIR_Coverage, 13506,
     /*  19170 */     GIR_EraseRootFromParent_Done,
     /*  19171 */   // Label 338: @19171
     /*  19171 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19222), // Rule ID 13472 //
     /*  19176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19208 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19220 */     GIR_RootConstrainSelectedInstOperands,
     /*  19221 */     // GIR_Coverage, 13472,
     /*  19221 */     GIR_EraseRootFromParent_Done,
     /*  19222 */   // Label 339: @19222
     /*  19222 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19273), // Rule ID 13505 //
     /*  19227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19271 */     GIR_RootConstrainSelectedInstOperands,
     /*  19272 */     // GIR_Coverage, 13505,
     /*  19272 */     GIR_EraseRootFromParent_Done,
     /*  19273 */   // Label 340: @19273
     /*  19273 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19324), // Rule ID 1813 //
     /*  19278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19310 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19322 */     GIR_RootConstrainSelectedInstOperands,
     /*  19323 */     // GIR_Coverage, 1813,
     /*  19323 */     GIR_EraseRootFromParent_Done,
     /*  19324 */   // Label 341: @19324
     /*  19324 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19375), // Rule ID 1723 //
     /*  19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19373 */     GIR_RootConstrainSelectedInstOperands,
     /*  19374 */     // GIR_Coverage, 1723,
     /*  19374 */     GIR_EraseRootFromParent_Done,
     /*  19375 */   // Label 342: @19375
     /*  19375 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19426), // Rule ID 1812 //
     /*  19380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19412 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 1812,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 343: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19482), // Rule ID 13390 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13390,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 344: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19538), // Rule ID 13402 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19525 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19536 */     GIR_RootConstrainSelectedInstOperands,
     /*  19537 */     // GIR_Coverage, 13402,
     /*  19537 */     GIR_EraseRootFromParent_Done,
     /*  19538 */   // Label 345: @19538
     /*  19538 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19605), // Rule ID 13640 //
     /*  19543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     // MIs[1] imm
     /*  19567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19579 */     // MIs[2] Operand 1
     /*  19579 */     // No operand predicates
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19589 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19603 */     GIR_RootConstrainSelectedInstOperands,
     /*  19604 */     // GIR_Coverage, 13640,
     /*  19604 */     GIR_EraseRootFromParent_Done,
     /*  19605 */   // Label 346: @19605
     /*  19605 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19672), // Rule ID 13661 //
     /*  19610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     // MIs[1] imm
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19646 */     // MIs[2] Operand 1
     /*  19646 */     // No operand predicates
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19656 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 13661,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 347: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19728), // Rule ID 999 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 999,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 348: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19784), // Rule ID 1060 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19782 */     GIR_RootConstrainSelectedInstOperands,
     /*  19783 */     // GIR_Coverage, 1060,
     /*  19783 */     GIR_EraseRootFromParent_Done,
     /*  19784 */   // Label 349: @19784
     /*  19784 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19851), // Rule ID 2242 //
     /*  19789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19817 */     // MIs[1] imm
     /*  19817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19829 */     // MIs[2] Operand 1
     /*  19829 */     // No operand predicates
     /*  19829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19835 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19849 */     GIR_RootConstrainSelectedInstOperands,
     /*  19850 */     // GIR_Coverage, 2242,
     /*  19850 */     GIR_EraseRootFromParent_Done,
     /*  19851 */   // Label 350: @19851
     /*  19851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19918), // Rule ID 2301 //
     /*  19856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19884 */     // MIs[1] imm
     /*  19884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19896 */     // MIs[2] Operand 1
     /*  19896 */     // No operand predicates
     /*  19896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19902 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19916 */     GIR_RootConstrainSelectedInstOperands,
     /*  19917 */     // GIR_Coverage, 2301,
     /*  19917 */     GIR_EraseRootFromParent_Done,
     /*  19918 */   // Label 351: @19918
     /*  19918 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19988), // Rule ID 6960 //
     /*  19923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19961 */     // MIs[2] Rn
     /*  19961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19966 */     // MIs[2] Rm
     /*  19966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19973 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19986 */     GIR_RootConstrainSelectedInstOperands,
     /*  19987 */     // GIR_Coverage, 6960,
     /*  19987 */     GIR_EraseRootFromParent_Done,
     /*  19988 */   // Label 352: @19988
     /*  19988 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20058), // Rule ID 14019 //
     /*  19993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20031 */     // MIs[2] Rn
     /*  20031 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20036 */     // MIs[2] Rm
     /*  20036 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20043 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20056 */     GIR_RootConstrainSelectedInstOperands,
     /*  20057 */     // GIR_Coverage, 14019,
     /*  20057 */     GIR_EraseRootFromParent_Done,
     /*  20058 */   // Label 353: @20058
     /*  20058 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20121), // Rule ID 1797 //
     /*  20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20106 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20119 */     GIR_RootConstrainSelectedInstOperands,
     /*  20120 */     // GIR_Coverage, 1797,
     /*  20120 */     GIR_EraseRootFromParent_Done,
     /*  20121 */   // Label 354: @20121
     /*  20121 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20184), // Rule ID 1796 //
     /*  20126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20169 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 1796,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 355: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20247), // Rule ID 1716 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20232 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20245 */     GIR_RootConstrainSelectedInstOperands,
     /*  20246 */     // GIR_Coverage, 1716,
     /*  20246 */     GIR_EraseRootFromParent_Done,
     /*  20247 */   // Label 356: @20247
     /*  20247 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20310), // Rule ID 1795 //
     /*  20252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20295 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20308 */     GIR_RootConstrainSelectedInstOperands,
     /*  20309 */     // GIR_Coverage, 1795,
     /*  20309 */     GIR_EraseRootFromParent_Done,
     /*  20310 */   // Label 357: @20310
     /*  20310 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20373), // Rule ID 1794 //
     /*  20315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20358 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20371 */     GIR_RootConstrainSelectedInstOperands,
     /*  20372 */     // GIR_Coverage, 1794,
     /*  20372 */     GIR_EraseRootFromParent_Done,
     /*  20373 */   // Label 358: @20373
     /*  20373 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20434), // Rule ID 13477 //
     /*  20378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20417 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 13477,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 359: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20495), // Rule ID 13511 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20478 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20493 */     GIR_RootConstrainSelectedInstOperands,
     /*  20494 */     // GIR_Coverage, 13511,
     /*  20494 */     GIR_EraseRootFromParent_Done,
     /*  20495 */   // Label 360: @20495
     /*  20495 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20543), // Rule ID 13504 //
     /*  20500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20530 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20541 */     GIR_RootConstrainSelectedInstOperands,
     /*  20542 */     // GIR_Coverage, 13504,
     /*  20542 */     GIR_EraseRootFromParent_Done,
     /*  20543 */   // Label 361: @20543
     /*  20543 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20591), // Rule ID 13389 //
     /*  20548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20578 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20589 */     GIR_RootConstrainSelectedInstOperands,
     /*  20590 */     // GIR_Coverage, 13389,
     /*  20590 */     GIR_EraseRootFromParent_Done,
     /*  20591 */   // Label 362: @20591
     /*  20591 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20639), // Rule ID 13471 //
     /*  20596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20626 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20637 */     GIR_RootConstrainSelectedInstOperands,
     /*  20638 */     // GIR_Coverage, 13471,
     /*  20638 */     GIR_EraseRootFromParent_Done,
     /*  20639 */   // Label 363: @20639
     /*  20639 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20687), // Rule ID 13401 //
     /*  20644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20674 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20685 */     GIR_RootConstrainSelectedInstOperands,
     /*  20686 */     // GIR_Coverage, 13401,
     /*  20686 */     GIR_EraseRootFromParent_Done,
     /*  20687 */   // Label 364: @20687
     /*  20687 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20735), // Rule ID 13503 //
     /*  20692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20722 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20733 */     GIR_RootConstrainSelectedInstOperands,
     /*  20734 */     // GIR_Coverage, 13503,
     /*  20734 */     GIR_EraseRootFromParent_Done,
     /*  20735 */   // Label 365: @20735
     /*  20735 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20796), // Rule ID 1728 //
     /*  20740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1728,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 366: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20857), // Rule ID 1818 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20840 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20855 */     GIR_RootConstrainSelectedInstOperands,
     /*  20856 */     // GIR_Coverage, 1818,
     /*  20856 */     GIR_EraseRootFromParent_Done,
     /*  20857 */   // Label 367: @20857
     /*  20857 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20905), // Rule ID 1811 //
     /*  20862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20892 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20903 */     GIR_RootConstrainSelectedInstOperands,
     /*  20904 */     // GIR_Coverage, 1811,
     /*  20904 */     GIR_EraseRootFromParent_Done,
     /*  20905 */   // Label 368: @20905
     /*  20905 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20953), // Rule ID 998 //
     /*  20910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20940 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 998,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 369: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21001), // Rule ID 1722 //
     /*  20958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20988 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1722,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 370: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21049), // Rule ID 1059 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21047 */     GIR_RootConstrainSelectedInstOperands,
     /*  21048 */     // GIR_Coverage, 1059,
     /*  21048 */     GIR_EraseRootFromParent_Done,
     /*  21049 */   // Label 371: @21049
     /*  21049 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21097), // Rule ID 1810 //
     /*  21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21095 */     GIR_RootConstrainSelectedInstOperands,
     /*  21096 */     // GIR_Coverage, 1810,
     /*  21096 */     GIR_EraseRootFromParent_Done,
     /*  21097 */   // Label 372: @21097
     /*  21097 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21124), // Rule ID 1106 //
     /*  21102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21117 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 1106,
     /*  21123 */     GIR_Done,
     /*  21124 */   // Label 373: @21124
     /*  21124 */   GIM_Reject,
     /*  21125 */ // Label 296: @21125
     /*  21125 */ GIM_Reject,
     /*  21126 */ // Label 159: @21126
     /*  21126 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24623),
     /*  21131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21137 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21273), // Rule ID 5381 //
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21175 */     // MIs[1] Operand 2
     /*  21175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21210 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21215 */     // MIs[3] Operand 2
     /*  21215 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21228 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21272 */     // GIR_Coverage, 5381,
     /*  21272 */     GIR_EraseRootFromParent_Done,
     /*  21273 */   // Label 375: @21273
     /*  21273 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21409), // Rule ID 5380 //
     /*  21278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21311 */     // MIs[1] Operand 2
     /*  21311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21346 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21351 */     // MIs[3] Operand 2
     /*  21351 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21362 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21364 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21408 */     // GIR_Coverage, 5380,
     /*  21408 */     GIR_EraseRootFromParent_Done,
     /*  21409 */   // Label 376: @21409
     /*  21409 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21545), // Rule ID 5396 //
     /*  21414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21447 */     // MIs[1] Operand 2
     /*  21447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[3] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21500 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21544 */     // GIR_Coverage, 5396,
     /*  21544 */     GIR_EraseRootFromParent_Done,
     /*  21545 */   // Label 377: @21545
     /*  21545 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21681), // Rule ID 5379 //
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21583 */     // MIs[1] Operand 2
     /*  21583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21618 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21623 */     // MIs[3] Operand 2
     /*  21623 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21636 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     // GIR_Coverage, 5379,
     /*  21680 */     GIR_EraseRootFromParent_Done,
     /*  21681 */   // Label 378: @21681
     /*  21681 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21817), // Rule ID 5378 //
     /*  21686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21719 */     // MIs[1] Operand 2
     /*  21719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21750 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21759 */     // MIs[3] Operand 2
     /*  21759 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21772 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21799 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21816 */     // GIR_Coverage, 5378,
     /*  21816 */     GIR_EraseRootFromParent_Done,
     /*  21817 */   // Label 379: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21950), // Rule ID 14024 //
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21867 */     // MIs[1] Operand 2
     /*  21867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21898 */     // MIs[5] Rn
     /*  21898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21903 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21905 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21949 */     // GIR_Coverage, 14024,
     /*  21949 */     GIR_EraseRootFromParent_Done,
     /*  21950 */   // Label 380: @21950
     /*  21950 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22083), // Rule ID 6965 //
     /*  21955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22012 */     // MIs[4] Rn
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22025 */     // MIs[3] Operand 2
     /*  22025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22036 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22038 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22082 */     // GIR_Coverage, 6965,
     /*  22082 */     GIR_EraseRootFromParent_Done,
     /*  22083 */   // Label 381: @22083
     /*  22083 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22246), // Rule ID 13982 //
     /*  22088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     // MIs[1] Operand 2
     /*  22130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22147 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22147 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22150 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22154 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22245 */     // GIR_Coverage, 13982,
     /*  22245 */     GIR_EraseRootFromParent_Done,
     /*  22246 */   // Label 382: @22246
     /*  22246 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22409), // Rule ID 13979 //
     /*  22251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22293 */     // MIs[1] Operand 2
     /*  22293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22310 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22408 */     // GIR_Coverage, 13979,
     /*  22408 */     GIR_EraseRootFromParent_Done,
     /*  22409 */   // Label 383: @22409
     /*  22409 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22559), // Rule ID 13986 //
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22447 */     // MIs[1] Operand 2
     /*  22447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22464 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22558 */     // GIR_Coverage, 13986,
     /*  22558 */     GIR_EraseRootFromParent_Done,
     /*  22559 */   // Label 384: @22559
     /*  22559 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22709), // Rule ID 13991 //
     /*  22564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22597 */     // MIs[1] Operand 2
     /*  22597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22614 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22691 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22708 */     // GIR_Coverage, 13991,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 385: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22859), // Rule ID 13985 //
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22747 */     // MIs[1] Operand 2
     /*  22747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22858 */     // GIR_Coverage, 13985,
     /*  22858 */     GIR_EraseRootFromParent_Done,
     /*  22859 */   // Label 386: @22859
     /*  22859 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23022), // Rule ID 5369 //
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22910 */     // MIs[1] Operand 2
     /*  22910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22923 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22923 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22926 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22930 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23021 */     // GIR_Coverage, 5369,
     /*  23021 */     GIR_EraseRootFromParent_Done,
     /*  23022 */   // Label 387: @23022
     /*  23022 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23185), // Rule ID 5366 //
     /*  23027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23073 */     // MIs[1] Operand 2
     /*  23073 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23086 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23112 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23184 */     // GIR_Coverage, 5366,
     /*  23184 */     GIR_EraseRootFromParent_Done,
     /*  23185 */   // Label 388: @23185
     /*  23185 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23335), // Rule ID 5391 //
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23227 */     // MIs[1] Operand 2
     /*  23227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23334 */     // GIR_Coverage, 5391,
     /*  23334 */     GIR_EraseRootFromParent_Done,
     /*  23335 */   // Label 389: @23335
     /*  23335 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23485), // Rule ID 5399 //
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23377 */     // MIs[1] Operand 2
     /*  23377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23390 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23416 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23484 */     // GIR_Coverage, 5399,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 390: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23635), // Rule ID 5390 //
     /*  23490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23527 */     // MIs[1] Operand 2
     /*  23527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23540 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23634 */     // GIR_Coverage, 5390,
     /*  23634 */     GIR_EraseRootFromParent_Done,
     /*  23635 */   // Label 391: @23635
     /*  23635 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23704), // Rule ID 13418 //
     /*  23640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23687 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23702 */     GIR_RootConstrainSelectedInstOperands,
     /*  23703 */     // GIR_Coverage, 13418,
     /*  23703 */     GIR_EraseRootFromParent_Done,
     /*  23704 */   // Label 392: @23704
     /*  23704 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23773), // Rule ID 13430 //
     /*  23709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23756 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13430,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 393: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23829), // Rule ID 13380 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13380,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 394: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23885), // Rule ID 13392 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23872 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23883 */     GIR_RootConstrainSelectedInstOperands,
     /*  23884 */     // GIR_Coverage, 13392,
     /*  23884 */     GIR_EraseRootFromParent_Done,
     /*  23885 */   // Label 395: @23885
     /*  23885 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23952), // Rule ID 13632 //
     /*  23890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     // MIs[1] imm
     /*  23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23926 */     // MIs[2] Operand 1
     /*  23926 */     // No operand predicates
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23936 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23950 */     GIR_RootConstrainSelectedInstOperands,
     /*  23951 */     // GIR_Coverage, 13632,
     /*  23951 */     GIR_EraseRootFromParent_Done,
     /*  23952 */   // Label 396: @23952
     /*  23952 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24019), // Rule ID 13653 //
     /*  23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     // MIs[1] imm
     /*  23981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23993 */     // MIs[2] Operand 1
     /*  23993 */     // No operand predicates
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24003 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24017 */     GIR_RootConstrainSelectedInstOperands,
     /*  24018 */     // GIR_Coverage, 13653,
     /*  24018 */     GIR_EraseRootFromParent_Done,
     /*  24019 */   // Label 397: @24019
     /*  24019 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24088), // Rule ID 1361 //
     /*  24024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24071 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24086 */     GIR_RootConstrainSelectedInstOperands,
     /*  24087 */     // GIR_Coverage, 1361,
     /*  24087 */     GIR_EraseRootFromParent_Done,
     /*  24088 */   // Label 398: @24088
     /*  24088 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24157), // Rule ID 1484 //
     /*  24093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24140 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 1484,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 399: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24213), // Rule ID 989 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 989,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 400: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24269), // Rule ID 1050 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24256 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24267 */     GIR_RootConstrainSelectedInstOperands,
     /*  24268 */     // GIR_Coverage, 1050,
     /*  24268 */     GIR_EraseRootFromParent_Done,
     /*  24269 */   // Label 401: @24269
     /*  24269 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24336), // Rule ID 2234 //
     /*  24274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24302 */     // MIs[1] imm
     /*  24302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24314 */     // MIs[2] Operand 1
     /*  24314 */     // No operand predicates
     /*  24314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24320 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24334 */     GIR_RootConstrainSelectedInstOperands,
     /*  24335 */     // GIR_Coverage, 2234,
     /*  24335 */     GIR_EraseRootFromParent_Done,
     /*  24336 */   // Label 402: @24336
     /*  24336 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24403), // Rule ID 2293 //
     /*  24341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24369 */     // MIs[1] imm
     /*  24369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24381 */     // MIs[2] Operand 1
     /*  24381 */     // No operand predicates
     /*  24381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24387 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24401 */     GIR_RootConstrainSelectedInstOperands,
     /*  24402 */     // GIR_Coverage, 2293,
     /*  24402 */     GIR_EraseRootFromParent_Done,
     /*  24403 */   // Label 403: @24403
     /*  24403 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24451), // Rule ID 13379 //
     /*  24408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24438 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24449 */     GIR_RootConstrainSelectedInstOperands,
     /*  24450 */     // GIR_Coverage, 13379,
     /*  24450 */     GIR_EraseRootFromParent_Done,
     /*  24451 */   // Label 404: @24451
     /*  24451 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24499), // Rule ID 13391 //
     /*  24456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24486 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24497 */     GIR_RootConstrainSelectedInstOperands,
     /*  24498 */     // GIR_Coverage, 13391,
     /*  24498 */     GIR_EraseRootFromParent_Done,
     /*  24499 */   // Label 405: @24499
     /*  24499 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24547), // Rule ID 988 //
     /*  24504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24534 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24545 */     GIR_RootConstrainSelectedInstOperands,
     /*  24546 */     // GIR_Coverage, 988,
     /*  24546 */     GIR_EraseRootFromParent_Done,
     /*  24547 */   // Label 406: @24547
     /*  24547 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24595), // Rule ID 1049 //
     /*  24552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24593 */     GIR_RootConstrainSelectedInstOperands,
     /*  24594 */     // GIR_Coverage, 1049,
     /*  24594 */     GIR_EraseRootFromParent_Done,
     /*  24595 */   // Label 407: @24595
     /*  24595 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24622), // Rule ID 1102 //
     /*  24600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24615 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24620 */     GIR_RootConstrainSelectedInstOperands,
     /*  24621 */     // GIR_Coverage, 1102,
     /*  24621 */     GIR_Done,
     /*  24622 */   // Label 408: @24622
     /*  24622 */   GIM_Reject,
     /*  24623 */ // Label 374: @24623
     /*  24623 */ GIM_Reject,
     /*  24624 */ // Label 160: @24624
     /*  24624 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30801),
     /*  24629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24753), // Rule ID 13556 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24708 */     // MIs[4] Operand 1
     /*  24708 */     // No operand predicates
     /*  24708 */     // MIs[2] Operand 2
     /*  24708 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24732 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24751 */     GIR_RootConstrainSelectedInstOperands,
     /*  24752 */     // GIR_Coverage, 13556,
     /*  24752 */     GIR_EraseRootFromParent_Done,
     /*  24753 */   // Label 410: @24753
     /*  24753 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24871), // Rule ID 13557 //
     /*  24758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24822 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24826 */     // MIs[4] Operand 1
     /*  24826 */     // No operand predicates
     /*  24826 */     // MIs[2] Operand 2
     /*  24826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24850 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24869 */     GIR_RootConstrainSelectedInstOperands,
     /*  24870 */     // GIR_Coverage, 13557,
     /*  24870 */     GIR_EraseRootFromParent_Done,
     /*  24871 */   // Label 411: @24871
     /*  24871 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24989), // Rule ID 13592 //
     /*  24876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24944 */     // MIs[4] Operand 1
     /*  24944 */     // No operand predicates
     /*  24944 */     // MIs[2] Operand 2
     /*  24944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24987 */     GIR_RootConstrainSelectedInstOperands,
     /*  24988 */     // GIR_Coverage, 13592,
     /*  24988 */     GIR_EraseRootFromParent_Done,
     /*  24989 */   // Label 412: @24989
     /*  24989 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25107), // Rule ID 13593 //
     /*  24994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25062 */     // MIs[4] Operand 1
     /*  25062 */     // No operand predicates
     /*  25062 */     // MIs[2] Operand 2
     /*  25062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25086 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13593,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 413: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25225), // Rule ID 2039 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25180 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25184 */     // MIs[4] Operand 1
     /*  25184 */     // No operand predicates
     /*  25184 */     // MIs[2] Operand 2
     /*  25184 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25204 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25223 */     GIR_RootConstrainSelectedInstOperands,
     /*  25224 */     // GIR_Coverage, 2039,
     /*  25224 */     GIR_EraseRootFromParent_Done,
     /*  25225 */   // Label 414: @25225
     /*  25225 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25343), // Rule ID 13555 //
     /*  25230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25298 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25302 */     // MIs[4] Operand 1
     /*  25302 */     // No operand predicates
     /*  25302 */     // MIs[2] Operand 2
     /*  25302 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25341 */     GIR_RootConstrainSelectedInstOperands,
     /*  25342 */     // GIR_Coverage, 13555,
     /*  25342 */     GIR_EraseRootFromParent_Done,
     /*  25343 */   // Label 415: @25343
     /*  25343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25461), // Rule ID 2091 //
     /*  25348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25416 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25420 */     // MIs[4] Operand 1
     /*  25420 */     // No operand predicates
     /*  25420 */     // MIs[2] Operand 2
     /*  25420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25431 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25459 */     GIR_RootConstrainSelectedInstOperands,
     /*  25460 */     // GIR_Coverage, 2091,
     /*  25460 */     GIR_EraseRootFromParent_Done,
     /*  25461 */   // Label 416: @25461
     /*  25461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25579), // Rule ID 13591 //
     /*  25466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25534 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25538 */     // MIs[4] Operand 1
     /*  25538 */     // No operand predicates
     /*  25538 */     // MIs[2] Operand 2
     /*  25538 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25558 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25577 */     GIR_RootConstrainSelectedInstOperands,
     /*  25578 */     // GIR_Coverage, 13591,
     /*  25578 */     GIR_EraseRootFromParent_Done,
     /*  25579 */   // Label 417: @25579
     /*  25579 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25666), // Rule ID 13462 //
     /*  25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25611 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25614 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25647 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 13462,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 418: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25753), // Rule ID 13490 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25698 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25701 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25710 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25734 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25751 */     GIR_RootConstrainSelectedInstOperands,
     /*  25752 */     // GIR_Coverage, 13490,
     /*  25752 */     GIR_EraseRootFromParent_Done,
     /*  25753 */   // Label 419: @25753
     /*  25753 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25840), // Rule ID 1695 //
     /*  25758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25789 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25792 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25801 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25821 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25838 */     GIR_RootConstrainSelectedInstOperands,
     /*  25839 */     // GIR_Coverage, 1695,
     /*  25839 */     GIR_EraseRootFromParent_Done,
     /*  25840 */   // Label 420: @25840
     /*  25840 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25927), // Rule ID 1773 //
     /*  25845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25876 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25879 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25888 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25925 */     GIR_RootConstrainSelectedInstOperands,
     /*  25926 */     // GIR_Coverage, 1773,
     /*  25926 */     GIR_EraseRootFromParent_Done,
     /*  25927 */   // Label 421: @25927
     /*  25927 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26042), // Rule ID 13551 //
     /*  25932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25996 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26000 */     // MIs[4] Operand 1
     /*  26000 */     // No operand predicates
     /*  26000 */     // MIs[2] Operand 2
     /*  26000 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26022 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26040 */     GIR_RootConstrainSelectedInstOperands,
     /*  26041 */     // GIR_Coverage, 13551,
     /*  26041 */     GIR_EraseRootFromParent_Done,
     /*  26042 */   // Label 422: @26042
     /*  26042 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26157), // Rule ID 13550 //
     /*  26047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26116 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26120 */     // MIs[4] Operand 1
     /*  26120 */     // No operand predicates
     /*  26120 */     // MIs[2] Operand 2
     /*  26120 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26137 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 13550,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 423: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26272), // Rule ID 13587 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26230 */     // MIs[4] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     // MIs[2] Operand 2
     /*  26230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26270 */     GIR_RootConstrainSelectedInstOperands,
     /*  26271 */     // GIR_Coverage, 13587,
     /*  26271 */     GIR_EraseRootFromParent_Done,
     /*  26272 */   // Label 424: @26272
     /*  26272 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26387), // Rule ID 13586 //
     /*  26277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26350 */     // MIs[4] Operand 1
     /*  26350 */     // No operand predicates
     /*  26350 */     // MIs[2] Operand 2
     /*  26350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26367 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26385 */     GIR_RootConstrainSelectedInstOperands,
     /*  26386 */     // GIR_Coverage, 13586,
     /*  26386 */     GIR_EraseRootFromParent_Done,
     /*  26387 */   // Label 425: @26387
     /*  26387 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26456), // Rule ID 1793 //
     /*  26392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26439 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26454 */     GIR_RootConstrainSelectedInstOperands,
     /*  26455 */     // GIR_Coverage, 1793,
     /*  26455 */     GIR_EraseRootFromParent_Done,
     /*  26456 */   // Label 426: @26456
     /*  26456 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26525), // Rule ID 1792 //
     /*  26461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26508 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 1792,
     /*  26524 */     GIR_EraseRootFromParent_Done,
     /*  26525 */   // Label 427: @26525
     /*  26525 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26594), // Rule ID 1715 //
     /*  26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26577 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26592 */     GIR_RootConstrainSelectedInstOperands,
     /*  26593 */     // GIR_Coverage, 1715,
     /*  26593 */     GIR_EraseRootFromParent_Done,
     /*  26594 */   // Label 428: @26594
     /*  26594 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26663), // Rule ID 1791 //
     /*  26599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 1791,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 429: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26732), // Rule ID 1790 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26715 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26730 */     GIR_RootConstrainSelectedInstOperands,
     /*  26731 */     // GIR_Coverage, 1790,
     /*  26731 */     GIR_EraseRootFromParent_Done,
     /*  26732 */   // Label 430: @26732
     /*  26732 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26847), // Rule ID 13549 //
     /*  26737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26809 */     // MIs[4] Operand 1
     /*  26809 */     // No operand predicates
     /*  26809 */     // MIs[2] Operand 2
     /*  26809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26827 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26845 */     GIR_RootConstrainSelectedInstOperands,
     /*  26846 */     // GIR_Coverage, 13549,
     /*  26846 */     GIR_EraseRootFromParent_Done,
     /*  26847 */   // Label 431: @26847
     /*  26847 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26962), // Rule ID 2037 //
     /*  26852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26925 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26929 */     // MIs[4] Operand 1
     /*  26929 */     // No operand predicates
     /*  26929 */     // MIs[2] Operand 2
     /*  26929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26942 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26960 */     GIR_RootConstrainSelectedInstOperands,
     /*  26961 */     // GIR_Coverage, 2037,
     /*  26961 */     GIR_EraseRootFromParent_Done,
     /*  26962 */   // Label 432: @26962
     /*  26962 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27077), // Rule ID 13585 //
     /*  26967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27035 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27039 */     // MIs[4] Operand 1
     /*  27039 */     // No operand predicates
     /*  27039 */     // MIs[2] Operand 2
     /*  27039 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27057 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27075 */     GIR_RootConstrainSelectedInstOperands,
     /*  27076 */     // GIR_Coverage, 13585,
     /*  27076 */     GIR_EraseRootFromParent_Done,
     /*  27077 */   // Label 433: @27077
     /*  27077 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27192), // Rule ID 2089 //
     /*  27082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27155 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27159 */     // MIs[4] Operand 1
     /*  27159 */     // No operand predicates
     /*  27159 */     // MIs[2] Operand 2
     /*  27159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27172 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27190 */     GIR_RootConstrainSelectedInstOperands,
     /*  27191 */     // GIR_Coverage, 2089,
     /*  27191 */     GIR_EraseRootFromParent_Done,
     /*  27192 */   // Label 434: @27192
     /*  27192 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27259), // Rule ID 13476 //
     /*  27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27240 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 13476,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 435: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27326), // Rule ID 13510 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27307 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27324 */     GIR_RootConstrainSelectedInstOperands,
     /*  27325 */     // GIR_Coverage, 13510,
     /*  27325 */     GIR_EraseRootFromParent_Done,
     /*  27326 */   // Label 436: @27326
     /*  27326 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27393), // Rule ID 1727 //
     /*  27331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27374 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27391 */     GIR_RootConstrainSelectedInstOperands,
     /*  27392 */     // GIR_Coverage, 1727,
     /*  27392 */     GIR_EraseRootFromParent_Done,
     /*  27393 */   // Label 437: @27393
     /*  27393 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27460), // Rule ID 1817 //
     /*  27398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27441 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 1817,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 438: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27541), // Rule ID 13460 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27492 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27495 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27524 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27539 */     GIR_RootConstrainSelectedInstOperands,
     /*  27540 */     // GIR_Coverage, 13460,
     /*  27540 */     GIR_EraseRootFromParent_Done,
     /*  27541 */   // Label 439: @27541
     /*  27541 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27622), // Rule ID 13488 //
     /*  27546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27605 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27620 */     GIR_RootConstrainSelectedInstOperands,
     /*  27621 */     // GIR_Coverage, 13488,
     /*  27621 */     GIR_EraseRootFromParent_Done,
     /*  27622 */   // Label 440: @27622
     /*  27622 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27703), // Rule ID 1693 //
     /*  27627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27670 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27686 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27701 */     GIR_RootConstrainSelectedInstOperands,
     /*  27702 */     // GIR_Coverage, 1693,
     /*  27702 */     GIR_EraseRootFromParent_Done,
     /*  27703 */   // Label 441: @27703
     /*  27703 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27784), // Rule ID 1771 //
     /*  27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27739 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27742 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27751 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27767 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27782 */     GIR_RootConstrainSelectedInstOperands,
     /*  27783 */     // GIR_Coverage, 1771,
     /*  27783 */     GIR_EraseRootFromParent_Done,
     /*  27784 */   // Label 442: @27784
     /*  27784 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27876), // Rule ID 13554 //
     /*  27789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27845 */     // MIs[3] Operand 1
     /*  27845 */     // No operand predicates
     /*  27845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27856 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27874 */     GIR_RootConstrainSelectedInstOperands,
     /*  27875 */     // GIR_Coverage, 13554,
     /*  27875 */     GIR_EraseRootFromParent_Done,
     /*  27876 */   // Label 443: @27876
     /*  27876 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27968), // Rule ID 13553 //
     /*  27881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27942 */     // MIs[3] Operand 1
     /*  27942 */     // No operand predicates
     /*  27942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27948 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27966 */     GIR_RootConstrainSelectedInstOperands,
     /*  27967 */     // GIR_Coverage, 13553,
     /*  27967 */     GIR_EraseRootFromParent_Done,
     /*  27968 */   // Label 444: @27968
     /*  27968 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28060), // Rule ID 13590 //
     /*  27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28029 */     // MIs[3] Operand 1
     /*  28029 */     // No operand predicates
     /*  28029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28040 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28058 */     GIR_RootConstrainSelectedInstOperands,
     /*  28059 */     // GIR_Coverage, 13590,
     /*  28059 */     GIR_EraseRootFromParent_Done,
     /*  28060 */   // Label 445: @28060
     /*  28060 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28152), // Rule ID 13589 //
     /*  28065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28126 */     // MIs[3] Operand 1
     /*  28126 */     // No operand predicates
     /*  28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28132 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28150 */     GIR_RootConstrainSelectedInstOperands,
     /*  28151 */     // GIR_Coverage, 13589,
     /*  28151 */     GIR_EraseRootFromParent_Done,
     /*  28152 */   // Label 446: @28152
     /*  28152 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28244), // Rule ID 13552 //
     /*  28157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28217 */     // MIs[3] Operand 1
     /*  28217 */     // No operand predicates
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28224 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28242 */     GIR_RootConstrainSelectedInstOperands,
     /*  28243 */     // GIR_Coverage, 13552,
     /*  28243 */     GIR_EraseRootFromParent_Done,
     /*  28244 */   // Label 447: @28244
     /*  28244 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28336), // Rule ID 2038 //
     /*  28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28314 */     // MIs[3] Operand 1
     /*  28314 */     // No operand predicates
     /*  28314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28316 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 2038,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 448: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28428), // Rule ID 13588 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28401 */     // MIs[3] Operand 1
     /*  28401 */     // No operand predicates
     /*  28401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28408 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28426 */     GIR_RootConstrainSelectedInstOperands,
     /*  28427 */     // GIR_Coverage, 13588,
     /*  28427 */     GIR_EraseRootFromParent_Done,
     /*  28428 */   // Label 449: @28428
     /*  28428 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28520), // Rule ID 2090 //
     /*  28433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28498 */     // MIs[3] Operand 1
     /*  28498 */     // No operand predicates
     /*  28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28518 */     GIR_RootConstrainSelectedInstOperands,
     /*  28519 */     // GIR_Coverage, 2090,
     /*  28519 */     GIR_EraseRootFromParent_Done,
     /*  28520 */   // Label 450: @28520
     /*  28520 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28571), // Rule ID 13502 //
     /*  28525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28557 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28569 */     GIR_RootConstrainSelectedInstOperands,
     /*  28570 */     // GIR_Coverage, 13502,
     /*  28570 */     GIR_EraseRootFromParent_Done,
     /*  28571 */   // Label 451: @28571
     /*  28571 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28622), // Rule ID 13470 //
     /*  28576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28608 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28620 */     GIR_RootConstrainSelectedInstOperands,
     /*  28621 */     // GIR_Coverage, 13470,
     /*  28621 */     GIR_EraseRootFromParent_Done,
     /*  28622 */   // Label 452: @28622
     /*  28622 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28673), // Rule ID 13501 //
     /*  28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28671 */     GIR_RootConstrainSelectedInstOperands,
     /*  28672 */     // GIR_Coverage, 13501,
     /*  28672 */     GIR_EraseRootFromParent_Done,
     /*  28673 */   // Label 453: @28673
     /*  28673 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28724), // Rule ID 1809 //
     /*  28678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28710 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28722 */     GIR_RootConstrainSelectedInstOperands,
     /*  28723 */     // GIR_Coverage, 1809,
     /*  28723 */     GIR_EraseRootFromParent_Done,
     /*  28724 */   // Label 454: @28724
     /*  28724 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28775), // Rule ID 1721 //
     /*  28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28761 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28773 */     GIR_RootConstrainSelectedInstOperands,
     /*  28774 */     // GIR_Coverage, 1721,
     /*  28774 */     GIR_EraseRootFromParent_Done,
     /*  28775 */   // Label 455: @28775
     /*  28775 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28826), // Rule ID 1808 //
     /*  28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28824 */     GIR_RootConstrainSelectedInstOperands,
     /*  28825 */     // GIR_Coverage, 1808,
     /*  28825 */     GIR_EraseRootFromParent_Done,
     /*  28826 */   // Label 456: @28826
     /*  28826 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28895), // Rule ID 13424 //
     /*  28831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28878 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28893 */     GIR_RootConstrainSelectedInstOperands,
     /*  28894 */     // GIR_Coverage, 13424,
     /*  28894 */     GIR_EraseRootFromParent_Done,
     /*  28895 */   // Label 457: @28895
     /*  28895 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28964), // Rule ID 13436 //
     /*  28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28947 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13436,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 458: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29020), // Rule ID 13386 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13386,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 459: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29076), // Rule ID 13398 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29063 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29074 */     GIR_RootConstrainSelectedInstOperands,
     /*  29075 */     // GIR_Coverage, 13398,
     /*  29075 */     GIR_EraseRootFromParent_Done,
     /*  29076 */   // Label 460: @29076
     /*  29076 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29143), // Rule ID 13638 //
     /*  29081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     // MIs[1] imm
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29117 */     // MIs[2] Operand 1
     /*  29117 */     // No operand predicates
     /*  29117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29127 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29141 */     GIR_RootConstrainSelectedInstOperands,
     /*  29142 */     // GIR_Coverage, 13638,
     /*  29142 */     GIR_EraseRootFromParent_Done,
     /*  29143 */   // Label 461: @29143
     /*  29143 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29210), // Rule ID 13659 //
     /*  29148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     // MIs[1] imm
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29184 */     // MIs[2] Operand 1
     /*  29184 */     // No operand predicates
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29194 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29208 */     GIR_RootConstrainSelectedInstOperands,
     /*  29209 */     // GIR_Coverage, 13659,
     /*  29209 */     GIR_EraseRootFromParent_Done,
     /*  29210 */   // Label 462: @29210
     /*  29210 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29279), // Rule ID 1367 //
     /*  29215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29262 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29277 */     GIR_RootConstrainSelectedInstOperands,
     /*  29278 */     // GIR_Coverage, 1367,
     /*  29278 */     GIR_EraseRootFromParent_Done,
     /*  29279 */   // Label 463: @29279
     /*  29279 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29348), // Rule ID 1490 //
     /*  29284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 1490,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 464: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29404), // Rule ID 995 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 995,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 465: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29460), // Rule ID 1056 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29458 */     GIR_RootConstrainSelectedInstOperands,
     /*  29459 */     // GIR_Coverage, 1056,
     /*  29459 */     GIR_EraseRootFromParent_Done,
     /*  29460 */   // Label 466: @29460
     /*  29460 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29527), // Rule ID 2240 //
     /*  29465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29493 */     // MIs[1] imm
     /*  29493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29505 */     // MIs[2] Operand 1
     /*  29505 */     // No operand predicates
     /*  29505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29511 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29525 */     GIR_RootConstrainSelectedInstOperands,
     /*  29526 */     // GIR_Coverage, 2240,
     /*  29526 */     GIR_EraseRootFromParent_Done,
     /*  29527 */   // Label 467: @29527
     /*  29527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29594), // Rule ID 2299 //
     /*  29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29560 */     // MIs[1] imm
     /*  29560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29572 */     // MIs[2] Operand 1
     /*  29572 */     // No operand predicates
     /*  29572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29578 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 2299,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 468: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29664), // Rule ID 6961 //
     /*  29599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29637 */     // MIs[2] Rn
     /*  29637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29642 */     // MIs[2] Rm
     /*  29642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29649 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 6961,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 469: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29734), // Rule ID 14020 //
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29707 */     // MIs[2] Rn
     /*  29707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29712 */     // MIs[2] Rm
     /*  29712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29719 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29732 */     GIR_RootConstrainSelectedInstOperands,
     /*  29733 */     // GIR_Coverage, 14020,
     /*  29733 */     GIR_EraseRootFromParent_Done,
     /*  29734 */   // Label 470: @29734
     /*  29734 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29797), // Rule ID 1789 //
     /*  29739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29782 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29795 */     GIR_RootConstrainSelectedInstOperands,
     /*  29796 */     // GIR_Coverage, 1789,
     /*  29796 */     GIR_EraseRootFromParent_Done,
     /*  29797 */   // Label 471: @29797
     /*  29797 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29860), // Rule ID 1788 //
     /*  29802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29845 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 1788,
     /*  29859 */     GIR_EraseRootFromParent_Done,
     /*  29860 */   // Label 472: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29923), // Rule ID 1714 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29908 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29921 */     GIR_RootConstrainSelectedInstOperands,
     /*  29922 */     // GIR_Coverage, 1714,
     /*  29922 */     GIR_EraseRootFromParent_Done,
     /*  29923 */   // Label 473: @29923
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29986), // Rule ID 1787 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29971 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29984 */     GIR_RootConstrainSelectedInstOperands,
     /*  29985 */     // GIR_Coverage, 1787,
     /*  29985 */     GIR_EraseRootFromParent_Done,
     /*  29986 */   // Label 474: @29986
     /*  29986 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30049), // Rule ID 1786 //
     /*  29991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30034 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30047 */     GIR_RootConstrainSelectedInstOperands,
     /*  30048 */     // GIR_Coverage, 1786,
     /*  30048 */     GIR_EraseRootFromParent_Done,
     /*  30049 */   // Label 475: @30049
     /*  30049 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30110), // Rule ID 13475 //
     /*  30054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30093 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30108 */     GIR_RootConstrainSelectedInstOperands,
     /*  30109 */     // GIR_Coverage, 13475,
     /*  30109 */     GIR_EraseRootFromParent_Done,
     /*  30110 */   // Label 476: @30110
     /*  30110 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30171), // Rule ID 13509 //
     /*  30115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30154 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30169 */     GIR_RootConstrainSelectedInstOperands,
     /*  30170 */     // GIR_Coverage, 13509,
     /*  30170 */     GIR_EraseRootFromParent_Done,
     /*  30171 */   // Label 477: @30171
     /*  30171 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30219), // Rule ID 13500 //
     /*  30176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30206 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30217 */     GIR_RootConstrainSelectedInstOperands,
     /*  30218 */     // GIR_Coverage, 13500,
     /*  30218 */     GIR_EraseRootFromParent_Done,
     /*  30219 */   // Label 478: @30219
     /*  30219 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30267), // Rule ID 13385 //
     /*  30224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30254 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 13385,
     /*  30266 */     GIR_EraseRootFromParent_Done,
     /*  30267 */   // Label 479: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30315), // Rule ID 13469 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30302 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30313 */     GIR_RootConstrainSelectedInstOperands,
     /*  30314 */     // GIR_Coverage, 13469,
     /*  30314 */     GIR_EraseRootFromParent_Done,
     /*  30315 */   // Label 480: @30315
     /*  30315 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30363), // Rule ID 13397 //
     /*  30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30350 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30361 */     GIR_RootConstrainSelectedInstOperands,
     /*  30362 */     // GIR_Coverage, 13397,
     /*  30362 */     GIR_EraseRootFromParent_Done,
     /*  30363 */   // Label 481: @30363
     /*  30363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30411), // Rule ID 13499 //
     /*  30368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30398 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30409 */     GIR_RootConstrainSelectedInstOperands,
     /*  30410 */     // GIR_Coverage, 13499,
     /*  30410 */     GIR_EraseRootFromParent_Done,
     /*  30411 */   // Label 482: @30411
     /*  30411 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30472), // Rule ID 1726 //
     /*  30416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1726,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 483: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30533), // Rule ID 1816 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30516 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30531 */     GIR_RootConstrainSelectedInstOperands,
     /*  30532 */     // GIR_Coverage, 1816,
     /*  30532 */     GIR_EraseRootFromParent_Done,
     /*  30533 */   // Label 484: @30533
     /*  30533 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30581), // Rule ID 1807 //
     /*  30538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30568 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30579 */     GIR_RootConstrainSelectedInstOperands,
     /*  30580 */     // GIR_Coverage, 1807,
     /*  30580 */     GIR_EraseRootFromParent_Done,
     /*  30581 */   // Label 485: @30581
     /*  30581 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30629), // Rule ID 994 //
     /*  30586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30616 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30627 */     GIR_RootConstrainSelectedInstOperands,
     /*  30628 */     // GIR_Coverage, 994,
     /*  30628 */     GIR_EraseRootFromParent_Done,
     /*  30629 */   // Label 486: @30629
     /*  30629 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30677), // Rule ID 1720 //
     /*  30634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30664 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1720,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 487: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30725), // Rule ID 1055 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30723 */     GIR_RootConstrainSelectedInstOperands,
     /*  30724 */     // GIR_Coverage, 1055,
     /*  30724 */     GIR_EraseRootFromParent_Done,
     /*  30725 */   // Label 488: @30725
     /*  30725 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30773), // Rule ID 1806 //
     /*  30730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30771 */     GIR_RootConstrainSelectedInstOperands,
     /*  30772 */     // GIR_Coverage, 1806,
     /*  30772 */     GIR_EraseRootFromParent_Done,
     /*  30773 */   // Label 489: @30773
     /*  30773 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30800), // Rule ID 1105 //
     /*  30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30798 */     GIR_RootConstrainSelectedInstOperands,
     /*  30799 */     // GIR_Coverage, 1105,
     /*  30799 */     GIR_Done,
     /*  30800 */   // Label 490: @30800
     /*  30800 */   GIM_Reject,
     /*  30801 */ // Label 409: @30801
     /*  30801 */ GIM_Reject,
     /*  30802 */ // Label 161: @30802
     /*  30802 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31651),
     /*  30807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30813 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30946), // Rule ID 14025 //
     /*  30818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30863 */     // MIs[1] Operand 2
     /*  30863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30894 */     // MIs[5] Rn
     /*  30894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30899 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30901 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30945 */     // GIR_Coverage, 14025,
     /*  30945 */     GIR_EraseRootFromParent_Done,
     /*  30946 */   // Label 492: @30946
     /*  30946 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31079), // Rule ID 6966 //
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31008 */     // MIs[4] Rn
     /*  31008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31021 */     // MIs[3] Operand 2
     /*  31021 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31032 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31034 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31078 */     // GIR_Coverage, 6966,
     /*  31078 */     GIR_EraseRootFromParent_Done,
     /*  31079 */   // Label 493: @31079
     /*  31079 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31148), // Rule ID 13414 //
     /*  31084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31131 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31146 */     GIR_RootConstrainSelectedInstOperands,
     /*  31147 */     // GIR_Coverage, 13414,
     /*  31147 */     GIR_EraseRootFromParent_Done,
     /*  31148 */   // Label 494: @31148
     /*  31148 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31217), // Rule ID 13426 //
     /*  31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31200 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31215 */     GIR_RootConstrainSelectedInstOperands,
     /*  31216 */     // GIR_Coverage, 13426,
     /*  31216 */     GIR_EraseRootFromParent_Done,
     /*  31217 */   // Label 495: @31217
     /*  31217 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31284), // Rule ID 13628 //
     /*  31222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     // MIs[1] imm
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31258 */     // MIs[2] Operand 1
     /*  31258 */     // No operand predicates
     /*  31258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31268 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31282 */     GIR_RootConstrainSelectedInstOperands,
     /*  31283 */     // GIR_Coverage, 13628,
     /*  31283 */     GIR_EraseRootFromParent_Done,
     /*  31284 */   // Label 496: @31284
     /*  31284 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31351), // Rule ID 13649 //
     /*  31289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     // MIs[1] imm
     /*  31313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31325 */     // MIs[2] Operand 1
     /*  31325 */     // No operand predicates
     /*  31325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31335 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31349 */     GIR_RootConstrainSelectedInstOperands,
     /*  31350 */     // GIR_Coverage, 13649,
     /*  31350 */     GIR_EraseRootFromParent_Done,
     /*  31351 */   // Label 497: @31351
     /*  31351 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31420), // Rule ID 1357 //
     /*  31356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31403 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31418 */     GIR_RootConstrainSelectedInstOperands,
     /*  31419 */     // GIR_Coverage, 1357,
     /*  31419 */     GIR_EraseRootFromParent_Done,
     /*  31420 */   // Label 498: @31420
     /*  31420 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31489), // Rule ID 1480 //
     /*  31425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31472 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31487 */     GIR_RootConstrainSelectedInstOperands,
     /*  31488 */     // GIR_Coverage, 1480,
     /*  31488 */     GIR_EraseRootFromParent_Done,
     /*  31489 */   // Label 499: @31489
     /*  31489 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31556), // Rule ID 2230 //
     /*  31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31522 */     // MIs[1] imm
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31534 */     // MIs[2] Operand 1
     /*  31534 */     // No operand predicates
     /*  31534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31540 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31554 */     GIR_RootConstrainSelectedInstOperands,
     /*  31555 */     // GIR_Coverage, 2230,
     /*  31555 */     GIR_EraseRootFromParent_Done,
     /*  31556 */   // Label 500: @31556
     /*  31556 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31623), // Rule ID 2289 //
     /*  31561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31589 */     // MIs[1] imm
     /*  31589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31601 */     // MIs[2] Operand 1
     /*  31601 */     // No operand predicates
     /*  31601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31607 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31621 */     GIR_RootConstrainSelectedInstOperands,
     /*  31622 */     // GIR_Coverage, 2289,
     /*  31622 */     GIR_EraseRootFromParent_Done,
     /*  31623 */   // Label 501: @31623
     /*  31623 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31650), // Rule ID 1100 //
     /*  31628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31643 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31648 */     GIR_RootConstrainSelectedInstOperands,
     /*  31649 */     // GIR_Coverage, 1100,
     /*  31649 */     GIR_Done,
     /*  31650 */   // Label 502: @31650
     /*  31650 */   GIM_Reject,
     /*  31651 */ // Label 491: @31651
     /*  31651 */ GIM_Reject,
     /*  31652 */ // Label 162: @31652
     /*  31652 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35229),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31663 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31750), // Rule ID 13458 //
     /*  31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31731 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 13458,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 504: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31837), // Rule ID 13486 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31782 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31785 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31794 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31835 */     GIR_RootConstrainSelectedInstOperands,
     /*  31836 */     // GIR_Coverage, 13486,
     /*  31836 */     GIR_EraseRootFromParent_Done,
     /*  31837 */   // Label 505: @31837
     /*  31837 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31924), // Rule ID 1691 //
     /*  31842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31885 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31905 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31922 */     GIR_RootConstrainSelectedInstOperands,
     /*  31923 */     // GIR_Coverage, 1691,
     /*  31923 */     GIR_EraseRootFromParent_Done,
     /*  31924 */   // Label 506: @31924
     /*  31924 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32011), // Rule ID 1769 //
     /*  31929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31963 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31972 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31992 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32009 */     GIR_RootConstrainSelectedInstOperands,
     /*  32010 */     // GIR_Coverage, 1769,
     /*  32010 */     GIR_EraseRootFromParent_Done,
     /*  32011 */   // Label 507: @32011
     /*  32011 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32080), // Rule ID 1785 //
     /*  32016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32063 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32078 */     GIR_RootConstrainSelectedInstOperands,
     /*  32079 */     // GIR_Coverage, 1785,
     /*  32079 */     GIR_EraseRootFromParent_Done,
     /*  32080 */   // Label 508: @32080
     /*  32080 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32149), // Rule ID 1784 //
     /*  32085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32132 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32147 */     GIR_RootConstrainSelectedInstOperands,
     /*  32148 */     // GIR_Coverage, 1784,
     /*  32148 */     GIR_EraseRootFromParent_Done,
     /*  32149 */   // Label 509: @32149
     /*  32149 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32218), // Rule ID 1713 //
     /*  32154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32201 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32216 */     GIR_RootConstrainSelectedInstOperands,
     /*  32217 */     // GIR_Coverage, 1713,
     /*  32217 */     GIR_EraseRootFromParent_Done,
     /*  32218 */   // Label 510: @32218
     /*  32218 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32287), // Rule ID 1783 //
     /*  32223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32270 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32285 */     GIR_RootConstrainSelectedInstOperands,
     /*  32286 */     // GIR_Coverage, 1783,
     /*  32286 */     GIR_EraseRootFromParent_Done,
     /*  32287 */   // Label 511: @32287
     /*  32287 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32356), // Rule ID 1782 //
     /*  32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32339 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32354 */     GIR_RootConstrainSelectedInstOperands,
     /*  32355 */     // GIR_Coverage, 1782,
     /*  32355 */     GIR_EraseRootFromParent_Done,
     /*  32356 */   // Label 512: @32356
     /*  32356 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32423), // Rule ID 13474 //
     /*  32361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32404 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32421 */     GIR_RootConstrainSelectedInstOperands,
     /*  32422 */     // GIR_Coverage, 13474,
     /*  32422 */     GIR_EraseRootFromParent_Done,
     /*  32423 */   // Label 513: @32423
     /*  32423 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32490), // Rule ID 13508 //
     /*  32428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32471 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32488 */     GIR_RootConstrainSelectedInstOperands,
     /*  32489 */     // GIR_Coverage, 13508,
     /*  32489 */     GIR_EraseRootFromParent_Done,
     /*  32490 */   // Label 514: @32490
     /*  32490 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32557), // Rule ID 1725 //
     /*  32495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32538 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32555 */     GIR_RootConstrainSelectedInstOperands,
     /*  32556 */     // GIR_Coverage, 1725,
     /*  32556 */     GIR_EraseRootFromParent_Done,
     /*  32557 */   // Label 515: @32557
     /*  32557 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32624), // Rule ID 1815 //
     /*  32562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32605 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 1815,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 516: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32705), // Rule ID 13456 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32656 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32659 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32688 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 13456,
     /*  32704 */     GIR_EraseRootFromParent_Done,
     /*  32705 */   // Label 517: @32705
     /*  32705 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32786), // Rule ID 13484 //
     /*  32710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32769 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32784 */     GIR_RootConstrainSelectedInstOperands,
     /*  32785 */     // GIR_Coverage, 13484,
     /*  32785 */     GIR_EraseRootFromParent_Done,
     /*  32786 */   // Label 518: @32786
     /*  32786 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32867), // Rule ID 1689 //
     /*  32791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32822 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32825 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32834 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32850 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32865 */     GIR_RootConstrainSelectedInstOperands,
     /*  32866 */     // GIR_Coverage, 1689,
     /*  32866 */     GIR_EraseRootFromParent_Done,
     /*  32867 */   // Label 519: @32867
     /*  32867 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32948), // Rule ID 1767 //
     /*  32872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32903 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32906 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32915 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 1767,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 520: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32999), // Rule ID 13498 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32985 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32997 */     GIR_RootConstrainSelectedInstOperands,
     /*  32998 */     // GIR_Coverage, 13498,
     /*  32998 */     GIR_EraseRootFromParent_Done,
     /*  32999 */   // Label 521: @32999
     /*  32999 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33050), // Rule ID 13468 //
     /*  33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33036 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33048 */     GIR_RootConstrainSelectedInstOperands,
     /*  33049 */     // GIR_Coverage, 13468,
     /*  33049 */     GIR_EraseRootFromParent_Done,
     /*  33050 */   // Label 522: @33050
     /*  33050 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33101), // Rule ID 13497 //
     /*  33055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33087 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33099 */     GIR_RootConstrainSelectedInstOperands,
     /*  33100 */     // GIR_Coverage, 13497,
     /*  33100 */     GIR_EraseRootFromParent_Done,
     /*  33101 */   // Label 523: @33101
     /*  33101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33152), // Rule ID 1805 //
     /*  33106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33138 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33150 */     GIR_RootConstrainSelectedInstOperands,
     /*  33151 */     // GIR_Coverage, 1805,
     /*  33151 */     GIR_EraseRootFromParent_Done,
     /*  33152 */   // Label 524: @33152
     /*  33152 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33203), // Rule ID 1719 //
     /*  33157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33189 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33201 */     GIR_RootConstrainSelectedInstOperands,
     /*  33202 */     // GIR_Coverage, 1719,
     /*  33202 */     GIR_EraseRootFromParent_Done,
     /*  33203 */   // Label 525: @33203
     /*  33203 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33254), // Rule ID 1804 //
     /*  33208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33252 */     GIR_RootConstrainSelectedInstOperands,
     /*  33253 */     // GIR_Coverage, 1804,
     /*  33253 */     GIR_EraseRootFromParent_Done,
     /*  33254 */   // Label 526: @33254
     /*  33254 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33323), // Rule ID 13420 //
     /*  33259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33306 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33321 */     GIR_RootConstrainSelectedInstOperands,
     /*  33322 */     // GIR_Coverage, 13420,
     /*  33322 */     GIR_EraseRootFromParent_Done,
     /*  33323 */   // Label 527: @33323
     /*  33323 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33392), // Rule ID 13432 //
     /*  33328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33375 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13432,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 528: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33448), // Rule ID 13382 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13382,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 529: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33504), // Rule ID 13394 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33491 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33502 */     GIR_RootConstrainSelectedInstOperands,
     /*  33503 */     // GIR_Coverage, 13394,
     /*  33503 */     GIR_EraseRootFromParent_Done,
     /*  33504 */   // Label 530: @33504
     /*  33504 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33571), // Rule ID 13634 //
     /*  33509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     // MIs[1] imm
     /*  33533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33545 */     // MIs[2] Operand 1
     /*  33545 */     // No operand predicates
     /*  33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33555 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33569 */     GIR_RootConstrainSelectedInstOperands,
     /*  33570 */     // GIR_Coverage, 13634,
     /*  33570 */     GIR_EraseRootFromParent_Done,
     /*  33571 */   // Label 531: @33571
     /*  33571 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33638), // Rule ID 13655 //
     /*  33576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     // MIs[1] imm
     /*  33600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33612 */     // MIs[2] Operand 1
     /*  33612 */     // No operand predicates
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33622 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 13655,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 532: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33707), // Rule ID 1363 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33662 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33665 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33690 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 1363,
     /*  33706 */     GIR_EraseRootFromParent_Done,
     /*  33707 */   // Label 533: @33707
     /*  33707 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33776), // Rule ID 1486 //
     /*  33712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 1486,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 534: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33832), // Rule ID 991 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 991,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 535: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33888), // Rule ID 1052 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33886 */     GIR_RootConstrainSelectedInstOperands,
     /*  33887 */     // GIR_Coverage, 1052,
     /*  33887 */     GIR_EraseRootFromParent_Done,
     /*  33888 */   // Label 536: @33888
     /*  33888 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33955), // Rule ID 2236 //
     /*  33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33921 */     // MIs[1] imm
     /*  33921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33933 */     // MIs[2] Operand 1
     /*  33933 */     // No operand predicates
     /*  33933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33939 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33953 */     GIR_RootConstrainSelectedInstOperands,
     /*  33954 */     // GIR_Coverage, 2236,
     /*  33954 */     GIR_EraseRootFromParent_Done,
     /*  33955 */   // Label 537: @33955
     /*  33955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34022), // Rule ID 2295 //
     /*  33960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33988 */     // MIs[1] imm
     /*  33988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34000 */     // MIs[2] Operand 1
     /*  34000 */     // No operand predicates
     /*  34000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34006 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34020 */     GIR_RootConstrainSelectedInstOperands,
     /*  34021 */     // GIR_Coverage, 2295,
     /*  34021 */     GIR_EraseRootFromParent_Done,
     /*  34022 */   // Label 538: @34022
     /*  34022 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34092), // Rule ID 6962 //
     /*  34027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34065 */     // MIs[2] Rn
     /*  34065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34070 */     // MIs[2] Rm
     /*  34070 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34077 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34090 */     GIR_RootConstrainSelectedInstOperands,
     /*  34091 */     // GIR_Coverage, 6962,
     /*  34091 */     GIR_EraseRootFromParent_Done,
     /*  34092 */   // Label 539: @34092
     /*  34092 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34162), // Rule ID 14021 //
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34135 */     // MIs[2] Rn
     /*  34135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34140 */     // MIs[2] Rm
     /*  34140 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34147 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34160 */     GIR_RootConstrainSelectedInstOperands,
     /*  34161 */     // GIR_Coverage, 14021,
     /*  34161 */     GIR_EraseRootFromParent_Done,
     /*  34162 */   // Label 540: @34162
     /*  34162 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34225), // Rule ID 1781 //
     /*  34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34210 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34223 */     GIR_RootConstrainSelectedInstOperands,
     /*  34224 */     // GIR_Coverage, 1781,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 541: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34288), // Rule ID 1780 //
     /*  34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34273 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34286 */     GIR_RootConstrainSelectedInstOperands,
     /*  34287 */     // GIR_Coverage, 1780,
     /*  34287 */     GIR_EraseRootFromParent_Done,
     /*  34288 */   // Label 542: @34288
     /*  34288 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34351), // Rule ID 1712 //
     /*  34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34336 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34349 */     GIR_RootConstrainSelectedInstOperands,
     /*  34350 */     // GIR_Coverage, 1712,
     /*  34350 */     GIR_EraseRootFromParent_Done,
     /*  34351 */   // Label 543: @34351
     /*  34351 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34414), // Rule ID 1779 //
     /*  34356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34399 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 1779,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 544: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34477), // Rule ID 1778 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34462 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 1778,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 545: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34538), // Rule ID 13473 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34521 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34536 */     GIR_RootConstrainSelectedInstOperands,
     /*  34537 */     // GIR_Coverage, 13473,
     /*  34537 */     GIR_EraseRootFromParent_Done,
     /*  34538 */   // Label 546: @34538
     /*  34538 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34599), // Rule ID 13507 //
     /*  34543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34582 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 13507,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 547: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34647), // Rule ID 13496 //
     /*  34604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34645 */     GIR_RootConstrainSelectedInstOperands,
     /*  34646 */     // GIR_Coverage, 13496,
     /*  34646 */     GIR_EraseRootFromParent_Done,
     /*  34647 */   // Label 548: @34647
     /*  34647 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34695), // Rule ID 13381 //
     /*  34652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34682 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34693 */     GIR_RootConstrainSelectedInstOperands,
     /*  34694 */     // GIR_Coverage, 13381,
     /*  34694 */     GIR_EraseRootFromParent_Done,
     /*  34695 */   // Label 549: @34695
     /*  34695 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34743), // Rule ID 13467 //
     /*  34700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34730 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34741 */     GIR_RootConstrainSelectedInstOperands,
     /*  34742 */     // GIR_Coverage, 13467,
     /*  34742 */     GIR_EraseRootFromParent_Done,
     /*  34743 */   // Label 550: @34743
     /*  34743 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34791), // Rule ID 13393 //
     /*  34748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34778 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34789 */     GIR_RootConstrainSelectedInstOperands,
     /*  34790 */     // GIR_Coverage, 13393,
     /*  34790 */     GIR_EraseRootFromParent_Done,
     /*  34791 */   // Label 551: @34791
     /*  34791 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34839), // Rule ID 13495 //
     /*  34796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34826 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34837 */     GIR_RootConstrainSelectedInstOperands,
     /*  34838 */     // GIR_Coverage, 13495,
     /*  34838 */     GIR_EraseRootFromParent_Done,
     /*  34839 */   // Label 552: @34839
     /*  34839 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34900), // Rule ID 1724 //
     /*  34844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1724,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 553: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34961), // Rule ID 1814 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34944 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34959 */     GIR_RootConstrainSelectedInstOperands,
     /*  34960 */     // GIR_Coverage, 1814,
     /*  34960 */     GIR_EraseRootFromParent_Done,
     /*  34961 */   // Label 554: @34961
     /*  34961 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35009), // Rule ID 1803 //
     /*  34966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34996 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35007 */     GIR_RootConstrainSelectedInstOperands,
     /*  35008 */     // GIR_Coverage, 1803,
     /*  35008 */     GIR_EraseRootFromParent_Done,
     /*  35009 */   // Label 555: @35009
     /*  35009 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35057), // Rule ID 990 //
     /*  35014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35044 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35055 */     GIR_RootConstrainSelectedInstOperands,
     /*  35056 */     // GIR_Coverage, 990,
     /*  35056 */     GIR_EraseRootFromParent_Done,
     /*  35057 */   // Label 556: @35057
     /*  35057 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35105), // Rule ID 1718 //
     /*  35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35092 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1718,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 557: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35153), // Rule ID 1051 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35140 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35151 */     GIR_RootConstrainSelectedInstOperands,
     /*  35152 */     // GIR_Coverage, 1051,
     /*  35152 */     GIR_EraseRootFromParent_Done,
     /*  35153 */   // Label 558: @35153
     /*  35153 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35201), // Rule ID 1802 //
     /*  35158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35199 */     GIR_RootConstrainSelectedInstOperands,
     /*  35200 */     // GIR_Coverage, 1802,
     /*  35200 */     GIR_EraseRootFromParent_Done,
     /*  35201 */   // Label 559: @35201
     /*  35201 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35228), // Rule ID 1103 //
     /*  35206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35221 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35226 */     GIR_RootConstrainSelectedInstOperands,
     /*  35227 */     // GIR_Coverage, 1103,
     /*  35227 */     GIR_Done,
     /*  35228 */   // Label 560: @35228
     /*  35228 */   GIM_Reject,
     /*  35229 */ // Label 503: @35229
     /*  35229 */ GIM_Reject,
     /*  35230 */ // Label 163: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35953),
     /*  35235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35310), // Rule ID 13416 //
     /*  35246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35293 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 13416,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 562: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35379), // Rule ID 13428 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35362 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35377 */     GIR_RootConstrainSelectedInstOperands,
     /*  35378 */     // GIR_Coverage, 13428,
     /*  35378 */     GIR_EraseRootFromParent_Done,
     /*  35379 */   // Label 563: @35379
     /*  35379 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35446), // Rule ID 13630 //
     /*  35384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     // MIs[1] imm
     /*  35408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35420 */     // MIs[2] Operand 1
     /*  35420 */     // No operand predicates
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35430 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35444 */     GIR_RootConstrainSelectedInstOperands,
     /*  35445 */     // GIR_Coverage, 13630,
     /*  35445 */     GIR_EraseRootFromParent_Done,
     /*  35446 */   // Label 564: @35446
     /*  35446 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35513), // Rule ID 13651 //
     /*  35451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     // MIs[1] imm
     /*  35475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35487 */     // MIs[2] Operand 1
     /*  35487 */     // No operand predicates
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35497 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35511 */     GIR_RootConstrainSelectedInstOperands,
     /*  35512 */     // GIR_Coverage, 13651,
     /*  35512 */     GIR_EraseRootFromParent_Done,
     /*  35513 */   // Label 565: @35513
     /*  35513 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35582), // Rule ID 1359 //
     /*  35518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35537 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35540 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35565 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 1359,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 566: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35651), // Rule ID 1482 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35634 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35649 */     GIR_RootConstrainSelectedInstOperands,
     /*  35650 */     // GIR_Coverage, 1482,
     /*  35650 */     GIR_EraseRootFromParent_Done,
     /*  35651 */   // Label 567: @35651
     /*  35651 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35718), // Rule ID 2232 //
     /*  35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35684 */     // MIs[1] imm
     /*  35684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35696 */     // MIs[2] Operand 1
     /*  35696 */     // No operand predicates
     /*  35696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35702 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 2232,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 568: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35785), // Rule ID 2291 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35751 */     // MIs[1] imm
     /*  35751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35763 */     // MIs[2] Operand 1
     /*  35763 */     // No operand predicates
     /*  35763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35769 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35783 */     GIR_RootConstrainSelectedInstOperands,
     /*  35784 */     // GIR_Coverage, 2291,
     /*  35784 */     GIR_EraseRootFromParent_Done,
     /*  35785 */   // Label 569: @35785
     /*  35785 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35855), // Rule ID 6963 //
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35828 */     // MIs[2] Rn
     /*  35828 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35833 */     // MIs[2] Rm
     /*  35833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35840 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35853 */     GIR_RootConstrainSelectedInstOperands,
     /*  35854 */     // GIR_Coverage, 6963,
     /*  35854 */     GIR_EraseRootFromParent_Done,
     /*  35855 */   // Label 570: @35855
     /*  35855 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35925), // Rule ID 14022 //
     /*  35860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35898 */     // MIs[2] Rn
     /*  35898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35903 */     // MIs[2] Rm
     /*  35903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35910 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35923 */     GIR_RootConstrainSelectedInstOperands,
     /*  35924 */     // GIR_Coverage, 14022,
     /*  35924 */     GIR_EraseRootFromParent_Done,
     /*  35925 */   // Label 571: @35925
     /*  35925 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35952), // Rule ID 1101 //
     /*  35930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35945 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35950 */     GIR_RootConstrainSelectedInstOperands,
     /*  35951 */     // GIR_Coverage, 1101,
     /*  35951 */     GIR_Done,
     /*  35952 */   // Label 572: @35952
     /*  35952 */   GIM_Reject,
     /*  35953 */ // Label 561: @35953
     /*  35953 */ GIM_Reject,
     /*  35954 */ // Label 164: @35954
     /*  35954 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36325),
     /*  35959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35969 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36031), // Rule ID 15206 //
     /*  35974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36005 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36018 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36029 */     GIR_RootConstrainSelectedInstOperands,
     /*  36030 */     // GIR_Coverage, 15206,
     /*  36030 */     GIR_EraseRootFromParent_Done,
     /*  36031 */   // Label 574: @36031
     /*  36031 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36093), // Rule ID 15205 //
     /*  36036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36067 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36080 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36091 */     GIR_RootConstrainSelectedInstOperands,
     /*  36092 */     // GIR_Coverage, 15205,
     /*  36092 */     GIR_EraseRootFromParent_Done,
     /*  36093 */   // Label 575: @36093
     /*  36093 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36155), // Rule ID 15204 //
     /*  36098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36129 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36142 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36153 */     GIR_RootConstrainSelectedInstOperands,
     /*  36154 */     // GIR_Coverage, 15204,
     /*  36154 */     GIR_EraseRootFromParent_Done,
     /*  36155 */   // Label 576: @36155
     /*  36155 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36217), // Rule ID 8938 //
     /*  36160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36191 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36204 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 8938,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 577: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36263), // Rule ID 15207 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36237 */     // MIs[1] Operand 2
     /*  36237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 15207,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 578: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36309), // Rule ID 8939 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36283 */     // MIs[1] Operand 2
     /*  36283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36296 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 8939,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 579: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36324), // Rule ID 2773 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36317 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36322 */     GIR_RootConstrainSelectedInstOperands,
     /*  36323 */     // GIR_Coverage, 2773,
     /*  36323 */     GIR_Done,
     /*  36324 */   // Label 580: @36324
     /*  36324 */   GIM_Reject,
     /*  36325 */ // Label 573: @36325
     /*  36325 */ GIM_Reject,
     /*  36326 */ // Label 165: @36326
     /*  36326 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36351), // Rule ID 2772 //
     /*  36331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36344 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36349 */   GIR_RootConstrainSelectedInstOperands,
     /*  36350 */   // GIR_Coverage, 2772,
     /*  36350 */   GIR_Done,
     /*  36351 */ // Label 581: @36351
     /*  36351 */ GIM_Reject,
     /*  36352 */ // Label 166: @36352
     /*  36352 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36377), // Rule ID 2771 //
     /*  36357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36370 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36375 */   GIR_RootConstrainSelectedInstOperands,
     /*  36376 */   // GIR_Coverage, 2771,
     /*  36376 */   GIR_Done,
     /*  36377 */ // Label 582: @36377
     /*  36377 */ GIM_Reject,
     /*  36378 */ // Label 167: @36378
     /*  36378 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36403), // Rule ID 2770 //
     /*  36383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36396 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36401 */   GIR_RootConstrainSelectedInstOperands,
     /*  36402 */   // GIR_Coverage, 2770,
     /*  36402 */   GIR_Done,
     /*  36403 */ // Label 583: @36403
     /*  36403 */ GIM_Reject,
     /*  36404 */ // Label 168: @36404
     /*  36404 */ GIM_Reject,
     /*  36405 */ // Label 1: @36405
     /*  36405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50632),
     /*  36416 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36504),
     /*  36420 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37986), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41268),
     /*  36432 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42759),
     /*  36436 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45219),
     /*  36440 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46710),
     /*  36444 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49170),
     /*  36448 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49245),
     /*  36452 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50554), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50580), GIMT_Encode4(0),
     /*  36500 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50606),
     /*  36504 */ // Label 584: @36504
     /*  36504 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37985),
     /*  36509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36515 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36667), // Rule ID 9985 //
     /*  36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36559 */     // MIs[2] pattern
     /*  36559 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36562 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36569 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36666 */     // GIR_Coverage, 9985,
     /*  36666 */     GIR_EraseRootFromParent_Done,
     /*  36667 */   // Label 599: @36667
     /*  36667 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36819), // Rule ID 9997 //
     /*  36672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36706 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36711 */     // MIs[2] pattern
     /*  36711 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36714 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36721 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36818 */     // GIR_Coverage, 9997,
     /*  36818 */     GIR_EraseRootFromParent_Done,
     /*  36819 */   // Label 600: @36819
     /*  36819 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36971), // Rule ID 10009 //
     /*  36824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36863 */     // MIs[2] pattern
     /*  36863 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36866 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36873 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36970 */     // GIR_Coverage, 10009,
     /*  36970 */     GIR_EraseRootFromParent_Done,
     /*  36971 */   // Label 601: @36971
     /*  36971 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37123), // Rule ID 10021 //
     /*  36976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37015 */     // MIs[2] pattern
     /*  37015 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37018 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37025 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37051 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37122 */     // GIR_Coverage, 10021,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 602: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37185), // Rule ID 3950 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37164 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37183 */     GIR_RootConstrainSelectedInstOperands,
     /*  37184 */     // GIR_Coverage, 3950,
     /*  37184 */     GIR_EraseRootFromParent_Done,
     /*  37185 */   // Label 603: @37185
     /*  37185 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37342), // Rule ID 10123 //
     /*  37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37221 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37224 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37240 */     // MIs[2] pred
     /*  37240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37247 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37341 */     // GIR_Coverage, 10123,
     /*  37341 */     GIR_EraseRootFromParent_Done,
     /*  37342 */   // Label 604: @37342
     /*  37342 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37499), // Rule ID 10124 //
     /*  37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37381 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37397 */     // MIs[2] pred
     /*  37397 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37404 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37498 */     // GIR_Coverage, 10124,
     /*  37498 */     GIR_EraseRootFromParent_Done,
     /*  37499 */   // Label 605: @37499
     /*  37499 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37656), // Rule ID 10125 //
     /*  37504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37554 */     // MIs[2] pred
     /*  37554 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37655 */     // GIR_Coverage, 10125,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 606: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37813), // Rule ID 10126 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37692 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37695 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37711 */     // MIs[2] pred
     /*  37711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37718 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37812 */     // GIR_Coverage, 10126,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 607: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37849), // Rule ID 3915 //
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37833 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37838 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37847 */     GIR_RootConstrainSelectedInstOperands,
     /*  37848 */     // GIR_Coverage, 3915,
     /*  37848 */     GIR_EraseRootFromParent_Done,
     /*  37849 */   // Label 608: @37849
     /*  37849 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37882), // Rule ID 3920 //
     /*  37854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37869 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37880 */     GIR_RootConstrainSelectedInstOperands,
     /*  37881 */     // GIR_Coverage, 3920,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 609: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37918), // Rule ID 3909 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37902 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37916 */     GIR_RootConstrainSelectedInstOperands,
     /*  37917 */     // GIR_Coverage, 3909,
     /*  37917 */     GIR_EraseRootFromParent_Done,
     /*  37918 */   // Label 610: @37918
     /*  37918 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 3913 //
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37938 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37952 */     GIR_RootConstrainSelectedInstOperands,
     /*  37953 */     // GIR_Coverage, 3913,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37984), // Rule ID 3911 //
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37971 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37976 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37982 */     GIR_RootConstrainSelectedInstOperands,
     /*  37983 */     // GIR_Coverage, 3911,
     /*  37983 */     GIR_Done,
     /*  37984 */   // Label 612: @37984
     /*  37984 */   GIM_Reject,
     /*  37985 */ // Label 598: @37985
     /*  37985 */ GIM_Reject,
     /*  37986 */ // Label 585: @37986
     /*  37986 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41267),
     /*  37991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38133), // Rule ID 5413 //
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38035 */     // MIs[1] Operand 2
     /*  38035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38070 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38075 */     // MIs[3] Operand 2
     /*  38075 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38088 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38132 */     // GIR_Coverage, 5413,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 614: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38269), // Rule ID 5412 //
     /*  38138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38171 */     // MIs[1] Operand 2
     /*  38171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38202 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38206 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38211 */     // MIs[3] Operand 2
     /*  38211 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38224 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38268 */     // GIR_Coverage, 5412,
     /*  38268 */     GIR_EraseRootFromParent_Done,
     /*  38269 */   // Label 615: @38269
     /*  38269 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38405), // Rule ID 5422 //
     /*  38274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38307 */     // MIs[1] Operand 2
     /*  38307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38342 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38347 */     // MIs[3] Operand 2
     /*  38347 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38360 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38404 */     // GIR_Coverage, 5422,
     /*  38404 */     GIR_EraseRootFromParent_Done,
     /*  38405 */   // Label 616: @38405
     /*  38405 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38541), // Rule ID 5411 //
     /*  38410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38443 */     // MIs[1] Operand 2
     /*  38443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38478 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38483 */     // MIs[3] Operand 2
     /*  38483 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38496 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38540 */     // GIR_Coverage, 5411,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 617: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38677), // Rule ID 5410 //
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38579 */     // MIs[1] Operand 2
     /*  38579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38614 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38619 */     // MIs[3] Operand 2
     /*  38619 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38632 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38676 */     // GIR_Coverage, 5410,
     /*  38676 */     GIR_EraseRootFromParent_Done,
     /*  38677 */   // Label 618: @38677
     /*  38677 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38814), // Rule ID 3967 //
     /*  38682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38723 */     // MIs[2] Operand 2
     /*  38723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38746 */     // MIs[3] Operand 1
     /*  38746 */     // No operand predicates
     /*  38746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38748 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 3967,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 619: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38913), // Rule ID 3965 //
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38872 */     // MIs[3] Operand 1
     /*  38872 */     // No operand predicates
     /*  38872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38874 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38886 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 3965,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 620: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39012), // Rule ID 3966 //
     /*  38918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38971 */     // MIs[3] Operand 1
     /*  38971 */     // No operand predicates
     /*  38971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38973 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38985 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39010 */     GIR_RootConstrainSelectedInstOperands,
     /*  39011 */     // GIR_Coverage, 3966,
     /*  39011 */     GIR_EraseRootFromParent_Done,
     /*  39012 */   // Label 621: @39012
     /*  39012 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39098), // Rule ID 3960 //
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39077 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39096 */     GIR_RootConstrainSelectedInstOperands,
     /*  39097 */     // GIR_Coverage, 3960,
     /*  39097 */     GIR_EraseRootFromParent_Done,
     /*  39098 */   // Label 622: @39098
     /*  39098 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39184), // Rule ID 3961 //
     /*  39103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39163 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39182 */     GIR_RootConstrainSelectedInstOperands,
     /*  39183 */     // GIR_Coverage, 3961,
     /*  39183 */     GIR_EraseRootFromParent_Done,
     /*  39184 */   // Label 623: @39184
     /*  39184 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39317), // Rule ID 3973 //
     /*  39189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39230 */     // MIs[2] Operand 2
     /*  39230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39253 */     // MIs[3] Operand 1
     /*  39253 */     // No operand predicates
     /*  39253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39255 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39267 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 3973,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 624: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39412), // Rule ID 3971 //
     /*  39322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39375 */     // MIs[3] Operand 1
     /*  39375 */     // No operand predicates
     /*  39375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39377 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39389 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39410 */     GIR_RootConstrainSelectedInstOperands,
     /*  39411 */     // GIR_Coverage, 3971,
     /*  39411 */     GIR_EraseRootFromParent_Done,
     /*  39412 */   // Label 625: @39412
     /*  39412 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39507), // Rule ID 3972 //
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39470 */     // MIs[3] Operand 1
     /*  39470 */     // No operand predicates
     /*  39470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39472 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39484 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39505 */     GIR_RootConstrainSelectedInstOperands,
     /*  39506 */     // GIR_Coverage, 3972,
     /*  39506 */     GIR_EraseRootFromParent_Done,
     /*  39507 */   // Label 626: @39507
     /*  39507 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39589), // Rule ID 124 //
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39572 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39587 */     GIR_RootConstrainSelectedInstOperands,
     /*  39588 */     // GIR_Coverage, 124,
     /*  39588 */     GIR_EraseRootFromParent_Done,
     /*  39589 */   // Label 627: @39589
     /*  39589 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39671), // Rule ID 126 //
     /*  39594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39654 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39669 */     GIR_RootConstrainSelectedInstOperands,
     /*  39670 */     // GIR_Coverage, 126,
     /*  39670 */     GIR_EraseRootFromParent_Done,
     /*  39671 */   // Label 628: @39671
     /*  39671 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39733), // Rule ID 3951 //
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39712 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 3951,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 629: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39791), // Rule ID 9982 //
     /*  39738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39765 */     // MIs[1] pattern
     /*  39765 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39768 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39775 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39789 */     GIR_RootConstrainSelectedInstOperands,
     /*  39790 */     // GIR_Coverage, 9982,
     /*  39790 */     GIR_EraseRootFromParent_Done,
     /*  39791 */   // Label 630: @39791
     /*  39791 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39849), // Rule ID 9994 //
     /*  39796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39815 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39818 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39823 */     // MIs[1] pattern
     /*  39823 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39826 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39833 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 9994,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 631: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39907), // Rule ID 10006 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39881 */     // MIs[1] pattern
     /*  39881 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39884 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39891 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 10006,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 632: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39965), // Rule ID 10018 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39939 */     // MIs[1] pattern
     /*  39939 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39942 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39949 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 10018,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 633: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40128), // Rule ID 5377 //
     /*  39970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40016 */     // MIs[1] Operand 2
     /*  40016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40029 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40127 */     // GIR_Coverage, 5377,
     /*  40127 */     GIR_EraseRootFromParent_Done,
     /*  40128 */   // Label 634: @40128
     /*  40128 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40291), // Rule ID 5374 //
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40179 */     // MIs[1] Operand 2
     /*  40179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40192 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40290 */     // GIR_Coverage, 5374,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 635: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40441), // Rule ID 5419 //
     /*  40296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40333 */     // MIs[1] Operand 2
     /*  40333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40346 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40440 */     // GIR_Coverage, 5419,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 636: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40591), // Rule ID 5425 //
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40483 */     // MIs[1] Operand 2
     /*  40483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40590 */     // GIR_Coverage, 5425,
     /*  40590 */     GIR_EraseRootFromParent_Done,
     /*  40591 */   // Label 637: @40591
     /*  40591 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40741), // Rule ID 5418 //
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40633 */     // MIs[1] Operand 2
     /*  40633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40646 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40740 */     // GIR_Coverage, 5418,
     /*  40740 */     GIR_EraseRootFromParent_Done,
     /*  40741 */   // Label 638: @40741
     /*  40741 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40777), // Rule ID 3916 //
     /*  40746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40761 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40775 */     GIR_RootConstrainSelectedInstOperands,
     /*  40776 */     // GIR_Coverage, 3916,
     /*  40776 */     GIR_EraseRootFromParent_Done,
     /*  40777 */   // Label 639: @40777
     /*  40777 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40810), // Rule ID 3921 //
     /*  40782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40797 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40808 */     GIR_RootConstrainSelectedInstOperands,
     /*  40809 */     // GIR_Coverage, 3921,
     /*  40809 */     GIR_EraseRootFromParent_Done,
     /*  40810 */   // Label 640: @40810
     /*  40810 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40846), // Rule ID 3910 //
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40830 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 3910,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 641: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40882), // Rule ID 3914 //
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40880 */     GIR_RootConstrainSelectedInstOperands,
     /*  40881 */     // GIR_Coverage, 3914,
     /*  40881 */     GIR_EraseRootFromParent_Done,
     /*  40882 */   // Label 642: @40882
     /*  40882 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40945), // Rule ID 10115 //
     /*  40887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40925 */     // MIs[1] pred
     /*  40925 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40932 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40943 */     GIR_RootConstrainSelectedInstOperands,
     /*  40944 */     // GIR_Coverage, 10115,
     /*  40944 */     GIR_EraseRootFromParent_Done,
     /*  40945 */   // Label 643: @40945
     /*  40945 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 10116 //
     /*  40950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40988 */     // MIs[1] pred
     /*  40988 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 10116,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41071), // Rule ID 10117 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41051 */     // MIs[1] pred
     /*  41051 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41058 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41069 */     GIR_RootConstrainSelectedInstOperands,
     /*  41070 */     // GIR_Coverage, 10117,
     /*  41070 */     GIR_EraseRootFromParent_Done,
     /*  41071 */   // Label 645: @41071
     /*  41071 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41134), // Rule ID 10118 //
     /*  41076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41114 */     // MIs[1] pred
     /*  41114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41121 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 10118,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 646: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41173), // Rule ID 1655 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41164 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41171 */     GIR_RootConstrainSelectedInstOperands,
     /*  41172 */     // GIR_Coverage, 1655,
     /*  41172 */     GIR_EraseRootFromParent_Done,
     /*  41173 */   // Label 647: @41173
     /*  41173 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41209), // Rule ID 5260 //
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41200 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41207 */     GIR_RootConstrainSelectedInstOperands,
     /*  41208 */     // GIR_Coverage, 5260,
     /*  41208 */     GIR_EraseRootFromParent_Done,
     /*  41209 */   // Label 648: @41209
     /*  41209 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41236), // Rule ID 1644 //
     /*  41214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41229 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1644,
     /*  41235 */     GIR_Done,
     /*  41236 */   // Label 649: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41266), // Rule ID 3912 //
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41253 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41264 */     GIR_RootConstrainSelectedInstOperands,
     /*  41265 */     // GIR_Coverage, 3912,
     /*  41265 */     GIR_Done,
     /*  41266 */   // Label 650: @41266
     /*  41266 */   GIM_Reject,
     /*  41267 */ // Label 613: @41267
     /*  41267 */ GIM_Reject,
     /*  41268 */ // Label 586: @41268
     /*  41268 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42758),
     /*  41273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41415), // Rule ID 5409 //
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41317 */     // MIs[1] Operand 2
     /*  41317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41348 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41352 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41357 */     // MIs[3] Operand 2
     /*  41357 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41370 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5409,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 652: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41547), // Rule ID 5408 //
     /*  41420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41449 */     // MIs[1] Operand 2
     /*  41449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41489 */     // MIs[3] Operand 2
     /*  41489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41502 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41546 */     // GIR_Coverage, 5408,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 653: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41679), // Rule ID 5421 //
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41581 */     // MIs[1] Operand 2
     /*  41581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     // MIs[3] Operand 2
     /*  41621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41634 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41678 */     // GIR_Coverage, 5421,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 654: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41811), // Rule ID 5407 //
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41713 */     // MIs[1] Operand 2
     /*  41713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     // MIs[3] Operand 2
     /*  41753 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41766 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41810 */     // GIR_Coverage, 5407,
     /*  41810 */     GIR_EraseRootFromParent_Done,
     /*  41811 */   // Label 655: @41811
     /*  41811 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41943), // Rule ID 5406 //
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41845 */     // MIs[1] Operand 2
     /*  41845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     // MIs[3] Operand 2
     /*  41885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41898 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41942 */     // GIR_Coverage, 5406,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 656: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42102), // Rule ID 5376 //
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41990 */     // MIs[1] Operand 2
     /*  41990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42003 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42101 */     // GIR_Coverage, 5376,
     /*  42101 */     GIR_EraseRootFromParent_Done,
     /*  42102 */   // Label 657: @42102
     /*  42102 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42261), // Rule ID 5373 //
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     // MIs[1] Operand 2
     /*  42149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42162 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42260 */     // GIR_Coverage, 5373,
     /*  42260 */     GIR_EraseRootFromParent_Done,
     /*  42261 */   // Label 658: @42261
     /*  42261 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42407), // Rule ID 5417 //
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42299 */     // MIs[1] Operand 2
     /*  42299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42312 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42338 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42406 */     // GIR_Coverage, 5417,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 659: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42553), // Rule ID 5424 //
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42445 */     // MIs[1] Operand 2
     /*  42445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42458 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42552 */     // GIR_Coverage, 5424,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 660: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42699), // Rule ID 5416 //
     /*  42558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42591 */     // MIs[1] Operand 2
     /*  42591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42604 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42604 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42607 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42611 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42630 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42698 */     // GIR_Coverage, 5416,
     /*  42698 */     GIR_EraseRootFromParent_Done,
     /*  42699 */   // Label 661: @42699
     /*  42699 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42734), // Rule ID 969 //
     /*  42704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42725 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 969,
     /*  42733 */     GIR_EraseRootFromParent_Done,
     /*  42734 */   // Label 662: @42734
     /*  42734 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42757), // Rule ID 1476 //
     /*  42739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42750 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 1476,
     /*  42756 */     GIR_Done,
     /*  42757 */   // Label 663: @42757
     /*  42757 */   GIM_Reject,
     /*  42758 */ // Label 651: @42758
     /*  42758 */ GIM_Reject,
     /*  42759 */ // Label 587: @42759
     /*  42759 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45218),
     /*  42764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42774 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42888), // Rule ID 2048 //
     /*  42779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42847 */     // MIs[4] Operand 1
     /*  42847 */     // No operand predicates
     /*  42847 */     // MIs[2] Operand 2
     /*  42847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42867 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42886 */     GIR_RootConstrainSelectedInstOperands,
     /*  42887 */     // GIR_Coverage, 2048,
     /*  42887 */     GIR_EraseRootFromParent_Done,
     /*  42888 */   // Label 665: @42888
     /*  42888 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43002), // Rule ID 13572 //
     /*  42893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42961 */     // MIs[4] Operand 1
     /*  42961 */     // No operand predicates
     /*  42961 */     // MIs[2] Operand 2
     /*  42961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42981 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43000 */     GIR_RootConstrainSelectedInstOperands,
     /*  43001 */     // GIR_Coverage, 13572,
     /*  43001 */     GIR_EraseRootFromParent_Done,
     /*  43002 */   // Label 666: @43002
     /*  43002 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43116), // Rule ID 2100 //
     /*  43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43075 */     // MIs[4] Operand 1
     /*  43075 */     // No operand predicates
     /*  43075 */     // MIs[2] Operand 2
     /*  43075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43095 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 2100,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 667: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43230), // Rule ID 13608 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43189 */     // MIs[4] Operand 1
     /*  43189 */     // No operand predicates
     /*  43189 */     // MIs[2] Operand 2
     /*  43189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43209 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43228 */     GIR_RootConstrainSelectedInstOperands,
     /*  43229 */     // GIR_Coverage, 13608,
     /*  43229 */     GIR_EraseRootFromParent_Done,
     /*  43230 */   // Label 668: @43230
     /*  43230 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43295), // Rule ID 1855 //
     /*  43235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43278 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43293 */     GIR_RootConstrainSelectedInstOperands,
     /*  43294 */     // GIR_Coverage, 1855,
     /*  43294 */     GIR_EraseRootFromParent_Done,
     /*  43295 */   // Label 669: @43295
     /*  43295 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43360), // Rule ID 1854 //
     /*  43300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43358 */     GIR_RootConstrainSelectedInstOperands,
     /*  43359 */     // GIR_Coverage, 1854,
     /*  43359 */     GIR_EraseRootFromParent_Done,
     /*  43360 */   // Label 670: @43360
     /*  43360 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43425), // Rule ID 1759 //
     /*  43365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43408 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43423 */     GIR_RootConstrainSelectedInstOperands,
     /*  43424 */     // GIR_Coverage, 1759,
     /*  43424 */     GIR_EraseRootFromParent_Done,
     /*  43425 */   // Label 671: @43425
     /*  43425 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43490), // Rule ID 1853 //
     /*  43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43473 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43488 */     GIR_RootConstrainSelectedInstOperands,
     /*  43489 */     // GIR_Coverage, 1853,
     /*  43489 */     GIR_EraseRootFromParent_Done,
     /*  43490 */   // Label 672: @43490
     /*  43490 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43555), // Rule ID 1852 //
     /*  43495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43538 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43553 */     GIR_RootConstrainSelectedInstOperands,
     /*  43554 */     // GIR_Coverage, 1852,
     /*  43554 */     GIR_EraseRootFromParent_Done,
     /*  43555 */   // Label 673: @43555
     /*  43555 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43666), // Rule ID 13570 //
     /*  43560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43628 */     // MIs[4] Operand 1
     /*  43628 */     // No operand predicates
     /*  43628 */     // MIs[2] Operand 2
     /*  43628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43646 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43664 */     GIR_RootConstrainSelectedInstOperands,
     /*  43665 */     // GIR_Coverage, 13570,
     /*  43665 */     GIR_EraseRootFromParent_Done,
     /*  43666 */   // Label 674: @43666
     /*  43666 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43777), // Rule ID 2046 //
     /*  43671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43744 */     // MIs[4] Operand 1
     /*  43744 */     // No operand predicates
     /*  43744 */     // MIs[2] Operand 2
     /*  43744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43757 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43775 */     GIR_RootConstrainSelectedInstOperands,
     /*  43776 */     // GIR_Coverage, 2046,
     /*  43776 */     GIR_EraseRootFromParent_Done,
     /*  43777 */   // Label 675: @43777
     /*  43777 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43888), // Rule ID 13606 //
     /*  43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43850 */     // MIs[4] Operand 1
     /*  43850 */     // No operand predicates
     /*  43850 */     // MIs[2] Operand 2
     /*  43850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43868 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43886 */     GIR_RootConstrainSelectedInstOperands,
     /*  43887 */     // GIR_Coverage, 13606,
     /*  43887 */     GIR_EraseRootFromParent_Done,
     /*  43888 */   // Label 676: @43888
     /*  43888 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43999), // Rule ID 2098 //
     /*  43893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43966 */     // MIs[4] Operand 1
     /*  43966 */     // No operand predicates
     /*  43966 */     // MIs[2] Operand 2
     /*  43966 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43979 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43997 */     GIR_RootConstrainSelectedInstOperands,
     /*  43998 */     // GIR_Coverage, 2098,
     /*  43998 */     GIR_EraseRootFromParent_Done,
     /*  43999 */   // Label 677: @43999
     /*  43999 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44062), // Rule ID 1735 //
     /*  44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44060 */     GIR_RootConstrainSelectedInstOperands,
     /*  44061 */     // GIR_Coverage, 1735,
     /*  44061 */     GIR_EraseRootFromParent_Done,
     /*  44062 */   // Label 678: @44062
     /*  44062 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44125), // Rule ID 1825 //
     /*  44067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44106 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44123 */     GIR_RootConstrainSelectedInstOperands,
     /*  44124 */     // GIR_Coverage, 1825,
     /*  44124 */     GIR_EraseRootFromParent_Done,
     /*  44125 */   // Label 679: @44125
     /*  44125 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44213), // Rule ID 13571 //
     /*  44130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44186 */     // MIs[3] Operand 1
     /*  44186 */     // No operand predicates
     /*  44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44211 */     GIR_RootConstrainSelectedInstOperands,
     /*  44212 */     // GIR_Coverage, 13571,
     /*  44212 */     GIR_EraseRootFromParent_Done,
     /*  44213 */   // Label 680: @44213
     /*  44213 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44301), // Rule ID 2047 //
     /*  44218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44279 */     // MIs[3] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44299 */     GIR_RootConstrainSelectedInstOperands,
     /*  44300 */     // GIR_Coverage, 2047,
     /*  44300 */     GIR_EraseRootFromParent_Done,
     /*  44301 */   // Label 681: @44301
     /*  44301 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44389), // Rule ID 13607 //
     /*  44306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44362 */     // MIs[3] Operand 1
     /*  44362 */     // No operand predicates
     /*  44362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44369 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44387 */     GIR_RootConstrainSelectedInstOperands,
     /*  44388 */     // GIR_Coverage, 13607,
     /*  44388 */     GIR_EraseRootFromParent_Done,
     /*  44389 */   // Label 682: @44389
     /*  44389 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44477), // Rule ID 2099 //
     /*  44394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44455 */     // MIs[3] Operand 1
     /*  44455 */     // No operand predicates
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2099,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 683: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44524), // Rule ID 1867 //
     /*  44482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44510 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44522 */     GIR_RootConstrainSelectedInstOperands,
     /*  44523 */     // GIR_Coverage, 1867,
     /*  44523 */     GIR_EraseRootFromParent_Done,
     /*  44524 */   // Label 684: @44524
     /*  44524 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44571), // Rule ID 1765 //
     /*  44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44569 */     GIR_RootConstrainSelectedInstOperands,
     /*  44570 */     // GIR_Coverage, 1765,
     /*  44570 */     GIR_EraseRootFromParent_Done,
     /*  44571 */   // Label 685: @44571
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44618), // Rule ID 1866 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44604 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44616 */     GIR_RootConstrainSelectedInstOperands,
     /*  44617 */     // GIR_Coverage, 1866,
     /*  44617 */     GIR_EraseRootFromParent_Done,
     /*  44618 */   // Label 686: @44618
     /*  44618 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44677), // Rule ID 1851 //
     /*  44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44662 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1851,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 687: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44736), // Rule ID 1850 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44721 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1850,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 688: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44795), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44780 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1758,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 689: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44854), // Rule ID 1849 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44852 */     GIR_RootConstrainSelectedInstOperands,
     /*  44853 */     // GIR_Coverage, 1849,
     /*  44853 */     GIR_EraseRootFromParent_Done,
     /*  44854 */   // Label 690: @44854
     /*  44854 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44913), // Rule ID 1848 //
     /*  44859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44898 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44911 */     GIR_RootConstrainSelectedInstOperands,
     /*  44912 */     // GIR_Coverage, 1848,
     /*  44912 */     GIR_EraseRootFromParent_Done,
     /*  44913 */   // Label 691: @44913
     /*  44913 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44948), // Rule ID 971 //
     /*  44918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44939 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 971,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 692: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45005), // Rule ID 1734 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44988 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45003 */     GIR_RootConstrainSelectedInstOperands,
     /*  45004 */     // GIR_Coverage, 1734,
     /*  45004 */     GIR_EraseRootFromParent_Done,
     /*  45005 */   // Label 693: @45005
     /*  45005 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45062), // Rule ID 1824 //
     /*  45010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45045 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1824,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 694: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45106), // Rule ID 1865 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45093 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45104 */     GIR_RootConstrainSelectedInstOperands,
     /*  45105 */     // GIR_Coverage, 1865,
     /*  45105 */     GIR_EraseRootFromParent_Done,
     /*  45106 */   // Label 695: @45106
     /*  45106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45150), // Rule ID 1764 //
     /*  45111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45148 */     GIR_RootConstrainSelectedInstOperands,
     /*  45149 */     // GIR_Coverage, 1764,
     /*  45149 */     GIR_EraseRootFromParent_Done,
     /*  45150 */   // Label 696: @45150
     /*  45150 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45194), // Rule ID 1864 //
     /*  45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45192 */     GIR_RootConstrainSelectedInstOperands,
     /*  45193 */     // GIR_Coverage, 1864,
     /*  45193 */     GIR_EraseRootFromParent_Done,
     /*  45194 */   // Label 697: @45194
     /*  45194 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45217), // Rule ID 1478 //
     /*  45199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45210 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1478,
     /*  45216 */     GIR_Done,
     /*  45217 */   // Label 698: @45217
     /*  45217 */   GIM_Reject,
     /*  45218 */ // Label 664: @45218
     /*  45218 */ GIM_Reject,
     /*  45219 */ // Label 588: @45219
     /*  45219 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46709),
     /*  45224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45234 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45366), // Rule ID 5405 //
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45268 */     // MIs[1] Operand 2
     /*  45268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45308 */     // MIs[3] Operand 2
     /*  45308 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45321 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45365 */     // GIR_Coverage, 5405,
     /*  45365 */     GIR_EraseRootFromParent_Done,
     /*  45366 */   // Label 700: @45366
     /*  45366 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45498), // Rule ID 5404 //
     /*  45371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45400 */     // MIs[1] Operand 2
     /*  45400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45440 */     // MIs[3] Operand 2
     /*  45440 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45453 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45497 */     // GIR_Coverage, 5404,
     /*  45497 */     GIR_EraseRootFromParent_Done,
     /*  45498 */   // Label 701: @45498
     /*  45498 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45630), // Rule ID 5420 //
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45532 */     // MIs[1] Operand 2
     /*  45532 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45567 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     // MIs[3] Operand 2
     /*  45572 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45585 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45629 */     // GIR_Coverage, 5420,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 702: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45762), // Rule ID 5403 //
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45664 */     // MIs[1] Operand 2
     /*  45664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     // MIs[3] Operand 2
     /*  45704 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45717 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45761 */     // GIR_Coverage, 5403,
     /*  45761 */     GIR_EraseRootFromParent_Done,
     /*  45762 */   // Label 703: @45762
     /*  45762 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45894), // Rule ID 5402 //
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45796 */     // MIs[1] Operand 2
     /*  45796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     // MIs[3] Operand 2
     /*  45836 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45849 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45893 */     // GIR_Coverage, 5402,
     /*  45893 */     GIR_EraseRootFromParent_Done,
     /*  45894 */   // Label 704: @45894
     /*  45894 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46053), // Rule ID 5375 //
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45941 */     // MIs[1] Operand 2
     /*  45941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45954 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45980 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45987 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46052 */     // GIR_Coverage, 5375,
     /*  46052 */     GIR_EraseRootFromParent_Done,
     /*  46053 */   // Label 705: @46053
     /*  46053 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46212), // Rule ID 5372 //
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     // MIs[1] Operand 2
     /*  46100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46113 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46146 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46194 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46211 */     // GIR_Coverage, 5372,
     /*  46211 */     GIR_EraseRootFromParent_Done,
     /*  46212 */   // Label 706: @46212
     /*  46212 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46358), // Rule ID 5415 //
     /*  46217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46250 */     // MIs[1] Operand 2
     /*  46250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46263 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46357 */     // GIR_Coverage, 5415,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 707: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46504), // Rule ID 5423 //
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46396 */     // MIs[1] Operand 2
     /*  46396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46409 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46435 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46503 */     // GIR_Coverage, 5423,
     /*  46503 */     GIR_EraseRootFromParent_Done,
     /*  46504 */   // Label 708: @46504
     /*  46504 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46650), // Rule ID 5414 //
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46542 */     // MIs[1] Operand 2
     /*  46542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46555 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46649 */     // GIR_Coverage, 5414,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 709: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46685), // Rule ID 967 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46676 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46683 */     GIR_RootConstrainSelectedInstOperands,
     /*  46684 */     // GIR_Coverage, 967,
     /*  46684 */     GIR_EraseRootFromParent_Done,
     /*  46685 */   // Label 710: @46685
     /*  46685 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46708), // Rule ID 1474 //
     /*  46690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46701 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46706 */     GIR_RootConstrainSelectedInstOperands,
     /*  46707 */     // GIR_Coverage, 1474,
     /*  46707 */     GIR_Done,
     /*  46708 */   // Label 711: @46708
     /*  46708 */   GIM_Reject,
     /*  46709 */ // Label 699: @46709
     /*  46709 */ GIM_Reject,
     /*  46710 */ // Label 589: @46710
     /*  46710 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49169),
     /*  46715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46725 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46839), // Rule ID 2045 //
     /*  46730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46798 */     // MIs[4] Operand 1
     /*  46798 */     // No operand predicates
     /*  46798 */     // MIs[2] Operand 2
     /*  46798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46818 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46837 */     GIR_RootConstrainSelectedInstOperands,
     /*  46838 */     // GIR_Coverage, 2045,
     /*  46838 */     GIR_EraseRootFromParent_Done,
     /*  46839 */   // Label 713: @46839
     /*  46839 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46953), // Rule ID 13569 //
     /*  46844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46908 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46912 */     // MIs[4] Operand 1
     /*  46912 */     // No operand predicates
     /*  46912 */     // MIs[2] Operand 2
     /*  46912 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46932 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 13569,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 714: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47067), // Rule ID 2097 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47022 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47026 */     // MIs[4] Operand 1
     /*  47026 */     // No operand predicates
     /*  47026 */     // MIs[2] Operand 2
     /*  47026 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47046 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47065 */     GIR_RootConstrainSelectedInstOperands,
     /*  47066 */     // GIR_Coverage, 2097,
     /*  47066 */     GIR_EraseRootFromParent_Done,
     /*  47067 */   // Label 715: @47067
     /*  47067 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47181), // Rule ID 13605 //
     /*  47072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47136 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47140 */     // MIs[4] Operand 1
     /*  47140 */     // No operand predicates
     /*  47140 */     // MIs[2] Operand 2
     /*  47140 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47160 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47179 */     GIR_RootConstrainSelectedInstOperands,
     /*  47180 */     // GIR_Coverage, 13605,
     /*  47180 */     GIR_EraseRootFromParent_Done,
     /*  47181 */   // Label 716: @47181
     /*  47181 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47246), // Rule ID 1847 //
     /*  47186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47229 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47244 */     GIR_RootConstrainSelectedInstOperands,
     /*  47245 */     // GIR_Coverage, 1847,
     /*  47245 */     GIR_EraseRootFromParent_Done,
     /*  47246 */   // Label 717: @47246
     /*  47246 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47311), // Rule ID 1846 //
     /*  47251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47294 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47309 */     GIR_RootConstrainSelectedInstOperands,
     /*  47310 */     // GIR_Coverage, 1846,
     /*  47310 */     GIR_EraseRootFromParent_Done,
     /*  47311 */   // Label 718: @47311
     /*  47311 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47376), // Rule ID 1757 //
     /*  47316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47359 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47374 */     GIR_RootConstrainSelectedInstOperands,
     /*  47375 */     // GIR_Coverage, 1757,
     /*  47375 */     GIR_EraseRootFromParent_Done,
     /*  47376 */   // Label 719: @47376
     /*  47376 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47441), // Rule ID 1845 //
     /*  47381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47424 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 1845,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 720: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47506), // Rule ID 1844 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47489 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47504 */     GIR_RootConstrainSelectedInstOperands,
     /*  47505 */     // GIR_Coverage, 1844,
     /*  47505 */     GIR_EraseRootFromParent_Done,
     /*  47506 */   // Label 721: @47506
     /*  47506 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47617), // Rule ID 13567 //
     /*  47511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47571 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47575 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47579 */     // MIs[4] Operand 1
     /*  47579 */     // No operand predicates
     /*  47579 */     // MIs[2] Operand 2
     /*  47579 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47597 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47615 */     GIR_RootConstrainSelectedInstOperands,
     /*  47616 */     // GIR_Coverage, 13567,
     /*  47616 */     GIR_EraseRootFromParent_Done,
     /*  47617 */   // Label 722: @47617
     /*  47617 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47728), // Rule ID 2043 //
     /*  47622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47695 */     // MIs[4] Operand 1
     /*  47695 */     // No operand predicates
     /*  47695 */     // MIs[2] Operand 2
     /*  47695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47708 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 2043,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 723: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47839), // Rule ID 13603 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47801 */     // MIs[4] Operand 1
     /*  47801 */     // No operand predicates
     /*  47801 */     // MIs[2] Operand 2
     /*  47801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47819 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 13603,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 724: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47950), // Rule ID 2095 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47913 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47917 */     // MIs[4] Operand 1
     /*  47917 */     // No operand predicates
     /*  47917 */     // MIs[2] Operand 2
     /*  47917 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47930 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47948 */     GIR_RootConstrainSelectedInstOperands,
     /*  47949 */     // GIR_Coverage, 2095,
     /*  47949 */     GIR_EraseRootFromParent_Done,
     /*  47950 */   // Label 725: @47950
     /*  47950 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48013), // Rule ID 1733 //
     /*  47955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48011 */     GIR_RootConstrainSelectedInstOperands,
     /*  48012 */     // GIR_Coverage, 1733,
     /*  48012 */     GIR_EraseRootFromParent_Done,
     /*  48013 */   // Label 726: @48013
     /*  48013 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48076), // Rule ID 1823 //
     /*  48018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48057 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48074 */     GIR_RootConstrainSelectedInstOperands,
     /*  48075 */     // GIR_Coverage, 1823,
     /*  48075 */     GIR_EraseRootFromParent_Done,
     /*  48076 */   // Label 727: @48076
     /*  48076 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48164), // Rule ID 13568 //
     /*  48081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48137 */     // MIs[3] Operand 1
     /*  48137 */     // No operand predicates
     /*  48137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48162 */     GIR_RootConstrainSelectedInstOperands,
     /*  48163 */     // GIR_Coverage, 13568,
     /*  48163 */     GIR_EraseRootFromParent_Done,
     /*  48164 */   // Label 728: @48164
     /*  48164 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48252), // Rule ID 2044 //
     /*  48169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48230 */     // MIs[3] Operand 1
     /*  48230 */     // No operand predicates
     /*  48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48250 */     GIR_RootConstrainSelectedInstOperands,
     /*  48251 */     // GIR_Coverage, 2044,
     /*  48251 */     GIR_EraseRootFromParent_Done,
     /*  48252 */   // Label 729: @48252
     /*  48252 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48340), // Rule ID 13604 //
     /*  48257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48313 */     // MIs[3] Operand 1
     /*  48313 */     // No operand predicates
     /*  48313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48320 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 13604,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 730: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48428), // Rule ID 2096 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48406 */     // MIs[3] Operand 1
     /*  48406 */     // No operand predicates
     /*  48406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48426 */     GIR_RootConstrainSelectedInstOperands,
     /*  48427 */     // GIR_Coverage, 2096,
     /*  48427 */     GIR_EraseRootFromParent_Done,
     /*  48428 */   // Label 731: @48428
     /*  48428 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48475), // Rule ID 1863 //
     /*  48433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48461 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48473 */     GIR_RootConstrainSelectedInstOperands,
     /*  48474 */     // GIR_Coverage, 1863,
     /*  48474 */     GIR_EraseRootFromParent_Done,
     /*  48475 */   // Label 732: @48475
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48522), // Rule ID 1763 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48520 */     GIR_RootConstrainSelectedInstOperands,
     /*  48521 */     // GIR_Coverage, 1763,
     /*  48521 */     GIR_EraseRootFromParent_Done,
     /*  48522 */   // Label 733: @48522
     /*  48522 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48569), // Rule ID 1862 //
     /*  48527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48555 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 1862,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 734: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48628), // Rule ID 1843 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1843,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 735: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48687), // Rule ID 1842 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48672 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1842,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 736: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48746), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48731 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 1756,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 737: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48805), // Rule ID 1841 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48790 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48803 */     GIR_RootConstrainSelectedInstOperands,
     /*  48804 */     // GIR_Coverage, 1841,
     /*  48804 */     GIR_EraseRootFromParent_Done,
     /*  48805 */   // Label 738: @48805
     /*  48805 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48864), // Rule ID 1840 //
     /*  48810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48849 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48862 */     GIR_RootConstrainSelectedInstOperands,
     /*  48863 */     // GIR_Coverage, 1840,
     /*  48863 */     GIR_EraseRootFromParent_Done,
     /*  48864 */   // Label 739: @48864
     /*  48864 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48899), // Rule ID 970 //
     /*  48869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48890 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 970,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 740: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48956), // Rule ID 1732 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48939 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48954 */     GIR_RootConstrainSelectedInstOperands,
     /*  48955 */     // GIR_Coverage, 1732,
     /*  48955 */     GIR_EraseRootFromParent_Done,
     /*  48956 */   // Label 741: @48956
     /*  48956 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49013), // Rule ID 1822 //
     /*  48961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48996 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 1822,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 742: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49057), // Rule ID 1861 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49044 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49055 */     GIR_RootConstrainSelectedInstOperands,
     /*  49056 */     // GIR_Coverage, 1861,
     /*  49056 */     GIR_EraseRootFromParent_Done,
     /*  49057 */   // Label 743: @49057
     /*  49057 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49101), // Rule ID 1762 //
     /*  49062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1762,
     /*  49100 */     GIR_EraseRootFromParent_Done,
     /*  49101 */   // Label 744: @49101
     /*  49101 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49145), // Rule ID 1860 //
     /*  49106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49143 */     GIR_RootConstrainSelectedInstOperands,
     /*  49144 */     // GIR_Coverage, 1860,
     /*  49144 */     GIR_EraseRootFromParent_Done,
     /*  49145 */   // Label 745: @49145
     /*  49145 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49168), // Rule ID 1477 //
     /*  49150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49161 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1477,
     /*  49167 */     GIR_Done,
     /*  49168 */   // Label 746: @49168
     /*  49168 */   GIM_Reject,
     /*  49169 */ // Label 712: @49169
     /*  49169 */ GIM_Reject,
     /*  49170 */ // Label 590: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49244),
     /*  49175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49185 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49220), // Rule ID 965 //
     /*  49190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49211 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49218 */     GIR_RootConstrainSelectedInstOperands,
     /*  49219 */     // GIR_Coverage, 965,
     /*  49219 */     GIR_EraseRootFromParent_Done,
     /*  49220 */   // Label 748: @49220
     /*  49220 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49243), // Rule ID 1472 //
     /*  49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49236 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49241 */     GIR_RootConstrainSelectedInstOperands,
     /*  49242 */     // GIR_Coverage, 1472,
     /*  49242 */     GIR_Done,
     /*  49243 */   // Label 749: @49243
     /*  49243 */   GIM_Reject,
     /*  49244 */ // Label 747: @49244
     /*  49244 */ GIM_Reject,
     /*  49245 */ // Label 591: @49245
     /*  49245 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50452),
     /*  49250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49260 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49325), // Rule ID 1839 //
     /*  49265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49308 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 1839,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 751: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49390), // Rule ID 1838 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49373 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49388 */     GIR_RootConstrainSelectedInstOperands,
     /*  49389 */     // GIR_Coverage, 1838,
     /*  49389 */     GIR_EraseRootFromParent_Done,
     /*  49390 */   // Label 752: @49390
     /*  49390 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49455), // Rule ID 1755 //
     /*  49395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49438 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1755,
     /*  49454 */     GIR_EraseRootFromParent_Done,
     /*  49455 */   // Label 753: @49455
     /*  49455 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49520), // Rule ID 1837 //
     /*  49460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49503 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49518 */     GIR_RootConstrainSelectedInstOperands,
     /*  49519 */     // GIR_Coverage, 1837,
     /*  49519 */     GIR_EraseRootFromParent_Done,
     /*  49520 */   // Label 754: @49520
     /*  49520 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49585), // Rule ID 1836 //
     /*  49525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49568 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49583 */     GIR_RootConstrainSelectedInstOperands,
     /*  49584 */     // GIR_Coverage, 1836,
     /*  49584 */     GIR_EraseRootFromParent_Done,
     /*  49585 */   // Label 755: @49585
     /*  49585 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49648), // Rule ID 1731 //
     /*  49590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49646 */     GIR_RootConstrainSelectedInstOperands,
     /*  49647 */     // GIR_Coverage, 1731,
     /*  49647 */     GIR_EraseRootFromParent_Done,
     /*  49648 */   // Label 756: @49648
     /*  49648 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49711), // Rule ID 1821 //
     /*  49653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49692 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1821,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 757: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49758), // Rule ID 1859 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49744 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1859,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 758: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49805), // Rule ID 1761 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49791 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1761,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 759: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49852), // Rule ID 1858 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49838 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49850 */     GIR_RootConstrainSelectedInstOperands,
     /*  49851 */     // GIR_Coverage, 1858,
     /*  49851 */     GIR_EraseRootFromParent_Done,
     /*  49852 */   // Label 760: @49852
     /*  49852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49911), // Rule ID 1835 //
     /*  49857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49896 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49909 */     GIR_RootConstrainSelectedInstOperands,
     /*  49910 */     // GIR_Coverage, 1835,
     /*  49910 */     GIR_EraseRootFromParent_Done,
     /*  49911 */   // Label 761: @49911
     /*  49911 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49970), // Rule ID 1834 //
     /*  49916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49955 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1834,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 762: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50029), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50014 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50027 */     GIR_RootConstrainSelectedInstOperands,
     /*  50028 */     // GIR_Coverage, 1754,
     /*  50028 */     GIR_EraseRootFromParent_Done,
     /*  50029 */   // Label 763: @50029
     /*  50029 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50088), // Rule ID 1833 //
     /*  50034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50073 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50086 */     GIR_RootConstrainSelectedInstOperands,
     /*  50087 */     // GIR_Coverage, 1833,
     /*  50087 */     GIR_EraseRootFromParent_Done,
     /*  50088 */   // Label 764: @50088
     /*  50088 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50147), // Rule ID 1832 //
     /*  50093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50132 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 1832,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 765: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50182), // Rule ID 968 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50173 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 968,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 766: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50239), // Rule ID 1730 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50222 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50237 */     GIR_RootConstrainSelectedInstOperands,
     /*  50238 */     // GIR_Coverage, 1730,
     /*  50238 */     GIR_EraseRootFromParent_Done,
     /*  50239 */   // Label 767: @50239
     /*  50239 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50296), // Rule ID 1820 //
     /*  50244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50279 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50294 */     GIR_RootConstrainSelectedInstOperands,
     /*  50295 */     // GIR_Coverage, 1820,
     /*  50295 */     GIR_EraseRootFromParent_Done,
     /*  50296 */   // Label 768: @50296
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50340), // Rule ID 1857 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50327 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50338 */     GIR_RootConstrainSelectedInstOperands,
     /*  50339 */     // GIR_Coverage, 1857,
     /*  50339 */     GIR_EraseRootFromParent_Done,
     /*  50340 */   // Label 769: @50340
     /*  50340 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50384), // Rule ID 1760 //
     /*  50345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50371 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50382 */     GIR_RootConstrainSelectedInstOperands,
     /*  50383 */     // GIR_Coverage, 1760,
     /*  50383 */     GIR_EraseRootFromParent_Done,
     /*  50384 */   // Label 770: @50384
     /*  50384 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50428), // Rule ID 1856 //
     /*  50389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50415 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 1856,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 771: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50451), // Rule ID 1475 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50444 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1475,
     /*  50450 */     GIR_Done,
     /*  50451 */   // Label 772: @50451
     /*  50451 */   GIM_Reject,
     /*  50452 */ // Label 750: @50452
     /*  50452 */ GIM_Reject,
     /*  50453 */ // Label 592: @50453
     /*  50453 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50527),
     /*  50458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50468 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50503), // Rule ID 966 //
     /*  50473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50501 */     GIR_RootConstrainSelectedInstOperands,
     /*  50502 */     // GIR_Coverage, 966,
     /*  50502 */     GIR_EraseRootFromParent_Done,
     /*  50503 */   // Label 774: @50503
     /*  50503 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50526), // Rule ID 1473 //
     /*  50508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50519 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50524 */     GIR_RootConstrainSelectedInstOperands,
     /*  50525 */     // GIR_Coverage, 1473,
     /*  50525 */     GIR_Done,
     /*  50526 */   // Label 775: @50526
     /*  50526 */   GIM_Reject,
     /*  50527 */ // Label 773: @50527
     /*  50527 */ GIM_Reject,
     /*  50528 */ // Label 593: @50528
     /*  50528 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50553), // Rule ID 7485 //
     /*  50533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50546 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50551 */   GIR_RootConstrainSelectedInstOperands,
     /*  50552 */   // GIR_Coverage, 7485,
     /*  50552 */   GIR_Done,
     /*  50553 */ // Label 776: @50553
     /*  50553 */ GIM_Reject,
     /*  50554 */ // Label 594: @50554
     /*  50554 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50579), // Rule ID 7484 //
     /*  50559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50572 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50577 */   GIR_RootConstrainSelectedInstOperands,
     /*  50578 */   // GIR_Coverage, 7484,
     /*  50578 */   GIR_Done,
     /*  50579 */ // Label 777: @50579
     /*  50579 */ GIM_Reject,
     /*  50580 */ // Label 595: @50580
     /*  50580 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50605), // Rule ID 7483 //
     /*  50585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50598 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50603 */   GIR_RootConstrainSelectedInstOperands,
     /*  50604 */   // GIR_Coverage, 7483,
     /*  50604 */   GIR_Done,
     /*  50605 */ // Label 778: @50605
     /*  50605 */ GIM_Reject,
     /*  50606 */ // Label 596: @50606
     /*  50606 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50631), // Rule ID 7482 //
     /*  50611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50624 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50629 */   GIR_RootConstrainSelectedInstOperands,
     /*  50630 */   // GIR_Coverage, 7482,
     /*  50630 */   GIR_Done,
     /*  50631 */ // Label 779: @50631
     /*  50631 */ GIM_Reject,
     /*  50632 */ // Label 597: @50632
     /*  50632 */ GIM_Reject,
     /*  50633 */ // Label 2: @50633
     /*  50633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53153),
     /*  50644 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50684),
     /*  50648 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50841), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  50664 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52415),
     /*  50668 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52753),
     /*  50672 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52919),
     /*  50676 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52953),
     /*  50680 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53119),
     /*  50684 */ // Label 780: @50684
     /*  50684 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50840),
     /*  50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50754), // Rule ID 3952 //
     /*  50704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50735 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50752 */     GIR_RootConstrainSelectedInstOperands,
     /*  50753 */     // GIR_Coverage, 3952,
     /*  50753 */     GIR_EraseRootFromParent_Done,
     /*  50754 */   // Label 790: @50754
     /*  50754 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50809), // Rule ID 13858 //
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50790 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 13858,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 791: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50839), // Rule ID 3948 //
     /*  50814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50822 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50837 */     GIR_RootConstrainSelectedInstOperands,
     /*  50838 */     // GIR_Coverage, 3948,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 792: @50839
     /*  50839 */   GIM_Reject,
     /*  50840 */ // Label 789: @50840
     /*  50840 */ GIM_Reject,
     /*  50841 */ // Label 781: @50841
     /*  50841 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52076),
     /*  50846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50856 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51002), // Rule ID 3957 //
     /*  50861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50882 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50927 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51000 */     GIR_RootConstrainSelectedInstOperands,
     /*  51001 */     // GIR_Coverage, 3957,
     /*  51001 */     GIR_EraseRootFromParent_Done,
     /*  51002 */   // Label 794: @51002
     /*  51002 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51106), // Rule ID 3958 //
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51058 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51104 */     GIR_RootConstrainSelectedInstOperands,
     /*  51105 */     // GIR_Coverage, 3958,
     /*  51105 */     GIR_EraseRootFromParent_Done,
     /*  51106 */   // Label 795: @51106
     /*  51106 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51210), // Rule ID 13861 //
     /*  51111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51149 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51208 */     GIR_RootConstrainSelectedInstOperands,
     /*  51209 */     // GIR_Coverage, 13861,
     /*  51209 */     GIR_EraseRootFromParent_Done,
     /*  51210 */   // Label 796: @51210
     /*  51210 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51265), // Rule ID 3953 //
     /*  51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 3953,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 797: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51320), // Rule ID 13859 //
     /*  51270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51301 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51318 */     GIR_RootConstrainSelectedInstOperands,
     /*  51319 */     // GIR_Coverage, 13859,
     /*  51319 */     GIR_EraseRootFromParent_Done,
     /*  51320 */   // Label 798: @51320
     /*  51320 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51433), // Rule ID 3964 //
     /*  51325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51342 */     // MIs[1] Operand 2
     /*  51342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51365 */     // MIs[2] Operand 1
     /*  51365 */     // No operand predicates
     /*  51365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51367 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51431 */     GIR_RootConstrainSelectedInstOperands,
     /*  51432 */     // GIR_Coverage, 3964,
     /*  51432 */     GIR_EraseRootFromParent_Done,
     /*  51433 */   // Label 799: @51433
     /*  51433 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51508), // Rule ID 3962 //
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51467 */     // MIs[2] Operand 1
     /*  51467 */     // No operand predicates
     /*  51467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51469 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51481 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 3962,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 800: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51583), // Rule ID 3963 //
     /*  51513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51542 */     // MIs[2] Operand 1
     /*  51542 */     // No operand predicates
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51556 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51581 */     GIR_RootConstrainSelectedInstOperands,
     /*  51582 */     // GIR_Coverage, 3963,
     /*  51582 */     GIR_EraseRootFromParent_Done,
     /*  51583 */   // Label 801: @51583
     /*  51583 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51721), // Rule ID 3954 //
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51605 */     // MIs[1] Operand 2
     /*  51605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51633 */     // MIs[2] Operand 2
     /*  51633 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51646 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51719 */     GIR_RootConstrainSelectedInstOperands,
     /*  51720 */     // GIR_Coverage, 3954,
     /*  51720 */     GIR_EraseRootFromParent_Done,
     /*  51721 */   // Label 802: @51721
     /*  51721 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51821), // Rule ID 3955 //
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51743 */     // MIs[1] Operand 2
     /*  51743 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51773 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51819 */     GIR_RootConstrainSelectedInstOperands,
     /*  51820 */     // GIR_Coverage, 3955,
     /*  51820 */     GIR_EraseRootFromParent_Done,
     /*  51821 */   // Label 803: @51821
     /*  51821 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51921), // Rule ID 13860 //
     /*  51826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51860 */     // MIs[2] Operand 2
     /*  51860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51873 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13860,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 804: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51983), // Rule ID 3956 //
     /*  51926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51962 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51981 */     GIR_RootConstrainSelectedInstOperands,
     /*  51982 */     // GIR_Coverage, 3956,
     /*  51982 */     GIR_EraseRootFromParent_Done,
     /*  51983 */   // Label 805: @51983
     /*  51983 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52045), // Rule ID 3959 //
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52024 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 3959,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 806: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52075), // Rule ID 3949 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52058 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3949,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 807: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 793: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 782: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52414),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52178), // Rule ID 13546 //
     /*  52097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52145 */     // MIs[3] Operand 1
     /*  52145 */     // No operand predicates
     /*  52145 */     // MIs[1] Operand 2
     /*  52145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52162 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 13546,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 809: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52264), // Rule ID 2034 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52235 */     // MIs[3] Operand 1
     /*  52235 */     // No operand predicates
     /*  52235 */     // MIs[1] Operand 2
     /*  52235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52248 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52262 */     GIR_RootConstrainSelectedInstOperands,
     /*  52263 */     // GIR_Coverage, 2034,
     /*  52263 */     GIR_EraseRootFromParent_Done,
     /*  52264 */   // Label 810: @52264
     /*  52264 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52327), // Rule ID 13547 //
     /*  52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52305 */     // MIs[2] Operand 1
     /*  52305 */     // No operand predicates
     /*  52305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52311 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52325 */     GIR_RootConstrainSelectedInstOperands,
     /*  52326 */     // GIR_Coverage, 13547,
     /*  52326 */     GIR_EraseRootFromParent_Done,
     /*  52327 */   // Label 811: @52327
     /*  52327 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52390), // Rule ID 2035 //
     /*  52332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52372 */     // MIs[2] Operand 1
     /*  52372 */     // No operand predicates
     /*  52372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52374 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52388 */     GIR_RootConstrainSelectedInstOperands,
     /*  52389 */     // GIR_Coverage, 2035,
     /*  52389 */     GIR_EraseRootFromParent_Done,
     /*  52390 */   // Label 812: @52390
     /*  52390 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52413), // Rule ID 1352 //
     /*  52395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52406 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52411 */     GIR_RootConstrainSelectedInstOperands,
     /*  52412 */     // GIR_Coverage, 1352,
     /*  52412 */     GIR_Done,
     /*  52413 */   // Label 813: @52413
     /*  52413 */   GIM_Reject,
     /*  52414 */ // Label 808: @52414
     /*  52414 */ GIM_Reject,
     /*  52415 */ // Label 783: @52415
     /*  52415 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52752),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52430 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52516), // Rule ID 13543 //
     /*  52435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52483 */     // MIs[3] Operand 1
     /*  52483 */     // No operand predicates
     /*  52483 */     // MIs[1] Operand 2
     /*  52483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52500 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 13543,
     /*  52515 */     GIR_EraseRootFromParent_Done,
     /*  52516 */   // Label 815: @52516
     /*  52516 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52602), // Rule ID 2031 //
     /*  52521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52573 */     // MIs[3] Operand 1
     /*  52573 */     // No operand predicates
     /*  52573 */     // MIs[1] Operand 2
     /*  52573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52586 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52600 */     GIR_RootConstrainSelectedInstOperands,
     /*  52601 */     // GIR_Coverage, 2031,
     /*  52601 */     GIR_EraseRootFromParent_Done,
     /*  52602 */   // Label 816: @52602
     /*  52602 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52665), // Rule ID 13544 //
     /*  52607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52643 */     // MIs[2] Operand 1
     /*  52643 */     // No operand predicates
     /*  52643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52649 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52663 */     GIR_RootConstrainSelectedInstOperands,
     /*  52664 */     // GIR_Coverage, 13544,
     /*  52664 */     GIR_EraseRootFromParent_Done,
     /*  52665 */   // Label 817: @52665
     /*  52665 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52728), // Rule ID 2032 //
     /*  52670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52710 */     // MIs[2] Operand 1
     /*  52710 */     // No operand predicates
     /*  52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52712 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52726 */     GIR_RootConstrainSelectedInstOperands,
     /*  52727 */     // GIR_Coverage, 2032,
     /*  52727 */     GIR_EraseRootFromParent_Done,
     /*  52728 */   // Label 818: @52728
     /*  52728 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52751), // Rule ID 1350 //
     /*  52733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52744 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52749 */     GIR_RootConstrainSelectedInstOperands,
     /*  52750 */     // GIR_Coverage, 1350,
     /*  52750 */     GIR_Done,
     /*  52751 */   // Label 819: @52751
     /*  52751 */   GIM_Reject,
     /*  52752 */ // Label 814: @52752
     /*  52752 */ GIM_Reject,
     /*  52753 */ // Label 784: @52753
     /*  52753 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52918),
     /*  52758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52768 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52831), // Rule ID 13548 //
     /*  52773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52809 */     // MIs[2] Operand 1
     /*  52809 */     // No operand predicates
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52815 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52829 */     GIR_RootConstrainSelectedInstOperands,
     /*  52830 */     // GIR_Coverage, 13548,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 821: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52894), // Rule ID 2036 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52876 */     // MIs[2] Operand 1
     /*  52876 */     // No operand predicates
     /*  52876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52878 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52892 */     GIR_RootConstrainSelectedInstOperands,
     /*  52893 */     // GIR_Coverage, 2036,
     /*  52893 */     GIR_EraseRootFromParent_Done,
     /*  52894 */   // Label 822: @52894
     /*  52894 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52917), // Rule ID 1353 //
     /*  52899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52910 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52915 */     GIR_RootConstrainSelectedInstOperands,
     /*  52916 */     // GIR_Coverage, 1353,
     /*  52916 */     GIR_Done,
     /*  52917 */   // Label 823: @52917
     /*  52917 */   GIM_Reject,
     /*  52918 */ // Label 820: @52918
     /*  52918 */ GIM_Reject,
     /*  52919 */ // Label 785: @52919
     /*  52919 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52952), // Rule ID 1348 //
     /*  52924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52945 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52950 */   GIR_RootConstrainSelectedInstOperands,
     /*  52951 */   // GIR_Coverage, 1348,
     /*  52951 */   GIR_Done,
     /*  52952 */ // Label 824: @52952
     /*  52952 */ GIM_Reject,
     /*  52953 */ // Label 786: @52953
     /*  52953 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53118),
     /*  52958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53031), // Rule ID 13545 //
     /*  52973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53009 */     // MIs[2] Operand 1
     /*  53009 */     // No operand predicates
     /*  53009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53015 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53029 */     GIR_RootConstrainSelectedInstOperands,
     /*  53030 */     // GIR_Coverage, 13545,
     /*  53030 */     GIR_EraseRootFromParent_Done,
     /*  53031 */   // Label 826: @53031
     /*  53031 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53094), // Rule ID 2033 //
     /*  53036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53076 */     // MIs[2] Operand 1
     /*  53076 */     // No operand predicates
     /*  53076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53078 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53092 */     GIR_RootConstrainSelectedInstOperands,
     /*  53093 */     // GIR_Coverage, 2033,
     /*  53093 */     GIR_EraseRootFromParent_Done,
     /*  53094 */   // Label 827: @53094
     /*  53094 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53117), // Rule ID 1351 //
     /*  53099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53110 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1351,
     /*  53116 */     GIR_Done,
     /*  53117 */   // Label 828: @53117
     /*  53117 */   GIM_Reject,
     /*  53118 */ // Label 825: @53118
     /*  53118 */ GIM_Reject,
     /*  53119 */ // Label 787: @53119
     /*  53119 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53152), // Rule ID 1349 //
     /*  53124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53150 */   GIR_RootConstrainSelectedInstOperands,
     /*  53151 */   // GIR_Coverage, 1349,
     /*  53151 */   GIR_Done,
     /*  53152 */ // Label 829: @53152
     /*  53152 */ GIM_Reject,
     /*  53153 */ // Label 788: @53153
     /*  53153 */ GIM_Reject,
     /*  53154 */ // Label 3: @53154
     /*  53154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53235),
     /*  53165 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53173),
     /*  53169 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53204),
     /*  53173 */ // Label 830: @53173
     /*  53173 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53203), // Rule ID 117 //
     /*  53178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53201 */   GIR_RootConstrainSelectedInstOperands,
     /*  53202 */   // GIR_Coverage, 117,
     /*  53202 */   GIR_Done,
     /*  53203 */ // Label 833: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 831: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53234), // Rule ID 118 //
     /*  53209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 118,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 834: @53234
     /*  53234 */ GIM_Reject,
     /*  53235 */ // Label 832: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 4: @53236
     /*  53236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53317),
     /*  53247 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53255),
     /*  53251 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53286),
     /*  53255 */ // Label 835: @53255
     /*  53255 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53285), // Rule ID 115 //
     /*  53260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53278 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 115,
     /*  53284 */   GIR_Done,
     /*  53285 */ // Label 838: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 836: @53286
     /*  53286 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53316), // Rule ID 116 //
     /*  53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53309 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53314 */   GIR_RootConstrainSelectedInstOperands,
     /*  53315 */   // GIR_Coverage, 116,
     /*  53315 */   GIR_Done,
     /*  53316 */ // Label 839: @53316
     /*  53316 */ GIM_Reject,
     /*  53317 */ // Label 837: @53317
     /*  53317 */ GIM_Reject,
     /*  53318 */ // Label 5: @53318
     /*  53318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61063),
     /*  53329 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53417),
     /*  53333 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53915), GIMT_Encode4(0),
     /*  53341 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55350),
     /*  53345 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55510),
     /*  53349 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55670),
     /*  53353 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55830),
     /*  53357 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55990),
     /*  53361 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56150),
     /*  53365 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56310),
     /*  53369 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56470),
     /*  53373 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53385 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57552),
     /*  53389 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*  53397 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58565),
     /*  53401 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59037),
     /*  53405 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59578),
     /*  53409 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60050),
     /*  53413 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60591),
     /*  53417 */ // Label 840: @53417
     /*  53417 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53914),
     /*  53422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53428 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53483), // Rule ID 13301 //
     /*  53433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53470 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53481 */     GIR_RootConstrainSelectedInstOperands,
     /*  53482 */     // GIR_Coverage, 13301,
     /*  53482 */     GIR_EraseRootFromParent_Done,
     /*  53483 */   // Label 860: @53483
     /*  53483 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53538), // Rule ID 162 //
     /*  53488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53525 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53536 */     GIR_RootConstrainSelectedInstOperands,
     /*  53537 */     // GIR_Coverage, 162,
     /*  53537 */     GIR_EraseRootFromParent_Done,
     /*  53538 */   // Label 861: @53538
     /*  53538 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53607), // Rule ID 5672 //
     /*  53543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53580 */     // MIs[2] Operand 1
     /*  53580 */     // No operand predicates
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53593 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53605 */     GIR_RootConstrainSelectedInstOperands,
     /*  53606 */     // GIR_Coverage, 5672,
     /*  53606 */     GIR_EraseRootFromParent_Done,
     /*  53607 */   // Label 862: @53607
     /*  53607 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53676), // Rule ID 5673 //
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53649 */     // MIs[2] Operand 1
     /*  53649 */     // No operand predicates
     /*  53649 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53662 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 5673,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 863: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53729), // Rule ID 13299 //
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53716 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53727 */     GIR_RootConstrainSelectedInstOperands,
     /*  53728 */     // GIR_Coverage, 13299,
     /*  53728 */     GIR_EraseRootFromParent_Done,
     /*  53729 */   // Label 864: @53729
     /*  53729 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53782), // Rule ID 160 //
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53769 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 160,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 865: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53823), // Rule ID 142 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53803 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53807 */     // MIs[1] Operand 1
     /*  53807 */     // No operand predicates
     /*  53807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53809 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53816 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 142,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 866: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53856), // Rule ID 13297 //
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53843 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 13297,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 867: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53889), // Rule ID 158 //
     /*  53861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53876 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53887 */     GIR_RootConstrainSelectedInstOperands,
     /*  53888 */     // GIR_Coverage, 158,
     /*  53888 */     GIR_EraseRootFromParent_Done,
     /*  53889 */   // Label 868: @53889
     /*  53889 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53913), // Rule ID 156 //
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53906 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53911 */     GIR_RootConstrainSelectedInstOperands,
     /*  53912 */     // GIR_Coverage, 156,
     /*  53912 */     GIR_Done,
     /*  53913 */   // Label 869: @53913
     /*  53913 */   GIM_Reject,
     /*  53914 */ // Label 859: @53914
     /*  53914 */ GIM_Reject,
     /*  53915 */ // Label 841: @53915
     /*  53915 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55349),
     /*  53920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53981), // Rule ID 13302 //
     /*  53931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53968 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53979 */     GIR_RootConstrainSelectedInstOperands,
     /*  53980 */     // GIR_Coverage, 13302,
     /*  53980 */     GIR_EraseRootFromParent_Done,
     /*  53981 */   // Label 871: @53981
     /*  53981 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54036), // Rule ID 163 //
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54023 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 163,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 872: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54149), // Rule ID 5674 //
     /*  54041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54090 */     // MIs[3] Operand 1
     /*  54090 */     // No operand predicates
     /*  54090 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54103 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54148 */     // GIR_Coverage, 5674,
     /*  54148 */     GIR_EraseRootFromParent_Done,
     /*  54149 */   // Label 873: @54149
     /*  54149 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54262), // Rule ID 5675 //
     /*  54154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54203 */     // MIs[3] Operand 1
     /*  54203 */     // No operand predicates
     /*  54203 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54216 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     // GIR_Coverage, 5675,
     /*  54261 */     GIR_EraseRootFromParent_Done,
     /*  54262 */   // Label 874: @54262
     /*  54262 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54361), // Rule ID 7134 //
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54287 */     // MIs[1] addr
     /*  54287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54296 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54300 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54313 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54360 */     // GIR_Coverage, 7134,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 875: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54460), // Rule ID 7135 //
     /*  54366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54386 */     // MIs[1] addr
     /*  54386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54399 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54412 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54459 */     // GIR_Coverage, 7135,
     /*  54459 */     GIR_EraseRootFromParent_Done,
     /*  54460 */   // Label 876: @54460
     /*  54460 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54559), // Rule ID 7136 //
     /*  54465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54485 */     // MIs[1] addr
     /*  54485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54511 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54558 */     // GIR_Coverage, 7136,
     /*  54558 */     GIR_EraseRootFromParent_Done,
     /*  54559 */   // Label 877: @54559
     /*  54559 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54658), // Rule ID 7141 //
     /*  54564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54584 */     // MIs[1] addr
     /*  54584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54593 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54597 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54610 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54657 */     // GIR_Coverage, 7141,
     /*  54657 */     GIR_EraseRootFromParent_Done,
     /*  54658 */   // Label 878: @54658
     /*  54658 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54757), // Rule ID 7142 //
     /*  54663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54683 */     // MIs[1] addr
     /*  54683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54696 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54709 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54756 */     // GIR_Coverage, 7142,
     /*  54756 */     GIR_EraseRootFromParent_Done,
     /*  54757 */   // Label 879: @54757
     /*  54757 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54856), // Rule ID 7143 //
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54782 */     // MIs[1] addr
     /*  54782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54795 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54808 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54855 */     // GIR_Coverage, 7143,
     /*  54855 */     GIR_EraseRootFromParent_Done,
     /*  54856 */   // Label 880: @54856
     /*  54856 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54909), // Rule ID 13300 //
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54896 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 13300,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 881: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54962), // Rule ID 161 //
     /*  54914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54949 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54960 */     GIR_RootConstrainSelectedInstOperands,
     /*  54961 */     // GIR_Coverage, 161,
     /*  54961 */     GIR_EraseRootFromParent_Done,
     /*  54962 */   // Label 882: @54962
     /*  54962 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55062), // Rule ID 4001 //
     /*  54967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54975 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  55004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55061 */     // GIR_Coverage, 4001,
     /*  55061 */     GIR_EraseRootFromParent_Done,
     /*  55062 */   // Label 883: @55062
     /*  55062 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55103), // Rule ID 143 //
     /*  55067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55087 */     // MIs[1] Operand 1
     /*  55087 */     // No operand predicates
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55089 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 143,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 884: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55136), // Rule ID 13298 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55123 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55134 */     GIR_RootConstrainSelectedInstOperands,
     /*  55135 */     // GIR_Coverage, 13298,
     /*  55135 */     GIR_EraseRootFromParent_Done,
     /*  55136 */   // Label 885: @55136
     /*  55136 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55169), // Rule ID 159 //
     /*  55141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55156 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55167 */     GIR_RootConstrainSelectedInstOperands,
     /*  55168 */     // GIR_Coverage, 159,
     /*  55168 */     GIR_EraseRootFromParent_Done,
     /*  55169 */   // Label 886: @55169
     /*  55169 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55233), // Rule ID 13966 //
     /*  55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55206 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55220 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 13966,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 887: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55297), // Rule ID 5056 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55284 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55289 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55295 */     GIR_RootConstrainSelectedInstOperands,
     /*  55296 */     // GIR_Coverage, 5056,
     /*  55296 */     GIR_EraseRootFromParent_Done,
     /*  55297 */   // Label 888: @55297
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55321), // Rule ID 157 //
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55314 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55319 */     GIR_RootConstrainSelectedInstOperands,
     /*  55320 */     // GIR_Coverage, 157,
     /*  55320 */     GIR_Done,
     /*  55321 */   // Label 889: @55321
     /*  55321 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55348), // Rule ID 2477 //
     /*  55326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2477,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 890: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 870: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 842: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55425), // Rule ID 13965 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13965,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 892: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55485), // Rule ID 5055 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5055,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 893: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55508), // Rule ID 2476 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55501 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2476,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 894: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 891: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 843: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55585), // Rule ID 13969 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13969,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 896: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55645), // Rule ID 5059 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 5059,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 897: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55668), // Rule ID 2480 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55661 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 2480,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 898: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 895: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 844: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55745), // Rule ID 13964 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13964,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 900: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55805), // Rule ID 5054 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5054,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 901: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55828), // Rule ID 2475 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55821 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2475,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 902: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 899: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 845: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55905), // Rule ID 13968 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13968,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 904: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55965), // Rule ID 5058 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 5058,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 905: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55988), // Rule ID 2479 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 2479,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 906: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 903: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 846: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56149),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56065), // Rule ID 13437 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56052 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56063 */     GIR_RootConstrainSelectedInstOperands,
     /*  56064 */     // GIR_Coverage, 13437,
     /*  56064 */     GIR_EraseRootFromParent_Done,
     /*  56065 */   // Label 908: @56065
     /*  56065 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56125), // Rule ID 1597 //
     /*  56070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56112 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56123 */     GIR_RootConstrainSelectedInstOperands,
     /*  56124 */     // GIR_Coverage, 1597,
     /*  56124 */     GIR_EraseRootFromParent_Done,
     /*  56125 */   // Label 909: @56125
     /*  56125 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56148), // Rule ID 1595 //
     /*  56130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56141 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1595,
     /*  56147 */     GIR_Done,
     /*  56148 */   // Label 910: @56148
     /*  56148 */   GIM_Reject,
     /*  56149 */ // Label 907: @56149
     /*  56149 */ GIM_Reject,
     /*  56150 */ // Label 847: @56150
     /*  56150 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56309),
     /*  56155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56165 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56225), // Rule ID 13967 //
     /*  56170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56212 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 13967,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 912: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56285), // Rule ID 5057 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56272 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56283 */     GIR_RootConstrainSelectedInstOperands,
     /*  56284 */     // GIR_Coverage, 5057,
     /*  56284 */     GIR_EraseRootFromParent_Done,
     /*  56285 */   // Label 913: @56285
     /*  56285 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56308), // Rule ID 2478 //
     /*  56290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56301 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 2478,
     /*  56307 */     GIR_Done,
     /*  56308 */   // Label 914: @56308
     /*  56308 */   GIM_Reject,
     /*  56309 */ // Label 911: @56309
     /*  56309 */ GIM_Reject,
     /*  56310 */ // Label 848: @56310
     /*  56310 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56469),
     /*  56315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56325 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56385), // Rule ID 13438 //
     /*  56330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56372 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56383 */     GIR_RootConstrainSelectedInstOperands,
     /*  56384 */     // GIR_Coverage, 13438,
     /*  56384 */     GIR_EraseRootFromParent_Done,
     /*  56385 */   // Label 916: @56385
     /*  56385 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56445), // Rule ID 1598 //
     /*  56390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56432 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56443 */     GIR_RootConstrainSelectedInstOperands,
     /*  56444 */     // GIR_Coverage, 1598,
     /*  56444 */     GIR_EraseRootFromParent_Done,
     /*  56445 */   // Label 917: @56445
     /*  56445 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56468), // Rule ID 1596 //
     /*  56450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56461 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1596,
     /*  56467 */     GIR_Done,
     /*  56468 */   // Label 918: @56468
     /*  56468 */   GIM_Reject,
     /*  56469 */ // Label 915: @56469
     /*  56469 */ GIM_Reject,
     /*  56470 */ // Label 849: @56470
     /*  56470 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57010),
     /*  56475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56542), // Rule ID 15161 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56540 */     GIR_RootConstrainSelectedInstOperands,
     /*  56541 */     // GIR_Coverage, 15161,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 920: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56599), // Rule ID 15164 //
     /*  56547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56584 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 15164,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 921: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56656), // Rule ID 15160 //
     /*  56604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56641 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56654 */     GIR_RootConstrainSelectedInstOperands,
     /*  56655 */     // GIR_Coverage, 15160,
     /*  56655 */     GIR_EraseRootFromParent_Done,
     /*  56656 */   // Label 922: @56656
     /*  56656 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56713), // Rule ID 15163 //
     /*  56661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56698 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 15163,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 923: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56770), // Rule ID 15159 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56755 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56768 */     GIR_RootConstrainSelectedInstOperands,
     /*  56769 */     // GIR_Coverage, 15159,
     /*  56769 */     GIR_EraseRootFromParent_Done,
     /*  56770 */   // Label 924: @56770
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56827), // Rule ID 15162 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56806 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56812 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56825 */     GIR_RootConstrainSelectedInstOperands,
     /*  56826 */     // GIR_Coverage, 15162,
     /*  56826 */     GIR_EraseRootFromParent_Done,
     /*  56827 */   // Label 925: @56827
     /*  56827 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56884), // Rule ID 8477 //
     /*  56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56869 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 8477,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 926: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56941), // Rule ID 8478 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56926 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56939 */     GIR_RootConstrainSelectedInstOperands,
     /*  56940 */     // GIR_Coverage, 8478,
     /*  56940 */     GIR_EraseRootFromParent_Done,
     /*  56941 */   // Label 927: @56941
     /*  56941 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56988), // Rule ID 10741 //
     /*  56946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56957 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 10741,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 928: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57009), // Rule ID 2746 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56996 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57007 */     GIR_RootConstrainSelectedInstOperands,
     /*  57008 */     // GIR_Coverage, 2746,
     /*  57008 */     GIR_EraseRootFromParent_Done,
     /*  57009 */   // Label 929: @57009
     /*  57009 */   GIM_Reject,
     /*  57010 */ // Label 919: @57010
     /*  57010 */ GIM_Reject,
     /*  57011 */ // Label 850: @57011
     /*  57011 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57551),
     /*  57016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57026 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57083), // Rule ID 15152 //
     /*  57031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57081 */     GIR_RootConstrainSelectedInstOperands,
     /*  57082 */     // GIR_Coverage, 15152,
     /*  57082 */     GIR_EraseRootFromParent_Done,
     /*  57083 */   // Label 931: @57083
     /*  57083 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57140), // Rule ID 15155 //
     /*  57088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57125 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57138 */     GIR_RootConstrainSelectedInstOperands,
     /*  57139 */     // GIR_Coverage, 15155,
     /*  57139 */     GIR_EraseRootFromParent_Done,
     /*  57140 */   // Label 932: @57140
     /*  57140 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57197), // Rule ID 15151 //
     /*  57145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57182 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 15151,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 933: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57254), // Rule ID 15154 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 15154,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 934: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57311), // Rule ID 15150 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57296 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57309 */     GIR_RootConstrainSelectedInstOperands,
     /*  57310 */     // GIR_Coverage, 15150,
     /*  57310 */     GIR_EraseRootFromParent_Done,
     /*  57311 */   // Label 935: @57311
     /*  57311 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57368), // Rule ID 15153 //
     /*  57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57353 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 15153,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 936: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57425), // Rule ID 8473 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57410 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57423 */     GIR_RootConstrainSelectedInstOperands,
     /*  57424 */     // GIR_Coverage, 8473,
     /*  57424 */     GIR_EraseRootFromParent_Done,
     /*  57425 */   // Label 937: @57425
     /*  57425 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57482), // Rule ID 8474 //
     /*  57430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57467 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 8474,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 938: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57529), // Rule ID 10740 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57498 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 10740,
     /*  57528 */     GIR_EraseRootFromParent_Done,
     /*  57529 */   // Label 939: @57529
     /*  57529 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57550), // Rule ID 2745 //
     /*  57534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57537 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 2745,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 940: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 930: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 851: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58023),
     /*  57557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57567 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57622), // Rule ID 15092 //
     /*  57572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57609 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57620 */     GIR_RootConstrainSelectedInstOperands,
     /*  57621 */     // GIR_Coverage, 15092,
     /*  57621 */     GIR_EraseRootFromParent_Done,
     /*  57622 */   // Label 942: @57622
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57677), // Rule ID 15095 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57664 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57675 */     GIR_RootConstrainSelectedInstOperands,
     /*  57676 */     // GIR_Coverage, 15095,
     /*  57676 */     GIR_EraseRootFromParent_Done,
     /*  57677 */   // Label 943: @57677
     /*  57677 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57732), // Rule ID 15091 //
     /*  57682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57719 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57730 */     GIR_RootConstrainSelectedInstOperands,
     /*  57731 */     // GIR_Coverage, 15091,
     /*  57731 */     GIR_EraseRootFromParent_Done,
     /*  57732 */   // Label 944: @57732
     /*  57732 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57787), // Rule ID 15094 //
     /*  57737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57774 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 15094,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 945: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57842), // Rule ID 15090 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57840 */     GIR_RootConstrainSelectedInstOperands,
     /*  57841 */     // GIR_Coverage, 15090,
     /*  57841 */     GIR_EraseRootFromParent_Done,
     /*  57842 */   // Label 946: @57842
     /*  57842 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57897), // Rule ID 15093 //
     /*  57847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57884 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 15093,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 947: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57952), // Rule ID 7522 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57939 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57950 */     GIR_RootConstrainSelectedInstOperands,
     /*  57951 */     // GIR_Coverage, 7522,
     /*  57951 */     GIR_EraseRootFromParent_Done,
     /*  57952 */   // Label 948: @57952
     /*  57952 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58007), // Rule ID 7523 //
     /*  57957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57994 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58005 */     GIR_RootConstrainSelectedInstOperands,
     /*  58006 */     // GIR_Coverage, 7523,
     /*  58006 */     GIR_EraseRootFromParent_Done,
     /*  58007 */   // Label 949: @58007
     /*  58007 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58022), // Rule ID 3139 //
     /*  58012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58015 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 3139,
     /*  58021 */     GIR_Done,
     /*  58022 */   // Label 950: @58022
     /*  58022 */   GIM_Reject,
     /*  58023 */ // Label 941: @58023
     /*  58023 */ GIM_Reject,
     /*  58024 */ // Label 852: @58024
     /*  58024 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58564),
     /*  58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58039 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58096), // Rule ID 15143 //
     /*  58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58081 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 15143,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 952: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58153), // Rule ID 15146 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58138 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58151 */     GIR_RootConstrainSelectedInstOperands,
     /*  58152 */     // GIR_Coverage, 15146,
     /*  58152 */     GIR_EraseRootFromParent_Done,
     /*  58153 */   // Label 953: @58153
     /*  58153 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58210), // Rule ID 15142 //
     /*  58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58195 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 15142,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 954: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58267), // Rule ID 15145 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58265 */     GIR_RootConstrainSelectedInstOperands,
     /*  58266 */     // GIR_Coverage, 15145,
     /*  58266 */     GIR_EraseRootFromParent_Done,
     /*  58267 */   // Label 955: @58267
     /*  58267 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58324), // Rule ID 15141 //
     /*  58272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58309 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58322 */     GIR_RootConstrainSelectedInstOperands,
     /*  58323 */     // GIR_Coverage, 15141,
     /*  58323 */     GIR_EraseRootFromParent_Done,
     /*  58324 */   // Label 956: @58324
     /*  58324 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58381), // Rule ID 15144 //
     /*  58329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58366 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58379 */     GIR_RootConstrainSelectedInstOperands,
     /*  58380 */     // GIR_Coverage, 15144,
     /*  58380 */     GIR_EraseRootFromParent_Done,
     /*  58381 */   // Label 957: @58381
     /*  58381 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58438), // Rule ID 8469 //
     /*  58386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58423 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58436 */     GIR_RootConstrainSelectedInstOperands,
     /*  58437 */     // GIR_Coverage, 8469,
     /*  58437 */     GIR_EraseRootFromParent_Done,
     /*  58438 */   // Label 958: @58438
     /*  58438 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58495), // Rule ID 8470 //
     /*  58443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58480 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58493 */     GIR_RootConstrainSelectedInstOperands,
     /*  58494 */     // GIR_Coverage, 8470,
     /*  58494 */     GIR_EraseRootFromParent_Done,
     /*  58495 */   // Label 959: @58495
     /*  58495 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58542), // Rule ID 10739 //
     /*  58500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58511 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58540 */     GIR_RootConstrainSelectedInstOperands,
     /*  58541 */     // GIR_Coverage, 10739,
     /*  58541 */     GIR_EraseRootFromParent_Done,
     /*  58542 */   // Label 960: @58542
     /*  58542 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58563), // Rule ID 2744 //
     /*  58547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58550 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 2744,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 961: @58563
     /*  58563 */   GIM_Reject,
     /*  58564 */ // Label 951: @58564
     /*  58564 */ GIM_Reject,
     /*  58565 */ // Label 853: @58565
     /*  58565 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59036),
     /*  58570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58635), // Rule ID 15083 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58622 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 15083,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 963: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58690), // Rule ID 15086 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58677 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 15086,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 964: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58745), // Rule ID 15082 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58732 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58743 */     GIR_RootConstrainSelectedInstOperands,
     /*  58744 */     // GIR_Coverage, 15082,
     /*  58744 */     GIR_EraseRootFromParent_Done,
     /*  58745 */   // Label 965: @58745
     /*  58745 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58800), // Rule ID 15085 //
     /*  58750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58787 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 15085,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 966: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58855), // Rule ID 15081 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58853 */     GIR_RootConstrainSelectedInstOperands,
     /*  58854 */     // GIR_Coverage, 15081,
     /*  58854 */     GIR_EraseRootFromParent_Done,
     /*  58855 */   // Label 967: @58855
     /*  58855 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58910), // Rule ID 15084 //
     /*  58860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58897 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 15084,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 968: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58965), // Rule ID 7518 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58952 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58963 */     GIR_RootConstrainSelectedInstOperands,
     /*  58964 */     // GIR_Coverage, 7518,
     /*  58964 */     GIR_EraseRootFromParent_Done,
     /*  58965 */   // Label 969: @58965
     /*  58965 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59020), // Rule ID 7519 //
     /*  58970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59007 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 7519,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 970: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59035), // Rule ID 3138 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59028 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59033 */     GIR_RootConstrainSelectedInstOperands,
     /*  59034 */     // GIR_Coverage, 3138,
     /*  59034 */     GIR_Done,
     /*  59035 */   // Label 971: @59035
     /*  59035 */   GIM_Reject,
     /*  59036 */ // Label 962: @59036
     /*  59036 */ GIM_Reject,
     /*  59037 */ // Label 854: @59037
     /*  59037 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59577),
     /*  59042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59052 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59109), // Rule ID 15134 //
     /*  59057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59094 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59107 */     GIR_RootConstrainSelectedInstOperands,
     /*  59108 */     // GIR_Coverage, 15134,
     /*  59108 */     GIR_EraseRootFromParent_Done,
     /*  59109 */   // Label 973: @59109
     /*  59109 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59166), // Rule ID 15137 //
     /*  59114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59151 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59164 */     GIR_RootConstrainSelectedInstOperands,
     /*  59165 */     // GIR_Coverage, 15137,
     /*  59165 */     GIR_EraseRootFromParent_Done,
     /*  59166 */   // Label 974: @59166
     /*  59166 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59223), // Rule ID 15133 //
     /*  59171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59202 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59208 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 15133,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 975: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59280), // Rule ID 15136 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 15136,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 976: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59337), // Rule ID 15132 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59322 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59335 */     GIR_RootConstrainSelectedInstOperands,
     /*  59336 */     // GIR_Coverage, 15132,
     /*  59336 */     GIR_EraseRootFromParent_Done,
     /*  59337 */   // Label 977: @59337
     /*  59337 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59394), // Rule ID 15135 //
     /*  59342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59379 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 15135,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 978: @59394
     /*  59394 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59451), // Rule ID 8465 //
     /*  59399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59436 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59449 */     GIR_RootConstrainSelectedInstOperands,
     /*  59450 */     // GIR_Coverage, 8465,
     /*  59450 */     GIR_EraseRootFromParent_Done,
     /*  59451 */   // Label 979: @59451
     /*  59451 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59508), // Rule ID 8466 //
     /*  59456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59493 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 8466,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 980: @59508
     /*  59508 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59555), // Rule ID 10738 //
     /*  59513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59524 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 10738,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 981: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59576), // Rule ID 2743 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59563 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 2743,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 982: @59576
     /*  59576 */   GIM_Reject,
     /*  59577 */ // Label 972: @59577
     /*  59577 */ GIM_Reject,
     /*  59578 */ // Label 855: @59578
     /*  59578 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60049),
     /*  59583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59593 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59648), // Rule ID 15074 //
     /*  59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59635 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59646 */     GIR_RootConstrainSelectedInstOperands,
     /*  59647 */     // GIR_Coverage, 15074,
     /*  59647 */     GIR_EraseRootFromParent_Done,
     /*  59648 */   // Label 984: @59648
     /*  59648 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59703), // Rule ID 15077 //
     /*  59653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59690 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59701 */     GIR_RootConstrainSelectedInstOperands,
     /*  59702 */     // GIR_Coverage, 15077,
     /*  59702 */     GIR_EraseRootFromParent_Done,
     /*  59703 */   // Label 985: @59703
     /*  59703 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59758), // Rule ID 15073 //
     /*  59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59745 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59756 */     GIR_RootConstrainSelectedInstOperands,
     /*  59757 */     // GIR_Coverage, 15073,
     /*  59757 */     GIR_EraseRootFromParent_Done,
     /*  59758 */   // Label 986: @59758
     /*  59758 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59813), // Rule ID 15076 //
     /*  59763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59800 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 15076,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 987: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59868), // Rule ID 15072 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59866 */     GIR_RootConstrainSelectedInstOperands,
     /*  59867 */     // GIR_Coverage, 15072,
     /*  59867 */     GIR_EraseRootFromParent_Done,
     /*  59868 */   // Label 988: @59868
     /*  59868 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59923), // Rule ID 15075 //
     /*  59873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59910 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59921 */     GIR_RootConstrainSelectedInstOperands,
     /*  59922 */     // GIR_Coverage, 15075,
     /*  59922 */     GIR_EraseRootFromParent_Done,
     /*  59923 */   // Label 989: @59923
     /*  59923 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59978), // Rule ID 7514 //
     /*  59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59965 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59976 */     GIR_RootConstrainSelectedInstOperands,
     /*  59977 */     // GIR_Coverage, 7514,
     /*  59977 */     GIR_EraseRootFromParent_Done,
     /*  59978 */   // Label 990: @59978
     /*  59978 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60033), // Rule ID 7515 //
     /*  59983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  60002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60020 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60031 */     GIR_RootConstrainSelectedInstOperands,
     /*  60032 */     // GIR_Coverage, 7515,
     /*  60032 */     GIR_EraseRootFromParent_Done,
     /*  60033 */   // Label 991: @60033
     /*  60033 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60048), // Rule ID 3137 //
     /*  60038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60041 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60046 */     GIR_RootConstrainSelectedInstOperands,
     /*  60047 */     // GIR_Coverage, 3137,
     /*  60047 */     GIR_Done,
     /*  60048 */   // Label 992: @60048
     /*  60048 */   GIM_Reject,
     /*  60049 */ // Label 983: @60049
     /*  60049 */ GIM_Reject,
     /*  60050 */ // Label 856: @60050
     /*  60050 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60590),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60122), // Rule ID 15125 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60107 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60120 */     GIR_RootConstrainSelectedInstOperands,
     /*  60121 */     // GIR_Coverage, 15125,
     /*  60121 */     GIR_EraseRootFromParent_Done,
     /*  60122 */   // Label 994: @60122
     /*  60122 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60179), // Rule ID 15128 //
     /*  60127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60164 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60177 */     GIR_RootConstrainSelectedInstOperands,
     /*  60178 */     // GIR_Coverage, 15128,
     /*  60178 */     GIR_EraseRootFromParent_Done,
     /*  60179 */   // Label 995: @60179
     /*  60179 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60236), // Rule ID 15124 //
     /*  60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60221 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 15124,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 996: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60293), // Rule ID 15127 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60291 */     GIR_RootConstrainSelectedInstOperands,
     /*  60292 */     // GIR_Coverage, 15127,
     /*  60292 */     GIR_EraseRootFromParent_Done,
     /*  60293 */   // Label 997: @60293
     /*  60293 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60350), // Rule ID 15123 //
     /*  60298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60335 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60348 */     GIR_RootConstrainSelectedInstOperands,
     /*  60349 */     // GIR_Coverage, 15123,
     /*  60349 */     GIR_EraseRootFromParent_Done,
     /*  60350 */   // Label 998: @60350
     /*  60350 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60407), // Rule ID 15126 //
     /*  60355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60392 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60405 */     GIR_RootConstrainSelectedInstOperands,
     /*  60406 */     // GIR_Coverage, 15126,
     /*  60406 */     GIR_EraseRootFromParent_Done,
     /*  60407 */   // Label 999: @60407
     /*  60407 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60464), // Rule ID 8461 //
     /*  60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60462 */     GIR_RootConstrainSelectedInstOperands,
     /*  60463 */     // GIR_Coverage, 8461,
     /*  60463 */     GIR_EraseRootFromParent_Done,
     /*  60464 */   // Label 1000: @60464
     /*  60464 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60521), // Rule ID 8462 //
     /*  60469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60506 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 8462,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1001: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60568), // Rule ID 10737 //
     /*  60526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60537 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60566 */     GIR_RootConstrainSelectedInstOperands,
     /*  60567 */     // GIR_Coverage, 10737,
     /*  60567 */     GIR_EraseRootFromParent_Done,
     /*  60568 */   // Label 1002: @60568
     /*  60568 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60589), // Rule ID 2742 //
     /*  60573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60576 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 2742,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 1003: @60589
     /*  60589 */   GIM_Reject,
     /*  60590 */ // Label 993: @60590
     /*  60590 */ GIM_Reject,
     /*  60591 */ // Label 857: @60591
     /*  60591 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61062),
     /*  60596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60606 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60661), // Rule ID 15065 //
     /*  60611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60648 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60659 */     GIR_RootConstrainSelectedInstOperands,
     /*  60660 */     // GIR_Coverage, 15065,
     /*  60660 */     GIR_EraseRootFromParent_Done,
     /*  60661 */   // Label 1005: @60661
     /*  60661 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60716), // Rule ID 15068 //
     /*  60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60703 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 15068,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1006: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60771), // Rule ID 15064 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60758 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 15064,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1007: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60826), // Rule ID 15067 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60813 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60824 */     GIR_RootConstrainSelectedInstOperands,
     /*  60825 */     // GIR_Coverage, 15067,
     /*  60825 */     GIR_EraseRootFromParent_Done,
     /*  60826 */   // Label 1008: @60826
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60881), // Rule ID 15063 //
     /*  60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60868 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60879 */     GIR_RootConstrainSelectedInstOperands,
     /*  60880 */     // GIR_Coverage, 15063,
     /*  60880 */     GIR_EraseRootFromParent_Done,
     /*  60881 */   // Label 1009: @60881
     /*  60881 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60936), // Rule ID 15066 //
     /*  60886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60923 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 15066,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1010: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60991), // Rule ID 7510 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60978 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60989 */     GIR_RootConstrainSelectedInstOperands,
     /*  60990 */     // GIR_Coverage, 7510,
     /*  60990 */     GIR_EraseRootFromParent_Done,
     /*  60991 */   // Label 1011: @60991
     /*  60991 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61046), // Rule ID 7511 //
     /*  60996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61033 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61044 */     GIR_RootConstrainSelectedInstOperands,
     /*  61045 */     // GIR_Coverage, 7511,
     /*  61045 */     GIR_EraseRootFromParent_Done,
     /*  61046 */   // Label 1012: @61046
     /*  61046 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61061), // Rule ID 3136 //
     /*  61051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61054 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3136,
     /*  61060 */     GIR_Done,
     /*  61061 */   // Label 1013: @61061
     /*  61061 */   GIM_Reject,
     /*  61062 */ // Label 1004: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 858: @61063
     /*  61063 */ GIM_Reject,
     /*  61064 */ // Label 6: @61064
     /*  61064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(86178),
     /*  61075 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61163),
     /*  61079 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61523), GIMT_Encode4(0),
     /*  61087 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63422),
     /*  61091 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64730),
     /*  61095 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66038),
     /*  61099 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67346),
     /*  61103 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68654),
     /*  61107 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69962),
     /*  61111 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71270),
     /*  61115 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72578),
     /*  61119 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61131 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72642),
     /*  61135 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(76002), GIMT_Encode4(0),
     /*  61143 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(76034),
     /*  61147 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(79394),
     /*  61151 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(79426),
     /*  61155 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(82786),
     /*  61159 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(82818),
     /*  61163 */ // Label 1014: @61163
     /*  61163 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61522),
     /*  61168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61174 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61229), // Rule ID 13321 //
     /*  61179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61216 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61227 */     GIR_RootConstrainSelectedInstOperands,
     /*  61228 */     // GIR_Coverage, 13321,
     /*  61228 */     GIR_EraseRootFromParent_Done,
     /*  61229 */   // Label 1034: @61229
     /*  61229 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61284), // Rule ID 174 //
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61271 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61282 */     GIR_RootConstrainSelectedInstOperands,
     /*  61283 */     // GIR_Coverage, 174,
     /*  61283 */     GIR_EraseRootFromParent_Done,
     /*  61284 */   // Label 1035: @61284
     /*  61284 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61325), // Rule ID 146 //
     /*  61289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61305 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61309 */     // MIs[1] Operand 1
     /*  61309 */     // No operand predicates
     /*  61309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61311 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61318 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61323 */     GIR_RootConstrainSelectedInstOperands,
     /*  61324 */     // GIR_Coverage, 146,
     /*  61324 */     GIR_EraseRootFromParent_Done,
     /*  61325 */   // Label 1036: @61325
     /*  61325 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61358), // Rule ID 13323 //
     /*  61330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61345 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13323,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1037: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61391), // Rule ID 178 //
     /*  61363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61378 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61389 */     GIR_RootConstrainSelectedInstOperands,
     /*  61390 */     // GIR_Coverage, 178,
     /*  61390 */     GIR_EraseRootFromParent_Done,
     /*  61391 */   // Label 1038: @61391
     /*  61391 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61444), // Rule ID 13319 //
     /*  61396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61431 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61442 */     GIR_RootConstrainSelectedInstOperands,
     /*  61443 */     // GIR_Coverage, 13319,
     /*  61443 */     GIR_EraseRootFromParent_Done,
     /*  61444 */   // Label 1039: @61444
     /*  61444 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61497), // Rule ID 172 //
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61484 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 172,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1040: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61521), // Rule ID 176 //
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61514 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 176,
     /*  61520 */     GIR_Done,
     /*  61521 */   // Label 1041: @61521
     /*  61521 */   GIM_Reject,
     /*  61522 */ // Label 1033: @61522
     /*  61522 */ GIM_Reject,
     /*  61523 */ // Label 1015: @61523
     /*  61523 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63421),
     /*  61528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61534 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61656), // Rule ID 4014 //
     /*  61539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61619 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61623 */     // MIs[4] Rn
     /*  61623 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61628 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61632 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61645 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61654 */     GIR_RootConstrainSelectedInstOperands,
     /*  61655 */     // GIR_Coverage, 4014,
     /*  61655 */     GIR_EraseRootFromParent_Done,
     /*  61656 */   // Label 1043: @61656
     /*  61656 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61778), // Rule ID 13881 //
     /*  61661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61706 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61745 */     // MIs[4] Rn
     /*  61745 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61750 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61754 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61765 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61767 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61776 */     GIR_RootConstrainSelectedInstOperands,
     /*  61777 */     // GIR_Coverage, 13881,
     /*  61777 */     GIR_EraseRootFromParent_Done,
     /*  61778 */   // Label 1044: @61778
     /*  61778 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61833), // Rule ID 13322 //
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61820 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 13322,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 1045: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61888), // Rule ID 175 //
     /*  61838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61875 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61886 */     GIR_RootConstrainSelectedInstOperands,
     /*  61887 */     // GIR_Coverage, 175,
     /*  61887 */     GIR_EraseRootFromParent_Done,
     /*  61888 */   // Label 1046: @61888
     /*  61888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61997), // Rule ID 13681 //
     /*  61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61971 */     // MIs[4] LHS
     /*  61971 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61978 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 13681,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1047: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62106), // Rule ID 13680 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62071 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62075 */     // MIs[4] LHS
     /*  62075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62080 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62087 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62104 */     GIR_RootConstrainSelectedInstOperands,
     /*  62105 */     // GIR_Coverage, 13680,
     /*  62105 */     GIR_EraseRootFromParent_Done,
     /*  62106 */   // Label 1048: @62106
     /*  62106 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62215), // Rule ID 13683 //
     /*  62111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62164 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62189 */     // MIs[4] LHS
     /*  62189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62196 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 13683,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 1049: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62324), // Rule ID 13682 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62293 */     // MIs[4] LHS
     /*  62293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62298 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62305 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62322 */     GIR_RootConstrainSelectedInstOperands,
     /*  62323 */     // GIR_Coverage, 13682,
     /*  62323 */     GIR_EraseRootFromParent_Done,
     /*  62324 */   // Label 1050: @62324
     /*  62324 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62433), // Rule ID 2471 //
     /*  62329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62390 */     // MIs[3] LHS
     /*  62390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62414 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62431 */     GIR_RootConstrainSelectedInstOperands,
     /*  62432 */     // GIR_Coverage, 2471,
     /*  62432 */     GIR_EraseRootFromParent_Done,
     /*  62433 */   // Label 1051: @62433
     /*  62433 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62542), // Rule ID 13678 //
     /*  62438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62499 */     // MIs[3] LHS
     /*  62499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62523 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 13678,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1052: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62651), // Rule ID 13677 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62613 */     // MIs[3] LHS
     /*  62613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62632 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62649 */     GIR_RootConstrainSelectedInstOperands,
     /*  62650 */     // GIR_Coverage, 13677,
     /*  62650 */     GIR_EraseRootFromParent_Done,
     /*  62651 */   // Label 1053: @62651
     /*  62651 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62760), // Rule ID 13679 //
     /*  62656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62722 */     // MIs[3] LHS
     /*  62722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62731 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62741 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62758 */     GIR_RootConstrainSelectedInstOperands,
     /*  62759 */     // GIR_Coverage, 13679,
     /*  62759 */     GIR_EraseRootFromParent_Done,
     /*  62760 */   // Label 1054: @62760
     /*  62760 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62801), // Rule ID 147 //
     /*  62765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62781 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62785 */     // MIs[1] Operand 1
     /*  62785 */     // No operand predicates
     /*  62785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62787 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62799 */     GIR_RootConstrainSelectedInstOperands,
     /*  62800 */     // GIR_Coverage, 147,
     /*  62800 */     GIR_EraseRootFromParent_Done,
     /*  62801 */   // Label 1055: @62801
     /*  62801 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62834), // Rule ID 13324 //
     /*  62806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62821 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13324,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1056: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62867), // Rule ID 179 //
     /*  62839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62854 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 179,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1057: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62934), // Rule ID 13617 //
     /*  62872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     // MIs[1] imm
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62908 */     // MIs[2] Operand 1
     /*  62908 */     // No operand predicates
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62918 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62932 */     GIR_RootConstrainSelectedInstOperands,
     /*  62933 */     // GIR_Coverage, 13617,
     /*  62933 */     GIR_EraseRootFromParent_Done,
     /*  62934 */   // Label 1058: @62934
     /*  62934 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63001), // Rule ID 13620 //
     /*  62939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     // MIs[1] imm
     /*  62963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62975 */     // MIs[2] Operand 1
     /*  62975 */     // No operand predicates
     /*  62975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62985 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 13620,
     /*  63000 */     GIR_EraseRootFromParent_Done,
     /*  63001 */   // Label 1059: @63001
     /*  63001 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63054), // Rule ID 13320 //
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63041 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63052 */     GIR_RootConstrainSelectedInstOperands,
     /*  63053 */     // GIR_Coverage, 13320,
     /*  63053 */     GIR_EraseRootFromParent_Done,
     /*  63054 */   // Label 1060: @63054
     /*  63054 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63121), // Rule ID 2122 //
     /*  63059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63087 */     // MIs[1] imm
     /*  63087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63099 */     // MIs[2] Operand 1
     /*  63099 */     // No operand predicates
     /*  63099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63105 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 2122,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1061: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63188), // Rule ID 2131 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     // MIs[1] imm
     /*  63154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63166 */     // MIs[2] Operand 1
     /*  63166 */     // No operand predicates
     /*  63166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63172 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63186 */     GIR_RootConstrainSelectedInstOperands,
     /*  63187 */     // GIR_Coverage, 2131,
     /*  63187 */     GIR_EraseRootFromParent_Done,
     /*  63188 */   // Label 1062: @63188
     /*  63188 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63241), // Rule ID 173 //
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63228 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 173,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 1063: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63305), // Rule ID 13972 //
     /*  63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63292 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63303 */     GIR_RootConstrainSelectedInstOperands,
     /*  63304 */     // GIR_Coverage, 13972,
     /*  63304 */     GIR_EraseRootFromParent_Done,
     /*  63305 */   // Label 1064: @63305
     /*  63305 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63369), // Rule ID 5068 //
     /*  63310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63356 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63361 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 5068,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 1065: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63393), // Rule ID 177 //
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63386 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 177,
     /*  63392 */     GIR_Done,
     /*  63393 */   // Label 1066: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63420), // Rule ID 5074 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63413 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 5074,
     /*  63419 */     GIR_Done,
     /*  63420 */   // Label 1067: @63420
     /*  63420 */   GIM_Reject,
     /*  63421 */ // Label 1042: @63421
     /*  63421 */ GIM_Reject,
     /*  63422 */ // Label 1016: @63422
     /*  63422 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64729),
     /*  63427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63542), // Rule ID 13674 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63516 */     // MIs[4] LHS
     /*  63516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63523 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 13674,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1069: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63651), // Rule ID 13673 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63620 */     // MIs[4] LHS
     /*  63620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63632 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63649 */     GIR_RootConstrainSelectedInstOperands,
     /*  63650 */     // GIR_Coverage, 13673,
     /*  63650 */     GIR_EraseRootFromParent_Done,
     /*  63651 */   // Label 1070: @63651
     /*  63651 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63760), // Rule ID 13676 //
     /*  63656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63709 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63725 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63729 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63734 */     // MIs[4] LHS
     /*  63734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63741 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63758 */     GIR_RootConstrainSelectedInstOperands,
     /*  63759 */     // GIR_Coverage, 13676,
     /*  63759 */     GIR_EraseRootFromParent_Done,
     /*  63760 */   // Label 1071: @63760
     /*  63760 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63869), // Rule ID 13675 //
     /*  63765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63838 */     // MIs[4] LHS
     /*  63838 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63850 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 13675,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1072: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63978), // Rule ID 2470 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63935 */     // MIs[3] LHS
     /*  63935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63959 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63976 */     GIR_RootConstrainSelectedInstOperands,
     /*  63977 */     // GIR_Coverage, 2470,
     /*  63977 */     GIR_EraseRootFromParent_Done,
     /*  63978 */   // Label 1073: @63978
     /*  63978 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64087), // Rule ID 13671 //
     /*  63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64044 */     // MIs[3] LHS
     /*  64044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64053 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64066 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64068 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64085 */     GIR_RootConstrainSelectedInstOperands,
     /*  64086 */     // GIR_Coverage, 13671,
     /*  64086 */     GIR_EraseRootFromParent_Done,
     /*  64087 */   // Label 1074: @64087
     /*  64087 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64196), // Rule ID 13670 //
     /*  64092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64158 */     // MIs[3] LHS
     /*  64158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64167 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64177 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64194 */     GIR_RootConstrainSelectedInstOperands,
     /*  64195 */     // GIR_Coverage, 13670,
     /*  64195 */     GIR_EraseRootFromParent_Done,
     /*  64196 */   // Label 1075: @64196
     /*  64196 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64305), // Rule ID 13672 //
     /*  64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64267 */     // MIs[3] LHS
     /*  64267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64286 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64303 */     GIR_RootConstrainSelectedInstOperands,
     /*  64304 */     // GIR_Coverage, 13672,
     /*  64304 */     GIR_EraseRootFromParent_Done,
     /*  64305 */   // Label 1076: @64305
     /*  64305 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64372), // Rule ID 13637 //
     /*  64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     // MIs[1] imm
     /*  64334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64346 */     // MIs[2] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64356 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64370 */     GIR_RootConstrainSelectedInstOperands,
     /*  64371 */     // GIR_Coverage, 13637,
     /*  64371 */     GIR_EraseRootFromParent_Done,
     /*  64372 */   // Label 1077: @64372
     /*  64372 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64439), // Rule ID 13658 //
     /*  64377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     // MIs[1] imm
     /*  64401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64413 */     // MIs[2] Operand 1
     /*  64413 */     // No operand predicates
     /*  64413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64423 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 13658,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 1078: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64506), // Rule ID 2239 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64472 */     // MIs[1] imm
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64484 */     // MIs[2] Operand 1
     /*  64484 */     // No operand predicates
     /*  64484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64490 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64504 */     GIR_RootConstrainSelectedInstOperands,
     /*  64505 */     // GIR_Coverage, 2239,
     /*  64505 */     GIR_EraseRootFromParent_Done,
     /*  64506 */   // Label 1079: @64506
     /*  64506 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64573), // Rule ID 2298 //
     /*  64511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64539 */     // MIs[1] imm
     /*  64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64551 */     // MIs[2] Operand 1
     /*  64551 */     // No operand predicates
     /*  64551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64557 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64571 */     GIR_RootConstrainSelectedInstOperands,
     /*  64572 */     // GIR_Coverage, 2298,
     /*  64572 */     GIR_EraseRootFromParent_Done,
     /*  64573 */   // Label 1080: @64573
     /*  64573 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64637), // Rule ID 13971 //
     /*  64578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64624 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64635 */     GIR_RootConstrainSelectedInstOperands,
     /*  64636 */     // GIR_Coverage, 13971,
     /*  64636 */     GIR_EraseRootFromParent_Done,
     /*  64637 */   // Label 1081: @64637
     /*  64637 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64701), // Rule ID 5067 //
     /*  64642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64688 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64693 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64699 */     GIR_RootConstrainSelectedInstOperands,
     /*  64700 */     // GIR_Coverage, 5067,
     /*  64700 */     GIR_EraseRootFromParent_Done,
     /*  64701 */   // Label 1082: @64701
     /*  64701 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64728), // Rule ID 5073 //
     /*  64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64721 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 5073,
     /*  64727 */     GIR_Done,
     /*  64728 */   // Label 1083: @64728
     /*  64728 */   GIM_Reject,
     /*  64729 */ // Label 1068: @64729
     /*  64729 */ GIM_Reject,
     /*  64730 */ // Label 1017: @64730
     /*  64730 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66037),
     /*  64735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64850), // Rule ID 13702 //
     /*  64746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64824 */     // MIs[4] LHS
     /*  64824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64829 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64831 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64848 */     GIR_RootConstrainSelectedInstOperands,
     /*  64849 */     // GIR_Coverage, 13702,
     /*  64849 */     GIR_EraseRootFromParent_Done,
     /*  64850 */   // Label 1085: @64850
     /*  64850 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64959), // Rule ID 13701 //
     /*  64855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64928 */     // MIs[4] LHS
     /*  64928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64940 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64957 */     GIR_RootConstrainSelectedInstOperands,
     /*  64958 */     // GIR_Coverage, 13701,
     /*  64958 */     GIR_EraseRootFromParent_Done,
     /*  64959 */   // Label 1086: @64959
     /*  64959 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65068), // Rule ID 13704 //
     /*  64964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65033 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65037 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65042 */     // MIs[4] LHS
     /*  65042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65049 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65066 */     GIR_RootConstrainSelectedInstOperands,
     /*  65067 */     // GIR_Coverage, 13704,
     /*  65067 */     GIR_EraseRootFromParent_Done,
     /*  65068 */   // Label 1087: @65068
     /*  65068 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65177), // Rule ID 13703 //
     /*  65073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65126 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65146 */     // MIs[4] LHS
     /*  65146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65158 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65175 */     GIR_RootConstrainSelectedInstOperands,
     /*  65176 */     // GIR_Coverage, 13703,
     /*  65176 */     GIR_EraseRootFromParent_Done,
     /*  65177 */   // Label 1088: @65177
     /*  65177 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65286), // Rule ID 2474 //
     /*  65182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65243 */     // MIs[3] LHS
     /*  65243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65267 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65284 */     GIR_RootConstrainSelectedInstOperands,
     /*  65285 */     // GIR_Coverage, 2474,
     /*  65285 */     GIR_EraseRootFromParent_Done,
     /*  65286 */   // Label 1089: @65286
     /*  65286 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65395), // Rule ID 13699 //
     /*  65291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65352 */     // MIs[3] LHS
     /*  65352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65361 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65376 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65393 */     GIR_RootConstrainSelectedInstOperands,
     /*  65394 */     // GIR_Coverage, 13699,
     /*  65394 */     GIR_EraseRootFromParent_Done,
     /*  65395 */   // Label 1090: @65395
     /*  65395 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65504), // Rule ID 13698 //
     /*  65400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65466 */     // MIs[3] LHS
     /*  65466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65485 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65502 */     GIR_RootConstrainSelectedInstOperands,
     /*  65503 */     // GIR_Coverage, 13698,
     /*  65503 */     GIR_EraseRootFromParent_Done,
     /*  65504 */   // Label 1091: @65504
     /*  65504 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65613), // Rule ID 13700 //
     /*  65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65575 */     // MIs[3] LHS
     /*  65575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65594 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65611 */     GIR_RootConstrainSelectedInstOperands,
     /*  65612 */     // GIR_Coverage, 13700,
     /*  65612 */     GIR_EraseRootFromParent_Done,
     /*  65613 */   // Label 1092: @65613
     /*  65613 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65680), // Rule ID 13641 //
     /*  65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     // MIs[1] imm
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65654 */     // MIs[2] Operand 1
     /*  65654 */     // No operand predicates
     /*  65654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65664 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65678 */     GIR_RootConstrainSelectedInstOperands,
     /*  65679 */     // GIR_Coverage, 13641,
     /*  65679 */     GIR_EraseRootFromParent_Done,
     /*  65680 */   // Label 1093: @65680
     /*  65680 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65747), // Rule ID 13662 //
     /*  65685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     // MIs[1] imm
     /*  65709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65721 */     // MIs[2] Operand 1
     /*  65721 */     // No operand predicates
     /*  65721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65731 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65745 */     GIR_RootConstrainSelectedInstOperands,
     /*  65746 */     // GIR_Coverage, 13662,
     /*  65746 */     GIR_EraseRootFromParent_Done,
     /*  65747 */   // Label 1094: @65747
     /*  65747 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65814), // Rule ID 2243 //
     /*  65752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65780 */     // MIs[1] imm
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65792 */     // MIs[2] Operand 1
     /*  65792 */     // No operand predicates
     /*  65792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65812 */     GIR_RootConstrainSelectedInstOperands,
     /*  65813 */     // GIR_Coverage, 2243,
     /*  65813 */     GIR_EraseRootFromParent_Done,
     /*  65814 */   // Label 1095: @65814
     /*  65814 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65881), // Rule ID 2302 //
     /*  65819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65847 */     // MIs[1] imm
     /*  65847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65859 */     // MIs[2] Operand 1
     /*  65859 */     // No operand predicates
     /*  65859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65865 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65879 */     GIR_RootConstrainSelectedInstOperands,
     /*  65880 */     // GIR_Coverage, 2302,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 1096: @65881
     /*  65881 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65945), // Rule ID 13975 //
     /*  65886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65932 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65943 */     GIR_RootConstrainSelectedInstOperands,
     /*  65944 */     // GIR_Coverage, 13975,
     /*  65944 */     GIR_EraseRootFromParent_Done,
     /*  65945 */   // Label 1097: @65945
     /*  65945 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66009), // Rule ID 5071 //
     /*  65950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65986 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65996 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66001 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 5071,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1098: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66036), // Rule ID 5077 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66029 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66034 */     GIR_RootConstrainSelectedInstOperands,
     /*  66035 */     // GIR_Coverage, 5077,
     /*  66035 */     GIR_Done,
     /*  66036 */   // Label 1099: @66036
     /*  66036 */   GIM_Reject,
     /*  66037 */ // Label 1084: @66037
     /*  66037 */ GIM_Reject,
     /*  66038 */ // Label 1018: @66038
     /*  66038 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67345),
     /*  66043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66158), // Rule ID 13667 //
     /*  66054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66115 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66119 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66123 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66127 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66132 */     // MIs[4] LHS
     /*  66132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66139 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 13667,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1101: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66267), // Rule ID 13666 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66232 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66236 */     // MIs[4] LHS
     /*  66236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66248 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 13666,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1102: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66376), // Rule ID 13669 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66341 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66345 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66350 */     // MIs[4] LHS
     /*  66350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66357 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66374 */     GIR_RootConstrainSelectedInstOperands,
     /*  66375 */     // GIR_Coverage, 13669,
     /*  66375 */     GIR_EraseRootFromParent_Done,
     /*  66376 */   // Label 1103: @66376
     /*  66376 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66485), // Rule ID 13668 //
     /*  66381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66454 */     // MIs[4] LHS
     /*  66454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66459 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66464 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66466 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66483 */     GIR_RootConstrainSelectedInstOperands,
     /*  66484 */     // GIR_Coverage, 13668,
     /*  66484 */     GIR_EraseRootFromParent_Done,
     /*  66485 */   // Label 1104: @66485
     /*  66485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66594), // Rule ID 2469 //
     /*  66490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66551 */     // MIs[3] LHS
     /*  66551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66575 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66592 */     GIR_RootConstrainSelectedInstOperands,
     /*  66593 */     // GIR_Coverage, 2469,
     /*  66593 */     GIR_EraseRootFromParent_Done,
     /*  66594 */   // Label 1105: @66594
     /*  66594 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66703), // Rule ID 13664 //
     /*  66599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66660 */     // MIs[3] LHS
     /*  66660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66669 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66684 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66701 */     GIR_RootConstrainSelectedInstOperands,
     /*  66702 */     // GIR_Coverage, 13664,
     /*  66702 */     GIR_EraseRootFromParent_Done,
     /*  66703 */   // Label 1106: @66703
     /*  66703 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66812), // Rule ID 13663 //
     /*  66708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66774 */     // MIs[3] LHS
     /*  66774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66783 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66793 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66810 */     GIR_RootConstrainSelectedInstOperands,
     /*  66811 */     // GIR_Coverage, 13663,
     /*  66811 */     GIR_EraseRootFromParent_Done,
     /*  66812 */   // Label 1107: @66812
     /*  66812 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66921), // Rule ID 13665 //
     /*  66817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66883 */     // MIs[3] LHS
     /*  66883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66902 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66919 */     GIR_RootConstrainSelectedInstOperands,
     /*  66920 */     // GIR_Coverage, 13665,
     /*  66920 */     GIR_EraseRootFromParent_Done,
     /*  66921 */   // Label 1108: @66921
     /*  66921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66988), // Rule ID 13633 //
     /*  66926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     // MIs[1] imm
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66962 */     // MIs[2] Operand 1
     /*  66962 */     // No operand predicates
     /*  66962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66972 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66986 */     GIR_RootConstrainSelectedInstOperands,
     /*  66987 */     // GIR_Coverage, 13633,
     /*  66987 */     GIR_EraseRootFromParent_Done,
     /*  66988 */   // Label 1109: @66988
     /*  66988 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67055), // Rule ID 13654 //
     /*  66993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     // MIs[1] imm
     /*  67017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67029 */     // MIs[2] Operand 1
     /*  67029 */     // No operand predicates
     /*  67029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67039 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 13654,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1110: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67122), // Rule ID 2235 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67088 */     // MIs[1] imm
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67100 */     // MIs[2] Operand 1
     /*  67100 */     // No operand predicates
     /*  67100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67106 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67120 */     GIR_RootConstrainSelectedInstOperands,
     /*  67121 */     // GIR_Coverage, 2235,
     /*  67121 */     GIR_EraseRootFromParent_Done,
     /*  67122 */   // Label 1111: @67122
     /*  67122 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67189), // Rule ID 2294 //
     /*  67127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67155 */     // MIs[1] imm
     /*  67155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67167 */     // MIs[2] Operand 1
     /*  67167 */     // No operand predicates
     /*  67167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67173 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 2294,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1112: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67253), // Rule ID 13970 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67240 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67245 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67251 */     GIR_RootConstrainSelectedInstOperands,
     /*  67252 */     // GIR_Coverage, 13970,
     /*  67252 */     GIR_EraseRootFromParent_Done,
     /*  67253 */   // Label 1113: @67253
     /*  67253 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67317), // Rule ID 5066 //
     /*  67258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67304 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67315 */     GIR_RootConstrainSelectedInstOperands,
     /*  67316 */     // GIR_Coverage, 5066,
     /*  67316 */     GIR_EraseRootFromParent_Done,
     /*  67317 */   // Label 1114: @67317
     /*  67317 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67344), // Rule ID 5072 //
     /*  67322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67337 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67342 */     GIR_RootConstrainSelectedInstOperands,
     /*  67343 */     // GIR_Coverage, 5072,
     /*  67343 */     GIR_Done,
     /*  67344 */   // Label 1115: @67344
     /*  67344 */   GIM_Reject,
     /*  67345 */ // Label 1100: @67345
     /*  67345 */ GIM_Reject,
     /*  67346 */ // Label 1019: @67346
     /*  67346 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68653),
     /*  67351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67466), // Rule ID 13695 //
     /*  67362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67410 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67440 */     // MIs[4] LHS
     /*  67440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67464 */     GIR_RootConstrainSelectedInstOperands,
     /*  67465 */     // GIR_Coverage, 13695,
     /*  67465 */     GIR_EraseRootFromParent_Done,
     /*  67466 */   // Label 1117: @67466
     /*  67466 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67575), // Rule ID 13694 //
     /*  67471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67544 */     // MIs[4] LHS
     /*  67544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67556 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67573 */     GIR_RootConstrainSelectedInstOperands,
     /*  67574 */     // GIR_Coverage, 13694,
     /*  67574 */     GIR_EraseRootFromParent_Done,
     /*  67575 */   // Label 1118: @67575
     /*  67575 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67684), // Rule ID 13697 //
     /*  67580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67653 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67658 */     // MIs[4] LHS
     /*  67658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67682 */     GIR_RootConstrainSelectedInstOperands,
     /*  67683 */     // GIR_Coverage, 13697,
     /*  67683 */     GIR_EraseRootFromParent_Done,
     /*  67684 */   // Label 1119: @67684
     /*  67684 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67793), // Rule ID 13696 //
     /*  67689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67762 */     // MIs[4] LHS
     /*  67762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67767 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67774 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 13696,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1120: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67902), // Rule ID 2473 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67855 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67859 */     // MIs[3] LHS
     /*  67859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67900 */     GIR_RootConstrainSelectedInstOperands,
     /*  67901 */     // GIR_Coverage, 2473,
     /*  67901 */     GIR_EraseRootFromParent_Done,
     /*  67902 */   // Label 1121: @67902
     /*  67902 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68011), // Rule ID 13692 //
     /*  67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67968 */     // MIs[3] LHS
     /*  67968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67977 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67992 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68009 */     GIR_RootConstrainSelectedInstOperands,
     /*  68010 */     // GIR_Coverage, 13692,
     /*  68010 */     GIR_EraseRootFromParent_Done,
     /*  68011 */   // Label 1122: @68011
     /*  68011 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68120), // Rule ID 13691 //
     /*  68016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68082 */     // MIs[3] LHS
     /*  68082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68091 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68118 */     GIR_RootConstrainSelectedInstOperands,
     /*  68119 */     // GIR_Coverage, 13691,
     /*  68119 */     GIR_EraseRootFromParent_Done,
     /*  68120 */   // Label 1123: @68120
     /*  68120 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68229), // Rule ID 13693 //
     /*  68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68191 */     // MIs[3] LHS
     /*  68191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68227 */     GIR_RootConstrainSelectedInstOperands,
     /*  68228 */     // GIR_Coverage, 13693,
     /*  68228 */     GIR_EraseRootFromParent_Done,
     /*  68229 */   // Label 1124: @68229
     /*  68229 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68296), // Rule ID 13639 //
     /*  68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     // MIs[1] imm
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68270 */     // MIs[2] Operand 1
     /*  68270 */     // No operand predicates
     /*  68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68280 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68294 */     GIR_RootConstrainSelectedInstOperands,
     /*  68295 */     // GIR_Coverage, 13639,
     /*  68295 */     GIR_EraseRootFromParent_Done,
     /*  68296 */   // Label 1125: @68296
     /*  68296 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68363), // Rule ID 13660 //
     /*  68301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     // MIs[1] imm
     /*  68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68337 */     // MIs[2] Operand 1
     /*  68337 */     // No operand predicates
     /*  68337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68347 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 13660,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1126: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68430), // Rule ID 2241 //
     /*  68368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     // MIs[1] imm
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68408 */     // MIs[2] Operand 1
     /*  68408 */     // No operand predicates
     /*  68408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68414 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68428 */     GIR_RootConstrainSelectedInstOperands,
     /*  68429 */     // GIR_Coverage, 2241,
     /*  68429 */     GIR_EraseRootFromParent_Done,
     /*  68430 */   // Label 1127: @68430
     /*  68430 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68497), // Rule ID 2300 //
     /*  68435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68463 */     // MIs[1] imm
     /*  68463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68475 */     // MIs[2] Operand 1
     /*  68475 */     // No operand predicates
     /*  68475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68495 */     GIR_RootConstrainSelectedInstOperands,
     /*  68496 */     // GIR_Coverage, 2300,
     /*  68496 */     GIR_EraseRootFromParent_Done,
     /*  68497 */   // Label 1128: @68497
     /*  68497 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68561), // Rule ID 13974 //
     /*  68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68548 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68553 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68559 */     GIR_RootConstrainSelectedInstOperands,
     /*  68560 */     // GIR_Coverage, 13974,
     /*  68560 */     GIR_EraseRootFromParent_Done,
     /*  68561 */   // Label 1129: @68561
     /*  68561 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68625), // Rule ID 5070 //
     /*  68566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68612 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 5070,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1130: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68652), // Rule ID 5076 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68645 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68650 */     GIR_RootConstrainSelectedInstOperands,
     /*  68651 */     // GIR_Coverage, 5076,
     /*  68651 */     GIR_Done,
     /*  68652 */   // Label 1131: @68652
     /*  68652 */   GIM_Reject,
     /*  68653 */ // Label 1116: @68653
     /*  68653 */ GIM_Reject,
     /*  68654 */ // Label 1020: @68654
     /*  68654 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69961),
     /*  68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68774), // Rule ID 13445 //
     /*  68670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68748 */     // MIs[4] Rd
     /*  68748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68755 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 13445,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1133: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68883), // Rule ID 13444 //
     /*  68779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68852 */     // MIs[4] Rd
     /*  68852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68864 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 13444,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1134: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68992), // Rule ID 13447 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68957 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68961 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68966 */     // MIs[4] Rd
     /*  68966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68973 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 13447,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1135: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69101), // Rule ID 13446 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69066 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69070 */     // MIs[4] Rd
     /*  69070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69075 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69082 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69099 */     GIR_RootConstrainSelectedInstOperands,
     /*  69100 */     // GIR_Coverage, 13446,
     /*  69100 */     GIR_EraseRootFromParent_Done,
     /*  69101 */   // Label 1136: @69101
     /*  69101 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69210), // Rule ID 1605 //
     /*  69106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69167 */     // MIs[3] Rd
     /*  69167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69191 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69208 */     GIR_RootConstrainSelectedInstOperands,
     /*  69209 */     // GIR_Coverage, 1605,
     /*  69209 */     GIR_EraseRootFromParent_Done,
     /*  69210 */   // Label 1137: @69210
     /*  69210 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69319), // Rule ID 13442 //
     /*  69215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69276 */     // MIs[3] Rd
     /*  69276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69285 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69300 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69317 */     GIR_RootConstrainSelectedInstOperands,
     /*  69318 */     // GIR_Coverage, 13442,
     /*  69318 */     GIR_EraseRootFromParent_Done,
     /*  69319 */   // Label 1138: @69319
     /*  69319 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69428), // Rule ID 13441 //
     /*  69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69390 */     // MIs[3] Rd
     /*  69390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69409 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69426 */     GIR_RootConstrainSelectedInstOperands,
     /*  69427 */     // GIR_Coverage, 13441,
     /*  69427 */     GIR_EraseRootFromParent_Done,
     /*  69428 */   // Label 1139: @69428
     /*  69428 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69537), // Rule ID 13443 //
     /*  69433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69499 */     // MIs[3] Rd
     /*  69499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69518 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69535 */     GIR_RootConstrainSelectedInstOperands,
     /*  69536 */     // GIR_Coverage, 13443,
     /*  69536 */     GIR_EraseRootFromParent_Done,
     /*  69537 */   // Label 1140: @69537
     /*  69537 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69604), // Rule ID 13629 //
     /*  69542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     // MIs[1] imm
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69578 */     // MIs[2] Operand 1
     /*  69578 */     // No operand predicates
     /*  69578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69588 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69602 */     GIR_RootConstrainSelectedInstOperands,
     /*  69603 */     // GIR_Coverage, 13629,
     /*  69603 */     GIR_EraseRootFromParent_Done,
     /*  69604 */   // Label 1141: @69604
     /*  69604 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69671), // Rule ID 13650 //
     /*  69609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     // MIs[1] imm
     /*  69633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69645 */     // MIs[2] Operand 1
     /*  69645 */     // No operand predicates
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69655 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69669 */     GIR_RootConstrainSelectedInstOperands,
     /*  69670 */     // GIR_Coverage, 13650,
     /*  69670 */     GIR_EraseRootFromParent_Done,
     /*  69671 */   // Label 1142: @69671
     /*  69671 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69738), // Rule ID 2231 //
     /*  69676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69704 */     // MIs[1] imm
     /*  69704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69716 */     // MIs[2] Operand 1
     /*  69716 */     // No operand predicates
     /*  69716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69722 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69736 */     GIR_RootConstrainSelectedInstOperands,
     /*  69737 */     // GIR_Coverage, 2231,
     /*  69737 */     GIR_EraseRootFromParent_Done,
     /*  69738 */   // Label 1143: @69738
     /*  69738 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69805), // Rule ID 2290 //
     /*  69743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69771 */     // MIs[1] imm
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69783 */     // MIs[2] Operand 1
     /*  69783 */     // No operand predicates
     /*  69783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69789 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69803 */     GIR_RootConstrainSelectedInstOperands,
     /*  69804 */     // GIR_Coverage, 2290,
     /*  69804 */     GIR_EraseRootFromParent_Done,
     /*  69805 */   // Label 1144: @69805
     /*  69805 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69869), // Rule ID 13439 //
     /*  69810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69856 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69867 */     GIR_RootConstrainSelectedInstOperands,
     /*  69868 */     // GIR_Coverage, 13439,
     /*  69868 */     GIR_EraseRootFromParent_Done,
     /*  69869 */   // Label 1145: @69869
     /*  69869 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69933), // Rule ID 1601 //
     /*  69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69920 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69931 */     GIR_RootConstrainSelectedInstOperands,
     /*  69932 */     // GIR_Coverage, 1601,
     /*  69932 */     GIR_EraseRootFromParent_Done,
     /*  69933 */   // Label 1146: @69933
     /*  69933 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69960), // Rule ID 1603 //
     /*  69938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69953 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69958 */     GIR_RootConstrainSelectedInstOperands,
     /*  69959 */     // GIR_Coverage, 1603,
     /*  69959 */     GIR_Done,
     /*  69960 */   // Label 1147: @69960
     /*  69960 */   GIM_Reject,
     /*  69961 */ // Label 1132: @69961
     /*  69961 */ GIM_Reject,
     /*  69962 */ // Label 1021: @69962
     /*  69962 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71269),
     /*  69967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70082), // Rule ID 13688 //
     /*  69978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70047 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70051 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70056 */     // MIs[4] LHS
     /*  70056 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70063 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 13688,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1149: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70191), // Rule ID 13687 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70160 */     // MIs[4] LHS
     /*  70160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70172 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70189 */     GIR_RootConstrainSelectedInstOperands,
     /*  70190 */     // GIR_Coverage, 13687,
     /*  70190 */     GIR_EraseRootFromParent_Done,
     /*  70191 */   // Label 1150: @70191
     /*  70191 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70300), // Rule ID 13690 //
     /*  70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70265 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70274 */     // MIs[4] LHS
     /*  70274 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70279 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70281 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70298 */     GIR_RootConstrainSelectedInstOperands,
     /*  70299 */     // GIR_Coverage, 13690,
     /*  70299 */     GIR_EraseRootFromParent_Done,
     /*  70300 */   // Label 1151: @70300
     /*  70300 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70409), // Rule ID 13689 //
     /*  70305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70378 */     // MIs[4] LHS
     /*  70378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70390 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 13689,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1152: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70518), // Rule ID 2472 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70475 */     // MIs[3] LHS
     /*  70475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70499 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70516 */     GIR_RootConstrainSelectedInstOperands,
     /*  70517 */     // GIR_Coverage, 2472,
     /*  70517 */     GIR_EraseRootFromParent_Done,
     /*  70518 */   // Label 1153: @70518
     /*  70518 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70627), // Rule ID 13685 //
     /*  70523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70584 */     // MIs[3] LHS
     /*  70584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70608 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70625 */     GIR_RootConstrainSelectedInstOperands,
     /*  70626 */     // GIR_Coverage, 13685,
     /*  70626 */     GIR_EraseRootFromParent_Done,
     /*  70627 */   // Label 1154: @70627
     /*  70627 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70736), // Rule ID 13684 //
     /*  70632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70698 */     // MIs[3] LHS
     /*  70698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70707 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70717 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 13684,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1155: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70845), // Rule ID 13686 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70807 */     // MIs[3] LHS
     /*  70807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70826 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70843 */     GIR_RootConstrainSelectedInstOperands,
     /*  70844 */     // GIR_Coverage, 13686,
     /*  70844 */     GIR_EraseRootFromParent_Done,
     /*  70845 */   // Label 1156: @70845
     /*  70845 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70912), // Rule ID 13635 //
     /*  70850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[1] imm
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70886 */     // MIs[2] Operand 1
     /*  70886 */     // No operand predicates
     /*  70886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70896 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70910 */     GIR_RootConstrainSelectedInstOperands,
     /*  70911 */     // GIR_Coverage, 13635,
     /*  70911 */     GIR_EraseRootFromParent_Done,
     /*  70912 */   // Label 1157: @70912
     /*  70912 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70979), // Rule ID 13656 //
     /*  70917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     // MIs[1] imm
     /*  70941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70953 */     // MIs[2] Operand 1
     /*  70953 */     // No operand predicates
     /*  70953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70963 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70977 */     GIR_RootConstrainSelectedInstOperands,
     /*  70978 */     // GIR_Coverage, 13656,
     /*  70978 */     GIR_EraseRootFromParent_Done,
     /*  70979 */   // Label 1158: @70979
     /*  70979 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71046), // Rule ID 2237 //
     /*  70984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71012 */     // MIs[1] imm
     /*  71012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71024 */     // MIs[2] Operand 1
     /*  71024 */     // No operand predicates
     /*  71024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71030 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71044 */     GIR_RootConstrainSelectedInstOperands,
     /*  71045 */     // GIR_Coverage, 2237,
     /*  71045 */     GIR_EraseRootFromParent_Done,
     /*  71046 */   // Label 1159: @71046
     /*  71046 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71113), // Rule ID 2296 //
     /*  71051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71079 */     // MIs[1] imm
     /*  71079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71091 */     // MIs[2] Operand 1
     /*  71091 */     // No operand predicates
     /*  71091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71097 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71111 */     GIR_RootConstrainSelectedInstOperands,
     /*  71112 */     // GIR_Coverage, 2296,
     /*  71112 */     GIR_EraseRootFromParent_Done,
     /*  71113 */   // Label 1160: @71113
     /*  71113 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71177), // Rule ID 13973 //
     /*  71118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 13973,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1161: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71241), // Rule ID 5069 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71228 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 5069,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1162: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71268), // Rule ID 5075 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71261 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 5075,
     /*  71267 */     GIR_Done,
     /*  71268 */   // Label 1163: @71268
     /*  71268 */   GIM_Reject,
     /*  71269 */ // Label 1148: @71269
     /*  71269 */ GIM_Reject,
     /*  71270 */ // Label 1022: @71270
     /*  71270 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72577),
     /*  71275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71390), // Rule ID 13452 //
     /*  71286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71359 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71364 */     // MIs[4] Rd
     /*  71364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71371 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71388 */     GIR_RootConstrainSelectedInstOperands,
     /*  71389 */     // GIR_Coverage, 13452,
     /*  71389 */     GIR_EraseRootFromParent_Done,
     /*  71390 */   // Label 1165: @71390
     /*  71390 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71499), // Rule ID 13451 //
     /*  71395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71468 */     // MIs[4] Rd
     /*  71468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71480 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71497 */     GIR_RootConstrainSelectedInstOperands,
     /*  71498 */     // GIR_Coverage, 13451,
     /*  71498 */     GIR_EraseRootFromParent_Done,
     /*  71499 */   // Label 1166: @71499
     /*  71499 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71608), // Rule ID 13454 //
     /*  71504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71573 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71582 */     // MIs[4] Rd
     /*  71582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71589 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71606 */     GIR_RootConstrainSelectedInstOperands,
     /*  71607 */     // GIR_Coverage, 13454,
     /*  71607 */     GIR_EraseRootFromParent_Done,
     /*  71608 */   // Label 1167: @71608
     /*  71608 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71717), // Rule ID 13453 //
     /*  71613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71686 */     // MIs[4] Rd
     /*  71686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71698 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71715 */     GIR_RootConstrainSelectedInstOperands,
     /*  71716 */     // GIR_Coverage, 13453,
     /*  71716 */     GIR_EraseRootFromParent_Done,
     /*  71717 */   // Label 1168: @71717
     /*  71717 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71826), // Rule ID 1606 //
     /*  71722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71783 */     // MIs[3] Rd
     /*  71783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71807 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 1606,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1169: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71935), // Rule ID 13449 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71892 */     // MIs[3] Rd
     /*  71892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71901 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71914 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71916 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71933 */     GIR_RootConstrainSelectedInstOperands,
     /*  71934 */     // GIR_Coverage, 13449,
     /*  71934 */     GIR_EraseRootFromParent_Done,
     /*  71935 */   // Label 1170: @71935
     /*  71935 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72044), // Rule ID 13448 //
     /*  71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72006 */     // MIs[3] Rd
     /*  72006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72015 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72025 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 13448,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1171: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72153), // Rule ID 13450 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72115 */     // MIs[3] Rd
     /*  72115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72134 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72151 */     GIR_RootConstrainSelectedInstOperands,
     /*  72152 */     // GIR_Coverage, 13450,
     /*  72152 */     GIR_EraseRootFromParent_Done,
     /*  72153 */   // Label 1172: @72153
     /*  72153 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72220), // Rule ID 13631 //
     /*  72158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     // MIs[1] imm
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72194 */     // MIs[2] Operand 1
     /*  72194 */     // No operand predicates
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72204 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72218 */     GIR_RootConstrainSelectedInstOperands,
     /*  72219 */     // GIR_Coverage, 13631,
     /*  72219 */     GIR_EraseRootFromParent_Done,
     /*  72220 */   // Label 1173: @72220
     /*  72220 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72287), // Rule ID 13652 //
     /*  72225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     // MIs[1] imm
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72261 */     // MIs[2] Operand 1
     /*  72261 */     // No operand predicates
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72271 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72285 */     GIR_RootConstrainSelectedInstOperands,
     /*  72286 */     // GIR_Coverage, 13652,
     /*  72286 */     GIR_EraseRootFromParent_Done,
     /*  72287 */   // Label 1174: @72287
     /*  72287 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72354), // Rule ID 2233 //
     /*  72292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72320 */     // MIs[1] imm
     /*  72320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72332 */     // MIs[2] Operand 1
     /*  72332 */     // No operand predicates
     /*  72332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72338 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2233,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1175: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72421), // Rule ID 2292 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72387 */     // MIs[1] imm
     /*  72387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72399 */     // MIs[2] Operand 1
     /*  72399 */     // No operand predicates
     /*  72399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72405 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72419 */     GIR_RootConstrainSelectedInstOperands,
     /*  72420 */     // GIR_Coverage, 2292,
     /*  72420 */     GIR_EraseRootFromParent_Done,
     /*  72421 */   // Label 1176: @72421
     /*  72421 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72485), // Rule ID 13440 //
     /*  72426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72472 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 13440,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1177: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72549), // Rule ID 1602 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72536 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72547 */     GIR_RootConstrainSelectedInstOperands,
     /*  72548 */     // GIR_Coverage, 1602,
     /*  72548 */     GIR_EraseRootFromParent_Done,
     /*  72549 */   // Label 1178: @72549
     /*  72549 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72576), // Rule ID 1604 //
     /*  72554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72569 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 1604,
     /*  72575 */     GIR_Done,
     /*  72576 */   // Label 1179: @72576
     /*  72576 */   GIM_Reject,
     /*  72577 */ // Label 1164: @72577
     /*  72577 */ GIM_Reject,
     /*  72578 */ // Label 1023: @72578
     /*  72578 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72609), // Rule ID 8500 //
     /*  72583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72596 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72605 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72607 */   GIR_RootConstrainSelectedInstOperands,
     /*  72608 */   // GIR_Coverage, 8500,
     /*  72608 */   GIR_EraseRootFromParent_Done,
     /*  72609 */ // Label 1180: @72609
     /*  72609 */ GIM_Reject,
     /*  72610 */ // Label 1024: @72610
     /*  72610 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72641), // Rule ID 8499 //
     /*  72615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72628 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72637 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72639 */   GIR_RootConstrainSelectedInstOperands,
     /*  72640 */   // GIR_Coverage, 8499,
     /*  72640 */   GIR_EraseRootFromParent_Done,
     /*  72641 */ // Label 1181: @72641
     /*  72641 */ GIM_Reject,
     /*  72642 */ // Label 1025: @72642
     /*  72642 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(76001),
     /*  72647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72775), // Rule ID 15805 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72725 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72729 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72741 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72745 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72749 */     // MIs[6] Op3
     /*  72749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72754 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72756 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  72769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  72773 */     GIR_RootConstrainSelectedInstOperands,
     /*  72774 */     // GIR_Coverage, 15805,
     /*  72774 */     GIR_EraseRootFromParent_Done,
     /*  72775 */   // Label 1183: @72775
     /*  72775 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72893), // Rule ID 15807 //
     /*  72780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72843 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72847 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72859 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72863 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72867 */     // MIs[6] Op3
     /*  72867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72872 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72874 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  72887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  72891 */     GIR_RootConstrainSelectedInstOperands,
     /*  72892 */     // GIR_Coverage, 15807,
     /*  72892 */     GIR_EraseRootFromParent_Done,
     /*  72893 */   // Label 1184: @72893
     /*  72893 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73011), // Rule ID 15804 //
     /*  72898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72937 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72945 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72949 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72953 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72957 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72965 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72973 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72977 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72981 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72985 */     // MIs[6] Op3
     /*  72985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72990 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72992 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  73005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  73009 */     GIR_RootConstrainSelectedInstOperands,
     /*  73010 */     // GIR_Coverage, 15804,
     /*  73010 */     GIR_EraseRootFromParent_Done,
     /*  73011 */   // Label 1185: @73011
     /*  73011 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73129), // Rule ID 15806 //
     /*  73016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73055 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  73067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73079 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73083 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  73091 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  73095 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73099 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73103 */     // MIs[6] Op3
     /*  73103 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73110 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73127 */     GIR_RootConstrainSelectedInstOperands,
     /*  73128 */     // GIR_Coverage, 15806,
     /*  73128 */     GIR_EraseRootFromParent_Done,
     /*  73129 */   // Label 1186: @73129
     /*  73129 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73247), // Rule ID 15752 //
     /*  73134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73173 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73181 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73185 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73189 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73193 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73197 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73201 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73205 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73209 */     // MIs[5] Op3
     /*  73209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73218 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73226 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73228 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73245 */     GIR_RootConstrainSelectedInstOperands,
     /*  73246 */     // GIR_Coverage, 15752,
     /*  73246 */     GIR_EraseRootFromParent_Done,
     /*  73247 */   // Label 1187: @73247
     /*  73247 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73365), // Rule ID 15757 //
     /*  73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73311 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73315 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73319 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73323 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73331 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73339 */     // MIs[4] Op3
     /*  73339 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73346 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73363 */     GIR_RootConstrainSelectedInstOperands,
     /*  73364 */     // GIR_Coverage, 15757,
     /*  73364 */     GIR_EraseRootFromParent_Done,
     /*  73365 */   // Label 1188: @73365
     /*  73365 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73483), // Rule ID 15758 //
     /*  73370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73409 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73425 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73429 */     // MIs[4] Op3
     /*  73429 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73446 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73450 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73454 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73462 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73464 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73481 */     GIR_RootConstrainSelectedInstOperands,
     /*  73482 */     // GIR_Coverage, 15758,
     /*  73482 */     GIR_EraseRootFromParent_Done,
     /*  73483 */   // Label 1189: @73483
     /*  73483 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73601), // Rule ID 11948 //
     /*  73488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73551 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73555 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73559 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73563 */     // MIs[5] Op3
     /*  73563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73572 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73580 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73582 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73599 */     GIR_RootConstrainSelectedInstOperands,
     /*  73600 */     // GIR_Coverage, 11948,
     /*  73600 */     GIR_EraseRootFromParent_Done,
     /*  73601 */   // Label 1190: @73601
     /*  73601 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73719), // Rule ID 15754 //
     /*  73606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73645 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73653 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73657 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73661 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73665 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73669 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73673 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73677 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73681 */     // MIs[5] Op3
     /*  73681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73690 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73698 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73700 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  73717 */     GIR_RootConstrainSelectedInstOperands,
     /*  73718 */     // GIR_Coverage, 15754,
     /*  73718 */     GIR_EraseRootFromParent_Done,
     /*  73719 */   // Label 1191: @73719
     /*  73719 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73837), // Rule ID 15755 //
     /*  73724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73771 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73775 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73779 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73787 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73791 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73795 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73803 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73811 */     // MIs[4] Op3
     /*  73811 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73818 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73835 */     GIR_RootConstrainSelectedInstOperands,
     /*  73836 */     // GIR_Coverage, 15755,
     /*  73836 */     GIR_EraseRootFromParent_Done,
     /*  73837 */   // Label 1192: @73837
     /*  73837 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73955), // Rule ID 15756 //
     /*  73842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73881 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73901 */     // MIs[4] Op3
     /*  73901 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73914 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73918 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73922 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73926 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73934 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73936 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73953 */     GIR_RootConstrainSelectedInstOperands,
     /*  73954 */     // GIR_Coverage, 15756,
     /*  73954 */     GIR_EraseRootFromParent_Done,
     /*  73955 */   // Label 1193: @73955
     /*  73955 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74073), // Rule ID 15753 //
     /*  73960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74015 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74023 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74027 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74031 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74035 */     // MIs[5] Op3
     /*  74035 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74044 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74052 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74054 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74071 */     GIR_RootConstrainSelectedInstOperands,
     /*  74072 */     // GIR_Coverage, 15753,
     /*  74072 */     GIR_EraseRootFromParent_Done,
     /*  74073 */   // Label 1194: @74073
     /*  74073 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74191), // Rule ID 15801 //
     /*  74078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74121 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74125 */     // MIs[3] Op3
     /*  74125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74134 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74162 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74170 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74172 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74189 */     GIR_RootConstrainSelectedInstOperands,
     /*  74190 */     // GIR_Coverage, 15801,
     /*  74190 */     GIR_EraseRootFromParent_Done,
     /*  74191 */   // Label 1195: @74191
     /*  74191 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74309), // Rule ID 15803 //
     /*  74196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74243 */     // MIs[3] Op3
     /*  74243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74268 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74276 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74280 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74286 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74288 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74290 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74307 */     GIR_RootConstrainSelectedInstOperands,
     /*  74308 */     // GIR_Coverage, 15803,
     /*  74308 */     GIR_EraseRootFromParent_Done,
     /*  74309 */   // Label 1196: @74309
     /*  74309 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74427), // Rule ID 11959 //
     /*  74314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74369 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74377 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74381 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74385 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74389 */     // MIs[5] Op3
     /*  74389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74394 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74398 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74406 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74408 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74425 */     GIR_RootConstrainSelectedInstOperands,
     /*  74426 */     // GIR_Coverage, 11959,
     /*  74426 */     GIR_EraseRootFromParent_Done,
     /*  74427 */   // Label 1197: @74427
     /*  74427 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74545), // Rule ID 15802 //
     /*  74432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74487 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74503 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74507 */     // MIs[5] Op3
     /*  74507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74512 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74516 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74524 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74526 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74543 */     GIR_RootConstrainSelectedInstOperands,
     /*  74544 */     // GIR_Coverage, 15802,
     /*  74544 */     GIR_EraseRootFromParent_Done,
     /*  74545 */   // Label 1198: @74545
     /*  74545 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74635), // Rule ID 15730 //
     /*  74550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74605 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74609 */     // MIs[4] Op3
     /*  74609 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74616 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 15730,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1199: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74725), // Rule ID 15729 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74679 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74699 */     // MIs[4] Op3
     /*  74699 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74706 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74723 */     GIR_RootConstrainSelectedInstOperands,
     /*  74724 */     // GIR_Coverage, 15729,
     /*  74724 */     GIR_EraseRootFromParent_Done,
     /*  74725 */   // Label 1200: @74725
     /*  74725 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74815), // Rule ID 15728 //
     /*  74730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74789 */     // MIs[4] Op3
     /*  74789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74796 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74813 */     GIR_RootConstrainSelectedInstOperands,
     /*  74814 */     // GIR_Coverage, 15728,
     /*  74814 */     GIR_EraseRootFromParent_Done,
     /*  74815 */   // Label 1201: @74815
     /*  74815 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74905), // Rule ID 15727 //
     /*  74820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74867 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74871 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74875 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74879 */     // MIs[4] Op3
     /*  74879 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74886 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74903 */     GIR_RootConstrainSelectedInstOperands,
     /*  74904 */     // GIR_Coverage, 15727,
     /*  74904 */     GIR_EraseRootFromParent_Done,
     /*  74905 */   // Label 1202: @74905
     /*  74905 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74995), // Rule ID 15724 //
     /*  74910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74957 */     // MIs[3] Op3
     /*  74957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74966 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74976 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  74989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74993 */     GIR_RootConstrainSelectedInstOperands,
     /*  74994 */     // GIR_Coverage, 15724,
     /*  74994 */     GIR_EraseRootFromParent_Done,
     /*  74995 */   // Label 1203: @74995
     /*  74995 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75085), // Rule ID 15726 //
     /*  75000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75047 */     // MIs[3] Op3
     /*  75047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75066 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 15726,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1204: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75175), // Rule ID 11940 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75133 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75137 */     // MIs[3] Op3
     /*  75137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75156 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75173 */     GIR_RootConstrainSelectedInstOperands,
     /*  75174 */     // GIR_Coverage, 11940,
     /*  75174 */     GIR_EraseRootFromParent_Done,
     /*  75175 */   // Label 1205: @75175
     /*  75175 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75265), // Rule ID 15725 //
     /*  75180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75227 */     // MIs[3] Op3
     /*  75227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75246 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75263 */     GIR_RootConstrainSelectedInstOperands,
     /*  75264 */     // GIR_Coverage, 15725,
     /*  75264 */     GIR_EraseRootFromParent_Done,
     /*  75265 */   // Label 1206: @75265
     /*  75265 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75355), // Rule ID 15808 //
     /*  75270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75317 */     // MIs[3] Op3
     /*  75317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75336 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 15808,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1207: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75445), // Rule ID 15810 //
     /*  75360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75407 */     // MIs[3] Op3
     /*  75407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75424 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75426 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 15810,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1208: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75535), // Rule ID 11960 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75497 */     // MIs[3] Op3
     /*  75497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75506 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75514 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75516 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75533 */     GIR_RootConstrainSelectedInstOperands,
     /*  75534 */     // GIR_Coverage, 11960,
     /*  75534 */     GIR_EraseRootFromParent_Done,
     /*  75535 */   // Label 1209: @75535
     /*  75535 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75625), // Rule ID 15809 //
     /*  75540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75583 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75587 */     // MIs[3] Op3
     /*  75587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75606 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75623 */     GIR_RootConstrainSelectedInstOperands,
     /*  75624 */     // GIR_Coverage, 15809,
     /*  75624 */     GIR_EraseRootFromParent_Done,
     /*  75625 */   // Label 1210: @75625
     /*  75625 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75715), // Rule ID 15812 //
     /*  75630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75677 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75681 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75685 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75689 */     // MIs[4] Op3
     /*  75689 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75694 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75696 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75713 */     GIR_RootConstrainSelectedInstOperands,
     /*  75714 */     // GIR_Coverage, 15812,
     /*  75714 */     GIR_EraseRootFromParent_Done,
     /*  75715 */   // Label 1211: @75715
     /*  75715 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75805), // Rule ID 15814 //
     /*  75720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75759 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75775 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75779 */     // MIs[4] Op3
     /*  75779 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75784 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75786 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75803 */     GIR_RootConstrainSelectedInstOperands,
     /*  75804 */     // GIR_Coverage, 15814,
     /*  75804 */     GIR_EraseRootFromParent_Done,
     /*  75805 */   // Label 1212: @75805
     /*  75805 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75895), // Rule ID 15811 //
     /*  75810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[4] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75876 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75893 */     GIR_RootConstrainSelectedInstOperands,
     /*  75894 */     // GIR_Coverage, 15811,
     /*  75894 */     GIR_EraseRootFromParent_Done,
     /*  75895 */   // Label 1213: @75895
     /*  75895 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75985), // Rule ID 15813 //
     /*  75900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     // MIs[4] Op3
     /*  75959 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75966 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75983 */     GIR_RootConstrainSelectedInstOperands,
     /*  75984 */     // GIR_Coverage, 15813,
     /*  75984 */     GIR_EraseRootFromParent_Done,
     /*  75985 */   // Label 1214: @75985
     /*  75985 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76000), // Rule ID 7505 //
     /*  75990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75993 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  75993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  75998 */     GIR_RootConstrainSelectedInstOperands,
     /*  75999 */     // GIR_Coverage, 7505,
     /*  75999 */     GIR_Done,
     /*  76000 */   // Label 1215: @76000
     /*  76000 */   GIM_Reject,
     /*  76001 */ // Label 1182: @76001
     /*  76001 */ GIM_Reject,
     /*  76002 */ // Label 1026: @76002
     /*  76002 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76033), // Rule ID 8498 //
     /*  76007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  76013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  76016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76020 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  76020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  76023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76027 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76029 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76031 */   GIR_RootConstrainSelectedInstOperands,
     /*  76032 */   // GIR_Coverage, 8498,
     /*  76032 */   GIR_EraseRootFromParent_Done,
     /*  76033 */ // Label 1216: @76033
     /*  76033 */ GIM_Reject,
     /*  76034 */ // Label 1027: @76034
     /*  76034 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(79393),
     /*  76039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76167), // Rule ID 15791 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76093 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76121 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76137 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76141 */     // MIs[6] Op3
     /*  76141 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76146 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76148 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76165 */     GIR_RootConstrainSelectedInstOperands,
     /*  76166 */     // GIR_Coverage, 15791,
     /*  76166 */     GIR_EraseRootFromParent_Done,
     /*  76167 */   // Label 1218: @76167
     /*  76167 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76285), // Rule ID 15793 //
     /*  76172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76219 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76223 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76227 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76231 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76235 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76239 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76255 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76259 */     // MIs[6] Op3
     /*  76259 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76264 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76266 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76283 */     GIR_RootConstrainSelectedInstOperands,
     /*  76284 */     // GIR_Coverage, 15793,
     /*  76284 */     GIR_EraseRootFromParent_Done,
     /*  76285 */   // Label 1219: @76285
     /*  76285 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76403), // Rule ID 15790 //
     /*  76290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76349 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76353 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76357 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76369 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76373 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76377 */     // MIs[6] Op3
     /*  76377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76382 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76384 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76401 */     GIR_RootConstrainSelectedInstOperands,
     /*  76402 */     // GIR_Coverage, 15790,
     /*  76402 */     GIR_EraseRootFromParent_Done,
     /*  76403 */   // Label 1220: @76403
     /*  76403 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76521), // Rule ID 15792 //
     /*  76408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76447 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76467 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76471 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76475 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76495 */     // MIs[6] Op3
     /*  76495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76500 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76502 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76519 */     GIR_RootConstrainSelectedInstOperands,
     /*  76520 */     // GIR_Coverage, 15792,
     /*  76520 */     GIR_EraseRootFromParent_Done,
     /*  76521 */   // Label 1221: @76521
     /*  76521 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76639), // Rule ID 15745 //
     /*  76526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76585 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76593 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76597 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76601 */     // MIs[5] Op3
     /*  76601 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76606 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76610 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76618 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76620 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  76633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76637 */     GIR_RootConstrainSelectedInstOperands,
     /*  76638 */     // GIR_Coverage, 15745,
     /*  76638 */     GIR_EraseRootFromParent_Done,
     /*  76639 */   // Label 1222: @76639
     /*  76639 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76757), // Rule ID 15750 //
     /*  76644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76683 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76699 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76711 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76715 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76731 */     // MIs[4] Op3
     /*  76731 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76736 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76738 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76755 */     GIR_RootConstrainSelectedInstOperands,
     /*  76756 */     // GIR_Coverage, 15750,
     /*  76756 */     GIR_EraseRootFromParent_Done,
     /*  76757 */   // Label 1223: @76757
     /*  76757 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76875), // Rule ID 15751 //
     /*  76762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76801 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76817 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76821 */     // MIs[4] Op3
     /*  76821 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76842 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76846 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76854 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76856 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76873 */     GIR_RootConstrainSelectedInstOperands,
     /*  76874 */     // GIR_Coverage, 15751,
     /*  76874 */     GIR_EraseRootFromParent_Done,
     /*  76875 */   // Label 1224: @76875
     /*  76875 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76993), // Rule ID 11946 //
     /*  76880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76919 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76951 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76955 */     // MIs[5] Op3
     /*  76955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76960 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76964 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76972 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76974 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76991 */     GIR_RootConstrainSelectedInstOperands,
     /*  76992 */     // GIR_Coverage, 11946,
     /*  76992 */     GIR_EraseRootFromParent_Done,
     /*  76993 */   // Label 1225: @76993
     /*  76993 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77111), // Rule ID 15747 //
     /*  76998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77057 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77061 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77065 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77069 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77073 */     // MIs[5] Op3
     /*  77073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77078 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77082 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77090 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77092 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  77105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77109 */     GIR_RootConstrainSelectedInstOperands,
     /*  77110 */     // GIR_Coverage, 15747,
     /*  77110 */     GIR_EraseRootFromParent_Done,
     /*  77111 */   // Label 1226: @77111
     /*  77111 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77229), // Rule ID 15748 //
     /*  77116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77171 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77175 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77179 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77183 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77187 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77195 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77203 */     // MIs[4] Op3
     /*  77203 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77208 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77210 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77227 */     GIR_RootConstrainSelectedInstOperands,
     /*  77228 */     // GIR_Coverage, 15748,
     /*  77228 */     GIR_EraseRootFromParent_Done,
     /*  77229 */   // Label 1227: @77229
     /*  77229 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77347), // Rule ID 15749 //
     /*  77234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77293 */     // MIs[4] Op3
     /*  77293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77306 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77314 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77318 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77326 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77328 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77345 */     GIR_RootConstrainSelectedInstOperands,
     /*  77346 */     // GIR_Coverage, 15749,
     /*  77346 */     GIR_EraseRootFromParent_Done,
     /*  77347 */   // Label 1228: @77347
     /*  77347 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15746 //
     /*  77352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77419 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77423 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77427 */     // MIs[5] Op3
     /*  77427 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77432 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77436 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77446 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15746,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77583), // Rule ID 15787 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77517 */     // MIs[3] Op3
     /*  77517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77542 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77554 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77562 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77564 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77581 */     GIR_RootConstrainSelectedInstOperands,
     /*  77582 */     // GIR_Coverage, 15787,
     /*  77582 */     GIR_EraseRootFromParent_Done,
     /*  77583 */   // Label 1230: @77583
     /*  77583 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77701), // Rule ID 15789 //
     /*  77588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77631 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77635 */     // MIs[3] Op3
     /*  77635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77644 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77660 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77668 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77672 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77680 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77682 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77699 */     GIR_RootConstrainSelectedInstOperands,
     /*  77700 */     // GIR_Coverage, 15789,
     /*  77700 */     GIR_EraseRootFromParent_Done,
     /*  77701 */   // Label 1231: @77701
     /*  77701 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77819), // Rule ID 11956 //
     /*  77706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77761 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77769 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77773 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77777 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77781 */     // MIs[5] Op3
     /*  77781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77790 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77798 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77800 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77817 */     GIR_RootConstrainSelectedInstOperands,
     /*  77818 */     // GIR_Coverage, 11956,
     /*  77818 */     GIR_EraseRootFromParent_Done,
     /*  77819 */   // Label 1232: @77819
     /*  77819 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77937), // Rule ID 15788 //
     /*  77824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77887 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77891 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77895 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77899 */     // MIs[5] Op3
     /*  77899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77904 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77908 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77916 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77918 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77935 */     GIR_RootConstrainSelectedInstOperands,
     /*  77936 */     // GIR_Coverage, 15788,
     /*  77936 */     GIR_EraseRootFromParent_Done,
     /*  77937 */   // Label 1233: @77937
     /*  77937 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(78027), // Rule ID 15723 //
     /*  77942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77997 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78001 */     // MIs[4] Op3
     /*  78001 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78008 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78025 */     GIR_RootConstrainSelectedInstOperands,
     /*  78026 */     // GIR_Coverage, 15723,
     /*  78026 */     GIR_EraseRootFromParent_Done,
     /*  78027 */   // Label 1234: @78027
     /*  78027 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78117), // Rule ID 15722 //
     /*  78032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78071 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78083 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78087 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78091 */     // MIs[4] Op3
     /*  78091 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78098 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78115 */     GIR_RootConstrainSelectedInstOperands,
     /*  78116 */     // GIR_Coverage, 15722,
     /*  78116 */     GIR_EraseRootFromParent_Done,
     /*  78117 */   // Label 1235: @78117
     /*  78117 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78207), // Rule ID 15721 //
     /*  78122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78177 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78181 */     // MIs[4] Op3
     /*  78181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78188 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78205 */     GIR_RootConstrainSelectedInstOperands,
     /*  78206 */     // GIR_Coverage, 15721,
     /*  78206 */     GIR_EraseRootFromParent_Done,
     /*  78207 */   // Label 1236: @78207
     /*  78207 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78297), // Rule ID 15720 //
     /*  78212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78263 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78267 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78271 */     // MIs[4] Op3
     /*  78271 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78278 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78295 */     GIR_RootConstrainSelectedInstOperands,
     /*  78296 */     // GIR_Coverage, 15720,
     /*  78296 */     GIR_EraseRootFromParent_Done,
     /*  78297 */   // Label 1237: @78297
     /*  78297 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78387), // Rule ID 15717 //
     /*  78302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78345 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78349 */     // MIs[3] Op3
     /*  78349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78368 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78385 */     GIR_RootConstrainSelectedInstOperands,
     /*  78386 */     // GIR_Coverage, 15717,
     /*  78386 */     GIR_EraseRootFromParent_Done,
     /*  78387 */   // Label 1238: @78387
     /*  78387 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78477), // Rule ID 15719 //
     /*  78392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78439 */     // MIs[3] Op3
     /*  78439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78458 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78475 */     GIR_RootConstrainSelectedInstOperands,
     /*  78476 */     // GIR_Coverage, 15719,
     /*  78476 */     GIR_EraseRootFromParent_Done,
     /*  78477 */   // Label 1239: @78477
     /*  78477 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78567), // Rule ID 11938 //
     /*  78482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78529 */     // MIs[3] Op3
     /*  78529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78538 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78544 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78548 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78565 */     GIR_RootConstrainSelectedInstOperands,
     /*  78566 */     // GIR_Coverage, 11938,
     /*  78566 */     GIR_EraseRootFromParent_Done,
     /*  78567 */   // Label 1240: @78567
     /*  78567 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78657), // Rule ID 15718 //
     /*  78572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78619 */     // MIs[3] Op3
     /*  78619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78638 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78655 */     GIR_RootConstrainSelectedInstOperands,
     /*  78656 */     // GIR_Coverage, 15718,
     /*  78656 */     GIR_EraseRootFromParent_Done,
     /*  78657 */   // Label 1241: @78657
     /*  78657 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78747), // Rule ID 15794 //
     /*  78662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78705 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78709 */     // MIs[3] Op3
     /*  78709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78718 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78728 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78745 */     GIR_RootConstrainSelectedInstOperands,
     /*  78746 */     // GIR_Coverage, 15794,
     /*  78746 */     GIR_EraseRootFromParent_Done,
     /*  78747 */   // Label 1242: @78747
     /*  78747 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78837), // Rule ID 15796 //
     /*  78752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78799 */     // MIs[3] Op3
     /*  78799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78816 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78818 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78835 */     GIR_RootConstrainSelectedInstOperands,
     /*  78836 */     // GIR_Coverage, 15796,
     /*  78836 */     GIR_EraseRootFromParent_Done,
     /*  78837 */   // Label 1243: @78837
     /*  78837 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78927), // Rule ID 11957 //
     /*  78842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78889 */     // MIs[3] Op3
     /*  78889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78898 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78908 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  78921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78925 */     GIR_RootConstrainSelectedInstOperands,
     /*  78926 */     // GIR_Coverage, 11957,
     /*  78926 */     GIR_EraseRootFromParent_Done,
     /*  78927 */   // Label 1244: @78927
     /*  78927 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79017), // Rule ID 15795 //
     /*  78932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78979 */     // MIs[3] Op3
     /*  78979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78998 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79015 */     GIR_RootConstrainSelectedInstOperands,
     /*  79016 */     // GIR_Coverage, 15795,
     /*  79016 */     GIR_EraseRootFromParent_Done,
     /*  79017 */   // Label 1245: @79017
     /*  79017 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79107), // Rule ID 15798 //
     /*  79022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79061 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79073 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79077 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79081 */     // MIs[4] Op3
     /*  79081 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79088 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79105 */     GIR_RootConstrainSelectedInstOperands,
     /*  79106 */     // GIR_Coverage, 15798,
     /*  79106 */     GIR_EraseRootFromParent_Done,
     /*  79107 */   // Label 1246: @79107
     /*  79107 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79197), // Rule ID 15800 //
     /*  79112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79151 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79159 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79163 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79167 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79171 */     // MIs[4] Op3
     /*  79171 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79178 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79195 */     GIR_RootConstrainSelectedInstOperands,
     /*  79196 */     // GIR_Coverage, 15800,
     /*  79196 */     GIR_EraseRootFromParent_Done,
     /*  79197 */   // Label 1247: @79197
     /*  79197 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79287), // Rule ID 15797 //
     /*  79202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[4] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79268 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79285 */     GIR_RootConstrainSelectedInstOperands,
     /*  79286 */     // GIR_Coverage, 15797,
     /*  79286 */     GIR_EraseRootFromParent_Done,
     /*  79287 */   // Label 1248: @79287
     /*  79287 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79377), // Rule ID 15799 //
     /*  79292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79331 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     // MIs[4] Op3
     /*  79351 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79358 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79375 */     GIR_RootConstrainSelectedInstOperands,
     /*  79376 */     // GIR_Coverage, 15799,
     /*  79376 */     GIR_EraseRootFromParent_Done,
     /*  79377 */   // Label 1249: @79377
     /*  79377 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79392), // Rule ID 7504 //
     /*  79382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79385 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  79385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  79390 */     GIR_RootConstrainSelectedInstOperands,
     /*  79391 */     // GIR_Coverage, 7504,
     /*  79391 */     GIR_Done,
     /*  79392 */   // Label 1250: @79392
     /*  79392 */   GIM_Reject,
     /*  79393 */ // Label 1217: @79393
     /*  79393 */ GIM_Reject,
     /*  79394 */ // Label 1028: @79394
     /*  79394 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79425), // Rule ID 8497 //
     /*  79399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79412 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  79415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79419 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79421 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79423 */   GIR_RootConstrainSelectedInstOperands,
     /*  79424 */   // GIR_Coverage, 8497,
     /*  79424 */   GIR_EraseRootFromParent_Done,
     /*  79425 */ // Label 1251: @79425
     /*  79425 */ GIM_Reject,
     /*  79426 */ // Label 1029: @79426
     /*  79426 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(82785),
     /*  79431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79441 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79559), // Rule ID 15777 //
     /*  79446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79485 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79501 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79505 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79509 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79513 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79529 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79533 */     // MIs[6] Op3
     /*  79533 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79538 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79540 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79557 */     GIR_RootConstrainSelectedInstOperands,
     /*  79558 */     // GIR_Coverage, 15777,
     /*  79558 */     GIR_EraseRootFromParent_Done,
     /*  79559 */   // Label 1253: @79559
     /*  79559 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79677), // Rule ID 15779 //
     /*  79564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79603 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79619 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79623 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79627 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79631 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79643 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79647 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79651 */     // MIs[6] Op3
     /*  79651 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79656 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79658 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79675 */     GIR_RootConstrainSelectedInstOperands,
     /*  79676 */     // GIR_Coverage, 15779,
     /*  79676 */     GIR_EraseRootFromParent_Done,
     /*  79677 */   // Label 1254: @79677
     /*  79677 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79795), // Rule ID 15776 //
     /*  79682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79749 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79769 */     // MIs[6] Op3
     /*  79769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79774 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79776 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79793 */     GIR_RootConstrainSelectedInstOperands,
     /*  79794 */     // GIR_Coverage, 15776,
     /*  79794 */     GIR_EraseRootFromParent_Done,
     /*  79795 */   // Label 1255: @79795
     /*  79795 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(79913), // Rule ID 15778 //
     /*  79800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79847 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79851 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79855 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79859 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79863 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79867 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79879 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79887 */     // MIs[6] Op3
     /*  79887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79892 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79894 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79911 */     GIR_RootConstrainSelectedInstOperands,
     /*  79912 */     // GIR_Coverage, 15778,
     /*  79912 */     GIR_EraseRootFromParent_Done,
     /*  79913 */   // Label 1256: @79913
     /*  79913 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80031), // Rule ID 15738 //
     /*  79918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79957 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79969 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  79985 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79989 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79993 */     // MIs[5] Op3
     /*  79993 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80002 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80010 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80012 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80029 */     GIR_RootConstrainSelectedInstOperands,
     /*  80030 */     // GIR_Coverage, 15738,
     /*  80030 */     GIR_EraseRootFromParent_Done,
     /*  80031 */   // Label 1257: @80031
     /*  80031 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80149), // Rule ID 15743 //
     /*  80036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80087 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80091 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80095 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80099 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80103 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80107 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80111 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80115 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80123 */     // MIs[4] Op3
     /*  80123 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80128 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80130 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80147 */     GIR_RootConstrainSelectedInstOperands,
     /*  80148 */     // GIR_Coverage, 15743,
     /*  80148 */     GIR_EraseRootFromParent_Done,
     /*  80149 */   // Label 1258: @80149
     /*  80149 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80267), // Rule ID 15744 //
     /*  80154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80213 */     // MIs[4] Op3
     /*  80213 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80238 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80246 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80248 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80265 */     GIR_RootConstrainSelectedInstOperands,
     /*  80266 */     // GIR_Coverage, 15744,
     /*  80266 */     GIR_EraseRootFromParent_Done,
     /*  80267 */   // Label 1259: @80267
     /*  80267 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80385), // Rule ID 11944 //
     /*  80272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80319 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80323 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80327 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80331 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80335 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80339 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80343 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80347 */     // MIs[5] Op3
     /*  80347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80352 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80356 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80364 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80366 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80383 */     GIR_RootConstrainSelectedInstOperands,
     /*  80384 */     // GIR_Coverage, 11944,
     /*  80384 */     GIR_EraseRootFromParent_Done,
     /*  80385 */   // Label 1260: @80385
     /*  80385 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80503), // Rule ID 15740 //
     /*  80390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80429 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80437 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80441 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80445 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80449 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80461 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80465 */     // MIs[5] Op3
     /*  80465 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80470 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80474 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80482 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80484 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80501 */     GIR_RootConstrainSelectedInstOperands,
     /*  80502 */     // GIR_Coverage, 15740,
     /*  80502 */     GIR_EraseRootFromParent_Done,
     /*  80503 */   // Label 1261: @80503
     /*  80503 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80621), // Rule ID 15741 //
     /*  80508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80567 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80571 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80575 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80579 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80595 */     // MIs[4] Op3
     /*  80595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80600 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80602 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80619 */     GIR_RootConstrainSelectedInstOperands,
     /*  80620 */     // GIR_Coverage, 15741,
     /*  80620 */     GIR_EraseRootFromParent_Done,
     /*  80621 */   // Label 1262: @80621
     /*  80621 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80739), // Rule ID 15742 //
     /*  80626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80681 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80685 */     // MIs[4] Op3
     /*  80685 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80698 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80702 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80706 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80710 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80718 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80720 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80737 */     GIR_RootConstrainSelectedInstOperands,
     /*  80738 */     // GIR_Coverage, 15742,
     /*  80738 */     GIR_EraseRootFromParent_Done,
     /*  80739 */   // Label 1263: @80739
     /*  80739 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15739 //
     /*  80744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80803 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80811 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80815 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80819 */     // MIs[5] Op3
     /*  80819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80828 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80838 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15739,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80975), // Rule ID 15773 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80909 */     // MIs[3] Op3
     /*  80909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80918 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  80930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80934 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80942 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80946 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80954 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80956 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  80969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80973 */     GIR_RootConstrainSelectedInstOperands,
     /*  80974 */     // GIR_Coverage, 15773,
     /*  80974 */     GIR_EraseRootFromParent_Done,
     /*  80975 */   // Label 1265: @80975
     /*  80975 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(81093), // Rule ID 15775 //
     /*  80980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81027 */     // MIs[3] Op3
     /*  81027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81036 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81042 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81052 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81056 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81060 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81064 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81072 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81074 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  81087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81091 */     GIR_RootConstrainSelectedInstOperands,
     /*  81092 */     // GIR_Coverage, 15775,
     /*  81092 */     GIR_EraseRootFromParent_Done,
     /*  81093 */   // Label 1266: @81093
     /*  81093 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(81211), // Rule ID 11953 //
     /*  81098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81145 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81153 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81161 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81165 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81173 */     // MIs[5] Op3
     /*  81173 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81178 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81182 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81190 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81192 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81209 */     GIR_RootConstrainSelectedInstOperands,
     /*  81210 */     // GIR_Coverage, 11953,
     /*  81210 */     GIR_EraseRootFromParent_Done,
     /*  81211 */   // Label 1267: @81211
     /*  81211 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81329), // Rule ID 15774 //
     /*  81216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81271 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81279 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81283 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81287 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81291 */     // MIs[5] Op3
     /*  81291 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81296 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81300 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81306 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81308 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81310 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81327 */     GIR_RootConstrainSelectedInstOperands,
     /*  81328 */     // GIR_Coverage, 15774,
     /*  81328 */     GIR_EraseRootFromParent_Done,
     /*  81329 */   // Label 1268: @81329
     /*  81329 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81419), // Rule ID 15716 //
     /*  81334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81389 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81393 */     // MIs[4] Op3
     /*  81393 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81400 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81417 */     GIR_RootConstrainSelectedInstOperands,
     /*  81418 */     // GIR_Coverage, 15716,
     /*  81418 */     GIR_EraseRootFromParent_Done,
     /*  81419 */   // Label 1269: @81419
     /*  81419 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81509), // Rule ID 15715 //
     /*  81424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81475 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81479 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81483 */     // MIs[4] Op3
     /*  81483 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81490 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81507 */     GIR_RootConstrainSelectedInstOperands,
     /*  81508 */     // GIR_Coverage, 15715,
     /*  81508 */     GIR_EraseRootFromParent_Done,
     /*  81509 */   // Label 1270: @81509
     /*  81509 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81599), // Rule ID 15714 //
     /*  81514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81573 */     // MIs[4] Op3
     /*  81573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81580 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81597 */     GIR_RootConstrainSelectedInstOperands,
     /*  81598 */     // GIR_Coverage, 15714,
     /*  81598 */     GIR_EraseRootFromParent_Done,
     /*  81599 */   // Label 1271: @81599
     /*  81599 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81689), // Rule ID 15713 //
     /*  81604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81643 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81659 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81663 */     // MIs[4] Op3
     /*  81663 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81670 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81687 */     GIR_RootConstrainSelectedInstOperands,
     /*  81688 */     // GIR_Coverage, 15713,
     /*  81688 */     GIR_EraseRootFromParent_Done,
     /*  81689 */   // Label 1272: @81689
     /*  81689 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81779), // Rule ID 15710 //
     /*  81694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81737 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81741 */     // MIs[3] Op3
     /*  81741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81760 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81777 */     GIR_RootConstrainSelectedInstOperands,
     /*  81778 */     // GIR_Coverage, 15710,
     /*  81778 */     GIR_EraseRootFromParent_Done,
     /*  81779 */   // Label 1273: @81779
     /*  81779 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81869), // Rule ID 15712 //
     /*  81784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81831 */     // MIs[3] Op3
     /*  81831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81850 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81867 */     GIR_RootConstrainSelectedInstOperands,
     /*  81868 */     // GIR_Coverage, 15712,
     /*  81868 */     GIR_EraseRootFromParent_Done,
     /*  81869 */   // Label 1274: @81869
     /*  81869 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81959), // Rule ID 11936 //
     /*  81874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81921 */     // MIs[3] Op3
     /*  81921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81940 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81957 */     GIR_RootConstrainSelectedInstOperands,
     /*  81958 */     // GIR_Coverage, 11936,
     /*  81958 */     GIR_EraseRootFromParent_Done,
     /*  81959 */   // Label 1275: @81959
     /*  81959 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(82049), // Rule ID 15711 //
     /*  81964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82011 */     // MIs[3] Op3
     /*  82011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82020 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82030 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 15711,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1276: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82139), // Rule ID 15780 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82097 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82101 */     // MIs[3] Op3
     /*  82101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82120 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82137 */     GIR_RootConstrainSelectedInstOperands,
     /*  82138 */     // GIR_Coverage, 15780,
     /*  82138 */     GIR_EraseRootFromParent_Done,
     /*  82139 */   // Label 1277: @82139
     /*  82139 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82229), // Rule ID 15782 //
     /*  82144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82191 */     // MIs[3] Op3
     /*  82191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82210 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82227 */     GIR_RootConstrainSelectedInstOperands,
     /*  82228 */     // GIR_Coverage, 15782,
     /*  82228 */     GIR_EraseRootFromParent_Done,
     /*  82229 */   // Label 1278: @82229
     /*  82229 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82319), // Rule ID 11954 //
     /*  82234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82281 */     // MIs[3] Op3
     /*  82281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82300 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82317 */     GIR_RootConstrainSelectedInstOperands,
     /*  82318 */     // GIR_Coverage, 11954,
     /*  82318 */     GIR_EraseRootFromParent_Done,
     /*  82319 */   // Label 1279: @82319
     /*  82319 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82409), // Rule ID 15781 //
     /*  82324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82371 */     // MIs[3] Op3
     /*  82371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82390 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82407 */     GIR_RootConstrainSelectedInstOperands,
     /*  82408 */     // GIR_Coverage, 15781,
     /*  82408 */     GIR_EraseRootFromParent_Done,
     /*  82409 */   // Label 1280: @82409
     /*  82409 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82499), // Rule ID 15784 //
     /*  82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82469 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82473 */     // MIs[4] Op3
     /*  82473 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82480 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82497 */     GIR_RootConstrainSelectedInstOperands,
     /*  82498 */     // GIR_Coverage, 15784,
     /*  82498 */     GIR_EraseRootFromParent_Done,
     /*  82499 */   // Label 1281: @82499
     /*  82499 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82589), // Rule ID 15786 //
     /*  82504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82559 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82563 */     // MIs[4] Op3
     /*  82563 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82570 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82587 */     GIR_RootConstrainSelectedInstOperands,
     /*  82588 */     // GIR_Coverage, 15786,
     /*  82588 */     GIR_EraseRootFromParent_Done,
     /*  82589 */   // Label 1282: @82589
     /*  82589 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82679), // Rule ID 15783 //
     /*  82594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[4] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82658 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82660 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82677 */     GIR_RootConstrainSelectedInstOperands,
     /*  82678 */     // GIR_Coverage, 15783,
     /*  82678 */     GIR_EraseRootFromParent_Done,
     /*  82679 */   // Label 1283: @82679
     /*  82679 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82769), // Rule ID 15785 //
     /*  82684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     // MIs[4] Op3
     /*  82743 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82750 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82767 */     GIR_RootConstrainSelectedInstOperands,
     /*  82768 */     // GIR_Coverage, 15785,
     /*  82768 */     GIR_EraseRootFromParent_Done,
     /*  82769 */   // Label 1284: @82769
     /*  82769 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82784), // Rule ID 7503 //
     /*  82774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82777 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  82777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  82782 */     GIR_RootConstrainSelectedInstOperands,
     /*  82783 */     // GIR_Coverage, 7503,
     /*  82783 */     GIR_Done,
     /*  82784 */   // Label 1285: @82784
     /*  82784 */   GIM_Reject,
     /*  82785 */ // Label 1252: @82785
     /*  82785 */ GIM_Reject,
     /*  82786 */ // Label 1030: @82786
     /*  82786 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(82817), // Rule ID 8496 //
     /*  82791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  82797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  82800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  82804 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  82804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  82807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  82809 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82811 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82813 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  82815 */   GIR_RootConstrainSelectedInstOperands,
     /*  82816 */   // GIR_Coverage, 8496,
     /*  82816 */   GIR_EraseRootFromParent_Done,
     /*  82817 */ // Label 1286: @82817
     /*  82817 */ GIM_Reject,
     /*  82818 */ // Label 1031: @82818
     /*  82818 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(86177),
     /*  82823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  82833 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(82951), // Rule ID 15763 //
     /*  82838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82877 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  82889 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82893 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82905 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  82913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  82917 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82921 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82925 */     // MIs[6] Op3
     /*  82925 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  82930 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82932 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  82932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  82941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  82949 */     GIR_RootConstrainSelectedInstOperands,
     /*  82950 */     // GIR_Coverage, 15763,
     /*  82950 */     GIR_EraseRootFromParent_Done,
     /*  82951 */   // Label 1288: @82951
     /*  82951 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83069), // Rule ID 15765 //
     /*  82956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82995 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83007 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83011 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83015 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83019 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83023 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83035 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83039 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83043 */     // MIs[6] Op3
     /*  83043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83048 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83050 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  83059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83067 */     GIR_RootConstrainSelectedInstOperands,
     /*  83068 */     // GIR_Coverage, 15765,
     /*  83068 */     GIR_EraseRootFromParent_Done,
     /*  83069 */   // Label 1289: @83069
     /*  83069 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83187), // Rule ID 15762 //
     /*  83074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83133 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83137 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83141 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83153 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83157 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83161 */     // MIs[6] Op3
     /*  83161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  83166 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83168 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  83185 */     GIR_RootConstrainSelectedInstOperands,
     /*  83186 */     // GIR_Coverage, 15762,
     /*  83186 */     GIR_EraseRootFromParent_Done,
     /*  83187 */   // Label 1290: @83187
     /*  83187 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83305), // Rule ID 15764 //
     /*  83192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83259 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83279 */     // MIs[6] Op3
     /*  83279 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83284 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83286 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83303 */     GIR_RootConstrainSelectedInstOperands,
     /*  83304 */     // GIR_Coverage, 15764,
     /*  83304 */     GIR_EraseRootFromParent_Done,
     /*  83305 */   // Label 1291: @83305
     /*  83305 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83423), // Rule ID 15731 //
     /*  83310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83349 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83361 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83369 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83377 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83381 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83385 */     // MIs[5] Op3
     /*  83385 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83394 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83402 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83404 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 15731,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1292: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83541), // Rule ID 15736 //
     /*  83428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83467 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83487 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83491 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83495 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83499 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83515 */     // MIs[4] Op3
     /*  83515 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83520 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83522 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83539 */     GIR_RootConstrainSelectedInstOperands,
     /*  83540 */     // GIR_Coverage, 15736,
     /*  83540 */     GIR_EraseRootFromParent_Done,
     /*  83541 */   // Label 1293: @83541
     /*  83541 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83659), // Rule ID 15737 //
     /*  83546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83585 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83593 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83597 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83601 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83605 */     // MIs[4] Op3
     /*  83605 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83610 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83614 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83618 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83622 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83626 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83630 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83638 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83640 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83657 */     GIR_RootConstrainSelectedInstOperands,
     /*  83658 */     // GIR_Coverage, 15737,
     /*  83658 */     GIR_EraseRootFromParent_Done,
     /*  83659 */   // Label 1294: @83659
     /*  83659 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83777), // Rule ID 11942 //
     /*  83664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83703 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83727 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83731 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83735 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83739 */     // MIs[5] Op3
     /*  83739 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83748 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83756 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83758 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83775 */     GIR_RootConstrainSelectedInstOperands,
     /*  83776 */     // GIR_Coverage, 11942,
     /*  83776 */     GIR_EraseRootFromParent_Done,
     /*  83777 */   // Label 1295: @83777
     /*  83777 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83895), // Rule ID 15733 //
     /*  83782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83821 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83833 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83837 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83841 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83857 */     // MIs[5] Op3
     /*  83857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83876 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83893 */     GIR_RootConstrainSelectedInstOperands,
     /*  83894 */     // GIR_Coverage, 15733,
     /*  83894 */     GIR_EraseRootFromParent_Done,
     /*  83895 */   // Label 1296: @83895
     /*  83895 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84013), // Rule ID 15734 //
     /*  83900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83959 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83963 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83967 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83971 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83975 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83979 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83987 */     // MIs[4] Op3
     /*  83987 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83994 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84011 */     GIR_RootConstrainSelectedInstOperands,
     /*  84012 */     // GIR_Coverage, 15734,
     /*  84012 */     GIR_EraseRootFromParent_Done,
     /*  84013 */   // Label 1297: @84013
     /*  84013 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84131), // Rule ID 15735 //
     /*  84018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84057 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84065 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84069 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84073 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84077 */     // MIs[4] Op3
     /*  84077 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84082 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84086 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84090 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84112 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84129 */     GIR_RootConstrainSelectedInstOperands,
     /*  84130 */     // GIR_Coverage, 15735,
     /*  84130 */     GIR_EraseRootFromParent_Done,
     /*  84131 */   // Label 1298: @84131
     /*  84131 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15732 //
     /*  84136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84195 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84207 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84211 */     // MIs[5] Op3
     /*  84211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84230 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15732,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84367), // Rule ID 15759 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84301 */     // MIs[3] Op3
     /*  84301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84326 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84330 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84348 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84365 */     GIR_RootConstrainSelectedInstOperands,
     /*  84366 */     // GIR_Coverage, 15759,
     /*  84366 */     GIR_EraseRootFromParent_Done,
     /*  84367 */   // Label 1300: @84367
     /*  84367 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84485), // Rule ID 15761 //
     /*  84372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84419 */     // MIs[3] Op3
     /*  84419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84444 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84448 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84466 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84483 */     GIR_RootConstrainSelectedInstOperands,
     /*  84484 */     // GIR_Coverage, 15761,
     /*  84484 */     GIR_EraseRootFromParent_Done,
     /*  84485 */   // Label 1301: @84485
     /*  84485 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84603), // Rule ID 11950 //
     /*  84490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84545 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84553 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84557 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84561 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84565 */     // MIs[5] Op3
     /*  84565 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84584 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84601 */     GIR_RootConstrainSelectedInstOperands,
     /*  84602 */     // GIR_Coverage, 11950,
     /*  84602 */     GIR_EraseRootFromParent_Done,
     /*  84603 */   // Label 1302: @84603
     /*  84603 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84721), // Rule ID 15760 //
     /*  84608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84671 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84675 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84679 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84683 */     // MIs[5] Op3
     /*  84683 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84702 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84719 */     GIR_RootConstrainSelectedInstOperands,
     /*  84720 */     // GIR_Coverage, 15760,
     /*  84720 */     GIR_EraseRootFromParent_Done,
     /*  84721 */   // Label 1303: @84721
     /*  84721 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84811), // Rule ID 15709 //
     /*  84726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84785 */     // MIs[4] Op3
     /*  84785 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84790 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84792 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84809 */     GIR_RootConstrainSelectedInstOperands,
     /*  84810 */     // GIR_Coverage, 15709,
     /*  84810 */     GIR_EraseRootFromParent_Done,
     /*  84811 */   // Label 1304: @84811
     /*  84811 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84901), // Rule ID 15708 //
     /*  84816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84855 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84861 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84871 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84875 */     // MIs[4] Op3
     /*  84875 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84882 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84899 */     GIR_RootConstrainSelectedInstOperands,
     /*  84900 */     // GIR_Coverage, 15708,
     /*  84900 */     GIR_EraseRootFromParent_Done,
     /*  84901 */   // Label 1305: @84901
     /*  84901 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84991), // Rule ID 15707 //
     /*  84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84945 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84953 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84957 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84961 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84965 */     // MIs[4] Op3
     /*  84965 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84972 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84989 */     GIR_RootConstrainSelectedInstOperands,
     /*  84990 */     // GIR_Coverage, 15707,
     /*  84990 */     GIR_EraseRootFromParent_Done,
     /*  84991 */   // Label 1306: @84991
     /*  84991 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(85081), // Rule ID 15706 //
     /*  84996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85035 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85051 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85055 */     // MIs[4] Op3
     /*  85055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85060 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85062 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  85071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85079 */     GIR_RootConstrainSelectedInstOperands,
     /*  85080 */     // GIR_Coverage, 15706,
     /*  85080 */     GIR_EraseRootFromParent_Done,
     /*  85081 */   // Label 1307: @85081
     /*  85081 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85171), // Rule ID 15703 //
     /*  85086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85133 */     // MIs[3] Op3
     /*  85133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85152 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85169 */     GIR_RootConstrainSelectedInstOperands,
     /*  85170 */     // GIR_Coverage, 15703,
     /*  85170 */     GIR_EraseRootFromParent_Done,
     /*  85171 */   // Label 1308: @85171
     /*  85171 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85261), // Rule ID 15705 //
     /*  85176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85223 */     // MIs[3] Op3
     /*  85223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85242 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85259 */     GIR_RootConstrainSelectedInstOperands,
     /*  85260 */     // GIR_Coverage, 15705,
     /*  85260 */     GIR_EraseRootFromParent_Done,
     /*  85261 */   // Label 1309: @85261
     /*  85261 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85351), // Rule ID 11934 //
     /*  85266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85313 */     // MIs[3] Op3
     /*  85313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85332 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 11934,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1310: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85441), // Rule ID 15704 //
     /*  85356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85403 */     // MIs[3] Op3
     /*  85403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85422 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85439 */     GIR_RootConstrainSelectedInstOperands,
     /*  85440 */     // GIR_Coverage, 15704,
     /*  85440 */     GIR_EraseRootFromParent_Done,
     /*  85441 */   // Label 1311: @85441
     /*  85441 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85531), // Rule ID 15766 //
     /*  85446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85493 */     // MIs[3] Op3
     /*  85493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85502 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85512 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85529 */     GIR_RootConstrainSelectedInstOperands,
     /*  85530 */     // GIR_Coverage, 15766,
     /*  85530 */     GIR_EraseRootFromParent_Done,
     /*  85531 */   // Label 1312: @85531
     /*  85531 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85621), // Rule ID 15768 //
     /*  85536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85583 */     // MIs[3] Op3
     /*  85583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85602 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85619 */     GIR_RootConstrainSelectedInstOperands,
     /*  85620 */     // GIR_Coverage, 15768,
     /*  85620 */     GIR_EraseRootFromParent_Done,
     /*  85621 */   // Label 1313: @85621
     /*  85621 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85711), // Rule ID 11951 //
     /*  85626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85673 */     // MIs[3] Op3
     /*  85673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85692 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85709 */     GIR_RootConstrainSelectedInstOperands,
     /*  85710 */     // GIR_Coverage, 11951,
     /*  85710 */     GIR_EraseRootFromParent_Done,
     /*  85711 */   // Label 1314: @85711
     /*  85711 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85801), // Rule ID 15767 //
     /*  85716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85763 */     // MIs[3] Op3
     /*  85763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85782 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85799 */     GIR_RootConstrainSelectedInstOperands,
     /*  85800 */     // GIR_Coverage, 15767,
     /*  85800 */     GIR_EraseRootFromParent_Done,
     /*  85801 */   // Label 1315: @85801
     /*  85801 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85891), // Rule ID 15770 //
     /*  85806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85861 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85865 */     // MIs[4] Op3
     /*  85865 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  85870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85872 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  85889 */     GIR_RootConstrainSelectedInstOperands,
     /*  85890 */     // GIR_Coverage, 15770,
     /*  85890 */     GIR_EraseRootFromParent_Done,
     /*  85891 */   // Label 1316: @85891
     /*  85891 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85981), // Rule ID 15772 //
     /*  85896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85935 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85955 */     // MIs[4] Op3
     /*  85955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85962 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85979 */     GIR_RootConstrainSelectedInstOperands,
     /*  85980 */     // GIR_Coverage, 15772,
     /*  85980 */     GIR_EraseRootFromParent_Done,
     /*  85981 */   // Label 1317: @85981
     /*  85981 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86071), // Rule ID 15769 //
     /*  85986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86037 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86041 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[4] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  86050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86052 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  86069 */     GIR_RootConstrainSelectedInstOperands,
     /*  86070 */     // GIR_Coverage, 15769,
     /*  86070 */     GIR_EraseRootFromParent_Done,
     /*  86071 */   // Label 1318: @86071
     /*  86071 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86161), // Rule ID 15771 //
     /*  86076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86127 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86131 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     // MIs[4] Op3
     /*  86135 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86142 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86159 */     GIR_RootConstrainSelectedInstOperands,
     /*  86160 */     // GIR_Coverage, 15771,
     /*  86160 */     GIR_EraseRootFromParent_Done,
     /*  86161 */   // Label 1319: @86161
     /*  86161 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86176), // Rule ID 7502 //
     /*  86166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86169 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  86169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  86174 */     GIR_RootConstrainSelectedInstOperands,
     /*  86175 */     // GIR_Coverage, 7502,
     /*  86175 */     GIR_Done,
     /*  86176 */   // Label 1320: @86176
     /*  86176 */   GIM_Reject,
     /*  86177 */ // Label 1287: @86177
     /*  86177 */ GIM_Reject,
     /*  86178 */ // Label 1032: @86178
     /*  86178 */ GIM_Reject,
     /*  86179 */ // Label 7: @86179
     /*  86179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1339*/ GIMT_Encode4(97146),
     /*  86190 */ /*GILLT_s32*//*Label 1321*/ GIMT_Encode4(86278),
     /*  86194 */ /*GILLT_s64*//*Label 1322*/ GIMT_Encode4(86958), GIMT_Encode4(0),
     /*  86202 */ /*GILLT_v2s32*//*Label 1323*/ GIMT_Encode4(87801),
     /*  86206 */ /*GILLT_v2s64*//*Label 1324*/ GIMT_Encode4(88036),
     /*  86210 */ /*GILLT_v4s16*//*Label 1325*/ GIMT_Encode4(88725),
     /*  86214 */ /*GILLT_v4s32*//*Label 1326*/ GIMT_Encode4(88960),
     /*  86218 */ /*GILLT_v8s8*//*Label 1327*/ GIMT_Encode4(89649),
     /*  86222 */ /*GILLT_v8s16*//*Label 1328*/ GIMT_Encode4(89887),
     /*  86226 */ /*GILLT_v16s8*//*Label 1329*/ GIMT_Encode4(90576),
     /*  86230 */ /*GILLT_nxv1s1*//*Label 1330*/ GIMT_Encode4(91268),
     /*  86234 */ /*GILLT_nxv2s1*//*Label 1331*/ GIMT_Encode4(91318), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86246 */ /*GILLT_nxv2s64*//*Label 1332*/ GIMT_Encode4(91368),
     /*  86250 */ /*GILLT_nxv4s1*//*Label 1333*/ GIMT_Encode4(92775), GIMT_Encode4(0),
     /*  86258 */ /*GILLT_nxv4s32*//*Label 1334*/ GIMT_Encode4(92825),
     /*  86262 */ /*GILLT_nxv8s1*//*Label 1335*/ GIMT_Encode4(94232),
     /*  86266 */ /*GILLT_nxv8s16*//*Label 1336*/ GIMT_Encode4(94282),
     /*  86270 */ /*GILLT_nxv16s1*//*Label 1337*/ GIMT_Encode4(95689),
     /*  86274 */ /*GILLT_nxv16s8*//*Label 1338*/ GIMT_Encode4(95739),
     /*  86278 */ // Label 1321: @86278
     /*  86278 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(86957),
     /*  86283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86289 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(86347), // Rule ID 13310 //
     /*  86294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86332 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86345 */     GIR_RootConstrainSelectedInstOperands,
     /*  86346 */     // GIR_Coverage, 13310,
     /*  86346 */     GIR_EraseRootFromParent_Done,
     /*  86347 */   // Label 1341: @86347
     /*  86347 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(86402), // Rule ID 13309 //
     /*  86352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86389 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86400 */     GIR_RootConstrainSelectedInstOperands,
     /*  86401 */     // GIR_Coverage, 13309,
     /*  86401 */     GIR_EraseRootFromParent_Done,
     /*  86402 */   // Label 1342: @86402
     /*  86402 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(86460), // Rule ID 13307 //
     /*  86407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86445 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86458 */     GIR_RootConstrainSelectedInstOperands,
     /*  86459 */     // GIR_Coverage, 13307,
     /*  86459 */     GIR_EraseRootFromParent_Done,
     /*  86460 */   // Label 1343: @86460
     /*  86460 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(86518), // Rule ID 166 //
     /*  86465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86503 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86516 */     GIR_RootConstrainSelectedInstOperands,
     /*  86517 */     // GIR_Coverage, 166,
     /*  86517 */     GIR_EraseRootFromParent_Done,
     /*  86518 */   // Label 1344: @86518
     /*  86518 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(86576), // Rule ID 13308 //
     /*  86523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86561 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86574 */     GIR_RootConstrainSelectedInstOperands,
     /*  86575 */     // GIR_Coverage, 13308,
     /*  86575 */     GIR_EraseRootFromParent_Done,
     /*  86576 */   // Label 1345: @86576
     /*  86576 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(86631), // Rule ID 13311 //
     /*  86581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86618 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86629 */     GIR_RootConstrainSelectedInstOperands,
     /*  86630 */     // GIR_Coverage, 13311,
     /*  86630 */     GIR_EraseRootFromParent_Done,
     /*  86631 */   // Label 1346: @86631
     /*  86631 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(86672), // Rule ID 144 //
     /*  86636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  86640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86652 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  86656 */     // MIs[1] Operand 1
     /*  86656 */     // No operand predicates
     /*  86656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86658 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  86658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  86670 */     GIR_RootConstrainSelectedInstOperands,
     /*  86671 */     // GIR_Coverage, 144,
     /*  86671 */     GIR_EraseRootFromParent_Done,
     /*  86672 */   // Label 1347: @86672
     /*  86672 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(86705), // Rule ID 13317 //
     /*  86677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86692 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86703 */     GIR_RootConstrainSelectedInstOperands,
     /*  86704 */     // GIR_Coverage, 13317,
     /*  86704 */     GIR_EraseRootFromParent_Done,
     /*  86705 */   // Label 1348: @86705
     /*  86705 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(86738), // Rule ID 170 //
     /*  86710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86725 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86736 */     GIR_RootConstrainSelectedInstOperands,
     /*  86737 */     // GIR_Coverage, 170,
     /*  86737 */     GIR_EraseRootFromParent_Done,
     /*  86738 */   // Label 1349: @86738
     /*  86738 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(86791), // Rule ID 13303 //
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86778 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  86789 */     GIR_RootConstrainSelectedInstOperands,
     /*  86790 */     // GIR_Coverage, 13303,
     /*  86790 */     GIR_EraseRootFromParent_Done,
     /*  86791 */   // Label 1350: @86791
     /*  86791 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(86847), // Rule ID 164 //
     /*  86796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  86845 */     GIR_RootConstrainSelectedInstOperands,
     /*  86846 */     // GIR_Coverage, 164,
     /*  86846 */     GIR_EraseRootFromParent_Done,
     /*  86847 */   // Label 1351: @86847
     /*  86847 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(86900), // Rule ID 13304 //
     /*  86852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86887 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  86898 */     GIR_RootConstrainSelectedInstOperands,
     /*  86899 */     // GIR_Coverage, 13304,
     /*  86899 */     GIR_EraseRootFromParent_Done,
     /*  86900 */   // Label 1352: @86900
     /*  86900 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(86932), // Rule ID 3999 //
     /*  86905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86917 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  86917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  86930 */     GIR_RootConstrainSelectedInstOperands,
     /*  86931 */     // GIR_Coverage, 3999,
     /*  86931 */     GIR_EraseRootFromParent_Done,
     /*  86932 */   // Label 1353: @86932
     /*  86932 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(86956), // Rule ID 168 //
     /*  86937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86949 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  86954 */     GIR_RootConstrainSelectedInstOperands,
     /*  86955 */     // GIR_Coverage, 168,
     /*  86955 */     GIR_Done,
     /*  86956 */   // Label 1354: @86956
     /*  86956 */   GIM_Reject,
     /*  86957 */ // Label 1340: @86957
     /*  86957 */ GIM_Reject,
     /*  86958 */ // Label 1322: @86958
     /*  86958 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(87800),
     /*  86963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86969 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87027), // Rule ID 13315 //
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  86990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87012 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87025 */     GIR_RootConstrainSelectedInstOperands,
     /*  87026 */     // GIR_Coverage, 13315,
     /*  87026 */     GIR_EraseRootFromParent_Done,
     /*  87027 */   // Label 1356: @87027
     /*  87027 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87082), // Rule ID 13314 //
     /*  87032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87069 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87080 */     GIR_RootConstrainSelectedInstOperands,
     /*  87081 */     // GIR_Coverage, 13314,
     /*  87081 */     GIR_EraseRootFromParent_Done,
     /*  87082 */   // Label 1357: @87082
     /*  87082 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87140), // Rule ID 13312 //
     /*  87087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87125 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87138 */     GIR_RootConstrainSelectedInstOperands,
     /*  87139 */     // GIR_Coverage, 13312,
     /*  87139 */     GIR_EraseRootFromParent_Done,
     /*  87140 */   // Label 1358: @87140
     /*  87140 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87198), // Rule ID 167 //
     /*  87145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87183 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87196 */     GIR_RootConstrainSelectedInstOperands,
     /*  87197 */     // GIR_Coverage, 167,
     /*  87197 */     GIR_EraseRootFromParent_Done,
     /*  87198 */   // Label 1359: @87198
     /*  87198 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87256), // Rule ID 13313 //
     /*  87203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87241 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87254 */     GIR_RootConstrainSelectedInstOperands,
     /*  87255 */     // GIR_Coverage, 13313,
     /*  87255 */     GIR_EraseRootFromParent_Done,
     /*  87256 */   // Label 1360: @87256
     /*  87256 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(87311), // Rule ID 13316 //
     /*  87261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87298 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87309 */     GIR_RootConstrainSelectedInstOperands,
     /*  87310 */     // GIR_Coverage, 13316,
     /*  87310 */     GIR_EraseRootFromParent_Done,
     /*  87311 */   // Label 1361: @87311
     /*  87311 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(87411), // Rule ID 1613 //
     /*  87316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  87339 */     // MIs[1] Operand 1
     /*  87339 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  87356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  87360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87374 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87396 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  87396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  87399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87409 */     GIR_RootConstrainSelectedInstOperands,
     /*  87410 */     // GIR_Coverage, 1613,
     /*  87410 */     GIR_EraseRootFromParent_Done,
     /*  87411 */   // Label 1362: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(87452), // Rule ID 145 //
     /*  87416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  87420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87432 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  87436 */     // MIs[1] Operand 1
     /*  87436 */     // No operand predicates
     /*  87436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87438 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  87438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  87441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 145,
     /*  87451 */     GIR_EraseRootFromParent_Done,
     /*  87452 */   // Label 1363: @87452
     /*  87452 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(87485), // Rule ID 13318 //
     /*  87457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87472 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87483 */     GIR_RootConstrainSelectedInstOperands,
     /*  87484 */     // GIR_Coverage, 13318,
     /*  87484 */     GIR_EraseRootFromParent_Done,
     /*  87485 */   // Label 1364: @87485
     /*  87485 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(87518), // Rule ID 171 //
     /*  87490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87505 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 171,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1365: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87571), // Rule ID 13305 //
     /*  87523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87558 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  87569 */     GIR_RootConstrainSelectedInstOperands,
     /*  87570 */     // GIR_Coverage, 13305,
     /*  87570 */     GIR_EraseRootFromParent_Done,
     /*  87571 */   // Label 1366: @87571
     /*  87571 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87627), // Rule ID 165 //
     /*  87576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87612 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  87625 */     GIR_RootConstrainSelectedInstOperands,
     /*  87626 */     // GIR_Coverage, 165,
     /*  87626 */     GIR_EraseRootFromParent_Done,
     /*  87627 */   // Label 1367: @87627
     /*  87627 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87680), // Rule ID 13306 //
     /*  87632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87667 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  87678 */     GIR_RootConstrainSelectedInstOperands,
     /*  87679 */     // GIR_Coverage, 13306,
     /*  87679 */     GIR_EraseRootFromParent_Done,
     /*  87680 */   // Label 1368: @87680
     /*  87680 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87712), // Rule ID 4000 //
     /*  87685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87697 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  87697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  87700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  87710 */     GIR_RootConstrainSelectedInstOperands,
     /*  87711 */     // GIR_Coverage, 4000,
     /*  87711 */     GIR_EraseRootFromParent_Done,
     /*  87712 */   // Label 1369: @87712
     /*  87712 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87748), // Rule ID 4984 //
     /*  87717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  87737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87739 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  87739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  87742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87746 */     GIR_RootConstrainSelectedInstOperands,
     /*  87747 */     // GIR_Coverage, 4984,
     /*  87747 */     GIR_EraseRootFromParent_Done,
     /*  87748 */   // Label 1370: @87748
     /*  87748 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87772), // Rule ID 169 //
     /*  87753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87765 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  87770 */     GIR_RootConstrainSelectedInstOperands,
     /*  87771 */     // GIR_Coverage, 169,
     /*  87771 */     GIR_Done,
     /*  87772 */   // Label 1371: @87772
     /*  87772 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87799), // Rule ID 5062 //
     /*  87777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87792 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  87792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  87797 */     GIR_RootConstrainSelectedInstOperands,
     /*  87798 */     // GIR_Coverage, 5062,
     /*  87798 */     GIR_Done,
     /*  87799 */   // Label 1372: @87799
     /*  87799 */   GIM_Reject,
     /*  87800 */ // Label 1355: @87800
     /*  87800 */ GIM_Reject,
     /*  87801 */ // Label 1323: @87801
     /*  87801 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88035),
     /*  87806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87816 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87912), // Rule ID 1160 //
     /*  87821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87840 */     // MIs[1] Operand 1
     /*  87840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87887 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87897 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  87897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87910 */     GIR_RootConstrainSelectedInstOperands,
     /*  87911 */     // GIR_Coverage, 1160,
     /*  87911 */     GIR_EraseRootFromParent_Done,
     /*  87912 */   // Label 1374: @87912
     /*  87912 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87979), // Rule ID 5031 //
     /*  87917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87933 */     // MIs[1] Operand 1
     /*  87933 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  87942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  87950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  87954 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87964 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  87964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87977 */     GIR_RootConstrainSelectedInstOperands,
     /*  87978 */     // GIR_Coverage, 5031,
     /*  87978 */     GIR_EraseRootFromParent_Done,
     /*  87979 */   // Label 1375: @87979
     /*  87979 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88011), // Rule ID 4982 //
     /*  87984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88002 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  88002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88009 */     GIR_RootConstrainSelectedInstOperands,
     /*  88010 */     // GIR_Coverage, 4982,
     /*  88010 */     GIR_EraseRootFromParent_Done,
     /*  88011 */   // Label 1376: @88011
     /*  88011 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88034), // Rule ID 5061 //
     /*  88016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88027 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  88027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88032 */     GIR_RootConstrainSelectedInstOperands,
     /*  88033 */     // GIR_Coverage, 5061,
     /*  88033 */     GIR_Done,
     /*  88034 */   // Label 1377: @88034
     /*  88034 */   GIM_Reject,
     /*  88035 */ // Label 1373: @88035
     /*  88035 */ GIM_Reject,
     /*  88036 */ // Label 1324: @88036
     /*  88036 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88724),
     /*  88041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88051 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88147), // Rule ID 1162 //
     /*  88056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88075 */     // MIs[1] Operand 1
     /*  88075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88122 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88132 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  88132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88145 */     GIR_RootConstrainSelectedInstOperands,
     /*  88146 */     // GIR_Coverage, 1162,
     /*  88146 */     GIR_EraseRootFromParent_Done,
     /*  88147 */   // Label 1379: @88147
     /*  88147 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88214), // Rule ID 5033 //
     /*  88152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88168 */     // MIs[1] Operand 1
     /*  88168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88177 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88199 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  88199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88212 */     GIR_RootConstrainSelectedInstOperands,
     /*  88213 */     // GIR_Coverage, 5033,
     /*  88213 */     GIR_EraseRootFromParent_Done,
     /*  88214 */   // Label 1380: @88214
     /*  88214 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88299), // Rule ID 13850 //
     /*  88219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88282 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88297 */     GIR_RootConstrainSelectedInstOperands,
     /*  88298 */     // GIR_Coverage, 13850,
     /*  88298 */     GIR_EraseRootFromParent_Done,
     /*  88299 */   // Label 1381: @88299
     /*  88299 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88384), // Rule ID 13849 //
     /*  88304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88353 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88367 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88382 */     GIR_RootConstrainSelectedInstOperands,
     /*  88383 */     // GIR_Coverage, 13849,
     /*  88383 */     GIR_EraseRootFromParent_Done,
     /*  88384 */   // Label 1382: @88384
     /*  88384 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88469), // Rule ID 13848 //
     /*  88389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88452 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88467 */     GIR_RootConstrainSelectedInstOperands,
     /*  88468 */     // GIR_Coverage, 13848,
     /*  88468 */     GIR_EraseRootFromParent_Done,
     /*  88469 */   // Label 1383: @88469
     /*  88469 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88554), // Rule ID 3827 //
     /*  88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88537 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88552 */     GIR_RootConstrainSelectedInstOperands,
     /*  88553 */     // GIR_Coverage, 3827,
     /*  88553 */     GIR_EraseRootFromParent_Done,
     /*  88554 */   // Label 1384: @88554
     /*  88554 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(88586), // Rule ID 4985 //
     /*  88559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88577 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  88577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88584 */     GIR_RootConstrainSelectedInstOperands,
     /*  88585 */     // GIR_Coverage, 4985,
     /*  88585 */     GIR_EraseRootFromParent_Done,
     /*  88586 */   // Label 1385: @88586
     /*  88586 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(88643), // Rule ID 3823 //
     /*  88591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88626 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  88641 */     GIR_RootConstrainSelectedInstOperands,
     /*  88642 */     // GIR_Coverage, 3823,
     /*  88642 */     GIR_EraseRootFromParent_Done,
     /*  88643 */   // Label 1386: @88643
     /*  88643 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(88700), // Rule ID 13838 //
     /*  88648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88683 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  88698 */     GIR_RootConstrainSelectedInstOperands,
     /*  88699 */     // GIR_Coverage, 13838,
     /*  88699 */     GIR_EraseRootFromParent_Done,
     /*  88700 */   // Label 1387: @88700
     /*  88700 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(88723), // Rule ID 5065 //
     /*  88705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88716 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  88716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  88721 */     GIR_RootConstrainSelectedInstOperands,
     /*  88722 */     // GIR_Coverage, 5065,
     /*  88722 */     GIR_Done,
     /*  88723 */   // Label 1388: @88723
     /*  88723 */   GIM_Reject,
     /*  88724 */ // Label 1378: @88724
     /*  88724 */ GIM_Reject,
     /*  88725 */ // Label 1325: @88725
     /*  88725 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(88959),
     /*  88730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88740 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(88836), // Rule ID 1158 //
     /*  88745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88764 */     // MIs[1] Operand 1
     /*  88764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88811 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88821 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  88821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88834 */     GIR_RootConstrainSelectedInstOperands,
     /*  88835 */     // GIR_Coverage, 1158,
     /*  88835 */     GIR_EraseRootFromParent_Done,
     /*  88836 */   // Label 1390: @88836
     /*  88836 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(88903), // Rule ID 5029 //
     /*  88841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88853 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88857 */     // MIs[1] Operand 1
     /*  88857 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88878 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88888 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88901 */     GIR_RootConstrainSelectedInstOperands,
     /*  88902 */     // GIR_Coverage, 5029,
     /*  88902 */     GIR_EraseRootFromParent_Done,
     /*  88903 */   // Label 1391: @88903
     /*  88903 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(88935), // Rule ID 4980 //
     /*  88908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88926 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  88926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88933 */     GIR_RootConstrainSelectedInstOperands,
     /*  88934 */     // GIR_Coverage, 4980,
     /*  88934 */     GIR_EraseRootFromParent_Done,
     /*  88935 */   // Label 1392: @88935
     /*  88935 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(88958), // Rule ID 5060 //
     /*  88940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88951 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  88951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88956 */     GIR_RootConstrainSelectedInstOperands,
     /*  88957 */     // GIR_Coverage, 5060,
     /*  88957 */     GIR_Done,
     /*  88958 */   // Label 1393: @88958
     /*  88958 */   GIM_Reject,
     /*  88959 */ // Label 1389: @88959
     /*  88959 */ GIM_Reject,
     /*  88960 */ // Label 1326: @88960
     /*  88960 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89648),
     /*  88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88975 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89071), // Rule ID 1161 //
     /*  88980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88999 */     // MIs[1] Operand 1
     /*  88999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89054 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89056 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  89056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89069 */     GIR_RootConstrainSelectedInstOperands,
     /*  89070 */     // GIR_Coverage, 1161,
     /*  89070 */     GIR_EraseRootFromParent_Done,
     /*  89071 */   // Label 1395: @89071
     /*  89071 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89138), // Rule ID 5032 //
     /*  89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89088 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89092 */     // MIs[1] Operand 1
     /*  89092 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89101 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89107 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89123 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  89123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89136 */     GIR_RootConstrainSelectedInstOperands,
     /*  89137 */     // GIR_Coverage, 5032,
     /*  89137 */     GIR_EraseRootFromParent_Done,
     /*  89138 */   // Label 1396: @89138
     /*  89138 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89223), // Rule ID 13847 //
     /*  89143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89187 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89206 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89221 */     GIR_RootConstrainSelectedInstOperands,
     /*  89222 */     // GIR_Coverage, 13847,
     /*  89222 */     GIR_EraseRootFromParent_Done,
     /*  89223 */   // Label 1397: @89223
     /*  89223 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89308), // Rule ID 13846 //
     /*  89228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89277 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89291 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89306 */     GIR_RootConstrainSelectedInstOperands,
     /*  89307 */     // GIR_Coverage, 13846,
     /*  89307 */     GIR_EraseRootFromParent_Done,
     /*  89308 */   // Label 1398: @89308
     /*  89308 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89393), // Rule ID 13845 //
     /*  89313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89376 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89391 */     GIR_RootConstrainSelectedInstOperands,
     /*  89392 */     // GIR_Coverage, 13845,
     /*  89392 */     GIR_EraseRootFromParent_Done,
     /*  89393 */   // Label 1399: @89393
     /*  89393 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(89478), // Rule ID 3826 //
     /*  89398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89461 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 3826,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1400: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(89510), // Rule ID 4983 //
     /*  89483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89501 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  89501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  89504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89508 */     GIR_RootConstrainSelectedInstOperands,
     /*  89509 */     // GIR_Coverage, 4983,
     /*  89509 */     GIR_EraseRootFromParent_Done,
     /*  89510 */   // Label 1401: @89510
     /*  89510 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(89567), // Rule ID 3822 //
     /*  89515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89550 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  89565 */     GIR_RootConstrainSelectedInstOperands,
     /*  89566 */     // GIR_Coverage, 3822,
     /*  89566 */     GIR_EraseRootFromParent_Done,
     /*  89567 */   // Label 1402: @89567
     /*  89567 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(89624), // Rule ID 13837 //
     /*  89572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89607 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  89622 */     GIR_RootConstrainSelectedInstOperands,
     /*  89623 */     // GIR_Coverage, 13837,
     /*  89623 */     GIR_EraseRootFromParent_Done,
     /*  89624 */   // Label 1403: @89624
     /*  89624 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(89647), // Rule ID 5064 //
     /*  89629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89640 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  89640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  89645 */     GIR_RootConstrainSelectedInstOperands,
     /*  89646 */     // GIR_Coverage, 5064,
     /*  89646 */     GIR_Done,
     /*  89647 */   // Label 1404: @89647
     /*  89647 */   GIM_Reject,
     /*  89648 */ // Label 1394: @89648
     /*  89648 */ GIM_Reject,
     /*  89649 */ // Label 1327: @89649
     /*  89649 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(89886),
     /*  89654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89664 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(89760), // Rule ID 1156 //
     /*  89669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89688 */     // MIs[1] Operand 1
     /*  89688 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89735 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89745 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89758 */     GIR_RootConstrainSelectedInstOperands,
     /*  89759 */     // GIR_Coverage, 1156,
     /*  89759 */     GIR_EraseRootFromParent_Done,
     /*  89760 */   // Label 1406: @89760
     /*  89760 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(89827), // Rule ID 5027 //
     /*  89765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89781 */     // MIs[1] Operand 1
     /*  89781 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89812 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  89812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89825 */     GIR_RootConstrainSelectedInstOperands,
     /*  89826 */     // GIR_Coverage, 5027,
     /*  89826 */     GIR_EraseRootFromParent_Done,
     /*  89827 */   // Label 1407: @89827
     /*  89827 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(89862), // Rule ID 972 //
     /*  89832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89853 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  89853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89860 */     GIR_RootConstrainSelectedInstOperands,
     /*  89861 */     // GIR_Coverage, 972,
     /*  89861 */     GIR_EraseRootFromParent_Done,
     /*  89862 */   // Label 1408: @89862
     /*  89862 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(89885), // Rule ID 1599 //
     /*  89867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89878 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89883 */     GIR_RootConstrainSelectedInstOperands,
     /*  89884 */     // GIR_Coverage, 1599,
     /*  89884 */     GIR_Done,
     /*  89885 */   // Label 1409: @89885
     /*  89885 */   GIM_Reject,
     /*  89886 */ // Label 1405: @89886
     /*  89886 */ GIM_Reject,
     /*  89887 */ // Label 1328: @89887
     /*  89887 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90575),
     /*  89892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89902 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(89998), // Rule ID 1159 //
     /*  89907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89922 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89926 */     // MIs[1] Operand 1
     /*  89926 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89973 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89983 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  89983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  89986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89996 */     GIR_RootConstrainSelectedInstOperands,
     /*  89997 */     // GIR_Coverage, 1159,
     /*  89997 */     GIR_EraseRootFromParent_Done,
     /*  89998 */   // Label 1411: @89998
     /*  89998 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90065), // Rule ID 5030 //
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90019 */     // MIs[1] Operand 1
     /*  90019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90040 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90050 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  90050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  90053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90063 */     GIR_RootConstrainSelectedInstOperands,
     /*  90064 */     // GIR_Coverage, 5030,
     /*  90064 */     GIR_EraseRootFromParent_Done,
     /*  90065 */   // Label 1412: @90065
     /*  90065 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90150), // Rule ID 13844 //
     /*  90070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90114 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90133 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90148 */     GIR_RootConstrainSelectedInstOperands,
     /*  90149 */     // GIR_Coverage, 13844,
     /*  90149 */     GIR_EraseRootFromParent_Done,
     /*  90150 */   // Label 1413: @90150
     /*  90150 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90235), // Rule ID 13843 //
     /*  90155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90204 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90218 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90233 */     GIR_RootConstrainSelectedInstOperands,
     /*  90234 */     // GIR_Coverage, 13843,
     /*  90234 */     GIR_EraseRootFromParent_Done,
     /*  90235 */   // Label 1414: @90235
     /*  90235 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90320), // Rule ID 13842 //
     /*  90240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90288 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90303 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90318 */     GIR_RootConstrainSelectedInstOperands,
     /*  90319 */     // GIR_Coverage, 13842,
     /*  90319 */     GIR_EraseRootFromParent_Done,
     /*  90320 */   // Label 1415: @90320
     /*  90320 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90405), // Rule ID 3825 //
     /*  90325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90388 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90403 */     GIR_RootConstrainSelectedInstOperands,
     /*  90404 */     // GIR_Coverage, 3825,
     /*  90404 */     GIR_EraseRootFromParent_Done,
     /*  90405 */   // Label 1416: @90405
     /*  90405 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90437), // Rule ID 4981 //
     /*  90410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90428 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  90428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90435 */     GIR_RootConstrainSelectedInstOperands,
     /*  90436 */     // GIR_Coverage, 4981,
     /*  90436 */     GIR_EraseRootFromParent_Done,
     /*  90437 */   // Label 1417: @90437
     /*  90437 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(90494), // Rule ID 3821 //
     /*  90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90477 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90492 */     GIR_RootConstrainSelectedInstOperands,
     /*  90493 */     // GIR_Coverage, 3821,
     /*  90493 */     GIR_EraseRootFromParent_Done,
     /*  90494 */   // Label 1418: @90494
     /*  90494 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(90551), // Rule ID 13836 //
     /*  90499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90534 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 13836,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1419: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90574), // Rule ID 5063 //
     /*  90556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90567 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  90567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90572 */     GIR_RootConstrainSelectedInstOperands,
     /*  90573 */     // GIR_Coverage, 5063,
     /*  90573 */     GIR_Done,
     /*  90574 */   // Label 1420: @90574
     /*  90574 */   GIM_Reject,
     /*  90575 */ // Label 1410: @90575
     /*  90575 */ GIM_Reject,
     /*  90576 */ // Label 1329: @90576
     /*  90576 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91267),
     /*  90581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90591 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(90687), // Rule ID 1157 //
     /*  90596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90615 */     // MIs[1] Operand 1
     /*  90615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90670 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90672 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  90672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90685 */     GIR_RootConstrainSelectedInstOperands,
     /*  90686 */     // GIR_Coverage, 1157,
     /*  90686 */     GIR_EraseRootFromParent_Done,
     /*  90687 */   // Label 1422: @90687
     /*  90687 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(90754), // Rule ID 5028 //
     /*  90692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90708 */     // MIs[1] Operand 1
     /*  90708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90717 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90739 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  90739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90752 */     GIR_RootConstrainSelectedInstOperands,
     /*  90753 */     // GIR_Coverage, 5028,
     /*  90753 */     GIR_EraseRootFromParent_Done,
     /*  90754 */   // Label 1423: @90754
     /*  90754 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(90839), // Rule ID 13841 //
     /*  90759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90803 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90822 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90837 */     GIR_RootConstrainSelectedInstOperands,
     /*  90838 */     // GIR_Coverage, 13841,
     /*  90838 */     GIR_EraseRootFromParent_Done,
     /*  90839 */   // Label 1424: @90839
     /*  90839 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(90924), // Rule ID 13840 //
     /*  90844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90907 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90922 */     GIR_RootConstrainSelectedInstOperands,
     /*  90923 */     // GIR_Coverage, 13840,
     /*  90923 */     GIR_EraseRootFromParent_Done,
     /*  90924 */   // Label 1425: @90924
     /*  90924 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91009), // Rule ID 13839 //
     /*  90929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90977 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90992 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91007 */     GIR_RootConstrainSelectedInstOperands,
     /*  91008 */     // GIR_Coverage, 13839,
     /*  91008 */     GIR_EraseRootFromParent_Done,
     /*  91009 */   // Label 1426: @91009
     /*  91009 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91094), // Rule ID 3824 //
     /*  91014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91067 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91077 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91092 */     GIR_RootConstrainSelectedInstOperands,
     /*  91093 */     // GIR_Coverage, 3824,
     /*  91093 */     GIR_EraseRootFromParent_Done,
     /*  91094 */   // Label 1427: @91094
     /*  91094 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91129), // Rule ID 973 //
     /*  91099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91120 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  91120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91127 */     GIR_RootConstrainSelectedInstOperands,
     /*  91128 */     // GIR_Coverage, 973,
     /*  91128 */     GIR_EraseRootFromParent_Done,
     /*  91129 */   // Label 1428: @91129
     /*  91129 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91186), // Rule ID 3820 //
     /*  91134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91169 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91184 */     GIR_RootConstrainSelectedInstOperands,
     /*  91185 */     // GIR_Coverage, 3820,
     /*  91185 */     GIR_EraseRootFromParent_Done,
     /*  91186 */   // Label 1429: @91186
     /*  91186 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91243), // Rule ID 13835 //
     /*  91191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91226 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91241 */     GIR_RootConstrainSelectedInstOperands,
     /*  91242 */     // GIR_Coverage, 13835,
     /*  91242 */     GIR_EraseRootFromParent_Done,
     /*  91243 */   // Label 1430: @91243
     /*  91243 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91266), // Rule ID 1600 //
     /*  91248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91259 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  91259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91264 */     GIR_RootConstrainSelectedInstOperands,
     /*  91265 */     // GIR_Coverage, 1600,
     /*  91265 */     GIR_Done,
     /*  91266 */   // Label 1431: @91266
     /*  91266 */   GIM_Reject,
     /*  91267 */ // Label 1421: @91267
     /*  91267 */ GIM_Reject,
     /*  91268 */ // Label 1330: @91268
     /*  91268 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91317), // Rule ID 8490 //
     /*  91273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  91279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  91282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91286 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  91286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91298 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91313 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91315 */   GIR_RootConstrainSelectedInstOperands,
     /*  91316 */   // GIR_Coverage, 8490,
     /*  91316 */   GIR_EraseRootFromParent_Done,
     /*  91317 */ // Label 1432: @91317
     /*  91317 */ GIM_Reject,
     /*  91318 */ // Label 1331: @91318
     /*  91318 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91367), // Rule ID 8489 //
     /*  91323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  91329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  91332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91336 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  91336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91361 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91365 */   GIR_RootConstrainSelectedInstOperands,
     /*  91366 */   // GIR_Coverage, 8489,
     /*  91366 */   GIR_EraseRootFromParent_Done,
     /*  91367 */ // Label 1433: @91367
     /*  91367 */ GIM_Reject,
     /*  91368 */ // Label 1332: @91368
     /*  91368 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92774),
     /*  91373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91383 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(91501), // Rule ID 15842 //
     /*  91388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91443 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91451 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91455 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91459 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91463 */     // MIs[5] Op3
     /*  91463 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91468 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91472 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91480 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91482 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91499 */     GIR_RootConstrainSelectedInstOperands,
     /*  91500 */     // GIR_Coverage, 15842,
     /*  91500 */     GIR_EraseRootFromParent_Done,
     /*  91501 */   // Label 1435: @91501
     /*  91501 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(91619), // Rule ID 15841 //
     /*  91506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91561 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91577 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91581 */     // MIs[5] Op3
     /*  91581 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91586 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91590 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91598 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91600 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91617 */     GIR_RootConstrainSelectedInstOperands,
     /*  91618 */     // GIR_Coverage, 15841,
     /*  91618 */     GIR_EraseRootFromParent_Done,
     /*  91619 */   // Label 1436: @91619
     /*  91619 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91737), // Rule ID 15840 //
     /*  91624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91695 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91699 */     // MIs[5] Op3
     /*  91699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91704 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91708 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91716 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91718 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91735 */     GIR_RootConstrainSelectedInstOperands,
     /*  91736 */     // GIR_Coverage, 15840,
     /*  91736 */     GIR_EraseRootFromParent_Done,
     /*  91737 */   // Label 1437: @91737
     /*  91737 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(91855), // Rule ID 15839 //
     /*  91742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91793 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91797 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91813 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91817 */     // MIs[5] Op3
     /*  91817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91822 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91826 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91834 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91836 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91853 */     GIR_RootConstrainSelectedInstOperands,
     /*  91854 */     // GIR_Coverage, 15839,
     /*  91854 */     GIR_EraseRootFromParent_Done,
     /*  91855 */   // Label 1438: @91855
     /*  91855 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(91973), // Rule ID 15836 //
     /*  91860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  91899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91911 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  91915 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91919 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91923 */     // MIs[4] Op3
     /*  91923 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  91928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  91932 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91944 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91952 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91954 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  91963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  91967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  91971 */     GIR_RootConstrainSelectedInstOperands,
     /*  91972 */     // GIR_Coverage, 15836,
     /*  91972 */     GIR_EraseRootFromParent_Done,
     /*  91973 */   // Label 1439: @91973
     /*  91973 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92091), // Rule ID 15838 //
     /*  91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  92033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92037 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92041 */     // MIs[4] Op3
     /*  92041 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92046 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92050 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92058 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92062 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92070 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92072 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  92085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92089 */     GIR_RootConstrainSelectedInstOperands,
     /*  92090 */     // GIR_Coverage, 15838,
     /*  92090 */     GIR_EraseRootFromParent_Done,
     /*  92091 */   // Label 1440: @92091
     /*  92091 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92209), // Rule ID 11968 //
     /*  92096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92155 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92159 */     // MIs[4] Op3
     /*  92159 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  92164 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92168 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92180 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92188 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92190 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  92199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  92207 */     GIR_RootConstrainSelectedInstOperands,
     /*  92208 */     // GIR_Coverage, 11968,
     /*  92208 */     GIR_EraseRootFromParent_Done,
     /*  92209 */   // Label 1441: @92209
     /*  92209 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92327), // Rule ID 15837 //
     /*  92214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92269 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92277 */     // MIs[4] Op3
     /*  92277 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92286 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92294 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92298 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92306 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92308 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92325 */     GIR_RootConstrainSelectedInstOperands,
     /*  92326 */     // GIR_Coverage, 15837,
     /*  92326 */     GIR_EraseRootFromParent_Done,
     /*  92327 */   // Label 1442: @92327
     /*  92327 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92398), // Rule ID 15702 //
     /*  92332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92381 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92396 */     GIR_RootConstrainSelectedInstOperands,
     /*  92397 */     // GIR_Coverage, 15702,
     /*  92397 */     GIR_EraseRootFromParent_Done,
     /*  92398 */   // Label 1443: @92398
     /*  92398 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92469), // Rule ID 15701 //
     /*  92403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92452 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92467 */     GIR_RootConstrainSelectedInstOperands,
     /*  92468 */     // GIR_Coverage, 15701,
     /*  92468 */     GIR_EraseRootFromParent_Done,
     /*  92469 */   // Label 1444: @92469
     /*  92469 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92540), // Rule ID 15700 //
     /*  92474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92523 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92538 */     GIR_RootConstrainSelectedInstOperands,
     /*  92539 */     // GIR_Coverage, 15700,
     /*  92539 */     GIR_EraseRootFromParent_Done,
     /*  92540 */   // Label 1445: @92540
     /*  92540 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92611), // Rule ID 11932 //
     /*  92545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92594 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92609 */     GIR_RootConstrainSelectedInstOperands,
     /*  92610 */     // GIR_Coverage, 11932,
     /*  92610 */     GIR_EraseRootFromParent_Done,
     /*  92611 */   // Label 1446: @92611
     /*  92611 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92672), // Rule ID 11967 //
     /*  92616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  92627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  92639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  92643 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  92651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  92653 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  92662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  92666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 11967,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1447: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92715), // Rule ID 13802 //
     /*  92677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92698 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 13802,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1448: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92758), // Rule ID 3147 //
     /*  92720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92741 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  92756 */     GIR_RootConstrainSelectedInstOperands,
     /*  92757 */     // GIR_Coverage, 3147,
     /*  92757 */     GIR_EraseRootFromParent_Done,
     /*  92758 */   // Label 1449: @92758
     /*  92758 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92773), // Rule ID 7509 //
     /*  92763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92766 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  92766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  92771 */     GIR_RootConstrainSelectedInstOperands,
     /*  92772 */     // GIR_Coverage, 7509,
     /*  92772 */     GIR_Done,
     /*  92773 */   // Label 1450: @92773
     /*  92773 */   GIM_Reject,
     /*  92774 */ // Label 1434: @92774
     /*  92774 */ GIM_Reject,
     /*  92775 */ // Label 1333: @92775
     /*  92775 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92824), // Rule ID 8488 //
     /*  92780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  92786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  92789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92793 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  92793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  92800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92805 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92822 */   GIR_RootConstrainSelectedInstOperands,
     /*  92823 */   // GIR_Coverage, 8488,
     /*  92823 */   GIR_EraseRootFromParent_Done,
     /*  92824 */ // Label 1451: @92824
     /*  92824 */ GIM_Reject,
     /*  92825 */ // Label 1334: @92825
     /*  92825 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(94231),
     /*  92830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92840 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92958), // Rule ID 15835 //
     /*  92845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92916 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92920 */     // MIs[5] Op3
     /*  92920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92939 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  92939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 15835,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1453: @92958
     /*  92958 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93076), // Rule ID 15834 //
     /*  92963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93038 */     // MIs[5] Op3
     /*  93038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93043 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93047 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93057 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 15834,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1454: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93194), // Rule ID 15833 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93152 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93156 */     // MIs[5] Op3
     /*  93156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93165 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93175 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93192 */     GIR_RootConstrainSelectedInstOperands,
     /*  93193 */     // GIR_Coverage, 15833,
     /*  93193 */     GIR_EraseRootFromParent_Done,
     /*  93194 */   // Label 1455: @93194
     /*  93194 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93312), // Rule ID 15832 //
     /*  93199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93274 */     // MIs[5] Op3
     /*  93274 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93293 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93310 */     GIR_RootConstrainSelectedInstOperands,
     /*  93311 */     // GIR_Coverage, 15832,
     /*  93311 */     GIR_EraseRootFromParent_Done,
     /*  93312 */   // Label 1456: @93312
     /*  93312 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93430), // Rule ID 15829 //
     /*  93317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93376 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93380 */     // MIs[4] Op3
     /*  93380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93385 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93389 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93401 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93411 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93428 */     GIR_RootConstrainSelectedInstOperands,
     /*  93429 */     // GIR_Coverage, 15829,
     /*  93429 */     GIR_EraseRootFromParent_Done,
     /*  93430 */   // Label 1457: @93430
     /*  93430 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93548), // Rule ID 15831 //
     /*  93435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93494 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93498 */     // MIs[4] Op3
     /*  93498 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93507 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93529 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93546 */     GIR_RootConstrainSelectedInstOperands,
     /*  93547 */     // GIR_Coverage, 15831,
     /*  93547 */     GIR_EraseRootFromParent_Done,
     /*  93548 */   // Label 1458: @93548
     /*  93548 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93666), // Rule ID 11966 //
     /*  93553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93612 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93616 */     // MIs[4] Op3
     /*  93616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93621 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93625 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93647 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93664 */     GIR_RootConstrainSelectedInstOperands,
     /*  93665 */     // GIR_Coverage, 11966,
     /*  93665 */     GIR_EraseRootFromParent_Done,
     /*  93666 */   // Label 1459: @93666
     /*  93666 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93784), // Rule ID 15830 //
     /*  93671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93734 */     // MIs[4] Op3
     /*  93734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93739 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93743 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93765 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93782 */     GIR_RootConstrainSelectedInstOperands,
     /*  93783 */     // GIR_Coverage, 15830,
     /*  93783 */     GIR_EraseRootFromParent_Done,
     /*  93784 */   // Label 1460: @93784
     /*  93784 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93855), // Rule ID 15699 //
     /*  93789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93828 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93838 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93853 */     GIR_RootConstrainSelectedInstOperands,
     /*  93854 */     // GIR_Coverage, 15699,
     /*  93854 */     GIR_EraseRootFromParent_Done,
     /*  93855 */   // Label 1461: @93855
     /*  93855 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93926), // Rule ID 15698 //
     /*  93860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93899 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93909 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93924 */     GIR_RootConstrainSelectedInstOperands,
     /*  93925 */     // GIR_Coverage, 15698,
     /*  93925 */     GIR_EraseRootFromParent_Done,
     /*  93926 */   // Label 1462: @93926
     /*  93926 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93997), // Rule ID 15697 //
     /*  93931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93970 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93980 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93995 */     GIR_RootConstrainSelectedInstOperands,
     /*  93996 */     // GIR_Coverage, 15697,
     /*  93996 */     GIR_EraseRootFromParent_Done,
     /*  93997 */   // Label 1463: @93997
     /*  93997 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94068), // Rule ID 11930 //
     /*  94002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94041 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94051 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94066 */     GIR_RootConstrainSelectedInstOperands,
     /*  94067 */     // GIR_Coverage, 11930,
     /*  94067 */     GIR_EraseRootFromParent_Done,
     /*  94068 */   // Label 1464: @94068
     /*  94068 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94129), // Rule ID 11965 //
     /*  94073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  94096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94100 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94106 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94110 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94127 */     GIR_RootConstrainSelectedInstOperands,
     /*  94128 */     // GIR_Coverage, 11965,
     /*  94128 */     GIR_EraseRootFromParent_Done,
     /*  94129 */   // Label 1465: @94129
     /*  94129 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94172), // Rule ID 13801 //
     /*  94134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94155 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94170 */     GIR_RootConstrainSelectedInstOperands,
     /*  94171 */     // GIR_Coverage, 13801,
     /*  94171 */     GIR_EraseRootFromParent_Done,
     /*  94172 */   // Label 1466: @94172
     /*  94172 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94215), // Rule ID 3145 //
     /*  94177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94198 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94213 */     GIR_RootConstrainSelectedInstOperands,
     /*  94214 */     // GIR_Coverage, 3145,
     /*  94214 */     GIR_EraseRootFromParent_Done,
     /*  94215 */   // Label 1467: @94215
     /*  94215 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94230), // Rule ID 7508 //
     /*  94220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94223 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  94223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94228 */     GIR_RootConstrainSelectedInstOperands,
     /*  94229 */     // GIR_Coverage, 7508,
     /*  94229 */     GIR_Done,
     /*  94230 */   // Label 1468: @94230
     /*  94230 */   GIM_Reject,
     /*  94231 */ // Label 1452: @94231
     /*  94231 */ GIM_Reject,
     /*  94232 */ // Label 1335: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94281), // Rule ID 8487 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  94243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  94246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94250 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  94250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  94257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94262 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94277 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94279 */   GIR_RootConstrainSelectedInstOperands,
     /*  94280 */   // GIR_Coverage, 8487,
     /*  94280 */   GIR_EraseRootFromParent_Done,
     /*  94281 */ // Label 1469: @94281
     /*  94281 */ GIM_Reject,
     /*  94282 */ // Label 1336: @94282
     /*  94282 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(95688),
     /*  94287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94297 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94415), // Rule ID 15828 //
     /*  94302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94357 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94365 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94369 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94373 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94377 */     // MIs[5] Op3
     /*  94377 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94382 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94386 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94394 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94396 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94413 */     GIR_RootConstrainSelectedInstOperands,
     /*  94414 */     // GIR_Coverage, 15828,
     /*  94414 */     GIR_EraseRootFromParent_Done,
     /*  94415 */   // Label 1471: @94415
     /*  94415 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94533), // Rule ID 15827 //
     /*  94420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94483 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94487 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94491 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94495 */     // MIs[5] Op3
     /*  94495 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94500 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94504 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94512 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94514 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94531 */     GIR_RootConstrainSelectedInstOperands,
     /*  94532 */     // GIR_Coverage, 15827,
     /*  94532 */     GIR_EraseRootFromParent_Done,
     /*  94533 */   // Label 1472: @94533
     /*  94533 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94651), // Rule ID 15826 //
     /*  94538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94585 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94601 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94605 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94609 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94613 */     // MIs[5] Op3
     /*  94613 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94622 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94630 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94632 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94649 */     GIR_RootConstrainSelectedInstOperands,
     /*  94650 */     // GIR_Coverage, 15826,
     /*  94650 */     GIR_EraseRootFromParent_Done,
     /*  94651 */   // Label 1473: @94651
     /*  94651 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(94769), // Rule ID 15825 //
     /*  94656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94707 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94711 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94719 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94723 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94727 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94731 */     // MIs[5] Op3
     /*  94731 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94740 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94748 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94750 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94767 */     GIR_RootConstrainSelectedInstOperands,
     /*  94768 */     // GIR_Coverage, 15825,
     /*  94768 */     GIR_EraseRootFromParent_Done,
     /*  94769 */   // Label 1474: @94769
     /*  94769 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(94887), // Rule ID 15822 //
     /*  94774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94825 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94829 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94833 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94837 */     // MIs[4] Op3
     /*  94837 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94846 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94858 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94866 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94868 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94885 */     GIR_RootConstrainSelectedInstOperands,
     /*  94886 */     // GIR_Coverage, 15822,
     /*  94886 */     GIR_EraseRootFromParent_Done,
     /*  94887 */   // Label 1475: @94887
     /*  94887 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95005), // Rule ID 15824 //
     /*  94892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94955 */     // MIs[4] Op3
     /*  94955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94964 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94972 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94976 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94984 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94986 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  94995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95003 */     GIR_RootConstrainSelectedInstOperands,
     /*  95004 */     // GIR_Coverage, 15824,
     /*  95004 */     GIR_EraseRootFromParent_Done,
     /*  95005 */   // Label 1476: @95005
     /*  95005 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95123), // Rule ID 11964 //
     /*  95010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95061 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95065 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95069 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95073 */     // MIs[4] Op3
     /*  95073 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95082 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95090 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95094 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95102 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95104 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95121 */     GIR_RootConstrainSelectedInstOperands,
     /*  95122 */     // GIR_Coverage, 11964,
     /*  95122 */     GIR_EraseRootFromParent_Done,
     /*  95123 */   // Label 1477: @95123
     /*  95123 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95241), // Rule ID 15823 //
     /*  95128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95175 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95179 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95183 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95187 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95191 */     // MIs[4] Op3
     /*  95191 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95200 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95208 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95212 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95220 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95222 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95239 */     GIR_RootConstrainSelectedInstOperands,
     /*  95240 */     // GIR_Coverage, 15823,
     /*  95240 */     GIR_EraseRootFromParent_Done,
     /*  95241 */   // Label 1478: @95241
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95312), // Rule ID 15696 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95285 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95295 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95310 */     GIR_RootConstrainSelectedInstOperands,
     /*  95311 */     // GIR_Coverage, 15696,
     /*  95311 */     GIR_EraseRootFromParent_Done,
     /*  95312 */   // Label 1479: @95312
     /*  95312 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95383), // Rule ID 15695 //
     /*  95317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95356 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95366 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95381 */     GIR_RootConstrainSelectedInstOperands,
     /*  95382 */     // GIR_Coverage, 15695,
     /*  95382 */     GIR_EraseRootFromParent_Done,
     /*  95383 */   // Label 1480: @95383
     /*  95383 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95454), // Rule ID 15694 //
     /*  95388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95437 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95452 */     GIR_RootConstrainSelectedInstOperands,
     /*  95453 */     // GIR_Coverage, 15694,
     /*  95453 */     GIR_EraseRootFromParent_Done,
     /*  95454 */   // Label 1481: @95454
     /*  95454 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95525), // Rule ID 11928 //
     /*  95459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95498 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95508 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95523 */     GIR_RootConstrainSelectedInstOperands,
     /*  95524 */     // GIR_Coverage, 11928,
     /*  95524 */     GIR_EraseRootFromParent_Done,
     /*  95525 */   // Label 1482: @95525
     /*  95525 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95586), // Rule ID 11963 //
     /*  95530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  95553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95557 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95567 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95584 */     GIR_RootConstrainSelectedInstOperands,
     /*  95585 */     // GIR_Coverage, 11963,
     /*  95585 */     GIR_EraseRootFromParent_Done,
     /*  95586 */   // Label 1483: @95586
     /*  95586 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95629), // Rule ID 13800 //
     /*  95591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95612 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95627 */     GIR_RootConstrainSelectedInstOperands,
     /*  95628 */     // GIR_Coverage, 13800,
     /*  95628 */     GIR_EraseRootFromParent_Done,
     /*  95629 */   // Label 1484: @95629
     /*  95629 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95672), // Rule ID 3143 //
     /*  95634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95655 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95670 */     GIR_RootConstrainSelectedInstOperands,
     /*  95671 */     // GIR_Coverage, 3143,
     /*  95671 */     GIR_EraseRootFromParent_Done,
     /*  95672 */   // Label 1485: @95672
     /*  95672 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95687), // Rule ID 7507 //
     /*  95677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95680 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  95680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95685 */     GIR_RootConstrainSelectedInstOperands,
     /*  95686 */     // GIR_Coverage, 7507,
     /*  95686 */     GIR_Done,
     /*  95687 */   // Label 1486: @95687
     /*  95687 */   GIM_Reject,
     /*  95688 */ // Label 1470: @95688
     /*  95688 */ GIM_Reject,
     /*  95689 */ // Label 1337: @95689
     /*  95689 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95738), // Rule ID 8486 //
     /*  95694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  95700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  95703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95707 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  95707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  95714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95736 */   GIR_RootConstrainSelectedInstOperands,
     /*  95737 */   // GIR_Coverage, 8486,
     /*  95737 */   GIR_EraseRootFromParent_Done,
     /*  95738 */ // Label 1487: @95738
     /*  95738 */ GIM_Reject,
     /*  95739 */ // Label 1338: @95739
     /*  95739 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(97145),
     /*  95744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(95872), // Rule ID 15821 //
     /*  95759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95814 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95830 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95834 */     // MIs[5] Op3
     /*  95834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95853 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95870 */     GIR_RootConstrainSelectedInstOperands,
     /*  95871 */     // GIR_Coverage, 15821,
     /*  95871 */     GIR_EraseRootFromParent_Done,
     /*  95872 */   // Label 1489: @95872
     /*  95872 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(95990), // Rule ID 15820 //
     /*  95877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95932 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95948 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95952 */     // MIs[5] Op3
     /*  95952 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95961 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95971 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  95980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95988 */     GIR_RootConstrainSelectedInstOperands,
     /*  95989 */     // GIR_Coverage, 15820,
     /*  95989 */     GIR_EraseRootFromParent_Done,
     /*  95990 */   // Label 1490: @95990
     /*  95990 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96108), // Rule ID 15819 //
     /*  95995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96070 */     // MIs[5] Op3
     /*  96070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96079 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96089 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96106 */     GIR_RootConstrainSelectedInstOperands,
     /*  96107 */     // GIR_Coverage, 15819,
     /*  96107 */     GIR_EraseRootFromParent_Done,
     /*  96108 */   // Label 1491: @96108
     /*  96108 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96226), // Rule ID 15818 //
     /*  96113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96176 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96180 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96184 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96188 */     // MIs[5] Op3
     /*  96188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96207 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96224 */     GIR_RootConstrainSelectedInstOperands,
     /*  96225 */     // GIR_Coverage, 15818,
     /*  96225 */     GIR_EraseRootFromParent_Done,
     /*  96226 */   // Label 1492: @96226
     /*  96226 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96344), // Rule ID 15815 //
     /*  96231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96290 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96294 */     // MIs[4] Op3
     /*  96294 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96299 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96303 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96309 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96325 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96342 */     GIR_RootConstrainSelectedInstOperands,
     /*  96343 */     // GIR_Coverage, 15815,
     /*  96343 */     GIR_EraseRootFromParent_Done,
     /*  96344 */   // Label 1493: @96344
     /*  96344 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96462), // Rule ID 15817 //
     /*  96349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96408 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96412 */     // MIs[4] Op3
     /*  96412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96421 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96429 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96433 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96443 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96460 */     GIR_RootConstrainSelectedInstOperands,
     /*  96461 */     // GIR_Coverage, 15817,
     /*  96461 */     GIR_EraseRootFromParent_Done,
     /*  96462 */   // Label 1494: @96462
     /*  96462 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96580), // Rule ID 11962 //
     /*  96467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96530 */     // MIs[4] Op3
     /*  96530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96539 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96561 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96578 */     GIR_RootConstrainSelectedInstOperands,
     /*  96579 */     // GIR_Coverage, 11962,
     /*  96579 */     GIR_EraseRootFromParent_Done,
     /*  96580 */   // Label 1495: @96580
     /*  96580 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96698), // Rule ID 15816 //
     /*  96585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96644 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96648 */     // MIs[4] Op3
     /*  96648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96653 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96657 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96665 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96669 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96679 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96696 */     GIR_RootConstrainSelectedInstOperands,
     /*  96697 */     // GIR_Coverage, 15816,
     /*  96697 */     GIR_EraseRootFromParent_Done,
     /*  96698 */   // Label 1496: @96698
     /*  96698 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96769), // Rule ID 15693 //
     /*  96703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96752 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96767 */     GIR_RootConstrainSelectedInstOperands,
     /*  96768 */     // GIR_Coverage, 15693,
     /*  96768 */     GIR_EraseRootFromParent_Done,
     /*  96769 */   // Label 1497: @96769
     /*  96769 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(96840), // Rule ID 15692 //
     /*  96774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96813 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96823 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96838 */     GIR_RootConstrainSelectedInstOperands,
     /*  96839 */     // GIR_Coverage, 15692,
     /*  96839 */     GIR_EraseRootFromParent_Done,
     /*  96840 */   // Label 1498: @96840
     /*  96840 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(96911), // Rule ID 15691 //
     /*  96845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96894 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96909 */     GIR_RootConstrainSelectedInstOperands,
     /*  96910 */     // GIR_Coverage, 15691,
     /*  96910 */     GIR_EraseRootFromParent_Done,
     /*  96911 */   // Label 1499: @96911
     /*  96911 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(96982), // Rule ID 11926 //
     /*  96916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96955 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96965 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96980 */     GIR_RootConstrainSelectedInstOperands,
     /*  96981 */     // GIR_Coverage, 11926,
     /*  96981 */     GIR_EraseRootFromParent_Done,
     /*  96982 */   // Label 1500: @96982
     /*  96982 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97043), // Rule ID 11961 //
     /*  96987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  96998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97006 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  97010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97024 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97041 */     GIR_RootConstrainSelectedInstOperands,
     /*  97042 */     // GIR_Coverage, 11961,
     /*  97042 */     GIR_EraseRootFromParent_Done,
     /*  97043 */   // Label 1501: @97043
     /*  97043 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97086), // Rule ID 13799 //
     /*  97048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97069 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97084 */     GIR_RootConstrainSelectedInstOperands,
     /*  97085 */     // GIR_Coverage, 13799,
     /*  97085 */     GIR_EraseRootFromParent_Done,
     /*  97086 */   // Label 1502: @97086
     /*  97086 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97129), // Rule ID 3141 //
     /*  97091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97112 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97127 */     GIR_RootConstrainSelectedInstOperands,
     /*  97128 */     // GIR_Coverage, 3141,
     /*  97128 */     GIR_EraseRootFromParent_Done,
     /*  97129 */   // Label 1503: @97129
     /*  97129 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97144), // Rule ID 7506 //
     /*  97134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97137 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  97137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97142 */     GIR_RootConstrainSelectedInstOperands,
     /*  97143 */     // GIR_Coverage, 7506,
     /*  97143 */     GIR_Done,
     /*  97144 */   // Label 1504: @97144
     /*  97144 */   GIM_Reject,
     /*  97145 */ // Label 1488: @97145
     /*  97145 */ GIM_Reject,
     /*  97146 */ // Label 1339: @97146
     /*  97146 */ GIM_Reject,
     /*  97147 */ // Label 8: @97147
     /*  97147 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(104670),
     /*  97152 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  97155 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1517*/ GIMT_Encode4(104669),
     /*  97166 */   /*GILLT_v2s64*//*Label 1506*/ GIMT_Encode4(97234), GIMT_Encode4(0),
     /*  97174 */   /*GILLT_v4s32*//*Label 1507*/ GIMT_Encode4(97755), GIMT_Encode4(0),
     /*  97182 */   /*GILLT_v8s16*//*Label 1508*/ GIMT_Encode4(100167),
     /*  97186 */   /*GILLT_v16s8*//*Label 1509*/ GIMT_Encode4(102576), GIMT_Encode4(0),
     /*  97194 */   /*GILLT_nxv2s1*//*Label 1510*/ GIMT_Encode4(104487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  97210 */   /*GILLT_nxv4s1*//*Label 1511*/ GIMT_Encode4(104513),
     /*  97214 */   /*GILLT_nxv4s16*//*Label 1512*/ GIMT_Encode4(104539),
     /*  97218 */   /*GILLT_nxv4s32*//*Label 1513*/ GIMT_Encode4(104565),
     /*  97222 */   /*GILLT_nxv8s1*//*Label 1514*/ GIMT_Encode4(104591),
     /*  97226 */   /*GILLT_nxv8s16*//*Label 1515*/ GIMT_Encode4(104617),
     /*  97230 */   /*GILLT_nxv16s1*//*Label 1516*/ GIMT_Encode4(104643),
     /*  97234 */   // Label 1506: @97234
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97754),
     /*  97239 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  97245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97253 */     GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97315), // Rule ID 5818 //
     /*  97258 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97262 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97268 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97272 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  97272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97284 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97314 */       // GIR_Coverage, 5818,
     /*  97314 */       GIR_EraseRootFromParent_Done,
     /*  97315 */     // Label 1519: @97315
     /*  97315 */     GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97377), // Rule ID 5822 //
     /*  97320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97324 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97330 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97334 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  97334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97346 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97357 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97360 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97363 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97376 */       // GIR_Coverage, 5822,
     /*  97376 */       GIR_EraseRootFromParent_Done,
     /*  97377 */     // Label 1520: @97377
     /*  97377 */     GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97435), // Rule ID 5819 //
     /*  97382 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97386 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97390 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97392 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  97392 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97395 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97399 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97406 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97409 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97411 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97414 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97416 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97419 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97424 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97429 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97434 */       // GIR_Coverage, 5819,
     /*  97434 */       GIR_EraseRootFromParent_Done,
     /*  97435 */     // Label 1521: @97435
     /*  97435 */     GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97493), // Rule ID 5823 //
     /*  97440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97448 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97450 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  97450 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97453 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97457 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97462 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97469 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97472 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97487 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97492 */       // GIR_Coverage, 5823,
     /*  97492 */       GIR_EraseRootFromParent_Done,
     /*  97493 */     // Label 1522: @97493
     /*  97493 */     GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97623), // Rule ID 5817 //
     /*  97498 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97502 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97502 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97505 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97509 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97516 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97519 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97523 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97528 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97531 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97535 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97538 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97543 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97548 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97553 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97556 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97560 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97565 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97579 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97582 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97586 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97599 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97604 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97607 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97615 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97618 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97621 */       GIR_RootConstrainSelectedInstOperands,
     /*  97622 */       // GIR_Coverage, 5817,
     /*  97622 */       GIR_EraseRootFromParent_Done,
     /*  97623 */     // Label 1523: @97623
     /*  97623 */     GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97753), // Rule ID 5821 //
     /*  97628 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97632 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97632 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97635 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97639 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97644 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97646 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97649 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97653 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97658 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97661 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97665 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97668 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97673 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97678 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97683 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97686 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97690 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97695 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97697 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97700 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97704 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97709 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97712 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97716 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97719 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97724 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97739 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97742 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97745 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97751 */       GIR_RootConstrainSelectedInstOperands,
     /*  97752 */       // GIR_Coverage, 5821,
     /*  97752 */       GIR_EraseRootFromParent_Done,
     /*  97753 */     // Label 1524: @97753
     /*  97753 */     GIM_Reject,
     /*  97754 */   // Label 1518: @97754
     /*  97754 */   GIM_Reject,
     /*  97755 */   // Label 1507: @97755
     /*  97755 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(100166),
     /*  97760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  97766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97770 */     GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97899), // Rule ID 5443 //
     /*  97775 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97787 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97791 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97795 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97799 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97803 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97807 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97811 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97815 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97819 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97824 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97828 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97834 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97836 */       // MIs[2] Operand 2
     /*  97836 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97847 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  97849 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  97849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97861 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97864 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97868 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97876 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  97884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97886 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97889 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  97893 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  97897 */       GIR_RootConstrainSelectedInstOperands,
     /*  97898 */       // GIR_Coverage, 5443,
     /*  97898 */       GIR_EraseRootFromParent_Done,
     /*  97899 */     // Label 1526: @97899
     /*  97899 */     GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98021), // Rule ID 5439 //
     /*  97904 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97908 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97912 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97916 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97920 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97924 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97928 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97932 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97936 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  97940 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97944 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97948 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97953 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97958 */       // MIs[2] Operand 2
     /*  97958 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97969 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97971 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  97971 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97974 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97978 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97983 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97986 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97990 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97993 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97998 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98003 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98006 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98008 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98011 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98015 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98019 */       GIR_RootConstrainSelectedInstOperands,
     /*  98020 */       // GIR_Coverage, 5439,
     /*  98020 */       GIR_EraseRootFromParent_Done,
     /*  98021 */     // Label 1527: @98021
     /*  98021 */     GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98143), // Rule ID 5441 //
     /*  98026 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98030 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98034 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98038 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98042 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98046 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98050 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98054 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  98058 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  98062 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98066 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98070 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98075 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98080 */       // MIs[2] Operand 2
     /*  98080 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98091 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98093 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98105 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  98108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  98128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98141 */       GIR_RootConstrainSelectedInstOperands,
     /*  98142 */       // GIR_Coverage, 5441,
     /*  98142 */       GIR_EraseRootFromParent_Done,
     /*  98143 */     // Label 1528: @98143
     /*  98143 */     GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98245), // Rule ID 5589 //
     /*  98148 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98152 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98156 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98160 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98164 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98168 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98172 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98177 */       // MIs[2] Operand 2
     /*  98177 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98188 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  98192 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98196 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98200 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98204 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98208 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98212 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98217 */       // MIs[4] Operand 2
     /*  98217 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  98228 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  98230 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  98230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  98233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98235 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  98239 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  98243 */       GIR_RootConstrainSelectedInstOperands,
     /*  98244 */       // GIR_Coverage, 5589,
     /*  98244 */       GIR_EraseRootFromParent_Done,
     /*  98245 */     // Label 1529: @98245
     /*  98245 */     GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98374), // Rule ID 6373 //
     /*  98250 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98262 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98265 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98270 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98274 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98278 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98283 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  98287 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98289 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  98289 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  98292 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  98296 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98301 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98318 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98320 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98323 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98327 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98332 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98335 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  98339 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98342 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  98360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98365 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  98369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98372 */       GIR_RootConstrainSelectedInstOperands,
     /*  98373 */       // GIR_Coverage, 6373,
     /*  98373 */       GIR_EraseRootFromParent_Done,
     /*  98374 */     // Label 1530: @98374
     /*  98374 */     GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98416), // Rule ID 5828 //
     /*  98379 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98393 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  98393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98403 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98406 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98411 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98414 */       GIR_RootConstrainSelectedInstOperands,
     /*  98415 */       // GIR_Coverage, 5828,
     /*  98415 */       GIR_EraseRootFromParent_Done,
     /*  98416 */     // Label 1531: @98416
     /*  98416 */     GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98458), // Rule ID 5832 //
     /*  98421 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98435 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  98435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98440 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98445 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98448 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98456 */       GIR_RootConstrainSelectedInstOperands,
     /*  98457 */       // GIR_Coverage, 5832,
     /*  98457 */       GIR_EraseRootFromParent_Done,
     /*  98458 */     // Label 1532: @98458
     /*  98458 */     GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98581), // Rule ID 2571 //
     /*  98463 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98466 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98470 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98474 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98478 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98481 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98486 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98490 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98499 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98503 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98507 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98511 */       // MIs[2] Operand 1
     /*  98511 */       // No operand predicates
     /*  98511 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98513 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98513 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98516 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98520 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98539 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98542 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98546 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98549 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  98567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98569 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98572 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98576 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  98579 */       GIR_RootConstrainSelectedInstOperands,
     /*  98580 */       // GIR_Coverage, 2571,
     /*  98580 */       GIR_EraseRootFromParent_Done,
     /*  98581 */     // Label 1533: @98581
     /*  98581 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98704), // Rule ID 6343 //
     /*  98586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  98613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98617 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98622 */       // MIs[2] imm
     /*  98622 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98626 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98630 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98634 */       // MIs[3] Operand 1
     /*  98634 */       // No operand predicates
     /*  98634 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98636 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98636 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98639 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98643 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98662 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98669 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98692 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98702 */       GIR_RootConstrainSelectedInstOperands,
     /*  98703 */       // GIR_Coverage, 6343,
     /*  98703 */       GIR_EraseRootFromParent_Done,
     /*  98704 */     // Label 1534: @98704
     /*  98704 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98824), // Rule ID 6379 //
     /*  98709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98721 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98725 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98729 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98733 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98737 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98742 */       // MIs[2] imm
     /*  98742 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98746 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98750 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98754 */       // MIs[3] Operand 1
     /*  98754 */       // No operand predicates
     /*  98754 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98756 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  98756 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98759 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98763 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98770 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98773 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98777 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98782 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98785 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98789 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98802 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98807 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98810 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98812 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98819 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98822 */       GIR_RootConstrainSelectedInstOperands,
     /*  98823 */       // GIR_Coverage, 6379,
     /*  98823 */       GIR_EraseRootFromParent_Done,
     /*  98824 */     // Label 1535: @98824
     /*  98824 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98941), // Rule ID 2494 //
     /*  98829 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98832 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98836 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98840 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98844 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98847 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  98852 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98856 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98860 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98865 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98875 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98886 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98889 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98893 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98898 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98901 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98905 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98908 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98928 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98931 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98935 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  98939 */       GIR_RootConstrainSelectedInstOperands,
     /*  98940 */       // GIR_Coverage, 2494,
     /*  98940 */       GIR_EraseRootFromParent_Done,
     /*  98941 */     // Label 1536: @98941
     /*  98941 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99058), // Rule ID 5359 //
     /*  98946 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98949 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98961 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98964 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  98969 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98973 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98977 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98987 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98989 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98989 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98992 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98996 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99001 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99015 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99022 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99048 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99056 */       GIR_RootConstrainSelectedInstOperands,
     /*  99057 */       // GIR_Coverage, 5359,
     /*  99057 */       GIR_EraseRootFromParent_Done,
     /*  99058 */     // Label 1537: @99058
     /*  99058 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99175), // Rule ID 5362 //
     /*  99063 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99066 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99070 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99074 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99078 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99081 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  99086 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99090 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99094 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99104 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99106 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99106 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99109 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99113 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99132 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99135 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99139 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99165 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99173 */       GIR_RootConstrainSelectedInstOperands,
     /*  99174 */       // GIR_Coverage, 5362,
     /*  99174 */       GIR_EraseRootFromParent_Done,
     /*  99175 */     // Label 1538: @99175
     /*  99175 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99292), // Rule ID 5365 //
     /*  99180 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99183 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99187 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99191 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99195 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99198 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  99203 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99207 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99211 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99216 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99221 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99223 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99223 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99226 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99230 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99237 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99240 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99244 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99249 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99256 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99259 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  99277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99279 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99282 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99290 */       GIR_RootConstrainSelectedInstOperands,
     /*  99291 */       // GIR_Coverage, 5365,
     /*  99291 */       GIR_EraseRootFromParent_Done,
     /*  99292 */     // Label 1539: @99292
     /*  99292 */     GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99396), // Rule ID 2490 //
     /*  99297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  99315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  99320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99331 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  99385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99394 */       GIR_RootConstrainSelectedInstOperands,
     /*  99395 */       // GIR_Coverage, 2490,
     /*  99395 */       GIR_EraseRootFromParent_Done,
     /*  99396 */     // Label 1540: @99396
     /*  99396 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99452), // Rule ID 5522 //
     /*  99401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  99422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99437 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  99440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  99446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  99450 */       GIR_RootConstrainSelectedInstOperands,
     /*  99451 */       // GIR_Coverage, 5522,
     /*  99451 */       GIR_EraseRootFromParent_Done,
     /*  99452 */     // Label 1541: @99452
     /*  99452 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99518), // Rule ID 5826 //
     /*  99457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99475 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  99475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99517 */       // GIR_Coverage, 5826,
     /*  99517 */       GIR_EraseRootFromParent_Done,
     /*  99518 */     // Label 1542: @99518
     /*  99518 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99584), // Rule ID 5830 //
     /*  99523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99541 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  99541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99583 */       // GIR_Coverage, 5830,
     /*  99583 */       GIR_EraseRootFromParent_Done,
     /*  99584 */     // Label 1543: @99584
     /*  99584 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99677), // Rule ID 4947 //
     /*  99589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  99601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99612 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  99666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99675 */       GIR_RootConstrainSelectedInstOperands,
     /*  99676 */       // GIR_Coverage, 4947,
     /*  99676 */       GIR_EraseRootFromParent_Done,
     /*  99677 */     // Label 1544: @99677
     /*  99677 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99773), // Rule ID 4994 //
     /*  99682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99708 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  99708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  99762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99771 */       GIR_RootConstrainSelectedInstOperands,
     /*  99772 */       // GIR_Coverage, 4994,
     /*  99772 */       GIR_EraseRootFromParent_Done,
     /*  99773 */     // Label 1545: @99773
     /*  99773 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99835), // Rule ID 5827 //
     /*  99778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99792 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  99792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99834 */       // GIR_Coverage, 5827,
     /*  99834 */       GIR_EraseRootFromParent_Done,
     /*  99835 */     // Label 1546: @99835
     /*  99835 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99897), // Rule ID 5831 //
     /*  99840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99854 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  99854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99896 */       // GIR_Coverage, 5831,
     /*  99896 */       GIR_EraseRootFromParent_Done,
     /*  99897 */     // Label 1547: @99897
     /*  99897 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100031), // Rule ID 5825 //
     /*  99902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99910 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100029 */       GIR_RootConstrainSelectedInstOperands,
     /* 100030 */       // GIR_Coverage, 5825,
     /* 100030 */       GIR_EraseRootFromParent_Done,
     /* 100031 */     // Label 1548: @100031
     /* 100031 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100165), // Rule ID 5829 //
     /* 100036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 100044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 100047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 100061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 100073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 100077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 100080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100163 */       GIR_RootConstrainSelectedInstOperands,
     /* 100164 */       // GIR_Coverage, 5829,
     /* 100164 */       GIR_EraseRootFromParent_Done,
     /* 100165 */     // Label 1549: @100165
     /* 100165 */     GIM_Reject,
     /* 100166 */   // Label 1525: @100166
     /* 100166 */   GIM_Reject,
     /* 100167 */   // Label 1508: @100167
     /* 100167 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(102575),
     /* 100172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 100178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100182 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100311), // Rule ID 5437 //
     /* 100187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 100223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 100240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 100248 */       // MIs[2] Operand 2
     /* 100248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100261 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 100261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100309 */       GIR_RootConstrainSelectedInstOperands,
     /* 100310 */       // GIR_Coverage, 5437,
     /* 100310 */       GIR_EraseRootFromParent_Done,
     /* 100311 */     // Label 1551: @100311
     /* 100311 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100433), // Rule ID 5433 //
     /* 100316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 100352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100370 */       // MIs[2] Operand 2
     /* 100370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100383 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 100418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100431 */       GIR_RootConstrainSelectedInstOperands,
     /* 100432 */       // GIR_Coverage, 5433,
     /* 100432 */       GIR_EraseRootFromParent_Done,
     /* 100433 */     // Label 1552: @100433
     /* 100433 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100555), // Rule ID 5435 //
     /* 100438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 100474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100492 */       // MIs[2] Operand 2
     /* 100492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100505 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100553 */       GIR_RootConstrainSelectedInstOperands,
     /* 100554 */       // GIR_Coverage, 5435,
     /* 100554 */       GIR_EraseRootFromParent_Done,
     /* 100555 */     // Label 1553: @100555
     /* 100555 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100657), // Rule ID 5588 //
     /* 100560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100589 */       // MIs[2] Operand 2
     /* 100589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 100604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 100616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100629 */       // MIs[4] Operand 2
     /* 100629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 100640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100642 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 100642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 100645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 100651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 100655 */       GIR_RootConstrainSelectedInstOperands,
     /* 100656 */       // GIR_Coverage, 5588,
     /* 100656 */       GIR_EraseRootFromParent_Done,
     /* 100657 */     // Label 1554: @100657
     /* 100657 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100786), // Rule ID 6372 //
     /* 100662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 100699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100701 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 100701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 100708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 100751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 100772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 100781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100784 */       GIR_RootConstrainSelectedInstOperands,
     /* 100785 */       // GIR_Coverage, 6372,
     /* 100785 */       GIR_EraseRootFromParent_Done,
     /* 100786 */     // Label 1555: @100786
     /* 100786 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100828), // Rule ID 5836 //
     /* 100791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100805 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 100805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100826 */       GIR_RootConstrainSelectedInstOperands,
     /* 100827 */       // GIR_Coverage, 5836,
     /* 100827 */       GIR_EraseRootFromParent_Done,
     /* 100828 */     // Label 1556: @100828
     /* 100828 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100870), // Rule ID 5840 //
     /* 100833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100847 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 100847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100857 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100860 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100865 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100868 */       GIR_RootConstrainSelectedInstOperands,
     /* 100869 */       // GIR_Coverage, 5840,
     /* 100869 */       GIR_EraseRootFromParent_Done,
     /* 100870 */     // Label 1557: @100870
     /* 100870 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100993), // Rule ID 2569 //
     /* 100875 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100878 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100882 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100886 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100890 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100893 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100898 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100902 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100906 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100911 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 100915 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100919 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 100923 */       // MIs[2] Operand 1
     /* 100923 */       // No operand predicates
     /* 100923 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100925 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100925 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100928 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100932 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100937 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100939 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100942 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100946 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100951 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100954 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100958 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100971 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 100979 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100988 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100991 */       GIR_RootConstrainSelectedInstOperands,
     /* 100992 */       // GIR_Coverage, 2569,
     /* 100992 */       GIR_EraseRootFromParent_Done,
     /* 100993 */     // Label 1558: @100993
     /* 100993 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101116), // Rule ID 6342 //
     /* 100998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101001 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101005 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101009 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101013 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101017 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101021 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 101025 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101029 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101034 */       // MIs[2] imm
     /* 101034 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101038 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101042 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101046 */       // MIs[3] Operand 1
     /* 101046 */       // No operand predicates
     /* 101046 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101048 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101048 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101051 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101055 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101060 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101062 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101065 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101069 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101074 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101081 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101111 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101114 */       GIR_RootConstrainSelectedInstOperands,
     /* 101115 */       // GIR_Coverage, 6342,
     /* 101115 */       GIR_EraseRootFromParent_Done,
     /* 101116 */     // Label 1559: @101116
     /* 101116 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101236), // Rule ID 6378 //
     /* 101121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101125 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101129 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101133 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101137 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101141 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101145 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101149 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101154 */       // MIs[2] imm
     /* 101154 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101158 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101162 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101166 */       // MIs[3] Operand 1
     /* 101166 */       // No operand predicates
     /* 101166 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101168 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101168 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101171 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101175 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101180 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101182 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101185 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101189 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101194 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101197 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101201 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101224 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101231 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101234 */       GIR_RootConstrainSelectedInstOperands,
     /* 101235 */       // GIR_Coverage, 6378,
     /* 101235 */       GIR_EraseRootFromParent_Done,
     /* 101236 */     // Label 1560: @101236
     /* 101236 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101353), // Rule ID 2493 //
     /* 101241 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101244 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101248 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101252 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101256 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101259 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 101264 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101268 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101272 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101282 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101284 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101284 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101287 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101291 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101296 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101298 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101301 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101305 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101313 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101317 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101330 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101335 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101338 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101340 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101343 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101347 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101351 */       GIR_RootConstrainSelectedInstOperands,
     /* 101352 */       // GIR_Coverage, 2493,
     /* 101352 */       GIR_EraseRootFromParent_Done,
     /* 101353 */     // Label 1561: @101353
     /* 101353 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101470), // Rule ID 5358 //
     /* 101358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101361 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101365 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101369 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101373 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101376 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 101381 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101385 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101389 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101394 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101399 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101401 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101401 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101404 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101408 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101413 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101427 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101434 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101468 */       GIR_RootConstrainSelectedInstOperands,
     /* 101469 */       // GIR_Coverage, 5358,
     /* 101469 */       GIR_EraseRootFromParent_Done,
     /* 101470 */     // Label 1562: @101470
     /* 101470 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101587), // Rule ID 5361 //
     /* 101475 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101490 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101493 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 101498 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101502 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101506 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101516 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101518 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101518 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101521 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101525 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101544 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101551 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 101572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101577 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101581 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101585 */       GIR_RootConstrainSelectedInstOperands,
     /* 101586 */       // GIR_Coverage, 5361,
     /* 101586 */       GIR_EraseRootFromParent_Done,
     /* 101587 */     // Label 1563: @101587
     /* 101587 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101704), // Rule ID 5364 //
     /* 101592 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101595 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101599 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101603 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101607 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101610 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 101615 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101619 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101623 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101628 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101633 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101635 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101635 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101638 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101642 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101649 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101652 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101656 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101661 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101664 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101668 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101671 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101686 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 101689 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101691 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101694 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101702 */       GIR_RootConstrainSelectedInstOperands,
     /* 101703 */       // GIR_Coverage, 5364,
     /* 101703 */       GIR_EraseRootFromParent_Done,
     /* 101704 */     // Label 1564: @101704
     /* 101704 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101805), // Rule ID 4941 //
     /* 101709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101721 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 101724 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 101729 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101733 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101738 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101740 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 101740 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101743 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101747 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101752 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101766 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101773 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101786 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101791 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 101794 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101796 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101799 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101803 */       GIR_RootConstrainSelectedInstOperands,
     /* 101804 */       // GIR_Coverage, 4941,
     /* 101804 */       GIR_EraseRootFromParent_Done,
     /* 101805 */     // Label 1565: @101805
     /* 101805 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101861), // Rule ID 5513 //
     /* 101810 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101814 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101818 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101822 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101827 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 101831 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101835 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101839 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101844 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 101846 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 101846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 101849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101851 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 101855 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 101859 */       GIR_RootConstrainSelectedInstOperands,
     /* 101860 */       // GIR_Coverage, 5513,
     /* 101860 */       GIR_EraseRootFromParent_Done,
     /* 101861 */     // Label 1566: @101861
     /* 101861 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101927), // Rule ID 5834 //
     /* 101866 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101870 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101874 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101880 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101882 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101884 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 101884 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101887 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101891 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101907 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101910 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101913 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101916 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101926 */       // GIR_Coverage, 5834,
     /* 101926 */       GIR_EraseRootFromParent_Done,
     /* 101927 */     // Label 1567: @101927
     /* 101927 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101993), // Rule ID 5838 //
     /* 101932 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101936 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101940 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101946 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101948 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101950 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 101950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101962 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101966 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101973 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101979 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101992 */       // GIR_Coverage, 5838,
     /* 101992 */       GIR_EraseRootFromParent_Done,
     /* 101993 */     // Label 1568: @101993
     /* 101993 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102086), // Rule ID 4949 //
     /* 101998 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102002 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102006 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 102010 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102014 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102021 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 102021 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102024 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102028 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102033 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102035 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102038 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102042 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102047 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102054 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102057 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102062 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102067 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 102075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102077 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102080 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102084 */       GIR_RootConstrainSelectedInstOperands,
     /* 102085 */       // GIR_Coverage, 4949,
     /* 102085 */       GIR_EraseRootFromParent_Done,
     /* 102086 */     // Label 1569: @102086
     /* 102086 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102182), // Rule ID 4993 //
     /* 102091 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102094 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102098 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102102 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102106 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102110 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102115 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102117 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 102117 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102120 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102124 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102129 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102131 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102134 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102138 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102143 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102150 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102153 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 102171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102176 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102180 */       GIR_RootConstrainSelectedInstOperands,
     /* 102181 */       // GIR_Coverage, 4993,
     /* 102181 */       GIR_EraseRootFromParent_Done,
     /* 102182 */     // Label 1570: @102182
     /* 102182 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102244), // Rule ID 5835 //
     /* 102187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102199 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102201 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 102201 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102204 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102208 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102223 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102225 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102243 */       // GIR_Coverage, 5835,
     /* 102243 */       GIR_EraseRootFromParent_Done,
     /* 102244 */     // Label 1571: @102244
     /* 102244 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102306), // Rule ID 5839 //
     /* 102249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102253 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102257 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102261 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102263 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 102263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102275 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102285 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102287 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102290 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102295 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102300 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */       // GIR_Coverage, 5839,
     /* 102305 */       GIR_EraseRootFromParent_Done,
     /* 102306 */     // Label 1572: @102306
     /* 102306 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102440), // Rule ID 5833 //
     /* 102311 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102315 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102319 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102319 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102322 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102326 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102331 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102333 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102336 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102340 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102345 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102348 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102352 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102355 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102360 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102365 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102370 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102373 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102377 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102384 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102387 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102391 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102396 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102399 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102403 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102426 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102429 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102438 */       GIR_RootConstrainSelectedInstOperands,
     /* 102439 */       // GIR_Coverage, 5833,
     /* 102439 */       GIR_EraseRootFromParent_Done,
     /* 102440 */     // Label 1573: @102440
     /* 102440 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102574), // Rule ID 5837 //
     /* 102445 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102449 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102453 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102453 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102456 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102460 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102467 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102470 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102474 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102479 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102482 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102486 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102489 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102494 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102499 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102504 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102507 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102511 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102518 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102521 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102525 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102530 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102533 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102537 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102550 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102563 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102566 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102569 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102572 */       GIR_RootConstrainSelectedInstOperands,
     /* 102573 */       // GIR_Coverage, 5837,
     /* 102573 */       GIR_EraseRootFromParent_Done,
     /* 102574 */     // Label 1574: @102574
     /* 102574 */     GIM_Reject,
     /* 102575 */   // Label 1550: @102575
     /* 102575 */   GIM_Reject,
     /* 102576 */   // Label 1509: @102576
     /* 102576 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(104486),
     /* 102581 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102591 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102720), // Rule ID 5431 //
     /* 102596 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102600 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102604 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102608 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102612 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102616 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102620 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102624 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102628 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 102632 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102636 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102640 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102645 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 102649 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 102655 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 102657 */       // MIs[2] Operand 2
     /* 102657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102668 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102670 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 102670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102689 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102718 */       GIR_RootConstrainSelectedInstOperands,
     /* 102719 */       // GIR_Coverage, 5431,
     /* 102719 */       GIR_EraseRootFromParent_Done,
     /* 102720 */     // Label 1576: @102720
     /* 102720 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102842), // Rule ID 5427 //
     /* 102725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102737 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102741 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102745 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102749 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102753 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102757 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 102761 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102765 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102769 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102774 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102779 */       // MIs[2] Operand 2
     /* 102779 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102790 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102792 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102804 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102807 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102811 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 102827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102832 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102836 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102840 */       GIR_RootConstrainSelectedInstOperands,
     /* 102841 */       // GIR_Coverage, 5427,
     /* 102841 */       GIR_EraseRootFromParent_Done,
     /* 102842 */     // Label 1577: @102842
     /* 102842 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102964), // Rule ID 5429 //
     /* 102847 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 102883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102896 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102901 */       // MIs[2] Operand 2
     /* 102901 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102912 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102914 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102914 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102917 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102921 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102926 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102929 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102933 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102962 */       GIR_RootConstrainSelectedInstOperands,
     /* 102963 */       // GIR_Coverage, 5429,
     /* 102963 */       GIR_EraseRootFromParent_Done,
     /* 102964 */     // Label 1578: @102964
     /* 102964 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103066), // Rule ID 5587 //
     /* 102969 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102973 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102977 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102981 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102985 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102989 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102993 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102998 */       // MIs[2] Operand 2
     /* 102998 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 103009 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 103013 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103017 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103021 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 103025 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103029 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103033 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103038 */       // MIs[4] Operand 2
     /* 103038 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 103049 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 103051 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 103051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 103054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103056 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 103060 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 103064 */       GIR_RootConstrainSelectedInstOperands,
     /* 103065 */       // GIR_Coverage, 5587,
     /* 103065 */       GIR_EraseRootFromParent_Done,
     /* 103066 */     // Label 1579: @103066
     /* 103066 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103195), // Rule ID 6371 //
     /* 103071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103075 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103079 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103083 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103086 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103091 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103104 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 103108 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103110 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 103110 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 103113 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 103117 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103127 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103130 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103134 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103141 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103144 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103148 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 103160 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103183 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103190 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103193 */       GIR_RootConstrainSelectedInstOperands,
     /* 103194 */       // GIR_Coverage, 6371,
     /* 103194 */       GIR_EraseRootFromParent_Done,
     /* 103195 */     // Label 1580: @103195
     /* 103195 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103237), // Rule ID 5844 //
     /* 103200 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103207 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103214 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 103214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103219 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 103224 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103232 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103235 */       GIR_RootConstrainSelectedInstOperands,
     /* 103236 */       // GIR_Coverage, 5844,
     /* 103236 */       GIR_EraseRootFromParent_Done,
     /* 103237 */     // Label 1581: @103237
     /* 103237 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103360), // Rule ID 2567 //
     /* 103242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103245 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103249 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103253 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103257 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103260 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103265 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103269 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103273 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103278 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 103282 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103286 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103290 */       // MIs[2] Operand 1
     /* 103290 */       // No operand predicates
     /* 103290 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103292 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103292 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103295 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103299 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103306 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103309 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103313 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103318 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103321 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103325 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 103346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103348 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103351 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103355 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 103358 */       GIR_RootConstrainSelectedInstOperands,
     /* 103359 */       // GIR_Coverage, 2567,
     /* 103359 */       GIR_EraseRootFromParent_Done,
     /* 103360 */     // Label 1582: @103360
     /* 103360 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103483), // Rule ID 6341 //
     /* 103365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103372 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103376 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103380 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103384 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103388 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 103392 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103396 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       // MIs[2] imm
     /* 103401 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103405 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103409 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103413 */       // MIs[3] Operand 1
     /* 103413 */       // No operand predicates
     /* 103413 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103415 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103474 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103478 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103481 */       GIR_RootConstrainSelectedInstOperands,
     /* 103482 */       // GIR_Coverage, 6341,
     /* 103482 */       GIR_EraseRootFromParent_Done,
     /* 103483 */     // Label 1583: @103483
     /* 103483 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103603), // Rule ID 6377 //
     /* 103488 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103492 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103496 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103500 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103504 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103508 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103512 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103516 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103521 */       // MIs[2] imm
     /* 103521 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103525 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103529 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103533 */       // MIs[3] Operand 1
     /* 103533 */       // No operand predicates
     /* 103533 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103535 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103535 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103538 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103542 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103547 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103549 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103552 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103556 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103561 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103568 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103571 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103598 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103601 */       GIR_RootConstrainSelectedInstOperands,
     /* 103602 */       // GIR_Coverage, 6377,
     /* 103602 */       GIR_EraseRootFromParent_Done,
     /* 103603 */     // Label 1584: @103603
     /* 103603 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103720), // Rule ID 2492 //
     /* 103608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103611 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103615 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103619 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103623 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103626 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 103631 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103635 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103639 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103644 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103649 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103651 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103651 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103654 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103658 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103663 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103665 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103668 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103672 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103677 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103680 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103684 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103687 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 103705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103718 */       GIR_RootConstrainSelectedInstOperands,
     /* 103719 */       // GIR_Coverage, 2492,
     /* 103719 */       GIR_EraseRootFromParent_Done,
     /* 103720 */     // Label 1585: @103720
     /* 103720 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103837), // Rule ID 5357 //
     /* 103725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103728 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103732 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103736 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103740 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103743 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 103748 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103752 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103756 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103766 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103768 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103768 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103771 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103775 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103780 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103782 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103785 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103789 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103794 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103797 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103801 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103804 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103809 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103819 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 103822 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103835 */       GIR_RootConstrainSelectedInstOperands,
     /* 103836 */       // GIR_Coverage, 5357,
     /* 103836 */       GIR_EraseRootFromParent_Done,
     /* 103837 */     // Label 1586: @103837
     /* 103837 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103954), // Rule ID 5360 //
     /* 103842 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103853 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103857 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103860 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 103865 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103869 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103873 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103883 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103885 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103918 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103948 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103952 */       GIR_RootConstrainSelectedInstOperands,
     /* 103953 */       // GIR_Coverage, 5360,
     /* 103953 */       GIR_EraseRootFromParent_Done,
     /* 103954 */     // Label 1587: @103954
     /* 103954 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104071), // Rule ID 5363 //
     /* 103959 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103962 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103966 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103970 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103974 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103977 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103982 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103986 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103995 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104000 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104002 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104002 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104005 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104009 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104014 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104016 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104019 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104023 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104028 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104035 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 104056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104058 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 104069 */       GIR_RootConstrainSelectedInstOperands,
     /* 104070 */       // GIR_Coverage, 5363,
     /* 104070 */       GIR_EraseRootFromParent_Done,
     /* 104071 */     // Label 1588: @104071
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104127), // Rule ID 5504 //
     /* 104076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104080 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104084 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104088 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104093 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 104097 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104101 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104105 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104110 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104112 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 104115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104117 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 104121 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 104125 */       GIR_RootConstrainSelectedInstOperands,
     /* 104126 */       // GIR_Coverage, 5504,
     /* 104126 */       GIR_EraseRootFromParent_Done,
     /* 104127 */     // Label 1589: @104127
     /* 104127 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(104193), // Rule ID 5842 //
     /* 104132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104140 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104146 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 104166 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104173 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104176 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104179 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104182 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104192 */       // GIR_Coverage, 5842,
     /* 104192 */       GIR_EraseRootFromParent_Done,
     /* 104193 */     // Label 1590: @104193
     /* 104193 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104289), // Rule ID 4992 //
     /* 104198 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104201 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104205 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104209 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104213 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104217 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104222 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104224 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 104224 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104227 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104231 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104236 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104238 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104241 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104245 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104250 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104253 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104257 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104275 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 104278 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104280 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104283 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104287 */       GIR_RootConstrainSelectedInstOperands,
     /* 104288 */       // GIR_Coverage, 4992,
     /* 104288 */       GIR_EraseRootFromParent_Done,
     /* 104289 */     // Label 1591: @104289
     /* 104289 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104351), // Rule ID 5843 //
     /* 104294 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104298 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104302 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104306 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104308 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 104308 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 104311 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104315 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104330 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104332 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104335 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104340 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104345 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104350 */       // GIR_Coverage, 5843,
     /* 104350 */       GIR_EraseRootFromParent_Done,
     /* 104351 */     // Label 1592: @104351
     /* 104351 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104485), // Rule ID 5841 //
     /* 104356 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104360 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104364 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104364 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104367 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104371 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104378 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104381 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104385 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104390 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104393 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104397 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104400 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104405 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104410 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104480 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104483 */       GIR_RootConstrainSelectedInstOperands,
     /* 104484 */       // GIR_Coverage, 5841,
     /* 104484 */       GIR_EraseRootFromParent_Done,
     /* 104485 */     // Label 1593: @104485
     /* 104485 */     GIM_Reject,
     /* 104486 */   // Label 1575: @104486
     /* 104486 */   GIM_Reject,
     /* 104487 */   // Label 1510: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104512), // Rule ID 9117 //
     /* 104492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 104498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 104501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104505 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 104505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 104510 */     GIR_RootConstrainSelectedInstOperands,
     /* 104511 */     // GIR_Coverage, 9117,
     /* 104511 */     GIR_Done,
     /* 104512 */   // Label 1594: @104512
     /* 104512 */   GIM_Reject,
     /* 104513 */   // Label 1511: @104513
     /* 104513 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104538), // Rule ID 9118 //
     /* 104518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104521 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 104524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 104527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104531 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 104531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 104536 */     GIR_RootConstrainSelectedInstOperands,
     /* 104537 */     // GIR_Coverage, 9118,
     /* 104537 */     GIR_Done,
     /* 104538 */   // Label 1595: @104538
     /* 104538 */   GIM_Reject,
     /* 104539 */   // Label 1512: @104539
     /* 104539 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104564), // Rule ID 9121 //
     /* 104544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104547 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 104550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 104553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104557 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 104557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104562 */     GIR_RootConstrainSelectedInstOperands,
     /* 104563 */     // GIR_Coverage, 9121,
     /* 104563 */     GIR_Done,
     /* 104564 */   // Label 1596: @104564
     /* 104564 */   GIM_Reject,
     /* 104565 */   // Label 1513: @104565
     /* 104565 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104590), // Rule ID 9123 //
     /* 104570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104573 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 104576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 104579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104583 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 104583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 9123,
     /* 104589 */     GIR_Done,
     /* 104590 */   // Label 1597: @104590
     /* 104590 */   GIM_Reject,
     /* 104591 */   // Label 1514: @104591
     /* 104591 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104616), // Rule ID 9119 //
     /* 104596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104599 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 104602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104609 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 104609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 104614 */     GIR_RootConstrainSelectedInstOperands,
     /* 104615 */     // GIR_Coverage, 9119,
     /* 104615 */     GIR_Done,
     /* 104616 */   // Label 1598: @104616
     /* 104616 */   GIM_Reject,
     /* 104617 */   // Label 1515: @104617
     /* 104617 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104642), // Rule ID 9122 //
     /* 104622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 104628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 104631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104635 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 104635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 9122,
     /* 104641 */     GIR_Done,
     /* 104642 */   // Label 1599: @104642
     /* 104642 */   GIM_Reject,
     /* 104643 */   // Label 1516: @104643
     /* 104643 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(104668), // Rule ID 9120 //
     /* 104648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104651 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 104654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 104657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104661 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 104661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 104666 */     GIR_RootConstrainSelectedInstOperands,
     /* 104667 */     // GIR_Coverage, 9120,
     /* 104667 */     GIR_Done,
     /* 104668 */   // Label 1600: @104668
     /* 104668 */   GIM_Reject,
     /* 104669 */   // Label 1517: @104669
     /* 104669 */   GIM_Reject,
     /* 104670 */ // Label 1505: @104670
     /* 104670 */ GIM_Reject,
     /* 104671 */ // Label 9: @104671
     /* 104671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(114752),
     /* 104682 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(104770),
     /* 104686 */ /*GILLT_s64*//*Label 1602*/ GIMT_Encode4(105273),
     /* 104690 */ /*GILLT_s128*//*Label 1603*/ GIMT_Encode4(107264),
     /* 104694 */ /*GILLT_v2s32*//*Label 1604*/ GIMT_Encode4(107910),
     /* 104698 */ /*GILLT_v2s64*//*Label 1605*/ GIMT_Encode4(108825),
     /* 104702 */ /*GILLT_v4s16*//*Label 1606*/ GIMT_Encode4(109594),
     /* 104706 */ /*GILLT_v4s32*//*Label 1607*/ GIMT_Encode4(110509),
     /* 104710 */ /*GILLT_v8s8*//*Label 1608*/ GIMT_Encode4(111354),
     /* 104714 */ /*GILLT_v8s16*//*Label 1609*/ GIMT_Encode4(111915),
     /* 104718 */ /*GILLT_v16s8*//*Label 1610*/ GIMT_Encode4(112760), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104738 */ /*GILLT_nxv2s64*//*Label 1611*/ GIMT_Encode4(113212), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104750 */ /*GILLT_nxv4s32*//*Label 1612*/ GIMT_Encode4(113661), GIMT_Encode4(0),
     /* 104758 */ /*GILLT_nxv8s16*//*Label 1613*/ GIMT_Encode4(114110), GIMT_Encode4(0),
     /* 104766 */ /*GILLT_nxv16s8*//*Label 1614*/ GIMT_Encode4(114559),
     /* 104770 */ // Label 1601: @104770
     /* 104770 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(105272),
     /* 104775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104778 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104852), // Rule ID 7094 //
     /* 104783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104795 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104802 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104809 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104825 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 104828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104850 */     GIR_RootConstrainSelectedInstOperands,
     /* 104851 */     // GIR_Coverage, 7094,
     /* 104851 */     GIR_EraseRootFromParent_Done,
     /* 104852 */   // Label 1617: @104852
     /* 104852 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104926), // Rule ID 7095 //
     /* 104857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104869 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104883 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104899 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104924 */     GIR_RootConstrainSelectedInstOperands,
     /* 104925 */     // GIR_Coverage, 7095,
     /* 104925 */     GIR_EraseRootFromParent_Done,
     /* 104926 */   // Label 1618: @104926
     /* 104926 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104995), // Rule ID 7096 //
     /* 104931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104943 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104950 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104957 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104973 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 104976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104993 */     GIR_RootConstrainSelectedInstOperands,
     /* 104994 */     // GIR_Coverage, 7096,
     /* 104994 */     GIR_EraseRootFromParent_Done,
     /* 104995 */   // Label 1619: @104995
     /* 104995 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(105064), // Rule ID 7097 //
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105012 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105019 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 105026 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 105042 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 105045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105062 */     GIR_RootConstrainSelectedInstOperands,
     /* 105063 */     // GIR_Coverage, 7097,
     /* 105063 */     GIR_EraseRootFromParent_Done,
     /* 105064 */   // Label 1620: @105064
     /* 105064 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(105117), // Rule ID 5803 //
     /* 105069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105095 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 105095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105100 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 105106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 105111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105116 */     // GIR_Coverage, 5803,
     /* 105116 */     GIR_EraseRootFromParent_Done,
     /* 105117 */   // Label 1621: @105117
     /* 105117 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(105170), // Rule ID 5804 //
     /* 105122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105148 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 105148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105153 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 105159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 105164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105169 */     // GIR_Coverage, 5804,
     /* 105169 */     GIR_EraseRootFromParent_Done,
     /* 105170 */   // Label 1622: @105170
     /* 105170 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105223), // Rule ID 5805 //
     /* 105175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105201 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 105201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105206 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 105212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105222 */     // GIR_Coverage, 5805,
     /* 105222 */     GIR_EraseRootFromParent_Done,
     /* 105223 */   // Label 1623: @105223
     /* 105223 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105247), // Rule ID 6705 //
     /* 105228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105236 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 105236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105246 */     // GIR_Coverage, 6705,
     /* 105246 */     GIR_Done,
     /* 105247 */   // Label 1624: @105247
     /* 105247 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105271), // Rule ID 6706 //
     /* 105252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105260 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 105260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105270 */     // GIR_Coverage, 6706,
     /* 105270 */     GIR_Done,
     /* 105271 */   // Label 1625: @105271
     /* 105271 */   GIM_Reject,
     /* 105272 */ // Label 1616: @105272
     /* 105272 */ GIM_Reject,
     /* 105273 */ // Label 1602: @105273
     /* 105273 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105350), // Rule ID 7098 //
     /* 105278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105300 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105307 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105323 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105348 */   GIR_RootConstrainSelectedInstOperands,
     /* 105349 */   // GIR_Coverage, 7098,
     /* 105349 */   GIR_EraseRootFromParent_Done,
     /* 105350 */ // Label 1626: @105350
     /* 105350 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105427), // Rule ID 7099 //
     /* 105355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105377 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105400 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105425 */   GIR_RootConstrainSelectedInstOperands,
     /* 105426 */   // GIR_Coverage, 7099,
     /* 105426 */   GIR_EraseRootFromParent_Done,
     /* 105427 */ // Label 1627: @105427
     /* 105427 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105499), // Rule ID 7100 //
     /* 105432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105454 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105461 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105464 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105470 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105477 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105497 */   GIR_RootConstrainSelectedInstOperands,
     /* 105498 */   // GIR_Coverage, 7100,
     /* 105498 */   GIR_EraseRootFromParent_Done,
     /* 105499 */ // Label 1628: @105499
     /* 105499 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105571), // Rule ID 7101 //
     /* 105504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105526 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105533 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105536 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105542 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105549 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105569 */   GIR_RootConstrainSelectedInstOperands,
     /* 105570 */   // GIR_Coverage, 7101,
     /* 105570 */   GIR_EraseRootFromParent_Done,
     /* 105571 */ // Label 1629: @105571
     /* 105571 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105627), // Rule ID 5806 //
     /* 105576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105599 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105605 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 105605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105610 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 105616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105626 */   // GIR_Coverage, 5806,
     /* 105626 */   GIR_EraseRootFromParent_Done,
     /* 105627 */ // Label 1630: @105627
     /* 105627 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105657), // Rule ID 6680 //
     /* 105632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105646 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 105646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105656 */   // GIR_Coverage, 6680,
     /* 105656 */   GIR_Done,
     /* 105657 */ // Label 1631: @105657
     /* 105657 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105687), // Rule ID 6681 //
     /* 105662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105676 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 105676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105686 */   // GIR_Coverage, 6681,
     /* 105686 */   GIR_Done,
     /* 105687 */ // Label 1632: @105687
     /* 105687 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105717), // Rule ID 6682 //
     /* 105692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105706 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 105706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105716 */   // GIR_Coverage, 6682,
     /* 105716 */   GIR_Done,
     /* 105717 */ // Label 1633: @105717
     /* 105717 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105747), // Rule ID 6683 //
     /* 105722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105736 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 105736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105746 */   // GIR_Coverage, 6683,
     /* 105746 */   GIR_Done,
     /* 105747 */ // Label 1634: @105747
     /* 105747 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105777), // Rule ID 6684 //
     /* 105752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105766 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 105766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105776 */   // GIR_Coverage, 6684,
     /* 105776 */   GIR_Done,
     /* 105777 */ // Label 1635: @105777
     /* 105777 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105807), // Rule ID 6685 //
     /* 105782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105796 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 105796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105806 */   // GIR_Coverage, 6685,
     /* 105806 */   GIR_Done,
     /* 105807 */ // Label 1636: @105807
     /* 105807 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105857), // Rule ID 6691 //
     /* 105812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105826 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 105826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 105850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105855 */   GIR_RootConstrainSelectedInstOperands,
     /* 105856 */   // GIR_Coverage, 6691,
     /* 105856 */   GIR_EraseRootFromParent_Done,
     /* 105857 */ // Label 1637: @105857
     /* 105857 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(105907), // Rule ID 6692 //
     /* 105862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105876 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 105900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105905 */   GIR_RootConstrainSelectedInstOperands,
     /* 105906 */   // GIR_Coverage, 6692,
     /* 105906 */   GIR_EraseRootFromParent_Done,
     /* 105907 */ // Label 1638: @105907
     /* 105907 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(105957), // Rule ID 6693 //
     /* 105912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105926 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 105926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105938 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 105950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105955 */   GIR_RootConstrainSelectedInstOperands,
     /* 105956 */   // GIR_Coverage, 6693,
     /* 105956 */   GIR_EraseRootFromParent_Done,
     /* 105957 */ // Label 1639: @105957
     /* 105957 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106007), // Rule ID 6694 //
     /* 105962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105976 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106005 */   GIR_RootConstrainSelectedInstOperands,
     /* 106006 */   // GIR_Coverage, 6694,
     /* 106006 */   GIR_EraseRootFromParent_Done,
     /* 106007 */ // Label 1640: @106007
     /* 106007 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106057), // Rule ID 6695 //
     /* 106012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106026 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 106026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 106042 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 106052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106055 */   GIR_RootConstrainSelectedInstOperands,
     /* 106056 */   // GIR_Coverage, 6695,
     /* 106056 */   GIR_EraseRootFromParent_Done,
     /* 106057 */ // Label 1641: @106057
     /* 106057 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106084), // Rule ID 6696 //
     /* 106062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106073 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106083 */   // GIR_Coverage, 6696,
     /* 106083 */   GIR_Done,
     /* 106084 */ // Label 1642: @106084
     /* 106084 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106111), // Rule ID 6697 //
     /* 106089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106100 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106110 */   // GIR_Coverage, 6697,
     /* 106110 */   GIR_Done,
     /* 106111 */ // Label 1643: @106111
     /* 106111 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106138), // Rule ID 6698 //
     /* 106116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106127 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 106127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106137 */   // GIR_Coverage, 6698,
     /* 106137 */   GIR_Done,
     /* 106138 */ // Label 1644: @106138
     /* 106138 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106165), // Rule ID 6707 //
     /* 106143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106154 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106164 */   // GIR_Coverage, 6707,
     /* 106164 */   GIR_Done,
     /* 106165 */ // Label 1645: @106165
     /* 106165 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106192), // Rule ID 6708 //
     /* 106170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106181 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 106181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106191 */   // GIR_Coverage, 6708,
     /* 106191 */   GIR_Done,
     /* 106192 */ // Label 1646: @106192
     /* 106192 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106219), // Rule ID 6709 //
     /* 106197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106208 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 106208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106218 */   // GIR_Coverage, 6709,
     /* 106218 */   GIR_Done,
     /* 106219 */ // Label 1647: @106219
     /* 106219 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106251), // Rule ID 6710 //
     /* 106224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106238 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106250 */   // GIR_Coverage, 6710,
     /* 106250 */   GIR_EraseRootFromParent_Done,
     /* 106251 */ // Label 1648: @106251
     /* 106251 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106283), // Rule ID 6711 //
     /* 106256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106270 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106273 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106275 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106282 */   // GIR_Coverage, 6711,
     /* 106282 */   GIR_EraseRootFromParent_Done,
     /* 106283 */ // Label 1649: @106283
     /* 106283 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(106315), // Rule ID 6712 //
     /* 106288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106302 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106305 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106307 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106314 */   // GIR_Coverage, 6712,
     /* 106314 */   GIR_EraseRootFromParent_Done,
     /* 106315 */ // Label 1650: @106315
     /* 106315 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(106347), // Rule ID 6713 //
     /* 106320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106334 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106346 */   // GIR_Coverage, 6713,
     /* 106346 */   GIR_EraseRootFromParent_Done,
     /* 106347 */ // Label 1651: @106347
     /* 106347 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(106379), // Rule ID 6714 //
     /* 106352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106366 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106378 */   // GIR_Coverage, 6714,
     /* 106378 */   GIR_EraseRootFromParent_Done,
     /* 106379 */ // Label 1652: @106379
     /* 106379 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(106405), // Rule ID 6715 //
     /* 106384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106398 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 106398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106403 */   GIR_RootConstrainSelectedInstOperands,
     /* 106404 */   // GIR_Coverage, 6715,
     /* 106404 */   GIR_Done,
     /* 106405 */ // Label 1653: @106405
     /* 106405 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(106431), // Rule ID 6716 //
     /* 106410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106424 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 106424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106429 */   GIR_RootConstrainSelectedInstOperands,
     /* 106430 */   // GIR_Coverage, 6716,
     /* 106430 */   GIR_Done,
     /* 106431 */ // Label 1654: @106431
     /* 106431 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(106457), // Rule ID 6717 //
     /* 106436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106450 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 106450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106455 */   GIR_RootConstrainSelectedInstOperands,
     /* 106456 */   // GIR_Coverage, 6717,
     /* 106456 */   GIR_Done,
     /* 106457 */ // Label 1655: @106457
     /* 106457 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(106483), // Rule ID 6718 //
     /* 106462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106476 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 106476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106481 */   GIR_RootConstrainSelectedInstOperands,
     /* 106482 */   // GIR_Coverage, 6718,
     /* 106482 */   GIR_Done,
     /* 106483 */ // Label 1656: @106483
     /* 106483 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(106509), // Rule ID 6719 //
     /* 106488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106502 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 106502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106507 */   GIR_RootConstrainSelectedInstOperands,
     /* 106508 */   // GIR_Coverage, 6719,
     /* 106508 */   GIR_Done,
     /* 106509 */ // Label 1657: @106509
     /* 106509 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(106538), // Rule ID 6720 //
     /* 106514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106525 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106528 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106537 */   // GIR_Coverage, 6720,
     /* 106537 */   GIR_EraseRootFromParent_Done,
     /* 106538 */ // Label 1658: @106538
     /* 106538 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(106567), // Rule ID 6721 //
     /* 106543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106554 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106557 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106559 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106566 */   // GIR_Coverage, 6721,
     /* 106566 */   GIR_EraseRootFromParent_Done,
     /* 106567 */ // Label 1659: @106567
     /* 106567 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(106599), // Rule ID 6775 //
     /* 106572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106586 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106589 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106591 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106598 */   // GIR_Coverage, 6775,
     /* 106598 */   GIR_EraseRootFromParent_Done,
     /* 106599 */ // Label 1660: @106599
     /* 106599 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(106631), // Rule ID 6776 //
     /* 106604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106618 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106621 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106630 */   // GIR_Coverage, 6776,
     /* 106630 */   GIR_EraseRootFromParent_Done,
     /* 106631 */ // Label 1661: @106631
     /* 106631 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(106663), // Rule ID 6777 //
     /* 106636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106650 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106653 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106655 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106662 */   // GIR_Coverage, 6777,
     /* 106662 */   GIR_EraseRootFromParent_Done,
     /* 106663 */ // Label 1662: @106663
     /* 106663 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(106695), // Rule ID 6778 //
     /* 106668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106682 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106694 */   // GIR_Coverage, 6778,
     /* 106694 */   GIR_EraseRootFromParent_Done,
     /* 106695 */ // Label 1663: @106695
     /* 106695 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(106727), // Rule ID 6779 //
     /* 106700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106714 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106717 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106726 */   // GIR_Coverage, 6779,
     /* 106726 */   GIR_EraseRootFromParent_Done,
     /* 106727 */ // Label 1664: @106727
     /* 106727 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(106753), // Rule ID 6780 //
     /* 106732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106746 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 106746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106751 */   GIR_RootConstrainSelectedInstOperands,
     /* 106752 */   // GIR_Coverage, 6780,
     /* 106752 */   GIR_Done,
     /* 106753 */ // Label 1665: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(106779), // Rule ID 6781 //
     /* 106758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106772 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 106772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106777 */   GIR_RootConstrainSelectedInstOperands,
     /* 106778 */   // GIR_Coverage, 6781,
     /* 106778 */   GIR_Done,
     /* 106779 */ // Label 1666: @106779
     /* 106779 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(106805), // Rule ID 6782 //
     /* 106784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106798 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 106798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106803 */   GIR_RootConstrainSelectedInstOperands,
     /* 106804 */   // GIR_Coverage, 6782,
     /* 106804 */   GIR_Done,
     /* 106805 */ // Label 1667: @106805
     /* 106805 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(106831), // Rule ID 6783 //
     /* 106810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106824 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 106824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106829 */   GIR_RootConstrainSelectedInstOperands,
     /* 106830 */   // GIR_Coverage, 6783,
     /* 106830 */   GIR_Done,
     /* 106831 */ // Label 1668: @106831
     /* 106831 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(106857), // Rule ID 6784 //
     /* 106836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106850 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 106850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106855 */   GIR_RootConstrainSelectedInstOperands,
     /* 106856 */   // GIR_Coverage, 6784,
     /* 106856 */   GIR_Done,
     /* 106857 */ // Label 1669: @106857
     /* 106857 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(106886), // Rule ID 6785 //
     /* 106862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106873 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106885 */   // GIR_Coverage, 6785,
     /* 106885 */   GIR_EraseRootFromParent_Done,
     /* 106886 */ // Label 1670: @106886
     /* 106886 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(106915), // Rule ID 6786 //
     /* 106891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106902 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106914 */   // GIR_Coverage, 6786,
     /* 106914 */   GIR_EraseRootFromParent_Done,
     /* 106915 */ // Label 1671: @106915
     /* 106915 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(106947), // Rule ID 6787 //
     /* 106920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106934 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106946 */   // GIR_Coverage, 6787,
     /* 106946 */   GIR_EraseRootFromParent_Done,
     /* 106947 */ // Label 1672: @106947
     /* 106947 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(106979), // Rule ID 6788 //
     /* 106952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106966 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106978 */   // GIR_Coverage, 6788,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1673: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(107011), // Rule ID 6789 //
     /* 106984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106998 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107010 */   // GIR_Coverage, 6789,
     /* 107010 */   GIR_EraseRootFromParent_Done,
     /* 107011 */ // Label 1674: @107011
     /* 107011 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(107043), // Rule ID 6790 //
     /* 107016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107030 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107042 */   // GIR_Coverage, 6790,
     /* 107042 */   GIR_EraseRootFromParent_Done,
     /* 107043 */ // Label 1675: @107043
     /* 107043 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(107075), // Rule ID 6791 //
     /* 107048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107062 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107074 */   // GIR_Coverage, 6791,
     /* 107074 */   GIR_EraseRootFromParent_Done,
     /* 107075 */ // Label 1676: @107075
     /* 107075 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(107101), // Rule ID 6792 //
     /* 107080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107094 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 107094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107099 */   GIR_RootConstrainSelectedInstOperands,
     /* 107100 */   // GIR_Coverage, 6792,
     /* 107100 */   GIR_Done,
     /* 107101 */ // Label 1677: @107101
     /* 107101 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(107127), // Rule ID 6793 //
     /* 107106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107120 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 107120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107125 */   GIR_RootConstrainSelectedInstOperands,
     /* 107126 */   // GIR_Coverage, 6793,
     /* 107126 */   GIR_Done,
     /* 107127 */ // Label 1678: @107127
     /* 107127 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(107153), // Rule ID 6794 //
     /* 107132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107146 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 107146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107151 */   GIR_RootConstrainSelectedInstOperands,
     /* 107152 */   // GIR_Coverage, 6794,
     /* 107152 */   GIR_Done,
     /* 107153 */ // Label 1679: @107153
     /* 107153 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(107179), // Rule ID 6795 //
     /* 107158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107172 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 107172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107177 */   GIR_RootConstrainSelectedInstOperands,
     /* 107178 */   // GIR_Coverage, 6795,
     /* 107178 */   GIR_Done,
     /* 107179 */ // Label 1680: @107179
     /* 107179 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107205), // Rule ID 6796 //
     /* 107184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107198 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 107198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107203 */   GIR_RootConstrainSelectedInstOperands,
     /* 107204 */   // GIR_Coverage, 6796,
     /* 107204 */   GIR_Done,
     /* 107205 */ // Label 1681: @107205
     /* 107205 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107234), // Rule ID 6797 //
     /* 107210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107221 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107233 */   // GIR_Coverage, 6797,
     /* 107233 */   GIR_EraseRootFromParent_Done,
     /* 107234 */ // Label 1682: @107234
     /* 107234 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107263), // Rule ID 6798 //
     /* 107239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107250 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107262 */   // GIR_Coverage, 6798,
     /* 107262 */   GIR_EraseRootFromParent_Done,
     /* 107263 */ // Label 1683: @107263
     /* 107263 */ GIM_Reject,
     /* 107264 */ // Label 1603: @107264
     /* 107264 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107296), // Rule ID 6812 //
     /* 107269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107283 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107295 */   // GIR_Coverage, 6812,
     /* 107295 */   GIR_EraseRootFromParent_Done,
     /* 107296 */ // Label 1684: @107296
     /* 107296 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107328), // Rule ID 6813 //
     /* 107301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107315 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107327 */   // GIR_Coverage, 6813,
     /* 107327 */   GIR_EraseRootFromParent_Done,
     /* 107328 */ // Label 1685: @107328
     /* 107328 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107360), // Rule ID 6814 //
     /* 107333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107347 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107359 */   // GIR_Coverage, 6814,
     /* 107359 */   GIR_EraseRootFromParent_Done,
     /* 107360 */ // Label 1686: @107360
     /* 107360 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107392), // Rule ID 6815 //
     /* 107365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107379 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107391 */   // GIR_Coverage, 6815,
     /* 107391 */   GIR_EraseRootFromParent_Done,
     /* 107392 */ // Label 1687: @107392
     /* 107392 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107424), // Rule ID 6816 //
     /* 107397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107411 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107423 */   // GIR_Coverage, 6816,
     /* 107423 */   GIR_EraseRootFromParent_Done,
     /* 107424 */ // Label 1688: @107424
     /* 107424 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107456), // Rule ID 6817 //
     /* 107429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107443 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107446 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107448 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107455 */   // GIR_Coverage, 6817,
     /* 107455 */   GIR_EraseRootFromParent_Done,
     /* 107456 */ // Label 1689: @107456
     /* 107456 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107488), // Rule ID 6818 //
     /* 107461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107475 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107478 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107487 */   // GIR_Coverage, 6818,
     /* 107487 */   GIR_EraseRootFromParent_Done,
     /* 107488 */ // Label 1690: @107488
     /* 107488 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107521), // Rule ID 6819 //
     /* 107493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107507 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 107507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107519 */   GIR_RootConstrainSelectedInstOperands,
     /* 107520 */   // GIR_Coverage, 6819,
     /* 107520 */   GIR_EraseRootFromParent_Done,
     /* 107521 */ // Label 1691: @107521
     /* 107521 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(107592), // Rule ID 6820 //
     /* 107526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107540 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 107540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107590 */   GIR_RootConstrainSelectedInstOperands,
     /* 107591 */   // GIR_Coverage, 6820,
     /* 107591 */   GIR_EraseRootFromParent_Done,
     /* 107592 */ // Label 1692: @107592
     /* 107592 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107663), // Rule ID 6821 //
     /* 107597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107611 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 107611 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107614 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107618 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107661 */   GIR_RootConstrainSelectedInstOperands,
     /* 107662 */   // GIR_Coverage, 6821,
     /* 107662 */   GIR_EraseRootFromParent_Done,
     /* 107663 */ // Label 1693: @107663
     /* 107663 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(107734), // Rule ID 6822 //
     /* 107668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107682 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 107682 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107685 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107689 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107694 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107732 */   GIR_RootConstrainSelectedInstOperands,
     /* 107733 */   // GIR_Coverage, 6822,
     /* 107733 */   GIR_EraseRootFromParent_Done,
     /* 107734 */ // Label 1694: @107734
     /* 107734 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(107767), // Rule ID 6823 //
     /* 107739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107753 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 107753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107765 */   GIR_RootConstrainSelectedInstOperands,
     /* 107766 */   // GIR_Coverage, 6823,
     /* 107766 */   GIR_EraseRootFromParent_Done,
     /* 107767 */ // Label 1695: @107767
     /* 107767 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(107838), // Rule ID 6824 //
     /* 107772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107786 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 107786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107836 */   GIR_RootConstrainSelectedInstOperands,
     /* 107837 */   // GIR_Coverage, 6824,
     /* 107837 */   GIR_EraseRootFromParent_Done,
     /* 107838 */ // Label 1696: @107838
     /* 107838 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(107909), // Rule ID 6825 //
     /* 107843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107857 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 107857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107869 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107907 */   GIR_RootConstrainSelectedInstOperands,
     /* 107908 */   // GIR_Coverage, 6825,
     /* 107908 */   GIR_EraseRootFromParent_Done,
     /* 107909 */ // Label 1697: @107909
     /* 107909 */ GIM_Reject,
     /* 107910 */ // Label 1604: @107910
     /* 107910 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(107940), // Rule ID 6677 //
     /* 107915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107929 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107939 */   // GIR_Coverage, 6677,
     /* 107939 */   GIR_Done,
     /* 107940 */ // Label 1698: @107940
     /* 107940 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(107970), // Rule ID 6679 //
     /* 107945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107959 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107969 */   // GIR_Coverage, 6679,
     /* 107969 */   GIR_Done,
     /* 107970 */ // Label 1699: @107970
     /* 107970 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108020), // Rule ID 6688 //
     /* 107975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107989 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 107989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108018 */   GIR_RootConstrainSelectedInstOperands,
     /* 108019 */   // GIR_Coverage, 6688,
     /* 108019 */   GIR_EraseRootFromParent_Done,
     /* 108020 */ // Label 1700: @108020
     /* 108020 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108070), // Rule ID 6690 //
     /* 108025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108039 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 108039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 108042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108051 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 108055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108068 */   GIR_RootConstrainSelectedInstOperands,
     /* 108069 */   // GIR_Coverage, 6690,
     /* 108069 */   GIR_EraseRootFromParent_Done,
     /* 108070 */ // Label 1701: @108070
     /* 108070 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108102), // Rule ID 6722 //
     /* 108075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108089 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108101 */   // GIR_Coverage, 6722,
     /* 108101 */   GIR_EraseRootFromParent_Done,
     /* 108102 */ // Label 1702: @108102
     /* 108102 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108134), // Rule ID 6723 //
     /* 108107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108121 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108133 */   // GIR_Coverage, 6723,
     /* 108133 */   GIR_EraseRootFromParent_Done,
     /* 108134 */ // Label 1703: @108134
     /* 108134 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108166), // Rule ID 6724 //
     /* 108139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108153 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108165 */   // GIR_Coverage, 6724,
     /* 108165 */   GIR_EraseRootFromParent_Done,
     /* 108166 */ // Label 1704: @108166
     /* 108166 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108198), // Rule ID 6725 //
     /* 108171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108185 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108197 */   // GIR_Coverage, 6725,
     /* 108197 */   GIR_EraseRootFromParent_Done,
     /* 108198 */ // Label 1705: @108198
     /* 108198 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108230), // Rule ID 6726 //
     /* 108203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108217 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108229 */   // GIR_Coverage, 6726,
     /* 108229 */   GIR_EraseRootFromParent_Done,
     /* 108230 */ // Label 1706: @108230
     /* 108230 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108262), // Rule ID 6727 //
     /* 108235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108249 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108261 */   // GIR_Coverage, 6727,
     /* 108261 */   GIR_EraseRootFromParent_Done,
     /* 108262 */ // Label 1707: @108262
     /* 108262 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108288), // Rule ID 6728 //
     /* 108267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108281 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 108281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108286 */   GIR_RootConstrainSelectedInstOperands,
     /* 108287 */   // GIR_Coverage, 6728,
     /* 108287 */   GIR_Done,
     /* 108288 */ // Label 1708: @108288
     /* 108288 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108314), // Rule ID 6729 //
     /* 108293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108307 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 108307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108312 */   GIR_RootConstrainSelectedInstOperands,
     /* 108313 */   // GIR_Coverage, 6729,
     /* 108313 */   GIR_Done,
     /* 108314 */ // Label 1709: @108314
     /* 108314 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108340), // Rule ID 6730 //
     /* 108319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108333 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 108333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108338 */   GIR_RootConstrainSelectedInstOperands,
     /* 108339 */   // GIR_Coverage, 6730,
     /* 108339 */   GIR_Done,
     /* 108340 */ // Label 1710: @108340
     /* 108340 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108366), // Rule ID 6731 //
     /* 108345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108359 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 108359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108364 */   GIR_RootConstrainSelectedInstOperands,
     /* 108365 */   // GIR_Coverage, 6731,
     /* 108365 */   GIR_Done,
     /* 108366 */ // Label 1711: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108392), // Rule ID 6732 //
     /* 108371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108385 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 108385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108390 */   GIR_RootConstrainSelectedInstOperands,
     /* 108391 */   // GIR_Coverage, 6732,
     /* 108391 */   GIR_Done,
     /* 108392 */ // Label 1712: @108392
     /* 108392 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108418), // Rule ID 6733 //
     /* 108397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108411 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 108411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108416 */   GIR_RootConstrainSelectedInstOperands,
     /* 108417 */   // GIR_Coverage, 6733,
     /* 108417 */   GIR_Done,
     /* 108418 */ // Label 1713: @108418
     /* 108418 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108447), // Rule ID 6734 //
     /* 108423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108434 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108437 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108439 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // GIR_Coverage, 6734,
     /* 108446 */   GIR_EraseRootFromParent_Done,
     /* 108447 */ // Label 1714: @108447
     /* 108447 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108479), // Rule ID 6799 //
     /* 108452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108466 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108469 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // GIR_Coverage, 6799,
     /* 108478 */   GIR_EraseRootFromParent_Done,
     /* 108479 */ // Label 1715: @108479
     /* 108479 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108511), // Rule ID 6800 //
     /* 108484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108498 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108501 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // GIR_Coverage, 6800,
     /* 108510 */   GIR_EraseRootFromParent_Done,
     /* 108511 */ // Label 1716: @108511
     /* 108511 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108543), // Rule ID 6801 //
     /* 108516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108530 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108533 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // GIR_Coverage, 6801,
     /* 108542 */   GIR_EraseRootFromParent_Done,
     /* 108543 */ // Label 1717: @108543
     /* 108543 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108575), // Rule ID 6802 //
     /* 108548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108562 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108565 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108567 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // GIR_Coverage, 6802,
     /* 108574 */   GIR_EraseRootFromParent_Done,
     /* 108575 */ // Label 1718: @108575
     /* 108575 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(108607), // Rule ID 6803 //
     /* 108580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108594 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108597 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108606 */   // GIR_Coverage, 6803,
     /* 108606 */   GIR_EraseRootFromParent_Done,
     /* 108607 */ // Label 1719: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(108639), // Rule ID 6804 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108638 */   // GIR_Coverage, 6804,
     /* 108638 */   GIR_EraseRootFromParent_Done,
     /* 108639 */ // Label 1720: @108639
     /* 108639 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(108665), // Rule ID 6805 //
     /* 108644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108658 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 108658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108663 */   GIR_RootConstrainSelectedInstOperands,
     /* 108664 */   // GIR_Coverage, 6805,
     /* 108664 */   GIR_Done,
     /* 108665 */ // Label 1721: @108665
     /* 108665 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(108691), // Rule ID 6806 //
     /* 108670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108684 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 108684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108689 */   GIR_RootConstrainSelectedInstOperands,
     /* 108690 */   // GIR_Coverage, 6806,
     /* 108690 */   GIR_Done,
     /* 108691 */ // Label 1722: @108691
     /* 108691 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(108717), // Rule ID 6807 //
     /* 108696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108710 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 108710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108715 */   GIR_RootConstrainSelectedInstOperands,
     /* 108716 */   // GIR_Coverage, 6807,
     /* 108716 */   GIR_Done,
     /* 108717 */ // Label 1723: @108717
     /* 108717 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(108743), // Rule ID 6808 //
     /* 108722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108736 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 108736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108741 */   GIR_RootConstrainSelectedInstOperands,
     /* 108742 */   // GIR_Coverage, 6808,
     /* 108742 */   GIR_Done,
     /* 108743 */ // Label 1724: @108743
     /* 108743 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(108769), // Rule ID 6809 //
     /* 108748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108762 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 108762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108767 */   GIR_RootConstrainSelectedInstOperands,
     /* 108768 */   // GIR_Coverage, 6809,
     /* 108768 */   GIR_Done,
     /* 108769 */ // Label 1725: @108769
     /* 108769 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(108795), // Rule ID 6810 //
     /* 108774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108788 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 108788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108793 */   GIR_RootConstrainSelectedInstOperands,
     /* 108794 */   // GIR_Coverage, 6810,
     /* 108794 */   GIR_Done,
     /* 108795 */ // Label 1726: @108795
     /* 108795 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(108824), // Rule ID 6811 //
     /* 108800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108811 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108823 */   // GIR_Coverage, 6811,
     /* 108823 */   GIR_EraseRootFromParent_Done,
     /* 108824 */ // Label 1727: @108824
     /* 108824 */ GIM_Reject,
     /* 108825 */ // Label 1605: @108825
     /* 108825 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(108857), // Rule ID 6826 //
     /* 108830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 108836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108844 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108856 */   // GIR_Coverage, 6826,
     /* 108856 */   GIR_EraseRootFromParent_Done,
     /* 108857 */ // Label 1728: @108857
     /* 108857 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(108889), // Rule ID 6827 //
     /* 108862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108876 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108888 */   // GIR_Coverage, 6827,
     /* 108888 */   GIR_EraseRootFromParent_Done,
     /* 108889 */ // Label 1729: @108889
     /* 108889 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(108921), // Rule ID 6828 //
     /* 108894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108908 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108920 */   // GIR_Coverage, 6828,
     /* 108920 */   GIR_EraseRootFromParent_Done,
     /* 108921 */ // Label 1730: @108921
     /* 108921 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(108953), // Rule ID 6829 //
     /* 108926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108940 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108952 */   // GIR_Coverage, 6829,
     /* 108952 */   GIR_EraseRootFromParent_Done,
     /* 108953 */ // Label 1731: @108953
     /* 108953 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(108985), // Rule ID 6830 //
     /* 108958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108972 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108984 */   // GIR_Coverage, 6830,
     /* 108984 */   GIR_EraseRootFromParent_Done,
     /* 108985 */ // Label 1732: @108985
     /* 108985 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109017), // Rule ID 6831 //
     /* 108990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109004 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   // GIR_Coverage, 6831,
     /* 109016 */   GIR_EraseRootFromParent_Done,
     /* 109017 */ // Label 1733: @109017
     /* 109017 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109050), // Rule ID 6832 //
     /* 109022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109036 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109048 */   GIR_RootConstrainSelectedInstOperands,
     /* 109049 */   // GIR_Coverage, 6832,
     /* 109049 */   GIR_EraseRootFromParent_Done,
     /* 109050 */ // Label 1734: @109050
     /* 109050 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109076), // Rule ID 6833 //
     /* 109055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109069 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 109069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109074 */   GIR_RootConstrainSelectedInstOperands,
     /* 109075 */   // GIR_Coverage, 6833,
     /* 109075 */   GIR_Done,
     /* 109076 */ // Label 1735: @109076
     /* 109076 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109102), // Rule ID 6834 //
     /* 109081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109095 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 109095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109100 */   GIR_RootConstrainSelectedInstOperands,
     /* 109101 */   // GIR_Coverage, 6834,
     /* 109101 */   GIR_Done,
     /* 109102 */ // Label 1736: @109102
     /* 109102 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109128), // Rule ID 6835 //
     /* 109107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109121 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 109121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109126 */   GIR_RootConstrainSelectedInstOperands,
     /* 109127 */   // GIR_Coverage, 6835,
     /* 109127 */   GIR_Done,
     /* 109128 */ // Label 1737: @109128
     /* 109128 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109154), // Rule ID 6836 //
     /* 109133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109147 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 109147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109152 */   GIR_RootConstrainSelectedInstOperands,
     /* 109153 */   // GIR_Coverage, 6836,
     /* 109153 */   GIR_Done,
     /* 109154 */ // Label 1738: @109154
     /* 109154 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109180), // Rule ID 6837 //
     /* 109159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109173 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 109173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109178 */   GIR_RootConstrainSelectedInstOperands,
     /* 109179 */   // GIR_Coverage, 6837,
     /* 109179 */   GIR_Done,
     /* 109180 */ // Label 1739: @109180
     /* 109180 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109209), // Rule ID 6838 //
     /* 109185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109196 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109199 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109208 */   // GIR_Coverage, 6838,
     /* 109208 */   GIR_EraseRootFromParent_Done,
     /* 109209 */ // Label 1740: @109209
     /* 109209 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109241), // Rule ID 6852 //
     /* 109214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109228 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109231 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109233 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109240 */   // GIR_Coverage, 6852,
     /* 109240 */   GIR_EraseRootFromParent_Done,
     /* 109241 */ // Label 1741: @109241
     /* 109241 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109273), // Rule ID 6853 //
     /* 109246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109260 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109263 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109272 */   // GIR_Coverage, 6853,
     /* 109272 */   GIR_EraseRootFromParent_Done,
     /* 109273 */ // Label 1742: @109273
     /* 109273 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109305), // Rule ID 6854 //
     /* 109278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109292 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109295 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109304 */   // GIR_Coverage, 6854,
     /* 109304 */   GIR_EraseRootFromParent_Done,
     /* 109305 */ // Label 1743: @109305
     /* 109305 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109337), // Rule ID 6855 //
     /* 109310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109324 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109336 */   // GIR_Coverage, 6855,
     /* 109336 */   GIR_EraseRootFromParent_Done,
     /* 109337 */ // Label 1744: @109337
     /* 109337 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109369), // Rule ID 6856 //
     /* 109342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109356 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109368 */   // GIR_Coverage, 6856,
     /* 109368 */   GIR_EraseRootFromParent_Done,
     /* 109369 */ // Label 1745: @109369
     /* 109369 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(109401), // Rule ID 6857 //
     /* 109374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109388 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109400 */   // GIR_Coverage, 6857,
     /* 109400 */   GIR_EraseRootFromParent_Done,
     /* 109401 */ // Label 1746: @109401
     /* 109401 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(109434), // Rule ID 6858 //
     /* 109406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109420 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109432 */   GIR_RootConstrainSelectedInstOperands,
     /* 109433 */   // GIR_Coverage, 6858,
     /* 109433 */   GIR_EraseRootFromParent_Done,
     /* 109434 */ // Label 1747: @109434
     /* 109434 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(109460), // Rule ID 6859 //
     /* 109439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109453 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 109453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109458 */   GIR_RootConstrainSelectedInstOperands,
     /* 109459 */   // GIR_Coverage, 6859,
     /* 109459 */   GIR_Done,
     /* 109460 */ // Label 1748: @109460
     /* 109460 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(109486), // Rule ID 6860 //
     /* 109465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109479 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 109479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109484 */   GIR_RootConstrainSelectedInstOperands,
     /* 109485 */   // GIR_Coverage, 6860,
     /* 109485 */   GIR_Done,
     /* 109486 */ // Label 1749: @109486
     /* 109486 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(109512), // Rule ID 6861 //
     /* 109491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109505 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 109505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109510 */   GIR_RootConstrainSelectedInstOperands,
     /* 109511 */   // GIR_Coverage, 6861,
     /* 109511 */   GIR_Done,
     /* 109512 */ // Label 1750: @109512
     /* 109512 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(109538), // Rule ID 6862 //
     /* 109517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109531 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 109531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109536 */   GIR_RootConstrainSelectedInstOperands,
     /* 109537 */   // GIR_Coverage, 6862,
     /* 109537 */   GIR_Done,
     /* 109538 */ // Label 1751: @109538
     /* 109538 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(109564), // Rule ID 6863 //
     /* 109543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109557 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 109557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109562 */   GIR_RootConstrainSelectedInstOperands,
     /* 109563 */   // GIR_Coverage, 6863,
     /* 109563 */   GIR_Done,
     /* 109564 */ // Label 1752: @109564
     /* 109564 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(109593), // Rule ID 6864 //
     /* 109569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109580 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109583 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109592 */   // GIR_Coverage, 6864,
     /* 109592 */   GIR_EraseRootFromParent_Done,
     /* 109593 */ // Label 1753: @109593
     /* 109593 */ GIM_Reject,
     /* 109594 */ // Label 1606: @109594
     /* 109594 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(109624), // Rule ID 6676 //
     /* 109599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109613 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109623 */   // GIR_Coverage, 6676,
     /* 109623 */   GIR_Done,
     /* 109624 */ // Label 1754: @109624
     /* 109624 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(109654), // Rule ID 6678 //
     /* 109629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109643 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109653 */   // GIR_Coverage, 6678,
     /* 109653 */   GIR_Done,
     /* 109654 */ // Label 1755: @109654
     /* 109654 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(109704), // Rule ID 6687 //
     /* 109659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109673 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109702 */   GIR_RootConstrainSelectedInstOperands,
     /* 109703 */   // GIR_Coverage, 6687,
     /* 109703 */   GIR_EraseRootFromParent_Done,
     /* 109704 */ // Label 1756: @109704
     /* 109704 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(109754), // Rule ID 6689 //
     /* 109709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109723 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109752 */   GIR_RootConstrainSelectedInstOperands,
     /* 109753 */   // GIR_Coverage, 6689,
     /* 109753 */   GIR_EraseRootFromParent_Done,
     /* 109754 */ // Label 1757: @109754
     /* 109754 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(109786), // Rule ID 6735 //
     /* 109759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109773 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109785 */   // GIR_Coverage, 6735,
     /* 109785 */   GIR_EraseRootFromParent_Done,
     /* 109786 */ // Label 1758: @109786
     /* 109786 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(109818), // Rule ID 6736 //
     /* 109791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109805 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109808 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109810 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109817 */   // GIR_Coverage, 6736,
     /* 109817 */   GIR_EraseRootFromParent_Done,
     /* 109818 */ // Label 1759: @109818
     /* 109818 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(109850), // Rule ID 6737 //
     /* 109823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109837 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109840 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109842 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109849 */   // GIR_Coverage, 6737,
     /* 109849 */   GIR_EraseRootFromParent_Done,
     /* 109850 */ // Label 1760: @109850
     /* 109850 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(109882), // Rule ID 6738 //
     /* 109855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109869 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109872 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109881 */   // GIR_Coverage, 6738,
     /* 109881 */   GIR_EraseRootFromParent_Done,
     /* 109882 */ // Label 1761: @109882
     /* 109882 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(109914), // Rule ID 6739 //
     /* 109887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109901 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109904 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109913 */   // GIR_Coverage, 6739,
     /* 109913 */   GIR_EraseRootFromParent_Done,
     /* 109914 */ // Label 1762: @109914
     /* 109914 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(109946), // Rule ID 6740 //
     /* 109919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109933 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109945 */   // GIR_Coverage, 6740,
     /* 109945 */   GIR_EraseRootFromParent_Done,
     /* 109946 */ // Label 1763: @109946
     /* 109946 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(109972), // Rule ID 6741 //
     /* 109951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109965 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 109965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109970 */   GIR_RootConstrainSelectedInstOperands,
     /* 109971 */   // GIR_Coverage, 6741,
     /* 109971 */   GIR_Done,
     /* 109972 */ // Label 1764: @109972
     /* 109972 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(109998), // Rule ID 6742 //
     /* 109977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109991 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 109991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109996 */   GIR_RootConstrainSelectedInstOperands,
     /* 109997 */   // GIR_Coverage, 6742,
     /* 109997 */   GIR_Done,
     /* 109998 */ // Label 1765: @109998
     /* 109998 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(110024), // Rule ID 6743 //
     /* 110003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110017 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 110017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110022 */   GIR_RootConstrainSelectedInstOperands,
     /* 110023 */   // GIR_Coverage, 6743,
     /* 110023 */   GIR_Done,
     /* 110024 */ // Label 1766: @110024
     /* 110024 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(110050), // Rule ID 6744 //
     /* 110029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110043 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 110043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110048 */   GIR_RootConstrainSelectedInstOperands,
     /* 110049 */   // GIR_Coverage, 6744,
     /* 110049 */   GIR_Done,
     /* 110050 */ // Label 1767: @110050
     /* 110050 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(110076), // Rule ID 6745 //
     /* 110055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110069 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 110069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110074 */   GIR_RootConstrainSelectedInstOperands,
     /* 110075 */   // GIR_Coverage, 6745,
     /* 110075 */   GIR_Done,
     /* 110076 */ // Label 1768: @110076
     /* 110076 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(110102), // Rule ID 6746 //
     /* 110081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110095 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 110095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110100 */   GIR_RootConstrainSelectedInstOperands,
     /* 110101 */   // GIR_Coverage, 6746,
     /* 110101 */   GIR_Done,
     /* 110102 */ // Label 1769: @110102
     /* 110102 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(110131), // Rule ID 6747 //
     /* 110107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 110118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110130 */   // GIR_Coverage, 6747,
     /* 110130 */   GIR_EraseRootFromParent_Done,
     /* 110131 */ // Label 1770: @110131
     /* 110131 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(110163), // Rule ID 6748 //
     /* 110136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110150 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110162 */   // GIR_Coverage, 6748,
     /* 110162 */   GIR_EraseRootFromParent_Done,
     /* 110163 */ // Label 1771: @110163
     /* 110163 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(110195), // Rule ID 6749 //
     /* 110168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110182 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110185 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110194 */   // GIR_Coverage, 6749,
     /* 110194 */   GIR_EraseRootFromParent_Done,
     /* 110195 */ // Label 1772: @110195
     /* 110195 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(110227), // Rule ID 6750 //
     /* 110200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110214 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110217 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110226 */   // GIR_Coverage, 6750,
     /* 110226 */   GIR_EraseRootFromParent_Done,
     /* 110227 */ // Label 1773: @110227
     /* 110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110259), // Rule ID 6751 //
     /* 110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110246 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110249 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110251 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110258 */   // GIR_Coverage, 6751,
     /* 110258 */   GIR_EraseRootFromParent_Done,
     /* 110259 */ // Label 1774: @110259
     /* 110259 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110291), // Rule ID 6752 //
     /* 110264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110278 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110290 */   // GIR_Coverage, 6752,
     /* 110290 */   GIR_EraseRootFromParent_Done,
     /* 110291 */ // Label 1775: @110291
     /* 110291 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110323), // Rule ID 6753 //
     /* 110296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110310 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110313 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110315 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110322 */   // GIR_Coverage, 6753,
     /* 110322 */   GIR_EraseRootFromParent_Done,
     /* 110323 */ // Label 1776: @110323
     /* 110323 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110349), // Rule ID 6754 //
     /* 110328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110342 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 110342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110347 */   GIR_RootConstrainSelectedInstOperands,
     /* 110348 */   // GIR_Coverage, 6754,
     /* 110348 */   GIR_Done,
     /* 110349 */ // Label 1777: @110349
     /* 110349 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110375), // Rule ID 6755 //
     /* 110354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110368 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 110368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110373 */   GIR_RootConstrainSelectedInstOperands,
     /* 110374 */   // GIR_Coverage, 6755,
     /* 110374 */   GIR_Done,
     /* 110375 */ // Label 1778: @110375
     /* 110375 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110401), // Rule ID 6756 //
     /* 110380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110394 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 110394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110399 */   GIR_RootConstrainSelectedInstOperands,
     /* 110400 */   // GIR_Coverage, 6756,
     /* 110400 */   GIR_Done,
     /* 110401 */ // Label 1779: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110427), // Rule ID 6757 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 110420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110425 */   GIR_RootConstrainSelectedInstOperands,
     /* 110426 */   // GIR_Coverage, 6757,
     /* 110426 */   GIR_Done,
     /* 110427 */ // Label 1780: @110427
     /* 110427 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110453), // Rule ID 6758 //
     /* 110432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110446 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 110446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110451 */   GIR_RootConstrainSelectedInstOperands,
     /* 110452 */   // GIR_Coverage, 6758,
     /* 110452 */   GIR_Done,
     /* 110453 */ // Label 1781: @110453
     /* 110453 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110479), // Rule ID 6759 //
     /* 110458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110472 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 110472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110477 */   GIR_RootConstrainSelectedInstOperands,
     /* 110478 */   // GIR_Coverage, 6759,
     /* 110478 */   GIR_Done,
     /* 110479 */ // Label 1782: @110479
     /* 110479 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110508), // Rule ID 6760 //
     /* 110484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110495 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110498 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110500 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110507 */   // GIR_Coverage, 6760,
     /* 110507 */   GIR_EraseRootFromParent_Done,
     /* 110508 */ // Label 1783: @110508
     /* 110508 */ GIM_Reject,
     /* 110509 */ // Label 1607: @110509
     /* 110509 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110541), // Rule ID 6839 //
     /* 110514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110528 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110540 */   // GIR_Coverage, 6839,
     /* 110540 */   GIR_EraseRootFromParent_Done,
     /* 110541 */ // Label 1784: @110541
     /* 110541 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110573), // Rule ID 6840 //
     /* 110546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110560 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110563 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110565 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110572 */   // GIR_Coverage, 6840,
     /* 110572 */   GIR_EraseRootFromParent_Done,
     /* 110573 */ // Label 1785: @110573
     /* 110573 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110605), // Rule ID 6841 //
     /* 110578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110592 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110595 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110604 */   // GIR_Coverage, 6841,
     /* 110604 */   GIR_EraseRootFromParent_Done,
     /* 110605 */ // Label 1786: @110605
     /* 110605 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110637), // Rule ID 6842 //
     /* 110610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110624 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110636 */   // GIR_Coverage, 6842,
     /* 110636 */   GIR_EraseRootFromParent_Done,
     /* 110637 */ // Label 1787: @110637
     /* 110637 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110669), // Rule ID 6843 //
     /* 110642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110656 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110668 */   // GIR_Coverage, 6843,
     /* 110668 */   GIR_EraseRootFromParent_Done,
     /* 110669 */ // Label 1788: @110669
     /* 110669 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110701), // Rule ID 6844 //
     /* 110674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110691 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110700 */   // GIR_Coverage, 6844,
     /* 110700 */   GIR_EraseRootFromParent_Done,
     /* 110701 */ // Label 1789: @110701
     /* 110701 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110772), // Rule ID 6845 //
     /* 110706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 110720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 110723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 110741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110750 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 110767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110770 */   GIR_RootConstrainSelectedInstOperands,
     /* 110771 */   // GIR_Coverage, 6845,
     /* 110771 */   GIR_EraseRootFromParent_Done,
     /* 110772 */ // Label 1790: @110772
     /* 110772 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110798), // Rule ID 6846 //
     /* 110777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110791 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 110791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110796 */   GIR_RootConstrainSelectedInstOperands,
     /* 110797 */   // GIR_Coverage, 6846,
     /* 110797 */   GIR_Done,
     /* 110798 */ // Label 1791: @110798
     /* 110798 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110824), // Rule ID 6847 //
     /* 110803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110817 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 110817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110822 */   GIR_RootConstrainSelectedInstOperands,
     /* 110823 */   // GIR_Coverage, 6847,
     /* 110823 */   GIR_Done,
     /* 110824 */ // Label 1792: @110824
     /* 110824 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110850), // Rule ID 6848 //
     /* 110829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110843 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 110843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 110848 */   GIR_RootConstrainSelectedInstOperands,
     /* 110849 */   // GIR_Coverage, 6848,
     /* 110849 */   GIR_Done,
     /* 110850 */ // Label 1793: @110850
     /* 110850 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(110876), // Rule ID 6849 //
     /* 110855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110869 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 110869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110874 */   GIR_RootConstrainSelectedInstOperands,
     /* 110875 */   // GIR_Coverage, 6849,
     /* 110875 */   GIR_Done,
     /* 110876 */ // Label 1794: @110876
     /* 110876 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(110902), // Rule ID 6850 //
     /* 110881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110895 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 110895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110900 */   GIR_RootConstrainSelectedInstOperands,
     /* 110901 */   // GIR_Coverage, 6850,
     /* 110901 */   GIR_Done,
     /* 110902 */ // Label 1795: @110902
     /* 110902 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(110931), // Rule ID 6851 //
     /* 110907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110918 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110930 */   // GIR_Coverage, 6851,
     /* 110930 */   GIR_EraseRootFromParent_Done,
     /* 110931 */ // Label 1796: @110931
     /* 110931 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(110963), // Rule ID 6865 //
     /* 110936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110950 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110962 */   // GIR_Coverage, 6865,
     /* 110962 */   GIR_EraseRootFromParent_Done,
     /* 110963 */ // Label 1797: @110963
     /* 110963 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(110995), // Rule ID 6866 //
     /* 110968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110982 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110994 */   // GIR_Coverage, 6866,
     /* 110994 */   GIR_EraseRootFromParent_Done,
     /* 110995 */ // Label 1798: @110995
     /* 110995 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111027), // Rule ID 6867 //
     /* 111000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111014 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111026 */   // GIR_Coverage, 6867,
     /* 111026 */   GIR_EraseRootFromParent_Done,
     /* 111027 */ // Label 1799: @111027
     /* 111027 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111059), // Rule ID 6868 //
     /* 111032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111046 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111058 */   // GIR_Coverage, 6868,
     /* 111058 */   GIR_EraseRootFromParent_Done,
     /* 111059 */ // Label 1800: @111059
     /* 111059 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111091), // Rule ID 6869 //
     /* 111064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111078 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111090 */   // GIR_Coverage, 6869,
     /* 111090 */   GIR_EraseRootFromParent_Done,
     /* 111091 */ // Label 1801: @111091
     /* 111091 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111123), // Rule ID 6870 //
     /* 111096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111110 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111122 */   // GIR_Coverage, 6870,
     /* 111122 */   GIR_EraseRootFromParent_Done,
     /* 111123 */ // Label 1802: @111123
     /* 111123 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111194), // Rule ID 6871 //
     /* 111128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111142 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 111142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 111145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 111181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 111189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 111192 */   GIR_RootConstrainSelectedInstOperands,
     /* 111193 */   // GIR_Coverage, 6871,
     /* 111193 */   GIR_EraseRootFromParent_Done,
     /* 111194 */ // Label 1803: @111194
     /* 111194 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111220), // Rule ID 6872 //
     /* 111199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111213 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 111213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111218 */   GIR_RootConstrainSelectedInstOperands,
     /* 111219 */   // GIR_Coverage, 6872,
     /* 111219 */   GIR_Done,
     /* 111220 */ // Label 1804: @111220
     /* 111220 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111246), // Rule ID 6873 //
     /* 111225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111239 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 111239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111244 */   GIR_RootConstrainSelectedInstOperands,
     /* 111245 */   // GIR_Coverage, 6873,
     /* 111245 */   GIR_Done,
     /* 111246 */ // Label 1805: @111246
     /* 111246 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111272), // Rule ID 6874 //
     /* 111251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111265 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 111265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 111270 */   GIR_RootConstrainSelectedInstOperands,
     /* 111271 */   // GIR_Coverage, 6874,
     /* 111271 */   GIR_Done,
     /* 111272 */ // Label 1806: @111272
     /* 111272 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111298), // Rule ID 6875 //
     /* 111277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111291 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 111291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111296 */   GIR_RootConstrainSelectedInstOperands,
     /* 111297 */   // GIR_Coverage, 6875,
     /* 111297 */   GIR_Done,
     /* 111298 */ // Label 1807: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111324), // Rule ID 6876 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 111317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111322 */   GIR_RootConstrainSelectedInstOperands,
     /* 111323 */   // GIR_Coverage, 6876,
     /* 111323 */   GIR_Done,
     /* 111324 */ // Label 1808: @111324
     /* 111324 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111353), // Rule ID 6877 //
     /* 111329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111340 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111343 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111345 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111352 */   // GIR_Coverage, 6877,
     /* 111352 */   GIR_EraseRootFromParent_Done,
     /* 111353 */ // Label 1809: @111353
     /* 111353 */ GIM_Reject,
     /* 111354 */ // Label 1608: @111354
     /* 111354 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111428), // Rule ID 5680 //
     /* 111359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 111374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111385 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 111385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 111392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 111401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 111417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111427 */   // GIR_Coverage, 5680,
     /* 111427 */   GIR_EraseRootFromParent_Done,
     /* 111428 */ // Label 1810: @111428
     /* 111428 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111458), // Rule ID 6675 //
     /* 111433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111447 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111457 */   // GIR_Coverage, 6675,
     /* 111457 */   GIR_Done,
     /* 111458 */ // Label 1811: @111458
     /* 111458 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111508), // Rule ID 6686 //
     /* 111463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111477 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111506 */   GIR_RootConstrainSelectedInstOperands,
     /* 111507 */   // GIR_Coverage, 6686,
     /* 111507 */   GIR_EraseRootFromParent_Done,
     /* 111508 */ // Label 1812: @111508
     /* 111508 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111540), // Rule ID 6761 //
     /* 111513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111527 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111539 */   // GIR_Coverage, 6761,
     /* 111539 */   GIR_EraseRootFromParent_Done,
     /* 111540 */ // Label 1813: @111540
     /* 111540 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111572), // Rule ID 6762 //
     /* 111545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111559 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111562 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   // GIR_Coverage, 6762,
     /* 111571 */   GIR_EraseRootFromParent_Done,
     /* 111572 */ // Label 1814: @111572
     /* 111572 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111604), // Rule ID 6763 //
     /* 111577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111591 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111594 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111596 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111603 */   // GIR_Coverage, 6763,
     /* 111603 */   GIR_EraseRootFromParent_Done,
     /* 111604 */ // Label 1815: @111604
     /* 111604 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111636), // Rule ID 6764 //
     /* 111609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111623 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111626 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111628 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111635 */   // GIR_Coverage, 6764,
     /* 111635 */   GIR_EraseRootFromParent_Done,
     /* 111636 */ // Label 1816: @111636
     /* 111636 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111668), // Rule ID 6765 //
     /* 111641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111655 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111667 */   // GIR_Coverage, 6765,
     /* 111667 */   GIR_EraseRootFromParent_Done,
     /* 111668 */ // Label 1817: @111668
     /* 111668 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(111700), // Rule ID 6766 //
     /* 111673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111687 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111699 */   // GIR_Coverage, 6766,
     /* 111699 */   GIR_EraseRootFromParent_Done,
     /* 111700 */ // Label 1818: @111700
     /* 111700 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111732), // Rule ID 6767 //
     /* 111705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111719 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111722 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111731 */   // GIR_Coverage, 6767,
     /* 111731 */   GIR_EraseRootFromParent_Done,
     /* 111732 */ // Label 1819: @111732
     /* 111732 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(111758), // Rule ID 6768 //
     /* 111737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111751 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 111751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111756 */   GIR_RootConstrainSelectedInstOperands,
     /* 111757 */   // GIR_Coverage, 6768,
     /* 111757 */   GIR_Done,
     /* 111758 */ // Label 1820: @111758
     /* 111758 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(111784), // Rule ID 6769 //
     /* 111763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 111777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111782 */   GIR_RootConstrainSelectedInstOperands,
     /* 111783 */   // GIR_Coverage, 6769,
     /* 111783 */   GIR_Done,
     /* 111784 */ // Label 1821: @111784
     /* 111784 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(111810), // Rule ID 6770 //
     /* 111789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111803 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 111803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111808 */   GIR_RootConstrainSelectedInstOperands,
     /* 111809 */   // GIR_Coverage, 6770,
     /* 111809 */   GIR_Done,
     /* 111810 */ // Label 1822: @111810
     /* 111810 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(111836), // Rule ID 6771 //
     /* 111815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 111829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111834 */   GIR_RootConstrainSelectedInstOperands,
     /* 111835 */   // GIR_Coverage, 6771,
     /* 111835 */   GIR_Done,
     /* 111836 */ // Label 1823: @111836
     /* 111836 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(111862), // Rule ID 6772 //
     /* 111841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111855 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 111855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111860 */   GIR_RootConstrainSelectedInstOperands,
     /* 111861 */   // GIR_Coverage, 6772,
     /* 111861 */   GIR_Done,
     /* 111862 */ // Label 1824: @111862
     /* 111862 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(111888), // Rule ID 6773 //
     /* 111867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111881 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 111881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111886 */   GIR_RootConstrainSelectedInstOperands,
     /* 111887 */   // GIR_Coverage, 6773,
     /* 111887 */   GIR_Done,
     /* 111888 */ // Label 1825: @111888
     /* 111888 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(111914), // Rule ID 6774 //
     /* 111893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111907 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 111907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 6774,
     /* 111913 */   GIR_Done,
     /* 111914 */ // Label 1826: @111914
     /* 111914 */ GIM_Reject,
     /* 111915 */ // Label 1609: @111915
     /* 111915 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(111947), // Rule ID 6878 //
     /* 111920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111934 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111946 */   // GIR_Coverage, 6878,
     /* 111946 */   GIR_EraseRootFromParent_Done,
     /* 111947 */ // Label 1827: @111947
     /* 111947 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(111979), // Rule ID 6879 //
     /* 111952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111966 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111978 */   // GIR_Coverage, 6879,
     /* 111978 */   GIR_EraseRootFromParent_Done,
     /* 111979 */ // Label 1828: @111979
     /* 111979 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112011), // Rule ID 6880 //
     /* 111984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111998 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112010 */   // GIR_Coverage, 6880,
     /* 112010 */   GIR_EraseRootFromParent_Done,
     /* 112011 */ // Label 1829: @112011
     /* 112011 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112043), // Rule ID 6881 //
     /* 112016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112030 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112042 */   // GIR_Coverage, 6881,
     /* 112042 */   GIR_EraseRootFromParent_Done,
     /* 112043 */ // Label 1830: @112043
     /* 112043 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112075), // Rule ID 6882 //
     /* 112048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112062 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112074 */   // GIR_Coverage, 6882,
     /* 112074 */   GIR_EraseRootFromParent_Done,
     /* 112075 */ // Label 1831: @112075
     /* 112075 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112107), // Rule ID 6883 //
     /* 112080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112094 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112106 */   // GIR_Coverage, 6883,
     /* 112106 */   GIR_EraseRootFromParent_Done,
     /* 112107 */ // Label 1832: @112107
     /* 112107 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112178), // Rule ID 6884 //
     /* 112112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112126 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112138 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112176 */   GIR_RootConstrainSelectedInstOperands,
     /* 112177 */   // GIR_Coverage, 6884,
     /* 112177 */   GIR_EraseRootFromParent_Done,
     /* 112178 */ // Label 1833: @112178
     /* 112178 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112204), // Rule ID 6885 //
     /* 112183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112197 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 112197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112202 */   GIR_RootConstrainSelectedInstOperands,
     /* 112203 */   // GIR_Coverage, 6885,
     /* 112203 */   GIR_Done,
     /* 112204 */ // Label 1834: @112204
     /* 112204 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112230), // Rule ID 6886 //
     /* 112209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112223 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 112223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112228 */   GIR_RootConstrainSelectedInstOperands,
     /* 112229 */   // GIR_Coverage, 6886,
     /* 112229 */   GIR_Done,
     /* 112230 */ // Label 1835: @112230
     /* 112230 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112256), // Rule ID 6887 //
     /* 112235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112249 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 112249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112254 */   GIR_RootConstrainSelectedInstOperands,
     /* 112255 */   // GIR_Coverage, 6887,
     /* 112255 */   GIR_Done,
     /* 112256 */ // Label 1836: @112256
     /* 112256 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112282), // Rule ID 6888 //
     /* 112261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112275 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 112275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112280 */   GIR_RootConstrainSelectedInstOperands,
     /* 112281 */   // GIR_Coverage, 6888,
     /* 112281 */   GIR_Done,
     /* 112282 */ // Label 1837: @112282
     /* 112282 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112308), // Rule ID 6889 //
     /* 112287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112301 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 112301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112306 */   GIR_RootConstrainSelectedInstOperands,
     /* 112307 */   // GIR_Coverage, 6889,
     /* 112307 */   GIR_Done,
     /* 112308 */ // Label 1838: @112308
     /* 112308 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112337), // Rule ID 6890 //
     /* 112313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112324 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112336 */   // GIR_Coverage, 6890,
     /* 112336 */   GIR_EraseRootFromParent_Done,
     /* 112337 */ // Label 1839: @112337
     /* 112337 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112369), // Rule ID 6891 //
     /* 112342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112356 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112368 */   // GIR_Coverage, 6891,
     /* 112368 */   GIR_EraseRootFromParent_Done,
     /* 112369 */ // Label 1840: @112369
     /* 112369 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112401), // Rule ID 6892 //
     /* 112374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112388 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112400 */   // GIR_Coverage, 6892,
     /* 112400 */   GIR_EraseRootFromParent_Done,
     /* 112401 */ // Label 1841: @112401
     /* 112401 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(112433), // Rule ID 6893 //
     /* 112406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112420 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112432 */   // GIR_Coverage, 6893,
     /* 112432 */   GIR_EraseRootFromParent_Done,
     /* 112433 */ // Label 1842: @112433
     /* 112433 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(112465), // Rule ID 6894 //
     /* 112438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112452 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112464 */   // GIR_Coverage, 6894,
     /* 112464 */   GIR_EraseRootFromParent_Done,
     /* 112465 */ // Label 1843: @112465
     /* 112465 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(112497), // Rule ID 6895 //
     /* 112470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112484 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112496 */   // GIR_Coverage, 6895,
     /* 112496 */   GIR_EraseRootFromParent_Done,
     /* 112497 */ // Label 1844: @112497
     /* 112497 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(112529), // Rule ID 6896 //
     /* 112502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112516 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112519 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112528 */   // GIR_Coverage, 6896,
     /* 112528 */   GIR_EraseRootFromParent_Done,
     /* 112529 */ // Label 1845: @112529
     /* 112529 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(112600), // Rule ID 6897 //
     /* 112534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112548 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112548 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112551 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112555 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112560 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112578 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112598 */   GIR_RootConstrainSelectedInstOperands,
     /* 112599 */   // GIR_Coverage, 6897,
     /* 112599 */   GIR_EraseRootFromParent_Done,
     /* 112600 */ // Label 1846: @112600
     /* 112600 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(112626), // Rule ID 6898 //
     /* 112605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112619 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 112619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112624 */   GIR_RootConstrainSelectedInstOperands,
     /* 112625 */   // GIR_Coverage, 6898,
     /* 112625 */   GIR_Done,
     /* 112626 */ // Label 1847: @112626
     /* 112626 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(112652), // Rule ID 6899 //
     /* 112631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112645 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 112645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112650 */   GIR_RootConstrainSelectedInstOperands,
     /* 112651 */   // GIR_Coverage, 6899,
     /* 112651 */   GIR_Done,
     /* 112652 */ // Label 1848: @112652
     /* 112652 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(112678), // Rule ID 6900 //
     /* 112657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112671 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 112671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112676 */   GIR_RootConstrainSelectedInstOperands,
     /* 112677 */   // GIR_Coverage, 6900,
     /* 112677 */   GIR_Done,
     /* 112678 */ // Label 1849: @112678
     /* 112678 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(112704), // Rule ID 6901 //
     /* 112683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112697 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 112697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112702 */   GIR_RootConstrainSelectedInstOperands,
     /* 112703 */   // GIR_Coverage, 6901,
     /* 112703 */   GIR_Done,
     /* 112704 */ // Label 1850: @112704
     /* 112704 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(112730), // Rule ID 6902 //
     /* 112709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112723 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 112723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112728 */   GIR_RootConstrainSelectedInstOperands,
     /* 112729 */   // GIR_Coverage, 6902,
     /* 112729 */   GIR_Done,
     /* 112730 */ // Label 1851: @112730
     /* 112730 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(112759), // Rule ID 6903 //
     /* 112735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112746 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112749 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112751 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112758 */   // GIR_Coverage, 6903,
     /* 112758 */   GIR_EraseRootFromParent_Done,
     /* 112759 */ // Label 1852: @112759
     /* 112759 */ GIM_Reject,
     /* 112760 */ // Label 1610: @112760
     /* 112760 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(112792), // Rule ID 6904 //
     /* 112765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112779 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112782 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112784 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112791 */   // GIR_Coverage, 6904,
     /* 112791 */   GIR_EraseRootFromParent_Done,
     /* 112792 */ // Label 1853: @112792
     /* 112792 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(112824), // Rule ID 6905 //
     /* 112797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112811 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112814 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112823 */   // GIR_Coverage, 6905,
     /* 112823 */   GIR_EraseRootFromParent_Done,
     /* 112824 */ // Label 1854: @112824
     /* 112824 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(112856), // Rule ID 6906 //
     /* 112829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112843 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112846 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112848 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112855 */   // GIR_Coverage, 6906,
     /* 112855 */   GIR_EraseRootFromParent_Done,
     /* 112856 */ // Label 1855: @112856
     /* 112856 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(112888), // Rule ID 6907 //
     /* 112861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112875 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112887 */   // GIR_Coverage, 6907,
     /* 112887 */   GIR_EraseRootFromParent_Done,
     /* 112888 */ // Label 1856: @112888
     /* 112888 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(112920), // Rule ID 6908 //
     /* 112893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112907 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112910 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112912 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112919 */   // GIR_Coverage, 6908,
     /* 112919 */   GIR_EraseRootFromParent_Done,
     /* 112920 */ // Label 1857: @112920
     /* 112920 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(112952), // Rule ID 6909 //
     /* 112925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112939 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112942 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112944 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112951 */   // GIR_Coverage, 6909,
     /* 112951 */   GIR_EraseRootFromParent_Done,
     /* 112952 */ // Label 1858: @112952
     /* 112952 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(112984), // Rule ID 6910 //
     /* 112957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112971 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112974 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112976 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112983 */   // GIR_Coverage, 6910,
     /* 112983 */   GIR_EraseRootFromParent_Done,
     /* 112984 */ // Label 1859: @112984
     /* 112984 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(113055), // Rule ID 6911 //
     /* 112989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113003 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113053 */   GIR_RootConstrainSelectedInstOperands,
     /* 113054 */   // GIR_Coverage, 6911,
     /* 113054 */   GIR_EraseRootFromParent_Done,
     /* 113055 */ // Label 1860: @113055
     /* 113055 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(113081), // Rule ID 6912 //
     /* 113060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113074 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 113074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113079 */   GIR_RootConstrainSelectedInstOperands,
     /* 113080 */   // GIR_Coverage, 6912,
     /* 113080 */   GIR_Done,
     /* 113081 */ // Label 1861: @113081
     /* 113081 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(113107), // Rule ID 6913 //
     /* 113086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113100 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 113100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113105 */   GIR_RootConstrainSelectedInstOperands,
     /* 113106 */   // GIR_Coverage, 6913,
     /* 113106 */   GIR_Done,
     /* 113107 */ // Label 1862: @113107
     /* 113107 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(113133), // Rule ID 6914 //
     /* 113112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113126 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 113126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113131 */   GIR_RootConstrainSelectedInstOperands,
     /* 113132 */   // GIR_Coverage, 6914,
     /* 113132 */   GIR_Done,
     /* 113133 */ // Label 1863: @113133
     /* 113133 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(113159), // Rule ID 6915 //
     /* 113138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113152 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 113152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113157 */   GIR_RootConstrainSelectedInstOperands,
     /* 113158 */   // GIR_Coverage, 6915,
     /* 113158 */   GIR_Done,
     /* 113159 */ // Label 1864: @113159
     /* 113159 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(113185), // Rule ID 6916 //
     /* 113164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113178 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 113178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113183 */   GIR_RootConstrainSelectedInstOperands,
     /* 113184 */   // GIR_Coverage, 6916,
     /* 113184 */   GIR_Done,
     /* 113185 */ // Label 1865: @113185
     /* 113185 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(113211), // Rule ID 6917 //
     /* 113190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113204 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 113204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113209 */   GIR_RootConstrainSelectedInstOperands,
     /* 113210 */   // GIR_Coverage, 6917,
     /* 113210 */   GIR_Done,
     /* 113211 */ // Label 1866: @113211
     /* 113211 */ GIM_Reject,
     /* 113212 */ // Label 1611: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(113244), // Rule ID 10618 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113231 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113234 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113236 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113243 */   // GIR_Coverage, 10618,
     /* 113243 */   GIR_EraseRootFromParent_Done,
     /* 113244 */ // Label 1867: @113244
     /* 113244 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113276), // Rule ID 10619 //
     /* 113249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113263 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113275 */   // GIR_Coverage, 10619,
     /* 113275 */   GIR_EraseRootFromParent_Done,
     /* 113276 */ // Label 1868: @113276
     /* 113276 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113308), // Rule ID 10620 //
     /* 113281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113295 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113298 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113300 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113307 */   // GIR_Coverage, 10620,
     /* 113307 */   GIR_EraseRootFromParent_Done,
     /* 113308 */ // Label 1869: @113308
     /* 113308 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113340), // Rule ID 10621 //
     /* 113313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113327 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113330 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113332 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113339 */   // GIR_Coverage, 10621,
     /* 113339 */   GIR_EraseRootFromParent_Done,
     /* 113340 */ // Label 1870: @113340
     /* 113340 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113372), // Rule ID 10622 //
     /* 113345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113359 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113362 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113371 */   // GIR_Coverage, 10622,
     /* 113371 */   GIR_EraseRootFromParent_Done,
     /* 113372 */ // Label 1871: @113372
     /* 113372 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113404), // Rule ID 10623 //
     /* 113377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113391 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113394 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113396 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113403 */   // GIR_Coverage, 10623,
     /* 113403 */   GIR_EraseRootFromParent_Done,
     /* 113404 */ // Label 1872: @113404
     /* 113404 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113436), // Rule ID 10636 //
     /* 113409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113423 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113426 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113428 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113435 */   // GIR_Coverage, 10636,
     /* 113435 */   GIR_EraseRootFromParent_Done,
     /* 113436 */ // Label 1873: @113436
     /* 113436 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113468), // Rule ID 10637 //
     /* 113441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113455 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113467 */   // GIR_Coverage, 10637,
     /* 113467 */   GIR_EraseRootFromParent_Done,
     /* 113468 */ // Label 1874: @113468
     /* 113468 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113500), // Rule ID 10638 //
     /* 113473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113487 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113490 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113492 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113499 */   // GIR_Coverage, 10638,
     /* 113499 */   GIR_EraseRootFromParent_Done,
     /* 113500 */ // Label 1875: @113500
     /* 113500 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113532), // Rule ID 10639 //
     /* 113505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113519 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113522 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113524 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113531 */   // GIR_Coverage, 10639,
     /* 113531 */   GIR_EraseRootFromParent_Done,
     /* 113532 */ // Label 1876: @113532
     /* 113532 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113564), // Rule ID 10640 //
     /* 113537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113551 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113554 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113563 */   // GIR_Coverage, 10640,
     /* 113563 */   GIR_EraseRootFromParent_Done,
     /* 113564 */ // Label 1877: @113564
     /* 113564 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113596), // Rule ID 10641 //
     /* 113569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113583 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113586 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113588 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113595 */   // GIR_Coverage, 10641,
     /* 113595 */   GIR_EraseRootFromParent_Done,
     /* 113596 */ // Label 1878: @113596
     /* 113596 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113628), // Rule ID 10646 //
     /* 113601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113615 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113618 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113620 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113627 */   // GIR_Coverage, 10646,
     /* 113627 */   GIR_EraseRootFromParent_Done,
     /* 113628 */ // Label 1879: @113628
     /* 113628 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113660), // Rule ID 10647 //
     /* 113633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113647 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113650 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113659 */   // GIR_Coverage, 10647,
     /* 113659 */   GIR_EraseRootFromParent_Done,
     /* 113660 */ // Label 1880: @113660
     /* 113660 */ GIM_Reject,
     /* 113661 */ // Label 1612: @113661
     /* 113661 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113693), // Rule ID 10612 //
     /* 113666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113680 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113683 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113685 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113692 */   // GIR_Coverage, 10612,
     /* 113692 */   GIR_EraseRootFromParent_Done,
     /* 113693 */ // Label 1881: @113693
     /* 113693 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113725), // Rule ID 10613 //
     /* 113698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113712 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113724 */   // GIR_Coverage, 10613,
     /* 113724 */   GIR_EraseRootFromParent_Done,
     /* 113725 */ // Label 1882: @113725
     /* 113725 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113757), // Rule ID 10614 //
     /* 113730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113744 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113756 */   // GIR_Coverage, 10614,
     /* 113756 */   GIR_EraseRootFromParent_Done,
     /* 113757 */ // Label 1883: @113757
     /* 113757 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113789), // Rule ID 10615 //
     /* 113762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113776 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113779 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113781 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113788 */   // GIR_Coverage, 10615,
     /* 113788 */   GIR_EraseRootFromParent_Done,
     /* 113789 */ // Label 1884: @113789
     /* 113789 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113821), // Rule ID 10616 //
     /* 113794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113808 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113811 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113813 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113820 */   // GIR_Coverage, 10616,
     /* 113820 */   GIR_EraseRootFromParent_Done,
     /* 113821 */ // Label 1885: @113821
     /* 113821 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113853), // Rule ID 10617 //
     /* 113826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113840 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113843 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113852 */   // GIR_Coverage, 10617,
     /* 113852 */   GIR_EraseRootFromParent_Done,
     /* 113853 */ // Label 1886: @113853
     /* 113853 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113885), // Rule ID 10630 //
     /* 113858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113872 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113875 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113884 */   // GIR_Coverage, 10630,
     /* 113884 */   GIR_EraseRootFromParent_Done,
     /* 113885 */ // Label 1887: @113885
     /* 113885 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113917), // Rule ID 10631 //
     /* 113890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113904 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113916 */   // GIR_Coverage, 10631,
     /* 113916 */   GIR_EraseRootFromParent_Done,
     /* 113917 */ // Label 1888: @113917
     /* 113917 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113949), // Rule ID 10632 //
     /* 113922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113936 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113948 */   // GIR_Coverage, 10632,
     /* 113948 */   GIR_EraseRootFromParent_Done,
     /* 113949 */ // Label 1889: @113949
     /* 113949 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113981), // Rule ID 10633 //
     /* 113954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113968 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113980 */   // GIR_Coverage, 10633,
     /* 113980 */   GIR_EraseRootFromParent_Done,
     /* 113981 */ // Label 1890: @113981
     /* 113981 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114013), // Rule ID 10634 //
     /* 113986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114000 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114012 */   // GIR_Coverage, 10634,
     /* 114012 */   GIR_EraseRootFromParent_Done,
     /* 114013 */ // Label 1891: @114013
     /* 114013 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114045), // Rule ID 10635 //
     /* 114018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114032 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114044 */   // GIR_Coverage, 10635,
     /* 114044 */   GIR_EraseRootFromParent_Done,
     /* 114045 */ // Label 1892: @114045
     /* 114045 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114077), // Rule ID 10644 //
     /* 114050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114064 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114076 */   // GIR_Coverage, 10644,
     /* 114076 */   GIR_EraseRootFromParent_Done,
     /* 114077 */ // Label 1893: @114077
     /* 114077 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114109), // Rule ID 10645 //
     /* 114082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114096 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 114096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114108 */   // GIR_Coverage, 10645,
     /* 114108 */   GIR_EraseRootFromParent_Done,
     /* 114109 */ // Label 1894: @114109
     /* 114109 */ GIM_Reject,
     /* 114110 */ // Label 1613: @114110
     /* 114110 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114142), // Rule ID 10606 //
     /* 114115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114129 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114141 */   // GIR_Coverage, 10606,
     /* 114141 */   GIR_EraseRootFromParent_Done,
     /* 114142 */ // Label 1895: @114142
     /* 114142 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114174), // Rule ID 10607 //
     /* 114147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114161 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114173 */   // GIR_Coverage, 10607,
     /* 114173 */   GIR_EraseRootFromParent_Done,
     /* 114174 */ // Label 1896: @114174
     /* 114174 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114206), // Rule ID 10608 //
     /* 114179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114193 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114205 */   // GIR_Coverage, 10608,
     /* 114205 */   GIR_EraseRootFromParent_Done,
     /* 114206 */ // Label 1897: @114206
     /* 114206 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114238), // Rule ID 10609 //
     /* 114211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114225 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114237 */   // GIR_Coverage, 10609,
     /* 114237 */   GIR_EraseRootFromParent_Done,
     /* 114238 */ // Label 1898: @114238
     /* 114238 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114270), // Rule ID 10610 //
     /* 114243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114257 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114269 */   // GIR_Coverage, 10610,
     /* 114269 */   GIR_EraseRootFromParent_Done,
     /* 114270 */ // Label 1899: @114270
     /* 114270 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114302), // Rule ID 10611 //
     /* 114275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114289 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114292 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114301 */   // GIR_Coverage, 10611,
     /* 114301 */   GIR_EraseRootFromParent_Done,
     /* 114302 */ // Label 1900: @114302
     /* 114302 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114334), // Rule ID 10624 //
     /* 114307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114321 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114324 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114333 */   // GIR_Coverage, 10624,
     /* 114333 */   GIR_EraseRootFromParent_Done,
     /* 114334 */ // Label 1901: @114334
     /* 114334 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114366), // Rule ID 10625 //
     /* 114339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114353 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114365 */   // GIR_Coverage, 10625,
     /* 114365 */   GIR_EraseRootFromParent_Done,
     /* 114366 */ // Label 1902: @114366
     /* 114366 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114398), // Rule ID 10626 //
     /* 114371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114385 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114388 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114397 */   // GIR_Coverage, 10626,
     /* 114397 */   GIR_EraseRootFromParent_Done,
     /* 114398 */ // Label 1903: @114398
     /* 114398 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114430), // Rule ID 10627 //
     /* 114403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114417 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114420 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114429 */   // GIR_Coverage, 10627,
     /* 114429 */   GIR_EraseRootFromParent_Done,
     /* 114430 */ // Label 1904: @114430
     /* 114430 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114462), // Rule ID 10628 //
     /* 114435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114449 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114452 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114461 */   // GIR_Coverage, 10628,
     /* 114461 */   GIR_EraseRootFromParent_Done,
     /* 114462 */ // Label 1905: @114462
     /* 114462 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114494), // Rule ID 10629 //
     /* 114467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114481 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114484 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114486 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114493 */   // GIR_Coverage, 10629,
     /* 114493 */   GIR_EraseRootFromParent_Done,
     /* 114494 */ // Label 1906: @114494
     /* 114494 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114526), // Rule ID 10642 //
     /* 114499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114513 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114525 */   // GIR_Coverage, 10642,
     /* 114525 */   GIR_EraseRootFromParent_Done,
     /* 114526 */ // Label 1907: @114526
     /* 114526 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114558), // Rule ID 10643 //
     /* 114531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114545 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114557 */   // GIR_Coverage, 10643,
     /* 114557 */   GIR_EraseRootFromParent_Done,
     /* 114558 */ // Label 1908: @114558
     /* 114558 */ GIM_Reject,
     /* 114559 */ // Label 1614: @114559
     /* 114559 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114591), // Rule ID 10600 //
     /* 114564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114578 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114581 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114590 */   // GIR_Coverage, 10600,
     /* 114590 */   GIR_EraseRootFromParent_Done,
     /* 114591 */ // Label 1909: @114591
     /* 114591 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114623), // Rule ID 10601 //
     /* 114596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114610 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114622 */   // GIR_Coverage, 10601,
     /* 114622 */   GIR_EraseRootFromParent_Done,
     /* 114623 */ // Label 1910: @114623
     /* 114623 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114655), // Rule ID 10602 //
     /* 114628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114642 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114654 */   // GIR_Coverage, 10602,
     /* 114654 */   GIR_EraseRootFromParent_Done,
     /* 114655 */ // Label 1911: @114655
     /* 114655 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114687), // Rule ID 10603 //
     /* 114660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114674 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114686 */   // GIR_Coverage, 10603,
     /* 114686 */   GIR_EraseRootFromParent_Done,
     /* 114687 */ // Label 1912: @114687
     /* 114687 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114719), // Rule ID 10604 //
     /* 114692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114706 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114709 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114711 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114718 */   // GIR_Coverage, 10604,
     /* 114718 */   GIR_EraseRootFromParent_Done,
     /* 114719 */ // Label 1913: @114719
     /* 114719 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114751), // Rule ID 10605 //
     /* 114724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114738 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114741 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114750 */   // GIR_Coverage, 10605,
     /* 114750 */   GIR_EraseRootFromParent_Done,
     /* 114751 */ // Label 1914: @114751
     /* 114751 */ GIM_Reject,
     /* 114752 */ // Label 1615: @114752
     /* 114752 */ GIM_Reject,
     /* 114753 */ // Label 10: @114753
     /* 114753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1923*/ GIMT_Encode4(115243),
     /* 114764 */ /*GILLT_s16*//*Label 1915*/ GIMT_Encode4(114804),
     /* 114768 */ /*GILLT_s32*//*Label 1916*/ GIMT_Encode4(114835),
     /* 114772 */ /*GILLT_s64*//*Label 1917*/ GIMT_Encode4(114866), GIMT_Encode4(0),
     /* 114780 */ /*GILLT_v2s32*//*Label 1918*/ GIMT_Encode4(114897),
     /* 114784 */ /*GILLT_v2s64*//*Label 1919*/ GIMT_Encode4(114928),
     /* 114788 */ /*GILLT_v4s16*//*Label 1920*/ GIMT_Encode4(114959),
     /* 114792 */ /*GILLT_v4s32*//*Label 1921*/ GIMT_Encode4(114990), GIMT_Encode4(0),
     /* 114800 */ /*GILLT_v8s16*//*Label 1922*/ GIMT_Encode4(115021),
     /* 114804 */ // Label 1915: @114804
     /* 114804 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(114834), // Rule ID 564 //
     /* 114809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114823 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 114823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 114828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114832 */   GIR_RootConstrainSelectedInstOperands,
     /* 114833 */   // GIR_Coverage, 564,
     /* 114833 */   GIR_Done,
     /* 114834 */ // Label 1924: @114834
     /* 114834 */ GIM_Reject,
     /* 114835 */ // Label 1916: @114835
     /* 114835 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(114865), // Rule ID 566 //
     /* 114840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114854 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 114854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 114859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114863 */   GIR_RootConstrainSelectedInstOperands,
     /* 114864 */   // GIR_Coverage, 566,
     /* 114864 */   GIR_Done,
     /* 114865 */ // Label 1925: @114865
     /* 114865 */ GIM_Reject,
     /* 114866 */ // Label 1917: @114866
     /* 114866 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(114896), // Rule ID 568 //
     /* 114871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114885 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 114885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 114890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114894 */   GIR_RootConstrainSelectedInstOperands,
     /* 114895 */   // GIR_Coverage, 568,
     /* 114895 */   GIR_Done,
     /* 114896 */ // Label 1926: @114896
     /* 114896 */ GIM_Reject,
     /* 114897 */ // Label 1918: @114897
     /* 114897 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(114927), // Rule ID 933 //
     /* 114902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114916 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 114916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 114921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114925 */   GIR_RootConstrainSelectedInstOperands,
     /* 114926 */   // GIR_Coverage, 933,
     /* 114926 */   GIR_Done,
     /* 114927 */ // Label 1927: @114927
     /* 114927 */ GIM_Reject,
     /* 114928 */ // Label 1919: @114928
     /* 114928 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(114958), // Rule ID 937 //
     /* 114933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114947 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 114947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 114952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114956 */   GIR_RootConstrainSelectedInstOperands,
     /* 114957 */   // GIR_Coverage, 937,
     /* 114957 */   GIR_Done,
     /* 114958 */ // Label 1928: @114958
     /* 114958 */ GIM_Reject,
     /* 114959 */ // Label 1920: @114959
     /* 114959 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(114989), // Rule ID 929 //
     /* 114964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114978 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 114978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 114983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114987 */   GIR_RootConstrainSelectedInstOperands,
     /* 114988 */   // GIR_Coverage, 929,
     /* 114988 */   GIR_Done,
     /* 114989 */ // Label 1929: @114989
     /* 114989 */ GIM_Reject,
     /* 114990 */ // Label 1921: @114990
     /* 114990 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115020), // Rule ID 935 //
     /* 114995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115009 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115018 */   GIR_RootConstrainSelectedInstOperands,
     /* 115019 */   // GIR_Coverage, 935,
     /* 115019 */   GIR_Done,
     /* 115020 */ // Label 1930: @115020
     /* 115020 */ GIM_Reject,
     /* 115021 */ // Label 1922: @115021
     /* 115021 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115242),
     /* 115026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115037 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115056), // Rule ID 931 //
     /* 115042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115045 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 115050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115054 */     GIR_RootConstrainSelectedInstOperands,
     /* 115055 */     // GIR_Coverage, 931,
     /* 115055 */     GIR_Done,
     /* 115056 */   // Label 1932: @115056
     /* 115056 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115241), // Rule ID 7036 //
     /* 115061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115064 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115064 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115067 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115071 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115076 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115082 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115085 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115089 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115094 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115099 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115102 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115106 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115111 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115122 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115127 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115130 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115134 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115139 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115156 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115173 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115204 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115239 */     GIR_RootConstrainSelectedInstOperands,
     /* 115240 */     // GIR_Coverage, 7036,
     /* 115240 */     GIR_EraseRootFromParent_Done,
     /* 115241 */   // Label 1933: @115241
     /* 115241 */   GIM_Reject,
     /* 115242 */ // Label 1931: @115242
     /* 115242 */ GIM_Reject,
     /* 115243 */ // Label 1923: @115243
     /* 115243 */ GIM_Reject,
     /* 115244 */ // Label 11: @115244
     /* 115244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1942*/ GIMT_Encode4(115734),
     /* 115255 */ /*GILLT_s16*//*Label 1934*/ GIMT_Encode4(115295),
     /* 115259 */ /*GILLT_s32*//*Label 1935*/ GIMT_Encode4(115326),
     /* 115263 */ /*GILLT_s64*//*Label 1936*/ GIMT_Encode4(115357), GIMT_Encode4(0),
     /* 115271 */ /*GILLT_v2s32*//*Label 1937*/ GIMT_Encode4(115388),
     /* 115275 */ /*GILLT_v2s64*//*Label 1938*/ GIMT_Encode4(115419),
     /* 115279 */ /*GILLT_v4s16*//*Label 1939*/ GIMT_Encode4(115450),
     /* 115283 */ /*GILLT_v4s32*//*Label 1940*/ GIMT_Encode4(115481), GIMT_Encode4(0),
     /* 115291 */ /*GILLT_v8s16*//*Label 1941*/ GIMT_Encode4(115512),
     /* 115295 */ // Label 1934: @115295
     /* 115295 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(115325), // Rule ID 528 //
     /* 115300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115314 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 115314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 115319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115323 */   GIR_RootConstrainSelectedInstOperands,
     /* 115324 */   // GIR_Coverage, 528,
     /* 115324 */   GIR_Done,
     /* 115325 */ // Label 1943: @115325
     /* 115325 */ GIM_Reject,
     /* 115326 */ // Label 1935: @115326
     /* 115326 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(115356), // Rule ID 530 //
     /* 115331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115345 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 115345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 115350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115354 */   GIR_RootConstrainSelectedInstOperands,
     /* 115355 */   // GIR_Coverage, 530,
     /* 115355 */   GIR_Done,
     /* 115356 */ // Label 1944: @115356
     /* 115356 */ GIM_Reject,
     /* 115357 */ // Label 1936: @115357
     /* 115357 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(115387), // Rule ID 532 //
     /* 115362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115376 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 115376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 115381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115385 */   GIR_RootConstrainSelectedInstOperands,
     /* 115386 */   // GIR_Coverage, 532,
     /* 115386 */   GIR_Done,
     /* 115387 */ // Label 1945: @115387
     /* 115387 */ GIM_Reject,
     /* 115388 */ // Label 1937: @115388
     /* 115388 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(115418), // Rule ID 873 //
     /* 115393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115407 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 115407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 115412 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115416 */   GIR_RootConstrainSelectedInstOperands,
     /* 115417 */   // GIR_Coverage, 873,
     /* 115417 */   GIR_Done,
     /* 115418 */ // Label 1946: @115418
     /* 115418 */ GIM_Reject,
     /* 115419 */ // Label 1938: @115419
     /* 115419 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(115449), // Rule ID 877 //
     /* 115424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115438 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 115438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 115443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115447 */   GIR_RootConstrainSelectedInstOperands,
     /* 115448 */   // GIR_Coverage, 877,
     /* 115448 */   GIR_Done,
     /* 115449 */ // Label 1947: @115449
     /* 115449 */ GIM_Reject,
     /* 115450 */ // Label 1939: @115450
     /* 115450 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(115480), // Rule ID 869 //
     /* 115455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115469 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 115469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 115474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115478 */   GIR_RootConstrainSelectedInstOperands,
     /* 115479 */   // GIR_Coverage, 869,
     /* 115479 */   GIR_Done,
     /* 115480 */ // Label 1948: @115480
     /* 115480 */ GIM_Reject,
     /* 115481 */ // Label 1940: @115481
     /* 115481 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(115511), // Rule ID 875 //
     /* 115486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115500 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115509 */   GIR_RootConstrainSelectedInstOperands,
     /* 115510 */   // GIR_Coverage, 875,
     /* 115510 */   GIR_Done,
     /* 115511 */ // Label 1949: @115511
     /* 115511 */ GIM_Reject,
     /* 115512 */ // Label 1941: @115512
     /* 115512 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(115733),
     /* 115517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115528 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(115547), // Rule ID 871 //
     /* 115533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115536 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 115541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115545 */     GIR_RootConstrainSelectedInstOperands,
     /* 115546 */     // GIR_Coverage, 871,
     /* 115546 */     GIR_Done,
     /* 115547 */   // Label 1951: @115547
     /* 115547 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(115732), // Rule ID 7030 //
     /* 115552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115555 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115555 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115558 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115562 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115567 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115573 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115576 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115580 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115585 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115590 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115593 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115597 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115602 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115608 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115613 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115618 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115621 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115625 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115630 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115635 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115638 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115642 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115647 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115664 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115730 */     GIR_RootConstrainSelectedInstOperands,
     /* 115731 */     // GIR_Coverage, 7030,
     /* 115731 */     GIR_EraseRootFromParent_Done,
     /* 115732 */   // Label 1952: @115732
     /* 115732 */   GIM_Reject,
     /* 115733 */ // Label 1950: @115733
     /* 115733 */ GIM_Reject,
     /* 115734 */ // Label 1942: @115734
     /* 115734 */ GIM_Reject,
     /* 115735 */ // Label 12: @115735
     /* 115735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1955*/ GIMT_Encode4(116002),
     /* 115746 */ /*GILLT_s32*//*Label 1953*/ GIMT_Encode4(115754),
     /* 115750 */ /*GILLT_s64*//*Label 1954*/ GIMT_Encode4(115878),
     /* 115754 */ // Label 1953: @115754
     /* 115754 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(115797), // Rule ID 4818 //
     /* 115759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115769 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 115790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115795 */   GIR_RootConstrainSelectedInstOperands,
     /* 115796 */   // GIR_Coverage, 4818,
     /* 115796 */   GIR_EraseRootFromParent_Done,
     /* 115797 */ // Label 1956: @115797
     /* 115797 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(115837), // Rule ID 4824 //
     /* 115802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115809 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 115830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115835 */   GIR_RootConstrainSelectedInstOperands,
     /* 115836 */   // GIR_Coverage, 4824,
     /* 115836 */   GIR_EraseRootFromParent_Done,
     /* 115837 */ // Label 1957: @115837
     /* 115837 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(115877), // Rule ID 4826 //
     /* 115842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115849 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115875 */   GIR_RootConstrainSelectedInstOperands,
     /* 115876 */   // GIR_Coverage, 4826,
     /* 115876 */   GIR_EraseRootFromParent_Done,
     /* 115877 */ // Label 1958: @115877
     /* 115877 */ GIM_Reject,
     /* 115878 */ // Label 1954: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(115921), // Rule ID 4820 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115893 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 115914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115919 */   GIR_RootConstrainSelectedInstOperands,
     /* 115920 */   // GIR_Coverage, 4820,
     /* 115920 */   GIR_EraseRootFromParent_Done,
     /* 115921 */ // Label 1959: @115921
     /* 115921 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(115961), // Rule ID 4828 //
     /* 115926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115933 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 115954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115959 */   GIR_RootConstrainSelectedInstOperands,
     /* 115960 */   // GIR_Coverage, 4828,
     /* 115960 */   GIR_EraseRootFromParent_Done,
     /* 115961 */ // Label 1960: @115961
     /* 115961 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116001), // Rule ID 4830 //
     /* 115966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115973 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115985 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 115994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115999 */   GIR_RootConstrainSelectedInstOperands,
     /* 116000 */   // GIR_Coverage, 4830,
     /* 116000 */   GIR_EraseRootFromParent_Done,
     /* 116001 */ // Label 1961: @116001
     /* 116001 */ GIM_Reject,
     /* 116002 */ // Label 1955: @116002
     /* 116002 */ GIM_Reject,
     /* 116003 */ // Label 13: @116003
     /* 116003 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116152),
     /* 116008 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116011 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1966*/ GIMT_Encode4(116151),
     /* 116022 */   /*GILLT_s16*//*Label 1963*/ GIMT_Encode4(116034),
     /* 116026 */   /*GILLT_s32*//*Label 1964*/ GIMT_Encode4(116075),
     /* 116030 */   /*GILLT_s64*//*Label 1965*/ GIMT_Encode4(116113),
     /* 116034 */   // Label 1963: @116034
     /* 116034 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116074), // Rule ID 4822 //
     /* 116039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116046 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 116046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 116049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 116053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 116067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116072 */     GIR_RootConstrainSelectedInstOperands,
     /* 116073 */     // GIR_Coverage, 4822,
     /* 116073 */     GIR_EraseRootFromParent_Done,
     /* 116074 */   // Label 1967: @116074
     /* 116074 */   GIM_Reject,
     /* 116075 */   // Label 1964: @116075
     /* 116075 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116112), // Rule ID 4832 //
     /* 116080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116084 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 116084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 116091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 116105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116110 */     GIR_RootConstrainSelectedInstOperands,
     /* 116111 */     // GIR_Coverage, 4832,
     /* 116111 */     GIR_EraseRootFromParent_Done,
     /* 116112 */   // Label 1968: @116112
     /* 116112 */   GIM_Reject,
     /* 116113 */   // Label 1965: @116113
     /* 116113 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116150), // Rule ID 4834 //
     /* 116118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116122 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 116122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 116125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 116129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 116143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116148 */     GIR_RootConstrainSelectedInstOperands,
     /* 116149 */     // GIR_Coverage, 4834,
     /* 116149 */     GIR_EraseRootFromParent_Done,
     /* 116150 */   // Label 1969: @116150
     /* 116150 */   GIM_Reject,
     /* 116151 */   // Label 1966: @116151
     /* 116151 */   GIM_Reject,
     /* 116152 */ // Label 1962: @116152
     /* 116152 */ GIM_Reject,
     /* 116153 */ // Label 14: @116153
     /* 116153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(116643),
     /* 116164 */ /*GILLT_s16*//*Label 1970*/ GIMT_Encode4(116204),
     /* 116168 */ /*GILLT_s32*//*Label 1971*/ GIMT_Encode4(116235),
     /* 116172 */ /*GILLT_s64*//*Label 1972*/ GIMT_Encode4(116266), GIMT_Encode4(0),
     /* 116180 */ /*GILLT_v2s32*//*Label 1973*/ GIMT_Encode4(116297),
     /* 116184 */ /*GILLT_v2s64*//*Label 1974*/ GIMT_Encode4(116328),
     /* 116188 */ /*GILLT_v4s16*//*Label 1975*/ GIMT_Encode4(116359),
     /* 116192 */ /*GILLT_v4s32*//*Label 1976*/ GIMT_Encode4(116390), GIMT_Encode4(0),
     /* 116200 */ /*GILLT_v8s16*//*Label 1977*/ GIMT_Encode4(116421),
     /* 116204 */ // Label 1970: @116204
     /* 116204 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116234), // Rule ID 546 //
     /* 116209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116223 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 116228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116232 */   GIR_RootConstrainSelectedInstOperands,
     /* 116233 */   // GIR_Coverage, 546,
     /* 116233 */   GIR_Done,
     /* 116234 */ // Label 1979: @116234
     /* 116234 */ GIM_Reject,
     /* 116235 */ // Label 1971: @116235
     /* 116235 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116265), // Rule ID 548 //
     /* 116240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116254 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 116259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116263 */   GIR_RootConstrainSelectedInstOperands,
     /* 116264 */   // GIR_Coverage, 548,
     /* 116264 */   GIR_Done,
     /* 116265 */ // Label 1980: @116265
     /* 116265 */ GIM_Reject,
     /* 116266 */ // Label 1972: @116266
     /* 116266 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116296), // Rule ID 550 //
     /* 116271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116285 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 116290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116294 */   GIR_RootConstrainSelectedInstOperands,
     /* 116295 */   // GIR_Coverage, 550,
     /* 116295 */   GIR_Done,
     /* 116296 */ // Label 1981: @116296
     /* 116296 */ GIM_Reject,
     /* 116297 */ // Label 1973: @116297
     /* 116297 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116327), // Rule ID 903 //
     /* 116302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116316 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 116321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116325 */   GIR_RootConstrainSelectedInstOperands,
     /* 116326 */   // GIR_Coverage, 903,
     /* 116326 */   GIR_Done,
     /* 116327 */ // Label 1982: @116327
     /* 116327 */ GIM_Reject,
     /* 116328 */ // Label 1974: @116328
     /* 116328 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116358), // Rule ID 907 //
     /* 116333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116347 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 116352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116356 */   GIR_RootConstrainSelectedInstOperands,
     /* 116357 */   // GIR_Coverage, 907,
     /* 116357 */   GIR_Done,
     /* 116358 */ // Label 1983: @116358
     /* 116358 */ GIM_Reject,
     /* 116359 */ // Label 1975: @116359
     /* 116359 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116389), // Rule ID 899 //
     /* 116364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116378 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 116383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116387 */   GIR_RootConstrainSelectedInstOperands,
     /* 116388 */   // GIR_Coverage, 899,
     /* 116388 */   GIR_Done,
     /* 116389 */ // Label 1984: @116389
     /* 116389 */ GIM_Reject,
     /* 116390 */ // Label 1976: @116390
     /* 116390 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116420), // Rule ID 905 //
     /* 116395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116409 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116418 */   GIR_RootConstrainSelectedInstOperands,
     /* 116419 */   // GIR_Coverage, 905,
     /* 116419 */   GIR_Done,
     /* 116420 */ // Label 1985: @116420
     /* 116420 */ GIM_Reject,
     /* 116421 */ // Label 1977: @116421
     /* 116421 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116642),
     /* 116426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116437 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116456), // Rule ID 901 //
     /* 116442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116445 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 116450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116454 */     GIR_RootConstrainSelectedInstOperands,
     /* 116455 */     // GIR_Coverage, 901,
     /* 116455 */     GIR_Done,
     /* 116456 */   // Label 1987: @116456
     /* 116456 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116641), // Rule ID 7032 //
     /* 116461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116464 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116464 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116467 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116471 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116476 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116482 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116485 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116489 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116494 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116499 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116502 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116506 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116539 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116573 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116639 */     GIR_RootConstrainSelectedInstOperands,
     /* 116640 */     // GIR_Coverage, 7032,
     /* 116640 */     GIR_EraseRootFromParent_Done,
     /* 116641 */   // Label 1988: @116641
     /* 116641 */   GIM_Reject,
     /* 116642 */ // Label 1986: @116642
     /* 116642 */ GIM_Reject,
     /* 116643 */ // Label 1978: @116643
     /* 116643 */ GIM_Reject,
     /* 116644 */ // Label 15: @116644
     /* 116644 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116676), // Rule ID 3901 //
     /* 116649 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116656 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 116656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 116659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116661 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 116671 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 116674 */   GIR_RootConstrainSelectedInstOperands,
     /* 116675 */   // GIR_Coverage, 3901,
     /* 116675 */   GIR_EraseRootFromParent_Done,
     /* 116676 */ // Label 1989: @116676
     /* 116676 */ GIM_Reject,
     /* 116677 */ // Label 16: @116677
     /* 116677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2010*/ GIMT_Encode4(125614),
     /* 116688 */ /*GILLT_s8*//*Label 1990*/ GIMT_Encode4(116784),
     /* 116692 */ /*GILLT_s16*//*Label 1991*/ GIMT_Encode4(116960),
     /* 116696 */ /*GILLT_s32*//*Label 1992*/ GIMT_Encode4(117136),
     /* 116700 */ /*GILLT_s64*//*Label 1993*/ GIMT_Encode4(119530),
     /* 116704 */ /*GILLT_s128*//*Label 1994*/ GIMT_Encode4(122243),
     /* 116708 */ /*GILLT_v2s32*//*Label 1995*/ GIMT_Encode4(122452),
     /* 116712 */ /*GILLT_v2s64*//*Label 1996*/ GIMT_Encode4(122830),
     /* 116716 */ /*GILLT_v4s16*//*Label 1997*/ GIMT_Encode4(123208),
     /* 116720 */ /*GILLT_v4s32*//*Label 1998*/ GIMT_Encode4(123586),
     /* 116724 */ /*GILLT_v8s8*//*Label 1999*/ GIMT_Encode4(123964),
     /* 116728 */ /*GILLT_v8s16*//*Label 2000*/ GIMT_Encode4(124172),
     /* 116732 */ /*GILLT_v16s8*//*Label 2001*/ GIMT_Encode4(124550), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116744 */ /*GILLT_nxv2s16*//*Label 2002*/ GIMT_Encode4(124758),
     /* 116748 */ /*GILLT_nxv2s32*//*Label 2003*/ GIMT_Encode4(124822),
     /* 116752 */ /*GILLT_nxv2s64*//*Label 2004*/ GIMT_Encode4(124886), GIMT_Encode4(0),
     /* 116760 */ /*GILLT_nxv4s16*//*Label 2005*/ GIMT_Encode4(125060),
     /* 116764 */ /*GILLT_nxv4s32*//*Label 2006*/ GIMT_Encode4(125124), GIMT_Encode4(0),
     /* 116772 */ /*GILLT_nxv8s16*//*Label 2007*/ GIMT_Encode4(125298),
     /* 116776 */ /*GILLT_nxv16s1*//*Label 2008*/ GIMT_Encode4(125472),
     /* 116780 */ /*GILLT_nxv16s8*//*Label 2009*/ GIMT_Encode4(125516),
     /* 116784 */ // Label 1990: @116784
     /* 116784 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(116959),
     /* 116789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 116800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116804 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(116845), // Rule ID 237 //
     /* 116809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116819 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 116822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116843 */     GIR_RootConstrainSelectedInstOperands,
     /* 116844 */     // GIR_Coverage, 237,
     /* 116844 */     GIR_EraseRootFromParent_Done,
     /* 116845 */   // Label 2012: @116845
     /* 116845 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(116886), // Rule ID 238 //
     /* 116850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116860 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 116863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116884 */     GIR_RootConstrainSelectedInstOperands,
     /* 116885 */     // GIR_Coverage, 238,
     /* 116885 */     GIR_EraseRootFromParent_Done,
     /* 116886 */   // Label 2013: @116886
     /* 116886 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(116922), // Rule ID 261 //
     /* 116891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116901 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 116904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116920 */     GIR_RootConstrainSelectedInstOperands,
     /* 116921 */     // GIR_Coverage, 261,
     /* 116921 */     GIR_EraseRootFromParent_Done,
     /* 116922 */   // Label 2014: @116922
     /* 116922 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(116958), // Rule ID 282 //
     /* 116927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116937 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 116940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116956 */     GIR_RootConstrainSelectedInstOperands,
     /* 116957 */     // GIR_Coverage, 282,
     /* 116957 */     GIR_EraseRootFromParent_Done,
     /* 116958 */   // Label 2015: @116958
     /* 116958 */   GIM_Reject,
     /* 116959 */ // Label 2011: @116959
     /* 116959 */ GIM_Reject,
     /* 116960 */ // Label 1991: @116960
     /* 116960 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117135),
     /* 116965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116980 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117021), // Rule ID 239 //
     /* 116985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116995 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 116998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117019 */     GIR_RootConstrainSelectedInstOperands,
     /* 117020 */     // GIR_Coverage, 239,
     /* 117020 */     GIR_EraseRootFromParent_Done,
     /* 117021 */   // Label 2017: @117021
     /* 117021 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117062), // Rule ID 240 //
     /* 117026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117036 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 117039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117060 */     GIR_RootConstrainSelectedInstOperands,
     /* 117061 */     // GIR_Coverage, 240,
     /* 117061 */     GIR_EraseRootFromParent_Done,
     /* 117062 */   // Label 2018: @117062
     /* 117062 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117098), // Rule ID 262 //
     /* 117067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117077 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 117080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117096 */     GIR_RootConstrainSelectedInstOperands,
     /* 117097 */     // GIR_Coverage, 262,
     /* 117097 */     GIR_EraseRootFromParent_Done,
     /* 117098 */   // Label 2019: @117098
     /* 117098 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117134), // Rule ID 283 //
     /* 117103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117113 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 117116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117132 */     GIR_RootConstrainSelectedInstOperands,
     /* 117133 */     // GIR_Coverage, 283,
     /* 117133 */     GIR_EraseRootFromParent_Done,
     /* 117134 */   // Label 2020: @117134
     /* 117134 */   GIM_Reject,
     /* 117135 */ // Label 2016: @117135
     /* 117135 */ GIM_Reject,
     /* 117136 */ // Label 1992: @117136
     /* 117136 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(117189), // Rule ID 233 //
     /* 117141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117152 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117163 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117187 */   GIR_RootConstrainSelectedInstOperands,
     /* 117188 */   // GIR_Coverage, 233,
     /* 117188 */   GIR_EraseRootFromParent_Done,
     /* 117189 */ // Label 2021: @117189
     /* 117189 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(117242), // Rule ID 234 //
     /* 117194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117216 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117240 */   GIR_RootConstrainSelectedInstOperands,
     /* 117241 */   // GIR_Coverage, 234,
     /* 117241 */   GIR_EraseRootFromParent_Done,
     /* 117242 */ // Label 2022: @117242
     /* 117242 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(117298), // Rule ID 241 //
     /* 117247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117272 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 117275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117296 */   GIR_RootConstrainSelectedInstOperands,
     /* 117297 */   // GIR_Coverage, 241,
     /* 117297 */   GIR_EraseRootFromParent_Done,
     /* 117298 */ // Label 2023: @117298
     /* 117298 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(117354), // Rule ID 242 //
     /* 117303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117328 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 117331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117352 */   GIR_RootConstrainSelectedInstOperands,
     /* 117353 */   // GIR_Coverage, 242,
     /* 117353 */   GIR_EraseRootFromParent_Done,
     /* 117354 */ // Label 2024: @117354
     /* 117354 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(117414), // Rule ID 4117 //
     /* 117359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117388 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117412 */   GIR_RootConstrainSelectedInstOperands,
     /* 117413 */   // GIR_Coverage, 4117,
     /* 117413 */   GIR_EraseRootFromParent_Done,
     /* 117414 */ // Label 2025: @117414
     /* 117414 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(117474), // Rule ID 4118 //
     /* 117419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117448 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117472 */   GIR_RootConstrainSelectedInstOperands,
     /* 117473 */   // GIR_Coverage, 4118,
     /* 117473 */   GIR_EraseRootFromParent_Done,
     /* 117474 */ // Label 2026: @117474
     /* 117474 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(117534), // Rule ID 4119 //
     /* 117479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117508 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117532 */   GIR_RootConstrainSelectedInstOperands,
     /* 117533 */   // GIR_Coverage, 4119,
     /* 117533 */   GIR_EraseRootFromParent_Done,
     /* 117534 */ // Label 2027: @117534
     /* 117534 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(117594), // Rule ID 4120 //
     /* 117539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117542 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117568 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 117571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117592 */   GIR_RootConstrainSelectedInstOperands,
     /* 117593 */   // GIR_Coverage, 4120,
     /* 117593 */   GIR_EraseRootFromParent_Done,
     /* 117594 */ // Label 2028: @117594
     /* 117594 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(117654), // Rule ID 4121 //
     /* 117599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117602 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117628 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117652 */   GIR_RootConstrainSelectedInstOperands,
     /* 117653 */   // GIR_Coverage, 4121,
     /* 117653 */   GIR_EraseRootFromParent_Done,
     /* 117654 */ // Label 2029: @117654
     /* 117654 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(117714), // Rule ID 4122 //
     /* 117659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117688 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 4122,
     /* 117713 */   GIR_EraseRootFromParent_Done,
     /* 117714 */ // Label 2030: @117714
     /* 117714 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(117762), // Rule ID 260 //
     /* 117719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117741 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 117744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117760 */   GIR_RootConstrainSelectedInstOperands,
     /* 117761 */   // GIR_Coverage, 260,
     /* 117761 */   GIR_EraseRootFromParent_Done,
     /* 117762 */ // Label 2031: @117762
     /* 117762 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(117813), // Rule ID 263 //
     /* 117767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117792 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 117795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117811 */   GIR_RootConstrainSelectedInstOperands,
     /* 117812 */   // GIR_Coverage, 263,
     /* 117812 */   GIR_EraseRootFromParent_Done,
     /* 117813 */ // Label 2032: @117813
     /* 117813 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(117876), // Rule ID 7062 //
     /* 117818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117821 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117825 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117832 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117850 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 117850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117874 */   GIR_RootConstrainSelectedInstOperands,
     /* 117875 */   // GIR_Coverage, 7062,
     /* 117875 */   GIR_EraseRootFromParent_Done,
     /* 117876 */ // Label 2033: @117876
     /* 117876 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(117939), // Rule ID 7064 //
     /* 117881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117884 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117895 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117913 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 117913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117937 */   GIR_RootConstrainSelectedInstOperands,
     /* 117938 */   // GIR_Coverage, 7064,
     /* 117938 */   GIR_EraseRootFromParent_Done,
     /* 117939 */ // Label 2034: @117939
     /* 117939 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118002), // Rule ID 7074 //
     /* 117944 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117947 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117958 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117976 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118000 */   GIR_RootConstrainSelectedInstOperands,
     /* 118001 */   // GIR_Coverage, 7074,
     /* 118001 */   GIR_EraseRootFromParent_Done,
     /* 118002 */ // Label 2035: @118002
     /* 118002 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118065), // Rule ID 7076 //
     /* 118007 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118021 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118039 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 118042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118063 */   GIR_RootConstrainSelectedInstOperands,
     /* 118064 */   // GIR_Coverage, 7076,
     /* 118064 */   GIR_EraseRootFromParent_Done,
     /* 118065 */ // Label 2036: @118065
     /* 118065 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118128), // Rule ID 7084 //
     /* 118070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118084 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118102 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118126 */   GIR_RootConstrainSelectedInstOperands,
     /* 118127 */   // GIR_Coverage, 7084,
     /* 118127 */   GIR_EraseRootFromParent_Done,
     /* 118128 */ // Label 2037: @118128
     /* 118128 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118191), // Rule ID 7085 //
     /* 118133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118147 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118165 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118189 */   GIR_RootConstrainSelectedInstOperands,
     /* 118190 */   // GIR_Coverage, 7085,
     /* 118190 */   GIR_EraseRootFromParent_Done,
     /* 118191 */ // Label 2038: @118191
     /* 118191 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118239), // Rule ID 281 //
     /* 118196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118218 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118237 */   GIR_RootConstrainSelectedInstOperands,
     /* 118238 */   // GIR_Coverage, 281,
     /* 118238 */   GIR_EraseRootFromParent_Done,
     /* 118239 */ // Label 2039: @118239
     /* 118239 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118290), // Rule ID 284 //
     /* 118244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118269 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 118272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118288 */   GIR_RootConstrainSelectedInstOperands,
     /* 118289 */   // GIR_Coverage, 284,
     /* 118289 */   GIR_EraseRootFromParent_Done,
     /* 118290 */ // Label 2040: @118290
     /* 118290 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118345), // Rule ID 4144 //
     /* 118295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118324 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118343 */   GIR_RootConstrainSelectedInstOperands,
     /* 118344 */   // GIR_Coverage, 4144,
     /* 118344 */   GIR_EraseRootFromParent_Done,
     /* 118345 */ // Label 2041: @118345
     /* 118345 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118400), // Rule ID 4145 //
     /* 118350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118353 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118357 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118379 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118398 */   GIR_RootConstrainSelectedInstOperands,
     /* 118399 */   // GIR_Coverage, 4145,
     /* 118399 */   GIR_EraseRootFromParent_Done,
     /* 118400 */ // Label 2042: @118400
     /* 118400 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(118455), // Rule ID 4146 //
     /* 118405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118408 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118434 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118453 */   GIR_RootConstrainSelectedInstOperands,
     /* 118454 */   // GIR_Coverage, 4146,
     /* 118454 */   GIR_EraseRootFromParent_Done,
     /* 118455 */ // Label 2043: @118455
     /* 118455 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(118510), // Rule ID 4167 //
     /* 118460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118463 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118489 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118508 */   GIR_RootConstrainSelectedInstOperands,
     /* 118509 */   // GIR_Coverage, 4167,
     /* 118509 */   GIR_EraseRootFromParent_Done,
     /* 118510 */ // Label 2044: @118510
     /* 118510 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(118565), // Rule ID 4168 //
     /* 118515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118544 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118563 */   GIR_RootConstrainSelectedInstOperands,
     /* 118564 */   // GIR_Coverage, 4168,
     /* 118564 */   GIR_EraseRootFromParent_Done,
     /* 118565 */ // Label 2045: @118565
     /* 118565 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(118620), // Rule ID 4169 //
     /* 118570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118573 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118592 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118599 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118618 */   GIR_RootConstrainSelectedInstOperands,
     /* 118619 */   // GIR_Coverage, 4169,
     /* 118619 */   GIR_EraseRootFromParent_Done,
     /* 118620 */ // Label 2046: @118620
     /* 118620 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(118678), // Rule ID 7066 //
     /* 118625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118628 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118639 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118657 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118672 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118676 */   GIR_RootConstrainSelectedInstOperands,
     /* 118677 */   // GIR_Coverage, 7066,
     /* 118677 */   GIR_EraseRootFromParent_Done,
     /* 118678 */ // Label 2047: @118678
     /* 118678 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(118736), // Rule ID 7068 //
     /* 118683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118697 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118708 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118715 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15835>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118734 */   GIR_RootConstrainSelectedInstOperands,
     /* 118735 */   // GIR_Coverage, 7068,
     /* 118735 */   GIR_EraseRootFromParent_Done,
     /* 118736 */ // Label 2048: @118736
     /* 118736 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(118794), // Rule ID 7078 //
     /* 118741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118755 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118773 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118792 */   GIR_RootConstrainSelectedInstOperands,
     /* 118793 */   // GIR_Coverage, 7078,
     /* 118793 */   GIR_EraseRootFromParent_Done,
     /* 118794 */ // Label 2049: @118794
     /* 118794 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(118852), // Rule ID 7080 //
     /* 118799 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118802 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118813 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118831 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15843>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118850 */   GIR_RootConstrainSelectedInstOperands,
     /* 118851 */   // GIR_Coverage, 7080,
     /* 118851 */   GIR_EraseRootFromParent_Done,
     /* 118852 */ // Label 2050: @118852
     /* 118852 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(118910), // Rule ID 7086 //
     /* 118857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118871 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118889 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 118892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118908 */   GIR_RootConstrainSelectedInstOperands,
     /* 118909 */   // GIR_Coverage, 7086,
     /* 118909 */   GIR_EraseRootFromParent_Done,
     /* 118910 */ // Label 2051: @118910
     /* 118910 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(118968), // Rule ID 7087 //
     /* 118915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118929 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118947 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15851>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118966 */   GIR_RootConstrainSelectedInstOperands,
     /* 118967 */   // GIR_Coverage, 7087,
     /* 118967 */   GIR_EraseRootFromParent_Done,
     /* 118968 */ // Label 2052: @118968
     /* 118968 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119029), // Rule ID 7472 //
     /* 118973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 119008 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15824>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 119011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119027 */   GIR_RootConstrainSelectedInstOperands,
     /* 119028 */   // GIR_Coverage, 7472,
     /* 119028 */   GIR_EraseRootFromParent_Done,
     /* 119029 */ // Label 2053: @119029
     /* 119029 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119090), // Rule ID 7474 //
     /* 119034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119040 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119069 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15826>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 119072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119088 */   GIR_RootConstrainSelectedInstOperands,
     /* 119089 */   // GIR_Coverage, 7474,
     /* 119089 */   GIR_EraseRootFromParent_Done,
     /* 119090 */ // Label 2054: @119090
     /* 119090 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119151), // Rule ID 7476 //
     /* 119095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 119098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119101 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119130 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15828>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 119133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119149 */   GIR_RootConstrainSelectedInstOperands,
     /* 119150 */   // GIR_Coverage, 7476,
     /* 119150 */   GIR_EraseRootFromParent_Done,
     /* 119151 */ // Label 2055: @119151
     /* 119151 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119195), // Rule ID 7052 //
     /* 119156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119159 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119180 */   // MIs[0] ptr
     /* 119180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119188 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15824>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 119193 */   GIR_RootConstrainSelectedInstOperands,
     /* 119194 */   // GIR_Coverage, 7052,
     /* 119194 */   GIR_Done,
     /* 119195 */ // Label 2056: @119195
     /* 119195 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119239), // Rule ID 7054 //
     /* 119200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119206 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119210 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119224 */   // MIs[0] ptr
     /* 119224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119232 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15826>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 119237 */   GIR_RootConstrainSelectedInstOperands,
     /* 119238 */   // GIR_Coverage, 7054,
     /* 119238 */   GIR_Done,
     /* 119239 */ // Label 2057: @119239
     /* 119239 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119283), // Rule ID 7056 //
     /* 119244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119247 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119254 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119268 */   // MIs[0] ptr
     /* 119268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119276 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15828>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 119281 */   GIR_RootConstrainSelectedInstOperands,
     /* 119282 */   // GIR_Coverage, 7056,
     /* 119282 */   GIR_Done,
     /* 119283 */ // Label 2058: @119283
     /* 119283 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119324), // Rule ID 7058 //
     /* 119288 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119291 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119309 */   // MIs[0] ptr
     /* 119309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119317 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15832>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119322 */   GIR_RootConstrainSelectedInstOperands,
     /* 119323 */   // GIR_Coverage, 7058,
     /* 119323 */   GIR_Done,
     /* 119324 */ // Label 2059: @119324
     /* 119324 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(119365), // Rule ID 7060 //
     /* 119329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119350 */   // MIs[0] ptr
     /* 119350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119358 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15824>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119363 */   GIR_RootConstrainSelectedInstOperands,
     /* 119364 */   // GIR_Coverage, 7060,
     /* 119364 */   GIR_Done,
     /* 119365 */ // Label 2060: @119365
     /* 119365 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(119406), // Rule ID 7070 //
     /* 119370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119373 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119391 */   // MIs[0] ptr
     /* 119391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119399 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15840>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119404 */   GIR_RootConstrainSelectedInstOperands,
     /* 119405 */   // GIR_Coverage, 7070,
     /* 119405 */   GIR_Done,
     /* 119406 */ // Label 2061: @119406
     /* 119406 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119447), // Rule ID 7072 //
     /* 119411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119414 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119432 */   // MIs[0] ptr
     /* 119432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119440 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15826>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119445 */   GIR_RootConstrainSelectedInstOperands,
     /* 119446 */   // GIR_Coverage, 7072,
     /* 119446 */   GIR_Done,
     /* 119447 */ // Label 2062: @119447
     /* 119447 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(119488), // Rule ID 7082 //
     /* 119452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119473 */   // MIs[0] ptr
     /* 119473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119481 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15848>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119486 */   GIR_RootConstrainSelectedInstOperands,
     /* 119487 */   // GIR_Coverage, 7082,
     /* 119487 */   GIR_Done,
     /* 119488 */ // Label 2063: @119488
     /* 119488 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(119529), // Rule ID 7083 //
     /* 119493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119514 */   // MIs[0] ptr
     /* 119514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119522 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15828>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119527 */   GIR_RootConstrainSelectedInstOperands,
     /* 119528 */   // GIR_Coverage, 7083,
     /* 119528 */   GIR_Done,
     /* 119529 */ // Label 2064: @119529
     /* 119529 */ GIM_Reject,
     /* 119530 */ // Label 1993: @119530
     /* 119530 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(119583), // Rule ID 235 //
     /* 119535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119557 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 119560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119581 */   GIR_RootConstrainSelectedInstOperands,
     /* 119582 */   // GIR_Coverage, 235,
     /* 119582 */   GIR_EraseRootFromParent_Done,
     /* 119583 */ // Label 2065: @119583
     /* 119583 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(119636), // Rule ID 236 //
     /* 119588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119591 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119610 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 119613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119634 */   GIR_RootConstrainSelectedInstOperands,
     /* 119635 */   // GIR_Coverage, 236,
     /* 119635 */   GIR_EraseRootFromParent_Done,
     /* 119636 */ // Label 2066: @119636
     /* 119636 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(119692), // Rule ID 243 //
     /* 119641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119666 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119690 */   GIR_RootConstrainSelectedInstOperands,
     /* 119691 */   // GIR_Coverage, 243,
     /* 119691 */   GIR_EraseRootFromParent_Done,
     /* 119692 */ // Label 2067: @119692
     /* 119692 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(119748), // Rule ID 244 //
     /* 119697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119722 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119746 */   GIR_RootConstrainSelectedInstOperands,
     /* 119747 */   // GIR_Coverage, 244,
     /* 119747 */   GIR_EraseRootFromParent_Done,
     /* 119748 */ // Label 2068: @119748
     /* 119748 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119801), // Rule ID 4083 //
     /* 119753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119775 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119799 */   GIR_RootConstrainSelectedInstOperands,
     /* 119800 */   // GIR_Coverage, 4083,
     /* 119800 */   GIR_EraseRootFromParent_Done,
     /* 119801 */ // Label 2069: @119801
     /* 119801 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119854), // Rule ID 4084 //
     /* 119806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119828 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119852 */   GIR_RootConstrainSelectedInstOperands,
     /* 119853 */   // GIR_Coverage, 4084,
     /* 119853 */   GIR_EraseRootFromParent_Done,
     /* 119854 */ // Label 2070: @119854
     /* 119854 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119907), // Rule ID 4085 //
     /* 119859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119881 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119905 */   GIR_RootConstrainSelectedInstOperands,
     /* 119906 */   // GIR_Coverage, 4085,
     /* 119906 */   GIR_EraseRootFromParent_Done,
     /* 119907 */ // Label 2071: @119907
     /* 119907 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119960), // Rule ID 4086 //
     /* 119912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119934 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119958 */   GIR_RootConstrainSelectedInstOperands,
     /* 119959 */   // GIR_Coverage, 4086,
     /* 119959 */   GIR_EraseRootFromParent_Done,
     /* 119960 */ // Label 2072: @119960
     /* 119960 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120052), // Rule ID 4109 //
     /* 119965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119968 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119994 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 119994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120021 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120051 */   // GIR_Coverage, 4109,
     /* 120051 */   GIR_EraseRootFromParent_Done,
     /* 120052 */ // Label 2073: @120052
     /* 120052 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120144), // Rule ID 4110 //
     /* 120057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120060 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120064 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120075 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120079 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120086 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120113 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120143 */   // GIR_Coverage, 4110,
     /* 120143 */   GIR_EraseRootFromParent_Done,
     /* 120144 */ // Label 2074: @120144
     /* 120144 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120236), // Rule ID 4111 //
     /* 120149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120178 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 120185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120205 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120235 */   // GIR_Coverage, 4111,
     /* 120235 */   GIR_EraseRootFromParent_Done,
     /* 120236 */ // Label 2075: @120236
     /* 120236 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120328), // Rule ID 4112 //
     /* 120241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120270 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 120277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120297 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120327 */   // GIR_Coverage, 4112,
     /* 120327 */   GIR_EraseRootFromParent_Done,
     /* 120328 */ // Label 2076: @120328
     /* 120328 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120420), // Rule ID 4113 //
     /* 120333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120336 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120362 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 120369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120389 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120419 */   // GIR_Coverage, 4113,
     /* 120419 */   GIR_EraseRootFromParent_Done,
     /* 120420 */ // Label 2077: @120420
     /* 120420 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120512), // Rule ID 4114 //
     /* 120425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120428 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120454 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 120461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120481 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120511 */   // GIR_Coverage, 4114,
     /* 120511 */   GIR_EraseRootFromParent_Done,
     /* 120512 */ // Label 2078: @120512
     /* 120512 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(120604), // Rule ID 4115 //
     /* 120517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 120546 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120573 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120603 */   // GIR_Coverage, 4115,
     /* 120603 */   GIR_EraseRootFromParent_Done,
     /* 120604 */ // Label 2079: @120604
     /* 120604 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(120696), // Rule ID 4116 //
     /* 120609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120612 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120638 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120665 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120695 */   // GIR_Coverage, 4116,
     /* 120695 */   GIR_EraseRootFromParent_Done,
     /* 120696 */ // Label 2080: @120696
     /* 120696 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(120744), // Rule ID 259 //
     /* 120701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120723 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 120726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120742 */   GIR_RootConstrainSelectedInstOperands,
     /* 120743 */   // GIR_Coverage, 259,
     /* 120743 */   GIR_EraseRootFromParent_Done,
     /* 120744 */ // Label 2081: @120744
     /* 120744 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(120795), // Rule ID 264 //
     /* 120749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120774 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120793 */   GIR_RootConstrainSelectedInstOperands,
     /* 120794 */   // GIR_Coverage, 264,
     /* 120794 */   GIR_EraseRootFromParent_Done,
     /* 120795 */ // Label 2082: @120795
     /* 120795 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(120858), // Rule ID 7090 //
     /* 120800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120814 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120832 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 120835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120856 */   GIR_RootConstrainSelectedInstOperands,
     /* 120857 */   // GIR_Coverage, 7090,
     /* 120857 */   GIR_EraseRootFromParent_Done,
     /* 120858 */ // Label 2083: @120858
     /* 120858 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(120921), // Rule ID 7091 //
     /* 120863 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120877 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120895 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 120898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120919 */   GIR_RootConstrainSelectedInstOperands,
     /* 120920 */   // GIR_Coverage, 7091,
     /* 120920 */   GIR_EraseRootFromParent_Done,
     /* 120921 */ // Label 2084: @120921
     /* 120921 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(120969), // Rule ID 280 //
     /* 120926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120948 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 120951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120967 */   GIR_RootConstrainSelectedInstOperands,
     /* 120968 */   // GIR_Coverage, 280,
     /* 120968 */   GIR_EraseRootFromParent_Done,
     /* 120969 */ // Label 2085: @120969
     /* 120969 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121020), // Rule ID 285 //
     /* 120974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120999 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121018 */   GIR_RootConstrainSelectedInstOperands,
     /* 121019 */   // GIR_Coverage, 285,
     /* 121019 */   GIR_EraseRootFromParent_Done,
     /* 121020 */ // Label 2086: @121020
     /* 121020 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121068), // Rule ID 4130 //
     /* 121025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121047 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121066 */   GIR_RootConstrainSelectedInstOperands,
     /* 121067 */   // GIR_Coverage, 4130,
     /* 121067 */   GIR_EraseRootFromParent_Done,
     /* 121068 */ // Label 2087: @121068
     /* 121068 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121116), // Rule ID 4131 //
     /* 121073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121095 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 121098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 4131,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2088: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121203), // Rule ID 4147 //
     /* 121121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121124 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 121150 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 121157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121172 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121202 */   // GIR_Coverage, 4147,
     /* 121202 */   GIR_EraseRootFromParent_Done,
     /* 121203 */ // Label 2089: @121203
     /* 121203 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121290), // Rule ID 4148 //
     /* 121208 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121211 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 121237 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 121244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121259 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121289 */   // GIR_Coverage, 4148,
     /* 121289 */   GIR_EraseRootFromParent_Done,
     /* 121290 */ // Label 2090: @121290
     /* 121290 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121377), // Rule ID 4149 //
     /* 121295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121298 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121324 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121346 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121376 */   // GIR_Coverage, 4149,
     /* 121376 */   GIR_EraseRootFromParent_Done,
     /* 121377 */ // Label 2091: @121377
     /* 121377 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121464), // Rule ID 4150 //
     /* 121382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121385 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121411 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121433 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121463 */   // GIR_Coverage, 4150,
     /* 121463 */   GIR_EraseRootFromParent_Done,
     /* 121464 */ // Label 2092: @121464
     /* 121464 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121512), // Rule ID 4158 //
     /* 121469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121491 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121510 */   GIR_RootConstrainSelectedInstOperands,
     /* 121511 */   // GIR_Coverage, 4158,
     /* 121511 */   GIR_EraseRootFromParent_Done,
     /* 121512 */ // Label 2093: @121512
     /* 121512 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121560), // Rule ID 4159 //
     /* 121517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121539 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121558 */   GIR_RootConstrainSelectedInstOperands,
     /* 121559 */   // GIR_Coverage, 4159,
     /* 121559 */   GIR_EraseRootFromParent_Done,
     /* 121560 */ // Label 2094: @121560
     /* 121560 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(121647), // Rule ID 4170 //
     /* 121565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121568 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121594 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 121601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121616 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121646 */   // GIR_Coverage, 4170,
     /* 121646 */   GIR_EraseRootFromParent_Done,
     /* 121647 */ // Label 2095: @121647
     /* 121647 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(121734), // Rule ID 4171 //
     /* 121652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121655 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121681 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 121688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121703 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121733 */   // GIR_Coverage, 4171,
     /* 121733 */   GIR_EraseRootFromParent_Done,
     /* 121734 */ // Label 2096: @121734
     /* 121734 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121821), // Rule ID 4172 //
     /* 121739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121768 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121790 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121820 */   // GIR_Coverage, 4172,
     /* 121820 */   GIR_EraseRootFromParent_Done,
     /* 121821 */ // Label 2097: @121821
     /* 121821 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(121908), // Rule ID 4173 //
     /* 121826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121829 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121855 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121877 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121907 */   // GIR_Coverage, 4173,
     /* 121907 */   GIR_EraseRootFromParent_Done,
     /* 121908 */ // Label 2098: @121908
     /* 121908 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(121966), // Rule ID 7092 //
     /* 121913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121927 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121945 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 121948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121964 */   GIR_RootConstrainSelectedInstOperands,
     /* 121965 */   // GIR_Coverage, 7092,
     /* 121965 */   GIR_EraseRootFromParent_Done,
     /* 121966 */ // Label 2099: @121966
     /* 121966 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122024), // Rule ID 7093 //
     /* 121971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121985 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122003 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15859>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122022 */   GIR_RootConstrainSelectedInstOperands,
     /* 122023 */   // GIR_Coverage, 7093,
     /* 122023 */   GIR_EraseRootFromParent_Done,
     /* 122024 */ // Label 2100: @122024
     /* 122024 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122085), // Rule ID 7477 //
     /* 122029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 122032 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122039 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122064 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15830>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 122067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122083 */   GIR_RootConstrainSelectedInstOperands,
     /* 122084 */   // GIR_Coverage, 7477,
     /* 122084 */   GIR_EraseRootFromParent_Done,
     /* 122085 */ // Label 2101: @122085
     /* 122085 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122116), // Rule ID 6433 //
     /* 122090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122101 */   // MIs[0] Rn
     /* 122101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122109 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 122114 */   GIR_RootConstrainSelectedInstOperands,
     /* 122115 */   // GIR_Coverage, 6433,
     /* 122115 */   GIR_Done,
     /* 122116 */ // Label 2102: @122116
     /* 122116 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122160), // Rule ID 7057 //
     /* 122121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 122124 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122145 */   // MIs[0] ptr
     /* 122145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122153 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15830>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 122158 */   GIR_RootConstrainSelectedInstOperands,
     /* 122159 */   // GIR_Coverage, 7057,
     /* 122159 */   GIR_Done,
     /* 122160 */ // Label 2103: @122160
     /* 122160 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122201), // Rule ID 7088 //
     /* 122165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122186 */   // MIs[0] ptr
     /* 122186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122194 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15856>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122199 */   GIR_RootConstrainSelectedInstOperands,
     /* 122200 */   // GIR_Coverage, 7088,
     /* 122200 */   GIR_Done,
     /* 122201 */ // Label 2104: @122201
     /* 122201 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122242), // Rule ID 7089 //
     /* 122206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122227 */   // MIs[0] ptr
     /* 122227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122235 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15830>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122240 */   GIR_RootConstrainSelectedInstOperands,
     /* 122241 */   // GIR_Coverage, 7089,
     /* 122241 */   GIR_Done,
     /* 122242 */ // Label 2105: @122242
     /* 122242 */ GIM_Reject,
     /* 122243 */ // Label 1994: @122243
     /* 122243 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122451),
     /* 122248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122263 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122304), // Rule ID 245 //
     /* 122268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122278 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122302 */     GIR_RootConstrainSelectedInstOperands,
     /* 122303 */     // GIR_Coverage, 245,
     /* 122303 */     GIR_EraseRootFromParent_Done,
     /* 122304 */   // Label 2107: @122304
     /* 122304 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122345), // Rule ID 246 //
     /* 122309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122319 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122343 */     GIR_RootConstrainSelectedInstOperands,
     /* 122344 */     // GIR_Coverage, 246,
     /* 122344 */     GIR_EraseRootFromParent_Done,
     /* 122345 */   // Label 2108: @122345
     /* 122345 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122381), // Rule ID 265 //
     /* 122350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122360 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122379 */     GIR_RootConstrainSelectedInstOperands,
     /* 122380 */     // GIR_Coverage, 265,
     /* 122380 */     GIR_EraseRootFromParent_Done,
     /* 122381 */   // Label 2109: @122381
     /* 122381 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(122417), // Rule ID 286 //
     /* 122386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122396 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 122399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122415 */     GIR_RootConstrainSelectedInstOperands,
     /* 122416 */     // GIR_Coverage, 286,
     /* 122416 */     GIR_EraseRootFromParent_Done,
     /* 122417 */   // Label 2110: @122417
     /* 122417 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(122450), // Rule ID 4139 //
     /* 122422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122429 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122448 */     GIR_RootConstrainSelectedInstOperands,
     /* 122449 */     // GIR_Coverage, 4139,
     /* 122449 */     GIR_EraseRootFromParent_Done,
     /* 122450 */   // Label 2111: @122450
     /* 122450 */   GIM_Reject,
     /* 122451 */ // Label 2106: @122451
     /* 122451 */ GIM_Reject,
     /* 122452 */ // Label 1995: @122452
     /* 122452 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(122829),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(122513), // Rule ID 4073 //
     /* 122473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122487 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122511 */     GIR_RootConstrainSelectedInstOperands,
     /* 122512 */     // GIR_Coverage, 4073,
     /* 122512 */     GIR_EraseRootFromParent_Done,
     /* 122513 */   // Label 2113: @122513
     /* 122513 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(122558), // Rule ID 4074 //
     /* 122518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122532 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122556 */     GIR_RootConstrainSelectedInstOperands,
     /* 122557 */     // GIR_Coverage, 4074,
     /* 122557 */     GIR_EraseRootFromParent_Done,
     /* 122558 */   // Label 2114: @122558
     /* 122558 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(122603), // Rule ID 4075 //
     /* 122563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122577 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122601 */     GIR_RootConstrainSelectedInstOperands,
     /* 122602 */     // GIR_Coverage, 4075,
     /* 122602 */     GIR_EraseRootFromParent_Done,
     /* 122603 */   // Label 2115: @122603
     /* 122603 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(122648), // Rule ID 4076 //
     /* 122608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122622 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122646 */     GIR_RootConstrainSelectedInstOperands,
     /* 122647 */     // GIR_Coverage, 4076,
     /* 122647 */     GIR_EraseRootFromParent_Done,
     /* 122648 */   // Label 2116: @122648
     /* 122648 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(122688), // Rule ID 4125 //
     /* 122653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122667 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122686 */     GIR_RootConstrainSelectedInstOperands,
     /* 122687 */     // GIR_Coverage, 4125,
     /* 122687 */     GIR_EraseRootFromParent_Done,
     /* 122688 */   // Label 2117: @122688
     /* 122688 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(122728), // Rule ID 4128 //
     /* 122693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122707 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122726 */     GIR_RootConstrainSelectedInstOperands,
     /* 122727 */     // GIR_Coverage, 4128,
     /* 122727 */     GIR_EraseRootFromParent_Done,
     /* 122728 */   // Label 2118: @122728
     /* 122728 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(122768), // Rule ID 4153 //
     /* 122733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122747 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122766 */     GIR_RootConstrainSelectedInstOperands,
     /* 122767 */     // GIR_Coverage, 4153,
     /* 122767 */     GIR_EraseRootFromParent_Done,
     /* 122768 */   // Label 2119: @122768
     /* 122768 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(122808), // Rule ID 4154 //
     /* 122773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122787 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122806 */     GIR_RootConstrainSelectedInstOperands,
     /* 122807 */     // GIR_Coverage, 4154,
     /* 122807 */     GIR_EraseRootFromParent_Done,
     /* 122808 */   // Label 2120: @122808
     /* 122808 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(122828), // Rule ID 6432 //
     /* 122813 */     // MIs[0] Rn
     /* 122813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122821 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 122826 */     GIR_RootConstrainSelectedInstOperands,
     /* 122827 */     // GIR_Coverage, 6432,
     /* 122827 */     GIR_Done,
     /* 122828 */   // Label 2121: @122828
     /* 122828 */   GIM_Reject,
     /* 122829 */ // Label 2112: @122829
     /* 122829 */ GIM_Reject,
     /* 122830 */ // Label 1996: @122830
     /* 122830 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123207),
     /* 122835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122846 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(122891), // Rule ID 4087 //
     /* 122851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122865 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122889 */     GIR_RootConstrainSelectedInstOperands,
     /* 122890 */     // GIR_Coverage, 4087,
     /* 122890 */     GIR_EraseRootFromParent_Done,
     /* 122891 */   // Label 2123: @122891
     /* 122891 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(122936), // Rule ID 4088 //
     /* 122896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122910 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122934 */     GIR_RootConstrainSelectedInstOperands,
     /* 122935 */     // GIR_Coverage, 4088,
     /* 122935 */     GIR_EraseRootFromParent_Done,
     /* 122936 */   // Label 2124: @122936
     /* 122936 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(122981), // Rule ID 4089 //
     /* 122941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122955 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122979 */     GIR_RootConstrainSelectedInstOperands,
     /* 122980 */     // GIR_Coverage, 4089,
     /* 122980 */     GIR_EraseRootFromParent_Done,
     /* 122981 */   // Label 2125: @122981
     /* 122981 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123026), // Rule ID 4090 //
     /* 122986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123000 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123024 */     GIR_RootConstrainSelectedInstOperands,
     /* 123025 */     // GIR_Coverage, 4090,
     /* 123025 */     GIR_EraseRootFromParent_Done,
     /* 123026 */   // Label 2126: @123026
     /* 123026 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(123066), // Rule ID 4133 //
     /* 123031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123045 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123064 */     GIR_RootConstrainSelectedInstOperands,
     /* 123065 */     // GIR_Coverage, 4133,
     /* 123065 */     GIR_EraseRootFromParent_Done,
     /* 123066 */   // Label 2127: @123066
     /* 123066 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123106), // Rule ID 4137 //
     /* 123071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123085 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123104 */     GIR_RootConstrainSelectedInstOperands,
     /* 123105 */     // GIR_Coverage, 4137,
     /* 123105 */     GIR_EraseRootFromParent_Done,
     /* 123106 */   // Label 2128: @123106
     /* 123106 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(123146), // Rule ID 4160 //
     /* 123111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123125 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123144 */     GIR_RootConstrainSelectedInstOperands,
     /* 123145 */     // GIR_Coverage, 4160,
     /* 123145 */     GIR_EraseRootFromParent_Done,
     /* 123146 */   // Label 2129: @123146
     /* 123146 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(123186), // Rule ID 4161 //
     /* 123151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123165 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123184 */     GIR_RootConstrainSelectedInstOperands,
     /* 123185 */     // GIR_Coverage, 4161,
     /* 123185 */     GIR_EraseRootFromParent_Done,
     /* 123186 */   // Label 2130: @123186
     /* 123186 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(123206), // Rule ID 6429 //
     /* 123191 */     // MIs[0] Rn
     /* 123191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123199 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 123204 */     GIR_RootConstrainSelectedInstOperands,
     /* 123205 */     // GIR_Coverage, 6429,
     /* 123205 */     GIR_Done,
     /* 123206 */   // Label 2131: @123206
     /* 123206 */   GIM_Reject,
     /* 123207 */ // Label 2122: @123207
     /* 123207 */ GIM_Reject,
     /* 123208 */ // Label 1997: @123208
     /* 123208 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(123585),
     /* 123213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123224 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(123269), // Rule ID 4079 //
     /* 123229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123243 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123267 */     GIR_RootConstrainSelectedInstOperands,
     /* 123268 */     // GIR_Coverage, 4079,
     /* 123268 */     GIR_EraseRootFromParent_Done,
     /* 123269 */   // Label 2133: @123269
     /* 123269 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(123314), // Rule ID 4080 //
     /* 123274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123288 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123312 */     GIR_RootConstrainSelectedInstOperands,
     /* 123313 */     // GIR_Coverage, 4080,
     /* 123313 */     GIR_EraseRootFromParent_Done,
     /* 123314 */   // Label 2134: @123314
     /* 123314 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(123359), // Rule ID 4081 //
     /* 123319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123333 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123357 */     GIR_RootConstrainSelectedInstOperands,
     /* 123358 */     // GIR_Coverage, 4081,
     /* 123358 */     GIR_EraseRootFromParent_Done,
     /* 123359 */   // Label 2135: @123359
     /* 123359 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(123404), // Rule ID 4082 //
     /* 123364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123378 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123402 */     GIR_RootConstrainSelectedInstOperands,
     /* 123403 */     // GIR_Coverage, 4082,
     /* 123403 */     GIR_EraseRootFromParent_Done,
     /* 123404 */   // Label 2136: @123404
     /* 123404 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(123444), // Rule ID 4127 //
     /* 123409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123423 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123442 */     GIR_RootConstrainSelectedInstOperands,
     /* 123443 */     // GIR_Coverage, 4127,
     /* 123443 */     GIR_EraseRootFromParent_Done,
     /* 123444 */   // Label 2137: @123444
     /* 123444 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(123484), // Rule ID 4129 //
     /* 123449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123463 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123482 */     GIR_RootConstrainSelectedInstOperands,
     /* 123483 */     // GIR_Coverage, 4129,
     /* 123483 */     GIR_EraseRootFromParent_Done,
     /* 123484 */   // Label 2138: @123484
     /* 123484 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(123524), // Rule ID 4155 //
     /* 123489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123503 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123522 */     GIR_RootConstrainSelectedInstOperands,
     /* 123523 */     // GIR_Coverage, 4155,
     /* 123523 */     GIR_EraseRootFromParent_Done,
     /* 123524 */   // Label 2139: @123524
     /* 123524 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(123564), // Rule ID 4157 //
     /* 123529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123543 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123562 */     GIR_RootConstrainSelectedInstOperands,
     /* 123563 */     // GIR_Coverage, 4157,
     /* 123563 */     GIR_EraseRootFromParent_Done,
     /* 123564 */   // Label 2140: @123564
     /* 123564 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(123584), // Rule ID 6431 //
     /* 123569 */     // MIs[0] Rn
     /* 123569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123577 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 123582 */     GIR_RootConstrainSelectedInstOperands,
     /* 123583 */     // GIR_Coverage, 6431,
     /* 123583 */     GIR_Done,
     /* 123584 */   // Label 2141: @123584
     /* 123584 */   GIM_Reject,
     /* 123585 */ // Label 2132: @123585
     /* 123585 */ GIM_Reject,
     /* 123586 */ // Label 1998: @123586
     /* 123586 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(123963),
     /* 123591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123594 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123602 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(123647), // Rule ID 4091 //
     /* 123607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123621 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123645 */     GIR_RootConstrainSelectedInstOperands,
     /* 123646 */     // GIR_Coverage, 4091,
     /* 123646 */     GIR_EraseRootFromParent_Done,
     /* 123647 */   // Label 2143: @123647
     /* 123647 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(123692), // Rule ID 4092 //
     /* 123652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123666 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123690 */     GIR_RootConstrainSelectedInstOperands,
     /* 123691 */     // GIR_Coverage, 4092,
     /* 123691 */     GIR_EraseRootFromParent_Done,
     /* 123692 */   // Label 2144: @123692
     /* 123692 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123737), // Rule ID 4093 //
     /* 123697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123711 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123735 */     GIR_RootConstrainSelectedInstOperands,
     /* 123736 */     // GIR_Coverage, 4093,
     /* 123736 */     GIR_EraseRootFromParent_Done,
     /* 123737 */   // Label 2145: @123737
     /* 123737 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(123782), // Rule ID 4094 //
     /* 123742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123756 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123780 */     GIR_RootConstrainSelectedInstOperands,
     /* 123781 */     // GIR_Coverage, 4094,
     /* 123781 */     GIR_EraseRootFromParent_Done,
     /* 123782 */   // Label 2146: @123782
     /* 123782 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(123822), // Rule ID 4132 //
     /* 123787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123801 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123820 */     GIR_RootConstrainSelectedInstOperands,
     /* 123821 */     // GIR_Coverage, 4132,
     /* 123821 */     GIR_EraseRootFromParent_Done,
     /* 123822 */   // Label 2147: @123822
     /* 123822 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123862), // Rule ID 4136 //
     /* 123827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123841 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123860 */     GIR_RootConstrainSelectedInstOperands,
     /* 123861 */     // GIR_Coverage, 4136,
     /* 123861 */     GIR_EraseRootFromParent_Done,
     /* 123862 */   // Label 2148: @123862
     /* 123862 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(123902), // Rule ID 4162 //
     /* 123867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123881 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123900 */     GIR_RootConstrainSelectedInstOperands,
     /* 123901 */     // GIR_Coverage, 4162,
     /* 123901 */     GIR_EraseRootFromParent_Done,
     /* 123902 */   // Label 2149: @123902
     /* 123902 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123942), // Rule ID 4163 //
     /* 123907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123921 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123940 */     GIR_RootConstrainSelectedInstOperands,
     /* 123941 */     // GIR_Coverage, 4163,
     /* 123941 */     GIR_EraseRootFromParent_Done,
     /* 123942 */   // Label 2150: @123942
     /* 123942 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123962), // Rule ID 6428 //
     /* 123947 */     // MIs[0] Rn
     /* 123947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123955 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 123960 */     GIR_RootConstrainSelectedInstOperands,
     /* 123961 */     // GIR_Coverage, 6428,
     /* 123961 */     GIR_Done,
     /* 123962 */   // Label 2151: @123962
     /* 123962 */   GIM_Reject,
     /* 123963 */ // Label 2142: @123963
     /* 123963 */ GIM_Reject,
     /* 123964 */ // Label 1999: @123964
     /* 123964 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124171),
     /* 123969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123980 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124025), // Rule ID 4077 //
     /* 123985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123999 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124023 */     GIR_RootConstrainSelectedInstOperands,
     /* 124024 */     // GIR_Coverage, 4077,
     /* 124024 */     GIR_EraseRootFromParent_Done,
     /* 124025 */   // Label 2153: @124025
     /* 124025 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(124070), // Rule ID 4078 //
     /* 124030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124044 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124068 */     GIR_RootConstrainSelectedInstOperands,
     /* 124069 */     // GIR_Coverage, 4078,
     /* 124069 */     GIR_EraseRootFromParent_Done,
     /* 124070 */   // Label 2154: @124070
     /* 124070 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(124110), // Rule ID 4126 //
     /* 124075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124089 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124108 */     GIR_RootConstrainSelectedInstOperands,
     /* 124109 */     // GIR_Coverage, 4126,
     /* 124109 */     GIR_EraseRootFromParent_Done,
     /* 124110 */   // Label 2155: @124110
     /* 124110 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(124150), // Rule ID 4156 //
     /* 124115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124129 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124148 */     GIR_RootConstrainSelectedInstOperands,
     /* 124149 */     // GIR_Coverage, 4156,
     /* 124149 */     GIR_EraseRootFromParent_Done,
     /* 124150 */   // Label 2156: @124150
     /* 124150 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(124170), // Rule ID 6430 //
     /* 124155 */     // MIs[0] Rn
     /* 124155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124163 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 124168 */     GIR_RootConstrainSelectedInstOperands,
     /* 124169 */     // GIR_Coverage, 6430,
     /* 124169 */     GIR_Done,
     /* 124170 */   // Label 2157: @124170
     /* 124170 */   GIM_Reject,
     /* 124171 */ // Label 2152: @124171
     /* 124171 */ GIM_Reject,
     /* 124172 */ // Label 2000: @124172
     /* 124172 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(124549),
     /* 124177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124188 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(124233), // Rule ID 4095 //
     /* 124193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124207 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124231 */     GIR_RootConstrainSelectedInstOperands,
     /* 124232 */     // GIR_Coverage, 4095,
     /* 124232 */     GIR_EraseRootFromParent_Done,
     /* 124233 */   // Label 2159: @124233
     /* 124233 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(124278), // Rule ID 4096 //
     /* 124238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124252 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124276 */     GIR_RootConstrainSelectedInstOperands,
     /* 124277 */     // GIR_Coverage, 4096,
     /* 124277 */     GIR_EraseRootFromParent_Done,
     /* 124278 */   // Label 2160: @124278
     /* 124278 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(124323), // Rule ID 4097 //
     /* 124283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124297 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124321 */     GIR_RootConstrainSelectedInstOperands,
     /* 124322 */     // GIR_Coverage, 4097,
     /* 124322 */     GIR_EraseRootFromParent_Done,
     /* 124323 */   // Label 2161: @124323
     /* 124323 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(124368), // Rule ID 4098 //
     /* 124328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124342 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124366 */     GIR_RootConstrainSelectedInstOperands,
     /* 124367 */     // GIR_Coverage, 4098,
     /* 124367 */     GIR_EraseRootFromParent_Done,
     /* 124368 */   // Label 2162: @124368
     /* 124368 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(124408), // Rule ID 4135 //
     /* 124373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124387 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 4135,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 2163: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(124448), // Rule ID 4138 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124427 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124446 */     GIR_RootConstrainSelectedInstOperands,
     /* 124447 */     // GIR_Coverage, 4138,
     /* 124447 */     GIR_EraseRootFromParent_Done,
     /* 124448 */   // Label 2164: @124448
     /* 124448 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(124488), // Rule ID 4164 //
     /* 124453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124467 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124486 */     GIR_RootConstrainSelectedInstOperands,
     /* 124487 */     // GIR_Coverage, 4164,
     /* 124487 */     GIR_EraseRootFromParent_Done,
     /* 124488 */   // Label 2165: @124488
     /* 124488 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(124528), // Rule ID 4166 //
     /* 124493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124507 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124526 */     GIR_RootConstrainSelectedInstOperands,
     /* 124527 */     // GIR_Coverage, 4166,
     /* 124527 */     GIR_EraseRootFromParent_Done,
     /* 124528 */   // Label 2166: @124528
     /* 124528 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(124548), // Rule ID 6427 //
     /* 124533 */     // MIs[0] Rn
     /* 124533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124541 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 124546 */     GIR_RootConstrainSelectedInstOperands,
     /* 124547 */     // GIR_Coverage, 6427,
     /* 124547 */     GIR_Done,
     /* 124548 */   // Label 2167: @124548
     /* 124548 */   GIM_Reject,
     /* 124549 */ // Label 2158: @124549
     /* 124549 */ GIM_Reject,
     /* 124550 */ // Label 2001: @124550
     /* 124550 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124757),
     /* 124555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124558 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124566 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(124611), // Rule ID 4099 //
     /* 124571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124585 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124609 */     GIR_RootConstrainSelectedInstOperands,
     /* 124610 */     // GIR_Coverage, 4099,
     /* 124610 */     GIR_EraseRootFromParent_Done,
     /* 124611 */   // Label 2169: @124611
     /* 124611 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(124656), // Rule ID 4100 //
     /* 124616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124630 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124654 */     GIR_RootConstrainSelectedInstOperands,
     /* 124655 */     // GIR_Coverage, 4100,
     /* 124655 */     GIR_EraseRootFromParent_Done,
     /* 124656 */   // Label 2170: @124656
     /* 124656 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124696), // Rule ID 4134 //
     /* 124661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124675 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124694 */     GIR_RootConstrainSelectedInstOperands,
     /* 124695 */     // GIR_Coverage, 4134,
     /* 124695 */     GIR_EraseRootFromParent_Done,
     /* 124696 */   // Label 2171: @124696
     /* 124696 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124736), // Rule ID 4165 //
     /* 124701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124715 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 4165,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2172: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124756), // Rule ID 6426 //
     /* 124741 */     // MIs[0] Rn
     /* 124741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124749 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 124754 */     GIR_RootConstrainSelectedInstOperands,
     /* 124755 */     // GIR_Coverage, 6426,
     /* 124755 */     GIR_Done,
     /* 124756 */   // Label 2173: @124756
     /* 124756 */   GIM_Reject,
     /* 124757 */ // Label 2168: @124757
     /* 124757 */ GIM_Reject,
     /* 124758 */ // Label 2002: @124758
     /* 124758 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124821), // Rule ID 11002 //
     /* 124763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124777 */   // MIs[0] base
     /* 124777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124785 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124797 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 124805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124810 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124819 */   GIR_RootConstrainSelectedInstOperands,
     /* 124820 */   // GIR_Coverage, 11002,
     /* 124820 */   GIR_EraseRootFromParent_Done,
     /* 124821 */ // Label 2174: @124821
     /* 124821 */ GIM_Reject,
     /* 124822 */ // Label 2003: @124822
     /* 124822 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124885), // Rule ID 11008 //
     /* 124827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124841 */   // MIs[0] base
     /* 124841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124849 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124861 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 124869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124874 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124883 */   GIR_RootConstrainSelectedInstOperands,
     /* 124884 */   // GIR_Coverage, 11008,
     /* 124884 */   GIR_EraseRootFromParent_Done,
     /* 124885 */ // Label 2175: @124885
     /* 124885 */ GIM_Reject,
     /* 124886 */ // Label 2004: @124886
     /* 124886 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125059),
     /* 124891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124906 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124954), // Rule ID 10993 //
     /* 124911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124918 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124930 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124943 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124952 */     GIR_RootConstrainSelectedInstOperands,
     /* 124953 */     // GIR_Coverage, 10993,
     /* 124953 */     GIR_EraseRootFromParent_Done,
     /* 124954 */   // Label 2177: @124954
     /* 124954 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125002), // Rule ID 11011 //
     /* 124959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124966 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124991 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125000 */     GIR_RootConstrainSelectedInstOperands,
     /* 125001 */     // GIR_Coverage, 11011,
     /* 125001 */     GIR_EraseRootFromParent_Done,
     /* 125002 */   // Label 2178: @125002
     /* 125002 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125030), // Rule ID 11038 //
     /* 125007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125014 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125019 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125028 */     GIR_RootConstrainSelectedInstOperands,
     /* 125029 */     // GIR_Coverage, 11038,
     /* 125029 */     GIR_EraseRootFromParent_Done,
     /* 125030 */   // Label 2179: @125030
     /* 125030 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125058), // Rule ID 11050 //
     /* 125035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125042 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125047 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125056 */     GIR_RootConstrainSelectedInstOperands,
     /* 125057 */     // GIR_Coverage, 11050,
     /* 125057 */     GIR_EraseRootFromParent_Done,
     /* 125058 */   // Label 2180: @125058
     /* 125058 */   GIM_Reject,
     /* 125059 */ // Label 2176: @125059
     /* 125059 */ GIM_Reject,
     /* 125060 */ // Label 2005: @125060
     /* 125060 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(125123), // Rule ID 10999 //
     /* 125065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125079 */   // MIs[0] base
     /* 125079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125087 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 125107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125112 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125121 */   GIR_RootConstrainSelectedInstOperands,
     /* 125122 */   // GIR_Coverage, 10999,
     /* 125122 */   GIR_EraseRootFromParent_Done,
     /* 125123 */ // Label 2181: @125123
     /* 125123 */ GIM_Reject,
     /* 125124 */ // Label 2006: @125124
     /* 125124 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(125297),
     /* 125129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125144 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(125192), // Rule ID 10981 //
     /* 125149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125156 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125181 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125190 */     GIR_RootConstrainSelectedInstOperands,
     /* 125191 */     // GIR_Coverage, 10981,
     /* 125191 */     GIR_EraseRootFromParent_Done,
     /* 125192 */   // Label 2183: @125192
     /* 125192 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(125240), // Rule ID 11005 //
     /* 125197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125204 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125238 */     GIR_RootConstrainSelectedInstOperands,
     /* 125239 */     // GIR_Coverage, 11005,
     /* 125239 */     GIR_EraseRootFromParent_Done,
     /* 125240 */   // Label 2184: @125240
     /* 125240 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(125268), // Rule ID 11034 //
     /* 125245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125252 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125257 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125266 */     GIR_RootConstrainSelectedInstOperands,
     /* 125267 */     // GIR_Coverage, 11034,
     /* 125267 */     GIR_EraseRootFromParent_Done,
     /* 125268 */   // Label 2185: @125268
     /* 125268 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(125296), // Rule ID 11046 //
     /* 125273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125280 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125285 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125294 */     GIR_RootConstrainSelectedInstOperands,
     /* 125295 */     // GIR_Coverage, 11046,
     /* 125295 */     GIR_EraseRootFromParent_Done,
     /* 125296 */   // Label 2186: @125296
     /* 125296 */   GIM_Reject,
     /* 125297 */ // Label 2182: @125297
     /* 125297 */ GIM_Reject,
     /* 125298 */ // Label 2007: @125298
     /* 125298 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(125471),
     /* 125303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125318 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(125366), // Rule ID 10960 //
     /* 125323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125330 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125364 */     GIR_RootConstrainSelectedInstOperands,
     /* 125365 */     // GIR_Coverage, 10960,
     /* 125365 */     GIR_EraseRootFromParent_Done,
     /* 125366 */   // Label 2188: @125366
     /* 125366 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(125414), // Rule ID 10996 //
     /* 125371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125378 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125403 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125412 */     GIR_RootConstrainSelectedInstOperands,
     /* 125413 */     // GIR_Coverage, 10996,
     /* 125413 */     GIR_EraseRootFromParent_Done,
     /* 125414 */   // Label 2189: @125414
     /* 125414 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(125442), // Rule ID 11030 //
     /* 125419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125426 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 11030,
     /* 125441 */     GIR_EraseRootFromParent_Done,
     /* 125442 */   // Label 2190: @125442
     /* 125442 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125470), // Rule ID 11042 //
     /* 125447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125454 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125459 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125468 */     GIR_RootConstrainSelectedInstOperands,
     /* 125469 */     // GIR_Coverage, 11042,
     /* 125469 */     GIR_EraseRootFromParent_Done,
     /* 125470 */   // Label 2191: @125470
     /* 125470 */   GIM_Reject,
     /* 125471 */ // Label 2187: @125471
     /* 125471 */ GIM_Reject,
     /* 125472 */ // Label 2008: @125472
     /* 125472 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125515), // Rule ID 2428 //
     /* 125477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 125491 */   // MIs[0] base
     /* 125491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125499 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 125502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 125504 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125513 */   GIR_RootConstrainSelectedInstOperands,
     /* 125514 */   // GIR_Coverage, 2428,
     /* 125514 */   GIR_EraseRootFromParent_Done,
     /* 125515 */ // Label 2192: @125515
     /* 125515 */ GIM_Reject,
     /* 125516 */ // Label 2009: @125516
     /* 125516 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125613),
     /* 125521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125536 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125584), // Rule ID 10928 //
     /* 125541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125548 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 125568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125573 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125582 */     GIR_RootConstrainSelectedInstOperands,
     /* 125583 */     // GIR_Coverage, 10928,
     /* 125583 */     GIR_EraseRootFromParent_Done,
     /* 125584 */   // Label 2194: @125584
     /* 125584 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125612), // Rule ID 11026 //
     /* 125589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125596 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125601 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125610 */     GIR_RootConstrainSelectedInstOperands,
     /* 125611 */     // GIR_Coverage, 11026,
     /* 125611 */     GIR_EraseRootFromParent_Done,
     /* 125612 */   // Label 2195: @125612
     /* 125612 */   GIM_Reject,
     /* 125613 */ // Label 2193: @125613
     /* 125613 */ GIM_Reject,
     /* 125614 */ // Label 2010: @125614
     /* 125614 */ GIM_Reject,
     /* 125615 */ // Label 17: @125615
     /* 125615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2198*/ GIMT_Encode4(126664),
     /* 125626 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(125634),
     /* 125630 */ /*GILLT_s64*//*Label 2197*/ GIMT_Encode4(126048),
     /* 125634 */ // Label 2196: @125634
     /* 125634 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126047),
     /* 125639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125695), // Rule ID 247 //
     /* 125647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 125669 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 125669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125693 */     GIR_RootConstrainSelectedInstOperands,
     /* 125694 */     // GIR_Coverage, 247,
     /* 125694 */     GIR_EraseRootFromParent_Done,
     /* 125695 */   // Label 2200: @125695
     /* 125695 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125748), // Rule ID 248 //
     /* 125700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 125722 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125746 */     GIR_RootConstrainSelectedInstOperands,
     /* 125747 */     // GIR_Coverage, 248,
     /* 125747 */     GIR_EraseRootFromParent_Done,
     /* 125748 */   // Label 2201: @125748
     /* 125748 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125801), // Rule ID 251 //
     /* 125753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 125775 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 125775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 125778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125799 */     GIR_RootConstrainSelectedInstOperands,
     /* 125800 */     // GIR_Coverage, 251,
     /* 125800 */     GIR_EraseRootFromParent_Done,
     /* 125801 */   // Label 2202: @125801
     /* 125801 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125854), // Rule ID 252 //
     /* 125806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 125828 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 125828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 125831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125852 */     GIR_RootConstrainSelectedInstOperands,
     /* 125853 */     // GIR_Coverage, 252,
     /* 125853 */     GIR_EraseRootFromParent_Done,
     /* 125854 */   // Label 2203: @125854
     /* 125854 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125902), // Rule ID 268 //
     /* 125859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 125881 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 125881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 125884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125900 */     GIR_RootConstrainSelectedInstOperands,
     /* 125901 */     // GIR_Coverage, 268,
     /* 125901 */     GIR_EraseRootFromParent_Done,
     /* 125902 */   // Label 2204: @125902
     /* 125902 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125950), // Rule ID 270 //
     /* 125907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 125929 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 125929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 125932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125948 */     GIR_RootConstrainSelectedInstOperands,
     /* 125949 */     // GIR_Coverage, 270,
     /* 125949 */     GIR_EraseRootFromParent_Done,
     /* 125950 */   // Label 2205: @125950
     /* 125950 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125998), // Rule ID 289 //
     /* 125955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 125977 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 125977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125996 */     GIR_RootConstrainSelectedInstOperands,
     /* 125997 */     // GIR_Coverage, 289,
     /* 125997 */     GIR_EraseRootFromParent_Done,
     /* 125998 */   // Label 2206: @125998
     /* 125998 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126046), // Rule ID 291 //
     /* 126003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126025 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126044 */     GIR_RootConstrainSelectedInstOperands,
     /* 126045 */     // GIR_Coverage, 291,
     /* 126045 */     GIR_EraseRootFromParent_Done,
     /* 126046 */   // Label 2207: @126046
     /* 126046 */   GIM_Reject,
     /* 126047 */ // Label 2199: @126047
     /* 126047 */ GIM_Reject,
     /* 126048 */ // Label 2197: @126048
     /* 126048 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(126663),
     /* 126053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126056 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(126109), // Rule ID 249 //
     /* 126061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126083 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 126086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126107 */     GIR_RootConstrainSelectedInstOperands,
     /* 126108 */     // GIR_Coverage, 249,
     /* 126108 */     GIR_EraseRootFromParent_Done,
     /* 126109 */   // Label 2209: @126109
     /* 126109 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(126162), // Rule ID 250 //
     /* 126114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126136 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 126139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126160 */     GIR_RootConstrainSelectedInstOperands,
     /* 126161 */     // GIR_Coverage, 250,
     /* 126161 */     GIR_EraseRootFromParent_Done,
     /* 126162 */   // Label 2210: @126162
     /* 126162 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126215), // Rule ID 253 //
     /* 126167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126189 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 126192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126213 */     GIR_RootConstrainSelectedInstOperands,
     /* 126214 */     // GIR_Coverage, 253,
     /* 126214 */     GIR_EraseRootFromParent_Done,
     /* 126215 */   // Label 2211: @126215
     /* 126215 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(126268), // Rule ID 254 //
     /* 126220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126242 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 126245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126266 */     GIR_RootConstrainSelectedInstOperands,
     /* 126267 */     // GIR_Coverage, 254,
     /* 126267 */     GIR_EraseRootFromParent_Done,
     /* 126268 */   // Label 2212: @126268
     /* 126268 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126321), // Rule ID 255 //
     /* 126273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 126295 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 126295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 126298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126319 */     GIR_RootConstrainSelectedInstOperands,
     /* 126320 */     // GIR_Coverage, 255,
     /* 126320 */     GIR_EraseRootFromParent_Done,
     /* 126321 */   // Label 2213: @126321
     /* 126321 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126374), // Rule ID 256 //
     /* 126326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 126348 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 126348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 126351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126372 */     GIR_RootConstrainSelectedInstOperands,
     /* 126373 */     // GIR_Coverage, 256,
     /* 126373 */     GIR_EraseRootFromParent_Done,
     /* 126374 */   // Label 2214: @126374
     /* 126374 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126422), // Rule ID 269 //
     /* 126379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 126401 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 126401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 126404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126420 */     GIR_RootConstrainSelectedInstOperands,
     /* 126421 */     // GIR_Coverage, 269,
     /* 126421 */     GIR_EraseRootFromParent_Done,
     /* 126422 */   // Label 2215: @126422
     /* 126422 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126470), // Rule ID 271 //
     /* 126427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 126449 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 126449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 126452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126468 */     GIR_RootConstrainSelectedInstOperands,
     /* 126469 */     // GIR_Coverage, 271,
     /* 126469 */     GIR_EraseRootFromParent_Done,
     /* 126470 */   // Label 2216: @126470
     /* 126470 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126518), // Rule ID 272 //
     /* 126475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 126497 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 126497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 126500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126516 */     GIR_RootConstrainSelectedInstOperands,
     /* 126517 */     // GIR_Coverage, 272,
     /* 126517 */     GIR_EraseRootFromParent_Done,
     /* 126518 */   // Label 2217: @126518
     /* 126518 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126566), // Rule ID 290 //
     /* 126523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 126545 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126564 */     GIR_RootConstrainSelectedInstOperands,
     /* 126565 */     // GIR_Coverage, 290,
     /* 126565 */     GIR_EraseRootFromParent_Done,
     /* 126566 */   // Label 2218: @126566
     /* 126566 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126614), // Rule ID 292 //
     /* 126571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126593 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 126596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126612 */     GIR_RootConstrainSelectedInstOperands,
     /* 126613 */     // GIR_Coverage, 292,
     /* 126613 */     GIR_EraseRootFromParent_Done,
     /* 126614 */   // Label 2219: @126614
     /* 126614 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126662), // Rule ID 293 //
     /* 126619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 126641 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 126644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126660 */     GIR_RootConstrainSelectedInstOperands,
     /* 126661 */     // GIR_Coverage, 293,
     /* 126661 */     GIR_EraseRootFromParent_Done,
     /* 126662 */   // Label 2220: @126662
     /* 126662 */   GIM_Reject,
     /* 126663 */ // Label 2208: @126663
     /* 126663 */ GIM_Reject,
     /* 126664 */ // Label 2198: @126664
     /* 126664 */ GIM_Reject,
     /* 126665 */ // Label 18: @126665
     /* 126665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2223*/ GIMT_Encode4(129713),
     /* 126676 */ /*GILLT_s32*//*Label 2221*/ GIMT_Encode4(126684),
     /* 126680 */ /*GILLT_s64*//*Label 2222*/ GIMT_Encode4(128223),
     /* 126684 */ // Label 2221: @126684
     /* 126684 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126740), // Rule ID 229 //
     /* 126689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126714 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126738 */   GIR_RootConstrainSelectedInstOperands,
     /* 126739 */   // GIR_Coverage, 229,
     /* 126739 */   GIR_EraseRootFromParent_Done,
     /* 126740 */ // Label 2224: @126740
     /* 126740 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126796), // Rule ID 230 //
     /* 126745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126770 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126794 */   GIR_RootConstrainSelectedInstOperands,
     /* 126795 */   // GIR_Coverage, 230,
     /* 126795 */   GIR_EraseRootFromParent_Done,
     /* 126796 */ // Label 2225: @126796
     /* 126796 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126852), // Rule ID 231 //
     /* 126801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126819 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126826 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 126829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126850 */   GIR_RootConstrainSelectedInstOperands,
     /* 126851 */   // GIR_Coverage, 231,
     /* 126851 */   GIR_EraseRootFromParent_Done,
     /* 126852 */ // Label 2226: @126852
     /* 126852 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126908), // Rule ID 232 //
     /* 126857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126882 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 126885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126906 */   GIR_RootConstrainSelectedInstOperands,
     /* 126907 */   // GIR_Coverage, 232,
     /* 126907 */   GIR_EraseRootFromParent_Done,
     /* 126908 */ // Label 2227: @126908
     /* 126908 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126964), // Rule ID 4123 //
     /* 126913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126938 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126962 */   GIR_RootConstrainSelectedInstOperands,
     /* 126963 */   // GIR_Coverage, 4123,
     /* 126963 */   GIR_EraseRootFromParent_Done,
     /* 126964 */ // Label 2228: @126964
     /* 126964 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127020), // Rule ID 4124 //
     /* 126969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126994 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127018 */   GIR_RootConstrainSelectedInstOperands,
     /* 127019 */   // GIR_Coverage, 4124,
     /* 127019 */   GIR_EraseRootFromParent_Done,
     /* 127020 */ // Label 2229: @127020
     /* 127020 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127071), // Rule ID 266 //
     /* 127025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127043 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127050 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127069 */   GIR_RootConstrainSelectedInstOperands,
     /* 127070 */   // GIR_Coverage, 266,
     /* 127070 */   GIR_EraseRootFromParent_Done,
     /* 127071 */ // Label 2230: @127071
     /* 127071 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127122), // Rule ID 267 //
     /* 127076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127101 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127120 */   GIR_RootConstrainSelectedInstOperands,
     /* 127121 */   // GIR_Coverage, 267,
     /* 127121 */   GIR_EraseRootFromParent_Done,
     /* 127122 */ // Label 2231: @127122
     /* 127122 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127181), // Rule ID 7063 //
     /* 127127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127137 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127155 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 127155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 127158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127179 */   GIR_RootConstrainSelectedInstOperands,
     /* 127180 */   // GIR_Coverage, 7063,
     /* 127180 */   GIR_EraseRootFromParent_Done,
     /* 127181 */ // Label 2232: @127181
     /* 127181 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(127240), // Rule ID 7065 //
     /* 127186 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127196 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127214 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 127214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 127217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127238 */   GIR_RootConstrainSelectedInstOperands,
     /* 127239 */   // GIR_Coverage, 7065,
     /* 127239 */   GIR_EraseRootFromParent_Done,
     /* 127240 */ // Label 2233: @127240
     /* 127240 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127299), // Rule ID 7075 //
     /* 127245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127255 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127273 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 127276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127297 */   GIR_RootConstrainSelectedInstOperands,
     /* 127298 */   // GIR_Coverage, 7075,
     /* 127298 */   GIR_EraseRootFromParent_Done,
     /* 127299 */ // Label 2234: @127299
     /* 127299 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127358), // Rule ID 7077 //
     /* 127304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127314 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127332 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 127335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127356 */   GIR_RootConstrainSelectedInstOperands,
     /* 127357 */   // GIR_Coverage, 7077,
     /* 127357 */   GIR_EraseRootFromParent_Done,
     /* 127358 */ // Label 2235: @127358
     /* 127358 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127409), // Rule ID 287 //
     /* 127363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127388 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127407 */   GIR_RootConstrainSelectedInstOperands,
     /* 127408 */   // GIR_Coverage, 287,
     /* 127408 */   GIR_EraseRootFromParent_Done,
     /* 127409 */ // Label 2236: @127409
     /* 127409 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127460), // Rule ID 288 //
     /* 127414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127439 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127458 */   GIR_RootConstrainSelectedInstOperands,
     /* 127459 */   // GIR_Coverage, 288,
     /* 127459 */   GIR_EraseRootFromParent_Done,
     /* 127460 */ // Label 2237: @127460
     /* 127460 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127511), // Rule ID 4142 //
     /* 127465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127490 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127509 */   GIR_RootConstrainSelectedInstOperands,
     /* 127510 */   // GIR_Coverage, 4142,
     /* 127510 */   GIR_EraseRootFromParent_Done,
     /* 127511 */ // Label 2238: @127511
     /* 127511 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127562), // Rule ID 4174 //
     /* 127516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127541 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127560 */   GIR_RootConstrainSelectedInstOperands,
     /* 127561 */   // GIR_Coverage, 4174,
     /* 127561 */   GIR_EraseRootFromParent_Done,
     /* 127562 */ // Label 2239: @127562
     /* 127562 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127613), // Rule ID 4175 //
     /* 127567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127592 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127611 */   GIR_RootConstrainSelectedInstOperands,
     /* 127612 */   // GIR_Coverage, 4175,
     /* 127612 */   GIR_EraseRootFromParent_Done,
     /* 127613 */ // Label 2240: @127613
     /* 127613 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127664), // Rule ID 4176 //
     /* 127618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127621 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127643 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127662 */   GIR_RootConstrainSelectedInstOperands,
     /* 127663 */   // GIR_Coverage, 4176,
     /* 127663 */   GIR_EraseRootFromParent_Done,
     /* 127664 */ // Label 2241: @127664
     /* 127664 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127718), // Rule ID 7067 //
     /* 127669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127679 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127697 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15835>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127716 */   GIR_RootConstrainSelectedInstOperands,
     /* 127717 */   // GIR_Coverage, 7067,
     /* 127717 */   GIR_EraseRootFromParent_Done,
     /* 127718 */ // Label 2242: @127718
     /* 127718 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127772), // Rule ID 7069 //
     /* 127723 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127733 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127751 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15835>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127770 */   GIR_RootConstrainSelectedInstOperands,
     /* 127771 */   // GIR_Coverage, 7069,
     /* 127771 */   GIR_EraseRootFromParent_Done,
     /* 127772 */ // Label 2243: @127772
     /* 127772 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127826), // Rule ID 7079 //
     /* 127777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127805 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15843>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127824 */   GIR_RootConstrainSelectedInstOperands,
     /* 127825 */   // GIR_Coverage, 7079,
     /* 127825 */   GIR_EraseRootFromParent_Done,
     /* 127826 */ // Label 2244: @127826
     /* 127826 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127880), // Rule ID 7081 //
     /* 127831 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127834 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127841 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127859 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15843>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127878 */   GIR_RootConstrainSelectedInstOperands,
     /* 127879 */   // GIR_Coverage, 7081,
     /* 127879 */   GIR_EraseRootFromParent_Done,
     /* 127880 */ // Label 2245: @127880
     /* 127880 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127937), // Rule ID 7473 //
     /* 127885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127888 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127916 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15824>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 127919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127935 */   GIR_RootConstrainSelectedInstOperands,
     /* 127936 */   // GIR_Coverage, 7473,
     /* 127936 */   GIR_EraseRootFromParent_Done,
     /* 127937 */ // Label 2246: @127937
     /* 127937 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127994), // Rule ID 7475 //
     /* 127942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127945 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127973 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15826>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 127976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127992 */   GIR_RootConstrainSelectedInstOperands,
     /* 127993 */   // GIR_Coverage, 7475,
     /* 127993 */   GIR_EraseRootFromParent_Done,
     /* 127994 */ // Label 2247: @127994
     /* 127994 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128034), // Rule ID 7053 //
     /* 127999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128002 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128012 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128019 */   // MIs[0] ptr
     /* 128019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128027 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15824>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 128032 */   GIR_RootConstrainSelectedInstOperands,
     /* 128033 */   // GIR_Coverage, 7053,
     /* 128033 */   GIR_Done,
     /* 128034 */ // Label 2248: @128034
     /* 128034 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128074), // Rule ID 7055 //
     /* 128039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 128042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128059 */   // MIs[0] ptr
     /* 128059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128067 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15826>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 128072 */   GIR_RootConstrainSelectedInstOperands,
     /* 128073 */   // GIR_Coverage, 7055,
     /* 128073 */   GIR_Done,
     /* 128074 */ // Label 2249: @128074
     /* 128074 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128111), // Rule ID 7059 //
     /* 128079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128096 */   // MIs[0] ptr
     /* 128096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128104 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15832>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128109 */   GIR_RootConstrainSelectedInstOperands,
     /* 128110 */   // GIR_Coverage, 7059,
     /* 128110 */   GIR_Done,
     /* 128111 */ // Label 2250: @128111
     /* 128111 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128148), // Rule ID 7061 //
     /* 128116 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128133 */   // MIs[0] ptr
     /* 128133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128141 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15824>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128146 */   GIR_RootConstrainSelectedInstOperands,
     /* 128147 */   // GIR_Coverage, 7061,
     /* 128147 */   GIR_Done,
     /* 128148 */ // Label 2251: @128148
     /* 128148 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128185), // Rule ID 7071 //
     /* 128153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128170 */   // MIs[0] ptr
     /* 128170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128178 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15840>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128183 */   GIR_RootConstrainSelectedInstOperands,
     /* 128184 */   // GIR_Coverage, 7071,
     /* 128184 */   GIR_Done,
     /* 128185 */ // Label 2252: @128185
     /* 128185 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128222), // Rule ID 7073 //
     /* 128190 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128193 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128207 */   // MIs[0] ptr
     /* 128207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128215 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15826>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128220 */   GIR_RootConstrainSelectedInstOperands,
     /* 128221 */   // GIR_Coverage, 7073,
     /* 128221 */   GIR_Done,
     /* 128222 */ // Label 2253: @128222
     /* 128222 */ GIM_Reject,
     /* 128223 */ // Label 2222: @128223
     /* 128223 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129712),
     /* 128228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128231 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(128316), // Rule ID 4101 //
     /* 128236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128258 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128315 */     // GIR_Coverage, 4101,
     /* 128315 */     GIR_EraseRootFromParent_Done,
     /* 128316 */   // Label 2255: @128316
     /* 128316 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128401), // Rule ID 4102 //
     /* 128321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128343 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128400 */     // GIR_Coverage, 4102,
     /* 128400 */     GIR_EraseRootFromParent_Done,
     /* 128401 */   // Label 2256: @128401
     /* 128401 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128486), // Rule ID 4103 //
     /* 128406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128428 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128485 */     // GIR_Coverage, 4103,
     /* 128485 */     GIR_EraseRootFromParent_Done,
     /* 128486 */   // Label 2257: @128486
     /* 128486 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128571), // Rule ID 4104 //
     /* 128491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128513 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */     // GIR_Coverage, 4104,
     /* 128570 */     GIR_EraseRootFromParent_Done,
     /* 128571 */   // Label 2258: @128571
     /* 128571 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128656), // Rule ID 4105 //
     /* 128576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 128598 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 128605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128655 */     // GIR_Coverage, 4105,
     /* 128655 */     GIR_EraseRootFromParent_Done,
     /* 128656 */   // Label 2259: @128656
     /* 128656 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128741), // Rule ID 4106 //
     /* 128661 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 128683 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 128690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128740 */     // GIR_Coverage, 4106,
     /* 128740 */     GIR_EraseRootFromParent_Done,
     /* 128741 */   // Label 2260: @128741
     /* 128741 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128826), // Rule ID 4107 //
     /* 128746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128768 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128795 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128825 */     // GIR_Coverage, 4107,
     /* 128825 */     GIR_EraseRootFromParent_Done,
     /* 128826 */   // Label 2261: @128826
     /* 128826 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128911), // Rule ID 4108 //
     /* 128831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128853 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128880 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128910 */     // GIR_Coverage, 4108,
     /* 128910 */     GIR_EraseRootFromParent_Done,
     /* 128911 */   // Label 2262: @128911
     /* 128911 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128991), // Rule ID 4140 //
     /* 128916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128938 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128960 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128990 */     // GIR_Coverage, 4140,
     /* 128990 */     GIR_EraseRootFromParent_Done,
     /* 128991 */   // Label 2263: @128991
     /* 128991 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129071), // Rule ID 4141 //
     /* 128996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129018 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129070 */     // GIR_Coverage, 4141,
     /* 129070 */     GIR_EraseRootFromParent_Done,
     /* 129071 */   // Label 2264: @129071
     /* 129071 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129151), // Rule ID 4143 //
     /* 129076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129098 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129150 */     // GIR_Coverage, 4143,
     /* 129150 */     GIR_EraseRootFromParent_Done,
     /* 129151 */   // Label 2265: @129151
     /* 129151 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129231), // Rule ID 4151 //
     /* 129156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 129178 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 129185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129200 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129230 */     // GIR_Coverage, 4151,
     /* 129230 */     GIR_EraseRootFromParent_Done,
     /* 129231 */   // Label 2266: @129231
     /* 129231 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129311), // Rule ID 4177 //
     /* 129236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 129258 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 129265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129280 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129310 */     // GIR_Coverage, 4177,
     /* 129310 */     GIR_EraseRootFromParent_Done,
     /* 129311 */   // Label 2267: @129311
     /* 129311 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129391), // Rule ID 4178 //
     /* 129316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129338 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129390 */     // GIR_Coverage, 4178,
     /* 129390 */     GIR_EraseRootFromParent_Done,
     /* 129391 */   // Label 2268: @129391
     /* 129391 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129471), // Rule ID 4179 //
     /* 129396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129418 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129470 */     // GIR_Coverage, 4179,
     /* 129470 */     GIR_EraseRootFromParent_Done,
     /* 129471 */   // Label 2269: @129471
     /* 129471 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129551), // Rule ID 4180 //
     /* 129476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129498 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129550 */     // GIR_Coverage, 4180,
     /* 129550 */     GIR_EraseRootFromParent_Done,
     /* 129551 */   // Label 2270: @129551
     /* 129551 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129631), // Rule ID 4181 //
     /* 129556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129578 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129630 */     // GIR_Coverage, 4181,
     /* 129630 */     GIR_EraseRootFromParent_Done,
     /* 129631 */   // Label 2271: @129631
     /* 129631 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129711), // Rule ID 4182 //
     /* 129636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129658 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129710 */     // GIR_Coverage, 4182,
     /* 129710 */     GIR_EraseRootFromParent_Done,
     /* 129711 */   // Label 2272: @129711
     /* 129711 */   GIM_Reject,
     /* 129712 */ // Label 2254: @129712
     /* 129712 */ GIM_Reject,
     /* 129713 */ // Label 2223: @129713
     /* 129713 */ GIM_Reject,
     /* 129714 */ // Label 19: @129714
     /* 129714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2293*/ GIMT_Encode4(143239),
     /* 129725 */ /*GILLT_s8*//*Label 2273*/ GIMT_Encode4(129821),
     /* 129729 */ /*GILLT_s16*//*Label 2274*/ GIMT_Encode4(130188),
     /* 129733 */ /*GILLT_s32*//*Label 2275*/ GIMT_Encode4(131327),
     /* 129737 */ /*GILLT_s64*//*Label 2276*/ GIMT_Encode4(135922),
     /* 129741 */ /*GILLT_s128*//*Label 2277*/ GIMT_Encode4(139691),
     /* 129745 */ /*GILLT_v2s32*//*Label 2278*/ GIMT_Encode4(139897),
     /* 129749 */ /*GILLT_v2s64*//*Label 2279*/ GIMT_Encode4(140303),
     /* 129753 */ /*GILLT_v4s16*//*Label 2280*/ GIMT_Encode4(140753),
     /* 129757 */ /*GILLT_v4s32*//*Label 2281*/ GIMT_Encode4(141159),
     /* 129761 */ /*GILLT_v8s8*//*Label 2282*/ GIMT_Encode4(141565),
     /* 129765 */ /*GILLT_v8s16*//*Label 2283*/ GIMT_Encode4(141785),
     /* 129769 */ /*GILLT_v16s8*//*Label 2284*/ GIMT_Encode4(142191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129781 */ /*GILLT_nxv2s16*//*Label 2285*/ GIMT_Encode4(142411),
     /* 129785 */ /*GILLT_nxv2s32*//*Label 2286*/ GIMT_Encode4(142471),
     /* 129789 */ /*GILLT_nxv2s64*//*Label 2287*/ GIMT_Encode4(142531), GIMT_Encode4(0),
     /* 129797 */ /*GILLT_nxv4s16*//*Label 2288*/ GIMT_Encode4(142701),
     /* 129801 */ /*GILLT_nxv4s32*//*Label 2289*/ GIMT_Encode4(142761), GIMT_Encode4(0),
     /* 129809 */ /*GILLT_nxv8s16*//*Label 2290*/ GIMT_Encode4(142931),
     /* 129813 */ /*GILLT_nxv16s1*//*Label 2291*/ GIMT_Encode4(143101),
     /* 129817 */ /*GILLT_nxv16s8*//*Label 2292*/ GIMT_Encode4(143145),
     /* 129821 */ // Label 2273: @129821
     /* 129821 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(130187),
     /* 129826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129829 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129833 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129901), // Rule ID 13262 //
     /* 129838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129871 */     // MIs[2] Operand 1
     /* 129871 */     // No operand predicates
     /* 129871 */     // MIs[0] Rn
     /* 129871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129881 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129899 */     GIR_RootConstrainSelectedInstOperands,
     /* 129900 */     // GIR_Coverage, 13262,
     /* 129900 */     GIR_EraseRootFromParent_Done,
     /* 129901 */   // Label 2295: @129901
     /* 129901 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(130000), // Rule ID 13263 //
     /* 129906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 129918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129939 */     // MIs[2] Operand 1
     /* 129939 */     // No operand predicates
     /* 129939 */     // MIs[0] Rn
     /* 129939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129949 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 129952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 129964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 129971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129998 */     GIR_RootConstrainSelectedInstOperands,
     /* 129999 */     // GIR_Coverage, 13263,
     /* 129999 */     GIR_EraseRootFromParent_Done,
     /* 130000 */   // Label 2296: @130000
     /* 130000 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(130049), // Rule ID 303 //
     /* 130005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130023 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 130023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 130026 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130047 */     GIR_RootConstrainSelectedInstOperands,
     /* 130048 */     // GIR_Coverage, 303,
     /* 130048 */     GIR_EraseRootFromParent_Done,
     /* 130049 */   // Label 2297: @130049
     /* 130049 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(130098), // Rule ID 304 //
     /* 130054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130072 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 130072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 130075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130096 */     GIR_RootConstrainSelectedInstOperands,
     /* 130097 */     // GIR_Coverage, 304,
     /* 130097 */     GIR_EraseRootFromParent_Done,
     /* 130098 */   // Label 2298: @130098
     /* 130098 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130142), // Rule ID 313 //
     /* 130103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130121 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 130121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 130124 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130140 */     GIR_RootConstrainSelectedInstOperands,
     /* 130141 */     // GIR_Coverage, 313,
     /* 130141 */     GIR_EraseRootFromParent_Done,
     /* 130142 */   // Label 2299: @130142
     /* 130142 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130186), // Rule ID 321 //
     /* 130147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130165 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 130165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 130168 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130184 */     GIR_RootConstrainSelectedInstOperands,
     /* 130185 */     // GIR_Coverage, 321,
     /* 130185 */     GIR_EraseRootFromParent_Done,
     /* 130186 */   // Label 2300: @130186
     /* 130186 */   GIM_Reject,
     /* 130187 */ // Label 2294: @130187
     /* 130187 */ GIM_Reject,
     /* 130188 */ // Label 2274: @130188
     /* 130188 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(131326),
     /* 130193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130200 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130299), // Rule ID 4515 //
     /* 130205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130243 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130297 */     GIR_RootConstrainSelectedInstOperands,
     /* 130298 */     // GIR_Coverage, 4515,
     /* 130298 */     GIR_EraseRootFromParent_Done,
     /* 130299 */   // Label 2302: @130299
     /* 130299 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130398), // Rule ID 4516 //
     /* 130304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130342 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130354 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130396 */     GIR_RootConstrainSelectedInstOperands,
     /* 130397 */     // GIR_Coverage, 4516,
     /* 130397 */     GIR_EraseRootFromParent_Done,
     /* 130398 */   // Label 2303: @130398
     /* 130398 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130497), // Rule ID 13260 //
     /* 130403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130441 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130495 */     GIR_RootConstrainSelectedInstOperands,
     /* 130496 */     // GIR_Coverage, 13260,
     /* 130496 */     GIR_EraseRootFromParent_Done,
     /* 130497 */   // Label 2304: @130497
     /* 130497 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130596), // Rule ID 13261 //
     /* 130502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130540 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130594 */     GIR_RootConstrainSelectedInstOperands,
     /* 130595 */     // GIR_Coverage, 13261,
     /* 130595 */     GIR_EraseRootFromParent_Done,
     /* 130596 */   // Label 2305: @130596
     /* 130596 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130690), // Rule ID 4544 //
     /* 130601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130639 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130688 */     GIR_RootConstrainSelectedInstOperands,
     /* 130689 */     // GIR_Coverage, 4544,
     /* 130689 */     GIR_EraseRootFromParent_Done,
     /* 130690 */   // Label 2306: @130690
     /* 130690 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130784), // Rule ID 4571 //
     /* 130695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 130733 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130782 */     GIR_RootConstrainSelectedInstOperands,
     /* 130783 */     // GIR_Coverage, 4571,
     /* 130783 */     GIR_EraseRootFromParent_Done,
     /* 130784 */   // Label 2307: @130784
     /* 130784 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130878), // Rule ID 13259 //
     /* 130789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130827 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130839 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130876 */     GIR_RootConstrainSelectedInstOperands,
     /* 130877 */     // GIR_Coverage, 13259,
     /* 130877 */     GIR_EraseRootFromParent_Done,
     /* 130878 */   // Label 2308: @130878
     /* 130878 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130972), // Rule ID 13265 //
     /* 130883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 130921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130970 */     GIR_RootConstrainSelectedInstOperands,
     /* 130971 */     // GIR_Coverage, 13265,
     /* 130971 */     GIR_EraseRootFromParent_Done,
     /* 130972 */   // Label 2309: @130972
     /* 130972 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131040), // Rule ID 6495 //
     /* 130977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131010 */     // MIs[2] Operand 1
     /* 131010 */     // No operand predicates
     /* 131010 */     // MIs[0] Rn
     /* 131010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131020 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131038 */     GIR_RootConstrainSelectedInstOperands,
     /* 131039 */     // GIR_Coverage, 6495,
     /* 131039 */     GIR_EraseRootFromParent_Done,
     /* 131040 */   // Label 2310: @131040
     /* 131040 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131139), // Rule ID 6500 //
     /* 131045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 131078 */     // MIs[2] Operand 1
     /* 131078 */     // No operand predicates
     /* 131078 */     // MIs[0] Rn
     /* 131078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131088 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131137 */     GIR_RootConstrainSelectedInstOperands,
     /* 131138 */     // GIR_Coverage, 6500,
     /* 131138 */     GIR_EraseRootFromParent_Done,
     /* 131139 */   // Label 2311: @131139
     /* 131139 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131188), // Rule ID 305 //
     /* 131144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131162 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131165 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131186 */     GIR_RootConstrainSelectedInstOperands,
     /* 131187 */     // GIR_Coverage, 305,
     /* 131187 */     GIR_EraseRootFromParent_Done,
     /* 131188 */   // Label 2312: @131188
     /* 131188 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131237), // Rule ID 306 //
     /* 131193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131211 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131214 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131235 */     GIR_RootConstrainSelectedInstOperands,
     /* 131236 */     // GIR_Coverage, 306,
     /* 131236 */     GIR_EraseRootFromParent_Done,
     /* 131237 */   // Label 2313: @131237
     /* 131237 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131281), // Rule ID 314 //
     /* 131242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 131260 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 131260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 131263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131279 */     GIR_RootConstrainSelectedInstOperands,
     /* 131280 */     // GIR_Coverage, 314,
     /* 131280 */     GIR_EraseRootFromParent_Done,
     /* 131281 */   // Label 2314: @131281
     /* 131281 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131325), // Rule ID 322 //
     /* 131286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131304 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 131307 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131323 */     GIR_RootConstrainSelectedInstOperands,
     /* 131324 */     // GIR_Coverage, 322,
     /* 131324 */     GIR_EraseRootFromParent_Done,
     /* 131325 */   // Label 2315: @131325
     /* 131325 */   GIM_Reject,
     /* 131326 */ // Label 2301: @131326
     /* 131326 */ GIM_Reject,
     /* 131327 */ // Label 2275: @131327
     /* 131327 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131440), // Rule ID 4513 //
     /* 131332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131367 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131384 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131396 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131438 */   GIR_RootConstrainSelectedInstOperands,
     /* 131439 */   // GIR_Coverage, 4513,
     /* 131439 */   GIR_EraseRootFromParent_Done,
     /* 131440 */ // Label 2316: @131440
     /* 131440 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131553), // Rule ID 4514 //
     /* 131445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131497 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131551 */   GIR_RootConstrainSelectedInstOperands,
     /* 131552 */   // GIR_Coverage, 4514,
     /* 131552 */   GIR_EraseRootFromParent_Done,
     /* 131553 */ // Label 2317: @131553
     /* 131553 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131659), // Rule ID 4517 //
     /* 131558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131603 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131615 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131657 */   GIR_RootConstrainSelectedInstOperands,
     /* 131658 */   // GIR_Coverage, 4517,
     /* 131658 */   GIR_EraseRootFromParent_Done,
     /* 131659 */ // Label 2318: @131659
     /* 131659 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131765), // Rule ID 4518 //
     /* 131664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131709 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131721 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131763 */   GIR_RootConstrainSelectedInstOperands,
     /* 131764 */   // GIR_Coverage, 4518,
     /* 131764 */   GIR_EraseRootFromParent_Done,
     /* 131765 */ // Label 2319: @131765
     /* 131765 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131871), // Rule ID 4519 //
     /* 131770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131798 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131815 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131827 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131869 */   GIR_RootConstrainSelectedInstOperands,
     /* 131870 */   // GIR_Coverage, 4519,
     /* 131870 */   GIR_EraseRootFromParent_Done,
     /* 131871 */ // Label 2320: @131871
     /* 131871 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131977), // Rule ID 4520 //
     /* 131876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131921 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */   GIR_RootConstrainSelectedInstOperands,
     /* 131976 */   // GIR_Coverage, 4520,
     /* 131976 */   GIR_EraseRootFromParent_Done,
     /* 131977 */ // Label 2321: @131977
     /* 131977 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132083), // Rule ID 13267 //
     /* 131982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132010 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 132027 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 132027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132039 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 132058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132081 */   GIR_RootConstrainSelectedInstOperands,
     /* 132082 */   // GIR_Coverage, 13267,
     /* 132082 */   GIR_EraseRootFromParent_Done,
     /* 132083 */ // Label 2322: @132083
     /* 132083 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132189), // Rule ID 13268 //
     /* 132088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132107 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132116 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 132133 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 132133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132145 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 132164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132187 */   GIR_RootConstrainSelectedInstOperands,
     /* 132188 */   // GIR_Coverage, 13268,
     /* 132188 */   GIR_EraseRootFromParent_Done,
     /* 132189 */ // Label 2323: @132189
     /* 132189 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132297), // Rule ID 4543 //
     /* 132194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132197 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132229 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132246 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132258 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132295 */   GIR_RootConstrainSelectedInstOperands,
     /* 132296 */   // GIR_Coverage, 4543,
     /* 132296 */   GIR_EraseRootFromParent_Done,
     /* 132297 */ // Label 2324: @132297
     /* 132297 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132398), // Rule ID 4545 //
     /* 132302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132305 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132317 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132321 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132330 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132347 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132359 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132396 */   GIR_RootConstrainSelectedInstOperands,
     /* 132397 */   // GIR_Coverage, 4545,
     /* 132397 */   GIR_EraseRootFromParent_Done,
     /* 132398 */ // Label 2325: @132398
     /* 132398 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132499), // Rule ID 4546 //
     /* 132403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132431 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132439 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132448 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132460 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132497 */   GIR_RootConstrainSelectedInstOperands,
     /* 132498 */   // GIR_Coverage, 4546,
     /* 132498 */   GIR_EraseRootFromParent_Done,
     /* 132499 */ // Label 2326: @132499
     /* 132499 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132607), // Rule ID 4570 //
     /* 132504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132530 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132539 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132556 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132568 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132605 */   GIR_RootConstrainSelectedInstOperands,
     /* 132606 */   // GIR_Coverage, 4570,
     /* 132606 */   GIR_EraseRootFromParent_Done,
     /* 132607 */ // Label 2327: @132607
     /* 132607 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132708), // Rule ID 4572 //
     /* 132612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132631 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132640 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132657 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132669 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132706 */   GIR_RootConstrainSelectedInstOperands,
     /* 132707 */   // GIR_Coverage, 4572,
     /* 132707 */   GIR_EraseRootFromParent_Done,
     /* 132708 */ // Label 2328: @132708
     /* 132708 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132809), // Rule ID 4573 //
     /* 132713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132728 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132736 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132741 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132758 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132770 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132807 */   GIR_RootConstrainSelectedInstOperands,
     /* 132808 */   // GIR_Coverage, 4573,
     /* 132808 */   GIR_EraseRootFromParent_Done,
     /* 132809 */ // Label 2329: @132809
     /* 132809 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132910), // Rule ID 13264 //
     /* 132814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132829 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132842 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132859 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132871 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132908 */   GIR_RootConstrainSelectedInstOperands,
     /* 132909 */   // GIR_Coverage, 13264,
     /* 132909 */   GIR_EraseRootFromParent_Done,
     /* 132910 */ // Label 2330: @132910
     /* 132910 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133011), // Rule ID 13266 //
     /* 132915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132960 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133009 */   GIR_RootConstrainSelectedInstOperands,
     /* 133010 */   // GIR_Coverage, 13266,
     /* 133010 */   GIR_EraseRootFromParent_Done,
     /* 133011 */ // Label 2331: @133011
     /* 133011 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133093), // Rule ID 6489 //
     /* 133016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133019 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 133042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133059 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133063 */   // MIs[2] Operand 1
     /* 133063 */   // No operand predicates
     /* 133063 */   // MIs[0] Rn
     /* 133063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133071 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133073 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133091 */   GIR_RootConstrainSelectedInstOperands,
     /* 133092 */   // GIR_Coverage, 6489,
     /* 133092 */   GIR_EraseRootFromParent_Done,
     /* 133093 */ // Label 2332: @133093
     /* 133093 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133175), // Rule ID 6490 //
     /* 133098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133128 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133133 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133137 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133141 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133145 */   // MIs[2] Operand 1
     /* 133145 */   // No operand predicates
     /* 133145 */   // MIs[0] Rn
     /* 133145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133153 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133155 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133158 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133162 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133165 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133173 */   GIR_RootConstrainSelectedInstOperands,
     /* 133174 */   // GIR_Coverage, 6490,
     /* 133174 */   GIR_EraseRootFromParent_Done,
     /* 133175 */ // Label 2333: @133175
     /* 133175 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133250), // Rule ID 6491 //
     /* 133180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133208 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133212 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133216 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133220 */   // MIs[2] Operand 1
     /* 133220 */   // No operand predicates
     /* 133220 */   // MIs[0] Rn
     /* 133220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133228 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133230 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133237 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133240 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133248 */   GIR_RootConstrainSelectedInstOperands,
     /* 133249 */   // GIR_Coverage, 6491,
     /* 133249 */   GIR_EraseRootFromParent_Done,
     /* 133250 */ // Label 2334: @133250
     /* 133250 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133325), // Rule ID 6492 //
     /* 133255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133291 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133295 */   // MIs[2] Operand 1
     /* 133295 */   // No operand predicates
     /* 133295 */   // MIs[0] Rn
     /* 133295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133305 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133308 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133312 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133315 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133323 */   GIR_RootConstrainSelectedInstOperands,
     /* 133324 */   // GIR_Coverage, 6492,
     /* 133324 */   GIR_EraseRootFromParent_Done,
     /* 133325 */ // Label 2335: @133325
     /* 133325 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133438), // Rule ID 6496 //
     /* 133330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133333 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 133356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133365 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133369 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133373 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133377 */   // MIs[2] Operand 1
     /* 133377 */   // No operand predicates
     /* 133377 */   // MIs[0] Rn
     /* 133377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133385 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133387 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133402 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133406 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133425 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133428 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133436 */   GIR_RootConstrainSelectedInstOperands,
     /* 133437 */   // GIR_Coverage, 6496,
     /* 133437 */   GIR_EraseRootFromParent_Done,
     /* 133438 */ // Label 2336: @133438
     /* 133438 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133551), // Rule ID 6497 //
     /* 133443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133465 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 133469 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133473 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133478 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133482 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133486 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133490 */   // MIs[2] Operand 1
     /* 133490 */   // No operand predicates
     /* 133490 */   // MIs[0] Rn
     /* 133490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133500 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133549 */   GIR_RootConstrainSelectedInstOperands,
     /* 133550 */   // GIR_Coverage, 6497,
     /* 133550 */   GIR_EraseRootFromParent_Done,
     /* 133551 */ // Label 2337: @133551
     /* 133551 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133657), // Rule ID 6498 //
     /* 133556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133571 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133575 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133579 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133592 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133596 */   // MIs[2] Operand 1
     /* 133596 */   // No operand predicates
     /* 133596 */   // MIs[0] Rn
     /* 133596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133606 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133618 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133655 */   GIR_RootConstrainSelectedInstOperands,
     /* 133656 */   // GIR_Coverage, 6498,
     /* 133656 */   GIR_EraseRootFromParent_Done,
     /* 133657 */ // Label 2338: @133657
     /* 133657 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133763), // Rule ID 6499 //
     /* 133662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133677 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133690 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133694 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133698 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133702 */   // MIs[2] Operand 1
     /* 133702 */   // No operand predicates
     /* 133702 */   // MIs[0] Rn
     /* 133702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133710 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133712 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133724 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133731 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133761 */   GIR_RootConstrainSelectedInstOperands,
     /* 133762 */   // GIR_Coverage, 6499,
     /* 133762 */   GIR_EraseRootFromParent_Done,
     /* 133763 */ // Label 2339: @133763
     /* 133763 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133823), // Rule ID 295 //
     /* 133768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 133797 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 133797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 133800 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133821 */   GIR_RootConstrainSelectedInstOperands,
     /* 133822 */   // GIR_Coverage, 295,
     /* 133822 */   GIR_EraseRootFromParent_Done,
     /* 133823 */ // Label 2340: @133823
     /* 133823 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133883), // Rule ID 296 //
     /* 133828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133831 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 133857 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 133857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 133860 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133881 */   GIR_RootConstrainSelectedInstOperands,
     /* 133882 */   // GIR_Coverage, 296,
     /* 133882 */   GIR_EraseRootFromParent_Done,
     /* 133883 */ // Label 2341: @133883
     /* 133883 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133943), // Rule ID 297 //
     /* 133888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133891 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133917 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 133920 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133941 */   GIR_RootConstrainSelectedInstOperands,
     /* 133942 */   // GIR_Coverage, 297,
     /* 133942 */   GIR_EraseRootFromParent_Done,
     /* 133943 */ // Label 2342: @133943
     /* 133943 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134003), // Rule ID 298 //
     /* 133948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133951 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133955 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133977 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 133980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134001 */   GIR_RootConstrainSelectedInstOperands,
     /* 134002 */   // GIR_Coverage, 298,
     /* 134002 */   GIR_EraseRootFromParent_Done,
     /* 134003 */ // Label 2343: @134003
     /* 134003 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134056), // Rule ID 299 //
     /* 134008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134030 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134033 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134054 */   GIR_RootConstrainSelectedInstOperands,
     /* 134055 */   // GIR_Coverage, 299,
     /* 134055 */   GIR_EraseRootFromParent_Done,
     /* 134056 */ // Label 2344: @134056
     /* 134056 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134109), // Rule ID 300 //
     /* 134061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134083 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134086 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134107 */   GIR_RootConstrainSelectedInstOperands,
     /* 134108 */   // GIR_Coverage, 300,
     /* 134108 */   GIR_EraseRootFromParent_Done,
     /* 134109 */ // Label 2345: @134109
     /* 134109 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134165), // Rule ID 307 //
     /* 134114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134120 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134139 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134142 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134163 */   GIR_RootConstrainSelectedInstOperands,
     /* 134164 */   // GIR_Coverage, 307,
     /* 134164 */   GIR_EraseRootFromParent_Done,
     /* 134165 */ // Label 2346: @134165
     /* 134165 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134221), // Rule ID 308 //
     /* 134170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134195 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134198 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134219 */   GIR_RootConstrainSelectedInstOperands,
     /* 134220 */   // GIR_Coverage, 308,
     /* 134220 */   GIR_EraseRootFromParent_Done,
     /* 134221 */ // Label 2347: @134221
     /* 134221 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134273), // Rule ID 312 //
     /* 134226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134248 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 134251 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134271 */   GIR_RootConstrainSelectedInstOperands,
     /* 134272 */   // GIR_Coverage, 312,
     /* 134272 */   GIR_EraseRootFromParent_Done,
     /* 134273 */ // Label 2348: @134273
     /* 134273 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134324), // Rule ID 315 //
     /* 134278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134303 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134306 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134322 */   GIR_RootConstrainSelectedInstOperands,
     /* 134323 */   // GIR_Coverage, 315,
     /* 134323 */   GIR_EraseRootFromParent_Done,
     /* 134324 */ // Label 2349: @134324
     /* 134324 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134383), // Rule ID 317 //
     /* 134329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 134358 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 134358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 134361 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134381 */   GIR_RootConstrainSelectedInstOperands,
     /* 134382 */   // GIR_Coverage, 317,
     /* 134382 */   GIR_EraseRootFromParent_Done,
     /* 134383 */ // Label 2350: @134383
     /* 134383 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134442), // Rule ID 318 //
     /* 134388 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134391 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 134417 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 134417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 134420 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134440 */   GIR_RootConstrainSelectedInstOperands,
     /* 134441 */   // GIR_Coverage, 318,
     /* 134441 */   GIR_EraseRootFromParent_Done,
     /* 134442 */ // Label 2351: @134442
     /* 134442 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134519), // Rule ID 7122 //
     /* 134447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134457 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134468 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134490 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134493 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134517 */   GIR_RootConstrainSelectedInstOperands,
     /* 134518 */   // GIR_Coverage, 7122,
     /* 134518 */   GIR_EraseRootFromParent_Done,
     /* 134519 */ // Label 2352: @134519
     /* 134519 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134596), // Rule ID 7123 //
     /* 134524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134534 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134545 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134567 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134570 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134594 */   GIR_RootConstrainSelectedInstOperands,
     /* 134595 */   // GIR_Coverage, 7123,
     /* 134595 */   GIR_EraseRootFromParent_Done,
     /* 134596 */ // Label 2353: @134596
     /* 134596 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134655), // Rule ID 7103 //
     /* 134601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134611 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 134629 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 134629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 134632 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 7103,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2354: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134714), // Rule ID 7104 //
     /* 134660 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134670 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 134688 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 134688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 134691 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134712 */   GIR_RootConstrainSelectedInstOperands,
     /* 134713 */   // GIR_Coverage, 7104,
     /* 134713 */   GIR_EraseRootFromParent_Done,
     /* 134714 */ // Label 2355: @134714
     /* 134714 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134773), // Rule ID 7108 //
     /* 134719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 134747 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 134747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 134750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134771 */   GIR_RootConstrainSelectedInstOperands,
     /* 134772 */   // GIR_Coverage, 7108,
     /* 134772 */   GIR_EraseRootFromParent_Done,
     /* 134773 */ // Label 2356: @134773
     /* 134773 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134832), // Rule ID 7109 //
     /* 134778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 134806 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 134806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 134809 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134830 */   GIR_RootConstrainSelectedInstOperands,
     /* 134831 */   // GIR_Coverage, 7109,
     /* 134831 */   GIR_EraseRootFromParent_Done,
     /* 134832 */ // Label 2357: @134832
     /* 134832 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134891), // Rule ID 7113 //
     /* 134837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134847 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134865 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134868 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134889 */   GIR_RootConstrainSelectedInstOperands,
     /* 134890 */   // GIR_Coverage, 7113,
     /* 134890 */   GIR_EraseRootFromParent_Done,
     /* 134891 */ // Label 2358: @134891
     /* 134891 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134950), // Rule ID 7114 //
     /* 134896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134906 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134924 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134927 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134948 */   GIR_RootConstrainSelectedInstOperands,
     /* 134949 */   // GIR_Coverage, 7114,
     /* 134949 */   GIR_EraseRootFromParent_Done,
     /* 134950 */ // Label 2359: @134950
     /* 134950 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135022), // Rule ID 7124 //
     /* 134955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134965 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134998 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135020 */   GIR_RootConstrainSelectedInstOperands,
     /* 135021 */   // GIR_Coverage, 7124,
     /* 135021 */   GIR_EraseRootFromParent_Done,
     /* 135022 */ // Label 2360: @135022
     /* 135022 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135094), // Rule ID 7125 //
     /* 135027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135037 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135070 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135092 */   GIR_RootConstrainSelectedInstOperands,
     /* 135093 */   // GIR_Coverage, 7125,
     /* 135093 */   GIR_EraseRootFromParent_Done,
     /* 135094 */ // Label 2361: @135094
     /* 135094 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135146), // Rule ID 320 //
     /* 135099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135121 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135124 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135144 */   GIR_RootConstrainSelectedInstOperands,
     /* 135145 */   // GIR_Coverage, 320,
     /* 135145 */   GIR_EraseRootFromParent_Done,
     /* 135146 */ // Label 2362: @135146
     /* 135146 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135197), // Rule ID 323 //
     /* 135151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135157 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135176 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135179 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135195 */   GIR_RootConstrainSelectedInstOperands,
     /* 135196 */   // GIR_Coverage, 323,
     /* 135196 */   GIR_EraseRootFromParent_Done,
     /* 135197 */ // Label 2363: @135197
     /* 135197 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135256), // Rule ID 326 //
     /* 135202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135205 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135231 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135234 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135254 */   GIR_RootConstrainSelectedInstOperands,
     /* 135255 */   // GIR_Coverage, 326,
     /* 135255 */   GIR_EraseRootFromParent_Done,
     /* 135256 */ // Label 2364: @135256
     /* 135256 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135315), // Rule ID 327 //
     /* 135261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135290 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135293 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135313 */   GIR_RootConstrainSelectedInstOperands,
     /* 135314 */   // GIR_Coverage, 327,
     /* 135314 */   GIR_EraseRootFromParent_Done,
     /* 135315 */ // Label 2365: @135315
     /* 135315 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135369), // Rule ID 7105 //
     /* 135320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135348 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135351 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135367 */   GIR_RootConstrainSelectedInstOperands,
     /* 135368 */   // GIR_Coverage, 7105,
     /* 135368 */   GIR_EraseRootFromParent_Done,
     /* 135369 */ // Label 2366: @135369
     /* 135369 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135423), // Rule ID 7106 //
     /* 135374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135402 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15874>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135405 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 7106,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2367: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135477), // Rule ID 7110 //
     /* 135428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135456 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135459 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135475 */   GIR_RootConstrainSelectedInstOperands,
     /* 135476 */   // GIR_Coverage, 7110,
     /* 135476 */   GIR_EraseRootFromParent_Done,
     /* 135477 */ // Label 2368: @135477
     /* 135477 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135531), // Rule ID 7111 //
     /* 135482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135492 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135510 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15881>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135529 */   GIR_RootConstrainSelectedInstOperands,
     /* 135530 */   // GIR_Coverage, 7111,
     /* 135530 */   GIR_EraseRootFromParent_Done,
     /* 135531 */ // Label 2369: @135531
     /* 135531 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135585), // Rule ID 7115 //
     /* 135536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135546 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135564 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135567 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135583 */   GIR_RootConstrainSelectedInstOperands,
     /* 135584 */   // GIR_Coverage, 7115,
     /* 135584 */   GIR_EraseRootFromParent_Done,
     /* 135585 */ // Label 2370: @135585
     /* 135585 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135639), // Rule ID 7116 //
     /* 135590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135600 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135618 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15888>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135621 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135637 */   GIR_RootConstrainSelectedInstOperands,
     /* 135638 */   // GIR_Coverage, 7116,
     /* 135638 */   GIR_EraseRootFromParent_Done,
     /* 135639 */ // Label 2371: @135639
     /* 135639 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135696), // Rule ID 7478 //
     /* 135644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135650 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135675 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15872>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135694 */   GIR_RootConstrainSelectedInstOperands,
     /* 135695 */   // GIR_Coverage, 7478,
     /* 135695 */   GIR_EraseRootFromParent_Done,
     /* 135696 */ // Label 2372: @135696
     /* 135696 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135753), // Rule ID 7479 //
     /* 135701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135732 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15879>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 135735 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 7479,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2373: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135810), // Rule ID 7480 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135761 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135764 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135789 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15886>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 135792 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135808 */   GIR_RootConstrainSelectedInstOperands,
     /* 135809 */   // GIR_Coverage, 7480,
     /* 135809 */   GIR_EraseRootFromParent_Done,
     /* 135810 */ // Label 2374: @135810
     /* 135810 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135847), // Rule ID 7102 //
     /* 135815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135825 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135832 */   // MIs[0] ptr
     /* 135832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135840 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15872>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 135845 */   GIR_RootConstrainSelectedInstOperands,
     /* 135846 */   // GIR_Coverage, 7102,
     /* 135846 */   GIR_Done,
     /* 135847 */ // Label 2375: @135847
     /* 135847 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135884), // Rule ID 7107 //
     /* 135852 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135862 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135869 */   // MIs[0] ptr
     /* 135869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135877 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15879>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 135882 */   GIR_RootConstrainSelectedInstOperands,
     /* 135883 */   // GIR_Coverage, 7107,
     /* 135883 */   GIR_Done,
     /* 135884 */ // Label 2376: @135884
     /* 135884 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135921), // Rule ID 7112 //
     /* 135889 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135899 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135906 */   // MIs[0] ptr
     /* 135906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135914 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15886>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 135919 */   GIR_RootConstrainSelectedInstOperands,
     /* 135920 */   // GIR_Coverage, 7112,
     /* 135920 */   GIR_Done,
     /* 135921 */ // Label 2377: @135921
     /* 135921 */ GIM_Reject,
     /* 135922 */ // Label 2276: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136028), // Rule ID 4521 //
     /* 135927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 135946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135955 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 135959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 135972 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 135972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 135975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135984 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 135990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136026 */   GIR_RootConstrainSelectedInstOperands,
     /* 136027 */   // GIR_Coverage, 4521,
     /* 136027 */   GIR_EraseRootFromParent_Done,
     /* 136028 */ // Label 2378: @136028
     /* 136028 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136134), // Rule ID 4522 //
     /* 136033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136132 */   GIR_RootConstrainSelectedInstOperands,
     /* 136133 */   // GIR_Coverage, 4522,
     /* 136133 */   GIR_EraseRootFromParent_Done,
     /* 136134 */ // Label 2379: @136134
     /* 136134 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136240), // Rule ID 4523 //
     /* 136139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136167 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136184 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136196 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136238 */   GIR_RootConstrainSelectedInstOperands,
     /* 136239 */   // GIR_Coverage, 4523,
     /* 136239 */   GIR_EraseRootFromParent_Done,
     /* 136240 */ // Label 2380: @136240
     /* 136240 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136346), // Rule ID 4524 //
     /* 136245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136290 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136344 */   GIR_RootConstrainSelectedInstOperands,
     /* 136345 */   // GIR_Coverage, 4524,
     /* 136345 */   GIR_EraseRootFromParent_Done,
     /* 136346 */ // Label 2381: @136346
     /* 136346 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136447), // Rule ID 4547 //
     /* 136351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136379 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136396 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136408 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136445 */   GIR_RootConstrainSelectedInstOperands,
     /* 136446 */   // GIR_Coverage, 4547,
     /* 136446 */   GIR_EraseRootFromParent_Done,
     /* 136447 */ // Label 2382: @136447
     /* 136447 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136548), // Rule ID 4548 //
     /* 136452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136497 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136546 */   GIR_RootConstrainSelectedInstOperands,
     /* 136547 */   // GIR_Coverage, 4548,
     /* 136547 */   GIR_EraseRootFromParent_Done,
     /* 136548 */ // Label 2383: @136548
     /* 136548 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(136649), // Rule ID 4574 //
     /* 136553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136568 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136581 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136598 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136610 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136647 */   GIR_RootConstrainSelectedInstOperands,
     /* 136648 */   // GIR_Coverage, 4574,
     /* 136648 */   GIR_EraseRootFromParent_Done,
     /* 136649 */ // Label 2384: @136649
     /* 136649 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(136750), // Rule ID 4575 //
     /* 136654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136657 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136669 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136682 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136699 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136711 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136748 */   GIR_RootConstrainSelectedInstOperands,
     /* 136749 */   // GIR_Coverage, 4575,
     /* 136749 */   GIR_EraseRootFromParent_Done,
     /* 136750 */ // Label 2385: @136750
     /* 136750 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(136825), // Rule ID 6493 //
     /* 136755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136770 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136778 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136783 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136787 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136791 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136795 */   // MIs[2] Operand 1
     /* 136795 */   // No operand predicates
     /* 136795 */   // MIs[0] Rn
     /* 136795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136803 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136805 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136808 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136812 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136823 */   GIR_RootConstrainSelectedInstOperands,
     /* 136824 */   // GIR_Coverage, 6493,
     /* 136824 */   GIR_EraseRootFromParent_Done,
     /* 136825 */ // Label 2386: @136825
     /* 136825 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136900), // Rule ID 6494 //
     /* 136830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136853 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136858 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136866 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136870 */   // MIs[2] Operand 1
     /* 136870 */   // No operand predicates
     /* 136870 */   // MIs[0] Rn
     /* 136870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136878 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136880 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136890 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136898 */   GIR_RootConstrainSelectedInstOperands,
     /* 136899 */   // GIR_Coverage, 6494,
     /* 136899 */   GIR_EraseRootFromParent_Done,
     /* 136900 */ // Label 2387: @136900
     /* 136900 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136953), // Rule ID 301 //
     /* 136905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136927 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 136930 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136951 */   GIR_RootConstrainSelectedInstOperands,
     /* 136952 */   // GIR_Coverage, 301,
     /* 136952 */   GIR_EraseRootFromParent_Done,
     /* 136953 */ // Label 2388: @136953
     /* 136953 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137006), // Rule ID 302 //
     /* 136958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136980 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 136983 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137004 */   GIR_RootConstrainSelectedInstOperands,
     /* 137005 */   // GIR_Coverage, 302,
     /* 137005 */   GIR_EraseRootFromParent_Done,
     /* 137006 */ // Label 2389: @137006
     /* 137006 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137062), // Rule ID 309 //
     /* 137011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137036 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137039 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137060 */   GIR_RootConstrainSelectedInstOperands,
     /* 137061 */   // GIR_Coverage, 309,
     /* 137061 */   GIR_EraseRootFromParent_Done,
     /* 137062 */ // Label 2390: @137062
     /* 137062 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137118), // Rule ID 310 //
     /* 137067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137081 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137085 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137092 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137095 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137116 */   GIR_RootConstrainSelectedInstOperands,
     /* 137117 */   // GIR_Coverage, 310,
     /* 137117 */   GIR_EraseRootFromParent_Done,
     /* 137118 */ // Label 2391: @137118
     /* 137118 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137207), // Rule ID 4479 //
     /* 137123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137126 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 137152 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 137152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137164 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137175 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 137183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137205 */   GIR_RootConstrainSelectedInstOperands,
     /* 137206 */   // GIR_Coverage, 4479,
     /* 137206 */   GIR_EraseRootFromParent_Done,
     /* 137207 */ // Label 2392: @137207
     /* 137207 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137296), // Rule ID 4480 //
     /* 137212 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137215 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 137241 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 137241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 137272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137294 */   GIR_RootConstrainSelectedInstOperands,
     /* 137295 */   // GIR_Coverage, 4480,
     /* 137295 */   GIR_EraseRootFromParent_Done,
     /* 137296 */ // Label 2393: @137296
     /* 137296 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137385), // Rule ID 4481 //
     /* 137301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137304 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 137330 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 137330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137342 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 137361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137383 */   GIR_RootConstrainSelectedInstOperands,
     /* 137384 */   // GIR_Coverage, 4481,
     /* 137384 */   GIR_EraseRootFromParent_Done,
     /* 137385 */ // Label 2394: @137385
     /* 137385 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137474), // Rule ID 4482 //
     /* 137390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137393 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 137419 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 137419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137431 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 137450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137472 */   GIR_RootConstrainSelectedInstOperands,
     /* 137473 */   // GIR_Coverage, 4482,
     /* 137473 */   GIR_EraseRootFromParent_Done,
     /* 137474 */ // Label 2395: @137474
     /* 137474 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137563), // Rule ID 4483 //
     /* 137479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 137508 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 137508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137520 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 137539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137561 */   GIR_RootConstrainSelectedInstOperands,
     /* 137562 */   // GIR_Coverage, 4483,
     /* 137562 */   GIR_EraseRootFromParent_Done,
     /* 137563 */ // Label 2396: @137563
     /* 137563 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137652), // Rule ID 4484 //
     /* 137568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137571 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 137597 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 137597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137609 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 137628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137650 */   GIR_RootConstrainSelectedInstOperands,
     /* 137651 */   // GIR_Coverage, 4484,
     /* 137651 */   GIR_EraseRootFromParent_Done,
     /* 137652 */ // Label 2397: @137652
     /* 137652 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137705), // Rule ID 4495 //
     /* 137657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137679 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137682 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137703 */   GIR_RootConstrainSelectedInstOperands,
     /* 137704 */   // GIR_Coverage, 4495,
     /* 137704 */   GIR_EraseRootFromParent_Done,
     /* 137705 */ // Label 2398: @137705
     /* 137705 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(137758), // Rule ID 4496 //
     /* 137710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137732 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137735 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */   GIR_RootConstrainSelectedInstOperands,
     /* 137757 */   // GIR_Coverage, 4496,
     /* 137757 */   GIR_EraseRootFromParent_Done,
     /* 137758 */ // Label 2399: @137758
     /* 137758 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(137811), // Rule ID 4497 //
     /* 137763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137785 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137788 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137809 */   GIR_RootConstrainSelectedInstOperands,
     /* 137810 */   // GIR_Coverage, 4497,
     /* 137810 */   GIR_EraseRootFromParent_Done,
     /* 137811 */ // Label 2400: @137811
     /* 137811 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(137864), // Rule ID 4498 //
     /* 137816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137838 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137841 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137862 */   GIR_RootConstrainSelectedInstOperands,
     /* 137863 */   // GIR_Coverage, 4498,
     /* 137863 */   GIR_EraseRootFromParent_Done,
     /* 137864 */ // Label 2401: @137864
     /* 137864 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(137916), // Rule ID 311 //
     /* 137869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137891 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 137894 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 137900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137914 */   GIR_RootConstrainSelectedInstOperands,
     /* 137915 */   // GIR_Coverage, 311,
     /* 137915 */   GIR_EraseRootFromParent_Done,
     /* 137916 */ // Label 2402: @137916
     /* 137916 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(137967), // Rule ID 316 //
     /* 137921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137946 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137949 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137965 */   GIR_RootConstrainSelectedInstOperands,
     /* 137966 */   // GIR_Coverage, 316,
     /* 137966 */   GIR_EraseRootFromParent_Done,
     /* 137967 */ // Label 2403: @137967
     /* 137967 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138015), // Rule ID 4525 //
     /* 137972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137994 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137997 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138013 */   GIR_RootConstrainSelectedInstOperands,
     /* 138014 */   // GIR_Coverage, 4525,
     /* 138014 */   GIR_EraseRootFromParent_Done,
     /* 138015 */ // Label 2404: @138015
     /* 138015 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138063), // Rule ID 4526 //
     /* 138020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138042 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138045 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138061 */   GIR_RootConstrainSelectedInstOperands,
     /* 138062 */   // GIR_Coverage, 4526,
     /* 138062 */   GIR_EraseRootFromParent_Done,
     /* 138063 */ // Label 2405: @138063
     /* 138063 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138147), // Rule ID 4540 //
     /* 138068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138071 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 138097 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138109 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 138128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138145 */   GIR_RootConstrainSelectedInstOperands,
     /* 138146 */   // GIR_Coverage, 4540,
     /* 138146 */   GIR_EraseRootFromParent_Done,
     /* 138147 */ // Label 2406: @138147
     /* 138147 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138231), // Rule ID 4541 //
     /* 138152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 138181 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 138181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138193 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 138212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138229 */   GIR_RootConstrainSelectedInstOperands,
     /* 138230 */   // GIR_Coverage, 4541,
     /* 138230 */   GIR_EraseRootFromParent_Done,
     /* 138231 */ // Label 2407: @138231
     /* 138231 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138315), // Rule ID 4542 //
     /* 138236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138239 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 138265 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 138265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138277 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 138296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138313 */   GIR_RootConstrainSelectedInstOperands,
     /* 138314 */   // GIR_Coverage, 4542,
     /* 138314 */   GIR_EraseRootFromParent_Done,
     /* 138315 */ // Label 2408: @138315
     /* 138315 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138392), // Rule ID 7126 //
     /* 138320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138341 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138363 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138366 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138390 */   GIR_RootConstrainSelectedInstOperands,
     /* 138391 */   // GIR_Coverage, 7126,
     /* 138391 */   GIR_EraseRootFromParent_Done,
     /* 138392 */ // Label 2409: @138392
     /* 138392 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138469), // Rule ID 7127 //
     /* 138397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138440 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138443 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138467 */   GIR_RootConstrainSelectedInstOperands,
     /* 138468 */   // GIR_Coverage, 7127,
     /* 138468 */   GIR_EraseRootFromParent_Done,
     /* 138469 */ // Label 2410: @138469
     /* 138469 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138528), // Rule ID 7118 //
     /* 138474 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138484 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138502 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138505 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138526 */   GIR_RootConstrainSelectedInstOperands,
     /* 138527 */   // GIR_Coverage, 7118,
     /* 138527 */   GIR_EraseRootFromParent_Done,
     /* 138528 */ // Label 2411: @138528
     /* 138528 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(138587), // Rule ID 7119 //
     /* 138533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138561 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138564 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138585 */   GIR_RootConstrainSelectedInstOperands,
     /* 138586 */   // GIR_Coverage, 7119,
     /* 138586 */   GIR_EraseRootFromParent_Done,
     /* 138587 */ // Label 2412: @138587
     /* 138587 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(138659), // Rule ID 7128 //
     /* 138592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138602 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138613 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138635 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138657 */   GIR_RootConstrainSelectedInstOperands,
     /* 138658 */   // GIR_Coverage, 7128,
     /* 138658 */   GIR_EraseRootFromParent_Done,
     /* 138659 */ // Label 2413: @138659
     /* 138659 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(138731), // Rule ID 7129 //
     /* 138664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138707 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138710 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138729 */   GIR_RootConstrainSelectedInstOperands,
     /* 138730 */   // GIR_Coverage, 7129,
     /* 138730 */   GIR_EraseRootFromParent_Done,
     /* 138731 */ // Label 2414: @138731
     /* 138731 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(138828), // Rule ID 7470 //
     /* 138736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 138739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138764 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 138768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138772 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138776 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138780 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138785 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138789 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138793 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138797 */   // MIs[3] Operand 1
     /* 138797 */   // No operand predicates
     /* 138797 */   // MIs[0] Rn
     /* 138797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138805 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138807 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15893>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 138810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 138814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 138817 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 138826 */   GIR_RootConstrainSelectedInstOperands,
     /* 138827 */   // GIR_Coverage, 7470,
     /* 138827 */   GIR_EraseRootFromParent_Done,
     /* 138828 */ // Label 2415: @138828
     /* 138828 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(138880), // Rule ID 319 //
     /* 138833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138855 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 138858 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 138864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138878 */   GIR_RootConstrainSelectedInstOperands,
     /* 138879 */   // GIR_Coverage, 319,
     /* 138879 */   GIR_EraseRootFromParent_Done,
     /* 138880 */ // Label 2416: @138880
     /* 138880 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(138931), // Rule ID 324 //
     /* 138885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138910 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138913 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138929 */   GIR_RootConstrainSelectedInstOperands,
     /* 138930 */   // GIR_Coverage, 324,
     /* 138930 */   GIR_EraseRootFromParent_Done,
     /* 138931 */ // Label 2417: @138931
     /* 138931 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(138985), // Rule ID 7120 //
     /* 138936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138946 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138964 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 138967 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138983 */   GIR_RootConstrainSelectedInstOperands,
     /* 138984 */   // GIR_Coverage, 7120,
     /* 138984 */   GIR_EraseRootFromParent_Done,
     /* 138985 */ // Label 2418: @138985
     /* 138985 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139039), // Rule ID 7121 //
     /* 138990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139018 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15895>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 139021 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139037 */   GIR_RootConstrainSelectedInstOperands,
     /* 139038 */   // GIR_Coverage, 7121,
     /* 139038 */   GIR_EraseRootFromParent_Done,
     /* 139039 */ // Label 2419: @139039
     /* 139039 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139096), // Rule ID 7481 //
     /* 139044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 139047 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139075 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15893>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 139078 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139094 */   GIR_RootConstrainSelectedInstOperands,
     /* 139095 */   // GIR_Coverage, 7481,
     /* 139095 */   GIR_EraseRootFromParent_Done,
     /* 139096 */ // Label 2420: @139096
     /* 139096 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139144), // Rule ID 4549 //
     /* 139101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139123 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139126 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139142 */   GIR_RootConstrainSelectedInstOperands,
     /* 139143 */   // GIR_Coverage, 4549,
     /* 139143 */   GIR_EraseRootFromParent_Done,
     /* 139144 */ // Label 2421: @139144
     /* 139144 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139192), // Rule ID 4550 //
     /* 139149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139171 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139174 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139190 */   GIR_RootConstrainSelectedInstOperands,
     /* 139191 */   // GIR_Coverage, 4550,
     /* 139191 */   GIR_EraseRootFromParent_Done,
     /* 139192 */ // Label 2422: @139192
     /* 139192 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139276), // Rule ID 4565 //
     /* 139197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 139226 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139238 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 139257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139274 */   GIR_RootConstrainSelectedInstOperands,
     /* 139275 */   // GIR_Coverage, 4565,
     /* 139275 */   GIR_EraseRootFromParent_Done,
     /* 139276 */ // Label 2423: @139276
     /* 139276 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139360), // Rule ID 4566 //
     /* 139281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139284 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 139310 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139322 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 139341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139358 */   GIR_RootConstrainSelectedInstOperands,
     /* 139359 */   // GIR_Coverage, 4566,
     /* 139359 */   GIR_EraseRootFromParent_Done,
     /* 139360 */ // Label 2424: @139360
     /* 139360 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139444), // Rule ID 4567 //
     /* 139365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139368 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139387 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 139394 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139406 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 139425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139442 */   GIR_RootConstrainSelectedInstOperands,
     /* 139443 */   // GIR_Coverage, 4567,
     /* 139443 */   GIR_EraseRootFromParent_Done,
     /* 139444 */ // Label 2425: @139444
     /* 139444 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139528), // Rule ID 7469 //
     /* 139449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 139473 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 139477 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 139494 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 139498 */   // MIs[2] Operand 1
     /* 139498 */   // No operand predicates
     /* 139498 */   // MIs[0] Rn
     /* 139498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139506 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139508 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15893>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 139508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139515 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 139518 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139526 */   GIR_RootConstrainSelectedInstOperands,
     /* 139527 */   // GIR_Coverage, 7469,
     /* 139527 */   GIR_EraseRootFromParent_Done,
     /* 139528 */ // Label 2426: @139528
     /* 139528 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(139626), // Rule ID 7471 //
     /* 139533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139546 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139566 */   // MIs[0] Rn
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139576 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15893>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 139576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 139579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 139583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 139591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139595 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 139598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139617 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139624 */   GIR_RootConstrainSelectedInstOperands,
     /* 139625 */   // GIR_Coverage, 7471,
     /* 139625 */   GIR_EraseRootFromParent_Done,
     /* 139626 */ // Label 2427: @139626
     /* 139626 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(139663), // Rule ID 7117 //
     /* 139631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139641 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139648 */   // MIs[0] ptr
     /* 139648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139656 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15893>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 139656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 139661 */   GIR_RootConstrainSelectedInstOperands,
     /* 139662 */   // GIR_Coverage, 7117,
     /* 139662 */   GIR_Done,
     /* 139663 */ // Label 2428: @139663
     /* 139663 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(139690), // Rule ID 6441 //
     /* 139668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139675 */   // MIs[0] Rn
     /* 139675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139683 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 139683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 139688 */   GIR_RootConstrainSelectedInstOperands,
     /* 139689 */   // GIR_Coverage, 6441,
     /* 139689 */   GIR_Done,
     /* 139690 */ // Label 2429: @139690
     /* 139690 */ GIM_Reject,
     /* 139691 */ // Label 2277: @139691
     /* 139691 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(139896),
     /* 139696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139711 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(139752), // Rule ID 4477 //
     /* 139716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 139726 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 139729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139750 */     GIR_RootConstrainSelectedInstOperands,
     /* 139751 */     // GIR_Coverage, 4477,
     /* 139751 */     GIR_EraseRootFromParent_Done,
     /* 139752 */   // Label 2431: @139752
     /* 139752 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(139793), // Rule ID 4478 //
     /* 139757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 139767 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 139770 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139791 */     GIR_RootConstrainSelectedInstOperands,
     /* 139792 */     // GIR_Coverage, 4478,
     /* 139792 */     GIR_EraseRootFromParent_Done,
     /* 139793 */   // Label 2432: @139793
     /* 139793 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(139826), // Rule ID 4532 //
     /* 139798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 139805 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 139805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 139808 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139824 */     GIR_RootConstrainSelectedInstOperands,
     /* 139825 */     // GIR_Coverage, 4532,
     /* 139825 */     GIR_EraseRootFromParent_Done,
     /* 139826 */   // Label 2433: @139826
     /* 139826 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(139859), // Rule ID 4556 //
     /* 139831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139838 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139841 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139857 */     GIR_RootConstrainSelectedInstOperands,
     /* 139858 */     // GIR_Coverage, 4556,
     /* 139858 */     GIR_EraseRootFromParent_Done,
     /* 139859 */   // Label 2434: @139859
     /* 139859 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(139895), // Rule ID 325 //
     /* 139864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139874 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 139874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139877 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139893 */     GIR_RootConstrainSelectedInstOperands,
     /* 139894 */     // GIR_Coverage, 325,
     /* 139894 */     GIR_EraseRootFromParent_Done,
     /* 139895 */   // Label 2435: @139895
     /* 139895 */   GIM_Reject,
     /* 139896 */ // Label 2430: @139896
     /* 139896 */ GIM_Reject,
     /* 139897 */ // Label 2278: @139897
     /* 139897 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140302),
     /* 139902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139909 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(139958), // Rule ID 4485 //
     /* 139914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139932 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139935 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139956 */     GIR_RootConstrainSelectedInstOperands,
     /* 139957 */     // GIR_Coverage, 4485,
     /* 139957 */     GIR_EraseRootFromParent_Done,
     /* 139958 */   // Label 2437: @139958
     /* 139958 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140007), // Rule ID 4486 //
     /* 139963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139981 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139984 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140005 */     GIR_RootConstrainSelectedInstOperands,
     /* 140006 */     // GIR_Coverage, 4486,
     /* 140006 */     GIR_EraseRootFromParent_Done,
     /* 140007 */   // Label 2438: @140007
     /* 140007 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140056), // Rule ID 4487 //
     /* 140012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140030 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140033 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140054 */     GIR_RootConstrainSelectedInstOperands,
     /* 140055 */     // GIR_Coverage, 4487,
     /* 140055 */     GIR_EraseRootFromParent_Done,
     /* 140056 */   // Label 2439: @140056
     /* 140056 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140105), // Rule ID 4488 //
     /* 140061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140079 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140082 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140103 */     GIR_RootConstrainSelectedInstOperands,
     /* 140104 */     // GIR_Coverage, 4488,
     /* 140104 */     GIR_EraseRootFromParent_Done,
     /* 140105 */   // Label 2440: @140105
     /* 140105 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140149), // Rule ID 4527 //
     /* 140110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140128 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140131 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140147 */     GIR_RootConstrainSelectedInstOperands,
     /* 140148 */     // GIR_Coverage, 4527,
     /* 140148 */     GIR_EraseRootFromParent_Done,
     /* 140149 */   // Label 2441: @140149
     /* 140149 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(140193), // Rule ID 4530 //
     /* 140154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140172 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140175 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140191 */     GIR_RootConstrainSelectedInstOperands,
     /* 140192 */     // GIR_Coverage, 4530,
     /* 140192 */     GIR_EraseRootFromParent_Done,
     /* 140193 */   // Label 2442: @140193
     /* 140193 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(140237), // Rule ID 4551 //
     /* 140198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140216 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140219 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 4551,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2443: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(140281), // Rule ID 4554 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140260 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140263 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140279 */     GIR_RootConstrainSelectedInstOperands,
     /* 140280 */     // GIR_Coverage, 4554,
     /* 140280 */     GIR_EraseRootFromParent_Done,
     /* 140281 */   // Label 2444: @140281
     /* 140281 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(140301), // Rule ID 6440 //
     /* 140286 */     // MIs[0] Rn
     /* 140286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140294 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 140299 */     GIR_RootConstrainSelectedInstOperands,
     /* 140300 */     // GIR_Coverage, 6440,
     /* 140300 */     GIR_Done,
     /* 140301 */   // Label 2445: @140301
     /* 140301 */   GIM_Reject,
     /* 140302 */ // Label 2436: @140302
     /* 140302 */ GIM_Reject,
     /* 140303 */ // Label 2279: @140303
     /* 140303 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(140752),
     /* 140308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140315 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(140364), // Rule ID 4499 //
     /* 140320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140338 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140341 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140362 */     GIR_RootConstrainSelectedInstOperands,
     /* 140363 */     // GIR_Coverage, 4499,
     /* 140363 */     GIR_EraseRootFromParent_Done,
     /* 140364 */   // Label 2447: @140364
     /* 140364 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(140413), // Rule ID 4500 //
     /* 140369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140387 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140390 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140411 */     GIR_RootConstrainSelectedInstOperands,
     /* 140412 */     // GIR_Coverage, 4500,
     /* 140412 */     GIR_EraseRootFromParent_Done,
     /* 140413 */   // Label 2448: @140413
     /* 140413 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(140462), // Rule ID 4501 //
     /* 140418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140436 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140439 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140460 */     GIR_RootConstrainSelectedInstOperands,
     /* 140461 */     // GIR_Coverage, 4501,
     /* 140461 */     GIR_EraseRootFromParent_Done,
     /* 140462 */   // Label 2449: @140462
     /* 140462 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(140511), // Rule ID 4502 //
     /* 140467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140485 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140488 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140509 */     GIR_RootConstrainSelectedInstOperands,
     /* 140510 */     // GIR_Coverage, 4502,
     /* 140510 */     GIR_EraseRootFromParent_Done,
     /* 140511 */   // Label 2450: @140511
     /* 140511 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(140555), // Rule ID 4534 //
     /* 140516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140534 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140537 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140553 */     GIR_RootConstrainSelectedInstOperands,
     /* 140554 */     // GIR_Coverage, 4534,
     /* 140554 */     GIR_EraseRootFromParent_Done,
     /* 140555 */   // Label 2451: @140555
     /* 140555 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(140599), // Rule ID 4538 //
     /* 140560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140578 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140581 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140597 */     GIR_RootConstrainSelectedInstOperands,
     /* 140598 */     // GIR_Coverage, 4538,
     /* 140598 */     GIR_EraseRootFromParent_Done,
     /* 140599 */   // Label 2452: @140599
     /* 140599 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(140643), // Rule ID 4558 //
     /* 140604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140622 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140625 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140641 */     GIR_RootConstrainSelectedInstOperands,
     /* 140642 */     // GIR_Coverage, 4558,
     /* 140642 */     GIR_EraseRootFromParent_Done,
     /* 140643 */   // Label 2453: @140643
     /* 140643 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(140687), // Rule ID 4562 //
     /* 140648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140666 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140669 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140685 */     GIR_RootConstrainSelectedInstOperands,
     /* 140686 */     // GIR_Coverage, 4562,
     /* 140686 */     GIR_EraseRootFromParent_Done,
     /* 140687 */   // Label 2454: @140687
     /* 140687 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(140731), // Rule ID 4563 //
     /* 140692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140710 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140713 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140729 */     GIR_RootConstrainSelectedInstOperands,
     /* 140730 */     // GIR_Coverage, 4563,
     /* 140730 */     GIR_EraseRootFromParent_Done,
     /* 140731 */   // Label 2455: @140731
     /* 140731 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(140751), // Rule ID 6437 //
     /* 140736 */     // MIs[0] Rn
     /* 140736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140744 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 140749 */     GIR_RootConstrainSelectedInstOperands,
     /* 140750 */     // GIR_Coverage, 6437,
     /* 140750 */     GIR_Done,
     /* 140751 */   // Label 2456: @140751
     /* 140751 */   GIM_Reject,
     /* 140752 */ // Label 2446: @140752
     /* 140752 */ GIM_Reject,
     /* 140753 */ // Label 2280: @140753
     /* 140753 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141158),
     /* 140758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140765 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(140814), // Rule ID 4489 //
     /* 140770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140788 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140791 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140812 */     GIR_RootConstrainSelectedInstOperands,
     /* 140813 */     // GIR_Coverage, 4489,
     /* 140813 */     GIR_EraseRootFromParent_Done,
     /* 140814 */   // Label 2458: @140814
     /* 140814 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(140863), // Rule ID 4490 //
     /* 140819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140837 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140840 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140861 */     GIR_RootConstrainSelectedInstOperands,
     /* 140862 */     // GIR_Coverage, 4490,
     /* 140862 */     GIR_EraseRootFromParent_Done,
     /* 140863 */   // Label 2459: @140863
     /* 140863 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(140912), // Rule ID 4493 //
     /* 140868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140886 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140889 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140910 */     GIR_RootConstrainSelectedInstOperands,
     /* 140911 */     // GIR_Coverage, 4493,
     /* 140911 */     GIR_EraseRootFromParent_Done,
     /* 140912 */   // Label 2460: @140912
     /* 140912 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(140961), // Rule ID 4494 //
     /* 140917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140935 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140938 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140959 */     GIR_RootConstrainSelectedInstOperands,
     /* 140960 */     // GIR_Coverage, 4494,
     /* 140960 */     GIR_EraseRootFromParent_Done,
     /* 140961 */   // Label 2461: @140961
     /* 140961 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141005), // Rule ID 4529 //
     /* 140966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140984 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140987 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141003 */     GIR_RootConstrainSelectedInstOperands,
     /* 141004 */     // GIR_Coverage, 4529,
     /* 141004 */     GIR_EraseRootFromParent_Done,
     /* 141005 */   // Label 2462: @141005
     /* 141005 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141049), // Rule ID 4531 //
     /* 141010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141028 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141047 */     GIR_RootConstrainSelectedInstOperands,
     /* 141048 */     // GIR_Coverage, 4531,
     /* 141048 */     GIR_EraseRootFromParent_Done,
     /* 141049 */   // Label 2463: @141049
     /* 141049 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141093), // Rule ID 4553 //
     /* 141054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141072 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141091 */     GIR_RootConstrainSelectedInstOperands,
     /* 141092 */     // GIR_Coverage, 4553,
     /* 141092 */     GIR_EraseRootFromParent_Done,
     /* 141093 */   // Label 2464: @141093
     /* 141093 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141137), // Rule ID 4555 //
     /* 141098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141116 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141119 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141135 */     GIR_RootConstrainSelectedInstOperands,
     /* 141136 */     // GIR_Coverage, 4555,
     /* 141136 */     GIR_EraseRootFromParent_Done,
     /* 141137 */   // Label 2465: @141137
     /* 141137 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(141157), // Rule ID 6439 //
     /* 141142 */     // MIs[0] Rn
     /* 141142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141150 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 141155 */     GIR_RootConstrainSelectedInstOperands,
     /* 141156 */     // GIR_Coverage, 6439,
     /* 141156 */     GIR_Done,
     /* 141157 */   // Label 2466: @141157
     /* 141157 */   GIM_Reject,
     /* 141158 */ // Label 2457: @141158
     /* 141158 */ GIM_Reject,
     /* 141159 */ // Label 2281: @141159
     /* 141159 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(141564),
     /* 141164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141167 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141171 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(141220), // Rule ID 4503 //
     /* 141176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141194 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141197 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141218 */     GIR_RootConstrainSelectedInstOperands,
     /* 141219 */     // GIR_Coverage, 4503,
     /* 141219 */     GIR_EraseRootFromParent_Done,
     /* 141220 */   // Label 2468: @141220
     /* 141220 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(141269), // Rule ID 4504 //
     /* 141225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141243 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141246 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141267 */     GIR_RootConstrainSelectedInstOperands,
     /* 141268 */     // GIR_Coverage, 4504,
     /* 141268 */     GIR_EraseRootFromParent_Done,
     /* 141269 */   // Label 2469: @141269
     /* 141269 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(141318), // Rule ID 4505 //
     /* 141274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141292 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141295 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 141317 */     // GIR_Coverage, 4505,
     /* 141317 */     GIR_EraseRootFromParent_Done,
     /* 141318 */   // Label 2470: @141318
     /* 141318 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(141367), // Rule ID 4506 //
     /* 141323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141341 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141344 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141365 */     GIR_RootConstrainSelectedInstOperands,
     /* 141366 */     // GIR_Coverage, 4506,
     /* 141366 */     GIR_EraseRootFromParent_Done,
     /* 141367 */   // Label 2471: @141367
     /* 141367 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(141411), // Rule ID 4533 //
     /* 141372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141390 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141393 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141409 */     GIR_RootConstrainSelectedInstOperands,
     /* 141410 */     // GIR_Coverage, 4533,
     /* 141410 */     GIR_EraseRootFromParent_Done,
     /* 141411 */   // Label 2472: @141411
     /* 141411 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(141455), // Rule ID 4537 //
     /* 141416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141434 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141437 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141453 */     GIR_RootConstrainSelectedInstOperands,
     /* 141454 */     // GIR_Coverage, 4537,
     /* 141454 */     GIR_EraseRootFromParent_Done,
     /* 141455 */   // Label 2473: @141455
     /* 141455 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(141499), // Rule ID 4557 //
     /* 141460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141478 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141481 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141497 */     GIR_RootConstrainSelectedInstOperands,
     /* 141498 */     // GIR_Coverage, 4557,
     /* 141498 */     GIR_EraseRootFromParent_Done,
     /* 141499 */   // Label 2474: @141499
     /* 141499 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(141543), // Rule ID 4561 //
     /* 141504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141522 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141525 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141541 */     GIR_RootConstrainSelectedInstOperands,
     /* 141542 */     // GIR_Coverage, 4561,
     /* 141542 */     GIR_EraseRootFromParent_Done,
     /* 141543 */   // Label 2475: @141543
     /* 141543 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(141563), // Rule ID 6436 //
     /* 141548 */     // MIs[0] Rn
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141556 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 141561 */     GIR_RootConstrainSelectedInstOperands,
     /* 141562 */     // GIR_Coverage, 6436,
     /* 141562 */     GIR_Done,
     /* 141563 */   // Label 2476: @141563
     /* 141563 */   GIM_Reject,
     /* 141564 */ // Label 2467: @141564
     /* 141564 */ GIM_Reject,
     /* 141565 */ // Label 2282: @141565
     /* 141565 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(141784),
     /* 141570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141577 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(141626), // Rule ID 4491 //
     /* 141582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141600 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141624 */     GIR_RootConstrainSelectedInstOperands,
     /* 141625 */     // GIR_Coverage, 4491,
     /* 141625 */     GIR_EraseRootFromParent_Done,
     /* 141626 */   // Label 2478: @141626
     /* 141626 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(141675), // Rule ID 4492 //
     /* 141631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141649 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141652 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141673 */     GIR_RootConstrainSelectedInstOperands,
     /* 141674 */     // GIR_Coverage, 4492,
     /* 141674 */     GIR_EraseRootFromParent_Done,
     /* 141675 */   // Label 2479: @141675
     /* 141675 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(141719), // Rule ID 4528 //
     /* 141680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141698 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141701 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141717 */     GIR_RootConstrainSelectedInstOperands,
     /* 141718 */     // GIR_Coverage, 4528,
     /* 141718 */     GIR_EraseRootFromParent_Done,
     /* 141719 */   // Label 2480: @141719
     /* 141719 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(141763), // Rule ID 4552 //
     /* 141724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141742 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141745 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141761 */     GIR_RootConstrainSelectedInstOperands,
     /* 141762 */     // GIR_Coverage, 4552,
     /* 141762 */     GIR_EraseRootFromParent_Done,
     /* 141763 */   // Label 2481: @141763
     /* 141763 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(141783), // Rule ID 6438 //
     /* 141768 */     // MIs[0] Rn
     /* 141768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141776 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 141781 */     GIR_RootConstrainSelectedInstOperands,
     /* 141782 */     // GIR_Coverage, 6438,
     /* 141782 */     GIR_Done,
     /* 141783 */   // Label 2482: @141783
     /* 141783 */   GIM_Reject,
     /* 141784 */ // Label 2477: @141784
     /* 141784 */ GIM_Reject,
     /* 141785 */ // Label 2283: @141785
     /* 141785 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142190),
     /* 141790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141797 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(141846), // Rule ID 4507 //
     /* 141802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141820 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141844 */     GIR_RootConstrainSelectedInstOperands,
     /* 141845 */     // GIR_Coverage, 4507,
     /* 141845 */     GIR_EraseRootFromParent_Done,
     /* 141846 */   // Label 2484: @141846
     /* 141846 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(141895), // Rule ID 4508 //
     /* 141851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141869 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141872 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141893 */     GIR_RootConstrainSelectedInstOperands,
     /* 141894 */     // GIR_Coverage, 4508,
     /* 141894 */     GIR_EraseRootFromParent_Done,
     /* 141895 */   // Label 2485: @141895
     /* 141895 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(141944), // Rule ID 4511 //
     /* 141900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141918 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141921 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141942 */     GIR_RootConstrainSelectedInstOperands,
     /* 141943 */     // GIR_Coverage, 4511,
     /* 141943 */     GIR_EraseRootFromParent_Done,
     /* 141944 */   // Label 2486: @141944
     /* 141944 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(141993), // Rule ID 4512 //
     /* 141949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141967 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141991 */     GIR_RootConstrainSelectedInstOperands,
     /* 141992 */     // GIR_Coverage, 4512,
     /* 141992 */     GIR_EraseRootFromParent_Done,
     /* 141993 */   // Label 2487: @141993
     /* 141993 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142037), // Rule ID 4536 //
     /* 141998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142016 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142019 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142035 */     GIR_RootConstrainSelectedInstOperands,
     /* 142036 */     // GIR_Coverage, 4536,
     /* 142036 */     GIR_EraseRootFromParent_Done,
     /* 142037 */   // Label 2488: @142037
     /* 142037 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142081), // Rule ID 4539 //
     /* 142042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142060 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142063 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142079 */     GIR_RootConstrainSelectedInstOperands,
     /* 142080 */     // GIR_Coverage, 4539,
     /* 142080 */     GIR_EraseRootFromParent_Done,
     /* 142081 */   // Label 2489: @142081
     /* 142081 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(142125), // Rule ID 4560 //
     /* 142086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142104 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142107 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142123 */     GIR_RootConstrainSelectedInstOperands,
     /* 142124 */     // GIR_Coverage, 4560,
     /* 142124 */     GIR_EraseRootFromParent_Done,
     /* 142125 */   // Label 2490: @142125
     /* 142125 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(142169), // Rule ID 4564 //
     /* 142130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142148 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142151 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142167 */     GIR_RootConstrainSelectedInstOperands,
     /* 142168 */     // GIR_Coverage, 4564,
     /* 142168 */     GIR_EraseRootFromParent_Done,
     /* 142169 */   // Label 2491: @142169
     /* 142169 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(142189), // Rule ID 6435 //
     /* 142174 */     // MIs[0] Rn
     /* 142174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142182 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 142187 */     GIR_RootConstrainSelectedInstOperands,
     /* 142188 */     // GIR_Coverage, 6435,
     /* 142188 */     GIR_Done,
     /* 142189 */   // Label 2492: @142189
     /* 142189 */   GIM_Reject,
     /* 142190 */ // Label 2483: @142190
     /* 142190 */ GIM_Reject,
     /* 142191 */ // Label 2284: @142191
     /* 142191 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(142410),
     /* 142196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142203 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(142252), // Rule ID 4509 //
     /* 142208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142226 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142250 */     GIR_RootConstrainSelectedInstOperands,
     /* 142251 */     // GIR_Coverage, 4509,
     /* 142251 */     GIR_EraseRootFromParent_Done,
     /* 142252 */   // Label 2494: @142252
     /* 142252 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(142301), // Rule ID 4510 //
     /* 142257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142275 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 142300 */     // GIR_Coverage, 4510,
     /* 142300 */     GIR_EraseRootFromParent_Done,
     /* 142301 */   // Label 2495: @142301
     /* 142301 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(142345), // Rule ID 4535 //
     /* 142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142324 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142327 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142343 */     GIR_RootConstrainSelectedInstOperands,
     /* 142344 */     // GIR_Coverage, 4535,
     /* 142344 */     GIR_EraseRootFromParent_Done,
     /* 142345 */   // Label 2496: @142345
     /* 142345 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(142389), // Rule ID 4559 //
     /* 142350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142368 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142371 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142387 */     GIR_RootConstrainSelectedInstOperands,
     /* 142388 */     // GIR_Coverage, 4559,
     /* 142388 */     GIR_EraseRootFromParent_Done,
     /* 142389 */   // Label 2497: @142389
     /* 142389 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(142409), // Rule ID 6434 //
     /* 142394 */     // MIs[0] Rn
     /* 142394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142402 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 142407 */     GIR_RootConstrainSelectedInstOperands,
     /* 142408 */     // GIR_Coverage, 6434,
     /* 142408 */     GIR_Done,
     /* 142409 */   // Label 2498: @142409
     /* 142409 */   GIM_Reject,
     /* 142410 */ // Label 2493: @142410
     /* 142410 */ GIM_Reject,
     /* 142411 */ // Label 2285: @142411
     /* 142411 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(142470), // Rule ID 10918 //
     /* 142416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142426 */   // MIs[0] base
     /* 142426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142434 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 142454 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142459 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142468 */   GIR_RootConstrainSelectedInstOperands,
     /* 142469 */   // GIR_Coverage, 10918,
     /* 142469 */   GIR_EraseRootFromParent_Done,
     /* 142470 */ // Label 2499: @142470
     /* 142470 */ GIM_Reject,
     /* 142471 */ // Label 2286: @142471
     /* 142471 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(142530), // Rule ID 10924 //
     /* 142476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142486 */   // MIs[0] base
     /* 142486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142494 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 142514 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142519 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142528 */   GIR_RootConstrainSelectedInstOperands,
     /* 142529 */   // GIR_Coverage, 10924,
     /* 142529 */   GIR_EraseRootFromParent_Done,
     /* 142530 */ // Label 2500: @142530
     /* 142530 */ GIM_Reject,
     /* 142531 */ // Label 2287: @142531
     /* 142531 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(142700),
     /* 142536 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142547 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(142595), // Rule ID 10909 //
     /* 142552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142559 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142579 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142584 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142593 */     GIR_RootConstrainSelectedInstOperands,
     /* 142594 */     // GIR_Coverage, 10909,
     /* 142594 */     GIR_EraseRootFromParent_Done,
     /* 142595 */   // Label 2502: @142595
     /* 142595 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(142643), // Rule ID 10927 //
     /* 142600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142607 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142627 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142632 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142641 */     GIR_RootConstrainSelectedInstOperands,
     /* 142642 */     // GIR_Coverage, 10927,
     /* 142642 */     GIR_EraseRootFromParent_Done,
     /* 142643 */   // Label 2503: @142643
     /* 142643 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(142671), // Rule ID 11039 //
     /* 142648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142655 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142658 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142660 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142669 */     GIR_RootConstrainSelectedInstOperands,
     /* 142670 */     // GIR_Coverage, 11039,
     /* 142670 */     GIR_EraseRootFromParent_Done,
     /* 142671 */   // Label 2504: @142671
     /* 142671 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(142699), // Rule ID 11051 //
     /* 142676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142683 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142686 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142688 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142697 */     GIR_RootConstrainSelectedInstOperands,
     /* 142698 */     // GIR_Coverage, 11051,
     /* 142698 */     GIR_EraseRootFromParent_Done,
     /* 142699 */   // Label 2505: @142699
     /* 142699 */   GIM_Reject,
     /* 142700 */ // Label 2501: @142700
     /* 142700 */ GIM_Reject,
     /* 142701 */ // Label 2288: @142701
     /* 142701 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(142760), // Rule ID 10915 //
     /* 142706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142716 */   // MIs[0] base
     /* 142716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142724 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 142744 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142749 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142758 */   GIR_RootConstrainSelectedInstOperands,
     /* 142759 */   // GIR_Coverage, 10915,
     /* 142759 */   GIR_EraseRootFromParent_Done,
     /* 142760 */ // Label 2506: @142760
     /* 142760 */ GIM_Reject,
     /* 142761 */ // Label 2289: @142761
     /* 142761 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(142930),
     /* 142766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142777 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(142825), // Rule ID 10903 //
     /* 142782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142789 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142809 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142814 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142823 */     GIR_RootConstrainSelectedInstOperands,
     /* 142824 */     // GIR_Coverage, 10903,
     /* 142824 */     GIR_EraseRootFromParent_Done,
     /* 142825 */   // Label 2508: @142825
     /* 142825 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(142873), // Rule ID 10921 //
     /* 142830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142837 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142857 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142862 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142871 */     GIR_RootConstrainSelectedInstOperands,
     /* 142872 */     // GIR_Coverage, 10921,
     /* 142872 */     GIR_EraseRootFromParent_Done,
     /* 142873 */   // Label 2509: @142873
     /* 142873 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(142901), // Rule ID 11035 //
     /* 142878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142885 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142888 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142890 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142899 */     GIR_RootConstrainSelectedInstOperands,
     /* 142900 */     // GIR_Coverage, 11035,
     /* 142900 */     GIR_EraseRootFromParent_Done,
     /* 142901 */   // Label 2510: @142901
     /* 142901 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(142929), // Rule ID 11047 //
     /* 142906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142913 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142916 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142918 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142927 */     GIR_RootConstrainSelectedInstOperands,
     /* 142928 */     // GIR_Coverage, 11047,
     /* 142928 */     GIR_EraseRootFromParent_Done,
     /* 142929 */   // Label 2511: @142929
     /* 142929 */   GIM_Reject,
     /* 142930 */ // Label 2507: @142930
     /* 142930 */ GIM_Reject,
     /* 142931 */ // Label 2290: @142931
     /* 142931 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143100),
     /* 142936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142947 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(142995), // Rule ID 10894 //
     /* 142952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142959 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 142966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 142979 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142984 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142993 */     GIR_RootConstrainSelectedInstOperands,
     /* 142994 */     // GIR_Coverage, 10894,
     /* 142994 */     GIR_EraseRootFromParent_Done,
     /* 142995 */   // Label 2513: @142995
     /* 142995 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143043), // Rule ID 10912 //
     /* 143000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143007 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 143014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 143027 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143032 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 10912,
     /* 143042 */     GIR_EraseRootFromParent_Done,
     /* 143043 */   // Label 2514: @143043
     /* 143043 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(143071), // Rule ID 11031 //
     /* 143048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143055 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143058 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143060 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143069 */     GIR_RootConstrainSelectedInstOperands,
     /* 143070 */     // GIR_Coverage, 11031,
     /* 143070 */     GIR_EraseRootFromParent_Done,
     /* 143071 */   // Label 2515: @143071
     /* 143071 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(143099), // Rule ID 11043 //
     /* 143076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143083 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143086 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143088 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143097 */     GIR_RootConstrainSelectedInstOperands,
     /* 143098 */     // GIR_Coverage, 11043,
     /* 143098 */     GIR_EraseRootFromParent_Done,
     /* 143099 */   // Label 2516: @143099
     /* 143099 */   GIM_Reject,
     /* 143100 */ // Label 2512: @143100
     /* 143100 */ GIM_Reject,
     /* 143101 */ // Label 2291: @143101
     /* 143101 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(143144), // Rule ID 2430 //
     /* 143106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143120 */   // MIs[0] base
     /* 143120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143128 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 143131 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 143133 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143142 */   GIR_RootConstrainSelectedInstOperands,
     /* 143143 */   // GIR_Coverage, 2430,
     /* 143143 */   GIR_EraseRootFromParent_Done,
     /* 143144 */ // Label 2517: @143144
     /* 143144 */ GIM_Reject,
     /* 143145 */ // Label 2292: @143145
     /* 143145 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(143238),
     /* 143150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143161 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(143209), // Rule ID 10880 //
     /* 143166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143173 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 143180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 143193 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143198 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143207 */     GIR_RootConstrainSelectedInstOperands,
     /* 143208 */     // GIR_Coverage, 10880,
     /* 143208 */     GIR_EraseRootFromParent_Done,
     /* 143209 */   // Label 2519: @143209
     /* 143209 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(143237), // Rule ID 11027 //
     /* 143214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143221 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143224 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143226 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143235 */     GIR_RootConstrainSelectedInstOperands,
     /* 143236 */     // GIR_Coverage, 11027,
     /* 143236 */     GIR_EraseRootFromParent_Done,
     /* 143237 */   // Label 2520: @143237
     /* 143237 */   GIM_Reject,
     /* 143238 */ // Label 2518: @143238
     /* 143238 */ GIM_Reject,
     /* 143239 */ // Label 2293: @143239
     /* 143239 */ GIM_Reject,
     /* 143240 */ // Label 20: @143240
     /* 143240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2523*/ GIMT_Encode4(144590),
     /* 143251 */ /*GILLT_s32*//*Label 2521*/ GIMT_Encode4(143259),
     /* 143255 */ /*GILLT_s64*//*Label 2522*/ GIMT_Encode4(144277),
     /* 143259 */ // Label 2521: @143259
     /* 143259 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144276),
     /* 143264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 143270 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(143325), // Rule ID 7340 //
     /* 143275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143292 */     // MIs[0] Rn
     /* 143292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143308 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 143311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143323 */     GIR_RootConstrainSelectedInstOperands,
     /* 143324 */     // GIR_Coverage, 7340,
     /* 143324 */     GIR_EraseRootFromParent_Done,
     /* 143325 */   // Label 2525: @143325
     /* 143325 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(143380), // Rule ID 7341 //
     /* 143330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143347 */     // MIs[0] Rn
     /* 143347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143363 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 143366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143378 */     GIR_RootConstrainSelectedInstOperands,
     /* 143379 */     // GIR_Coverage, 7341,
     /* 143379 */     GIR_EraseRootFromParent_Done,
     /* 143380 */   // Label 2526: @143380
     /* 143380 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(143435), // Rule ID 7342 //
     /* 143385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143402 */     // MIs[0] Rn
     /* 143402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143418 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 143421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143433 */     GIR_RootConstrainSelectedInstOperands,
     /* 143434 */     // GIR_Coverage, 7342,
     /* 143434 */     GIR_EraseRootFromParent_Done,
     /* 143435 */   // Label 2527: @143435
     /* 143435 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(143490), // Rule ID 7343 //
     /* 143440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143457 */     // MIs[0] Rn
     /* 143457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143473 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143488 */     GIR_RootConstrainSelectedInstOperands,
     /* 143489 */     // GIR_Coverage, 7343,
     /* 143489 */     GIR_EraseRootFromParent_Done,
     /* 143490 */   // Label 2528: @143490
     /* 143490 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(143545), // Rule ID 7344 //
     /* 143495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143512 */     // MIs[0] Rn
     /* 143512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143528 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143543 */     GIR_RootConstrainSelectedInstOperands,
     /* 143544 */     // GIR_Coverage, 7344,
     /* 143544 */     GIR_EraseRootFromParent_Done,
     /* 143545 */   // Label 2529: @143545
     /* 143545 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(143600), // Rule ID 7345 //
     /* 143550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143560 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143567 */     // MIs[0] Rn
     /* 143567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143583 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 143586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143598 */     GIR_RootConstrainSelectedInstOperands,
     /* 143599 */     // GIR_Coverage, 7345,
     /* 143599 */     GIR_EraseRootFromParent_Done,
     /* 143600 */   // Label 2530: @143600
     /* 143600 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(143655), // Rule ID 7346 //
     /* 143605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143622 */     // MIs[0] Rn
     /* 143622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143638 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 143641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143653 */     GIR_RootConstrainSelectedInstOperands,
     /* 143654 */     // GIR_Coverage, 7346,
     /* 143654 */     GIR_EraseRootFromParent_Done,
     /* 143655 */   // Label 2531: @143655
     /* 143655 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(143710), // Rule ID 7347 //
     /* 143660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143677 */     // MIs[0] Rn
     /* 143677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143693 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 143696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143708 */     GIR_RootConstrainSelectedInstOperands,
     /* 143709 */     // GIR_Coverage, 7347,
     /* 143709 */     GIR_EraseRootFromParent_Done,
     /* 143710 */   // Label 2532: @143710
     /* 143710 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(143765), // Rule ID 7348 //
     /* 143715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143732 */     // MIs[0] Rn
     /* 143732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143748 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143763 */     GIR_RootConstrainSelectedInstOperands,
     /* 143764 */     // GIR_Coverage, 7348,
     /* 143764 */     GIR_EraseRootFromParent_Done,
     /* 143765 */   // Label 2533: @143765
     /* 143765 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(143820), // Rule ID 7349 //
     /* 143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143787 */     // MIs[0] Rn
     /* 143787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143803 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143818 */     GIR_RootConstrainSelectedInstOperands,
     /* 143819 */     // GIR_Coverage, 7349,
     /* 143819 */     GIR_EraseRootFromParent_Done,
     /* 143820 */   // Label 2534: @143820
     /* 143820 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(143875), // Rule ID 7350 //
     /* 143825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143842 */     // MIs[0] Rn
     /* 143842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143858 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 143861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143873 */     GIR_RootConstrainSelectedInstOperands,
     /* 143874 */     // GIR_Coverage, 7350,
     /* 143874 */     GIR_EraseRootFromParent_Done,
     /* 143875 */   // Label 2535: @143875
     /* 143875 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143930), // Rule ID 7351 //
     /* 143880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143897 */     // MIs[0] Rn
     /* 143897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143913 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 143916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143928 */     GIR_RootConstrainSelectedInstOperands,
     /* 143929 */     // GIR_Coverage, 7351,
     /* 143929 */     GIR_EraseRootFromParent_Done,
     /* 143930 */   // Label 2536: @143930
     /* 143930 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(143985), // Rule ID 7352 //
     /* 143935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143952 */     // MIs[0] Rn
     /* 143952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143968 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 143971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143983 */     GIR_RootConstrainSelectedInstOperands,
     /* 143984 */     // GIR_Coverage, 7352,
     /* 143984 */     GIR_EraseRootFromParent_Done,
     /* 143985 */   // Label 2537: @143985
     /* 143985 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(144040), // Rule ID 7353 //
     /* 143990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144007 */     // MIs[0] Rn
     /* 144007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144023 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144038 */     GIR_RootConstrainSelectedInstOperands,
     /* 144039 */     // GIR_Coverage, 7353,
     /* 144039 */     GIR_EraseRootFromParent_Done,
     /* 144040 */   // Label 2538: @144040
     /* 144040 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(144095), // Rule ID 7354 //
     /* 144045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144062 */     // MIs[0] Rn
     /* 144062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144078 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 144081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144093 */     GIR_RootConstrainSelectedInstOperands,
     /* 144094 */     // GIR_Coverage, 7354,
     /* 144094 */     GIR_EraseRootFromParent_Done,
     /* 144095 */   // Label 2539: @144095
     /* 144095 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144155), // Rule ID 13191 //
     /* 144100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144114 */     // MIs[0] addr
     /* 144114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144130 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 144136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144138 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144143 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144145 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144147 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144153 */     GIR_RootConstrainSelectedInstOperands,
     /* 144154 */     // GIR_Coverage, 13191,
     /* 144154 */     GIR_EraseRootFromParent_Done,
     /* 144155 */   // Label 2540: @144155
     /* 144155 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144215), // Rule ID 13192 //
     /* 144160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144174 */     // MIs[0] addr
     /* 144174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144190 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 144196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144198 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144203 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144205 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144207 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144213 */     GIR_RootConstrainSelectedInstOperands,
     /* 144214 */     // GIR_Coverage, 13192,
     /* 144214 */     GIR_EraseRootFromParent_Done,
     /* 144215 */   // Label 2541: @144215
     /* 144215 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144275), // Rule ID 13193 //
     /* 144220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144234 */     // MIs[0] addr
     /* 144234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144250 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 144256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144258 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144263 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144265 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144267 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144273 */     GIR_RootConstrainSelectedInstOperands,
     /* 144274 */     // GIR_Coverage, 13193,
     /* 144274 */     GIR_EraseRootFromParent_Done,
     /* 144275 */   // Label 2542: @144275
     /* 144275 */   GIM_Reject,
     /* 144276 */ // Label 2524: @144276
     /* 144276 */ GIM_Reject,
     /* 144277 */ // Label 2522: @144277
     /* 144277 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144589),
     /* 144282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 144288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 144295 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(144343), // Rule ID 2582 //
     /* 144300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144310 */     // MIs[0] Rn
     /* 144310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144326 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 144329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144341 */     GIR_RootConstrainSelectedInstOperands,
     /* 144342 */     // GIR_Coverage, 2582,
     /* 144342 */     GIR_EraseRootFromParent_Done,
     /* 144343 */   // Label 2544: @144343
     /* 144343 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(144391), // Rule ID 2583 //
     /* 144348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144358 */     // MIs[0] Rn
     /* 144358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144374 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 144377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144389 */     GIR_RootConstrainSelectedInstOperands,
     /* 144390 */     // GIR_Coverage, 2583,
     /* 144390 */     GIR_EraseRootFromParent_Done,
     /* 144391 */   // Label 2545: @144391
     /* 144391 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(144439), // Rule ID 2584 //
     /* 144396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144406 */     // MIs[0] Rn
     /* 144406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144422 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144437 */     GIR_RootConstrainSelectedInstOperands,
     /* 144438 */     // GIR_Coverage, 2584,
     /* 144438 */     GIR_EraseRootFromParent_Done,
     /* 144439 */   // Label 2546: @144439
     /* 144439 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(144487), // Rule ID 2585 //
     /* 144444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144454 */     // MIs[0] Rn
     /* 144454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144470 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144485 */     GIR_RootConstrainSelectedInstOperands,
     /* 144486 */     // GIR_Coverage, 2585,
     /* 144486 */     GIR_EraseRootFromParent_Done,
     /* 144487 */   // Label 2547: @144487
     /* 144487 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(144535), // Rule ID 2586 //
     /* 144492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144502 */     // MIs[0] Rn
     /* 144502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144518 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144533 */     GIR_RootConstrainSelectedInstOperands,
     /* 144534 */     // GIR_Coverage, 2586,
     /* 144534 */     GIR_EraseRootFromParent_Done,
     /* 144535 */   // Label 2548: @144535
     /* 144535 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(144588), // Rule ID 13194 //
     /* 144540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144547 */     // MIs[0] addr
     /* 144547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144563 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 144563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 144569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144571 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144576 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144578 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144580 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144586 */     GIR_RootConstrainSelectedInstOperands,
     /* 144587 */     // GIR_Coverage, 13194,
     /* 144587 */     GIR_EraseRootFromParent_Done,
     /* 144588 */   // Label 2549: @144588
     /* 144588 */   GIM_Reject,
     /* 144589 */ // Label 2543: @144589
     /* 144589 */ GIM_Reject,
     /* 144590 */ // Label 2523: @144590
     /* 144590 */ GIM_Reject,
     /* 144591 */ // Label 21: @144591
     /* 144591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(145582),
     /* 144602 */ /*GILLT_s32*//*Label 2550*/ GIMT_Encode4(144610),
     /* 144606 */ /*GILLT_s64*//*Label 2551*/ GIMT_Encode4(145355),
     /* 144610 */ // Label 2550: @144610
     /* 144610 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145354),
     /* 144615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144618 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144667), // Rule ID 7325 //
     /* 144623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144640 */     // MIs[0] Rn
     /* 144640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144652 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 144655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144665 */     GIR_RootConstrainSelectedInstOperands,
     /* 144666 */     // GIR_Coverage, 7325,
     /* 144666 */     GIR_EraseRootFromParent_Done,
     /* 144667 */   // Label 2554: @144667
     /* 144667 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(144716), // Rule ID 7326 //
     /* 144672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144682 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144689 */     // MIs[0] Rn
     /* 144689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144701 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144714 */     GIR_RootConstrainSelectedInstOperands,
     /* 144715 */     // GIR_Coverage, 7326,
     /* 144715 */     GIR_EraseRootFromParent_Done,
     /* 144716 */   // Label 2555: @144716
     /* 144716 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(144765), // Rule ID 7327 //
     /* 144721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144738 */     // MIs[0] Rn
     /* 144738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144750 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144763 */     GIR_RootConstrainSelectedInstOperands,
     /* 144764 */     // GIR_Coverage, 7327,
     /* 144764 */     GIR_EraseRootFromParent_Done,
     /* 144765 */   // Label 2556: @144765
     /* 144765 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(144814), // Rule ID 7328 //
     /* 144770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144787 */     // MIs[0] Rn
     /* 144787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144799 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144812 */     GIR_RootConstrainSelectedInstOperands,
     /* 144813 */     // GIR_Coverage, 7328,
     /* 144813 */     GIR_EraseRootFromParent_Done,
     /* 144814 */   // Label 2557: @144814
     /* 144814 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(144863), // Rule ID 7329 //
     /* 144819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144836 */     // MIs[0] Rn
     /* 144836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144848 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144861 */     GIR_RootConstrainSelectedInstOperands,
     /* 144862 */     // GIR_Coverage, 7329,
     /* 144862 */     GIR_EraseRootFromParent_Done,
     /* 144863 */   // Label 2558: @144863
     /* 144863 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(144912), // Rule ID 7330 //
     /* 144868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144885 */     // MIs[0] Rn
     /* 144885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144897 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 144900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144910 */     GIR_RootConstrainSelectedInstOperands,
     /* 144911 */     // GIR_Coverage, 7330,
     /* 144911 */     GIR_EraseRootFromParent_Done,
     /* 144912 */   // Label 2559: @144912
     /* 144912 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(144961), // Rule ID 7331 //
     /* 144917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144934 */     // MIs[0] Rn
     /* 144934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144946 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 144949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144959 */     GIR_RootConstrainSelectedInstOperands,
     /* 144960 */     // GIR_Coverage, 7331,
     /* 144960 */     GIR_EraseRootFromParent_Done,
     /* 144961 */   // Label 2560: @144961
     /* 144961 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145010), // Rule ID 7332 //
     /* 144966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144983 */     // MIs[0] Rn
     /* 144983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144995 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 144998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145008 */     GIR_RootConstrainSelectedInstOperands,
     /* 145009 */     // GIR_Coverage, 7332,
     /* 145009 */     GIR_EraseRootFromParent_Done,
     /* 145010 */   // Label 2561: @145010
     /* 145010 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145059), // Rule ID 7333 //
     /* 145015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145032 */     // MIs[0] Rn
     /* 145032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145044 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145057 */     GIR_RootConstrainSelectedInstOperands,
     /* 145058 */     // GIR_Coverage, 7333,
     /* 145058 */     GIR_EraseRootFromParent_Done,
     /* 145059 */   // Label 2562: @145059
     /* 145059 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(145108), // Rule ID 7334 //
     /* 145064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145081 */     // MIs[0] Rn
     /* 145081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145093 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 145096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145106 */     GIR_RootConstrainSelectedInstOperands,
     /* 145107 */     // GIR_Coverage, 7334,
     /* 145107 */     GIR_EraseRootFromParent_Done,
     /* 145108 */   // Label 2563: @145108
     /* 145108 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(145157), // Rule ID 7335 //
     /* 145113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145130 */     // MIs[0] Rn
     /* 145130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145142 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 145145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145155 */     GIR_RootConstrainSelectedInstOperands,
     /* 145156 */     // GIR_Coverage, 7335,
     /* 145156 */     GIR_EraseRootFromParent_Done,
     /* 145157 */   // Label 2564: @145157
     /* 145157 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(145206), // Rule ID 7336 //
     /* 145162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145179 */     // MIs[0] Rn
     /* 145179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145191 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 145194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145204 */     GIR_RootConstrainSelectedInstOperands,
     /* 145205 */     // GIR_Coverage, 7336,
     /* 145205 */     GIR_EraseRootFromParent_Done,
     /* 145206 */   // Label 2565: @145206
     /* 145206 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(145255), // Rule ID 7337 //
     /* 145211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // MIs[0] Rn
     /* 145228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145240 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 145243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145253 */     GIR_RootConstrainSelectedInstOperands,
     /* 145254 */     // GIR_Coverage, 7337,
     /* 145254 */     GIR_EraseRootFromParent_Done,
     /* 145255 */   // Label 2566: @145255
     /* 145255 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(145304), // Rule ID 7338 //
     /* 145260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145277 */     // MIs[0] Rn
     /* 145277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145289 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145302 */     GIR_RootConstrainSelectedInstOperands,
     /* 145303 */     // GIR_Coverage, 7338,
     /* 145303 */     GIR_EraseRootFromParent_Done,
     /* 145304 */   // Label 2567: @145304
     /* 145304 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(145353), // Rule ID 7339 //
     /* 145309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145326 */     // MIs[0] Rn
     /* 145326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145351 */     GIR_RootConstrainSelectedInstOperands,
     /* 145352 */     // GIR_Coverage, 7339,
     /* 145352 */     GIR_EraseRootFromParent_Done,
     /* 145353 */   // Label 2568: @145353
     /* 145353 */   GIM_Reject,
     /* 145354 */ // Label 2553: @145354
     /* 145354 */ GIM_Reject,
     /* 145355 */ // Label 2551: @145355
     /* 145355 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(145581),
     /* 145360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145370 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(145412), // Rule ID 7320 //
     /* 145375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145385 */     // MIs[0] Rn
     /* 145385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145397 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145410 */     GIR_RootConstrainSelectedInstOperands,
     /* 145411 */     // GIR_Coverage, 7320,
     /* 145411 */     GIR_EraseRootFromParent_Done,
     /* 145412 */   // Label 2570: @145412
     /* 145412 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(145454), // Rule ID 7321 //
     /* 145417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145427 */     // MIs[0] Rn
     /* 145427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145439 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 145442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145452 */     GIR_RootConstrainSelectedInstOperands,
     /* 145453 */     // GIR_Coverage, 7321,
     /* 145453 */     GIR_EraseRootFromParent_Done,
     /* 145454 */   // Label 2571: @145454
     /* 145454 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(145496), // Rule ID 7322 //
     /* 145459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145469 */     // MIs[0] Rn
     /* 145469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145481 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 145484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145494 */     GIR_RootConstrainSelectedInstOperands,
     /* 145495 */     // GIR_Coverage, 7322,
     /* 145495 */     GIR_EraseRootFromParent_Done,
     /* 145496 */   // Label 2572: @145496
     /* 145496 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(145538), // Rule ID 7323 //
     /* 145501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145511 */     // MIs[0] Rn
     /* 145511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145523 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145536 */     GIR_RootConstrainSelectedInstOperands,
     /* 145537 */     // GIR_Coverage, 7323,
     /* 145537 */     GIR_EraseRootFromParent_Done,
     /* 145538 */   // Label 2573: @145538
     /* 145538 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(145580), // Rule ID 7324 //
     /* 145543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145553 */     // MIs[0] Rn
     /* 145553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145565 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145578 */     GIR_RootConstrainSelectedInstOperands,
     /* 145579 */     // GIR_Coverage, 7324,
     /* 145579 */     GIR_EraseRootFromParent_Done,
     /* 145580 */   // Label 2574: @145580
     /* 145580 */   GIM_Reject,
     /* 145581 */ // Label 2569: @145581
     /* 145581 */ GIM_Reject,
     /* 145582 */ // Label 2552: @145582
     /* 145582 */ GIM_Reject,
     /* 145583 */ // Label 22: @145583
     /* 145583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2577*/ GIMT_Encode4(146574),
     /* 145594 */ /*GILLT_s32*//*Label 2575*/ GIMT_Encode4(145602),
     /* 145598 */ /*GILLT_s64*//*Label 2576*/ GIMT_Encode4(146347),
     /* 145602 */ // Label 2575: @145602
     /* 145602 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146346),
     /* 145607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145610 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(145659), // Rule ID 7165 //
     /* 145615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145632 */     // MIs[0] Rn
     /* 145632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145644 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 145647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145657 */     GIR_RootConstrainSelectedInstOperands,
     /* 145658 */     // GIR_Coverage, 7165,
     /* 145658 */     GIR_EraseRootFromParent_Done,
     /* 145659 */   // Label 2579: @145659
     /* 145659 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(145708), // Rule ID 7166 //
     /* 145664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145681 */     // MIs[0] Rn
     /* 145681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145693 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 145696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145706 */     GIR_RootConstrainSelectedInstOperands,
     /* 145707 */     // GIR_Coverage, 7166,
     /* 145707 */     GIR_EraseRootFromParent_Done,
     /* 145708 */   // Label 2580: @145708
     /* 145708 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145757), // Rule ID 7167 //
     /* 145713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // MIs[0] Rn
     /* 145730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145742 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145755 */     GIR_RootConstrainSelectedInstOperands,
     /* 145756 */     // GIR_Coverage, 7167,
     /* 145756 */     GIR_EraseRootFromParent_Done,
     /* 145757 */   // Label 2581: @145757
     /* 145757 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(145806), // Rule ID 7168 //
     /* 145762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145779 */     // MIs[0] Rn
     /* 145779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145791 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145804 */     GIR_RootConstrainSelectedInstOperands,
     /* 145805 */     // GIR_Coverage, 7168,
     /* 145805 */     GIR_EraseRootFromParent_Done,
     /* 145806 */   // Label 2582: @145806
     /* 145806 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(145855), // Rule ID 7169 //
     /* 145811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145828 */     // MIs[0] Rn
     /* 145828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145840 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145853 */     GIR_RootConstrainSelectedInstOperands,
     /* 145854 */     // GIR_Coverage, 7169,
     /* 145854 */     GIR_EraseRootFromParent_Done,
     /* 145855 */   // Label 2583: @145855
     /* 145855 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(145904), // Rule ID 7170 //
     /* 145860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145877 */     // MIs[0] Rn
     /* 145877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145889 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 145892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145902 */     GIR_RootConstrainSelectedInstOperands,
     /* 145903 */     // GIR_Coverage, 7170,
     /* 145903 */     GIR_EraseRootFromParent_Done,
     /* 145904 */   // Label 2584: @145904
     /* 145904 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(145953), // Rule ID 7171 //
     /* 145909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145926 */     // MIs[0] Rn
     /* 145926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145938 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 145941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145951 */     GIR_RootConstrainSelectedInstOperands,
     /* 145952 */     // GIR_Coverage, 7171,
     /* 145952 */     GIR_EraseRootFromParent_Done,
     /* 145953 */   // Label 2585: @145953
     /* 145953 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146002), // Rule ID 7172 //
     /* 145958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145975 */     // MIs[0] Rn
     /* 145975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145987 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 145990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146000 */     GIR_RootConstrainSelectedInstOperands,
     /* 146001 */     // GIR_Coverage, 7172,
     /* 146001 */     GIR_EraseRootFromParent_Done,
     /* 146002 */   // Label 2586: @146002
     /* 146002 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146051), // Rule ID 7173 //
     /* 146007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146024 */     // MIs[0] Rn
     /* 146024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146036 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146049 */     GIR_RootConstrainSelectedInstOperands,
     /* 146050 */     // GIR_Coverage, 7173,
     /* 146050 */     GIR_EraseRootFromParent_Done,
     /* 146051 */   // Label 2587: @146051
     /* 146051 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(146100), // Rule ID 7174 //
     /* 146056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146073 */     // MIs[0] Rn
     /* 146073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146085 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 146088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146098 */     GIR_RootConstrainSelectedInstOperands,
     /* 146099 */     // GIR_Coverage, 7174,
     /* 146099 */     GIR_EraseRootFromParent_Done,
     /* 146100 */   // Label 2588: @146100
     /* 146100 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(146149), // Rule ID 7175 //
     /* 146105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146122 */     // MIs[0] Rn
     /* 146122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146134 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146147 */     GIR_RootConstrainSelectedInstOperands,
     /* 146148 */     // GIR_Coverage, 7175,
     /* 146148 */     GIR_EraseRootFromParent_Done,
     /* 146149 */   // Label 2589: @146149
     /* 146149 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(146198), // Rule ID 7176 //
     /* 146154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146171 */     // MIs[0] Rn
     /* 146171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146183 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146196 */     GIR_RootConstrainSelectedInstOperands,
     /* 146197 */     // GIR_Coverage, 7176,
     /* 146197 */     GIR_EraseRootFromParent_Done,
     /* 146198 */   // Label 2590: @146198
     /* 146198 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(146247), // Rule ID 7177 //
     /* 146203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146220 */     // MIs[0] Rn
     /* 146220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146232 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146245 */     GIR_RootConstrainSelectedInstOperands,
     /* 146246 */     // GIR_Coverage, 7177,
     /* 146246 */     GIR_EraseRootFromParent_Done,
     /* 146247 */   // Label 2591: @146247
     /* 146247 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(146296), // Rule ID 7178 //
     /* 146252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146269 */     // MIs[0] Rn
     /* 146269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146281 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146294 */     GIR_RootConstrainSelectedInstOperands,
     /* 146295 */     // GIR_Coverage, 7178,
     /* 146295 */     GIR_EraseRootFromParent_Done,
     /* 146296 */   // Label 2592: @146296
     /* 146296 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146345), // Rule ID 7179 //
     /* 146301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146318 */     // MIs[0] Rn
     /* 146318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146330 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146343 */     GIR_RootConstrainSelectedInstOperands,
     /* 146344 */     // GIR_Coverage, 7179,
     /* 146344 */     GIR_EraseRootFromParent_Done,
     /* 146345 */   // Label 2593: @146345
     /* 146345 */   GIM_Reject,
     /* 146346 */ // Label 2578: @146346
     /* 146346 */ GIM_Reject,
     /* 146347 */ // Label 2576: @146347
     /* 146347 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(146573),
     /* 146352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146362 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(146404), // Rule ID 2572 //
     /* 146367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146377 */     // MIs[0] Rn
     /* 146377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146389 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 146392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146402 */     GIR_RootConstrainSelectedInstOperands,
     /* 146403 */     // GIR_Coverage, 2572,
     /* 146403 */     GIR_EraseRootFromParent_Done,
     /* 146404 */   // Label 2595: @146404
     /* 146404 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(146446), // Rule ID 2573 //
     /* 146409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146419 */     // MIs[0] Rn
     /* 146419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146431 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 146434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146444 */     GIR_RootConstrainSelectedInstOperands,
     /* 146445 */     // GIR_Coverage, 2573,
     /* 146445 */     GIR_EraseRootFromParent_Done,
     /* 146446 */   // Label 2596: @146446
     /* 146446 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(146488), // Rule ID 2574 //
     /* 146451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146461 */     // MIs[0] Rn
     /* 146461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146473 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 146476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146486 */     GIR_RootConstrainSelectedInstOperands,
     /* 146487 */     // GIR_Coverage, 2574,
     /* 146487 */     GIR_EraseRootFromParent_Done,
     /* 146488 */   // Label 2597: @146488
     /* 146488 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(146530), // Rule ID 2575 //
     /* 146493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146503 */     // MIs[0] Rn
     /* 146503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146515 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146528 */     GIR_RootConstrainSelectedInstOperands,
     /* 146529 */     // GIR_Coverage, 2575,
     /* 146529 */     GIR_EraseRootFromParent_Done,
     /* 146530 */   // Label 2598: @146530
     /* 146530 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(146572), // Rule ID 2576 //
     /* 146535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146545 */     // MIs[0] Rn
     /* 146545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146557 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146570 */     GIR_RootConstrainSelectedInstOperands,
     /* 146571 */     // GIR_Coverage, 2576,
     /* 146571 */     GIR_EraseRootFromParent_Done,
     /* 146572 */   // Label 2599: @146572
     /* 146572 */   GIM_Reject,
     /* 146573 */ // Label 2594: @146573
     /* 146573 */ GIM_Reject,
     /* 146574 */ // Label 2577: @146574
     /* 146574 */ GIM_Reject,
     /* 146575 */ // Label 23: @146575
     /* 146575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(148066),
     /* 146586 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(146594),
     /* 146590 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(147714),
     /* 146594 */ // Label 2600: @146594
     /* 146594 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147713),
     /* 146599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146602 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(146676), // Rule ID 7360 //
     /* 146607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146624 */     // MIs[0] Rn
     /* 146624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146636 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146648 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 146663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146674 */     GIR_RootConstrainSelectedInstOperands,
     /* 146675 */     // GIR_Coverage, 7360,
     /* 146675 */     GIR_EraseRootFromParent_Done,
     /* 146676 */   // Label 2604: @146676
     /* 146676 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(146750), // Rule ID 7361 //
     /* 146681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146698 */     // MIs[0] Rn
     /* 146698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146710 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146722 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 146737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146748 */     GIR_RootConstrainSelectedInstOperands,
     /* 146749 */     // GIR_Coverage, 7361,
     /* 146749 */     GIR_EraseRootFromParent_Done,
     /* 146750 */   // Label 2605: @146750
     /* 146750 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(146824), // Rule ID 7362 //
     /* 146755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146772 */     // MIs[0] Rn
     /* 146772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146784 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 146811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146822 */     GIR_RootConstrainSelectedInstOperands,
     /* 146823 */     // GIR_Coverage, 7362,
     /* 146823 */     GIR_EraseRootFromParent_Done,
     /* 146824 */   // Label 2606: @146824
     /* 146824 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(146898), // Rule ID 7363 //
     /* 146829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146846 */     // MIs[0] Rn
     /* 146846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146858 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146870 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146896 */     GIR_RootConstrainSelectedInstOperands,
     /* 146897 */     // GIR_Coverage, 7363,
     /* 146897 */     GIR_EraseRootFromParent_Done,
     /* 146898 */   // Label 2607: @146898
     /* 146898 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(146972), // Rule ID 7364 //
     /* 146903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146920 */     // MIs[0] Rn
     /* 146920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146932 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146944 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146970 */     GIR_RootConstrainSelectedInstOperands,
     /* 146971 */     // GIR_Coverage, 7364,
     /* 146971 */     GIR_EraseRootFromParent_Done,
     /* 146972 */   // Label 2608: @146972
     /* 146972 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147046), // Rule ID 7365 //
     /* 146977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146994 */     // MIs[0] Rn
     /* 146994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147006 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147018 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147044 */     GIR_RootConstrainSelectedInstOperands,
     /* 147045 */     // GIR_Coverage, 7365,
     /* 147045 */     GIR_EraseRootFromParent_Done,
     /* 147046 */   // Label 2609: @147046
     /* 147046 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147120), // Rule ID 7366 //
     /* 147051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147068 */     // MIs[0] Rn
     /* 147068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147080 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147092 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147118 */     GIR_RootConstrainSelectedInstOperands,
     /* 147119 */     // GIR_Coverage, 7366,
     /* 147119 */     GIR_EraseRootFromParent_Done,
     /* 147120 */   // Label 2610: @147120
     /* 147120 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147194), // Rule ID 7367 //
     /* 147125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147142 */     // MIs[0] Rn
     /* 147142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147154 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147166 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147192 */     GIR_RootConstrainSelectedInstOperands,
     /* 147193 */     // GIR_Coverage, 7367,
     /* 147193 */     GIR_EraseRootFromParent_Done,
     /* 147194 */   // Label 2611: @147194
     /* 147194 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147268), // Rule ID 7368 //
     /* 147199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147216 */     // MIs[0] Rn
     /* 147216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147228 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147240 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147266 */     GIR_RootConstrainSelectedInstOperands,
     /* 147267 */     // GIR_Coverage, 7368,
     /* 147267 */     GIR_EraseRootFromParent_Done,
     /* 147268 */   // Label 2612: @147268
     /* 147268 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(147342), // Rule ID 7369 //
     /* 147273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147290 */     // MIs[0] Rn
     /* 147290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147302 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147314 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147340 */     GIR_RootConstrainSelectedInstOperands,
     /* 147341 */     // GIR_Coverage, 7369,
     /* 147341 */     GIR_EraseRootFromParent_Done,
     /* 147342 */   // Label 2613: @147342
     /* 147342 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147416), // Rule ID 7370 //
     /* 147347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147364 */     // MIs[0] Rn
     /* 147364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147376 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147388 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147414 */     GIR_RootConstrainSelectedInstOperands,
     /* 147415 */     // GIR_Coverage, 7370,
     /* 147415 */     GIR_EraseRootFromParent_Done,
     /* 147416 */   // Label 2614: @147416
     /* 147416 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(147490), // Rule ID 7371 //
     /* 147421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147438 */     // MIs[0] Rn
     /* 147438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147450 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147462 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147488 */     GIR_RootConstrainSelectedInstOperands,
     /* 147489 */     // GIR_Coverage, 7371,
     /* 147489 */     GIR_EraseRootFromParent_Done,
     /* 147490 */   // Label 2615: @147490
     /* 147490 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(147564), // Rule ID 7372 //
     /* 147495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147512 */     // MIs[0] Rn
     /* 147512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147524 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147536 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147562 */     GIR_RootConstrainSelectedInstOperands,
     /* 147563 */     // GIR_Coverage, 7372,
     /* 147563 */     GIR_EraseRootFromParent_Done,
     /* 147564 */   // Label 2616: @147564
     /* 147564 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(147638), // Rule ID 7373 //
     /* 147569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147586 */     // MIs[0] Rn
     /* 147586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147598 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147610 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147636 */     GIR_RootConstrainSelectedInstOperands,
     /* 147637 */     // GIR_Coverage, 7373,
     /* 147637 */     GIR_EraseRootFromParent_Done,
     /* 147638 */   // Label 2617: @147638
     /* 147638 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(147712), // Rule ID 7374 //
     /* 147643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147660 */     // MIs[0] Rn
     /* 147660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147672 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147684 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147710 */     GIR_RootConstrainSelectedInstOperands,
     /* 147711 */     // GIR_Coverage, 7374,
     /* 147711 */     GIR_EraseRootFromParent_Done,
     /* 147712 */   // Label 2618: @147712
     /* 147712 */   GIM_Reject,
     /* 147713 */ // Label 2603: @147713
     /* 147713 */ GIM_Reject,
     /* 147714 */ // Label 2601: @147714
     /* 147714 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148065),
     /* 147719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147729 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(147796), // Rule ID 7355 //
     /* 147734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147744 */     // MIs[0] Rn
     /* 147744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147756 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147794 */     GIR_RootConstrainSelectedInstOperands,
     /* 147795 */     // GIR_Coverage, 7355,
     /* 147795 */     GIR_EraseRootFromParent_Done,
     /* 147796 */   // Label 2620: @147796
     /* 147796 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(147863), // Rule ID 7356 //
     /* 147801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147811 */     // MIs[0] Rn
     /* 147811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147823 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147861 */     GIR_RootConstrainSelectedInstOperands,
     /* 147862 */     // GIR_Coverage, 7356,
     /* 147862 */     GIR_EraseRootFromParent_Done,
     /* 147863 */   // Label 2621: @147863
     /* 147863 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(147930), // Rule ID 7357 //
     /* 147868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147878 */     // MIs[0] Rn
     /* 147878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147890 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147902 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147928 */     GIR_RootConstrainSelectedInstOperands,
     /* 147929 */     // GIR_Coverage, 7357,
     /* 147929 */     GIR_EraseRootFromParent_Done,
     /* 147930 */   // Label 2622: @147930
     /* 147930 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(147997), // Rule ID 7358 //
     /* 147935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147945 */     // MIs[0] Rn
     /* 147945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147957 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147969 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147995 */     GIR_RootConstrainSelectedInstOperands,
     /* 147996 */     // GIR_Coverage, 7358,
     /* 147996 */     GIR_EraseRootFromParent_Done,
     /* 147997 */   // Label 2623: @147997
     /* 147997 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148064), // Rule ID 7359 //
     /* 148002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148012 */     // MIs[0] Rn
     /* 148012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148024 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 148027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 148031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148062 */     GIR_RootConstrainSelectedInstOperands,
     /* 148063 */     // GIR_Coverage, 7359,
     /* 148063 */     GIR_EraseRootFromParent_Done,
     /* 148064 */   // Label 2624: @148064
     /* 148064 */   GIM_Reject,
     /* 148065 */ // Label 2619: @148065
     /* 148065 */ GIM_Reject,
     /* 148066 */ // Label 2602: @148066
     /* 148066 */ GIM_Reject,
     /* 148067 */ // Label 24: @148067
     /* 148067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(149558),
     /* 148078 */ /*GILLT_s32*//*Label 2625*/ GIMT_Encode4(148086),
     /* 148082 */ /*GILLT_s64*//*Label 2626*/ GIMT_Encode4(149206),
     /* 148086 */ // Label 2625: @148086
     /* 148086 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(149205),
     /* 148091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148094 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148168), // Rule ID 7380 //
     /* 148099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148102 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148109 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // MIs[0] Rn
     /* 148116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148128 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 148155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148166 */     GIR_RootConstrainSelectedInstOperands,
     /* 148167 */     // GIR_Coverage, 7380,
     /* 148167 */     GIR_EraseRootFromParent_Done,
     /* 148168 */   // Label 2629: @148168
     /* 148168 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148242), // Rule ID 7381 //
     /* 148173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148176 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // MIs[0] Rn
     /* 148190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148202 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 148229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148240 */     GIR_RootConstrainSelectedInstOperands,
     /* 148241 */     // GIR_Coverage, 7381,
     /* 148241 */     GIR_EraseRootFromParent_Done,
     /* 148242 */   // Label 2630: @148242
     /* 148242 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148316), // Rule ID 7382 //
     /* 148247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // MIs[0] Rn
     /* 148264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148276 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148288 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 148303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148314 */     GIR_RootConstrainSelectedInstOperands,
     /* 148315 */     // GIR_Coverage, 7382,
     /* 148315 */     GIR_EraseRootFromParent_Done,
     /* 148316 */   // Label 2631: @148316
     /* 148316 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148390), // Rule ID 7383 //
     /* 148321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // MIs[0] Rn
     /* 148338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148350 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148362 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148388 */     GIR_RootConstrainSelectedInstOperands,
     /* 148389 */     // GIR_Coverage, 7383,
     /* 148389 */     GIR_EraseRootFromParent_Done,
     /* 148390 */   // Label 2632: @148390
     /* 148390 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(148464), // Rule ID 7384 //
     /* 148395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // MIs[0] Rn
     /* 148412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148424 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148436 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148462 */     GIR_RootConstrainSelectedInstOperands,
     /* 148463 */     // GIR_Coverage, 7384,
     /* 148463 */     GIR_EraseRootFromParent_Done,
     /* 148464 */   // Label 2633: @148464
     /* 148464 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(148538), // Rule ID 7385 //
     /* 148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // MIs[0] Rn
     /* 148486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148498 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 148525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 148537 */     // GIR_Coverage, 7385,
     /* 148537 */     GIR_EraseRootFromParent_Done,
     /* 148538 */   // Label 2634: @148538
     /* 148538 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(148612), // Rule ID 7386 //
     /* 148543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // MIs[0] Rn
     /* 148560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148572 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148584 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 148599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148610 */     GIR_RootConstrainSelectedInstOperands,
     /* 148611 */     // GIR_Coverage, 7386,
     /* 148611 */     GIR_EraseRootFromParent_Done,
     /* 148612 */   // Label 2635: @148612
     /* 148612 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(148686), // Rule ID 7387 //
     /* 148617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148620 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148627 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // MIs[0] Rn
     /* 148634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148646 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148658 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148684 */     GIR_RootConstrainSelectedInstOperands,
     /* 148685 */     // GIR_Coverage, 7387,
     /* 148685 */     GIR_EraseRootFromParent_Done,
     /* 148686 */   // Label 2636: @148686
     /* 148686 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(148760), // Rule ID 7388 //
     /* 148691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // MIs[0] Rn
     /* 148708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148720 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148758 */     GIR_RootConstrainSelectedInstOperands,
     /* 148759 */     // GIR_Coverage, 7388,
     /* 148759 */     GIR_EraseRootFromParent_Done,
     /* 148760 */   // Label 2637: @148760
     /* 148760 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(148834), // Rule ID 7389 //
     /* 148765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // MIs[0] Rn
     /* 148782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148794 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148806 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148832 */     GIR_RootConstrainSelectedInstOperands,
     /* 148833 */     // GIR_Coverage, 7389,
     /* 148833 */     GIR_EraseRootFromParent_Done,
     /* 148834 */   // Label 2638: @148834
     /* 148834 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(148908), // Rule ID 7390 //
     /* 148839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // MIs[0] Rn
     /* 148856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148868 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 148895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148906 */     GIR_RootConstrainSelectedInstOperands,
     /* 148907 */     // GIR_Coverage, 7390,
     /* 148907 */     GIR_EraseRootFromParent_Done,
     /* 148908 */   // Label 2639: @148908
     /* 148908 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(148982), // Rule ID 7391 //
     /* 148913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // MIs[0] Rn
     /* 148930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148942 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148954 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 148969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148980 */     GIR_RootConstrainSelectedInstOperands,
     /* 148981 */     // GIR_Coverage, 7391,
     /* 148981 */     GIR_EraseRootFromParent_Done,
     /* 148982 */   // Label 2640: @148982
     /* 148982 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(149056), // Rule ID 7392 //
     /* 148987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // MIs[0] Rn
     /* 149004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149016 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149028 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149054 */     GIR_RootConstrainSelectedInstOperands,
     /* 149055 */     // GIR_Coverage, 7392,
     /* 149055 */     GIR_EraseRootFromParent_Done,
     /* 149056 */   // Label 2641: @149056
     /* 149056 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(149130), // Rule ID 7393 //
     /* 149061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // MIs[0] Rn
     /* 149078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149090 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149102 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149128 */     GIR_RootConstrainSelectedInstOperands,
     /* 149129 */     // GIR_Coverage, 7393,
     /* 149129 */     GIR_EraseRootFromParent_Done,
     /* 149130 */   // Label 2642: @149130
     /* 149130 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(149204), // Rule ID 7394 //
     /* 149135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // MIs[0] Rn
     /* 149152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149164 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149176 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149202 */     GIR_RootConstrainSelectedInstOperands,
     /* 149203 */     // GIR_Coverage, 7394,
     /* 149203 */     GIR_EraseRootFromParent_Done,
     /* 149204 */   // Label 2643: @149204
     /* 149204 */   GIM_Reject,
     /* 149205 */ // Label 2628: @149205
     /* 149205 */ GIM_Reject,
     /* 149206 */ // Label 2626: @149206
     /* 149206 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149557),
     /* 149211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149221 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149288), // Rule ID 7375 //
     /* 149226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // MIs[0] Rn
     /* 149236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149248 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 149275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149286 */     GIR_RootConstrainSelectedInstOperands,
     /* 149287 */     // GIR_Coverage, 7375,
     /* 149287 */     GIR_EraseRootFromParent_Done,
     /* 149288 */   // Label 2645: @149288
     /* 149288 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149355), // Rule ID 7376 //
     /* 149293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // MIs[0] Rn
     /* 149303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149315 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149327 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 149342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149353 */     GIR_RootConstrainSelectedInstOperands,
     /* 149354 */     // GIR_Coverage, 7376,
     /* 149354 */     GIR_EraseRootFromParent_Done,
     /* 149355 */   // Label 2646: @149355
     /* 149355 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149422), // Rule ID 7377 //
     /* 149360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // MIs[0] Rn
     /* 149370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149382 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149394 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 149409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149420 */     GIR_RootConstrainSelectedInstOperands,
     /* 149421 */     // GIR_Coverage, 7377,
     /* 149421 */     GIR_EraseRootFromParent_Done,
     /* 149422 */   // Label 2647: @149422
     /* 149422 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149489), // Rule ID 7378 //
     /* 149427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // MIs[0] Rn
     /* 149437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149449 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149461 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149487 */     GIR_RootConstrainSelectedInstOperands,
     /* 149488 */     // GIR_Coverage, 7378,
     /* 149488 */     GIR_EraseRootFromParent_Done,
     /* 149489 */   // Label 2648: @149489
     /* 149489 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(149556), // Rule ID 7379 //
     /* 149494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // MIs[0] Rn
     /* 149504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149516 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149528 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149554 */     GIR_RootConstrainSelectedInstOperands,
     /* 149555 */     // GIR_Coverage, 7379,
     /* 149555 */     GIR_EraseRootFromParent_Done,
     /* 149556 */   // Label 2649: @149556
     /* 149556 */   GIM_Reject,
     /* 149557 */ // Label 2644: @149557
     /* 149557 */ GIM_Reject,
     /* 149558 */ // Label 2627: @149558
     /* 149558 */ GIM_Reject,
     /* 149559 */ // Label 25: @149559
     /* 149559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2652*/ GIMT_Encode4(150550),
     /* 149570 */ /*GILLT_s32*//*Label 2650*/ GIMT_Encode4(149578),
     /* 149574 */ /*GILLT_s64*//*Label 2651*/ GIMT_Encode4(150323),
     /* 149578 */ // Label 2650: @149578
     /* 149578 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150322),
     /* 149583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149586 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(149635), // Rule ID 7185 //
     /* 149591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // MIs[0] Rn
     /* 149608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149620 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 149623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149633 */     GIR_RootConstrainSelectedInstOperands,
     /* 149634 */     // GIR_Coverage, 7185,
     /* 149634 */     GIR_EraseRootFromParent_Done,
     /* 149635 */   // Label 2654: @149635
     /* 149635 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(149684), // Rule ID 7186 //
     /* 149640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149657 */     // MIs[0] Rn
     /* 149657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149669 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 149672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149682 */     GIR_RootConstrainSelectedInstOperands,
     /* 149683 */     // GIR_Coverage, 7186,
     /* 149683 */     GIR_EraseRootFromParent_Done,
     /* 149684 */   // Label 2655: @149684
     /* 149684 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(149733), // Rule ID 7187 //
     /* 149689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149706 */     // MIs[0] Rn
     /* 149706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149718 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 149721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149731 */     GIR_RootConstrainSelectedInstOperands,
     /* 149732 */     // GIR_Coverage, 7187,
     /* 149732 */     GIR_EraseRootFromParent_Done,
     /* 149733 */   // Label 2656: @149733
     /* 149733 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(149782), // Rule ID 7188 //
     /* 149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149755 */     // MIs[0] Rn
     /* 149755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149767 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149780 */     GIR_RootConstrainSelectedInstOperands,
     /* 149781 */     // GIR_Coverage, 7188,
     /* 149781 */     GIR_EraseRootFromParent_Done,
     /* 149782 */   // Label 2657: @149782
     /* 149782 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(149831), // Rule ID 7189 //
     /* 149787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149804 */     // MIs[0] Rn
     /* 149804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149816 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149829 */     GIR_RootConstrainSelectedInstOperands,
     /* 149830 */     // GIR_Coverage, 7189,
     /* 149830 */     GIR_EraseRootFromParent_Done,
     /* 149831 */   // Label 2658: @149831
     /* 149831 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(149880), // Rule ID 7190 //
     /* 149836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149853 */     // MIs[0] Rn
     /* 149853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149865 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 149868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149878 */     GIR_RootConstrainSelectedInstOperands,
     /* 149879 */     // GIR_Coverage, 7190,
     /* 149879 */     GIR_EraseRootFromParent_Done,
     /* 149880 */   // Label 2659: @149880
     /* 149880 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(149929), // Rule ID 7191 //
     /* 149885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149902 */     // MIs[0] Rn
     /* 149902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149914 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 149917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149927 */     GIR_RootConstrainSelectedInstOperands,
     /* 149928 */     // GIR_Coverage, 7191,
     /* 149928 */     GIR_EraseRootFromParent_Done,
     /* 149929 */   // Label 2660: @149929
     /* 149929 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(149978), // Rule ID 7192 //
     /* 149934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149951 */     // MIs[0] Rn
     /* 149951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149963 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 149966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149976 */     GIR_RootConstrainSelectedInstOperands,
     /* 149977 */     // GIR_Coverage, 7192,
     /* 149977 */     GIR_EraseRootFromParent_Done,
     /* 149978 */   // Label 2661: @149978
     /* 149978 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150027), // Rule ID 7193 //
     /* 149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150000 */     // MIs[0] Rn
     /* 150000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150012 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150025 */     GIR_RootConstrainSelectedInstOperands,
     /* 150026 */     // GIR_Coverage, 7193,
     /* 150026 */     GIR_EraseRootFromParent_Done,
     /* 150027 */   // Label 2662: @150027
     /* 150027 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150076), // Rule ID 7194 //
     /* 150032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150049 */     // MIs[0] Rn
     /* 150049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150061 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 150064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150074 */     GIR_RootConstrainSelectedInstOperands,
     /* 150075 */     // GIR_Coverage, 7194,
     /* 150075 */     GIR_EraseRootFromParent_Done,
     /* 150076 */   // Label 2663: @150076
     /* 150076 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150125), // Rule ID 7195 //
     /* 150081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150098 */     // MIs[0] Rn
     /* 150098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150110 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 150113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150123 */     GIR_RootConstrainSelectedInstOperands,
     /* 150124 */     // GIR_Coverage, 7195,
     /* 150124 */     GIR_EraseRootFromParent_Done,
     /* 150125 */   // Label 2664: @150125
     /* 150125 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(150174), // Rule ID 7196 //
     /* 150130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150147 */     // MIs[0] Rn
     /* 150147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150159 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 150162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150172 */     GIR_RootConstrainSelectedInstOperands,
     /* 150173 */     // GIR_Coverage, 7196,
     /* 150173 */     GIR_EraseRootFromParent_Done,
     /* 150174 */   // Label 2665: @150174
     /* 150174 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(150223), // Rule ID 7197 //
     /* 150179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150196 */     // MIs[0] Rn
     /* 150196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150208 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 150211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150221 */     GIR_RootConstrainSelectedInstOperands,
     /* 150222 */     // GIR_Coverage, 7197,
     /* 150222 */     GIR_EraseRootFromParent_Done,
     /* 150223 */   // Label 2666: @150223
     /* 150223 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(150272), // Rule ID 7198 //
     /* 150228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150245 */     // MIs[0] Rn
     /* 150245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150257 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150270 */     GIR_RootConstrainSelectedInstOperands,
     /* 150271 */     // GIR_Coverage, 7198,
     /* 150271 */     GIR_EraseRootFromParent_Done,
     /* 150272 */   // Label 2667: @150272
     /* 150272 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(150321), // Rule ID 7199 //
     /* 150277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150294 */     // MIs[0] Rn
     /* 150294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150306 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150319 */     GIR_RootConstrainSelectedInstOperands,
     /* 150320 */     // GIR_Coverage, 7199,
     /* 150320 */     GIR_EraseRootFromParent_Done,
     /* 150321 */   // Label 2668: @150321
     /* 150321 */   GIM_Reject,
     /* 150322 */ // Label 2653: @150322
     /* 150322 */ GIM_Reject,
     /* 150323 */ // Label 2651: @150323
     /* 150323 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(150549),
     /* 150328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150338 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(150380), // Rule ID 7180 //
     /* 150343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150353 */     // MIs[0] Rn
     /* 150353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150365 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 150368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150378 */     GIR_RootConstrainSelectedInstOperands,
     /* 150379 */     // GIR_Coverage, 7180,
     /* 150379 */     GIR_EraseRootFromParent_Done,
     /* 150380 */   // Label 2670: @150380
     /* 150380 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150422), // Rule ID 7181 //
     /* 150385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150395 */     // MIs[0] Rn
     /* 150395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150407 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 150410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150420 */     GIR_RootConstrainSelectedInstOperands,
     /* 150421 */     // GIR_Coverage, 7181,
     /* 150421 */     GIR_EraseRootFromParent_Done,
     /* 150422 */   // Label 2671: @150422
     /* 150422 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(150464), // Rule ID 7182 //
     /* 150427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150437 */     // MIs[0] Rn
     /* 150437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150449 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 150452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150462 */     GIR_RootConstrainSelectedInstOperands,
     /* 150463 */     // GIR_Coverage, 7182,
     /* 150463 */     GIR_EraseRootFromParent_Done,
     /* 150464 */   // Label 2672: @150464
     /* 150464 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(150506), // Rule ID 7183 //
     /* 150469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150479 */     // MIs[0] Rn
     /* 150479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150491 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150504 */     GIR_RootConstrainSelectedInstOperands,
     /* 150505 */     // GIR_Coverage, 7183,
     /* 150505 */     GIR_EraseRootFromParent_Done,
     /* 150506 */   // Label 2673: @150506
     /* 150506 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(150548), // Rule ID 7184 //
     /* 150511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150521 */     // MIs[0] Rn
     /* 150521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150533 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150546 */     GIR_RootConstrainSelectedInstOperands,
     /* 150547 */     // GIR_Coverage, 7184,
     /* 150547 */     GIR_EraseRootFromParent_Done,
     /* 150548 */   // Label 2674: @150548
     /* 150548 */   GIM_Reject,
     /* 150549 */ // Label 2669: @150549
     /* 150549 */ GIM_Reject,
     /* 150550 */ // Label 2652: @150550
     /* 150550 */ GIM_Reject,
     /* 150551 */ // Label 26: @150551
     /* 150551 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2677*/ GIMT_Encode4(151542),
     /* 150562 */ /*GILLT_s32*//*Label 2675*/ GIMT_Encode4(150570),
     /* 150566 */ /*GILLT_s64*//*Label 2676*/ GIMT_Encode4(151315),
     /* 150570 */ // Label 2675: @150570
     /* 150570 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151314),
     /* 150575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150578 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(150627), // Rule ID 7205 //
     /* 150583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150600 */     // MIs[0] Rn
     /* 150600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150612 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 150615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150625 */     GIR_RootConstrainSelectedInstOperands,
     /* 150626 */     // GIR_Coverage, 7205,
     /* 150626 */     GIR_EraseRootFromParent_Done,
     /* 150627 */   // Label 2679: @150627
     /* 150627 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(150676), // Rule ID 7206 //
     /* 150632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150635 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150642 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150649 */     // MIs[0] Rn
     /* 150649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150661 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 150664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150674 */     GIR_RootConstrainSelectedInstOperands,
     /* 150675 */     // GIR_Coverage, 7206,
     /* 150675 */     GIR_EraseRootFromParent_Done,
     /* 150676 */   // Label 2680: @150676
     /* 150676 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(150725), // Rule ID 7207 //
     /* 150681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150698 */     // MIs[0] Rn
     /* 150698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150710 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 150713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150723 */     GIR_RootConstrainSelectedInstOperands,
     /* 150724 */     // GIR_Coverage, 7207,
     /* 150724 */     GIR_EraseRootFromParent_Done,
     /* 150725 */   // Label 2681: @150725
     /* 150725 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(150774), // Rule ID 7208 //
     /* 150730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150747 */     // MIs[0] Rn
     /* 150747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150759 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150772 */     GIR_RootConstrainSelectedInstOperands,
     /* 150773 */     // GIR_Coverage, 7208,
     /* 150773 */     GIR_EraseRootFromParent_Done,
     /* 150774 */   // Label 2682: @150774
     /* 150774 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(150823), // Rule ID 7209 //
     /* 150779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150796 */     // MIs[0] Rn
     /* 150796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150808 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150821 */     GIR_RootConstrainSelectedInstOperands,
     /* 150822 */     // GIR_Coverage, 7209,
     /* 150822 */     GIR_EraseRootFromParent_Done,
     /* 150823 */   // Label 2683: @150823
     /* 150823 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(150872), // Rule ID 7210 //
     /* 150828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150845 */     // MIs[0] Rn
     /* 150845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150857 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 150860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150870 */     GIR_RootConstrainSelectedInstOperands,
     /* 150871 */     // GIR_Coverage, 7210,
     /* 150871 */     GIR_EraseRootFromParent_Done,
     /* 150872 */   // Label 2684: @150872
     /* 150872 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(150921), // Rule ID 7211 //
     /* 150877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150894 */     // MIs[0] Rn
     /* 150894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150906 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 150909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150919 */     GIR_RootConstrainSelectedInstOperands,
     /* 150920 */     // GIR_Coverage, 7211,
     /* 150920 */     GIR_EraseRootFromParent_Done,
     /* 150921 */   // Label 2685: @150921
     /* 150921 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(150970), // Rule ID 7212 //
     /* 150926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150943 */     // MIs[0] Rn
     /* 150943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150955 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 150958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150968 */     GIR_RootConstrainSelectedInstOperands,
     /* 150969 */     // GIR_Coverage, 7212,
     /* 150969 */     GIR_EraseRootFromParent_Done,
     /* 150970 */   // Label 2686: @150970
     /* 150970 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151019), // Rule ID 7213 //
     /* 150975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150992 */     // MIs[0] Rn
     /* 150992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151004 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151017 */     GIR_RootConstrainSelectedInstOperands,
     /* 151018 */     // GIR_Coverage, 7213,
     /* 151018 */     GIR_EraseRootFromParent_Done,
     /* 151019 */   // Label 2687: @151019
     /* 151019 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151068), // Rule ID 7214 //
     /* 151024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151041 */     // MIs[0] Rn
     /* 151041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151053 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 151056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151066 */     GIR_RootConstrainSelectedInstOperands,
     /* 151067 */     // GIR_Coverage, 7214,
     /* 151067 */     GIR_EraseRootFromParent_Done,
     /* 151068 */   // Label 2688: @151068
     /* 151068 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(151117), // Rule ID 7215 //
     /* 151073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151090 */     // MIs[0] Rn
     /* 151090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151102 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151115 */     GIR_RootConstrainSelectedInstOperands,
     /* 151116 */     // GIR_Coverage, 7215,
     /* 151116 */     GIR_EraseRootFromParent_Done,
     /* 151117 */   // Label 2689: @151117
     /* 151117 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(151166), // Rule ID 7216 //
     /* 151122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151139 */     // MIs[0] Rn
     /* 151139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151151 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151164 */     GIR_RootConstrainSelectedInstOperands,
     /* 151165 */     // GIR_Coverage, 7216,
     /* 151165 */     GIR_EraseRootFromParent_Done,
     /* 151166 */   // Label 2690: @151166
     /* 151166 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(151215), // Rule ID 7217 //
     /* 151171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151188 */     // MIs[0] Rn
     /* 151188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151200 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151213 */     GIR_RootConstrainSelectedInstOperands,
     /* 151214 */     // GIR_Coverage, 7217,
     /* 151214 */     GIR_EraseRootFromParent_Done,
     /* 151215 */   // Label 2691: @151215
     /* 151215 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151264), // Rule ID 7218 //
     /* 151220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151237 */     // MIs[0] Rn
     /* 151237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151249 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151262 */     GIR_RootConstrainSelectedInstOperands,
     /* 151263 */     // GIR_Coverage, 7218,
     /* 151263 */     GIR_EraseRootFromParent_Done,
     /* 151264 */   // Label 2692: @151264
     /* 151264 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(151313), // Rule ID 7219 //
     /* 151269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151286 */     // MIs[0] Rn
     /* 151286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151298 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151311 */     GIR_RootConstrainSelectedInstOperands,
     /* 151312 */     // GIR_Coverage, 7219,
     /* 151312 */     GIR_EraseRootFromParent_Done,
     /* 151313 */   // Label 2693: @151313
     /* 151313 */   GIM_Reject,
     /* 151314 */ // Label 2678: @151314
     /* 151314 */ GIM_Reject,
     /* 151315 */ // Label 2676: @151315
     /* 151315 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(151541),
     /* 151320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151330 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(151372), // Rule ID 7200 //
     /* 151335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151345 */     // MIs[0] Rn
     /* 151345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151357 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 151360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151370 */     GIR_RootConstrainSelectedInstOperands,
     /* 151371 */     // GIR_Coverage, 7200,
     /* 151371 */     GIR_EraseRootFromParent_Done,
     /* 151372 */   // Label 2695: @151372
     /* 151372 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(151414), // Rule ID 7201 //
     /* 151377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151387 */     // MIs[0] Rn
     /* 151387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151399 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 151402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151412 */     GIR_RootConstrainSelectedInstOperands,
     /* 151413 */     // GIR_Coverage, 7201,
     /* 151413 */     GIR_EraseRootFromParent_Done,
     /* 151414 */   // Label 2696: @151414
     /* 151414 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(151456), // Rule ID 7202 //
     /* 151419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151422 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151429 */     // MIs[0] Rn
     /* 151429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151441 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 151444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151454 */     GIR_RootConstrainSelectedInstOperands,
     /* 151455 */     // GIR_Coverage, 7202,
     /* 151455 */     GIR_EraseRootFromParent_Done,
     /* 151456 */   // Label 2697: @151456
     /* 151456 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(151498), // Rule ID 7203 //
     /* 151461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151471 */     // MIs[0] Rn
     /* 151471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151483 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151496 */     GIR_RootConstrainSelectedInstOperands,
     /* 151497 */     // GIR_Coverage, 7203,
     /* 151497 */     GIR_EraseRootFromParent_Done,
     /* 151498 */   // Label 2698: @151498
     /* 151498 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(151540), // Rule ID 7204 //
     /* 151503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151513 */     // MIs[0] Rn
     /* 151513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151525 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151538 */     GIR_RootConstrainSelectedInstOperands,
     /* 151539 */     // GIR_Coverage, 7204,
     /* 151539 */     GIR_EraseRootFromParent_Done,
     /* 151540 */   // Label 2699: @151540
     /* 151540 */   GIM_Reject,
     /* 151541 */ // Label 2694: @151541
     /* 151541 */ GIM_Reject,
     /* 151542 */ // Label 2677: @151542
     /* 151542 */ GIM_Reject,
     /* 151543 */ // Label 27: @151543
     /* 151543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2702*/ GIMT_Encode4(152534),
     /* 151554 */ /*GILLT_s32*//*Label 2700*/ GIMT_Encode4(151562),
     /* 151558 */ /*GILLT_s64*//*Label 2701*/ GIMT_Encode4(152307),
     /* 151562 */ // Label 2700: @151562
     /* 151562 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152306),
     /* 151567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151570 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151619), // Rule ID 7245 //
     /* 151575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151592 */     // MIs[0] Rn
     /* 151592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151604 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 151607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151617 */     GIR_RootConstrainSelectedInstOperands,
     /* 151618 */     // GIR_Coverage, 7245,
     /* 151618 */     GIR_EraseRootFromParent_Done,
     /* 151619 */   // Label 2704: @151619
     /* 151619 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(151668), // Rule ID 7246 //
     /* 151624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151641 */     // MIs[0] Rn
     /* 151641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151653 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 151656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151666 */     GIR_RootConstrainSelectedInstOperands,
     /* 151667 */     // GIR_Coverage, 7246,
     /* 151667 */     GIR_EraseRootFromParent_Done,
     /* 151668 */   // Label 2705: @151668
     /* 151668 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(151717), // Rule ID 7247 //
     /* 151673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151690 */     // MIs[0] Rn
     /* 151690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151702 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151715 */     GIR_RootConstrainSelectedInstOperands,
     /* 151716 */     // GIR_Coverage, 7247,
     /* 151716 */     GIR_EraseRootFromParent_Done,
     /* 151717 */   // Label 2706: @151717
     /* 151717 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(151766), // Rule ID 7248 //
     /* 151722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151739 */     // MIs[0] Rn
     /* 151739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151751 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151764 */     GIR_RootConstrainSelectedInstOperands,
     /* 151765 */     // GIR_Coverage, 7248,
     /* 151765 */     GIR_EraseRootFromParent_Done,
     /* 151766 */   // Label 2707: @151766
     /* 151766 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(151815), // Rule ID 7249 //
     /* 151771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151788 */     // MIs[0] Rn
     /* 151788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151800 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151813 */     GIR_RootConstrainSelectedInstOperands,
     /* 151814 */     // GIR_Coverage, 7249,
     /* 151814 */     GIR_EraseRootFromParent_Done,
     /* 151815 */   // Label 2708: @151815
     /* 151815 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(151864), // Rule ID 7250 //
     /* 151820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151837 */     // MIs[0] Rn
     /* 151837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151849 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151862 */     GIR_RootConstrainSelectedInstOperands,
     /* 151863 */     // GIR_Coverage, 7250,
     /* 151863 */     GIR_EraseRootFromParent_Done,
     /* 151864 */   // Label 2709: @151864
     /* 151864 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151913), // Rule ID 7251 //
     /* 151869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151886 */     // MIs[0] Rn
     /* 151886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151898 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 151901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151911 */     GIR_RootConstrainSelectedInstOperands,
     /* 151912 */     // GIR_Coverage, 7251,
     /* 151912 */     GIR_EraseRootFromParent_Done,
     /* 151913 */   // Label 2710: @151913
     /* 151913 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151962), // Rule ID 7252 //
     /* 151918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151935 */     // MIs[0] Rn
     /* 151935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151947 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 151950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151960 */     GIR_RootConstrainSelectedInstOperands,
     /* 151961 */     // GIR_Coverage, 7252,
     /* 151961 */     GIR_EraseRootFromParent_Done,
     /* 151962 */   // Label 2711: @151962
     /* 151962 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152011), // Rule ID 7253 //
     /* 151967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151984 */     // MIs[0] Rn
     /* 151984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151996 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 151999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152009 */     GIR_RootConstrainSelectedInstOperands,
     /* 152010 */     // GIR_Coverage, 7253,
     /* 152010 */     GIR_EraseRootFromParent_Done,
     /* 152011 */   // Label 2712: @152011
     /* 152011 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152060), // Rule ID 7254 //
     /* 152016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152033 */     // MIs[0] Rn
     /* 152033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152045 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 152048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152058 */     GIR_RootConstrainSelectedInstOperands,
     /* 152059 */     // GIR_Coverage, 7254,
     /* 152059 */     GIR_EraseRootFromParent_Done,
     /* 152060 */   // Label 2713: @152060
     /* 152060 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(152109), // Rule ID 7255 //
     /* 152065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152082 */     // MIs[0] Rn
     /* 152082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152094 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152107 */     GIR_RootConstrainSelectedInstOperands,
     /* 152108 */     // GIR_Coverage, 7255,
     /* 152108 */     GIR_EraseRootFromParent_Done,
     /* 152109 */   // Label 2714: @152109
     /* 152109 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(152158), // Rule ID 7256 //
     /* 152114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152131 */     // MIs[0] Rn
     /* 152131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152143 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152156 */     GIR_RootConstrainSelectedInstOperands,
     /* 152157 */     // GIR_Coverage, 7256,
     /* 152157 */     GIR_EraseRootFromParent_Done,
     /* 152158 */   // Label 2715: @152158
     /* 152158 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(152207), // Rule ID 7257 //
     /* 152163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152180 */     // MIs[0] Rn
     /* 152180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152192 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152205 */     GIR_RootConstrainSelectedInstOperands,
     /* 152206 */     // GIR_Coverage, 7257,
     /* 152206 */     GIR_EraseRootFromParent_Done,
     /* 152207 */   // Label 2716: @152207
     /* 152207 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(152256), // Rule ID 7258 //
     /* 152212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152229 */     // MIs[0] Rn
     /* 152229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152241 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152254 */     GIR_RootConstrainSelectedInstOperands,
     /* 152255 */     // GIR_Coverage, 7258,
     /* 152255 */     GIR_EraseRootFromParent_Done,
     /* 152256 */   // Label 2717: @152256
     /* 152256 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(152305), // Rule ID 7259 //
     /* 152261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152278 */     // MIs[0] Rn
     /* 152278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152290 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152303 */     GIR_RootConstrainSelectedInstOperands,
     /* 152304 */     // GIR_Coverage, 7259,
     /* 152304 */     GIR_EraseRootFromParent_Done,
     /* 152305 */   // Label 2718: @152305
     /* 152305 */   GIM_Reject,
     /* 152306 */ // Label 2703: @152306
     /* 152306 */ GIM_Reject,
     /* 152307 */ // Label 2701: @152307
     /* 152307 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(152533),
     /* 152312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152322 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(152364), // Rule ID 7240 //
     /* 152327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152337 */     // MIs[0] Rn
     /* 152337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152349 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 152352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152362 */     GIR_RootConstrainSelectedInstOperands,
     /* 152363 */     // GIR_Coverage, 7240,
     /* 152363 */     GIR_EraseRootFromParent_Done,
     /* 152364 */   // Label 2720: @152364
     /* 152364 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(152406), // Rule ID 7241 //
     /* 152369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152379 */     // MIs[0] Rn
     /* 152379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152391 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 152394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152404 */     GIR_RootConstrainSelectedInstOperands,
     /* 152405 */     // GIR_Coverage, 7241,
     /* 152405 */     GIR_EraseRootFromParent_Done,
     /* 152406 */   // Label 2721: @152406
     /* 152406 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(152448), // Rule ID 7242 //
     /* 152411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152421 */     // MIs[0] Rn
     /* 152421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152433 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 152436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152446 */     GIR_RootConstrainSelectedInstOperands,
     /* 152447 */     // GIR_Coverage, 7242,
     /* 152447 */     GIR_EraseRootFromParent_Done,
     /* 152448 */   // Label 2722: @152448
     /* 152448 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(152490), // Rule ID 7243 //
     /* 152453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152463 */     // MIs[0] Rn
     /* 152463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152475 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152488 */     GIR_RootConstrainSelectedInstOperands,
     /* 152489 */     // GIR_Coverage, 7243,
     /* 152489 */     GIR_EraseRootFromParent_Done,
     /* 152490 */   // Label 2723: @152490
     /* 152490 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(152532), // Rule ID 7244 //
     /* 152495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152505 */     // MIs[0] Rn
     /* 152505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152517 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152530 */     GIR_RootConstrainSelectedInstOperands,
     /* 152531 */     // GIR_Coverage, 7244,
     /* 152531 */     GIR_EraseRootFromParent_Done,
     /* 152532 */   // Label 2724: @152532
     /* 152532 */   GIM_Reject,
     /* 152533 */ // Label 2719: @152533
     /* 152533 */ GIM_Reject,
     /* 152534 */ // Label 2702: @152534
     /* 152534 */ GIM_Reject,
     /* 152535 */ // Label 28: @152535
     /* 152535 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2727*/ GIMT_Encode4(153526),
     /* 152546 */ /*GILLT_s32*//*Label 2725*/ GIMT_Encode4(152554),
     /* 152550 */ /*GILLT_s64*//*Label 2726*/ GIMT_Encode4(153299),
     /* 152554 */ // Label 2725: @152554
     /* 152554 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153298),
     /* 152559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152562 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152611), // Rule ID 7265 //
     /* 152567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152584 */     // MIs[0] Rn
     /* 152584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152596 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 152599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152609 */     GIR_RootConstrainSelectedInstOperands,
     /* 152610 */     // GIR_Coverage, 7265,
     /* 152610 */     GIR_EraseRootFromParent_Done,
     /* 152611 */   // Label 2729: @152611
     /* 152611 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152660), // Rule ID 7266 //
     /* 152616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152633 */     // MIs[0] Rn
     /* 152633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152645 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 152648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152658 */     GIR_RootConstrainSelectedInstOperands,
     /* 152659 */     // GIR_Coverage, 7266,
     /* 152659 */     GIR_EraseRootFromParent_Done,
     /* 152660 */   // Label 2730: @152660
     /* 152660 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152709), // Rule ID 7267 //
     /* 152665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152682 */     // MIs[0] Rn
     /* 152682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152694 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 152697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152707 */     GIR_RootConstrainSelectedInstOperands,
     /* 152708 */     // GIR_Coverage, 7267,
     /* 152708 */     GIR_EraseRootFromParent_Done,
     /* 152709 */   // Label 2731: @152709
     /* 152709 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152758), // Rule ID 7268 //
     /* 152714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152731 */     // MIs[0] Rn
     /* 152731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152743 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152756 */     GIR_RootConstrainSelectedInstOperands,
     /* 152757 */     // GIR_Coverage, 7268,
     /* 152757 */     GIR_EraseRootFromParent_Done,
     /* 152758 */   // Label 2732: @152758
     /* 152758 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152807), // Rule ID 7269 //
     /* 152763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152780 */     // MIs[0] Rn
     /* 152780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152792 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152805 */     GIR_RootConstrainSelectedInstOperands,
     /* 152806 */     // GIR_Coverage, 7269,
     /* 152806 */     GIR_EraseRootFromParent_Done,
     /* 152807 */   // Label 2733: @152807
     /* 152807 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152856), // Rule ID 7270 //
     /* 152812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152829 */     // MIs[0] Rn
     /* 152829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152841 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152854 */     GIR_RootConstrainSelectedInstOperands,
     /* 152855 */     // GIR_Coverage, 7270,
     /* 152855 */     GIR_EraseRootFromParent_Done,
     /* 152856 */   // Label 2734: @152856
     /* 152856 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152905), // Rule ID 7271 //
     /* 152861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152878 */     // MIs[0] Rn
     /* 152878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152890 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 152893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152903 */     GIR_RootConstrainSelectedInstOperands,
     /* 152904 */     // GIR_Coverage, 7271,
     /* 152904 */     GIR_EraseRootFromParent_Done,
     /* 152905 */   // Label 2735: @152905
     /* 152905 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152954), // Rule ID 7272 //
     /* 152910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152927 */     // MIs[0] Rn
     /* 152927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152939 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 152942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152952 */     GIR_RootConstrainSelectedInstOperands,
     /* 152953 */     // GIR_Coverage, 7272,
     /* 152953 */     GIR_EraseRootFromParent_Done,
     /* 152954 */   // Label 2736: @152954
     /* 152954 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153003), // Rule ID 7273 //
     /* 152959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152976 */     // MIs[0] Rn
     /* 152976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152988 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 152991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153001 */     GIR_RootConstrainSelectedInstOperands,
     /* 153002 */     // GIR_Coverage, 7273,
     /* 153002 */     GIR_EraseRootFromParent_Done,
     /* 153003 */   // Label 2737: @153003
     /* 153003 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153052), // Rule ID 7274 //
     /* 153008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153025 */     // MIs[0] Rn
     /* 153025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153037 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 153040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153050 */     GIR_RootConstrainSelectedInstOperands,
     /* 153051 */     // GIR_Coverage, 7274,
     /* 153051 */     GIR_EraseRootFromParent_Done,
     /* 153052 */   // Label 2738: @153052
     /* 153052 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(153101), // Rule ID 7275 //
     /* 153057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153074 */     // MIs[0] Rn
     /* 153074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153086 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153099 */     GIR_RootConstrainSelectedInstOperands,
     /* 153100 */     // GIR_Coverage, 7275,
     /* 153100 */     GIR_EraseRootFromParent_Done,
     /* 153101 */   // Label 2739: @153101
     /* 153101 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153150), // Rule ID 7276 //
     /* 153106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153123 */     // MIs[0] Rn
     /* 153123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153135 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153148 */     GIR_RootConstrainSelectedInstOperands,
     /* 153149 */     // GIR_Coverage, 7276,
     /* 153149 */     GIR_EraseRootFromParent_Done,
     /* 153150 */   // Label 2740: @153150
     /* 153150 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(153199), // Rule ID 7277 //
     /* 153155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153172 */     // MIs[0] Rn
     /* 153172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153184 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153197 */     GIR_RootConstrainSelectedInstOperands,
     /* 153198 */     // GIR_Coverage, 7277,
     /* 153198 */     GIR_EraseRootFromParent_Done,
     /* 153199 */   // Label 2741: @153199
     /* 153199 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(153248), // Rule ID 7278 //
     /* 153204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153221 */     // MIs[0] Rn
     /* 153221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153233 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153246 */     GIR_RootConstrainSelectedInstOperands,
     /* 153247 */     // GIR_Coverage, 7278,
     /* 153247 */     GIR_EraseRootFromParent_Done,
     /* 153248 */   // Label 2742: @153248
     /* 153248 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(153297), // Rule ID 7279 //
     /* 153253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153270 */     // MIs[0] Rn
     /* 153270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153282 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153295 */     GIR_RootConstrainSelectedInstOperands,
     /* 153296 */     // GIR_Coverage, 7279,
     /* 153296 */     GIR_EraseRootFromParent_Done,
     /* 153297 */   // Label 2743: @153297
     /* 153297 */   GIM_Reject,
     /* 153298 */ // Label 2728: @153298
     /* 153298 */ GIM_Reject,
     /* 153299 */ // Label 2726: @153299
     /* 153299 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(153525),
     /* 153304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153314 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(153356), // Rule ID 7260 //
     /* 153319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153329 */     // MIs[0] Rn
     /* 153329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153341 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 153344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153354 */     GIR_RootConstrainSelectedInstOperands,
     /* 153355 */     // GIR_Coverage, 7260,
     /* 153355 */     GIR_EraseRootFromParent_Done,
     /* 153356 */   // Label 2745: @153356
     /* 153356 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153398), // Rule ID 7261 //
     /* 153361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153371 */     // MIs[0] Rn
     /* 153371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153383 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 153386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153396 */     GIR_RootConstrainSelectedInstOperands,
     /* 153397 */     // GIR_Coverage, 7261,
     /* 153397 */     GIR_EraseRootFromParent_Done,
     /* 153398 */   // Label 2746: @153398
     /* 153398 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153440), // Rule ID 7262 //
     /* 153403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153413 */     // MIs[0] Rn
     /* 153413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153425 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 153428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153438 */     GIR_RootConstrainSelectedInstOperands,
     /* 153439 */     // GIR_Coverage, 7262,
     /* 153439 */     GIR_EraseRootFromParent_Done,
     /* 153440 */   // Label 2747: @153440
     /* 153440 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(153482), // Rule ID 7263 //
     /* 153445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153455 */     // MIs[0] Rn
     /* 153455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153467 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153480 */     GIR_RootConstrainSelectedInstOperands,
     /* 153481 */     // GIR_Coverage, 7263,
     /* 153481 */     GIR_EraseRootFromParent_Done,
     /* 153482 */   // Label 2748: @153482
     /* 153482 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(153524), // Rule ID 7264 //
     /* 153487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153497 */     // MIs[0] Rn
     /* 153497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153509 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153522 */     GIR_RootConstrainSelectedInstOperands,
     /* 153523 */     // GIR_Coverage, 7264,
     /* 153523 */     GIR_EraseRootFromParent_Done,
     /* 153524 */   // Label 2749: @153524
     /* 153524 */   GIM_Reject,
     /* 153525 */ // Label 2744: @153525
     /* 153525 */ GIM_Reject,
     /* 153526 */ // Label 2727: @153526
     /* 153526 */ GIM_Reject,
     /* 153527 */ // Label 29: @153527
     /* 153527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2752*/ GIMT_Encode4(154518),
     /* 153538 */ /*GILLT_s32*//*Label 2750*/ GIMT_Encode4(153546),
     /* 153542 */ /*GILLT_s64*//*Label 2751*/ GIMT_Encode4(154291),
     /* 153546 */ // Label 2750: @153546
     /* 153546 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154290),
     /* 153551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153554 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153603), // Rule ID 7285 //
     /* 153559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153576 */     // MIs[0] Rn
     /* 153576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153588 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 153591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153601 */     GIR_RootConstrainSelectedInstOperands,
     /* 153602 */     // GIR_Coverage, 7285,
     /* 153602 */     GIR_EraseRootFromParent_Done,
     /* 153603 */   // Label 2754: @153603
     /* 153603 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153652), // Rule ID 7286 //
     /* 153608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153625 */     // MIs[0] Rn
     /* 153625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153637 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 153640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153650 */     GIR_RootConstrainSelectedInstOperands,
     /* 153651 */     // GIR_Coverage, 7286,
     /* 153651 */     GIR_EraseRootFromParent_Done,
     /* 153652 */   // Label 2755: @153652
     /* 153652 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153701), // Rule ID 7287 //
     /* 153657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153674 */     // MIs[0] Rn
     /* 153674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153686 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 153689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153699 */     GIR_RootConstrainSelectedInstOperands,
     /* 153700 */     // GIR_Coverage, 7287,
     /* 153700 */     GIR_EraseRootFromParent_Done,
     /* 153701 */   // Label 2756: @153701
     /* 153701 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153750), // Rule ID 7288 //
     /* 153706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153723 */     // MIs[0] Rn
     /* 153723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153735 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153748 */     GIR_RootConstrainSelectedInstOperands,
     /* 153749 */     // GIR_Coverage, 7288,
     /* 153749 */     GIR_EraseRootFromParent_Done,
     /* 153750 */   // Label 2757: @153750
     /* 153750 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153799), // Rule ID 7289 //
     /* 153755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153772 */     // MIs[0] Rn
     /* 153772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153784 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153797 */     GIR_RootConstrainSelectedInstOperands,
     /* 153798 */     // GIR_Coverage, 7289,
     /* 153798 */     GIR_EraseRootFromParent_Done,
     /* 153799 */   // Label 2758: @153799
     /* 153799 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153848), // Rule ID 7290 //
     /* 153804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153821 */     // MIs[0] Rn
     /* 153821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153833 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153846 */     GIR_RootConstrainSelectedInstOperands,
     /* 153847 */     // GIR_Coverage, 7290,
     /* 153847 */     GIR_EraseRootFromParent_Done,
     /* 153848 */   // Label 2759: @153848
     /* 153848 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153897), // Rule ID 7291 //
     /* 153853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153870 */     // MIs[0] Rn
     /* 153870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153882 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 153885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153895 */     GIR_RootConstrainSelectedInstOperands,
     /* 153896 */     // GIR_Coverage, 7291,
     /* 153896 */     GIR_EraseRootFromParent_Done,
     /* 153897 */   // Label 2760: @153897
     /* 153897 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153946), // Rule ID 7292 //
     /* 153902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153919 */     // MIs[0] Rn
     /* 153919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153931 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 153934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153944 */     GIR_RootConstrainSelectedInstOperands,
     /* 153945 */     // GIR_Coverage, 7292,
     /* 153945 */     GIR_EraseRootFromParent_Done,
     /* 153946 */   // Label 2761: @153946
     /* 153946 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153995), // Rule ID 7293 //
     /* 153951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153968 */     // MIs[0] Rn
     /* 153968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153980 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 153983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153993 */     GIR_RootConstrainSelectedInstOperands,
     /* 153994 */     // GIR_Coverage, 7293,
     /* 153994 */     GIR_EraseRootFromParent_Done,
     /* 153995 */   // Label 2762: @153995
     /* 153995 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154044), // Rule ID 7294 //
     /* 154000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154017 */     // MIs[0] Rn
     /* 154017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154029 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 154032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154042 */     GIR_RootConstrainSelectedInstOperands,
     /* 154043 */     // GIR_Coverage, 7294,
     /* 154043 */     GIR_EraseRootFromParent_Done,
     /* 154044 */   // Label 2763: @154044
     /* 154044 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(154093), // Rule ID 7295 //
     /* 154049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154066 */     // MIs[0] Rn
     /* 154066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154078 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154091 */     GIR_RootConstrainSelectedInstOperands,
     /* 154092 */     // GIR_Coverage, 7295,
     /* 154092 */     GIR_EraseRootFromParent_Done,
     /* 154093 */   // Label 2764: @154093
     /* 154093 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154142), // Rule ID 7296 //
     /* 154098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154115 */     // MIs[0] Rn
     /* 154115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154127 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154140 */     GIR_RootConstrainSelectedInstOperands,
     /* 154141 */     // GIR_Coverage, 7296,
     /* 154141 */     GIR_EraseRootFromParent_Done,
     /* 154142 */   // Label 2765: @154142
     /* 154142 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154191), // Rule ID 7297 //
     /* 154147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154164 */     // MIs[0] Rn
     /* 154164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154176 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154189 */     GIR_RootConstrainSelectedInstOperands,
     /* 154190 */     // GIR_Coverage, 7297,
     /* 154190 */     GIR_EraseRootFromParent_Done,
     /* 154191 */   // Label 2766: @154191
     /* 154191 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154240), // Rule ID 7298 //
     /* 154196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154213 */     // MIs[0] Rn
     /* 154213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154225 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154238 */     GIR_RootConstrainSelectedInstOperands,
     /* 154239 */     // GIR_Coverage, 7298,
     /* 154239 */     GIR_EraseRootFromParent_Done,
     /* 154240 */   // Label 2767: @154240
     /* 154240 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154289), // Rule ID 7299 //
     /* 154245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154262 */     // MIs[0] Rn
     /* 154262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154274 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154287 */     GIR_RootConstrainSelectedInstOperands,
     /* 154288 */     // GIR_Coverage, 7299,
     /* 154288 */     GIR_EraseRootFromParent_Done,
     /* 154289 */   // Label 2768: @154289
     /* 154289 */   GIM_Reject,
     /* 154290 */ // Label 2753: @154290
     /* 154290 */ GIM_Reject,
     /* 154291 */ // Label 2751: @154291
     /* 154291 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154517),
     /* 154296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154306 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154348), // Rule ID 7280 //
     /* 154311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154321 */     // MIs[0] Rn
     /* 154321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154333 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 154336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154346 */     GIR_RootConstrainSelectedInstOperands,
     /* 154347 */     // GIR_Coverage, 7280,
     /* 154347 */     GIR_EraseRootFromParent_Done,
     /* 154348 */   // Label 2770: @154348
     /* 154348 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154390), // Rule ID 7281 //
     /* 154353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154363 */     // MIs[0] Rn
     /* 154363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154375 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 154378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154388 */     GIR_RootConstrainSelectedInstOperands,
     /* 154389 */     // GIR_Coverage, 7281,
     /* 154389 */     GIR_EraseRootFromParent_Done,
     /* 154390 */   // Label 2771: @154390
     /* 154390 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154432), // Rule ID 7282 //
     /* 154395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154405 */     // MIs[0] Rn
     /* 154405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154417 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 154420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154430 */     GIR_RootConstrainSelectedInstOperands,
     /* 154431 */     // GIR_Coverage, 7282,
     /* 154431 */     GIR_EraseRootFromParent_Done,
     /* 154432 */   // Label 2772: @154432
     /* 154432 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154474), // Rule ID 7283 //
     /* 154437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154447 */     // MIs[0] Rn
     /* 154447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154459 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154472 */     GIR_RootConstrainSelectedInstOperands,
     /* 154473 */     // GIR_Coverage, 7283,
     /* 154473 */     GIR_EraseRootFromParent_Done,
     /* 154474 */   // Label 2773: @154474
     /* 154474 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154516), // Rule ID 7284 //
     /* 154479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154489 */     // MIs[0] Rn
     /* 154489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154501 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154514 */     GIR_RootConstrainSelectedInstOperands,
     /* 154515 */     // GIR_Coverage, 7284,
     /* 154515 */     GIR_EraseRootFromParent_Done,
     /* 154516 */   // Label 2774: @154516
     /* 154516 */   GIM_Reject,
     /* 154517 */ // Label 2769: @154517
     /* 154517 */ GIM_Reject,
     /* 154518 */ // Label 2752: @154518
     /* 154518 */ GIM_Reject,
     /* 154519 */ // Label 30: @154519
     /* 154519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2777*/ GIMT_Encode4(155510),
     /* 154530 */ /*GILLT_s32*//*Label 2775*/ GIMT_Encode4(154538),
     /* 154534 */ /*GILLT_s64*//*Label 2776*/ GIMT_Encode4(155283),
     /* 154538 */ // Label 2775: @154538
     /* 154538 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155282),
     /* 154543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154546 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154595), // Rule ID 7305 //
     /* 154551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154568 */     // MIs[0] Rn
     /* 154568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154580 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 154583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154593 */     GIR_RootConstrainSelectedInstOperands,
     /* 154594 */     // GIR_Coverage, 7305,
     /* 154594 */     GIR_EraseRootFromParent_Done,
     /* 154595 */   // Label 2779: @154595
     /* 154595 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154644), // Rule ID 7306 //
     /* 154600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154617 */     // MIs[0] Rn
     /* 154617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154629 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 154632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154642 */     GIR_RootConstrainSelectedInstOperands,
     /* 154643 */     // GIR_Coverage, 7306,
     /* 154643 */     GIR_EraseRootFromParent_Done,
     /* 154644 */   // Label 2780: @154644
     /* 154644 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154693), // Rule ID 7307 //
     /* 154649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154666 */     // MIs[0] Rn
     /* 154666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154678 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 154681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154691 */     GIR_RootConstrainSelectedInstOperands,
     /* 154692 */     // GIR_Coverage, 7307,
     /* 154692 */     GIR_EraseRootFromParent_Done,
     /* 154693 */   // Label 2781: @154693
     /* 154693 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154742), // Rule ID 7308 //
     /* 154698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154715 */     // MIs[0] Rn
     /* 154715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154727 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154740 */     GIR_RootConstrainSelectedInstOperands,
     /* 154741 */     // GIR_Coverage, 7308,
     /* 154741 */     GIR_EraseRootFromParent_Done,
     /* 154742 */   // Label 2782: @154742
     /* 154742 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154791), // Rule ID 7309 //
     /* 154747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154764 */     // MIs[0] Rn
     /* 154764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154776 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154789 */     GIR_RootConstrainSelectedInstOperands,
     /* 154790 */     // GIR_Coverage, 7309,
     /* 154790 */     GIR_EraseRootFromParent_Done,
     /* 154791 */   // Label 2783: @154791
     /* 154791 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154840), // Rule ID 7310 //
     /* 154796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154813 */     // MIs[0] Rn
     /* 154813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154825 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154838 */     GIR_RootConstrainSelectedInstOperands,
     /* 154839 */     // GIR_Coverage, 7310,
     /* 154839 */     GIR_EraseRootFromParent_Done,
     /* 154840 */   // Label 2784: @154840
     /* 154840 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154889), // Rule ID 7311 //
     /* 154845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154862 */     // MIs[0] Rn
     /* 154862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154874 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 154877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154887 */     GIR_RootConstrainSelectedInstOperands,
     /* 154888 */     // GIR_Coverage, 7311,
     /* 154888 */     GIR_EraseRootFromParent_Done,
     /* 154889 */   // Label 2785: @154889
     /* 154889 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(154938), // Rule ID 7312 //
     /* 154894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154911 */     // MIs[0] Rn
     /* 154911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154923 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 154926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154936 */     GIR_RootConstrainSelectedInstOperands,
     /* 154937 */     // GIR_Coverage, 7312,
     /* 154937 */     GIR_EraseRootFromParent_Done,
     /* 154938 */   // Label 2786: @154938
     /* 154938 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(154987), // Rule ID 7313 //
     /* 154943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154960 */     // MIs[0] Rn
     /* 154960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154972 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 154975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154985 */     GIR_RootConstrainSelectedInstOperands,
     /* 154986 */     // GIR_Coverage, 7313,
     /* 154986 */     GIR_EraseRootFromParent_Done,
     /* 154987 */   // Label 2787: @154987
     /* 154987 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155036), // Rule ID 7314 //
     /* 154992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155009 */     // MIs[0] Rn
     /* 155009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155021 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 155024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155034 */     GIR_RootConstrainSelectedInstOperands,
     /* 155035 */     // GIR_Coverage, 7314,
     /* 155035 */     GIR_EraseRootFromParent_Done,
     /* 155036 */   // Label 2788: @155036
     /* 155036 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155085), // Rule ID 7315 //
     /* 155041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155058 */     // MIs[0] Rn
     /* 155058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155070 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155083 */     GIR_RootConstrainSelectedInstOperands,
     /* 155084 */     // GIR_Coverage, 7315,
     /* 155084 */     GIR_EraseRootFromParent_Done,
     /* 155085 */   // Label 2789: @155085
     /* 155085 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155134), // Rule ID 7316 //
     /* 155090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155107 */     // MIs[0] Rn
     /* 155107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155119 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155132 */     GIR_RootConstrainSelectedInstOperands,
     /* 155133 */     // GIR_Coverage, 7316,
     /* 155133 */     GIR_EraseRootFromParent_Done,
     /* 155134 */   // Label 2790: @155134
     /* 155134 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155183), // Rule ID 7317 //
     /* 155139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155156 */     // MIs[0] Rn
     /* 155156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155168 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155181 */     GIR_RootConstrainSelectedInstOperands,
     /* 155182 */     // GIR_Coverage, 7317,
     /* 155182 */     GIR_EraseRootFromParent_Done,
     /* 155183 */   // Label 2791: @155183
     /* 155183 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155232), // Rule ID 7318 //
     /* 155188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155205 */     // MIs[0] Rn
     /* 155205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155217 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155230 */     GIR_RootConstrainSelectedInstOperands,
     /* 155231 */     // GIR_Coverage, 7318,
     /* 155231 */     GIR_EraseRootFromParent_Done,
     /* 155232 */   // Label 2792: @155232
     /* 155232 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155281), // Rule ID 7319 //
     /* 155237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155254 */     // MIs[0] Rn
     /* 155254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155266 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155279 */     GIR_RootConstrainSelectedInstOperands,
     /* 155280 */     // GIR_Coverage, 7319,
     /* 155280 */     GIR_EraseRootFromParent_Done,
     /* 155281 */   // Label 2793: @155281
     /* 155281 */   GIM_Reject,
     /* 155282 */ // Label 2778: @155282
     /* 155282 */ GIM_Reject,
     /* 155283 */ // Label 2776: @155283
     /* 155283 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155509),
     /* 155288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155298 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155340), // Rule ID 7300 //
     /* 155303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155313 */     // MIs[0] Rn
     /* 155313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155325 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 155328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155338 */     GIR_RootConstrainSelectedInstOperands,
     /* 155339 */     // GIR_Coverage, 7300,
     /* 155339 */     GIR_EraseRootFromParent_Done,
     /* 155340 */   // Label 2795: @155340
     /* 155340 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155382), // Rule ID 7301 //
     /* 155345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155355 */     // MIs[0] Rn
     /* 155355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155367 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 155370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155380 */     GIR_RootConstrainSelectedInstOperands,
     /* 155381 */     // GIR_Coverage, 7301,
     /* 155381 */     GIR_EraseRootFromParent_Done,
     /* 155382 */   // Label 2796: @155382
     /* 155382 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155424), // Rule ID 7302 //
     /* 155387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155397 */     // MIs[0] Rn
     /* 155397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155409 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 155412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155422 */     GIR_RootConstrainSelectedInstOperands,
     /* 155423 */     // GIR_Coverage, 7302,
     /* 155423 */     GIR_EraseRootFromParent_Done,
     /* 155424 */   // Label 2797: @155424
     /* 155424 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155466), // Rule ID 7303 //
     /* 155429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155439 */     // MIs[0] Rn
     /* 155439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155451 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155464 */     GIR_RootConstrainSelectedInstOperands,
     /* 155465 */     // GIR_Coverage, 7303,
     /* 155465 */     GIR_EraseRootFromParent_Done,
     /* 155466 */   // Label 2798: @155466
     /* 155466 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155508), // Rule ID 7304 //
     /* 155471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155481 */     // MIs[0] Rn
     /* 155481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155493 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155506 */     GIR_RootConstrainSelectedInstOperands,
     /* 155507 */     // GIR_Coverage, 7304,
     /* 155507 */     GIR_EraseRootFromParent_Done,
     /* 155508 */   // Label 2799: @155508
     /* 155508 */   GIM_Reject,
     /* 155509 */ // Label 2794: @155509
     /* 155509 */ GIM_Reject,
     /* 155510 */ // Label 2777: @155510
     /* 155510 */ GIM_Reject,
     /* 155511 */ // Label 31: @155511
     /* 155511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2803*/ GIMT_Encode4(156215),
     /* 155522 */ /*GILLT_s16*//*Label 2800*/ GIMT_Encode4(155534),
     /* 155526 */ /*GILLT_s32*//*Label 2801*/ GIMT_Encode4(155761),
     /* 155530 */ /*GILLT_s64*//*Label 2802*/ GIMT_Encode4(155988),
     /* 155534 */ // Label 2800: @155534
     /* 155534 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155760),
     /* 155539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155549 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155591), // Rule ID 2577 //
     /* 155554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155564 */     // MIs[0] Rn
     /* 155564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155576 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 155579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155589 */     GIR_RootConstrainSelectedInstOperands,
     /* 155590 */     // GIR_Coverage, 2577,
     /* 155590 */     GIR_EraseRootFromParent_Done,
     /* 155591 */   // Label 2805: @155591
     /* 155591 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155633), // Rule ID 2578 //
     /* 155596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155606 */     // MIs[0] Rn
     /* 155606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155618 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 155621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155631 */     GIR_RootConstrainSelectedInstOperands,
     /* 155632 */     // GIR_Coverage, 2578,
     /* 155632 */     GIR_EraseRootFromParent_Done,
     /* 155633 */   // Label 2806: @155633
     /* 155633 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155675), // Rule ID 2579 //
     /* 155638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155648 */     // MIs[0] Rn
     /* 155648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155660 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155673 */     GIR_RootConstrainSelectedInstOperands,
     /* 155674 */     // GIR_Coverage, 2579,
     /* 155674 */     GIR_EraseRootFromParent_Done,
     /* 155675 */   // Label 2807: @155675
     /* 155675 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155717), // Rule ID 2580 //
     /* 155680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155690 */     // MIs[0] Rn
     /* 155690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155702 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155715 */     GIR_RootConstrainSelectedInstOperands,
     /* 155716 */     // GIR_Coverage, 2580,
     /* 155716 */     GIR_EraseRootFromParent_Done,
     /* 155717 */   // Label 2808: @155717
     /* 155717 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155759), // Rule ID 2581 //
     /* 155722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155732 */     // MIs[0] Rn
     /* 155732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155744 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155757 */     GIR_RootConstrainSelectedInstOperands,
     /* 155758 */     // GIR_Coverage, 2581,
     /* 155758 */     GIR_EraseRootFromParent_Done,
     /* 155759 */   // Label 2809: @155759
     /* 155759 */   GIM_Reject,
     /* 155760 */ // Label 2804: @155760
     /* 155760 */ GIM_Reject,
     /* 155761 */ // Label 2801: @155761
     /* 155761 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155987),
     /* 155766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155776 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155818), // Rule ID 7395 //
     /* 155781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155791 */     // MIs[0] Rn
     /* 155791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155803 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 155806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155816 */     GIR_RootConstrainSelectedInstOperands,
     /* 155817 */     // GIR_Coverage, 7395,
     /* 155817 */     GIR_EraseRootFromParent_Done,
     /* 155818 */   // Label 2811: @155818
     /* 155818 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155860), // Rule ID 7396 //
     /* 155823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155833 */     // MIs[0] Rn
     /* 155833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155845 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 155848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155858 */     GIR_RootConstrainSelectedInstOperands,
     /* 155859 */     // GIR_Coverage, 7396,
     /* 155859 */     GIR_EraseRootFromParent_Done,
     /* 155860 */   // Label 2812: @155860
     /* 155860 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155902), // Rule ID 7397 //
     /* 155865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155875 */     // MIs[0] Rn
     /* 155875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155887 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 155890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155900 */     GIR_RootConstrainSelectedInstOperands,
     /* 155901 */     // GIR_Coverage, 7397,
     /* 155901 */     GIR_EraseRootFromParent_Done,
     /* 155902 */   // Label 2813: @155902
     /* 155902 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(155944), // Rule ID 7398 //
     /* 155907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155917 */     // MIs[0] Rn
     /* 155917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155929 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155942 */     GIR_RootConstrainSelectedInstOperands,
     /* 155943 */     // GIR_Coverage, 7398,
     /* 155943 */     GIR_EraseRootFromParent_Done,
     /* 155944 */   // Label 2814: @155944
     /* 155944 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155986), // Rule ID 7399 //
     /* 155949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155959 */     // MIs[0] Rn
     /* 155959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155971 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155984 */     GIR_RootConstrainSelectedInstOperands,
     /* 155985 */     // GIR_Coverage, 7399,
     /* 155985 */     GIR_EraseRootFromParent_Done,
     /* 155986 */   // Label 2815: @155986
     /* 155986 */   GIM_Reject,
     /* 155987 */ // Label 2810: @155987
     /* 155987 */ GIM_Reject,
     /* 155988 */ // Label 2802: @155988
     /* 155988 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(156214),
     /* 155993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156003 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156045), // Rule ID 7400 //
     /* 156008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156018 */     // MIs[0] Rn
     /* 156018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156030 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 156033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156043 */     GIR_RootConstrainSelectedInstOperands,
     /* 156044 */     // GIR_Coverage, 7400,
     /* 156044 */     GIR_EraseRootFromParent_Done,
     /* 156045 */   // Label 2817: @156045
     /* 156045 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156087), // Rule ID 7401 //
     /* 156050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156060 */     // MIs[0] Rn
     /* 156060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156072 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 156075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156085 */     GIR_RootConstrainSelectedInstOperands,
     /* 156086 */     // GIR_Coverage, 7401,
     /* 156086 */     GIR_EraseRootFromParent_Done,
     /* 156087 */   // Label 2818: @156087
     /* 156087 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156129), // Rule ID 7402 //
     /* 156092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156102 */     // MIs[0] Rn
     /* 156102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156114 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 156117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156127 */     GIR_RootConstrainSelectedInstOperands,
     /* 156128 */     // GIR_Coverage, 7402,
     /* 156128 */     GIR_EraseRootFromParent_Done,
     /* 156129 */   // Label 2819: @156129
     /* 156129 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(156171), // Rule ID 7403 //
     /* 156134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156144 */     // MIs[0] Rn
     /* 156144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156156 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156169 */     GIR_RootConstrainSelectedInstOperands,
     /* 156170 */     // GIR_Coverage, 7403,
     /* 156170 */     GIR_EraseRootFromParent_Done,
     /* 156171 */   // Label 2820: @156171
     /* 156171 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(156213), // Rule ID 7404 //
     /* 156176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156186 */     // MIs[0] Rn
     /* 156186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156198 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156211 */     GIR_RootConstrainSelectedInstOperands,
     /* 156212 */     // GIR_Coverage, 7404,
     /* 156212 */     GIR_EraseRootFromParent_Done,
     /* 156213 */   // Label 2821: @156213
     /* 156213 */   GIM_Reject,
     /* 156214 */ // Label 2816: @156214
     /* 156214 */ GIM_Reject,
     /* 156215 */ // Label 2803: @156215
     /* 156215 */ GIM_Reject,
     /* 156216 */ // Label 32: @156216
     /* 156216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(156920),
     /* 156227 */ /*GILLT_s16*//*Label 2822*/ GIMT_Encode4(156239),
     /* 156231 */ /*GILLT_s32*//*Label 2823*/ GIMT_Encode4(156466),
     /* 156235 */ /*GILLT_s64*//*Label 2824*/ GIMT_Encode4(156693),
     /* 156239 */ // Label 2822: @156239
     /* 156239 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156465),
     /* 156244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156247 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156254 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156296), // Rule ID 7405 //
     /* 156259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156269 */     // MIs[0] Rn
     /* 156269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156281 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 156284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156294 */     GIR_RootConstrainSelectedInstOperands,
     /* 156295 */     // GIR_Coverage, 7405,
     /* 156295 */     GIR_EraseRootFromParent_Done,
     /* 156296 */   // Label 2827: @156296
     /* 156296 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156338), // Rule ID 7406 //
     /* 156301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156311 */     // MIs[0] Rn
     /* 156311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156323 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 156326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156336 */     GIR_RootConstrainSelectedInstOperands,
     /* 156337 */     // GIR_Coverage, 7406,
     /* 156337 */     GIR_EraseRootFromParent_Done,
     /* 156338 */   // Label 2828: @156338
     /* 156338 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156380), // Rule ID 7407 //
     /* 156343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156353 */     // MIs[0] Rn
     /* 156353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156365 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 156368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156378 */     GIR_RootConstrainSelectedInstOperands,
     /* 156379 */     // GIR_Coverage, 7407,
     /* 156379 */     GIR_EraseRootFromParent_Done,
     /* 156380 */   // Label 2829: @156380
     /* 156380 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156422), // Rule ID 7408 //
     /* 156385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156395 */     // MIs[0] Rn
     /* 156395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156407 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 156421 */     // GIR_Coverage, 7408,
     /* 156421 */     GIR_EraseRootFromParent_Done,
     /* 156422 */   // Label 2830: @156422
     /* 156422 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156464), // Rule ID 7409 //
     /* 156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156437 */     // MIs[0] Rn
     /* 156437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156449 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156462 */     GIR_RootConstrainSelectedInstOperands,
     /* 156463 */     // GIR_Coverage, 7409,
     /* 156463 */     GIR_EraseRootFromParent_Done,
     /* 156464 */   // Label 2831: @156464
     /* 156464 */   GIM_Reject,
     /* 156465 */ // Label 2826: @156465
     /* 156465 */ GIM_Reject,
     /* 156466 */ // Label 2823: @156466
     /* 156466 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156692),
     /* 156471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156481 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156523), // Rule ID 7410 //
     /* 156486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156496 */     // MIs[0] Rn
     /* 156496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156508 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 156511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156521 */     GIR_RootConstrainSelectedInstOperands,
     /* 156522 */     // GIR_Coverage, 7410,
     /* 156522 */     GIR_EraseRootFromParent_Done,
     /* 156523 */   // Label 2833: @156523
     /* 156523 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156565), // Rule ID 7411 //
     /* 156528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156550 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7411,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2834: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156607), // Rule ID 7412 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156580 */     // MIs[0] Rn
     /* 156580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156592 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 156595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156605 */     GIR_RootConstrainSelectedInstOperands,
     /* 156606 */     // GIR_Coverage, 7412,
     /* 156606 */     GIR_EraseRootFromParent_Done,
     /* 156607 */   // Label 2835: @156607
     /* 156607 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156649), // Rule ID 7413 //
     /* 156612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156622 */     // MIs[0] Rn
     /* 156622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156634 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156647 */     GIR_RootConstrainSelectedInstOperands,
     /* 156648 */     // GIR_Coverage, 7413,
     /* 156648 */     GIR_EraseRootFromParent_Done,
     /* 156649 */   // Label 2836: @156649
     /* 156649 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156691), // Rule ID 7414 //
     /* 156654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156664 */     // MIs[0] Rn
     /* 156664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156676 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156689 */     GIR_RootConstrainSelectedInstOperands,
     /* 156690 */     // GIR_Coverage, 7414,
     /* 156690 */     GIR_EraseRootFromParent_Done,
     /* 156691 */   // Label 2837: @156691
     /* 156691 */   GIM_Reject,
     /* 156692 */ // Label 2832: @156692
     /* 156692 */ GIM_Reject,
     /* 156693 */ // Label 2824: @156693
     /* 156693 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156919),
     /* 156698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156708 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156750), // Rule ID 7415 //
     /* 156713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156723 */     // MIs[0] Rn
     /* 156723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156735 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 156738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156748 */     GIR_RootConstrainSelectedInstOperands,
     /* 156749 */     // GIR_Coverage, 7415,
     /* 156749 */     GIR_EraseRootFromParent_Done,
     /* 156750 */   // Label 2839: @156750
     /* 156750 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156792), // Rule ID 7416 //
     /* 156755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156765 */     // MIs[0] Rn
     /* 156765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156777 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 156780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156790 */     GIR_RootConstrainSelectedInstOperands,
     /* 156791 */     // GIR_Coverage, 7416,
     /* 156791 */     GIR_EraseRootFromParent_Done,
     /* 156792 */   // Label 2840: @156792
     /* 156792 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156834), // Rule ID 7417 //
     /* 156797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156807 */     // MIs[0] Rn
     /* 156807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156819 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 156822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156832 */     GIR_RootConstrainSelectedInstOperands,
     /* 156833 */     // GIR_Coverage, 7417,
     /* 156833 */     GIR_EraseRootFromParent_Done,
     /* 156834 */   // Label 2841: @156834
     /* 156834 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156876), // Rule ID 7418 //
     /* 156839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156849 */     // MIs[0] Rn
     /* 156849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156861 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156874 */     GIR_RootConstrainSelectedInstOperands,
     /* 156875 */     // GIR_Coverage, 7418,
     /* 156875 */     GIR_EraseRootFromParent_Done,
     /* 156876 */   // Label 2842: @156876
     /* 156876 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(156918), // Rule ID 7419 //
     /* 156881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156891 */     // MIs[0] Rn
     /* 156891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156903 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156916 */     GIR_RootConstrainSelectedInstOperands,
     /* 156917 */     // GIR_Coverage, 7419,
     /* 156917 */     GIR_EraseRootFromParent_Done,
     /* 156918 */   // Label 2843: @156918
     /* 156918 */   GIM_Reject,
     /* 156919 */ // Label 2838: @156919
     /* 156919 */ GIM_Reject,
     /* 156920 */ // Label 2825: @156920
     /* 156920 */ GIM_Reject,
     /* 156921 */ // Label 33: @156921
     /* 156921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2847*/ GIMT_Encode4(157625),
     /* 156932 */ /*GILLT_s16*//*Label 2844*/ GIMT_Encode4(156944),
     /* 156936 */ /*GILLT_s32*//*Label 2845*/ GIMT_Encode4(157171),
     /* 156940 */ /*GILLT_s64*//*Label 2846*/ GIMT_Encode4(157398),
     /* 156944 */ // Label 2844: @156944
     /* 156944 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(157170),
     /* 156949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156959 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(157001), // Rule ID 7420 //
     /* 156964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156974 */     // MIs[0] Rn
     /* 156974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156986 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 156989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156999 */     GIR_RootConstrainSelectedInstOperands,
     /* 157000 */     // GIR_Coverage, 7420,
     /* 157000 */     GIR_EraseRootFromParent_Done,
     /* 157001 */   // Label 2849: @157001
     /* 157001 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(157043), // Rule ID 7421 //
     /* 157006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157016 */     // MIs[0] Rn
     /* 157016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157028 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 157031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157041 */     GIR_RootConstrainSelectedInstOperands,
     /* 157042 */     // GIR_Coverage, 7421,
     /* 157042 */     GIR_EraseRootFromParent_Done,
     /* 157043 */   // Label 2850: @157043
     /* 157043 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(157085), // Rule ID 7422 //
     /* 157048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157058 */     // MIs[0] Rn
     /* 157058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157070 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 157073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157083 */     GIR_RootConstrainSelectedInstOperands,
     /* 157084 */     // GIR_Coverage, 7422,
     /* 157084 */     GIR_EraseRootFromParent_Done,
     /* 157085 */   // Label 2851: @157085
     /* 157085 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(157127), // Rule ID 7423 //
     /* 157090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157093 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157100 */     // MIs[0] Rn
     /* 157100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157112 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157125 */     GIR_RootConstrainSelectedInstOperands,
     /* 157126 */     // GIR_Coverage, 7423,
     /* 157126 */     GIR_EraseRootFromParent_Done,
     /* 157127 */   // Label 2852: @157127
     /* 157127 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157169), // Rule ID 7424 //
     /* 157132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157142 */     // MIs[0] Rn
     /* 157142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157154 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157167 */     GIR_RootConstrainSelectedInstOperands,
     /* 157168 */     // GIR_Coverage, 7424,
     /* 157168 */     GIR_EraseRootFromParent_Done,
     /* 157169 */   // Label 2853: @157169
     /* 157169 */   GIM_Reject,
     /* 157170 */ // Label 2848: @157170
     /* 157170 */ GIM_Reject,
     /* 157171 */ // Label 2845: @157171
     /* 157171 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157397),
     /* 157176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157186 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157228), // Rule ID 7425 //
     /* 157191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157201 */     // MIs[0] Rn
     /* 157201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157213 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 157216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157226 */     GIR_RootConstrainSelectedInstOperands,
     /* 157227 */     // GIR_Coverage, 7425,
     /* 157227 */     GIR_EraseRootFromParent_Done,
     /* 157228 */   // Label 2855: @157228
     /* 157228 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157270), // Rule ID 7426 //
     /* 157233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157243 */     // MIs[0] Rn
     /* 157243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157255 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 157258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157268 */     GIR_RootConstrainSelectedInstOperands,
     /* 157269 */     // GIR_Coverage, 7426,
     /* 157269 */     GIR_EraseRootFromParent_Done,
     /* 157270 */   // Label 2856: @157270
     /* 157270 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157312), // Rule ID 7427 //
     /* 157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157285 */     // MIs[0] Rn
     /* 157285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157297 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 157300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157310 */     GIR_RootConstrainSelectedInstOperands,
     /* 157311 */     // GIR_Coverage, 7427,
     /* 157311 */     GIR_EraseRootFromParent_Done,
     /* 157312 */   // Label 2857: @157312
     /* 157312 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157354), // Rule ID 7428 //
     /* 157317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157327 */     // MIs[0] Rn
     /* 157327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157339 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157352 */     GIR_RootConstrainSelectedInstOperands,
     /* 157353 */     // GIR_Coverage, 7428,
     /* 157353 */     GIR_EraseRootFromParent_Done,
     /* 157354 */   // Label 2858: @157354
     /* 157354 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157396), // Rule ID 7429 //
     /* 157359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157369 */     // MIs[0] Rn
     /* 157369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157381 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157394 */     GIR_RootConstrainSelectedInstOperands,
     /* 157395 */     // GIR_Coverage, 7429,
     /* 157395 */     GIR_EraseRootFromParent_Done,
     /* 157396 */   // Label 2859: @157396
     /* 157396 */   GIM_Reject,
     /* 157397 */ // Label 2854: @157397
     /* 157397 */ GIM_Reject,
     /* 157398 */ // Label 2846: @157398
     /* 157398 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157624),
     /* 157403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157413 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157455), // Rule ID 7430 //
     /* 157418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157428 */     // MIs[0] Rn
     /* 157428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157440 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 157443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157453 */     GIR_RootConstrainSelectedInstOperands,
     /* 157454 */     // GIR_Coverage, 7430,
     /* 157454 */     GIR_EraseRootFromParent_Done,
     /* 157455 */   // Label 2861: @157455
     /* 157455 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(157497), // Rule ID 7431 //
     /* 157460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157470 */     // MIs[0] Rn
     /* 157470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157482 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 157485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157495 */     GIR_RootConstrainSelectedInstOperands,
     /* 157496 */     // GIR_Coverage, 7431,
     /* 157496 */     GIR_EraseRootFromParent_Done,
     /* 157497 */   // Label 2862: @157497
     /* 157497 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(157539), // Rule ID 7432 //
     /* 157502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157512 */     // MIs[0] Rn
     /* 157512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157524 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 157527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157537 */     GIR_RootConstrainSelectedInstOperands,
     /* 157538 */     // GIR_Coverage, 7432,
     /* 157538 */     GIR_EraseRootFromParent_Done,
     /* 157539 */   // Label 2863: @157539
     /* 157539 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(157581), // Rule ID 7433 //
     /* 157544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157554 */     // MIs[0] Rn
     /* 157554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157566 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157579 */     GIR_RootConstrainSelectedInstOperands,
     /* 157580 */     // GIR_Coverage, 7433,
     /* 157580 */     GIR_EraseRootFromParent_Done,
     /* 157581 */   // Label 2864: @157581
     /* 157581 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157623), // Rule ID 7434 //
     /* 157586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157596 */     // MIs[0] Rn
     /* 157596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157608 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157621 */     GIR_RootConstrainSelectedInstOperands,
     /* 157622 */     // GIR_Coverage, 7434,
     /* 157622 */     GIR_EraseRootFromParent_Done,
     /* 157623 */   // Label 2865: @157623
     /* 157623 */   GIM_Reject,
     /* 157624 */ // Label 2860: @157624
     /* 157624 */ GIM_Reject,
     /* 157625 */ // Label 2847: @157625
     /* 157625 */ GIM_Reject,
     /* 157626 */ // Label 34: @157626
     /* 157626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(158330),
     /* 157637 */ /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(157649),
     /* 157641 */ /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(157876),
     /* 157645 */ /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(158103),
     /* 157649 */ // Label 2866: @157649
     /* 157649 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157875),
     /* 157654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157664 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157706), // Rule ID 7435 //
     /* 157669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157679 */     // MIs[0] Rn
     /* 157679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157691 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 157694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157704 */     GIR_RootConstrainSelectedInstOperands,
     /* 157705 */     // GIR_Coverage, 7435,
     /* 157705 */     GIR_EraseRootFromParent_Done,
     /* 157706 */   // Label 2871: @157706
     /* 157706 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157748), // Rule ID 7436 //
     /* 157711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157721 */     // MIs[0] Rn
     /* 157721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157733 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 157736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157746 */     GIR_RootConstrainSelectedInstOperands,
     /* 157747 */     // GIR_Coverage, 7436,
     /* 157747 */     GIR_EraseRootFromParent_Done,
     /* 157748 */   // Label 2872: @157748
     /* 157748 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157790), // Rule ID 7437 //
     /* 157753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157756 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157763 */     // MIs[0] Rn
     /* 157763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157775 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 157778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157788 */     GIR_RootConstrainSelectedInstOperands,
     /* 157789 */     // GIR_Coverage, 7437,
     /* 157789 */     GIR_EraseRootFromParent_Done,
     /* 157790 */   // Label 2873: @157790
     /* 157790 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157832), // Rule ID 7438 //
     /* 157795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157805 */     // MIs[0] Rn
     /* 157805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157817 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157830 */     GIR_RootConstrainSelectedInstOperands,
     /* 157831 */     // GIR_Coverage, 7438,
     /* 157831 */     GIR_EraseRootFromParent_Done,
     /* 157832 */   // Label 2874: @157832
     /* 157832 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157874), // Rule ID 7439 //
     /* 157837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157847 */     // MIs[0] Rn
     /* 157847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157859 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157872 */     GIR_RootConstrainSelectedInstOperands,
     /* 157873 */     // GIR_Coverage, 7439,
     /* 157873 */     GIR_EraseRootFromParent_Done,
     /* 157874 */   // Label 2875: @157874
     /* 157874 */   GIM_Reject,
     /* 157875 */ // Label 2870: @157875
     /* 157875 */ GIM_Reject,
     /* 157876 */ // Label 2867: @157876
     /* 157876 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(158102),
     /* 157881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157891 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157933), // Rule ID 7440 //
     /* 157896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157906 */     // MIs[0] Rn
     /* 157906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157918 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 157921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157931 */     GIR_RootConstrainSelectedInstOperands,
     /* 157932 */     // GIR_Coverage, 7440,
     /* 157932 */     GIR_EraseRootFromParent_Done,
     /* 157933 */   // Label 2877: @157933
     /* 157933 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157975), // Rule ID 7441 //
     /* 157938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157948 */     // MIs[0] Rn
     /* 157948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157960 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 157963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157973 */     GIR_RootConstrainSelectedInstOperands,
     /* 157974 */     // GIR_Coverage, 7441,
     /* 157974 */     GIR_EraseRootFromParent_Done,
     /* 157975 */   // Label 2878: @157975
     /* 157975 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(158017), // Rule ID 7442 //
     /* 157980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157990 */     // MIs[0] Rn
     /* 157990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158002 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 158005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158015 */     GIR_RootConstrainSelectedInstOperands,
     /* 158016 */     // GIR_Coverage, 7442,
     /* 158016 */     GIR_EraseRootFromParent_Done,
     /* 158017 */   // Label 2879: @158017
     /* 158017 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(158059), // Rule ID 7443 //
     /* 158022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158032 */     // MIs[0] Rn
     /* 158032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158044 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158057 */     GIR_RootConstrainSelectedInstOperands,
     /* 158058 */     // GIR_Coverage, 7443,
     /* 158058 */     GIR_EraseRootFromParent_Done,
     /* 158059 */   // Label 2880: @158059
     /* 158059 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(158101), // Rule ID 7444 //
     /* 158064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158074 */     // MIs[0] Rn
     /* 158074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158086 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 158089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158099 */     GIR_RootConstrainSelectedInstOperands,
     /* 158100 */     // GIR_Coverage, 7444,
     /* 158100 */     GIR_EraseRootFromParent_Done,
     /* 158101 */   // Label 2881: @158101
     /* 158101 */   GIM_Reject,
     /* 158102 */ // Label 2876: @158102
     /* 158102 */ GIM_Reject,
     /* 158103 */ // Label 2868: @158103
     /* 158103 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(158329),
     /* 158108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158160), // Rule ID 7445 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158133 */     // MIs[0] Rn
     /* 158133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158145 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 158148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158158 */     GIR_RootConstrainSelectedInstOperands,
     /* 158159 */     // GIR_Coverage, 7445,
     /* 158159 */     GIR_EraseRootFromParent_Done,
     /* 158160 */   // Label 2883: @158160
     /* 158160 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(158202), // Rule ID 7446 //
     /* 158165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158175 */     // MIs[0] Rn
     /* 158175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158187 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 158190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158200 */     GIR_RootConstrainSelectedInstOperands,
     /* 158201 */     // GIR_Coverage, 7446,
     /* 158201 */     GIR_EraseRootFromParent_Done,
     /* 158202 */   // Label 2884: @158202
     /* 158202 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(158244), // Rule ID 7447 //
     /* 158207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158217 */     // MIs[0] Rn
     /* 158217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158229 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 158232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158242 */     GIR_RootConstrainSelectedInstOperands,
     /* 158243 */     // GIR_Coverage, 7447,
     /* 158243 */     GIR_EraseRootFromParent_Done,
     /* 158244 */   // Label 2885: @158244
     /* 158244 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(158286), // Rule ID 7448 //
     /* 158249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158259 */     // MIs[0] Rn
     /* 158259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158271 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158284 */     GIR_RootConstrainSelectedInstOperands,
     /* 158285 */     // GIR_Coverage, 7448,
     /* 158285 */     GIR_EraseRootFromParent_Done,
     /* 158286 */   // Label 2886: @158286
     /* 158286 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(158328), // Rule ID 7449 //
     /* 158291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158301 */     // MIs[0] Rn
     /* 158301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158313 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158326 */     GIR_RootConstrainSelectedInstOperands,
     /* 158327 */     // GIR_Coverage, 7449,
     /* 158327 */     GIR_EraseRootFromParent_Done,
     /* 158328 */   // Label 2887: @158328
     /* 158328 */   GIM_Reject,
     /* 158329 */ // Label 2882: @158329
     /* 158329 */ GIM_Reject,
     /* 158330 */ // Label 2869: @158330
     /* 158330 */ GIM_Reject,
     /* 158331 */ // Label 35: @158331
     /* 158331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2891*/ GIMT_Encode4(159035),
     /* 158342 */ /*GILLT_s16*//*Label 2888*/ GIMT_Encode4(158354),
     /* 158346 */ /*GILLT_s32*//*Label 2889*/ GIMT_Encode4(158581),
     /* 158350 */ /*GILLT_s64*//*Label 2890*/ GIMT_Encode4(158808),
     /* 158354 */ // Label 2888: @158354
     /* 158354 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(158580),
     /* 158359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158369 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(158411), // Rule ID 7450 //
     /* 158374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158384 */     // MIs[0] Rn
     /* 158384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158396 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 158399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158409 */     GIR_RootConstrainSelectedInstOperands,
     /* 158410 */     // GIR_Coverage, 7450,
     /* 158410 */     GIR_EraseRootFromParent_Done,
     /* 158411 */   // Label 2893: @158411
     /* 158411 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158453), // Rule ID 7451 //
     /* 158416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158426 */     // MIs[0] Rn
     /* 158426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158438 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 158441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158451 */     GIR_RootConstrainSelectedInstOperands,
     /* 158452 */     // GIR_Coverage, 7451,
     /* 158452 */     GIR_EraseRootFromParent_Done,
     /* 158453 */   // Label 2894: @158453
     /* 158453 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158495), // Rule ID 7452 //
     /* 158458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158468 */     // MIs[0] Rn
     /* 158468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158480 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 158483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158493 */     GIR_RootConstrainSelectedInstOperands,
     /* 158494 */     // GIR_Coverage, 7452,
     /* 158494 */     GIR_EraseRootFromParent_Done,
     /* 158495 */   // Label 2895: @158495
     /* 158495 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158537), // Rule ID 7453 //
     /* 158500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158510 */     // MIs[0] Rn
     /* 158510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158522 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158535 */     GIR_RootConstrainSelectedInstOperands,
     /* 158536 */     // GIR_Coverage, 7453,
     /* 158536 */     GIR_EraseRootFromParent_Done,
     /* 158537 */   // Label 2896: @158537
     /* 158537 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(158579), // Rule ID 7454 //
     /* 158542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158545 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158552 */     // MIs[0] Rn
     /* 158552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158564 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158577 */     GIR_RootConstrainSelectedInstOperands,
     /* 158578 */     // GIR_Coverage, 7454,
     /* 158578 */     GIR_EraseRootFromParent_Done,
     /* 158579 */   // Label 2897: @158579
     /* 158579 */   GIM_Reject,
     /* 158580 */ // Label 2892: @158580
     /* 158580 */ GIM_Reject,
     /* 158581 */ // Label 2889: @158581
     /* 158581 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(158807),
     /* 158586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158596 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(158638), // Rule ID 7455 //
     /* 158601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158611 */     // MIs[0] Rn
     /* 158611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158623 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 158626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158636 */     GIR_RootConstrainSelectedInstOperands,
     /* 158637 */     // GIR_Coverage, 7455,
     /* 158637 */     GIR_EraseRootFromParent_Done,
     /* 158638 */   // Label 2899: @158638
     /* 158638 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(158680), // Rule ID 7456 //
     /* 158643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158653 */     // MIs[0] Rn
     /* 158653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158665 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158678 */     GIR_RootConstrainSelectedInstOperands,
     /* 158679 */     // GIR_Coverage, 7456,
     /* 158679 */     GIR_EraseRootFromParent_Done,
     /* 158680 */   // Label 2900: @158680
     /* 158680 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158722), // Rule ID 7457 //
     /* 158685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158695 */     // MIs[0] Rn
     /* 158695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158707 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 158710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158720 */     GIR_RootConstrainSelectedInstOperands,
     /* 158721 */     // GIR_Coverage, 7457,
     /* 158721 */     GIR_EraseRootFromParent_Done,
     /* 158722 */   // Label 2901: @158722
     /* 158722 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158764), // Rule ID 7458 //
     /* 158727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158737 */     // MIs[0] Rn
     /* 158737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158749 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158762 */     GIR_RootConstrainSelectedInstOperands,
     /* 158763 */     // GIR_Coverage, 7458,
     /* 158763 */     GIR_EraseRootFromParent_Done,
     /* 158764 */   // Label 2902: @158764
     /* 158764 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158806), // Rule ID 7459 //
     /* 158769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158779 */     // MIs[0] Rn
     /* 158779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158791 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158804 */     GIR_RootConstrainSelectedInstOperands,
     /* 158805 */     // GIR_Coverage, 7459,
     /* 158805 */     GIR_EraseRootFromParent_Done,
     /* 158806 */   // Label 2903: @158806
     /* 158806 */   GIM_Reject,
     /* 158807 */ // Label 2898: @158807
     /* 158807 */ GIM_Reject,
     /* 158808 */ // Label 2890: @158808
     /* 158808 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(159034),
     /* 158813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158823 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158865), // Rule ID 7460 //
     /* 158828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158838 */     // MIs[0] Rn
     /* 158838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158850 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 158853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158863 */     GIR_RootConstrainSelectedInstOperands,
     /* 158864 */     // GIR_Coverage, 7460,
     /* 158864 */     GIR_EraseRootFromParent_Done,
     /* 158865 */   // Label 2905: @158865
     /* 158865 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158907), // Rule ID 7461 //
     /* 158870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158873 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158880 */     // MIs[0] Rn
     /* 158880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158892 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 158895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158905 */     GIR_RootConstrainSelectedInstOperands,
     /* 158906 */     // GIR_Coverage, 7461,
     /* 158906 */     GIR_EraseRootFromParent_Done,
     /* 158907 */   // Label 2906: @158907
     /* 158907 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158949), // Rule ID 7462 //
     /* 158912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158922 */     // MIs[0] Rn
     /* 158922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158934 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 158937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158947 */     GIR_RootConstrainSelectedInstOperands,
     /* 158948 */     // GIR_Coverage, 7462,
     /* 158948 */     GIR_EraseRootFromParent_Done,
     /* 158949 */   // Label 2907: @158949
     /* 158949 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158991), // Rule ID 7463 //
     /* 158954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158964 */     // MIs[0] Rn
     /* 158964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158976 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 158979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158989 */     GIR_RootConstrainSelectedInstOperands,
     /* 158990 */     // GIR_Coverage, 7463,
     /* 158990 */     GIR_EraseRootFromParent_Done,
     /* 158991 */   // Label 2908: @158991
     /* 158991 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159033), // Rule ID 7464 //
     /* 158996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159006 */     // MIs[0] Rn
     /* 159006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159018 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 159021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159031 */     GIR_RootConstrainSelectedInstOperands,
     /* 159032 */     // GIR_Coverage, 7464,
     /* 159032 */     GIR_EraseRootFromParent_Done,
     /* 159033 */   // Label 2909: @159033
     /* 159033 */   GIM_Reject,
     /* 159034 */ // Label 2904: @159034
     /* 159034 */ GIM_Reject,
     /* 159035 */ // Label 2891: @159035
     /* 159035 */ GIM_Reject,
     /* 159036 */ // Label 36: @159036
     /* 159036 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159063), // Rule ID 7050 //
     /* 159041 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159044 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 159048 */   // MIs[0] Operand 1
     /* 159048 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159051 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 159051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 159057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159061 */   GIR_RootConstrainSelectedInstOperands,
     /* 159062 */   // GIR_Coverage, 7050,
     /* 159062 */   GIR_EraseRootFromParent_Done,
     /* 159063 */ // Label 2910: @159063
     /* 159063 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(159086), // Rule ID 7051 //
     /* 159068 */   // MIs[0] Operand 0
     /* 159068 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 159071 */   // MIs[0] Operand 1
     /* 159071 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 159074 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 159074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 159077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 159080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159084 */   GIR_RootConstrainSelectedInstOperands,
     /* 159085 */   // GIR_Coverage, 7051,
     /* 159085 */   GIR_EraseRootFromParent_Done,
     /* 159086 */ // Label 2911: @159086
     /* 159086 */ GIM_Reject,
     /* 159087 */ // Label 37: @159087
     /* 159087 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(171614),
     /* 159092 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 159095 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(159186), // Rule ID 6529 //
     /* 159100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 159108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159129 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 159134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159154 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 159161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 159179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 6529,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2913: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(159277), // Rule ID 6530 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 159199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159217 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159220 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 159225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159245 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 159252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 159270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159275 */     GIR_RootConstrainSelectedInstOperands,
     /* 159276 */     // GIR_Coverage, 6530,
     /* 159276 */     GIR_EraseRootFromParent_Done,
     /* 159277 */   // Label 2914: @159277
     /* 159277 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(159338), // Rule ID 4931 //
     /* 159282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 159287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159314 */     // MIs[1] Operand 2
     /* 159314 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 159325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 159327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 159330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 159336 */     GIR_RootConstrainSelectedInstOperands,
     /* 159337 */     // GIR_Coverage, 4931,
     /* 159337 */     GIR_EraseRootFromParent_Done,
     /* 159338 */   // Label 2915: @159338
     /* 159338 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(159378), // Rule ID 2644 //
     /* 159343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 159351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159358 */     // MIs[0] pattern
     /* 159358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159366 */     // (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 159369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159371 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159376 */     GIR_RootConstrainSelectedInstOperands,
     /* 159377 */     // GIR_Coverage, 2644,
     /* 159377 */     GIR_EraseRootFromParent_Done,
     /* 159378 */   // Label 2916: @159378
     /* 159378 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(159418), // Rule ID 9971 //
     /* 159383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 159391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159398 */     // MIs[0] pattern
     /* 159398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159406 */     // (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159411 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159416 */     GIR_RootConstrainSelectedInstOperands,
     /* 159417 */     // GIR_Coverage, 9971,
     /* 159417 */     GIR_EraseRootFromParent_Done,
     /* 159418 */   // Label 2917: @159418
     /* 159418 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(159458), // Rule ID 9974 //
     /* 159423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 159431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159438 */     // MIs[0] pattern
     /* 159438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159446 */     // (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 159449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159451 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159456 */     GIR_RootConstrainSelectedInstOperands,
     /* 159457 */     // GIR_Coverage, 9974,
     /* 159457 */     GIR_EraseRootFromParent_Done,
     /* 159458 */   // Label 2918: @159458
     /* 159458 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(159498), // Rule ID 9977 //
     /* 159463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 159471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159478 */     // MIs[0] pattern
     /* 159478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159486 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159491 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159496 */     GIR_RootConstrainSelectedInstOperands,
     /* 159497 */     // GIR_Coverage, 9977,
     /* 159497 */     GIR_EraseRootFromParent_Done,
     /* 159498 */   // Label 2919: @159498
     /* 159498 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(159537), // Rule ID 66 //
     /* 159503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 159506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 159511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159525 */     // (intrinsic_wo_chain:{ *:[i32] } 553:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 159528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 159535 */     GIR_RootConstrainSelectedInstOperands,
     /* 159536 */     // GIR_Coverage, 66,
     /* 159536 */     GIR_EraseRootFromParent_Done,
     /* 159537 */   // Label 2920: @159537
     /* 159537 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(159573), // Rule ID 346 //
     /* 159542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159564 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 159567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159571 */     GIR_RootConstrainSelectedInstOperands,
     /* 159572 */     // GIR_Coverage, 346,
     /* 159572 */     GIR_EraseRootFromParent_Done,
     /* 159573 */   // Label 2921: @159573
     /* 159573 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(159609), // Rule ID 347 //
     /* 159578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159600 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 159603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159607 */     GIR_RootConstrainSelectedInstOperands,
     /* 159608 */     // GIR_Coverage, 347,
     /* 159608 */     GIR_EraseRootFromParent_Done,
     /* 159609 */   // Label 2922: @159609
     /* 159609 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(159645), // Rule ID 348 //
     /* 159614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159636 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 159639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159643 */     GIR_RootConstrainSelectedInstOperands,
     /* 159644 */     // GIR_Coverage, 348,
     /* 159644 */     GIR_EraseRootFromParent_Done,
     /* 159645 */   // Label 2923: @159645
     /* 159645 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(159681), // Rule ID 349 //
     /* 159650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159672 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 159675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159679 */     GIR_RootConstrainSelectedInstOperands,
     /* 159680 */     // GIR_Coverage, 349,
     /* 159680 */     GIR_EraseRootFromParent_Done,
     /* 159681 */   // Label 2924: @159681
     /* 159681 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(159717), // Rule ID 350 //
     /* 159686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159708 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 159711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159715 */     GIR_RootConstrainSelectedInstOperands,
     /* 159716 */     // GIR_Coverage, 350,
     /* 159716 */     GIR_EraseRootFromParent_Done,
     /* 159717 */   // Label 2925: @159717
     /* 159717 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(159753), // Rule ID 351 //
     /* 159722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159744 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 159747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159751 */     GIR_RootConstrainSelectedInstOperands,
     /* 159752 */     // GIR_Coverage, 351,
     /* 159752 */     GIR_EraseRootFromParent_Done,
     /* 159753 */   // Label 2926: @159753
     /* 159753 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(159789), // Rule ID 352 //
     /* 159758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159780 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159787 */     GIR_RootConstrainSelectedInstOperands,
     /* 159788 */     // GIR_Coverage, 352,
     /* 159788 */     GIR_EraseRootFromParent_Done,
     /* 159789 */   // Label 2927: @159789
     /* 159789 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(159825), // Rule ID 353 //
     /* 159794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159816 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 159819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159823 */     GIR_RootConstrainSelectedInstOperands,
     /* 159824 */     // GIR_Coverage, 353,
     /* 159824 */     GIR_EraseRootFromParent_Done,
     /* 159825 */   // Label 2928: @159825
     /* 159825 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(159861), // Rule ID 354 //
     /* 159830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159852 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 159855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159859 */     GIR_RootConstrainSelectedInstOperands,
     /* 159860 */     // GIR_Coverage, 354,
     /* 159860 */     GIR_EraseRootFromParent_Done,
     /* 159861 */   // Label 2929: @159861
     /* 159861 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(159897), // Rule ID 355 //
     /* 159866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159888 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 159891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159895 */     GIR_RootConstrainSelectedInstOperands,
     /* 159896 */     // GIR_Coverage, 355,
     /* 159896 */     GIR_EraseRootFromParent_Done,
     /* 159897 */   // Label 2930: @159897
     /* 159897 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(159933), // Rule ID 356 //
     /* 159902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159924 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 159927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 356,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2931: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(159969), // Rule ID 357 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159960 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159967 */     GIR_RootConstrainSelectedInstOperands,
     /* 159968 */     // GIR_Coverage, 357,
     /* 159968 */     GIR_EraseRootFromParent_Done,
     /* 159969 */   // Label 2932: @159969
     /* 159969 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160005), // Rule ID 358 //
     /* 159974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159996 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 159999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 160004 */     // GIR_Coverage, 358,
     /* 160004 */     GIR_EraseRootFromParent_Done,
     /* 160005 */   // Label 2933: @160005
     /* 160005 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160041), // Rule ID 359 //
     /* 160010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 160035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160039 */     GIR_RootConstrainSelectedInstOperands,
     /* 160040 */     // GIR_Coverage, 359,
     /* 160040 */     GIR_EraseRootFromParent_Done,
     /* 160041 */   // Label 2934: @160041
     /* 160041 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(160077), // Rule ID 360 //
     /* 160046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160068 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 160071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160075 */     GIR_RootConstrainSelectedInstOperands,
     /* 160076 */     // GIR_Coverage, 360,
     /* 160076 */     GIR_EraseRootFromParent_Done,
     /* 160077 */   // Label 2935: @160077
     /* 160077 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(160113), // Rule ID 361 //
     /* 160082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160104 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 160107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160111 */     GIR_RootConstrainSelectedInstOperands,
     /* 160112 */     // GIR_Coverage, 361,
     /* 160112 */     GIR_EraseRootFromParent_Done,
     /* 160113 */   // Label 2936: @160113
     /* 160113 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(160149), // Rule ID 362 //
     /* 160118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160140 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 160143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160147 */     GIR_RootConstrainSelectedInstOperands,
     /* 160148 */     // GIR_Coverage, 362,
     /* 160148 */     GIR_EraseRootFromParent_Done,
     /* 160149 */   // Label 2937: @160149
     /* 160149 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(160185), // Rule ID 363 //
     /* 160154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160176 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 160179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160183 */     GIR_RootConstrainSelectedInstOperands,
     /* 160184 */     // GIR_Coverage, 363,
     /* 160184 */     GIR_EraseRootFromParent_Done,
     /* 160185 */   // Label 2938: @160185
     /* 160185 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(160221), // Rule ID 364 //
     /* 160190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160212 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 160215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160219 */     GIR_RootConstrainSelectedInstOperands,
     /* 160220 */     // GIR_Coverage, 364,
     /* 160220 */     GIR_EraseRootFromParent_Done,
     /* 160221 */   // Label 2939: @160221
     /* 160221 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(160257), // Rule ID 365 //
     /* 160226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160248 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 160251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160255 */     GIR_RootConstrainSelectedInstOperands,
     /* 160256 */     // GIR_Coverage, 365,
     /* 160256 */     GIR_EraseRootFromParent_Done,
     /* 160257 */   // Label 2940: @160257
     /* 160257 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(160293), // Rule ID 366 //
     /* 160262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160284 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 160287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160291 */     GIR_RootConstrainSelectedInstOperands,
     /* 160292 */     // GIR_Coverage, 366,
     /* 160292 */     GIR_EraseRootFromParent_Done,
     /* 160293 */   // Label 2941: @160293
     /* 160293 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(160329), // Rule ID 367 //
     /* 160298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160320 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 160323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160327 */     GIR_RootConstrainSelectedInstOperands,
     /* 160328 */     // GIR_Coverage, 367,
     /* 160328 */     GIR_EraseRootFromParent_Done,
     /* 160329 */   // Label 2942: @160329
     /* 160329 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(160365), // Rule ID 368 //
     /* 160334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160356 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 160359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160363 */     GIR_RootConstrainSelectedInstOperands,
     /* 160364 */     // GIR_Coverage, 368,
     /* 160364 */     GIR_EraseRootFromParent_Done,
     /* 160365 */   // Label 2943: @160365
     /* 160365 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(160401), // Rule ID 369 //
     /* 160370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160392 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 160395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160399 */     GIR_RootConstrainSelectedInstOperands,
     /* 160400 */     // GIR_Coverage, 369,
     /* 160400 */     GIR_EraseRootFromParent_Done,
     /* 160401 */   // Label 2944: @160401
     /* 160401 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(160437), // Rule ID 370 //
     /* 160406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160428 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 160431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160435 */     GIR_RootConstrainSelectedInstOperands,
     /* 160436 */     // GIR_Coverage, 370,
     /* 160436 */     GIR_EraseRootFromParent_Done,
     /* 160437 */   // Label 2945: @160437
     /* 160437 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(160473), // Rule ID 371 //
     /* 160442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160464 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 160467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160471 */     GIR_RootConstrainSelectedInstOperands,
     /* 160472 */     // GIR_Coverage, 371,
     /* 160472 */     GIR_EraseRootFromParent_Done,
     /* 160473 */   // Label 2946: @160473
     /* 160473 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(160509), // Rule ID 372 //
     /* 160478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160500 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160507 */     GIR_RootConstrainSelectedInstOperands,
     /* 160508 */     // GIR_Coverage, 372,
     /* 160508 */     GIR_EraseRootFromParent_Done,
     /* 160509 */   // Label 2947: @160509
     /* 160509 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(160545), // Rule ID 373 //
     /* 160514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160536 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 160539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160543 */     GIR_RootConstrainSelectedInstOperands,
     /* 160544 */     // GIR_Coverage, 373,
     /* 160544 */     GIR_EraseRootFromParent_Done,
     /* 160545 */   // Label 2948: @160545
     /* 160545 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(160581), // Rule ID 374 //
     /* 160550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160572 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 160575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160579 */     GIR_RootConstrainSelectedInstOperands,
     /* 160580 */     // GIR_Coverage, 374,
     /* 160580 */     GIR_EraseRootFromParent_Done,
     /* 160581 */   // Label 2949: @160581
     /* 160581 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(160617), // Rule ID 375 //
     /* 160586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160608 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 160611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160615 */     GIR_RootConstrainSelectedInstOperands,
     /* 160616 */     // GIR_Coverage, 375,
     /* 160616 */     GIR_EraseRootFromParent_Done,
     /* 160617 */   // Label 2950: @160617
     /* 160617 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(160653), // Rule ID 376 //
     /* 160622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160644 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 160647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160651 */     GIR_RootConstrainSelectedInstOperands,
     /* 160652 */     // GIR_Coverage, 376,
     /* 160652 */     GIR_EraseRootFromParent_Done,
     /* 160653 */   // Label 2951: @160653
     /* 160653 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(160689), // Rule ID 377 //
     /* 160658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160680 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 160683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160687 */     GIR_RootConstrainSelectedInstOperands,
     /* 160688 */     // GIR_Coverage, 377,
     /* 160688 */     GIR_EraseRootFromParent_Done,
     /* 160689 */   // Label 2952: @160689
     /* 160689 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(160725), // Rule ID 378 //
     /* 160694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160716 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 160719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 160724 */     // GIR_Coverage, 378,
     /* 160724 */     GIR_EraseRootFromParent_Done,
     /* 160725 */   // Label 2953: @160725
     /* 160725 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(160761), // Rule ID 379 //
     /* 160730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160752 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 160755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160759 */     GIR_RootConstrainSelectedInstOperands,
     /* 160760 */     // GIR_Coverage, 379,
     /* 160760 */     GIR_EraseRootFromParent_Done,
     /* 160761 */   // Label 2954: @160761
     /* 160761 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(160797), // Rule ID 380 //
     /* 160766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160788 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 160791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160795 */     GIR_RootConstrainSelectedInstOperands,
     /* 160796 */     // GIR_Coverage, 380,
     /* 160796 */     GIR_EraseRootFromParent_Done,
     /* 160797 */   // Label 2955: @160797
     /* 160797 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(160833), // Rule ID 381 //
     /* 160802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160824 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 160827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160831 */     GIR_RootConstrainSelectedInstOperands,
     /* 160832 */     // GIR_Coverage, 381,
     /* 160832 */     GIR_EraseRootFromParent_Done,
     /* 160833 */   // Label 2956: @160833
     /* 160833 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(160869), // Rule ID 382 //
     /* 160838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160860 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 160863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160867 */     GIR_RootConstrainSelectedInstOperands,
     /* 160868 */     // GIR_Coverage, 382,
     /* 160868 */     GIR_EraseRootFromParent_Done,
     /* 160869 */   // Label 2957: @160869
     /* 160869 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(160905), // Rule ID 383 //
     /* 160874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160896 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 160899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160903 */     GIR_RootConstrainSelectedInstOperands,
     /* 160904 */     // GIR_Coverage, 383,
     /* 160904 */     GIR_EraseRootFromParent_Done,
     /* 160905 */   // Label 2958: @160905
     /* 160905 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(160941), // Rule ID 384 //
     /* 160910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160932 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 160935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160939 */     GIR_RootConstrainSelectedInstOperands,
     /* 160940 */     // GIR_Coverage, 384,
     /* 160940 */     GIR_EraseRootFromParent_Done,
     /* 160941 */   // Label 2959: @160941
     /* 160941 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(160977), // Rule ID 385 //
     /* 160946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160968 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160975 */     GIR_RootConstrainSelectedInstOperands,
     /* 160976 */     // GIR_Coverage, 385,
     /* 160976 */     GIR_EraseRootFromParent_Done,
     /* 160977 */   // Label 2960: @160977
     /* 160977 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161013), // Rule ID 386 //
     /* 160982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161004 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 161007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161011 */     GIR_RootConstrainSelectedInstOperands,
     /* 161012 */     // GIR_Coverage, 386,
     /* 161012 */     GIR_EraseRootFromParent_Done,
     /* 161013 */   // Label 2961: @161013
     /* 161013 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161049), // Rule ID 387 //
     /* 161018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 161026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161040 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161047 */     GIR_RootConstrainSelectedInstOperands,
     /* 161048 */     // GIR_Coverage, 387,
     /* 161048 */     GIR_EraseRootFromParent_Done,
     /* 161049 */   // Label 2962: @161049
     /* 161049 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(161085), // Rule ID 388 //
     /* 161054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161076 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 161079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161083 */     GIR_RootConstrainSelectedInstOperands,
     /* 161084 */     // GIR_Coverage, 388,
     /* 161084 */     GIR_EraseRootFromParent_Done,
     /* 161085 */   // Label 2963: @161085
     /* 161085 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(161121), // Rule ID 389 //
     /* 161090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161112 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 161115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161119 */     GIR_RootConstrainSelectedInstOperands,
     /* 161120 */     // GIR_Coverage, 389,
     /* 161120 */     GIR_EraseRootFromParent_Done,
     /* 161121 */   // Label 2964: @161121
     /* 161121 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(161157), // Rule ID 390 //
     /* 161126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161148 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 161151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161155 */     GIR_RootConstrainSelectedInstOperands,
     /* 161156 */     // GIR_Coverage, 390,
     /* 161156 */     GIR_EraseRootFromParent_Done,
     /* 161157 */   // Label 2965: @161157
     /* 161157 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(161193), // Rule ID 391 //
     /* 161162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161184 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 161187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161191 */     GIR_RootConstrainSelectedInstOperands,
     /* 161192 */     // GIR_Coverage, 391,
     /* 161192 */     GIR_EraseRootFromParent_Done,
     /* 161193 */   // Label 2966: @161193
     /* 161193 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(161229), // Rule ID 392 //
     /* 161198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161220 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 161223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 161228 */     // GIR_Coverage, 392,
     /* 161228 */     GIR_EraseRootFromParent_Done,
     /* 161229 */   // Label 2967: @161229
     /* 161229 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(161265), // Rule ID 393 //
     /* 161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161256 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 161259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161263 */     GIR_RootConstrainSelectedInstOperands,
     /* 161264 */     // GIR_Coverage, 393,
     /* 161264 */     GIR_EraseRootFromParent_Done,
     /* 161265 */   // Label 2968: @161265
     /* 161265 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(161301), // Rule ID 575 //
     /* 161270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161292 */     // (intrinsic_wo_chain:{ *:[f32] } 555:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 161295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161299 */     GIR_RootConstrainSelectedInstOperands,
     /* 161300 */     // GIR_Coverage, 575,
     /* 161300 */     GIR_EraseRootFromParent_Done,
     /* 161301 */   // Label 2969: @161301
     /* 161301 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(161337), // Rule ID 576 //
     /* 161306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161328 */     // (intrinsic_wo_chain:{ *:[f64] } 555:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 161331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161335 */     GIR_RootConstrainSelectedInstOperands,
     /* 161336 */     // GIR_Coverage, 576,
     /* 161336 */     GIR_EraseRootFromParent_Done,
     /* 161337 */   // Label 2970: @161337
     /* 161337 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(161373), // Rule ID 577 //
     /* 161342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161364 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 161367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161371 */     GIR_RootConstrainSelectedInstOperands,
     /* 161372 */     // GIR_Coverage, 577,
     /* 161372 */     GIR_EraseRootFromParent_Done,
     /* 161373 */   // Label 2971: @161373
     /* 161373 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(161409), // Rule ID 578 //
     /* 161378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161400 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 161403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161407 */     GIR_RootConstrainSelectedInstOperands,
     /* 161408 */     // GIR_Coverage, 578,
     /* 161408 */     GIR_EraseRootFromParent_Done,
     /* 161409 */   // Label 2972: @161409
     /* 161409 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(161445), // Rule ID 579 //
     /* 161414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161436 */     // (intrinsic_wo_chain:{ *:[f32] } 554:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 161439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161443 */     GIR_RootConstrainSelectedInstOperands,
     /* 161444 */     // GIR_Coverage, 579,
     /* 161444 */     GIR_EraseRootFromParent_Done,
     /* 161445 */   // Label 2973: @161445
     /* 161445 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(161481), // Rule ID 580 //
     /* 161450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161472 */     // (intrinsic_wo_chain:{ *:[f64] } 554:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 161475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161479 */     GIR_RootConstrainSelectedInstOperands,
     /* 161480 */     // GIR_Coverage, 580,
     /* 161480 */     GIR_EraseRootFromParent_Done,
     /* 161481 */   // Label 2974: @161481
     /* 161481 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(161517), // Rule ID 581 //
     /* 161486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161508 */     // (intrinsic_wo_chain:{ *:[f32] } 556:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 161511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161515 */     GIR_RootConstrainSelectedInstOperands,
     /* 161516 */     // GIR_Coverage, 581,
     /* 161516 */     GIR_EraseRootFromParent_Done,
     /* 161517 */   // Label 2975: @161517
     /* 161517 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(161553), // Rule ID 582 //
     /* 161522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161544 */     // (intrinsic_wo_chain:{ *:[f64] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 161547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161551 */     GIR_RootConstrainSelectedInstOperands,
     /* 161552 */     // GIR_Coverage, 582,
     /* 161552 */     GIR_EraseRootFromParent_Done,
     /* 161553 */   // Label 2976: @161553
     /* 161553 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(161589), // Rule ID 710 //
     /* 161558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161580 */     // (intrinsic_wo_chain:{ *:[v8i8] } 582:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 161580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 161583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161587 */     GIR_RootConstrainSelectedInstOperands,
     /* 161588 */     // GIR_Coverage, 710,
     /* 161588 */     GIR_EraseRootFromParent_Done,
     /* 161589 */   // Label 2977: @161589
     /* 161589 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(161625), // Rule ID 711 //
     /* 161594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161616 */     // (intrinsic_wo_chain:{ *:[v16i8] } 582:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 161616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 161619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161623 */     GIR_RootConstrainSelectedInstOperands,
     /* 161624 */     // GIR_Coverage, 711,
     /* 161624 */     GIR_EraseRootFromParent_Done,
     /* 161625 */   // Label 2978: @161625
     /* 161625 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(161661), // Rule ID 712 //
     /* 161630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 582:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 161652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 161655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161659 */     GIR_RootConstrainSelectedInstOperands,
     /* 161660 */     // GIR_Coverage, 712,
     /* 161660 */     GIR_EraseRootFromParent_Done,
     /* 161661 */   // Label 2979: @161661
     /* 161661 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(161697), // Rule ID 713 //
     /* 161666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 582:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 161688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 161691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161695 */     GIR_RootConstrainSelectedInstOperands,
     /* 161696 */     // GIR_Coverage, 713,
     /* 161696 */     GIR_EraseRootFromParent_Done,
     /* 161697 */   // Label 2980: @161697
     /* 161697 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(161733), // Rule ID 714 //
     /* 161702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161724 */     // (intrinsic_wo_chain:{ *:[v2i32] } 582:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 161724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 161727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161731 */     GIR_RootConstrainSelectedInstOperands,
     /* 161732 */     // GIR_Coverage, 714,
     /* 161732 */     GIR_EraseRootFromParent_Done,
     /* 161733 */   // Label 2981: @161733
     /* 161733 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(161769), // Rule ID 715 //
     /* 161738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161760 */     // (intrinsic_wo_chain:{ *:[v4i32] } 582:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 161760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 161763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161767 */     GIR_RootConstrainSelectedInstOperands,
     /* 161768 */     // GIR_Coverage, 715,
     /* 161768 */     GIR_EraseRootFromParent_Done,
     /* 161769 */   // Label 2982: @161769
     /* 161769 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161805), // Rule ID 796 //
     /* 161774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 161799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161803 */     GIR_RootConstrainSelectedInstOperands,
     /* 161804 */     // GIR_Coverage, 796,
     /* 161804 */     GIR_EraseRootFromParent_Done,
     /* 161805 */   // Label 2983: @161805
     /* 161805 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161841), // Rule ID 797 //
     /* 161810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161839 */     GIR_RootConstrainSelectedInstOperands,
     /* 161840 */     // GIR_Coverage, 797,
     /* 161840 */     GIR_EraseRootFromParent_Done,
     /* 161841 */   // Label 2984: @161841
     /* 161841 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161877), // Rule ID 798 //
     /* 161846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 161868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 161871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161875 */     GIR_RootConstrainSelectedInstOperands,
     /* 161876 */     // GIR_Coverage, 798,
     /* 161876 */     GIR_EraseRootFromParent_Done,
     /* 161877 */   // Label 2985: @161877
     /* 161877 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161913), // Rule ID 799 //
     /* 161882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 161904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 161907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161911 */     GIR_RootConstrainSelectedInstOperands,
     /* 161912 */     // GIR_Coverage, 799,
     /* 161912 */     GIR_EraseRootFromParent_Done,
     /* 161913 */   // Label 2986: @161913
     /* 161913 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161949), // Rule ID 800 //
     /* 161918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 161940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 161943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161947 */     GIR_RootConstrainSelectedInstOperands,
     /* 161948 */     // GIR_Coverage, 800,
     /* 161948 */     GIR_EraseRootFromParent_Done,
     /* 161949 */   // Label 2987: @161949
     /* 161949 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161985), // Rule ID 801 //
     /* 161954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 161979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161983 */     GIR_RootConstrainSelectedInstOperands,
     /* 161984 */     // GIR_Coverage, 801,
     /* 161984 */     GIR_EraseRootFromParent_Done,
     /* 161985 */   // Label 2988: @161985
     /* 161985 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162021), // Rule ID 802 //
     /* 161990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 162015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162019 */     GIR_RootConstrainSelectedInstOperands,
     /* 162020 */     // GIR_Coverage, 802,
     /* 162020 */     GIR_EraseRootFromParent_Done,
     /* 162021 */   // Label 2989: @162021
     /* 162021 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162057), // Rule ID 803 //
     /* 162026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162048 */     // (intrinsic_wo_chain:{ *:[v2i32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 162051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162055 */     GIR_RootConstrainSelectedInstOperands,
     /* 162056 */     // GIR_Coverage, 803,
     /* 162056 */     GIR_EraseRootFromParent_Done,
     /* 162057 */   // Label 2990: @162057
     /* 162057 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(162093), // Rule ID 804 //
     /* 162062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 162087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162091 */     GIR_RootConstrainSelectedInstOperands,
     /* 162092 */     // GIR_Coverage, 804,
     /* 162092 */     GIR_EraseRootFromParent_Done,
     /* 162093 */   // Label 2991: @162093
     /* 162093 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(162129), // Rule ID 805 //
     /* 162098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162120 */     // (intrinsic_wo_chain:{ *:[v2i64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 162123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162127 */     GIR_RootConstrainSelectedInstOperands,
     /* 162128 */     // GIR_Coverage, 805,
     /* 162128 */     GIR_EraseRootFromParent_Done,
     /* 162129 */   // Label 2992: @162129
     /* 162129 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(162165), // Rule ID 806 //
     /* 162134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162156 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 162159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162163 */     GIR_RootConstrainSelectedInstOperands,
     /* 162164 */     // GIR_Coverage, 806,
     /* 162164 */     GIR_EraseRootFromParent_Done,
     /* 162165 */   // Label 2993: @162165
     /* 162165 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(162201), // Rule ID 807 //
     /* 162170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162199 */     GIR_RootConstrainSelectedInstOperands,
     /* 162200 */     // GIR_Coverage, 807,
     /* 162200 */     GIR_EraseRootFromParent_Done,
     /* 162201 */   // Label 2994: @162201
     /* 162201 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(162237), // Rule ID 808 //
     /* 162206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162228 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 162231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162235 */     GIR_RootConstrainSelectedInstOperands,
     /* 162236 */     // GIR_Coverage, 808,
     /* 162236 */     GIR_EraseRootFromParent_Done,
     /* 162237 */   // Label 2995: @162237
     /* 162237 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(162273), // Rule ID 809 //
     /* 162242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 162267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162271 */     GIR_RootConstrainSelectedInstOperands,
     /* 162272 */     // GIR_Coverage, 809,
     /* 162272 */     GIR_EraseRootFromParent_Done,
     /* 162273 */   // Label 2996: @162273
     /* 162273 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(162309), // Rule ID 810 //
     /* 162278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162300 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 162303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162307 */     GIR_RootConstrainSelectedInstOperands,
     /* 162308 */     // GIR_Coverage, 810,
     /* 162308 */     GIR_EraseRootFromParent_Done,
     /* 162309 */   // Label 2997: @162309
     /* 162309 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(162345), // Rule ID 811 //
     /* 162314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 162339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162343 */     GIR_RootConstrainSelectedInstOperands,
     /* 162344 */     // GIR_Coverage, 811,
     /* 162344 */     GIR_EraseRootFromParent_Done,
     /* 162345 */   // Label 2998: @162345
     /* 162345 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(162381), // Rule ID 812 //
     /* 162350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162379 */     GIR_RootConstrainSelectedInstOperands,
     /* 162380 */     // GIR_Coverage, 812,
     /* 162380 */     GIR_EraseRootFromParent_Done,
     /* 162381 */   // Label 2999: @162381
     /* 162381 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(162417), // Rule ID 813 //
     /* 162386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162408 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 162411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162415 */     GIR_RootConstrainSelectedInstOperands,
     /* 162416 */     // GIR_Coverage, 813,
     /* 162416 */     GIR_EraseRootFromParent_Done,
     /* 162417 */   // Label 3000: @162417
     /* 162417 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(162453), // Rule ID 814 //
     /* 162422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 162447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162451 */     GIR_RootConstrainSelectedInstOperands,
     /* 162452 */     // GIR_Coverage, 814,
     /* 162452 */     GIR_EraseRootFromParent_Done,
     /* 162453 */   // Label 3001: @162453
     /* 162453 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162489), // Rule ID 815 //
     /* 162458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162480 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 162483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162487 */     GIR_RootConstrainSelectedInstOperands,
     /* 162488 */     // GIR_Coverage, 815,
     /* 162488 */     GIR_EraseRootFromParent_Done,
     /* 162489 */   // Label 3002: @162489
     /* 162489 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162525), // Rule ID 816 //
     /* 162494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 162519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162523 */     GIR_RootConstrainSelectedInstOperands,
     /* 162524 */     // GIR_Coverage, 816,
     /* 162524 */     GIR_EraseRootFromParent_Done,
     /* 162525 */   // Label 3003: @162525
     /* 162525 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162561), // Rule ID 817 //
     /* 162530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 162555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162559 */     GIR_RootConstrainSelectedInstOperands,
     /* 162560 */     // GIR_Coverage, 817,
     /* 162560 */     GIR_EraseRootFromParent_Done,
     /* 162561 */   // Label 3004: @162561
     /* 162561 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162597), // Rule ID 818 //
     /* 162566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 162591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162595 */     GIR_RootConstrainSelectedInstOperands,
     /* 162596 */     // GIR_Coverage, 818,
     /* 162596 */     GIR_EraseRootFromParent_Done,
     /* 162597 */   // Label 3005: @162597
     /* 162597 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162633), // Rule ID 819 //
     /* 162602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 162627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162631 */     GIR_RootConstrainSelectedInstOperands,
     /* 162632 */     // GIR_Coverage, 819,
     /* 162632 */     GIR_EraseRootFromParent_Done,
     /* 162633 */   // Label 3006: @162633
     /* 162633 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162669), // Rule ID 820 //
     /* 162638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162660 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162667 */     GIR_RootConstrainSelectedInstOperands,
     /* 162668 */     // GIR_Coverage, 820,
     /* 162668 */     GIR_EraseRootFromParent_Done,
     /* 162669 */   // Label 3007: @162669
     /* 162669 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162705), // Rule ID 821 //
     /* 162674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162696 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 162699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162703 */     GIR_RootConstrainSelectedInstOperands,
     /* 162704 */     // GIR_Coverage, 821,
     /* 162704 */     GIR_EraseRootFromParent_Done,
     /* 162705 */   // Label 3008: @162705
     /* 162705 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162741), // Rule ID 822 //
     /* 162710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 162735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162739 */     GIR_RootConstrainSelectedInstOperands,
     /* 162740 */     // GIR_Coverage, 822,
     /* 162740 */     GIR_EraseRootFromParent_Done,
     /* 162741 */   // Label 3009: @162741
     /* 162741 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162777), // Rule ID 823 //
     /* 162746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162768 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 162771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162775 */     GIR_RootConstrainSelectedInstOperands,
     /* 162776 */     // GIR_Coverage, 823,
     /* 162776 */     GIR_EraseRootFromParent_Done,
     /* 162777 */   // Label 3010: @162777
     /* 162777 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162813), // Rule ID 824 //
     /* 162782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 162807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162811 */     GIR_RootConstrainSelectedInstOperands,
     /* 162812 */     // GIR_Coverage, 824,
     /* 162812 */     GIR_EraseRootFromParent_Done,
     /* 162813 */   // Label 3011: @162813
     /* 162813 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162849), // Rule ID 825 //
     /* 162818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162840 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 162843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162847 */     GIR_RootConstrainSelectedInstOperands,
     /* 162848 */     // GIR_Coverage, 825,
     /* 162848 */     GIR_EraseRootFromParent_Done,
     /* 162849 */   // Label 3012: @162849
     /* 162849 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162885), // Rule ID 826 //
     /* 162854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 162879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162883 */     GIR_RootConstrainSelectedInstOperands,
     /* 162884 */     // GIR_Coverage, 826,
     /* 162884 */     GIR_EraseRootFromParent_Done,
     /* 162885 */   // Label 3013: @162885
     /* 162885 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162921), // Rule ID 827 //
     /* 162890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 162915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162919 */     GIR_RootConstrainSelectedInstOperands,
     /* 162920 */     // GIR_Coverage, 827,
     /* 162920 */     GIR_EraseRootFromParent_Done,
     /* 162921 */   // Label 3014: @162921
     /* 162921 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162957), // Rule ID 828 //
     /* 162926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 162951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162955 */     GIR_RootConstrainSelectedInstOperands,
     /* 162956 */     // GIR_Coverage, 828,
     /* 162956 */     GIR_EraseRootFromParent_Done,
     /* 162957 */   // Label 3015: @162957
     /* 162957 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162993), // Rule ID 829 //
     /* 162962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 162987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162991 */     GIR_RootConstrainSelectedInstOperands,
     /* 162992 */     // GIR_Coverage, 829,
     /* 162992 */     GIR_EraseRootFromParent_Done,
     /* 162993 */   // Label 3016: @162993
     /* 162993 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163029), // Rule ID 830 //
     /* 162998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 163006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163020 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 163023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163027 */     GIR_RootConstrainSelectedInstOperands,
     /* 163028 */     // GIR_Coverage, 830,
     /* 163028 */     GIR_EraseRootFromParent_Done,
     /* 163029 */   // Label 3017: @163029
     /* 163029 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(163065), // Rule ID 831 //
     /* 163034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 163059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163063 */     GIR_RootConstrainSelectedInstOperands,
     /* 163064 */     // GIR_Coverage, 831,
     /* 163064 */     GIR_EraseRootFromParent_Done,
     /* 163065 */   // Label 3018: @163065
     /* 163065 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(163101), // Rule ID 832 //
     /* 163070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 163095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163099 */     GIR_RootConstrainSelectedInstOperands,
     /* 163100 */     // GIR_Coverage, 832,
     /* 163100 */     GIR_EraseRootFromParent_Done,
     /* 163101 */   // Label 3019: @163101
     /* 163101 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(163137), // Rule ID 833 //
     /* 163106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 163131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163135 */     GIR_RootConstrainSelectedInstOperands,
     /* 163136 */     // GIR_Coverage, 833,
     /* 163136 */     GIR_EraseRootFromParent_Done,
     /* 163137 */   // Label 3020: @163137
     /* 163137 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(163173), // Rule ID 834 //
     /* 163142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 163167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163171 */     GIR_RootConstrainSelectedInstOperands,
     /* 163172 */     // GIR_Coverage, 834,
     /* 163172 */     GIR_EraseRootFromParent_Done,
     /* 163173 */   // Label 3021: @163173
     /* 163173 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163209), // Rule ID 835 //
     /* 163178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 163203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163207 */     GIR_RootConstrainSelectedInstOperands,
     /* 163208 */     // GIR_Coverage, 835,
     /* 163208 */     GIR_EraseRootFromParent_Done,
     /* 163209 */   // Label 3022: @163209
     /* 163209 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(163245), // Rule ID 836 //
     /* 163214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 163222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 163236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 163239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163243 */     GIR_RootConstrainSelectedInstOperands,
     /* 163244 */     // GIR_Coverage, 836,
     /* 163244 */     GIR_EraseRootFromParent_Done,
     /* 163245 */   // Label 3023: @163245
     /* 163245 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(163281), // Rule ID 863 //
     /* 163250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 163275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163279 */     GIR_RootConstrainSelectedInstOperands,
     /* 163280 */     // GIR_Coverage, 863,
     /* 163280 */     GIR_EraseRootFromParent_Done,
     /* 163281 */   // Label 3024: @163281
     /* 163281 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163317), // Rule ID 864 //
     /* 163286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 163311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163315 */     GIR_RootConstrainSelectedInstOperands,
     /* 163316 */     // GIR_Coverage, 864,
     /* 163316 */     GIR_EraseRootFromParent_Done,
     /* 163317 */   // Label 3025: @163317
     /* 163317 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163353), // Rule ID 865 //
     /* 163322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 163347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163351 */     GIR_RootConstrainSelectedInstOperands,
     /* 163352 */     // GIR_Coverage, 865,
     /* 163352 */     GIR_EraseRootFromParent_Done,
     /* 163353 */   // Label 3026: @163353
     /* 163353 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163389), // Rule ID 866 //
     /* 163358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 163383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163387 */     GIR_RootConstrainSelectedInstOperands,
     /* 163388 */     // GIR_Coverage, 866,
     /* 163388 */     GIR_EraseRootFromParent_Done,
     /* 163389 */   // Label 3027: @163389
     /* 163389 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163425), // Rule ID 867 //
     /* 163394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 163419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163423 */     GIR_RootConstrainSelectedInstOperands,
     /* 163424 */     // GIR_Coverage, 867,
     /* 163424 */     GIR_EraseRootFromParent_Done,
     /* 163425 */   // Label 3028: @163425
     /* 163425 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163461), // Rule ID 938 //
     /* 163430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 163455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163459 */     GIR_RootConstrainSelectedInstOperands,
     /* 163460 */     // GIR_Coverage, 938,
     /* 163460 */     GIR_EraseRootFromParent_Done,
     /* 163461 */   // Label 3029: @163461
     /* 163461 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163497), // Rule ID 939 //
     /* 163466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 163491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163495 */     GIR_RootConstrainSelectedInstOperands,
     /* 163496 */     // GIR_Coverage, 939,
     /* 163496 */     GIR_EraseRootFromParent_Done,
     /* 163497 */   // Label 3030: @163497
     /* 163497 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163533), // Rule ID 940 //
     /* 163502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163524 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 163527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163531 */     GIR_RootConstrainSelectedInstOperands,
     /* 163532 */     // GIR_Coverage, 940,
     /* 163532 */     GIR_EraseRootFromParent_Done,
     /* 163533 */   // Label 3031: @163533
     /* 163533 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163569), // Rule ID 941 //
     /* 163538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163560 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 163563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163567 */     GIR_RootConstrainSelectedInstOperands,
     /* 163568 */     // GIR_Coverage, 941,
     /* 163568 */     GIR_EraseRootFromParent_Done,
     /* 163569 */   // Label 3032: @163569
     /* 163569 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163605), // Rule ID 942 //
     /* 163574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163603 */     GIR_RootConstrainSelectedInstOperands,
     /* 163604 */     // GIR_Coverage, 942,
     /* 163604 */     GIR_EraseRootFromParent_Done,
     /* 163605 */   // Label 3033: @163605
     /* 163605 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163641), // Rule ID 943 //
     /* 163610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 163635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163639 */     GIR_RootConstrainSelectedInstOperands,
     /* 163640 */     // GIR_Coverage, 943,
     /* 163640 */     GIR_EraseRootFromParent_Done,
     /* 163641 */   // Label 3034: @163641
     /* 163641 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163677), // Rule ID 944 //
     /* 163646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163668 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163675 */     GIR_RootConstrainSelectedInstOperands,
     /* 163676 */     // GIR_Coverage, 944,
     /* 163676 */     GIR_EraseRootFromParent_Done,
     /* 163677 */   // Label 3035: @163677
     /* 163677 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163713), // Rule ID 945 //
     /* 163682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163704 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 163707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163711 */     GIR_RootConstrainSelectedInstOperands,
     /* 163712 */     // GIR_Coverage, 945,
     /* 163712 */     GIR_EraseRootFromParent_Done,
     /* 163713 */   // Label 3036: @163713
     /* 163713 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163749), // Rule ID 946 //
     /* 163718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 163748 */     // GIR_Coverage, 946,
     /* 163748 */     GIR_EraseRootFromParent_Done,
     /* 163749 */   // Label 3037: @163749
     /* 163749 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163785), // Rule ID 947 //
     /* 163754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163776 */     // (intrinsic_wo_chain:{ *:[v2f32] } 644:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 163779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163783 */     GIR_RootConstrainSelectedInstOperands,
     /* 163784 */     // GIR_Coverage, 947,
     /* 163784 */     GIR_EraseRootFromParent_Done,
     /* 163785 */   // Label 3038: @163785
     /* 163785 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163821), // Rule ID 948 //
     /* 163790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163812 */     // (intrinsic_wo_chain:{ *:[v4f32] } 644:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 163815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163819 */     GIR_RootConstrainSelectedInstOperands,
     /* 163820 */     // GIR_Coverage, 948,
     /* 163820 */     GIR_EraseRootFromParent_Done,
     /* 163821 */   // Label 3039: @163821
     /* 163821 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163857), // Rule ID 949 //
     /* 163826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     // (intrinsic_wo_chain:{ *:[v2f64] } 644:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 163851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163855 */     GIR_RootConstrainSelectedInstOperands,
     /* 163856 */     // GIR_Coverage, 949,
     /* 163856 */     GIR_EraseRootFromParent_Done,
     /* 163857 */   // Label 3040: @163857
     /* 163857 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163893), // Rule ID 950 //
     /* 163862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     // (intrinsic_wo_chain:{ *:[v4f16] } 646:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 163887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163891 */     GIR_RootConstrainSelectedInstOperands,
     /* 163892 */     // GIR_Coverage, 950,
     /* 163892 */     GIR_EraseRootFromParent_Done,
     /* 163893 */   // Label 3041: @163893
     /* 163893 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163929), // Rule ID 951 //
     /* 163898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     // (intrinsic_wo_chain:{ *:[v8f16] } 646:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 163923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163927 */     GIR_RootConstrainSelectedInstOperands,
     /* 163928 */     // GIR_Coverage, 951,
     /* 163928 */     GIR_EraseRootFromParent_Done,
     /* 163929 */   // Label 3042: @163929
     /* 163929 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163965), // Rule ID 952 //
     /* 163934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163956 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 163959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163963 */     GIR_RootConstrainSelectedInstOperands,
     /* 163964 */     // GIR_Coverage, 952,
     /* 163964 */     GIR_EraseRootFromParent_Done,
     /* 163965 */   // Label 3043: @163965
     /* 163965 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164001), // Rule ID 953 //
     /* 163970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163992 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 163995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163999 */     GIR_RootConstrainSelectedInstOperands,
     /* 164000 */     // GIR_Coverage, 953,
     /* 164000 */     GIR_EraseRootFromParent_Done,
     /* 164001 */   // Label 3044: @164001
     /* 164001 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164037), // Rule ID 954 //
     /* 164006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 164014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 164031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164035 */     GIR_RootConstrainSelectedInstOperands,
     /* 164036 */     // GIR_Coverage, 954,
     /* 164036 */     GIR_EraseRootFromParent_Done,
     /* 164037 */   // Label 3045: @164037
     /* 164037 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(164073), // Rule ID 1001 //
     /* 164042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 164067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164071 */     GIR_RootConstrainSelectedInstOperands,
     /* 164072 */     // GIR_Coverage, 1001,
     /* 164072 */     GIR_EraseRootFromParent_Done,
     /* 164073 */   // Label 3046: @164073
     /* 164073 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164109), // Rule ID 1003 //
     /* 164078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 164103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164107 */     GIR_RootConstrainSelectedInstOperands,
     /* 164108 */     // GIR_Coverage, 1003,
     /* 164108 */     GIR_EraseRootFromParent_Done,
     /* 164109 */   // Label 3047: @164109
     /* 164109 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164145), // Rule ID 1005 //
     /* 164114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164136 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 164139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164143 */     GIR_RootConstrainSelectedInstOperands,
     /* 164144 */     // GIR_Coverage, 1005,
     /* 164144 */     GIR_EraseRootFromParent_Done,
     /* 164145 */   // Label 3048: @164145
     /* 164145 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164181), // Rule ID 1007 //
     /* 164150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164179 */     GIR_RootConstrainSelectedInstOperands,
     /* 164180 */     // GIR_Coverage, 1007,
     /* 164180 */     GIR_EraseRootFromParent_Done,
     /* 164181 */   // Label 3049: @164181
     /* 164181 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164217), // Rule ID 1009 //
     /* 164186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164208 */     // (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 164211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164215 */     GIR_RootConstrainSelectedInstOperands,
     /* 164216 */     // GIR_Coverage, 1009,
     /* 164216 */     GIR_EraseRootFromParent_Done,
     /* 164217 */   // Label 3050: @164217
     /* 164217 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164253), // Rule ID 1011 //
     /* 164222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 164247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164251 */     GIR_RootConstrainSelectedInstOperands,
     /* 164252 */     // GIR_Coverage, 1011,
     /* 164252 */     GIR_EraseRootFromParent_Done,
     /* 164253 */   // Label 3051: @164253
     /* 164253 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164289), // Rule ID 1022 //
     /* 164258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164280 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 164283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164287 */     GIR_RootConstrainSelectedInstOperands,
     /* 164288 */     // GIR_Coverage, 1022,
     /* 164288 */     GIR_EraseRootFromParent_Done,
     /* 164289 */   // Label 3052: @164289
     /* 164289 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164325), // Rule ID 1023 //
     /* 164294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 164319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164323 */     GIR_RootConstrainSelectedInstOperands,
     /* 164324 */     // GIR_Coverage, 1023,
     /* 164324 */     GIR_EraseRootFromParent_Done,
     /* 164325 */   // Label 3053: @164325
     /* 164325 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164361), // Rule ID 1024 //
     /* 164330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 164355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164359 */     GIR_RootConstrainSelectedInstOperands,
     /* 164360 */     // GIR_Coverage, 1024,
     /* 164360 */     GIR_EraseRootFromParent_Done,
     /* 164361 */   // Label 3054: @164361
     /* 164361 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164397), // Rule ID 1025 //
     /* 164366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 164391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164395 */     GIR_RootConstrainSelectedInstOperands,
     /* 164396 */     // GIR_Coverage, 1025,
     /* 164396 */     GIR_EraseRootFromParent_Done,
     /* 164397 */   // Label 3055: @164397
     /* 164397 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164433), // Rule ID 1026 //
     /* 164402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 164427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164431 */     GIR_RootConstrainSelectedInstOperands,
     /* 164432 */     // GIR_Coverage, 1026,
     /* 164432 */     GIR_EraseRootFromParent_Done,
     /* 164433 */   // Label 3056: @164433
     /* 164433 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164469), // Rule ID 1027 //
     /* 164438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 164463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164467 */     GIR_RootConstrainSelectedInstOperands,
     /* 164468 */     // GIR_Coverage, 1027,
     /* 164468 */     GIR_EraseRootFromParent_Done,
     /* 164469 */   // Label 3057: @164469
     /* 164469 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164505), // Rule ID 1028 //
     /* 164474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 164499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164503 */     GIR_RootConstrainSelectedInstOperands,
     /* 164504 */     // GIR_Coverage, 1028,
     /* 164504 */     GIR_EraseRootFromParent_Done,
     /* 164505 */   // Label 3058: @164505
     /* 164505 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164541), // Rule ID 1029 //
     /* 164510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     // (intrinsic_wo_chain:{ *:[v8i8] } 692:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 164535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164539 */     GIR_RootConstrainSelectedInstOperands,
     /* 164540 */     // GIR_Coverage, 1029,
     /* 164540 */     GIR_EraseRootFromParent_Done,
     /* 164541 */   // Label 3059: @164541
     /* 164541 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164577), // Rule ID 1030 //
     /* 164546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 692:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 164571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164575 */     GIR_RootConstrainSelectedInstOperands,
     /* 164576 */     // GIR_Coverage, 1030,
     /* 164576 */     GIR_EraseRootFromParent_Done,
     /* 164577 */   // Label 3060: @164577
     /* 164577 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164613), // Rule ID 1031 //
     /* 164582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 692:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 164607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164611 */     GIR_RootConstrainSelectedInstOperands,
     /* 164612 */     // GIR_Coverage, 1031,
     /* 164612 */     GIR_EraseRootFromParent_Done,
     /* 164613 */   // Label 3061: @164613
     /* 164613 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164649), // Rule ID 1032 //
     /* 164618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 692:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 164643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164647 */     GIR_RootConstrainSelectedInstOperands,
     /* 164648 */     // GIR_Coverage, 1032,
     /* 164648 */     GIR_EraseRootFromParent_Done,
     /* 164649 */   // Label 3062: @164649
     /* 164649 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164685), // Rule ID 1033 //
     /* 164654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164676 */     // (intrinsic_wo_chain:{ *:[v2i32] } 692:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 164679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164683 */     GIR_RootConstrainSelectedInstOperands,
     /* 164684 */     // GIR_Coverage, 1033,
     /* 164684 */     GIR_EraseRootFromParent_Done,
     /* 164685 */   // Label 3063: @164685
     /* 164685 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164721), // Rule ID 1034 //
     /* 164690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164712 */     // (intrinsic_wo_chain:{ *:[v4i32] } 692:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 164715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164719 */     GIR_RootConstrainSelectedInstOperands,
     /* 164720 */     // GIR_Coverage, 1034,
     /* 164720 */     GIR_EraseRootFromParent_Done,
     /* 164721 */   // Label 3064: @164721
     /* 164721 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164757), // Rule ID 1035 //
     /* 164726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164748 */     // (intrinsic_wo_chain:{ *:[v2i64] } 692:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 164751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164755 */     GIR_RootConstrainSelectedInstOperands,
     /* 164756 */     // GIR_Coverage, 1035,
     /* 164756 */     GIR_EraseRootFromParent_Done,
     /* 164757 */   // Label 3065: @164757
     /* 164757 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164793), // Rule ID 1062 //
     /* 164762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164784 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 164787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164791 */     GIR_RootConstrainSelectedInstOperands,
     /* 164792 */     // GIR_Coverage, 1062,
     /* 164792 */     GIR_EraseRootFromParent_Done,
     /* 164793 */   // Label 3066: @164793
     /* 164793 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164829), // Rule ID 1064 //
     /* 164798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 164823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164827 */     GIR_RootConstrainSelectedInstOperands,
     /* 164828 */     // GIR_Coverage, 1064,
     /* 164828 */     GIR_EraseRootFromParent_Done,
     /* 164829 */   // Label 3067: @164829
     /* 164829 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164865), // Rule ID 1066 //
     /* 164834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164856 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 164859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164863 */     GIR_RootConstrainSelectedInstOperands,
     /* 164864 */     // GIR_Coverage, 1066,
     /* 164864 */     GIR_EraseRootFromParent_Done,
     /* 164865 */   // Label 3068: @164865
     /* 164865 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164901), // Rule ID 1068 //
     /* 164870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164899 */     GIR_RootConstrainSelectedInstOperands,
     /* 164900 */     // GIR_Coverage, 1068,
     /* 164900 */     GIR_EraseRootFromParent_Done,
     /* 164901 */   // Label 3069: @164901
     /* 164901 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164937), // Rule ID 1070 //
     /* 164906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     // (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 164931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164935 */     GIR_RootConstrainSelectedInstOperands,
     /* 164936 */     // GIR_Coverage, 1070,
     /* 164936 */     GIR_EraseRootFromParent_Done,
     /* 164937 */   // Label 3070: @164937
     /* 164937 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164973), // Rule ID 1072 //
     /* 164942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     // (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 164967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164971 */     GIR_RootConstrainSelectedInstOperands,
     /* 164972 */     // GIR_Coverage, 1072,
     /* 164972 */     GIR_EraseRootFromParent_Done,
     /* 164973 */   // Label 3071: @164973
     /* 164973 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165009), // Rule ID 1086 //
     /* 164978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 164986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165000 */     // (intrinsic_wo_chain:{ *:[v2i32] } 753:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 165003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165007 */     GIR_RootConstrainSelectedInstOperands,
     /* 165008 */     // GIR_Coverage, 1086,
     /* 165008 */     GIR_EraseRootFromParent_Done,
     /* 165009 */   // Label 3072: @165009
     /* 165009 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165045), // Rule ID 1087 //
     /* 165014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 165022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165036 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 165039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165043 */     GIR_RootConstrainSelectedInstOperands,
     /* 165044 */     // GIR_Coverage, 1087,
     /* 165044 */     GIR_EraseRootFromParent_Done,
     /* 165045 */   // Label 3073: @165045
     /* 165045 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165081), // Rule ID 1088 //
     /* 165050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165072 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 165075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165079 */     GIR_RootConstrainSelectedInstOperands,
     /* 165080 */     // GIR_Coverage, 1088,
     /* 165080 */     GIR_EraseRootFromParent_Done,
     /* 165081 */   // Label 3074: @165081
     /* 165081 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165117), // Rule ID 1089 //
     /* 165086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 165094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 165111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165115 */     GIR_RootConstrainSelectedInstOperands,
     /* 165116 */     // GIR_Coverage, 1089,
     /* 165116 */     GIR_EraseRootFromParent_Done,
     /* 165117 */   // Label 3075: @165117
     /* 165117 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165153), // Rule ID 1653 //
     /* 165122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 165130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     // (intrinsic_wo_chain:{ *:[f32] } 793:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 165147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165151 */     GIR_RootConstrainSelectedInstOperands,
     /* 165152 */     // GIR_Coverage, 1653,
     /* 165152 */     GIR_EraseRootFromParent_Done,
     /* 165153 */   // Label 3076: @165153
     /* 165153 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165189), // Rule ID 1659 //
     /* 165158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165180 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165187 */     GIR_RootConstrainSelectedInstOperands,
     /* 165188 */     // GIR_Coverage, 1659,
     /* 165188 */     GIR_EraseRootFromParent_Done,
     /* 165189 */   // Label 3077: @165189
     /* 165189 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165225), // Rule ID 1660 //
     /* 165194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165216 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 165219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165223 */     GIR_RootConstrainSelectedInstOperands,
     /* 165224 */     // GIR_Coverage, 1660,
     /* 165224 */     GIR_EraseRootFromParent_Done,
     /* 165225 */   // Label 3078: @165225
     /* 165225 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165261), // Rule ID 1661 //
     /* 165230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     // (intrinsic_wo_chain:{ *:[i64] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 165255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165259 */     GIR_RootConstrainSelectedInstOperands,
     /* 165260 */     // GIR_Coverage, 1661,
     /* 165260 */     GIR_EraseRootFromParent_Done,
     /* 165261 */   // Label 3079: @165261
     /* 165261 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165297), // Rule ID 1662 //
     /* 165266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165288 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 165291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165295 */     GIR_RootConstrainSelectedInstOperands,
     /* 165296 */     // GIR_Coverage, 1662,
     /* 165296 */     GIR_EraseRootFromParent_Done,
     /* 165297 */   // Label 3080: @165297
     /* 165297 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165333), // Rule ID 1663 //
     /* 165302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 165310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165324 */     // (intrinsic_wo_chain:{ *:[f32] } 670:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 165327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165331 */     GIR_RootConstrainSelectedInstOperands,
     /* 165332 */     // GIR_Coverage, 1663,
     /* 165332 */     GIR_EraseRootFromParent_Done,
     /* 165333 */   // Label 3081: @165333
     /* 165333 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165369), // Rule ID 1664 //
     /* 165338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 165346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     // (intrinsic_wo_chain:{ *:[f32] } 671:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 165363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165367 */     GIR_RootConstrainSelectedInstOperands,
     /* 165368 */     // GIR_Coverage, 1664,
     /* 165368 */     GIR_EraseRootFromParent_Done,
     /* 165369 */   // Label 3082: @165369
     /* 165369 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165405), // Rule ID 1670 //
     /* 165374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 165382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165396 */     // (intrinsic_wo_chain:{ *:[f32] } 672:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165403 */     GIR_RootConstrainSelectedInstOperands,
     /* 165404 */     // GIR_Coverage, 1670,
     /* 165404 */     GIR_EraseRootFromParent_Done,
     /* 165405 */   // Label 3083: @165405
     /* 165405 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165441), // Rule ID 1943 //
     /* 165410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 165435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165439 */     GIR_RootConstrainSelectedInstOperands,
     /* 165440 */     // GIR_Coverage, 1943,
     /* 165440 */     GIR_EraseRootFromParent_Done,
     /* 165441 */   // Label 3084: @165441
     /* 165441 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165477), // Rule ID 1945 //
     /* 165446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 165471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165475 */     GIR_RootConstrainSelectedInstOperands,
     /* 165476 */     // GIR_Coverage, 1945,
     /* 165476 */     GIR_EraseRootFromParent_Done,
     /* 165477 */   // Label 3085: @165477
     /* 165477 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165513), // Rule ID 1947 //
     /* 165482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 165507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165511 */     GIR_RootConstrainSelectedInstOperands,
     /* 165512 */     // GIR_Coverage, 1947,
     /* 165512 */     GIR_EraseRootFromParent_Done,
     /* 165513 */   // Label 3086: @165513
     /* 165513 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165549), // Rule ID 1949 //
     /* 165518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 165543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165547 */     GIR_RootConstrainSelectedInstOperands,
     /* 165548 */     // GIR_Coverage, 1949,
     /* 165548 */     GIR_EraseRootFromParent_Done,
     /* 165549 */   // Label 3087: @165549
     /* 165549 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165585), // Rule ID 1951 //
     /* 165554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 165579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165583 */     GIR_RootConstrainSelectedInstOperands,
     /* 165584 */     // GIR_Coverage, 1951,
     /* 165584 */     GIR_EraseRootFromParent_Done,
     /* 165585 */   // Label 3088: @165585
     /* 165585 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165621), // Rule ID 1953 //
     /* 165590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165612 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 165615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165619 */     GIR_RootConstrainSelectedInstOperands,
     /* 165620 */     // GIR_Coverage, 1953,
     /* 165620 */     GIR_EraseRootFromParent_Done,
     /* 165621 */   // Label 3089: @165621
     /* 165621 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165657), // Rule ID 1955 //
     /* 165626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165648 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165655 */     GIR_RootConstrainSelectedInstOperands,
     /* 165656 */     // GIR_Coverage, 1955,
     /* 165656 */     GIR_EraseRootFromParent_Done,
     /* 165657 */   // Label 3090: @165657
     /* 165657 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165693), // Rule ID 1957 //
     /* 165662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165684 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 165687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165691 */     GIR_RootConstrainSelectedInstOperands,
     /* 165692 */     // GIR_Coverage, 1957,
     /* 165692 */     GIR_EraseRootFromParent_Done,
     /* 165693 */   // Label 3091: @165693
     /* 165693 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165729), // Rule ID 1959 //
     /* 165698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 165723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165727 */     GIR_RootConstrainSelectedInstOperands,
     /* 165728 */     // GIR_Coverage, 1959,
     /* 165728 */     GIR_EraseRootFromParent_Done,
     /* 165729 */   // Label 3092: @165729
     /* 165729 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165765), // Rule ID 1961 //
     /* 165734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 165759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165763 */     GIR_RootConstrainSelectedInstOperands,
     /* 165764 */     // GIR_Coverage, 1961,
     /* 165764 */     GIR_EraseRootFromParent_Done,
     /* 165765 */   // Label 3093: @165765
     /* 165765 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165801), // Rule ID 1963 //
     /* 165770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 165795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165799 */     GIR_RootConstrainSelectedInstOperands,
     /* 165800 */     // GIR_Coverage, 1963,
     /* 165800 */     GIR_EraseRootFromParent_Done,
     /* 165801 */   // Label 3094: @165801
     /* 165801 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165837), // Rule ID 1965 //
     /* 165806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165828 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 165831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165835 */     GIR_RootConstrainSelectedInstOperands,
     /* 165836 */     // GIR_Coverage, 1965,
     /* 165836 */     GIR_EraseRootFromParent_Done,
     /* 165837 */   // Label 3095: @165837
     /* 165837 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165873), // Rule ID 2305 //
     /* 165842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 165850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 165867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165871 */     GIR_RootConstrainSelectedInstOperands,
     /* 165872 */     // GIR_Coverage, 2305,
     /* 165872 */     GIR_EraseRootFromParent_Done,
     /* 165873 */   // Label 3096: @165873
     /* 165873 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165909), // Rule ID 2306 //
     /* 165878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 165886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165900 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 165903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165907 */     GIR_RootConstrainSelectedInstOperands,
     /* 165908 */     // GIR_Coverage, 2306,
     /* 165908 */     GIR_EraseRootFromParent_Done,
     /* 165909 */   // Label 3097: @165909
     /* 165909 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165945), // Rule ID 2314 //
     /* 165914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 165917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 165922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165936 */     // (intrinsic_wo_chain:{ *:[i32] } 528:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 165939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165943 */     GIR_RootConstrainSelectedInstOperands,
     /* 165944 */     // GIR_Coverage, 2314,
     /* 165944 */     GIR_EraseRootFromParent_Done,
     /* 165945 */   // Label 3098: @165945
     /* 165945 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165981), // Rule ID 2508 //
     /* 165950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165972 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165979 */     GIR_RootConstrainSelectedInstOperands,
     /* 165980 */     // GIR_Coverage, 2508,
     /* 165980 */     GIR_EraseRootFromParent_Done,
     /* 165981 */   // Label 3099: @165981
     /* 165981 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166020), // Rule ID 3541 //
     /* 165986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 165997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 166008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 166011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166018 */     GIR_RootConstrainSelectedInstOperands,
     /* 166019 */     // GIR_Coverage, 3541,
     /* 166019 */     GIR_EraseRootFromParent_Done,
     /* 166020 */   // Label 3100: @166020
     /* 166020 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166059), // Rule ID 3542 //
     /* 166025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 166036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 166047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 166050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166057 */     GIR_RootConstrainSelectedInstOperands,
     /* 166058 */     // GIR_Coverage, 3542,
     /* 166058 */     GIR_EraseRootFromParent_Done,
     /* 166059 */   // Label 3101: @166059
     /* 166059 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166098), // Rule ID 3543 //
     /* 166064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 166075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 166086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166096 */     GIR_RootConstrainSelectedInstOperands,
     /* 166097 */     // GIR_Coverage, 3543,
     /* 166097 */     GIR_EraseRootFromParent_Done,
     /* 166098 */   // Label 3102: @166098
     /* 166098 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166137), // Rule ID 3544 //
     /* 166103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 166114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 166125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 166128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166135 */     GIR_RootConstrainSelectedInstOperands,
     /* 166136 */     // GIR_Coverage, 3544,
     /* 166136 */     GIR_EraseRootFromParent_Done,
     /* 166137 */   // Label 3103: @166137
     /* 166137 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166193), // Rule ID 3548 //
     /* 166142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 166156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1636:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 166164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 166181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166191 */     GIR_RootConstrainSelectedInstOperands,
     /* 166192 */     // GIR_Coverage, 3548,
     /* 166192 */     GIR_EraseRootFromParent_Done,
     /* 166193 */   // Label 3104: @166193
     /* 166193 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166249), // Rule ID 3549 //
     /* 166198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 166212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1636:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 166220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 166237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166247 */     GIR_RootConstrainSelectedInstOperands,
     /* 166248 */     // GIR_Coverage, 3549,
     /* 166248 */     GIR_EraseRootFromParent_Done,
     /* 166249 */   // Label 3105: @166249
     /* 166249 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166305), // Rule ID 3550 //
     /* 166254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 166268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1636:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 166276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 166293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166303 */     GIR_RootConstrainSelectedInstOperands,
     /* 166304 */     // GIR_Coverage, 3550,
     /* 166304 */     GIR_EraseRootFromParent_Done,
     /* 166305 */   // Label 3106: @166305
     /* 166305 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166361), // Rule ID 3551 //
     /* 166310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 166324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1636:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 166332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 166349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166359 */     GIR_RootConstrainSelectedInstOperands,
     /* 166360 */     // GIR_Coverage, 3551,
     /* 166360 */     GIR_EraseRootFromParent_Done,
     /* 166361 */   // Label 3107: @166361
     /* 166361 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166394), // Rule ID 4006 //
     /* 166366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 166371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166385 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 166385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 166388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166392 */     GIR_RootConstrainSelectedInstOperands,
     /* 166393 */     // GIR_Coverage, 4006,
     /* 166393 */     GIR_EraseRootFromParent_Done,
     /* 166394 */   // Label 3108: @166394
     /* 166394 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166459), // Rule ID 4007 //
     /* 166399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 166404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166418 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 166418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 166425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 166434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 166448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166458 */     // GIR_Coverage, 4007,
     /* 166458 */     GIR_EraseRootFromParent_Done,
     /* 166459 */   // Label 3109: @166459
     /* 166459 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166492), // Rule ID 4813 //
     /* 166464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 166469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166483 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 166486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166490 */     GIR_RootConstrainSelectedInstOperands,
     /* 166491 */     // GIR_Coverage, 4813,
     /* 166491 */     GIR_EraseRootFromParent_Done,
     /* 166492 */   // Label 3110: @166492
     /* 166492 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166525), // Rule ID 4814 //
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 4814,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3111: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166558), // Rule ID 4815 //
     /* 166530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 166535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166549 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 166552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166556 */     GIR_RootConstrainSelectedInstOperands,
     /* 166557 */     // GIR_Coverage, 4815,
     /* 166557 */     GIR_EraseRootFromParent_Done,
     /* 166558 */   // Label 3112: @166558
     /* 166558 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166591), // Rule ID 4816 //
     /* 166563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 166568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166582 */     // (intrinsic_wo_chain:{ *:[v1f64] } 644:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 166585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166589 */     GIR_RootConstrainSelectedInstOperands,
     /* 166590 */     // GIR_Coverage, 4816,
     /* 166590 */     GIR_EraseRootFromParent_Done,
     /* 166591 */   // Label 3113: @166591
     /* 166591 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166624), // Rule ID 4930 //
     /* 166596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 166601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166615 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 166615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 166618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166622 */     GIR_RootConstrainSelectedInstOperands,
     /* 166623 */     // GIR_Coverage, 4930,
     /* 166623 */     GIR_EraseRootFromParent_Done,
     /* 166624 */   // Label 3114: @166624
     /* 166624 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166657), // Rule ID 4940 //
     /* 166629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 166634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 166648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 166651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166655 */     GIR_RootConstrainSelectedInstOperands,
     /* 166656 */     // GIR_Coverage, 4940,
     /* 166656 */     GIR_EraseRootFromParent_Done,
     /* 166657 */   // Label 3115: @166657
     /* 166657 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166693), // Rule ID 5261 //
     /* 166662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166684 */     // (intrinsic_wo_chain:{ *:[v1i64] } 692:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 166684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166691 */     GIR_RootConstrainSelectedInstOperands,
     /* 166692 */     // GIR_Coverage, 5261,
     /* 166692 */     GIR_EraseRootFromParent_Done,
     /* 166693 */   // Label 3116: @166693
     /* 166693 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166726), // Rule ID 5264 //
     /* 166698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 166703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166717 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 166720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166724 */     GIR_RootConstrainSelectedInstOperands,
     /* 166725 */     // GIR_Coverage, 5264,
     /* 166725 */     GIR_EraseRootFromParent_Done,
     /* 166726 */   // Label 3117: @166726
     /* 166726 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166759), // Rule ID 5265 //
     /* 166731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 166736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166750 */     // (intrinsic_wo_chain:{ *:[v1i64] } 591:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 166753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166757 */     GIR_RootConstrainSelectedInstOperands,
     /* 166758 */     // GIR_Coverage, 5265,
     /* 166758 */     GIR_EraseRootFromParent_Done,
     /* 166759 */   // Label 3118: @166759
     /* 166759 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166792), // Rule ID 5266 //
     /* 166764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 166769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166783 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 166786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166790 */     GIR_RootConstrainSelectedInstOperands,
     /* 166791 */     // GIR_Coverage, 5266,
     /* 166791 */     GIR_EraseRootFromParent_Done,
     /* 166792 */   // Label 3119: @166792
     /* 166792 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166825), // Rule ID 5267 //
     /* 166797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 166802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166816 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 166819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166823 */     GIR_RootConstrainSelectedInstOperands,
     /* 166824 */     // GIR_Coverage, 5267,
     /* 166824 */     GIR_EraseRootFromParent_Done,
     /* 166825 */   // Label 3120: @166825
     /* 166825 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166858), // Rule ID 5268 //
     /* 166830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 166835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166849 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 166852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166856 */     GIR_RootConstrainSelectedInstOperands,
     /* 166857 */     // GIR_Coverage, 5268,
     /* 166857 */     GIR_EraseRootFromParent_Done,
     /* 166858 */   // Label 3121: @166858
     /* 166858 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166891), // Rule ID 5269 //
     /* 166863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 166868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166882 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 166885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166889 */     GIR_RootConstrainSelectedInstOperands,
     /* 166890 */     // GIR_Coverage, 5269,
     /* 166890 */     GIR_EraseRootFromParent_Done,
     /* 166891 */   // Label 3122: @166891
     /* 166891 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166924), // Rule ID 5270 //
     /* 166896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 166901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166915 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166922 */     GIR_RootConstrainSelectedInstOperands,
     /* 166923 */     // GIR_Coverage, 5270,
     /* 166923 */     GIR_EraseRootFromParent_Done,
     /* 166924 */   // Label 3123: @166924
     /* 166924 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166957), // Rule ID 5271 //
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 5271,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3124: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166990), // Rule ID 5272 //
     /* 166962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 166967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166981 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 166984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166988 */     GIR_RootConstrainSelectedInstOperands,
     /* 166989 */     // GIR_Coverage, 5272,
     /* 166989 */     GIR_EraseRootFromParent_Done,
     /* 166990 */   // Label 3125: @166990
     /* 166990 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167023), // Rule ID 5273 //
     /* 166995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 167000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167014 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 167017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167021 */     GIR_RootConstrainSelectedInstOperands,
     /* 167022 */     // GIR_Coverage, 5273,
     /* 167022 */     GIR_EraseRootFromParent_Done,
     /* 167023 */   // Label 3126: @167023
     /* 167023 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167056), // Rule ID 5274 //
     /* 167028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167047 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 167050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167054 */     GIR_RootConstrainSelectedInstOperands,
     /* 167055 */     // GIR_Coverage, 5274,
     /* 167055 */     GIR_EraseRootFromParent_Done,
     /* 167056 */   // Label 3127: @167056
     /* 167056 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167089), // Rule ID 5275 //
     /* 167061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167080 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 167083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167087 */     GIR_RootConstrainSelectedInstOperands,
     /* 167088 */     // GIR_Coverage, 5275,
     /* 167088 */     GIR_EraseRootFromParent_Done,
     /* 167089 */   // Label 3128: @167089
     /* 167089 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167122), // Rule ID 5276 //
     /* 167094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167113 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167120 */     GIR_RootConstrainSelectedInstOperands,
     /* 167121 */     // GIR_Coverage, 5276,
     /* 167121 */     GIR_EraseRootFromParent_Done,
     /* 167122 */   // Label 3129: @167122
     /* 167122 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167155), // Rule ID 5277 //
     /* 167127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167146 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167153 */     GIR_RootConstrainSelectedInstOperands,
     /* 167154 */     // GIR_Coverage, 5277,
     /* 167154 */     GIR_EraseRootFromParent_Done,
     /* 167155 */   // Label 3130: @167155
     /* 167155 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167188), // Rule ID 5289 //
     /* 167160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167179 */     // (intrinsic_wo_chain:{ *:[f16] } 641:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167186 */     GIR_RootConstrainSelectedInstOperands,
     /* 167187 */     // GIR_Coverage, 5289,
     /* 167187 */     GIR_EraseRootFromParent_Done,
     /* 167188 */   // Label 3131: @167188
     /* 167188 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167221), // Rule ID 5290 //
     /* 167193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167212 */     // (intrinsic_wo_chain:{ *:[f32] } 641:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 167215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167219 */     GIR_RootConstrainSelectedInstOperands,
     /* 167220 */     // GIR_Coverage, 5290,
     /* 167220 */     GIR_EraseRootFromParent_Done,
     /* 167221 */   // Label 3132: @167221
     /* 167221 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167254), // Rule ID 5291 //
     /* 167226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167245 */     // (intrinsic_wo_chain:{ *:[f64] } 641:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 167248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167252 */     GIR_RootConstrainSelectedInstOperands,
     /* 167253 */     // GIR_Coverage, 5291,
     /* 167253 */     GIR_EraseRootFromParent_Done,
     /* 167254 */   // Label 3133: @167254
     /* 167254 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167287), // Rule ID 5292 //
     /* 167259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167278 */     // (intrinsic_wo_chain:{ *:[f16] } 646:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 167281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167285 */     GIR_RootConstrainSelectedInstOperands,
     /* 167286 */     // GIR_Coverage, 5292,
     /* 167286 */     GIR_EraseRootFromParent_Done,
     /* 167287 */   // Label 3134: @167287
     /* 167287 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167320), // Rule ID 5293 //
     /* 167292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167311 */     // (intrinsic_wo_chain:{ *:[f32] } 646:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 167314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167318 */     GIR_RootConstrainSelectedInstOperands,
     /* 167319 */     // GIR_Coverage, 5293,
     /* 167319 */     GIR_EraseRootFromParent_Done,
     /* 167320 */   // Label 3135: @167320
     /* 167320 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167353), // Rule ID 5294 //
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[f64] } 646:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 5294,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3136: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167386), // Rule ID 5295 //
     /* 167358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167377 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167384 */     GIR_RootConstrainSelectedInstOperands,
     /* 167385 */     // GIR_Coverage, 5295,
     /* 167385 */     GIR_EraseRootFromParent_Done,
     /* 167386 */   // Label 3137: @167386
     /* 167386 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167419), // Rule ID 5625 //
     /* 167391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167410 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167417 */     GIR_RootConstrainSelectedInstOperands,
     /* 167418 */     // GIR_Coverage, 5625,
     /* 167418 */     GIR_EraseRootFromParent_Done,
     /* 167419 */   // Label 3138: @167419
     /* 167419 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167504), // Rule ID 5626 //
     /* 167424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167443 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 167443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 167450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167477 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 167484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167502 */     GIR_RootConstrainSelectedInstOperands,
     /* 167503 */     // GIR_Coverage, 5626,
     /* 167503 */     GIR_EraseRootFromParent_Done,
     /* 167504 */   // Label 3139: @167504
     /* 167504 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167537), // Rule ID 5627 //
     /* 167509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167528 */     // (intrinsic_wo_chain:{ *:[f64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 167531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167535 */     GIR_RootConstrainSelectedInstOperands,
     /* 167536 */     // GIR_Coverage, 5627,
     /* 167536 */     GIR_EraseRootFromParent_Done,
     /* 167537 */   // Label 3140: @167537
     /* 167537 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167570), // Rule ID 5629 //
     /* 167542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167561 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 167564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167568 */     GIR_RootConstrainSelectedInstOperands,
     /* 167569 */     // GIR_Coverage, 5629,
     /* 167569 */     GIR_EraseRootFromParent_Done,
     /* 167570 */   // Label 3141: @167570
     /* 167570 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167603), // Rule ID 5631 //
     /* 167575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167594 */     // (intrinsic_wo_chain:{ *:[f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 167597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167601 */     GIR_RootConstrainSelectedInstOperands,
     /* 167602 */     // GIR_Coverage, 5631,
     /* 167602 */     GIR_EraseRootFromParent_Done,
     /* 167603 */   // Label 3142: @167603
     /* 167603 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167636), // Rule ID 5633 //
     /* 167608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167627 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167634 */     GIR_RootConstrainSelectedInstOperands,
     /* 167635 */     // GIR_Coverage, 5633,
     /* 167635 */     GIR_EraseRootFromParent_Done,
     /* 167636 */   // Label 3143: @167636
     /* 167636 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167669), // Rule ID 5635 //
     /* 167641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167660 */     // (intrinsic_wo_chain:{ *:[f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 167663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167667 */     GIR_RootConstrainSelectedInstOperands,
     /* 167668 */     // GIR_Coverage, 5635,
     /* 167668 */     GIR_EraseRootFromParent_Done,
     /* 167669 */   // Label 3144: @167669
     /* 167669 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167702), // Rule ID 5637 //
     /* 167674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167693 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 167696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167700 */     GIR_RootConstrainSelectedInstOperands,
     /* 167701 */     // GIR_Coverage, 5637,
     /* 167701 */     GIR_EraseRootFromParent_Done,
     /* 167702 */   // Label 3145: @167702
     /* 167702 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167735), // Rule ID 5639 //
     /* 167707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167726 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 167729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167733 */     GIR_RootConstrainSelectedInstOperands,
     /* 167734 */     // GIR_Coverage, 5639,
     /* 167734 */     GIR_EraseRootFromParent_Done,
     /* 167735 */   // Label 3146: @167735
     /* 167735 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167768), // Rule ID 5641 //
     /* 167740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167759 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 167762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167766 */     GIR_RootConstrainSelectedInstOperands,
     /* 167767 */     // GIR_Coverage, 5641,
     /* 167767 */     GIR_EraseRootFromParent_Done,
     /* 167768 */   // Label 3147: @167768
     /* 167768 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167801), // Rule ID 5643 //
     /* 167773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167792 */     // (intrinsic_wo_chain:{ *:[f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 167795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167799 */     GIR_RootConstrainSelectedInstOperands,
     /* 167800 */     // GIR_Coverage, 5643,
     /* 167800 */     GIR_EraseRootFromParent_Done,
     /* 167801 */   // Label 3148: @167801
     /* 167801 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167834), // Rule ID 13198 //
     /* 167806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167825 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 167825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 167828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167832 */     GIR_RootConstrainSelectedInstOperands,
     /* 167833 */     // GIR_Coverage, 13198,
     /* 167833 */     GIR_EraseRootFromParent_Done,
     /* 167834 */   // Label 3149: @167834
     /* 167834 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167867), // Rule ID 13200 //
     /* 167839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167858 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 167861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167865 */     GIR_RootConstrainSelectedInstOperands,
     /* 167866 */     // GIR_Coverage, 13200,
     /* 167866 */     GIR_EraseRootFromParent_Done,
     /* 167867 */   // Label 3150: @167867
     /* 167867 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167900), // Rule ID 13202 //
     /* 167872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167891 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167898 */     GIR_RootConstrainSelectedInstOperands,
     /* 167899 */     // GIR_Coverage, 13202,
     /* 167899 */     GIR_EraseRootFromParent_Done,
     /* 167900 */   // Label 3151: @167900
     /* 167900 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167933), // Rule ID 13204 //
     /* 167905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167924 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 167924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 167927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167931 */     GIR_RootConstrainSelectedInstOperands,
     /* 167932 */     // GIR_Coverage, 13204,
     /* 167932 */     GIR_EraseRootFromParent_Done,
     /* 167933 */   // Label 3152: @167933
     /* 167933 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168048), // Rule ID 13205 //
     /* 167938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167957 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 167957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 167960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 167964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167969 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 167975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 167978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 167992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 167996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168047 */     // GIR_Coverage, 13205,
     /* 168047 */     GIR_EraseRootFromParent_Done,
     /* 168048 */   // Label 3153: @168048
     /* 168048 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168081), // Rule ID 13207 //
     /* 168053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168072 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 168075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168079 */     GIR_RootConstrainSelectedInstOperands,
     /* 168080 */     // GIR_Coverage, 13207,
     /* 168080 */     GIR_EraseRootFromParent_Done,
     /* 168081 */   // Label 3154: @168081
     /* 168081 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168114), // Rule ID 13209 //
     /* 168086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168105 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 168108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168112 */     GIR_RootConstrainSelectedInstOperands,
     /* 168113 */     // GIR_Coverage, 13209,
     /* 168113 */     GIR_EraseRootFromParent_Done,
     /* 168114 */   // Label 3155: @168114
     /* 168114 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168147), // Rule ID 13211 //
     /* 168119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168138 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 168141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168145 */     GIR_RootConstrainSelectedInstOperands,
     /* 168146 */     // GIR_Coverage, 13211,
     /* 168146 */     GIR_EraseRootFromParent_Done,
     /* 168147 */   // Label 3156: @168147
     /* 168147 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168180), // Rule ID 13213 //
     /* 168152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168171 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 168174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168178 */     GIR_RootConstrainSelectedInstOperands,
     /* 168179 */     // GIR_Coverage, 13213,
     /* 168179 */     GIR_EraseRootFromParent_Done,
     /* 168180 */   // Label 3157: @168180
     /* 168180 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168295), // Rule ID 13214 //
     /* 168185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168204 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 168211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168216 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168248 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168254 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168294 */     // GIR_Coverage, 13214,
     /* 168294 */     GIR_EraseRootFromParent_Done,
     /* 168295 */   // Label 3158: @168295
     /* 168295 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168414), // Rule ID 13215 //
     /* 168300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168319 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168331 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168335 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168413 */     // GIR_Coverage, 13215,
     /* 168413 */     GIR_EraseRootFromParent_Done,
     /* 168414 */   // Label 3159: @168414
     /* 168414 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168529), // Rule ID 13216 //
     /* 168419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168438 */     // (intrinsic_wo_chain:{ *:[i64] } 669:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168450 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168488 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168528 */     // GIR_Coverage, 13216,
     /* 168528 */     GIR_EraseRootFromParent_Done,
     /* 168529 */   // Label 3160: @168529
     /* 168529 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168648), // Rule ID 13217 //
     /* 168534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168553 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168565 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168569 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168647 */     // GIR_Coverage, 13217,
     /* 168647 */     GIR_EraseRootFromParent_Done,
     /* 168648 */   // Label 3161: @168648
     /* 168648 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168763), // Rule ID 13218 //
     /* 168653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168672 */     // (intrinsic_wo_chain:{ *:[i64] } 734:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168684 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168762 */     // GIR_Coverage, 13218,
     /* 168762 */     GIR_EraseRootFromParent_Done,
     /* 168763 */   // Label 3162: @168763
     /* 168763 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168796), // Rule ID 13220 //
     /* 168768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168787 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 168790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168794 */     GIR_RootConstrainSelectedInstOperands,
     /* 168795 */     // GIR_Coverage, 13220,
     /* 168795 */     GIR_EraseRootFromParent_Done,
     /* 168796 */   // Label 3163: @168796
     /* 168796 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168829), // Rule ID 13222 //
     /* 168801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168820 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 168823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168827 */     GIR_RootConstrainSelectedInstOperands,
     /* 168828 */     // GIR_Coverage, 13222,
     /* 168828 */     GIR_EraseRootFromParent_Done,
     /* 168829 */   // Label 3164: @168829
     /* 168829 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168862), // Rule ID 13224 //
     /* 168834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 168856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168860 */     GIR_RootConstrainSelectedInstOperands,
     /* 168861 */     // GIR_Coverage, 13224,
     /* 168861 */     GIR_EraseRootFromParent_Done,
     /* 168862 */   // Label 3165: @168862
     /* 168862 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168895), // Rule ID 13226 //
     /* 168867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168886 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 168889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168893 */     GIR_RootConstrainSelectedInstOperands,
     /* 168894 */     // GIR_Coverage, 13226,
     /* 168894 */     GIR_EraseRootFromParent_Done,
     /* 168895 */   // Label 3166: @168895
     /* 168895 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169010), // Rule ID 13227 //
     /* 168900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168919 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 168926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168931 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169009 */     // GIR_Coverage, 13227,
     /* 169009 */     GIR_EraseRootFromParent_Done,
     /* 169010 */   // Label 3167: @169010
     /* 169010 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169129), // Rule ID 13228 //
     /* 169015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 169020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169034 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 169041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169046 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169050 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169128 */     // GIR_Coverage, 13228,
     /* 169128 */     GIR_EraseRootFromParent_Done,
     /* 169129 */   // Label 3168: @169129
     /* 169129 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169162), // Rule ID 13230 //
     /* 169134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169153 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 169156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 13230,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3169: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169195), // Rule ID 13232 //
     /* 169167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169186 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169193 */     GIR_RootConstrainSelectedInstOperands,
     /* 169194 */     // GIR_Coverage, 13232,
     /* 169194 */     GIR_EraseRootFromParent_Done,
     /* 169195 */   // Label 3170: @169195
     /* 169195 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169228), // Rule ID 13234 //
     /* 169200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169219 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 169222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169226 */     GIR_RootConstrainSelectedInstOperands,
     /* 169227 */     // GIR_Coverage, 13234,
     /* 169227 */     GIR_EraseRootFromParent_Done,
     /* 169228 */   // Label 3171: @169228
     /* 169228 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169261), // Rule ID 13236 //
     /* 169233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169252 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 169255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169259 */     GIR_RootConstrainSelectedInstOperands,
     /* 169260 */     // GIR_Coverage, 13236,
     /* 169260 */     GIR_EraseRootFromParent_Done,
     /* 169261 */   // Label 3172: @169261
     /* 169261 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169376), // Rule ID 13237 //
     /* 169266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169285 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 169292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169297 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169358 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169375 */     // GIR_Coverage, 13237,
     /* 169375 */     GIR_EraseRootFromParent_Done,
     /* 169376 */   // Label 3173: @169376
     /* 169376 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169495), // Rule ID 13238 //
     /* 169381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169400 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 169407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169412 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169416 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169494 */     // GIR_Coverage, 13238,
     /* 169494 */     GIR_EraseRootFromParent_Done,
     /* 169495 */   // Label 3174: @169495
     /* 169495 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169528), // Rule ID 13240 //
     /* 169500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169519 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 169522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169526 */     GIR_RootConstrainSelectedInstOperands,
     /* 169527 */     // GIR_Coverage, 13240,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3175: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(169561), // Rule ID 13242 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13242,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3176: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(169594), // Rule ID 13244 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13244,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3177: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(169627), // Rule ID 13246 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13246,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3178: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(169742), // Rule ID 13247 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 169658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169663 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169695 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169724 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169741 */     // GIR_Coverage, 13247,
     /* 169741 */     GIR_EraseRootFromParent_Done,
     /* 169742 */   // Label 3179: @169742
     /* 169742 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(169861), // Rule ID 13248 //
     /* 169747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169766 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 169773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169778 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169782 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169860 */     // GIR_Coverage, 13248,
     /* 169860 */     GIR_EraseRootFromParent_Done,
     /* 169861 */   // Label 3180: @169861
     /* 169861 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(169894), // Rule ID 13250 //
     /* 169866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169885 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169892 */     GIR_RootConstrainSelectedInstOperands,
     /* 169893 */     // GIR_Coverage, 13250,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3181: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(169927), // Rule ID 13252 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 169921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169925 */     GIR_RootConstrainSelectedInstOperands,
     /* 169926 */     // GIR_Coverage, 13252,
     /* 169926 */     GIR_EraseRootFromParent_Done,
     /* 169927 */   // Label 3182: @169927
     /* 169927 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(169960), // Rule ID 13254 //
     /* 169932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169951 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 169954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169958 */     GIR_RootConstrainSelectedInstOperands,
     /* 169959 */     // GIR_Coverage, 13254,
     /* 169959 */     GIR_EraseRootFromParent_Done,
     /* 169960 */   // Label 3183: @169960
     /* 169960 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(169993), // Rule ID 13256 //
     /* 169965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169984 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 169987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169991 */     GIR_RootConstrainSelectedInstOperands,
     /* 169992 */     // GIR_Coverage, 13256,
     /* 169992 */     GIR_EraseRootFromParent_Done,
     /* 169993 */   // Label 3184: @169993
     /* 169993 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170108), // Rule ID 13257 //
     /* 169998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170017 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 170024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170029 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170090 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170107 */     // GIR_Coverage, 13257,
     /* 170107 */     GIR_EraseRootFromParent_Done,
     /* 170108 */   // Label 3185: @170108
     /* 170108 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170227), // Rule ID 13258 //
     /* 170113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170132 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 170139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170144 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170148 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170226 */     // GIR_Coverage, 13258,
     /* 170226 */     GIR_EraseRootFromParent_Done,
     /* 170227 */   // Label 3186: @170227
     /* 170227 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170259), // Rule ID 2393 //
     /* 170232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 170240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 170253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170257 */     GIR_RootConstrainSelectedInstOperands,
     /* 170258 */     // GIR_Coverage, 2393,
     /* 170258 */     GIR_EraseRootFromParent_Done,
     /* 170259 */   // Label 3187: @170259
     /* 170259 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170291), // Rule ID 2394 //
     /* 170264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 170272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 170285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170289 */     GIR_RootConstrainSelectedInstOperands,
     /* 170290 */     // GIR_Coverage, 2394,
     /* 170290 */     GIR_EraseRootFromParent_Done,
     /* 170291 */   // Label 3188: @170291
     /* 170291 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170323), // Rule ID 2395 //
     /* 170296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 170304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170314 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1678:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 170317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170321 */     GIR_RootConstrainSelectedInstOperands,
     /* 170322 */     // GIR_Coverage, 2395,
     /* 170322 */     GIR_EraseRootFromParent_Done,
     /* 170323 */   // Label 3189: @170323
     /* 170323 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170355), // Rule ID 3086 //
     /* 170328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 170349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170353 */     GIR_RootConstrainSelectedInstOperands,
     /* 170354 */     // GIR_Coverage, 3086,
     /* 170354 */     GIR_EraseRootFromParent_Done,
     /* 170355 */   // Label 3190: @170355
     /* 170355 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(170387), // Rule ID 3087 //
     /* 170360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170385 */     GIR_RootConstrainSelectedInstOperands,
     /* 170386 */     // GIR_Coverage, 3087,
     /* 170386 */     GIR_EraseRootFromParent_Done,
     /* 170387 */   // Label 3191: @170387
     /* 170387 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(170419), // Rule ID 3088 //
     /* 170392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 170413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170417 */     GIR_RootConstrainSelectedInstOperands,
     /* 170418 */     // GIR_Coverage, 3088,
     /* 170418 */     GIR_EraseRootFromParent_Done,
     /* 170419 */   // Label 3192: @170419
     /* 170419 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(170451), // Rule ID 3342 //
     /* 170424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 170435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170442 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1668:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 170442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170449 */     GIR_RootConstrainSelectedInstOperands,
     /* 170450 */     // GIR_Coverage, 3342,
     /* 170450 */     GIR_EraseRootFromParent_Done,
     /* 170451 */   // Label 3193: @170451
     /* 170451 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(170483), // Rule ID 3343 //
     /* 170456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 170467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 170470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1668:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 170474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170481 */     GIR_RootConstrainSelectedInstOperands,
     /* 170482 */     // GIR_Coverage, 3343,
     /* 170482 */     GIR_EraseRootFromParent_Done,
     /* 170483 */   // Label 3194: @170483
     /* 170483 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(170515), // Rule ID 3344 //
     /* 170488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 170499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 170502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1668:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 170506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170513 */     GIR_RootConstrainSelectedInstOperands,
     /* 170514 */     // GIR_Coverage, 3344,
     /* 170514 */     GIR_EraseRootFromParent_Done,
     /* 170515 */   // Label 3195: @170515
     /* 170515 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(170547), // Rule ID 3423 //
     /* 170520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 170541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170545 */     GIR_RootConstrainSelectedInstOperands,
     /* 170546 */     // GIR_Coverage, 3423,
     /* 170546 */     GIR_EraseRootFromParent_Done,
     /* 170547 */   // Label 3196: @170547
     /* 170547 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(170579), // Rule ID 3424 //
     /* 170552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 170573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170577 */     GIR_RootConstrainSelectedInstOperands,
     /* 170578 */     // GIR_Coverage, 3424,
     /* 170578 */     GIR_EraseRootFromParent_Done,
     /* 170579 */   // Label 3197: @170579
     /* 170579 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(170611), // Rule ID 3425 //
     /* 170584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 170595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 170605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170609 */     GIR_RootConstrainSelectedInstOperands,
     /* 170610 */     // GIR_Coverage, 3425,
     /* 170610 */     GIR_EraseRootFromParent_Done,
     /* 170611 */   // Label 3198: @170611
     /* 170611 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(170643), // Rule ID 3451 //
     /* 170616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 170619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 170624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 170630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 170634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 170637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 170639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170641 */     GIR_RootConstrainSelectedInstOperands,
     /* 170642 */     // GIR_Coverage, 3451,
     /* 170642 */     GIR_EraseRootFromParent_Done,
     /* 170643 */   // Label 3199: @170643
     /* 170643 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(170675), // Rule ID 4658 //
     /* 170648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 4658,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3200: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(170707), // Rule ID 4659 //
     /* 170680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170698 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 170701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170705 */     GIR_RootConstrainSelectedInstOperands,
     /* 170706 */     // GIR_Coverage, 4659,
     /* 170706 */     GIR_EraseRootFromParent_Done,
     /* 170707 */   // Label 3201: @170707
     /* 170707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(170736), // Rule ID 4660 //
     /* 170712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170727 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 170730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170734 */     GIR_RootConstrainSelectedInstOperands,
     /* 170735 */     // GIR_Coverage, 4660,
     /* 170735 */     GIR_EraseRootFromParent_Done,
     /* 170736 */   // Label 3202: @170736
     /* 170736 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(170765), // Rule ID 4661 //
     /* 170741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170756 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 170759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170763 */     GIR_RootConstrainSelectedInstOperands,
     /* 170764 */     // GIR_Coverage, 4661,
     /* 170764 */     GIR_EraseRootFromParent_Done,
     /* 170765 */   // Label 3203: @170765
     /* 170765 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(170794), // Rule ID 4662 //
     /* 170770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170785 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170792 */     GIR_RootConstrainSelectedInstOperands,
     /* 170793 */     // GIR_Coverage, 4662,
     /* 170793 */     GIR_EraseRootFromParent_Done,
     /* 170794 */   // Label 3204: @170794
     /* 170794 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(170823), // Rule ID 4663 //
     /* 170799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170814 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 170817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170821 */     GIR_RootConstrainSelectedInstOperands,
     /* 170822 */     // GIR_Coverage, 4663,
     /* 170822 */     GIR_EraseRootFromParent_Done,
     /* 170823 */   // Label 3205: @170823
     /* 170823 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(170855), // Rule ID 4670 //
     /* 170828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170846 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 170849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170853 */     GIR_RootConstrainSelectedInstOperands,
     /* 170854 */     // GIR_Coverage, 4670,
     /* 170854 */     GIR_EraseRootFromParent_Done,
     /* 170855 */   // Label 3206: @170855
     /* 170855 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(170887), // Rule ID 4671 //
     /* 170860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170878 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 170881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170885 */     GIR_RootConstrainSelectedInstOperands,
     /* 170886 */     // GIR_Coverage, 4671,
     /* 170886 */     GIR_EraseRootFromParent_Done,
     /* 170887 */   // Label 3207: @170887
     /* 170887 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(170916), // Rule ID 4672 //
     /* 170892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170907 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 170910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170914 */     GIR_RootConstrainSelectedInstOperands,
     /* 170915 */     // GIR_Coverage, 4672,
     /* 170915 */     GIR_EraseRootFromParent_Done,
     /* 170916 */   // Label 3208: @170916
     /* 170916 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(170945), // Rule ID 4673 //
     /* 170921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170936 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 170939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170943 */     GIR_RootConstrainSelectedInstOperands,
     /* 170944 */     // GIR_Coverage, 4673,
     /* 170944 */     GIR_EraseRootFromParent_Done,
     /* 170945 */   // Label 3209: @170945
     /* 170945 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(170974), // Rule ID 4674 //
     /* 170950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170965 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170972 */     GIR_RootConstrainSelectedInstOperands,
     /* 170973 */     // GIR_Coverage, 4674,
     /* 170973 */     GIR_EraseRootFromParent_Done,
     /* 170974 */   // Label 3210: @170974
     /* 170974 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(171003), // Rule ID 4675 //
     /* 170979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170994 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 170997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171001 */     GIR_RootConstrainSelectedInstOperands,
     /* 171002 */     // GIR_Coverage, 4675,
     /* 171002 */     GIR_EraseRootFromParent_Done,
     /* 171003 */   // Label 3211: @171003
     /* 171003 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(171032), // Rule ID 4970 //
     /* 171008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171023 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 171026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171030 */     GIR_RootConstrainSelectedInstOperands,
     /* 171031 */     // GIR_Coverage, 4970,
     /* 171031 */     GIR_EraseRootFromParent_Done,
     /* 171032 */   // Label 3212: @171032
     /* 171032 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(171061), // Rule ID 4971 //
     /* 171037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171052 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 171055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171059 */     GIR_RootConstrainSelectedInstOperands,
     /* 171060 */     // GIR_Coverage, 4971,
     /* 171060 */     GIR_EraseRootFromParent_Done,
     /* 171061 */   // Label 3213: @171061
     /* 171061 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(171090), // Rule ID 4972 //
     /* 171066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171081 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 171084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171088 */     GIR_RootConstrainSelectedInstOperands,
     /* 171089 */     // GIR_Coverage, 4972,
     /* 171089 */     GIR_EraseRootFromParent_Done,
     /* 171090 */   // Label 3214: @171090
     /* 171090 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(171119), // Rule ID 4973 //
     /* 171095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 171113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171117 */     GIR_RootConstrainSelectedInstOperands,
     /* 171118 */     // GIR_Coverage, 4973,
     /* 171118 */     GIR_EraseRootFromParent_Done,
     /* 171119 */   // Label 3215: @171119
     /* 171119 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(171148), // Rule ID 4974 //
     /* 171124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 171142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171146 */     GIR_RootConstrainSelectedInstOperands,
     /* 171147 */     // GIR_Coverage, 4974,
     /* 171147 */     GIR_EraseRootFromParent_Done,
     /* 171148 */   // Label 3216: @171148
     /* 171148 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(171177), // Rule ID 4975 //
     /* 171153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 171171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171175 */     GIR_RootConstrainSelectedInstOperands,
     /* 171176 */     // GIR_Coverage, 4975,
     /* 171176 */     GIR_EraseRootFromParent_Done,
     /* 171177 */   // Label 3217: @171177
     /* 171177 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(171206), // Rule ID 4976 //
     /* 171182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171197 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 171200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171204 */     GIR_RootConstrainSelectedInstOperands,
     /* 171205 */     // GIR_Coverage, 4976,
     /* 171205 */     GIR_EraseRootFromParent_Done,
     /* 171206 */   // Label 3218: @171206
     /* 171206 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171235), // Rule ID 4977 //
     /* 171211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171226 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 171229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171233 */     GIR_RootConstrainSelectedInstOperands,
     /* 171234 */     // GIR_Coverage, 4977,
     /* 171234 */     GIR_EraseRootFromParent_Done,
     /* 171235 */   // Label 3219: @171235
     /* 171235 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171264), // Rule ID 4978 //
     /* 171240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171255 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 171258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_RootConstrainSelectedInstOperands,
     /* 171263 */     // GIR_Coverage, 4978,
     /* 171263 */     GIR_EraseRootFromParent_Done,
     /* 171264 */   // Label 3220: @171264
     /* 171264 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171293), // Rule ID 4979 //
     /* 171269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171284 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 171287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171291 */     GIR_RootConstrainSelectedInstOperands,
     /* 171292 */     // GIR_Coverage, 4979,
     /* 171292 */     GIR_EraseRootFromParent_Done,
     /* 171293 */   // Label 3221: @171293
     /* 171293 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171325), // Rule ID 8449 //
     /* 171298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1667:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171323 */     GIR_RootConstrainSelectedInstOperands,
     /* 171324 */     // GIR_Coverage, 8449,
     /* 171324 */     GIR_EraseRootFromParent_Done,
     /* 171325 */   // Label 3222: @171325
     /* 171325 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171357), // Rule ID 8450 //
     /* 171330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1667:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171355 */     GIR_RootConstrainSelectedInstOperands,
     /* 171356 */     // GIR_Coverage, 8450,
     /* 171356 */     GIR_EraseRootFromParent_Done,
     /* 171357 */   // Label 3223: @171357
     /* 171357 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171389), // Rule ID 8451 //
     /* 171362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1667:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171387 */     GIR_RootConstrainSelectedInstOperands,
     /* 171388 */     // GIR_Coverage, 8451,
     /* 171388 */     GIR_EraseRootFromParent_Done,
     /* 171389 */   // Label 3224: @171389
     /* 171389 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171421), // Rule ID 11872 //
     /* 171394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 171415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171419 */     GIR_RootConstrainSelectedInstOperands,
     /* 171420 */     // GIR_Coverage, 11872,
     /* 171420 */     GIR_EraseRootFromParent_Done,
     /* 171421 */   // Label 3225: @171421
     /* 171421 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171453), // Rule ID 11873 //
     /* 171426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 171447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171451 */     GIR_RootConstrainSelectedInstOperands,
     /* 171452 */     // GIR_Coverage, 11873,
     /* 171452 */     GIR_EraseRootFromParent_Done,
     /* 171453 */   // Label 3226: @171453
     /* 171453 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171485), // Rule ID 11874 //
     /* 171458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 171479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171483 */     GIR_RootConstrainSelectedInstOperands,
     /* 171484 */     // GIR_Coverage, 11874,
     /* 171484 */     GIR_EraseRootFromParent_Done,
     /* 171485 */   // Label 3227: @171485
     /* 171485 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171517), // Rule ID 11875 //
     /* 171490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 171511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171515 */     GIR_RootConstrainSelectedInstOperands,
     /* 171516 */     // GIR_Coverage, 11875,
     /* 171516 */     GIR_EraseRootFromParent_Done,
     /* 171517 */   // Label 3228: @171517
     /* 171517 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171549), // Rule ID 11876 //
     /* 171522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171547 */     GIR_RootConstrainSelectedInstOperands,
     /* 171548 */     // GIR_Coverage, 11876,
     /* 171548 */     GIR_EraseRootFromParent_Done,
     /* 171549 */   // Label 3229: @171549
     /* 171549 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171581), // Rule ID 11877 //
     /* 171554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 171575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171579 */     GIR_RootConstrainSelectedInstOperands,
     /* 171580 */     // GIR_Coverage, 11877,
     /* 171580 */     GIR_EraseRootFromParent_Done,
     /* 171581 */   // Label 3230: @171581
     /* 171581 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171613), // Rule ID 12044 //
     /* 171586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 171589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 171594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 171600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 171604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 171607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 171609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171611 */     GIR_RootConstrainSelectedInstOperands,
     /* 171612 */     // GIR_Coverage, 12044,
     /* 171612 */     GIR_EraseRootFromParent_Done,
     /* 171613 */   // Label 3231: @171613
     /* 171613 */   GIM_Reject,
     /* 171614 */ // Label 2912: @171614
     /* 171614 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(214096),
     /* 171619 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 171622 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171806), // Rule ID 2561 //
     /* 171627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171725 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171738 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171742 */     // MIs[5] Operand 1
     /* 171742 */     // No operand predicates
     /* 171742 */     // MIs[3] Operand 2
     /* 171742 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171757 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171759 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 171790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171804 */     GIR_RootConstrainSelectedInstOperands,
     /* 171805 */     // GIR_Coverage, 2561,
     /* 171805 */     GIR_EraseRootFromParent_Done,
     /* 171806 */   // Label 3233: @171806
     /* 171806 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171990), // Rule ID 6297 //
     /* 171811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 171819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171860 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171863 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171872 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171901 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171909 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171922 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171926 */     // MIs[5] Operand 1
     /* 171926 */     // No operand predicates
     /* 171926 */     // MIs[3] Operand 2
     /* 171926 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171941 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171943 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 171974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171988 */     GIR_RootConstrainSelectedInstOperands,
     /* 171989 */     // GIR_Coverage, 6297,
     /* 171989 */     GIR_EraseRootFromParent_Done,
     /* 171990 */   // Label 3234: @171990
     /* 171990 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172151), // Rule ID 2562 //
     /* 171995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 172028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 172036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172044 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 172047 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172056 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 172069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172073 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172077 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172081 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172094 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172098 */     // MIs[4] Operand 1
     /* 172098 */     // No operand predicates
     /* 172098 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 172102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172104 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 172104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 172107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172116 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 172122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 172135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172149 */     GIR_RootConstrainSelectedInstOperands,
     /* 172150 */     // GIR_Coverage, 2562,
     /* 172150 */     GIR_EraseRootFromParent_Done,
     /* 172151 */   // Label 3235: @172151
     /* 172151 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172312), // Rule ID 6298 //
     /* 172156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 172189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 172197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172205 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 172208 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172217 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 172230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172242 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172255 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172259 */     // MIs[4] Operand 1
     /* 172259 */     // No operand predicates
     /* 172259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 172263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172265 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 172265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 172268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172277 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 172283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 172296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172310 */     GIR_RootConstrainSelectedInstOperands,
     /* 172311 */     // GIR_Coverage, 6298,
     /* 172311 */     GIR_EraseRootFromParent_Done,
     /* 172312 */   // Label 3236: @172312
     /* 172312 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172422), // Rule ID 2085 //
     /* 172317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 172366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 172375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172383 */     // MIs[3] Operand 1
     /* 172383 */     // No operand predicates
     /* 172383 */     // MIs[1] Operand 2
     /* 172383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 172394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 172396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172403 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 172406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 172417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 172420 */     GIR_RootConstrainSelectedInstOperands,
     /* 172421 */     // GIR_Coverage, 2085,
     /* 172421 */     GIR_EraseRootFromParent_Done,
     /* 172422 */   // Label 3237: @172422
     /* 172422 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172532), // Rule ID 2088 //
     /* 172427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 172464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 172476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 172485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172493 */     // MIs[3] Operand 1
     /* 172493 */     // No operand predicates
     /* 172493 */     // MIs[1] Operand 2
     /* 172493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 172504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 172506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172513 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 172516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 172527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 172530 */     GIR_RootConstrainSelectedInstOperands,
     /* 172531 */     // GIR_Coverage, 2088,
     /* 172531 */     GIR_EraseRootFromParent_Done,
     /* 172532 */   // Label 3238: @172532
     /* 172532 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172654), // Rule ID 6951 //
     /* 172537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172572 */     // MIs[1] Operand 2
     /* 172572 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172591 */     // MIs[2] Rn
     /* 172591 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172596 */     // MIs[2] Operand 2
     /* 172596 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172609 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 172609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 172616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172636 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172653 */     // GIR_Coverage, 6951,
     /* 172653 */     GIR_EraseRootFromParent_Done,
     /* 172654 */   // Label 3239: @172654
     /* 172654 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172776), // Rule ID 6953 //
     /* 172659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172694 */     // MIs[1] Operand 2
     /* 172694 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172713 */     // MIs[2] Rn
     /* 172713 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172718 */     // MIs[2] Operand 2
     /* 172718 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 172729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172731 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 172731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 172738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172775 */     // GIR_Coverage, 6953,
     /* 172775 */     GIR_EraseRootFromParent_Done,
     /* 172776 */   // Label 3240: @172776
     /* 172776 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172898), // Rule ID 6955 //
     /* 172781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 172786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 172811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172816 */     // MIs[1] Operand 2
     /* 172816 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172835 */     // MIs[2] Rn
     /* 172835 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172840 */     // MIs[2] Operand 2
     /* 172840 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 172851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172853 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 172853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 172860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172880 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 172887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172897 */     // GIR_Coverage, 6955,
     /* 172897 */     GIR_EraseRootFromParent_Done,
     /* 172898 */   // Label 3241: @172898
     /* 172898 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(173020), // Rule ID 6957 //
     /* 172903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 172908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172938 */     // MIs[1] Operand 2
     /* 172938 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 172949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 172953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172957 */     // MIs[2] Rn
     /* 172957 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 172962 */     // MIs[2] Operand 2
     /* 172962 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 172975 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 172975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 172978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 172982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 172995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173002 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 173009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173019 */     // GIR_Coverage, 6957,
     /* 173019 */     GIR_EraseRootFromParent_Done,
     /* 173020 */   // Label 3242: @173020
     /* 173020 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(173142), // Rule ID 6959 //
     /* 173025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 173030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173060 */     // MIs[1] Operand 2
     /* 173060 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173079 */     // MIs[2] Rn
     /* 173079 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 173084 */     // MIs[2] Operand 2
     /* 173084 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 173095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173097 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 173097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 173100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 173104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 173131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173141 */     // GIR_Coverage, 6959,
     /* 173141 */     GIR_EraseRootFromParent_Done,
     /* 173142 */   // Label 3243: @173142
     /* 173142 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173325), // Rule ID 2560 //
     /* 173147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173196 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173199 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173208 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173228 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 173228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 173231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 173242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 173245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 173249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 173257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 173261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 173264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173323 */     GIR_RootConstrainSelectedInstOperands,
     /* 173324 */     // GIR_Coverage, 2560,
     /* 173324 */     GIR_EraseRootFromParent_Done,
     /* 173325 */   // Label 3244: @173325
     /* 173325 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173508), // Rule ID 6296 //
     /* 173330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173379 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173382 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173391 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173411 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 173411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 173414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 173425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 173428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 173432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 173440 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 173444 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 173447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173452 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173457 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173506 */     GIR_RootConstrainSelectedInstOperands,
     /* 173507 */     // GIR_Coverage, 6296,
     /* 173507 */     GIR_EraseRootFromParent_Done,
     /* 173508 */   // Label 3245: @173508
     /* 173508 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173612), // Rule ID 13513 //
     /* 173513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173579 */     // MIs[3] Operand 1
     /* 173579 */     // No operand predicates
     /* 173579 */     // MIs[1] Operand 2
     /* 173579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173596 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 173599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173610 */     GIR_RootConstrainSelectedInstOperands,
     /* 173611 */     // GIR_Coverage, 13513,
     /* 173611 */     GIR_EraseRootFromParent_Done,
     /* 173612 */   // Label 3246: @173612
     /* 173612 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173716), // Rule ID 13516 //
     /* 173617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173683 */     // MIs[3] Operand 1
     /* 173683 */     // No operand predicates
     /* 173683 */     // MIs[1] Operand 2
     /* 173683 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173700 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 173703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173714 */     GIR_RootConstrainSelectedInstOperands,
     /* 173715 */     // GIR_Coverage, 13516,
     /* 173715 */     GIR_EraseRootFromParent_Done,
     /* 173716 */   // Label 3247: @173716
     /* 173716 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173847), // Rule ID 2517 //
     /* 173721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 173724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 173732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 173735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 173738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173800 */     // MIs[3] Operand 1
     /* 173800 */     // No operand predicates
     /* 173800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173802 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173814 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 173833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173845 */     GIR_RootConstrainSelectedInstOperands,
     /* 173846 */     // GIR_Coverage, 2517,
     /* 173846 */     GIR_EraseRootFromParent_Done,
     /* 173847 */   // Label 3248: @173847
     /* 173847 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173978), // Rule ID 2518 //
     /* 173852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173894 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173931 */     // MIs[3] Operand 1
     /* 173931 */     // No operand predicates
     /* 173931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173933 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 173933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 173951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 173964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173976 */     GIR_RootConstrainSelectedInstOperands,
     /* 173977 */     // GIR_Coverage, 2518,
     /* 173977 */     GIR_EraseRootFromParent_Done,
     /* 173978 */   // Label 3249: @173978
     /* 173978 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(174109), // Rule ID 2519 //
     /* 173983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 173991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 174062 */     // MIs[3] Operand 1
     /* 174062 */     // No operand predicates
     /* 174062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174064 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 174064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 174082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 174095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174107 */     GIR_RootConstrainSelectedInstOperands,
     /* 174108 */     // GIR_Coverage, 2519,
     /* 174108 */     GIR_EraseRootFromParent_Done,
     /* 174109 */   // Label 3250: @174109
     /* 174109 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(174240), // Rule ID 13705 //
     /* 174114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 174125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 174128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 174131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174168 */     // MIs[2] Operand 1
     /* 174168 */     // No operand predicates
     /* 174168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174184 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174189 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174195 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 174195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174207 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 174226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174238 */     GIR_RootConstrainSelectedInstOperands,
     /* 174239 */     // GIR_Coverage, 13705,
     /* 174239 */     GIR_EraseRootFromParent_Done,
     /* 174240 */   // Label 3251: @174240
     /* 174240 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(174371), // Rule ID 13706 //
     /* 174245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174299 */     // MIs[2] Operand 1
     /* 174299 */     // No operand predicates
     /* 174299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174320 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174326 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 174326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 174344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 174357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174369 */     GIR_RootConstrainSelectedInstOperands,
     /* 174370 */     // GIR_Coverage, 13706,
     /* 174370 */     GIR_EraseRootFromParent_Done,
     /* 174371 */   // Label 3252: @174371
     /* 174371 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174502), // Rule ID 13707 //
     /* 174376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 174422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 174430 */     // MIs[2] Operand 1
     /* 174430 */     // No operand predicates
     /* 174430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 174434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 174442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 174446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174451 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 174455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174457 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 174457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 174475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 174488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 174497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 174500 */     GIR_RootConstrainSelectedInstOperands,
     /* 174501 */     // GIR_Coverage, 13707,
     /* 174501 */     GIR_EraseRootFromParent_Done,
     /* 174502 */   // Label 3253: @174502
     /* 174502 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174616), // Rule ID 2061 //
     /* 174507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174540 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 174543 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 174548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 174552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 174556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 174565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174594 */     // MIs[3] Operand 1
     /* 174594 */     // No operand predicates
     /* 174594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174596 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 174599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 174607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174614 */     GIR_RootConstrainSelectedInstOperands,
     /* 174615 */     // GIR_Coverage, 2061,
     /* 174615 */     GIR_EraseRootFromParent_Done,
     /* 174616 */   // Label 3254: @174616
     /* 174616 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174730), // Rule ID 2068 //
     /* 174621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174654 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 174657 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 174662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 174666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 174670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 174679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174704 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 174708 */     // MIs[3] Operand 1
     /* 174708 */     // No operand predicates
     /* 174708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174710 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 174713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 174721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174728 */     GIR_RootConstrainSelectedInstOperands,
     /* 174729 */     // GIR_Coverage, 2068,
     /* 174729 */     GIR_EraseRootFromParent_Done,
     /* 174730 */   // Label 3255: @174730
     /* 174730 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174834), // Rule ID 1987 //
     /* 174735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174805 */     // MIs[3] Operand 1
     /* 174805 */     // No operand predicates
     /* 174805 */     // MIs[1] Operand 2
     /* 174805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174818 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 174821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174832 */     GIR_RootConstrainSelectedInstOperands,
     /* 174833 */     // GIR_Coverage, 1987,
     /* 174833 */     GIR_EraseRootFromParent_Done,
     /* 174834 */   // Label 3256: @174834
     /* 174834 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174938), // Rule ID 2017 //
     /* 174839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 174847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174909 */     // MIs[3] Operand 1
     /* 174909 */     // No operand predicates
     /* 174909 */     // MIs[1] Operand 2
     /* 174909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174922 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 174925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174936 */     GIR_RootConstrainSelectedInstOperands,
     /* 174937 */     // GIR_Coverage, 2017,
     /* 174937 */     GIR_EraseRootFromParent_Done,
     /* 174938 */   // Label 3257: @174938
     /* 174938 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(175042), // Rule ID 2024 //
     /* 174943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 174951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175013 */     // MIs[3] Operand 1
     /* 175013 */     // No operand predicates
     /* 175013 */     // MIs[1] Operand 2
     /* 175013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175026 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 175029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175040 */     GIR_RootConstrainSelectedInstOperands,
     /* 175041 */     // GIR_Coverage, 2024,
     /* 175041 */     GIR_EraseRootFromParent_Done,
     /* 175042 */   // Label 3258: @175042
     /* 175042 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(175146), // Rule ID 2083 //
     /* 175047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175113 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175117 */     // MIs[3] Operand 1
     /* 175117 */     // No operand predicates
     /* 175117 */     // MIs[1] Operand 2
     /* 175117 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 175133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175144 */     GIR_RootConstrainSelectedInstOperands,
     /* 175145 */     // GIR_Coverage, 2083,
     /* 175145 */     GIR_EraseRootFromParent_Done,
     /* 175146 */   // Label 3259: @175146
     /* 175146 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(175250), // Rule ID 1990 //
     /* 175151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175217 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175221 */     // MIs[3] Operand 1
     /* 175221 */     // No operand predicates
     /* 175221 */     // MIs[1] Operand 2
     /* 175221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175234 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175248 */     GIR_RootConstrainSelectedInstOperands,
     /* 175249 */     // GIR_Coverage, 1990,
     /* 175249 */     GIR_EraseRootFromParent_Done,
     /* 175250 */   // Label 3260: @175250
     /* 175250 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175354), // Rule ID 2020 //
     /* 175255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 175263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175321 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175325 */     // MIs[3] Operand 1
     /* 175325 */     // No operand predicates
     /* 175325 */     // MIs[1] Operand 2
     /* 175325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175338 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 175341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175352 */     GIR_RootConstrainSelectedInstOperands,
     /* 175353 */     // GIR_Coverage, 2020,
     /* 175353 */     GIR_EraseRootFromParent_Done,
     /* 175354 */   // Label 3261: @175354
     /* 175354 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175458), // Rule ID 2027 //
     /* 175359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 175367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175429 */     // MIs[3] Operand 1
     /* 175429 */     // No operand predicates
     /* 175429 */     // MIs[1] Operand 2
     /* 175429 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175442 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 175445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175456 */     GIR_RootConstrainSelectedInstOperands,
     /* 175457 */     // GIR_Coverage, 2027,
     /* 175457 */     GIR_EraseRootFromParent_Done,
     /* 175458 */   // Label 3262: @175458
     /* 175458 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175562), // Rule ID 2086 //
     /* 175463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175529 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175533 */     // MIs[3] Operand 1
     /* 175533 */     // No operand predicates
     /* 175533 */     // MIs[1] Operand 2
     /* 175533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175546 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 175549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175560 */     GIR_RootConstrainSelectedInstOperands,
     /* 175561 */     // GIR_Coverage, 2086,
     /* 175561 */     GIR_EraseRootFromParent_Done,
     /* 175562 */   // Label 3263: @175562
     /* 175562 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175619), // Rule ID 1751 //
     /* 175567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 175595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 175602 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 175605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 175612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 175617 */     GIR_RootConstrainSelectedInstOperands,
     /* 175618 */     // GIR_Coverage, 1751,
     /* 175618 */     GIR_EraseRootFromParent_Done,
     /* 175619 */   // Label 3264: @175619
     /* 175619 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175676), // Rule ID 1753 //
     /* 175624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 175652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 175659 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 175662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 175669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 175674 */     GIR_RootConstrainSelectedInstOperands,
     /* 175675 */     // GIR_Coverage, 1753,
     /* 175675 */     GIR_EraseRootFromParent_Done,
     /* 175676 */   // Label 3265: @175676
     /* 175676 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175786), // Rule ID 6315 //
     /* 175681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 175686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 175707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 175711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 175715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175720 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 175731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 175743 */     // MIs[2] Operand 1
     /* 175743 */     // No operand predicates
     /* 175743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 175745 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 175745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 175776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 175784 */     GIR_RootConstrainSelectedInstOperands,
     /* 175785 */     // GIR_Coverage, 6315,
     /* 175785 */     GIR_EraseRootFromParent_Done,
     /* 175786 */   // Label 3266: @175786
     /* 175786 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175883), // Rule ID 13976 //
     /* 175791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 175794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175833 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175843 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 175843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175855 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 175861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 175874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175881 */     GIR_RootConstrainSelectedInstOperands,
     /* 175882 */     // GIR_Coverage, 13976,
     /* 175882 */     GIR_EraseRootFromParent_Done,
     /* 175883 */   // Label 3267: @175883
     /* 175883 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175980), // Rule ID 13977 //
     /* 175888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 175891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175940 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 175940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 175958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 175971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175978 */     GIR_RootConstrainSelectedInstOperands,
     /* 175979 */     // GIR_Coverage, 13977,
     /* 175979 */     GIR_EraseRootFromParent_Done,
     /* 175980 */   // Label 3268: @175980
     /* 175980 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176077), // Rule ID 13978 //
     /* 175985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 175988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176037 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 176037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 176040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176049 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 176055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176075 */     GIR_RootConstrainSelectedInstOperands,
     /* 176076 */     // GIR_Coverage, 13978,
     /* 176076 */     GIR_EraseRootFromParent_Done,
     /* 176077 */   // Label 3269: @176077
     /* 176077 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176157), // Rule ID 5249 //
     /* 176082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176140 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 176143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 176155 */     GIR_RootConstrainSelectedInstOperands,
     /* 176156 */     // GIR_Coverage, 5249,
     /* 176156 */     GIR_EraseRootFromParent_Done,
     /* 176157 */   // Label 3270: @176157
     /* 176157 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176237), // Rule ID 5250 //
     /* 176162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176192 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176195 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176220 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 176235 */     GIR_RootConstrainSelectedInstOperands,
     /* 176236 */     // GIR_Coverage, 5250,
     /* 176236 */     GIR_EraseRootFromParent_Done,
     /* 176237 */   // Label 3271: @176237
     /* 176237 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176334), // Rule ID 5246 //
     /* 176242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 176245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176294 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 176294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 176312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 176325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176332 */     GIR_RootConstrainSelectedInstOperands,
     /* 176333 */     // GIR_Coverage, 5246,
     /* 176333 */     GIR_EraseRootFromParent_Done,
     /* 176334 */   // Label 3272: @176334
     /* 176334 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176431), // Rule ID 5247 //
     /* 176339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176391 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 176391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 176409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 176422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176429 */     GIR_RootConstrainSelectedInstOperands,
     /* 176430 */     // GIR_Coverage, 5247,
     /* 176430 */     GIR_EraseRootFromParent_Done,
     /* 176431 */   // Label 3273: @176431
     /* 176431 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176528), // Rule ID 5248 //
     /* 176436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176482 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 176486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176488 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 176488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 176491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 176506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176526 */     GIR_RootConstrainSelectedInstOperands,
     /* 176527 */     // GIR_Coverage, 5248,
     /* 176527 */     GIR_EraseRootFromParent_Done,
     /* 176528 */   // Label 3274: @176528
     /* 176528 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176609), // Rule ID 13514 //
     /* 176533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176587 */     // MIs[2] Operand 1
     /* 176587 */     // No operand predicates
     /* 176587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176593 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176607 */     GIR_RootConstrainSelectedInstOperands,
     /* 176608 */     // GIR_Coverage, 13514,
     /* 176608 */     GIR_EraseRootFromParent_Done,
     /* 176609 */   // Label 3275: @176609
     /* 176609 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176690), // Rule ID 13515 //
     /* 176614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176668 */     // MIs[2] Operand 1
     /* 176668 */     // No operand predicates
     /* 176668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176674 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 176677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176688 */     GIR_RootConstrainSelectedInstOperands,
     /* 176689 */     // GIR_Coverage, 13515,
     /* 176689 */     GIR_EraseRootFromParent_Done,
     /* 176690 */   // Label 3276: @176690
     /* 176690 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176771), // Rule ID 13517 //
     /* 176695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176749 */     // MIs[2] Operand 1
     /* 176749 */     // No operand predicates
     /* 176749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176755 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 176758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176769 */     GIR_RootConstrainSelectedInstOperands,
     /* 176770 */     // GIR_Coverage, 13517,
     /* 176770 */     GIR_EraseRootFromParent_Done,
     /* 176771 */   // Label 3277: @176771
     /* 176771 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(176852), // Rule ID 13518 //
     /* 176776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176830 */     // MIs[2] Operand 1
     /* 176830 */     // No operand predicates
     /* 176830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176836 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 176839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176850 */     GIR_RootConstrainSelectedInstOperands,
     /* 176851 */     // GIR_Coverage, 13518,
     /* 176851 */     GIR_EraseRootFromParent_Done,
     /* 176852 */   // Label 3278: @176852
     /* 176852 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(176933), // Rule ID 13519 //
     /* 176857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 176886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 176890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 176911 */     // MIs[2] Operand 1
     /* 176911 */     // No operand predicates
     /* 176911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176917 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 176920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 176928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 176931 */     GIR_RootConstrainSelectedInstOperands,
     /* 176932 */     // GIR_Coverage, 13519,
     /* 176932 */     GIR_EraseRootFromParent_Done,
     /* 176933 */   // Label 3279: @176933
     /* 176933 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177014), // Rule ID 13520 //
     /* 176938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 176963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 176975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 176984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176992 */     // MIs[2] Operand 1
     /* 176992 */     // No operand predicates
     /* 176992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 176998 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 177001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177012 */     GIR_RootConstrainSelectedInstOperands,
     /* 177013 */     // GIR_Coverage, 13520,
     /* 177013 */     GIR_EraseRootFromParent_Done,
     /* 177014 */   // Label 3280: @177014
     /* 177014 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177095), // Rule ID 13521 //
     /* 177019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177073 */     // MIs[2] Operand 1
     /* 177073 */     // No operand predicates
     /* 177073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177079 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 177082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177093 */     GIR_RootConstrainSelectedInstOperands,
     /* 177094 */     // GIR_Coverage, 13521,
     /* 177094 */     GIR_EraseRootFromParent_Done,
     /* 177095 */   // Label 3281: @177095
     /* 177095 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177176), // Rule ID 13522 //
     /* 177100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 177154 */     // MIs[2] Operand 1
     /* 177154 */     // No operand predicates
     /* 177154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177160 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 177163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177174 */     GIR_RootConstrainSelectedInstOperands,
     /* 177175 */     // GIR_Coverage, 13522,
     /* 177175 */     GIR_EraseRootFromParent_Done,
     /* 177176 */   // Label 3282: @177176
     /* 177176 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177282), // Rule ID 6312 //
     /* 177181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 177186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 177207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177216 */     // MIs[1] Operand 2
     /* 177216 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 177227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177239 */     // MIs[2] Operand 1
     /* 177239 */     // No operand predicates
     /* 177239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177241 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 177272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177280 */     GIR_RootConstrainSelectedInstOperands,
     /* 177281 */     // GIR_Coverage, 6312,
     /* 177281 */     GIR_EraseRootFromParent_Done,
     /* 177282 */   // Label 3283: @177282
     /* 177282 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177363), // Rule ID 1988 //
     /* 177287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177345 */     // MIs[2] Operand 1
     /* 177345 */     // No operand predicates
     /* 177345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177347 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 177350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 177362 */     // GIR_Coverage, 1988,
     /* 177362 */     GIR_EraseRootFromParent_Done,
     /* 177363 */   // Label 3284: @177363
     /* 177363 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177444), // Rule ID 1989 //
     /* 177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177426 */     // MIs[2] Operand 1
     /* 177426 */     // No operand predicates
     /* 177426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177428 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 177431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177442 */     GIR_RootConstrainSelectedInstOperands,
     /* 177443 */     // GIR_Coverage, 1989,
     /* 177443 */     GIR_EraseRootFromParent_Done,
     /* 177444 */   // Label 3285: @177444
     /* 177444 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177525), // Rule ID 2018 //
     /* 177449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177507 */     // MIs[2] Operand 1
     /* 177507 */     // No operand predicates
     /* 177507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177509 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 177512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177523 */     GIR_RootConstrainSelectedInstOperands,
     /* 177524 */     // GIR_Coverage, 2018,
     /* 177524 */     GIR_EraseRootFromParent_Done,
     /* 177525 */   // Label 3286: @177525
     /* 177525 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177606), // Rule ID 2019 //
     /* 177530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177588 */     // MIs[2] Operand 1
     /* 177588 */     // No operand predicates
     /* 177588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177590 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177604 */     GIR_RootConstrainSelectedInstOperands,
     /* 177605 */     // GIR_Coverage, 2019,
     /* 177605 */     GIR_EraseRootFromParent_Done,
     /* 177606 */   // Label 3287: @177606
     /* 177606 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177687), // Rule ID 2025 //
     /* 177611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177669 */     // MIs[2] Operand 1
     /* 177669 */     // No operand predicates
     /* 177669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177671 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 177674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177685 */     GIR_RootConstrainSelectedInstOperands,
     /* 177686 */     // GIR_Coverage, 2025,
     /* 177686 */     GIR_EraseRootFromParent_Done,
     /* 177687 */   // Label 3288: @177687
     /* 177687 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(177768), // Rule ID 2026 //
     /* 177692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177750 */     // MIs[2] Operand 1
     /* 177750 */     // No operand predicates
     /* 177750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 177755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177766 */     GIR_RootConstrainSelectedInstOperands,
     /* 177767 */     // GIR_Coverage, 2026,
     /* 177767 */     GIR_EraseRootFromParent_Done,
     /* 177768 */   // Label 3289: @177768
     /* 177768 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(177849), // Rule ID 2084 //
     /* 177773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 177806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 177819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 177831 */     // MIs[2] Operand 1
     /* 177831 */     // No operand predicates
     /* 177831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 177836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177847 */     GIR_RootConstrainSelectedInstOperands,
     /* 177848 */     // GIR_Coverage, 2084,
     /* 177848 */     GIR_EraseRootFromParent_Done,
     /* 177849 */   // Label 3290: @177849
     /* 177849 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(177930), // Rule ID 1991 //
     /* 177854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177912 */     // MIs[2] Operand 1
     /* 177912 */     // No operand predicates
     /* 177912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177914 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 177917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 177925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 177928 */     GIR_RootConstrainSelectedInstOperands,
     /* 177929 */     // GIR_Coverage, 1991,
     /* 177929 */     GIR_EraseRootFromParent_Done,
     /* 177930 */   // Label 3291: @177930
     /* 177930 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178011), // Rule ID 1992 //
     /* 177935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 177985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177993 */     // MIs[2] Operand 1
     /* 177993 */     // No operand predicates
     /* 177993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177995 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 177998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178009 */     GIR_RootConstrainSelectedInstOperands,
     /* 178010 */     // GIR_Coverage, 1992,
     /* 178010 */     GIR_EraseRootFromParent_Done,
     /* 178011 */   // Label 3292: @178011
     /* 178011 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178092), // Rule ID 2021 //
     /* 178016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178074 */     // MIs[2] Operand 1
     /* 178074 */     // No operand predicates
     /* 178074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178076 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 178079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178090 */     GIR_RootConstrainSelectedInstOperands,
     /* 178091 */     // GIR_Coverage, 2021,
     /* 178091 */     GIR_EraseRootFromParent_Done,
     /* 178092 */   // Label 3293: @178092
     /* 178092 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178173), // Rule ID 2022 //
     /* 178097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178155 */     // MIs[2] Operand 1
     /* 178155 */     // No operand predicates
     /* 178155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178157 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 178160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178171 */     GIR_RootConstrainSelectedInstOperands,
     /* 178172 */     // GIR_Coverage, 2022,
     /* 178172 */     GIR_EraseRootFromParent_Done,
     /* 178173 */   // Label 3294: @178173
     /* 178173 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178254), // Rule ID 2028 //
     /* 178178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178236 */     // MIs[2] Operand 1
     /* 178236 */     // No operand predicates
     /* 178236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178238 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 178241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178252 */     GIR_RootConstrainSelectedInstOperands,
     /* 178253 */     // GIR_Coverage, 2028,
     /* 178253 */     GIR_EraseRootFromParent_Done,
     /* 178254 */   // Label 3295: @178254
     /* 178254 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178335), // Rule ID 2029 //
     /* 178259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178317 */     // MIs[2] Operand 1
     /* 178317 */     // No operand predicates
     /* 178317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 178322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178333 */     GIR_RootConstrainSelectedInstOperands,
     /* 178334 */     // GIR_Coverage, 2029,
     /* 178334 */     GIR_EraseRootFromParent_Done,
     /* 178335 */   // Label 3296: @178335
     /* 178335 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178416), // Rule ID 2087 //
     /* 178340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178398 */     // MIs[2] Operand 1
     /* 178398 */     // No operand predicates
     /* 178398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 178403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178414 */     GIR_RootConstrainSelectedInstOperands,
     /* 178415 */     // GIR_Coverage, 2087,
     /* 178415 */     GIR_EraseRootFromParent_Done,
     /* 178416 */   // Label 3297: @178416
     /* 178416 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178497), // Rule ID 1993 //
     /* 178421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178479 */     // MIs[2] Operand 1
     /* 178479 */     // No operand predicates
     /* 178479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178481 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178495 */     GIR_RootConstrainSelectedInstOperands,
     /* 178496 */     // GIR_Coverage, 1993,
     /* 178496 */     GIR_EraseRootFromParent_Done,
     /* 178497 */   // Label 3298: @178497
     /* 178497 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178578), // Rule ID 1994 //
     /* 178502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178560 */     // MIs[2] Operand 1
     /* 178560 */     // No operand predicates
     /* 178560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178562 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178576 */     GIR_RootConstrainSelectedInstOperands,
     /* 178577 */     // GIR_Coverage, 1994,
     /* 178577 */     GIR_EraseRootFromParent_Done,
     /* 178578 */   // Label 3299: @178578
     /* 178578 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178659), // Rule ID 1995 //
     /* 178583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178641 */     // MIs[2] Operand 1
     /* 178641 */     // No operand predicates
     /* 178641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178643 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178657 */     GIR_RootConstrainSelectedInstOperands,
     /* 178658 */     // GIR_Coverage, 1995,
     /* 178658 */     GIR_EraseRootFromParent_Done,
     /* 178659 */   // Label 3300: @178659
     /* 178659 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(178740), // Rule ID 1996 //
     /* 178664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178722 */     // MIs[2] Operand 1
     /* 178722 */     // No operand predicates
     /* 178722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178724 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 178727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178738 */     GIR_RootConstrainSelectedInstOperands,
     /* 178739 */     // GIR_Coverage, 1996,
     /* 178739 */     GIR_EraseRootFromParent_Done,
     /* 178740 */   // Label 3301: @178740
     /* 178740 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(178821), // Rule ID 2023 //
     /* 178745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178803 */     // MIs[2] Operand 1
     /* 178803 */     // No operand predicates
     /* 178803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178805 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 178808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178819 */     GIR_RootConstrainSelectedInstOperands,
     /* 178820 */     // GIR_Coverage, 2023,
     /* 178820 */     GIR_EraseRootFromParent_Done,
     /* 178821 */   // Label 3302: @178821
     /* 178821 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(178902), // Rule ID 2030 //
     /* 178826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178884 */     // MIs[2] Operand 1
     /* 178884 */     // No operand predicates
     /* 178884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178886 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 178889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178900 */     GIR_RootConstrainSelectedInstOperands,
     /* 178901 */     // GIR_Coverage, 2030,
     /* 178901 */     GIR_EraseRootFromParent_Done,
     /* 178902 */   // Label 3303: @178902
     /* 178902 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(178980), // Rule ID 6299 //
     /* 178907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178962 */     // MIs[2] Operand 1
     /* 178962 */     // No operand predicates
     /* 178962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178964 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 178964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 178967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 178975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178978 */     GIR_RootConstrainSelectedInstOperands,
     /* 178979 */     // GIR_Coverage, 6299,
     /* 178979 */     GIR_EraseRootFromParent_Done,
     /* 178980 */   // Label 3304: @178980
     /* 178980 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179040), // Rule ID 6365 //
     /* 178985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 178990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 179011 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 179011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 179014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179038 */     GIR_RootConstrainSelectedInstOperands,
     /* 179039 */     // GIR_Coverage, 6365,
     /* 179039 */     GIR_EraseRootFromParent_Done,
     /* 179040 */   // Label 3305: @179040
     /* 179040 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179100), // Rule ID 6366 //
     /* 179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 179071 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 179071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 179074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179098 */     GIR_RootConstrainSelectedInstOperands,
     /* 179099 */     // GIR_Coverage, 6366,
     /* 179099 */     GIR_EraseRootFromParent_Done,
     /* 179100 */   // Label 3306: @179100
     /* 179100 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179160), // Rule ID 6367 //
     /* 179105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 179131 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 179131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 179134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 179138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179143 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 179146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 179155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179158 */     GIR_RootConstrainSelectedInstOperands,
     /* 179159 */     // GIR_Coverage, 6367,
     /* 179159 */     GIR_EraseRootFromParent_Done,
     /* 179160 */   // Label 3307: @179160
     /* 179160 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179207), // Rule ID 3894 //
     /* 179165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179187 */     // MIs[0] Operand 3
     /* 179187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 179198 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 179201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179205 */     GIR_RootConstrainSelectedInstOperands,
     /* 179206 */     // GIR_Coverage, 3894,
     /* 179206 */     GIR_EraseRootFromParent_Done,
     /* 179207 */   // Label 3308: @179207
     /* 179207 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179254), // Rule ID 3895 //
     /* 179212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179234 */     // MIs[0] Operand 3
     /* 179234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 179245 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 179248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179252 */     GIR_RootConstrainSelectedInstOperands,
     /* 179253 */     // GIR_Coverage, 3895,
     /* 179253 */     GIR_EraseRootFromParent_Done,
     /* 179254 */   // Label 3309: @179254
     /* 179254 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179301), // Rule ID 3896 //
     /* 179259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179281 */     // MIs[0] Operand 3
     /* 179281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 179292 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 179295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179299 */     GIR_RootConstrainSelectedInstOperands,
     /* 179300 */     // GIR_Coverage, 3896,
     /* 179300 */     GIR_EraseRootFromParent_Done,
     /* 179301 */   // Label 3310: @179301
     /* 179301 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179348), // Rule ID 3897 //
     /* 179306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 179309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 179314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179328 */     // MIs[0] Operand 3
     /* 179328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 179339 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 179339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 179342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179346 */     GIR_RootConstrainSelectedInstOperands,
     /* 179347 */     // GIR_Coverage, 3897,
     /* 179347 */     GIR_EraseRootFromParent_Done,
     /* 179348 */   // Label 3311: @179348
     /* 179348 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179394), // Rule ID 3537 //
     /* 179353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 179364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179375 */     // MIs[0] Idx
     /* 179375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 179383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 179383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 179386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179392 */     GIR_RootConstrainSelectedInstOperands,
     /* 179393 */     // GIR_Coverage, 3537,
     /* 179393 */     GIR_EraseRootFromParent_Done,
     /* 179394 */   // Label 3312: @179394
     /* 179394 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179440), // Rule ID 3538 //
     /* 179399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 179410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179421 */     // MIs[0] Idx
     /* 179421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 179429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 179429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 179432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179438 */     GIR_RootConstrainSelectedInstOperands,
     /* 179439 */     // GIR_Coverage, 3538,
     /* 179439 */     GIR_EraseRootFromParent_Done,
     /* 179440 */   // Label 3313: @179440
     /* 179440 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(179486), // Rule ID 3539 //
     /* 179445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 179456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179467 */     // MIs[0] Idx
     /* 179467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 179475 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 179475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 179478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179484 */     GIR_RootConstrainSelectedInstOperands,
     /* 179485 */     // GIR_Coverage, 3539,
     /* 179485 */     GIR_EraseRootFromParent_Done,
     /* 179486 */   // Label 3314: @179486
     /* 179486 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(179532), // Rule ID 3540 //
     /* 179491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 179494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 179499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 179502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179513 */     // MIs[0] Idx
     /* 179513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 179516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 179521 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 179521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 179524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 179530 */     GIR_RootConstrainSelectedInstOperands,
     /* 179531 */     // GIR_Coverage, 3540,
     /* 179531 */     GIR_EraseRootFromParent_Done,
     /* 179532 */   // Label 3315: @179532
     /* 179532 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(179588), // Rule ID 2109 //
     /* 179537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 179545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179574 */     // MIs[1] Operand 1
     /* 179574 */     // No operand predicates
     /* 179574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179576 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 179579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179586 */     GIR_RootConstrainSelectedInstOperands,
     /* 179587 */     // GIR_Coverage, 2109,
     /* 179587 */     GIR_EraseRootFromParent_Done,
     /* 179588 */   // Label 3316: @179588
     /* 179588 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(179644), // Rule ID 2110 //
     /* 179593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 179601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179630 */     // MIs[1] Operand 1
     /* 179630 */     // No operand predicates
     /* 179630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179632 */     // (intrinsic_wo_chain:{ *:[i32] } 700:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 179635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179642 */     GIR_RootConstrainSelectedInstOperands,
     /* 179643 */     // GIR_Coverage, 2110,
     /* 179643 */     GIR_EraseRootFromParent_Done,
     /* 179644 */   // Label 3317: @179644
     /* 179644 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(179700), // Rule ID 2115 //
     /* 179649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 179657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179686 */     // MIs[1] Operand 1
     /* 179686 */     // No operand predicates
     /* 179686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179688 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 179691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179698 */     GIR_RootConstrainSelectedInstOperands,
     /* 179699 */     // GIR_Coverage, 2115,
     /* 179699 */     GIR_EraseRootFromParent_Done,
     /* 179700 */   // Label 3318: @179700
     /* 179700 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(179756), // Rule ID 2116 //
     /* 179705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 179713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179742 */     // MIs[1] Operand 1
     /* 179742 */     // No operand predicates
     /* 179742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179744 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 179747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179754 */     GIR_RootConstrainSelectedInstOperands,
     /* 179755 */     // GIR_Coverage, 2116,
     /* 179755 */     GIR_EraseRootFromParent_Done,
     /* 179756 */   // Label 3319: @179756
     /* 179756 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(179812), // Rule ID 2123 //
     /* 179761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 179769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179798 */     // MIs[1] Operand 1
     /* 179798 */     // No operand predicates
     /* 179798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179800 */     // (intrinsic_wo_chain:{ *:[i32] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 179803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179810 */     GIR_RootConstrainSelectedInstOperands,
     /* 179811 */     // GIR_Coverage, 2123,
     /* 179811 */     GIR_EraseRootFromParent_Done,
     /* 179812 */   // Label 3320: @179812
     /* 179812 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(179868), // Rule ID 2126 //
     /* 179817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 179825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 179854 */     // MIs[1] Operand 1
     /* 179854 */     // No operand predicates
     /* 179854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179856 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 179859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179866 */     GIR_RootConstrainSelectedInstOperands,
     /* 179867 */     // GIR_Coverage, 2126,
     /* 179867 */     GIR_EraseRootFromParent_Done,
     /* 179868 */   // Label 3321: @179868
     /* 179868 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(179924), // Rule ID 2148 //
     /* 179873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 179910 */     // MIs[1] Operand 1
     /* 179910 */     // No operand predicates
     /* 179910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179912 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 179915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179922 */     GIR_RootConstrainSelectedInstOperands,
     /* 179923 */     // GIR_Coverage, 2148,
     /* 179923 */     GIR_EraseRootFromParent_Done,
     /* 179924 */   // Label 3322: @179924
     /* 179924 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(179980), // Rule ID 2150 //
     /* 179929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 179966 */     // MIs[1] Operand 1
     /* 179966 */     // No operand predicates
     /* 179966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179968 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 179968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 179971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 179978 */     GIR_RootConstrainSelectedInstOperands,
     /* 179979 */     // GIR_Coverage, 2150,
     /* 179979 */     GIR_EraseRootFromParent_Done,
     /* 179980 */   // Label 3323: @179980
     /* 179980 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180036), // Rule ID 2152 //
     /* 179985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 179993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 180022 */     // MIs[1] Operand 1
     /* 180022 */     // No operand predicates
     /* 180022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180024 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 180024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 180027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180034 */     GIR_RootConstrainSelectedInstOperands,
     /* 180035 */     // GIR_Coverage, 2152,
     /* 180035 */     GIR_EraseRootFromParent_Done,
     /* 180036 */   // Label 3324: @180036
     /* 180036 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180089), // Rule ID 6300 //
     /* 180041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180075 */     // MIs[1] Operand 1
     /* 180075 */     // No operand predicates
     /* 180075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180077 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 180080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180087 */     GIR_RootConstrainSelectedInstOperands,
     /* 180088 */     // GIR_Coverage, 6300,
     /* 180088 */     GIR_EraseRootFromParent_Done,
     /* 180089 */   // Label 3325: @180089
     /* 180089 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180142), // Rule ID 6301 //
     /* 180094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180128 */     // MIs[1] Operand 1
     /* 180128 */     // No operand predicates
     /* 180128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180130 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 180133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180140 */     GIR_RootConstrainSelectedInstOperands,
     /* 180141 */     // GIR_Coverage, 6301,
     /* 180141 */     GIR_EraseRootFromParent_Done,
     /* 180142 */   // Label 3326: @180142
     /* 180142 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180195), // Rule ID 6302 //
     /* 180147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180181 */     // MIs[1] Operand 1
     /* 180181 */     // No operand predicates
     /* 180181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180183 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 180186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180193 */     GIR_RootConstrainSelectedInstOperands,
     /* 180194 */     // GIR_Coverage, 6302,
     /* 180194 */     GIR_EraseRootFromParent_Done,
     /* 180195 */   // Label 3327: @180195
     /* 180195 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180248), // Rule ID 6303 //
     /* 180200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180234 */     // MIs[1] Operand 1
     /* 180234 */     // No operand predicates
     /* 180234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180236 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 180239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180246 */     GIR_RootConstrainSelectedInstOperands,
     /* 180247 */     // GIR_Coverage, 6303,
     /* 180247 */     GIR_EraseRootFromParent_Done,
     /* 180248 */   // Label 3328: @180248
     /* 180248 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(180301), // Rule ID 6304 //
     /* 180253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 180258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180287 */     // MIs[1] Operand 1
     /* 180287 */     // No operand predicates
     /* 180287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180289 */     // (intrinsic_wo_chain:{ *:[v1i64] } 769:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 180292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180299 */     GIR_RootConstrainSelectedInstOperands,
     /* 180300 */     // GIR_Coverage, 6304,
     /* 180300 */     GIR_EraseRootFromParent_Done,
     /* 180301 */   // Label 3329: @180301
     /* 180301 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(180354), // Rule ID 6305 //
     /* 180306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 180311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180340 */     // MIs[1] Operand 1
     /* 180340 */     // No operand predicates
     /* 180340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180342 */     // (intrinsic_wo_chain:{ *:[v1i64] } 770:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 180345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180352 */     GIR_RootConstrainSelectedInstOperands,
     /* 180353 */     // GIR_Coverage, 6305,
     /* 180353 */     GIR_EraseRootFromParent_Done,
     /* 180354 */   // Label 3330: @180354
     /* 180354 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(180407), // Rule ID 6306 //
     /* 180359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180393 */     // MIs[1] Operand 1
     /* 180393 */     // No operand predicates
     /* 180393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180395 */     // (intrinsic_wo_chain:{ *:[f32] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 180398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180405 */     GIR_RootConstrainSelectedInstOperands,
     /* 180406 */     // GIR_Coverage, 6306,
     /* 180406 */     GIR_EraseRootFromParent_Done,
     /* 180407 */   // Label 3331: @180407
     /* 180407 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(180460), // Rule ID 6307 //
     /* 180412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180446 */     // MIs[1] Operand 1
     /* 180446 */     // No operand predicates
     /* 180446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180448 */     // (intrinsic_wo_chain:{ *:[f64] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 180451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180458 */     GIR_RootConstrainSelectedInstOperands,
     /* 180459 */     // GIR_Coverage, 6307,
     /* 180459 */     GIR_EraseRootFromParent_Done,
     /* 180460 */   // Label 3332: @180460
     /* 180460 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(180513), // Rule ID 6308 //
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180499 */     // MIs[1] Operand 1
     /* 180499 */     // No operand predicates
     /* 180499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180501 */     // (intrinsic_wo_chain:{ *:[v1f64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 180504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180511 */     GIR_RootConstrainSelectedInstOperands,
     /* 180512 */     // GIR_Coverage, 6308,
     /* 180512 */     GIR_EraseRootFromParent_Done,
     /* 180513 */   // Label 3333: @180513
     /* 180513 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(180566), // Rule ID 6309 //
     /* 180518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180552 */     // MIs[1] Operand 1
     /* 180552 */     // No operand predicates
     /* 180552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180554 */     // (intrinsic_wo_chain:{ *:[f64] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 180557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180564 */     GIR_RootConstrainSelectedInstOperands,
     /* 180565 */     // GIR_Coverage, 6309,
     /* 180565 */     GIR_EraseRootFromParent_Done,
     /* 180566 */   // Label 3334: @180566
     /* 180566 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(180619), // Rule ID 6310 //
     /* 180571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 180605 */     // MIs[1] Operand 1
     /* 180605 */     // No operand predicates
     /* 180605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180607 */     // (intrinsic_wo_chain:{ *:[v1f64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 180607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 180610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180617 */     GIR_RootConstrainSelectedInstOperands,
     /* 180618 */     // GIR_Coverage, 6310,
     /* 180618 */     GIR_EraseRootFromParent_Done,
     /* 180619 */   // Label 3335: @180619
     /* 180619 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(180672), // Rule ID 6311 //
     /* 180624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 180658 */     // MIs[1] Operand 1
     /* 180658 */     // No operand predicates
     /* 180658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180660 */     // (intrinsic_wo_chain:{ *:[f32] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 180660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 180663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180670 */     GIR_RootConstrainSelectedInstOperands,
     /* 180671 */     // GIR_Coverage, 6311,
     /* 180671 */     GIR_EraseRootFromParent_Done,
     /* 180672 */   // Label 3336: @180672
     /* 180672 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(180754), // Rule ID 6313 //
     /* 180677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180711 */     // MIs[1] Operand 1
     /* 180711 */     // No operand predicates
     /* 180711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180713 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 180744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180752 */     GIR_RootConstrainSelectedInstOperands,
     /* 180753 */     // GIR_Coverage, 6313,
     /* 180753 */     GIR_EraseRootFromParent_Done,
     /* 180754 */   // Label 3337: @180754
     /* 180754 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(180836), // Rule ID 6314 //
     /* 180759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 180764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180793 */     // MIs[1] Operand 1
     /* 180793 */     // No operand predicates
     /* 180793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180795 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 180826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180834 */     GIR_RootConstrainSelectedInstOperands,
     /* 180835 */     // GIR_Coverage, 6314,
     /* 180835 */     GIR_EraseRootFromParent_Done,
     /* 180836 */   // Label 3338: @180836
     /* 180836 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(180918), // Rule ID 6316 //
     /* 180841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180875 */     // MIs[1] Operand 1
     /* 180875 */     // No operand predicates
     /* 180875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180877 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 180908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180916 */     GIR_RootConstrainSelectedInstOperands,
     /* 180917 */     // GIR_Coverage, 6316,
     /* 180917 */     GIR_EraseRootFromParent_Done,
     /* 180918 */   // Label 3339: @180918
     /* 180918 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181000), // Rule ID 6317 //
     /* 180923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 180928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 180957 */     // MIs[1] Operand 1
     /* 180957 */     // No operand predicates
     /* 180957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180959 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 180959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180971 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 180977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 180990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 180998 */     GIR_RootConstrainSelectedInstOperands,
     /* 180999 */     // GIR_Coverage, 6317,
     /* 180999 */     GIR_EraseRootFromParent_Done,
     /* 181000 */   // Label 3340: @181000
     /* 181000 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181106), // Rule ID 6318 //
     /* 181005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181039 */     // MIs[1] Operand 1
     /* 181039 */     // No operand predicates
     /* 181039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181041 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 181041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 181048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181105 */     // GIR_Coverage, 6318,
     /* 181105 */     GIR_EraseRootFromParent_Done,
     /* 181106 */   // Label 3341: @181106
     /* 181106 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181212), // Rule ID 6319 //
     /* 181111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181145 */     // MIs[1] Operand 1
     /* 181145 */     // No operand predicates
     /* 181145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181147 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 181147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 181154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181159 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181211 */     // GIR_Coverage, 6319,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 3342: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181318), // Rule ID 6320 //
     /* 181217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181251 */     // MIs[1] Operand 1
     /* 181251 */     // No operand predicates
     /* 181251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181253 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 181253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 181260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181265 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181317 */     // GIR_Coverage, 6320,
     /* 181317 */     GIR_EraseRootFromParent_Done,
     /* 181318 */   // Label 3343: @181318
     /* 181318 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181424), // Rule ID 6321 //
     /* 181323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181357 */     // MIs[1] Operand 1
     /* 181357 */     // No operand predicates
     /* 181357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181359 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 181359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 181366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 181378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181423 */     // GIR_Coverage, 6321,
     /* 181423 */     GIR_EraseRootFromParent_Done,
     /* 181424 */   // Label 3344: @181424
     /* 181424 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181482), // Rule ID 7012 //
     /* 181429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 181434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 181463 */     // MIs[1] Operand 1
     /* 181463 */     // No operand predicates
     /* 181463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181465 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 181465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 181468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181472 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 181477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 181480 */     GIR_RootConstrainSelectedInstOperands,
     /* 181481 */     // GIR_Coverage, 7012,
     /* 181481 */     GIR_EraseRootFromParent_Done,
     /* 181482 */   // Label 3345: @181482
     /* 181482 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181524), // Rule ID 3038 //
     /* 181487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181505 */     // MIs[0] Op2
     /* 181505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 181513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 181513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 181516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181522 */     GIR_RootConstrainSelectedInstOperands,
     /* 181523 */     // GIR_Coverage, 3038,
     /* 181523 */     GIR_EraseRootFromParent_Done,
     /* 181524 */   // Label 3346: @181524
     /* 181524 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181566), // Rule ID 3039 //
     /* 181529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181547 */     // MIs[0] Op2
     /* 181547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 181555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 181555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 181558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181564 */     GIR_RootConstrainSelectedInstOperands,
     /* 181565 */     // GIR_Coverage, 3039,
     /* 181565 */     GIR_EraseRootFromParent_Done,
     /* 181566 */   // Label 3347: @181566
     /* 181566 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(181608), // Rule ID 3040 //
     /* 181571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 181579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181589 */     // MIs[0] Op2
     /* 181589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 181597 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 181597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 181600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181606 */     GIR_RootConstrainSelectedInstOperands,
     /* 181607 */     // GIR_Coverage, 3040,
     /* 181607 */     GIR_EraseRootFromParent_Done,
     /* 181608 */   // Label 3348: @181608
     /* 181608 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(181650), // Rule ID 3074 //
     /* 181613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181631 */     // MIs[0] Op2
     /* 181631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 181639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 181639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 181642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181648 */     GIR_RootConstrainSelectedInstOperands,
     /* 181649 */     // GIR_Coverage, 3074,
     /* 181649 */     GIR_EraseRootFromParent_Done,
     /* 181650 */   // Label 3349: @181650
     /* 181650 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(181692), // Rule ID 3075 //
     /* 181655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181673 */     // MIs[0] Op2
     /* 181673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 181681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 181681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181690 */     GIR_RootConstrainSelectedInstOperands,
     /* 181691 */     // GIR_Coverage, 3075,
     /* 181691 */     GIR_EraseRootFromParent_Done,
     /* 181692 */   // Label 3350: @181692
     /* 181692 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(181734), // Rule ID 3076 //
     /* 181697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 181700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 181705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181715 */     // MIs[0] Op2
     /* 181715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 181723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 181723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 181726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181732 */     GIR_RootConstrainSelectedInstOperands,
     /* 181733 */     // GIR_Coverage, 3076,
     /* 181733 */     GIR_EraseRootFromParent_Done,
     /* 181734 */   // Label 3351: @181734
     /* 181734 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(181776), // Rule ID 3523 //
     /* 181739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181757 */     // MIs[0] Op2
     /* 181757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 181765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 181765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 181768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181774 */     GIR_RootConstrainSelectedInstOperands,
     /* 181775 */     // GIR_Coverage, 3523,
     /* 181775 */     GIR_EraseRootFromParent_Done,
     /* 181776 */   // Label 3352: @181776
     /* 181776 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(181818), // Rule ID 3524 //
     /* 181781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181799 */     // MIs[0] Op2
     /* 181799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 181807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 181807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 181810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181816 */     GIR_RootConstrainSelectedInstOperands,
     /* 181817 */     // GIR_Coverage, 3524,
     /* 181817 */     GIR_EraseRootFromParent_Done,
     /* 181818 */   // Label 3353: @181818
     /* 181818 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(181860), // Rule ID 3525 //
     /* 181823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181841 */     // MIs[0] Op2
     /* 181841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 181849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 181849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 181852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181858 */     GIR_RootConstrainSelectedInstOperands,
     /* 181859 */     // GIR_Coverage, 3525,
     /* 181859 */     GIR_EraseRootFromParent_Done,
     /* 181860 */   // Label 3354: @181860
     /* 181860 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(181902), // Rule ID 3526 //
     /* 181865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181883 */     // MIs[0] Op2
     /* 181883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 181891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 181891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 181894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181900 */     GIR_RootConstrainSelectedInstOperands,
     /* 181901 */     // GIR_Coverage, 3526,
     /* 181901 */     GIR_EraseRootFromParent_Done,
     /* 181902 */   // Label 3355: @181902
     /* 181902 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(181944), // Rule ID 3527 //
     /* 181907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181925 */     // MIs[0] Op2
     /* 181925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 181933 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 181933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 181936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181942 */     GIR_RootConstrainSelectedInstOperands,
     /* 181943 */     // GIR_Coverage, 3527,
     /* 181943 */     GIR_EraseRootFromParent_Done,
     /* 181944 */   // Label 3356: @181944
     /* 181944 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(181986), // Rule ID 3528 //
     /* 181949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181967 */     // MIs[0] Op2
     /* 181967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 181975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 181975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 181978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181984 */     GIR_RootConstrainSelectedInstOperands,
     /* 181985 */     // GIR_Coverage, 3528,
     /* 181985 */     GIR_EraseRootFromParent_Done,
     /* 181986 */   // Label 3357: @181986
     /* 181986 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182028), // Rule ID 3529 //
     /* 181991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 181999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182009 */     // MIs[0] Op2
     /* 182009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 182017 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 182017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 182020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182026 */     GIR_RootConstrainSelectedInstOperands,
     /* 182027 */     // GIR_Coverage, 3529,
     /* 182027 */     GIR_EraseRootFromParent_Done,
     /* 182028 */   // Label 3358: @182028
     /* 182028 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182070), // Rule ID 11809 //
     /* 182033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182051 */     // MIs[0] Op2
     /* 182051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 182062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182068 */     GIR_RootConstrainSelectedInstOperands,
     /* 182069 */     // GIR_Coverage, 11809,
     /* 182069 */     GIR_EraseRootFromParent_Done,
     /* 182070 */   // Label 3359: @182070
     /* 182070 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182112), // Rule ID 11810 //
     /* 182075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182093 */     // MIs[0] Op2
     /* 182093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 182104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182110 */     GIR_RootConstrainSelectedInstOperands,
     /* 182111 */     // GIR_Coverage, 11810,
     /* 182111 */     GIR_EraseRootFromParent_Done,
     /* 182112 */   // Label 3360: @182112
     /* 182112 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(182154), // Rule ID 11811 //
     /* 182117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 182125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182135 */     // MIs[0] Op2
     /* 182135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 182146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182152 */     GIR_RootConstrainSelectedInstOperands,
     /* 182153 */     // GIR_Coverage, 11811,
     /* 182153 */     GIR_EraseRootFromParent_Done,
     /* 182154 */   // Label 3361: @182154
     /* 182154 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(182196), // Rule ID 11812 //
     /* 182159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182177 */     // MIs[0] Op2
     /* 182177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 182188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182194 */     GIR_RootConstrainSelectedInstOperands,
     /* 182195 */     // GIR_Coverage, 11812,
     /* 182195 */     GIR_EraseRootFromParent_Done,
     /* 182196 */   // Label 3362: @182196
     /* 182196 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(182238), // Rule ID 11813 //
     /* 182201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182219 */     // MIs[0] Op2
     /* 182219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 182230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182236 */     GIR_RootConstrainSelectedInstOperands,
     /* 182237 */     // GIR_Coverage, 11813,
     /* 182237 */     GIR_EraseRootFromParent_Done,
     /* 182238 */   // Label 3363: @182238
     /* 182238 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(182280), // Rule ID 11814 //
     /* 182243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 182251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182261 */     // MIs[0] Op2
     /* 182261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 182272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182278 */     GIR_RootConstrainSelectedInstOperands,
     /* 182279 */     // GIR_Coverage, 11814,
     /* 182279 */     GIR_EraseRootFromParent_Done,
     /* 182280 */   // Label 3364: @182280
     /* 182280 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(182322), // Rule ID 11816 //
     /* 182285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182303 */     // MIs[0] Op2
     /* 182303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 182314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182320 */     GIR_RootConstrainSelectedInstOperands,
     /* 182321 */     // GIR_Coverage, 11816,
     /* 182321 */     GIR_EraseRootFromParent_Done,
     /* 182322 */   // Label 3365: @182322
     /* 182322 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(182364), // Rule ID 11818 //
     /* 182327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182345 */     // MIs[0] Op2
     /* 182345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 182356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182362 */     GIR_RootConstrainSelectedInstOperands,
     /* 182363 */     // GIR_Coverage, 11818,
     /* 182363 */     GIR_EraseRootFromParent_Done,
     /* 182364 */   // Label 3366: @182364
     /* 182364 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(182406), // Rule ID 11820 //
     /* 182369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 182377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182387 */     // MIs[0] Op2
     /* 182387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 182398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182404 */     GIR_RootConstrainSelectedInstOperands,
     /* 182405 */     // GIR_Coverage, 11820,
     /* 182405 */     GIR_EraseRootFromParent_Done,
     /* 182406 */   // Label 3367: @182406
     /* 182406 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(182448), // Rule ID 11821 //
     /* 182411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182429 */     // MIs[0] Op2
     /* 182429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182446 */     GIR_RootConstrainSelectedInstOperands,
     /* 182447 */     // GIR_Coverage, 11821,
     /* 182447 */     GIR_EraseRootFromParent_Done,
     /* 182448 */   // Label 3368: @182448
     /* 182448 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(182490), // Rule ID 11822 //
     /* 182453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182471 */     // MIs[0] Op2
     /* 182471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 182482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182488 */     GIR_RootConstrainSelectedInstOperands,
     /* 182489 */     // GIR_Coverage, 11822,
     /* 182489 */     GIR_EraseRootFromParent_Done,
     /* 182490 */   // Label 3369: @182490
     /* 182490 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(182532), // Rule ID 11823 //
     /* 182495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 182503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182513 */     // MIs[0] Op2
     /* 182513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 182524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182530 */     GIR_RootConstrainSelectedInstOperands,
     /* 182531 */     // GIR_Coverage, 11823,
     /* 182531 */     GIR_EraseRootFromParent_Done,
     /* 182532 */   // Label 3370: @182532
     /* 182532 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(182574), // Rule ID 11824 //
     /* 182537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182555 */     // MIs[0] Op2
     /* 182555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 182566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182572 */     GIR_RootConstrainSelectedInstOperands,
     /* 182573 */     // GIR_Coverage, 11824,
     /* 182573 */     GIR_EraseRootFromParent_Done,
     /* 182574 */   // Label 3371: @182574
     /* 182574 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(182616), // Rule ID 11825 //
     /* 182579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182597 */     // MIs[0] Op2
     /* 182597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 182608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182614 */     GIR_RootConstrainSelectedInstOperands,
     /* 182615 */     // GIR_Coverage, 11825,
     /* 182615 */     GIR_EraseRootFromParent_Done,
     /* 182616 */   // Label 3372: @182616
     /* 182616 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(182658), // Rule ID 11826 //
     /* 182621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 182629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182639 */     // MIs[0] Op2
     /* 182639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 182650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182656 */     GIR_RootConstrainSelectedInstOperands,
     /* 182657 */     // GIR_Coverage, 11826,
     /* 182657 */     GIR_EraseRootFromParent_Done,
     /* 182658 */   // Label 3373: @182658
     /* 182658 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(182700), // Rule ID 11827 //
     /* 182663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182681 */     // MIs[0] Op2
     /* 182681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 182692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182698 */     GIR_RootConstrainSelectedInstOperands,
     /* 182699 */     // GIR_Coverage, 11827,
     /* 182699 */     GIR_EraseRootFromParent_Done,
     /* 182700 */   // Label 3374: @182700
     /* 182700 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(182742), // Rule ID 11828 //
     /* 182705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182723 */     // MIs[0] Op2
     /* 182723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 182734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182740 */     GIR_RootConstrainSelectedInstOperands,
     /* 182741 */     // GIR_Coverage, 11828,
     /* 182741 */     GIR_EraseRootFromParent_Done,
     /* 182742 */   // Label 3375: @182742
     /* 182742 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(182784), // Rule ID 11829 //
     /* 182747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 182755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182765 */     // MIs[0] Op2
     /* 182765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 182776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182782 */     GIR_RootConstrainSelectedInstOperands,
     /* 182783 */     // GIR_Coverage, 11829,
     /* 182783 */     GIR_EraseRootFromParent_Done,
     /* 182784 */   // Label 3376: @182784
     /* 182784 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(182826), // Rule ID 11830 //
     /* 182789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 182800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182807 */     // MIs[0] Op2
     /* 182807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 182815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2042:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 182815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 182818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182824 */     GIR_RootConstrainSelectedInstOperands,
     /* 182825 */     // GIR_Coverage, 11830,
     /* 182825 */     GIR_EraseRootFromParent_Done,
     /* 182826 */   // Label 3377: @182826
     /* 182826 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(182868), // Rule ID 11831 //
     /* 182831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182849 */     // MIs[0] Op2
     /* 182849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 182857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2042:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 182857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 182860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182866 */     GIR_RootConstrainSelectedInstOperands,
     /* 182867 */     // GIR_Coverage, 11831,
     /* 182867 */     GIR_EraseRootFromParent_Done,
     /* 182868 */   // Label 3378: @182868
     /* 182868 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(182910), // Rule ID 11832 //
     /* 182873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 182881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182891 */     // MIs[0] Op2
     /* 182891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 182899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2042:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 182899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 182902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182908 */     GIR_RootConstrainSelectedInstOperands,
     /* 182909 */     // GIR_Coverage, 11832,
     /* 182909 */     GIR_EraseRootFromParent_Done,
     /* 182910 */   // Label 3379: @182910
     /* 182910 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(182952), // Rule ID 11890 //
     /* 182915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 182923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182933 */     // MIs[0] Op2
     /* 182933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 182941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 182941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 182944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182950 */     GIR_RootConstrainSelectedInstOperands,
     /* 182951 */     // GIR_Coverage, 11890,
     /* 182951 */     GIR_EraseRootFromParent_Done,
     /* 182952 */   // Label 3380: @182952
     /* 182952 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(182994), // Rule ID 11891 //
     /* 182957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 182965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182975 */     // MIs[0] Op2
     /* 182975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 182983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 182983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 182986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182992 */     GIR_RootConstrainSelectedInstOperands,
     /* 182993 */     // GIR_Coverage, 11891,
     /* 182993 */     GIR_EraseRootFromParent_Done,
     /* 182994 */   // Label 3381: @182994
     /* 182994 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183036), // Rule ID 11892 //
     /* 182999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 183007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183017 */     // MIs[0] Op2
     /* 183017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 183028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183034 */     GIR_RootConstrainSelectedInstOperands,
     /* 183035 */     // GIR_Coverage, 11892,
     /* 183035 */     GIR_EraseRootFromParent_Done,
     /* 183036 */   // Label 3382: @183036
     /* 183036 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(183078), // Rule ID 11893 //
     /* 183041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183059 */     // MIs[0] Op2
     /* 183059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 183070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183076 */     GIR_RootConstrainSelectedInstOperands,
     /* 183077 */     // GIR_Coverage, 11893,
     /* 183077 */     GIR_EraseRootFromParent_Done,
     /* 183078 */   // Label 3383: @183078
     /* 183078 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(183120), // Rule ID 11894 //
     /* 183083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183101 */     // MIs[0] Op2
     /* 183101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 183112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183118 */     GIR_RootConstrainSelectedInstOperands,
     /* 183119 */     // GIR_Coverage, 11894,
     /* 183119 */     GIR_EraseRootFromParent_Done,
     /* 183120 */   // Label 3384: @183120
     /* 183120 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(183162), // Rule ID 11895 //
     /* 183125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 183133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183143 */     // MIs[0] Op2
     /* 183143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 183154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183160 */     GIR_RootConstrainSelectedInstOperands,
     /* 183161 */     // GIR_Coverage, 11895,
     /* 183161 */     GIR_EraseRootFromParent_Done,
     /* 183162 */   // Label 3385: @183162
     /* 183162 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(183204), // Rule ID 11896 //
     /* 183167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183185 */     // MIs[0] Op2
     /* 183185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 183196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183202 */     GIR_RootConstrainSelectedInstOperands,
     /* 183203 */     // GIR_Coverage, 11896,
     /* 183203 */     GIR_EraseRootFromParent_Done,
     /* 183204 */   // Label 3386: @183204
     /* 183204 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(183246), // Rule ID 11897 //
     /* 183209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183227 */     // MIs[0] Op2
     /* 183227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 183238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183244 */     GIR_RootConstrainSelectedInstOperands,
     /* 183245 */     // GIR_Coverage, 11897,
     /* 183245 */     GIR_EraseRootFromParent_Done,
     /* 183246 */   // Label 3387: @183246
     /* 183246 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(183288), // Rule ID 11898 //
     /* 183251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 183259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183269 */     // MIs[0] Op2
     /* 183269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 183280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183286 */     GIR_RootConstrainSelectedInstOperands,
     /* 183287 */     // GIR_Coverage, 11898,
     /* 183287 */     GIR_EraseRootFromParent_Done,
     /* 183288 */   // Label 3388: @183288
     /* 183288 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(183340), // Rule ID 2132 //
     /* 183293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183326 */     // MIs[1] Operand 1
     /* 183326 */     // No operand predicates
     /* 183326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183328 */     // (intrinsic_wo_chain:{ *:[v4i16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 183331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 2132,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3389: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(183392), // Rule ID 2133 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183378 */     // MIs[1] Operand 1
     /* 183378 */     // No operand predicates
     /* 183378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183380 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 183383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183390 */     GIR_RootConstrainSelectedInstOperands,
     /* 183391 */     // GIR_Coverage, 2133,
     /* 183391 */     GIR_EraseRootFromParent_Done,
     /* 183392 */   // Label 3390: @183392
     /* 183392 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(183444), // Rule ID 2134 //
     /* 183397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183430 */     // MIs[1] Operand 1
     /* 183430 */     // No operand predicates
     /* 183430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183432 */     // (intrinsic_wo_chain:{ *:[v2i32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183442 */     GIR_RootConstrainSelectedInstOperands,
     /* 183443 */     // GIR_Coverage, 2134,
     /* 183443 */     GIR_EraseRootFromParent_Done,
     /* 183444 */   // Label 3391: @183444
     /* 183444 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(183496), // Rule ID 2135 //
     /* 183449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183482 */     // MIs[1] Operand 1
     /* 183482 */     // No operand predicates
     /* 183482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 183487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183494 */     GIR_RootConstrainSelectedInstOperands,
     /* 183495 */     // GIR_Coverage, 2135,
     /* 183495 */     GIR_EraseRootFromParent_Done,
     /* 183496 */   // Label 3392: @183496
     /* 183496 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(183548), // Rule ID 2136 //
     /* 183501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183534 */     // MIs[1] Operand 1
     /* 183534 */     // No operand predicates
     /* 183534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183536 */     // (intrinsic_wo_chain:{ *:[v2i64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 183539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183546 */     GIR_RootConstrainSelectedInstOperands,
     /* 183547 */     // GIR_Coverage, 2136,
     /* 183547 */     GIR_EraseRootFromParent_Done,
     /* 183548 */   // Label 3393: @183548
     /* 183548 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(183600), // Rule ID 2137 //
     /* 183553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183586 */     // MIs[1] Operand 1
     /* 183586 */     // No operand predicates
     /* 183586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183588 */     // (intrinsic_wo_chain:{ *:[v4i16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 183591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183598 */     GIR_RootConstrainSelectedInstOperands,
     /* 183599 */     // GIR_Coverage, 2137,
     /* 183599 */     GIR_EraseRootFromParent_Done,
     /* 183600 */   // Label 3394: @183600
     /* 183600 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(183652), // Rule ID 2138 //
     /* 183605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183638 */     // MIs[1] Operand 1
     /* 183638 */     // No operand predicates
     /* 183638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183640 */     // (intrinsic_wo_chain:{ *:[v8i16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 183643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183650 */     GIR_RootConstrainSelectedInstOperands,
     /* 183651 */     // GIR_Coverage, 2138,
     /* 183651 */     GIR_EraseRootFromParent_Done,
     /* 183652 */   // Label 3395: @183652
     /* 183652 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(183704), // Rule ID 2139 //
     /* 183657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183690 */     // MIs[1] Operand 1
     /* 183690 */     // No operand predicates
     /* 183690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183692 */     // (intrinsic_wo_chain:{ *:[v2i32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 183695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183702 */     GIR_RootConstrainSelectedInstOperands,
     /* 183703 */     // GIR_Coverage, 2139,
     /* 183703 */     GIR_EraseRootFromParent_Done,
     /* 183704 */   // Label 3396: @183704
     /* 183704 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(183756), // Rule ID 2140 //
     /* 183709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183742 */     // MIs[1] Operand 1
     /* 183742 */     // No operand predicates
     /* 183742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 183747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183754 */     GIR_RootConstrainSelectedInstOperands,
     /* 183755 */     // GIR_Coverage, 2140,
     /* 183755 */     GIR_EraseRootFromParent_Done,
     /* 183756 */   // Label 3397: @183756
     /* 183756 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(183808), // Rule ID 2141 //
     /* 183761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 183772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183794 */     // MIs[1] Operand 1
     /* 183794 */     // No operand predicates
     /* 183794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 183799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183806 */     GIR_RootConstrainSelectedInstOperands,
     /* 183807 */     // GIR_Coverage, 2141,
     /* 183807 */     GIR_EraseRootFromParent_Done,
     /* 183808 */   // Label 3398: @183808
     /* 183808 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(183860), // Rule ID 2142 //
     /* 183813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 183824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 183827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183846 */     // MIs[1] Operand 1
     /* 183846 */     // No operand predicates
     /* 183846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183848 */     // (intrinsic_wo_chain:{ *:[v4f16] } 772:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 183851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183858 */     GIR_RootConstrainSelectedInstOperands,
     /* 183859 */     // GIR_Coverage, 2142,
     /* 183859 */     GIR_EraseRootFromParent_Done,
     /* 183860 */   // Label 3399: @183860
     /* 183860 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(183912), // Rule ID 2143 //
     /* 183865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 183868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 183876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183898 */     // MIs[1] Operand 1
     /* 183898 */     // No operand predicates
     /* 183898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183900 */     // (intrinsic_wo_chain:{ *:[v8f16] } 772:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 183903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183910 */     GIR_RootConstrainSelectedInstOperands,
     /* 183911 */     // GIR_Coverage, 2143,
     /* 183911 */     GIR_EraseRootFromParent_Done,
     /* 183912 */   // Label 3400: @183912
     /* 183912 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(183964), // Rule ID 2144 //
     /* 183917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 183928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 183931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183950 */     // MIs[1] Operand 1
     /* 183950 */     // No operand predicates
     /* 183950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 772:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 183952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 183955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183962 */     GIR_RootConstrainSelectedInstOperands,
     /* 183963 */     // GIR_Coverage, 2144,
     /* 183963 */     GIR_EraseRootFromParent_Done,
     /* 183964 */   // Label 3401: @183964
     /* 183964 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184016), // Rule ID 2145 //
     /* 183969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 183977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 183980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184002 */     // MIs[1] Operand 1
     /* 184002 */     // No operand predicates
     /* 184002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184004 */     // (intrinsic_wo_chain:{ *:[v4f32] } 772:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 184007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184014 */     GIR_RootConstrainSelectedInstOperands,
     /* 184015 */     // GIR_Coverage, 2145,
     /* 184015 */     GIR_EraseRootFromParent_Done,
     /* 184016 */   // Label 3402: @184016
     /* 184016 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184068), // Rule ID 2146 //
     /* 184021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 184029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184054 */     // MIs[1] Operand 1
     /* 184054 */     // No operand predicates
     /* 184054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184056 */     // (intrinsic_wo_chain:{ *:[v2f64] } 772:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 184059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184066 */     GIR_RootConstrainSelectedInstOperands,
     /* 184067 */     // GIR_Coverage, 2146,
     /* 184067 */     GIR_EraseRootFromParent_Done,
     /* 184068 */   // Label 3403: @184068
     /* 184068 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184120), // Rule ID 2244 //
     /* 184073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184106 */     // MIs[1] Operand 1
     /* 184106 */     // No operand predicates
     /* 184106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184108 */     // (intrinsic_wo_chain:{ *:[v4f16] } 773:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 184111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184118 */     GIR_RootConstrainSelectedInstOperands,
     /* 184119 */     // GIR_Coverage, 2244,
     /* 184119 */     GIR_EraseRootFromParent_Done,
     /* 184120 */   // Label 3404: @184120
     /* 184120 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184172), // Rule ID 2245 //
     /* 184125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184158 */     // MIs[1] Operand 1
     /* 184158 */     // No operand predicates
     /* 184158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184160 */     // (intrinsic_wo_chain:{ *:[v8f16] } 773:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 184163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184170 */     GIR_RootConstrainSelectedInstOperands,
     /* 184171 */     // GIR_Coverage, 2245,
     /* 184171 */     GIR_EraseRootFromParent_Done,
     /* 184172 */   // Label 3405: @184172
     /* 184172 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184224), // Rule ID 2246 //
     /* 184177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184210 */     // MIs[1] Operand 1
     /* 184210 */     // No operand predicates
     /* 184210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184212 */     // (intrinsic_wo_chain:{ *:[v2f32] } 773:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 184215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184222 */     GIR_RootConstrainSelectedInstOperands,
     /* 184223 */     // GIR_Coverage, 2246,
     /* 184223 */     GIR_EraseRootFromParent_Done,
     /* 184224 */   // Label 3406: @184224
     /* 184224 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(184276), // Rule ID 2247 //
     /* 184229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184262 */     // MIs[1] Operand 1
     /* 184262 */     // No operand predicates
     /* 184262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184264 */     // (intrinsic_wo_chain:{ *:[v4f32] } 773:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 184267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184274 */     GIR_RootConstrainSelectedInstOperands,
     /* 184275 */     // GIR_Coverage, 2247,
     /* 184275 */     GIR_EraseRootFromParent_Done,
     /* 184276 */   // Label 3407: @184276
     /* 184276 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(184328), // Rule ID 2248 //
     /* 184281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 184289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184314 */     // MIs[1] Operand 1
     /* 184314 */     // No operand predicates
     /* 184314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184316 */     // (intrinsic_wo_chain:{ *:[v2f64] } 773:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 184319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184326 */     GIR_RootConstrainSelectedInstOperands,
     /* 184327 */     // GIR_Coverage, 2248,
     /* 184327 */     GIR_EraseRootFromParent_Done,
     /* 184328 */   // Label 3408: @184328
     /* 184328 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(184373), // Rule ID 63 //
     /* 184333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 184336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 184341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184362 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 184362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 184365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184371 */     GIR_RootConstrainSelectedInstOperands,
     /* 184372 */     // GIR_Coverage, 63,
     /* 184372 */     GIR_EraseRootFromParent_Done,
     /* 184373 */   // Label 3409: @184373
     /* 184373 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(184418), // Rule ID 129 //
     /* 184378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 184386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184407 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 184410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184416 */     GIR_RootConstrainSelectedInstOperands,
     /* 184417 */     // GIR_Coverage, 129,
     /* 184417 */     GIR_EraseRootFromParent_Done,
     /* 184418 */   // Label 3410: @184418
     /* 184418 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(184463), // Rule ID 130 //
     /* 184423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 184431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184452 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 184455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184461 */     GIR_RootConstrainSelectedInstOperands,
     /* 184462 */     // GIR_Coverage, 130,
     /* 184462 */     GIR_EraseRootFromParent_Done,
     /* 184463 */   // Label 3411: @184463
     /* 184463 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(184508), // Rule ID 131 //
     /* 184468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 184476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184497 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 184500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184506 */     GIR_RootConstrainSelectedInstOperands,
     /* 184507 */     // GIR_Coverage, 131,
     /* 184507 */     GIR_EraseRootFromParent_Done,
     /* 184508 */   // Label 3412: @184508
     /* 184508 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(184553), // Rule ID 132 //
     /* 184513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 184521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184542 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184551 */     GIR_RootConstrainSelectedInstOperands,
     /* 184552 */     // GIR_Coverage, 132,
     /* 184552 */     GIR_EraseRootFromParent_Done,
     /* 184553 */   // Label 3413: @184553
     /* 184553 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(184598), // Rule ID 133 //
     /* 184558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 184566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184587 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184596 */     GIR_RootConstrainSelectedInstOperands,
     /* 184597 */     // GIR_Coverage, 133,
     /* 184597 */     GIR_EraseRootFromParent_Done,
     /* 184598 */   // Label 3414: @184598
     /* 184598 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(184643), // Rule ID 134 //
     /* 184603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 184611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184632 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 184635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184641 */     GIR_RootConstrainSelectedInstOperands,
     /* 184642 */     // GIR_Coverage, 134,
     /* 184642 */     GIR_EraseRootFromParent_Done,
     /* 184643 */   // Label 3415: @184643
     /* 184643 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(184688), // Rule ID 135 //
     /* 184648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 184656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184677 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 184677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 184680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184686 */     GIR_RootConstrainSelectedInstOperands,
     /* 184687 */     // GIR_Coverage, 135,
     /* 184687 */     GIR_EraseRootFromParent_Done,
     /* 184688 */   // Label 3416: @184688
     /* 184688 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(184733), // Rule ID 136 //
     /* 184693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 184696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 184701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184722 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 184725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184731 */     GIR_RootConstrainSelectedInstOperands,
     /* 184732 */     // GIR_Coverage, 136,
     /* 184732 */     GIR_EraseRootFromParent_Done,
     /* 184733 */   // Label 3417: @184733
     /* 184733 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(184778), // Rule ID 1042 //
     /* 184738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 184749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 184752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 184755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184767 */     // (intrinsic_wo_chain:{ *:[v8i8] } 722:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 184767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 184770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184776 */     GIR_RootConstrainSelectedInstOperands,
     /* 184777 */     // GIR_Coverage, 1042,
     /* 184777 */     GIR_EraseRootFromParent_Done,
     /* 184778 */   // Label 3418: @184778
     /* 184778 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(184823), // Rule ID 1043 //
     /* 184783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 184794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 184800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184812 */     // (intrinsic_wo_chain:{ *:[v16i8] } 722:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 184812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 184815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184821 */     GIR_RootConstrainSelectedInstOperands,
     /* 184822 */     // GIR_Coverage, 1043,
     /* 184822 */     GIR_EraseRootFromParent_Done,
     /* 184823 */   // Label 3419: @184823
     /* 184823 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(184868), // Rule ID 1044 //
     /* 184828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 184845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184857 */     // (intrinsic_wo_chain:{ *:[v4i16] } 722:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 184857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 184860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184866 */     GIR_RootConstrainSelectedInstOperands,
     /* 184867 */     // GIR_Coverage, 1044,
     /* 184867 */     GIR_EraseRootFromParent_Done,
     /* 184868 */   // Label 3420: @184868
     /* 184868 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(184913), // Rule ID 1045 //
     /* 184873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 184890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184902 */     // (intrinsic_wo_chain:{ *:[v8i16] } 722:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 184902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 184905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184911 */     GIR_RootConstrainSelectedInstOperands,
     /* 184912 */     // GIR_Coverage, 1045,
     /* 184912 */     GIR_EraseRootFromParent_Done,
     /* 184913 */   // Label 3421: @184913
     /* 184913 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(184958), // Rule ID 1046 //
     /* 184918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 184935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184947 */     // (intrinsic_wo_chain:{ *:[v2i32] } 722:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 184947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 184950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 184956 */     GIR_RootConstrainSelectedInstOperands,
     /* 184957 */     // GIR_Coverage, 1046,
     /* 184957 */     GIR_EraseRootFromParent_Done,
     /* 184958 */   // Label 3422: @184958
     /* 184958 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185003), // Rule ID 1047 //
     /* 184963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 184971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 184980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184992 */     // (intrinsic_wo_chain:{ *:[v4i32] } 722:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 184992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 184995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 184999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185001 */     GIR_RootConstrainSelectedInstOperands,
     /* 185002 */     // GIR_Coverage, 1047,
     /* 185002 */     GIR_EraseRootFromParent_Done,
     /* 185003 */   // Label 3423: @185003
     /* 185003 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185048), // Rule ID 1048 //
     /* 185008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 185016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185037 */     // (intrinsic_wo_chain:{ *:[v2i64] } 722:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 185037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 185040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185046 */     GIR_RootConstrainSelectedInstOperands,
     /* 185047 */     // GIR_Coverage, 1048,
     /* 185047 */     GIR_EraseRootFromParent_Done,
     /* 185048 */   // Label 3424: @185048
     /* 185048 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185093), // Rule ID 1090 //
     /* 185053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 185064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 185067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 185070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185082 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 185082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 185085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185091 */     GIR_RootConstrainSelectedInstOperands,
     /* 185092 */     // GIR_Coverage, 1090,
     /* 185092 */     GIR_EraseRootFromParent_Done,
     /* 185093 */   // Label 3425: @185093
     /* 185093 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185138), // Rule ID 1091 //
     /* 185098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 185109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 185112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 185127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 185130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185136 */     GIR_RootConstrainSelectedInstOperands,
     /* 185137 */     // GIR_Coverage, 1091,
     /* 185137 */     GIR_EraseRootFromParent_Done,
     /* 185138 */   // Label 3426: @185138
     /* 185138 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(185183), // Rule ID 1092 //
     /* 185143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185172 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185181 */     GIR_RootConstrainSelectedInstOperands,
     /* 185182 */     // GIR_Coverage, 1092,
     /* 185182 */     GIR_EraseRootFromParent_Done,
     /* 185183 */   // Label 3427: @185183
     /* 185183 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(185228), // Rule ID 1093 //
     /* 185188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185217 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 185217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 185220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185226 */     GIR_RootConstrainSelectedInstOperands,
     /* 185227 */     // GIR_Coverage, 1093,
     /* 185227 */     GIR_EraseRootFromParent_Done,
     /* 185228 */   // Label 3428: @185228
     /* 185228 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(185273), // Rule ID 1094 //
     /* 185233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185262 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 185262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 185265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185271 */     GIR_RootConstrainSelectedInstOperands,
     /* 185272 */     // GIR_Coverage, 1094,
     /* 185272 */     GIR_EraseRootFromParent_Done,
     /* 185273 */   // Label 3429: @185273
     /* 185273 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(185318), // Rule ID 1095 //
     /* 185278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185307 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 185307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 185310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185316 */     GIR_RootConstrainSelectedInstOperands,
     /* 185317 */     // GIR_Coverage, 1095,
     /* 185317 */     GIR_EraseRootFromParent_Done,
     /* 185318 */   // Label 3430: @185318
     /* 185318 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(185363), // Rule ID 1096 //
     /* 185323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 185331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 185352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 185355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 185359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 185361 */     GIR_RootConstrainSelectedInstOperands,
     /* 185362 */     // GIR_Coverage, 1096,
     /* 185362 */     GIR_EraseRootFromParent_Done,
     /* 185363 */   // Label 3431: @185363
     /* 185363 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(185408), // Rule ID 1108 //
     /* 185368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 185379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 185382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 185385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185397 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 185397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 185400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185406 */     GIR_RootConstrainSelectedInstOperands,
     /* 185407 */     // GIR_Coverage, 1108,
     /* 185407 */     GIR_EraseRootFromParent_Done,
     /* 185408 */   // Label 3432: @185408
     /* 185408 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(185453), // Rule ID 1110 //
     /* 185413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 185424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 185427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 185430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185442 */     // (intrinsic_wo_chain:{ *:[v16i8] } 577:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 185442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 185445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185451 */     GIR_RootConstrainSelectedInstOperands,
     /* 185452 */     // GIR_Coverage, 1110,
     /* 185452 */     GIR_EraseRootFromParent_Done,
     /* 185453 */   // Label 3433: @185453
     /* 185453 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(185498), // Rule ID 1112 //
     /* 185458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185487 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 185487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185496 */     GIR_RootConstrainSelectedInstOperands,
     /* 185497 */     // GIR_Coverage, 1112,
     /* 185497 */     GIR_EraseRootFromParent_Done,
     /* 185498 */   // Label 3434: @185498
     /* 185498 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(185543), // Rule ID 1114 //
     /* 185503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 185532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 185535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185541 */     GIR_RootConstrainSelectedInstOperands,
     /* 185542 */     // GIR_Coverage, 1114,
     /* 185542 */     GIR_EraseRootFromParent_Done,
     /* 185543 */   // Label 3435: @185543
     /* 185543 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(185588), // Rule ID 1116 //
     /* 185548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185577 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 185577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 185580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185586 */     GIR_RootConstrainSelectedInstOperands,
     /* 185587 */     // GIR_Coverage, 1116,
     /* 185587 */     GIR_EraseRootFromParent_Done,
     /* 185588 */   // Label 3436: @185588
     /* 185588 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(185633), // Rule ID 1118 //
     /* 185593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185622 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 185622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 185625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185631 */     GIR_RootConstrainSelectedInstOperands,
     /* 185632 */     // GIR_Coverage, 1118,
     /* 185632 */     GIR_EraseRootFromParent_Done,
     /* 185633 */   // Label 3437: @185633
     /* 185633 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(185678), // Rule ID 1120 //
     /* 185638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 185646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185667 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 185667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 185670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185676 */     GIR_RootConstrainSelectedInstOperands,
     /* 185677 */     // GIR_Coverage, 1120,
     /* 185677 */     GIR_EraseRootFromParent_Done,
     /* 185678 */   // Label 3438: @185678
     /* 185678 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(185723), // Rule ID 1163 //
     /* 185683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185712 */     // (intrinsic_wo_chain:{ *:[v4f16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 185712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 185715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185721 */     GIR_RootConstrainSelectedInstOperands,
     /* 185722 */     // GIR_Coverage, 1163,
     /* 185722 */     GIR_EraseRootFromParent_Done,
     /* 185723 */   // Label 3439: @185723
     /* 185723 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(185768), // Rule ID 1164 //
     /* 185728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185757 */     // (intrinsic_wo_chain:{ *:[v8f16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 185757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 185760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185766 */     GIR_RootConstrainSelectedInstOperands,
     /* 185767 */     // GIR_Coverage, 1164,
     /* 185767 */     GIR_EraseRootFromParent_Done,
     /* 185768 */   // Label 3440: @185768
     /* 185768 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(185813), // Rule ID 1165 //
     /* 185773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 185790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185802 */     // (intrinsic_wo_chain:{ *:[v2f32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 185802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 185805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185811 */     GIR_RootConstrainSelectedInstOperands,
     /* 185812 */     // GIR_Coverage, 1165,
     /* 185812 */     GIR_EraseRootFromParent_Done,
     /* 185813 */   // Label 3441: @185813
     /* 185813 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(185858), // Rule ID 1166 //
     /* 185818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 185835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185847 */     // (intrinsic_wo_chain:{ *:[v4f32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 185847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 185850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185856 */     GIR_RootConstrainSelectedInstOperands,
     /* 185857 */     // GIR_Coverage, 1166,
     /* 185857 */     GIR_EraseRootFromParent_Done,
     /* 185858 */   // Label 3442: @185858
     /* 185858 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(185903), // Rule ID 1167 //
     /* 185863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 185871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 185880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185892 */     // (intrinsic_wo_chain:{ *:[v2f64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 185892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185901 */     GIR_RootConstrainSelectedInstOperands,
     /* 185902 */     // GIR_Coverage, 1167,
     /* 185902 */     GIR_EraseRootFromParent_Done,
     /* 185903 */   // Label 3443: @185903
     /* 185903 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(185948), // Rule ID 1169 //
     /* 185908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 185925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185937 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 185937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 185940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185946 */     GIR_RootConstrainSelectedInstOperands,
     /* 185947 */     // GIR_Coverage, 1169,
     /* 185947 */     GIR_EraseRootFromParent_Done,
     /* 185948 */   // Label 3444: @185948
     /* 185948 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(185993), // Rule ID 1171 //
     /* 185953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 185961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 185970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185982 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 185982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 185985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185991 */     GIR_RootConstrainSelectedInstOperands,
     /* 185992 */     // GIR_Coverage, 1171,
     /* 185992 */     GIR_EraseRootFromParent_Done,
     /* 185993 */   // Label 3445: @185993
     /* 185993 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186038), // Rule ID 1173 //
     /* 185998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186027 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 186030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186036 */     GIR_RootConstrainSelectedInstOperands,
     /* 186037 */     // GIR_Coverage, 1173,
     /* 186037 */     GIR_EraseRootFromParent_Done,
     /* 186038 */   // Label 3446: @186038
     /* 186038 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186083), // Rule ID 1175 //
     /* 186043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186072 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 186075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186081 */     GIR_RootConstrainSelectedInstOperands,
     /* 186082 */     // GIR_Coverage, 1175,
     /* 186082 */     GIR_EraseRootFromParent_Done,
     /* 186083 */   // Label 3447: @186083
     /* 186083 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(186128), // Rule ID 1177 //
     /* 186088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 186096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186117 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 186120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186126 */     GIR_RootConstrainSelectedInstOperands,
     /* 186127 */     // GIR_Coverage, 1177,
     /* 186127 */     GIR_EraseRootFromParent_Done,
     /* 186128 */   // Label 3448: @186128
     /* 186128 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(186173), // Rule ID 1179 //
     /* 186133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186162 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 186165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186171 */     GIR_RootConstrainSelectedInstOperands,
     /* 186172 */     // GIR_Coverage, 1179,
     /* 186172 */     GIR_EraseRootFromParent_Done,
     /* 186173 */   // Label 3449: @186173
     /* 186173 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(186218), // Rule ID 1181 //
     /* 186178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 186210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186216 */     GIR_RootConstrainSelectedInstOperands,
     /* 186217 */     // GIR_Coverage, 1181,
     /* 186217 */     GIR_EraseRootFromParent_Done,
     /* 186218 */   // Label 3450: @186218
     /* 186218 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(186263), // Rule ID 1183 //
     /* 186223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 186255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186261 */     GIR_RootConstrainSelectedInstOperands,
     /* 186262 */     // GIR_Coverage, 1183,
     /* 186262 */     GIR_EraseRootFromParent_Done,
     /* 186263 */   // Label 3451: @186263
     /* 186263 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(186308), // Rule ID 1185 //
     /* 186268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 186300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186306 */     GIR_RootConstrainSelectedInstOperands,
     /* 186307 */     // GIR_Coverage, 1185,
     /* 186307 */     GIR_EraseRootFromParent_Done,
     /* 186308 */   // Label 3452: @186308
     /* 186308 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(186353), // Rule ID 1187 //
     /* 186313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 186321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186342 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 186345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186351 */     GIR_RootConstrainSelectedInstOperands,
     /* 186352 */     // GIR_Coverage, 1187,
     /* 186352 */     GIR_EraseRootFromParent_Done,
     /* 186353 */   // Label 3453: @186353
     /* 186353 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(186398), // Rule ID 1189 //
     /* 186358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186387 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 186390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186396 */     GIR_RootConstrainSelectedInstOperands,
     /* 186397 */     // GIR_Coverage, 1189,
     /* 186397 */     GIR_EraseRootFromParent_Done,
     /* 186398 */   // Label 3454: @186398
     /* 186398 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(186443), // Rule ID 1191 //
     /* 186403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186432 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 186435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186441 */     GIR_RootConstrainSelectedInstOperands,
     /* 186442 */     // GIR_Coverage, 1191,
     /* 186442 */     GIR_EraseRootFromParent_Done,
     /* 186443 */   // Label 3455: @186443
     /* 186443 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(186488), // Rule ID 1193 //
     /* 186448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186477 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 186480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186486 */     GIR_RootConstrainSelectedInstOperands,
     /* 186487 */     // GIR_Coverage, 1193,
     /* 186487 */     GIR_EraseRootFromParent_Done,
     /* 186488 */   // Label 3456: @186488
     /* 186488 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(186533), // Rule ID 1195 //
     /* 186493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186522 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 186525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186531 */     GIR_RootConstrainSelectedInstOperands,
     /* 186532 */     // GIR_Coverage, 1195,
     /* 186532 */     GIR_EraseRootFromParent_Done,
     /* 186533 */   // Label 3457: @186533
     /* 186533 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(186578), // Rule ID 1197 //
     /* 186538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 186546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186567 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 186570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186576 */     GIR_RootConstrainSelectedInstOperands,
     /* 186577 */     // GIR_Coverage, 1197,
     /* 186577 */     GIR_EraseRootFromParent_Done,
     /* 186578 */   // Label 3458: @186578
     /* 186578 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(186623), // Rule ID 1233 //
     /* 186583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186612 */     // (intrinsic_wo_chain:{ *:[v4f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 186615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186621 */     GIR_RootConstrainSelectedInstOperands,
     /* 186622 */     // GIR_Coverage, 1233,
     /* 186622 */     GIR_EraseRootFromParent_Done,
     /* 186623 */   // Label 3459: @186623
     /* 186623 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(186668), // Rule ID 1234 //
     /* 186628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186657 */     // (intrinsic_wo_chain:{ *:[v8f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 186660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186666 */     GIR_RootConstrainSelectedInstOperands,
     /* 186667 */     // GIR_Coverage, 1234,
     /* 186667 */     GIR_EraseRootFromParent_Done,
     /* 186668 */   // Label 3460: @186668
     /* 186668 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(186713), // Rule ID 1235 //
     /* 186673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186702 */     // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 186705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186711 */     GIR_RootConstrainSelectedInstOperands,
     /* 186712 */     // GIR_Coverage, 1235,
     /* 186712 */     GIR_EraseRootFromParent_Done,
     /* 186713 */   // Label 3461: @186713
     /* 186713 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(186758), // Rule ID 1236 //
     /* 186718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186747 */     // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 186750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186756 */     GIR_RootConstrainSelectedInstOperands,
     /* 186757 */     // GIR_Coverage, 1236,
     /* 186757 */     GIR_EraseRootFromParent_Done,
     /* 186758 */   // Label 3462: @186758
     /* 186758 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(186803), // Rule ID 1237 //
     /* 186763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 186771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186792 */     // (intrinsic_wo_chain:{ *:[v2f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 186792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 186795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186801 */     GIR_RootConstrainSelectedInstOperands,
     /* 186802 */     // GIR_Coverage, 1237,
     /* 186802 */     GIR_EraseRootFromParent_Done,
     /* 186803 */   // Label 3463: @186803
     /* 186803 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(186848), // Rule ID 1248 //
     /* 186808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 186837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186846 */     GIR_RootConstrainSelectedInstOperands,
     /* 186847 */     // GIR_Coverage, 1248,
     /* 186847 */     GIR_EraseRootFromParent_Done,
     /* 186848 */   // Label 3464: @186848
     /* 186848 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(186893), // Rule ID 1249 //
     /* 186853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 186882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 186885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186891 */     GIR_RootConstrainSelectedInstOperands,
     /* 186892 */     // GIR_Coverage, 1249,
     /* 186892 */     GIR_EraseRootFromParent_Done,
     /* 186893 */   // Label 3465: @186893
     /* 186893 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(186938), // Rule ID 1250 //
     /* 186898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186927 */     // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 186927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 186930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186936 */     GIR_RootConstrainSelectedInstOperands,
     /* 186937 */     // GIR_Coverage, 1250,
     /* 186937 */     GIR_EraseRootFromParent_Done,
     /* 186938 */   // Label 3466: @186938
     /* 186938 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(186983), // Rule ID 1251 //
     /* 186943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186972 */     // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 186972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 186975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186981 */     GIR_RootConstrainSelectedInstOperands,
     /* 186982 */     // GIR_Coverage, 1251,
     /* 186982 */     GIR_EraseRootFromParent_Done,
     /* 186983 */   // Label 3467: @186983
     /* 186983 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187028), // Rule ID 1252 //
     /* 186988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 186996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187017 */     // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 187020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187026 */     GIR_RootConstrainSelectedInstOperands,
     /* 187027 */     // GIR_Coverage, 1252,
     /* 187027 */     GIR_EraseRootFromParent_Done,
     /* 187028 */   // Label 3468: @187028
     /* 187028 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187073), // Rule ID 1263 //
     /* 187033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187062 */     // (intrinsic_wo_chain:{ *:[v4f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 187065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187071 */     GIR_RootConstrainSelectedInstOperands,
     /* 187072 */     // GIR_Coverage, 1263,
     /* 187072 */     GIR_EraseRootFromParent_Done,
     /* 187073 */   // Label 3469: @187073
     /* 187073 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187118), // Rule ID 1264 //
     /* 187078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187107 */     // (intrinsic_wo_chain:{ *:[v8f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 187110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187116 */     GIR_RootConstrainSelectedInstOperands,
     /* 187117 */     // GIR_Coverage, 1264,
     /* 187117 */     GIR_EraseRootFromParent_Done,
     /* 187118 */   // Label 3470: @187118
     /* 187118 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(187163), // Rule ID 1265 //
     /* 187123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187152 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 187155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187161 */     GIR_RootConstrainSelectedInstOperands,
     /* 187162 */     // GIR_Coverage, 1265,
     /* 187162 */     GIR_EraseRootFromParent_Done,
     /* 187163 */   // Label 3471: @187163
     /* 187163 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(187208), // Rule ID 1266 //
     /* 187168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187197 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 187200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187206 */     GIR_RootConstrainSelectedInstOperands,
     /* 187207 */     // GIR_Coverage, 1266,
     /* 187207 */     GIR_EraseRootFromParent_Done,
     /* 187208 */   // Label 3472: @187208
     /* 187208 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(187253), // Rule ID 1267 //
     /* 187213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 187221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187242 */     // (intrinsic_wo_chain:{ *:[v2f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 187245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187251 */     GIR_RootConstrainSelectedInstOperands,
     /* 187252 */     // GIR_Coverage, 1267,
     /* 187252 */     GIR_EraseRootFromParent_Done,
     /* 187253 */   // Label 3473: @187253
     /* 187253 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(187298), // Rule ID 1278 //
     /* 187258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187287 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 187290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187296 */     GIR_RootConstrainSelectedInstOperands,
     /* 187297 */     // GIR_Coverage, 1278,
     /* 187297 */     GIR_EraseRootFromParent_Done,
     /* 187298 */   // Label 3474: @187298
     /* 187298 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(187343), // Rule ID 1279 //
     /* 187303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187332 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 187335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187341 */     GIR_RootConstrainSelectedInstOperands,
     /* 187342 */     // GIR_Coverage, 1279,
     /* 187342 */     GIR_EraseRootFromParent_Done,
     /* 187343 */   // Label 3475: @187343
     /* 187343 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(187388), // Rule ID 1280 //
     /* 187348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187377 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 187380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187386 */     GIR_RootConstrainSelectedInstOperands,
     /* 187387 */     // GIR_Coverage, 1280,
     /* 187387 */     GIR_EraseRootFromParent_Done,
     /* 187388 */   // Label 3476: @187388
     /* 187388 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(187433), // Rule ID 1281 //
     /* 187393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187422 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 187425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187431 */     GIR_RootConstrainSelectedInstOperands,
     /* 187432 */     // GIR_Coverage, 1281,
     /* 187432 */     GIR_EraseRootFromParent_Done,
     /* 187433 */   // Label 3477: @187433
     /* 187433 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(187478), // Rule ID 1282 //
     /* 187438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 187446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187467 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 187470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187476 */     GIR_RootConstrainSelectedInstOperands,
     /* 187477 */     // GIR_Coverage, 1282,
     /* 187477 */     GIR_EraseRootFromParent_Done,
     /* 187478 */   // Label 3478: @187478
     /* 187478 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(187523), // Rule ID 1313 //
     /* 187483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187512 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 187515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187521 */     GIR_RootConstrainSelectedInstOperands,
     /* 187522 */     // GIR_Coverage, 1313,
     /* 187522 */     GIR_EraseRootFromParent_Done,
     /* 187523 */   // Label 3479: @187523
     /* 187523 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(187568), // Rule ID 1314 //
     /* 187528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187557 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 187560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187566 */     GIR_RootConstrainSelectedInstOperands,
     /* 187567 */     // GIR_Coverage, 1314,
     /* 187567 */     GIR_EraseRootFromParent_Done,
     /* 187568 */   // Label 3480: @187568
     /* 187568 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(187613), // Rule ID 1315 //
     /* 187573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187602 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 187605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187611 */     GIR_RootConstrainSelectedInstOperands,
     /* 187612 */     // GIR_Coverage, 1315,
     /* 187612 */     GIR_EraseRootFromParent_Done,
     /* 187613 */   // Label 3481: @187613
     /* 187613 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(187658), // Rule ID 1316 //
     /* 187618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187647 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 187650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187656 */     GIR_RootConstrainSelectedInstOperands,
     /* 187657 */     // GIR_Coverage, 1316,
     /* 187657 */     GIR_EraseRootFromParent_Done,
     /* 187658 */   // Label 3482: @187658
     /* 187658 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(187703), // Rule ID 1317 //
     /* 187663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 187671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187692 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 187695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187701 */     GIR_RootConstrainSelectedInstOperands,
     /* 187702 */     // GIR_Coverage, 1317,
     /* 187702 */     GIR_EraseRootFromParent_Done,
     /* 187703 */   // Label 3483: @187703
     /* 187703 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(187748), // Rule ID 1328 //
     /* 187708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187737 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 187740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187746 */     GIR_RootConstrainSelectedInstOperands,
     /* 187747 */     // GIR_Coverage, 1328,
     /* 187747 */     GIR_EraseRootFromParent_Done,
     /* 187748 */   // Label 3484: @187748
     /* 187748 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(187793), // Rule ID 1329 //
     /* 187753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187782 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 187785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187791 */     GIR_RootConstrainSelectedInstOperands,
     /* 187792 */     // GIR_Coverage, 1329,
     /* 187792 */     GIR_EraseRootFromParent_Done,
     /* 187793 */   // Label 3485: @187793
     /* 187793 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(187838), // Rule ID 1330 //
     /* 187798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187827 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 187830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187836 */     GIR_RootConstrainSelectedInstOperands,
     /* 187837 */     // GIR_Coverage, 1330,
     /* 187837 */     GIR_EraseRootFromParent_Done,
     /* 187838 */   // Label 3486: @187838
     /* 187838 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(187883), // Rule ID 1331 //
     /* 187843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187872 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 187875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187881 */     GIR_RootConstrainSelectedInstOperands,
     /* 187882 */     // GIR_Coverage, 1331,
     /* 187882 */     GIR_EraseRootFromParent_Done,
     /* 187883 */   // Label 3487: @187883
     /* 187883 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(187928), // Rule ID 1332 //
     /* 187888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 187896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187917 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 187920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187926 */     GIR_RootConstrainSelectedInstOperands,
     /* 187927 */     // GIR_Coverage, 1332,
     /* 187927 */     GIR_EraseRootFromParent_Done,
     /* 187928 */   // Label 3488: @187928
     /* 187928 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(187973), // Rule ID 1333 //
     /* 187933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 187941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187962 */     // (intrinsic_wo_chain:{ *:[v4f16] } 647:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 187965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187971 */     GIR_RootConstrainSelectedInstOperands,
     /* 187972 */     // GIR_Coverage, 1333,
     /* 187972 */     GIR_EraseRootFromParent_Done,
     /* 187973 */   // Label 3489: @187973
     /* 187973 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188018), // Rule ID 1334 //
     /* 187978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 187986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188007 */     // (intrinsic_wo_chain:{ *:[v8f16] } 647:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 188010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188016 */     GIR_RootConstrainSelectedInstOperands,
     /* 188017 */     // GIR_Coverage, 1334,
     /* 188017 */     GIR_EraseRootFromParent_Done,
     /* 188018 */   // Label 3490: @188018
     /* 188018 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188063), // Rule ID 1335 //
     /* 188023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188052 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 188055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188061 */     GIR_RootConstrainSelectedInstOperands,
     /* 188062 */     // GIR_Coverage, 1335,
     /* 188062 */     GIR_EraseRootFromParent_Done,
     /* 188063 */   // Label 3491: @188063
     /* 188063 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188108), // Rule ID 1336 //
     /* 188068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188097 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 188100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188106 */     GIR_RootConstrainSelectedInstOperands,
     /* 188107 */     // GIR_Coverage, 1336,
     /* 188107 */     GIR_EraseRootFromParent_Done,
     /* 188108 */   // Label 3492: @188108
     /* 188108 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(188153), // Rule ID 1337 //
     /* 188113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 188121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188142 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 188145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188151 */     GIR_RootConstrainSelectedInstOperands,
     /* 188152 */     // GIR_Coverage, 1337,
     /* 188152 */     GIR_EraseRootFromParent_Done,
     /* 188153 */   // Label 3493: @188153
     /* 188153 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(188198), // Rule ID 1354 //
     /* 188158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 188166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188187 */     // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 188190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188196 */     GIR_RootConstrainSelectedInstOperands,
     /* 188197 */     // GIR_Coverage, 1354,
     /* 188197 */     GIR_EraseRootFromParent_Done,
     /* 188198 */   // Label 3494: @188198
     /* 188198 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(188243), // Rule ID 1355 //
     /* 188203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 188211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188232 */     // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 188235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188241 */     GIR_RootConstrainSelectedInstOperands,
     /* 188242 */     // GIR_Coverage, 1355,
     /* 188242 */     GIR_EraseRootFromParent_Done,
     /* 188243 */   // Label 3495: @188243
     /* 188243 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(188288), // Rule ID 1369 //
     /* 188248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188277 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 188280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188286 */     GIR_RootConstrainSelectedInstOperands,
     /* 188287 */     // GIR_Coverage, 1369,
     /* 188287 */     GIR_EraseRootFromParent_Done,
     /* 188288 */   // Label 3496: @188288
     /* 188288 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(188333), // Rule ID 1371 //
     /* 188293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188322 */     // (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 188325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 1371,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 3497: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(188378), // Rule ID 1373 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188367 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 188370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188376 */     GIR_RootConstrainSelectedInstOperands,
     /* 188377 */     // GIR_Coverage, 1373,
     /* 188377 */     GIR_EraseRootFromParent_Done,
     /* 188378 */   // Label 3498: @188378
     /* 188378 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(188423), // Rule ID 1375 //
     /* 188383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188412 */     // (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 188415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188421 */     GIR_RootConstrainSelectedInstOperands,
     /* 188422 */     // GIR_Coverage, 1375,
     /* 188422 */     GIR_EraseRootFromParent_Done,
     /* 188423 */   // Label 3499: @188423
     /* 188423 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(188468), // Rule ID 1377 //
     /* 188428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188457 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 188460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188466 */     GIR_RootConstrainSelectedInstOperands,
     /* 188467 */     // GIR_Coverage, 1377,
     /* 188467 */     GIR_EraseRootFromParent_Done,
     /* 188468 */   // Label 3500: @188468
     /* 188468 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(188513), // Rule ID 1379 //
     /* 188473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 188481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188502 */     // (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 188502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 188505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188511 */     GIR_RootConstrainSelectedInstOperands,
     /* 188512 */     // GIR_Coverage, 1379,
     /* 188512 */     GIR_EraseRootFromParent_Done,
     /* 188513 */   // Label 3501: @188513
     /* 188513 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(188558), // Rule ID 1386 //
     /* 188518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188547 */     // (intrinsic_wo_chain:{ *:[v8i8] } 676:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 188550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188556 */     GIR_RootConstrainSelectedInstOperands,
     /* 188557 */     // GIR_Coverage, 1386,
     /* 188557 */     GIR_EraseRootFromParent_Done,
     /* 188558 */   // Label 3502: @188558
     /* 188558 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(188603), // Rule ID 1387 //
     /* 188563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188592 */     // (intrinsic_wo_chain:{ *:[v16i8] } 676:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 188595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188601 */     GIR_RootConstrainSelectedInstOperands,
     /* 188602 */     // GIR_Coverage, 1387,
     /* 188602 */     GIR_EraseRootFromParent_Done,
     /* 188603 */   // Label 3503: @188603
     /* 188603 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(188648), // Rule ID 1388 //
     /* 188608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188637 */     // (intrinsic_wo_chain:{ *:[v4i16] } 676:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 188640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188646 */     GIR_RootConstrainSelectedInstOperands,
     /* 188647 */     // GIR_Coverage, 1388,
     /* 188647 */     GIR_EraseRootFromParent_Done,
     /* 188648 */   // Label 3504: @188648
     /* 188648 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(188693), // Rule ID 1389 //
     /* 188653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188682 */     // (intrinsic_wo_chain:{ *:[v8i16] } 676:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 188685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188691 */     GIR_RootConstrainSelectedInstOperands,
     /* 188692 */     // GIR_Coverage, 1389,
     /* 188692 */     GIR_EraseRootFromParent_Done,
     /* 188693 */   // Label 3505: @188693
     /* 188693 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(188738), // Rule ID 1390 //
     /* 188698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188727 */     // (intrinsic_wo_chain:{ *:[v2i32] } 676:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 188730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188736 */     GIR_RootConstrainSelectedInstOperands,
     /* 188737 */     // GIR_Coverage, 1390,
     /* 188737 */     GIR_EraseRootFromParent_Done,
     /* 188738 */   // Label 3506: @188738
     /* 188738 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(188783), // Rule ID 1391 //
     /* 188743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 188751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 188772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 188775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188781 */     GIR_RootConstrainSelectedInstOperands,
     /* 188782 */     // GIR_Coverage, 1391,
     /* 188782 */     GIR_EraseRootFromParent_Done,
     /* 188783 */   // Label 3507: @188783
     /* 188783 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(188828), // Rule ID 1392 //
     /* 188788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 188799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 188802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 188805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188817 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 188817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 188820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188826 */     GIR_RootConstrainSelectedInstOperands,
     /* 188827 */     // GIR_Coverage, 1392,
     /* 188827 */     GIR_EraseRootFromParent_Done,
     /* 188828 */   // Label 3508: @188828
     /* 188828 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(188873), // Rule ID 1393 //
     /* 188833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 188844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 188850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188862 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 188862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 188865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188871 */     GIR_RootConstrainSelectedInstOperands,
     /* 188872 */     // GIR_Coverage, 1393,
     /* 188872 */     GIR_EraseRootFromParent_Done,
     /* 188873 */   // Label 3509: @188873
     /* 188873 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(188918), // Rule ID 1394 //
     /* 188878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188907 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 188907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 188910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188916 */     GIR_RootConstrainSelectedInstOperands,
     /* 188917 */     // GIR_Coverage, 1394,
     /* 188917 */     GIR_EraseRootFromParent_Done,
     /* 188918 */   // Label 3510: @188918
     /* 188918 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(188963), // Rule ID 1395 //
     /* 188923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 188952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 188955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188961 */     GIR_RootConstrainSelectedInstOperands,
     /* 188962 */     // GIR_Coverage, 1395,
     /* 188962 */     GIR_EraseRootFromParent_Done,
     /* 188963 */   // Label 3511: @188963
     /* 188963 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189008), // Rule ID 1396 //
     /* 188968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 188976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188997 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 188997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 189000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189006 */     GIR_RootConstrainSelectedInstOperands,
     /* 189007 */     // GIR_Coverage, 1396,
     /* 189007 */     GIR_EraseRootFromParent_Done,
     /* 189008 */   // Label 3512: @189008
     /* 189008 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189053), // Rule ID 1397 //
     /* 189013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 189021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 189045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189051 */     GIR_RootConstrainSelectedInstOperands,
     /* 189052 */     // GIR_Coverage, 1397,
     /* 189052 */     GIR_EraseRootFromParent_Done,
     /* 189053 */   // Label 3513: @189053
     /* 189053 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189098), // Rule ID 1404 //
     /* 189058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189087 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 189090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189096 */     GIR_RootConstrainSelectedInstOperands,
     /* 189097 */     // GIR_Coverage, 1404,
     /* 189097 */     GIR_EraseRootFromParent_Done,
     /* 189098 */   // Label 3514: @189098
     /* 189098 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(189143), // Rule ID 1405 //
     /* 189103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 189135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189141 */     GIR_RootConstrainSelectedInstOperands,
     /* 189142 */     // GIR_Coverage, 1405,
     /* 189142 */     GIR_EraseRootFromParent_Done,
     /* 189143 */   // Label 3515: @189143
     /* 189143 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(189188), // Rule ID 1406 //
     /* 189148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189177 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 189180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189186 */     GIR_RootConstrainSelectedInstOperands,
     /* 189187 */     // GIR_Coverage, 1406,
     /* 189187 */     GIR_EraseRootFromParent_Done,
     /* 189188 */   // Label 3516: @189188
     /* 189188 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(189233), // Rule ID 1407 //
     /* 189193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189222 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 189225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189231 */     GIR_RootConstrainSelectedInstOperands,
     /* 189232 */     // GIR_Coverage, 1407,
     /* 189232 */     GIR_EraseRootFromParent_Done,
     /* 189233 */   // Label 3517: @189233
     /* 189233 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(189278), // Rule ID 1408 //
     /* 189238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189267 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 189270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189276 */     GIR_RootConstrainSelectedInstOperands,
     /* 189277 */     // GIR_Coverage, 1408,
     /* 189277 */     GIR_EraseRootFromParent_Done,
     /* 189278 */   // Label 3518: @189278
     /* 189278 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(189323), // Rule ID 1409 //
     /* 189283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 189291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 189315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189321 */     GIR_RootConstrainSelectedInstOperands,
     /* 189322 */     // GIR_Coverage, 1409,
     /* 189322 */     GIR_EraseRootFromParent_Done,
     /* 189323 */   // Label 3519: @189323
     /* 189323 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(189368), // Rule ID 1423 //
     /* 189328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189357 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189366 */     GIR_RootConstrainSelectedInstOperands,
     /* 189367 */     // GIR_Coverage, 1423,
     /* 189367 */     GIR_EraseRootFromParent_Done,
     /* 189368 */   // Label 3520: @189368
     /* 189368 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(189413), // Rule ID 1424 //
     /* 189373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 189405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189411 */     GIR_RootConstrainSelectedInstOperands,
     /* 189412 */     // GIR_Coverage, 1424,
     /* 189412 */     GIR_EraseRootFromParent_Done,
     /* 189413 */   // Label 3521: @189413
     /* 189413 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(189458), // Rule ID 1425 //
     /* 189418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189447 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 189450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189456 */     GIR_RootConstrainSelectedInstOperands,
     /* 189457 */     // GIR_Coverage, 1425,
     /* 189457 */     GIR_EraseRootFromParent_Done,
     /* 189458 */   // Label 3522: @189458
     /* 189458 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(189503), // Rule ID 1426 //
     /* 189463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 189471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 189495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189501 */     GIR_RootConstrainSelectedInstOperands,
     /* 189502 */     // GIR_Coverage, 1426,
     /* 189502 */     GIR_EraseRootFromParent_Done,
     /* 189503 */   // Label 3523: @189503
     /* 189503 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(189548), // Rule ID 1427 //
     /* 189508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189537 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 189540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189546 */     GIR_RootConstrainSelectedInstOperands,
     /* 189547 */     // GIR_Coverage, 1427,
     /* 189547 */     GIR_EraseRootFromParent_Done,
     /* 189548 */   // Label 3524: @189548
     /* 189548 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(189593), // Rule ID 1428 //
     /* 189553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189582 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 189585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189591 */     GIR_RootConstrainSelectedInstOperands,
     /* 189592 */     // GIR_Coverage, 1428,
     /* 189592 */     GIR_EraseRootFromParent_Done,
     /* 189593 */   // Label 3525: @189593
     /* 189593 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(189638), // Rule ID 1429 //
     /* 189598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189627 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 189630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189636 */     GIR_RootConstrainSelectedInstOperands,
     /* 189637 */     // GIR_Coverage, 1429,
     /* 189637 */     GIR_EraseRootFromParent_Done,
     /* 189638 */   // Label 3526: @189638
     /* 189638 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(189683), // Rule ID 1430 //
     /* 189643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 189651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189672 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 189675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189681 */     GIR_RootConstrainSelectedInstOperands,
     /* 189682 */     // GIR_Coverage, 1430,
     /* 189682 */     GIR_EraseRootFromParent_Done,
     /* 189683 */   // Label 3527: @189683
     /* 189683 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(189728), // Rule ID 1431 //
     /* 189688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189717 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 189720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189726 */     GIR_RootConstrainSelectedInstOperands,
     /* 189727 */     // GIR_Coverage, 1431,
     /* 189727 */     GIR_EraseRootFromParent_Done,
     /* 189728 */   // Label 3528: @189728
     /* 189728 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(189773), // Rule ID 1432 //
     /* 189733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189762 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 189765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189771 */     GIR_RootConstrainSelectedInstOperands,
     /* 189772 */     // GIR_Coverage, 1432,
     /* 189772 */     GIR_EraseRootFromParent_Done,
     /* 189773 */   // Label 3529: @189773
     /* 189773 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(189818), // Rule ID 1433 //
     /* 189778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189807 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 189810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189816 */     GIR_RootConstrainSelectedInstOperands,
     /* 189817 */     // GIR_Coverage, 1433,
     /* 189817 */     GIR_EraseRootFromParent_Done,
     /* 189818 */   // Label 3530: @189818
     /* 189818 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(189863), // Rule ID 1434 //
     /* 189823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 189855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189861 */     GIR_RootConstrainSelectedInstOperands,
     /* 189862 */     // GIR_Coverage, 1434,
     /* 189862 */     GIR_EraseRootFromParent_Done,
     /* 189863 */   // Label 3531: @189863
     /* 189863 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(189908), // Rule ID 1435 //
     /* 189868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189897 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 189900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189906 */     GIR_RootConstrainSelectedInstOperands,
     /* 189907 */     // GIR_Coverage, 1435,
     /* 189907 */     GIR_EraseRootFromParent_Done,
     /* 189908 */   // Label 3532: @189908
     /* 189908 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(189953), // Rule ID 1436 //
     /* 189913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189942 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 189945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189951 */     GIR_RootConstrainSelectedInstOperands,
     /* 189952 */     // GIR_Coverage, 1436,
     /* 189952 */     GIR_EraseRootFromParent_Done,
     /* 189953 */   // Label 3533: @189953
     /* 189953 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(189998), // Rule ID 1437 //
     /* 189958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 189966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189987 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 189987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 189990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189996 */     GIR_RootConstrainSelectedInstOperands,
     /* 189997 */     // GIR_Coverage, 1437,
     /* 189997 */     GIR_EraseRootFromParent_Done,
     /* 189998 */   // Label 3534: @189998
     /* 189998 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190043), // Rule ID 1438 //
     /* 190003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190032 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 190035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190041 */     GIR_RootConstrainSelectedInstOperands,
     /* 190042 */     // GIR_Coverage, 1438,
     /* 190042 */     GIR_EraseRootFromParent_Done,
     /* 190043 */   // Label 3535: @190043
     /* 190043 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190088), // Rule ID 1439 //
     /* 190048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190077 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 190080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190086 */     GIR_RootConstrainSelectedInstOperands,
     /* 190087 */     // GIR_Coverage, 1439,
     /* 190087 */     GIR_EraseRootFromParent_Done,
     /* 190088 */   // Label 3536: @190088
     /* 190088 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(190133), // Rule ID 1440 //
     /* 190093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190122 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 190125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190131 */     GIR_RootConstrainSelectedInstOperands,
     /* 190132 */     // GIR_Coverage, 1440,
     /* 190132 */     GIR_EraseRootFromParent_Done,
     /* 190133 */   // Label 3537: @190133
     /* 190133 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(190178), // Rule ID 1441 //
     /* 190138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 190170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190176 */     GIR_RootConstrainSelectedInstOperands,
     /* 190177 */     // GIR_Coverage, 1441,
     /* 190177 */     GIR_EraseRootFromParent_Done,
     /* 190178 */   // Label 3538: @190178
     /* 190178 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(190223), // Rule ID 1442 //
     /* 190183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190212 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 190215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190221 */     GIR_RootConstrainSelectedInstOperands,
     /* 190222 */     // GIR_Coverage, 1442,
     /* 190222 */     GIR_EraseRootFromParent_Done,
     /* 190223 */   // Label 3539: @190223
     /* 190223 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(190268), // Rule ID 1443 //
     /* 190228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190257 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 190260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190266 */     GIR_RootConstrainSelectedInstOperands,
     /* 190267 */     // GIR_Coverage, 1443,
     /* 190267 */     GIR_EraseRootFromParent_Done,
     /* 190268 */   // Label 3540: @190268
     /* 190268 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(190313), // Rule ID 1444 //
     /* 190273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 190281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190302 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 190305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190311 */     GIR_RootConstrainSelectedInstOperands,
     /* 190312 */     // GIR_Coverage, 1444,
     /* 190312 */     GIR_EraseRootFromParent_Done,
     /* 190313 */   // Label 3541: @190313
     /* 190313 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(190358), // Rule ID 1458 //
     /* 190318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190347 */     // (intrinsic_wo_chain:{ *:[v8i8] } 709:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 190350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190356 */     GIR_RootConstrainSelectedInstOperands,
     /* 190357 */     // GIR_Coverage, 1458,
     /* 190357 */     GIR_EraseRootFromParent_Done,
     /* 190358 */   // Label 3542: @190358
     /* 190358 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(190403), // Rule ID 1459 //
     /* 190363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190392 */     // (intrinsic_wo_chain:{ *:[v16i8] } 709:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 190395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190401 */     GIR_RootConstrainSelectedInstOperands,
     /* 190402 */     // GIR_Coverage, 1459,
     /* 190402 */     GIR_EraseRootFromParent_Done,
     /* 190403 */   // Label 3543: @190403
     /* 190403 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(190448), // Rule ID 1460 //
     /* 190408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190437 */     // (intrinsic_wo_chain:{ *:[v4i16] } 709:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 190440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190446 */     GIR_RootConstrainSelectedInstOperands,
     /* 190447 */     // GIR_Coverage, 1460,
     /* 190447 */     GIR_EraseRootFromParent_Done,
     /* 190448 */   // Label 3544: @190448
     /* 190448 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(190493), // Rule ID 1461 //
     /* 190453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 709:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 190485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190491 */     GIR_RootConstrainSelectedInstOperands,
     /* 190492 */     // GIR_Coverage, 1461,
     /* 190492 */     GIR_EraseRootFromParent_Done,
     /* 190493 */   // Label 3545: @190493
     /* 190493 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(190538), // Rule ID 1462 //
     /* 190498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190527 */     // (intrinsic_wo_chain:{ *:[v2i32] } 709:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 190530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190536 */     GIR_RootConstrainSelectedInstOperands,
     /* 190537 */     // GIR_Coverage, 1462,
     /* 190537 */     GIR_EraseRootFromParent_Done,
     /* 190538 */   // Label 3546: @190538
     /* 190538 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(190583), // Rule ID 1463 //
     /* 190543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190572 */     // (intrinsic_wo_chain:{ *:[v4i32] } 709:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 190575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190581 */     GIR_RootConstrainSelectedInstOperands,
     /* 190582 */     // GIR_Coverage, 1463,
     /* 190582 */     GIR_EraseRootFromParent_Done,
     /* 190583 */   // Label 3547: @190583
     /* 190583 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(190628), // Rule ID 1464 //
     /* 190588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 190596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190617 */     // (intrinsic_wo_chain:{ *:[v2i64] } 709:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 190620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190626 */     GIR_RootConstrainSelectedInstOperands,
     /* 190627 */     // GIR_Coverage, 1464,
     /* 190627 */     GIR_EraseRootFromParent_Done,
     /* 190628 */   // Label 3548: @190628
     /* 190628 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(190673), // Rule ID 1465 //
     /* 190633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190662 */     // (intrinsic_wo_chain:{ *:[v8i8] } 710:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 190665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190671 */     GIR_RootConstrainSelectedInstOperands,
     /* 190672 */     // GIR_Coverage, 1465,
     /* 190672 */     GIR_EraseRootFromParent_Done,
     /* 190673 */   // Label 3549: @190673
     /* 190673 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(190718), // Rule ID 1466 //
     /* 190678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 710:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 190710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190716 */     GIR_RootConstrainSelectedInstOperands,
     /* 190717 */     // GIR_Coverage, 1466,
     /* 190717 */     GIR_EraseRootFromParent_Done,
     /* 190718 */   // Label 3550: @190718
     /* 190718 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(190763), // Rule ID 1467 //
     /* 190723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190752 */     // (intrinsic_wo_chain:{ *:[v4i16] } 710:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 190755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190761 */     GIR_RootConstrainSelectedInstOperands,
     /* 190762 */     // GIR_Coverage, 1467,
     /* 190762 */     GIR_EraseRootFromParent_Done,
     /* 190763 */   // Label 3551: @190763
     /* 190763 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(190808), // Rule ID 1468 //
     /* 190768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190797 */     // (intrinsic_wo_chain:{ *:[v8i16] } 710:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 190800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190806 */     GIR_RootConstrainSelectedInstOperands,
     /* 190807 */     // GIR_Coverage, 1468,
     /* 190807 */     GIR_EraseRootFromParent_Done,
     /* 190808 */   // Label 3552: @190808
     /* 190808 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(190853), // Rule ID 1469 //
     /* 190813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190842 */     // (intrinsic_wo_chain:{ *:[v2i32] } 710:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 190845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190851 */     GIR_RootConstrainSelectedInstOperands,
     /* 190852 */     // GIR_Coverage, 1469,
     /* 190852 */     GIR_EraseRootFromParent_Done,
     /* 190853 */   // Label 3553: @190853
     /* 190853 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(190898), // Rule ID 1470 //
     /* 190858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 710:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 190890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190896 */     GIR_RootConstrainSelectedInstOperands,
     /* 190897 */     // GIR_Coverage, 1470,
     /* 190897 */     GIR_EraseRootFromParent_Done,
     /* 190898 */   // Label 3554: @190898
     /* 190898 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(190943), // Rule ID 1471 //
     /* 190903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 190911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190932 */     // (intrinsic_wo_chain:{ *:[v2i64] } 710:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 190932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190941 */     GIR_RootConstrainSelectedInstOperands,
     /* 190942 */     // GIR_Coverage, 1471,
     /* 190942 */     GIR_EraseRootFromParent_Done,
     /* 190943 */   // Label 3555: @190943
     /* 190943 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(190988), // Rule ID 1492 //
     /* 190948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 190956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190977 */     // (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 190980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190986 */     GIR_RootConstrainSelectedInstOperands,
     /* 190987 */     // GIR_Coverage, 1492,
     /* 190987 */     GIR_EraseRootFromParent_Done,
     /* 190988 */   // Label 3556: @190988
     /* 190988 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191033), // Rule ID 1494 //
     /* 190993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 191025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191031 */     GIR_RootConstrainSelectedInstOperands,
     /* 191032 */     // GIR_Coverage, 1494,
     /* 191032 */     GIR_EraseRootFromParent_Done,
     /* 191033 */   // Label 3557: @191033
     /* 191033 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191078), // Rule ID 1496 //
     /* 191038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191067 */     // (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 191070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191076 */     GIR_RootConstrainSelectedInstOperands,
     /* 191077 */     // GIR_Coverage, 1496,
     /* 191077 */     GIR_EraseRootFromParent_Done,
     /* 191078 */   // Label 3558: @191078
     /* 191078 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191123), // Rule ID 1498 //
     /* 191083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 191115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191121 */     GIR_RootConstrainSelectedInstOperands,
     /* 191122 */     // GIR_Coverage, 1498,
     /* 191122 */     GIR_EraseRootFromParent_Done,
     /* 191123 */   // Label 3559: @191123
     /* 191123 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(191168), // Rule ID 1500 //
     /* 191128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191157 */     // (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 191160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191166 */     GIR_RootConstrainSelectedInstOperands,
     /* 191167 */     // GIR_Coverage, 1500,
     /* 191167 */     GIR_EraseRootFromParent_Done,
     /* 191168 */   // Label 3560: @191168
     /* 191168 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(191213), // Rule ID 1502 //
     /* 191173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 191181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 191205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191211 */     GIR_RootConstrainSelectedInstOperands,
     /* 191212 */     // GIR_Coverage, 1502,
     /* 191212 */     GIR_EraseRootFromParent_Done,
     /* 191213 */   // Label 3561: @191213
     /* 191213 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(191258), // Rule ID 1509 //
     /* 191218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 191250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191256 */     GIR_RootConstrainSelectedInstOperands,
     /* 191257 */     // GIR_Coverage, 1509,
     /* 191257 */     GIR_EraseRootFromParent_Done,
     /* 191258 */   // Label 3562: @191258
     /* 191258 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(191303), // Rule ID 1510 //
     /* 191263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 191295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191301 */     GIR_RootConstrainSelectedInstOperands,
     /* 191302 */     // GIR_Coverage, 1510,
     /* 191302 */     GIR_EraseRootFromParent_Done,
     /* 191303 */   // Label 3563: @191303
     /* 191303 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(191348), // Rule ID 1511 //
     /* 191308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 191340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191346 */     GIR_RootConstrainSelectedInstOperands,
     /* 191347 */     // GIR_Coverage, 1511,
     /* 191347 */     GIR_EraseRootFromParent_Done,
     /* 191348 */   // Label 3564: @191348
     /* 191348 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(191393), // Rule ID 1512 //
     /* 191353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191382 */     // (intrinsic_wo_chain:{ *:[v8i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 191385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191391 */     GIR_RootConstrainSelectedInstOperands,
     /* 191392 */     // GIR_Coverage, 1512,
     /* 191392 */     GIR_EraseRootFromParent_Done,
     /* 191393 */   // Label 3565: @191393
     /* 191393 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(191438), // Rule ID 1513 //
     /* 191398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191427 */     // (intrinsic_wo_chain:{ *:[v2i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 191430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191436 */     GIR_RootConstrainSelectedInstOperands,
     /* 191437 */     // GIR_Coverage, 1513,
     /* 191437 */     GIR_EraseRootFromParent_Done,
     /* 191438 */   // Label 3566: @191438
     /* 191438 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(191483), // Rule ID 1514 //
     /* 191443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 191451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191481 */     GIR_RootConstrainSelectedInstOperands,
     /* 191482 */     // GIR_Coverage, 1514,
     /* 191482 */     GIR_EraseRootFromParent_Done,
     /* 191483 */   // Label 3567: @191483
     /* 191483 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(191528), // Rule ID 1515 //
     /* 191488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191517 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 191520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191526 */     GIR_RootConstrainSelectedInstOperands,
     /* 191527 */     // GIR_Coverage, 1515,
     /* 191527 */     GIR_EraseRootFromParent_Done,
     /* 191528 */   // Label 3568: @191528
     /* 191528 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(191573), // Rule ID 1516 //
     /* 191533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191562 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 191565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191571 */     GIR_RootConstrainSelectedInstOperands,
     /* 191572 */     // GIR_Coverage, 1516,
     /* 191572 */     GIR_EraseRootFromParent_Done,
     /* 191573 */   // Label 3569: @191573
     /* 191573 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(191618), // Rule ID 1517 //
     /* 191578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191607 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 191610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191616 */     GIR_RootConstrainSelectedInstOperands,
     /* 191617 */     // GIR_Coverage, 1517,
     /* 191617 */     GIR_EraseRootFromParent_Done,
     /* 191618 */   // Label 3570: @191618
     /* 191618 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(191663), // Rule ID 1518 //
     /* 191623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 191655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191661 */     GIR_RootConstrainSelectedInstOperands,
     /* 191662 */     // GIR_Coverage, 1518,
     /* 191662 */     GIR_EraseRootFromParent_Done,
     /* 191663 */   // Label 3571: @191663
     /* 191663 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(191708), // Rule ID 1519 //
     /* 191668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191697 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 191700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191706 */     GIR_RootConstrainSelectedInstOperands,
     /* 191707 */     // GIR_Coverage, 1519,
     /* 191707 */     GIR_EraseRootFromParent_Done,
     /* 191708 */   // Label 3572: @191708
     /* 191708 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(191753), // Rule ID 1520 //
     /* 191713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 191721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 191745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191751 */     GIR_RootConstrainSelectedInstOperands,
     /* 191752 */     // GIR_Coverage, 1520,
     /* 191752 */     GIR_EraseRootFromParent_Done,
     /* 191753 */   // Label 3573: @191753
     /* 191753 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(191798), // Rule ID 1527 //
     /* 191758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191787 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 191790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191796 */     GIR_RootConstrainSelectedInstOperands,
     /* 191797 */     // GIR_Coverage, 1527,
     /* 191797 */     GIR_EraseRootFromParent_Done,
     /* 191798 */   // Label 3574: @191798
     /* 191798 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(191843), // Rule ID 1528 //
     /* 191803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191832 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 191835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191841 */     GIR_RootConstrainSelectedInstOperands,
     /* 191842 */     // GIR_Coverage, 1528,
     /* 191842 */     GIR_EraseRootFromParent_Done,
     /* 191843 */   // Label 3575: @191843
     /* 191843 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(191888), // Rule ID 1529 //
     /* 191848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191877 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 191880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191886 */     GIR_RootConstrainSelectedInstOperands,
     /* 191887 */     // GIR_Coverage, 1529,
     /* 191887 */     GIR_EraseRootFromParent_Done,
     /* 191888 */   // Label 3576: @191888
     /* 191888 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(191933), // Rule ID 1530 //
     /* 191893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191922 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 191925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191931 */     GIR_RootConstrainSelectedInstOperands,
     /* 191932 */     // GIR_Coverage, 1530,
     /* 191932 */     GIR_EraseRootFromParent_Done,
     /* 191933 */   // Label 3577: @191933
     /* 191933 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(191978), // Rule ID 1531 //
     /* 191938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191967 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 191970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191976 */     GIR_RootConstrainSelectedInstOperands,
     /* 191977 */     // GIR_Coverage, 1531,
     /* 191977 */     GIR_EraseRootFromParent_Done,
     /* 191978 */   // Label 3578: @191978
     /* 191978 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192023), // Rule ID 1532 //
     /* 191983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 191991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 192015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192021 */     GIR_RootConstrainSelectedInstOperands,
     /* 192022 */     // GIR_Coverage, 1532,
     /* 192022 */     GIR_EraseRootFromParent_Done,
     /* 192023 */   // Label 3579: @192023
     /* 192023 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192068), // Rule ID 1546 //
     /* 192028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192057 */     // (intrinsic_wo_chain:{ *:[v8i8] } 747:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 192060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192066 */     GIR_RootConstrainSelectedInstOperands,
     /* 192067 */     // GIR_Coverage, 1546,
     /* 192067 */     GIR_EraseRootFromParent_Done,
     /* 192068 */   // Label 3580: @192068
     /* 192068 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192113), // Rule ID 1547 //
     /* 192073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 747:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192111 */     GIR_RootConstrainSelectedInstOperands,
     /* 192112 */     // GIR_Coverage, 1547,
     /* 192112 */     GIR_EraseRootFromParent_Done,
     /* 192113 */   // Label 3581: @192113
     /* 192113 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(192158), // Rule ID 1548 //
     /* 192118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192147 */     // (intrinsic_wo_chain:{ *:[v4i16] } 747:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 192150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192156 */     GIR_RootConstrainSelectedInstOperands,
     /* 192157 */     // GIR_Coverage, 1548,
     /* 192157 */     GIR_EraseRootFromParent_Done,
     /* 192158 */   // Label 3582: @192158
     /* 192158 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(192203), // Rule ID 1549 //
     /* 192163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 747:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 192195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192201 */     GIR_RootConstrainSelectedInstOperands,
     /* 192202 */     // GIR_Coverage, 1549,
     /* 192202 */     GIR_EraseRootFromParent_Done,
     /* 192203 */   // Label 3583: @192203
     /* 192203 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(192248), // Rule ID 1550 //
     /* 192208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192237 */     // (intrinsic_wo_chain:{ *:[v2i32] } 747:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 192240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192246 */     GIR_RootConstrainSelectedInstOperands,
     /* 192247 */     // GIR_Coverage, 1550,
     /* 192247 */     GIR_EraseRootFromParent_Done,
     /* 192248 */   // Label 3584: @192248
     /* 192248 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(192293), // Rule ID 1551 //
     /* 192253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192282 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 192285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192291 */     GIR_RootConstrainSelectedInstOperands,
     /* 192292 */     // GIR_Coverage, 1551,
     /* 192292 */     GIR_EraseRootFromParent_Done,
     /* 192293 */   // Label 3585: @192293
     /* 192293 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(192338), // Rule ID 1552 //
     /* 192298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 192306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192327 */     // (intrinsic_wo_chain:{ *:[v2i64] } 747:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 192330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192336 */     GIR_RootConstrainSelectedInstOperands,
     /* 192337 */     // GIR_Coverage, 1552,
     /* 192337 */     GIR_EraseRootFromParent_Done,
     /* 192338 */   // Label 3586: @192338
     /* 192338 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(192383), // Rule ID 1553 //
     /* 192343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192372 */     // (intrinsic_wo_chain:{ *:[v8i8] } 749:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 192375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192381 */     GIR_RootConstrainSelectedInstOperands,
     /* 192382 */     // GIR_Coverage, 1553,
     /* 192382 */     GIR_EraseRootFromParent_Done,
     /* 192383 */   // Label 3587: @192383
     /* 192383 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(192428), // Rule ID 1554 //
     /* 192388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192417 */     // (intrinsic_wo_chain:{ *:[v16i8] } 749:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 192420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192426 */     GIR_RootConstrainSelectedInstOperands,
     /* 192427 */     // GIR_Coverage, 1554,
     /* 192427 */     GIR_EraseRootFromParent_Done,
     /* 192428 */   // Label 3588: @192428
     /* 192428 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(192473), // Rule ID 1555 //
     /* 192433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192462 */     // (intrinsic_wo_chain:{ *:[v4i16] } 749:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 192465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192471 */     GIR_RootConstrainSelectedInstOperands,
     /* 192472 */     // GIR_Coverage, 1555,
     /* 192472 */     GIR_EraseRootFromParent_Done,
     /* 192473 */   // Label 3589: @192473
     /* 192473 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(192518), // Rule ID 1556 //
     /* 192478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192507 */     // (intrinsic_wo_chain:{ *:[v8i16] } 749:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 192510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192516 */     GIR_RootConstrainSelectedInstOperands,
     /* 192517 */     // GIR_Coverage, 1556,
     /* 192517 */     GIR_EraseRootFromParent_Done,
     /* 192518 */   // Label 3590: @192518
     /* 192518 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(192563), // Rule ID 1557 //
     /* 192523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 192555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192561 */     GIR_RootConstrainSelectedInstOperands,
     /* 192562 */     // GIR_Coverage, 1557,
     /* 192562 */     GIR_EraseRootFromParent_Done,
     /* 192563 */   // Label 3591: @192563
     /* 192563 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(192608), // Rule ID 1558 //
     /* 192568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 192600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192606 */     GIR_RootConstrainSelectedInstOperands,
     /* 192607 */     // GIR_Coverage, 1558,
     /* 192607 */     GIR_EraseRootFromParent_Done,
     /* 192608 */   // Label 3592: @192608
     /* 192608 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(192653), // Rule ID 1559 //
     /* 192613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 192621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 749:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 192645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192651 */     GIR_RootConstrainSelectedInstOperands,
     /* 192652 */     // GIR_Coverage, 1559,
     /* 192652 */     GIR_EraseRootFromParent_Done,
     /* 192653 */   // Label 3593: @192653
     /* 192653 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(192698), // Rule ID 1573 //
     /* 192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192687 */     // (intrinsic_wo_chain:{ *:[v8i8] } 755:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 192690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192696 */     GIR_RootConstrainSelectedInstOperands,
     /* 192697 */     // GIR_Coverage, 1573,
     /* 192697 */     GIR_EraseRootFromParent_Done,
     /* 192698 */   // Label 3594: @192698
     /* 192698 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(192743), // Rule ID 1574 //
     /* 192703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192732 */     // (intrinsic_wo_chain:{ *:[v16i8] } 755:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 192735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192741 */     GIR_RootConstrainSelectedInstOperands,
     /* 192742 */     // GIR_Coverage, 1574,
     /* 192742 */     GIR_EraseRootFromParent_Done,
     /* 192743 */   // Label 3595: @192743
     /* 192743 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(192788), // Rule ID 1575 //
     /* 192748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192777 */     // (intrinsic_wo_chain:{ *:[v4i16] } 755:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 192780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192786 */     GIR_RootConstrainSelectedInstOperands,
     /* 192787 */     // GIR_Coverage, 1575,
     /* 192787 */     GIR_EraseRootFromParent_Done,
     /* 192788 */   // Label 3596: @192788
     /* 192788 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(192833), // Rule ID 1576 //
     /* 192793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192822 */     // (intrinsic_wo_chain:{ *:[v8i16] } 755:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 192825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192831 */     GIR_RootConstrainSelectedInstOperands,
     /* 192832 */     // GIR_Coverage, 1576,
     /* 192832 */     GIR_EraseRootFromParent_Done,
     /* 192833 */   // Label 3597: @192833
     /* 192833 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(192878), // Rule ID 1577 //
     /* 192838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192867 */     // (intrinsic_wo_chain:{ *:[v2i32] } 755:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 192870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192876 */     GIR_RootConstrainSelectedInstOperands,
     /* 192877 */     // GIR_Coverage, 1577,
     /* 192877 */     GIR_EraseRootFromParent_Done,
     /* 192878 */   // Label 3598: @192878
     /* 192878 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(192923), // Rule ID 1578 //
     /* 192883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 755:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 192915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192921 */     GIR_RootConstrainSelectedInstOperands,
     /* 192922 */     // GIR_Coverage, 1578,
     /* 192922 */     GIR_EraseRootFromParent_Done,
     /* 192923 */   // Label 3599: @192923
     /* 192923 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(192968), // Rule ID 1579 //
     /* 192928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 192936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192957 */     // (intrinsic_wo_chain:{ *:[v2i64] } 755:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 192960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192966 */     GIR_RootConstrainSelectedInstOperands,
     /* 192967 */     // GIR_Coverage, 1579,
     /* 192967 */     GIR_EraseRootFromParent_Done,
     /* 192968 */   // Label 3600: @192968
     /* 192968 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193013), // Rule ID 1580 //
     /* 192973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 192981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193002 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 193005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193011 */     GIR_RootConstrainSelectedInstOperands,
     /* 193012 */     // GIR_Coverage, 1580,
     /* 193012 */     GIR_EraseRootFromParent_Done,
     /* 193013 */   // Label 3601: @193013
     /* 193013 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193058), // Rule ID 1581 //
     /* 193018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193047 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 193050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193056 */     GIR_RootConstrainSelectedInstOperands,
     /* 193057 */     // GIR_Coverage, 1581,
     /* 193057 */     GIR_EraseRootFromParent_Done,
     /* 193058 */   // Label 3602: @193058
     /* 193058 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193103), // Rule ID 1582 //
     /* 193063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193092 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 193095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193101 */     GIR_RootConstrainSelectedInstOperands,
     /* 193102 */     // GIR_Coverage, 1582,
     /* 193102 */     GIR_EraseRootFromParent_Done,
     /* 193103 */   // Label 3603: @193103
     /* 193103 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(193148), // Rule ID 1583 //
     /* 193108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 193140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193146 */     GIR_RootConstrainSelectedInstOperands,
     /* 193147 */     // GIR_Coverage, 1583,
     /* 193147 */     GIR_EraseRootFromParent_Done,
     /* 193148 */   // Label 3604: @193148
     /* 193148 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(193193), // Rule ID 1584 //
     /* 193153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193182 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 193185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193191 */     GIR_RootConstrainSelectedInstOperands,
     /* 193192 */     // GIR_Coverage, 1584,
     /* 193192 */     GIR_EraseRootFromParent_Done,
     /* 193193 */   // Label 3605: @193193
     /* 193193 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(193238), // Rule ID 1585 //
     /* 193198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 193230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193236 */     GIR_RootConstrainSelectedInstOperands,
     /* 193237 */     // GIR_Coverage, 1585,
     /* 193237 */     GIR_EraseRootFromParent_Done,
     /* 193238 */   // Label 3606: @193238
     /* 193238 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(193283), // Rule ID 1586 //
     /* 193243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 193251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193272 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 193275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193281 */     GIR_RootConstrainSelectedInstOperands,
     /* 193282 */     // GIR_Coverage, 1586,
     /* 193282 */     GIR_EraseRootFromParent_Done,
     /* 193283 */   // Label 3607: @193283
     /* 193283 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(193328), // Rule ID 1614 //
     /* 193288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193317 */     // (intrinsic_wo_chain:{ *:[f64] } 792:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 193320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193326 */     GIR_RootConstrainSelectedInstOperands,
     /* 193327 */     // GIR_Coverage, 1614,
     /* 193327 */     GIR_EraseRootFromParent_Done,
     /* 193328 */   // Label 3608: @193328
     /* 193328 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(193373), // Rule ID 1615 //
     /* 193333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193362 */     // (intrinsic_wo_chain:{ *:[f32] } 792:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 193365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193371 */     GIR_RootConstrainSelectedInstOperands,
     /* 193372 */     // GIR_Coverage, 1615,
     /* 193372 */     GIR_EraseRootFromParent_Done,
     /* 193373 */   // Label 3609: @193373
     /* 193373 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(193418), // Rule ID 1616 //
     /* 193378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 193381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 193386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193407 */     // (intrinsic_wo_chain:{ *:[f16] } 792:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 193410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193416 */     GIR_RootConstrainSelectedInstOperands,
     /* 193417 */     // GIR_Coverage, 1616,
     /* 193417 */     GIR_EraseRootFromParent_Done,
     /* 193418 */   // Label 3610: @193418
     /* 193418 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(193463), // Rule ID 1617 //
     /* 193423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 193431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193452 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 193455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193461 */     GIR_RootConstrainSelectedInstOperands,
     /* 193462 */     // GIR_Coverage, 1617,
     /* 193462 */     GIR_EraseRootFromParent_Done,
     /* 193463 */   // Label 3611: @193463
     /* 193463 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(193508), // Rule ID 1618 //
     /* 193468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 193476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193497 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 193500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193506 */     GIR_RootConstrainSelectedInstOperands,
     /* 193507 */     // GIR_Coverage, 1618,
     /* 193507 */     GIR_EraseRootFromParent_Done,
     /* 193508 */   // Label 3612: @193508
     /* 193508 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(193553), // Rule ID 1619 //
     /* 193513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 193521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193542 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 193545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193551 */     GIR_RootConstrainSelectedInstOperands,
     /* 193552 */     // GIR_Coverage, 1619,
     /* 193552 */     GIR_EraseRootFromParent_Done,
     /* 193553 */   // Label 3613: @193553
     /* 193553 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(193598), // Rule ID 1620 //
     /* 193558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 193566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193587 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 193590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193596 */     GIR_RootConstrainSelectedInstOperands,
     /* 193597 */     // GIR_Coverage, 1620,
     /* 193597 */     GIR_EraseRootFromParent_Done,
     /* 193598 */   // Label 3614: @193598
     /* 193598 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(193643), // Rule ID 1627 //
     /* 193603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193632 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 193635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193641 */     GIR_RootConstrainSelectedInstOperands,
     /* 193642 */     // GIR_Coverage, 1627,
     /* 193642 */     GIR_EraseRootFromParent_Done,
     /* 193643 */   // Label 3615: @193643
     /* 193643 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(193688), // Rule ID 1628 //
     /* 193648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193677 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 193680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193686 */     GIR_RootConstrainSelectedInstOperands,
     /* 193687 */     // GIR_Coverage, 1628,
     /* 193687 */     GIR_EraseRootFromParent_Done,
     /* 193688 */   // Label 3616: @193688
     /* 193688 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(193733), // Rule ID 1629 //
     /* 193693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 193701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193722 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 193725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193731 */     GIR_RootConstrainSelectedInstOperands,
     /* 193732 */     // GIR_Coverage, 1629,
     /* 193732 */     GIR_EraseRootFromParent_Done,
     /* 193733 */   // Label 3617: @193733
     /* 193733 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(193778), // Rule ID 1630 //
     /* 193738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193767 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 193770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193776 */     GIR_RootConstrainSelectedInstOperands,
     /* 193777 */     // GIR_Coverage, 1630,
     /* 193777 */     GIR_EraseRootFromParent_Done,
     /* 193778 */   // Label 3618: @193778
     /* 193778 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(193823), // Rule ID 1631 //
     /* 193783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193812 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 193815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193821 */     GIR_RootConstrainSelectedInstOperands,
     /* 193822 */     // GIR_Coverage, 1631,
     /* 193822 */     GIR_EraseRootFromParent_Done,
     /* 193823 */   // Label 3619: @193823
     /* 193823 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(193868), // Rule ID 1632 //
     /* 193828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 193836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193857 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 193860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193866 */     GIR_RootConstrainSelectedInstOperands,
     /* 193867 */     // GIR_Coverage, 1632,
     /* 193867 */     GIR_EraseRootFromParent_Done,
     /* 193868 */   // Label 3620: @193868
     /* 193868 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(193913), // Rule ID 1633 //
     /* 193873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193902 */     // (intrinsic_wo_chain:{ *:[f64] } 647:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 193902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193911 */     GIR_RootConstrainSelectedInstOperands,
     /* 193912 */     // GIR_Coverage, 1633,
     /* 193912 */     GIR_EraseRootFromParent_Done,
     /* 193913 */   // Label 3621: @193913
     /* 193913 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(193958), // Rule ID 1634 //
     /* 193918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 193921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 193929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 193947 */     // (intrinsic_wo_chain:{ *:[f32] } 647:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 193947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 193950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193956 */     GIR_RootConstrainSelectedInstOperands,
     /* 193957 */     // GIR_Coverage, 1634,
     /* 193957 */     GIR_EraseRootFromParent_Done,
     /* 193958 */   // Label 3622: @193958
     /* 193958 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194003), // Rule ID 1635 //
     /* 193963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 193966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 193971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 193974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 193977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 193980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 193992 */     // (intrinsic_wo_chain:{ *:[f16] } 647:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 193992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 193995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194001 */     GIR_RootConstrainSelectedInstOperands,
     /* 194002 */     // GIR_Coverage, 1635,
     /* 194002 */     GIR_EraseRootFromParent_Done,
     /* 194003 */   // Label 3623: @194003
     /* 194003 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194048), // Rule ID 1636 //
     /* 194008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 194016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194037 */     // (intrinsic_wo_chain:{ *:[v1i64] } 686:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 194040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194046 */     GIR_RootConstrainSelectedInstOperands,
     /* 194047 */     // GIR_Coverage, 1636,
     /* 194047 */     GIR_EraseRootFromParent_Done,
     /* 194048 */   // Label 3624: @194048
     /* 194048 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194093), // Rule ID 1637 //
     /* 194053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 194061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194082 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 194085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194091 */     GIR_RootConstrainSelectedInstOperands,
     /* 194092 */     // GIR_Coverage, 1637,
     /* 194092 */     GIR_EraseRootFromParent_Done,
     /* 194093 */   // Label 3625: @194093
     /* 194093 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(194138), // Rule ID 1638 //
     /* 194098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 194106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194127 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 194130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194136 */     GIR_RootConstrainSelectedInstOperands,
     /* 194137 */     // GIR_Coverage, 1638,
     /* 194137 */     GIR_EraseRootFromParent_Done,
     /* 194138 */   // Label 3626: @194138
     /* 194138 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(194183), // Rule ID 1639 //
     /* 194143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 194151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194172 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 194175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194181 */     GIR_RootConstrainSelectedInstOperands,
     /* 194182 */     // GIR_Coverage, 1639,
     /* 194182 */     GIR_EraseRootFromParent_Done,
     /* 194183 */   // Label 3627: @194183
     /* 194183 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(194228), // Rule ID 1640 //
     /* 194188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 194196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194217 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 194220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194226 */     GIR_RootConstrainSelectedInstOperands,
     /* 194227 */     // GIR_Coverage, 1640,
     /* 194227 */     GIR_EraseRootFromParent_Done,
     /* 194228 */   // Label 3628: @194228
     /* 194228 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(194273), // Rule ID 1641 //
     /* 194233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 194241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194262 */     // (intrinsic_wo_chain:{ *:[v1i64] } 705:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 194265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194271 */     GIR_RootConstrainSelectedInstOperands,
     /* 194272 */     // GIR_Coverage, 1641,
     /* 194272 */     GIR_EraseRootFromParent_Done,
     /* 194273 */   // Label 3629: @194273
     /* 194273 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(194318), // Rule ID 1642 //
     /* 194278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 194286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194307 */     // (intrinsic_wo_chain:{ *:[v1i64] } 709:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 194310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194316 */     GIR_RootConstrainSelectedInstOperands,
     /* 194317 */     // GIR_Coverage, 1642,
     /* 194317 */     GIR_EraseRootFromParent_Done,
     /* 194318 */   // Label 3630: @194318
     /* 194318 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(194363), // Rule ID 1643 //
     /* 194323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 194331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194352 */     // (intrinsic_wo_chain:{ *:[v1i64] } 710:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 194355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194361 */     GIR_RootConstrainSelectedInstOperands,
     /* 194362 */     // GIR_Coverage, 1643,
     /* 194362 */     GIR_EraseRootFromParent_Done,
     /* 194363 */   // Label 3631: @194363
     /* 194363 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(194408), // Rule ID 1645 //
     /* 194368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194397 */     // (intrinsic_wo_chain:{ *:[v1i64] } 746:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 194400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194406 */     GIR_RootConstrainSelectedInstOperands,
     /* 194407 */     // GIR_Coverage, 1645,
     /* 194407 */     GIR_EraseRootFromParent_Done,
     /* 194408 */   // Label 3632: @194408
     /* 194408 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(194453), // Rule ID 1646 //
     /* 194413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 194421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194442 */     // (intrinsic_wo_chain:{ *:[v1i64] } 747:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 194445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194451 */     GIR_RootConstrainSelectedInstOperands,
     /* 194452 */     // GIR_Coverage, 1646,
     /* 194452 */     GIR_EraseRootFromParent_Done,
     /* 194453 */   // Label 3633: @194453
     /* 194453 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(194498), // Rule ID 1647 //
     /* 194458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194487 */     // (intrinsic_wo_chain:{ *:[v1i64] } 749:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 194490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194496 */     GIR_RootConstrainSelectedInstOperands,
     /* 194497 */     // GIR_Coverage, 1647,
     /* 194497 */     GIR_EraseRootFromParent_Done,
     /* 194498 */   // Label 3634: @194498
     /* 194498 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(194543), // Rule ID 1648 //
     /* 194503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 194511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194532 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 194535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194541 */     GIR_RootConstrainSelectedInstOperands,
     /* 194542 */     // GIR_Coverage, 1648,
     /* 194542 */     GIR_EraseRootFromParent_Done,
     /* 194543 */   // Label 3635: @194543
     /* 194543 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(194588), // Rule ID 1649 //
     /* 194548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194577 */     // (intrinsic_wo_chain:{ *:[v1i64] } 755:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 194580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194586 */     GIR_RootConstrainSelectedInstOperands,
     /* 194587 */     // GIR_Coverage, 1649,
     /* 194587 */     GIR_EraseRootFromParent_Done,
     /* 194588 */   // Label 3636: @194588
     /* 194588 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(194633), // Rule ID 1650 //
     /* 194593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194622 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 194622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 194625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194631 */     GIR_RootConstrainSelectedInstOperands,
     /* 194632 */     // GIR_Coverage, 1650,
     /* 194632 */     GIR_EraseRootFromParent_Done,
     /* 194633 */   // Label 3637: @194633
     /* 194633 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(194678), // Rule ID 1651 //
     /* 194638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 194646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194667 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 194667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 194670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194676 */     GIR_RootConstrainSelectedInstOperands,
     /* 194677 */     // GIR_Coverage, 1651,
     /* 194677 */     GIR_EraseRootFromParent_Done,
     /* 194678 */   // Label 3638: @194678
     /* 194678 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(194723), // Rule ID 1665 //
     /* 194683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 194691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194712 */     // (intrinsic_wo_chain:{ *:[i64] } 722:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 194712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 194715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194721 */     GIR_RootConstrainSelectedInstOperands,
     /* 194722 */     // GIR_Coverage, 1665,
     /* 194722 */     GIR_EraseRootFromParent_Done,
     /* 194723 */   // Label 3639: @194723
     /* 194723 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(194768), // Rule ID 1666 //
     /* 194728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 194736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194757 */     // (intrinsic_wo_chain:{ *:[i32] } 722:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 194757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 194760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194766 */     GIR_RootConstrainSelectedInstOperands,
     /* 194767 */     // GIR_Coverage, 1666,
     /* 194767 */     GIR_EraseRootFromParent_Done,
     /* 194768 */   // Label 3640: @194768
     /* 194768 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(194813), // Rule ID 1671 //
     /* 194773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 194781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194802 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 194802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 194805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194811 */     GIR_RootConstrainSelectedInstOperands,
     /* 194812 */     // GIR_Coverage, 1671,
     /* 194812 */     GIR_EraseRootFromParent_Done,
     /* 194813 */   // Label 3641: @194813
     /* 194813 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(194858), // Rule ID 1672 //
     /* 194818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 194826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194847 */     // (intrinsic_wo_chain:{ *:[i32] } 761:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 194847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 194850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194856 */     GIR_RootConstrainSelectedInstOperands,
     /* 194857 */     // GIR_Coverage, 1672,
     /* 194857 */     GIR_EraseRootFromParent_Done,
     /* 194858 */   // Label 3642: @194858
     /* 194858 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(194903), // Rule ID 1673 //
     /* 194863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194892 */     // (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 194895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194901 */     GIR_RootConstrainSelectedInstOperands,
     /* 194902 */     // GIR_Coverage, 1673,
     /* 194902 */     GIR_EraseRootFromParent_Done,
     /* 194903 */   // Label 3643: @194903
     /* 194903 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(194948), // Rule ID 1674 //
     /* 194908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194937 */     // (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 194940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194946 */     GIR_RootConstrainSelectedInstOperands,
     /* 194947 */     // GIR_Coverage, 1674,
     /* 194947 */     GIR_EraseRootFromParent_Done,
     /* 194948 */   // Label 3644: @194948
     /* 194948 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(194993), // Rule ID 1675 //
     /* 194953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 194961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194982 */     // (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 194985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194991 */     GIR_RootConstrainSelectedInstOperands,
     /* 194992 */     // GIR_Coverage, 1675,
     /* 194992 */     GIR_EraseRootFromParent_Done,
     /* 194993 */   // Label 3645: @194993
     /* 194993 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195038), // Rule ID 1676 //
     /* 194998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 195006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195027 */     // (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 195030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195036 */     GIR_RootConstrainSelectedInstOperands,
     /* 195037 */     // GIR_Coverage, 1676,
     /* 195037 */     GIR_EraseRootFromParent_Done,
     /* 195038 */   // Label 3646: @195038
     /* 195038 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195083), // Rule ID 1677 //
     /* 195043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 195051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195072 */     // (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 195075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195081 */     GIR_RootConstrainSelectedInstOperands,
     /* 195082 */     // GIR_Coverage, 1677,
     /* 195082 */     GIR_EraseRootFromParent_Done,
     /* 195083 */   // Label 3647: @195083
     /* 195083 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(195128), // Rule ID 1678 //
     /* 195088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 195096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195117 */     // (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 195120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195126 */     GIR_RootConstrainSelectedInstOperands,
     /* 195127 */     // GIR_Coverage, 1678,
     /* 195127 */     GIR_EraseRootFromParent_Done,
     /* 195128 */   // Label 3648: @195128
     /* 195128 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(195173), // Rule ID 1679 //
     /* 195133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 195141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195162 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 195165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195171 */     GIR_RootConstrainSelectedInstOperands,
     /* 195172 */     // GIR_Coverage, 1679,
     /* 195172 */     GIR_EraseRootFromParent_Done,
     /* 195173 */   // Label 3649: @195173
     /* 195173 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(195218), // Rule ID 1680 //
     /* 195178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 195186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195207 */     // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 195210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195216 */     GIR_RootConstrainSelectedInstOperands,
     /* 195217 */     // GIR_Coverage, 1680,
     /* 195217 */     GIR_EraseRootFromParent_Done,
     /* 195218 */   // Label 3650: @195218
     /* 195218 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(195263), // Rule ID 1681 //
     /* 195223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 195231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 195255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195261 */     GIR_RootConstrainSelectedInstOperands,
     /* 195262 */     // GIR_Coverage, 1681,
     /* 195262 */     GIR_EraseRootFromParent_Done,
     /* 195263 */   // Label 3651: @195263
     /* 195263 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(195308), // Rule ID 1682 //
     /* 195268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195297 */     // (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 195300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195306 */     GIR_RootConstrainSelectedInstOperands,
     /* 195307 */     // GIR_Coverage, 1682,
     /* 195307 */     GIR_EraseRootFromParent_Done,
     /* 195308 */   // Label 3652: @195308
     /* 195308 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(195353), // Rule ID 1683 //
     /* 195313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195342 */     // (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 195345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195351 */     GIR_RootConstrainSelectedInstOperands,
     /* 195352 */     // GIR_Coverage, 1683,
     /* 195352 */     GIR_EraseRootFromParent_Done,
     /* 195353 */   // Label 3653: @195353
     /* 195353 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(195398), // Rule ID 1684 //
     /* 195358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 195366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195387 */     // (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 195390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195396 */     GIR_RootConstrainSelectedInstOperands,
     /* 195397 */     // GIR_Coverage, 1684,
     /* 195397 */     GIR_EraseRootFromParent_Done,
     /* 195398 */   // Label 3654: @195398
     /* 195398 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(195443), // Rule ID 1750 //
     /* 195403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 195411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 195435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195441 */     GIR_RootConstrainSelectedInstOperands,
     /* 195442 */     // GIR_Coverage, 1750,
     /* 195442 */     GIR_EraseRootFromParent_Done,
     /* 195443 */   // Label 3655: @195443
     /* 195443 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(195488), // Rule ID 1752 //
     /* 195448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 195456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195477 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 195480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195486 */     GIR_RootConstrainSelectedInstOperands,
     /* 195487 */     // GIR_Coverage, 1752,
     /* 195487 */     GIR_EraseRootFromParent_Done,
     /* 195488 */   // Label 3656: @195488
     /* 195488 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(195533), // Rule ID 2303 //
     /* 195493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 195496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 195501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 195522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 195525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195531 */     GIR_RootConstrainSelectedInstOperands,
     /* 195532 */     // GIR_Coverage, 2303,
     /* 195532 */     GIR_EraseRootFromParent_Done,
     /* 195533 */   // Label 3657: @195533
     /* 195533 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(195578), // Rule ID 2304 //
     /* 195538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 195541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 195546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195567 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 195567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 195570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195576 */     GIR_RootConstrainSelectedInstOperands,
     /* 195577 */     // GIR_Coverage, 2304,
     /* 195577 */     GIR_EraseRootFromParent_Done,
     /* 195578 */   // Label 3658: @195578
     /* 195578 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(195623), // Rule ID 2315 //
     /* 195583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 195586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 195591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195612 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 195612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 195615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195621 */     GIR_RootConstrainSelectedInstOperands,
     /* 195622 */     // GIR_Coverage, 2315,
     /* 195622 */     GIR_EraseRootFromParent_Done,
     /* 195623 */   // Label 3659: @195623
     /* 195623 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(195668), // Rule ID 2316 //
     /* 195628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 195631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 195636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 195657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 195660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 195664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 195666 */     GIR_RootConstrainSelectedInstOperands,
     /* 195667 */     // GIR_Coverage, 2316,
     /* 195667 */     GIR_EraseRootFromParent_Done,
     /* 195668 */   // Label 3660: @195668
     /* 195668 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(195713), // Rule ID 2339 //
     /* 195673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195702 */     // (intrinsic_wo_chain:{ *:[v4f16] } 638:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 195705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195711 */     GIR_RootConstrainSelectedInstOperands,
     /* 195712 */     // GIR_Coverage, 2339,
     /* 195712 */     GIR_EraseRootFromParent_Done,
     /* 195713 */   // Label 3661: @195713
     /* 195713 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(195758), // Rule ID 2340 //
     /* 195718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195747 */     // (intrinsic_wo_chain:{ *:[v8f16] } 638:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 195750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195756 */     GIR_RootConstrainSelectedInstOperands,
     /* 195757 */     // GIR_Coverage, 2340,
     /* 195757 */     GIR_EraseRootFromParent_Done,
     /* 195758 */   // Label 3662: @195758
     /* 195758 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(195803), // Rule ID 2341 //
     /* 195763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195792 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 195795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195801 */     GIR_RootConstrainSelectedInstOperands,
     /* 195802 */     // GIR_Coverage, 2341,
     /* 195802 */     GIR_EraseRootFromParent_Done,
     /* 195803 */   // Label 3663: @195803
     /* 195803 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(195848), // Rule ID 2342 //
     /* 195808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195837 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 195840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195846 */     GIR_RootConstrainSelectedInstOperands,
     /* 195847 */     // GIR_Coverage, 2342,
     /* 195847 */     GIR_EraseRootFromParent_Done,
     /* 195848 */   // Label 3664: @195848
     /* 195848 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(195893), // Rule ID 2343 //
     /* 195853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 195856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 195861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195882 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 195885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195891 */     GIR_RootConstrainSelectedInstOperands,
     /* 195892 */     // GIR_Coverage, 2343,
     /* 195892 */     GIR_EraseRootFromParent_Done,
     /* 195893 */   // Label 3665: @195893
     /* 195893 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(195938), // Rule ID 2344 //
     /* 195898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195927 */     // (intrinsic_wo_chain:{ *:[v4f16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 195927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 195930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195936 */     GIR_RootConstrainSelectedInstOperands,
     /* 195937 */     // GIR_Coverage, 2344,
     /* 195937 */     GIR_EraseRootFromParent_Done,
     /* 195938 */   // Label 3666: @195938
     /* 195938 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(195983), // Rule ID 2347 //
     /* 195943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195972 */     // (intrinsic_wo_chain:{ *:[v8f16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 195972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 195975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195981 */     GIR_RootConstrainSelectedInstOperands,
     /* 195982 */     // GIR_Coverage, 2347,
     /* 195982 */     GIR_EraseRootFromParent_Done,
     /* 195983 */   // Label 3667: @195983
     /* 195983 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196028), // Rule ID 2350 //
     /* 195988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 195991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 195996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196017 */     // (intrinsic_wo_chain:{ *:[v2f32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 196017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 196020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196026 */     GIR_RootConstrainSelectedInstOperands,
     /* 196027 */     // GIR_Coverage, 2350,
     /* 196027 */     GIR_EraseRootFromParent_Done,
     /* 196028 */   // Label 3668: @196028
     /* 196028 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196073), // Rule ID 2353 //
     /* 196033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 196041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 196062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 196065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196071 */     GIR_RootConstrainSelectedInstOperands,
     /* 196072 */     // GIR_Coverage, 2353,
     /* 196072 */     GIR_EraseRootFromParent_Done,
     /* 196073 */   // Label 3669: @196073
     /* 196073 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196118), // Rule ID 2356 //
     /* 196078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 196086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196107 */     // (intrinsic_wo_chain:{ *:[v2f64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 196107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 196110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196116 */     GIR_RootConstrainSelectedInstOperands,
     /* 196117 */     // GIR_Coverage, 2356,
     /* 196117 */     GIR_EraseRootFromParent_Done,
     /* 196118 */   // Label 3670: @196118
     /* 196118 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(196163), // Rule ID 2359 //
     /* 196123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196152 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 196152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 196155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196161 */     GIR_RootConstrainSelectedInstOperands,
     /* 196162 */     // GIR_Coverage, 2359,
     /* 196162 */     GIR_EraseRootFromParent_Done,
     /* 196163 */   // Label 3671: @196163
     /* 196163 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(196208), // Rule ID 2362 //
     /* 196168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196197 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 196197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 196200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196206 */     GIR_RootConstrainSelectedInstOperands,
     /* 196207 */     // GIR_Coverage, 2362,
     /* 196207 */     GIR_EraseRootFromParent_Done,
     /* 196208 */   // Label 3672: @196208
     /* 196208 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(196253), // Rule ID 2365 //
     /* 196213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196242 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 196242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 196245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196251 */     GIR_RootConstrainSelectedInstOperands,
     /* 196252 */     // GIR_Coverage, 2365,
     /* 196252 */     GIR_EraseRootFromParent_Done,
     /* 196253 */   // Label 3673: @196253
     /* 196253 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(196298), // Rule ID 2368 //
     /* 196258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196287 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 196287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 196290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196296 */     GIR_RootConstrainSelectedInstOperands,
     /* 196297 */     // GIR_Coverage, 2368,
     /* 196297 */     GIR_EraseRootFromParent_Done,
     /* 196298 */   // Label 3674: @196298
     /* 196298 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(196343), // Rule ID 2371 //
     /* 196303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 196306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 196311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196332 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 196332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 196335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196341 */     GIR_RootConstrainSelectedInstOperands,
     /* 196342 */     // GIR_Coverage, 2371,
     /* 196342 */     GIR_EraseRootFromParent_Done,
     /* 196343 */   // Label 3675: @196343
     /* 196343 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(196388), // Rule ID 2501 //
     /* 196348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 196356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196377 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 196377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 196380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196386 */     GIR_RootConstrainSelectedInstOperands,
     /* 196387 */     // GIR_Coverage, 2501,
     /* 196387 */     GIR_EraseRootFromParent_Done,
     /* 196388 */   // Label 3676: @196388
     /* 196388 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(196433), // Rule ID 2502 //
     /* 196393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 196401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196422 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 196422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 196425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196431 */     GIR_RootConstrainSelectedInstOperands,
     /* 196432 */     // GIR_Coverage, 2502,
     /* 196432 */     GIR_EraseRootFromParent_Done,
     /* 196433 */   // Label 3677: @196433
     /* 196433 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(196478), // Rule ID 2503 //
     /* 196438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196467 */     // (intrinsic_wo_chain:{ *:[v1f64] } 792:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 196467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 196470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196476 */     GIR_RootConstrainSelectedInstOperands,
     /* 196477 */     // GIR_Coverage, 2503,
     /* 196477 */     GIR_EraseRootFromParent_Done,
     /* 196478 */   // Label 3678: @196478
     /* 196478 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(196523), // Rule ID 2504 //
     /* 196483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196512 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 196512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 196515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196521 */     GIR_RootConstrainSelectedInstOperands,
     /* 196522 */     // GIR_Coverage, 2504,
     /* 196522 */     GIR_EraseRootFromParent_Done,
     /* 196523 */   // Label 3679: @196523
     /* 196523 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(196568), // Rule ID 2509 //
     /* 196528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196557 */     // (intrinsic_wo_chain:{ *:[v1i64] } 722:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 196557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196566 */     GIR_RootConstrainSelectedInstOperands,
     /* 196567 */     // GIR_Coverage, 2509,
     /* 196567 */     GIR_EraseRootFromParent_Done,
     /* 196568 */   // Label 3680: @196568
     /* 196568 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(196613), // Rule ID 2627 //
     /* 196573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 196590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196602 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 196605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196611 */     GIR_RootConstrainSelectedInstOperands,
     /* 196612 */     // GIR_Coverage, 2627,
     /* 196612 */     GIR_EraseRootFromParent_Done,
     /* 196613 */   // Label 3681: @196613
     /* 196613 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(196658), // Rule ID 2628 //
     /* 196618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 196635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196647 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 196650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196656 */     GIR_RootConstrainSelectedInstOperands,
     /* 196657 */     // GIR_Coverage, 2628,
     /* 196657 */     GIR_EraseRootFromParent_Done,
     /* 196658 */   // Label 3682: @196658
     /* 196658 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(196703), // Rule ID 2629 //
     /* 196663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 196680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196692 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 196695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196701 */     GIR_RootConstrainSelectedInstOperands,
     /* 196702 */     // GIR_Coverage, 2629,
     /* 196702 */     GIR_EraseRootFromParent_Done,
     /* 196703 */   // Label 3683: @196703
     /* 196703 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(196748), // Rule ID 2630 //
     /* 196708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 196716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 196725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 196733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196737 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 196737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 196740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196746 */     GIR_RootConstrainSelectedInstOperands,
     /* 196747 */     // GIR_Coverage, 2630,
     /* 196747 */     GIR_EraseRootFromParent_Done,
     /* 196748 */   // Label 3684: @196748
     /* 196748 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(196793), // Rule ID 2631 //
     /* 196753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 196770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196782 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 196785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196791 */     GIR_RootConstrainSelectedInstOperands,
     /* 196792 */     // GIR_Coverage, 2631,
     /* 196792 */     GIR_EraseRootFromParent_Done,
     /* 196793 */   // Label 3685: @196793
     /* 196793 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(196838), // Rule ID 2632 //
     /* 196798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 196815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196827 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 196830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196836 */     GIR_RootConstrainSelectedInstOperands,
     /* 196837 */     // GIR_Coverage, 2632,
     /* 196837 */     GIR_EraseRootFromParent_Done,
     /* 196838 */   // Label 3686: @196838
     /* 196838 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(196883), // Rule ID 2633 //
     /* 196843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 196860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196872 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 196875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196881 */     GIR_RootConstrainSelectedInstOperands,
     /* 196882 */     // GIR_Coverage, 2633,
     /* 196882 */     GIR_EraseRootFromParent_Done,
     /* 196883 */   // Label 3687: @196883
     /* 196883 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(196928), // Rule ID 2634 //
     /* 196888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 196896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 196905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 196913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196917 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 196917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 196920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 196922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 196924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196926 */     GIR_RootConstrainSelectedInstOperands,
     /* 196927 */     // GIR_Coverage, 2634,
     /* 196927 */     GIR_EraseRootFromParent_Done,
     /* 196928 */   // Label 3688: @196928
     /* 196928 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(196973), // Rule ID 3812 //
     /* 196933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 196936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 196941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 539:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 196962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 196965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 196967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 196969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 196971 */     GIR_RootConstrainSelectedInstOperands,
     /* 196972 */     // GIR_Coverage, 3812,
     /* 196972 */     GIR_EraseRootFromParent_Done,
     /* 196973 */   // Label 3689: @196973
     /* 196973 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197018), // Rule ID 3840 //
     /* 196978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 196981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 196986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197007 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 197007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 197010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 197014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 197016 */     GIR_RootConstrainSelectedInstOperands,
     /* 197017 */     // GIR_Coverage, 3840,
     /* 197017 */     GIR_EraseRootFromParent_Done,
     /* 197018 */   // Label 3690: @197018
     /* 197018 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197063), // Rule ID 3850 //
     /* 197023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 197026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 197031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 197052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 197055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 197059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 197061 */     GIR_RootConstrainSelectedInstOperands,
     /* 197062 */     // GIR_Coverage, 3850,
     /* 197062 */     GIR_EraseRootFromParent_Done,
     /* 197063 */   // Label 3691: @197063
     /* 197063 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197108), // Rule ID 3851 //
     /* 197068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 197071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 197076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197097 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 197097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 197100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 197102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 197104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 197106 */     GIR_RootConstrainSelectedInstOperands,
     /* 197107 */     // GIR_Coverage, 3851,
     /* 197107 */     GIR_EraseRootFromParent_Done,
     /* 197108 */   // Label 3692: @197108
     /* 197108 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(197156), // Rule ID 3852 //
     /* 197113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197142 */     // (intrinsic_wo_chain:{ *:[v4f16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 197142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 197145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197154 */     GIR_RootConstrainSelectedInstOperands,
     /* 197155 */     // GIR_Coverage, 3852,
     /* 197155 */     GIR_EraseRootFromParent_Done,
     /* 197156 */   // Label 3693: @197156
     /* 197156 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(197204), // Rule ID 3853 //
     /* 197161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197190 */     // (intrinsic_wo_chain:{ *:[v4f16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 197190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 197193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197202 */     GIR_RootConstrainSelectedInstOperands,
     /* 197203 */     // GIR_Coverage, 3853,
     /* 197203 */     GIR_EraseRootFromParent_Done,
     /* 197204 */   // Label 3694: @197204
     /* 197204 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(197252), // Rule ID 3854 //
     /* 197209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197238 */     // (intrinsic_wo_chain:{ *:[v8f16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 197238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 197241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197250 */     GIR_RootConstrainSelectedInstOperands,
     /* 197251 */     // GIR_Coverage, 3854,
     /* 197251 */     GIR_EraseRootFromParent_Done,
     /* 197252 */   // Label 3695: @197252
     /* 197252 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(197300), // Rule ID 3855 //
     /* 197257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 197260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197286 */     // (intrinsic_wo_chain:{ *:[v8f16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 197286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 197289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197298 */     GIR_RootConstrainSelectedInstOperands,
     /* 197299 */     // GIR_Coverage, 3855,
     /* 197299 */     GIR_EraseRootFromParent_Done,
     /* 197300 */   // Label 3696: @197300
     /* 197300 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(197348), // Rule ID 3856 //
     /* 197305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197334 */     // (intrinsic_wo_chain:{ *:[v2f32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 197334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 197337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197346 */     GIR_RootConstrainSelectedInstOperands,
     /* 197347 */     // GIR_Coverage, 3856,
     /* 197347 */     GIR_EraseRootFromParent_Done,
     /* 197348 */   // Label 3697: @197348
     /* 197348 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(197396), // Rule ID 3857 //
     /* 197353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197382 */     // (intrinsic_wo_chain:{ *:[v2f32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 197382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 197385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197394 */     GIR_RootConstrainSelectedInstOperands,
     /* 197395 */     // GIR_Coverage, 3857,
     /* 197395 */     GIR_EraseRootFromParent_Done,
     /* 197396 */   // Label 3698: @197396
     /* 197396 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(197444), // Rule ID 3858 //
     /* 197401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197430 */     // (intrinsic_wo_chain:{ *:[v4f32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 197430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 197433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197442 */     GIR_RootConstrainSelectedInstOperands,
     /* 197443 */     // GIR_Coverage, 3858,
     /* 197443 */     GIR_EraseRootFromParent_Done,
     /* 197444 */   // Label 3699: @197444
     /* 197444 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(197492), // Rule ID 3859 //
     /* 197449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197478 */     // (intrinsic_wo_chain:{ *:[v4f32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 197478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 197481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197490 */     GIR_RootConstrainSelectedInstOperands,
     /* 197491 */     // GIR_Coverage, 3859,
     /* 197491 */     GIR_EraseRootFromParent_Done,
     /* 197492 */   // Label 3700: @197492
     /* 197492 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(197540), // Rule ID 3860 //
     /* 197497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 197505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197526 */     // (intrinsic_wo_chain:{ *:[v2f64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 197526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 197529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197538 */     GIR_RootConstrainSelectedInstOperands,
     /* 197539 */     // GIR_Coverage, 3860,
     /* 197539 */     GIR_EraseRootFromParent_Done,
     /* 197540 */   // Label 3701: @197540
     /* 197540 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(197588), // Rule ID 3861 //
     /* 197545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 197548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 197553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197574 */     // (intrinsic_wo_chain:{ *:[v2f64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 197574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 197577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197586 */     GIR_RootConstrainSelectedInstOperands,
     /* 197587 */     // GIR_Coverage, 3861,
     /* 197587 */     GIR_EraseRootFromParent_Done,
     /* 197588 */   // Label 3702: @197588
     /* 197588 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(197630), // Rule ID 3926 //
     /* 197593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 197598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197619 */     // (intrinsic_wo_chain:{ *:[i32] } 2176:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 197619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 197622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197628 */     GIR_RootConstrainSelectedInstOperands,
     /* 197629 */     // GIR_Coverage, 3926,
     /* 197629 */     GIR_EraseRootFromParent_Done,
     /* 197630 */   // Label 3703: @197630
     /* 197630 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(197672), // Rule ID 3927 //
     /* 197635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 197640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197661 */     // (intrinsic_wo_chain:{ *:[i64] } 2176:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 197661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 197664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197670 */     GIR_RootConstrainSelectedInstOperands,
     /* 197671 */     // GIR_Coverage, 3927,
     /* 197671 */     GIR_EraseRootFromParent_Done,
     /* 197672 */   // Label 3704: @197672
     /* 197672 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(197714), // Rule ID 3928 //
     /* 197677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 197682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 197703 */     // (intrinsic_wo_chain:{ *:[i32] } 786:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 197703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 197706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197712 */     GIR_RootConstrainSelectedInstOperands,
     /* 197713 */     // GIR_Coverage, 3928,
     /* 197713 */     GIR_EraseRootFromParent_Done,
     /* 197714 */   // Label 3705: @197714
     /* 197714 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(197756), // Rule ID 3929 //
     /* 197719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 197724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 197745 */     // (intrinsic_wo_chain:{ *:[i64] } 786:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 197745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 197748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197754 */     GIR_RootConstrainSelectedInstOperands,
     /* 197755 */     // GIR_Coverage, 3929,
     /* 197755 */     GIR_EraseRootFromParent_Done,
     /* 197756 */   // Label 3706: @197756
     /* 197756 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(197798), // Rule ID 5219 //
     /* 197761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 197766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197787 */     // (intrinsic_wo_chain:{ *:[v1f64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 197790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197796 */     GIR_RootConstrainSelectedInstOperands,
     /* 197797 */     // GIR_Coverage, 5219,
     /* 197797 */     GIR_EraseRootFromParent_Done,
     /* 197798 */   // Label 3707: @197798
     /* 197798 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(197843), // Rule ID 5223 //
     /* 197803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 197811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197832 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 197835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197841 */     GIR_RootConstrainSelectedInstOperands,
     /* 197842 */     // GIR_Coverage, 5223,
     /* 197842 */     GIR_EraseRootFromParent_Done,
     /* 197843 */   // Label 3708: @197843
     /* 197843 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(197888), // Rule ID 5227 //
     /* 197848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197877 */     // (intrinsic_wo_chain:{ *:[v1f64] } 617:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 197880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197886 */     GIR_RootConstrainSelectedInstOperands,
     /* 197887 */     // GIR_Coverage, 5227,
     /* 197887 */     GIR_EraseRootFromParent_Done,
     /* 197888 */   // Label 3709: @197888
     /* 197888 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(197933), // Rule ID 5228 //
     /* 197893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197922 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 197925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197931 */     GIR_RootConstrainSelectedInstOperands,
     /* 197932 */     // GIR_Coverage, 5228,
     /* 197932 */     GIR_EraseRootFromParent_Done,
     /* 197933 */   // Label 3710: @197933
     /* 197933 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(197978), // Rule ID 5229 //
     /* 197938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197967 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 197970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197976 */     GIR_RootConstrainSelectedInstOperands,
     /* 197977 */     // GIR_Coverage, 5229,
     /* 197977 */     GIR_EraseRootFromParent_Done,
     /* 197978 */   // Label 3711: @197978
     /* 197978 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198023), // Rule ID 5230 //
     /* 197983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 197991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198012 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 198015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198021 */     GIR_RootConstrainSelectedInstOperands,
     /* 198022 */     // GIR_Coverage, 5230,
     /* 198022 */     GIR_EraseRootFromParent_Done,
     /* 198023 */   // Label 3712: @198023
     /* 198023 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198068), // Rule ID 5231 //
     /* 198028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 198036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198057 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 198060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198066 */     GIR_RootConstrainSelectedInstOperands,
     /* 198067 */     // GIR_Coverage, 5231,
     /* 198067 */     GIR_EraseRootFromParent_Done,
     /* 198068 */   // Label 3713: @198068
     /* 198068 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198113), // Rule ID 5232 //
     /* 198073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 198081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198102 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 198105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198111 */     GIR_RootConstrainSelectedInstOperands,
     /* 198112 */     // GIR_Coverage, 5232,
     /* 198112 */     GIR_EraseRootFromParent_Done,
     /* 198113 */   // Label 3714: @198113
     /* 198113 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(198158), // Rule ID 5233 //
     /* 198118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 198126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198147 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 198150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198156 */     GIR_RootConstrainSelectedInstOperands,
     /* 198157 */     // GIR_Coverage, 5233,
     /* 198157 */     GIR_EraseRootFromParent_Done,
     /* 198158 */   // Label 3715: @198158
     /* 198158 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(198203), // Rule ID 5234 //
     /* 198163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 198171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198192 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 198195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198201 */     GIR_RootConstrainSelectedInstOperands,
     /* 198202 */     // GIR_Coverage, 5234,
     /* 198202 */     GIR_EraseRootFromParent_Done,
     /* 198203 */   // Label 3716: @198203
     /* 198203 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(198248), // Rule ID 5235 //
     /* 198208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 198216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198237 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 198240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198246 */     GIR_RootConstrainSelectedInstOperands,
     /* 198247 */     // GIR_Coverage, 5235,
     /* 198247 */     GIR_EraseRootFromParent_Done,
     /* 198248 */   // Label 3717: @198248
     /* 198248 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(198293), // Rule ID 5236 //
     /* 198253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 198261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198282 */     // (intrinsic_wo_chain:{ *:[i64] } 746:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 198285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198291 */     GIR_RootConstrainSelectedInstOperands,
     /* 198292 */     // GIR_Coverage, 5236,
     /* 198292 */     GIR_EraseRootFromParent_Done,
     /* 198293 */   // Label 3718: @198293
     /* 198293 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(198338), // Rule ID 5237 //
     /* 198298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 198306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198327 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 198330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198336 */     GIR_RootConstrainSelectedInstOperands,
     /* 198337 */     // GIR_Coverage, 5237,
     /* 198337 */     GIR_EraseRootFromParent_Done,
     /* 198338 */   // Label 3719: @198338
     /* 198338 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(198383), // Rule ID 5238 //
     /* 198343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 198351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198372 */     // (intrinsic_wo_chain:{ *:[i64] } 747:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 198375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198381 */     GIR_RootConstrainSelectedInstOperands,
     /* 198382 */     // GIR_Coverage, 5238,
     /* 198382 */     GIR_EraseRootFromParent_Done,
     /* 198383 */   // Label 3720: @198383
     /* 198383 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(198428), // Rule ID 5239 //
     /* 198388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 198396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198417 */     // (intrinsic_wo_chain:{ *:[i32] } 747:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 198420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198426 */     GIR_RootConstrainSelectedInstOperands,
     /* 198427 */     // GIR_Coverage, 5239,
     /* 198427 */     GIR_EraseRootFromParent_Done,
     /* 198428 */   // Label 3721: @198428
     /* 198428 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(198473), // Rule ID 5240 //
     /* 198433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 198441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198462 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 198465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198471 */     GIR_RootConstrainSelectedInstOperands,
     /* 198472 */     // GIR_Coverage, 5240,
     /* 198472 */     GIR_EraseRootFromParent_Done,
     /* 198473 */   // Label 3722: @198473
     /* 198473 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(198518), // Rule ID 5241 //
     /* 198478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 198486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198507 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 198510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198516 */     GIR_RootConstrainSelectedInstOperands,
     /* 198517 */     // GIR_Coverage, 5241,
     /* 198517 */     GIR_EraseRootFromParent_Done,
     /* 198518 */   // Label 3723: @198518
     /* 198518 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(198563), // Rule ID 5242 //
     /* 198523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 198531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198552 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 198555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198561 */     GIR_RootConstrainSelectedInstOperands,
     /* 198562 */     // GIR_Coverage, 5242,
     /* 198562 */     GIR_EraseRootFromParent_Done,
     /* 198563 */   // Label 3724: @198563
     /* 198563 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(198608), // Rule ID 5243 //
     /* 198568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 198576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198597 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 198600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198606 */     GIR_RootConstrainSelectedInstOperands,
     /* 198607 */     // GIR_Coverage, 5243,
     /* 198607 */     GIR_EraseRootFromParent_Done,
     /* 198608 */   // Label 3725: @198608
     /* 198608 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(198653), // Rule ID 5262 //
     /* 198613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198642 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 198642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 198645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198651 */     GIR_RootConstrainSelectedInstOperands,
     /* 198652 */     // GIR_Coverage, 5262,
     /* 198652 */     GIR_EraseRootFromParent_Done,
     /* 198653 */   // Label 3726: @198653
     /* 198653 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(198695), // Rule ID 5596 //
     /* 198658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 198663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 198672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198684 */     // (intrinsic_wo_chain:{ *:[v8i8] } 723:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 198684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 198687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 198693 */     GIR_RootConstrainSelectedInstOperands,
     /* 198694 */     // GIR_Coverage, 5596,
     /* 198694 */     GIR_EraseRootFromParent_Done,
     /* 198695 */   // Label 3727: @198695
     /* 198695 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(198737), // Rule ID 5597 //
     /* 198700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 198705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 198714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198726 */     // (intrinsic_wo_chain:{ *:[v16i8] } 723:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 198726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 198729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 198733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198735 */     GIR_RootConstrainSelectedInstOperands,
     /* 198736 */     // GIR_Coverage, 5597,
     /* 198736 */     GIR_EraseRootFromParent_Done,
     /* 198737 */   // Label 3728: @198737
     /* 198737 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(198834), // Rule ID 6322 //
     /* 198742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 198747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 198753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 198756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198768 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 198768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 198771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 198775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 198784 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 198788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 198790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 198793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 198804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 198815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 198818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198833 */     // GIR_Coverage, 6322,
     /* 198833 */     GIR_EraseRootFromParent_Done,
     /* 198834 */   // Label 3729: @198834
     /* 198834 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(198931), // Rule ID 6323 //
     /* 198839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 198844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 198850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 198853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198865 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 198865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 198868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 198872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 198881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 198885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 198887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 198890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 198901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 198912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 198915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 198930 */     // GIR_Coverage, 6323,
     /* 198930 */     GIR_EraseRootFromParent_Done,
     /* 198931 */   // Label 3730: @198931
     /* 198931 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(198973), // Rule ID 6970 //
     /* 198936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 198941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198962 */     // (intrinsic_wo_chain:{ *:[i64] } 710:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 198962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 198965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198971 */     GIR_RootConstrainSelectedInstOperands,
     /* 198972 */     // GIR_Coverage, 6970,
     /* 198972 */     GIR_EraseRootFromParent_Done,
     /* 198973 */   // Label 3731: @198973
     /* 198973 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199015), // Rule ID 6971 //
     /* 198978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 198983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199004 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 199007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199013 */     GIR_RootConstrainSelectedInstOperands,
     /* 199014 */     // GIR_Coverage, 6971,
     /* 199014 */     GIR_EraseRootFromParent_Done,
     /* 199015 */   // Label 3732: @199015
     /* 199015 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199057), // Rule ID 6972 //
     /* 199020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 199025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199046 */     // (intrinsic_wo_chain:{ *:[i64] } 709:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 199049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199055 */     GIR_RootConstrainSelectedInstOperands,
     /* 199056 */     // GIR_Coverage, 6972,
     /* 199056 */     GIR_EraseRootFromParent_Done,
     /* 199057 */   // Label 3733: @199057
     /* 199057 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199099), // Rule ID 6973 //
     /* 199062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 199067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199088 */     // (intrinsic_wo_chain:{ *:[i64] } 755:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 199091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199097 */     GIR_RootConstrainSelectedInstOperands,
     /* 199098 */     // GIR_Coverage, 6973,
     /* 199098 */     GIR_EraseRootFromParent_Done,
     /* 199099 */   // Label 3734: @199099
     /* 199099 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199147), // Rule ID 7013 //
     /* 199104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 199109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199130 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 199130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 199133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 199142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 199145 */     GIR_RootConstrainSelectedInstOperands,
     /* 199146 */     // GIR_Coverage, 7013,
     /* 199146 */     GIR_EraseRootFromParent_Done,
     /* 199147 */   // Label 3735: @199147
     /* 199147 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199192), // Rule ID 10071 //
     /* 199152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199181 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 199184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199190 */     GIR_RootConstrainSelectedInstOperands,
     /* 199191 */     // GIR_Coverage, 10071,
     /* 199191 */     GIR_EraseRootFromParent_Done,
     /* 199192 */   // Label 3736: @199192
     /* 199192 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(199237), // Rule ID 10072 //
     /* 199197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199226 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199235 */     GIR_RootConstrainSelectedInstOperands,
     /* 199236 */     // GIR_Coverage, 10072,
     /* 199236 */     GIR_EraseRootFromParent_Done,
     /* 199237 */   // Label 3737: @199237
     /* 199237 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(199282), // Rule ID 10073 //
     /* 199242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199271 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199280 */     GIR_RootConstrainSelectedInstOperands,
     /* 199281 */     // GIR_Coverage, 10073,
     /* 199281 */     GIR_EraseRootFromParent_Done,
     /* 199282 */   // Label 3738: @199282
     /* 199282 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(199327), // Rule ID 10074 //
     /* 199287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 199295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199316 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199325 */     GIR_RootConstrainSelectedInstOperands,
     /* 199326 */     // GIR_Coverage, 10074,
     /* 199326 */     GIR_EraseRootFromParent_Done,
     /* 199327 */   // Label 3739: @199327
     /* 199327 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(199372), // Rule ID 10083 //
     /* 199332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199361 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 199364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199370 */     GIR_RootConstrainSelectedInstOperands,
     /* 199371 */     // GIR_Coverage, 10083,
     /* 199371 */     GIR_EraseRootFromParent_Done,
     /* 199372 */   // Label 3740: @199372
     /* 199372 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(199417), // Rule ID 10084 //
     /* 199377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199406 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199415 */     GIR_RootConstrainSelectedInstOperands,
     /* 199416 */     // GIR_Coverage, 10084,
     /* 199416 */     GIR_EraseRootFromParent_Done,
     /* 199417 */   // Label 3741: @199417
     /* 199417 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(199462), // Rule ID 10085 //
     /* 199422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199451 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 199454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199460 */     GIR_RootConstrainSelectedInstOperands,
     /* 199461 */     // GIR_Coverage, 10085,
     /* 199461 */     GIR_EraseRootFromParent_Done,
     /* 199462 */   // Label 3742: @199462
     /* 199462 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(199507), // Rule ID 10086 //
     /* 199467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 199475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199496 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199505 */     GIR_RootConstrainSelectedInstOperands,
     /* 199506 */     // GIR_Coverage, 10086,
     /* 199506 */     GIR_EraseRootFromParent_Done,
     /* 199507 */   // Label 3743: @199507
     /* 199507 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(199552), // Rule ID 10087 //
     /* 199512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199541 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 199544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199550 */     GIR_RootConstrainSelectedInstOperands,
     /* 199551 */     // GIR_Coverage, 10087,
     /* 199551 */     GIR_EraseRootFromParent_Done,
     /* 199552 */   // Label 3744: @199552
     /* 199552 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(199597), // Rule ID 10088 //
     /* 199557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199586 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199595 */     GIR_RootConstrainSelectedInstOperands,
     /* 199596 */     // GIR_Coverage, 10088,
     /* 199596 */     GIR_EraseRootFromParent_Done,
     /* 199597 */   // Label 3745: @199597
     /* 199597 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(199642), // Rule ID 10089 //
     /* 199602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199631 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199640 */     GIR_RootConstrainSelectedInstOperands,
     /* 199641 */     // GIR_Coverage, 10089,
     /* 199641 */     GIR_EraseRootFromParent_Done,
     /* 199642 */   // Label 3746: @199642
     /* 199642 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(199687), // Rule ID 10090 //
     /* 199647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 199655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199676 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 199676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199685 */     GIR_RootConstrainSelectedInstOperands,
     /* 199686 */     // GIR_Coverage, 10090,
     /* 199686 */     GIR_EraseRootFromParent_Done,
     /* 199687 */   // Label 3747: @199687
     /* 199687 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(199732), // Rule ID 10091 //
     /* 199692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199721 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 199724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199730 */     GIR_RootConstrainSelectedInstOperands,
     /* 199731 */     // GIR_Coverage, 10091,
     /* 199731 */     GIR_EraseRootFromParent_Done,
     /* 199732 */   // Label 3748: @199732
     /* 199732 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(199777), // Rule ID 10092 //
     /* 199737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 199754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199766 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199775 */     GIR_RootConstrainSelectedInstOperands,
     /* 199776 */     // GIR_Coverage, 10092,
     /* 199776 */     GIR_EraseRootFromParent_Done,
     /* 199777 */   // Label 3749: @199777
     /* 199777 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(199822), // Rule ID 10093 //
     /* 199782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 199799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199811 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199820 */     GIR_RootConstrainSelectedInstOperands,
     /* 199821 */     // GIR_Coverage, 10093,
     /* 199821 */     GIR_EraseRootFromParent_Done,
     /* 199822 */   // Label 3750: @199822
     /* 199822 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(199867), // Rule ID 10094 //
     /* 199827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 199835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 199844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199856 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 199856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 199863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199865 */     GIR_RootConstrainSelectedInstOperands,
     /* 199866 */     // GIR_Coverage, 10094,
     /* 199866 */     GIR_EraseRootFromParent_Done,
     /* 199867 */   // Label 3751: @199867
     /* 199867 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(199913), // Rule ID 138 //
     /* 199872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 199875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 199880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199890 */     // MIs[0] Rn
     /* 199890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199902 */     // (intrinsic_wo_chain:{ *:[i64] } 562:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 199905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199911 */     GIR_RootConstrainSelectedInstOperands,
     /* 199912 */     // GIR_Coverage, 138,
     /* 199912 */     GIR_EraseRootFromParent_Done,
     /* 199913 */   // Label 3752: @199913
     /* 199913 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(199960), // Rule ID 139 //
     /* 199918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 199921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 199926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199933 */     // MIs[0] Rn
     /* 199933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199941 */     // MIs[0] Rm
     /* 199941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 199949 */     // (intrinsic_wo_chain:{ *:[i64] } 1249:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 199949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 199952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199958 */     GIR_RootConstrainSelectedInstOperands,
     /* 199959 */     // GIR_Coverage, 139,
     /* 199959 */     GIR_EraseRootFromParent_Done,
     /* 199960 */   // Label 3753: @199960
     /* 199960 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(199997), // Rule ID 2399 //
     /* 199965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 199973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 199979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 199986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 199989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 199993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 199995 */     GIR_RootConstrainSelectedInstOperands,
     /* 199996 */     // GIR_Coverage, 2399,
     /* 199996 */     GIR_EraseRootFromParent_Done,
     /* 199997 */   // Label 3754: @199997
     /* 199997 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200034), // Rule ID 2400 //
     /* 200002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 200010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200023 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 200026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200032 */     GIR_RootConstrainSelectedInstOperands,
     /* 200033 */     // GIR_Coverage, 2400,
     /* 200033 */     GIR_EraseRootFromParent_Done,
     /* 200034 */   // Label 3755: @200034
     /* 200034 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200071), // Rule ID 2401 //
     /* 200039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 200047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2160:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 200063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200069 */     GIR_RootConstrainSelectedInstOperands,
     /* 200070 */     // GIR_Coverage, 2401,
     /* 200070 */     GIR_EraseRootFromParent_Done,
     /* 200071 */   // Label 3756: @200071
     /* 200071 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(200108), // Rule ID 2403 //
     /* 200076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 200084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 200100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200106 */     GIR_RootConstrainSelectedInstOperands,
     /* 200107 */     // GIR_Coverage, 2403,
     /* 200107 */     GIR_EraseRootFromParent_Done,
     /* 200108 */   // Label 3757: @200108
     /* 200108 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(200145), // Rule ID 2404 //
     /* 200113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 200121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200134 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2164:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 200137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200143 */     GIR_RootConstrainSelectedInstOperands,
     /* 200144 */     // GIR_Coverage, 2404,
     /* 200144 */     GIR_EraseRootFromParent_Done,
     /* 200145 */   // Label 3758: @200145
     /* 200145 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(200182), // Rule ID 2405 //
     /* 200150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 200158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200171 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2165:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 200174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200180 */     GIR_RootConstrainSelectedInstOperands,
     /* 200181 */     // GIR_Coverage, 2405,
     /* 200181 */     GIR_EraseRootFromParent_Done,
     /* 200182 */   // Label 3759: @200182
     /* 200182 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(200219), // Rule ID 2407 //
     /* 200187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 200195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 200211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200217 */     GIR_RootConstrainSelectedInstOperands,
     /* 200218 */     // GIR_Coverage, 2407,
     /* 200218 */     GIR_EraseRootFromParent_Done,
     /* 200219 */   // Label 3760: @200219
     /* 200219 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(200256), // Rule ID 2408 //
     /* 200224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 200232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200245 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2085:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 200248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200254 */     GIR_RootConstrainSelectedInstOperands,
     /* 200255 */     // GIR_Coverage, 2408,
     /* 200255 */     GIR_EraseRootFromParent_Done,
     /* 200256 */   // Label 3761: @200256
     /* 200256 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(200293), // Rule ID 2409 //
     /* 200261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 200269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2086:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 200285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200291 */     GIR_RootConstrainSelectedInstOperands,
     /* 200292 */     // GIR_Coverage, 2409,
     /* 200292 */     GIR_EraseRootFromParent_Done,
     /* 200293 */   // Label 3762: @200293
     /* 200293 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(200330), // Rule ID 2411 //
     /* 200298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 200306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200319 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 200322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200328 */     GIR_RootConstrainSelectedInstOperands,
     /* 200329 */     // GIR_Coverage, 2411,
     /* 200329 */     GIR_EraseRootFromParent_Done,
     /* 200330 */   // Label 3763: @200330
     /* 200330 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(200367), // Rule ID 2412 //
     /* 200335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 200343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200356 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 200359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200365 */     GIR_RootConstrainSelectedInstOperands,
     /* 200366 */     // GIR_Coverage, 2412,
     /* 200366 */     GIR_EraseRootFromParent_Done,
     /* 200367 */   // Label 3764: @200367
     /* 200367 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(200404), // Rule ID 2413 //
     /* 200372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 200380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200393 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2091:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 200396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200402 */     GIR_RootConstrainSelectedInstOperands,
     /* 200403 */     // GIR_Coverage, 2413,
     /* 200403 */     GIR_EraseRootFromParent_Done,
     /* 200404 */   // Label 3765: @200404
     /* 200404 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(200441), // Rule ID 2415 //
     /* 200409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 200417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 200433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200439 */     GIR_RootConstrainSelectedInstOperands,
     /* 200440 */     // GIR_Coverage, 2415,
     /* 200440 */     GIR_EraseRootFromParent_Done,
     /* 200441 */   // Label 3766: @200441
     /* 200441 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(200478), // Rule ID 2416 //
     /* 200446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 200454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 200470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200476 */     GIR_RootConstrainSelectedInstOperands,
     /* 200477 */     // GIR_Coverage, 2416,
     /* 200477 */     GIR_EraseRootFromParent_Done,
     /* 200478 */   // Label 3767: @200478
     /* 200478 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(200515), // Rule ID 2417 //
     /* 200483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 200491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1930:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 200507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200513 */     GIR_RootConstrainSelectedInstOperands,
     /* 200514 */     // GIR_Coverage, 2417,
     /* 200514 */     GIR_EraseRootFromParent_Done,
     /* 200515 */   // Label 3768: @200515
     /* 200515 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(200552), // Rule ID 2419 //
     /* 200520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 200528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 200544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200550 */     GIR_RootConstrainSelectedInstOperands,
     /* 200551 */     // GIR_Coverage, 2419,
     /* 200551 */     GIR_EraseRootFromParent_Done,
     /* 200552 */   // Label 3769: @200552
     /* 200552 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(200589), // Rule ID 2420 //
     /* 200557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 200565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1934:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 200581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200587 */     GIR_RootConstrainSelectedInstOperands,
     /* 200588 */     // GIR_Coverage, 2420,
     /* 200588 */     GIR_EraseRootFromParent_Done,
     /* 200589 */   // Label 3770: @200589
     /* 200589 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(200626), // Rule ID 2421 //
     /* 200594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 200602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200615 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1935:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 200615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 200618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 200620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 200622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 200624 */     GIR_RootConstrainSelectedInstOperands,
     /* 200625 */     // GIR_Coverage, 2421,
     /* 200625 */     GIR_EraseRootFromParent_Done,
     /* 200626 */   // Label 3771: @200626
     /* 200626 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(200663), // Rule ID 2422 //
     /* 200631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 200634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 200639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 200642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 200645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 200648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1553:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 200652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 200655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 200657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 200661 */     GIR_RootConstrainSelectedInstOperands,
     /* 200662 */     // GIR_Coverage, 2422,
     /* 200662 */     GIR_EraseRootFromParent_Done,
     /* 200663 */   // Label 3772: @200663
     /* 200663 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(200703), // Rule ID 2614 //
     /* 200668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 200676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200689 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1632:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 200689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 200692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200701 */     GIR_RootConstrainSelectedInstOperands,
     /* 200702 */     // GIR_Coverage, 2614,
     /* 200702 */     GIR_EraseRootFromParent_Done,
     /* 200703 */   // Label 3773: @200703
     /* 200703 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(200743), // Rule ID 2615 //
     /* 200708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 200719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1640:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 200729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 200732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200741 */     GIR_RootConstrainSelectedInstOperands,
     /* 200742 */     // GIR_Coverage, 2615,
     /* 200742 */     GIR_EraseRootFromParent_Done,
     /* 200743 */   // Label 3774: @200743
     /* 200743 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(200783), // Rule ID 2616 //
     /* 200748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 200759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200769 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1640:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 200769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 200772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200781 */     GIR_RootConstrainSelectedInstOperands,
     /* 200782 */     // GIR_Coverage, 2616,
     /* 200782 */     GIR_EraseRootFromParent_Done,
     /* 200783 */   // Label 3775: @200783
     /* 200783 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(200823), // Rule ID 2617 //
     /* 200788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 200799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200809 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1640:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 200809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 200812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200821 */     GIR_RootConstrainSelectedInstOperands,
     /* 200822 */     // GIR_Coverage, 2617,
     /* 200822 */     GIR_EraseRootFromParent_Done,
     /* 200823 */   // Label 3776: @200823
     /* 200823 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(200863), // Rule ID 2618 //
     /* 200828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 200836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 200839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200849 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1640:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 200849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 200852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 200854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 200861 */     GIR_RootConstrainSelectedInstOperands,
     /* 200862 */     // GIR_Coverage, 2618,
     /* 200862 */     GIR_EraseRootFromParent_Done,
     /* 200863 */   // Label 3777: @200863
     /* 200863 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(200900), // Rule ID 2635 //
     /* 200868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 200889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 200892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200898 */     GIR_RootConstrainSelectedInstOperands,
     /* 200899 */     // GIR_Coverage, 2635,
     /* 200899 */     GIR_EraseRootFromParent_Done,
     /* 200900 */   // Label 3778: @200900
     /* 200900 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(200937), // Rule ID 2636 //
     /* 200905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 200919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 200926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 200929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200935 */     GIR_RootConstrainSelectedInstOperands,
     /* 200936 */     // GIR_Coverage, 2636,
     /* 200936 */     GIR_EraseRootFromParent_Done,
     /* 200937 */   // Label 3779: @200937
     /* 200937 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(200974), // Rule ID 2637 //
     /* 200942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 200950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 200956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200963 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 200963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 200966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 200970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 200972 */     GIR_RootConstrainSelectedInstOperands,
     /* 200973 */     // GIR_Coverage, 2637,
     /* 200973 */     GIR_EraseRootFromParent_Done,
     /* 200974 */   // Label 3780: @200974
     /* 200974 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(201011), // Rule ID 2638 //
     /* 200979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 200987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 200993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201000 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 201000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 201003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201009 */     GIR_RootConstrainSelectedInstOperands,
     /* 201010 */     // GIR_Coverage, 2638,
     /* 201010 */     GIR_EraseRootFromParent_Done,
     /* 201011 */   // Label 3781: @201011
     /* 201011 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(201048), // Rule ID 2639 //
     /* 201016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 201024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201037 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 201037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 201040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201046 */     GIR_RootConstrainSelectedInstOperands,
     /* 201047 */     // GIR_Coverage, 2639,
     /* 201047 */     GIR_EraseRootFromParent_Done,
     /* 201048 */   // Label 3782: @201048
     /* 201048 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(201085), // Rule ID 2640 //
     /* 201053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 201061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201074 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 201074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 201077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201083 */     GIR_RootConstrainSelectedInstOperands,
     /* 201084 */     // GIR_Coverage, 2640,
     /* 201084 */     GIR_EraseRootFromParent_Done,
     /* 201085 */   // Label 3783: @201085
     /* 201085 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(201122), // Rule ID 2641 //
     /* 201090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 201098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201111 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 201111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 201114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201120 */     GIR_RootConstrainSelectedInstOperands,
     /* 201121 */     // GIR_Coverage, 2641,
     /* 201121 */     GIR_EraseRootFromParent_Done,
     /* 201122 */   // Label 3784: @201122
     /* 201122 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(201159), // Rule ID 2819 //
     /* 201127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 201135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201148 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1550:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 201151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201157 */     GIR_RootConstrainSelectedInstOperands,
     /* 201158 */     // GIR_Coverage, 2819,
     /* 201158 */     GIR_EraseRootFromParent_Done,
     /* 201159 */   // Label 3785: @201159
     /* 201159 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(201196), // Rule ID 2820 //
     /* 201164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 201172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1550:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 201188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201194 */     GIR_RootConstrainSelectedInstOperands,
     /* 201195 */     // GIR_Coverage, 2820,
     /* 201195 */     GIR_EraseRootFromParent_Done,
     /* 201196 */   // Label 3786: @201196
     /* 201196 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(201233), // Rule ID 2821 //
     /* 201201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 201209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1550:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 201225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201231 */     GIR_RootConstrainSelectedInstOperands,
     /* 201232 */     // GIR_Coverage, 2821,
     /* 201232 */     GIR_EraseRootFromParent_Done,
     /* 201233 */   // Label 3787: @201233
     /* 201233 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(201270), // Rule ID 2992 //
     /* 201238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1802:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 201262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201268 */     GIR_RootConstrainSelectedInstOperands,
     /* 201269 */     // GIR_Coverage, 2992,
     /* 201269 */     GIR_EraseRootFromParent_Done,
     /* 201270 */   // Label 3788: @201270
     /* 201270 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(201307), // Rule ID 2993 //
     /* 201275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 201299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201305 */     GIR_RootConstrainSelectedInstOperands,
     /* 201306 */     // GIR_Coverage, 2993,
     /* 201306 */     GIR_EraseRootFromParent_Done,
     /* 201307 */   // Label 3789: @201307
     /* 201307 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(201344), // Rule ID 2994 //
     /* 201312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 201336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201342 */     GIR_RootConstrainSelectedInstOperands,
     /* 201343 */     // GIR_Coverage, 2994,
     /* 201343 */     GIR_EraseRootFromParent_Done,
     /* 201344 */   // Label 3790: @201344
     /* 201344 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(201381), // Rule ID 2995 //
     /* 201349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 201357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 201373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201379 */     GIR_RootConstrainSelectedInstOperands,
     /* 201380 */     // GIR_Coverage, 2995,
     /* 201380 */     GIR_EraseRootFromParent_Done,
     /* 201381 */   // Label 3791: @201381
     /* 201381 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(201418), // Rule ID 2996 //
     /* 201386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 201394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 201410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201416 */     GIR_RootConstrainSelectedInstOperands,
     /* 201417 */     // GIR_Coverage, 2996,
     /* 201417 */     GIR_EraseRootFromParent_Done,
     /* 201418 */   // Label 3792: @201418
     /* 201418 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(201455), // Rule ID 3018 //
     /* 201423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 201447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201453 */     GIR_RootConstrainSelectedInstOperands,
     /* 201454 */     // GIR_Coverage, 3018,
     /* 201454 */     GIR_EraseRootFromParent_Done,
     /* 201455 */   // Label 3793: @201455
     /* 201455 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(201492), // Rule ID 3019 //
     /* 201460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 201484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201490 */     GIR_RootConstrainSelectedInstOperands,
     /* 201491 */     // GIR_Coverage, 3019,
     /* 201491 */     GIR_EraseRootFromParent_Done,
     /* 201492 */   // Label 3794: @201492
     /* 201492 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(201529), // Rule ID 3020 //
     /* 201497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 201505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 201521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201527 */     GIR_RootConstrainSelectedInstOperands,
     /* 201528 */     // GIR_Coverage, 3020,
     /* 201528 */     GIR_EraseRootFromParent_Done,
     /* 201529 */   // Label 3795: @201529
     /* 201529 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(201566), // Rule ID 3024 //
     /* 201534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 201537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 201558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201564 */     GIR_RootConstrainSelectedInstOperands,
     /* 201565 */     // GIR_Coverage, 3024,
     /* 201565 */     GIR_EraseRootFromParent_Done,
     /* 201566 */   // Label 3796: @201566
     /* 201566 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(201603), // Rule ID 3025 //
     /* 201571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1638:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 201595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201601 */     GIR_RootConstrainSelectedInstOperands,
     /* 201602 */     // GIR_Coverage, 3025,
     /* 201602 */     GIR_EraseRootFromParent_Done,
     /* 201603 */   // Label 3797: @201603
     /* 201603 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(201640), // Rule ID 3026 //
     /* 201608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 201616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 201632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201638 */     GIR_RootConstrainSelectedInstOperands,
     /* 201639 */     // GIR_Coverage, 3026,
     /* 201639 */     GIR_EraseRootFromParent_Done,
     /* 201640 */   // Label 3798: @201640
     /* 201640 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(201677), // Rule ID 3027 //
     /* 201645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1280:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 201669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201675 */     GIR_RootConstrainSelectedInstOperands,
     /* 201676 */     // GIR_Coverage, 3027,
     /* 201676 */     GIR_EraseRootFromParent_Done,
     /* 201677 */   // Label 3799: @201677
     /* 201677 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(201714), // Rule ID 3028 //
     /* 201682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1280:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 201706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201712 */     GIR_RootConstrainSelectedInstOperands,
     /* 201713 */     // GIR_Coverage, 3028,
     /* 201713 */     GIR_EraseRootFromParent_Done,
     /* 201714 */   // Label 3800: @201714
     /* 201714 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(201751), // Rule ID 3029 //
     /* 201719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1280:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 201743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201749 */     GIR_RootConstrainSelectedInstOperands,
     /* 201750 */     // GIR_Coverage, 3029,
     /* 201750 */     GIR_EraseRootFromParent_Done,
     /* 201751 */   // Label 3801: @201751
     /* 201751 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(201788), // Rule ID 3030 //
     /* 201756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 201759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 201764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1280:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 201780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201786 */     GIR_RootConstrainSelectedInstOperands,
     /* 201787 */     // GIR_Coverage, 3030,
     /* 201787 */     GIR_EraseRootFromParent_Done,
     /* 201788 */   // Label 3802: @201788
     /* 201788 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(201825), // Rule ID 3031 //
     /* 201793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 201807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 201810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 201814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 201817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201823 */     GIR_RootConstrainSelectedInstOperands,
     /* 201824 */     // GIR_Coverage, 3031,
     /* 201824 */     GIR_EraseRootFromParent_Done,
     /* 201825 */   // Label 3803: @201825
     /* 201825 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(201862), // Rule ID 3032 //
     /* 201830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 201854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201860 */     GIR_RootConstrainSelectedInstOperands,
     /* 201861 */     // GIR_Coverage, 3032,
     /* 201861 */     GIR_EraseRootFromParent_Done,
     /* 201862 */   // Label 3804: @201862
     /* 201862 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(201899), // Rule ID 3033 //
     /* 201867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 201875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201897 */     GIR_RootConstrainSelectedInstOperands,
     /* 201898 */     // GIR_Coverage, 3033,
     /* 201898 */     GIR_EraseRootFromParent_Done,
     /* 201899 */   // Label 3805: @201899
     /* 201899 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(201936), // Rule ID 3080 //
     /* 201904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 201915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 201925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 201928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201934 */     GIR_RootConstrainSelectedInstOperands,
     /* 201935 */     // GIR_Coverage, 3080,
     /* 201935 */     GIR_EraseRootFromParent_Done,
     /* 201936 */   // Label 3806: @201936
     /* 201936 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(201973), // Rule ID 3081 //
     /* 201941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 201962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 201965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 201969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 201971 */     GIR_RootConstrainSelectedInstOperands,
     /* 201972 */     // GIR_Coverage, 3081,
     /* 201972 */     GIR_EraseRootFromParent_Done,
     /* 201973 */   // Label 3807: @201973
     /* 201973 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(202010), // Rule ID 3082 //
     /* 201978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 201981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 201986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 201999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 202002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202008 */     GIR_RootConstrainSelectedInstOperands,
     /* 202009 */     // GIR_Coverage, 3082,
     /* 202009 */     GIR_EraseRootFromParent_Done,
     /* 202010 */   // Label 3808: @202010
     /* 202010 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(202047), // Rule ID 3089 //
     /* 202015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 202023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202036 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1859:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 202039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202045 */     GIR_RootConstrainSelectedInstOperands,
     /* 202046 */     // GIR_Coverage, 3089,
     /* 202046 */     GIR_EraseRootFromParent_Done,
     /* 202047 */   // Label 3809: @202047
     /* 202047 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(202084), // Rule ID 3090 //
     /* 202052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 202060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1859:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 202076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202082 */     GIR_RootConstrainSelectedInstOperands,
     /* 202083 */     // GIR_Coverage, 3090,
     /* 202083 */     GIR_EraseRootFromParent_Done,
     /* 202084 */   // Label 3810: @202084
     /* 202084 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(202121), // Rule ID 3091 //
     /* 202089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 202097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 202113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202119 */     GIR_RootConstrainSelectedInstOperands,
     /* 202120 */     // GIR_Coverage, 3091,
     /* 202120 */     GIR_EraseRootFromParent_Done,
     /* 202121 */   // Label 3811: @202121
     /* 202121 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(202161), // Rule ID 3195 //
     /* 202126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 202150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202159 */     GIR_RootConstrainSelectedInstOperands,
     /* 202160 */     // GIR_Coverage, 3195,
     /* 202160 */     GIR_EraseRootFromParent_Done,
     /* 202161 */   // Label 3812: @202161
     /* 202161 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(202201), // Rule ID 3196 //
     /* 202166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 202190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202199 */     GIR_RootConstrainSelectedInstOperands,
     /* 202200 */     // GIR_Coverage, 3196,
     /* 202200 */     GIR_EraseRootFromParent_Done,
     /* 202201 */   // Label 3813: @202201
     /* 202201 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(202241), // Rule ID 3197 //
     /* 202206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202227 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 202230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202239 */     GIR_RootConstrainSelectedInstOperands,
     /* 202240 */     // GIR_Coverage, 3197,
     /* 202240 */     GIR_EraseRootFromParent_Done,
     /* 202241 */   // Label 3814: @202241
     /* 202241 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(202281), // Rule ID 3198 //
     /* 202246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 202263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202267 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 202267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 202270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202279 */     GIR_RootConstrainSelectedInstOperands,
     /* 202280 */     // GIR_Coverage, 3198,
     /* 202280 */     GIR_EraseRootFromParent_Done,
     /* 202281 */   // Label 3815: @202281
     /* 202281 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(202321), // Rule ID 3203 //
     /* 202286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202307 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 202310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202319 */     GIR_RootConstrainSelectedInstOperands,
     /* 202320 */     // GIR_Coverage, 3203,
     /* 202320 */     GIR_EraseRootFromParent_Done,
     /* 202321 */   // Label 3816: @202321
     /* 202321 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(202361), // Rule ID 3204 //
     /* 202326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 202350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202359 */     GIR_RootConstrainSelectedInstOperands,
     /* 202360 */     // GIR_Coverage, 3204,
     /* 202360 */     GIR_EraseRootFromParent_Done,
     /* 202361 */   // Label 3817: @202361
     /* 202361 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(202401), // Rule ID 3205 //
     /* 202366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202387 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 202390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202399 */     GIR_RootConstrainSelectedInstOperands,
     /* 202400 */     // GIR_Coverage, 3205,
     /* 202400 */     GIR_EraseRootFromParent_Done,
     /* 202401 */   // Label 3818: @202401
     /* 202401 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(202441), // Rule ID 3206 //
     /* 202406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 202414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 202427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 202430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202439 */     GIR_RootConstrainSelectedInstOperands,
     /* 202440 */     // GIR_Coverage, 3206,
     /* 202440 */     GIR_EraseRootFromParent_Done,
     /* 202441 */   // Label 3819: @202441
     /* 202441 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(202478), // Rule ID 3395 //
     /* 202446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 202470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202476 */     GIR_RootConstrainSelectedInstOperands,
     /* 202477 */     // GIR_Coverage, 3395,
     /* 202477 */     GIR_EraseRootFromParent_Done,
     /* 202478 */   // Label 3820: @202478
     /* 202478 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(202515), // Rule ID 3396 //
     /* 202483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 202504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 202507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202513 */     GIR_RootConstrainSelectedInstOperands,
     /* 202514 */     // GIR_Coverage, 3396,
     /* 202514 */     GIR_EraseRootFromParent_Done,
     /* 202515 */   // Label 3821: @202515
     /* 202515 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(202552), // Rule ID 3397 //
     /* 202520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 202544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202550 */     GIR_RootConstrainSelectedInstOperands,
     /* 202551 */     // GIR_Coverage, 3397,
     /* 202551 */     GIR_EraseRootFromParent_Done,
     /* 202552 */   // Label 3822: @202552
     /* 202552 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(202589), // Rule ID 3398 //
     /* 202557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 202560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 202565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202578 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 202578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 202581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202587 */     GIR_RootConstrainSelectedInstOperands,
     /* 202588 */     // GIR_Coverage, 3398,
     /* 202588 */     GIR_EraseRootFromParent_Done,
     /* 202589 */   // Label 3823: @202589
     /* 202589 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(202626), // Rule ID 3420 //
     /* 202594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202615 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 202618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202624 */     GIR_RootConstrainSelectedInstOperands,
     /* 202625 */     // GIR_Coverage, 3420,
     /* 202625 */     GIR_EraseRootFromParent_Done,
     /* 202626 */   // Label 3824: @202626
     /* 202626 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(202663), // Rule ID 3421 //
     /* 202631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202652 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 202655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202661 */     GIR_RootConstrainSelectedInstOperands,
     /* 202662 */     // GIR_Coverage, 3421,
     /* 202662 */     GIR_EraseRootFromParent_Done,
     /* 202663 */   // Label 3825: @202663
     /* 202663 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(202700), // Rule ID 3422 //
     /* 202668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 202676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 202692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202698 */     GIR_RootConstrainSelectedInstOperands,
     /* 202699 */     // GIR_Coverage, 3422,
     /* 202699 */     GIR_EraseRootFromParent_Done,
     /* 202700 */   // Label 3826: @202700
     /* 202700 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(202737), // Rule ID 3444 //
     /* 202705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 202713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 202729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202735 */     GIR_RootConstrainSelectedInstOperands,
     /* 202736 */     // GIR_Coverage, 3444,
     /* 202736 */     GIR_EraseRootFromParent_Done,
     /* 202737 */   // Label 3827: @202737
     /* 202737 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(202774), // Rule ID 3449 //
     /* 202742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 202745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 202750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202763 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 202766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202772 */     GIR_RootConstrainSelectedInstOperands,
     /* 202773 */     // GIR_Coverage, 3449,
     /* 202773 */     GIR_EraseRootFromParent_Done,
     /* 202774 */   // Label 3828: @202774
     /* 202774 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(202811), // Rule ID 3450 //
     /* 202779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 202782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 202787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1266:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 202803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202809 */     GIR_RootConstrainSelectedInstOperands,
     /* 202810 */     // GIR_Coverage, 3450,
     /* 202810 */     GIR_EraseRootFromParent_Done,
     /* 202811 */   // Label 3829: @202811
     /* 202811 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(202848), // Rule ID 3459 //
     /* 202816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202837 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2161:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202846 */     GIR_RootConstrainSelectedInstOperands,
     /* 202847 */     // GIR_Coverage, 3459,
     /* 202847 */     GIR_EraseRootFromParent_Done,
     /* 202848 */   // Label 3830: @202848
     /* 202848 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(202885), // Rule ID 3460 //
     /* 202853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2161:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202883 */     GIR_RootConstrainSelectedInstOperands,
     /* 202884 */     // GIR_Coverage, 3460,
     /* 202884 */     GIR_EraseRootFromParent_Done,
     /* 202885 */   // Label 3831: @202885
     /* 202885 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(202922), // Rule ID 3461 //
     /* 202890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202911 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2161:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 202911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202920 */     GIR_RootConstrainSelectedInstOperands,
     /* 202921 */     // GIR_Coverage, 3461,
     /* 202921 */     GIR_EraseRootFromParent_Done,
     /* 202922 */   // Label 3832: @202922
     /* 202922 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(202959), // Rule ID 3462 //
     /* 202927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202957 */     GIR_RootConstrainSelectedInstOperands,
     /* 202958 */     // GIR_Coverage, 3462,
     /* 202958 */     GIR_EraseRootFromParent_Done,
     /* 202959 */   // Label 3833: @202959
     /* 202959 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(202996), // Rule ID 3463 //
     /* 202964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 202967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 202972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202985 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2161:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 202985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 202988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202994 */     GIR_RootConstrainSelectedInstOperands,
     /* 202995 */     // GIR_Coverage, 3463,
     /* 202995 */     GIR_EraseRootFromParent_Done,
     /* 202996 */   // Label 3834: @202996
     /* 202996 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(203033), // Rule ID 3464 //
     /* 203001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 203004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 203009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 203025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203031 */     GIR_RootConstrainSelectedInstOperands,
     /* 203032 */     // GIR_Coverage, 3464,
     /* 203032 */     GIR_EraseRootFromParent_Done,
     /* 203033 */   // Label 3835: @203033
     /* 203033 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(203070), // Rule ID 3465 //
     /* 203038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 203041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 203046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2161:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 203059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 203062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203068 */     GIR_RootConstrainSelectedInstOperands,
     /* 203069 */     // GIR_Coverage, 3465,
     /* 203069 */     GIR_EraseRootFromParent_Done,
     /* 203070 */   // Label 3836: @203070
     /* 203070 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(203107), // Rule ID 3520 //
     /* 203075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 203083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203096 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 203096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 203099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203105 */     GIR_RootConstrainSelectedInstOperands,
     /* 203106 */     // GIR_Coverage, 3520,
     /* 203106 */     GIR_EraseRootFromParent_Done,
     /* 203107 */   // Label 3837: @203107
     /* 203107 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(203144), // Rule ID 3521 //
     /* 203112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 203120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203133 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 203136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203142 */     GIR_RootConstrainSelectedInstOperands,
     /* 203143 */     // GIR_Coverage, 3521,
     /* 203143 */     GIR_EraseRootFromParent_Done,
     /* 203144 */   // Label 3838: @203144
     /* 203144 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(203181), // Rule ID 3522 //
     /* 203149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 203157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 203160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203170 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 203170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 203173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203179 */     GIR_RootConstrainSelectedInstOperands,
     /* 203180 */     // GIR_Coverage, 3522,
     /* 203180 */     GIR_EraseRootFromParent_Done,
     /* 203181 */   // Label 3839: @203181
     /* 203181 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(203218), // Rule ID 3552 //
     /* 203186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 203197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203207 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 203210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203216 */     GIR_RootConstrainSelectedInstOperands,
     /* 203217 */     // GIR_Coverage, 3552,
     /* 203217 */     GIR_EraseRootFromParent_Done,
     /* 203218 */   // Label 3840: @203218
     /* 203218 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(203255), // Rule ID 3553 //
     /* 203223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 203247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203253 */     GIR_RootConstrainSelectedInstOperands,
     /* 203254 */     // GIR_Coverage, 3553,
     /* 203254 */     GIR_EraseRootFromParent_Done,
     /* 203255 */   // Label 3841: @203255
     /* 203255 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(203292), // Rule ID 3554 //
     /* 203260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203281 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 203284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203290 */     GIR_RootConstrainSelectedInstOperands,
     /* 203291 */     // GIR_Coverage, 3554,
     /* 203291 */     GIR_EraseRootFromParent_Done,
     /* 203292 */   // Label 3842: @203292
     /* 203292 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(203329), // Rule ID 3555 //
     /* 203297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 203305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 203308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203318 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 203321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 203323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203327 */     GIR_RootConstrainSelectedInstOperands,
     /* 203328 */     // GIR_Coverage, 3555,
     /* 203328 */     GIR_EraseRootFromParent_Done,
     /* 203329 */   // Label 3843: @203329
     /* 203329 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(203366), // Rule ID 3556 //
     /* 203334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 203358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203364 */     GIR_RootConstrainSelectedInstOperands,
     /* 203365 */     // GIR_Coverage, 3556,
     /* 203365 */     GIR_EraseRootFromParent_Done,
     /* 203366 */   // Label 3844: @203366
     /* 203366 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(203403), // Rule ID 3557 //
     /* 203371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 203395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203401 */     GIR_RootConstrainSelectedInstOperands,
     /* 203402 */     // GIR_Coverage, 3557,
     /* 203402 */     GIR_EraseRootFromParent_Done,
     /* 203403 */   // Label 3845: @203403
     /* 203403 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(203440), // Rule ID 3558 //
     /* 203408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 203432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203438 */     GIR_RootConstrainSelectedInstOperands,
     /* 203439 */     // GIR_Coverage, 3558,
     /* 203439 */     GIR_EraseRootFromParent_Done,
     /* 203440 */   // Label 3846: @203440
     /* 203440 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(203477), // Rule ID 3559 //
     /* 203445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 203469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203475 */     GIR_RootConstrainSelectedInstOperands,
     /* 203476 */     // GIR_Coverage, 3559,
     /* 203476 */     GIR_EraseRootFromParent_Done,
     /* 203477 */   // Label 3847: @203477
     /* 203477 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(203514), // Rule ID 3560 //
     /* 203482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203503 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 203503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 203506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203512 */     GIR_RootConstrainSelectedInstOperands,
     /* 203513 */     // GIR_Coverage, 3560,
     /* 203513 */     GIR_EraseRootFromParent_Done,
     /* 203514 */   // Label 3848: @203514
     /* 203514 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(203551), // Rule ID 3561 //
     /* 203519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203540 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 203543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203549 */     GIR_RootConstrainSelectedInstOperands,
     /* 203550 */     // GIR_Coverage, 3561,
     /* 203550 */     GIR_EraseRootFromParent_Done,
     /* 203551 */   // Label 3849: @203551
     /* 203551 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(203588), // Rule ID 3562 //
     /* 203556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 203564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 203577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 203580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203586 */     GIR_RootConstrainSelectedInstOperands,
     /* 203587 */     // GIR_Coverage, 3562,
     /* 203587 */     GIR_EraseRootFromParent_Done,
     /* 203588 */   // Label 3850: @203588
     /* 203588 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(203625), // Rule ID 3563 //
     /* 203593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 203617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203623 */     GIR_RootConstrainSelectedInstOperands,
     /* 203624 */     // GIR_Coverage, 3563,
     /* 203624 */     GIR_EraseRootFromParent_Done,
     /* 203625 */   // Label 3851: @203625
     /* 203625 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(203662), // Rule ID 3564 //
     /* 203630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 203654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203660 */     GIR_RootConstrainSelectedInstOperands,
     /* 203661 */     // GIR_Coverage, 3564,
     /* 203661 */     GIR_EraseRootFromParent_Done,
     /* 203662 */   // Label 3852: @203662
     /* 203662 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(203699), // Rule ID 3565 //
     /* 203667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 203691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203697 */     GIR_RootConstrainSelectedInstOperands,
     /* 203698 */     // GIR_Coverage, 3565,
     /* 203698 */     GIR_EraseRootFromParent_Done,
     /* 203699 */   // Label 3853: @203699
     /* 203699 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(203736), // Rule ID 3566 //
     /* 203704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 203728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203734 */     GIR_RootConstrainSelectedInstOperands,
     /* 203735 */     // GIR_Coverage, 3566,
     /* 203735 */     GIR_EraseRootFromParent_Done,
     /* 203736 */   // Label 3854: @203736
     /* 203736 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(203773), // Rule ID 3567 //
     /* 203741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 203765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203771 */     GIR_RootConstrainSelectedInstOperands,
     /* 203772 */     // GIR_Coverage, 3567,
     /* 203772 */     GIR_EraseRootFromParent_Done,
     /* 203773 */   // Label 3855: @203773
     /* 203773 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(203810), // Rule ID 3568 //
     /* 203778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203799 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 203802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203808 */     GIR_RootConstrainSelectedInstOperands,
     /* 203809 */     // GIR_Coverage, 3568,
     /* 203809 */     GIR_EraseRootFromParent_Done,
     /* 203810 */   // Label 3856: @203810
     /* 203810 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(203847), // Rule ID 3569 //
     /* 203815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 203823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 203839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203845 */     GIR_RootConstrainSelectedInstOperands,
     /* 203846 */     // GIR_Coverage, 3569,
     /* 203846 */     GIR_EraseRootFromParent_Done,
     /* 203847 */   // Label 3857: @203847
     /* 203847 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(203884), // Rule ID 8454 //
     /* 203852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 203860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203873 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 203873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 203876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203882 */     GIR_RootConstrainSelectedInstOperands,
     /* 203883 */     // GIR_Coverage, 8454,
     /* 203883 */     GIR_EraseRootFromParent_Done,
     /* 203884 */   // Label 3858: @203884
     /* 203884 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(203921), // Rule ID 8930 //
     /* 203889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 203897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 203913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203919 */     GIR_RootConstrainSelectedInstOperands,
     /* 203920 */     // GIR_Coverage, 8930,
     /* 203920 */     GIR_EraseRootFromParent_Done,
     /* 203921 */   // Label 3859: @203921
     /* 203921 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(203958), // Rule ID 8931 //
     /* 203926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 203934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1263:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 203950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203956 */     GIR_RootConstrainSelectedInstOperands,
     /* 203957 */     // GIR_Coverage, 8931,
     /* 203957 */     GIR_EraseRootFromParent_Done,
     /* 203958 */   // Label 3860: @203958
     /* 203958 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(203995), // Rule ID 8932 //
     /* 203963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 203966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 203971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 203987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203993 */     GIR_RootConstrainSelectedInstOperands,
     /* 203994 */     // GIR_Coverage, 8932,
     /* 203994 */     GIR_EraseRootFromParent_Done,
     /* 203995 */   // Label 3861: @203995
     /* 203995 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(204032), // Rule ID 8933 //
     /* 204000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 204008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 204024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204030 */     GIR_RootConstrainSelectedInstOperands,
     /* 204031 */     // GIR_Coverage, 8933,
     /* 204031 */     GIR_EraseRootFromParent_Done,
     /* 204032 */   // Label 3862: @204032
     /* 204032 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(204069), // Rule ID 8934 //
     /* 204037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 204045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1261:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 204061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204067 */     GIR_RootConstrainSelectedInstOperands,
     /* 204068 */     // GIR_Coverage, 8934,
     /* 204068 */     GIR_EraseRootFromParent_Done,
     /* 204069 */   // Label 3863: @204069
     /* 204069 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(204106), // Rule ID 8935 //
     /* 204074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 204082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1263:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 204098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204104 */     GIR_RootConstrainSelectedInstOperands,
     /* 204105 */     // GIR_Coverage, 8935,
     /* 204105 */     GIR_EraseRootFromParent_Done,
     /* 204106 */   // Label 3864: @204106
     /* 204106 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(204143), // Rule ID 8936 //
     /* 204111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 204119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 204135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204141 */     GIR_RootConstrainSelectedInstOperands,
     /* 204142 */     // GIR_Coverage, 8936,
     /* 204142 */     GIR_EraseRootFromParent_Done,
     /* 204143 */   // Label 3865: @204143
     /* 204143 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(204180), // Rule ID 8937 //
     /* 204148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 204156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 204172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204178 */     GIR_RootConstrainSelectedInstOperands,
     /* 204179 */     // GIR_Coverage, 8937,
     /* 204179 */     GIR_EraseRootFromParent_Done,
     /* 204180 */   // Label 3866: @204180
     /* 204180 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(204220), // Rule ID 9937 //
     /* 204185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204206 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 204209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 9937,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 3867: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(204260), // Rule ID 9938 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204246 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 204249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204258 */     GIR_RootConstrainSelectedInstOperands,
     /* 204259 */     // GIR_Coverage, 9938,
     /* 204259 */     GIR_EraseRootFromParent_Done,
     /* 204260 */   // Label 3868: @204260
     /* 204260 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(204300), // Rule ID 9939 //
     /* 204265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 204289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204298 */     GIR_RootConstrainSelectedInstOperands,
     /* 204299 */     // GIR_Coverage, 9939,
     /* 204299 */     GIR_EraseRootFromParent_Done,
     /* 204300 */   // Label 3869: @204300
     /* 204300 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(204340), // Rule ID 9940 //
     /* 204305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 204329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204338 */     GIR_RootConstrainSelectedInstOperands,
     /* 204339 */     // GIR_Coverage, 9940,
     /* 204339 */     GIR_EraseRootFromParent_Done,
     /* 204340 */   // Label 3870: @204340
     /* 204340 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(204380), // Rule ID 9949 //
     /* 204345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 204369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204378 */     GIR_RootConstrainSelectedInstOperands,
     /* 204379 */     // GIR_Coverage, 9949,
     /* 204379 */     GIR_EraseRootFromParent_Done,
     /* 204380 */   // Label 3871: @204380
     /* 204380 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(204420), // Rule ID 9950 //
     /* 204385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 204409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204418 */     GIR_RootConstrainSelectedInstOperands,
     /* 204419 */     // GIR_Coverage, 9950,
     /* 204419 */     GIR_EraseRootFromParent_Done,
     /* 204420 */   // Label 3872: @204420
     /* 204420 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(204460), // Rule ID 9951 //
     /* 204425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 204449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204458 */     GIR_RootConstrainSelectedInstOperands,
     /* 204459 */     // GIR_Coverage, 9951,
     /* 204459 */     GIR_EraseRootFromParent_Done,
     /* 204460 */   // Label 3873: @204460
     /* 204460 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(204500), // Rule ID 9952 //
     /* 204465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 204486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 204489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204498 */     GIR_RootConstrainSelectedInstOperands,
     /* 204499 */     // GIR_Coverage, 9952,
     /* 204499 */     GIR_EraseRootFromParent_Done,
     /* 204500 */   // Label 3874: @204500
     /* 204500 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(204540), // Rule ID 9953 //
     /* 204505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 204529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204538 */     GIR_RootConstrainSelectedInstOperands,
     /* 204539 */     // GIR_Coverage, 9953,
     /* 204539 */     GIR_EraseRootFromParent_Done,
     /* 204540 */   // Label 3875: @204540
     /* 204540 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(204580), // Rule ID 9954 //
     /* 204545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 204569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204578 */     GIR_RootConstrainSelectedInstOperands,
     /* 204579 */     // GIR_Coverage, 9954,
     /* 204579 */     GIR_EraseRootFromParent_Done,
     /* 204580 */   // Label 3876: @204580
     /* 204580 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(204620), // Rule ID 9955 //
     /* 204585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 204609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204618 */     GIR_RootConstrainSelectedInstOperands,
     /* 204619 */     // GIR_Coverage, 9955,
     /* 204619 */     GIR_EraseRootFromParent_Done,
     /* 204620 */   // Label 3877: @204620
     /* 204620 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(204660), // Rule ID 9956 //
     /* 204625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 204633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204646 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 204649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204658 */     GIR_RootConstrainSelectedInstOperands,
     /* 204659 */     // GIR_Coverage, 9956,
     /* 204659 */     GIR_EraseRootFromParent_Done,
     /* 204660 */   // Label 3878: @204660
     /* 204660 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(204700), // Rule ID 9965 //
     /* 204665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 204689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204698 */     GIR_RootConstrainSelectedInstOperands,
     /* 204699 */     // GIR_Coverage, 9965,
     /* 204699 */     GIR_EraseRootFromParent_Done,
     /* 204700 */   // Label 3879: @204700
     /* 204700 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(204740), // Rule ID 9966 //
     /* 204705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 204729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204738 */     GIR_RootConstrainSelectedInstOperands,
     /* 204739 */     // GIR_Coverage, 9966,
     /* 204739 */     GIR_EraseRootFromParent_Done,
     /* 204740 */   // Label 3880: @204740
     /* 204740 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(204780), // Rule ID 9967 //
     /* 204745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 204769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204778 */     GIR_RootConstrainSelectedInstOperands,
     /* 204779 */     // GIR_Coverage, 9967,
     /* 204779 */     GIR_EraseRootFromParent_Done,
     /* 204780 */   // Label 3881: @204780
     /* 204780 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(204820), // Rule ID 9968 //
     /* 204785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 204793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 204802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 204806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 204809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204818 */     GIR_RootConstrainSelectedInstOperands,
     /* 204819 */     // GIR_Coverage, 9968,
     /* 204819 */     GIR_EraseRootFromParent_Done,
     /* 204820 */   // Label 3882: @204820
     /* 204820 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(204857), // Rule ID 10127 //
     /* 204825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 204849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204855 */     GIR_RootConstrainSelectedInstOperands,
     /* 204856 */     // GIR_Coverage, 10127,
     /* 204856 */     GIR_EraseRootFromParent_Done,
     /* 204857 */   // Label 3883: @204857
     /* 204857 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(204894), // Rule ID 10128 //
     /* 204862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 204886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204892 */     GIR_RootConstrainSelectedInstOperands,
     /* 204893 */     // GIR_Coverage, 10128,
     /* 204893 */     GIR_EraseRootFromParent_Done,
     /* 204894 */   // Label 3884: @204894
     /* 204894 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(204931), // Rule ID 10129 //
     /* 204899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 204907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2031:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 204923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204929 */     GIR_RootConstrainSelectedInstOperands,
     /* 204930 */     // GIR_Coverage, 10129,
     /* 204930 */     GIR_EraseRootFromParent_Done,
     /* 204931 */   // Label 3885: @204931
     /* 204931 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(204968), // Rule ID 10130 //
     /* 204936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 204944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 204960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204966 */     GIR_RootConstrainSelectedInstOperands,
     /* 204967 */     // GIR_Coverage, 10130,
     /* 204967 */     GIR_EraseRootFromParent_Done,
     /* 204968 */   // Label 3886: @204968
     /* 204968 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(205005), // Rule ID 10131 //
     /* 204973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 204981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 204997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205003 */     GIR_RootConstrainSelectedInstOperands,
     /* 205004 */     // GIR_Coverage, 10131,
     /* 205004 */     GIR_EraseRootFromParent_Done,
     /* 205005 */   // Label 3887: @205005
     /* 205005 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(205042), // Rule ID 10132 //
     /* 205010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 205018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 205027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 205031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 205034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205040 */     GIR_RootConstrainSelectedInstOperands,
     /* 205041 */     // GIR_Coverage, 10132,
     /* 205041 */     GIR_EraseRootFromParent_Done,
     /* 205042 */   // Label 3888: @205042
     /* 205042 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(205079), // Rule ID 10133 //
     /* 205047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 205055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 205064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 205068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 205071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205077 */     GIR_RootConstrainSelectedInstOperands,
     /* 205078 */     // GIR_Coverage, 10133,
     /* 205078 */     GIR_EraseRootFromParent_Done,
     /* 205079 */   // Label 3889: @205079
     /* 205079 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(205116), // Rule ID 10134 //
     /* 205084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 205092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 205101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2017:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 205105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 205108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205114 */     GIR_RootConstrainSelectedInstOperands,
     /* 205115 */     // GIR_Coverage, 10134,
     /* 205115 */     GIR_EraseRootFromParent_Done,
     /* 205116 */   // Label 3890: @205116
     /* 205116 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(205153), // Rule ID 10135 //
     /* 205121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 205129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 205138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2017:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 205142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 205145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205151 */     GIR_RootConstrainSelectedInstOperands,
     /* 205152 */     // GIR_Coverage, 10135,
     /* 205152 */     GIR_EraseRootFromParent_Done,
     /* 205153 */   // Label 3891: @205153
     /* 205153 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(205190), // Rule ID 11323 //
     /* 205158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205188 */     GIR_RootConstrainSelectedInstOperands,
     /* 205189 */     // GIR_Coverage, 11323,
     /* 205189 */     GIR_EraseRootFromParent_Done,
     /* 205190 */   // Label 3892: @205190
     /* 205190 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(205227), // Rule ID 11324 //
     /* 205195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2166:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205225 */     GIR_RootConstrainSelectedInstOperands,
     /* 205226 */     // GIR_Coverage, 11324,
     /* 205226 */     GIR_EraseRootFromParent_Done,
     /* 205227 */   // Label 3893: @205227
     /* 205227 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(205264), // Rule ID 11325 //
     /* 205232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205253 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2166:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205262 */     GIR_RootConstrainSelectedInstOperands,
     /* 205263 */     // GIR_Coverage, 11325,
     /* 205263 */     GIR_EraseRootFromParent_Done,
     /* 205264 */   // Label 3894: @205264
     /* 205264 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(205301), // Rule ID 11326 //
     /* 205269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2166:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205299 */     GIR_RootConstrainSelectedInstOperands,
     /* 205300 */     // GIR_Coverage, 11326,
     /* 205300 */     GIR_EraseRootFromParent_Done,
     /* 205301 */   // Label 3895: @205301
     /* 205301 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(205338), // Rule ID 11327 //
     /* 205306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2166:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205336 */     GIR_RootConstrainSelectedInstOperands,
     /* 205337 */     // GIR_Coverage, 11327,
     /* 205337 */     GIR_EraseRootFromParent_Done,
     /* 205338 */   // Label 3896: @205338
     /* 205338 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(205375), // Rule ID 11328 //
     /* 205343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2166:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205373 */     GIR_RootConstrainSelectedInstOperands,
     /* 205374 */     // GIR_Coverage, 11328,
     /* 205374 */     GIR_EraseRootFromParent_Done,
     /* 205375 */   // Label 3897: @205375
     /* 205375 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(205412), // Rule ID 11329 //
     /* 205380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 205388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205401 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2166:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 205404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205410 */     GIR_RootConstrainSelectedInstOperands,
     /* 205411 */     // GIR_Coverage, 11329,
     /* 205411 */     GIR_EraseRootFromParent_Done,
     /* 205412 */   // Label 3898: @205412
     /* 205412 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(205449), // Rule ID 11330 //
     /* 205417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2087:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205447 */     GIR_RootConstrainSelectedInstOperands,
     /* 205448 */     // GIR_Coverage, 11330,
     /* 205448 */     GIR_EraseRootFromParent_Done,
     /* 205449 */   // Label 3899: @205449
     /* 205449 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(205486), // Rule ID 11331 //
     /* 205454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2087:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205484 */     GIR_RootConstrainSelectedInstOperands,
     /* 205485 */     // GIR_Coverage, 11331,
     /* 205485 */     GIR_EraseRootFromParent_Done,
     /* 205486 */   // Label 3900: @205486
     /* 205486 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(205523), // Rule ID 11332 //
     /* 205491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205512 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2087:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205521 */     GIR_RootConstrainSelectedInstOperands,
     /* 205522 */     // GIR_Coverage, 11332,
     /* 205522 */     GIR_EraseRootFromParent_Done,
     /* 205523 */   // Label 3901: @205523
     /* 205523 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(205560), // Rule ID 11333 //
     /* 205528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2087:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205558 */     GIR_RootConstrainSelectedInstOperands,
     /* 205559 */     // GIR_Coverage, 11333,
     /* 205559 */     GIR_EraseRootFromParent_Done,
     /* 205560 */   // Label 3902: @205560
     /* 205560 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(205597), // Rule ID 11334 //
     /* 205565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205586 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2087:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205595 */     GIR_RootConstrainSelectedInstOperands,
     /* 205596 */     // GIR_Coverage, 11334,
     /* 205596 */     GIR_EraseRootFromParent_Done,
     /* 205597 */   // Label 3903: @205597
     /* 205597 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(205634), // Rule ID 11335 //
     /* 205602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2087:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205632 */     GIR_RootConstrainSelectedInstOperands,
     /* 205633 */     // GIR_Coverage, 11335,
     /* 205633 */     GIR_EraseRootFromParent_Done,
     /* 205634 */   // Label 3904: @205634
     /* 205634 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(205671), // Rule ID 11336 //
     /* 205639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 205647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205660 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2087:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 205663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205669 */     GIR_RootConstrainSelectedInstOperands,
     /* 205670 */     // GIR_Coverage, 11336,
     /* 205670 */     GIR_EraseRootFromParent_Done,
     /* 205671 */   // Label 3905: @205671
     /* 205671 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(205708), // Rule ID 11337 //
     /* 205676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205697 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2092:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205706 */     GIR_RootConstrainSelectedInstOperands,
     /* 205707 */     // GIR_Coverage, 11337,
     /* 205707 */     GIR_EraseRootFromParent_Done,
     /* 205708 */   // Label 3906: @205708
     /* 205708 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(205745), // Rule ID 11338 //
     /* 205713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2092:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205743 */     GIR_RootConstrainSelectedInstOperands,
     /* 205744 */     // GIR_Coverage, 11338,
     /* 205744 */     GIR_EraseRootFromParent_Done,
     /* 205745 */   // Label 3907: @205745
     /* 205745 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(205782), // Rule ID 11339 //
     /* 205750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205771 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2092:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205780 */     GIR_RootConstrainSelectedInstOperands,
     /* 205781 */     // GIR_Coverage, 11339,
     /* 205781 */     GIR_EraseRootFromParent_Done,
     /* 205782 */   // Label 3908: @205782
     /* 205782 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(205819), // Rule ID 11340 //
     /* 205787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2092:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205817 */     GIR_RootConstrainSelectedInstOperands,
     /* 205818 */     // GIR_Coverage, 11340,
     /* 205818 */     GIR_EraseRootFromParent_Done,
     /* 205819 */   // Label 3909: @205819
     /* 205819 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(205856), // Rule ID 11341 //
     /* 205824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205845 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2092:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205854 */     GIR_RootConstrainSelectedInstOperands,
     /* 205855 */     // GIR_Coverage, 11341,
     /* 205855 */     GIR_EraseRootFromParent_Done,
     /* 205856 */   // Label 3910: @205856
     /* 205856 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(205893), // Rule ID 11342 //
     /* 205861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2092:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205891 */     GIR_RootConstrainSelectedInstOperands,
     /* 205892 */     // GIR_Coverage, 11342,
     /* 205892 */     GIR_EraseRootFromParent_Done,
     /* 205893 */   // Label 3911: @205893
     /* 205893 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(205930), // Rule ID 11343 //
     /* 205898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 205906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2092:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 205922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205928 */     GIR_RootConstrainSelectedInstOperands,
     /* 205929 */     // GIR_Coverage, 11343,
     /* 205929 */     GIR_EraseRootFromParent_Done,
     /* 205930 */   // Label 3912: @205930
     /* 205930 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(205967), // Rule ID 11344 //
     /* 205935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1931:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205965 */     GIR_RootConstrainSelectedInstOperands,
     /* 205966 */     // GIR_Coverage, 11344,
     /* 205966 */     GIR_EraseRootFromParent_Done,
     /* 205967 */   // Label 3913: @205967
     /* 205967 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(206004), // Rule ID 11345 //
     /* 205972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 205975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 205980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 205996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206002 */     GIR_RootConstrainSelectedInstOperands,
     /* 206003 */     // GIR_Coverage, 11345,
     /* 206003 */     GIR_EraseRootFromParent_Done,
     /* 206004 */   // Label 3914: @206004
     /* 206004 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(206041), // Rule ID 11346 //
     /* 206009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 206017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206030 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1931:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206039 */     GIR_RootConstrainSelectedInstOperands,
     /* 206040 */     // GIR_Coverage, 11346,
     /* 206040 */     GIR_EraseRootFromParent_Done,
     /* 206041 */   // Label 3915: @206041
     /* 206041 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(206078), // Rule ID 11347 //
     /* 206046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 206054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206076 */     GIR_RootConstrainSelectedInstOperands,
     /* 206077 */     // GIR_Coverage, 11347,
     /* 206077 */     GIR_EraseRootFromParent_Done,
     /* 206078 */   // Label 3916: @206078
     /* 206078 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(206115), // Rule ID 11348 //
     /* 206083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 206091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206104 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1931:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206113 */     GIR_RootConstrainSelectedInstOperands,
     /* 206114 */     // GIR_Coverage, 11348,
     /* 206114 */     GIR_EraseRootFromParent_Done,
     /* 206115 */   // Label 3917: @206115
     /* 206115 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(206152), // Rule ID 11349 //
     /* 206120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 206128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206150 */     GIR_RootConstrainSelectedInstOperands,
     /* 206151 */     // GIR_Coverage, 11349,
     /* 206151 */     GIR_EraseRootFromParent_Done,
     /* 206152 */   // Label 3918: @206152
     /* 206152 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(206189), // Rule ID 11350 //
     /* 206157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 206165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206178 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1931:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 206181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206187 */     GIR_RootConstrainSelectedInstOperands,
     /* 206188 */     // GIR_Coverage, 11350,
     /* 206188 */     GIR_EraseRootFromParent_Done,
     /* 206189 */   // Label 3919: @206189
     /* 206189 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(206226), // Rule ID 11351 //
     /* 206194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206224 */     GIR_RootConstrainSelectedInstOperands,
     /* 206225 */     // GIR_Coverage, 11351,
     /* 206225 */     GIR_EraseRootFromParent_Done,
     /* 206226 */   // Label 3920: @206226
     /* 206226 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(206263), // Rule ID 11352 //
     /* 206231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206261 */     GIR_RootConstrainSelectedInstOperands,
     /* 206262 */     // GIR_Coverage, 11352,
     /* 206262 */     GIR_EraseRootFromParent_Done,
     /* 206263 */   // Label 3921: @206263
     /* 206263 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(206300), // Rule ID 11353 //
     /* 206268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206289 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1936:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206298 */     GIR_RootConstrainSelectedInstOperands,
     /* 206299 */     // GIR_Coverage, 11353,
     /* 206299 */     GIR_EraseRootFromParent_Done,
     /* 206300 */   // Label 3922: @206300
     /* 206300 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(206337), // Rule ID 11354 //
     /* 206305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206335 */     GIR_RootConstrainSelectedInstOperands,
     /* 206336 */     // GIR_Coverage, 11354,
     /* 206336 */     GIR_EraseRootFromParent_Done,
     /* 206337 */   // Label 3923: @206337
     /* 206337 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(206374), // Rule ID 11355 //
     /* 206342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206363 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1936:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206372 */     GIR_RootConstrainSelectedInstOperands,
     /* 206373 */     // GIR_Coverage, 11355,
     /* 206373 */     GIR_EraseRootFromParent_Done,
     /* 206374 */   // Label 3924: @206374
     /* 206374 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(206411), // Rule ID 11356 //
     /* 206379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206409 */     GIR_RootConstrainSelectedInstOperands,
     /* 206410 */     // GIR_Coverage, 11356,
     /* 206410 */     GIR_EraseRootFromParent_Done,
     /* 206411 */   // Label 3925: @206411
     /* 206411 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(206448), // Rule ID 11357 //
     /* 206416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 206424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 206440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206446 */     GIR_RootConstrainSelectedInstOperands,
     /* 206447 */     // GIR_Coverage, 11357,
     /* 206447 */     GIR_EraseRootFromParent_Done,
     /* 206448 */   // Label 3926: @206448
     /* 206448 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(206485), // Rule ID 11377 //
     /* 206453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 206477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206483 */     GIR_RootConstrainSelectedInstOperands,
     /* 206484 */     // GIR_Coverage, 11377,
     /* 206484 */     GIR_EraseRootFromParent_Done,
     /* 206485 */   // Label 3927: @206485
     /* 206485 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(206522), // Rule ID 11378 //
     /* 206490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206511 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 206514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206520 */     GIR_RootConstrainSelectedInstOperands,
     /* 206521 */     // GIR_Coverage, 11378,
     /* 206521 */     GIR_EraseRootFromParent_Done,
     /* 206522 */   // Label 3928: @206522
     /* 206522 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(206559), // Rule ID 11379 //
     /* 206527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 206551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206557 */     GIR_RootConstrainSelectedInstOperands,
     /* 206558 */     // GIR_Coverage, 11379,
     /* 206558 */     GIR_EraseRootFromParent_Done,
     /* 206559 */   // Label 3929: @206559
     /* 206559 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(206596), // Rule ID 11380 //
     /* 206564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 206572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 206588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206594 */     GIR_RootConstrainSelectedInstOperands,
     /* 206595 */     // GIR_Coverage, 11380,
     /* 206595 */     GIR_EraseRootFromParent_Done,
     /* 206596 */   // Label 3930: @206596
     /* 206596 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(206633), // Rule ID 11668 //
     /* 206601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206622 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 206625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206631 */     GIR_RootConstrainSelectedInstOperands,
     /* 206632 */     // GIR_Coverage, 11668,
     /* 206632 */     GIR_EraseRootFromParent_Done,
     /* 206633 */   // Label 3931: @206633
     /* 206633 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(206670), // Rule ID 11669 //
     /* 206638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 206662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206668 */     GIR_RootConstrainSelectedInstOperands,
     /* 206669 */     // GIR_Coverage, 11669,
     /* 206669 */     GIR_EraseRootFromParent_Done,
     /* 206670 */   // Label 3932: @206670
     /* 206670 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(206707), // Rule ID 11670 //
     /* 206675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 206683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 206699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206705 */     GIR_RootConstrainSelectedInstOperands,
     /* 206706 */     // GIR_Coverage, 11670,
     /* 206706 */     GIR_EraseRootFromParent_Done,
     /* 206707 */   // Label 3933: @206707
     /* 206707 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(206744), // Rule ID 11671 //
     /* 206712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 206736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206742 */     GIR_RootConstrainSelectedInstOperands,
     /* 206743 */     // GIR_Coverage, 11671,
     /* 206743 */     GIR_EraseRootFromParent_Done,
     /* 206744 */   // Label 3934: @206744
     /* 206744 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(206781), // Rule ID 11672 //
     /* 206749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 206773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206779 */     GIR_RootConstrainSelectedInstOperands,
     /* 206780 */     // GIR_Coverage, 11672,
     /* 206780 */     GIR_EraseRootFromParent_Done,
     /* 206781 */   // Label 3935: @206781
     /* 206781 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(206818), // Rule ID 11673 //
     /* 206786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 206794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 206810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206816 */     GIR_RootConstrainSelectedInstOperands,
     /* 206817 */     // GIR_Coverage, 11673,
     /* 206817 */     GIR_EraseRootFromParent_Done,
     /* 206818 */   // Label 3936: @206818
     /* 206818 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(206855), // Rule ID 11674 //
     /* 206823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 206847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206853 */     GIR_RootConstrainSelectedInstOperands,
     /* 206854 */     // GIR_Coverage, 11674,
     /* 206854 */     GIR_EraseRootFromParent_Done,
     /* 206855 */   // Label 3937: @206855
     /* 206855 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(206892), // Rule ID 11675 //
     /* 206860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 206884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206890 */     GIR_RootConstrainSelectedInstOperands,
     /* 206891 */     // GIR_Coverage, 11675,
     /* 206891 */     GIR_EraseRootFromParent_Done,
     /* 206892 */   // Label 3938: @206892
     /* 206892 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(206929), // Rule ID 11676 //
     /* 206897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 206905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 206921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206927 */     GIR_RootConstrainSelectedInstOperands,
     /* 206928 */     // GIR_Coverage, 11676,
     /* 206928 */     GIR_EraseRootFromParent_Done,
     /* 206929 */   // Label 3939: @206929
     /* 206929 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(206966), // Rule ID 11677 //
     /* 206934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 206942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 206958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206964 */     GIR_RootConstrainSelectedInstOperands,
     /* 206965 */     // GIR_Coverage, 11677,
     /* 206965 */     GIR_EraseRootFromParent_Done,
     /* 206966 */   // Label 3940: @206966
     /* 206966 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(207003), // Rule ID 11678 //
     /* 206971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 206979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 206995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207001 */     GIR_RootConstrainSelectedInstOperands,
     /* 207002 */     // GIR_Coverage, 11678,
     /* 207002 */     GIR_EraseRootFromParent_Done,
     /* 207003 */   // Label 3941: @207003
     /* 207003 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(207040), // Rule ID 11679 //
     /* 207008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 207016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207029 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 207032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207038 */     GIR_RootConstrainSelectedInstOperands,
     /* 207039 */     // GIR_Coverage, 11679,
     /* 207039 */     GIR_EraseRootFromParent_Done,
     /* 207040 */   // Label 3942: @207040
     /* 207040 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(207077), // Rule ID 11680 //
     /* 207045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 207053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 207069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207075 */     GIR_RootConstrainSelectedInstOperands,
     /* 207076 */     // GIR_Coverage, 11680,
     /* 207076 */     GIR_EraseRootFromParent_Done,
     /* 207077 */   // Label 3943: @207077
     /* 207077 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(207114), // Rule ID 11681 //
     /* 207082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 207090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207103 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 207106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207112 */     GIR_RootConstrainSelectedInstOperands,
     /* 207113 */     // GIR_Coverage, 11681,
     /* 207113 */     GIR_EraseRootFromParent_Done,
     /* 207114 */   // Label 3944: @207114
     /* 207114 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(207151), // Rule ID 11682 //
     /* 207119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 207127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 207143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207149 */     GIR_RootConstrainSelectedInstOperands,
     /* 207150 */     // GIR_Coverage, 11682,
     /* 207150 */     GIR_EraseRootFromParent_Done,
     /* 207151 */   // Label 3945: @207151
     /* 207151 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(207188), // Rule ID 11683 //
     /* 207156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 207164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2070:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 207180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207186 */     GIR_RootConstrainSelectedInstOperands,
     /* 207187 */     // GIR_Coverage, 11683,
     /* 207187 */     GIR_EraseRootFromParent_Done,
     /* 207188 */   // Label 3946: @207188
     /* 207188 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(207225), // Rule ID 11684 //
     /* 207193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 207201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 207217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207223 */     GIR_RootConstrainSelectedInstOperands,
     /* 207224 */     // GIR_Coverage, 11684,
     /* 207224 */     GIR_EraseRootFromParent_Done,
     /* 207225 */   // Label 3947: @207225
     /* 207225 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(207262), // Rule ID 11685 //
     /* 207230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 207238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 207254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207260 */     GIR_RootConstrainSelectedInstOperands,
     /* 207261 */     // GIR_Coverage, 11685,
     /* 207261 */     GIR_EraseRootFromParent_Done,
     /* 207262 */   // Label 3948: @207262
     /* 207262 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(207299), // Rule ID 11686 //
     /* 207267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 207291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207297 */     GIR_RootConstrainSelectedInstOperands,
     /* 207298 */     // GIR_Coverage, 11686,
     /* 207298 */     GIR_EraseRootFromParent_Done,
     /* 207299 */   // Label 3949: @207299
     /* 207299 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(207336), // Rule ID 11687 //
     /* 207304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 207328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207334 */     GIR_RootConstrainSelectedInstOperands,
     /* 207335 */     // GIR_Coverage, 11687,
     /* 207335 */     GIR_EraseRootFromParent_Done,
     /* 207336 */   // Label 3950: @207336
     /* 207336 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(207373), // Rule ID 11688 //
     /* 207341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 207349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 207365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207371 */     GIR_RootConstrainSelectedInstOperands,
     /* 207372 */     // GIR_Coverage, 11688,
     /* 207372 */     GIR_EraseRootFromParent_Done,
     /* 207373 */   // Label 3951: @207373
     /* 207373 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(207410), // Rule ID 11689 //
     /* 207378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 207402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207408 */     GIR_RootConstrainSelectedInstOperands,
     /* 207409 */     // GIR_Coverage, 11689,
     /* 207409 */     GIR_EraseRootFromParent_Done,
     /* 207410 */   // Label 3952: @207410
     /* 207410 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(207447), // Rule ID 11690 //
     /* 207415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 207439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207445 */     GIR_RootConstrainSelectedInstOperands,
     /* 207446 */     // GIR_Coverage, 11690,
     /* 207446 */     GIR_EraseRootFromParent_Done,
     /* 207447 */   // Label 3953: @207447
     /* 207447 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(207484), // Rule ID 11691 //
     /* 207452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 207460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 207476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207482 */     GIR_RootConstrainSelectedInstOperands,
     /* 207483 */     // GIR_Coverage, 11691,
     /* 207483 */     GIR_EraseRootFromParent_Done,
     /* 207484 */   // Label 3954: @207484
     /* 207484 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(207521), // Rule ID 11692 //
     /* 207489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 207513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207519 */     GIR_RootConstrainSelectedInstOperands,
     /* 207520 */     // GIR_Coverage, 11692,
     /* 207520 */     GIR_EraseRootFromParent_Done,
     /* 207521 */   // Label 3955: @207521
     /* 207521 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(207558), // Rule ID 11693 //
     /* 207526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 207550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207556 */     GIR_RootConstrainSelectedInstOperands,
     /* 207557 */     // GIR_Coverage, 11693,
     /* 207557 */     GIR_EraseRootFromParent_Done,
     /* 207558 */   // Label 3956: @207558
     /* 207558 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(207595), // Rule ID 11694 //
     /* 207563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 207571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 207587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207593 */     GIR_RootConstrainSelectedInstOperands,
     /* 207594 */     // GIR_Coverage, 11694,
     /* 207594 */     GIR_EraseRootFromParent_Done,
     /* 207595 */   // Label 3957: @207595
     /* 207595 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(207632), // Rule ID 11695 //
     /* 207600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 207624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207630 */     GIR_RootConstrainSelectedInstOperands,
     /* 207631 */     // GIR_Coverage, 11695,
     /* 207631 */     GIR_EraseRootFromParent_Done,
     /* 207632 */   // Label 3958: @207632
     /* 207632 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(207669), // Rule ID 11696 //
     /* 207637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 207661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207667 */     GIR_RootConstrainSelectedInstOperands,
     /* 207668 */     // GIR_Coverage, 11696,
     /* 207668 */     GIR_EraseRootFromParent_Done,
     /* 207669 */   // Label 3959: @207669
     /* 207669 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(207706), // Rule ID 11697 //
     /* 207674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 207682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 207698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207704 */     GIR_RootConstrainSelectedInstOperands,
     /* 207705 */     // GIR_Coverage, 11697,
     /* 207705 */     GIR_EraseRootFromParent_Done,
     /* 207706 */   // Label 3960: @207706
     /* 207706 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(207743), // Rule ID 11698 //
     /* 207711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 207735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207741 */     GIR_RootConstrainSelectedInstOperands,
     /* 207742 */     // GIR_Coverage, 11698,
     /* 207742 */     GIR_EraseRootFromParent_Done,
     /* 207743 */   // Label 3961: @207743
     /* 207743 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(207780), // Rule ID 11699 //
     /* 207748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 207772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207778 */     GIR_RootConstrainSelectedInstOperands,
     /* 207779 */     // GIR_Coverage, 11699,
     /* 207779 */     GIR_EraseRootFromParent_Done,
     /* 207780 */   // Label 3962: @207780
     /* 207780 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(207817), // Rule ID 11700 //
     /* 207785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 207793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 207809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207815 */     GIR_RootConstrainSelectedInstOperands,
     /* 207816 */     // GIR_Coverage, 11700,
     /* 207816 */     GIR_EraseRootFromParent_Done,
     /* 207817 */   // Label 3963: @207817
     /* 207817 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(207854), // Rule ID 11710 //
     /* 207822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 207846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207852 */     GIR_RootConstrainSelectedInstOperands,
     /* 207853 */     // GIR_Coverage, 11710,
     /* 207853 */     GIR_EraseRootFromParent_Done,
     /* 207854 */   // Label 3964: @207854
     /* 207854 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(207891), // Rule ID 11711 //
     /* 207859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 207883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207889 */     GIR_RootConstrainSelectedInstOperands,
     /* 207890 */     // GIR_Coverage, 11711,
     /* 207890 */     GIR_EraseRootFromParent_Done,
     /* 207891 */   // Label 3965: @207891
     /* 207891 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(207928), // Rule ID 11712 //
     /* 207896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 207904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207917 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 207920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207926 */     GIR_RootConstrainSelectedInstOperands,
     /* 207927 */     // GIR_Coverage, 11712,
     /* 207927 */     GIR_EraseRootFromParent_Done,
     /* 207928 */   // Label 3966: @207928
     /* 207928 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(207965), // Rule ID 11713 //
     /* 207933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 207941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 207957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207963 */     GIR_RootConstrainSelectedInstOperands,
     /* 207964 */     // GIR_Coverage, 11713,
     /* 207964 */     GIR_EraseRootFromParent_Done,
     /* 207965 */   // Label 3967: @207965
     /* 207965 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(208002), // Rule ID 11714 //
     /* 207970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 207978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207991 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 207994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208000 */     GIR_RootConstrainSelectedInstOperands,
     /* 208001 */     // GIR_Coverage, 11714,
     /* 208001 */     GIR_EraseRootFromParent_Done,
     /* 208002 */   // Label 3968: @208002
     /* 208002 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(208039), // Rule ID 11715 //
     /* 208007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 208015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 208031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208037 */     GIR_RootConstrainSelectedInstOperands,
     /* 208038 */     // GIR_Coverage, 11715,
     /* 208038 */     GIR_EraseRootFromParent_Done,
     /* 208039 */   // Label 3969: @208039
     /* 208039 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(208076), // Rule ID 11716 //
     /* 208044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 208052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 208068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208074 */     GIR_RootConstrainSelectedInstOperands,
     /* 208075 */     // GIR_Coverage, 11716,
     /* 208075 */     GIR_EraseRootFromParent_Done,
     /* 208076 */   // Label 3970: @208076
     /* 208076 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(208113), // Rule ID 11717 //
     /* 208081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 208089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 208105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208111 */     GIR_RootConstrainSelectedInstOperands,
     /* 208112 */     // GIR_Coverage, 11717,
     /* 208112 */     GIR_EraseRootFromParent_Done,
     /* 208113 */   // Label 3971: @208113
     /* 208113 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(208150), // Rule ID 11718 //
     /* 208118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 208126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 208142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208148 */     GIR_RootConstrainSelectedInstOperands,
     /* 208149 */     // GIR_Coverage, 11718,
     /* 208149 */     GIR_EraseRootFromParent_Done,
     /* 208150 */   // Label 3972: @208150
     /* 208150 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(208187), // Rule ID 11719 //
     /* 208155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 208163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 208179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208185 */     GIR_RootConstrainSelectedInstOperands,
     /* 208186 */     // GIR_Coverage, 11719,
     /* 208186 */     GIR_EraseRootFromParent_Done,
     /* 208187 */   // Label 3973: @208187
     /* 208187 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(208224), // Rule ID 11720 //
     /* 208192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 208200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 208216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208222 */     GIR_RootConstrainSelectedInstOperands,
     /* 208223 */     // GIR_Coverage, 11720,
     /* 208223 */     GIR_EraseRootFromParent_Done,
     /* 208224 */   // Label 3974: @208224
     /* 208224 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(208261), // Rule ID 11721 //
     /* 208229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 208237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 208253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208259 */     GIR_RootConstrainSelectedInstOperands,
     /* 208260 */     // GIR_Coverage, 11721,
     /* 208260 */     GIR_EraseRootFromParent_Done,
     /* 208261 */   // Label 3975: @208261
     /* 208261 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(208298), // Rule ID 11734 //
     /* 208266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 208290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208296 */     GIR_RootConstrainSelectedInstOperands,
     /* 208297 */     // GIR_Coverage, 11734,
     /* 208297 */     GIR_EraseRootFromParent_Done,
     /* 208298 */   // Label 3976: @208298
     /* 208298 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(208335), // Rule ID 11735 //
     /* 208303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 208327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208333 */     GIR_RootConstrainSelectedInstOperands,
     /* 208334 */     // GIR_Coverage, 11735,
     /* 208334 */     GIR_EraseRootFromParent_Done,
     /* 208335 */   // Label 3977: @208335
     /* 208335 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(208372), // Rule ID 11736 //
     /* 208340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 208348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 208364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208370 */     GIR_RootConstrainSelectedInstOperands,
     /* 208371 */     // GIR_Coverage, 11736,
     /* 208371 */     GIR_EraseRootFromParent_Done,
     /* 208372 */   // Label 3978: @208372
     /* 208372 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(208409), // Rule ID 11737 //
     /* 208377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 208401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208407 */     GIR_RootConstrainSelectedInstOperands,
     /* 208408 */     // GIR_Coverage, 11737,
     /* 208408 */     GIR_EraseRootFromParent_Done,
     /* 208409 */   // Label 3979: @208409
     /* 208409 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(208446), // Rule ID 11738 //
     /* 208414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 208438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208444 */     GIR_RootConstrainSelectedInstOperands,
     /* 208445 */     // GIR_Coverage, 11738,
     /* 208445 */     GIR_EraseRootFromParent_Done,
     /* 208446 */   // Label 3980: @208446
     /* 208446 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(208483), // Rule ID 11739 //
     /* 208451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 208459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 208475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208481 */     GIR_RootConstrainSelectedInstOperands,
     /* 208482 */     // GIR_Coverage, 11739,
     /* 208482 */     GIR_EraseRootFromParent_Done,
     /* 208483 */   // Label 3981: @208483
     /* 208483 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(208520), // Rule ID 11740 //
     /* 208488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 208512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208518 */     GIR_RootConstrainSelectedInstOperands,
     /* 208519 */     // GIR_Coverage, 11740,
     /* 208519 */     GIR_EraseRootFromParent_Done,
     /* 208520 */   // Label 3982: @208520
     /* 208520 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(208557), // Rule ID 11741 //
     /* 208525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 208549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208555 */     GIR_RootConstrainSelectedInstOperands,
     /* 208556 */     // GIR_Coverage, 11741,
     /* 208556 */     GIR_EraseRootFromParent_Done,
     /* 208557 */   // Label 3983: @208557
     /* 208557 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(208594), // Rule ID 11742 //
     /* 208562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 208570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 208586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208592 */     GIR_RootConstrainSelectedInstOperands,
     /* 208593 */     // GIR_Coverage, 11742,
     /* 208593 */     GIR_EraseRootFromParent_Done,
     /* 208594 */   // Label 3984: @208594
     /* 208594 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(208631), // Rule ID 11743 //
     /* 208599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 208623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208629 */     GIR_RootConstrainSelectedInstOperands,
     /* 208630 */     // GIR_Coverage, 11743,
     /* 208630 */     GIR_EraseRootFromParent_Done,
     /* 208631 */   // Label 3985: @208631
     /* 208631 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(208668), // Rule ID 11744 //
     /* 208636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 208660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208666 */     GIR_RootConstrainSelectedInstOperands,
     /* 208667 */     // GIR_Coverage, 11744,
     /* 208667 */     GIR_EraseRootFromParent_Done,
     /* 208668 */   // Label 3986: @208668
     /* 208668 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(208705), // Rule ID 11745 //
     /* 208673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 208681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 208697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208703 */     GIR_RootConstrainSelectedInstOperands,
     /* 208704 */     // GIR_Coverage, 11745,
     /* 208704 */     GIR_EraseRootFromParent_Done,
     /* 208705 */   // Label 3987: @208705
     /* 208705 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(208742), // Rule ID 11746 //
     /* 208710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1999:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 208734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208740 */     GIR_RootConstrainSelectedInstOperands,
     /* 208741 */     // GIR_Coverage, 11746,
     /* 208741 */     GIR_EraseRootFromParent_Done,
     /* 208742 */   // Label 3988: @208742
     /* 208742 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(208779), // Rule ID 11747 //
     /* 208747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 208771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208777 */     GIR_RootConstrainSelectedInstOperands,
     /* 208778 */     // GIR_Coverage, 11747,
     /* 208778 */     GIR_EraseRootFromParent_Done,
     /* 208779 */   // Label 3989: @208779
     /* 208779 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(208816), // Rule ID 11748 //
     /* 208784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 208792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 208808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208814 */     GIR_RootConstrainSelectedInstOperands,
     /* 208815 */     // GIR_Coverage, 11748,
     /* 208815 */     GIR_EraseRootFromParent_Done,
     /* 208816 */   // Label 3990: @208816
     /* 208816 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(208853), // Rule ID 11749 //
     /* 208821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2001:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 208845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208851 */     GIR_RootConstrainSelectedInstOperands,
     /* 208852 */     // GIR_Coverage, 11749,
     /* 208852 */     GIR_EraseRootFromParent_Done,
     /* 208853 */   // Label 3991: @208853
     /* 208853 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(208890), // Rule ID 11750 //
     /* 208858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2001:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 208882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208888 */     GIR_RootConstrainSelectedInstOperands,
     /* 208889 */     // GIR_Coverage, 11750,
     /* 208889 */     GIR_EraseRootFromParent_Done,
     /* 208890 */   // Label 3992: @208890
     /* 208890 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(208927), // Rule ID 11751 //
     /* 208895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 208903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2001:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 208919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208925 */     GIR_RootConstrainSelectedInstOperands,
     /* 208926 */     // GIR_Coverage, 11751,
     /* 208926 */     GIR_EraseRootFromParent_Done,
     /* 208927 */   // Label 3993: @208927
     /* 208927 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(208964), // Rule ID 11752 //
     /* 208932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 208940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208953 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 208956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208962 */     GIR_RootConstrainSelectedInstOperands,
     /* 208963 */     // GIR_Coverage, 11752,
     /* 208963 */     GIR_EraseRootFromParent_Done,
     /* 208964 */   // Label 3994: @208964
     /* 208964 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(209001), // Rule ID 11753 //
     /* 208969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 208977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 208993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208999 */     GIR_RootConstrainSelectedInstOperands,
     /* 209000 */     // GIR_Coverage, 11753,
     /* 209000 */     GIR_EraseRootFromParent_Done,
     /* 209001 */   // Label 3995: @209001
     /* 209001 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(209038), // Rule ID 11854 //
     /* 209006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 209014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 209030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209036 */     GIR_RootConstrainSelectedInstOperands,
     /* 209037 */     // GIR_Coverage, 11854,
     /* 209037 */     GIR_EraseRootFromParent_Done,
     /* 209038 */   // Label 3996: @209038
     /* 209038 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(209075), // Rule ID 11855 //
     /* 209043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 209051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 209067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209073 */     GIR_RootConstrainSelectedInstOperands,
     /* 209074 */     // GIR_Coverage, 11855,
     /* 209074 */     GIR_EraseRootFromParent_Done,
     /* 209075 */   // Label 3997: @209075
     /* 209075 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(209112), // Rule ID 11856 //
     /* 209080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 209088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 209104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209110 */     GIR_RootConstrainSelectedInstOperands,
     /* 209111 */     // GIR_Coverage, 11856,
     /* 209111 */     GIR_EraseRootFromParent_Done,
     /* 209112 */   // Label 3998: @209112
     /* 209112 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(209149), // Rule ID 11857 //
     /* 209117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 209125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 209141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209147 */     GIR_RootConstrainSelectedInstOperands,
     /* 209148 */     // GIR_Coverage, 11857,
     /* 209148 */     GIR_EraseRootFromParent_Done,
     /* 209149 */   // Label 3999: @209149
     /* 209149 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(209186), // Rule ID 11858 //
     /* 209154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 209162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 209178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209184 */     GIR_RootConstrainSelectedInstOperands,
     /* 209185 */     // GIR_Coverage, 11858,
     /* 209185 */     GIR_EraseRootFromParent_Done,
     /* 209186 */   // Label 4000: @209186
     /* 209186 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(209223), // Rule ID 11859 //
     /* 209191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 209199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 209215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209221 */     GIR_RootConstrainSelectedInstOperands,
     /* 209222 */     // GIR_Coverage, 11859,
     /* 209222 */     GIR_EraseRootFromParent_Done,
     /* 209223 */   // Label 4001: @209223
     /* 209223 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(209260), // Rule ID 11860 //
     /* 209228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 209252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209258 */     GIR_RootConstrainSelectedInstOperands,
     /* 209259 */     // GIR_Coverage, 11860,
     /* 209259 */     GIR_EraseRootFromParent_Done,
     /* 209260 */   // Label 4002: @209260
     /* 209260 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(209297), // Rule ID 11861 //
     /* 209265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 209289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209295 */     GIR_RootConstrainSelectedInstOperands,
     /* 209296 */     // GIR_Coverage, 11861,
     /* 209296 */     GIR_EraseRootFromParent_Done,
     /* 209297 */   // Label 4003: @209297
     /* 209297 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(209334), // Rule ID 11862 //
     /* 209302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 209310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 209326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209332 */     GIR_RootConstrainSelectedInstOperands,
     /* 209333 */     // GIR_Coverage, 11862,
     /* 209333 */     GIR_EraseRootFromParent_Done,
     /* 209334 */   // Label 4004: @209334
     /* 209334 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(209371), // Rule ID 11878 //
     /* 209339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2052:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 209363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209369 */     GIR_RootConstrainSelectedInstOperands,
     /* 209370 */     // GIR_Coverage, 11878,
     /* 209370 */     GIR_EraseRootFromParent_Done,
     /* 209371 */   // Label 4005: @209371
     /* 209371 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(209408), // Rule ID 11879 //
     /* 209376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 209400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209406 */     GIR_RootConstrainSelectedInstOperands,
     /* 209407 */     // GIR_Coverage, 11879,
     /* 209407 */     GIR_EraseRootFromParent_Done,
     /* 209408 */   // Label 4006: @209408
     /* 209408 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(209445), // Rule ID 11880 //
     /* 209413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 209421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 209437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209443 */     GIR_RootConstrainSelectedInstOperands,
     /* 209444 */     // GIR_Coverage, 11880,
     /* 209444 */     GIR_EraseRootFromParent_Done,
     /* 209445 */   // Label 4007: @209445
     /* 209445 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(209482), // Rule ID 11881 //
     /* 209450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 209474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209480 */     GIR_RootConstrainSelectedInstOperands,
     /* 209481 */     // GIR_Coverage, 11881,
     /* 209481 */     GIR_EraseRootFromParent_Done,
     /* 209482 */   // Label 4008: @209482
     /* 209482 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(209519), // Rule ID 11882 //
     /* 209487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 209511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209517 */     GIR_RootConstrainSelectedInstOperands,
     /* 209518 */     // GIR_Coverage, 11882,
     /* 209518 */     GIR_EraseRootFromParent_Done,
     /* 209519 */   // Label 4009: @209519
     /* 209519 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(209556), // Rule ID 11883 //
     /* 209524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 209532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 209548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209554 */     GIR_RootConstrainSelectedInstOperands,
     /* 209555 */     // GIR_Coverage, 11883,
     /* 209555 */     GIR_EraseRootFromParent_Done,
     /* 209556 */   // Label 4010: @209556
     /* 209556 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(209593), // Rule ID 11899 //
     /* 209561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 209585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209591 */     GIR_RootConstrainSelectedInstOperands,
     /* 209592 */     // GIR_Coverage, 11899,
     /* 209592 */     GIR_EraseRootFromParent_Done,
     /* 209593 */   // Label 4011: @209593
     /* 209593 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(209630), // Rule ID 11900 //
     /* 209598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 209622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209628 */     GIR_RootConstrainSelectedInstOperands,
     /* 209629 */     // GIR_Coverage, 11900,
     /* 209629 */     GIR_EraseRootFromParent_Done,
     /* 209630 */   // Label 4012: @209630
     /* 209630 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(209667), // Rule ID 11901 //
     /* 209635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 209643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 209659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209665 */     GIR_RootConstrainSelectedInstOperands,
     /* 209666 */     // GIR_Coverage, 11901,
     /* 209666 */     GIR_EraseRootFromParent_Done,
     /* 209667 */   // Label 4013: @209667
     /* 209667 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(209704), // Rule ID 11902 //
     /* 209672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209693 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 209696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209702 */     GIR_RootConstrainSelectedInstOperands,
     /* 209703 */     // GIR_Coverage, 11902,
     /* 209703 */     GIR_EraseRootFromParent_Done,
     /* 209704 */   // Label 4014: @209704
     /* 209704 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(209741), // Rule ID 11903 //
     /* 209709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 209733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209739 */     GIR_RootConstrainSelectedInstOperands,
     /* 209740 */     // GIR_Coverage, 11903,
     /* 209740 */     GIR_EraseRootFromParent_Done,
     /* 209741 */   // Label 4015: @209741
     /* 209741 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(209778), // Rule ID 11904 //
     /* 209746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 209754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 209770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209776 */     GIR_RootConstrainSelectedInstOperands,
     /* 209777 */     // GIR_Coverage, 11904,
     /* 209777 */     GIR_EraseRootFromParent_Done,
     /* 209778 */   // Label 4016: @209778
     /* 209778 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(209818), // Rule ID 11991 //
     /* 209783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 209807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209816 */     GIR_RootConstrainSelectedInstOperands,
     /* 209817 */     // GIR_Coverage, 11991,
     /* 209817 */     GIR_EraseRootFromParent_Done,
     /* 209818 */   // Label 4017: @209818
     /* 209818 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(209858), // Rule ID 11992 //
     /* 209823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 209834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209844 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 209847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209856 */     GIR_RootConstrainSelectedInstOperands,
     /* 209857 */     // GIR_Coverage, 11992,
     /* 209857 */     GIR_EraseRootFromParent_Done,
     /* 209858 */   // Label 4018: @209858
     /* 209858 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(209898), // Rule ID 11993 //
     /* 209863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 209874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209884 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 209887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209896 */     GIR_RootConstrainSelectedInstOperands,
     /* 209897 */     // GIR_Coverage, 11993,
     /* 209897 */     GIR_EraseRootFromParent_Done,
     /* 209898 */   // Label 4019: @209898
     /* 209898 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(209938), // Rule ID 11994 //
     /* 209903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 209911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 209914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 209927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209936 */     GIR_RootConstrainSelectedInstOperands,
     /* 209937 */     // GIR_Coverage, 11994,
     /* 209937 */     GIR_EraseRootFromParent_Done,
     /* 209938 */   // Label 4020: @209938
     /* 209938 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(209978), // Rule ID 11995 //
     /* 209943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 209964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 209967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 209976 */     GIR_RootConstrainSelectedInstOperands,
     /* 209977 */     // GIR_Coverage, 11995,
     /* 209977 */     GIR_EraseRootFromParent_Done,
     /* 209978 */   // Label 4021: @209978
     /* 209978 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(210018), // Rule ID 11996 //
     /* 209983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 209991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 209994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 210007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210016 */     GIR_RootConstrainSelectedInstOperands,
     /* 210017 */     // GIR_Coverage, 11996,
     /* 210017 */     GIR_EraseRootFromParent_Done,
     /* 210018 */   // Label 4022: @210018
     /* 210018 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(210058), // Rule ID 11997 //
     /* 210023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210044 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 210047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210056 */     GIR_RootConstrainSelectedInstOperands,
     /* 210057 */     // GIR_Coverage, 11997,
     /* 210057 */     GIR_EraseRootFromParent_Done,
     /* 210058 */   // Label 4023: @210058
     /* 210058 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(210098), // Rule ID 11998 //
     /* 210063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 210087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210096 */     GIR_RootConstrainSelectedInstOperands,
     /* 210097 */     // GIR_Coverage, 11998,
     /* 210097 */     GIR_EraseRootFromParent_Done,
     /* 210098 */   // Label 4024: @210098
     /* 210098 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(210138), // Rule ID 12003 //
     /* 210103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 210127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210136 */     GIR_RootConstrainSelectedInstOperands,
     /* 210137 */     // GIR_Coverage, 12003,
     /* 210137 */     GIR_EraseRootFromParent_Done,
     /* 210138 */   // Label 4025: @210138
     /* 210138 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(210178), // Rule ID 12004 //
     /* 210143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 210167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210176 */     GIR_RootConstrainSelectedInstOperands,
     /* 210177 */     // GIR_Coverage, 12004,
     /* 210177 */     GIR_EraseRootFromParent_Done,
     /* 210178 */   // Label 4026: @210178
     /* 210178 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(210218), // Rule ID 12005 //
     /* 210183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 210207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210216 */     GIR_RootConstrainSelectedInstOperands,
     /* 210217 */     // GIR_Coverage, 12005,
     /* 210217 */     GIR_EraseRootFromParent_Done,
     /* 210218 */   // Label 4027: @210218
     /* 210218 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(210258), // Rule ID 12006 //
     /* 210223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210256 */     GIR_RootConstrainSelectedInstOperands,
     /* 210257 */     // GIR_Coverage, 12006,
     /* 210257 */     GIR_EraseRootFromParent_Done,
     /* 210258 */   // Label 4028: @210258
     /* 210258 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(210298), // Rule ID 12007 //
     /* 210263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 210287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210296 */     GIR_RootConstrainSelectedInstOperands,
     /* 210297 */     // GIR_Coverage, 12007,
     /* 210297 */     GIR_EraseRootFromParent_Done,
     /* 210298 */   // Label 4029: @210298
     /* 210298 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(210338), // Rule ID 12008 //
     /* 210303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 210327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210336 */     GIR_RootConstrainSelectedInstOperands,
     /* 210337 */     // GIR_Coverage, 12008,
     /* 210337 */     GIR_EraseRootFromParent_Done,
     /* 210338 */   // Label 4030: @210338
     /* 210338 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(210378), // Rule ID 12009 //
     /* 210343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 210367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210376 */     GIR_RootConstrainSelectedInstOperands,
     /* 210377 */     // GIR_Coverage, 12009,
     /* 210377 */     GIR_EraseRootFromParent_Done,
     /* 210378 */   // Label 4031: @210378
     /* 210378 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(210418), // Rule ID 12010 //
     /* 210383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 210404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 210407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210416 */     GIR_RootConstrainSelectedInstOperands,
     /* 210417 */     // GIR_Coverage, 12010,
     /* 210417 */     GIR_EraseRootFromParent_Done,
     /* 210418 */   // Label 4032: @210418
     /* 210418 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(210458), // Rule ID 12015 //
     /* 210423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 210447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210456 */     GIR_RootConstrainSelectedInstOperands,
     /* 210457 */     // GIR_Coverage, 12015,
     /* 210457 */     GIR_EraseRootFromParent_Done,
     /* 210458 */   // Label 4033: @210458
     /* 210458 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(210498), // Rule ID 12016 //
     /* 210463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 210487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210496 */     GIR_RootConstrainSelectedInstOperands,
     /* 210497 */     // GIR_Coverage, 12016,
     /* 210497 */     GIR_EraseRootFromParent_Done,
     /* 210498 */   // Label 4034: @210498
     /* 210498 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(210538), // Rule ID 12017 //
     /* 210503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 210527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210536 */     GIR_RootConstrainSelectedInstOperands,
     /* 210537 */     // GIR_Coverage, 12017,
     /* 210537 */     GIR_EraseRootFromParent_Done,
     /* 210538 */   // Label 4035: @210538
     /* 210538 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(210578), // Rule ID 12018 //
     /* 210543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 210551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 210567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210576 */     GIR_RootConstrainSelectedInstOperands,
     /* 210577 */     // GIR_Coverage, 12018,
     /* 210577 */     GIR_EraseRootFromParent_Done,
     /* 210578 */   // Label 4036: @210578
     /* 210578 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(210618), // Rule ID 12019 //
     /* 210583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 210607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210616 */     GIR_RootConstrainSelectedInstOperands,
     /* 210617 */     // GIR_Coverage, 12019,
     /* 210617 */     GIR_EraseRootFromParent_Done,
     /* 210618 */   // Label 4037: @210618
     /* 210618 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(210658), // Rule ID 12020 //
     /* 210623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 210647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210656 */     GIR_RootConstrainSelectedInstOperands,
     /* 210657 */     // GIR_Coverage, 12020,
     /* 210657 */     GIR_EraseRootFromParent_Done,
     /* 210658 */   // Label 4038: @210658
     /* 210658 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(210698), // Rule ID 12021 //
     /* 210663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 210687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210696 */     GIR_RootConstrainSelectedInstOperands,
     /* 210697 */     // GIR_Coverage, 12021,
     /* 210697 */     GIR_EraseRootFromParent_Done,
     /* 210698 */   // Label 4039: @210698
     /* 210698 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(210738), // Rule ID 12022 //
     /* 210703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 210711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 210727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210736 */     GIR_RootConstrainSelectedInstOperands,
     /* 210737 */     // GIR_Coverage, 12022,
     /* 210737 */     GIR_EraseRootFromParent_Done,
     /* 210738 */   // Label 4040: @210738
     /* 210738 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(210778), // Rule ID 12027 //
     /* 210743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 210767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210776 */     GIR_RootConstrainSelectedInstOperands,
     /* 210777 */     // GIR_Coverage, 12027,
     /* 210777 */     GIR_EraseRootFromParent_Done,
     /* 210778 */   // Label 4041: @210778
     /* 210778 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(210818), // Rule ID 12028 //
     /* 210783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 210807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210816 */     GIR_RootConstrainSelectedInstOperands,
     /* 210817 */     // GIR_Coverage, 12028,
     /* 210817 */     GIR_EraseRootFromParent_Done,
     /* 210818 */   // Label 4042: @210818
     /* 210818 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(210858), // Rule ID 12029 //
     /* 210823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 210847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210856 */     GIR_RootConstrainSelectedInstOperands,
     /* 210857 */     // GIR_Coverage, 12029,
     /* 210857 */     GIR_EraseRootFromParent_Done,
     /* 210858 */   // Label 4043: @210858
     /* 210858 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(210898), // Rule ID 12030 //
     /* 210863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 210871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 210874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 210887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210896 */     GIR_RootConstrainSelectedInstOperands,
     /* 210897 */     // GIR_Coverage, 12030,
     /* 210897 */     GIR_EraseRootFromParent_Done,
     /* 210898 */   // Label 4044: @210898
     /* 210898 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(210938), // Rule ID 12031 //
     /* 210903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 210914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 210927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210936 */     GIR_RootConstrainSelectedInstOperands,
     /* 210937 */     // GIR_Coverage, 12031,
     /* 210937 */     GIR_EraseRootFromParent_Done,
     /* 210938 */   // Label 4045: @210938
     /* 210938 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(210978), // Rule ID 12032 //
     /* 210943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 210954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 210964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 210964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 210967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 210969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 210976 */     GIR_RootConstrainSelectedInstOperands,
     /* 210977 */     // GIR_Coverage, 12032,
     /* 210977 */     GIR_EraseRootFromParent_Done,
     /* 210978 */   // Label 4046: @210978
     /* 210978 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(211018), // Rule ID 12033 //
     /* 210983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 210991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 210994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 211007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211016 */     GIR_RootConstrainSelectedInstOperands,
     /* 211017 */     // GIR_Coverage, 12033,
     /* 211017 */     GIR_EraseRootFromParent_Done,
     /* 211018 */   // Label 4047: @211018
     /* 211018 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(211058), // Rule ID 12034 //
     /* 211023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 211047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211056 */     GIR_RootConstrainSelectedInstOperands,
     /* 211057 */     // GIR_Coverage, 12034,
     /* 211057 */     GIR_EraseRootFromParent_Done,
     /* 211058 */   // Label 4048: @211058
     /* 211058 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(211095), // Rule ID 12043 //
     /* 211063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 211066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 211071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1265:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 211087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211093 */     GIR_RootConstrainSelectedInstOperands,
     /* 211094 */     // GIR_Coverage, 12043,
     /* 211094 */     GIR_EraseRootFromParent_Done,
     /* 211095 */   // Label 4049: @211095
     /* 211095 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(211132), // Rule ID 12045 //
     /* 211100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 211103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 211108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 211124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211130 */     GIR_RootConstrainSelectedInstOperands,
     /* 211131 */     // GIR_Coverage, 12045,
     /* 211131 */     GIR_EraseRootFromParent_Done,
     /* 211132 */   // Label 4050: @211132
     /* 211132 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(211169), // Rule ID 12046 //
     /* 211137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 211140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 211145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 211161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211167 */     GIR_RootConstrainSelectedInstOperands,
     /* 211168 */     // GIR_Coverage, 12046,
     /* 211168 */     GIR_EraseRootFromParent_Done,
     /* 211169 */   // Label 4051: @211169
     /* 211169 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(211206), // Rule ID 12047 //
     /* 211174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 211177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 211182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 211198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211204 */     GIR_RootConstrainSelectedInstOperands,
     /* 211205 */     // GIR_Coverage, 12047,
     /* 211205 */     GIR_EraseRootFromParent_Done,
     /* 211206 */   // Label 4052: @211206
     /* 211206 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(211243), // Rule ID 12048 //
     /* 211211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211232 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 211235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211241 */     GIR_RootConstrainSelectedInstOperands,
     /* 211242 */     // GIR_Coverage, 12048,
     /* 211242 */     GIR_EraseRootFromParent_Done,
     /* 211243 */   // Label 4053: @211243
     /* 211243 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(211280), // Rule ID 12049 //
     /* 211248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 211272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211278 */     GIR_RootConstrainSelectedInstOperands,
     /* 211279 */     // GIR_Coverage, 12049,
     /* 211279 */     GIR_EraseRootFromParent_Done,
     /* 211280 */   // Label 4054: @211280
     /* 211280 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(211317), // Rule ID 12050 //
     /* 211285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 211309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211315 */     GIR_RootConstrainSelectedInstOperands,
     /* 211316 */     // GIR_Coverage, 12050,
     /* 211316 */     GIR_EraseRootFromParent_Done,
     /* 211317 */   // Label 4055: @211317
     /* 211317 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(211354), // Rule ID 12051 //
     /* 211322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 211330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1279:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 211346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211352 */     GIR_RootConstrainSelectedInstOperands,
     /* 211353 */     // GIR_Coverage, 12051,
     /* 211353 */     GIR_EraseRootFromParent_Done,
     /* 211354 */   // Label 4056: @211354
     /* 211354 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(211391), // Rule ID 12052 //
     /* 211359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 211383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211389 */     GIR_RootConstrainSelectedInstOperands,
     /* 211390 */     // GIR_Coverage, 12052,
     /* 211390 */     GIR_EraseRootFromParent_Done,
     /* 211391 */   // Label 4057: @211391
     /* 211391 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(211428), // Rule ID 12053 //
     /* 211396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 211420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211426 */     GIR_RootConstrainSelectedInstOperands,
     /* 211427 */     // GIR_Coverage, 12053,
     /* 211427 */     GIR_EraseRootFromParent_Done,
     /* 211428 */   // Label 4058: @211428
     /* 211428 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(211465), // Rule ID 12054 //
     /* 211433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 211457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211463 */     GIR_RootConstrainSelectedInstOperands,
     /* 211464 */     // GIR_Coverage, 12054,
     /* 211464 */     GIR_EraseRootFromParent_Done,
     /* 211465 */   // Label 4059: @211465
     /* 211465 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(211502), // Rule ID 12055 //
     /* 211470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 211473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 211478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 211494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211500 */     GIR_RootConstrainSelectedInstOperands,
     /* 211501 */     // GIR_Coverage, 12055,
     /* 211501 */     GIR_EraseRootFromParent_Done,
     /* 211502 */   // Label 4060: @211502
     /* 211502 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(211539), // Rule ID 12168 //
     /* 211507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211528 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 211531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211537 */     GIR_RootConstrainSelectedInstOperands,
     /* 211538 */     // GIR_Coverage, 12168,
     /* 211538 */     GIR_EraseRootFromParent_Done,
     /* 211539 */   // Label 4061: @211539
     /* 211539 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(211576), // Rule ID 12169 //
     /* 211544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211565 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 211568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211574 */     GIR_RootConstrainSelectedInstOperands,
     /* 211575 */     // GIR_Coverage, 12169,
     /* 211575 */     GIR_EraseRootFromParent_Done,
     /* 211576 */   // Label 4062: @211576
     /* 211576 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(211613), // Rule ID 12170 //
     /* 211581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 211589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211602 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 211605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211611 */     GIR_RootConstrainSelectedInstOperands,
     /* 211612 */     // GIR_Coverage, 12170,
     /* 211612 */     GIR_EraseRootFromParent_Done,
     /* 211613 */   // Label 4063: @211613
     /* 211613 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(211650), // Rule ID 12171 //
     /* 211618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211639 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1463:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 211642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211648 */     GIR_RootConstrainSelectedInstOperands,
     /* 211649 */     // GIR_Coverage, 12171,
     /* 211649 */     GIR_EraseRootFromParent_Done,
     /* 211650 */   // Label 4064: @211650
     /* 211650 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(211687), // Rule ID 12172 //
     /* 211655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211676 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1463:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 211679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211685 */     GIR_RootConstrainSelectedInstOperands,
     /* 211686 */     // GIR_Coverage, 12172,
     /* 211686 */     GIR_EraseRootFromParent_Done,
     /* 211687 */   // Label 4065: @211687
     /* 211687 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(211724), // Rule ID 12173 //
     /* 211692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 211700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211713 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1463:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 211716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211722 */     GIR_RootConstrainSelectedInstOperands,
     /* 211723 */     // GIR_Coverage, 12173,
     /* 211723 */     GIR_EraseRootFromParent_Done,
     /* 211724 */   // Label 4066: @211724
     /* 211724 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(211761), // Rule ID 12174 //
     /* 211729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211750 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 211753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211759 */     GIR_RootConstrainSelectedInstOperands,
     /* 211760 */     // GIR_Coverage, 12174,
     /* 211760 */     GIR_EraseRootFromParent_Done,
     /* 211761 */   // Label 4067: @211761
     /* 211761 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(211798), // Rule ID 12175 //
     /* 211766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211787 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 211790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211796 */     GIR_RootConstrainSelectedInstOperands,
     /* 211797 */     // GIR_Coverage, 12175,
     /* 211797 */     GIR_EraseRootFromParent_Done,
     /* 211798 */   // Label 4068: @211798
     /* 211798 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(211835), // Rule ID 12176 //
     /* 211803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 211811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211824 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 211827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211833 */     GIR_RootConstrainSelectedInstOperands,
     /* 211834 */     // GIR_Coverage, 12176,
     /* 211834 */     GIR_EraseRootFromParent_Done,
     /* 211835 */   // Label 4069: @211835
     /* 211835 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(211872), // Rule ID 12177 //
     /* 211840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211861 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 211861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 211864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211870 */     GIR_RootConstrainSelectedInstOperands,
     /* 211871 */     // GIR_Coverage, 12177,
     /* 211871 */     GIR_EraseRootFromParent_Done,
     /* 211872 */   // Label 4070: @211872
     /* 211872 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(211909), // Rule ID 12178 //
     /* 211877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211898 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 211898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 211901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211907 */     GIR_RootConstrainSelectedInstOperands,
     /* 211908 */     // GIR_Coverage, 12178,
     /* 211908 */     GIR_EraseRootFromParent_Done,
     /* 211909 */   // Label 4071: @211909
     /* 211909 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(211946), // Rule ID 12179 //
     /* 211914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 211922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211935 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 211935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 211938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211944 */     GIR_RootConstrainSelectedInstOperands,
     /* 211945 */     // GIR_Coverage, 12179,
     /* 211945 */     GIR_EraseRootFromParent_Done,
     /* 211946 */   // Label 4072: @211946
     /* 211946 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(211983), // Rule ID 12180 //
     /* 211951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 211962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211972 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 211975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 211977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211981 */     GIR_RootConstrainSelectedInstOperands,
     /* 211982 */     // GIR_Coverage, 12180,
     /* 211982 */     GIR_EraseRootFromParent_Done,
     /* 211983 */   // Label 4073: @211983
     /* 211983 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(212020), // Rule ID 12181 //
     /* 211988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 211991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 211996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212009 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 212012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212018 */     GIR_RootConstrainSelectedInstOperands,
     /* 212019 */     // GIR_Coverage, 12181,
     /* 212019 */     GIR_EraseRootFromParent_Done,
     /* 212020 */   // Label 4074: @212020
     /* 212020 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(212057), // Rule ID 12182 //
     /* 212025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 212033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212046 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 212049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212055 */     GIR_RootConstrainSelectedInstOperands,
     /* 212056 */     // GIR_Coverage, 12182,
     /* 212056 */     GIR_EraseRootFromParent_Done,
     /* 212057 */   // Label 4075: @212057
     /* 212057 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(212094), // Rule ID 12183 //
     /* 212062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 212070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212083 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 212086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212092 */     GIR_RootConstrainSelectedInstOperands,
     /* 212093 */     // GIR_Coverage, 12183,
     /* 212093 */     GIR_EraseRootFromParent_Done,
     /* 212094 */   // Label 4076: @212094
     /* 212094 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(212131), // Rule ID 12184 //
     /* 212099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1272:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 212123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212129 */     GIR_RootConstrainSelectedInstOperands,
     /* 212130 */     // GIR_Coverage, 12184,
     /* 212130 */     GIR_EraseRootFromParent_Done,
     /* 212131 */   // Label 4077: @212131
     /* 212131 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(212168), // Rule ID 12185 //
     /* 212136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212157 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 212160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212166 */     GIR_RootConstrainSelectedInstOperands,
     /* 212167 */     // GIR_Coverage, 12185,
     /* 212167 */     GIR_EraseRootFromParent_Done,
     /* 212168 */   // Label 4078: @212168
     /* 212168 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(212205), // Rule ID 12186 //
     /* 212173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212194 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 212197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212203 */     GIR_RootConstrainSelectedInstOperands,
     /* 212204 */     // GIR_Coverage, 12186,
     /* 212204 */     GIR_EraseRootFromParent_Done,
     /* 212205 */   // Label 4079: @212205
     /* 212205 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(212242), // Rule ID 12187 //
     /* 212210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 212218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212231 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 212234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212240 */     GIR_RootConstrainSelectedInstOperands,
     /* 212241 */     // GIR_Coverage, 12187,
     /* 212241 */     GIR_EraseRootFromParent_Done,
     /* 212242 */   // Label 4080: @212242
     /* 212242 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(212279), // Rule ID 12188 //
     /* 212247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212268 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1260:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 212271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212277 */     GIR_RootConstrainSelectedInstOperands,
     /* 212278 */     // GIR_Coverage, 12188,
     /* 212278 */     GIR_EraseRootFromParent_Done,
     /* 212279 */   // Label 4081: @212279
     /* 212279 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(212316), // Rule ID 12189 //
     /* 212284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212305 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1260:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 212308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212314 */     GIR_RootConstrainSelectedInstOperands,
     /* 212315 */     // GIR_Coverage, 12189,
     /* 212315 */     GIR_EraseRootFromParent_Done,
     /* 212316 */   // Label 4082: @212316
     /* 212316 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(212353), // Rule ID 12190 //
     /* 212321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212342 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1260:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 212345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212351 */     GIR_RootConstrainSelectedInstOperands,
     /* 212352 */     // GIR_Coverage, 12190,
     /* 212352 */     GIR_EraseRootFromParent_Done,
     /* 212353 */   // Label 4083: @212353
     /* 212353 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(212390), // Rule ID 12191 //
     /* 212358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 212366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212379 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1260:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 212382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212388 */     GIR_RootConstrainSelectedInstOperands,
     /* 212389 */     // GIR_Coverage, 12191,
     /* 212389 */     GIR_EraseRootFromParent_Done,
     /* 212390 */   // Label 4084: @212390
     /* 212390 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(212427), // Rule ID 12192 //
     /* 212395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212416 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1739:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 212419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212425 */     GIR_RootConstrainSelectedInstOperands,
     /* 212426 */     // GIR_Coverage, 12192,
     /* 212426 */     GIR_EraseRootFromParent_Done,
     /* 212427 */   // Label 4085: @212427
     /* 212427 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(212464), // Rule ID 12193 //
     /* 212432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212453 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1739:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 212456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212462 */     GIR_RootConstrainSelectedInstOperands,
     /* 212463 */     // GIR_Coverage, 12193,
     /* 212463 */     GIR_EraseRootFromParent_Done,
     /* 212464 */   // Label 4086: @212464
     /* 212464 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(212501), // Rule ID 12194 //
     /* 212469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212490 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1739:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 212493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212499 */     GIR_RootConstrainSelectedInstOperands,
     /* 212500 */     // GIR_Coverage, 12194,
     /* 212500 */     GIR_EraseRootFromParent_Done,
     /* 212501 */   // Label 4087: @212501
     /* 212501 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(212538), // Rule ID 12195 //
     /* 212506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 212514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212527 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1739:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 212530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212536 */     GIR_RootConstrainSelectedInstOperands,
     /* 212537 */     // GIR_Coverage, 12195,
     /* 212537 */     GIR_EraseRootFromParent_Done,
     /* 212538 */   // Label 4088: @212538
     /* 212538 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(212575), // Rule ID 12196 //
     /* 212543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212564 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1977:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 212567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212573 */     GIR_RootConstrainSelectedInstOperands,
     /* 212574 */     // GIR_Coverage, 12196,
     /* 212574 */     GIR_EraseRootFromParent_Done,
     /* 212575 */   // Label 4089: @212575
     /* 212575 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(212612), // Rule ID 12197 //
     /* 212580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212601 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1977:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 212604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212610 */     GIR_RootConstrainSelectedInstOperands,
     /* 212611 */     // GIR_Coverage, 12197,
     /* 212611 */     GIR_EraseRootFromParent_Done,
     /* 212612 */   // Label 4090: @212612
     /* 212612 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(212649), // Rule ID 12198 //
     /* 212617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212638 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1977:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 212641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212647 */     GIR_RootConstrainSelectedInstOperands,
     /* 212648 */     // GIR_Coverage, 12198,
     /* 212648 */     GIR_EraseRootFromParent_Done,
     /* 212649 */   // Label 4091: @212649
     /* 212649 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(212686), // Rule ID 12199 //
     /* 212654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 212662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212675 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1977:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 212678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212684 */     GIR_RootConstrainSelectedInstOperands,
     /* 212685 */     // GIR_Coverage, 12199,
     /* 212685 */     GIR_EraseRootFromParent_Done,
     /* 212686 */   // Label 4092: @212686
     /* 212686 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(212723), // Rule ID 12200 //
     /* 212691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212712 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 212715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212721 */     GIR_RootConstrainSelectedInstOperands,
     /* 212722 */     // GIR_Coverage, 12200,
     /* 212722 */     GIR_EraseRootFromParent_Done,
     /* 212723 */   // Label 4093: @212723
     /* 212723 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(212760), // Rule ID 12201 //
     /* 212728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212749 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 212752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212758 */     GIR_RootConstrainSelectedInstOperands,
     /* 212759 */     // GIR_Coverage, 12201,
     /* 212759 */     GIR_EraseRootFromParent_Done,
     /* 212760 */   // Label 4094: @212760
     /* 212760 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(212797), // Rule ID 12202 //
     /* 212765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212786 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 212789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212795 */     GIR_RootConstrainSelectedInstOperands,
     /* 212796 */     // GIR_Coverage, 12202,
     /* 212796 */     GIR_EraseRootFromParent_Done,
     /* 212797 */   // Label 4095: @212797
     /* 212797 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(212834), // Rule ID 12203 //
     /* 212802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 212810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212823 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 212826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212832 */     GIR_RootConstrainSelectedInstOperands,
     /* 212833 */     // GIR_Coverage, 12203,
     /* 212833 */     GIR_EraseRootFromParent_Done,
     /* 212834 */   // Label 4096: @212834
     /* 212834 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(212871), // Rule ID 12204 //
     /* 212839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212860 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1986:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 212863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212869 */     GIR_RootConstrainSelectedInstOperands,
     /* 212870 */     // GIR_Coverage, 12204,
     /* 212870 */     GIR_EraseRootFromParent_Done,
     /* 212871 */   // Label 4097: @212871
     /* 212871 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(212908), // Rule ID 12205 //
     /* 212876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212897 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1986:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 212900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212906 */     GIR_RootConstrainSelectedInstOperands,
     /* 212907 */     // GIR_Coverage, 12205,
     /* 212907 */     GIR_EraseRootFromParent_Done,
     /* 212908 */   // Label 4098: @212908
     /* 212908 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(212945), // Rule ID 12206 //
     /* 212913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212934 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1986:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 212937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212943 */     GIR_RootConstrainSelectedInstOperands,
     /* 212944 */     // GIR_Coverage, 12206,
     /* 212944 */     GIR_EraseRootFromParent_Done,
     /* 212945 */   // Label 4099: @212945
     /* 212945 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(212982), // Rule ID 12207 //
     /* 212950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 212958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212971 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1986:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 212974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212980 */     GIR_RootConstrainSelectedInstOperands,
     /* 212981 */     // GIR_Coverage, 12207,
     /* 212981 */     GIR_EraseRootFromParent_Done,
     /* 212982 */   // Label 4100: @212982
     /* 212982 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(213019), // Rule ID 12208 //
     /* 212987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 212995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2170:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 213011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213017 */     GIR_RootConstrainSelectedInstOperands,
     /* 213018 */     // GIR_Coverage, 12208,
     /* 213018 */     GIR_EraseRootFromParent_Done,
     /* 213019 */   // Label 4101: @213019
     /* 213019 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(213056), // Rule ID 12209 //
     /* 213024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2170:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 213048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213054 */     GIR_RootConstrainSelectedInstOperands,
     /* 213055 */     // GIR_Coverage, 12209,
     /* 213055 */     GIR_EraseRootFromParent_Done,
     /* 213056 */   // Label 4102: @213056
     /* 213056 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(213093), // Rule ID 12210 //
     /* 213061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2170:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 213085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213091 */     GIR_RootConstrainSelectedInstOperands,
     /* 213092 */     // GIR_Coverage, 12210,
     /* 213092 */     GIR_EraseRootFromParent_Done,
     /* 213093 */   // Label 4103: @213093
     /* 213093 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(213130), // Rule ID 12211 //
     /* 213098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213119 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2170:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 213122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213128 */     GIR_RootConstrainSelectedInstOperands,
     /* 213129 */     // GIR_Coverage, 12211,
     /* 213129 */     GIR_EraseRootFromParent_Done,
     /* 213130 */   // Label 4104: @213130
     /* 213130 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(213167), // Rule ID 12212 //
     /* 213135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213156 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2170:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 213159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213165 */     GIR_RootConstrainSelectedInstOperands,
     /* 213166 */     // GIR_Coverage, 12212,
     /* 213166 */     GIR_EraseRootFromParent_Done,
     /* 213167 */   // Label 4105: @213167
     /* 213167 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(213204), // Rule ID 12213 //
     /* 213172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213193 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2170:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 213196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213202 */     GIR_RootConstrainSelectedInstOperands,
     /* 213203 */     // GIR_Coverage, 12213,
     /* 213203 */     GIR_EraseRootFromParent_Done,
     /* 213204 */   // Label 4106: @213204
     /* 213204 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(213241), // Rule ID 12214 //
     /* 213209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 213217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213230 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2170:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 213233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213239 */     GIR_RootConstrainSelectedInstOperands,
     /* 213240 */     // GIR_Coverage, 12214,
     /* 213240 */     GIR_EraseRootFromParent_Done,
     /* 213241 */   // Label 4107: @213241
     /* 213241 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(213278), // Rule ID 12215 //
     /* 213246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213267 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 213270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213276 */     GIR_RootConstrainSelectedInstOperands,
     /* 213277 */     // GIR_Coverage, 12215,
     /* 213277 */     GIR_EraseRootFromParent_Done,
     /* 213278 */   // Label 4108: @213278
     /* 213278 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(213315), // Rule ID 12216 //
     /* 213283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 213307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213313 */     GIR_RootConstrainSelectedInstOperands,
     /* 213314 */     // GIR_Coverage, 12216,
     /* 213314 */     GIR_EraseRootFromParent_Done,
     /* 213315 */   // Label 4109: @213315
     /* 213315 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(213352), // Rule ID 12217 //
     /* 213320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 213344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213350 */     GIR_RootConstrainSelectedInstOperands,
     /* 213351 */     // GIR_Coverage, 12217,
     /* 213351 */     GIR_EraseRootFromParent_Done,
     /* 213352 */   // Label 4110: @213352
     /* 213352 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(213389), // Rule ID 12218 //
     /* 213357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 213381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213387 */     GIR_RootConstrainSelectedInstOperands,
     /* 213388 */     // GIR_Coverage, 12218,
     /* 213388 */     GIR_EraseRootFromParent_Done,
     /* 213389 */   // Label 4111: @213389
     /* 213389 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(213426), // Rule ID 12219 //
     /* 213394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 213418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213424 */     GIR_RootConstrainSelectedInstOperands,
     /* 213425 */     // GIR_Coverage, 12219,
     /* 213425 */     GIR_EraseRootFromParent_Done,
     /* 213426 */   // Label 4112: @213426
     /* 213426 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(213463), // Rule ID 12220 //
     /* 213431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 213455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213461 */     GIR_RootConstrainSelectedInstOperands,
     /* 213462 */     // GIR_Coverage, 12220,
     /* 213462 */     GIR_EraseRootFromParent_Done,
     /* 213463 */   // Label 4113: @213463
     /* 213463 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(213500), // Rule ID 12221 //
     /* 213468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 213476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213489 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 213492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213498 */     GIR_RootConstrainSelectedInstOperands,
     /* 213499 */     // GIR_Coverage, 12221,
     /* 213499 */     GIR_EraseRootFromParent_Done,
     /* 213500 */   // Label 4114: @213500
     /* 213500 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(213537), // Rule ID 12222 //
     /* 213505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2096:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 213529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213535 */     GIR_RootConstrainSelectedInstOperands,
     /* 213536 */     // GIR_Coverage, 12222,
     /* 213536 */     GIR_EraseRootFromParent_Done,
     /* 213537 */   // Label 4115: @213537
     /* 213537 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(213574), // Rule ID 12223 //
     /* 213542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2096:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 213566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213572 */     GIR_RootConstrainSelectedInstOperands,
     /* 213573 */     // GIR_Coverage, 12223,
     /* 213573 */     GIR_EraseRootFromParent_Done,
     /* 213574 */   // Label 4116: @213574
     /* 213574 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(213611), // Rule ID 12224 //
     /* 213579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2096:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 213603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213609 */     GIR_RootConstrainSelectedInstOperands,
     /* 213610 */     // GIR_Coverage, 12224,
     /* 213610 */     GIR_EraseRootFromParent_Done,
     /* 213611 */   // Label 4117: @213611
     /* 213611 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(213648), // Rule ID 12225 //
     /* 213616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2096:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 213640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213646 */     GIR_RootConstrainSelectedInstOperands,
     /* 213647 */     // GIR_Coverage, 12225,
     /* 213647 */     GIR_EraseRootFromParent_Done,
     /* 213648 */   // Label 4118: @213648
     /* 213648 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(213685), // Rule ID 12226 //
     /* 213653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2096:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 213677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213683 */     GIR_RootConstrainSelectedInstOperands,
     /* 213684 */     // GIR_Coverage, 12226,
     /* 213684 */     GIR_EraseRootFromParent_Done,
     /* 213685 */   // Label 4119: @213685
     /* 213685 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(213722), // Rule ID 12227 //
     /* 213690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2096:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 213714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213720 */     GIR_RootConstrainSelectedInstOperands,
     /* 213721 */     // GIR_Coverage, 12227,
     /* 213721 */     GIR_EraseRootFromParent_Done,
     /* 213722 */   // Label 4120: @213722
     /* 213722 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(213759), // Rule ID 12228 //
     /* 213727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 213735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213748 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2096:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 213751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213757 */     GIR_RootConstrainSelectedInstOperands,
     /* 213758 */     // GIR_Coverage, 12228,
     /* 213758 */     GIR_EraseRootFromParent_Done,
     /* 213759 */   // Label 4121: @213759
     /* 213759 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(213801), // Rule ID 3211 //
     /* 213764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 213772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213779 */     // MIs[0] Op1
     /* 213779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213783 */     // MIs[0] Op2
     /* 213783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213787 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 213790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213799 */     GIR_RootConstrainSelectedInstOperands,
     /* 213800 */     // GIR_Coverage, 3211,
     /* 213800 */     GIR_EraseRootFromParent_Done,
     /* 213801 */   // Label 4122: @213801
     /* 213801 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(213843), // Rule ID 3212 //
     /* 213806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 213814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213821 */     // MIs[0] Op1
     /* 213821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213825 */     // MIs[0] Op2
     /* 213825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213829 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 213832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213841 */     GIR_RootConstrainSelectedInstOperands,
     /* 213842 */     // GIR_Coverage, 3212,
     /* 213842 */     GIR_EraseRootFromParent_Done,
     /* 213843 */   // Label 4123: @213843
     /* 213843 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(213885), // Rule ID 3213 //
     /* 213848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 213856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213863 */     // MIs[0] Op1
     /* 213863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213867 */     // MIs[0] Op2
     /* 213867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213871 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 213874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213883 */     GIR_RootConstrainSelectedInstOperands,
     /* 213884 */     // GIR_Coverage, 3213,
     /* 213884 */     GIR_EraseRootFromParent_Done,
     /* 213885 */   // Label 4124: @213885
     /* 213885 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(213927), // Rule ID 3214 //
     /* 213890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 213898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213905 */     // MIs[0] Op1
     /* 213905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213909 */     // MIs[0] Op2
     /* 213909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 213916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213925 */     GIR_RootConstrainSelectedInstOperands,
     /* 213926 */     // GIR_Coverage, 3214,
     /* 213926 */     GIR_EraseRootFromParent_Done,
     /* 213927 */   // Label 4125: @213927
     /* 213927 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(213969), // Rule ID 12039 //
     /* 213932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 213940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213947 */     // MIs[0] Op1
     /* 213947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213951 */     // MIs[0] Op2
     /* 213951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 213958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213967 */     GIR_RootConstrainSelectedInstOperands,
     /* 213968 */     // GIR_Coverage, 12039,
     /* 213968 */     GIR_EraseRootFromParent_Done,
     /* 213969 */   // Label 4126: @213969
     /* 213969 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(214011), // Rule ID 12040 //
     /* 213974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 213982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213989 */     // MIs[0] Op1
     /* 213989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 213993 */     // MIs[0] Op2
     /* 213993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 213997 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2147:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 213997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 214000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214009 */     GIR_RootConstrainSelectedInstOperands,
     /* 214010 */     // GIR_Coverage, 12040,
     /* 214010 */     GIR_EraseRootFromParent_Done,
     /* 214011 */   // Label 4127: @214011
     /* 214011 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(214053), // Rule ID 12041 //
     /* 214016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 214024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214031 */     // MIs[0] Op1
     /* 214031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 214035 */     // MIs[0] Op2
     /* 214035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 214039 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 214042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214051 */     GIR_RootConstrainSelectedInstOperands,
     /* 214052 */     // GIR_Coverage, 12041,
     /* 214052 */     GIR_EraseRootFromParent_Done,
     /* 214053 */   // Label 4128: @214053
     /* 214053 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(214095), // Rule ID 12042 //
     /* 214058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 214066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214073 */     // MIs[0] Op1
     /* 214073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 214077 */     // MIs[0] Op2
     /* 214077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 214081 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2146:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 214084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214093 */     GIR_RootConstrainSelectedInstOperands,
     /* 214094 */     // GIR_Coverage, 12042,
     /* 214094 */     GIR_EraseRootFromParent_Done,
     /* 214095 */   // Label 4129: @214095
     /* 214095 */   GIM_Reject,
     /* 214096 */ // Label 3232: @214096
     /* 214096 */ GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(257207),
     /* 214101 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 214104 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(214217), // Rule ID 2069 //
     /* 214109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 214161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 214174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 214186 */     // MIs[3] Operand 1
     /* 214186 */     // No operand predicates
     /* 214186 */     // MIs[1] Operand 2
     /* 214186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214199 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 214202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214215 */     GIR_RootConstrainSelectedInstOperands,
     /* 214216 */     // GIR_Coverage, 2069,
     /* 214216 */     GIR_EraseRootFromParent_Done,
     /* 214217 */   // Label 4131: @214217
     /* 214217 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(214330), // Rule ID 2076 //
     /* 214222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 214274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 214278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 214287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214295 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 214299 */     // MIs[3] Operand 1
     /* 214299 */     // No operand predicates
     /* 214299 */     // MIs[1] Operand 2
     /* 214299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214312 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 214315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214328 */     GIR_RootConstrainSelectedInstOperands,
     /* 214329 */     // GIR_Coverage, 2076,
     /* 214329 */     GIR_EraseRootFromParent_Done,
     /* 214330 */   // Label 4132: @214330
     /* 214330 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(214443), // Rule ID 2072 //
     /* 214335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214408 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214412 */     // MIs[3] Operand 1
     /* 214412 */     // No operand predicates
     /* 214412 */     // MIs[1] Operand 2
     /* 214412 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214425 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 214428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214441 */     GIR_RootConstrainSelectedInstOperands,
     /* 214442 */     // GIR_Coverage, 2072,
     /* 214442 */     GIR_EraseRootFromParent_Done,
     /* 214443 */   // Label 4133: @214443
     /* 214443 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(214556), // Rule ID 2079 //
     /* 214448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 214488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214521 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 214525 */     // MIs[3] Operand 1
     /* 214525 */     // No operand predicates
     /* 214525 */     // MIs[1] Operand 2
     /* 214525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 214536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214538 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 214538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 214541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214554 */     GIR_RootConstrainSelectedInstOperands,
     /* 214555 */     // GIR_Coverage, 2079,
     /* 214555 */     GIR_EraseRootFromParent_Done,
     /* 214556 */   // Label 4134: @214556
     /* 214556 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(214661), // Rule ID 3866 //
     /* 214561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 214569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214634 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214638 */     // MIs[3] Operand 1
     /* 214638 */     // No operand predicates
     /* 214638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214640 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 214640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214659 */     GIR_RootConstrainSelectedInstOperands,
     /* 214660 */     // GIR_Coverage, 3866,
     /* 214660 */     GIR_EraseRootFromParent_Done,
     /* 214661 */   // Label 4135: @214661
     /* 214661 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(214766), // Rule ID 3867 //
     /* 214666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 214674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214743 */     // MIs[3] Operand 1
     /* 214743 */     // No operand predicates
     /* 214743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214745 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 214745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214764 */     GIR_RootConstrainSelectedInstOperands,
     /* 214765 */     // GIR_Coverage, 3867,
     /* 214765 */     GIR_EraseRootFromParent_Done,
     /* 214766 */   // Label 4136: @214766
     /* 214766 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(214871), // Rule ID 3868 //
     /* 214771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 214779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214844 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214848 */     // MIs[3] Operand 1
     /* 214848 */     // No operand predicates
     /* 214848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214850 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 214850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 214869 */     GIR_RootConstrainSelectedInstOperands,
     /* 214870 */     // GIR_Coverage, 3868,
     /* 214870 */     GIR_EraseRootFromParent_Done,
     /* 214871 */   // Label 4137: @214871
     /* 214871 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(214976), // Rule ID 3869 //
     /* 214876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 214884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 214912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 214916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 214920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 214924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 214928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 214932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 214936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 214945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 214949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 214953 */     // MIs[3] Operand 1
     /* 214953 */     // No operand predicates
     /* 214953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 214955 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 214955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 214958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 214968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 214971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 214974 */     GIR_RootConstrainSelectedInstOperands,
     /* 214975 */     // GIR_Coverage, 3869,
     /* 214975 */     GIR_EraseRootFromParent_Done,
     /* 214976 */   // Label 4138: @214976
     /* 214976 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215081), // Rule ID 3874 //
     /* 214981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 214984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 214989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215058 */     // MIs[3] Operand 1
     /* 215058 */     // No operand predicates
     /* 215058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215060 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 215060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215079 */     GIR_RootConstrainSelectedInstOperands,
     /* 215080 */     // GIR_Coverage, 3874,
     /* 215080 */     GIR_EraseRootFromParent_Done,
     /* 215081 */   // Label 4139: @215081
     /* 215081 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215186), // Rule ID 3875 //
     /* 215086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 215094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215159 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215163 */     // MIs[3] Operand 1
     /* 215163 */     // No operand predicates
     /* 215163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215165 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 215165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215184 */     GIR_RootConstrainSelectedInstOperands,
     /* 215185 */     // GIR_Coverage, 3875,
     /* 215185 */     GIR_EraseRootFromParent_Done,
     /* 215186 */   // Label 4140: @215186
     /* 215186 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(215291), // Rule ID 3876 //
     /* 215191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 215199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215268 */     // MIs[3] Operand 1
     /* 215268 */     // No operand predicates
     /* 215268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215270 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 215270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 215289 */     GIR_RootConstrainSelectedInstOperands,
     /* 215290 */     // GIR_Coverage, 3876,
     /* 215290 */     GIR_EraseRootFromParent_Done,
     /* 215291 */   // Label 4141: @215291
     /* 215291 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215396), // Rule ID 3877 //
     /* 215296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 215304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215373 */     // MIs[3] Operand 1
     /* 215373 */     // No operand predicates
     /* 215373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215375 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 215375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 215378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 215394 */     GIR_RootConstrainSelectedInstOperands,
     /* 215395 */     // GIR_Coverage, 3877,
     /* 215395 */     GIR_EraseRootFromParent_Done,
     /* 215396 */   // Label 4142: @215396
     /* 215396 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215501), // Rule ID 3890 //
     /* 215401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 215409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215478 */     // MIs[3] Operand 1
     /* 215478 */     // No operand predicates
     /* 215478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215480 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 215480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215499 */     GIR_RootConstrainSelectedInstOperands,
     /* 215500 */     // GIR_Coverage, 3890,
     /* 215500 */     GIR_EraseRootFromParent_Done,
     /* 215501 */   // Label 4143: @215501
     /* 215501 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(215606), // Rule ID 3891 //
     /* 215506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 215514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215583 */     // MIs[3] Operand 1
     /* 215583 */     // No operand predicates
     /* 215583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215585 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 215585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215604 */     GIR_RootConstrainSelectedInstOperands,
     /* 215605 */     // GIR_Coverage, 3891,
     /* 215605 */     GIR_EraseRootFromParent_Done,
     /* 215606 */   // Label 4144: @215606
     /* 215606 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(215711), // Rule ID 3892 //
     /* 215611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 215619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215688 */     // MIs[3] Operand 1
     /* 215688 */     // No operand predicates
     /* 215688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215690 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 215690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 215709 */     GIR_RootConstrainSelectedInstOperands,
     /* 215710 */     // GIR_Coverage, 3892,
     /* 215710 */     GIR_EraseRootFromParent_Done,
     /* 215711 */   // Label 4145: @215711
     /* 215711 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215816), // Rule ID 3893 //
     /* 215716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 215719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 215724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 215768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215789 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215793 */     // MIs[3] Operand 1
     /* 215793 */     // No operand predicates
     /* 215793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215795 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 215795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 215798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 215814 */     GIR_RootConstrainSelectedInstOperands,
     /* 215815 */     // GIR_Coverage, 3893,
     /* 215815 */     GIR_EraseRootFromParent_Done,
     /* 215816 */   // Label 4146: @215816
     /* 215816 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(215870), // Rule ID 59 //
     /* 215821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215846 */     // MIs[0] Operand 3
     /* 215846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 215857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215861 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 215864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215868 */     GIR_RootConstrainSelectedInstOperands,
     /* 215869 */     // GIR_Coverage, 59,
     /* 215869 */     GIR_EraseRootFromParent_Done,
     /* 215870 */   // Label 4147: @215870
     /* 215870 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(215924), // Rule ID 60 //
     /* 215875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215900 */     // MIs[0] Operand 3
     /* 215900 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 215911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215915 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 215918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215922 */     GIR_RootConstrainSelectedInstOperands,
     /* 215923 */     // GIR_Coverage, 60,
     /* 215923 */     GIR_EraseRootFromParent_Done,
     /* 215924 */   // Label 4148: @215924
     /* 215924 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(215978), // Rule ID 61 //
     /* 215929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 215946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 215954 */     // MIs[0] Operand 3
     /* 215954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 215965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 215969 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 215969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 215972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215976 */     GIR_RootConstrainSelectedInstOperands,
     /* 215977 */     // GIR_Coverage, 61,
     /* 215977 */     GIR_EraseRootFromParent_Done,
     /* 215978 */   // Label 4149: @215978
     /* 215978 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216032), // Rule ID 62 //
     /* 215983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 215986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 215991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 215994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 216000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216008 */     // MIs[0] Operand 3
     /* 216008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 216019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 216023 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 216023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 216026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216030 */     GIR_RootConstrainSelectedInstOperands,
     /* 216031 */     // GIR_Coverage, 62,
     /* 216031 */     GIR_EraseRootFromParent_Done,
     /* 216032 */   // Label 4150: @216032
     /* 216032 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216088), // Rule ID 2645 //
     /* 216037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 216045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216059 */     // MIs[0] pattern
     /* 216059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216067 */     // MIs[0] imm4
     /* 216067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 216078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 216082 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216084 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216086 */     GIR_RootConstrainSelectedInstOperands,
     /* 216087 */     // GIR_Coverage, 2645,
     /* 216087 */     GIR_EraseRootFromParent_Done,
     /* 216088 */   // Label 4151: @216088
     /* 216088 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216144), // Rule ID 2654 //
     /* 216093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 216101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216115 */     // MIs[0] pattern
     /* 216115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216123 */     // MIs[0] imm4
     /* 216123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216131 */     // (intrinsic_wo_chain:{ *:[i32] } 2023:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 216134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216138 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216140 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216142 */     GIR_RootConstrainSelectedInstOperands,
     /* 216143 */     // GIR_Coverage, 2654,
     /* 216143 */     GIR_EraseRootFromParent_Done,
     /* 216144 */   // Label 4152: @216144
     /* 216144 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216200), // Rule ID 2655 //
     /* 216149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 216157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216171 */     // MIs[0] pattern
     /* 216171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216179 */     // MIs[0] imm4
     /* 216179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216187 */     // (intrinsic_wo_chain:{ *:[i64] } 1813:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 216190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216194 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216196 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216198 */     GIR_RootConstrainSelectedInstOperands,
     /* 216199 */     // GIR_Coverage, 2655,
     /* 216199 */     GIR_EraseRootFromParent_Done,
     /* 216200 */   // Label 4153: @216200
     /* 216200 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216256), // Rule ID 10026 //
     /* 216205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 216213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216227 */     // MIs[0] pattern
     /* 216227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216235 */     // MIs[0] imm4
     /* 216235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216243 */     // (intrinsic_wo_chain:{ *:[i32] } 2009:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 216246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216250 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216252 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216254 */     GIR_RootConstrainSelectedInstOperands,
     /* 216255 */     // GIR_Coverage, 10026,
     /* 216255 */     GIR_EraseRootFromParent_Done,
     /* 216256 */   // Label 4154: @216256
     /* 216256 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216312), // Rule ID 10027 //
     /* 216261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 216269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216283 */     // MIs[0] pattern
     /* 216283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216291 */     // MIs[0] imm4
     /* 216291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216299 */     // (intrinsic_wo_chain:{ *:[i64] } 2024:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 216302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216306 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216308 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216310 */     GIR_RootConstrainSelectedInstOperands,
     /* 216311 */     // GIR_Coverage, 10027,
     /* 216311 */     GIR_EraseRootFromParent_Done,
     /* 216312 */   // Label 4155: @216312
     /* 216312 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216368), // Rule ID 10028 //
     /* 216317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 216325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216339 */     // MIs[0] pattern
     /* 216339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216347 */     // MIs[0] imm4
     /* 216347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216355 */     // (intrinsic_wo_chain:{ *:[i64] } 1779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 216358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216362 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216364 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216366 */     GIR_RootConstrainSelectedInstOperands,
     /* 216367 */     // GIR_Coverage, 10028,
     /* 216367 */     GIR_EraseRootFromParent_Done,
     /* 216368 */   // Label 4156: @216368
     /* 216368 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216424), // Rule ID 10029 //
     /* 216373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 216381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216395 */     // MIs[0] pattern
     /* 216395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216403 */     // MIs[0] imm4
     /* 216403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216411 */     // (intrinsic_wo_chain:{ *:[i64] } 2010:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 216414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216418 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216420 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216422 */     GIR_RootConstrainSelectedInstOperands,
     /* 216423 */     // GIR_Coverage, 10029,
     /* 216423 */     GIR_EraseRootFromParent_Done,
     /* 216424 */   // Label 4157: @216424
     /* 216424 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216480), // Rule ID 10032 //
     /* 216429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 216437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216451 */     // MIs[0] pattern
     /* 216451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216459 */     // MIs[0] imm4
     /* 216459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216467 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 216470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216474 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216476 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216478 */     GIR_RootConstrainSelectedInstOperands,
     /* 216479 */     // GIR_Coverage, 10032,
     /* 216479 */     GIR_EraseRootFromParent_Done,
     /* 216480 */   // Label 4158: @216480
     /* 216480 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(216536), // Rule ID 10035 //
     /* 216485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 216493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216507 */     // MIs[0] pattern
     /* 216507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216515 */     // MIs[0] imm4
     /* 216515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216523 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 216526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216530 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216532 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216534 */     GIR_RootConstrainSelectedInstOperands,
     /* 216535 */     // GIR_Coverage, 10035,
     /* 216535 */     GIR_EraseRootFromParent_Done,
     /* 216536 */   // Label 4159: @216536
     /* 216536 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(216592), // Rule ID 10036 //
     /* 216541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 216549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216563 */     // MIs[0] pattern
     /* 216563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216571 */     // MIs[0] imm4
     /* 216571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216579 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 216582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216586 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216588 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216590 */     GIR_RootConstrainSelectedInstOperands,
     /* 216591 */     // GIR_Coverage, 10036,
     /* 216591 */     GIR_EraseRootFromParent_Done,
     /* 216592 */   // Label 4160: @216592
     /* 216592 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(216648), // Rule ID 10037 //
     /* 216597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 216605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216619 */     // MIs[0] pattern
     /* 216619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216627 */     // MIs[0] imm4
     /* 216627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216635 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 216638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216642 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216644 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216646 */     GIR_RootConstrainSelectedInstOperands,
     /* 216647 */     // GIR_Coverage, 10037,
     /* 216647 */     GIR_EraseRootFromParent_Done,
     /* 216648 */   // Label 4161: @216648
     /* 216648 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(216704), // Rule ID 10038 //
     /* 216653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 216661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216675 */     // MIs[0] pattern
     /* 216675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216683 */     // MIs[0] imm4
     /* 216683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216691 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 216694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216698 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216700 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216702 */     GIR_RootConstrainSelectedInstOperands,
     /* 216703 */     // GIR_Coverage, 10038,
     /* 216703 */     GIR_EraseRootFromParent_Done,
     /* 216704 */   // Label 4162: @216704
     /* 216704 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(216760), // Rule ID 10039 //
     /* 216709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 216717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216731 */     // MIs[0] pattern
     /* 216731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216739 */     // MIs[0] imm4
     /* 216739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216747 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 216750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216754 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216756 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216758 */     GIR_RootConstrainSelectedInstOperands,
     /* 216759 */     // GIR_Coverage, 10039,
     /* 216759 */     GIR_EraseRootFromParent_Done,
     /* 216760 */   // Label 4163: @216760
     /* 216760 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(216816), // Rule ID 10042 //
     /* 216765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 216773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216787 */     // MIs[0] pattern
     /* 216787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216795 */     // MIs[0] imm4
     /* 216795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216803 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 216806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216810 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216812 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216814 */     GIR_RootConstrainSelectedInstOperands,
     /* 216815 */     // GIR_Coverage, 10042,
     /* 216815 */     GIR_EraseRootFromParent_Done,
     /* 216816 */   // Label 4164: @216816
     /* 216816 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(216872), // Rule ID 10045 //
     /* 216821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 216829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 216832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 216843 */     // MIs[0] pattern
     /* 216843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216851 */     // MIs[0] imm4
     /* 216851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216859 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 216862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216866 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216868 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216870 */     GIR_RootConstrainSelectedInstOperands,
     /* 216871 */     // GIR_Coverage, 10045,
     /* 216871 */     GIR_EraseRootFromParent_Done,
     /* 216872 */   // Label 4165: @216872
     /* 216872 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(216928), // Rule ID 10046 //
     /* 216877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 216885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216899 */     // MIs[0] pattern
     /* 216899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216907 */     // MIs[0] imm4
     /* 216907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216915 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 216918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216924 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216926 */     GIR_RootConstrainSelectedInstOperands,
     /* 216927 */     // GIR_Coverage, 10046,
     /* 216927 */     GIR_EraseRootFromParent_Done,
     /* 216928 */   // Label 4166: @216928
     /* 216928 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(216984), // Rule ID 10047 //
     /* 216933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 216941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 216944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 216955 */     // MIs[0] pattern
     /* 216955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 216958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 216963 */     // MIs[0] imm4
     /* 216963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 216966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 216971 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 216971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 216974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 216976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 216978 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 216980 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 216982 */     GIR_RootConstrainSelectedInstOperands,
     /* 216983 */     // GIR_Coverage, 10047,
     /* 216983 */     GIR_EraseRootFromParent_Done,
     /* 216984 */   // Label 4167: @216984
     /* 216984 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217040), // Rule ID 10048 //
     /* 216989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 216997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217011 */     // MIs[0] pattern
     /* 217011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217019 */     // MIs[0] imm4
     /* 217019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217027 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 217030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217034 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217036 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217038 */     GIR_RootConstrainSelectedInstOperands,
     /* 217039 */     // GIR_Coverage, 10048,
     /* 217039 */     GIR_EraseRootFromParent_Done,
     /* 217040 */   // Label 4168: @217040
     /* 217040 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217096), // Rule ID 10049 //
     /* 217045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 217053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217067 */     // MIs[0] pattern
     /* 217067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217075 */     // MIs[0] imm4
     /* 217075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217083 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 217086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217090 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217092 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217094 */     GIR_RootConstrainSelectedInstOperands,
     /* 217095 */     // GIR_Coverage, 10049,
     /* 217095 */     GIR_EraseRootFromParent_Done,
     /* 217096 */   // Label 4169: @217096
     /* 217096 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217152), // Rule ID 10052 //
     /* 217101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 217109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217123 */     // MIs[0] pattern
     /* 217123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217131 */     // MIs[0] imm4
     /* 217131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217139 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 217142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217146 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217148 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217150 */     GIR_RootConstrainSelectedInstOperands,
     /* 217151 */     // GIR_Coverage, 10052,
     /* 217151 */     GIR_EraseRootFromParent_Done,
     /* 217152 */   // Label 4170: @217152
     /* 217152 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217208), // Rule ID 10055 //
     /* 217157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 217165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217179 */     // MIs[0] pattern
     /* 217179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217187 */     // MIs[0] imm4
     /* 217187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217195 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 217198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217202 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217204 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217206 */     GIR_RootConstrainSelectedInstOperands,
     /* 217207 */     // GIR_Coverage, 10055,
     /* 217207 */     GIR_EraseRootFromParent_Done,
     /* 217208 */   // Label 4171: @217208
     /* 217208 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217264), // Rule ID 10056 //
     /* 217213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 217221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217235 */     // MIs[0] pattern
     /* 217235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217243 */     // MIs[0] imm4
     /* 217243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217251 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 217254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217258 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217260 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217262 */     GIR_RootConstrainSelectedInstOperands,
     /* 217263 */     // GIR_Coverage, 10056,
     /* 217263 */     GIR_EraseRootFromParent_Done,
     /* 217264 */   // Label 4172: @217264
     /* 217264 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217320), // Rule ID 10057 //
     /* 217269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 217277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217291 */     // MIs[0] pattern
     /* 217291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217299 */     // MIs[0] imm4
     /* 217299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217307 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 217310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217314 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217316 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217318 */     GIR_RootConstrainSelectedInstOperands,
     /* 217319 */     // GIR_Coverage, 10057,
     /* 217319 */     GIR_EraseRootFromParent_Done,
     /* 217320 */   // Label 4173: @217320
     /* 217320 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(217376), // Rule ID 10058 //
     /* 217325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 217333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217347 */     // MIs[0] pattern
     /* 217347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217355 */     // MIs[0] imm4
     /* 217355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217363 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 217366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217370 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217372 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217374 */     GIR_RootConstrainSelectedInstOperands,
     /* 217375 */     // GIR_Coverage, 10058,
     /* 217375 */     GIR_EraseRootFromParent_Done,
     /* 217376 */   // Label 4174: @217376
     /* 217376 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(217432), // Rule ID 10059 //
     /* 217381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 217389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217403 */     // MIs[0] pattern
     /* 217403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217411 */     // MIs[0] imm4
     /* 217411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217419 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 217422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217426 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217428 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217430 */     GIR_RootConstrainSelectedInstOperands,
     /* 217431 */     // GIR_Coverage, 10059,
     /* 217431 */     GIR_EraseRootFromParent_Done,
     /* 217432 */   // Label 4175: @217432
     /* 217432 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(217488), // Rule ID 10060 //
     /* 217437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 217445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217459 */     // MIs[0] pattern
     /* 217459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217467 */     // MIs[0] imm4
     /* 217467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2028:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 217478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217482 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217484 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217486 */     GIR_RootConstrainSelectedInstOperands,
     /* 217487 */     // GIR_Coverage, 10060,
     /* 217487 */     GIR_EraseRootFromParent_Done,
     /* 217488 */   // Label 4176: @217488
     /* 217488 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(217544), // Rule ID 10061 //
     /* 217493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 217501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217515 */     // MIs[0] pattern
     /* 217515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217523 */     // MIs[0] imm4
     /* 217523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217531 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1783:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 217534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217538 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217540 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217542 */     GIR_RootConstrainSelectedInstOperands,
     /* 217543 */     // GIR_Coverage, 10061,
     /* 217543 */     GIR_EraseRootFromParent_Done,
     /* 217544 */   // Label 4177: @217544
     /* 217544 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(217600), // Rule ID 10062 //
     /* 217549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 217557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217571 */     // MIs[0] pattern
     /* 217571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217579 */     // MIs[0] imm4
     /* 217579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2014:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 217590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217594 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217596 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217598 */     GIR_RootConstrainSelectedInstOperands,
     /* 217599 */     // GIR_Coverage, 10062,
     /* 217599 */     GIR_EraseRootFromParent_Done,
     /* 217600 */   // Label 4178: @217600
     /* 217600 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(217656), // Rule ID 10063 //
     /* 217605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 217613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217627 */     // MIs[0] pattern
     /* 217627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217635 */     // MIs[0] imm4
     /* 217635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 217646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217650 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217652 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217654 */     GIR_RootConstrainSelectedInstOperands,
     /* 217655 */     // GIR_Coverage, 10063,
     /* 217655 */     GIR_EraseRootFromParent_Done,
     /* 217656 */   // Label 4179: @217656
     /* 217656 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(217712), // Rule ID 10064 //
     /* 217661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 217669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217683 */     // MIs[0] pattern
     /* 217683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217691 */     // MIs[0] imm4
     /* 217691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 217702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217706 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217708 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217710 */     GIR_RootConstrainSelectedInstOperands,
     /* 217711 */     // GIR_Coverage, 10064,
     /* 217711 */     GIR_EraseRootFromParent_Done,
     /* 217712 */   // Label 4180: @217712
     /* 217712 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(217768), // Rule ID 10065 //
     /* 217717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 217725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217739 */     // MIs[0] pattern
     /* 217739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217747 */     // MIs[0] imm4
     /* 217747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217755 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 217758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217762 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217764 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217766 */     GIR_RootConstrainSelectedInstOperands,
     /* 217767 */     // GIR_Coverage, 10065,
     /* 217767 */     GIR_EraseRootFromParent_Done,
     /* 217768 */   // Label 4181: @217768
     /* 217768 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(217824), // Rule ID 10066 //
     /* 217773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 217781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217795 */     // MIs[0] pattern
     /* 217795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217803 */     // MIs[0] imm4
     /* 217803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 217814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217818 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217820 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217822 */     GIR_RootConstrainSelectedInstOperands,
     /* 217823 */     // GIR_Coverage, 10066,
     /* 217823 */     GIR_EraseRootFromParent_Done,
     /* 217824 */   // Label 4182: @217824
     /* 217824 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(217880), // Rule ID 10067 //
     /* 217829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 217837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217851 */     // MIs[0] pattern
     /* 217851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217859 */     // MIs[0] imm4
     /* 217859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 217870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217874 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217876 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217878 */     GIR_RootConstrainSelectedInstOperands,
     /* 217879 */     // GIR_Coverage, 10067,
     /* 217879 */     GIR_EraseRootFromParent_Done,
     /* 217880 */   // Label 4183: @217880
     /* 217880 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(217936), // Rule ID 10068 //
     /* 217885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 217893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217907 */     // MIs[0] pattern
     /* 217907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217915 */     // MIs[0] imm4
     /* 217915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2025:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 217926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217930 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217932 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217934 */     GIR_RootConstrainSelectedInstOperands,
     /* 217935 */     // GIR_Coverage, 10068,
     /* 217935 */     GIR_EraseRootFromParent_Done,
     /* 217936 */   // Label 4184: @217936
     /* 217936 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(217992), // Rule ID 10069 //
     /* 217941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 217949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217963 */     // MIs[0] pattern
     /* 217963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217971 */     // MIs[0] imm4
     /* 217971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 217982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217986 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217988 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217990 */     GIR_RootConstrainSelectedInstOperands,
     /* 217991 */     // GIR_Coverage, 10069,
     /* 217991 */     GIR_EraseRootFromParent_Done,
     /* 217992 */   // Label 4185: @217992
     /* 217992 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218048), // Rule ID 10070 //
     /* 217997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 218005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218019 */     // MIs[0] pattern
     /* 218019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218027 */     // MIs[0] imm4
     /* 218027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2011:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 218038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218042 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218044 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218046 */     GIR_RootConstrainSelectedInstOperands,
     /* 218047 */     // GIR_Coverage, 10070,
     /* 218047 */     GIR_EraseRootFromParent_Done,
     /* 218048 */   // Label 4186: @218048
     /* 218048 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218138), // Rule ID 47 //
     /* 218053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 218061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218118 */     // MIs[2] Operand 1
     /* 218118 */     // No operand predicates
     /* 218118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218120 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 218123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218136 */     GIR_RootConstrainSelectedInstOperands,
     /* 218137 */     // GIR_Coverage, 47,
     /* 218137 */     GIR_EraseRootFromParent_Done,
     /* 218138 */   // Label 4187: @218138
     /* 218138 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218228), // Rule ID 48 //
     /* 218143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 218151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218208 */     // MIs[2] Operand 1
     /* 218208 */     // No operand predicates
     /* 218208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218210 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 218213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218226 */     GIR_RootConstrainSelectedInstOperands,
     /* 218227 */     // GIR_Coverage, 48,
     /* 218227 */     GIR_EraseRootFromParent_Done,
     /* 218228 */   // Label 4188: @218228
     /* 218228 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218318), // Rule ID 49 //
     /* 218233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 218241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218298 */     // MIs[2] Operand 1
     /* 218298 */     // No operand predicates
     /* 218298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218300 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 218303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218316 */     GIR_RootConstrainSelectedInstOperands,
     /* 218317 */     // GIR_Coverage, 49,
     /* 218317 */     GIR_EraseRootFromParent_Done,
     /* 218318 */   // Label 4189: @218318
     /* 218318 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218408), // Rule ID 50 //
     /* 218323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 218331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218388 */     // MIs[2] Operand 1
     /* 218388 */     // No operand predicates
     /* 218388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218390 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 218393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218406 */     GIR_RootConstrainSelectedInstOperands,
     /* 218407 */     // GIR_Coverage, 50,
     /* 218407 */     GIR_EraseRootFromParent_Done,
     /* 218408 */   // Label 4190: @218408
     /* 218408 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218498), // Rule ID 51 //
     /* 218413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 218421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218478 */     // MIs[2] Operand 1
     /* 218478 */     // No operand predicates
     /* 218478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218480 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 218483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218496 */     GIR_RootConstrainSelectedInstOperands,
     /* 218497 */     // GIR_Coverage, 51,
     /* 218497 */     GIR_EraseRootFromParent_Done,
     /* 218498 */   // Label 4191: @218498
     /* 218498 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(218588), // Rule ID 52 //
     /* 218503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 218511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218568 */     // MIs[2] Operand 1
     /* 218568 */     // No operand predicates
     /* 218568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218570 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 218573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 52,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4192: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(218678), // Rule ID 53 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218658 */     // MIs[2] Operand 1
     /* 218658 */     // No operand predicates
     /* 218658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218660 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 218663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218676 */     GIR_RootConstrainSelectedInstOperands,
     /* 218677 */     // GIR_Coverage, 53,
     /* 218677 */     GIR_EraseRootFromParent_Done,
     /* 218678 */   // Label 4193: @218678
     /* 218678 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(218768), // Rule ID 54 //
     /* 218683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 218686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 218691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218748 */     // MIs[2] Operand 1
     /* 218748 */     // No operand predicates
     /* 218748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218750 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 218753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218766 */     GIR_RootConstrainSelectedInstOperands,
     /* 218767 */     // GIR_Coverage, 54,
     /* 218767 */     GIR_EraseRootFromParent_Done,
     /* 218768 */   // Label 4194: @218768
     /* 218768 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(218858), // Rule ID 2070 //
     /* 218773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218834 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218838 */     // MIs[2] Operand 1
     /* 218838 */     // No operand predicates
     /* 218838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 218843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218856 */     GIR_RootConstrainSelectedInstOperands,
     /* 218857 */     // GIR_Coverage, 2070,
     /* 218857 */     GIR_EraseRootFromParent_Done,
     /* 218858 */   // Label 4195: @218858
     /* 218858 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(218948), // Rule ID 2071 //
     /* 218863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 218911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 218920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218924 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218928 */     // MIs[2] Operand 1
     /* 218928 */     // No operand predicates
     /* 218928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 218930 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 218933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 218943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 218946 */     GIR_RootConstrainSelectedInstOperands,
     /* 218947 */     // GIR_Coverage, 2071,
     /* 218947 */     GIR_EraseRootFromParent_Done,
     /* 218948 */   // Label 4196: @218948
     /* 218948 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219038), // Rule ID 2077 //
     /* 218953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219018 */     // MIs[2] Operand 1
     /* 219018 */     // No operand predicates
     /* 219018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219020 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 219023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219036 */     GIR_RootConstrainSelectedInstOperands,
     /* 219037 */     // GIR_Coverage, 2077,
     /* 219037 */     GIR_EraseRootFromParent_Done,
     /* 219038 */   // Label 4197: @219038
     /* 219038 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219128), // Rule ID 2078 //
     /* 219043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219108 */     // MIs[2] Operand 1
     /* 219108 */     // No operand predicates
     /* 219108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219110 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 219113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219126 */     GIR_RootConstrainSelectedInstOperands,
     /* 219127 */     // GIR_Coverage, 2078,
     /* 219127 */     GIR_EraseRootFromParent_Done,
     /* 219128 */   // Label 4198: @219128
     /* 219128 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219218), // Rule ID 2073 //
     /* 219133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 219141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219194 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219198 */     // MIs[2] Operand 1
     /* 219198 */     // No operand predicates
     /* 219198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219200 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 219203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219216 */     GIR_RootConstrainSelectedInstOperands,
     /* 219217 */     // GIR_Coverage, 2073,
     /* 219217 */     GIR_EraseRootFromParent_Done,
     /* 219218 */   // Label 4199: @219218
     /* 219218 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219308), // Rule ID 2074 //
     /* 219223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 219231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219288 */     // MIs[2] Operand 1
     /* 219288 */     // No operand predicates
     /* 219288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219290 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 219293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219306 */     GIR_RootConstrainSelectedInstOperands,
     /* 219307 */     // GIR_Coverage, 2074,
     /* 219307 */     GIR_EraseRootFromParent_Done,
     /* 219308 */   // Label 4200: @219308
     /* 219308 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219398), // Rule ID 2080 //
     /* 219313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 219330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 219333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219378 */     // MIs[2] Operand 1
     /* 219378 */     // No operand predicates
     /* 219378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219380 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 219383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219396 */     GIR_RootConstrainSelectedInstOperands,
     /* 219397 */     // GIR_Coverage, 2080,
     /* 219397 */     GIR_EraseRootFromParent_Done,
     /* 219398 */   // Label 4201: @219398
     /* 219398 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219488), // Rule ID 2081 //
     /* 219403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219468 */     // MIs[2] Operand 1
     /* 219468 */     // No operand predicates
     /* 219468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219470 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 219473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219486 */     GIR_RootConstrainSelectedInstOperands,
     /* 219487 */     // GIR_Coverage, 2081,
     /* 219487 */     GIR_EraseRootFromParent_Done,
     /* 219488 */   // Label 4202: @219488
     /* 219488 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219578), // Rule ID 2075 //
     /* 219493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 219501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 219510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 219513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 219533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219558 */     // MIs[2] Operand 1
     /* 219558 */     // No operand predicates
     /* 219558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219560 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 219563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219576 */     GIR_RootConstrainSelectedInstOperands,
     /* 219577 */     // GIR_Coverage, 2075,
     /* 219577 */     GIR_EraseRootFromParent_Done,
     /* 219578 */   // Label 4203: @219578
     /* 219578 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219668), // Rule ID 2082 //
     /* 219583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 219586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 219591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 219600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 219603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 219615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 219623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219648 */     // MIs[2] Operand 1
     /* 219648 */     // No operand predicates
     /* 219648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219650 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 219653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219666 */     GIR_RootConstrainSelectedInstOperands,
     /* 219667 */     // GIR_Coverage, 2082,
     /* 219667 */     GIR_EraseRootFromParent_Done,
     /* 219668 */   // Label 4204: @219668
     /* 219668 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219745), // Rule ID 2774 //
     /* 219673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 219717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219725 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 219729 */     // MIs[2] Operand 1
     /* 219729 */     // No operand predicates
     /* 219729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 219731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 219734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219743 */     GIR_RootConstrainSelectedInstOperands,
     /* 219744 */     // GIR_Coverage, 2774,
     /* 219744 */     GIR_EraseRootFromParent_Done,
     /* 219745 */   // Label 4205: @219745
     /* 219745 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219822), // Rule ID 2775 //
     /* 219750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 219794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219802 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 219806 */     // MIs[2] Operand 1
     /* 219806 */     // No operand predicates
     /* 219806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219808 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 219808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 219811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219820 */     GIR_RootConstrainSelectedInstOperands,
     /* 219821 */     // GIR_Coverage, 2775,
     /* 219821 */     GIR_EraseRootFromParent_Done,
     /* 219822 */   // Label 4206: @219822
     /* 219822 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(219899), // Rule ID 2776 //
     /* 219827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 219871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219879 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 219883 */     // MIs[2] Operand 1
     /* 219883 */     // No operand predicates
     /* 219883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219885 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 219885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 219888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219897 */     GIR_RootConstrainSelectedInstOperands,
     /* 219898 */     // GIR_Coverage, 2776,
     /* 219898 */     GIR_EraseRootFromParent_Done,
     /* 219899 */   // Label 4207: @219899
     /* 219899 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(219976), // Rule ID 2777 //
     /* 219904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 219932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 219944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 219948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 219956 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 219960 */     // MIs[2] Operand 1
     /* 219960 */     // No operand predicates
     /* 219960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 219962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 219965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 219969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 219971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219974 */     GIR_RootConstrainSelectedInstOperands,
     /* 219975 */     // GIR_Coverage, 2777,
     /* 219975 */     GIR_EraseRootFromParent_Done,
     /* 219976 */   // Label 4208: @219976
     /* 219976 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220053), // Rule ID 2778 //
     /* 219981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220033 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220037 */     // MIs[2] Operand 1
     /* 220037 */     // No operand predicates
     /* 220037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220039 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 220039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 220042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220051 */     GIR_RootConstrainSelectedInstOperands,
     /* 220052 */     // GIR_Coverage, 2778,
     /* 220052 */     GIR_EraseRootFromParent_Done,
     /* 220053 */   // Label 4209: @220053
     /* 220053 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220130), // Rule ID 2779 //
     /* 220058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 220066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220110 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220114 */     // MIs[2] Operand 1
     /* 220114 */     // No operand predicates
     /* 220114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 220116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 220119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220128 */     GIR_RootConstrainSelectedInstOperands,
     /* 220129 */     // GIR_Coverage, 2779,
     /* 220129 */     GIR_EraseRootFromParent_Done,
     /* 220130 */   // Label 4210: @220130
     /* 220130 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220207), // Rule ID 7913 //
     /* 220135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220187 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220191 */     // MIs[2] Operand 1
     /* 220191 */     // No operand predicates
     /* 220191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220193 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 220193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 220196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220205 */     GIR_RootConstrainSelectedInstOperands,
     /* 220206 */     // GIR_Coverage, 7913,
     /* 220206 */     GIR_EraseRootFromParent_Done,
     /* 220207 */   // Label 4211: @220207
     /* 220207 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220284), // Rule ID 7914 //
     /* 220212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220264 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220268 */     // MIs[2] Operand 1
     /* 220268 */     // No operand predicates
     /* 220268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 220270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 220273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220282 */     GIR_RootConstrainSelectedInstOperands,
     /* 220283 */     // GIR_Coverage, 7914,
     /* 220283 */     GIR_EraseRootFromParent_Done,
     /* 220284 */   // Label 4212: @220284
     /* 220284 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220361), // Rule ID 7915 //
     /* 220289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220341 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220345 */     // MIs[2] Operand 1
     /* 220345 */     // No operand predicates
     /* 220345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220347 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 220347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 220350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220359 */     GIR_RootConstrainSelectedInstOperands,
     /* 220360 */     // GIR_Coverage, 7915,
     /* 220360 */     GIR_EraseRootFromParent_Done,
     /* 220361 */   // Label 4213: @220361
     /* 220361 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220438), // Rule ID 7916 //
     /* 220366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220418 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220422 */     // MIs[2] Operand 1
     /* 220422 */     // No operand predicates
     /* 220422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 220424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 220427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220436 */     GIR_RootConstrainSelectedInstOperands,
     /* 220437 */     // GIR_Coverage, 7916,
     /* 220437 */     GIR_EraseRootFromParent_Done,
     /* 220438 */   // Label 4214: @220438
     /* 220438 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220515), // Rule ID 7917 //
     /* 220443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220495 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220499 */     // MIs[2] Operand 1
     /* 220499 */     // No operand predicates
     /* 220499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220501 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 220501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 220504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220513 */     GIR_RootConstrainSelectedInstOperands,
     /* 220514 */     // GIR_Coverage, 7917,
     /* 220514 */     GIR_EraseRootFromParent_Done,
     /* 220515 */   // Label 4215: @220515
     /* 220515 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220592), // Rule ID 7918 //
     /* 220520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 220528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220572 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 220576 */     // MIs[2] Operand 1
     /* 220576 */     // No operand predicates
     /* 220576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220578 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 220578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 220581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220590 */     GIR_RootConstrainSelectedInstOperands,
     /* 220591 */     // GIR_Coverage, 7918,
     /* 220591 */     GIR_EraseRootFromParent_Done,
     /* 220592 */   // Label 4216: @220592
     /* 220592 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220669), // Rule ID 7919 //
     /* 220597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220649 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220653 */     // MIs[2] Operand 1
     /* 220653 */     // No operand predicates
     /* 220653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 220655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 220658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220667 */     GIR_RootConstrainSelectedInstOperands,
     /* 220668 */     // GIR_Coverage, 7919,
     /* 220668 */     GIR_EraseRootFromParent_Done,
     /* 220669 */   // Label 4217: @220669
     /* 220669 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(220746), // Rule ID 7920 //
     /* 220674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 220718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220726 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 220730 */     // MIs[2] Operand 1
     /* 220730 */     // No operand predicates
     /* 220730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 220732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 220735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220744 */     GIR_RootConstrainSelectedInstOperands,
     /* 220745 */     // GIR_Coverage, 7920,
     /* 220745 */     GIR_EraseRootFromParent_Done,
     /* 220746 */   // Label 4218: @220746
     /* 220746 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(220823), // Rule ID 7921 //
     /* 220751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220803 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220807 */     // MIs[2] Operand 1
     /* 220807 */     // No operand predicates
     /* 220807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220809 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 220809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 220812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220821 */     GIR_RootConstrainSelectedInstOperands,
     /* 220822 */     // GIR_Coverage, 7921,
     /* 220822 */     GIR_EraseRootFromParent_Done,
     /* 220823 */   // Label 4219: @220823
     /* 220823 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(220900), // Rule ID 7922 //
     /* 220828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 220872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220880 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 220884 */     // MIs[2] Operand 1
     /* 220884 */     // No operand predicates
     /* 220884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220886 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 220886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 220889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220898 */     GIR_RootConstrainSelectedInstOperands,
     /* 220899 */     // GIR_Coverage, 7922,
     /* 220899 */     GIR_EraseRootFromParent_Done,
     /* 220900 */   // Label 4220: @220900
     /* 220900 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(220977), // Rule ID 7923 //
     /* 220905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 220933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 220945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 220949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 220953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 220957 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 220961 */     // MIs[2] Operand 1
     /* 220961 */     // No operand predicates
     /* 220961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220963 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 220963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 220966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 220970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 220972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220975 */     GIR_RootConstrainSelectedInstOperands,
     /* 220976 */     // GIR_Coverage, 7923,
     /* 220976 */     GIR_EraseRootFromParent_Done,
     /* 220977 */   // Label 4221: @220977
     /* 220977 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221054), // Rule ID 7924 //
     /* 220982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 220990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221034 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 221038 */     // MIs[2] Operand 1
     /* 221038 */     // No operand predicates
     /* 221038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 221043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221052 */     GIR_RootConstrainSelectedInstOperands,
     /* 221053 */     // GIR_Coverage, 7924,
     /* 221053 */     GIR_EraseRootFromParent_Done,
     /* 221054 */   // Label 4222: @221054
     /* 221054 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221131), // Rule ID 7925 //
     /* 221059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221111 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221115 */     // MIs[2] Operand 1
     /* 221115 */     // No operand predicates
     /* 221115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 221120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221129 */     GIR_RootConstrainSelectedInstOperands,
     /* 221130 */     // GIR_Coverage, 7925,
     /* 221130 */     GIR_EraseRootFromParent_Done,
     /* 221131 */   // Label 4223: @221131
     /* 221131 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221208), // Rule ID 7926 //
     /* 221136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221188 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221192 */     // MIs[2] Operand 1
     /* 221192 */     // No operand predicates
     /* 221192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 221197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221206 */     GIR_RootConstrainSelectedInstOperands,
     /* 221207 */     // GIR_Coverage, 7926,
     /* 221207 */     GIR_EraseRootFromParent_Done,
     /* 221208 */   // Label 4224: @221208
     /* 221208 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221285), // Rule ID 7927 //
     /* 221213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221265 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221269 */     // MIs[2] Operand 1
     /* 221269 */     // No operand predicates
     /* 221269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221271 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 221274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221283 */     GIR_RootConstrainSelectedInstOperands,
     /* 221284 */     // GIR_Coverage, 7927,
     /* 221284 */     GIR_EraseRootFromParent_Done,
     /* 221285 */   // Label 4225: @221285
     /* 221285 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221362), // Rule ID 7928 //
     /* 221290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221342 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221346 */     // MIs[2] Operand 1
     /* 221346 */     // No operand predicates
     /* 221346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 221351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221360 */     GIR_RootConstrainSelectedInstOperands,
     /* 221361 */     // GIR_Coverage, 7928,
     /* 221361 */     GIR_EraseRootFromParent_Done,
     /* 221362 */   // Label 4226: @221362
     /* 221362 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221439), // Rule ID 7929 //
     /* 221367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221419 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221423 */     // MIs[2] Operand 1
     /* 221423 */     // No operand predicates
     /* 221423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 221428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221437 */     GIR_RootConstrainSelectedInstOperands,
     /* 221438 */     // GIR_Coverage, 7929,
     /* 221438 */     GIR_EraseRootFromParent_Done,
     /* 221439 */   // Label 4227: @221439
     /* 221439 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221516), // Rule ID 7930 //
     /* 221444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 221452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221496 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221500 */     // MIs[2] Operand 1
     /* 221500 */     // No operand predicates
     /* 221500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 221505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221514 */     GIR_RootConstrainSelectedInstOperands,
     /* 221515 */     // GIR_Coverage, 7930,
     /* 221515 */     GIR_EraseRootFromParent_Done,
     /* 221516 */   // Label 4228: @221516
     /* 221516 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221593), // Rule ID 7931 //
     /* 221521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221573 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221577 */     // MIs[2] Operand 1
     /* 221577 */     // No operand predicates
     /* 221577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 221582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221591 */     GIR_RootConstrainSelectedInstOperands,
     /* 221592 */     // GIR_Coverage, 7931,
     /* 221592 */     GIR_EraseRootFromParent_Done,
     /* 221593 */   // Label 4229: @221593
     /* 221593 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221670), // Rule ID 7932 //
     /* 221598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221650 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221654 */     // MIs[2] Operand 1
     /* 221654 */     // No operand predicates
     /* 221654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 221659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221668 */     GIR_RootConstrainSelectedInstOperands,
     /* 221669 */     // GIR_Coverage, 7932,
     /* 221669 */     GIR_EraseRootFromParent_Done,
     /* 221670 */   // Label 4230: @221670
     /* 221670 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(221747), // Rule ID 7933 //
     /* 221675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221727 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221731 */     // MIs[2] Operand 1
     /* 221731 */     // No operand predicates
     /* 221731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 221736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221745 */     GIR_RootConstrainSelectedInstOperands,
     /* 221746 */     // GIR_Coverage, 7933,
     /* 221746 */     GIR_EraseRootFromParent_Done,
     /* 221747 */   // Label 4231: @221747
     /* 221747 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(221824), // Rule ID 7934 //
     /* 221752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221804 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221808 */     // MIs[2] Operand 1
     /* 221808 */     // No operand predicates
     /* 221808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 221813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221822 */     GIR_RootConstrainSelectedInstOperands,
     /* 221823 */     // GIR_Coverage, 7934,
     /* 221823 */     GIR_EraseRootFromParent_Done,
     /* 221824 */   // Label 4232: @221824
     /* 221824 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(221901), // Rule ID 7935 //
     /* 221829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221881 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 221885 */     // MIs[2] Operand 1
     /* 221885 */     // No operand predicates
     /* 221885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 221890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221899 */     GIR_RootConstrainSelectedInstOperands,
     /* 221900 */     // GIR_Coverage, 7935,
     /* 221900 */     GIR_EraseRootFromParent_Done,
     /* 221901 */   // Label 4233: @221901
     /* 221901 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(221978), // Rule ID 7936 //
     /* 221906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 221914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221958 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221962 */     // MIs[2] Operand 1
     /* 221962 */     // No operand predicates
     /* 221962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 221967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221976 */     GIR_RootConstrainSelectedInstOperands,
     /* 221977 */     // GIR_Coverage, 7936,
     /* 221977 */     GIR_EraseRootFromParent_Done,
     /* 221978 */   // Label 4234: @221978
     /* 221978 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222055), // Rule ID 7937 //
     /* 221983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 221991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222035 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222039 */     // MIs[2] Operand 1
     /* 222039 */     // No operand predicates
     /* 222039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 222044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222053 */     GIR_RootConstrainSelectedInstOperands,
     /* 222054 */     // GIR_Coverage, 7937,
     /* 222054 */     GIR_EraseRootFromParent_Done,
     /* 222055 */   // Label 4235: @222055
     /* 222055 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222132), // Rule ID 7938 //
     /* 222060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222112 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222116 */     // MIs[2] Operand 1
     /* 222116 */     // No operand predicates
     /* 222116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 222121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222130 */     GIR_RootConstrainSelectedInstOperands,
     /* 222131 */     // GIR_Coverage, 7938,
     /* 222131 */     GIR_EraseRootFromParent_Done,
     /* 222132 */   // Label 4236: @222132
     /* 222132 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222209), // Rule ID 7939 //
     /* 222137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222189 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222193 */     // MIs[2] Operand 1
     /* 222193 */     // No operand predicates
     /* 222193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222195 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 222198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222207 */     GIR_RootConstrainSelectedInstOperands,
     /* 222208 */     // GIR_Coverage, 7939,
     /* 222208 */     GIR_EraseRootFromParent_Done,
     /* 222209 */   // Label 4237: @222209
     /* 222209 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222286), // Rule ID 7940 //
     /* 222214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222266 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222270 */     // MIs[2] Operand 1
     /* 222270 */     // No operand predicates
     /* 222270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222272 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 222275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222284 */     GIR_RootConstrainSelectedInstOperands,
     /* 222285 */     // GIR_Coverage, 7940,
     /* 222285 */     GIR_EraseRootFromParent_Done,
     /* 222286 */   // Label 4238: @222286
     /* 222286 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222363), // Rule ID 7941 //
     /* 222291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222343 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222347 */     // MIs[2] Operand 1
     /* 222347 */     // No operand predicates
     /* 222347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222349 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 222352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222361 */     GIR_RootConstrainSelectedInstOperands,
     /* 222362 */     // GIR_Coverage, 7941,
     /* 222362 */     GIR_EraseRootFromParent_Done,
     /* 222363 */   // Label 4239: @222363
     /* 222363 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222440), // Rule ID 7942 //
     /* 222368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 222376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222420 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222424 */     // MIs[2] Operand 1
     /* 222424 */     // No operand predicates
     /* 222424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 222429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222438 */     GIR_RootConstrainSelectedInstOperands,
     /* 222439 */     // GIR_Coverage, 7942,
     /* 222439 */     GIR_EraseRootFromParent_Done,
     /* 222440 */   // Label 4240: @222440
     /* 222440 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222517), // Rule ID 7943 //
     /* 222445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222497 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222501 */     // MIs[2] Operand 1
     /* 222501 */     // No operand predicates
     /* 222501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222503 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 222506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222515 */     GIR_RootConstrainSelectedInstOperands,
     /* 222516 */     // GIR_Coverage, 7943,
     /* 222516 */     GIR_EraseRootFromParent_Done,
     /* 222517 */   // Label 4241: @222517
     /* 222517 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222594), // Rule ID 7944 //
     /* 222522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222574 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222578 */     // MIs[2] Operand 1
     /* 222578 */     // No operand predicates
     /* 222578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222580 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 222583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222592 */     GIR_RootConstrainSelectedInstOperands,
     /* 222593 */     // GIR_Coverage, 7944,
     /* 222593 */     GIR_EraseRootFromParent_Done,
     /* 222594 */   // Label 4242: @222594
     /* 222594 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222671), // Rule ID 7945 //
     /* 222599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222651 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222655 */     // MIs[2] Operand 1
     /* 222655 */     // No operand predicates
     /* 222655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222657 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 222660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222669 */     GIR_RootConstrainSelectedInstOperands,
     /* 222670 */     // GIR_Coverage, 7945,
     /* 222670 */     GIR_EraseRootFromParent_Done,
     /* 222671 */   // Label 4243: @222671
     /* 222671 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(222748), // Rule ID 7946 //
     /* 222676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222728 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222732 */     // MIs[2] Operand 1
     /* 222732 */     // No operand predicates
     /* 222732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 222737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222746 */     GIR_RootConstrainSelectedInstOperands,
     /* 222747 */     // GIR_Coverage, 7946,
     /* 222747 */     GIR_EraseRootFromParent_Done,
     /* 222748 */   // Label 4244: @222748
     /* 222748 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(222825), // Rule ID 7947 //
     /* 222753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222805 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222809 */     // MIs[2] Operand 1
     /* 222809 */     // No operand predicates
     /* 222809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222811 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 222814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222823 */     GIR_RootConstrainSelectedInstOperands,
     /* 222824 */     // GIR_Coverage, 7947,
     /* 222824 */     GIR_EraseRootFromParent_Done,
     /* 222825 */   // Label 4245: @222825
     /* 222825 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(222902), // Rule ID 7948 //
     /* 222830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 222838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222882 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222886 */     // MIs[2] Operand 1
     /* 222886 */     // No operand predicates
     /* 222886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222888 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 222891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222900 */     GIR_RootConstrainSelectedInstOperands,
     /* 222901 */     // GIR_Coverage, 7948,
     /* 222901 */     GIR_EraseRootFromParent_Done,
     /* 222902 */   // Label 4246: @222902
     /* 222902 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(222979), // Rule ID 7949 //
     /* 222907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222959 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222963 */     // MIs[2] Operand 1
     /* 222963 */     // No operand predicates
     /* 222963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222965 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 222968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222977 */     GIR_RootConstrainSelectedInstOperands,
     /* 222978 */     // GIR_Coverage, 7949,
     /* 222978 */     GIR_EraseRootFromParent_Done,
     /* 222979 */   // Label 4247: @222979
     /* 222979 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223056), // Rule ID 7950 //
     /* 222984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 222992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223036 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223040 */     // MIs[2] Operand 1
     /* 223040 */     // No operand predicates
     /* 223040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223042 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 223045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223054 */     GIR_RootConstrainSelectedInstOperands,
     /* 223055 */     // GIR_Coverage, 7950,
     /* 223055 */     GIR_EraseRootFromParent_Done,
     /* 223056 */   // Label 4248: @223056
     /* 223056 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223133), // Rule ID 7951 //
     /* 223061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223113 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223117 */     // MIs[2] Operand 1
     /* 223117 */     // No operand predicates
     /* 223117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223119 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 223122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223131 */     GIR_RootConstrainSelectedInstOperands,
     /* 223132 */     // GIR_Coverage, 7951,
     /* 223132 */     GIR_EraseRootFromParent_Done,
     /* 223133 */   // Label 4249: @223133
     /* 223133 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223210), // Rule ID 7952 //
     /* 223138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223190 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223194 */     // MIs[2] Operand 1
     /* 223194 */     // No operand predicates
     /* 223194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223196 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 223199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223208 */     GIR_RootConstrainSelectedInstOperands,
     /* 223209 */     // GIR_Coverage, 7952,
     /* 223209 */     GIR_EraseRootFromParent_Done,
     /* 223210 */   // Label 4250: @223210
     /* 223210 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223287), // Rule ID 7953 //
     /* 223215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223267 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223271 */     // MIs[2] Operand 1
     /* 223271 */     // No operand predicates
     /* 223271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223273 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 223276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223285 */     GIR_RootConstrainSelectedInstOperands,
     /* 223286 */     // GIR_Coverage, 7953,
     /* 223286 */     GIR_EraseRootFromParent_Done,
     /* 223287 */   // Label 4251: @223287
     /* 223287 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223364), // Rule ID 7954 //
     /* 223292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 223300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223344 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223348 */     // MIs[2] Operand 1
     /* 223348 */     // No operand predicates
     /* 223348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 223353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223362 */     GIR_RootConstrainSelectedInstOperands,
     /* 223363 */     // GIR_Coverage, 7954,
     /* 223363 */     GIR_EraseRootFromParent_Done,
     /* 223364 */   // Label 4252: @223364
     /* 223364 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223420), // Rule ID 55 //
     /* 223369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223394 */     // MIs[0] Operand 3
     /* 223394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 223405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223409 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 223412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223418 */     GIR_RootConstrainSelectedInstOperands,
     /* 223419 */     // GIR_Coverage, 55,
     /* 223419 */     GIR_EraseRootFromParent_Done,
     /* 223420 */   // Label 4253: @223420
     /* 223420 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223476), // Rule ID 56 //
     /* 223425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223450 */     // MIs[0] Operand 3
     /* 223450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 223461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223465 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 223468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223474 */     GIR_RootConstrainSelectedInstOperands,
     /* 223475 */     // GIR_Coverage, 56,
     /* 223475 */     GIR_EraseRootFromParent_Done,
     /* 223476 */   // Label 4254: @223476
     /* 223476 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223532), // Rule ID 57 //
     /* 223481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223506 */     // MIs[0] Operand 3
     /* 223506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 223517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223521 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 223524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223530 */     GIR_RootConstrainSelectedInstOperands,
     /* 223531 */     // GIR_Coverage, 57,
     /* 223531 */     GIR_EraseRootFromParent_Done,
     /* 223532 */   // Label 4255: @223532
     /* 223532 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223588), // Rule ID 58 //
     /* 223537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 223540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 223545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 223548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 223554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 223562 */     // MIs[0] Operand 3
     /* 223562 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 223573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 223577 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 223577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 223580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 223586 */     GIR_RootConstrainSelectedInstOperands,
     /* 223587 */     // GIR_Coverage, 58,
     /* 223587 */     GIR_EraseRootFromParent_Done,
     /* 223588 */   // Label 4256: @223588
     /* 223588 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(223643), // Rule ID 2792 //
     /* 223593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223622 */     // MIs[0] imm
     /* 223622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223630 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223639 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223641 */     GIR_RootConstrainSelectedInstOperands,
     /* 223642 */     // GIR_Coverage, 2792,
     /* 223642 */     GIR_EraseRootFromParent_Done,
     /* 223643 */   // Label 4257: @223643
     /* 223643 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(223698), // Rule ID 2793 //
     /* 223648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223677 */     // MIs[0] imm
     /* 223677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 223688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223694 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223696 */     GIR_RootConstrainSelectedInstOperands,
     /* 223697 */     // GIR_Coverage, 2793,
     /* 223697 */     GIR_EraseRootFromParent_Done,
     /* 223698 */   // Label 4258: @223698
     /* 223698 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(223753), // Rule ID 2794 //
     /* 223703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 223706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 223711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223732 */     // MIs[0] imm
     /* 223732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 223740 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 223740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 223743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 223747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 223749 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223751 */     GIR_RootConstrainSelectedInstOperands,
     /* 223752 */     // GIR_Coverage, 2794,
     /* 223752 */     GIR_EraseRootFromParent_Done,
     /* 223753 */   // Label 4259: @223753
     /* 223753 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(223808), // Rule ID 3545 //
     /* 223758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223787 */     // MIs[0] Idx
     /* 223787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 223795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 223795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 223798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223806 */     GIR_RootConstrainSelectedInstOperands,
     /* 223807 */     // GIR_Coverage, 3545,
     /* 223807 */     GIR_EraseRootFromParent_Done,
     /* 223808 */   // Label 4260: @223808
     /* 223808 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(223863), // Rule ID 3546 //
     /* 223813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223842 */     // MIs[0] Idx
     /* 223842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 223850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 223850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 223853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223861 */     GIR_RootConstrainSelectedInstOperands,
     /* 223862 */     // GIR_Coverage, 3546,
     /* 223862 */     GIR_EraseRootFromParent_Done,
     /* 223863 */   // Label 4261: @223863
     /* 223863 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(223918), // Rule ID 3547 //
     /* 223868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 223871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 223876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223897 */     // MIs[0] Idx
     /* 223897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 223905 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 223905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 223908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 223912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 223914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 223916 */     GIR_RootConstrainSelectedInstOperands,
     /* 223917 */     // GIR_Coverage, 3547,
     /* 223917 */     GIR_EraseRootFromParent_Done,
     /* 223918 */   // Label 4262: @223918
     /* 223918 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(223973), // Rule ID 3841 //
     /* 223923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 223926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 223931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 223934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 223937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 223940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223952 */     // MIs[0] imm
     /* 223952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 223955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 223960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 550:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 223960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 223963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 223965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 223967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 223969 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 223971 */     GIR_RootConstrainSelectedInstOperands,
     /* 223972 */     // GIR_Coverage, 3841,
     /* 223972 */     GIR_EraseRootFromParent_Done,
     /* 223973 */   // Label 4263: @223973
     /* 223973 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224020), // Rule ID 2846 //
     /* 223978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 223986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223999 */     // MIs[0] idx
     /* 223999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 224007 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 224007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 224010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224016 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 224018 */     GIR_RootConstrainSelectedInstOperands,
     /* 224019 */     // GIR_Coverage, 2846,
     /* 224019 */     GIR_EraseRootFromParent_Done,
     /* 224020 */   // Label 4264: @224020
     /* 224020 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224067), // Rule ID 2847 //
     /* 224025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 224033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224046 */     // MIs[0] idx
     /* 224046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 224054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 224054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 224057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224063 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 224065 */     GIR_RootConstrainSelectedInstOperands,
     /* 224066 */     // GIR_Coverage, 2847,
     /* 224066 */     GIR_EraseRootFromParent_Done,
     /* 224067 */   // Label 4265: @224067
     /* 224067 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224114), // Rule ID 2848 //
     /* 224072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 224080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224093 */     // MIs[0] idx
     /* 224093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 224101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 224101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 224104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224110 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 224112 */     GIR_RootConstrainSelectedInstOperands,
     /* 224113 */     // GIR_Coverage, 2848,
     /* 224113 */     GIR_EraseRootFromParent_Done,
     /* 224114 */   // Label 4266: @224114
     /* 224114 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224161), // Rule ID 2997 //
     /* 224119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 224127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224140 */     // MIs[0] Op3
     /* 224140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 224148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 224148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 224151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224159 */     GIR_RootConstrainSelectedInstOperands,
     /* 224160 */     // GIR_Coverage, 2997,
     /* 224160 */     GIR_EraseRootFromParent_Done,
     /* 224161 */   // Label 4267: @224161
     /* 224161 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224208), // Rule ID 2998 //
     /* 224166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 224174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224187 */     // MIs[0] Op3
     /* 224187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 224195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 224195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 224198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224206 */     GIR_RootConstrainSelectedInstOperands,
     /* 224207 */     // GIR_Coverage, 2998,
     /* 224207 */     GIR_EraseRootFromParent_Done,
     /* 224208 */   // Label 4268: @224208
     /* 224208 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224255), // Rule ID 2999 //
     /* 224213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 224221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224234 */     // MIs[0] Op3
     /* 224234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 224242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 224242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 224245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224253 */     GIR_RootConstrainSelectedInstOperands,
     /* 224254 */     // GIR_Coverage, 2999,
     /* 224254 */     GIR_EraseRootFromParent_Done,
     /* 224255 */   // Label 4269: @224255
     /* 224255 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224302), // Rule ID 3000 //
     /* 224260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 224268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224281 */     // MIs[0] Op3
     /* 224281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 224289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 224289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 224292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224300 */     GIR_RootConstrainSelectedInstOperands,
     /* 224301 */     // GIR_Coverage, 3000,
     /* 224301 */     GIR_EraseRootFromParent_Done,
     /* 224302 */   // Label 4270: @224302
     /* 224302 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(224349), // Rule ID 3001 //
     /* 224307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 224315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224328 */     // MIs[0] Op3
     /* 224328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 224336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 224336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 224339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224347 */     GIR_RootConstrainSelectedInstOperands,
     /* 224348 */     // GIR_Coverage, 3001,
     /* 224348 */     GIR_EraseRootFromParent_Done,
     /* 224349 */   // Label 4271: @224349
     /* 224349 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(224396), // Rule ID 3049 //
     /* 224354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224375 */     // MIs[0] Op3
     /* 224375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 224386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224394 */     GIR_RootConstrainSelectedInstOperands,
     /* 224395 */     // GIR_Coverage, 3049,
     /* 224395 */     GIR_EraseRootFromParent_Done,
     /* 224396 */   // Label 4272: @224396
     /* 224396 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(224443), // Rule ID 3051 //
     /* 224401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224422 */     // MIs[0] Op3
     /* 224422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 224433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224441 */     GIR_RootConstrainSelectedInstOperands,
     /* 224442 */     // GIR_Coverage, 3051,
     /* 224442 */     GIR_EraseRootFromParent_Done,
     /* 224443 */   // Label 4273: @224443
     /* 224443 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(224490), // Rule ID 3053 //
     /* 224448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224469 */     // MIs[0] Op3
     /* 224469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224488 */     GIR_RootConstrainSelectedInstOperands,
     /* 224489 */     // GIR_Coverage, 3053,
     /* 224489 */     GIR_EraseRootFromParent_Done,
     /* 224490 */   // Label 4274: @224490
     /* 224490 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(224537), // Rule ID 3055 //
     /* 224495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 224503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224516 */     // MIs[0] Op3
     /* 224516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 224524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 224524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 224527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224535 */     GIR_RootConstrainSelectedInstOperands,
     /* 224536 */     // GIR_Coverage, 3055,
     /* 224536 */     GIR_EraseRootFromParent_Done,
     /* 224537 */   // Label 4275: @224537
     /* 224537 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(224584), // Rule ID 3077 //
     /* 224542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224563 */     // MIs[0] Op3
     /* 224563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 224574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224582 */     GIR_RootConstrainSelectedInstOperands,
     /* 224583 */     // GIR_Coverage, 3077,
     /* 224583 */     GIR_EraseRootFromParent_Done,
     /* 224584 */   // Label 4276: @224584
     /* 224584 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(224631), // Rule ID 3078 //
     /* 224589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224610 */     // MIs[0] Op3
     /* 224610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 224621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224629 */     GIR_RootConstrainSelectedInstOperands,
     /* 224630 */     // GIR_Coverage, 3078,
     /* 224630 */     GIR_EraseRootFromParent_Done,
     /* 224631 */   // Label 4277: @224631
     /* 224631 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(224678), // Rule ID 3079 //
     /* 224636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 224644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224657 */     // MIs[0] Op3
     /* 224657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 224668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224676 */     GIR_RootConstrainSelectedInstOperands,
     /* 224677 */     // GIR_Coverage, 3079,
     /* 224677 */     GIR_EraseRootFromParent_Done,
     /* 224678 */   // Label 4278: @224678
     /* 224678 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(224725), // Rule ID 3148 //
     /* 224683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224704 */     // MIs[0] Op3
     /* 224704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 224712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 224712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 224715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224723 */     GIR_RootConstrainSelectedInstOperands,
     /* 224724 */     // GIR_Coverage, 3148,
     /* 224724 */     GIR_EraseRootFromParent_Done,
     /* 224725 */   // Label 4279: @224725
     /* 224725 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(224772), // Rule ID 3149 //
     /* 224730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224751 */     // MIs[0] Op3
     /* 224751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 224759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 224759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 224762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224770 */     GIR_RootConstrainSelectedInstOperands,
     /* 224771 */     // GIR_Coverage, 3149,
     /* 224771 */     GIR_EraseRootFromParent_Done,
     /* 224772 */   // Label 4280: @224772
     /* 224772 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(224819), // Rule ID 3150 //
     /* 224777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224798 */     // MIs[0] Op3
     /* 224798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 224806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 224806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 224809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224817 */     GIR_RootConstrainSelectedInstOperands,
     /* 224818 */     // GIR_Coverage, 3150,
     /* 224818 */     GIR_EraseRootFromParent_Done,
     /* 224819 */   // Label 4281: @224819
     /* 224819 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(224866), // Rule ID 3151 //
     /* 224824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 224832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224845 */     // MIs[0] Op3
     /* 224845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 224853 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 224853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 224856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224864 */     GIR_RootConstrainSelectedInstOperands,
     /* 224865 */     // GIR_Coverage, 3151,
     /* 224865 */     GIR_EraseRootFromParent_Done,
     /* 224866 */   // Label 4282: @224866
     /* 224866 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(224913), // Rule ID 3530 //
     /* 224871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 224874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 224879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224892 */     // MIs[0] Op3
     /* 224892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 224900 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 224900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 224903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224911 */     GIR_RootConstrainSelectedInstOperands,
     /* 224912 */     // GIR_Coverage, 3530,
     /* 224912 */     GIR_EraseRootFromParent_Done,
     /* 224913 */   // Label 4283: @224913
     /* 224913 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(224960), // Rule ID 3578 //
     /* 224918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 224926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224939 */     // MIs[0] Op3
     /* 224939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 224947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 224947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 224950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224958 */     GIR_RootConstrainSelectedInstOperands,
     /* 224959 */     // GIR_Coverage, 3578,
     /* 224959 */     GIR_EraseRootFromParent_Done,
     /* 224960 */   // Label 4284: @224960
     /* 224960 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225007), // Rule ID 3579 //
     /* 224965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 224968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 224973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224986 */     // MIs[0] Op3
     /* 224986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 224994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 224994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 224997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225005 */     GIR_RootConstrainSelectedInstOperands,
     /* 225006 */     // GIR_Coverage, 3579,
     /* 225006 */     GIR_EraseRootFromParent_Done,
     /* 225007 */   // Label 4285: @225007
     /* 225007 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225054), // Rule ID 3580 //
     /* 225012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 225015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 225020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225033 */     // MIs[0] Op3
     /* 225033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1603:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 225041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 225044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225052 */     GIR_RootConstrainSelectedInstOperands,
     /* 225053 */     // GIR_Coverage, 3580,
     /* 225053 */     GIR_EraseRootFromParent_Done,
     /* 225054 */   // Label 4286: @225054
     /* 225054 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225101), // Rule ID 3581 //
     /* 225059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 225062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 225067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225080 */     // MIs[0] Op3
     /* 225080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 225088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 225088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 225091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225099 */     GIR_RootConstrainSelectedInstOperands,
     /* 225100 */     // GIR_Coverage, 3581,
     /* 225100 */     GIR_EraseRootFromParent_Done,
     /* 225101 */   // Label 4287: @225101
     /* 225101 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225148), // Rule ID 3582 //
     /* 225106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 225109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 225114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225127 */     // MIs[0] Op3
     /* 225127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 225135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 225135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 225138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225146 */     GIR_RootConstrainSelectedInstOperands,
     /* 225147 */     // GIR_Coverage, 3582,
     /* 225147 */     GIR_EraseRootFromParent_Done,
     /* 225148 */   // Label 4288: @225148
     /* 225148 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(225195), // Rule ID 3583 //
     /* 225153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 225156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 225161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225174 */     // MIs[0] Op3
     /* 225174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 225182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1604:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 225182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 225185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225193 */     GIR_RootConstrainSelectedInstOperands,
     /* 225194 */     // GIR_Coverage, 3583,
     /* 225194 */     GIR_EraseRootFromParent_Done,
     /* 225195 */   // Label 4289: @225195
     /* 225195 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(225242), // Rule ID 11371 //
     /* 225200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225221 */     // MIs[0] Op3
     /* 225221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 225232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225240 */     GIR_RootConstrainSelectedInstOperands,
     /* 225241 */     // GIR_Coverage, 11371,
     /* 225241 */     GIR_EraseRootFromParent_Done,
     /* 225242 */   // Label 4290: @225242
     /* 225242 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(225289), // Rule ID 11372 //
     /* 225247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225268 */     // MIs[0] Op3
     /* 225268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 225279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225287 */     GIR_RootConstrainSelectedInstOperands,
     /* 225288 */     // GIR_Coverage, 11372,
     /* 225288 */     GIR_EraseRootFromParent_Done,
     /* 225289 */   // Label 4291: @225289
     /* 225289 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(225336), // Rule ID 11373 //
     /* 225294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 225302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225315 */     // MIs[0] Op3
     /* 225315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 225326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225334 */     GIR_RootConstrainSelectedInstOperands,
     /* 225335 */     // GIR_Coverage, 11373,
     /* 225335 */     GIR_EraseRootFromParent_Done,
     /* 225336 */   // Label 4292: @225336
     /* 225336 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(225383), // Rule ID 11374 //
     /* 225341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225362 */     // MIs[0] Op3
     /* 225362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 225373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225381 */     GIR_RootConstrainSelectedInstOperands,
     /* 225382 */     // GIR_Coverage, 11374,
     /* 225382 */     GIR_EraseRootFromParent_Done,
     /* 225383 */   // Label 4293: @225383
     /* 225383 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(225430), // Rule ID 11375 //
     /* 225388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225409 */     // MIs[0] Op3
     /* 225409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 225420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225428 */     GIR_RootConstrainSelectedInstOperands,
     /* 225429 */     // GIR_Coverage, 11375,
     /* 225429 */     GIR_EraseRootFromParent_Done,
     /* 225430 */   // Label 4294: @225430
     /* 225430 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(225477), // Rule ID 11376 //
     /* 225435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 225443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225456 */     // MIs[0] Op3
     /* 225456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 225467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225475 */     GIR_RootConstrainSelectedInstOperands,
     /* 225476 */     // GIR_Coverage, 11376,
     /* 225476 */     GIR_EraseRootFromParent_Done,
     /* 225477 */   // Label 4295: @225477
     /* 225477 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(225524), // Rule ID 11399 //
     /* 225482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 225490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225503 */     // MIs[0] Op3
     /* 225503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 225514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225522 */     GIR_RootConstrainSelectedInstOperands,
     /* 225523 */     // GIR_Coverage, 11399,
     /* 225523 */     GIR_EraseRootFromParent_Done,
     /* 225524 */   // Label 4296: @225524
     /* 225524 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(225571), // Rule ID 11400 //
     /* 225529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 225537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225550 */     // MIs[0] Op3
     /* 225550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 225561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225569 */     GIR_RootConstrainSelectedInstOperands,
     /* 225570 */     // GIR_Coverage, 11400,
     /* 225570 */     GIR_EraseRootFromParent_Done,
     /* 225571 */   // Label 4297: @225571
     /* 225571 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(225618), // Rule ID 11401 //
     /* 225576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 225584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225597 */     // MIs[0] Op3
     /* 225597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 225608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225616 */     GIR_RootConstrainSelectedInstOperands,
     /* 225617 */     // GIR_Coverage, 11401,
     /* 225617 */     GIR_EraseRootFromParent_Done,
     /* 225618 */   // Label 4298: @225618
     /* 225618 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(225665), // Rule ID 11402 //
     /* 225623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 225631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225644 */     // MIs[0] Op3
     /* 225644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 225655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225663 */     GIR_RootConstrainSelectedInstOperands,
     /* 225664 */     // GIR_Coverage, 11402,
     /* 225664 */     GIR_EraseRootFromParent_Done,
     /* 225665 */   // Label 4299: @225665
     /* 225665 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(225712), // Rule ID 11403 //
     /* 225670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 225678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225691 */     // MIs[0] Op3
     /* 225691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 225702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225710 */     GIR_RootConstrainSelectedInstOperands,
     /* 225711 */     // GIR_Coverage, 11403,
     /* 225711 */     GIR_EraseRootFromParent_Done,
     /* 225712 */   // Label 4300: @225712
     /* 225712 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(225759), // Rule ID 11404 //
     /* 225717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 225725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225738 */     // MIs[0] Op3
     /* 225738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 225749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225757 */     GIR_RootConstrainSelectedInstOperands,
     /* 225758 */     // GIR_Coverage, 11404,
     /* 225758 */     GIR_EraseRootFromParent_Done,
     /* 225759 */   // Label 4301: @225759
     /* 225759 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(225806), // Rule ID 11405 //
     /* 225764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 225772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225785 */     // MIs[0] Op3
     /* 225785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 225796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225804 */     GIR_RootConstrainSelectedInstOperands,
     /* 225805 */     // GIR_Coverage, 11405,
     /* 225805 */     GIR_EraseRootFromParent_Done,
     /* 225806 */   // Label 4302: @225806
     /* 225806 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(225853), // Rule ID 11406 //
     /* 225811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 225819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225832 */     // MIs[0] Op3
     /* 225832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 225843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225851 */     GIR_RootConstrainSelectedInstOperands,
     /* 225852 */     // GIR_Coverage, 11406,
     /* 225852 */     GIR_EraseRootFromParent_Done,
     /* 225853 */   // Label 4303: @225853
     /* 225853 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(225900), // Rule ID 11407 //
     /* 225858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 225866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225879 */     // MIs[0] Op3
     /* 225879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 225890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225898 */     GIR_RootConstrainSelectedInstOperands,
     /* 225899 */     // GIR_Coverage, 11407,
     /* 225899 */     GIR_EraseRootFromParent_Done,
     /* 225900 */   // Label 4304: @225900
     /* 225900 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(225947), // Rule ID 11408 //
     /* 225905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 225913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225926 */     // MIs[0] Op3
     /* 225926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 225937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225945 */     GIR_RootConstrainSelectedInstOperands,
     /* 225946 */     // GIR_Coverage, 11408,
     /* 225946 */     GIR_EraseRootFromParent_Done,
     /* 225947 */   // Label 4305: @225947
     /* 225947 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(225994), // Rule ID 11652 //
     /* 225952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 225960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225973 */     // MIs[0] Op3
     /* 225973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225981 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1869:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 225984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225992 */     GIR_RootConstrainSelectedInstOperands,
     /* 225993 */     // GIR_Coverage, 11652,
     /* 225993 */     GIR_EraseRootFromParent_Done,
     /* 225994 */   // Label 4306: @225994
     /* 225994 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226041), // Rule ID 11653 //
     /* 225999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 226007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226020 */     // MIs[0] Op3
     /* 226020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 226031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226039 */     GIR_RootConstrainSelectedInstOperands,
     /* 226040 */     // GIR_Coverage, 11653,
     /* 226040 */     GIR_EraseRootFromParent_Done,
     /* 226041 */   // Label 4307: @226041
     /* 226041 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226088), // Rule ID 11654 //
     /* 226046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 226054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226067 */     // MIs[0] Op3
     /* 226067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 226078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226086 */     GIR_RootConstrainSelectedInstOperands,
     /* 226087 */     // GIR_Coverage, 11654,
     /* 226087 */     GIR_EraseRootFromParent_Done,
     /* 226088 */   // Label 4308: @226088
     /* 226088 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226135), // Rule ID 11655 //
     /* 226093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 226101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226114 */     // MIs[0] Op3
     /* 226114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 226125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226133 */     GIR_RootConstrainSelectedInstOperands,
     /* 226134 */     // GIR_Coverage, 11655,
     /* 226134 */     GIR_EraseRootFromParent_Done,
     /* 226135 */   // Label 4309: @226135
     /* 226135 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(226182), // Rule ID 11656 //
     /* 226140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226161 */     // MIs[0] Op3
     /* 226161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 226172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226180 */     GIR_RootConstrainSelectedInstOperands,
     /* 226181 */     // GIR_Coverage, 11656,
     /* 226181 */     GIR_EraseRootFromParent_Done,
     /* 226182 */   // Label 4310: @226182
     /* 226182 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(226229), // Rule ID 11658 //
     /* 226187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226208 */     // MIs[0] Op3
     /* 226208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 226219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226227 */     GIR_RootConstrainSelectedInstOperands,
     /* 226228 */     // GIR_Coverage, 11658,
     /* 226228 */     GIR_EraseRootFromParent_Done,
     /* 226229 */   // Label 4311: @226229
     /* 226229 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(226276), // Rule ID 11660 //
     /* 226234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226255 */     // MIs[0] Op3
     /* 226255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 226266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226274 */     GIR_RootConstrainSelectedInstOperands,
     /* 226275 */     // GIR_Coverage, 11660,
     /* 226275 */     GIR_EraseRootFromParent_Done,
     /* 226276 */   // Label 4312: @226276
     /* 226276 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(226323), // Rule ID 11662 //
     /* 226281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 226289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226302 */     // MIs[0] Op3
     /* 226302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 226313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226321 */     GIR_RootConstrainSelectedInstOperands,
     /* 226322 */     // GIR_Coverage, 11662,
     /* 226322 */     GIR_EraseRootFromParent_Done,
     /* 226323 */   // Label 4313: @226323
     /* 226323 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(226370), // Rule ID 11664 //
     /* 226328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226349 */     // MIs[0] Op3
     /* 226349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 226357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 226357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 226360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226368 */     GIR_RootConstrainSelectedInstOperands,
     /* 226369 */     // GIR_Coverage, 11664,
     /* 226369 */     GIR_EraseRootFromParent_Done,
     /* 226370 */   // Label 4314: @226370
     /* 226370 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(226417), // Rule ID 11665 //
     /* 226375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226396 */     // MIs[0] Op3
     /* 226396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 226404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 226404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 226407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226415 */     GIR_RootConstrainSelectedInstOperands,
     /* 226416 */     // GIR_Coverage, 11665,
     /* 226416 */     GIR_EraseRootFromParent_Done,
     /* 226417 */   // Label 4315: @226417
     /* 226417 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(226464), // Rule ID 11666 //
     /* 226422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226443 */     // MIs[0] Op3
     /* 226443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 226451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 226451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 226454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226462 */     GIR_RootConstrainSelectedInstOperands,
     /* 226463 */     // GIR_Coverage, 11666,
     /* 226463 */     GIR_EraseRootFromParent_Done,
     /* 226464 */   // Label 4316: @226464
     /* 226464 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(226511), // Rule ID 11667 //
     /* 226469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 226477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226490 */     // MIs[0] Op3
     /* 226490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 226498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 226498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 226501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226509 */     GIR_RootConstrainSelectedInstOperands,
     /* 226510 */     // GIR_Coverage, 11667,
     /* 226510 */     GIR_EraseRootFromParent_Done,
     /* 226511 */   // Label 4317: @226511
     /* 226511 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(226558), // Rule ID 11754 //
     /* 226516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226537 */     // MIs[0] Op3
     /* 226537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226545 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 226548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226556 */     GIR_RootConstrainSelectedInstOperands,
     /* 226557 */     // GIR_Coverage, 11754,
     /* 226557 */     GIR_EraseRootFromParent_Done,
     /* 226558 */   // Label 4318: @226558
     /* 226558 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(226605), // Rule ID 11756 //
     /* 226563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226584 */     // MIs[0] Op3
     /* 226584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 226595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226603 */     GIR_RootConstrainSelectedInstOperands,
     /* 226604 */     // GIR_Coverage, 11756,
     /* 226604 */     GIR_EraseRootFromParent_Done,
     /* 226605 */   // Label 4319: @226605
     /* 226605 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(226652), // Rule ID 11758 //
     /* 226610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226631 */     // MIs[0] Op3
     /* 226631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 226642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226650 */     GIR_RootConstrainSelectedInstOperands,
     /* 226651 */     // GIR_Coverage, 11758,
     /* 226651 */     GIR_EraseRootFromParent_Done,
     /* 226652 */   // Label 4320: @226652
     /* 226652 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(226699), // Rule ID 11760 //
     /* 226657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 226665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226678 */     // MIs[0] Op3
     /* 226678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 226689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226697 */     GIR_RootConstrainSelectedInstOperands,
     /* 226698 */     // GIR_Coverage, 11760,
     /* 226698 */     GIR_EraseRootFromParent_Done,
     /* 226699 */   // Label 4321: @226699
     /* 226699 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(226746), // Rule ID 11762 //
     /* 226704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226725 */     // MIs[0] Op3
     /* 226725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 226736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226744 */     GIR_RootConstrainSelectedInstOperands,
     /* 226745 */     // GIR_Coverage, 11762,
     /* 226745 */     GIR_EraseRootFromParent_Done,
     /* 226746 */   // Label 4322: @226746
     /* 226746 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(226793), // Rule ID 11763 //
     /* 226751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226772 */     // MIs[0] Op3
     /* 226772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 226783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226791 */     GIR_RootConstrainSelectedInstOperands,
     /* 226792 */     // GIR_Coverage, 11763,
     /* 226792 */     GIR_EraseRootFromParent_Done,
     /* 226793 */   // Label 4323: @226793
     /* 226793 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(226840), // Rule ID 11764 //
     /* 226798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226819 */     // MIs[0] Op3
     /* 226819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 226830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226838 */     GIR_RootConstrainSelectedInstOperands,
     /* 226839 */     // GIR_Coverage, 11764,
     /* 226839 */     GIR_EraseRootFromParent_Done,
     /* 226840 */   // Label 4324: @226840
     /* 226840 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(226887), // Rule ID 11765 //
     /* 226845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 226853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226866 */     // MIs[0] Op3
     /* 226866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 226877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226885 */     GIR_RootConstrainSelectedInstOperands,
     /* 226886 */     // GIR_Coverage, 11765,
     /* 226886 */     GIR_EraseRootFromParent_Done,
     /* 226887 */   // Label 4325: @226887
     /* 226887 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(226934), // Rule ID 11770 //
     /* 226892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226913 */     // MIs[0] Op3
     /* 226913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 226924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226932 */     GIR_RootConstrainSelectedInstOperands,
     /* 226933 */     // GIR_Coverage, 11770,
     /* 226933 */     GIR_EraseRootFromParent_Done,
     /* 226934 */   // Label 4326: @226934
     /* 226934 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(226981), // Rule ID 11771 //
     /* 226939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226960 */     // MIs[0] Op3
     /* 226960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 226971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226979 */     GIR_RootConstrainSelectedInstOperands,
     /* 226980 */     // GIR_Coverage, 11771,
     /* 226980 */     GIR_EraseRootFromParent_Done,
     /* 226981 */   // Label 4327: @226981
     /* 226981 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227028), // Rule ID 11772 //
     /* 226986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 226994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227007 */     // MIs[0] Op3
     /* 227007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 227018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227026 */     GIR_RootConstrainSelectedInstOperands,
     /* 227027 */     // GIR_Coverage, 11772,
     /* 227027 */     GIR_EraseRootFromParent_Done,
     /* 227028 */   // Label 4328: @227028
     /* 227028 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227075), // Rule ID 11773 //
     /* 227033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 227041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227054 */     // MIs[0] Op3
     /* 227054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 227065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227073 */     GIR_RootConstrainSelectedInstOperands,
     /* 227074 */     // GIR_Coverage, 11773,
     /* 227074 */     GIR_EraseRootFromParent_Done,
     /* 227075 */   // Label 4329: @227075
     /* 227075 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227122), // Rule ID 11833 //
     /* 227080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 227088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227101 */     // MIs[0] Op3
     /* 227101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 227112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227120 */     GIR_RootConstrainSelectedInstOperands,
     /* 227121 */     // GIR_Coverage, 11833,
     /* 227121 */     GIR_EraseRootFromParent_Done,
     /* 227122 */   // Label 4330: @227122
     /* 227122 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(227169), // Rule ID 11834 //
     /* 227127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 227135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227148 */     // MIs[0] Op3
     /* 227148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 227159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227167 */     GIR_RootConstrainSelectedInstOperands,
     /* 227168 */     // GIR_Coverage, 11834,
     /* 227168 */     GIR_EraseRootFromParent_Done,
     /* 227169 */   // Label 4331: @227169
     /* 227169 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(227216), // Rule ID 11835 //
     /* 227174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 227182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227195 */     // MIs[0] Op3
     /* 227195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 227206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227214 */     GIR_RootConstrainSelectedInstOperands,
     /* 227215 */     // GIR_Coverage, 11835,
     /* 227215 */     GIR_EraseRootFromParent_Done,
     /* 227216 */   // Label 4332: @227216
     /* 227216 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(227263), // Rule ID 11836 //
     /* 227221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227242 */     // MIs[0] Op3
     /* 227242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 227253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227261 */     GIR_RootConstrainSelectedInstOperands,
     /* 227262 */     // GIR_Coverage, 11836,
     /* 227262 */     GIR_EraseRootFromParent_Done,
     /* 227263 */   // Label 4333: @227263
     /* 227263 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(227310), // Rule ID 11837 //
     /* 227268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227289 */     // MIs[0] Op3
     /* 227289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 227300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227308 */     GIR_RootConstrainSelectedInstOperands,
     /* 227309 */     // GIR_Coverage, 11837,
     /* 227309 */     GIR_EraseRootFromParent_Done,
     /* 227310 */   // Label 4334: @227310
     /* 227310 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(227357), // Rule ID 11838 //
     /* 227315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 227323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227336 */     // MIs[0] Op3
     /* 227336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 227347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227355 */     GIR_RootConstrainSelectedInstOperands,
     /* 227356 */     // GIR_Coverage, 11838,
     /* 227356 */     GIR_EraseRootFromParent_Done,
     /* 227357 */   // Label 4335: @227357
     /* 227357 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(227404), // Rule ID 11839 //
     /* 227362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227383 */     // MIs[0] Op3
     /* 227383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227391 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1684:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 227394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227402 */     GIR_RootConstrainSelectedInstOperands,
     /* 227403 */     // GIR_Coverage, 11839,
     /* 227403 */     GIR_EraseRootFromParent_Done,
     /* 227404 */   // Label 4336: @227404
     /* 227404 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(227451), // Rule ID 11840 //
     /* 227409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227430 */     // MIs[0] Op3
     /* 227430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1684:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 227441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227449 */     GIR_RootConstrainSelectedInstOperands,
     /* 227450 */     // GIR_Coverage, 11840,
     /* 227450 */     GIR_EraseRootFromParent_Done,
     /* 227451 */   // Label 4337: @227451
     /* 227451 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(227498), // Rule ID 11841 //
     /* 227456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 227464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227477 */     // MIs[0] Op3
     /* 227477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 227488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227496 */     GIR_RootConstrainSelectedInstOperands,
     /* 227497 */     // GIR_Coverage, 11841,
     /* 227497 */     GIR_EraseRootFromParent_Done,
     /* 227498 */   // Label 4338: @227498
     /* 227498 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(227545), // Rule ID 11842 //
     /* 227503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227524 */     // MIs[0] Op3
     /* 227524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 227535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227543 */     GIR_RootConstrainSelectedInstOperands,
     /* 227544 */     // GIR_Coverage, 11842,
     /* 227544 */     GIR_EraseRootFromParent_Done,
     /* 227545 */   // Label 4339: @227545
     /* 227545 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(227592), // Rule ID 11843 //
     /* 227550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227571 */     // MIs[0] Op3
     /* 227571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 227582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227590 */     GIR_RootConstrainSelectedInstOperands,
     /* 227591 */     // GIR_Coverage, 11843,
     /* 227591 */     GIR_EraseRootFromParent_Done,
     /* 227592 */   // Label 4340: @227592
     /* 227592 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(227639), // Rule ID 11844 //
     /* 227597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 227605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227618 */     // MIs[0] Op3
     /* 227618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 227629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227637 */     GIR_RootConstrainSelectedInstOperands,
     /* 227638 */     // GIR_Coverage, 11844,
     /* 227638 */     GIR_EraseRootFromParent_Done,
     /* 227639 */   // Label 4341: @227639
     /* 227639 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(227686), // Rule ID 11845 //
     /* 227644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227665 */     // MIs[0] Op3
     /* 227665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227673 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 227676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227684 */     GIR_RootConstrainSelectedInstOperands,
     /* 227685 */     // GIR_Coverage, 11845,
     /* 227685 */     GIR_EraseRootFromParent_Done,
     /* 227686 */   // Label 4342: @227686
     /* 227686 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(227733), // Rule ID 11846 //
     /* 227691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227712 */     // MIs[0] Op3
     /* 227712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 227723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227731 */     GIR_RootConstrainSelectedInstOperands,
     /* 227732 */     // GIR_Coverage, 11846,
     /* 227732 */     GIR_EraseRootFromParent_Done,
     /* 227733 */   // Label 4343: @227733
     /* 227733 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(227780), // Rule ID 11847 //
     /* 227738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 227746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227759 */     // MIs[0] Op3
     /* 227759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 227770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227778 */     GIR_RootConstrainSelectedInstOperands,
     /* 227779 */     // GIR_Coverage, 11847,
     /* 227779 */     GIR_EraseRootFromParent_Done,
     /* 227780 */   // Label 4344: @227780
     /* 227780 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(227827), // Rule ID 11848 //
     /* 227785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227806 */     // MIs[0] Op3
     /* 227806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 227817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227825 */     GIR_RootConstrainSelectedInstOperands,
     /* 227826 */     // GIR_Coverage, 11848,
     /* 227826 */     GIR_EraseRootFromParent_Done,
     /* 227827 */   // Label 4345: @227827
     /* 227827 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(227874), // Rule ID 11849 //
     /* 227832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227853 */     // MIs[0] Op3
     /* 227853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227861 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 227864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227872 */     GIR_RootConstrainSelectedInstOperands,
     /* 227873 */     // GIR_Coverage, 11849,
     /* 227873 */     GIR_EraseRootFromParent_Done,
     /* 227874 */   // Label 4346: @227874
     /* 227874 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(227921), // Rule ID 11850 //
     /* 227879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 227887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227900 */     // MIs[0] Op3
     /* 227900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 227911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227919 */     GIR_RootConstrainSelectedInstOperands,
     /* 227920 */     // GIR_Coverage, 11850,
     /* 227920 */     GIR_EraseRootFromParent_Done,
     /* 227921 */   // Label 4347: @227921
     /* 227921 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(227968), // Rule ID 11851 //
     /* 227926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 227934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227947 */     // MIs[0] Op3
     /* 227947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227955 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 227958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227966 */     GIR_RootConstrainSelectedInstOperands,
     /* 227967 */     // GIR_Coverage, 11851,
     /* 227967 */     GIR_EraseRootFromParent_Done,
     /* 227968 */   // Label 4348: @227968
     /* 227968 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228015), // Rule ID 11852 //
     /* 227973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 227981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227994 */     // MIs[0] Op3
     /* 227994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 228005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228013 */     GIR_RootConstrainSelectedInstOperands,
     /* 228014 */     // GIR_Coverage, 11852,
     /* 228014 */     GIR_EraseRootFromParent_Done,
     /* 228015 */   // Label 4349: @228015
     /* 228015 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228062), // Rule ID 11853 //
     /* 228020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 228028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228041 */     // MIs[0] Op3
     /* 228041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 228052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228060 */     GIR_RootConstrainSelectedInstOperands,
     /* 228061 */     // GIR_Coverage, 11853,
     /* 228061 */     GIR_EraseRootFromParent_Done,
     /* 228062 */   // Label 4350: @228062
     /* 228062 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228129), // Rule ID 2597 //
     /* 228067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 228075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 228118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228127 */     GIR_RootConstrainSelectedInstOperands,
     /* 228128 */     // GIR_Coverage, 2597,
     /* 228128 */     GIR_EraseRootFromParent_Done,
     /* 228129 */   // Label 4351: @228129
     /* 228129 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228196), // Rule ID 7752 //
     /* 228134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 228185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228194 */     GIR_RootConstrainSelectedInstOperands,
     /* 228195 */     // GIR_Coverage, 7752,
     /* 228195 */     GIR_EraseRootFromParent_Done,
     /* 228196 */   // Label 4352: @228196
     /* 228196 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(228263), // Rule ID 7754 //
     /* 228201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 228252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228261 */     GIR_RootConstrainSelectedInstOperands,
     /* 228262 */     // GIR_Coverage, 7754,
     /* 228262 */     GIR_EraseRootFromParent_Done,
     /* 228263 */   // Label 4353: @228263
     /* 228263 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(228330), // Rule ID 7756 //
     /* 228268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 228319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228328 */     GIR_RootConstrainSelectedInstOperands,
     /* 228329 */     // GIR_Coverage, 7756,
     /* 228329 */     GIR_EraseRootFromParent_Done,
     /* 228330 */   // Label 4354: @228330
     /* 228330 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(228397), // Rule ID 7758 //
     /* 228335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 228343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 228386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228395 */     GIR_RootConstrainSelectedInstOperands,
     /* 228396 */     // GIR_Coverage, 7758,
     /* 228396 */     GIR_EraseRootFromParent_Done,
     /* 228397 */   // Label 4355: @228397
     /* 228397 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(228464), // Rule ID 7788 //
     /* 228402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228436 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 228453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228462 */     GIR_RootConstrainSelectedInstOperands,
     /* 228463 */     // GIR_Coverage, 7788,
     /* 228463 */     GIR_EraseRootFromParent_Done,
     /* 228464 */   // Label 4356: @228464
     /* 228464 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(228531), // Rule ID 7790 //
     /* 228469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 228520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228529 */     GIR_RootConstrainSelectedInstOperands,
     /* 228530 */     // GIR_Coverage, 7790,
     /* 228530 */     GIR_EraseRootFromParent_Done,
     /* 228531 */   // Label 4357: @228531
     /* 228531 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(228598), // Rule ID 7792 //
     /* 228536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 228587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228596 */     GIR_RootConstrainSelectedInstOperands,
     /* 228597 */     // GIR_Coverage, 7792,
     /* 228597 */     GIR_EraseRootFromParent_Done,
     /* 228598 */   // Label 4358: @228598
     /* 228598 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(228665), // Rule ID 7794 //
     /* 228603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 228611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 228654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228663 */     GIR_RootConstrainSelectedInstOperands,
     /* 228664 */     // GIR_Coverage, 7794,
     /* 228664 */     GIR_EraseRootFromParent_Done,
     /* 228665 */   // Label 4359: @228665
     /* 228665 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(228732), // Rule ID 7800 //
     /* 228670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 228704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 228721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228730 */     GIR_RootConstrainSelectedInstOperands,
     /* 228731 */     // GIR_Coverage, 7800,
     /* 228731 */     GIR_EraseRootFromParent_Done,
     /* 228732 */   // Label 4360: @228732
     /* 228732 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(228799), // Rule ID 7802 //
     /* 228737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 228771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 228788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228797 */     GIR_RootConstrainSelectedInstOperands,
     /* 228798 */     // GIR_Coverage, 7802,
     /* 228798 */     GIR_EraseRootFromParent_Done,
     /* 228799 */   // Label 4361: @228799
     /* 228799 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(228866), // Rule ID 7804 //
     /* 228804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 228855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228864 */     GIR_RootConstrainSelectedInstOperands,
     /* 228865 */     // GIR_Coverage, 7804,
     /* 228865 */     GIR_EraseRootFromParent_Done,
     /* 228866 */   // Label 4362: @228866
     /* 228866 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(228933), // Rule ID 7806 //
     /* 228871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 228879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228905 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 228905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 228922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228931 */     GIR_RootConstrainSelectedInstOperands,
     /* 228932 */     // GIR_Coverage, 7806,
     /* 228932 */     GIR_EraseRootFromParent_Done,
     /* 228933 */   // Label 4363: @228933
     /* 228933 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229000), // Rule ID 11534 //
     /* 228938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 228946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 228970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 228972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 228975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 228979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 228984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 228986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 228989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 228994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 228996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 228998 */     GIR_RootConstrainSelectedInstOperands,
     /* 228999 */     // GIR_Coverage, 11534,
     /* 228999 */     GIR_EraseRootFromParent_Done,
     /* 229000 */   // Label 4364: @229000
     /* 229000 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229067), // Rule ID 11536 //
     /* 229005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 229013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 229056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229065 */     GIR_RootConstrainSelectedInstOperands,
     /* 229066 */     // GIR_Coverage, 11536,
     /* 229066 */     GIR_EraseRootFromParent_Done,
     /* 229067 */   // Label 4365: @229067
     /* 229067 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229134), // Rule ID 11538 //
     /* 229072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 229080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 229123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229132 */     GIR_RootConstrainSelectedInstOperands,
     /* 229133 */     // GIR_Coverage, 11538,
     /* 229133 */     GIR_EraseRootFromParent_Done,
     /* 229134 */   // Label 4366: @229134
     /* 229134 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229201), // Rule ID 11540 //
     /* 229139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 229147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 229190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229199 */     GIR_RootConstrainSelectedInstOperands,
     /* 229200 */     // GIR_Coverage, 11540,
     /* 229200 */     GIR_EraseRootFromParent_Done,
     /* 229201 */   // Label 4367: @229201
     /* 229201 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229268), // Rule ID 11542 //
     /* 229206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 229214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 229257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229266 */     GIR_RootConstrainSelectedInstOperands,
     /* 229267 */     // GIR_Coverage, 11542,
     /* 229267 */     GIR_EraseRootFromParent_Done,
     /* 229268 */   // Label 4368: @229268
     /* 229268 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229335), // Rule ID 11548 //
     /* 229273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 229324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229333 */     GIR_RootConstrainSelectedInstOperands,
     /* 229334 */     // GIR_Coverage, 11548,
     /* 229334 */     GIR_EraseRootFromParent_Done,
     /* 229335 */   // Label 4369: @229335
     /* 229335 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229402), // Rule ID 11550 //
     /* 229340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 229391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229400 */     GIR_RootConstrainSelectedInstOperands,
     /* 229401 */     // GIR_Coverage, 11550,
     /* 229401 */     GIR_EraseRootFromParent_Done,
     /* 229402 */   // Label 4370: @229402
     /* 229402 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(229469), // Rule ID 11552 //
     /* 229407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 229458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229467 */     GIR_RootConstrainSelectedInstOperands,
     /* 229468 */     // GIR_Coverage, 11552,
     /* 229468 */     GIR_EraseRootFromParent_Done,
     /* 229469 */   // Label 4371: @229469
     /* 229469 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(229536), // Rule ID 11554 //
     /* 229474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 229482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 229525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229534 */     GIR_RootConstrainSelectedInstOperands,
     /* 229535 */     // GIR_Coverage, 11554,
     /* 229535 */     GIR_EraseRootFromParent_Done,
     /* 229536 */   // Label 4372: @229536
     /* 229536 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(229590), // Rule ID 30 //
     /* 229541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 229549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229577 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 229580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229588 */     GIR_RootConstrainSelectedInstOperands,
     /* 229589 */     // GIR_Coverage, 30,
     /* 229589 */     GIR_EraseRootFromParent_Done,
     /* 229590 */   // Label 4373: @229590
     /* 229590 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(229644), // Rule ID 31 //
     /* 229595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 229603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229631 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 229634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229642 */     GIR_RootConstrainSelectedInstOperands,
     /* 229643 */     // GIR_Coverage, 31,
     /* 229643 */     GIR_EraseRootFromParent_Done,
     /* 229644 */   // Label 4374: @229644
     /* 229644 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(229698), // Rule ID 32 //
     /* 229649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 229652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 229657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 229666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 229669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229685 */     // (intrinsic_wo_chain:{ *:[v4i32] } 760:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 229685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 229688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229696 */     GIR_RootConstrainSelectedInstOperands,
     /* 229697 */     // GIR_Coverage, 32,
     /* 229697 */     GIR_EraseRootFromParent_Done,
     /* 229698 */   // Label 4375: @229698
     /* 229698 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(229752), // Rule ID 39 //
     /* 229703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 229711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229739 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 229742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229750 */     GIR_RootConstrainSelectedInstOperands,
     /* 229751 */     // GIR_Coverage, 39,
     /* 229751 */     GIR_EraseRootFromParent_Done,
     /* 229752 */   // Label 4376: @229752
     /* 229752 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(229806), // Rule ID 40 //
     /* 229757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 229765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229793 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 229796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229804 */     GIR_RootConstrainSelectedInstOperands,
     /* 229805 */     // GIR_Coverage, 40,
     /* 229805 */     GIR_EraseRootFromParent_Done,
     /* 229806 */   // Label 4377: @229806
     /* 229806 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(229860), // Rule ID 41 //
     /* 229811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 229819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229847 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 229850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229858 */     GIR_RootConstrainSelectedInstOperands,
     /* 229859 */     // GIR_Coverage, 41,
     /* 229859 */     GIR_EraseRootFromParent_Done,
     /* 229860 */   // Label 4378: @229860
     /* 229860 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(229914), // Rule ID 42 //
     /* 229865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 229873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229901 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 229901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 229904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229912 */     GIR_RootConstrainSelectedInstOperands,
     /* 229913 */     // GIR_Coverage, 42,
     /* 229913 */     GIR_EraseRootFromParent_Done,
     /* 229914 */   // Label 4379: @229914
     /* 229914 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(229968), // Rule ID 43 //
     /* 229919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 229927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 229930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 229933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 229936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 229939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 229955 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 229955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 229958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 229962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 229964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 229966 */     GIR_RootConstrainSelectedInstOperands,
     /* 229967 */     // GIR_Coverage, 43,
     /* 229967 */     GIR_EraseRootFromParent_Done,
     /* 229968 */   // Label 4380: @229968
     /* 229968 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230022), // Rule ID 44 //
     /* 229973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 229976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 229981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 229984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 229990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 229993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 229997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230009 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 230009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 230012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230020 */     GIR_RootConstrainSelectedInstOperands,
     /* 230021 */     // GIR_Coverage, 44,
     /* 230021 */     GIR_EraseRootFromParent_Done,
     /* 230022 */   // Label 4381: @230022
     /* 230022 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230076), // Rule ID 45 //
     /* 230027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 230030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 230035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 230038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 230041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 230044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 230047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230063 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 230063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 230066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230074 */     GIR_RootConstrainSelectedInstOperands,
     /* 230075 */     // GIR_Coverage, 45,
     /* 230075 */     GIR_EraseRootFromParent_Done,
     /* 230076 */   // Label 4382: @230076
     /* 230076 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230130), // Rule ID 46 //
     /* 230081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 230084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 230089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 230098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 230101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230117 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 230117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 230120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230128 */     GIR_RootConstrainSelectedInstOperands,
     /* 230129 */     // GIR_Coverage, 46,
     /* 230129 */     GIR_EraseRootFromParent_Done,
     /* 230130 */   // Label 4383: @230130
     /* 230130 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230184), // Rule ID 1587 //
     /* 230135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 230146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 230149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 230152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 230155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230171 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 230171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 230174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230182 */     GIR_RootConstrainSelectedInstOperands,
     /* 230183 */     // GIR_Coverage, 1587,
     /* 230183 */     GIR_EraseRootFromParent_Done,
     /* 230184 */   // Label 4384: @230184
     /* 230184 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230238), // Rule ID 1588 //
     /* 230189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 230200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 230203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 230206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 230209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230225 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 230225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230236 */     GIR_RootConstrainSelectedInstOperands,
     /* 230237 */     // GIR_Coverage, 1588,
     /* 230237 */     GIR_EraseRootFromParent_Done,
     /* 230238 */   // Label 4385: @230238
     /* 230238 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230292), // Rule ID 1589 //
     /* 230243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 230254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 230257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 230260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 230263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230279 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 230279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 230282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230290 */     GIR_RootConstrainSelectedInstOperands,
     /* 230291 */     // GIR_Coverage, 1589,
     /* 230291 */     GIR_EraseRootFromParent_Done,
     /* 230292 */   // Label 4386: @230292
     /* 230292 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(230346), // Rule ID 1590 //
     /* 230297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 230305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230333 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 230336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230344 */     GIR_RootConstrainSelectedInstOperands,
     /* 230345 */     // GIR_Coverage, 1590,
     /* 230345 */     GIR_EraseRootFromParent_Done,
     /* 230346 */   // Label 4387: @230346
     /* 230346 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(230400), // Rule ID 1591 //
     /* 230351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 230362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 230365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 230368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 230371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 230387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 230390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230398 */     GIR_RootConstrainSelectedInstOperands,
     /* 230399 */     // GIR_Coverage, 1591,
     /* 230399 */     GIR_EraseRootFromParent_Done,
     /* 230400 */   // Label 4388: @230400
     /* 230400 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(230454), // Rule ID 1592 //
     /* 230405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 230416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 230419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 230422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 230425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230441 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 230441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 230444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230452 */     GIR_RootConstrainSelectedInstOperands,
     /* 230453 */     // GIR_Coverage, 1592,
     /* 230453 */     GIR_EraseRootFromParent_Done,
     /* 230454 */   // Label 4389: @230454
     /* 230454 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(230508), // Rule ID 1593 //
     /* 230459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 230470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 230473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 230476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 230479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 230495 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 230495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 230498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230506 */     GIR_RootConstrainSelectedInstOperands,
     /* 230507 */     // GIR_Coverage, 1593,
     /* 230507 */     GIR_EraseRootFromParent_Done,
     /* 230508 */   // Label 4390: @230508
     /* 230508 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(230562), // Rule ID 1594 //
     /* 230513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 230516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 230521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230549 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 230552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230560 */     GIR_RootConstrainSelectedInstOperands,
     /* 230561 */     // GIR_Coverage, 1594,
     /* 230561 */     GIR_EraseRootFromParent_Done,
     /* 230562 */   // Label 4391: @230562
     /* 230562 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(230616), // Rule ID 2307 //
     /* 230567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 230575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230603 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 230606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230614 */     GIR_RootConstrainSelectedInstOperands,
     /* 230615 */     // GIR_Coverage, 2307,
     /* 230615 */     GIR_EraseRootFromParent_Done,
     /* 230616 */   // Label 4392: @230616
     /* 230616 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(230670), // Rule ID 2308 //
     /* 230621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 230629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 230660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230668 */     GIR_RootConstrainSelectedInstOperands,
     /* 230669 */     // GIR_Coverage, 2308,
     /* 230669 */     GIR_EraseRootFromParent_Done,
     /* 230670 */   // Label 4393: @230670
     /* 230670 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(230724), // Rule ID 2309 //
     /* 230675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 230683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 230707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230711 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 230714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230722 */     GIR_RootConstrainSelectedInstOperands,
     /* 230723 */     // GIR_Coverage, 2309,
     /* 230723 */     GIR_EraseRootFromParent_Done,
     /* 230724 */   // Label 4394: @230724
     /* 230724 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(230778), // Rule ID 2310 //
     /* 230729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 230737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230765 */     // (intrinsic_wo_chain:{ *:[v4i32] } 531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 230768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230776 */     GIR_RootConstrainSelectedInstOperands,
     /* 230777 */     // GIR_Coverage, 2310,
     /* 230777 */     GIR_EraseRootFromParent_Done,
     /* 230778 */   // Label 4395: @230778
     /* 230778 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(230832), // Rule ID 2311 //
     /* 230783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 230791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 230822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230830 */     GIR_RootConstrainSelectedInstOperands,
     /* 230831 */     // GIR_Coverage, 2311,
     /* 230831 */     GIR_EraseRootFromParent_Done,
     /* 230832 */   // Label 4396: @230832
     /* 230832 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(230886), // Rule ID 2312 //
     /* 230837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 230845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230873 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 230876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230884 */     GIR_RootConstrainSelectedInstOperands,
     /* 230885 */     // GIR_Coverage, 2312,
     /* 230885 */     GIR_EraseRootFromParent_Done,
     /* 230886 */   // Label 4397: @230886
     /* 230886 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(230940), // Rule ID 2313 //
     /* 230891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 230894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 230899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 230908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 230911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230927 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 230927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 230930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230938 */     GIR_RootConstrainSelectedInstOperands,
     /* 230939 */     // GIR_Coverage, 2313,
     /* 230939 */     GIR_EraseRootFromParent_Done,
     /* 230940 */   // Label 4398: @230940
     /* 230940 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(230997), // Rule ID 3633 //
     /* 230945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 230948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 230953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 230956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 230965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 230969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 230977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 230981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 230981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 230984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 230986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 230988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 230990 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 230992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230995 */     GIR_RootConstrainSelectedInstOperands,
     /* 230996 */     // GIR_Coverage, 3633,
     /* 230996 */     GIR_EraseRootFromParent_Done,
     /* 230997 */   // Label 4399: @230997
     /* 230997 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231054), // Rule ID 3634 //
     /* 231002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 231005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 231010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 231013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 231019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 231022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 231026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 231038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 231038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 231041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 231045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 231047 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 231049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231052 */     GIR_RootConstrainSelectedInstOperands,
     /* 231053 */     // GIR_Coverage, 3634,
     /* 231053 */     GIR_EraseRootFromParent_Done,
     /* 231054 */   // Label 4400: @231054
     /* 231054 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231111), // Rule ID 3635 //
     /* 231059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 231062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 231067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 231070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 231079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 231083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 231095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 231095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 231098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 231102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 231104 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 231106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231109 */     GIR_RootConstrainSelectedInstOperands,
     /* 231110 */     // GIR_Coverage, 3635,
     /* 231110 */     GIR_EraseRootFromParent_Done,
     /* 231111 */   // Label 4401: @231111
     /* 231111 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231168), // Rule ID 3636 //
     /* 231116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 231119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 231124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 231127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 231133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 231136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 231140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 231152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 231152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 231155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 231159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 231161 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 231163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231166 */     GIR_RootConstrainSelectedInstOperands,
     /* 231167 */     // GIR_Coverage, 3636,
     /* 231167 */     GIR_EraseRootFromParent_Done,
     /* 231168 */   // Label 4402: @231168
     /* 231168 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231222), // Rule ID 3813 //
     /* 231173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 231181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231209 */     // (intrinsic_wo_chain:{ *:[v2i64] } 537:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 231212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231220 */     GIR_RootConstrainSelectedInstOperands,
     /* 231221 */     // GIR_Coverage, 3813,
     /* 231221 */     GIR_EraseRootFromParent_Done,
     /* 231222 */   // Label 4403: @231222
     /* 231222 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231276), // Rule ID 3814 //
     /* 231227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 231235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231263 */     // (intrinsic_wo_chain:{ *:[v2i64] } 538:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 231266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231274 */     GIR_RootConstrainSelectedInstOperands,
     /* 231275 */     // GIR_Coverage, 3814,
     /* 231275 */     GIR_EraseRootFromParent_Done,
     /* 231276 */   // Label 4404: @231276
     /* 231276 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(231330), // Rule ID 3815 //
     /* 231281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 231289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231317 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 231320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 231322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231328 */     GIR_RootConstrainSelectedInstOperands,
     /* 231329 */     // GIR_Coverage, 3815,
     /* 231329 */     GIR_EraseRootFromParent_Done,
     /* 231330 */   // Label 4405: @231330
     /* 231330 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(231384), // Rule ID 3816 //
     /* 231335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231371 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231382 */     GIR_RootConstrainSelectedInstOperands,
     /* 231383 */     // GIR_Coverage, 3816,
     /* 231383 */     GIR_EraseRootFromParent_Done,
     /* 231384 */   // Label 4406: @231384
     /* 231384 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(231438), // Rule ID 3817 //
     /* 231389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231425 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231436 */     GIR_RootConstrainSelectedInstOperands,
     /* 231437 */     // GIR_Coverage, 3817,
     /* 231437 */     GIR_EraseRootFromParent_Done,
     /* 231438 */   // Label 4407: @231438
     /* 231438 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(231492), // Rule ID 3818 //
     /* 231443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231490 */     GIR_RootConstrainSelectedInstOperands,
     /* 231491 */     // GIR_Coverage, 3818,
     /* 231491 */     GIR_EraseRootFromParent_Done,
     /* 231492 */   // Label 4408: @231492
     /* 231492 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(231546), // Rule ID 3819 //
     /* 231497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 231505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231533 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231544 */     GIR_RootConstrainSelectedInstOperands,
     /* 231545 */     // GIR_Coverage, 3819,
     /* 231545 */     GIR_EraseRootFromParent_Done,
     /* 231546 */   // Label 4409: @231546
     /* 231546 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(231600), // Rule ID 3828 //
     /* 231551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231587 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231598 */     GIR_RootConstrainSelectedInstOperands,
     /* 231599 */     // GIR_Coverage, 3828,
     /* 231599 */     GIR_EraseRootFromParent_Done,
     /* 231600 */   // Label 4410: @231600
     /* 231600 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(231654), // Rule ID 3829 //
     /* 231605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231641 */     // (intrinsic_wo_chain:{ *:[v8i16] } 523:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231652 */     GIR_RootConstrainSelectedInstOperands,
     /* 231653 */     // GIR_Coverage, 3829,
     /* 231653 */     GIR_EraseRootFromParent_Done,
     /* 231654 */   // Label 4411: @231654
     /* 231654 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(231708), // Rule ID 3830 //
     /* 231659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231706 */     GIR_RootConstrainSelectedInstOperands,
     /* 231707 */     // GIR_Coverage, 3830,
     /* 231707 */     GIR_EraseRootFromParent_Done,
     /* 231708 */   // Label 4412: @231708
     /* 231708 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(231762), // Rule ID 3831 //
     /* 231713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 231721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231749 */     // (intrinsic_wo_chain:{ *:[v2i64] } 523:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 231752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231760 */     GIR_RootConstrainSelectedInstOperands,
     /* 231761 */     // GIR_Coverage, 3831,
     /* 231761 */     GIR_EraseRootFromParent_Done,
     /* 231762 */   // Label 4413: @231762
     /* 231762 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(231816), // Rule ID 3832 //
     /* 231767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231803 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 231803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231814 */     GIR_RootConstrainSelectedInstOperands,
     /* 231815 */     // GIR_Coverage, 3832,
     /* 231815 */     GIR_EraseRootFromParent_Done,
     /* 231816 */   // Label 4414: @231816
     /* 231816 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(231870), // Rule ID 3833 //
     /* 231821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 524:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 231857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231868 */     GIR_RootConstrainSelectedInstOperands,
     /* 231869 */     // GIR_Coverage, 3833,
     /* 231869 */     GIR_EraseRootFromParent_Done,
     /* 231870 */   // Label 4415: @231870
     /* 231870 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(231924), // Rule ID 3834 //
     /* 231875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231911 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 231911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231922 */     GIR_RootConstrainSelectedInstOperands,
     /* 231923 */     // GIR_Coverage, 3834,
     /* 231923 */     GIR_EraseRootFromParent_Done,
     /* 231924 */   // Label 4416: @231924
     /* 231924 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(231978), // Rule ID 3835 //
     /* 231929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 231937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 231940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 231943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 231946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 231949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231965 */     // (intrinsic_wo_chain:{ *:[v2i64] } 524:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 231965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 231968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 231970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 231972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 231974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 231976 */     GIR_RootConstrainSelectedInstOperands,
     /* 231977 */     // GIR_Coverage, 3835,
     /* 231977 */     GIR_EraseRootFromParent_Done,
     /* 231978 */   // Label 4417: @231978
     /* 231978 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232032), // Rule ID 3836 //
     /* 231983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 231986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 231991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 231994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 231997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 232000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 232003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232019 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 232019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232030 */     GIR_RootConstrainSelectedInstOperands,
     /* 232031 */     // GIR_Coverage, 3836,
     /* 232031 */     GIR_EraseRootFromParent_Done,
     /* 232032 */   // Label 4418: @232032
     /* 232032 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232086), // Rule ID 3837 //
     /* 232037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 232045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 522:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 232073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232084 */     GIR_RootConstrainSelectedInstOperands,
     /* 232085 */     // GIR_Coverage, 3837,
     /* 232085 */     GIR_EraseRootFromParent_Done,
     /* 232086 */   // Label 4419: @232086
     /* 232086 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232140), // Rule ID 3838 //
     /* 232091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 232099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232127 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232138 */     GIR_RootConstrainSelectedInstOperands,
     /* 232139 */     // GIR_Coverage, 3838,
     /* 232139 */     GIR_EraseRootFromParent_Done,
     /* 232140 */   // Label 4420: @232140
     /* 232140 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232194), // Rule ID 3839 //
     /* 232145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 232153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232181 */     // (intrinsic_wo_chain:{ *:[v2i64] } 522:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232192 */     GIR_RootConstrainSelectedInstOperands,
     /* 232193 */     // GIR_Coverage, 3839,
     /* 232193 */     GIR_EraseRootFromParent_Done,
     /* 232194 */   // Label 4421: @232194
     /* 232194 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232248), // Rule ID 3843 //
     /* 232199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 232207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 543:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 232235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 232238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 232242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 232244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 232246 */     GIR_RootConstrainSelectedInstOperands,
     /* 232247 */     // GIR_Coverage, 3843,
     /* 232247 */     GIR_EraseRootFromParent_Done,
     /* 232248 */   // Label 4422: @232248
     /* 232248 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(232302), // Rule ID 3844 //
     /* 232253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 232261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232289 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 232292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232300 */     GIR_RootConstrainSelectedInstOperands,
     /* 232301 */     // GIR_Coverage, 3844,
     /* 232301 */     GIR_EraseRootFromParent_Done,
     /* 232302 */   // Label 4423: @232302
     /* 232302 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(232356), // Rule ID 3845 //
     /* 232307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 232310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 232315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232343 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 232346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232354 */     GIR_RootConstrainSelectedInstOperands,
     /* 232355 */     // GIR_Coverage, 3845,
     /* 232355 */     GIR_EraseRootFromParent_Done,
     /* 232356 */   // Label 4424: @232356
     /* 232356 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(232413), // Rule ID 3862 //
     /* 232361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232397 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 232397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232411 */     GIR_RootConstrainSelectedInstOperands,
     /* 232412 */     // GIR_Coverage, 3862,
     /* 232412 */     GIR_EraseRootFromParent_Done,
     /* 232413 */   // Label 4425: @232413
     /* 232413 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(232470), // Rule ID 3863 //
     /* 232418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232454 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 232454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232468 */     GIR_RootConstrainSelectedInstOperands,
     /* 232469 */     // GIR_Coverage, 3863,
     /* 232469 */     GIR_EraseRootFromParent_Done,
     /* 232470 */   // Label 4426: @232470
     /* 232470 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(232527), // Rule ID 3864 //
     /* 232475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232511 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 232511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232525 */     GIR_RootConstrainSelectedInstOperands,
     /* 232526 */     // GIR_Coverage, 3864,
     /* 232526 */     GIR_EraseRootFromParent_Done,
     /* 232527 */   // Label 4427: @232527
     /* 232527 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(232584), // Rule ID 3865 //
     /* 232532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 232543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 232546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 232549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 232552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232568 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 232568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 232571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 232582 */     GIR_RootConstrainSelectedInstOperands,
     /* 232583 */     // GIR_Coverage, 3865,
     /* 232583 */     GIR_EraseRootFromParent_Done,
     /* 232584 */   // Label 4428: @232584
     /* 232584 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(232641), // Rule ID 3870 //
     /* 232589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232625 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 232625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232639 */     GIR_RootConstrainSelectedInstOperands,
     /* 232640 */     // GIR_Coverage, 3870,
     /* 232640 */     GIR_EraseRootFromParent_Done,
     /* 232641 */   // Label 4429: @232641
     /* 232641 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(232698), // Rule ID 3871 //
     /* 232646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232682 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 232682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232696 */     GIR_RootConstrainSelectedInstOperands,
     /* 232697 */     // GIR_Coverage, 3871,
     /* 232697 */     GIR_EraseRootFromParent_Done,
     /* 232698 */   // Label 4430: @232698
     /* 232698 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(232755), // Rule ID 3872 //
     /* 232703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232739 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 232739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232753 */     GIR_RootConstrainSelectedInstOperands,
     /* 232754 */     // GIR_Coverage, 3872,
     /* 232754 */     GIR_EraseRootFromParent_Done,
     /* 232755 */   // Label 4431: @232755
     /* 232755 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(232812), // Rule ID 3873 //
     /* 232760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 232763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232796 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 232796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 232799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 232810 */     GIR_RootConstrainSelectedInstOperands,
     /* 232811 */     // GIR_Coverage, 3873,
     /* 232811 */     GIR_EraseRootFromParent_Done,
     /* 232812 */   // Label 4432: @232812
     /* 232812 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(232869), // Rule ID 3878 //
     /* 232817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 232825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232853 */     // (intrinsic_wo_chain:{ *:[v2f32] } 764:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 232853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232867 */     GIR_RootConstrainSelectedInstOperands,
     /* 232868 */     // GIR_Coverage, 3878,
     /* 232868 */     GIR_EraseRootFromParent_Done,
     /* 232869 */   // Label 4433: @232869
     /* 232869 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(232926), // Rule ID 3879 //
     /* 232874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 232882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232910 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 232910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 232924 */     GIR_RootConstrainSelectedInstOperands,
     /* 232925 */     // GIR_Coverage, 3879,
     /* 232925 */     GIR_EraseRootFromParent_Done,
     /* 232926 */   // Label 4434: @232926
     /* 232926 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(232983), // Rule ID 3880 //
     /* 232931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 232939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 232945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 232948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 232951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 232967 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 232967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 232970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 232981 */     GIR_RootConstrainSelectedInstOperands,
     /* 232982 */     // GIR_Coverage, 3880,
     /* 232982 */     GIR_EraseRootFromParent_Done,
     /* 232983 */   // Label 4435: @232983
     /* 232983 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233040), // Rule ID 3881 //
     /* 232988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 232991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 232996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 232999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 233005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 233008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233024 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 233024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 233027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233038 */     GIR_RootConstrainSelectedInstOperands,
     /* 233039 */     // GIR_Coverage, 3881,
     /* 233039 */     GIR_EraseRootFromParent_Done,
     /* 233040 */   // Label 4436: @233040
     /* 233040 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233097), // Rule ID 3882 //
     /* 233045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233081 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 233081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233095 */     GIR_RootConstrainSelectedInstOperands,
     /* 233096 */     // GIR_Coverage, 3882,
     /* 233096 */     GIR_EraseRootFromParent_Done,
     /* 233097 */   // Label 4437: @233097
     /* 233097 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233154), // Rule ID 3883 //
     /* 233102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233138 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 233138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233152 */     GIR_RootConstrainSelectedInstOperands,
     /* 233153 */     // GIR_Coverage, 3883,
     /* 233153 */     GIR_EraseRootFromParent_Done,
     /* 233154 */   // Label 4438: @233154
     /* 233154 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233211), // Rule ID 3884 //
     /* 233159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233195 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 233195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233209 */     GIR_RootConstrainSelectedInstOperands,
     /* 233210 */     // GIR_Coverage, 3884,
     /* 233210 */     GIR_EraseRootFromParent_Done,
     /* 233211 */   // Label 4439: @233211
     /* 233211 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233268), // Rule ID 3885 //
     /* 233216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233252 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 233252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 233255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233266 */     GIR_RootConstrainSelectedInstOperands,
     /* 233267 */     // GIR_Coverage, 3885,
     /* 233267 */     GIR_EraseRootFromParent_Done,
     /* 233268 */   // Label 4440: @233268
     /* 233268 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(233325), // Rule ID 3886 //
     /* 233273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233309 */     // (intrinsic_wo_chain:{ *:[v2f64] } 764:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 233309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233323 */     GIR_RootConstrainSelectedInstOperands,
     /* 233324 */     // GIR_Coverage, 3886,
     /* 233324 */     GIR_EraseRootFromParent_Done,
     /* 233325 */   // Label 4441: @233325
     /* 233325 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(233382), // Rule ID 3887 //
     /* 233330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233366 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 233366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233380 */     GIR_RootConstrainSelectedInstOperands,
     /* 233381 */     // GIR_Coverage, 3887,
     /* 233381 */     GIR_EraseRootFromParent_Done,
     /* 233382 */   // Label 4442: @233382
     /* 233382 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(233439), // Rule ID 3888 //
     /* 233387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233423 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 233423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233437 */     GIR_RootConstrainSelectedInstOperands,
     /* 233438 */     // GIR_Coverage, 3888,
     /* 233438 */     GIR_EraseRootFromParent_Done,
     /* 233439 */   // Label 4443: @233439
     /* 233439 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(233496), // Rule ID 3889 //
     /* 233444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 233447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233480 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 233480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 233483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233494 */     GIR_RootConstrainSelectedInstOperands,
     /* 233495 */     // GIR_Coverage, 3889,
     /* 233495 */     GIR_EraseRootFromParent_Done,
     /* 233496 */   // Label 4444: @233496
     /* 233496 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(233550), // Rule ID 5244 //
     /* 233501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 233504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233537 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 233537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 233540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233548 */     GIR_RootConstrainSelectedInstOperands,
     /* 233549 */     // GIR_Coverage, 5244,
     /* 233549 */     GIR_EraseRootFromParent_Done,
     /* 233550 */   // Label 4445: @233550
     /* 233550 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(233604), // Rule ID 5245 //
     /* 233555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 233558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 233563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 233591 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 233591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 233594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233602 */     GIR_RootConstrainSelectedInstOperands,
     /* 233603 */     // GIR_Coverage, 5245,
     /* 233603 */     GIR_EraseRootFromParent_Done,
     /* 233604 */   // Label 4446: @233604
     /* 233604 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(233655), // Rule ID 5598 //
     /* 233609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 233614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 233617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 233620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 233626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233642 */     // (intrinsic_wo_chain:{ *:[v8i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 233642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 233645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 233653 */     GIR_RootConstrainSelectedInstOperands,
     /* 233654 */     // GIR_Coverage, 5598,
     /* 233654 */     GIR_EraseRootFromParent_Done,
     /* 233655 */   // Label 4447: @233655
     /* 233655 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(233706), // Rule ID 5599 //
     /* 233660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 233665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233693 */     // (intrinsic_wo_chain:{ *:[v16i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 233693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 233696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 233702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 233704 */     GIR_RootConstrainSelectedInstOperands,
     /* 233705 */     // GIR_Coverage, 5599,
     /* 233705 */     GIR_EraseRootFromParent_Done,
     /* 233706 */   // Label 4448: @233706
     /* 233706 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(233748), // Rule ID 2692 //
     /* 233711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 233738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233746 */     GIR_RootConstrainSelectedInstOperands,
     /* 233747 */     // GIR_Coverage, 2692,
     /* 233747 */     GIR_EraseRootFromParent_Done,
     /* 233748 */   // Label 4449: @233748
     /* 233748 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(233790), // Rule ID 2693 //
     /* 233753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 233780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233788 */     GIR_RootConstrainSelectedInstOperands,
     /* 233789 */     // GIR_Coverage, 2693,
     /* 233789 */     GIR_EraseRootFromParent_Done,
     /* 233790 */   // Label 4450: @233790
     /* 233790 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(233832), // Rule ID 2694 //
     /* 233795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 233822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233830 */     GIR_RootConstrainSelectedInstOperands,
     /* 233831 */     // GIR_Coverage, 2694,
     /* 233831 */     GIR_EraseRootFromParent_Done,
     /* 233832 */   // Label 4451: @233832
     /* 233832 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(233874), // Rule ID 2695 //
     /* 233837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 233864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233872 */     GIR_RootConstrainSelectedInstOperands,
     /* 233873 */     // GIR_Coverage, 2695,
     /* 233873 */     GIR_EraseRootFromParent_Done,
     /* 233874 */   // Label 4452: @233874
     /* 233874 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(233916), // Rule ID 2696 //
     /* 233879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1925:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 233906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233914 */     GIR_RootConstrainSelectedInstOperands,
     /* 233915 */     // GIR_Coverage, 2696,
     /* 233915 */     GIR_EraseRootFromParent_Done,
     /* 233916 */   // Label 4453: @233916
     /* 233916 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(233958), // Rule ID 2697 //
     /* 233921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233945 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1925:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 233948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233956 */     GIR_RootConstrainSelectedInstOperands,
     /* 233957 */     // GIR_Coverage, 2697,
     /* 233957 */     GIR_EraseRootFromParent_Done,
     /* 233958 */   // Label 4454: @233958
     /* 233958 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234000), // Rule ID 2698 //
     /* 233963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 233971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233987 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1925:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 233990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233998 */     GIR_RootConstrainSelectedInstOperands,
     /* 233999 */     // GIR_Coverage, 2698,
     /* 233999 */     GIR_EraseRootFromParent_Done,
     /* 234000 */   // Label 4455: @234000
     /* 234000 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234042), // Rule ID 2737 //
     /* 234005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 234025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234029 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1271:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 234029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234040 */     GIR_RootConstrainSelectedInstOperands,
     /* 234041 */     // GIR_Coverage, 2737,
     /* 234041 */     GIR_EraseRootFromParent_Done,
     /* 234042 */   // Label 4456: @234042
     /* 234042 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234084), // Rule ID 2738 //
     /* 234047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 234058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 234067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234071 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1271:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 234071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234082 */     GIR_RootConstrainSelectedInstOperands,
     /* 234083 */     // GIR_Coverage, 2738,
     /* 234083 */     GIR_EraseRootFromParent_Done,
     /* 234084 */   // Label 4457: @234084
     /* 234084 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234126), // Rule ID 2739 //
     /* 234089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 234100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 234109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234113 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1271:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 234113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234124 */     GIR_RootConstrainSelectedInstOperands,
     /* 234125 */     // GIR_Coverage, 2739,
     /* 234125 */     GIR_EraseRootFromParent_Done,
     /* 234126 */   // Label 4458: @234126
     /* 234126 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(234168), // Rule ID 2740 //
     /* 234131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 234142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 234151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1271:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 234155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234166 */     GIR_RootConstrainSelectedInstOperands,
     /* 234167 */     // GIR_Coverage, 2740,
     /* 234167 */     GIR_EraseRootFromParent_Done,
     /* 234168 */   // Label 4459: @234168
     /* 234168 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(234210), // Rule ID 2741 //
     /* 234173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 234181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 234184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 234187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 234190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 234193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234197 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1271:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 234197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 234200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234208 */     GIR_RootConstrainSelectedInstOperands,
     /* 234209 */     // GIR_Coverage, 2741,
     /* 234209 */     GIR_EraseRootFromParent_Done,
     /* 234210 */   // Label 4460: @234210
     /* 234210 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(234252), // Rule ID 2780 //
     /* 234215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234239 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 234242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234250 */     GIR_RootConstrainSelectedInstOperands,
     /* 234251 */     // GIR_Coverage, 2780,
     /* 234251 */     GIR_EraseRootFromParent_Done,
     /* 234252 */   // Label 4461: @234252
     /* 234252 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(234294), // Rule ID 2782 //
     /* 234257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234281 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 234284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234292 */     GIR_RootConstrainSelectedInstOperands,
     /* 234293 */     // GIR_Coverage, 2782,
     /* 234293 */     GIR_EraseRootFromParent_Done,
     /* 234294 */   // Label 4462: @234294
     /* 234294 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(234336), // Rule ID 2784 //
     /* 234299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 234307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234323 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 234326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234334 */     GIR_RootConstrainSelectedInstOperands,
     /* 234335 */     // GIR_Coverage, 2784,
     /* 234335 */     GIR_EraseRootFromParent_Done,
     /* 234336 */   // Label 4463: @234336
     /* 234336 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(234378), // Rule ID 2786 //
     /* 234341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234365 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 234368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234376 */     GIR_RootConstrainSelectedInstOperands,
     /* 234377 */     // GIR_Coverage, 2786,
     /* 234377 */     GIR_EraseRootFromParent_Done,
     /* 234378 */   // Label 4464: @234378
     /* 234378 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(234420), // Rule ID 2787 //
     /* 234383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234407 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 234410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234418 */     GIR_RootConstrainSelectedInstOperands,
     /* 234419 */     // GIR_Coverage, 2787,
     /* 234419 */     GIR_EraseRootFromParent_Done,
     /* 234420 */   // Label 4465: @234420
     /* 234420 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(234462), // Rule ID 2788 //
     /* 234425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 234433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234449 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 234452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234460 */     GIR_RootConstrainSelectedInstOperands,
     /* 234461 */     // GIR_Coverage, 2788,
     /* 234461 */     GIR_EraseRootFromParent_Done,
     /* 234462 */   // Label 4466: @234462
     /* 234462 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(234504), // Rule ID 2857 //
     /* 234467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 234475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234491 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1406:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 234494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234502 */     GIR_RootConstrainSelectedInstOperands,
     /* 234503 */     // GIR_Coverage, 2857,
     /* 234503 */     GIR_EraseRootFromParent_Done,
     /* 234504 */   // Label 4467: @234504
     /* 234504 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(234546), // Rule ID 2858 //
     /* 234509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 234517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 234536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234544 */     GIR_RootConstrainSelectedInstOperands,
     /* 234545 */     // GIR_Coverage, 2858,
     /* 234545 */     GIR_EraseRootFromParent_Done,
     /* 234546 */   // Label 4468: @234546
     /* 234546 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(234588), // Rule ID 2859 //
     /* 234551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 234559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234575 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 234578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234586 */     GIR_RootConstrainSelectedInstOperands,
     /* 234587 */     // GIR_Coverage, 2859,
     /* 234587 */     GIR_EraseRootFromParent_Done,
     /* 234588 */   // Label 4469: @234588
     /* 234588 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(234630), // Rule ID 2860 //
     /* 234593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 234601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234617 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 234620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234628 */     GIR_RootConstrainSelectedInstOperands,
     /* 234629 */     // GIR_Coverage, 2860,
     /* 234629 */     GIR_EraseRootFromParent_Done,
     /* 234630 */   // Label 4470: @234630
     /* 234630 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(234672), // Rule ID 2861 //
     /* 234635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 234643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234659 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 234662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234670 */     GIR_RootConstrainSelectedInstOperands,
     /* 234671 */     // GIR_Coverage, 2861,
     /* 234671 */     GIR_EraseRootFromParent_Done,
     /* 234672 */   // Label 4471: @234672
     /* 234672 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(234714), // Rule ID 2862 //
     /* 234677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234701 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 234704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234712 */     GIR_RootConstrainSelectedInstOperands,
     /* 234713 */     // GIR_Coverage, 2862,
     /* 234713 */     GIR_EraseRootFromParent_Done,
     /* 234714 */   // Label 4472: @234714
     /* 234714 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(234756), // Rule ID 2863 //
     /* 234719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234743 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 234746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234754 */     GIR_RootConstrainSelectedInstOperands,
     /* 234755 */     // GIR_Coverage, 2863,
     /* 234755 */     GIR_EraseRootFromParent_Done,
     /* 234756 */   // Label 4473: @234756
     /* 234756 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(234798), // Rule ID 2864 //
     /* 234761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 234769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234785 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 234788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234796 */     GIR_RootConstrainSelectedInstOperands,
     /* 234797 */     // GIR_Coverage, 2864,
     /* 234797 */     GIR_EraseRootFromParent_Done,
     /* 234798 */   // Label 4474: @234798
     /* 234798 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(234840), // Rule ID 2875 //
     /* 234803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 234811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 234830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234838 */     GIR_RootConstrainSelectedInstOperands,
     /* 234839 */     // GIR_Coverage, 2875,
     /* 234839 */     GIR_EraseRootFromParent_Done,
     /* 234840 */   // Label 4475: @234840
     /* 234840 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(234882), // Rule ID 2877 //
     /* 234845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 234848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 234853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234869 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 234872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234880 */     GIR_RootConstrainSelectedInstOperands,
     /* 234881 */     // GIR_Coverage, 2877,
     /* 234881 */     GIR_EraseRootFromParent_Done,
     /* 234882 */   // Label 4476: @234882
     /* 234882 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(234924), // Rule ID 2885 //
     /* 234887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1430:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 234914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234922 */     GIR_RootConstrainSelectedInstOperands,
     /* 234923 */     // GIR_Coverage, 2885,
     /* 234923 */     GIR_EraseRootFromParent_Done,
     /* 234924 */   // Label 4477: @234924
     /* 234924 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(234966), // Rule ID 2886 //
     /* 234929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234953 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1430:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 234956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234964 */     GIR_RootConstrainSelectedInstOperands,
     /* 234965 */     // GIR_Coverage, 2886,
     /* 234965 */     GIR_EraseRootFromParent_Done,
     /* 234966 */   // Label 4478: @234966
     /* 234966 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(235008), // Rule ID 2887 //
     /* 234971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 234979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234995 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1430:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 234998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235006 */     GIR_RootConstrainSelectedInstOperands,
     /* 235007 */     // GIR_Coverage, 2887,
     /* 235007 */     GIR_EraseRootFromParent_Done,
     /* 235008 */   // Label 4479: @235008
     /* 235008 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235050), // Rule ID 2891 //
     /* 235013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 235021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235037 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 235040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235048 */     GIR_RootConstrainSelectedInstOperands,
     /* 235049 */     // GIR_Coverage, 2891,
     /* 235049 */     GIR_EraseRootFromParent_Done,
     /* 235050 */   // Label 4480: @235050
     /* 235050 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(235092), // Rule ID 2936 //
     /* 235055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 235063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 235082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235090 */     GIR_RootConstrainSelectedInstOperands,
     /* 235091 */     // GIR_Coverage, 2936,
     /* 235091 */     GIR_EraseRootFromParent_Done,
     /* 235092 */   // Label 4481: @235092
     /* 235092 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(235134), // Rule ID 2937 //
     /* 235097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 235105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 235124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235132 */     GIR_RootConstrainSelectedInstOperands,
     /* 235133 */     // GIR_Coverage, 2937,
     /* 235133 */     GIR_EraseRootFromParent_Done,
     /* 235134 */   // Label 4482: @235134
     /* 235134 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(235176), // Rule ID 2966 //
     /* 235139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 235166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235174 */     GIR_RootConstrainSelectedInstOperands,
     /* 235175 */     // GIR_Coverage, 2966,
     /* 235175 */     GIR_EraseRootFromParent_Done,
     /* 235176 */   // Label 4483: @235176
     /* 235176 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(235218), // Rule ID 2967 //
     /* 235181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 235208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235216 */     GIR_RootConstrainSelectedInstOperands,
     /* 235217 */     // GIR_Coverage, 2967,
     /* 235217 */     GIR_EraseRootFromParent_Done,
     /* 235218 */   // Label 4484: @235218
     /* 235218 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(235260), // Rule ID 2968 //
     /* 235223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 235250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235258 */     GIR_RootConstrainSelectedInstOperands,
     /* 235259 */     // GIR_Coverage, 2968,
     /* 235259 */     GIR_EraseRootFromParent_Done,
     /* 235260 */   // Label 4485: @235260
     /* 235260 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(235302), // Rule ID 2969 //
     /* 235265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 235273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 235292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235300 */     GIR_RootConstrainSelectedInstOperands,
     /* 235301 */     // GIR_Coverage, 2969,
     /* 235301 */     GIR_EraseRootFromParent_Done,
     /* 235302 */   // Label 4486: @235302
     /* 235302 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(235344), // Rule ID 2970 //
     /* 235307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 235334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235342 */     GIR_RootConstrainSelectedInstOperands,
     /* 235343 */     // GIR_Coverage, 2970,
     /* 235343 */     GIR_EraseRootFromParent_Done,
     /* 235344 */   // Label 4487: @235344
     /* 235344 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(235386), // Rule ID 2971 //
     /* 235349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 235376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235384 */     GIR_RootConstrainSelectedInstOperands,
     /* 235385 */     // GIR_Coverage, 2971,
     /* 235385 */     GIR_EraseRootFromParent_Done,
     /* 235386 */   // Label 4488: @235386
     /* 235386 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(235428), // Rule ID 2972 //
     /* 235391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 235399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 235418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235426 */     GIR_RootConstrainSelectedInstOperands,
     /* 235427 */     // GIR_Coverage, 2972,
     /* 235427 */     GIR_EraseRootFromParent_Done,
     /* 235428 */   // Label 4489: @235428
     /* 235428 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(235470), // Rule ID 3002 //
     /* 235433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1724:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 235460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235468 */     GIR_RootConstrainSelectedInstOperands,
     /* 235469 */     // GIR_Coverage, 3002,
     /* 235469 */     GIR_EraseRootFromParent_Done,
     /* 235470 */   // Label 4490: @235470
     /* 235470 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(235512), // Rule ID 3004 //
     /* 235475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1724:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 235502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235510 */     GIR_RootConstrainSelectedInstOperands,
     /* 235511 */     // GIR_Coverage, 3004,
     /* 235511 */     GIR_EraseRootFromParent_Done,
     /* 235512 */   // Label 4491: @235512
     /* 235512 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(235554), // Rule ID 3006 //
     /* 235517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 235544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235552 */     GIR_RootConstrainSelectedInstOperands,
     /* 235553 */     // GIR_Coverage, 3006,
     /* 235553 */     GIR_EraseRootFromParent_Done,
     /* 235554 */   // Label 4492: @235554
     /* 235554 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(235596), // Rule ID 3008 //
     /* 235559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 235567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1724:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 235586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235594 */     GIR_RootConstrainSelectedInstOperands,
     /* 235595 */     // GIR_Coverage, 3008,
     /* 235595 */     GIR_EraseRootFromParent_Done,
     /* 235596 */   // Label 4493: @235596
     /* 235596 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(235638), // Rule ID 3010 //
     /* 235601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 235628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235636 */     GIR_RootConstrainSelectedInstOperands,
     /* 235637 */     // GIR_Coverage, 3010,
     /* 235637 */     GIR_EraseRootFromParent_Done,
     /* 235638 */   // Label 4494: @235638
     /* 235638 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(235680), // Rule ID 3011 //
     /* 235643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 235670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235678 */     GIR_RootConstrainSelectedInstOperands,
     /* 235679 */     // GIR_Coverage, 3011,
     /* 235679 */     GIR_EraseRootFromParent_Done,
     /* 235680 */   // Label 4495: @235680
     /* 235680 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(235722), // Rule ID 3012 //
     /* 235685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 235693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 235712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235720 */     GIR_RootConstrainSelectedInstOperands,
     /* 235721 */     // GIR_Coverage, 3012,
     /* 235721 */     GIR_EraseRootFromParent_Done,
     /* 235722 */   // Label 4496: @235722
     /* 235722 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(235764), // Rule ID 3013 //
     /* 235727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 235735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 235754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235762 */     GIR_RootConstrainSelectedInstOperands,
     /* 235763 */     // GIR_Coverage, 3013,
     /* 235763 */     GIR_EraseRootFromParent_Done,
     /* 235764 */   // Label 4497: @235764
     /* 235764 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(235806), // Rule ID 3014 //
     /* 235769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 235796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235804 */     GIR_RootConstrainSelectedInstOperands,
     /* 235805 */     // GIR_Coverage, 3014,
     /* 235805 */     GIR_EraseRootFromParent_Done,
     /* 235806 */   // Label 4498: @235806
     /* 235806 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(235848), // Rule ID 3015 //
     /* 235811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 235838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235846 */     GIR_RootConstrainSelectedInstOperands,
     /* 235847 */     // GIR_Coverage, 3015,
     /* 235847 */     GIR_EraseRootFromParent_Done,
     /* 235848 */   // Label 4499: @235848
     /* 235848 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(235890), // Rule ID 3016 //
     /* 235853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 235880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235888 */     GIR_RootConstrainSelectedInstOperands,
     /* 235889 */     // GIR_Coverage, 3016,
     /* 235889 */     GIR_EraseRootFromParent_Done,
     /* 235890 */   // Label 4500: @235890
     /* 235890 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(235932), // Rule ID 3017 //
     /* 235895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 235903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 235922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235930 */     GIR_RootConstrainSelectedInstOperands,
     /* 235931 */     // GIR_Coverage, 3017,
     /* 235931 */     GIR_EraseRootFromParent_Done,
     /* 235932 */   // Label 4501: @235932
     /* 235932 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(235974), // Rule ID 3034 //
     /* 235937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1359:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 235964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235972 */     GIR_RootConstrainSelectedInstOperands,
     /* 235973 */     // GIR_Coverage, 3034,
     /* 235973 */     GIR_EraseRootFromParent_Done,
     /* 235974 */   // Label 4502: @235974
     /* 235974 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236016), // Rule ID 3035 //
     /* 235979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 235987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1359:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 236006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236014 */     GIR_RootConstrainSelectedInstOperands,
     /* 236015 */     // GIR_Coverage, 3035,
     /* 236015 */     GIR_EraseRootFromParent_Done,
     /* 236016 */   // Label 4503: @236016
     /* 236016 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236058), // Rule ID 3036 //
     /* 236021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 236029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1359:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 236048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236056 */     GIR_RootConstrainSelectedInstOperands,
     /* 236057 */     // GIR_Coverage, 3036,
     /* 236057 */     GIR_EraseRootFromParent_Done,
     /* 236058 */   // Label 4504: @236058
     /* 236058 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(236100), // Rule ID 3037 //
     /* 236063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 236071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1359:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 236090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236098 */     GIR_RootConstrainSelectedInstOperands,
     /* 236099 */     // GIR_Coverage, 3037,
     /* 236099 */     GIR_EraseRootFromParent_Done,
     /* 236100 */   // Label 4505: @236100
     /* 236100 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(236142), // Rule ID 3061 //
     /* 236105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 236132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236140 */     GIR_RootConstrainSelectedInstOperands,
     /* 236141 */     // GIR_Coverage, 3061,
     /* 236141 */     GIR_EraseRootFromParent_Done,
     /* 236142 */   // Label 4506: @236142
     /* 236142 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(236184), // Rule ID 3063 //
     /* 236147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 236174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236182 */     GIR_RootConstrainSelectedInstOperands,
     /* 236183 */     // GIR_Coverage, 3063,
     /* 236183 */     GIR_EraseRootFromParent_Done,
     /* 236184 */   // Label 4507: @236184
     /* 236184 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(236226), // Rule ID 3065 //
     /* 236189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 236216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236224 */     GIR_RootConstrainSelectedInstOperands,
     /* 236225 */     // GIR_Coverage, 3065,
     /* 236225 */     GIR_EraseRootFromParent_Done,
     /* 236226 */   // Label 4508: @236226
     /* 236226 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(236268), // Rule ID 3067 //
     /* 236231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 236239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236255 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 236258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236266 */     GIR_RootConstrainSelectedInstOperands,
     /* 236267 */     // GIR_Coverage, 3067,
     /* 236267 */     GIR_EraseRootFromParent_Done,
     /* 236268 */   // Label 4509: @236268
     /* 236268 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(236310), // Rule ID 3069 //
     /* 236273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 236300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236308 */     GIR_RootConstrainSelectedInstOperands,
     /* 236309 */     // GIR_Coverage, 3069,
     /* 236309 */     GIR_EraseRootFromParent_Done,
     /* 236310 */   // Label 4510: @236310
     /* 236310 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(236352), // Rule ID 3070 //
     /* 236315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 236342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236350 */     GIR_RootConstrainSelectedInstOperands,
     /* 236351 */     // GIR_Coverage, 3070,
     /* 236351 */     GIR_EraseRootFromParent_Done,
     /* 236352 */   // Label 4511: @236352
     /* 236352 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(236394), // Rule ID 3071 //
     /* 236357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 236365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 236384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236392 */     GIR_RootConstrainSelectedInstOperands,
     /* 236393 */     // GIR_Coverage, 3071,
     /* 236393 */     GIR_EraseRootFromParent_Done,
     /* 236394 */   // Label 4512: @236394
     /* 236394 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(236436), // Rule ID 3072 //
     /* 236399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 236407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 236426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236434 */     GIR_RootConstrainSelectedInstOperands,
     /* 236435 */     // GIR_Coverage, 3072,
     /* 236435 */     GIR_EraseRootFromParent_Done,
     /* 236436 */   // Label 4513: @236436
     /* 236436 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(236478), // Rule ID 3073 //
     /* 236441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 236449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 236468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236476 */     GIR_RootConstrainSelectedInstOperands,
     /* 236477 */     // GIR_Coverage, 3073,
     /* 236477 */     GIR_EraseRootFromParent_Done,
     /* 236478 */   // Label 4514: @236478
     /* 236478 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(236520), // Rule ID 3083 //
     /* 236483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 236510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236518 */     GIR_RootConstrainSelectedInstOperands,
     /* 236519 */     // GIR_Coverage, 3083,
     /* 236519 */     GIR_EraseRootFromParent_Done,
     /* 236520 */   // Label 4515: @236520
     /* 236520 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(236562), // Rule ID 3084 //
     /* 236525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 236552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236560 */     GIR_RootConstrainSelectedInstOperands,
     /* 236561 */     // GIR_Coverage, 3084,
     /* 236561 */     GIR_EraseRootFromParent_Done,
     /* 236562 */   // Label 4516: @236562
     /* 236562 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(236604), // Rule ID 3085 //
     /* 236567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 236575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 236594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236602 */     GIR_RootConstrainSelectedInstOperands,
     /* 236603 */     // GIR_Coverage, 3085,
     /* 236603 */     GIR_EraseRootFromParent_Done,
     /* 236604 */   // Label 4517: @236604
     /* 236604 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(236646), // Rule ID 3102 //
     /* 236609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 236626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 236633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 236636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236644 */     GIR_RootConstrainSelectedInstOperands,
     /* 236645 */     // GIR_Coverage, 3102,
     /* 236645 */     GIR_EraseRootFromParent_Done,
     /* 236646 */   // Label 4518: @236646
     /* 236646 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(236688), // Rule ID 3103 //
     /* 236651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236675 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 236675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 236678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236686 */     GIR_RootConstrainSelectedInstOperands,
     /* 236687 */     // GIR_Coverage, 3103,
     /* 236687 */     GIR_EraseRootFromParent_Done,
     /* 236688 */   // Label 4519: @236688
     /* 236688 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(236730), // Rule ID 3104 //
     /* 236693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 236717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 236720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236728 */     GIR_RootConstrainSelectedInstOperands,
     /* 236729 */     // GIR_Coverage, 3104,
     /* 236729 */     GIR_EraseRootFromParent_Done,
     /* 236730 */   // Label 4520: @236730
     /* 236730 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(236772), // Rule ID 3105 //
     /* 236735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 236743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 236759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 236762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 236766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 236768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 236770 */     GIR_RootConstrainSelectedInstOperands,
     /* 236771 */     // GIR_Coverage, 3105,
     /* 236771 */     GIR_EraseRootFromParent_Done,
     /* 236772 */   // Label 4521: @236772
     /* 236772 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(236814), // Rule ID 3140 //
     /* 236777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1358:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236812 */     GIR_RootConstrainSelectedInstOperands,
     /* 236813 */     // GIR_Coverage, 3140,
     /* 236813 */     GIR_EraseRootFromParent_Done,
     /* 236814 */   // Label 4522: @236814
     /* 236814 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(236856), // Rule ID 3142 //
     /* 236819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1358:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236854 */     GIR_RootConstrainSelectedInstOperands,
     /* 236855 */     // GIR_Coverage, 3142,
     /* 236855 */     GIR_EraseRootFromParent_Done,
     /* 236856 */   // Label 4523: @236856
     /* 236856 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(236898), // Rule ID 3144 //
     /* 236861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1358:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236896 */     GIR_RootConstrainSelectedInstOperands,
     /* 236897 */     // GIR_Coverage, 3144,
     /* 236897 */     GIR_EraseRootFromParent_Done,
     /* 236898 */   // Label 4524: @236898
     /* 236898 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(236940), // Rule ID 3146 //
     /* 236903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 236911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1358:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 236930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236938 */     GIR_RootConstrainSelectedInstOperands,
     /* 236939 */     // GIR_Coverage, 3146,
     /* 236939 */     GIR_EraseRootFromParent_Done,
     /* 236940 */   // Label 4525: @236940
     /* 236940 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(236985), // Rule ID 3185 //
     /* 236945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 236953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 236956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 236969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1322:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 236972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 236974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 236983 */     GIR_RootConstrainSelectedInstOperands,
     /* 236984 */     // GIR_Coverage, 3185,
     /* 236984 */     GIR_EraseRootFromParent_Done,
     /* 236985 */   // Label 4526: @236985
     /* 236985 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237030), // Rule ID 3186 //
     /* 236990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 236998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1322:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 237017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237028 */     GIR_RootConstrainSelectedInstOperands,
     /* 237029 */     // GIR_Coverage, 3186,
     /* 237029 */     GIR_EraseRootFromParent_Done,
     /* 237030 */   // Label 4527: @237030
     /* 237030 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(237075), // Rule ID 3187 //
     /* 237035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 237043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1322:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 237062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237073 */     GIR_RootConstrainSelectedInstOperands,
     /* 237074 */     // GIR_Coverage, 3187,
     /* 237074 */     GIR_EraseRootFromParent_Done,
     /* 237075 */   // Label 4528: @237075
     /* 237075 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(237120), // Rule ID 3188 //
     /* 237080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 237088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 237107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237118 */     GIR_RootConstrainSelectedInstOperands,
     /* 237119 */     // GIR_Coverage, 3188,
     /* 237119 */     GIR_EraseRootFromParent_Done,
     /* 237120 */   // Label 4529: @237120
     /* 237120 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(237165), // Rule ID 3189 //
     /* 237125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 237133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237149 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 237152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237163 */     GIR_RootConstrainSelectedInstOperands,
     /* 237164 */     // GIR_Coverage, 3189,
     /* 237164 */     GIR_EraseRootFromParent_Done,
     /* 237165 */   // Label 4530: @237165
     /* 237165 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(237210), // Rule ID 3190 //
     /* 237170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 237178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 237197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237208 */     GIR_RootConstrainSelectedInstOperands,
     /* 237209 */     // GIR_Coverage, 3190,
     /* 237209 */     GIR_EraseRootFromParent_Done,
     /* 237210 */   // Label 4531: @237210
     /* 237210 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(237252), // Rule ID 3245 //
     /* 237215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237239 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 237242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237250 */     GIR_RootConstrainSelectedInstOperands,
     /* 237251 */     // GIR_Coverage, 3245,
     /* 237251 */     GIR_EraseRootFromParent_Done,
     /* 237252 */   // Label 4532: @237252
     /* 237252 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(237294), // Rule ID 3246 //
     /* 237257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237281 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 237284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237292 */     GIR_RootConstrainSelectedInstOperands,
     /* 237293 */     // GIR_Coverage, 3246,
     /* 237293 */     GIR_EraseRootFromParent_Done,
     /* 237294 */   // Label 4533: @237294
     /* 237294 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(237336), // Rule ID 3247 //
     /* 237299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 237307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 237310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237323 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 237326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237334 */     GIR_RootConstrainSelectedInstOperands,
     /* 237335 */     // GIR_Coverage, 3247,
     /* 237335 */     GIR_EraseRootFromParent_Done,
     /* 237336 */   // Label 4534: @237336
     /* 237336 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(237378), // Rule ID 3299 //
     /* 237341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237365 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 237368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237376 */     GIR_RootConstrainSelectedInstOperands,
     /* 237377 */     // GIR_Coverage, 3299,
     /* 237377 */     GIR_EraseRootFromParent_Done,
     /* 237378 */   // Label 4535: @237378
     /* 237378 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(237420), // Rule ID 3300 //
     /* 237383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 237410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237418 */     GIR_RootConstrainSelectedInstOperands,
     /* 237419 */     // GIR_Coverage, 3300,
     /* 237419 */     GIR_EraseRootFromParent_Done,
     /* 237420 */   // Label 4536: @237420
     /* 237420 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(237462), // Rule ID 3301 //
     /* 237425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 237452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237460 */     GIR_RootConstrainSelectedInstOperands,
     /* 237461 */     // GIR_Coverage, 3301,
     /* 237461 */     GIR_EraseRootFromParent_Done,
     /* 237462 */   // Label 4537: @237462
     /* 237462 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(237504), // Rule ID 3302 //
     /* 237467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 237475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 237494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237502 */     GIR_RootConstrainSelectedInstOperands,
     /* 237503 */     // GIR_Coverage, 3302,
     /* 237503 */     GIR_EraseRootFromParent_Done,
     /* 237504 */   // Label 4538: @237504
     /* 237504 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(237546), // Rule ID 3311 //
     /* 237509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237544 */     GIR_RootConstrainSelectedInstOperands,
     /* 237545 */     // GIR_Coverage, 3311,
     /* 237545 */     GIR_EraseRootFromParent_Done,
     /* 237546 */   // Label 4539: @237546
     /* 237546 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(237588), // Rule ID 3312 //
     /* 237551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237586 */     GIR_RootConstrainSelectedInstOperands,
     /* 237587 */     // GIR_Coverage, 3312,
     /* 237587 */     GIR_EraseRootFromParent_Done,
     /* 237588 */   // Label 4540: @237588
     /* 237588 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(237630), // Rule ID 3313 //
     /* 237593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 237601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 237620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237628 */     GIR_RootConstrainSelectedInstOperands,
     /* 237629 */     // GIR_Coverage, 3313,
     /* 237629 */     GIR_EraseRootFromParent_Done,
     /* 237630 */   // Label 4541: @237630
     /* 237630 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(237672), // Rule ID 3352 //
     /* 237635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 237662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237670 */     GIR_RootConstrainSelectedInstOperands,
     /* 237671 */     // GIR_Coverage, 3352,
     /* 237671 */     GIR_EraseRootFromParent_Done,
     /* 237672 */   // Label 4542: @237672
     /* 237672 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(237714), // Rule ID 3353 //
     /* 237677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 237704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237712 */     GIR_RootConstrainSelectedInstOperands,
     /* 237713 */     // GIR_Coverage, 3353,
     /* 237713 */     GIR_EraseRootFromParent_Done,
     /* 237714 */   // Label 4543: @237714
     /* 237714 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(237756), // Rule ID 3354 //
     /* 237719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 237746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237754 */     GIR_RootConstrainSelectedInstOperands,
     /* 237755 */     // GIR_Coverage, 3354,
     /* 237755 */     GIR_EraseRootFromParent_Done,
     /* 237756 */   // Label 4544: @237756
     /* 237756 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(237798), // Rule ID 3355 //
     /* 237761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 237788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237796 */     GIR_RootConstrainSelectedInstOperands,
     /* 237797 */     // GIR_Coverage, 3355,
     /* 237797 */     GIR_EraseRootFromParent_Done,
     /* 237798 */   // Label 4545: @237798
     /* 237798 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(237840), // Rule ID 3356 //
     /* 237803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 237830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237838 */     GIR_RootConstrainSelectedInstOperands,
     /* 237839 */     // GIR_Coverage, 3356,
     /* 237839 */     GIR_EraseRootFromParent_Done,
     /* 237840 */   // Label 4546: @237840
     /* 237840 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(237882), // Rule ID 3357 //
     /* 237845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237869 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 237872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237880 */     GIR_RootConstrainSelectedInstOperands,
     /* 237881 */     // GIR_Coverage, 3357,
     /* 237881 */     GIR_EraseRootFromParent_Done,
     /* 237882 */   // Label 4547: @237882
     /* 237882 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(237924), // Rule ID 3358 //
     /* 237887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 237895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237911 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 237914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237922 */     GIR_RootConstrainSelectedInstOperands,
     /* 237923 */     // GIR_Coverage, 3358,
     /* 237923 */     GIR_EraseRootFromParent_Done,
     /* 237924 */   // Label 4548: @237924
     /* 237924 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(237966), // Rule ID 3441 //
     /* 237929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 237937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237953 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 237956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237964 */     GIR_RootConstrainSelectedInstOperands,
     /* 237965 */     // GIR_Coverage, 3441,
     /* 237965 */     GIR_EraseRootFromParent_Done,
     /* 237966 */   // Label 4549: @237966
     /* 237966 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238008), // Rule ID 3442 //
     /* 237971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 237979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238006 */     GIR_RootConstrainSelectedInstOperands,
     /* 238007 */     // GIR_Coverage, 3442,
     /* 238007 */     GIR_EraseRootFromParent_Done,
     /* 238008 */   // Label 4550: @238008
     /* 238008 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238050), // Rule ID 3443 //
     /* 238013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 238021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 238030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 238033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 238037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238048 */     GIR_RootConstrainSelectedInstOperands,
     /* 238049 */     // GIR_Coverage, 3443,
     /* 238049 */     GIR_EraseRootFromParent_Done,
     /* 238050 */   // Label 4551: @238050
     /* 238050 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(238095), // Rule ID 3445 //
     /* 238055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 238063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238093 */     GIR_RootConstrainSelectedInstOperands,
     /* 238094 */     // GIR_Coverage, 3445,
     /* 238094 */     GIR_EraseRootFromParent_Done,
     /* 238095 */   // Label 4552: @238095
     /* 238095 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(238140), // Rule ID 3446 //
     /* 238100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 238108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 238127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238138 */     GIR_RootConstrainSelectedInstOperands,
     /* 238139 */     // GIR_Coverage, 3446,
     /* 238139 */     GIR_EraseRootFromParent_Done,
     /* 238140 */   // Label 4553: @238140
     /* 238140 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(238182), // Rule ID 3447 //
     /* 238145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 238153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1552:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 238172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238180 */     GIR_RootConstrainSelectedInstOperands,
     /* 238181 */     // GIR_Coverage, 3447,
     /* 238181 */     GIR_EraseRootFromParent_Done,
     /* 238182 */   // Label 4554: @238182
     /* 238182 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(238224), // Rule ID 3448 //
     /* 238187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 238195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238222 */     GIR_RootConstrainSelectedInstOperands,
     /* 238223 */     // GIR_Coverage, 3448,
     /* 238223 */     GIR_EraseRootFromParent_Done,
     /* 238224 */   // Label 4555: @238224
     /* 238224 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(238266), // Rule ID 3453 //
     /* 238229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 238232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 238237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238264 */     GIR_RootConstrainSelectedInstOperands,
     /* 238265 */     // GIR_Coverage, 3453,
     /* 238265 */     GIR_EraseRootFromParent_Done,
     /* 238266 */   // Label 4556: @238266
     /* 238266 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(238308), // Rule ID 3492 //
     /* 238271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 238298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238306 */     GIR_RootConstrainSelectedInstOperands,
     /* 238307 */     // GIR_Coverage, 3492,
     /* 238307 */     GIR_EraseRootFromParent_Done,
     /* 238308 */   // Label 4557: @238308
     /* 238308 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(238350), // Rule ID 3494 //
     /* 238313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238337 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 238340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238348 */     GIR_RootConstrainSelectedInstOperands,
     /* 238349 */     // GIR_Coverage, 3494,
     /* 238349 */     GIR_EraseRootFromParent_Done,
     /* 238350 */   // Label 4558: @238350
     /* 238350 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(238392), // Rule ID 3496 //
     /* 238355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 238363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 238382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238390 */     GIR_RootConstrainSelectedInstOperands,
     /* 238391 */     // GIR_Coverage, 3496,
     /* 238391 */     GIR_EraseRootFromParent_Done,
     /* 238392 */   // Label 4559: @238392
     /* 238392 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(238434), // Rule ID 3498 //
     /* 238397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 238400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 238405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 238424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238432 */     GIR_RootConstrainSelectedInstOperands,
     /* 238433 */     // GIR_Coverage, 3498,
     /* 238433 */     GIR_EraseRootFromParent_Done,
     /* 238434 */   // Label 4560: @238434
     /* 238434 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(238476), // Rule ID 3625 //
     /* 238439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 238466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238474 */     GIR_RootConstrainSelectedInstOperands,
     /* 238475 */     // GIR_Coverage, 3625,
     /* 238475 */     GIR_EraseRootFromParent_Done,
     /* 238476 */   // Label 4561: @238476
     /* 238476 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(238518), // Rule ID 3627 //
     /* 238481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 238508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238516 */     GIR_RootConstrainSelectedInstOperands,
     /* 238517 */     // GIR_Coverage, 3627,
     /* 238517 */     GIR_EraseRootFromParent_Done,
     /* 238518 */   // Label 4562: @238518
     /* 238518 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(238560), // Rule ID 3629 //
     /* 238523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 238550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238558 */     GIR_RootConstrainSelectedInstOperands,
     /* 238559 */     // GIR_Coverage, 3629,
     /* 238559 */     GIR_EraseRootFromParent_Done,
     /* 238560 */   // Label 4563: @238560
     /* 238560 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(238602), // Rule ID 3631 //
     /* 238565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 238573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 238592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238600 */     GIR_RootConstrainSelectedInstOperands,
     /* 238601 */     // GIR_Coverage, 3631,
     /* 238601 */     GIR_EraseRootFromParent_Done,
     /* 238602 */   // Label 4564: @238602
     /* 238602 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(238644), // Rule ID 7534 //
     /* 238607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238642 */     GIR_RootConstrainSelectedInstOperands,
     /* 238643 */     // GIR_Coverage, 7534,
     /* 238643 */     GIR_EraseRootFromParent_Done,
     /* 238644 */   // Label 4565: @238644
     /* 238644 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(238686), // Rule ID 7536 //
     /* 238649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1912:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 238676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238684 */     GIR_RootConstrainSelectedInstOperands,
     /* 238685 */     // GIR_Coverage, 7536,
     /* 238685 */     GIR_EraseRootFromParent_Done,
     /* 238686 */   // Label 4566: @238686
     /* 238686 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(238728), // Rule ID 7538 //
     /* 238691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1912:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 238718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238726 */     GIR_RootConstrainSelectedInstOperands,
     /* 238727 */     // GIR_Coverage, 7538,
     /* 238727 */     GIR_EraseRootFromParent_Done,
     /* 238728 */   // Label 4567: @238728
     /* 238728 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(238770), // Rule ID 7540 //
     /* 238733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 238741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1912:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 238760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238768 */     GIR_RootConstrainSelectedInstOperands,
     /* 238769 */     // GIR_Coverage, 7540,
     /* 238769 */     GIR_EraseRootFromParent_Done,
     /* 238770 */   // Label 4568: @238770
     /* 238770 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(238812), // Rule ID 7558 //
     /* 238775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 238802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238810 */     GIR_RootConstrainSelectedInstOperands,
     /* 238811 */     // GIR_Coverage, 7558,
     /* 238811 */     GIR_EraseRootFromParent_Done,
     /* 238812 */   // Label 4569: @238812
     /* 238812 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(238854), // Rule ID 7559 //
     /* 238817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1297:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 238844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238852 */     GIR_RootConstrainSelectedInstOperands,
     /* 238853 */     // GIR_Coverage, 7559,
     /* 238853 */     GIR_EraseRootFromParent_Done,
     /* 238854 */   // Label 4570: @238854
     /* 238854 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(238896), // Rule ID 7560 //
     /* 238859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1297:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238894 */     GIR_RootConstrainSelectedInstOperands,
     /* 238895 */     // GIR_Coverage, 7560,
     /* 238895 */     GIR_EraseRootFromParent_Done,
     /* 238896 */   // Label 4571: @238896
     /* 238896 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(238938), // Rule ID 7561 //
     /* 238901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 238909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1297:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238936 */     GIR_RootConstrainSelectedInstOperands,
     /* 238937 */     // GIR_Coverage, 7561,
     /* 238937 */     GIR_EraseRootFromParent_Done,
     /* 238938 */   // Label 4572: @238938
     /* 238938 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(238980), // Rule ID 7674 //
     /* 238943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 238970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238978 */     GIR_RootConstrainSelectedInstOperands,
     /* 238979 */     // GIR_Coverage, 7674,
     /* 238979 */     GIR_EraseRootFromParent_Done,
     /* 238980 */   // Label 4573: @238980
     /* 238980 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239022), // Rule ID 7675 //
     /* 238985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 238993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239020 */     GIR_RootConstrainSelectedInstOperands,
     /* 239021 */     // GIR_Coverage, 7675,
     /* 239021 */     GIR_EraseRootFromParent_Done,
     /* 239022 */   // Label 4574: @239022
     /* 239022 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(239064), // Rule ID 7676 //
     /* 239027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 239035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 239054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239062 */     GIR_RootConstrainSelectedInstOperands,
     /* 239063 */     // GIR_Coverage, 7676,
     /* 239063 */     GIR_EraseRootFromParent_Done,
     /* 239064 */   // Label 4575: @239064
     /* 239064 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(239106), // Rule ID 7677 //
     /* 239069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 239077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239104 */     GIR_RootConstrainSelectedInstOperands,
     /* 239105 */     // GIR_Coverage, 7677,
     /* 239105 */     GIR_EraseRootFromParent_Done,
     /* 239106 */   // Label 4576: @239106
     /* 239106 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(239148), // Rule ID 7678 //
     /* 239111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1997:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239146 */     GIR_RootConstrainSelectedInstOperands,
     /* 239147 */     // GIR_Coverage, 7678,
     /* 239147 */     GIR_EraseRootFromParent_Done,
     /* 239148 */   // Label 4577: @239148
     /* 239148 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(239190), // Rule ID 7679 //
     /* 239153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 239180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239188 */     GIR_RootConstrainSelectedInstOperands,
     /* 239189 */     // GIR_Coverage, 7679,
     /* 239189 */     GIR_EraseRootFromParent_Done,
     /* 239190 */   // Label 4578: @239190
     /* 239190 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(239232), // Rule ID 7680 //
     /* 239195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239230 */     GIR_RootConstrainSelectedInstOperands,
     /* 239231 */     // GIR_Coverage, 7680,
     /* 239231 */     GIR_EraseRootFromParent_Done,
     /* 239232 */   // Label 4579: @239232
     /* 239232 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(239274), // Rule ID 7681 //
     /* 239237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 239245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 239264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239272 */     GIR_RootConstrainSelectedInstOperands,
     /* 239273 */     // GIR_Coverage, 7681,
     /* 239273 */     GIR_EraseRootFromParent_Done,
     /* 239274 */   // Label 4580: @239274
     /* 239274 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(239316), // Rule ID 7690 //
     /* 239279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 239287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239314 */     GIR_RootConstrainSelectedInstOperands,
     /* 239315 */     // GIR_Coverage, 7690,
     /* 239315 */     GIR_EraseRootFromParent_Done,
     /* 239316 */   // Label 4581: @239316
     /* 239316 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(239358), // Rule ID 7691 //
     /* 239321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 239329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239356 */     GIR_RootConstrainSelectedInstOperands,
     /* 239357 */     // GIR_Coverage, 7691,
     /* 239357 */     GIR_EraseRootFromParent_Done,
     /* 239358 */   // Label 4582: @239358
     /* 239358 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(239400), // Rule ID 7692 //
     /* 239363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 239371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1715:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 239390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239398 */     GIR_RootConstrainSelectedInstOperands,
     /* 239399 */     // GIR_Coverage, 7692,
     /* 239399 */     GIR_EraseRootFromParent_Done,
     /* 239400 */   // Label 4583: @239400
     /* 239400 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(239442), // Rule ID 7693 //
     /* 239405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 239413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1715:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239440 */     GIR_RootConstrainSelectedInstOperands,
     /* 239441 */     // GIR_Coverage, 7693,
     /* 239441 */     GIR_EraseRootFromParent_Done,
     /* 239442 */   // Label 4584: @239442
     /* 239442 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(239484), // Rule ID 7694 //
     /* 239447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 239455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 239474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239482 */     GIR_RootConstrainSelectedInstOperands,
     /* 239483 */     // GIR_Coverage, 7694,
     /* 239483 */     GIR_EraseRootFromParent_Done,
     /* 239484 */   // Label 4585: @239484
     /* 239484 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(239526), // Rule ID 7695 //
     /* 239489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 239497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239524 */     GIR_RootConstrainSelectedInstOperands,
     /* 239525 */     // GIR_Coverage, 7695,
     /* 239525 */     GIR_EraseRootFromParent_Done,
     /* 239526 */   // Label 4586: @239526
     /* 239526 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(239568), // Rule ID 7784 //
     /* 239531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 239555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 239558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239566 */     GIR_RootConstrainSelectedInstOperands,
     /* 239567 */     // GIR_Coverage, 7784,
     /* 239567 */     GIR_EraseRootFromParent_Done,
     /* 239568 */   // Label 4587: @239568
     /* 239568 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(239610), // Rule ID 7785 //
     /* 239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 239597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239608 */     GIR_RootConstrainSelectedInstOperands,
     /* 239609 */     // GIR_Coverage, 7785,
     /* 239609 */     GIR_EraseRootFromParent_Done,
     /* 239610 */   // Label 4588: @239610
     /* 239610 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(239652), // Rule ID 7786 //
     /* 239615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 239639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239650 */     GIR_RootConstrainSelectedInstOperands,
     /* 239651 */     // GIR_Coverage, 7786,
     /* 239651 */     GIR_EraseRootFromParent_Done,
     /* 239652 */   // Label 4589: @239652
     /* 239652 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(239694), // Rule ID 7787 //
     /* 239657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 239665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 239681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 239684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239692 */     GIR_RootConstrainSelectedInstOperands,
     /* 239693 */     // GIR_Coverage, 7787,
     /* 239693 */     GIR_EraseRootFromParent_Done,
     /* 239694 */   // Label 4590: @239694
     /* 239694 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(239736), // Rule ID 7796 //
     /* 239699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 239723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 239726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239734 */     GIR_RootConstrainSelectedInstOperands,
     /* 239735 */     // GIR_Coverage, 7796,
     /* 239735 */     GIR_EraseRootFromParent_Done,
     /* 239736 */   // Label 4591: @239736
     /* 239736 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(239778), // Rule ID 7797 //
     /* 239741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 239765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239776 */     GIR_RootConstrainSelectedInstOperands,
     /* 239777 */     // GIR_Coverage, 7797,
     /* 239777 */     GIR_EraseRootFromParent_Done,
     /* 239778 */   // Label 4592: @239778
     /* 239778 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(239820), // Rule ID 7798 //
     /* 239783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 239807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239818 */     GIR_RootConstrainSelectedInstOperands,
     /* 239819 */     // GIR_Coverage, 7798,
     /* 239819 */     GIR_EraseRootFromParent_Done,
     /* 239820 */   // Label 4593: @239820
     /* 239820 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(239862), // Rule ID 7799 //
     /* 239825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 239833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 239849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 239852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 239856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 239858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 239860 */     GIR_RootConstrainSelectedInstOperands,
     /* 239861 */     // GIR_Coverage, 7799,
     /* 239861 */     GIR_EraseRootFromParent_Done,
     /* 239862 */   // Label 4594: @239862
     /* 239862 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(239904), // Rule ID 7878 //
     /* 239867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239902 */     GIR_RootConstrainSelectedInstOperands,
     /* 239903 */     // GIR_Coverage, 7878,
     /* 239903 */     GIR_EraseRootFromParent_Done,
     /* 239904 */   // Label 4595: @239904
     /* 239904 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(239946), // Rule ID 7879 //
     /* 239909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 239936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239944 */     GIR_RootConstrainSelectedInstOperands,
     /* 239945 */     // GIR_Coverage, 7879,
     /* 239945 */     GIR_EraseRootFromParent_Done,
     /* 239946 */   // Label 4596: @239946
     /* 239946 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(239988), // Rule ID 7880 //
     /* 239951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 239959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239986 */     GIR_RootConstrainSelectedInstOperands,
     /* 239987 */     // GIR_Coverage, 7880,
     /* 239987 */     GIR_EraseRootFromParent_Done,
     /* 239988 */   // Label 4597: @239988
     /* 239988 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240030), // Rule ID 7881 //
     /* 239993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 240001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 240020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240028 */     GIR_RootConstrainSelectedInstOperands,
     /* 240029 */     // GIR_Coverage, 7881,
     /* 240029 */     GIR_EraseRootFromParent_Done,
     /* 240030 */   // Label 4598: @240030
     /* 240030 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(240072), // Rule ID 7882 //
     /* 240035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 240043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 240062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240070 */     GIR_RootConstrainSelectedInstOperands,
     /* 240071 */     // GIR_Coverage, 7882,
     /* 240071 */     GIR_EraseRootFromParent_Done,
     /* 240072 */   // Label 4599: @240072
     /* 240072 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(240114), // Rule ID 7883 //
     /* 240077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 240085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 240104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240112 */     GIR_RootConstrainSelectedInstOperands,
     /* 240113 */     // GIR_Coverage, 7883,
     /* 240113 */     GIR_EraseRootFromParent_Done,
     /* 240114 */   // Label 4600: @240114
     /* 240114 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(240156), // Rule ID 7884 //
     /* 240119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 240127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 240146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240154 */     GIR_RootConstrainSelectedInstOperands,
     /* 240155 */     // GIR_Coverage, 7884,
     /* 240155 */     GIR_EraseRootFromParent_Done,
     /* 240156 */   // Label 4601: @240156
     /* 240156 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(240198), // Rule ID 7885 //
     /* 240161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 240169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240196 */     GIR_RootConstrainSelectedInstOperands,
     /* 240197 */     // GIR_Coverage, 7885,
     /* 240197 */     GIR_EraseRootFromParent_Done,
     /* 240198 */   // Label 4602: @240198
     /* 240198 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(240240), // Rule ID 8081 //
     /* 240203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 240230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240238 */     GIR_RootConstrainSelectedInstOperands,
     /* 240239 */     // GIR_Coverage, 8081,
     /* 240239 */     GIR_EraseRootFromParent_Done,
     /* 240240 */   // Label 4603: @240240
     /* 240240 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(240282), // Rule ID 8083 //
     /* 240245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 240272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240280 */     GIR_RootConstrainSelectedInstOperands,
     /* 240281 */     // GIR_Coverage, 8083,
     /* 240281 */     GIR_EraseRootFromParent_Done,
     /* 240282 */   // Label 4604: @240282
     /* 240282 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(240324), // Rule ID 8085 //
     /* 240287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 240295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 240314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240322 */     GIR_RootConstrainSelectedInstOperands,
     /* 240323 */     // GIR_Coverage, 8085,
     /* 240323 */     GIR_EraseRootFromParent_Done,
     /* 240324 */   // Label 4605: @240324
     /* 240324 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(240366), // Rule ID 8093 //
     /* 240329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240353 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 240356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240364 */     GIR_RootConstrainSelectedInstOperands,
     /* 240365 */     // GIR_Coverage, 8093,
     /* 240365 */     GIR_EraseRootFromParent_Done,
     /* 240366 */   // Label 4606: @240366
     /* 240366 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(240408), // Rule ID 8095 //
     /* 240371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240395 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 240398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240406 */     GIR_RootConstrainSelectedInstOperands,
     /* 240407 */     // GIR_Coverage, 8095,
     /* 240407 */     GIR_EraseRootFromParent_Done,
     /* 240408 */   // Label 4607: @240408
     /* 240408 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(240450), // Rule ID 8097 //
     /* 240413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 240421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 240440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240448 */     GIR_RootConstrainSelectedInstOperands,
     /* 240449 */     // GIR_Coverage, 8097,
     /* 240449 */     GIR_EraseRootFromParent_Done,
     /* 240450 */   // Label 4608: @240450
     /* 240450 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(240492), // Rule ID 8135 //
     /* 240455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240479 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 240482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240490 */     GIR_RootConstrainSelectedInstOperands,
     /* 240491 */     // GIR_Coverage, 8135,
     /* 240491 */     GIR_EraseRootFromParent_Done,
     /* 240492 */   // Label 4609: @240492
     /* 240492 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(240534), // Rule ID 8136 //
     /* 240497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240521 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 240524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240532 */     GIR_RootConstrainSelectedInstOperands,
     /* 240533 */     // GIR_Coverage, 8136,
     /* 240533 */     GIR_EraseRootFromParent_Done,
     /* 240534 */   // Label 4610: @240534
     /* 240534 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(240576), // Rule ID 8137 //
     /* 240539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 240547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240563 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 240566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240574 */     GIR_RootConstrainSelectedInstOperands,
     /* 240575 */     // GIR_Coverage, 8137,
     /* 240575 */     GIR_EraseRootFromParent_Done,
     /* 240576 */   // Label 4611: @240576
     /* 240576 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(240618), // Rule ID 8138 //
     /* 240581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240605 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 240608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240616 */     GIR_RootConstrainSelectedInstOperands,
     /* 240617 */     // GIR_Coverage, 8138,
     /* 240617 */     GIR_EraseRootFromParent_Done,
     /* 240618 */   // Label 4612: @240618
     /* 240618 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(240660), // Rule ID 8139 //
     /* 240623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 240650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240658 */     GIR_RootConstrainSelectedInstOperands,
     /* 240659 */     // GIR_Coverage, 8139,
     /* 240659 */     GIR_EraseRootFromParent_Done,
     /* 240660 */   // Label 4613: @240660
     /* 240660 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(240702), // Rule ID 8140 //
     /* 240665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 240673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 240692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240700 */     GIR_RootConstrainSelectedInstOperands,
     /* 240701 */     // GIR_Coverage, 8140,
     /* 240701 */     GIR_EraseRootFromParent_Done,
     /* 240702 */   // Label 4614: @240702
     /* 240702 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(240744), // Rule ID 8141 //
     /* 240707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 240734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240742 */     GIR_RootConstrainSelectedInstOperands,
     /* 240743 */     // GIR_Coverage, 8141,
     /* 240743 */     GIR_EraseRootFromParent_Done,
     /* 240744 */   // Label 4615: @240744
     /* 240744 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(240786), // Rule ID 8142 //
     /* 240749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240773 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 240776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240784 */     GIR_RootConstrainSelectedInstOperands,
     /* 240785 */     // GIR_Coverage, 8142,
     /* 240785 */     GIR_EraseRootFromParent_Done,
     /* 240786 */   // Label 4616: @240786
     /* 240786 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(240828), // Rule ID 8143 //
     /* 240791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 240799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240815 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 240818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240826 */     GIR_RootConstrainSelectedInstOperands,
     /* 240827 */     // GIR_Coverage, 8143,
     /* 240827 */     GIR_EraseRootFromParent_Done,
     /* 240828 */   // Label 4617: @240828
     /* 240828 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(240870), // Rule ID 8144 //
     /* 240833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240857 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 240860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240868 */     GIR_RootConstrainSelectedInstOperands,
     /* 240869 */     // GIR_Coverage, 8144,
     /* 240869 */     GIR_EraseRootFromParent_Done,
     /* 240870 */   // Label 4618: @240870
     /* 240870 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(240912), // Rule ID 8145 //
     /* 240875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 240902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240910 */     GIR_RootConstrainSelectedInstOperands,
     /* 240911 */     // GIR_Coverage, 8145,
     /* 240911 */     GIR_EraseRootFromParent_Done,
     /* 240912 */   // Label 4619: @240912
     /* 240912 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(240954), // Rule ID 8146 //
     /* 240917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 240925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240941 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 240944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240952 */     GIR_RootConstrainSelectedInstOperands,
     /* 240953 */     // GIR_Coverage, 8146,
     /* 240953 */     GIR_EraseRootFromParent_Done,
     /* 240954 */   // Label 4620: @240954
     /* 240954 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(240996), // Rule ID 8183 //
     /* 240959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 240967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240983 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 240986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240994 */     GIR_RootConstrainSelectedInstOperands,
     /* 240995 */     // GIR_Coverage, 8183,
     /* 240995 */     GIR_EraseRootFromParent_Done,
     /* 240996 */   // Label 4621: @240996
     /* 240996 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241038), // Rule ID 8185 //
     /* 241001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 241009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241025 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 241028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241036 */     GIR_RootConstrainSelectedInstOperands,
     /* 241037 */     // GIR_Coverage, 8185,
     /* 241037 */     GIR_EraseRootFromParent_Done,
     /* 241038 */   // Label 4622: @241038
     /* 241038 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(241080), // Rule ID 8187 //
     /* 241043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 241051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241067 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 241070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241078 */     GIR_RootConstrainSelectedInstOperands,
     /* 241079 */     // GIR_Coverage, 8187,
     /* 241079 */     GIR_EraseRootFromParent_Done,
     /* 241080 */   // Label 4623: @241080
     /* 241080 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(241122), // Rule ID 8189 //
     /* 241085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 241093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241109 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 241112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241120 */     GIR_RootConstrainSelectedInstOperands,
     /* 241121 */     // GIR_Coverage, 8189,
     /* 241121 */     GIR_EraseRootFromParent_Done,
     /* 241122 */   // Label 4624: @241122
     /* 241122 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(241164), // Rule ID 8191 //
     /* 241127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 241135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241151 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 241154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241162 */     GIR_RootConstrainSelectedInstOperands,
     /* 241163 */     // GIR_Coverage, 8191,
     /* 241163 */     GIR_EraseRootFromParent_Done,
     /* 241164 */   // Label 4625: @241164
     /* 241164 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(241206), // Rule ID 8193 //
     /* 241169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 241177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241193 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 241196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241204 */     GIR_RootConstrainSelectedInstOperands,
     /* 241205 */     // GIR_Coverage, 8193,
     /* 241205 */     GIR_EraseRootFromParent_Done,
     /* 241206 */   // Label 4626: @241206
     /* 241206 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(241248), // Rule ID 8195 //
     /* 241211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241235 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241246 */     GIR_RootConstrainSelectedInstOperands,
     /* 241247 */     // GIR_Coverage, 8195,
     /* 241247 */     GIR_EraseRootFromParent_Done,
     /* 241248 */   // Label 4627: @241248
     /* 241248 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(241290), // Rule ID 8196 //
     /* 241253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241277 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241288 */     GIR_RootConstrainSelectedInstOperands,
     /* 241289 */     // GIR_Coverage, 8196,
     /* 241289 */     GIR_EraseRootFromParent_Done,
     /* 241290 */   // Label 4628: @241290
     /* 241290 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(241332), // Rule ID 8197 //
     /* 241295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241319 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 241322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241330 */     GIR_RootConstrainSelectedInstOperands,
     /* 241331 */     // GIR_Coverage, 8197,
     /* 241331 */     GIR_EraseRootFromParent_Done,
     /* 241332 */   // Label 4629: @241332
     /* 241332 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(241374), // Rule ID 8198 //
     /* 241337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 241364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241372 */     GIR_RootConstrainSelectedInstOperands,
     /* 241373 */     // GIR_Coverage, 8198,
     /* 241373 */     GIR_EraseRootFromParent_Done,
     /* 241374 */   // Label 4630: @241374
     /* 241374 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(241416), // Rule ID 8199 //
     /* 241379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241403 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 241406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241414 */     GIR_RootConstrainSelectedInstOperands,
     /* 241415 */     // GIR_Coverage, 8199,
     /* 241415 */     GIR_EraseRootFromParent_Done,
     /* 241416 */   // Label 4631: @241416
     /* 241416 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(241458), // Rule ID 8200 //
     /* 241421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 241429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 241448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241456 */     GIR_RootConstrainSelectedInstOperands,
     /* 241457 */     // GIR_Coverage, 8200,
     /* 241457 */     GIR_EraseRootFromParent_Done,
     /* 241458 */   // Label 4632: @241458
     /* 241458 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(241500), // Rule ID 8453 //
     /* 241463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 241471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 241490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241498 */     GIR_RootConstrainSelectedInstOperands,
     /* 241499 */     // GIR_Coverage, 8453,
     /* 241499 */     GIR_EraseRootFromParent_Done,
     /* 241500 */   // Label 4633: @241500
     /* 241500 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(241542), // Rule ID 8455 //
     /* 241505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 241513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241529 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 241532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241540 */     GIR_RootConstrainSelectedInstOperands,
     /* 241541 */     // GIR_Coverage, 8455,
     /* 241541 */     GIR_EraseRootFromParent_Done,
     /* 241542 */   // Label 4634: @241542
     /* 241542 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(241584), // Rule ID 8456 //
     /* 241547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241582 */     GIR_RootConstrainSelectedInstOperands,
     /* 241583 */     // GIR_Coverage, 8456,
     /* 241583 */     GIR_EraseRootFromParent_Done,
     /* 241584 */   // Label 4635: @241584
     /* 241584 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(241626), // Rule ID 8457 //
     /* 241589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 241609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241613 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1299:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 241613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241624 */     GIR_RootConstrainSelectedInstOperands,
     /* 241625 */     // GIR_Coverage, 8457,
     /* 241625 */     GIR_EraseRootFromParent_Done,
     /* 241626 */   // Label 4636: @241626
     /* 241626 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(241668), // Rule ID 8458 //
     /* 241631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 241642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 241651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241655 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1299:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 241655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241666 */     GIR_RootConstrainSelectedInstOperands,
     /* 241667 */     // GIR_Coverage, 8458,
     /* 241667 */     GIR_EraseRootFromParent_Done,
     /* 241668 */   // Label 4637: @241668
     /* 241668 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(241710), // Rule ID 8459 //
     /* 241673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 241693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1299:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 241697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241708 */     GIR_RootConstrainSelectedInstOperands,
     /* 241709 */     // GIR_Coverage, 8459,
     /* 241709 */     GIR_EraseRootFromParent_Done,
     /* 241710 */   // Label 4638: @241710
     /* 241710 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(241752), // Rule ID 8460 //
     /* 241715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 241723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 241726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 241729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 241732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 241735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241739 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1299:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 241739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 241742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241750 */     GIR_RootConstrainSelectedInstOperands,
     /* 241751 */     // GIR_Coverage, 8460,
     /* 241751 */     GIR_EraseRootFromParent_Done,
     /* 241752 */   // Label 4639: @241752
     /* 241752 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(241794), // Rule ID 8481 //
     /* 241757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241781 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1357:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241792 */     GIR_RootConstrainSelectedInstOperands,
     /* 241793 */     // GIR_Coverage, 8481,
     /* 241793 */     GIR_EraseRootFromParent_Done,
     /* 241794 */   // Label 4640: @241794
     /* 241794 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(241836), // Rule ID 8482 //
     /* 241799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 241819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241823 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 241823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241834 */     GIR_RootConstrainSelectedInstOperands,
     /* 241835 */     // GIR_Coverage, 8482,
     /* 241835 */     GIR_EraseRootFromParent_Done,
     /* 241836 */   // Label 4641: @241836
     /* 241836 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(241878), // Rule ID 8483 //
     /* 241841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 241852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 241861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241865 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 241865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241876 */     GIR_RootConstrainSelectedInstOperands,
     /* 241877 */     // GIR_Coverage, 8483,
     /* 241877 */     GIR_EraseRootFromParent_Done,
     /* 241878 */   // Label 4642: @241878
     /* 241878 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(241920), // Rule ID 8484 //
     /* 241883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 241903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241907 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 241907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241918 */     GIR_RootConstrainSelectedInstOperands,
     /* 241919 */     // GIR_Coverage, 8484,
     /* 241919 */     GIR_EraseRootFromParent_Done,
     /* 241920 */   // Label 4643: @241920
     /* 241920 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(241962), // Rule ID 8485 //
     /* 241925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 241933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 241936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 241939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 241942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 241945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241949 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1357:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 241949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 241952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241960 */     GIR_RootConstrainSelectedInstOperands,
     /* 241961 */     // GIR_Coverage, 8485,
     /* 241961 */     GIR_EraseRootFromParent_Done,
     /* 241962 */   // Label 4644: @241962
     /* 241962 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(242004), // Rule ID 8501 //
     /* 241967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 241975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 241991 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 241994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242002 */     GIR_RootConstrainSelectedInstOperands,
     /* 242003 */     // GIR_Coverage, 8501,
     /* 242003 */     GIR_EraseRootFromParent_Done,
     /* 242004 */   // Label 4645: @242004
     /* 242004 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242046), // Rule ID 8502 //
     /* 242009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 242017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242033 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 242036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242044 */     GIR_RootConstrainSelectedInstOperands,
     /* 242045 */     // GIR_Coverage, 8502,
     /* 242045 */     GIR_EraseRootFromParent_Done,
     /* 242046 */   // Label 4646: @242046
     /* 242046 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(242088), // Rule ID 8503 //
     /* 242051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 242059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 242078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242086 */     GIR_RootConstrainSelectedInstOperands,
     /* 242087 */     // GIR_Coverage, 8503,
     /* 242087 */     GIR_EraseRootFromParent_Done,
     /* 242088 */   // Label 4647: @242088
     /* 242088 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(242130), // Rule ID 8504 //
     /* 242093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 242101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242117 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 242120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242128 */     GIR_RootConstrainSelectedInstOperands,
     /* 242129 */     // GIR_Coverage, 8504,
     /* 242129 */     GIR_EraseRootFromParent_Done,
     /* 242130 */   // Label 4648: @242130
     /* 242130 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(242172), // Rule ID 8505 //
     /* 242135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 242143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242159 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1628:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 242162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242170 */     GIR_RootConstrainSelectedInstOperands,
     /* 242171 */     // GIR_Coverage, 8505,
     /* 242171 */     GIR_EraseRootFromParent_Done,
     /* 242172 */   // Label 4649: @242172
     /* 242172 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(242214), // Rule ID 8506 //
     /* 242177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242201 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242212 */     GIR_RootConstrainSelectedInstOperands,
     /* 242213 */     // GIR_Coverage, 8506,
     /* 242213 */     GIR_EraseRootFromParent_Done,
     /* 242214 */   // Label 4650: @242214
     /* 242214 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(242256), // Rule ID 8507 //
     /* 242219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242243 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242254 */     GIR_RootConstrainSelectedInstOperands,
     /* 242255 */     // GIR_Coverage, 8507,
     /* 242255 */     GIR_EraseRootFromParent_Done,
     /* 242256 */   // Label 4651: @242256
     /* 242256 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(242298), // Rule ID 8508 //
     /* 242261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242285 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1624:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242296 */     GIR_RootConstrainSelectedInstOperands,
     /* 242297 */     // GIR_Coverage, 8508,
     /* 242297 */     GIR_EraseRootFromParent_Done,
     /* 242298 */   // Label 4652: @242298
     /* 242298 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(242340), // Rule ID 8509 //
     /* 242303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242327 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1624:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242338 */     GIR_RootConstrainSelectedInstOperands,
     /* 242339 */     // GIR_Coverage, 8509,
     /* 242339 */     GIR_EraseRootFromParent_Done,
     /* 242340 */   // Label 4653: @242340
     /* 242340 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(242382), // Rule ID 8510 //
     /* 242345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 242353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242369 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1624:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 242372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242380 */     GIR_RootConstrainSelectedInstOperands,
     /* 242381 */     // GIR_Coverage, 8510,
     /* 242381 */     GIR_EraseRootFromParent_Done,
     /* 242382 */   // Label 4654: @242382
     /* 242382 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(242424), // Rule ID 8511 //
     /* 242387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242411 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1622:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242422 */     GIR_RootConstrainSelectedInstOperands,
     /* 242423 */     // GIR_Coverage, 8511,
     /* 242423 */     GIR_EraseRootFromParent_Done,
     /* 242424 */   // Label 4655: @242424
     /* 242424 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(242466), // Rule ID 8512 //
     /* 242429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242453 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1622:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242464 */     GIR_RootConstrainSelectedInstOperands,
     /* 242465 */     // GIR_Coverage, 8512,
     /* 242465 */     GIR_EraseRootFromParent_Done,
     /* 242466 */   // Label 4656: @242466
     /* 242466 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(242508), // Rule ID 8513 //
     /* 242471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1622:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242506 */     GIR_RootConstrainSelectedInstOperands,
     /* 242507 */     // GIR_Coverage, 8513,
     /* 242507 */     GIR_EraseRootFromParent_Done,
     /* 242508 */   // Label 4657: @242508
     /* 242508 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(242550), // Rule ID 8514 //
     /* 242513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242537 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1622:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242548 */     GIR_RootConstrainSelectedInstOperands,
     /* 242549 */     // GIR_Coverage, 8514,
     /* 242549 */     GIR_EraseRootFromParent_Done,
     /* 242550 */   // Label 4658: @242550
     /* 242550 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(242592), // Rule ID 8515 //
     /* 242555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 242563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242579 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1622:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 242582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242590 */     GIR_RootConstrainSelectedInstOperands,
     /* 242591 */     // GIR_Coverage, 8515,
     /* 242591 */     GIR_EraseRootFromParent_Done,
     /* 242592 */   // Label 4659: @242592
     /* 242592 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(242634), // Rule ID 8516 //
     /* 242597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242621 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242632 */     GIR_RootConstrainSelectedInstOperands,
     /* 242633 */     // GIR_Coverage, 8516,
     /* 242633 */     GIR_EraseRootFromParent_Done,
     /* 242634 */   // Label 4660: @242634
     /* 242634 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(242676), // Rule ID 8517 //
     /* 242639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242663 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242674 */     GIR_RootConstrainSelectedInstOperands,
     /* 242675 */     // GIR_Coverage, 8517,
     /* 242675 */     GIR_EraseRootFromParent_Done,
     /* 242676 */   // Label 4661: @242676
     /* 242676 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(242718), // Rule ID 8518 //
     /* 242681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242705 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242716 */     GIR_RootConstrainSelectedInstOperands,
     /* 242717 */     // GIR_Coverage, 8518,
     /* 242717 */     GIR_EraseRootFromParent_Done,
     /* 242718 */   // Label 4662: @242718
     /* 242718 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(242760), // Rule ID 8519 //
     /* 242723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 242734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 242740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 242743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 242747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242758 */     GIR_RootConstrainSelectedInstOperands,
     /* 242759 */     // GIR_Coverage, 8519,
     /* 242759 */     GIR_EraseRootFromParent_Done,
     /* 242760 */   // Label 4663: @242760
     /* 242760 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(242802), // Rule ID 8520 //
     /* 242765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 242773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 242776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 242779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 242782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 242785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242789 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1618:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 242789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 242792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242800 */     GIR_RootConstrainSelectedInstOperands,
     /* 242801 */     // GIR_Coverage, 8520,
     /* 242801 */     GIR_EraseRootFromParent_Done,
     /* 242802 */   // Label 4664: @242802
     /* 242802 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(242844), // Rule ID 8528 //
     /* 242807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242831 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 242834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242842 */     GIR_RootConstrainSelectedInstOperands,
     /* 242843 */     // GIR_Coverage, 8528,
     /* 242843 */     GIR_EraseRootFromParent_Done,
     /* 242844 */   // Label 4665: @242844
     /* 242844 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(242886), // Rule ID 8529 //
     /* 242849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 242876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242884 */     GIR_RootConstrainSelectedInstOperands,
     /* 242885 */     // GIR_Coverage, 8529,
     /* 242885 */     GIR_EraseRootFromParent_Done,
     /* 242886 */   // Label 4666: @242886
     /* 242886 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(242928), // Rule ID 8530 //
     /* 242891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 242918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242926 */     GIR_RootConstrainSelectedInstOperands,
     /* 242927 */     // GIR_Coverage, 8530,
     /* 242927 */     GIR_EraseRootFromParent_Done,
     /* 242928 */   // Label 4667: @242928
     /* 242928 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(242970), // Rule ID 8531 //
     /* 242933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242957 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 242960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242968 */     GIR_RootConstrainSelectedInstOperands,
     /* 242969 */     // GIR_Coverage, 8531,
     /* 242969 */     GIR_EraseRootFromParent_Done,
     /* 242970 */   // Label 4668: @242970
     /* 242970 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243012), // Rule ID 8532 //
     /* 242975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 242983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242999 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 243002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243010 */     GIR_RootConstrainSelectedInstOperands,
     /* 243011 */     // GIR_Coverage, 8532,
     /* 243011 */     GIR_EraseRootFromParent_Done,
     /* 243012 */   // Label 4669: @243012
     /* 243012 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243054), // Rule ID 8533 //
     /* 243017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 243025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243041 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 243044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243052 */     GIR_RootConstrainSelectedInstOperands,
     /* 243053 */     // GIR_Coverage, 8533,
     /* 243053 */     GIR_EraseRootFromParent_Done,
     /* 243054 */   // Label 4670: @243054
     /* 243054 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(243096), // Rule ID 8534 //
     /* 243059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 243067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243083 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 243083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 243086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243094 */     GIR_RootConstrainSelectedInstOperands,
     /* 243095 */     // GIR_Coverage, 8534,
     /* 243095 */     GIR_EraseRootFromParent_Done,
     /* 243096 */   // Label 4671: @243096
     /* 243096 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(243141), // Rule ID 9230 //
     /* 243101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 243109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243125 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 243128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243139 */     GIR_RootConstrainSelectedInstOperands,
     /* 243140 */     // GIR_Coverage, 9230,
     /* 243140 */     GIR_EraseRootFromParent_Done,
     /* 243141 */   // Label 4672: @243141
     /* 243141 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(243186), // Rule ID 9231 //
     /* 243146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 243154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 243173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243184 */     GIR_RootConstrainSelectedInstOperands,
     /* 243185 */     // GIR_Coverage, 9231,
     /* 243185 */     GIR_EraseRootFromParent_Done,
     /* 243186 */   // Label 4673: @243186
     /* 243186 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(243231), // Rule ID 9232 //
     /* 243191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 243199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 243218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243229 */     GIR_RootConstrainSelectedInstOperands,
     /* 243230 */     // GIR_Coverage, 9232,
     /* 243230 */     GIR_EraseRootFromParent_Done,
     /* 243231 */   // Label 4674: @243231
     /* 243231 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(243276), // Rule ID 9233 //
     /* 243236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243274 */     GIR_RootConstrainSelectedInstOperands,
     /* 243275 */     // GIR_Coverage, 9233,
     /* 243275 */     GIR_EraseRootFromParent_Done,
     /* 243276 */   // Label 4675: @243276
     /* 243276 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(243321), // Rule ID 9234 //
     /* 243281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 243308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243319 */     GIR_RootConstrainSelectedInstOperands,
     /* 243320 */     // GIR_Coverage, 9234,
     /* 243320 */     GIR_EraseRootFromParent_Done,
     /* 243321 */   // Label 4676: @243321
     /* 243321 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(243366), // Rule ID 9235 //
     /* 243326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 243334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 243353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243364 */     GIR_RootConstrainSelectedInstOperands,
     /* 243365 */     // GIR_Coverage, 9235,
     /* 243365 */     GIR_EraseRootFromParent_Done,
     /* 243366 */   // Label 4677: @243366
     /* 243366 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(243411), // Rule ID 9236 //
     /* 243371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243395 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 243398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243409 */     GIR_RootConstrainSelectedInstOperands,
     /* 243410 */     // GIR_Coverage, 9236,
     /* 243410 */     GIR_EraseRootFromParent_Done,
     /* 243411 */   // Label 4678: @243411
     /* 243411 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(243456), // Rule ID 9237 //
     /* 243416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 243443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243454 */     GIR_RootConstrainSelectedInstOperands,
     /* 243455 */     // GIR_Coverage, 9237,
     /* 243455 */     GIR_EraseRootFromParent_Done,
     /* 243456 */   // Label 4679: @243456
     /* 243456 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(243501), // Rule ID 9238 //
     /* 243461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 243469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 243488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243499 */     GIR_RootConstrainSelectedInstOperands,
     /* 243500 */     // GIR_Coverage, 9238,
     /* 243500 */     GIR_EraseRootFromParent_Done,
     /* 243501 */   // Label 4680: @243501
     /* 243501 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(243546), // Rule ID 9239 //
     /* 243506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 243533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243544 */     GIR_RootConstrainSelectedInstOperands,
     /* 243545 */     // GIR_Coverage, 9239,
     /* 243545 */     GIR_EraseRootFromParent_Done,
     /* 243546 */   // Label 4681: @243546
     /* 243546 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(243591), // Rule ID 9240 //
     /* 243551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243589 */     GIR_RootConstrainSelectedInstOperands,
     /* 243590 */     // GIR_Coverage, 9240,
     /* 243590 */     GIR_EraseRootFromParent_Done,
     /* 243591 */   // Label 4682: @243591
     /* 243591 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(243636), // Rule ID 9241 //
     /* 243596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 243604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 243623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243634 */     GIR_RootConstrainSelectedInstOperands,
     /* 243635 */     // GIR_Coverage, 9241,
     /* 243635 */     GIR_EraseRootFromParent_Done,
     /* 243636 */   // Label 4683: @243636
     /* 243636 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(243681), // Rule ID 9242 //
     /* 243641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243665 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1330:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243679 */     GIR_RootConstrainSelectedInstOperands,
     /* 243680 */     // GIR_Coverage, 9242,
     /* 243680 */     GIR_EraseRootFromParent_Done,
     /* 243681 */   // Label 4684: @243681
     /* 243681 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(243726), // Rule ID 9243 //
     /* 243686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 243713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243724 */     GIR_RootConstrainSelectedInstOperands,
     /* 243725 */     // GIR_Coverage, 9243,
     /* 243725 */     GIR_EraseRootFromParent_Done,
     /* 243726 */   // Label 4685: @243726
     /* 243726 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(243771), // Rule ID 9244 //
     /* 243731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 243739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243755 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 243758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243769 */     GIR_RootConstrainSelectedInstOperands,
     /* 243770 */     // GIR_Coverage, 9244,
     /* 243770 */     GIR_EraseRootFromParent_Done,
     /* 243771 */   // Label 4686: @243771
     /* 243771 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(243816), // Rule ID 9245 //
     /* 243776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1328:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 243803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243814 */     GIR_RootConstrainSelectedInstOperands,
     /* 243815 */     // GIR_Coverage, 9245,
     /* 243815 */     GIR_EraseRootFromParent_Done,
     /* 243816 */   // Label 4687: @243816
     /* 243816 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(243861), // Rule ID 9246 //
     /* 243821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1328:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 243848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243859 */     GIR_RootConstrainSelectedInstOperands,
     /* 243860 */     // GIR_Coverage, 9246,
     /* 243860 */     GIR_EraseRootFromParent_Done,
     /* 243861 */   // Label 4688: @243861
     /* 243861 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(243906), // Rule ID 9247 //
     /* 243866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 243874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 243893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243904 */     GIR_RootConstrainSelectedInstOperands,
     /* 243905 */     // GIR_Coverage, 9247,
     /* 243905 */     GIR_EraseRootFromParent_Done,
     /* 243906 */   // Label 4689: @243906
     /* 243906 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(243951), // Rule ID 9248 //
     /* 243911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 243919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243935 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1332:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 243938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243949 */     GIR_RootConstrainSelectedInstOperands,
     /* 243950 */     // GIR_Coverage, 9248,
     /* 243950 */     GIR_EraseRootFromParent_Done,
     /* 243951 */   // Label 4690: @243951
     /* 243951 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(243996), // Rule ID 9249 //
     /* 243956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 243964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1332:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 243983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243994 */     GIR_RootConstrainSelectedInstOperands,
     /* 243995 */     // GIR_Coverage, 9249,
     /* 243995 */     GIR_EraseRootFromParent_Done,
     /* 243996 */   // Label 4691: @243996
     /* 243996 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244041), // Rule ID 9250 //
     /* 244001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 244009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244025 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1332:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 244028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244039 */     GIR_RootConstrainSelectedInstOperands,
     /* 244040 */     // GIR_Coverage, 9250,
     /* 244040 */     GIR_EraseRootFromParent_Done,
     /* 244041 */   // Label 4692: @244041
     /* 244041 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244086), // Rule ID 9251 //
     /* 244046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 244054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 244073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244084 */     GIR_RootConstrainSelectedInstOperands,
     /* 244085 */     // GIR_Coverage, 9251,
     /* 244085 */     GIR_EraseRootFromParent_Done,
     /* 244086 */   // Label 4693: @244086
     /* 244086 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(244131), // Rule ID 9252 //
     /* 244091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 244099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244115 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 244118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244129 */     GIR_RootConstrainSelectedInstOperands,
     /* 244130 */     // GIR_Coverage, 9252,
     /* 244130 */     GIR_EraseRootFromParent_Done,
     /* 244131 */   // Label 4694: @244131
     /* 244131 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(244176), // Rule ID 9253 //
     /* 244136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 244144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 244163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244174 */     GIR_RootConstrainSelectedInstOperands,
     /* 244175 */     // GIR_Coverage, 9253,
     /* 244175 */     GIR_EraseRootFromParent_Done,
     /* 244176 */   // Label 4695: @244176
     /* 244176 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(244218), // Rule ID 9650 //
     /* 244181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244205 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 244208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244216 */     GIR_RootConstrainSelectedInstOperands,
     /* 244217 */     // GIR_Coverage, 9650,
     /* 244217 */     GIR_EraseRootFromParent_Done,
     /* 244218 */   // Label 4696: @244218
     /* 244218 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(244260), // Rule ID 9651 //
     /* 244223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 244250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244258 */     GIR_RootConstrainSelectedInstOperands,
     /* 244259 */     // GIR_Coverage, 9651,
     /* 244259 */     GIR_EraseRootFromParent_Done,
     /* 244260 */   // Label 4697: @244260
     /* 244260 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(244302), // Rule ID 9652 //
     /* 244265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 244273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244289 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 244292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244300 */     GIR_RootConstrainSelectedInstOperands,
     /* 244301 */     // GIR_Coverage, 9652,
     /* 244301 */     GIR_EraseRootFromParent_Done,
     /* 244302 */   // Label 4698: @244302
     /* 244302 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(244344), // Rule ID 10190 //
     /* 244307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 244334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244342 */     GIR_RootConstrainSelectedInstOperands,
     /* 244343 */     // GIR_Coverage, 10190,
     /* 244343 */     GIR_EraseRootFromParent_Done,
     /* 244344 */   // Label 4699: @244344
     /* 244344 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(244386), // Rule ID 10191 //
     /* 244349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 244376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244384 */     GIR_RootConstrainSelectedInstOperands,
     /* 244385 */     // GIR_Coverage, 10191,
     /* 244385 */     GIR_EraseRootFromParent_Done,
     /* 244386 */   // Label 4700: @244386
     /* 244386 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(244428), // Rule ID 10192 //
     /* 244391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 244418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244426 */     GIR_RootConstrainSelectedInstOperands,
     /* 244427 */     // GIR_Coverage, 10192,
     /* 244427 */     GIR_EraseRootFromParent_Done,
     /* 244428 */   // Label 4701: @244428
     /* 244428 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(244470), // Rule ID 10193 //
     /* 244433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 244441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 244460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244468 */     GIR_RootConstrainSelectedInstOperands,
     /* 244469 */     // GIR_Coverage, 10193,
     /* 244469 */     GIR_EraseRootFromParent_Done,
     /* 244470 */   // Label 4702: @244470
     /* 244470 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(244512), // Rule ID 10194 //
     /* 244475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244499 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 244502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244510 */     GIR_RootConstrainSelectedInstOperands,
     /* 244511 */     // GIR_Coverage, 10194,
     /* 244511 */     GIR_EraseRootFromParent_Done,
     /* 244512 */   // Label 4703: @244512
     /* 244512 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(244554), // Rule ID 10195 //
     /* 244517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 244544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244552 */     GIR_RootConstrainSelectedInstOperands,
     /* 244553 */     // GIR_Coverage, 10195,
     /* 244553 */     GIR_EraseRootFromParent_Done,
     /* 244554 */   // Label 4704: @244554
     /* 244554 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(244596), // Rule ID 10196 //
     /* 244559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244583 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 244586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244594 */     GIR_RootConstrainSelectedInstOperands,
     /* 244595 */     // GIR_Coverage, 10196,
     /* 244595 */     GIR_EraseRootFromParent_Done,
     /* 244596 */   // Label 4705: @244596
     /* 244596 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(244638), // Rule ID 10197 //
     /* 244601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 244609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 244628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244636 */     GIR_RootConstrainSelectedInstOperands,
     /* 244637 */     // GIR_Coverage, 10197,
     /* 244637 */     GIR_EraseRootFromParent_Done,
     /* 244638 */   // Label 4706: @244638
     /* 244638 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(244680), // Rule ID 10210 //
     /* 244643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 244670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244678 */     GIR_RootConstrainSelectedInstOperands,
     /* 244679 */     // GIR_Coverage, 10210,
     /* 244679 */     GIR_EraseRootFromParent_Done,
     /* 244680 */   // Label 4707: @244680
     /* 244680 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(244722), // Rule ID 10211 //
     /* 244685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 244712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244720 */     GIR_RootConstrainSelectedInstOperands,
     /* 244721 */     // GIR_Coverage, 10211,
     /* 244721 */     GIR_EraseRootFromParent_Done,
     /* 244722 */   // Label 4708: @244722
     /* 244722 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(244764), // Rule ID 10212 //
     /* 244727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 244735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 244754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244762 */     GIR_RootConstrainSelectedInstOperands,
     /* 244763 */     // GIR_Coverage, 10212,
     /* 244763 */     GIR_EraseRootFromParent_Done,
     /* 244764 */   // Label 4709: @244764
     /* 244764 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(244806), // Rule ID 10213 //
     /* 244769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 244796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244804 */     GIR_RootConstrainSelectedInstOperands,
     /* 244805 */     // GIR_Coverage, 10213,
     /* 244805 */     GIR_EraseRootFromParent_Done,
     /* 244806 */   // Label 4710: @244806
     /* 244806 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(244848), // Rule ID 10214 //
     /* 244811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 244838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244846 */     GIR_RootConstrainSelectedInstOperands,
     /* 244847 */     // GIR_Coverage, 10214,
     /* 244847 */     GIR_EraseRootFromParent_Done,
     /* 244848 */   // Label 4711: @244848
     /* 244848 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(244890), // Rule ID 10215 //
     /* 244853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 244861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244888 */     GIR_RootConstrainSelectedInstOperands,
     /* 244889 */     // GIR_Coverage, 10215,
     /* 244889 */     GIR_EraseRootFromParent_Done,
     /* 244890 */   // Label 4712: @244890
     /* 244890 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(244932), // Rule ID 10242 //
     /* 244895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 244903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244919 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 244922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244930 */     GIR_RootConstrainSelectedInstOperands,
     /* 244931 */     // GIR_Coverage, 10242,
     /* 244931 */     GIR_EraseRootFromParent_Done,
     /* 244932 */   // Label 4713: @244932
     /* 244932 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(244974), // Rule ID 10246 //
     /* 244937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 244945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244961 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1397:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 244964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244972 */     GIR_RootConstrainSelectedInstOperands,
     /* 244973 */     // GIR_Coverage, 10246,
     /* 244973 */     GIR_EraseRootFromParent_Done,
     /* 244974 */   // Label 4714: @244974
     /* 244974 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245016), // Rule ID 10250 //
     /* 244979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 244987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245003 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1396:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 245006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245014 */     GIR_RootConstrainSelectedInstOperands,
     /* 245015 */     // GIR_Coverage, 10250,
     /* 245015 */     GIR_EraseRootFromParent_Done,
     /* 245016 */   // Label 4715: @245016
     /* 245016 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245058), // Rule ID 10254 //
     /* 245021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 245029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245045 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1398:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 245048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245056 */     GIR_RootConstrainSelectedInstOperands,
     /* 245057 */     // GIR_Coverage, 10254,
     /* 245057 */     GIR_EraseRootFromParent_Done,
     /* 245058 */   // Label 4716: @245058
     /* 245058 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(245100), // Rule ID 10258 //
     /* 245063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 245071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245087 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1710:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 245090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245098 */     GIR_RootConstrainSelectedInstOperands,
     /* 245099 */     // GIR_Coverage, 10258,
     /* 245099 */     GIR_EraseRootFromParent_Done,
     /* 245100 */   // Label 4717: @245100
     /* 245100 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245142), // Rule ID 10259 //
     /* 245105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 245113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245129 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1957:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 245132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245140 */     GIR_RootConstrainSelectedInstOperands,
     /* 245141 */     // GIR_Coverage, 10259,
     /* 245141 */     GIR_EraseRootFromParent_Done,
     /* 245142 */   // Label 4718: @245142
     /* 245142 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(245184), // Rule ID 10260 //
     /* 245147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 245155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245171 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1954:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245182 */     GIR_RootConstrainSelectedInstOperands,
     /* 245183 */     // GIR_Coverage, 10260,
     /* 245183 */     GIR_EraseRootFromParent_Done,
     /* 245184 */   // Label 4719: @245184
     /* 245184 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(245226), // Rule ID 10264 //
     /* 245189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 245197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245213 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1709:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 245216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245224 */     GIR_RootConstrainSelectedInstOperands,
     /* 245225 */     // GIR_Coverage, 10264,
     /* 245225 */     GIR_EraseRootFromParent_Done,
     /* 245226 */   // Label 4720: @245226
     /* 245226 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(245268), // Rule ID 10268 //
     /* 245231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 245239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1707:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 245258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245266 */     GIR_RootConstrainSelectedInstOperands,
     /* 245267 */     // GIR_Coverage, 10268,
     /* 245267 */     GIR_EraseRootFromParent_Done,
     /* 245268 */   // Label 4721: @245268
     /* 245268 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(245310), // Rule ID 10272 //
     /* 245273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 245281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1708:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 245300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245308 */     GIR_RootConstrainSelectedInstOperands,
     /* 245309 */     // GIR_Coverage, 10272,
     /* 245309 */     GIR_EraseRootFromParent_Done,
     /* 245310 */   // Label 4722: @245310
     /* 245310 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(245352), // Rule ID 10276 //
     /* 245315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 245323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1956:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 245342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245350 */     GIR_RootConstrainSelectedInstOperands,
     /* 245351 */     // GIR_Coverage, 10276,
     /* 245351 */     GIR_EraseRootFromParent_Done,
     /* 245352 */   // Label 4723: @245352
     /* 245352 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(245394), // Rule ID 10280 //
     /* 245357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 245365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245381 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1955:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 245384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245392 */     GIR_RootConstrainSelectedInstOperands,
     /* 245393 */     // GIR_Coverage, 10280,
     /* 245393 */     GIR_EraseRootFromParent_Done,
     /* 245394 */   // Label 4724: @245394
     /* 245394 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(245436), // Rule ID 10290 //
     /* 245399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 245407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 245426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245434 */     GIR_RootConstrainSelectedInstOperands,
     /* 245435 */     // GIR_Coverage, 10290,
     /* 245435 */     GIR_EraseRootFromParent_Done,
     /* 245436 */   // Label 4725: @245436
     /* 245436 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(245478), // Rule ID 10291 //
     /* 245441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 245449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1419:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 245468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245476 */     GIR_RootConstrainSelectedInstOperands,
     /* 245477 */     // GIR_Coverage, 10291,
     /* 245477 */     GIR_EraseRootFromParent_Done,
     /* 245478 */   // Label 4726: @245478
     /* 245478 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(245520), // Rule ID 10292 //
     /* 245483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 245491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245518 */     GIR_RootConstrainSelectedInstOperands,
     /* 245519 */     // GIR_Coverage, 10292,
     /* 245519 */     GIR_EraseRootFromParent_Done,
     /* 245520 */   // Label 4727: @245520
     /* 245520 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(245562), // Rule ID 10296 //
     /* 245525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 245533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 245552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245560 */     GIR_RootConstrainSelectedInstOperands,
     /* 245561 */     // GIR_Coverage, 10296,
     /* 245561 */     GIR_EraseRootFromParent_Done,
     /* 245562 */   // Label 4728: @245562
     /* 245562 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(245604), // Rule ID 10300 //
     /* 245567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 245575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 245594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245602 */     GIR_RootConstrainSelectedInstOperands,
     /* 245603 */     // GIR_Coverage, 10300,
     /* 245603 */     GIR_EraseRootFromParent_Done,
     /* 245604 */   // Label 4729: @245604
     /* 245604 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(245646), // Rule ID 10304 //
     /* 245609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 245617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1418:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 245636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245644 */     GIR_RootConstrainSelectedInstOperands,
     /* 245645 */     // GIR_Coverage, 10304,
     /* 245645 */     GIR_EraseRootFromParent_Done,
     /* 245646 */   // Label 4730: @245646
     /* 245646 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(245688), // Rule ID 10308 //
     /* 245651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 245659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1420:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 245678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245686 */     GIR_RootConstrainSelectedInstOperands,
     /* 245687 */     // GIR_Coverage, 10308,
     /* 245687 */     GIR_EraseRootFromParent_Done,
     /* 245688 */   // Label 4731: @245688
     /* 245688 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(245730), // Rule ID 10312 //
     /* 245693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 245701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1421:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 245720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245728 */     GIR_RootConstrainSelectedInstOperands,
     /* 245729 */     // GIR_Coverage, 10312,
     /* 245729 */     GIR_EraseRootFromParent_Done,
     /* 245730 */   // Label 4732: @245730
     /* 245730 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(245772), // Rule ID 11309 //
     /* 245735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 245738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 245743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 245762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245770 */     GIR_RootConstrainSelectedInstOperands,
     /* 245771 */     // GIR_Coverage, 11309,
     /* 245771 */     GIR_EraseRootFromParent_Done,
     /* 245772 */   // Label 4733: @245772
     /* 245772 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(245814), // Rule ID 11310 //
     /* 245777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 245780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 245785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 245804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245812 */     GIR_RootConstrainSelectedInstOperands,
     /* 245813 */     // GIR_Coverage, 11310,
     /* 245813 */     GIR_EraseRootFromParent_Done,
     /* 245814 */   // Label 4734: @245814
     /* 245814 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(245856), // Rule ID 11312 //
     /* 245819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 245822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 245827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245843 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 245846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245854 */     GIR_RootConstrainSelectedInstOperands,
     /* 245855 */     // GIR_Coverage, 11312,
     /* 245855 */     GIR_EraseRootFromParent_Done,
     /* 245856 */   // Label 4735: @245856
     /* 245856 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(245898), // Rule ID 11313 //
     /* 245861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 245864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 245869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245885 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1482:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 245888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245896 */     GIR_RootConstrainSelectedInstOperands,
     /* 245897 */     // GIR_Coverage, 11313,
     /* 245897 */     GIR_EraseRootFromParent_Done,
     /* 245898 */   // Label 4736: @245898
     /* 245898 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(245940), // Rule ID 11367 //
     /* 245903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 245930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245938 */     GIR_RootConstrainSelectedInstOperands,
     /* 245939 */     // GIR_Coverage, 11367,
     /* 245939 */     GIR_EraseRootFromParent_Done,
     /* 245940 */   // Label 4737: @245940
     /* 245940 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(245982), // Rule ID 11368 //
     /* 245945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 245972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245980 */     GIR_RootConstrainSelectedInstOperands,
     /* 245981 */     // GIR_Coverage, 11368,
     /* 245981 */     GIR_EraseRootFromParent_Done,
     /* 245982 */   // Label 4738: @245982
     /* 245982 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246024), // Rule ID 11369 //
     /* 245987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 245995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 246014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246022 */     GIR_RootConstrainSelectedInstOperands,
     /* 246023 */     // GIR_Coverage, 11369,
     /* 246023 */     GIR_EraseRootFromParent_Done,
     /* 246024 */   // Label 4739: @246024
     /* 246024 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246066), // Rule ID 11370 //
     /* 246029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 246037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 246056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246064 */     GIR_RootConstrainSelectedInstOperands,
     /* 246065 */     // GIR_Coverage, 11370,
     /* 246065 */     GIR_EraseRootFromParent_Done,
     /* 246066 */   // Label 4740: @246066
     /* 246066 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246108), // Rule ID 11423 //
     /* 246071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 246079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 246098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246106 */     GIR_RootConstrainSelectedInstOperands,
     /* 246107 */     // GIR_Coverage, 11423,
     /* 246107 */     GIR_EraseRootFromParent_Done,
     /* 246108 */   // Label 4741: @246108
     /* 246108 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246150), // Rule ID 11424 //
     /* 246113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 246121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 246140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246148 */     GIR_RootConstrainSelectedInstOperands,
     /* 246149 */     // GIR_Coverage, 11424,
     /* 246149 */     GIR_EraseRootFromParent_Done,
     /* 246150 */   // Label 4742: @246150
     /* 246150 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246192), // Rule ID 11425 //
     /* 246155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 246163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246190 */     GIR_RootConstrainSelectedInstOperands,
     /* 246191 */     // GIR_Coverage, 11425,
     /* 246191 */     GIR_EraseRootFromParent_Done,
     /* 246192 */   // Label 4743: @246192
     /* 246192 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(246234), // Rule ID 11426 //
     /* 246197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 246224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246232 */     GIR_RootConstrainSelectedInstOperands,
     /* 246233 */     // GIR_Coverage, 11426,
     /* 246233 */     GIR_EraseRootFromParent_Done,
     /* 246234 */   // Label 4744: @246234
     /* 246234 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(246276), // Rule ID 11427 //
     /* 246239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246274 */     GIR_RootConstrainSelectedInstOperands,
     /* 246275 */     // GIR_Coverage, 11427,
     /* 246275 */     GIR_EraseRootFromParent_Done,
     /* 246276 */   // Label 4745: @246276
     /* 246276 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(246318), // Rule ID 11428 //
     /* 246281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 246289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 246308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246316 */     GIR_RootConstrainSelectedInstOperands,
     /* 246317 */     // GIR_Coverage, 11428,
     /* 246317 */     GIR_EraseRootFromParent_Done,
     /* 246318 */   // Label 4746: @246318
     /* 246318 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(246360), // Rule ID 11429 //
     /* 246323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 246350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246358 */     GIR_RootConstrainSelectedInstOperands,
     /* 246359 */     // GIR_Coverage, 11429,
     /* 246359 */     GIR_EraseRootFromParent_Done,
     /* 246360 */   // Label 4747: @246360
     /* 246360 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(246402), // Rule ID 11430 //
     /* 246365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 246392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246400 */     GIR_RootConstrainSelectedInstOperands,
     /* 246401 */     // GIR_Coverage, 11430,
     /* 246401 */     GIR_EraseRootFromParent_Done,
     /* 246402 */   // Label 4748: @246402
     /* 246402 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(246444), // Rule ID 11431 //
     /* 246407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 246415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 246434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246442 */     GIR_RootConstrainSelectedInstOperands,
     /* 246443 */     // GIR_Coverage, 11431,
     /* 246443 */     GIR_EraseRootFromParent_Done,
     /* 246444 */   // Label 4749: @246444
     /* 246444 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(246486), // Rule ID 11432 //
     /* 246449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 246476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246484 */     GIR_RootConstrainSelectedInstOperands,
     /* 246485 */     // GIR_Coverage, 11432,
     /* 246485 */     GIR_EraseRootFromParent_Done,
     /* 246486 */   // Label 4750: @246486
     /* 246486 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(246528), // Rule ID 11433 //
     /* 246491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 246518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246526 */     GIR_RootConstrainSelectedInstOperands,
     /* 246527 */     // GIR_Coverage, 11433,
     /* 246527 */     GIR_EraseRootFromParent_Done,
     /* 246528 */   // Label 4751: @246528
     /* 246528 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(246570), // Rule ID 11434 //
     /* 246533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 246541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 246560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246568 */     GIR_RootConstrainSelectedInstOperands,
     /* 246569 */     // GIR_Coverage, 11434,
     /* 246569 */     GIR_EraseRootFromParent_Done,
     /* 246570 */   // Label 4752: @246570
     /* 246570 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(246612), // Rule ID 11435 //
     /* 246575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 246602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246610 */     GIR_RootConstrainSelectedInstOperands,
     /* 246611 */     // GIR_Coverage, 11435,
     /* 246611 */     GIR_EraseRootFromParent_Done,
     /* 246612 */   // Label 4753: @246612
     /* 246612 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(246654), // Rule ID 11436 //
     /* 246617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 246644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246652 */     GIR_RootConstrainSelectedInstOperands,
     /* 246653 */     // GIR_Coverage, 11436,
     /* 246653 */     GIR_EraseRootFromParent_Done,
     /* 246654 */   // Label 4754: @246654
     /* 246654 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(246696), // Rule ID 11437 //
     /* 246659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 246667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 246686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246694 */     GIR_RootConstrainSelectedInstOperands,
     /* 246695 */     // GIR_Coverage, 11437,
     /* 246695 */     GIR_EraseRootFromParent_Done,
     /* 246696 */   // Label 4755: @246696
     /* 246696 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(246738), // Rule ID 11438 //
     /* 246701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 246728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246736 */     GIR_RootConstrainSelectedInstOperands,
     /* 246737 */     // GIR_Coverage, 11438,
     /* 246737 */     GIR_EraseRootFromParent_Done,
     /* 246738 */   // Label 4756: @246738
     /* 246738 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(246780), // Rule ID 11439 //
     /* 246743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 246770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246778 */     GIR_RootConstrainSelectedInstOperands,
     /* 246779 */     // GIR_Coverage, 11439,
     /* 246779 */     GIR_EraseRootFromParent_Done,
     /* 246780 */   // Label 4757: @246780
     /* 246780 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(246822), // Rule ID 11440 //
     /* 246785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 246793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 246812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246820 */     GIR_RootConstrainSelectedInstOperands,
     /* 246821 */     // GIR_Coverage, 11440,
     /* 246821 */     GIR_EraseRootFromParent_Done,
     /* 246822 */   // Label 4758: @246822
     /* 246822 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(246864), // Rule ID 11441 //
     /* 246827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 246854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246862 */     GIR_RootConstrainSelectedInstOperands,
     /* 246863 */     // GIR_Coverage, 11441,
     /* 246863 */     GIR_EraseRootFromParent_Done,
     /* 246864 */   // Label 4759: @246864
     /* 246864 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(246906), // Rule ID 11442 //
     /* 246869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 246896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246904 */     GIR_RootConstrainSelectedInstOperands,
     /* 246905 */     // GIR_Coverage, 11442,
     /* 246905 */     GIR_EraseRootFromParent_Done,
     /* 246906 */   // Label 4760: @246906
     /* 246906 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(246948), // Rule ID 11443 //
     /* 246911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 246919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 246938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246946 */     GIR_RootConstrainSelectedInstOperands,
     /* 246947 */     // GIR_Coverage, 11443,
     /* 246947 */     GIR_EraseRootFromParent_Done,
     /* 246948 */   // Label 4761: @246948
     /* 246948 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(246990), // Rule ID 11452 //
     /* 246953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 246961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 246980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246988 */     GIR_RootConstrainSelectedInstOperands,
     /* 246989 */     // GIR_Coverage, 11452,
     /* 246989 */     GIR_EraseRootFromParent_Done,
     /* 246990 */   // Label 4762: @246990
     /* 246990 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247032), // Rule ID 11453 //
     /* 246995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 247003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 247022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247030 */     GIR_RootConstrainSelectedInstOperands,
     /* 247031 */     // GIR_Coverage, 11453,
     /* 247031 */     GIR_EraseRootFromParent_Done,
     /* 247032 */   // Label 4763: @247032
     /* 247032 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247074), // Rule ID 11454 //
     /* 247037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 247045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 247064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247072 */     GIR_RootConstrainSelectedInstOperands,
     /* 247073 */     // GIR_Coverage, 11454,
     /* 247073 */     GIR_EraseRootFromParent_Done,
     /* 247074 */   // Label 4764: @247074
     /* 247074 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247116), // Rule ID 11455 //
     /* 247079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 247087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 247106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247114 */     GIR_RootConstrainSelectedInstOperands,
     /* 247115 */     // GIR_Coverage, 11455,
     /* 247115 */     GIR_EraseRootFromParent_Done,
     /* 247116 */   // Label 4765: @247116
     /* 247116 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(247158), // Rule ID 11456 //
     /* 247121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 247129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 247148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247156 */     GIR_RootConstrainSelectedInstOperands,
     /* 247157 */     // GIR_Coverage, 11456,
     /* 247157 */     GIR_EraseRootFromParent_Done,
     /* 247158 */   // Label 4766: @247158
     /* 247158 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(247200), // Rule ID 11457 //
     /* 247163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 247171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 247190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247198 */     GIR_RootConstrainSelectedInstOperands,
     /* 247199 */     // GIR_Coverage, 11457,
     /* 247199 */     GIR_EraseRootFromParent_Done,
     /* 247200 */   // Label 4767: @247200
     /* 247200 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(247242), // Rule ID 11458 //
     /* 247205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 247232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247240 */     GIR_RootConstrainSelectedInstOperands,
     /* 247241 */     // GIR_Coverage, 11458,
     /* 247241 */     GIR_EraseRootFromParent_Done,
     /* 247242 */   // Label 4768: @247242
     /* 247242 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(247284), // Rule ID 11459 //
     /* 247247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 247274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247282 */     GIR_RootConstrainSelectedInstOperands,
     /* 247283 */     // GIR_Coverage, 11459,
     /* 247283 */     GIR_EraseRootFromParent_Done,
     /* 247284 */   // Label 4769: @247284
     /* 247284 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(247326), // Rule ID 11460 //
     /* 247289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 247297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247313 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 247316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247324 */     GIR_RootConstrainSelectedInstOperands,
     /* 247325 */     // GIR_Coverage, 11460,
     /* 247325 */     GIR_EraseRootFromParent_Done,
     /* 247326 */   // Label 4770: @247326
     /* 247326 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(247368), // Rule ID 11461 //
     /* 247331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 247358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247366 */     GIR_RootConstrainSelectedInstOperands,
     /* 247367 */     // GIR_Coverage, 11461,
     /* 247367 */     GIR_EraseRootFromParent_Done,
     /* 247368 */   // Label 4771: @247368
     /* 247368 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(247410), // Rule ID 11462 //
     /* 247373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 247400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247408 */     GIR_RootConstrainSelectedInstOperands,
     /* 247409 */     // GIR_Coverage, 11462,
     /* 247409 */     GIR_EraseRootFromParent_Done,
     /* 247410 */   // Label 4772: @247410
     /* 247410 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(247452), // Rule ID 11463 //
     /* 247415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 247423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247439 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 247442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247450 */     GIR_RootConstrainSelectedInstOperands,
     /* 247451 */     // GIR_Coverage, 11463,
     /* 247451 */     GIR_EraseRootFromParent_Done,
     /* 247452 */   // Label 4773: @247452
     /* 247452 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(247494), // Rule ID 11464 //
     /* 247457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1794:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 247484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247492 */     GIR_RootConstrainSelectedInstOperands,
     /* 247493 */     // GIR_Coverage, 11464,
     /* 247493 */     GIR_EraseRootFromParent_Done,
     /* 247494 */   // Label 4774: @247494
     /* 247494 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(247536), // Rule ID 11465 //
     /* 247499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 247526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247534 */     GIR_RootConstrainSelectedInstOperands,
     /* 247535 */     // GIR_Coverage, 11465,
     /* 247535 */     GIR_EraseRootFromParent_Done,
     /* 247536 */   // Label 4775: @247536
     /* 247536 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(247578), // Rule ID 11466 //
     /* 247541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 247549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 247568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247576 */     GIR_RootConstrainSelectedInstOperands,
     /* 247577 */     // GIR_Coverage, 11466,
     /* 247577 */     GIR_EraseRootFromParent_Done,
     /* 247578 */   // Label 4776: @247578
     /* 247578 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(247620), // Rule ID 11467 //
     /* 247583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 247610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247618 */     GIR_RootConstrainSelectedInstOperands,
     /* 247619 */     // GIR_Coverage, 11467,
     /* 247619 */     GIR_EraseRootFromParent_Done,
     /* 247620 */   // Label 4777: @247620
     /* 247620 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247662), // Rule ID 11468 //
     /* 247625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 247652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247660 */     GIR_RootConstrainSelectedInstOperands,
     /* 247661 */     // GIR_Coverage, 11468,
     /* 247661 */     GIR_EraseRootFromParent_Done,
     /* 247662 */   // Label 4778: @247662
     /* 247662 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247704), // Rule ID 11469 //
     /* 247667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 247675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 247694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247702 */     GIR_RootConstrainSelectedInstOperands,
     /* 247703 */     // GIR_Coverage, 11469,
     /* 247703 */     GIR_EraseRootFromParent_Done,
     /* 247704 */   // Label 4779: @247704
     /* 247704 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247746), // Rule ID 11470 //
     /* 247709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 247736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247744 */     GIR_RootConstrainSelectedInstOperands,
     /* 247745 */     // GIR_Coverage, 11470,
     /* 247745 */     GIR_EraseRootFromParent_Done,
     /* 247746 */   // Label 4780: @247746
     /* 247746 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247788), // Rule ID 11472 //
     /* 247751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 247778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247786 */     GIR_RootConstrainSelectedInstOperands,
     /* 247787 */     // GIR_Coverage, 11472,
     /* 247787 */     GIR_EraseRootFromParent_Done,
     /* 247788 */   // Label 4781: @247788
     /* 247788 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247830), // Rule ID 11474 //
     /* 247793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 247820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247828 */     GIR_RootConstrainSelectedInstOperands,
     /* 247829 */     // GIR_Coverage, 11474,
     /* 247829 */     GIR_EraseRootFromParent_Done,
     /* 247830 */   // Label 4782: @247830
     /* 247830 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247872), // Rule ID 11476 //
     /* 247835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 247843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 247862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247870 */     GIR_RootConstrainSelectedInstOperands,
     /* 247871 */     // GIR_Coverage, 11476,
     /* 247871 */     GIR_EraseRootFromParent_Done,
     /* 247872 */   // Label 4783: @247872
     /* 247872 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247914), // Rule ID 11478 //
     /* 247877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 247904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247912 */     GIR_RootConstrainSelectedInstOperands,
     /* 247913 */     // GIR_Coverage, 11478,
     /* 247913 */     GIR_EraseRootFromParent_Done,
     /* 247914 */   // Label 4784: @247914
     /* 247914 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247956), // Rule ID 11479 //
     /* 247919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 247946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247954 */     GIR_RootConstrainSelectedInstOperands,
     /* 247955 */     // GIR_Coverage, 11479,
     /* 247955 */     GIR_EraseRootFromParent_Done,
     /* 247956 */   // Label 4785: @247956
     /* 247956 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247998), // Rule ID 11480 //
     /* 247961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 247969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 247988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247996 */     GIR_RootConstrainSelectedInstOperands,
     /* 247997 */     // GIR_Coverage, 11480,
     /* 247997 */     GIR_EraseRootFromParent_Done,
     /* 247998 */   // Label 4786: @247998
     /* 247998 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248040), // Rule ID 11481 //
     /* 248003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 248011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 248030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248038 */     GIR_RootConstrainSelectedInstOperands,
     /* 248039 */     // GIR_Coverage, 11481,
     /* 248039 */     GIR_EraseRootFromParent_Done,
     /* 248040 */   // Label 4787: @248040
     /* 248040 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(248082), // Rule ID 11482 //
     /* 248045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 248053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 248072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248080 */     GIR_RootConstrainSelectedInstOperands,
     /* 248081 */     // GIR_Coverage, 11482,
     /* 248081 */     GIR_EraseRootFromParent_Done,
     /* 248082 */   // Label 4788: @248082
     /* 248082 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(248124), // Rule ID 11483 //
     /* 248087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 248095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 248114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248122 */     GIR_RootConstrainSelectedInstOperands,
     /* 248123 */     // GIR_Coverage, 11483,
     /* 248123 */     GIR_EraseRootFromParent_Done,
     /* 248124 */   // Label 4789: @248124
     /* 248124 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(248166), // Rule ID 11484 //
     /* 248129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 248137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 248156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248164 */     GIR_RootConstrainSelectedInstOperands,
     /* 248165 */     // GIR_Coverage, 11484,
     /* 248165 */     GIR_EraseRootFromParent_Done,
     /* 248166 */   // Label 4790: @248166
     /* 248166 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(248208), // Rule ID 11485 //
     /* 248171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 248179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 248198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248206 */     GIR_RootConstrainSelectedInstOperands,
     /* 248207 */     // GIR_Coverage, 11485,
     /* 248207 */     GIR_EraseRootFromParent_Done,
     /* 248208 */   // Label 4791: @248208
     /* 248208 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(248250), // Rule ID 11486 //
     /* 248213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 248240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248248 */     GIR_RootConstrainSelectedInstOperands,
     /* 248249 */     // GIR_Coverage, 11486,
     /* 248249 */     GIR_EraseRootFromParent_Done,
     /* 248250 */   // Label 4792: @248250
     /* 248250 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(248292), // Rule ID 11488 //
     /* 248255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 248282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248290 */     GIR_RootConstrainSelectedInstOperands,
     /* 248291 */     // GIR_Coverage, 11488,
     /* 248291 */     GIR_EraseRootFromParent_Done,
     /* 248292 */   // Label 4793: @248292
     /* 248292 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248334), // Rule ID 11490 //
     /* 248297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 248324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248332 */     GIR_RootConstrainSelectedInstOperands,
     /* 248333 */     // GIR_Coverage, 11490,
     /* 248333 */     GIR_EraseRootFromParent_Done,
     /* 248334 */   // Label 4794: @248334
     /* 248334 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248376), // Rule ID 11492 //
     /* 248339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 248347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 248366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248374 */     GIR_RootConstrainSelectedInstOperands,
     /* 248375 */     // GIR_Coverage, 11492,
     /* 248375 */     GIR_EraseRootFromParent_Done,
     /* 248376 */   // Label 4795: @248376
     /* 248376 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248418), // Rule ID 11494 //
     /* 248381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 248408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248416 */     GIR_RootConstrainSelectedInstOperands,
     /* 248417 */     // GIR_Coverage, 11494,
     /* 248417 */     GIR_EraseRootFromParent_Done,
     /* 248418 */   // Label 4796: @248418
     /* 248418 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248460), // Rule ID 11496 //
     /* 248423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 248450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248458 */     GIR_RootConstrainSelectedInstOperands,
     /* 248459 */     // GIR_Coverage, 11496,
     /* 248459 */     GIR_EraseRootFromParent_Done,
     /* 248460 */   // Label 4797: @248460
     /* 248460 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248502), // Rule ID 11498 //
     /* 248465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 248492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248500 */     GIR_RootConstrainSelectedInstOperands,
     /* 248501 */     // GIR_Coverage, 11498,
     /* 248501 */     GIR_EraseRootFromParent_Done,
     /* 248502 */   // Label 4798: @248502
     /* 248502 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248544), // Rule ID 11500 //
     /* 248507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 248515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2054:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 248534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248542 */     GIR_RootConstrainSelectedInstOperands,
     /* 248543 */     // GIR_Coverage, 11500,
     /* 248543 */     GIR_EraseRootFromParent_Done,
     /* 248544 */   // Label 4799: @248544
     /* 248544 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248586), // Rule ID 11502 //
     /* 248549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 248576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248584 */     GIR_RootConstrainSelectedInstOperands,
     /* 248585 */     // GIR_Coverage, 11502,
     /* 248585 */     GIR_EraseRootFromParent_Done,
     /* 248586 */   // Label 4800: @248586
     /* 248586 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248628), // Rule ID 11503 //
     /* 248591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 248618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248626 */     GIR_RootConstrainSelectedInstOperands,
     /* 248627 */     // GIR_Coverage, 11503,
     /* 248627 */     GIR_EraseRootFromParent_Done,
     /* 248628 */   // Label 4801: @248628
     /* 248628 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248670), // Rule ID 11504 //
     /* 248633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 248660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248668 */     GIR_RootConstrainSelectedInstOperands,
     /* 248669 */     // GIR_Coverage, 11504,
     /* 248669 */     GIR_EraseRootFromParent_Done,
     /* 248670 */   // Label 4802: @248670
     /* 248670 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248712), // Rule ID 11505 //
     /* 248675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 248683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 248702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248710 */     GIR_RootConstrainSelectedInstOperands,
     /* 248711 */     // GIR_Coverage, 11505,
     /* 248711 */     GIR_EraseRootFromParent_Done,
     /* 248712 */   // Label 4803: @248712
     /* 248712 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248754), // Rule ID 11506 //
     /* 248717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248741 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 248744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248752 */     GIR_RootConstrainSelectedInstOperands,
     /* 248753 */     // GIR_Coverage, 11506,
     /* 248753 */     GIR_EraseRootFromParent_Done,
     /* 248754 */   // Label 4804: @248754
     /* 248754 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248796), // Rule ID 11507 //
     /* 248759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 248786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248794 */     GIR_RootConstrainSelectedInstOperands,
     /* 248795 */     // GIR_Coverage, 11507,
     /* 248795 */     GIR_EraseRootFromParent_Done,
     /* 248796 */   // Label 4805: @248796
     /* 248796 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248838), // Rule ID 11508 //
     /* 248801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 248828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248836 */     GIR_RootConstrainSelectedInstOperands,
     /* 248837 */     // GIR_Coverage, 11508,
     /* 248837 */     GIR_EraseRootFromParent_Done,
     /* 248838 */   // Label 4806: @248838
     /* 248838 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248880), // Rule ID 11509 //
     /* 248843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 248851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 248870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248878 */     GIR_RootConstrainSelectedInstOperands,
     /* 248879 */     // GIR_Coverage, 11509,
     /* 248879 */     GIR_EraseRootFromParent_Done,
     /* 248880 */   // Label 4807: @248880
     /* 248880 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(248922), // Rule ID 11510 //
     /* 248885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 248912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248920 */     GIR_RootConstrainSelectedInstOperands,
     /* 248921 */     // GIR_Coverage, 11510,
     /* 248921 */     GIR_EraseRootFromParent_Done,
     /* 248922 */   // Label 4808: @248922
     /* 248922 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(248964), // Rule ID 11511 //
     /* 248927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 248954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248962 */     GIR_RootConstrainSelectedInstOperands,
     /* 248963 */     // GIR_Coverage, 11511,
     /* 248963 */     GIR_EraseRootFromParent_Done,
     /* 248964 */   // Label 4809: @248964
     /* 248964 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249006), // Rule ID 11512 //
     /* 248969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 248977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1944:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 248996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249004 */     GIR_RootConstrainSelectedInstOperands,
     /* 249005 */     // GIR_Coverage, 11512,
     /* 249005 */     GIR_EraseRootFromParent_Done,
     /* 249006 */   // Label 4810: @249006
     /* 249006 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249048), // Rule ID 11513 //
     /* 249011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 249019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 249038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249046 */     GIR_RootConstrainSelectedInstOperands,
     /* 249047 */     // GIR_Coverage, 11513,
     /* 249047 */     GIR_EraseRootFromParent_Done,
     /* 249048 */   // Label 4811: @249048
     /* 249048 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249090), // Rule ID 11514 //
     /* 249053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 249061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 249080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249088 */     GIR_RootConstrainSelectedInstOperands,
     /* 249089 */     // GIR_Coverage, 11514,
     /* 249089 */     GIR_EraseRootFromParent_Done,
     /* 249090 */   // Label 4812: @249090
     /* 249090 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249132), // Rule ID 11515 //
     /* 249095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 249103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 249122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249130 */     GIR_RootConstrainSelectedInstOperands,
     /* 249131 */     // GIR_Coverage, 11515,
     /* 249131 */     GIR_EraseRootFromParent_Done,
     /* 249132 */   // Label 4813: @249132
     /* 249132 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249174), // Rule ID 11516 //
     /* 249137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 249145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 249164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249172 */     GIR_RootConstrainSelectedInstOperands,
     /* 249173 */     // GIR_Coverage, 11516,
     /* 249173 */     GIR_EraseRootFromParent_Done,
     /* 249174 */   // Label 4814: @249174
     /* 249174 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249216), // Rule ID 11517 //
     /* 249179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 249206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249214 */     GIR_RootConstrainSelectedInstOperands,
     /* 249215 */     // GIR_Coverage, 11517,
     /* 249215 */     GIR_EraseRootFromParent_Done,
     /* 249216 */   // Label 4815: @249216
     /* 249216 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249258), // Rule ID 11518 //
     /* 249221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 249248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249256 */     GIR_RootConstrainSelectedInstOperands,
     /* 249257 */     // GIR_Coverage, 11518,
     /* 249257 */     GIR_EraseRootFromParent_Done,
     /* 249258 */   // Label 4816: @249258
     /* 249258 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249300), // Rule ID 11519 //
     /* 249263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 249290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249298 */     GIR_RootConstrainSelectedInstOperands,
     /* 249299 */     // GIR_Coverage, 11519,
     /* 249299 */     GIR_EraseRootFromParent_Done,
     /* 249300 */   // Label 4817: @249300
     /* 249300 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249342), // Rule ID 11520 //
     /* 249305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 249313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 249332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249340 */     GIR_RootConstrainSelectedInstOperands,
     /* 249341 */     // GIR_Coverage, 11520,
     /* 249341 */     GIR_EraseRootFromParent_Done,
     /* 249342 */   // Label 4818: @249342
     /* 249342 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249384), // Rule ID 11521 //
     /* 249347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 249374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249382 */     GIR_RootConstrainSelectedInstOperands,
     /* 249383 */     // GIR_Coverage, 11521,
     /* 249383 */     GIR_EraseRootFromParent_Done,
     /* 249384 */   // Label 4819: @249384
     /* 249384 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249426), // Rule ID 11522 //
     /* 249389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 249416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249424 */     GIR_RootConstrainSelectedInstOperands,
     /* 249425 */     // GIR_Coverage, 11522,
     /* 249425 */     GIR_EraseRootFromParent_Done,
     /* 249426 */   // Label 4820: @249426
     /* 249426 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249468), // Rule ID 11523 //
     /* 249431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249455 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 249458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249466 */     GIR_RootConstrainSelectedInstOperands,
     /* 249467 */     // GIR_Coverage, 11523,
     /* 249467 */     GIR_EraseRootFromParent_Done,
     /* 249468 */   // Label 4821: @249468
     /* 249468 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249510), // Rule ID 11524 //
     /* 249473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 249481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 249500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249508 */     GIR_RootConstrainSelectedInstOperands,
     /* 249509 */     // GIR_Coverage, 11524,
     /* 249509 */     GIR_EraseRootFromParent_Done,
     /* 249510 */   // Label 4822: @249510
     /* 249510 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249552), // Rule ID 11525 //
     /* 249515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 249542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249550 */     GIR_RootConstrainSelectedInstOperands,
     /* 249551 */     // GIR_Coverage, 11525,
     /* 249551 */     GIR_EraseRootFromParent_Done,
     /* 249552 */   // Label 4823: @249552
     /* 249552 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(249594), // Rule ID 11526 //
     /* 249557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 249584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249592 */     GIR_RootConstrainSelectedInstOperands,
     /* 249593 */     // GIR_Coverage, 11526,
     /* 249593 */     GIR_EraseRootFromParent_Done,
     /* 249594 */   // Label 4824: @249594
     /* 249594 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(249636), // Rule ID 11527 //
     /* 249599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 249626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249634 */     GIR_RootConstrainSelectedInstOperands,
     /* 249635 */     // GIR_Coverage, 11527,
     /* 249635 */     GIR_EraseRootFromParent_Done,
     /* 249636 */   // Label 4825: @249636
     /* 249636 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(249678), // Rule ID 11528 //
     /* 249641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 249649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 249668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249676 */     GIR_RootConstrainSelectedInstOperands,
     /* 249677 */     // GIR_Coverage, 11528,
     /* 249677 */     GIR_EraseRootFromParent_Done,
     /* 249678 */   // Label 4826: @249678
     /* 249678 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(249720), // Rule ID 11529 //
     /* 249683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 249710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249718 */     GIR_RootConstrainSelectedInstOperands,
     /* 249719 */     // GIR_Coverage, 11529,
     /* 249719 */     GIR_EraseRootFromParent_Done,
     /* 249720 */   // Label 4827: @249720
     /* 249720 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(249762), // Rule ID 11530 //
     /* 249725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 249752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249760 */     GIR_RootConstrainSelectedInstOperands,
     /* 249761 */     // GIR_Coverage, 11530,
     /* 249761 */     GIR_EraseRootFromParent_Done,
     /* 249762 */   // Label 4828: @249762
     /* 249762 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(249804), // Rule ID 11531 //
     /* 249767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 249794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249802 */     GIR_RootConstrainSelectedInstOperands,
     /* 249803 */     // GIR_Coverage, 11531,
     /* 249803 */     GIR_EraseRootFromParent_Done,
     /* 249804 */   // Label 4829: @249804
     /* 249804 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(249846), // Rule ID 11532 //
     /* 249809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 249817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249833 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 249836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249844 */     GIR_RootConstrainSelectedInstOperands,
     /* 249845 */     // GIR_Coverage, 11532,
     /* 249845 */     GIR_EraseRootFromParent_Done,
     /* 249846 */   // Label 4830: @249846
     /* 249846 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(249888), // Rule ID 11533 //
     /* 249851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 249859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 249878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249886 */     GIR_RootConstrainSelectedInstOperands,
     /* 249887 */     // GIR_Coverage, 11533,
     /* 249887 */     GIR_EraseRootFromParent_Done,
     /* 249888 */   // Label 4831: @249888
     /* 249888 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(249930), // Rule ID 11544 //
     /* 249893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 249907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 249910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 249920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249928 */     GIR_RootConstrainSelectedInstOperands,
     /* 249929 */     // GIR_Coverage, 11544,
     /* 249929 */     GIR_EraseRootFromParent_Done,
     /* 249930 */   // Label 4832: @249930
     /* 249930 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(249972), // Rule ID 11545 //
     /* 249935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 249952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 249962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249970 */     GIR_RootConstrainSelectedInstOperands,
     /* 249971 */     // GIR_Coverage, 11545,
     /* 249971 */     GIR_EraseRootFromParent_Done,
     /* 249972 */   // Label 4833: @249972
     /* 249972 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250014), // Rule ID 11546 //
     /* 249977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 249985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 250004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250012 */     GIR_RootConstrainSelectedInstOperands,
     /* 250013 */     // GIR_Coverage, 11546,
     /* 250013 */     GIR_EraseRootFromParent_Done,
     /* 250014 */   // Label 4834: @250014
     /* 250014 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250056), // Rule ID 11547 //
     /* 250019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 250027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 250036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 250046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250054 */     GIR_RootConstrainSelectedInstOperands,
     /* 250055 */     // GIR_Coverage, 11547,
     /* 250055 */     GIR_EraseRootFromParent_Done,
     /* 250056 */   // Label 4835: @250056
     /* 250056 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250098), // Rule ID 11556 //
     /* 250061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 250069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1767:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 250088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250096 */     GIR_RootConstrainSelectedInstOperands,
     /* 250097 */     // GIR_Coverage, 11556,
     /* 250097 */     GIR_EraseRootFromParent_Done,
     /* 250098 */   // Label 4836: @250098
     /* 250098 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250140), // Rule ID 11557 //
     /* 250103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 250111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1767:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 250130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250138 */     GIR_RootConstrainSelectedInstOperands,
     /* 250139 */     // GIR_Coverage, 11557,
     /* 250139 */     GIR_EraseRootFromParent_Done,
     /* 250140 */   // Label 4837: @250140
     /* 250140 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250182), // Rule ID 11558 //
     /* 250145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 250153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 250172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250180 */     GIR_RootConstrainSelectedInstOperands,
     /* 250181 */     // GIR_Coverage, 11558,
     /* 250181 */     GIR_EraseRootFromParent_Done,
     /* 250182 */   // Label 4838: @250182
     /* 250182 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250224), // Rule ID 11559 //
     /* 250187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 250195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 250214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250222 */     GIR_RootConstrainSelectedInstOperands,
     /* 250223 */     // GIR_Coverage, 11559,
     /* 250223 */     GIR_EraseRootFromParent_Done,
     /* 250224 */   // Label 4839: @250224
     /* 250224 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(250266), // Rule ID 11560 //
     /* 250229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2003:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 250256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250264 */     GIR_RootConstrainSelectedInstOperands,
     /* 250265 */     // GIR_Coverage, 11560,
     /* 250265 */     GIR_EraseRootFromParent_Done,
     /* 250266 */   // Label 4840: @250266
     /* 250266 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(250308), // Rule ID 11561 //
     /* 250271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2003:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 250298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250306 */     GIR_RootConstrainSelectedInstOperands,
     /* 250307 */     // GIR_Coverage, 11561,
     /* 250307 */     GIR_EraseRootFromParent_Done,
     /* 250308 */   // Label 4841: @250308
     /* 250308 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(250350), // Rule ID 11562 //
     /* 250313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 250340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250348 */     GIR_RootConstrainSelectedInstOperands,
     /* 250349 */     // GIR_Coverage, 11562,
     /* 250349 */     GIR_EraseRootFromParent_Done,
     /* 250350 */   // Label 4842: @250350
     /* 250350 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(250392), // Rule ID 11563 //
     /* 250355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 250363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 250382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250390 */     GIR_RootConstrainSelectedInstOperands,
     /* 250391 */     // GIR_Coverage, 11563,
     /* 250391 */     GIR_EraseRootFromParent_Done,
     /* 250392 */   // Label 4843: @250392
     /* 250392 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(250434), // Rule ID 11564 //
     /* 250397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 250424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250432 */     GIR_RootConstrainSelectedInstOperands,
     /* 250433 */     // GIR_Coverage, 11564,
     /* 250433 */     GIR_EraseRootFromParent_Done,
     /* 250434 */   // Label 4844: @250434
     /* 250434 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(250476), // Rule ID 11565 //
     /* 250439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 250466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250474 */     GIR_RootConstrainSelectedInstOperands,
     /* 250475 */     // GIR_Coverage, 11565,
     /* 250475 */     GIR_EraseRootFromParent_Done,
     /* 250476 */   // Label 4845: @250476
     /* 250476 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(250518), // Rule ID 11566 //
     /* 250481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 250508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250516 */     GIR_RootConstrainSelectedInstOperands,
     /* 250517 */     // GIR_Coverage, 11566,
     /* 250517 */     GIR_EraseRootFromParent_Done,
     /* 250518 */   // Label 4846: @250518
     /* 250518 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(250560), // Rule ID 11567 //
     /* 250523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 250531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 250550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250558 */     GIR_RootConstrainSelectedInstOperands,
     /* 250559 */     // GIR_Coverage, 11567,
     /* 250559 */     GIR_EraseRootFromParent_Done,
     /* 250560 */   // Label 4847: @250560
     /* 250560 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(250602), // Rule ID 11568 //
     /* 250565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 250592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250600 */     GIR_RootConstrainSelectedInstOperands,
     /* 250601 */     // GIR_Coverage, 11568,
     /* 250601 */     GIR_EraseRootFromParent_Done,
     /* 250602 */   // Label 4848: @250602
     /* 250602 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(250644), // Rule ID 11569 //
     /* 250607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 250634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250642 */     GIR_RootConstrainSelectedInstOperands,
     /* 250643 */     // GIR_Coverage, 11569,
     /* 250643 */     GIR_EraseRootFromParent_Done,
     /* 250644 */   // Label 4849: @250644
     /* 250644 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(250686), // Rule ID 11570 //
     /* 250649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 250676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250684 */     GIR_RootConstrainSelectedInstOperands,
     /* 250685 */     // GIR_Coverage, 11570,
     /* 250685 */     GIR_EraseRootFromParent_Done,
     /* 250686 */   // Label 4850: @250686
     /* 250686 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(250728), // Rule ID 11571 //
     /* 250691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 250699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 250718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250726 */     GIR_RootConstrainSelectedInstOperands,
     /* 250727 */     // GIR_Coverage, 11571,
     /* 250727 */     GIR_EraseRootFromParent_Done,
     /* 250728 */   // Label 4851: @250728
     /* 250728 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(250770), // Rule ID 11572 //
     /* 250733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 250760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250768 */     GIR_RootConstrainSelectedInstOperands,
     /* 250769 */     // GIR_Coverage, 11572,
     /* 250769 */     GIR_EraseRootFromParent_Done,
     /* 250770 */   // Label 4852: @250770
     /* 250770 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(250812), // Rule ID 11573 //
     /* 250775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 250802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250810 */     GIR_RootConstrainSelectedInstOperands,
     /* 250811 */     // GIR_Coverage, 11573,
     /* 250811 */     GIR_EraseRootFromParent_Done,
     /* 250812 */   // Label 4853: @250812
     /* 250812 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(250854), // Rule ID 11574 //
     /* 250817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 250844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250852 */     GIR_RootConstrainSelectedInstOperands,
     /* 250853 */     // GIR_Coverage, 11574,
     /* 250853 */     GIR_EraseRootFromParent_Done,
     /* 250854 */   // Label 4854: @250854
     /* 250854 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(250896), // Rule ID 11575 //
     /* 250859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 250867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 250886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250894 */     GIR_RootConstrainSelectedInstOperands,
     /* 250895 */     // GIR_Coverage, 11575,
     /* 250895 */     GIR_EraseRootFromParent_Done,
     /* 250896 */   // Label 4855: @250896
     /* 250896 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(250938), // Rule ID 11576 //
     /* 250901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 250928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250936 */     GIR_RootConstrainSelectedInstOperands,
     /* 250937 */     // GIR_Coverage, 11576,
     /* 250937 */     GIR_EraseRootFromParent_Done,
     /* 250938 */   // Label 4856: @250938
     /* 250938 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(250980), // Rule ID 11577 //
     /* 250943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 250970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250978 */     GIR_RootConstrainSelectedInstOperands,
     /* 250979 */     // GIR_Coverage, 11577,
     /* 250979 */     GIR_EraseRootFromParent_Done,
     /* 250980 */   // Label 4857: @250980
     /* 250980 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251022), // Rule ID 11578 //
     /* 250985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 250993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 251012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251020 */     GIR_RootConstrainSelectedInstOperands,
     /* 251021 */     // GIR_Coverage, 11578,
     /* 251021 */     GIR_EraseRootFromParent_Done,
     /* 251022 */   // Label 4858: @251022
     /* 251022 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(251064), // Rule ID 11579 //
     /* 251027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 251035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 251054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251062 */     GIR_RootConstrainSelectedInstOperands,
     /* 251063 */     // GIR_Coverage, 11579,
     /* 251063 */     GIR_EraseRootFromParent_Done,
     /* 251064 */   // Label 4859: @251064
     /* 251064 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(251106), // Rule ID 11580 //
     /* 251069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 251077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 251096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251104 */     GIR_RootConstrainSelectedInstOperands,
     /* 251105 */     // GIR_Coverage, 11580,
     /* 251105 */     GIR_EraseRootFromParent_Done,
     /* 251106 */   // Label 4860: @251106
     /* 251106 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(251148), // Rule ID 11581 //
     /* 251111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 251119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 251138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251146 */     GIR_RootConstrainSelectedInstOperands,
     /* 251147 */     // GIR_Coverage, 11581,
     /* 251147 */     GIR_EraseRootFromParent_Done,
     /* 251148 */   // Label 4861: @251148
     /* 251148 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(251190), // Rule ID 11582 //
     /* 251153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 251161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 251180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251188 */     GIR_RootConstrainSelectedInstOperands,
     /* 251189 */     // GIR_Coverage, 11582,
     /* 251189 */     GIR_EraseRootFromParent_Done,
     /* 251190 */   // Label 4862: @251190
     /* 251190 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(251232), // Rule ID 11583 //
     /* 251195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 251203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 251222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251230 */     GIR_RootConstrainSelectedInstOperands,
     /* 251231 */     // GIR_Coverage, 11583,
     /* 251231 */     GIR_EraseRootFromParent_Done,
     /* 251232 */   // Label 4863: @251232
     /* 251232 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(251274), // Rule ID 11584 //
     /* 251237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 251264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251272 */     GIR_RootConstrainSelectedInstOperands,
     /* 251273 */     // GIR_Coverage, 11584,
     /* 251273 */     GIR_EraseRootFromParent_Done,
     /* 251274 */   // Label 4864: @251274
     /* 251274 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(251316), // Rule ID 11585 //
     /* 251279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251303 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 251306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251314 */     GIR_RootConstrainSelectedInstOperands,
     /* 251315 */     // GIR_Coverage, 11585,
     /* 251315 */     GIR_EraseRootFromParent_Done,
     /* 251316 */   // Label 4865: @251316
     /* 251316 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(251358), // Rule ID 11586 //
     /* 251321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 251348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251356 */     GIR_RootConstrainSelectedInstOperands,
     /* 251357 */     // GIR_Coverage, 11586,
     /* 251357 */     GIR_EraseRootFromParent_Done,
     /* 251358 */   // Label 4866: @251358
     /* 251358 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(251400), // Rule ID 11587 //
     /* 251363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 251371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 251390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251398 */     GIR_RootConstrainSelectedInstOperands,
     /* 251399 */     // GIR_Coverage, 11587,
     /* 251399 */     GIR_EraseRootFromParent_Done,
     /* 251400 */   // Label 4867: @251400
     /* 251400 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(251442), // Rule ID 11588 //
     /* 251405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 251432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251440 */     GIR_RootConstrainSelectedInstOperands,
     /* 251441 */     // GIR_Coverage, 11588,
     /* 251441 */     GIR_EraseRootFromParent_Done,
     /* 251442 */   // Label 4868: @251442
     /* 251442 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(251484), // Rule ID 11589 //
     /* 251447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 251474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251482 */     GIR_RootConstrainSelectedInstOperands,
     /* 251483 */     // GIR_Coverage, 11589,
     /* 251483 */     GIR_EraseRootFromParent_Done,
     /* 251484 */   // Label 4869: @251484
     /* 251484 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(251526), // Rule ID 11590 //
     /* 251489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 251516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251524 */     GIR_RootConstrainSelectedInstOperands,
     /* 251525 */     // GIR_Coverage, 11590,
     /* 251525 */     GIR_EraseRootFromParent_Done,
     /* 251526 */   // Label 4870: @251526
     /* 251526 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(251568), // Rule ID 11591 //
     /* 251531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 251539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 251558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251566 */     GIR_RootConstrainSelectedInstOperands,
     /* 251567 */     // GIR_Coverage, 11591,
     /* 251567 */     GIR_EraseRootFromParent_Done,
     /* 251568 */   // Label 4871: @251568
     /* 251568 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(251610), // Rule ID 11592 //
     /* 251573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 251600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251608 */     GIR_RootConstrainSelectedInstOperands,
     /* 251609 */     // GIR_Coverage, 11592,
     /* 251609 */     GIR_EraseRootFromParent_Done,
     /* 251610 */   // Label 4872: @251610
     /* 251610 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(251652), // Rule ID 11593 //
     /* 251615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 251642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251650 */     GIR_RootConstrainSelectedInstOperands,
     /* 251651 */     // GIR_Coverage, 11593,
     /* 251651 */     GIR_EraseRootFromParent_Done,
     /* 251652 */   // Label 4873: @251652
     /* 251652 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(251694), // Rule ID 11594 //
     /* 251657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 251684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251692 */     GIR_RootConstrainSelectedInstOperands,
     /* 251693 */     // GIR_Coverage, 11594,
     /* 251693 */     GIR_EraseRootFromParent_Done,
     /* 251694 */   // Label 4874: @251694
     /* 251694 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(251736), // Rule ID 11595 //
     /* 251699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 251707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 251726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251734 */     GIR_RootConstrainSelectedInstOperands,
     /* 251735 */     // GIR_Coverage, 11595,
     /* 251735 */     GIR_EraseRootFromParent_Done,
     /* 251736 */   // Label 4875: @251736
     /* 251736 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(251778), // Rule ID 11596 //
     /* 251741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 251768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251776 */     GIR_RootConstrainSelectedInstOperands,
     /* 251777 */     // GIR_Coverage, 11596,
     /* 251777 */     GIR_EraseRootFromParent_Done,
     /* 251778 */   // Label 4876: @251778
     /* 251778 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(251820), // Rule ID 11597 //
     /* 251783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 251810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251818 */     GIR_RootConstrainSelectedInstOperands,
     /* 251819 */     // GIR_Coverage, 11597,
     /* 251819 */     GIR_EraseRootFromParent_Done,
     /* 251820 */   // Label 4877: @251820
     /* 251820 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(251862), // Rule ID 11598 //
     /* 251825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 251852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251860 */     GIR_RootConstrainSelectedInstOperands,
     /* 251861 */     // GIR_Coverage, 11598,
     /* 251861 */     GIR_EraseRootFromParent_Done,
     /* 251862 */   // Label 4878: @251862
     /* 251862 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(251904), // Rule ID 11599 //
     /* 251867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 251875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 251894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251902 */     GIR_RootConstrainSelectedInstOperands,
     /* 251903 */     // GIR_Coverage, 11599,
     /* 251903 */     GIR_EraseRootFromParent_Done,
     /* 251904 */   // Label 4879: @251904
     /* 251904 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(251946), // Rule ID 11600 //
     /* 251909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251933 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 251936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251944 */     GIR_RootConstrainSelectedInstOperands,
     /* 251945 */     // GIR_Coverage, 11600,
     /* 251945 */     GIR_EraseRootFromParent_Done,
     /* 251946 */   // Label 4880: @251946
     /* 251946 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(251988), // Rule ID 11601 //
     /* 251951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 251959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 251978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251986 */     GIR_RootConstrainSelectedInstOperands,
     /* 251987 */     // GIR_Coverage, 11601,
     /* 251987 */     GIR_EraseRootFromParent_Done,
     /* 251988 */   // Label 4881: @251988
     /* 251988 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252030), // Rule ID 11602 //
     /* 251993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 252001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 252020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252028 */     GIR_RootConstrainSelectedInstOperands,
     /* 252029 */     // GIR_Coverage, 11602,
     /* 252029 */     GIR_EraseRootFromParent_Done,
     /* 252030 */   // Label 4882: @252030
     /* 252030 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(252072), // Rule ID 11603 //
     /* 252035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 252043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 252062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252070 */     GIR_RootConstrainSelectedInstOperands,
     /* 252071 */     // GIR_Coverage, 11603,
     /* 252071 */     GIR_EraseRootFromParent_Done,
     /* 252072 */   // Label 4883: @252072
     /* 252072 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(252114), // Rule ID 11604 //
     /* 252077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 252085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 252104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252112 */     GIR_RootConstrainSelectedInstOperands,
     /* 252113 */     // GIR_Coverage, 11604,
     /* 252113 */     GIR_EraseRootFromParent_Done,
     /* 252114 */   // Label 4884: @252114
     /* 252114 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(252156), // Rule ID 11605 //
     /* 252119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 252127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 252146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252154 */     GIR_RootConstrainSelectedInstOperands,
     /* 252155 */     // GIR_Coverage, 11605,
     /* 252155 */     GIR_EraseRootFromParent_Done,
     /* 252156 */   // Label 4885: @252156
     /* 252156 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(252198), // Rule ID 11606 //
     /* 252161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 252169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 252188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252196 */     GIR_RootConstrainSelectedInstOperands,
     /* 252197 */     // GIR_Coverage, 11606,
     /* 252197 */     GIR_EraseRootFromParent_Done,
     /* 252198 */   // Label 4886: @252198
     /* 252198 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(252240), // Rule ID 11607 //
     /* 252203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 252211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252238 */     GIR_RootConstrainSelectedInstOperands,
     /* 252239 */     // GIR_Coverage, 11607,
     /* 252239 */     GIR_EraseRootFromParent_Done,
     /* 252240 */   // Label 4887: @252240
     /* 252240 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(252282), // Rule ID 11608 //
     /* 252245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 252272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252280 */     GIR_RootConstrainSelectedInstOperands,
     /* 252281 */     // GIR_Coverage, 11608,
     /* 252281 */     GIR_EraseRootFromParent_Done,
     /* 252282 */   // Label 4888: @252282
     /* 252282 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(252324), // Rule ID 11609 //
     /* 252287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 252314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252322 */     GIR_RootConstrainSelectedInstOperands,
     /* 252323 */     // GIR_Coverage, 11609,
     /* 252323 */     GIR_EraseRootFromParent_Done,
     /* 252324 */   // Label 4889: @252324
     /* 252324 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(252366), // Rule ID 11610 //
     /* 252329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 252356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252364 */     GIR_RootConstrainSelectedInstOperands,
     /* 252365 */     // GIR_Coverage, 11610,
     /* 252365 */     GIR_EraseRootFromParent_Done,
     /* 252366 */   // Label 4890: @252366
     /* 252366 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(252408), // Rule ID 11611 //
     /* 252371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 252379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 252398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252406 */     GIR_RootConstrainSelectedInstOperands,
     /* 252407 */     // GIR_Coverage, 11611,
     /* 252407 */     GIR_EraseRootFromParent_Done,
     /* 252408 */   // Label 4891: @252408
     /* 252408 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(252450), // Rule ID 11786 //
     /* 252413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1937:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 252440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252448 */     GIR_RootConstrainSelectedInstOperands,
     /* 252449 */     // GIR_Coverage, 11786,
     /* 252449 */     GIR_EraseRootFromParent_Done,
     /* 252450 */   // Label 4892: @252450
     /* 252450 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(252492), // Rule ID 11788 //
     /* 252455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 252482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252490 */     GIR_RootConstrainSelectedInstOperands,
     /* 252491 */     // GIR_Coverage, 11788,
     /* 252491 */     GIR_EraseRootFromParent_Done,
     /* 252492 */   // Label 4893: @252492
     /* 252492 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(252534), // Rule ID 11790 //
     /* 252497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 252524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252532 */     GIR_RootConstrainSelectedInstOperands,
     /* 252533 */     // GIR_Coverage, 11790,
     /* 252533 */     GIR_EraseRootFromParent_Done,
     /* 252534 */   // Label 4894: @252534
     /* 252534 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(252576), // Rule ID 11792 //
     /* 252539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 252547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252563 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 252566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252574 */     GIR_RootConstrainSelectedInstOperands,
     /* 252575 */     // GIR_Coverage, 11792,
     /* 252575 */     GIR_EraseRootFromParent_Done,
     /* 252576 */   // Label 4895: @252576
     /* 252576 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(252618), // Rule ID 11794 //
     /* 252581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 252608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252616 */     GIR_RootConstrainSelectedInstOperands,
     /* 252617 */     // GIR_Coverage, 11794,
     /* 252617 */     GIR_EraseRootFromParent_Done,
     /* 252618 */   // Label 4896: @252618
     /* 252618 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(252660), // Rule ID 11795 //
     /* 252623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 252650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252658 */     GIR_RootConstrainSelectedInstOperands,
     /* 252659 */     // GIR_Coverage, 11795,
     /* 252659 */     GIR_EraseRootFromParent_Done,
     /* 252660 */   // Label 4897: @252660
     /* 252660 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(252702), // Rule ID 11796 //
     /* 252665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 252673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 252692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252700 */     GIR_RootConstrainSelectedInstOperands,
     /* 252701 */     // GIR_Coverage, 11796,
     /* 252701 */     GIR_EraseRootFromParent_Done,
     /* 252702 */   // Label 4898: @252702
     /* 252702 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(252744), // Rule ID 11797 //
     /* 252707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 252734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252742 */     GIR_RootConstrainSelectedInstOperands,
     /* 252743 */     // GIR_Coverage, 11797,
     /* 252743 */     GIR_EraseRootFromParent_Done,
     /* 252744 */   // Label 4899: @252744
     /* 252744 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(252786), // Rule ID 11798 //
     /* 252749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 252776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252784 */     GIR_RootConstrainSelectedInstOperands,
     /* 252785 */     // GIR_Coverage, 11798,
     /* 252785 */     GIR_EraseRootFromParent_Done,
     /* 252786 */   // Label 4900: @252786
     /* 252786 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(252828), // Rule ID 11799 //
     /* 252791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 252799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 252818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252826 */     GIR_RootConstrainSelectedInstOperands,
     /* 252827 */     // GIR_Coverage, 11799,
     /* 252827 */     GIR_EraseRootFromParent_Done,
     /* 252828 */   // Label 4901: @252828
     /* 252828 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(252870), // Rule ID 11800 //
     /* 252833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 252860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252868 */     GIR_RootConstrainSelectedInstOperands,
     /* 252869 */     // GIR_Coverage, 11800,
     /* 252869 */     GIR_EraseRootFromParent_Done,
     /* 252870 */   // Label 4902: @252870
     /* 252870 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(252912), // Rule ID 11801 //
     /* 252875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 252902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252910 */     GIR_RootConstrainSelectedInstOperands,
     /* 252911 */     // GIR_Coverage, 11801,
     /* 252911 */     GIR_EraseRootFromParent_Done,
     /* 252912 */   // Label 4903: @252912
     /* 252912 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(252954), // Rule ID 11802 //
     /* 252917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 252925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 252944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252952 */     GIR_RootConstrainSelectedInstOperands,
     /* 252953 */     // GIR_Coverage, 11802,
     /* 252953 */     GIR_EraseRootFromParent_Done,
     /* 252954 */   // Label 4904: @252954
     /* 252954 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(252996), // Rule ID 11803 //
     /* 252959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 252967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 252986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252994 */     GIR_RootConstrainSelectedInstOperands,
     /* 252995 */     // GIR_Coverage, 11803,
     /* 252995 */     GIR_EraseRootFromParent_Done,
     /* 252996 */   // Label 4905: @252996
     /* 252996 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253038), // Rule ID 11804 //
     /* 253001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 253009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 253028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253036 */     GIR_RootConstrainSelectedInstOperands,
     /* 253037 */     // GIR_Coverage, 11804,
     /* 253037 */     GIR_EraseRootFromParent_Done,
     /* 253038 */   // Label 4906: @253038
     /* 253038 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(253080), // Rule ID 11805 //
     /* 253043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 253051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 253070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253078 */     GIR_RootConstrainSelectedInstOperands,
     /* 253079 */     // GIR_Coverage, 11805,
     /* 253079 */     GIR_EraseRootFromParent_Done,
     /* 253080 */   // Label 4907: @253080
     /* 253080 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(253122), // Rule ID 11806 //
     /* 253085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 253093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 253112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253120 */     GIR_RootConstrainSelectedInstOperands,
     /* 253121 */     // GIR_Coverage, 11806,
     /* 253121 */     GIR_EraseRootFromParent_Done,
     /* 253122 */   // Label 4908: @253122
     /* 253122 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(253164), // Rule ID 11807 //
     /* 253127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 253135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 253154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253162 */     GIR_RootConstrainSelectedInstOperands,
     /* 253163 */     // GIR_Coverage, 11807,
     /* 253163 */     GIR_EraseRootFromParent_Done,
     /* 253164 */   // Label 4909: @253164
     /* 253164 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(253206), // Rule ID 11808 //
     /* 253169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 253177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 253196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253204 */     GIR_RootConstrainSelectedInstOperands,
     /* 253205 */     // GIR_Coverage, 11808,
     /* 253205 */     GIR_EraseRootFromParent_Done,
     /* 253206 */   // Label 4910: @253206
     /* 253206 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(253248), // Rule ID 11863 //
     /* 253211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1670:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 253238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253246 */     GIR_RootConstrainSelectedInstOperands,
     /* 253247 */     // GIR_Coverage, 11863,
     /* 253247 */     GIR_EraseRootFromParent_Done,
     /* 253248 */   // Label 4911: @253248
     /* 253248 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(253290), // Rule ID 11864 //
     /* 253253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1670:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 253280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253288 */     GIR_RootConstrainSelectedInstOperands,
     /* 253289 */     // GIR_Coverage, 11864,
     /* 253289 */     GIR_EraseRootFromParent_Done,
     /* 253290 */   // Label 4912: @253290
     /* 253290 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(253332), // Rule ID 11865 //
     /* 253295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 253303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1670:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 253322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253330 */     GIR_RootConstrainSelectedInstOperands,
     /* 253331 */     // GIR_Coverage, 11865,
     /* 253331 */     GIR_EraseRootFromParent_Done,
     /* 253332 */   // Label 4913: @253332
     /* 253332 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(253374), // Rule ID 11866 //
     /* 253337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 253364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253372 */     GIR_RootConstrainSelectedInstOperands,
     /* 253373 */     // GIR_Coverage, 11866,
     /* 253373 */     GIR_EraseRootFromParent_Done,
     /* 253374 */   // Label 4914: @253374
     /* 253374 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(253416), // Rule ID 11867 //
     /* 253379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 253406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253414 */     GIR_RootConstrainSelectedInstOperands,
     /* 253415 */     // GIR_Coverage, 11867,
     /* 253415 */     GIR_EraseRootFromParent_Done,
     /* 253416 */   // Label 4915: @253416
     /* 253416 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(253458), // Rule ID 11868 //
     /* 253421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 253429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 253448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253456 */     GIR_RootConstrainSelectedInstOperands,
     /* 253457 */     // GIR_Coverage, 11868,
     /* 253457 */     GIR_EraseRootFromParent_Done,
     /* 253458 */   // Label 4916: @253458
     /* 253458 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(253500), // Rule ID 11869 //
     /* 253463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253487 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 253490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253498 */     GIR_RootConstrainSelectedInstOperands,
     /* 253499 */     // GIR_Coverage, 11869,
     /* 253499 */     GIR_EraseRootFromParent_Done,
     /* 253500 */   // Label 4917: @253500
     /* 253500 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(253542), // Rule ID 11870 //
     /* 253505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 253532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253540 */     GIR_RootConstrainSelectedInstOperands,
     /* 253541 */     // GIR_Coverage, 11870,
     /* 253541 */     GIR_EraseRootFromParent_Done,
     /* 253542 */   // Label 4918: @253542
     /* 253542 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(253584), // Rule ID 11871 //
     /* 253547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 253555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 253574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253582 */     GIR_RootConstrainSelectedInstOperands,
     /* 253583 */     // GIR_Coverage, 11871,
     /* 253583 */     GIR_EraseRootFromParent_Done,
     /* 253584 */   // Label 4919: @253584
     /* 253584 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(253629), // Rule ID 11884 //
     /* 253589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 253592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 253597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 253600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 253613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 253616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 253618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 253627 */     GIR_RootConstrainSelectedInstOperands,
     /* 253628 */     // GIR_Coverage, 11884,
     /* 253628 */     GIR_EraseRootFromParent_Done,
     /* 253629 */   // Label 4920: @253629
     /* 253629 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(253674), // Rule ID 11885 //
     /* 253634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 253637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 253642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 253645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 253658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 253661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 253663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 253672 */     GIR_RootConstrainSelectedInstOperands,
     /* 253673 */     // GIR_Coverage, 11885,
     /* 253673 */     GIR_EraseRootFromParent_Done,
     /* 253674 */   // Label 4921: @253674
     /* 253674 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(253716), // Rule ID 11886 //
     /* 253679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253703 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 253706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253714 */     GIR_RootConstrainSelectedInstOperands,
     /* 253715 */     // GIR_Coverage, 11886,
     /* 253715 */     GIR_EraseRootFromParent_Done,
     /* 253716 */   // Label 4922: @253716
     /* 253716 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(253758), // Rule ID 11887 //
     /* 253721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 253748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253756 */     GIR_RootConstrainSelectedInstOperands,
     /* 253757 */     // GIR_Coverage, 11887,
     /* 253757 */     GIR_EraseRootFromParent_Done,
     /* 253758 */   // Label 4923: @253758
     /* 253758 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(253800), // Rule ID 11888 //
     /* 253763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 253790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253798 */     GIR_RootConstrainSelectedInstOperands,
     /* 253799 */     // GIR_Coverage, 11888,
     /* 253799 */     GIR_EraseRootFromParent_Done,
     /* 253800 */   // Label 4924: @253800
     /* 253800 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(253842), // Rule ID 11889 //
     /* 253805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 253813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 253832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253840 */     GIR_RootConstrainSelectedInstOperands,
     /* 253841 */     // GIR_Coverage, 11889,
     /* 253841 */     GIR_EraseRootFromParent_Done,
     /* 253842 */   // Label 4925: @253842
     /* 253842 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(253884), // Rule ID 11905 //
     /* 253847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253871 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 253871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 253874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253882 */     GIR_RootConstrainSelectedInstOperands,
     /* 253883 */     // GIR_Coverage, 11905,
     /* 253883 */     GIR_EraseRootFromParent_Done,
     /* 253884 */   // Label 4926: @253884
     /* 253884 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(253926), // Rule ID 11906 //
     /* 253889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253913 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 253913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 253916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253924 */     GIR_RootConstrainSelectedInstOperands,
     /* 253925 */     // GIR_Coverage, 11906,
     /* 253925 */     GIR_EraseRootFromParent_Done,
     /* 253926 */   // Label 4927: @253926
     /* 253926 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(253968), // Rule ID 11907 //
     /* 253931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 253939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253955 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 253955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 253958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253966 */     GIR_RootConstrainSelectedInstOperands,
     /* 253967 */     // GIR_Coverage, 11907,
     /* 253967 */     GIR_EraseRootFromParent_Done,
     /* 253968 */   // Label 4928: @253968
     /* 253968 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(254010), // Rule ID 11908 //
     /* 253973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 253981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253997 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 253997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 254000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254008 */     GIR_RootConstrainSelectedInstOperands,
     /* 254009 */     // GIR_Coverage, 11908,
     /* 254009 */     GIR_EraseRootFromParent_Done,
     /* 254010 */   // Label 4929: @254010
     /* 254010 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254052), // Rule ID 11909 //
     /* 254015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 254023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 254039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 254042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254050 */     GIR_RootConstrainSelectedInstOperands,
     /* 254051 */     // GIR_Coverage, 11909,
     /* 254051 */     GIR_EraseRootFromParent_Done,
     /* 254052 */   // Label 4930: @254052
     /* 254052 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(254094), // Rule ID 11910 //
     /* 254057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 254065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254081 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 254081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 254084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254092 */     GIR_RootConstrainSelectedInstOperands,
     /* 254093 */     // GIR_Coverage, 11910,
     /* 254093 */     GIR_EraseRootFromParent_Done,
     /* 254094 */   // Label 4931: @254094
     /* 254094 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(254136), // Rule ID 11911 //
     /* 254099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 254107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254123 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 254126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254134 */     GIR_RootConstrainSelectedInstOperands,
     /* 254135 */     // GIR_Coverage, 11911,
     /* 254135 */     GIR_EraseRootFromParent_Done,
     /* 254136 */   // Label 4932: @254136
     /* 254136 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(254178), // Rule ID 11912 //
     /* 254141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 254149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 254165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 254168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254176 */     GIR_RootConstrainSelectedInstOperands,
     /* 254177 */     // GIR_Coverage, 11912,
     /* 254177 */     GIR_EraseRootFromParent_Done,
     /* 254178 */   // Label 4933: @254178
     /* 254178 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(254220), // Rule ID 11913 //
     /* 254183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 254191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254207 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 254207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 254210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254218 */     GIR_RootConstrainSelectedInstOperands,
     /* 254219 */     // GIR_Coverage, 11913,
     /* 254219 */     GIR_EraseRootFromParent_Done,
     /* 254220 */   // Label 4934: @254220
     /* 254220 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(254262), // Rule ID 11914 //
     /* 254225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 254252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254260 */     GIR_RootConstrainSelectedInstOperands,
     /* 254261 */     // GIR_Coverage, 11914,
     /* 254261 */     GIR_EraseRootFromParent_Done,
     /* 254262 */   // Label 4935: @254262
     /* 254262 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(254304), // Rule ID 11915 //
     /* 254267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254291 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 254291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 254294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254302 */     GIR_RootConstrainSelectedInstOperands,
     /* 254303 */     // GIR_Coverage, 11915,
     /* 254303 */     GIR_EraseRootFromParent_Done,
     /* 254304 */   // Label 4936: @254304
     /* 254304 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(254346), // Rule ID 11916 //
     /* 254309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 254317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254333 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 254333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 254336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254344 */     GIR_RootConstrainSelectedInstOperands,
     /* 254345 */     // GIR_Coverage, 11916,
     /* 254345 */     GIR_EraseRootFromParent_Done,
     /* 254346 */   // Label 4937: @254346
     /* 254346 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(254388), // Rule ID 11921 //
     /* 254351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 254359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254375 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 254378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254386 */     GIR_RootConstrainSelectedInstOperands,
     /* 254387 */     // GIR_Coverage, 11921,
     /* 254387 */     GIR_EraseRootFromParent_Done,
     /* 254388 */   // Label 4938: @254388
     /* 254388 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(254430), // Rule ID 11922 //
     /* 254393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 254401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254417 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 254420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254428 */     GIR_RootConstrainSelectedInstOperands,
     /* 254429 */     // GIR_Coverage, 11922,
     /* 254429 */     GIR_EraseRootFromParent_Done,
     /* 254430 */   // Label 4939: @254430
     /* 254430 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(254472), // Rule ID 11923 //
     /* 254435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 254443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 254462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254470 */     GIR_RootConstrainSelectedInstOperands,
     /* 254471 */     // GIR_Coverage, 11923,
     /* 254471 */     GIR_EraseRootFromParent_Done,
     /* 254472 */   // Label 4940: @254472
     /* 254472 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(254514), // Rule ID 11924 //
     /* 254477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 254485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254501 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 254504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254512 */     GIR_RootConstrainSelectedInstOperands,
     /* 254513 */     // GIR_Coverage, 11924,
     /* 254513 */     GIR_EraseRootFromParent_Done,
     /* 254514 */   // Label 4941: @254514
     /* 254514 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(254556), // Rule ID 11925 //
     /* 254519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1278:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254554 */     GIR_RootConstrainSelectedInstOperands,
     /* 254555 */     // GIR_Coverage, 11925,
     /* 254555 */     GIR_EraseRootFromParent_Done,
     /* 254556 */   // Label 4942: @254556
     /* 254556 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(254598), // Rule ID 11927 //
     /* 254561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1278:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254596 */     GIR_RootConstrainSelectedInstOperands,
     /* 254597 */     // GIR_Coverage, 11927,
     /* 254597 */     GIR_EraseRootFromParent_Done,
     /* 254598 */   // Label 4943: @254598
     /* 254598 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(254640), // Rule ID 11929 //
     /* 254603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1278:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254638 */     GIR_RootConstrainSelectedInstOperands,
     /* 254639 */     // GIR_Coverage, 11929,
     /* 254639 */     GIR_EraseRootFromParent_Done,
     /* 254640 */   // Label 4944: @254640
     /* 254640 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(254682), // Rule ID 11931 //
     /* 254645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 254653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1278:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 254672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254680 */     GIR_RootConstrainSelectedInstOperands,
     /* 254681 */     // GIR_Coverage, 11931,
     /* 254681 */     GIR_EraseRootFromParent_Done,
     /* 254682 */   // Label 4945: @254682
     /* 254682 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(254724), // Rule ID 12056 //
     /* 254687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 254714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254722 */     GIR_RootConstrainSelectedInstOperands,
     /* 254723 */     // GIR_Coverage, 12056,
     /* 254723 */     GIR_EraseRootFromParent_Done,
     /* 254724 */   // Label 4946: @254724
     /* 254724 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(254766), // Rule ID 12058 //
     /* 254729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 254756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254764 */     GIR_RootConstrainSelectedInstOperands,
     /* 254765 */     // GIR_Coverage, 12058,
     /* 254765 */     GIR_EraseRootFromParent_Done,
     /* 254766 */   // Label 4947: @254766
     /* 254766 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(254808), // Rule ID 12060 //
     /* 254771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 254798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254806 */     GIR_RootConstrainSelectedInstOperands,
     /* 254807 */     // GIR_Coverage, 12060,
     /* 254807 */     GIR_EraseRootFromParent_Done,
     /* 254808 */   // Label 4948: @254808
     /* 254808 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(254850), // Rule ID 12062 //
     /* 254813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 254816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 254821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 254840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254848 */     GIR_RootConstrainSelectedInstOperands,
     /* 254849 */     // GIR_Coverage, 12062,
     /* 254849 */     GIR_EraseRootFromParent_Done,
     /* 254850 */   // Label 4949: @254850
     /* 254850 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(254892), // Rule ID 12064 //
     /* 254855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 254858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 254863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254879 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1428:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 254879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 254882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254890 */     GIR_RootConstrainSelectedInstOperands,
     /* 254891 */     // GIR_Coverage, 12064,
     /* 254891 */     GIR_EraseRootFromParent_Done,
     /* 254892 */   // Label 4950: @254892
     /* 254892 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(254934), // Rule ID 12066 //
     /* 254897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 254900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 254905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 254924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254932 */     GIR_RootConstrainSelectedInstOperands,
     /* 254933 */     // GIR_Coverage, 12066,
     /* 254933 */     GIR_EraseRootFromParent_Done,
     /* 254934 */   // Label 4951: @254934
     /* 254934 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(254976), // Rule ID 12229 //
     /* 254939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254963 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1926:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 254966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254974 */     GIR_RootConstrainSelectedInstOperands,
     /* 254975 */     // GIR_Coverage, 12229,
     /* 254975 */     GIR_EraseRootFromParent_Done,
     /* 254976 */   // Label 4952: @254976
     /* 254976 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255018), // Rule ID 12230 //
     /* 254981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 254984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 254989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1926:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 255008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255016 */     GIR_RootConstrainSelectedInstOperands,
     /* 255017 */     // GIR_Coverage, 12230,
     /* 255017 */     GIR_EraseRootFromParent_Done,
     /* 255018 */   // Label 4953: @255018
     /* 255018 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255060), // Rule ID 12231 //
     /* 255023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1926:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 255050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255058 */     GIR_RootConstrainSelectedInstOperands,
     /* 255059 */     // GIR_Coverage, 12231,
     /* 255059 */     GIR_EraseRootFromParent_Done,
     /* 255060 */   // Label 4954: @255060
     /* 255060 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(255102), // Rule ID 12232 //
     /* 255065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1926:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 255092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255100 */     GIR_RootConstrainSelectedInstOperands,
     /* 255101 */     // GIR_Coverage, 12232,
     /* 255101 */     GIR_EraseRootFromParent_Done,
     /* 255102 */   // Label 4955: @255102
     /* 255102 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(255144), // Rule ID 12233 //
     /* 255107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255131 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1926:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 255134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255142 */     GIR_RootConstrainSelectedInstOperands,
     /* 255143 */     // GIR_Coverage, 12233,
     /* 255143 */     GIR_EraseRootFromParent_Done,
     /* 255144 */   // Label 4956: @255144
     /* 255144 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(255186), // Rule ID 12234 //
     /* 255149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255173 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1926:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 255176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255184 */     GIR_RootConstrainSelectedInstOperands,
     /* 255185 */     // GIR_Coverage, 12234,
     /* 255185 */     GIR_EraseRootFromParent_Done,
     /* 255186 */   // Label 4957: @255186
     /* 255186 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(255228), // Rule ID 12235 //
     /* 255191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 255194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 255199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1926:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 255218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255226 */     GIR_RootConstrainSelectedInstOperands,
     /* 255227 */     // GIR_Coverage, 12235,
     /* 255227 */     GIR_EraseRootFromParent_Done,
     /* 255228 */   // Label 4958: @255228
     /* 255228 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(255270), // Rule ID 12580 //
     /* 255233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255257 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1378:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 255260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255268 */     GIR_RootConstrainSelectedInstOperands,
     /* 255269 */     // GIR_Coverage, 12580,
     /* 255269 */     GIR_EraseRootFromParent_Done,
     /* 255270 */   // Label 4959: @255270
     /* 255270 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(255312), // Rule ID 12581 //
     /* 255275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255299 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 255302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255310 */     GIR_RootConstrainSelectedInstOperands,
     /* 255311 */     // GIR_Coverage, 12581,
     /* 255311 */     GIR_EraseRootFromParent_Done,
     /* 255312 */   // Label 4960: @255312
     /* 255312 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(255354), // Rule ID 12582 //
     /* 255317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 255325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255341 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1378:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 255344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255352 */     GIR_RootConstrainSelectedInstOperands,
     /* 255353 */     // GIR_Coverage, 12582,
     /* 255353 */     GIR_EraseRootFromParent_Done,
     /* 255354 */   // Label 4961: @255354
     /* 255354 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(255396), // Rule ID 12583 //
     /* 255359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255383 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 255386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255394 */     GIR_RootConstrainSelectedInstOperands,
     /* 255395 */     // GIR_Coverage, 12583,
     /* 255395 */     GIR_EraseRootFromParent_Done,
     /* 255396 */   // Label 4962: @255396
     /* 255396 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(255438), // Rule ID 12584 //
     /* 255401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255425 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 255428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255436 */     GIR_RootConstrainSelectedInstOperands,
     /* 255437 */     // GIR_Coverage, 12584,
     /* 255437 */     GIR_EraseRootFromParent_Done,
     /* 255438 */   // Label 4963: @255438
     /* 255438 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(255480), // Rule ID 12585 //
     /* 255443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 255451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255467 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 255470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255478 */     GIR_RootConstrainSelectedInstOperands,
     /* 255479 */     // GIR_Coverage, 12585,
     /* 255479 */     GIR_EraseRootFromParent_Done,
     /* 255480 */   // Label 4964: @255480
     /* 255480 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(255522), // Rule ID 12586 //
     /* 255485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255509 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255520 */     GIR_RootConstrainSelectedInstOperands,
     /* 255521 */     // GIR_Coverage, 12586,
     /* 255521 */     GIR_EraseRootFromParent_Done,
     /* 255522 */   // Label 4965: @255522
     /* 255522 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(255564), // Rule ID 12589 //
     /* 255527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 255538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 255544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 255547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255551 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 255551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255562 */     GIR_RootConstrainSelectedInstOperands,
     /* 255563 */     // GIR_Coverage, 12589,
     /* 255563 */     GIR_EraseRootFromParent_Done,
     /* 255564 */   // Label 4966: @255564
     /* 255564 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(255606), // Rule ID 12592 //
     /* 255569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 255580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 255586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 255589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255593 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 255593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 255596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255604 */     GIR_RootConstrainSelectedInstOperands,
     /* 255605 */     // GIR_Coverage, 12592,
     /* 255605 */     GIR_EraseRootFromParent_Done,
     /* 255606 */   // Label 4967: @255606
     /* 255606 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(255648), // Rule ID 12595 //
     /* 255611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 255638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255646 */     GIR_RootConstrainSelectedInstOperands,
     /* 255647 */     // GIR_Coverage, 12595,
     /* 255647 */     GIR_EraseRootFromParent_Done,
     /* 255648 */   // Label 4968: @255648
     /* 255648 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(255690), // Rule ID 12598 //
     /* 255653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 255664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 255670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 255673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255677 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 255677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255688 */     GIR_RootConstrainSelectedInstOperands,
     /* 255689 */     // GIR_Coverage, 12598,
     /* 255689 */     GIR_EraseRootFromParent_Done,
     /* 255690 */   // Label 4969: @255690
     /* 255690 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(255732), // Rule ID 12601 //
     /* 255695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 255703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255719 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 255722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255730 */     GIR_RootConstrainSelectedInstOperands,
     /* 255731 */     // GIR_Coverage, 12601,
     /* 255731 */     GIR_EraseRootFromParent_Done,
     /* 255732 */   // Label 4970: @255732
     /* 255732 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(255774), // Rule ID 12604 //
     /* 255737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255761 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255772 */     GIR_RootConstrainSelectedInstOperands,
     /* 255773 */     // GIR_Coverage, 12604,
     /* 255773 */     GIR_EraseRootFromParent_Done,
     /* 255774 */   // Label 4971: @255774
     /* 255774 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(255816), // Rule ID 12607 //
     /* 255779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 255790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 255796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 255799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255803 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 255803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255814 */     GIR_RootConstrainSelectedInstOperands,
     /* 255815 */     // GIR_Coverage, 12607,
     /* 255815 */     GIR_EraseRootFromParent_Done,
     /* 255816 */   // Label 4972: @255816
     /* 255816 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(255858), // Rule ID 12610 //
     /* 255821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 255832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 255838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 255841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255845 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 255845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 255848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255856 */     GIR_RootConstrainSelectedInstOperands,
     /* 255857 */     // GIR_Coverage, 12610,
     /* 255857 */     GIR_EraseRootFromParent_Done,
     /* 255858 */   // Label 4973: @255858
     /* 255858 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(255900), // Rule ID 12613 //
     /* 255863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 255890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255898 */     GIR_RootConstrainSelectedInstOperands,
     /* 255899 */     // GIR_Coverage, 12613,
     /* 255899 */     GIR_EraseRootFromParent_Done,
     /* 255900 */   // Label 4974: @255900
     /* 255900 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(255942), // Rule ID 12616 //
     /* 255905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 255916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 255922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 255925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255929 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 255929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 255932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255940 */     GIR_RootConstrainSelectedInstOperands,
     /* 255941 */     // GIR_Coverage, 12616,
     /* 255941 */     GIR_EraseRootFromParent_Done,
     /* 255942 */   // Label 4975: @255942
     /* 255942 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(255984), // Rule ID 12619 //
     /* 255947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 255950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 255955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255971 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 255974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255982 */     GIR_RootConstrainSelectedInstOperands,
     /* 255983 */     // GIR_Coverage, 12619,
     /* 255983 */     GIR_EraseRootFromParent_Done,
     /* 255984 */   // Label 4976: @255984
     /* 255984 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256127), // Rule ID 5600 //
     /* 255989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 255992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 255997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256010 */     // MIs[0] idx
     /* 256010 */     // No operand predicates
     /* 256010 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256010 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 256013 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256017 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 256024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 256027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256036 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 256039 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256043 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 256046 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256051 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256056 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 256123 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256125 */     GIR_RootConstrainSelectedInstOperands,
     /* 256126 */     // GIR_Coverage, 5600,
     /* 256126 */     GIR_EraseRootFromParent_Done,
     /* 256127 */   // Label 4977: @256127
     /* 256127 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(256218), // Rule ID 5601 //
     /* 256132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256153 */     // MIs[0] idx
     /* 256153 */     // No operand predicates
     /* 256153 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256214 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256216 */     GIR_RootConstrainSelectedInstOperands,
     /* 256217 */     // GIR_Coverage, 5601,
     /* 256217 */     GIR_EraseRootFromParent_Done,
     /* 256218 */   // Label 4978: @256218
     /* 256218 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(256309), // Rule ID 5602 //
     /* 256223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256244 */     // MIs[0] idx
     /* 256244 */     // No operand predicates
     /* 256244 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256305 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256307 */     GIR_RootConstrainSelectedInstOperands,
     /* 256308 */     // GIR_Coverage, 5602,
     /* 256308 */     GIR_EraseRootFromParent_Done,
     /* 256309 */   // Label 4979: @256309
     /* 256309 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(256348), // Rule ID 5603 //
     /* 256314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256335 */     // MIs[0] idx
     /* 256335 */     // No operand predicates
     /* 256335 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 256338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256344 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256346 */     GIR_RootConstrainSelectedInstOperands,
     /* 256347 */     // GIR_Coverage, 5603,
     /* 256347 */     GIR_EraseRootFromParent_Done,
     /* 256348 */   // Label 4980: @256348
     /* 256348 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(256491), // Rule ID 5604 //
     /* 256353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256374 */     // MIs[0] idx
     /* 256374 */     // No operand predicates
     /* 256374 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256374 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 256377 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256381 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 256388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 256391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256400 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 256403 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256407 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 256410 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256415 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256420 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 256487 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256489 */     GIR_RootConstrainSelectedInstOperands,
     /* 256490 */     // GIR_Coverage, 5604,
     /* 256490 */     GIR_EraseRootFromParent_Done,
     /* 256491 */   // Label 4981: @256491
     /* 256491 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(256582), // Rule ID 5605 //
     /* 256496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256517 */     // MIs[0] idx
     /* 256517 */     // No operand predicates
     /* 256517 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256578 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256580 */     GIR_RootConstrainSelectedInstOperands,
     /* 256581 */     // GIR_Coverage, 5605,
     /* 256581 */     GIR_EraseRootFromParent_Done,
     /* 256582 */   // Label 4982: @256582
     /* 256582 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(256673), // Rule ID 5606 //
     /* 256587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256608 */     // MIs[0] idx
     /* 256608 */     // No operand predicates
     /* 256608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256669 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256671 */     GIR_RootConstrainSelectedInstOperands,
     /* 256672 */     // GIR_Coverage, 5606,
     /* 256672 */     GIR_EraseRootFromParent_Done,
     /* 256673 */   // Label 4983: @256673
     /* 256673 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(256712), // Rule ID 5607 //
     /* 256678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256699 */     // MIs[0] idx
     /* 256699 */     // No operand predicates
     /* 256699 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256708 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256710 */     GIR_RootConstrainSelectedInstOperands,
     /* 256711 */     // GIR_Coverage, 5607,
     /* 256711 */     GIR_EraseRootFromParent_Done,
     /* 256712 */   // Label 4984: @256712
     /* 256712 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(256855), // Rule ID 5608 //
     /* 256717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256738 */     // MIs[0] idx
     /* 256738 */     // No operand predicates
     /* 256738 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256738 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 256741 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256745 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 256752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 256755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256764 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 256767 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 256771 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 256774 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256779 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256784 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 256851 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256853 */     GIR_RootConstrainSelectedInstOperands,
     /* 256854 */     // GIR_Coverage, 5608,
     /* 256854 */     GIR_EraseRootFromParent_Done,
     /* 256855 */   // Label 4985: @256855
     /* 256855 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(256946), // Rule ID 5609 //
     /* 256860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 256868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256881 */     // MIs[0] idx
     /* 256881 */     // No operand predicates
     /* 256881 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256907 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 256914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 256917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 256935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 256942 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 256944 */     GIR_RootConstrainSelectedInstOperands,
     /* 256945 */     // GIR_Coverage, 5609,
     /* 256945 */     GIR_EraseRootFromParent_Done,
     /* 256946 */   // Label 4986: @256946
     /* 256946 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257037), // Rule ID 5610 //
     /* 256951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 256954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 256959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256972 */     // MIs[0] idx
     /* 256972 */     // No operand predicates
     /* 256972 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 256972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 256975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 256989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257033 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257035 */     GIR_RootConstrainSelectedInstOperands,
     /* 257036 */     // GIR_Coverage, 5610,
     /* 257036 */     GIR_EraseRootFromParent_Done,
     /* 257037 */   // Label 4987: @257037
     /* 257037 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257076), // Rule ID 5611 //
     /* 257042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257063 */     // MIs[0] idx
     /* 257063 */     // No operand predicates
     /* 257063 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257072 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257074 */     GIR_RootConstrainSelectedInstOperands,
     /* 257075 */     // GIR_Coverage, 5611,
     /* 257075 */     GIR_EraseRootFromParent_Done,
     /* 257076 */   // Label 4988: @257076
     /* 257076 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257115), // Rule ID 5612 //
     /* 257081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 257089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257102 */     // MIs[0] idx
     /* 257102 */     // No operand predicates
     /* 257102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 257102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 257105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257111 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257113 */     GIR_RootConstrainSelectedInstOperands,
     /* 257114 */     // GIR_Coverage, 5612,
     /* 257114 */     GIR_EraseRootFromParent_Done,
     /* 257115 */   // Label 4989: @257115
     /* 257115 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257206), // Rule ID 5613 //
     /* 257120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 257128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257141 */     // MIs[0] idx
     /* 257141 */     // No operand predicates
     /* 257141 */     // (intrinsic_wo_chain:{ *:[v16i8] } 777:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 257141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 257195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257202 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257204 */     GIR_RootConstrainSelectedInstOperands,
     /* 257205 */     // GIR_Coverage, 5613,
     /* 257205 */     GIR_EraseRootFromParent_Done,
     /* 257206 */   // Label 4990: @257206
     /* 257206 */   GIM_Reject,
     /* 257207 */ // Label 4130: @257207
     /* 257207 */ GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(264318),
     /* 257212 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 257215 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257262), // Rule ID 2958 //
     /* 257220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257247 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 257247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 257250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257258 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257260 */     GIR_RootConstrainSelectedInstOperands,
     /* 257261 */     // GIR_Coverage, 2958,
     /* 257261 */     GIR_EraseRootFromParent_Done,
     /* 257262 */   // Label 4992: @257262
     /* 257262 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257309), // Rule ID 2960 //
     /* 257267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 257294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 257297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257307 */     GIR_RootConstrainSelectedInstOperands,
     /* 257308 */     // GIR_Coverage, 2960,
     /* 257308 */     GIR_EraseRootFromParent_Done,
     /* 257309 */   // Label 4993: @257309
     /* 257309 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257356), // Rule ID 2962 //
     /* 257314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 257337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1610:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 257341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 257344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257352 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257354 */     GIR_RootConstrainSelectedInstOperands,
     /* 257355 */     // GIR_Coverage, 2962,
     /* 257355 */     GIR_EraseRootFromParent_Done,
     /* 257356 */   // Label 4994: @257356
     /* 257356 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(257403), // Rule ID 2964 //
     /* 257361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 257369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 257384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1610:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 257388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 257391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257401 */     GIR_RootConstrainSelectedInstOperands,
     /* 257402 */     // GIR_Coverage, 2964,
     /* 257402 */     GIR_EraseRootFromParent_Done,
     /* 257403 */   // Label 4995: @257403
     /* 257403 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(257450), // Rule ID 7630 //
     /* 257408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257435 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 257435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 257438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257446 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257448 */     GIR_RootConstrainSelectedInstOperands,
     /* 257449 */     // GIR_Coverage, 7630,
     /* 257449 */     GIR_EraseRootFromParent_Done,
     /* 257450 */   // Label 4996: @257450
     /* 257450 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(257497), // Rule ID 7632 //
     /* 257455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 257482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 257485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257493 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257495 */     GIR_RootConstrainSelectedInstOperands,
     /* 257496 */     // GIR_Coverage, 7632,
     /* 257496 */     GIR_EraseRootFromParent_Done,
     /* 257497 */   // Label 4997: @257497
     /* 257497 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(257544), // Rule ID 7634 //
     /* 257502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 257525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 257529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 257532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257540 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257542 */     GIR_RootConstrainSelectedInstOperands,
     /* 257543 */     // GIR_Coverage, 7634,
     /* 257543 */     GIR_EraseRootFromParent_Done,
     /* 257544 */   // Label 4998: @257544
     /* 257544 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(257591), // Rule ID 7636 //
     /* 257549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 257552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 257557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 257572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 257576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 257579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 257589 */     GIR_RootConstrainSelectedInstOperands,
     /* 257590 */     // GIR_Coverage, 7636,
     /* 257590 */     GIR_EraseRootFromParent_Done,
     /* 257591 */   // Label 4999: @257591
     /* 257591 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(257671), // Rule ID 5720 //
     /* 257596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257636 */     // MIs[1] Operand 1
     /* 257636 */     // No operand predicates
     /* 257636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257648 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257652 */     // MIs[2] Operand 1
     /* 257652 */     // No operand predicates
     /* 257652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257654 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 257654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 257657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257669 */     GIR_RootConstrainSelectedInstOperands,
     /* 257670 */     // GIR_Coverage, 5720,
     /* 257670 */     GIR_EraseRootFromParent_Done,
     /* 257671 */   // Label 5000: @257671
     /* 257671 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(257751), // Rule ID 5721 //
     /* 257676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 257693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257716 */     // MIs[1] Operand 1
     /* 257716 */     // No operand predicates
     /* 257716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257732 */     // MIs[2] Operand 1
     /* 257732 */     // No operand predicates
     /* 257732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257734 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 257734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 257737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257749 */     GIR_RootConstrainSelectedInstOperands,
     /* 257750 */     // GIR_Coverage, 5721,
     /* 257750 */     GIR_EraseRootFromParent_Done,
     /* 257751 */   // Label 5001: @257751
     /* 257751 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(257831), // Rule ID 5722 //
     /* 257756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257796 */     // MIs[1] Operand 1
     /* 257796 */     // No operand predicates
     /* 257796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257812 */     // MIs[2] Operand 1
     /* 257812 */     // No operand predicates
     /* 257812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 768:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 257814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 257817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257829 */     GIR_RootConstrainSelectedInstOperands,
     /* 257830 */     // GIR_Coverage, 5722,
     /* 257830 */     GIR_EraseRootFromParent_Done,
     /* 257831 */   // Label 5002: @257831
     /* 257831 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(257911), // Rule ID 5723 //
     /* 257836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 257841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 257844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 257847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 257853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 257856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 257868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 257876 */     // MIs[1] Operand 1
     /* 257876 */     // No operand predicates
     /* 257876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 257884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 257892 */     // MIs[2] Operand 1
     /* 257892 */     // No operand predicates
     /* 257892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257894 */     // (intrinsic_wo_chain:{ *:[v2i64] } 768:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 257894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 257897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 257904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 257906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 257909 */     GIR_RootConstrainSelectedInstOperands,
     /* 257910 */     // GIR_Coverage, 5723,
     /* 257910 */     GIR_EraseRootFromParent_Done,
     /* 257911 */   // Label 5003: @257911
     /* 257911 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(257975), // Rule ID 3846 //
     /* 257916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 257924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257952 */     // MIs[0] imm
     /* 257952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 257960 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 257960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 257963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 257965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 257967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 257969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 257971 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 257973 */     GIR_RootConstrainSelectedInstOperands,
     /* 257974 */     // GIR_Coverage, 3846,
     /* 257974 */     GIR_EraseRootFromParent_Done,
     /* 257975 */   // Label 5004: @257975
     /* 257975 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258039), // Rule ID 3847 //
     /* 257980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 257983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 257988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 258000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258016 */     // MIs[0] imm
     /* 258016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 258024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 258024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 258027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 258029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 258031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 258035 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 258037 */     GIR_RootConstrainSelectedInstOperands,
     /* 258038 */     // GIR_Coverage, 3847,
     /* 258038 */     GIR_EraseRootFromParent_Done,
     /* 258039 */   // Label 5005: @258039
     /* 258039 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258103), // Rule ID 3848 //
     /* 258044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 258047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 258052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 258061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 258064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258080 */     // MIs[0] imm
     /* 258080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 258088 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 258088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 258091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 258093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 258095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 258097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 258099 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 258101 */     GIR_RootConstrainSelectedInstOperands,
     /* 258102 */     // GIR_Coverage, 3848,
     /* 258102 */     GIR_EraseRootFromParent_Done,
     /* 258103 */   // Label 5006: @258103
     /* 258103 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258167), // Rule ID 3849 //
     /* 258108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 258111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 258116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 258125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 258128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258144 */     // MIs[0] imm
     /* 258144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 258152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 258152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 258155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 258157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 258159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 258161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 258163 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 258165 */     GIR_RootConstrainSelectedInstOperands,
     /* 258166 */     // GIR_Coverage, 3849,
     /* 258166 */     GIR_EraseRootFromParent_Done,
     /* 258167 */   // Label 5007: @258167
     /* 258167 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258219), // Rule ID 2843 //
     /* 258172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258196 */     // MIs[0] idx
     /* 258196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 258204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 258207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258215 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258217 */     GIR_RootConstrainSelectedInstOperands,
     /* 258218 */     // GIR_Coverage, 2843,
     /* 258218 */     GIR_EraseRootFromParent_Done,
     /* 258219 */   // Label 5008: @258219
     /* 258219 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258271), // Rule ID 2844 //
     /* 258224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258248 */     // MIs[0] idx
     /* 258248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258256 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 258259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258267 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258269 */     GIR_RootConstrainSelectedInstOperands,
     /* 258270 */     // GIR_Coverage, 2844,
     /* 258270 */     GIR_EraseRootFromParent_Done,
     /* 258271 */   // Label 5009: @258271
     /* 258271 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258323), // Rule ID 2845 //
     /* 258276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 258284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258300 */     // MIs[0] idx
     /* 258300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258308 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 258311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258319 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258321 */     GIR_RootConstrainSelectedInstOperands,
     /* 258322 */     // GIR_Coverage, 2845,
     /* 258322 */     GIR_EraseRootFromParent_Done,
     /* 258323 */   // Label 5010: @258323
     /* 258323 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258375), // Rule ID 2973 //
     /* 258328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258352 */     // MIs[0] Op4
     /* 258352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 258360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 258363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258371 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258373 */     GIR_RootConstrainSelectedInstOperands,
     /* 258374 */     // GIR_Coverage, 2973,
     /* 258374 */     GIR_EraseRootFromParent_Done,
     /* 258375 */   // Label 5011: @258375
     /* 258375 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258427), // Rule ID 2974 //
     /* 258380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258404 */     // MIs[0] Op4
     /* 258404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 258415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258425 */     GIR_RootConstrainSelectedInstOperands,
     /* 258426 */     // GIR_Coverage, 2974,
     /* 258426 */     GIR_EraseRootFromParent_Done,
     /* 258427 */   // Label 5012: @258427
     /* 258427 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(258479), // Rule ID 2975 //
     /* 258432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 258440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258456 */     // MIs[0] Op4
     /* 258456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 258467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258477 */     GIR_RootConstrainSelectedInstOperands,
     /* 258478 */     // GIR_Coverage, 2975,
     /* 258478 */     GIR_EraseRootFromParent_Done,
     /* 258479 */   // Label 5013: @258479
     /* 258479 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(258531), // Rule ID 2976 //
     /* 258484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 258492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258508 */     // MIs[0] Op4
     /* 258508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 258516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 258519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258529 */     GIR_RootConstrainSelectedInstOperands,
     /* 258530 */     // GIR_Coverage, 2976,
     /* 258530 */     GIR_EraseRootFromParent_Done,
     /* 258531 */   // Label 5014: @258531
     /* 258531 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(258583), // Rule ID 2977 //
     /* 258536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 258544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258560 */     // MIs[0] Op4
     /* 258560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 258571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258581 */     GIR_RootConstrainSelectedInstOperands,
     /* 258582 */     // GIR_Coverage, 2977,
     /* 258582 */     GIR_EraseRootFromParent_Done,
     /* 258583 */   // Label 5015: @258583
     /* 258583 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(258635), // Rule ID 2980 //
     /* 258588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 258596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258612 */     // MIs[0] Op4
     /* 258612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 258623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258633 */     GIR_RootConstrainSelectedInstOperands,
     /* 258634 */     // GIR_Coverage, 2980,
     /* 258634 */     GIR_EraseRootFromParent_Done,
     /* 258635 */   // Label 5016: @258635
     /* 258635 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(258687), // Rule ID 2981 //
     /* 258640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 258648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258664 */     // MIs[0] Op4
     /* 258664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 258675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258685 */     GIR_RootConstrainSelectedInstOperands,
     /* 258686 */     // GIR_Coverage, 2981,
     /* 258686 */     GIR_EraseRootFromParent_Done,
     /* 258687 */   // Label 5017: @258687
     /* 258687 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(258739), // Rule ID 3455 //
     /* 258692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 258695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 258700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258716 */     // MIs[0] Op4
     /* 258716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 258727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258737 */     GIR_RootConstrainSelectedInstOperands,
     /* 258738 */     // GIR_Coverage, 3455,
     /* 258738 */     GIR_EraseRootFromParent_Done,
     /* 258739 */   // Label 5018: @258739
     /* 258739 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(258791), // Rule ID 3499 //
     /* 258744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 258752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258768 */     // MIs[0] Op4
     /* 258768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 258779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258789 */     GIR_RootConstrainSelectedInstOperands,
     /* 258790 */     // GIR_Coverage, 3499,
     /* 258790 */     GIR_EraseRootFromParent_Done,
     /* 258791 */   // Label 5019: @258791
     /* 258791 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(258843), // Rule ID 7704 //
     /* 258796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 258804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258820 */     // MIs[0] Op4
     /* 258820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 258828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 258831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258841 */     GIR_RootConstrainSelectedInstOperands,
     /* 258842 */     // GIR_Coverage, 7704,
     /* 258842 */     GIR_EraseRootFromParent_Done,
     /* 258843 */   // Label 5020: @258843
     /* 258843 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(258895), // Rule ID 7705 //
     /* 258848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 258856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258872 */     // MIs[0] Op4
     /* 258872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 258880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 258880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 258883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258891 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258893 */     GIR_RootConstrainSelectedInstOperands,
     /* 258894 */     // GIR_Coverage, 7705,
     /* 258894 */     GIR_EraseRootFromParent_Done,
     /* 258895 */   // Label 5021: @258895
     /* 258895 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(258947), // Rule ID 8345 //
     /* 258900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 258908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258924 */     // MIs[0] idx
     /* 258924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 258932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 258935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258943 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258945 */     GIR_RootConstrainSelectedInstOperands,
     /* 258946 */     // GIR_Coverage, 8345,
     /* 258946 */     GIR_EraseRootFromParent_Done,
     /* 258947 */   // Label 5022: @258947
     /* 258947 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(258999), // Rule ID 8346 //
     /* 258952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 258960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258976 */     // MIs[0] idx
     /* 258976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 258987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258995 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 258997 */     GIR_RootConstrainSelectedInstOperands,
     /* 258998 */     // GIR_Coverage, 8346,
     /* 258998 */     GIR_EraseRootFromParent_Done,
     /* 258999 */   // Label 5023: @258999
     /* 258999 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259051), // Rule ID 8347 //
     /* 259004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 259012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259028 */     // MIs[0] idx
     /* 259028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259036 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 259036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 259039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259047 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259049 */     GIR_RootConstrainSelectedInstOperands,
     /* 259050 */     // GIR_Coverage, 8347,
     /* 259050 */     GIR_EraseRootFromParent_Done,
     /* 259051 */   // Label 5024: @259051
     /* 259051 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259103), // Rule ID 11311 //
     /* 259056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 259059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 259064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259080 */     // MIs[0] Op4
     /* 259080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 259091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259101 */     GIR_RootConstrainSelectedInstOperands,
     /* 259102 */     // GIR_Coverage, 11311,
     /* 259102 */     GIR_EraseRootFromParent_Done,
     /* 259103 */   // Label 5025: @259103
     /* 259103 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259155), // Rule ID 11358 //
     /* 259108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 259116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259132 */     // MIs[0] Op4
     /* 259132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 259143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259153 */     GIR_RootConstrainSelectedInstOperands,
     /* 259154 */     // GIR_Coverage, 11358,
     /* 259154 */     GIR_EraseRootFromParent_Done,
     /* 259155 */   // Label 5026: @259155
     /* 259155 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259207), // Rule ID 11359 //
     /* 259160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 259168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259184 */     // MIs[0] Op4
     /* 259184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 259195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259203 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259205 */     GIR_RootConstrainSelectedInstOperands,
     /* 259206 */     // GIR_Coverage, 11359,
     /* 259206 */     GIR_EraseRootFromParent_Done,
     /* 259207 */   // Label 5027: @259207
     /* 259207 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259259), // Rule ID 11360 //
     /* 259212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 259220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259236 */     // MIs[0] Op4
     /* 259236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 259247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259257 */     GIR_RootConstrainSelectedInstOperands,
     /* 259258 */     // GIR_Coverage, 11360,
     /* 259258 */     GIR_EraseRootFromParent_Done,
     /* 259259 */   // Label 5028: @259259
     /* 259259 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(259311), // Rule ID 11361 //
     /* 259264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259288 */     // MIs[0] Op4
     /* 259288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 259299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259309 */     GIR_RootConstrainSelectedInstOperands,
     /* 259310 */     // GIR_Coverage, 11361,
     /* 259310 */     GIR_EraseRootFromParent_Done,
     /* 259311 */   // Label 5029: @259311
     /* 259311 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(259363), // Rule ID 11362 //
     /* 259316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259340 */     // MIs[0] Op4
     /* 259340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 259351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259361 */     GIR_RootConstrainSelectedInstOperands,
     /* 259362 */     // GIR_Coverage, 11362,
     /* 259362 */     GIR_EraseRootFromParent_Done,
     /* 259363 */   // Label 5030: @259363
     /* 259363 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(259415), // Rule ID 11363 //
     /* 259368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 259376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259392 */     // MIs[0] Op4
     /* 259392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 259403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259413 */     GIR_RootConstrainSelectedInstOperands,
     /* 259414 */     // GIR_Coverage, 11363,
     /* 259414 */     GIR_EraseRootFromParent_Done,
     /* 259415 */   // Label 5031: @259415
     /* 259415 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(259467), // Rule ID 11364 //
     /* 259420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259444 */     // MIs[0] Op4
     /* 259444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 259455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259463 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259465 */     GIR_RootConstrainSelectedInstOperands,
     /* 259466 */     // GIR_Coverage, 11364,
     /* 259466 */     GIR_EraseRootFromParent_Done,
     /* 259467 */   // Label 5032: @259467
     /* 259467 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(259519), // Rule ID 11365 //
     /* 259472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259496 */     // MIs[0] Op4
     /* 259496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 259507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259515 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259517 */     GIR_RootConstrainSelectedInstOperands,
     /* 259518 */     // GIR_Coverage, 11365,
     /* 259518 */     GIR_EraseRootFromParent_Done,
     /* 259519 */   // Label 5033: @259519
     /* 259519 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(259571), // Rule ID 11366 //
     /* 259524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 259532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259548 */     // MIs[0] Op4
     /* 259548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 259559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259569 */     GIR_RootConstrainSelectedInstOperands,
     /* 259570 */     // GIR_Coverage, 11366,
     /* 259570 */     GIR_EraseRootFromParent_Done,
     /* 259571 */   // Label 5034: @259571
     /* 259571 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(259623), // Rule ID 11409 //
     /* 259576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 259584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259600 */     // MIs[0] Op4
     /* 259600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 259611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259619 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259621 */     GIR_RootConstrainSelectedInstOperands,
     /* 259622 */     // GIR_Coverage, 11409,
     /* 259622 */     GIR_EraseRootFromParent_Done,
     /* 259623 */   // Label 5035: @259623
     /* 259623 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(259675), // Rule ID 11410 //
     /* 259628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 259636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259652 */     // MIs[0] Op4
     /* 259652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 259663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259671 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259673 */     GIR_RootConstrainSelectedInstOperands,
     /* 259674 */     // GIR_Coverage, 11410,
     /* 259674 */     GIR_EraseRootFromParent_Done,
     /* 259675 */   // Label 5036: @259675
     /* 259675 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(259727), // Rule ID 11411 //
     /* 259680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 259688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259704 */     // MIs[0] Op4
     /* 259704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 259715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259725 */     GIR_RootConstrainSelectedInstOperands,
     /* 259726 */     // GIR_Coverage, 11411,
     /* 259726 */     GIR_EraseRootFromParent_Done,
     /* 259727 */   // Label 5037: @259727
     /* 259727 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(259779), // Rule ID 11412 //
     /* 259732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 259740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259756 */     // MIs[0] Op4
     /* 259756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1989:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 259767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259777 */     GIR_RootConstrainSelectedInstOperands,
     /* 259778 */     // GIR_Coverage, 11412,
     /* 259778 */     GIR_EraseRootFromParent_Done,
     /* 259779 */   // Label 5038: @259779
     /* 259779 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(259831), // Rule ID 11413 //
     /* 259784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 259792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259808 */     // MIs[0] Op4
     /* 259808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 259819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259827 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259829 */     GIR_RootConstrainSelectedInstOperands,
     /* 259830 */     // GIR_Coverage, 11413,
     /* 259830 */     GIR_EraseRootFromParent_Done,
     /* 259831 */   // Label 5039: @259831
     /* 259831 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(259883), // Rule ID 11414 //
     /* 259836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 259844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259860 */     // MIs[0] Op4
     /* 259860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 259871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259879 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259881 */     GIR_RootConstrainSelectedInstOperands,
     /* 259882 */     // GIR_Coverage, 11414,
     /* 259882 */     GIR_EraseRootFromParent_Done,
     /* 259883 */   // Label 5040: @259883
     /* 259883 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(259935), // Rule ID 11415 //
     /* 259888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 259896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259912 */     // MIs[0] Op4
     /* 259912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 259923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259931 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259933 */     GIR_RootConstrainSelectedInstOperands,
     /* 259934 */     // GIR_Coverage, 11415,
     /* 259934 */     GIR_EraseRootFromParent_Done,
     /* 259935 */   // Label 5041: @259935
     /* 259935 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(259987), // Rule ID 11416 //
     /* 259940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 259948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259964 */     // MIs[0] Op4
     /* 259964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 259975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259985 */     GIR_RootConstrainSelectedInstOperands,
     /* 259986 */     // GIR_Coverage, 11416,
     /* 259986 */     GIR_EraseRootFromParent_Done,
     /* 259987 */   // Label 5042: @259987
     /* 259987 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260039), // Rule ID 11417 //
     /* 259992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 260000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260016 */     // MIs[0] Op4
     /* 260016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 260027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260037 */     GIR_RootConstrainSelectedInstOperands,
     /* 260038 */     // GIR_Coverage, 11417,
     /* 260038 */     GIR_EraseRootFromParent_Done,
     /* 260039 */   // Label 5043: @260039
     /* 260039 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260091), // Rule ID 11418 //
     /* 260044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 260052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260068 */     // MIs[0] Op4
     /* 260068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 260079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260087 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260089 */     GIR_RootConstrainSelectedInstOperands,
     /* 260090 */     // GIR_Coverage, 11418,
     /* 260090 */     GIR_EraseRootFromParent_Done,
     /* 260091 */   // Label 5044: @260091
     /* 260091 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260143), // Rule ID 11419 //
     /* 260096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 260104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260120 */     // MIs[0] Op4
     /* 260120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 260131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260139 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260141 */     GIR_RootConstrainSelectedInstOperands,
     /* 260142 */     // GIR_Coverage, 11419,
     /* 260142 */     GIR_EraseRootFromParent_Done,
     /* 260143 */   // Label 5045: @260143
     /* 260143 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260195), // Rule ID 11420 //
     /* 260148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 260156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260172 */     // MIs[0] Op4
     /* 260172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 260183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260191 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260193 */     GIR_RootConstrainSelectedInstOperands,
     /* 260194 */     // GIR_Coverage, 11420,
     /* 260194 */     GIR_EraseRootFromParent_Done,
     /* 260195 */   // Label 5046: @260195
     /* 260195 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260247), // Rule ID 11421 //
     /* 260200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 260208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260224 */     // MIs[0] Op4
     /* 260224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 260235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260243 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260245 */     GIR_RootConstrainSelectedInstOperands,
     /* 260246 */     // GIR_Coverage, 11421,
     /* 260246 */     GIR_EraseRootFromParent_Done,
     /* 260247 */   // Label 5047: @260247
     /* 260247 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(260299), // Rule ID 11422 //
     /* 260252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 260260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260276 */     // MIs[0] Op4
     /* 260276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 260287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260295 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260297 */     GIR_RootConstrainSelectedInstOperands,
     /* 260298 */     // GIR_Coverage, 11422,
     /* 260298 */     GIR_EraseRootFromParent_Done,
     /* 260299 */   // Label 5048: @260299
     /* 260299 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(260351), // Rule ID 11444 //
     /* 260304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 260312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260328 */     // MIs[0] Op4
     /* 260328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 260339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260349 */     GIR_RootConstrainSelectedInstOperands,
     /* 260350 */     // GIR_Coverage, 11444,
     /* 260350 */     GIR_EraseRootFromParent_Done,
     /* 260351 */   // Label 5049: @260351
     /* 260351 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(260403), // Rule ID 11445 //
     /* 260356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 260364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260380 */     // MIs[0] Op4
     /* 260380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 260391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260401 */     GIR_RootConstrainSelectedInstOperands,
     /* 260402 */     // GIR_Coverage, 11445,
     /* 260402 */     GIR_EraseRootFromParent_Done,
     /* 260403 */   // Label 5050: @260403
     /* 260403 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(260455), // Rule ID 11446 //
     /* 260408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 260416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260432 */     // MIs[0] Op4
     /* 260432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 260443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260451 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260453 */     GIR_RootConstrainSelectedInstOperands,
     /* 260454 */     // GIR_Coverage, 11446,
     /* 260454 */     GIR_EraseRootFromParent_Done,
     /* 260455 */   // Label 5051: @260455
     /* 260455 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(260507), // Rule ID 11447 //
     /* 260460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 260468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260484 */     // MIs[0] Op4
     /* 260484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260487 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 260495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260503 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260505 */     GIR_RootConstrainSelectedInstOperands,
     /* 260506 */     // GIR_Coverage, 11447,
     /* 260506 */     GIR_EraseRootFromParent_Done,
     /* 260507 */   // Label 5052: @260507
     /* 260507 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(260559), // Rule ID 11448 //
     /* 260512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 260520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260536 */     // MIs[0] Op4
     /* 260536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 260547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260555 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260557 */     GIR_RootConstrainSelectedInstOperands,
     /* 260558 */     // GIR_Coverage, 11448,
     /* 260558 */     GIR_EraseRootFromParent_Done,
     /* 260559 */   // Label 5053: @260559
     /* 260559 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(260611), // Rule ID 11449 //
     /* 260564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 260572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260588 */     // MIs[0] Op4
     /* 260588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 260599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260609 */     GIR_RootConstrainSelectedInstOperands,
     /* 260610 */     // GIR_Coverage, 11449,
     /* 260610 */     GIR_EraseRootFromParent_Done,
     /* 260611 */   // Label 5054: @260611
     /* 260611 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(260663), // Rule ID 11450 //
     /* 260616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 260624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260640 */     // MIs[0] Op4
     /* 260640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 260651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260659 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260661 */     GIR_RootConstrainSelectedInstOperands,
     /* 260662 */     // GIR_Coverage, 11450,
     /* 260662 */     GIR_EraseRootFromParent_Done,
     /* 260663 */   // Label 5055: @260663
     /* 260663 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(260715), // Rule ID 11451 //
     /* 260668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 260676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260692 */     // MIs[0] Op4
     /* 260692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 260703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260711 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260713 */     GIR_RootConstrainSelectedInstOperands,
     /* 260714 */     // GIR_Coverage, 11451,
     /* 260714 */     GIR_EraseRootFromParent_Done,
     /* 260715 */   // Label 5056: @260715
     /* 260715 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(260767), // Rule ID 11917 //
     /* 260720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 260728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260744 */     // MIs[0] Op4
     /* 260744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 260755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260763 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260765 */     GIR_RootConstrainSelectedInstOperands,
     /* 260766 */     // GIR_Coverage, 11917,
     /* 260766 */     GIR_EraseRootFromParent_Done,
     /* 260767 */   // Label 5057: @260767
     /* 260767 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(260819), // Rule ID 11918 //
     /* 260772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 260780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260796 */     // MIs[0] Op4
     /* 260796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260804 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 260807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260815 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260817 */     GIR_RootConstrainSelectedInstOperands,
     /* 260818 */     // GIR_Coverage, 11918,
     /* 260818 */     GIR_EraseRootFromParent_Done,
     /* 260819 */   // Label 5058: @260819
     /* 260819 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(260871), // Rule ID 11919 //
     /* 260824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 260832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260848 */     // MIs[0] Op4
     /* 260848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 260859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260867 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260869 */     GIR_RootConstrainSelectedInstOperands,
     /* 260870 */     // GIR_Coverage, 11919,
     /* 260870 */     GIR_EraseRootFromParent_Done,
     /* 260871 */   // Label 5059: @260871
     /* 260871 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(260923), // Rule ID 11920 //
     /* 260876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 260884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260900 */     // MIs[0] Op4
     /* 260900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 260911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260921 */     GIR_RootConstrainSelectedInstOperands,
     /* 260922 */     // GIR_Coverage, 11920,
     /* 260922 */     GIR_EraseRootFromParent_Done,
     /* 260923 */   // Label 5060: @260923
     /* 260923 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(260975), // Rule ID 12065 //
     /* 260928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 260936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260952 */     // MIs[0] Op4
     /* 260952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260960 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 260963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260971 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260973 */     GIR_RootConstrainSelectedInstOperands,
     /* 260974 */     // GIR_Coverage, 12065,
     /* 260974 */     GIR_EraseRootFromParent_Done,
     /* 260975 */   // Label 5061: @260975
     /* 260975 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261027), // Rule ID 12067 //
     /* 260980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 260988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261004 */     // MIs[0] Op4
     /* 261004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 261015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261023 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261025 */     GIR_RootConstrainSelectedInstOperands,
     /* 261026 */     // GIR_Coverage, 12067,
     /* 261026 */     GIR_EraseRootFromParent_Done,
     /* 261027 */   // Label 5062: @261027
     /* 261027 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261074), // Rule ID 2822 //
     /* 261032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 261059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 261062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261070 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261072 */     GIR_RootConstrainSelectedInstOperands,
     /* 261073 */     // GIR_Coverage, 2822,
     /* 261073 */     GIR_EraseRootFromParent_Done,
     /* 261074 */   // Label 5063: @261074
     /* 261074 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261121), // Rule ID 2825 //
     /* 261079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 261090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 261096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 261099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 261102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261106 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 261106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 261109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261117 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261119 */     GIR_RootConstrainSelectedInstOperands,
     /* 261120 */     // GIR_Coverage, 2825,
     /* 261120 */     GIR_EraseRootFromParent_Done,
     /* 261121 */   // Label 5064: @261121
     /* 261121 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261168), // Rule ID 2828 //
     /* 261126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 261137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 261143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 261146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 261149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261153 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 261153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 261156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261164 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261166 */     GIR_RootConstrainSelectedInstOperands,
     /* 261167 */     // GIR_Coverage, 2828,
     /* 261167 */     GIR_EraseRootFromParent_Done,
     /* 261168 */   // Label 5065: @261168
     /* 261168 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261215), // Rule ID 2831 //
     /* 261173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261200 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 261200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 261203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261211 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261213 */     GIR_RootConstrainSelectedInstOperands,
     /* 261214 */     // GIR_Coverage, 2831,
     /* 261214 */     GIR_EraseRootFromParent_Done,
     /* 261215 */   // Label 5066: @261215
     /* 261215 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(261262), // Rule ID 2834 //
     /* 261220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 261231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 261237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 261240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 261243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261247 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 261247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 261250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261258 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261260 */     GIR_RootConstrainSelectedInstOperands,
     /* 261261 */     // GIR_Coverage, 2834,
     /* 261261 */     GIR_EraseRootFromParent_Done,
     /* 261262 */   // Label 5067: @261262
     /* 261262 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(261309), // Rule ID 2837 //
     /* 261267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 261275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 261294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 261297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261307 */     GIR_RootConstrainSelectedInstOperands,
     /* 261308 */     // GIR_Coverage, 2837,
     /* 261308 */     GIR_EraseRootFromParent_Done,
     /* 261309 */   // Label 5068: @261309
     /* 261309 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(261356), // Rule ID 2840 //
     /* 261314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261341 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 261341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 261344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261352 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261354 */     GIR_RootConstrainSelectedInstOperands,
     /* 261355 */     // GIR_Coverage, 2840,
     /* 261355 */     GIR_EraseRootFromParent_Done,
     /* 261356 */   // Label 5069: @261356
     /* 261356 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(261403), // Rule ID 2841 //
     /* 261361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 261388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 261391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261401 */     GIR_RootConstrainSelectedInstOperands,
     /* 261402 */     // GIR_Coverage, 2841,
     /* 261402 */     GIR_EraseRootFromParent_Done,
     /* 261403 */   // Label 5070: @261403
     /* 261403 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(261450), // Rule ID 2842 //
     /* 261408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 261416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261435 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 261435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 261438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261446 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261448 */     GIR_RootConstrainSelectedInstOperands,
     /* 261449 */     // GIR_Coverage, 2842,
     /* 261449 */     GIR_EraseRootFromParent_Done,
     /* 261450 */   // Label 5071: @261450
     /* 261450 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(261497), // Rule ID 2938 //
     /* 261455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 261485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261493 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261495 */     GIR_RootConstrainSelectedInstOperands,
     /* 261496 */     // GIR_Coverage, 2938,
     /* 261496 */     GIR_EraseRootFromParent_Done,
     /* 261497 */   // Label 5072: @261497
     /* 261497 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(261544), // Rule ID 2941 //
     /* 261502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 261532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261540 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261542 */     GIR_RootConstrainSelectedInstOperands,
     /* 261543 */     // GIR_Coverage, 2941,
     /* 261543 */     GIR_EraseRootFromParent_Done,
     /* 261544 */   // Label 5073: @261544
     /* 261544 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(261591), // Rule ID 2944 //
     /* 261549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 261579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261589 */     GIR_RootConstrainSelectedInstOperands,
     /* 261590 */     // GIR_Coverage, 2944,
     /* 261590 */     GIR_EraseRootFromParent_Done,
     /* 261591 */   // Label 5074: @261591
     /* 261591 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(261638), // Rule ID 2947 //
     /* 261596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 261604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 261626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261634 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261636 */     GIR_RootConstrainSelectedInstOperands,
     /* 261637 */     // GIR_Coverage, 2947,
     /* 261637 */     GIR_EraseRootFromParent_Done,
     /* 261638 */   // Label 5075: @261638
     /* 261638 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(261685), // Rule ID 2950 //
     /* 261643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 261673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261681 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261683 */     GIR_RootConstrainSelectedInstOperands,
     /* 261684 */     // GIR_Coverage, 2950,
     /* 261684 */     GIR_EraseRootFromParent_Done,
     /* 261685 */   // Label 5076: @261685
     /* 261685 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(261732), // Rule ID 2952 //
     /* 261690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 261720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261728 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261730 */     GIR_RootConstrainSelectedInstOperands,
     /* 261731 */     // GIR_Coverage, 2952,
     /* 261731 */     GIR_EraseRootFromParent_Done,
     /* 261732 */   // Label 5077: @261732
     /* 261732 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(261779), // Rule ID 2954 //
     /* 261737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 261767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261777 */     GIR_RootConstrainSelectedInstOperands,
     /* 261778 */     // GIR_Coverage, 2954,
     /* 261778 */     GIR_EraseRootFromParent_Done,
     /* 261779 */   // Label 5078: @261779
     /* 261779 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(261826), // Rule ID 2956 //
     /* 261784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 261792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 261814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261822 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261824 */     GIR_RootConstrainSelectedInstOperands,
     /* 261825 */     // GIR_Coverage, 2956,
     /* 261825 */     GIR_EraseRootFromParent_Done,
     /* 261826 */   // Label 5079: @261826
     /* 261826 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(261873), // Rule ID 7610 //
     /* 261831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 261861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261869 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261871 */     GIR_RootConstrainSelectedInstOperands,
     /* 261872 */     // GIR_Coverage, 7610,
     /* 261872 */     GIR_EraseRootFromParent_Done,
     /* 261873 */   // Label 5080: @261873
     /* 261873 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(261920), // Rule ID 7613 //
     /* 261878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 261908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261916 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261918 */     GIR_RootConstrainSelectedInstOperands,
     /* 261919 */     // GIR_Coverage, 7613,
     /* 261919 */     GIR_EraseRootFromParent_Done,
     /* 261920 */   // Label 5081: @261920
     /* 261920 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(261967), // Rule ID 7616 //
     /* 261925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 261955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 261957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261963 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261965 */     GIR_RootConstrainSelectedInstOperands,
     /* 261966 */     // GIR_Coverage, 7616,
     /* 261966 */     GIR_EraseRootFromParent_Done,
     /* 261967 */   // Label 5082: @261967
     /* 261967 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262014), // Rule ID 7619 //
     /* 261972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 261980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 262002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262010 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262012 */     GIR_RootConstrainSelectedInstOperands,
     /* 262013 */     // GIR_Coverage, 7619,
     /* 262013 */     GIR_EraseRootFromParent_Done,
     /* 262014 */   // Label 5083: @262014
     /* 262014 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262061), // Rule ID 7622 //
     /* 262019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 262027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 262030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 262033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 262042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 262046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 262049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262057 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262059 */     GIR_RootConstrainSelectedInstOperands,
     /* 262060 */     // GIR_Coverage, 7622,
     /* 262060 */     GIR_EraseRootFromParent_Done,
     /* 262061 */   // Label 5084: @262061
     /* 262061 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262108), // Rule ID 7624 //
     /* 262066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 262074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 262093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 262096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262104 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262106 */     GIR_RootConstrainSelectedInstOperands,
     /* 262107 */     // GIR_Coverage, 7624,
     /* 262107 */     GIR_EraseRootFromParent_Done,
     /* 262108 */   // Label 5085: @262108
     /* 262108 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262155), // Rule ID 7626 //
     /* 262113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 262121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 262140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 262143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262153 */     GIR_RootConstrainSelectedInstOperands,
     /* 262154 */     // GIR_Coverage, 7626,
     /* 262154 */     GIR_EraseRootFromParent_Done,
     /* 262155 */   // Label 5086: @262155
     /* 262155 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(262202), // Rule ID 7628 //
     /* 262160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 262168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 262187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 262190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262200 */     GIR_RootConstrainSelectedInstOperands,
     /* 262201 */     // GIR_Coverage, 7628,
     /* 262201 */     GIR_EraseRootFromParent_Done,
     /* 262202 */   // Label 5087: @262202
     /* 262202 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(262249), // Rule ID 8258 //
     /* 262207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262234 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1475:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262247 */     GIR_RootConstrainSelectedInstOperands,
     /* 262248 */     // GIR_Coverage, 8258,
     /* 262248 */     GIR_EraseRootFromParent_Done,
     /* 262249 */   // Label 5088: @262249
     /* 262249 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(262296), // Rule ID 8261 //
     /* 262254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262281 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262292 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262294 */     GIR_RootConstrainSelectedInstOperands,
     /* 262295 */     // GIR_Coverage, 8261,
     /* 262295 */     GIR_EraseRootFromParent_Done,
     /* 262296 */   // Label 5089: @262296
     /* 262296 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(262343), // Rule ID 8264 //
     /* 262301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262328 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 262331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262339 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262341 */     GIR_RootConstrainSelectedInstOperands,
     /* 262342 */     // GIR_Coverage, 8264,
     /* 262342 */     GIR_EraseRootFromParent_Done,
     /* 262343 */   // Label 5090: @262343
     /* 262343 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(262390), // Rule ID 8267 //
     /* 262348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262375 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 262378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262386 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262388 */     GIR_RootConstrainSelectedInstOperands,
     /* 262389 */     // GIR_Coverage, 8267,
     /* 262389 */     GIR_EraseRootFromParent_Done,
     /* 262390 */   // Label 5091: @262390
     /* 262390 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(262437), // Rule ID 8270 //
     /* 262395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 262425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262433 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262435 */     GIR_RootConstrainSelectedInstOperands,
     /* 262436 */     // GIR_Coverage, 8270,
     /* 262436 */     GIR_EraseRootFromParent_Done,
     /* 262437 */   // Label 5092: @262437
     /* 262437 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(262484), // Rule ID 8273 //
     /* 262442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 262450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262469 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 262472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262480 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262482 */     GIR_RootConstrainSelectedInstOperands,
     /* 262483 */     // GIR_Coverage, 8273,
     /* 262483 */     GIR_EraseRootFromParent_Done,
     /* 262484 */   // Label 5093: @262484
     /* 262484 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(262531), // Rule ID 8276 //
     /* 262489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262516 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262529 */     GIR_RootConstrainSelectedInstOperands,
     /* 262530 */     // GIR_Coverage, 8276,
     /* 262530 */     GIR_EraseRootFromParent_Done,
     /* 262531 */   // Label 5094: @262531
     /* 262531 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(262578), // Rule ID 8277 //
     /* 262536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262563 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262574 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262576 */     GIR_RootConstrainSelectedInstOperands,
     /* 262577 */     // GIR_Coverage, 8277,
     /* 262577 */     GIR_EraseRootFromParent_Done,
     /* 262578 */   // Label 5095: @262578
     /* 262578 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(262625), // Rule ID 8278 //
     /* 262583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262610 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 262613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262621 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262623 */     GIR_RootConstrainSelectedInstOperands,
     /* 262624 */     // GIR_Coverage, 8278,
     /* 262624 */     GIR_EraseRootFromParent_Done,
     /* 262625 */   // Label 5096: @262625
     /* 262625 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(262672), // Rule ID 8279 //
     /* 262630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262657 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 262660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262668 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262670 */     GIR_RootConstrainSelectedInstOperands,
     /* 262671 */     // GIR_Coverage, 8279,
     /* 262671 */     GIR_EraseRootFromParent_Done,
     /* 262672 */   // Label 5097: @262672
     /* 262672 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(262719), // Rule ID 8280 //
     /* 262677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 262707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262717 */     GIR_RootConstrainSelectedInstOperands,
     /* 262718 */     // GIR_Coverage, 8280,
     /* 262718 */     GIR_EraseRootFromParent_Done,
     /* 262719 */   // Label 5098: @262719
     /* 262719 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(262766), // Rule ID 8281 //
     /* 262724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 262732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262751 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 262754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262762 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262764 */     GIR_RootConstrainSelectedInstOperands,
     /* 262765 */     // GIR_Coverage, 8281,
     /* 262765 */     GIR_EraseRootFromParent_Done,
     /* 262766 */   // Label 5099: @262766
     /* 262766 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(262813), // Rule ID 8282 //
     /* 262771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262809 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262811 */     GIR_RootConstrainSelectedInstOperands,
     /* 262812 */     // GIR_Coverage, 8282,
     /* 262812 */     GIR_EraseRootFromParent_Done,
     /* 262813 */   // Label 5100: @262813
     /* 262813 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(262860), // Rule ID 8283 //
     /* 262818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262845 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262858 */     GIR_RootConstrainSelectedInstOperands,
     /* 262859 */     // GIR_Coverage, 8283,
     /* 262859 */     GIR_EraseRootFromParent_Done,
     /* 262860 */   // Label 5101: @262860
     /* 262860 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(262907), // Rule ID 8284 //
     /* 262865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262892 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 262895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262903 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262905 */     GIR_RootConstrainSelectedInstOperands,
     /* 262906 */     // GIR_Coverage, 8284,
     /* 262906 */     GIR_EraseRootFromParent_Done,
     /* 262907 */   // Label 5102: @262907
     /* 262907 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(262954), // Rule ID 8285 //
     /* 262912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 262942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262950 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262952 */     GIR_RootConstrainSelectedInstOperands,
     /* 262953 */     // GIR_Coverage, 8285,
     /* 262953 */     GIR_EraseRootFromParent_Done,
     /* 262954 */   // Label 5103: @262954
     /* 262954 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263001), // Rule ID 8286 //
     /* 262959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 262967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262986 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 262989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262997 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262999 */     GIR_RootConstrainSelectedInstOperands,
     /* 263000 */     // GIR_Coverage, 8286,
     /* 263000 */     GIR_EraseRootFromParent_Done,
     /* 263001 */   // Label 5104: @263001
     /* 263001 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263048), // Rule ID 8287 //
     /* 263006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 263014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263033 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 263036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263046 */     GIR_RootConstrainSelectedInstOperands,
     /* 263047 */     // GIR_Coverage, 8287,
     /* 263047 */     GIR_EraseRootFromParent_Done,
     /* 263048 */   // Label 5105: @263048
     /* 263048 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263095), // Rule ID 8288 //
     /* 263053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 263061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263080 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 263083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263091 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263093 */     GIR_RootConstrainSelectedInstOperands,
     /* 263094 */     // GIR_Coverage, 8288,
     /* 263094 */     GIR_EraseRootFromParent_Done,
     /* 263095 */   // Label 5106: @263095
     /* 263095 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263142), // Rule ID 8289 //
     /* 263100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 263108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263127 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 263130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263138 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263140 */     GIR_RootConstrainSelectedInstOperands,
     /* 263141 */     // GIR_Coverage, 8289,
     /* 263141 */     GIR_EraseRootFromParent_Done,
     /* 263142 */   // Label 5107: @263142
     /* 263142 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(263189), // Rule ID 8290 //
     /* 263147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 263155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 263177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263185 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263187 */     GIR_RootConstrainSelectedInstOperands,
     /* 263188 */     // GIR_Coverage, 8290,
     /* 263188 */     GIR_EraseRootFromParent_Done,
     /* 263189 */   // Label 5108: @263189
     /* 263189 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(263236), // Rule ID 8291 //
     /* 263194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 263224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263232 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263234 */     GIR_RootConstrainSelectedInstOperands,
     /* 263235 */     // GIR_Coverage, 8291,
     /* 263235 */     GIR_EraseRootFromParent_Done,
     /* 263236 */   // Label 5109: @263236
     /* 263236 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(263283), // Rule ID 8292 //
     /* 263241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263268 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 263271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263279 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263281 */     GIR_RootConstrainSelectedInstOperands,
     /* 263282 */     // GIR_Coverage, 8292,
     /* 263282 */     GIR_EraseRootFromParent_Done,
     /* 263283 */   // Label 5110: @263283
     /* 263283 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(263330), // Rule ID 8293 //
     /* 263288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 263296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263315 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 263318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263326 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263328 */     GIR_RootConstrainSelectedInstOperands,
     /* 263329 */     // GIR_Coverage, 8293,
     /* 263329 */     GIR_EraseRootFromParent_Done,
     /* 263330 */   // Label 5111: @263330
     /* 263330 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(263377), // Rule ID 8294 //
     /* 263335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 263365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263373 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263375 */     GIR_RootConstrainSelectedInstOperands,
     /* 263376 */     // GIR_Coverage, 8294,
     /* 263376 */     GIR_EraseRootFromParent_Done,
     /* 263377 */   // Label 5112: @263377
     /* 263377 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(263424), // Rule ID 8295 //
     /* 263382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 263412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263420 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263422 */     GIR_RootConstrainSelectedInstOperands,
     /* 263423 */     // GIR_Coverage, 8295,
     /* 263423 */     GIR_EraseRootFromParent_Done,
     /* 263424 */   // Label 5113: @263424
     /* 263424 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(263471), // Rule ID 8296 //
     /* 263429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 263437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263456 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 263459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263467 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263469 */     GIR_RootConstrainSelectedInstOperands,
     /* 263470 */     // GIR_Coverage, 8296,
     /* 263470 */     GIR_EraseRootFromParent_Done,
     /* 263471 */   // Label 5114: @263471
     /* 263471 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(263518), // Rule ID 8297 //
     /* 263476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263503 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263514 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263516 */     GIR_RootConstrainSelectedInstOperands,
     /* 263517 */     // GIR_Coverage, 8297,
     /* 263517 */     GIR_EraseRootFromParent_Done,
     /* 263518 */   // Label 5115: @263518
     /* 263518 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(263565), // Rule ID 8300 //
     /* 263523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263550 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263561 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263563 */     GIR_RootConstrainSelectedInstOperands,
     /* 263564 */     // GIR_Coverage, 8300,
     /* 263564 */     GIR_EraseRootFromParent_Done,
     /* 263565 */   // Label 5116: @263565
     /* 263565 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(263612), // Rule ID 8303 //
     /* 263570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263597 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 263600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263608 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263610 */     GIR_RootConstrainSelectedInstOperands,
     /* 263611 */     // GIR_Coverage, 8303,
     /* 263611 */     GIR_EraseRootFromParent_Done,
     /* 263612 */   // Label 5117: @263612
     /* 263612 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(263659), // Rule ID 8306 //
     /* 263617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263644 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 263647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263655 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263657 */     GIR_RootConstrainSelectedInstOperands,
     /* 263658 */     // GIR_Coverage, 8306,
     /* 263658 */     GIR_EraseRootFromParent_Done,
     /* 263659 */   // Label 5118: @263659
     /* 263659 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(263706), // Rule ID 8309 //
     /* 263664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263691 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 263694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263702 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263704 */     GIR_RootConstrainSelectedInstOperands,
     /* 263705 */     // GIR_Coverage, 8309,
     /* 263705 */     GIR_EraseRootFromParent_Done,
     /* 263706 */   // Label 5119: @263706
     /* 263706 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(263753), // Rule ID 8312 //
     /* 263711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 263719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 263741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263749 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263751 */     GIR_RootConstrainSelectedInstOperands,
     /* 263752 */     // GIR_Coverage, 8312,
     /* 263752 */     GIR_EraseRootFromParent_Done,
     /* 263753 */   // Label 5120: @263753
     /* 263753 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(263800), // Rule ID 8315 //
     /* 263758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263785 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263796 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263798 */     GIR_RootConstrainSelectedInstOperands,
     /* 263799 */     // GIR_Coverage, 8315,
     /* 263799 */     GIR_EraseRootFromParent_Done,
     /* 263800 */   // Label 5121: @263800
     /* 263800 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(263847), // Rule ID 8318 //
     /* 263805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263843 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263845 */     GIR_RootConstrainSelectedInstOperands,
     /* 263846 */     // GIR_Coverage, 8318,
     /* 263846 */     GIR_EraseRootFromParent_Done,
     /* 263847 */   // Label 5122: @263847
     /* 263847 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(263894), // Rule ID 8321 //
     /* 263852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 263882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263890 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263892 */     GIR_RootConstrainSelectedInstOperands,
     /* 263893 */     // GIR_Coverage, 8321,
     /* 263893 */     GIR_EraseRootFromParent_Done,
     /* 263894 */   // Label 5123: @263894
     /* 263894 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(263941), // Rule ID 8324 //
     /* 263899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263926 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 263929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263937 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263939 */     GIR_RootConstrainSelectedInstOperands,
     /* 263940 */     // GIR_Coverage, 8324,
     /* 263940 */     GIR_EraseRootFromParent_Done,
     /* 263941 */   // Label 5124: @263941
     /* 263941 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(263988), // Rule ID 8327 //
     /* 263946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 263954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263973 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 263976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 263978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263986 */     GIR_RootConstrainSelectedInstOperands,
     /* 263987 */     // GIR_Coverage, 8327,
     /* 263987 */     GIR_EraseRootFromParent_Done,
     /* 263988 */   // Label 5125: @263988
     /* 263988 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264035), // Rule ID 8330 //
     /* 263993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 264001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264020 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 264023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264031 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264033 */     GIR_RootConstrainSelectedInstOperands,
     /* 264034 */     // GIR_Coverage, 8330,
     /* 264034 */     GIR_EraseRootFromParent_Done,
     /* 264035 */   // Label 5126: @264035
     /* 264035 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264082), // Rule ID 8333 //
     /* 264040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264067 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 264070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264078 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264080 */     GIR_RootConstrainSelectedInstOperands,
     /* 264081 */     // GIR_Coverage, 8333,
     /* 264081 */     GIR_EraseRootFromParent_Done,
     /* 264082 */   // Label 5127: @264082
     /* 264082 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264129), // Rule ID 8335 //
     /* 264087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264114 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 264117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264127 */     GIR_RootConstrainSelectedInstOperands,
     /* 264128 */     // GIR_Coverage, 8335,
     /* 264128 */     GIR_EraseRootFromParent_Done,
     /* 264129 */   // Label 5128: @264129
     /* 264129 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(264176), // Rule ID 8337 //
     /* 264134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264161 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 264164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264172 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264174 */     GIR_RootConstrainSelectedInstOperands,
     /* 264175 */     // GIR_Coverage, 8337,
     /* 264175 */     GIR_EraseRootFromParent_Done,
     /* 264176 */   // Label 5129: @264176
     /* 264176 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(264223), // Rule ID 8339 //
     /* 264181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 264211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264221 */     GIR_RootConstrainSelectedInstOperands,
     /* 264222 */     // GIR_Coverage, 8339,
     /* 264222 */     GIR_EraseRootFromParent_Done,
     /* 264223 */   // Label 5130: @264223
     /* 264223 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(264270), // Rule ID 8341 //
     /* 264228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264255 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 264258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264266 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264268 */     GIR_RootConstrainSelectedInstOperands,
     /* 264269 */     // GIR_Coverage, 8341,
     /* 264269 */     GIR_EraseRootFromParent_Done,
     /* 264270 */   // Label 5131: @264270
     /* 264270 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(264317), // Rule ID 8343 //
     /* 264275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 264283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 264305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264315 */     GIR_RootConstrainSelectedInstOperands,
     /* 264316 */     // GIR_Coverage, 8343,
     /* 264316 */     GIR_EraseRootFromParent_Done,
     /* 264317 */   // Label 5132: @264317
     /* 264317 */   GIM_Reject,
     /* 264318 */ // Label 4991: @264318
     /* 264318 */ GIM_Reject,
     /* 264319 */ // Label 38: @264319
     /* 264319 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(264397),
     /* 264324 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 264327 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(264349), // Rule ID 78 //
     /* 264332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 264340 */     // (intrinsic_void 2173:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 264340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 264343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264347 */     GIR_RootConstrainSelectedInstOperands,
     /* 264348 */     // GIR_Coverage, 78,
     /* 264348 */     GIR_EraseRootFromParent_Done,
     /* 264349 */   // Label 5134: @264349
     /* 264349 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(264374), // Rule ID 2386 //
     /* 264354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 264362 */     // (intrinsic_void 1723:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 264362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 264365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 264368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264372 */     GIR_RootConstrainSelectedInstOperands,
     /* 264373 */     // GIR_Coverage, 2386,
     /* 264373 */     GIR_EraseRootFromParent_Done,
     /* 264374 */   // Label 5135: @264374
     /* 264374 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(264396), // Rule ID 7164 //
     /* 264379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 264384 */     // (intrinsic_void 507:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 264384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 264387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 264390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264394 */     GIR_RootConstrainSelectedInstOperands,
     /* 264395 */     // GIR_Coverage, 7164,
     /* 264395 */     GIR_EraseRootFromParent_Done,
     /* 264396 */   // Label 5136: @264396
     /* 264396 */   GIM_Reject,
     /* 264397 */ // Label 5133: @264397
     /* 264397 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(264997),
     /* 264402 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 264405 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(264437), // Rule ID 79 //
     /* 264410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 264418 */     // MIs[0] imm
     /* 264418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 264426 */     // (intrinsic_void 2172:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 264426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 264429 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264435 */     GIR_RootConstrainSelectedInstOperands,
     /* 264436 */     // GIR_Coverage, 79,
     /* 264436 */     GIR_EraseRootFromParent_Done,
     /* 264437 */   // Label 5138: @264437
     /* 264437 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(264462), // Rule ID 227 //
     /* 264442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 264447 */     // MIs[0] imm
     /* 264447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 264455 */     // (intrinsic_void 505:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 264455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 264458 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264460 */     GIR_RootConstrainSelectedInstOperands,
     /* 264461 */     // GIR_Coverage, 227,
     /* 264461 */     GIR_EraseRootFromParent_Done,
     /* 264462 */   // Label 5139: @264462
     /* 264462 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(264487), // Rule ID 228 //
     /* 264467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 264472 */     // MIs[0] imm
     /* 264472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 264480 */     // (intrinsic_void 564:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 264480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 264483 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264485 */     GIR_RootConstrainSelectedInstOperands,
     /* 264486 */     // GIR_Coverage, 228,
     /* 264486 */     GIR_EraseRootFromParent_Done,
     /* 264487 */   // Label 5140: @264487
     /* 264487 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(264519), // Rule ID 3617 //
     /* 264492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 264500 */     // MIs[0] imm
     /* 264500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 264503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 264508 */     // (intrinsic_void 1229:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 264508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 264511 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 264513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264517 */     GIR_RootConstrainSelectedInstOperands,
     /* 264518 */     // GIR_Coverage, 3617,
     /* 264518 */     GIR_EraseRootFromParent_Done,
     /* 264519 */   // Label 5141: @264519
     /* 264519 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(264559), // Rule ID 16 //
     /* 264524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 264529 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 264544 */     // MIs[1] Operand 1
     /* 264544 */     // No operand predicates
     /* 264544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264546 */     // (intrinsic_void 563:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 264546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 264549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264557 */     GIR_RootConstrainSelectedInstOperands,
     /* 264558 */     // GIR_Coverage, 16,
     /* 264558 */     GIR_EraseRootFromParent_Done,
     /* 264559 */   // Label 5142: @264559
     /* 264559 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(264599), // Rule ID 17 //
     /* 264564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 264569 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264584 */     // MIs[1] Operand 1
     /* 264584 */     // No operand predicates
     /* 264584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264586 */     // (intrinsic_void 551:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 264586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 264589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264597 */     GIR_RootConstrainSelectedInstOperands,
     /* 264598 */     // GIR_Coverage, 17,
     /* 264598 */     GIR_EraseRootFromParent_Done,
     /* 264599 */   // Label 5143: @264599
     /* 264599 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(264639), // Rule ID 18 //
     /* 264604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 264609 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264624 */     // MIs[1] Operand 1
     /* 264624 */     // No operand predicates
     /* 264624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264626 */     // (intrinsic_void 552:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 264626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 264629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264637 */     GIR_RootConstrainSelectedInstOperands,
     /* 264638 */     // GIR_Coverage, 18,
     /* 264638 */     GIR_EraseRootFromParent_Done,
     /* 264639 */   // Label 5144: @264639
     /* 264639 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(264679), // Rule ID 19 //
     /* 264644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 264649 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 264664 */     // MIs[1] Operand 1
     /* 264664 */     // No operand predicates
     /* 264664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264666 */     // (intrinsic_void 567:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 264666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 264669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 264672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 264677 */     GIR_RootConstrainSelectedInstOperands,
     /* 264678 */     // GIR_Coverage, 19,
     /* 264678 */     GIR_EraseRootFromParent_Done,
     /* 264679 */   // Label 5145: @264679
     /* 264679 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(264703), // Rule ID 72 //
     /* 264684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 264689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264696 */     // (intrinsic_w_chain:{ *:[i64] } 560:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 264696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 264699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264701 */     GIR_RootConstrainSelectedInstOperands,
     /* 264702 */     // GIR_Coverage, 72,
     /* 264702 */     GIR_EraseRootFromParent_Done,
     /* 264703 */   // Label 5146: @264703
     /* 264703 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(264727), // Rule ID 74 //
     /* 264708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 264713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264720 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 264720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 264723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 264725 */     GIR_RootConstrainSelectedInstOperands,
     /* 264726 */     // GIR_Coverage, 74,
     /* 264726 */     GIR_EraseRootFromParent_Done,
     /* 264727 */   // Label 5147: @264727
     /* 264727 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(264758), // Rule ID 77 //
     /* 264732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 264740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264747 */     // (intrinsic_w_chain:{ *:[i64] } 2174:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 264747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 264750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264756 */     GIR_RootConstrainSelectedInstOperands,
     /* 264757 */     // GIR_Coverage, 77,
     /* 264757 */     GIR_EraseRootFromParent_Done,
     /* 264758 */   // Label 5148: @264758
     /* 264758 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(264785), // Rule ID 80 //
     /* 264763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 264766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 264771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264778 */     // (intrinsic_w_chain:{ *:[i64] } 2175:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 264778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 264781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264783 */     GIR_RootConstrainSelectedInstOperands,
     /* 264784 */     // GIR_Coverage, 80,
     /* 264784 */     GIR_EraseRootFromParent_Done,
     /* 264785 */   // Label 5149: @264785
     /* 264785 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(264816), // Rule ID 2385 //
     /* 264790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 264798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 264801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 264805 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1673:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 264805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 264808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 264810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264814 */     GIR_RootConstrainSelectedInstOperands,
     /* 264815 */     // GIR_Coverage, 2385,
     /* 264815 */     GIR_EraseRootFromParent_Done,
     /* 264816 */   // Label 5150: @264816
     /* 264816 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(264856), // Rule ID 12851 //
     /* 264821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 264829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264836 */     // (intrinsic_w_chain:{ *:[i64] } 898:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 264836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 264839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 264841 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 264851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 264854 */     GIR_RootConstrainSelectedInstOperands,
     /* 264855 */     // GIR_Coverage, 12851,
     /* 264855 */     GIR_EraseRootFromParent_Done,
     /* 264856 */   // Label 5151: @264856
     /* 264856 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(264890), // Rule ID 2387 //
     /* 264861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 264864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 264869 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 264872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 264876 */     // (intrinsic_void 2153:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 264876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 264879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 264881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 264884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264888 */     GIR_RootConstrainSelectedInstOperands,
     /* 264889 */     // GIR_Coverage, 2387,
     /* 264889 */     GIR_EraseRootFromParent_Done,
     /* 264890 */   // Label 5152: @264890
     /* 264890 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(264913), // Rule ID 73 //
     /* 264895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 264900 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264903 */     // (intrinsic_void 787:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 264903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 264906 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 264911 */     GIR_RootConstrainSelectedInstOperands,
     /* 264912 */     // GIR_Coverage, 73,
     /* 264912 */     GIR_EraseRootFromParent_Done,
     /* 264913 */   // Label 5153: @264913
     /* 264913 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(264936), // Rule ID 75 //
     /* 264918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 264923 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264926 */     // (intrinsic_void 789:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 264926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 264929 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 264934 */     GIR_RootConstrainSelectedInstOperands,
     /* 264935 */     // GIR_Coverage, 75,
     /* 264935 */     GIR_EraseRootFromParent_Done,
     /* 264936 */   // Label 5154: @264936
     /* 264936 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(264963), // Rule ID 76 //
     /* 264941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 264946 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264949 */     // (intrinsic_void 788:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 264949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 264952 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 264957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 264961 */     GIR_RootConstrainSelectedInstOperands,
     /* 264962 */     // GIR_Coverage, 76,
     /* 264962 */     GIR_EraseRootFromParent_Done,
     /* 264963 */   // Label 5155: @264963
     /* 264963 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(264996), // Rule ID 12850 //
     /* 264968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 264971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 264976 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264979 */     // (intrinsic_void 973:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 264979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 264982 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 264992 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 264994 */     GIR_RootConstrainSelectedInstOperands,
     /* 264995 */     // GIR_Coverage, 12850,
     /* 264995 */     GIR_EraseRootFromParent_Done,
     /* 264996 */   // Label 5156: @264996
     /* 264996 */   GIM_Reject,
     /* 264997 */ // Label 5137: @264997
     /* 264997 */ GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(265968),
     /* 265002 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 265005 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(265081), // Rule ID 7130 //
     /* 265010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 265015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265022 */     // MIs[0] addr
     /* 265022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 265034 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 265041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265050 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265080 */     // GIR_Coverage, 7130,
     /* 265080 */     GIR_EraseRootFromParent_Done,
     /* 265081 */   // Label 5158: @265081
     /* 265081 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(265157), // Rule ID 7131 //
     /* 265086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 265091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265098 */     // MIs[0] addr
     /* 265098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 265110 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 265117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265126 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265156 */     // GIR_Coverage, 7131,
     /* 265156 */     GIR_EraseRootFromParent_Done,
     /* 265157 */   // Label 5159: @265157
     /* 265157 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(265233), // Rule ID 7132 //
     /* 265162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 265167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265174 */     // MIs[0] addr
     /* 265174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 265186 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 265193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265202 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265232 */     // GIR_Coverage, 7132,
     /* 265232 */     GIR_EraseRootFromParent_Done,
     /* 265233 */   // Label 5160: @265233
     /* 265233 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(265275), // Rule ID 7133 //
     /* 265238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 265243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265250 */     // MIs[0] addr
     /* 265250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 265262 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 265262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 265265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265267 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 265269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265273 */     GIR_RootConstrainSelectedInstOperands,
     /* 265274 */     // GIR_Coverage, 7133,
     /* 265274 */     GIR_EraseRootFromParent_Done,
     /* 265275 */   // Label 5161: @265275
     /* 265275 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(265351), // Rule ID 7137 //
     /* 265280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265292 */     // MIs[0] addr
     /* 265292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 265304 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 265311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265350 */     // GIR_Coverage, 7137,
     /* 265350 */     GIR_EraseRootFromParent_Done,
     /* 265351 */   // Label 5162: @265351
     /* 265351 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(265427), // Rule ID 7138 //
     /* 265356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265368 */     // MIs[0] addr
     /* 265368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 265380 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 265387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265396 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265426 */     // GIR_Coverage, 7138,
     /* 265426 */     GIR_EraseRootFromParent_Done,
     /* 265427 */   // Label 5163: @265427
     /* 265427 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(265503), // Rule ID 7139 //
     /* 265432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265444 */     // MIs[0] addr
     /* 265444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 265456 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 265456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 265463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 265472 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 265481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 265492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265502 */     // GIR_Coverage, 7139,
     /* 265502 */     GIR_EraseRootFromParent_Done,
     /* 265503 */   // Label 5164: @265503
     /* 265503 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(265545), // Rule ID 7140 //
     /* 265508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 265513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265520 */     // MIs[0] addr
     /* 265520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 265524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 265532 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 265532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 265535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265537 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 265539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265543 */     GIR_RootConstrainSelectedInstOperands,
     /* 265544 */     // GIR_Coverage, 7140,
     /* 265544 */     GIR_EraseRootFromParent_Done,
     /* 265545 */   // Label 5165: @265545
     /* 265545 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(265585), // Rule ID 20 //
     /* 265550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 265553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 265558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265572 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 265572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 265575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 265577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 265579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265583 */     GIR_RootConstrainSelectedInstOperands,
     /* 265584 */     // GIR_Coverage, 20,
     /* 265584 */     GIR_EraseRootFromParent_Done,
     /* 265585 */   // Label 5166: @265585
     /* 265585 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(265625), // Rule ID 2384 //
     /* 265590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 265593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 265598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 265601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 265608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 265612 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1674:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 265612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 265615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 265617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 265619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265623 */     GIR_RootConstrainSelectedInstOperands,
     /* 265624 */     // GIR_Coverage, 2384,
     /* 265624 */     GIR_EraseRootFromParent_Done,
     /* 265625 */   // Label 5167: @265625
     /* 265625 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(265665), // Rule ID 2488 //
     /* 265630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 265638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265652 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 265652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 265655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265663 */     GIR_RootConstrainSelectedInstOperands,
     /* 265664 */     // GIR_Coverage, 2488,
     /* 265664 */     GIR_EraseRootFromParent_Done,
     /* 265665 */   // Label 5168: @265665
     /* 265665 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(265705), // Rule ID 2489 //
     /* 265670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 265678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265692 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 265692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 265695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265703 */     GIR_RootConstrainSelectedInstOperands,
     /* 265704 */     // GIR_Coverage, 2489,
     /* 265704 */     GIR_EraseRootFromParent_Done,
     /* 265705 */   // Label 5169: @265705
     /* 265705 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(265745), // Rule ID 7017 //
     /* 265710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 265718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265732 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 265732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 265735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265743 */     GIR_RootConstrainSelectedInstOperands,
     /* 265744 */     // GIR_Coverage, 7017,
     /* 265744 */     GIR_EraseRootFromParent_Done,
     /* 265745 */   // Label 5170: @265745
     /* 265745 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(265785), // Rule ID 7018 //
     /* 265750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 265753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 265758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 265761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265772 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 265772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 265775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265783 */     GIR_RootConstrainSelectedInstOperands,
     /* 265784 */     // GIR_Coverage, 7018,
     /* 265784 */     GIR_EraseRootFromParent_Done,
     /* 265785 */   // Label 5171: @265785
     /* 265785 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(265821), // Rule ID 3570 //
     /* 265790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 265798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265808 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 265811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265819 */     GIR_RootConstrainSelectedInstOperands,
     /* 265820 */     // GIR_Coverage, 3570,
     /* 265820 */     GIR_EraseRootFromParent_Done,
     /* 265821 */   // Label 5172: @265821
     /* 265821 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(265859), // Rule ID 3998 //
     /* 265826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 265829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 265834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 265837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 265844 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 265844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 265847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 265855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 265857 */     GIR_RootConstrainSelectedInstOperands,
     /* 265858 */     // GIR_Coverage, 3998,
     /* 265858 */     GIR_EraseRootFromParent_Done,
     /* 265859 */   // Label 5173: @265859
     /* 265859 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(265895), // Rule ID 12576 //
     /* 265864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 265872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265882 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1500:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 265885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265893 */     GIR_RootConstrainSelectedInstOperands,
     /* 265894 */     // GIR_Coverage, 12576,
     /* 265894 */     GIR_EraseRootFromParent_Done,
     /* 265895 */   // Label 5174: @265895
     /* 265895 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(265931), // Rule ID 12577 //
     /* 265900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 265908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265918 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 265921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265929 */     GIR_RootConstrainSelectedInstOperands,
     /* 265930 */     // GIR_Coverage, 12577,
     /* 265930 */     GIR_EraseRootFromParent_Done,
     /* 265931 */   // Label 5175: @265931
     /* 265931 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(265967), // Rule ID 12578 //
     /* 265936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 265939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 265944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 265950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265954 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 265954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 265957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265965 */     GIR_RootConstrainSelectedInstOperands,
     /* 265966 */     // GIR_Coverage, 12578,
     /* 265966 */     GIR_EraseRootFromParent_Done,
     /* 265967 */   // Label 5176: @265967
     /* 265967 */   GIM_Reject,
     /* 265968 */ // Label 5157: @265968
     /* 265968 */ GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(270136),
     /* 265973 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 265976 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(266073), // Rule ID 7148 //
     /* 265981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 265986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 265989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266029 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 266040 */     // MIs[0] addr
     /* 266040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 266052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266054 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 266057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266063 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266071 */     GIR_RootConstrainSelectedInstOperands,
     /* 266072 */     // GIR_Coverage, 7148,
     /* 266072 */     GIR_EraseRootFromParent_Done,
     /* 266073 */   // Label 5178: @266073
     /* 266073 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266170), // Rule ID 7149 //
     /* 266078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266126 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 266137 */     // MIs[0] addr
     /* 266137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 266149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266151 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 266154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266160 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266168 */     GIR_RootConstrainSelectedInstOperands,
     /* 266169 */     // GIR_Coverage, 7149,
     /* 266169 */     GIR_EraseRootFromParent_Done,
     /* 266170 */   // Label 5179: @266170
     /* 266170 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(266267), // Rule ID 7158 //
     /* 266175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266223 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 266234 */     // MIs[0] addr
     /* 266234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 266246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266248 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 266251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266257 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266265 */     GIR_RootConstrainSelectedInstOperands,
     /* 266266 */     // GIR_Coverage, 7158,
     /* 266266 */     GIR_EraseRootFromParent_Done,
     /* 266267 */   // Label 5180: @266267
     /* 266267 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(266364), // Rule ID 7159 //
     /* 266272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 266295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 266311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 266315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266320 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 266331 */     // MIs[0] addr
     /* 266331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 266343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266345 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 266345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 266348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 266354 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 266362 */     GIR_RootConstrainSelectedInstOperands,
     /* 266363 */     // GIR_Coverage, 7159,
     /* 266363 */     GIR_EraseRootFromParent_Done,
     /* 266364 */   // Label 5181: @266364
     /* 266364 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(266475), // Rule ID 7151 //
     /* 266369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266405 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 266416 */     // MIs[0] addr
     /* 266416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 266428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266430 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266442 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 266461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266466 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266473 */     GIR_RootConstrainSelectedInstOperands,
     /* 266474 */     // GIR_Coverage, 7151,
     /* 266474 */     GIR_EraseRootFromParent_Done,
     /* 266475 */   // Label 5182: @266475
     /* 266475 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(266586), // Rule ID 7152 //
     /* 266480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266516 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 266527 */     // MIs[0] addr
     /* 266527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 266539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266541 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266553 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 266572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266577 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266584 */     GIR_RootConstrainSelectedInstOperands,
     /* 266585 */     // GIR_Coverage, 7152,
     /* 266585 */     GIR_EraseRootFromParent_Done,
     /* 266586 */   // Label 5183: @266586
     /* 266586 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(266697), // Rule ID 7153 //
     /* 266591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 266596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266627 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 266638 */     // MIs[0] addr
     /* 266638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 266650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266652 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266664 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 266683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266688 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266695 */     GIR_RootConstrainSelectedInstOperands,
     /* 266696 */     // GIR_Coverage, 7153,
     /* 266696 */     GIR_EraseRootFromParent_Done,
     /* 266697 */   // Label 5184: @266697
     /* 266697 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(266808), // Rule ID 7161 //
     /* 266702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266738 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 266749 */     // MIs[0] addr
     /* 266749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 266761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266763 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 266794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266799 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266806 */     GIR_RootConstrainSelectedInstOperands,
     /* 266807 */     // GIR_Coverage, 7161,
     /* 266807 */     GIR_EraseRootFromParent_Done,
     /* 266808 */   // Label 5185: @266808
     /* 266808 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(266919), // Rule ID 7162 //
     /* 266813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266849 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 266860 */     // MIs[0] addr
     /* 266860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 266872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266874 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266886 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 266892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 266905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 266907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266910 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 266912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266917 */     GIR_RootConstrainSelectedInstOperands,
     /* 266918 */     // GIR_Coverage, 7162,
     /* 266918 */     GIR_EraseRootFromParent_Done,
     /* 266919 */   // Label 5186: @266919
     /* 266919 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267030), // Rule ID 7163 //
     /* 266924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 266929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 266932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 266947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 266951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266960 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 266971 */     // MIs[0] addr
     /* 266971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 266975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 266983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266985 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 266985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266997 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 267016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267021 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267028 */     GIR_RootConstrainSelectedInstOperands,
     /* 267029 */     // GIR_Coverage, 7163,
     /* 267029 */     GIR_EraseRootFromParent_Done,
     /* 267030 */   // Label 5187: @267030
     /* 267030 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267081), // Rule ID 70 //
     /* 267035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 267040 */     // MIs[0] ptr
     /* 267040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 267044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 267048 */     // MIs[0] accessinfo
     /* 267048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 267051 */     // MIs[0] fixed_shadow
     /* 267051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 267054 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 267054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 267057 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 267059 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 267061 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 267063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 267066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 267069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 267072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 267075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267079 */     GIR_RootConstrainSelectedInstOperands,
     /* 267080 */     // GIR_Coverage, 70,
     /* 267080 */     GIR_EraseRootFromParent_Done,
     /* 267081 */   // Label 5188: @267081
     /* 267081 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267132), // Rule ID 71 //
     /* 267086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 267091 */     // MIs[0] ptr
     /* 267091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 267095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 267099 */     // MIs[0] accessinfo
     /* 267099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 267102 */     // MIs[0] fixed_shadow
     /* 267102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 267105 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 267105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 267108 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 267110 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 267112 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 267114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 267117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 267120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 267123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 267126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267130 */     GIR_RootConstrainSelectedInstOperands,
     /* 267131 */     // GIR_Coverage, 71,
     /* 267131 */     GIR_EraseRootFromParent_Done,
     /* 267132 */   // Label 5189: @267132
     /* 267132 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267201), // Rule ID 7150 //
     /* 267137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267169 */     // MIs[0] addr
     /* 267169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 267181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267183 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 267186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 267192 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267199 */     GIR_RootConstrainSelectedInstOperands,
     /* 267200 */     // GIR_Coverage, 7150,
     /* 267200 */     GIR_EraseRootFromParent_Done,
     /* 267201 */   // Label 5190: @267201
     /* 267201 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(267270), // Rule ID 7160 //
     /* 267206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267238 */     // MIs[0] addr
     /* 267238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 267250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267252 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 267255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 267261 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267268 */     GIR_RootConstrainSelectedInstOperands,
     /* 267269 */     // GIR_Coverage, 7160,
     /* 267269 */     GIR_EraseRootFromParent_Done,
     /* 267270 */   // Label 5191: @267270
     /* 267270 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(267312), // Rule ID 3594 //
     /* 267275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 267283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267289 */     // MIs[0] tile
     /* 267289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267297 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 267300 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267310 */     GIR_RootConstrainSelectedInstOperands,
     /* 267311 */     // GIR_Coverage, 3594,
     /* 267311 */     GIR_EraseRootFromParent_Done,
     /* 267312 */   // Label 5192: @267312
     /* 267312 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267354), // Rule ID 3598 //
     /* 267317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 267325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267331 */     // MIs[0] tile
     /* 267331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267339 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 267342 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267352 */     GIR_RootConstrainSelectedInstOperands,
     /* 267353 */     // GIR_Coverage, 3598,
     /* 267353 */     GIR_EraseRootFromParent_Done,
     /* 267354 */   // Label 5193: @267354
     /* 267354 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267396), // Rule ID 3602 //
     /* 267359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 267362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 267367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267373 */     // MIs[0] tile
     /* 267373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267381 */     // (intrinsic_void 1026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 267384 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267394 */     GIR_RootConstrainSelectedInstOperands,
     /* 267395 */     // GIR_Coverage, 3602,
     /* 267395 */     GIR_EraseRootFromParent_Done,
     /* 267396 */   // Label 5194: @267396
     /* 267396 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(267438), // Rule ID 3772 //
     /* 267401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 267404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267415 */     // MIs[0] tile
     /* 267415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 267423 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 267423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 267426 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267436 */     GIR_RootConstrainSelectedInstOperands,
     /* 267437 */     // GIR_Coverage, 3772,
     /* 267437 */     GIR_EraseRootFromParent_Done,
     /* 267438 */   // Label 5195: @267438
     /* 267438 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(267480), // Rule ID 3776 //
     /* 267443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 267446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 267451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267457 */     // MIs[0] tile
     /* 267457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267465 */     // (intrinsic_void 882:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 267468 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267478 */     GIR_RootConstrainSelectedInstOperands,
     /* 267479 */     // GIR_Coverage, 3776,
     /* 267479 */     GIR_EraseRootFromParent_Done,
     /* 267480 */   // Label 5196: @267480
     /* 267480 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(267522), // Rule ID 3780 //
     /* 267485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 267496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267499 */     // MIs[0] tile
     /* 267499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267507 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 267507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 267510 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267520 */     GIR_RootConstrainSelectedInstOperands,
     /* 267521 */     // GIR_Coverage, 3780,
     /* 267521 */     GIR_EraseRootFromParent_Done,
     /* 267522 */   // Label 5197: @267522
     /* 267522 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(267564), // Rule ID 3784 //
     /* 267527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 267530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 267535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 267538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267541 */     // MIs[0] tile
     /* 267541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 267549 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 267549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 267552 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267562 */     GIR_RootConstrainSelectedInstOperands,
     /* 267563 */     // GIR_Coverage, 3784,
     /* 267563 */     GIR_EraseRootFromParent_Done,
     /* 267564 */   // Label 5198: @267564
     /* 267564 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(267606), // Rule ID 3788 //
     /* 267569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 267577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267583 */     // MIs[0] tile
     /* 267583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267591 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 267591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 267594 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267604 */     GIR_RootConstrainSelectedInstOperands,
     /* 267605 */     // GIR_Coverage, 3788,
     /* 267605 */     GIR_EraseRootFromParent_Done,
     /* 267606 */   // Label 5199: @267606
     /* 267606 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(267648), // Rule ID 3792 //
     /* 267611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 267614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 267619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267625 */     // MIs[0] tile
     /* 267625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 267633 */     // (intrinsic_void 878:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 267636 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267646 */     GIR_RootConstrainSelectedInstOperands,
     /* 267647 */     // GIR_Coverage, 3792,
     /* 267647 */     GIR_EraseRootFromParent_Done,
     /* 267648 */   // Label 5200: @267648
     /* 267648 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(267690), // Rule ID 12655 //
     /* 267653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 267661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267667 */     // MIs[0] tile
     /* 267667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267675 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 267678 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267688 */     GIR_RootConstrainSelectedInstOperands,
     /* 267689 */     // GIR_Coverage, 12655,
     /* 267689 */     GIR_EraseRootFromParent_Done,
     /* 267690 */   // Label 5201: @267690
     /* 267690 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(267732), // Rule ID 12659 //
     /* 267695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 267703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267709 */     // MIs[0] tile
     /* 267709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267717 */     // (intrinsic_void 1074:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 267720 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267730 */     GIR_RootConstrainSelectedInstOperands,
     /* 267731 */     // GIR_Coverage, 12659,
     /* 267731 */     GIR_EraseRootFromParent_Done,
     /* 267732 */   // Label 5202: @267732
     /* 267732 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(267774), // Rule ID 12663 //
     /* 267737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 267745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267751 */     // MIs[0] tile
     /* 267751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267759 */     // (intrinsic_void 1082:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 267762 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267772 */     GIR_RootConstrainSelectedInstOperands,
     /* 267773 */     // GIR_Coverage, 12663,
     /* 267773 */     GIR_EraseRootFromParent_Done,
     /* 267774 */   // Label 5203: @267774
     /* 267774 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(267816), // Rule ID 12667 //
     /* 267779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 267787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267793 */     // MIs[0] tile
     /* 267793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267801 */     // (intrinsic_void 1191:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 267804 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267814 */     GIR_RootConstrainSelectedInstOperands,
     /* 267815 */     // GIR_Coverage, 12667,
     /* 267815 */     GIR_EraseRootFromParent_Done,
     /* 267816 */   // Label 5204: @267816
     /* 267816 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(267858), // Rule ID 12671 //
     /* 267821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 267829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267835 */     // MIs[0] tile
     /* 267835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267843 */     // (intrinsic_void 1199:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 267846 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267856 */     GIR_RootConstrainSelectedInstOperands,
     /* 267857 */     // GIR_Coverage, 12671,
     /* 267857 */     GIR_EraseRootFromParent_Done,
     /* 267858 */   // Label 5205: @267858
     /* 267858 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(267900), // Rule ID 12675 //
     /* 267863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 267871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267877 */     // MIs[0] tile
     /* 267877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267885 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 267888 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267898 */     GIR_RootConstrainSelectedInstOperands,
     /* 267899 */     // GIR_Coverage, 12675,
     /* 267899 */     GIR_EraseRootFromParent_Done,
     /* 267900 */   // Label 5206: @267900
     /* 267900 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(267942), // Rule ID 12679 //
     /* 267905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 267913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 267919 */     // MIs[0] tile
     /* 267919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267927 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 267927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 267930 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267940 */     GIR_RootConstrainSelectedInstOperands,
     /* 267941 */     // GIR_Coverage, 12679,
     /* 267941 */     GIR_EraseRootFromParent_Done,
     /* 267942 */   // Label 5207: @267942
     /* 267942 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(267984), // Rule ID 12683 //
     /* 267947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 267955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 267958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267961 */     // MIs[0] tile
     /* 267961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 267964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 267969 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 267969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 267972 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 267974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 267976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 267978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267982 */     GIR_RootConstrainSelectedInstOperands,
     /* 267983 */     // GIR_Coverage, 12683,
     /* 267983 */     GIR_EraseRootFromParent_Done,
     /* 267984 */   // Label 5208: @267984
     /* 267984 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268026), // Rule ID 12687 //
     /* 267989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 267992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 267997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268003 */     // MIs[0] tile
     /* 268003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268011 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 268014 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268024 */     GIR_RootConstrainSelectedInstOperands,
     /* 268025 */     // GIR_Coverage, 12687,
     /* 268025 */     GIR_EraseRootFromParent_Done,
     /* 268026 */   // Label 5209: @268026
     /* 268026 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268068), // Rule ID 12691 //
     /* 268031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 268039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268045 */     // MIs[0] tile
     /* 268045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268053 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 268056 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268066 */     GIR_RootConstrainSelectedInstOperands,
     /* 268067 */     // GIR_Coverage, 12691,
     /* 268067 */     GIR_EraseRootFromParent_Done,
     /* 268068 */   // Label 5210: @268068
     /* 268068 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268110), // Rule ID 12695 //
     /* 268073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 268081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268087 */     // MIs[0] tile
     /* 268087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268095 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 268098 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268108 */     GIR_RootConstrainSelectedInstOperands,
     /* 268109 */     // GIR_Coverage, 12695,
     /* 268109 */     GIR_EraseRootFromParent_Done,
     /* 268110 */   // Label 5211: @268110
     /* 268110 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(268152), // Rule ID 12699 //
     /* 268115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 268123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268129 */     // MIs[0] tile
     /* 268129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268137 */     // (intrinsic_void 1078:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 268140 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268150 */     GIR_RootConstrainSelectedInstOperands,
     /* 268151 */     // GIR_Coverage, 12699,
     /* 268151 */     GIR_EraseRootFromParent_Done,
     /* 268152 */   // Label 5212: @268152
     /* 268152 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(268194), // Rule ID 12703 //
     /* 268157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 268165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268171 */     // MIs[0] tile
     /* 268171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268179 */     // (intrinsic_void 1086:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 268182 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268192 */     GIR_RootConstrainSelectedInstOperands,
     /* 268193 */     // GIR_Coverage, 12703,
     /* 268193 */     GIR_EraseRootFromParent_Done,
     /* 268194 */   // Label 5213: @268194
     /* 268194 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(268236), // Rule ID 12707 //
     /* 268199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 268207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268213 */     // MIs[0] tile
     /* 268213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268221 */     // (intrinsic_void 1161:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 268224 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268234 */     GIR_RootConstrainSelectedInstOperands,
     /* 268235 */     // GIR_Coverage, 12707,
     /* 268235 */     GIR_EraseRootFromParent_Done,
     /* 268236 */   // Label 5214: @268236
     /* 268236 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(268278), // Rule ID 12711 //
     /* 268241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 268249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268255 */     // MIs[0] tile
     /* 268255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268263 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 268266 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268276 */     GIR_RootConstrainSelectedInstOperands,
     /* 268277 */     // GIR_Coverage, 12711,
     /* 268277 */     GIR_EraseRootFromParent_Done,
     /* 268278 */   // Label 5215: @268278
     /* 268278 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(268320), // Rule ID 12715 //
     /* 268283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 268291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268297 */     // MIs[0] tile
     /* 268297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268305 */     // (intrinsic_void 1195:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 268308 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268318 */     GIR_RootConstrainSelectedInstOperands,
     /* 268319 */     // GIR_Coverage, 12715,
     /* 268319 */     GIR_EraseRootFromParent_Done,
     /* 268320 */   // Label 5216: @268320
     /* 268320 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(268362), // Rule ID 12719 //
     /* 268325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 268333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268339 */     // MIs[0] tile
     /* 268339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268347 */     // (intrinsic_void 1203:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 268350 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268360 */     GIR_RootConstrainSelectedInstOperands,
     /* 268361 */     // GIR_Coverage, 12719,
     /* 268361 */     GIR_EraseRootFromParent_Done,
     /* 268362 */   // Label 5217: @268362
     /* 268362 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(268404), // Rule ID 13174 //
     /* 268367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 268375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268381 */     // MIs[0] tile
     /* 268381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268389 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 268392 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268402 */     GIR_RootConstrainSelectedInstOperands,
     /* 268403 */     // GIR_Coverage, 13174,
     /* 268403 */     GIR_EraseRootFromParent_Done,
     /* 268404 */   // Label 5218: @268404
     /* 268404 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(268446), // Rule ID 13178 //
     /* 268409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 268420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 268423 */     // MIs[0] tile
     /* 268423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268431 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 268431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 268434 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268444 */     GIR_RootConstrainSelectedInstOperands,
     /* 268445 */     // GIR_Coverage, 13178,
     /* 268445 */     GIR_EraseRootFromParent_Done,
     /* 268446 */   // Label 5219: @268446
     /* 268446 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(268488), // Rule ID 13182 //
     /* 268451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 268454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268465 */     // MIs[0] tile
     /* 268465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268473 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 268476 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268486 */     GIR_RootConstrainSelectedInstOperands,
     /* 268487 */     // GIR_Coverage, 13182,
     /* 268487 */     GIR_EraseRootFromParent_Done,
     /* 268488 */   // Label 5220: @268488
     /* 268488 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(268530), // Rule ID 13186 //
     /* 268493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 268496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 268501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 268504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268507 */     // MIs[0] tile
     /* 268507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268515 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 268515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 268518 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268528 */     GIR_RootConstrainSelectedInstOperands,
     /* 268529 */     // GIR_Coverage, 13186,
     /* 268529 */     GIR_EraseRootFromParent_Done,
     /* 268530 */   // Label 5221: @268530
     /* 268530 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(268584), // Rule ID 8897 //
     /* 268535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268543 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 268546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268550 */     // MIs[0] base
     /* 268550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268558 */     // MIs[0] prfop
     /* 268558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268566 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 268569 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268571 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268573 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268582 */     GIR_RootConstrainSelectedInstOperands,
     /* 268583 */     // GIR_Coverage, 8897,
     /* 268583 */     GIR_EraseRootFromParent_Done,
     /* 268584 */   // Label 5222: @268584
     /* 268584 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(268638), // Rule ID 8900 //
     /* 268589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268597 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 268600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268604 */     // MIs[0] base
     /* 268604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268612 */     // MIs[0] prfop
     /* 268612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268620 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 268623 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268625 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268627 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268636 */     GIR_RootConstrainSelectedInstOperands,
     /* 268637 */     // GIR_Coverage, 8900,
     /* 268637 */     GIR_EraseRootFromParent_Done,
     /* 268638 */   // Label 5223: @268638
     /* 268638 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(268692), // Rule ID 8903 //
     /* 268643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268651 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 268654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268658 */     // MIs[0] base
     /* 268658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268666 */     // MIs[0] prfop
     /* 268666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268674 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 268677 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268679 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268681 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268690 */     GIR_RootConstrainSelectedInstOperands,
     /* 268691 */     // GIR_Coverage, 8903,
     /* 268691 */     GIR_EraseRootFromParent_Done,
     /* 268692 */   // Label 5224: @268692
     /* 268692 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(268746), // Rule ID 8906 //
     /* 268697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 268705 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 268708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 268712 */     // MIs[0] base
     /* 268712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268720 */     // MIs[0] prfop
     /* 268720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 268728 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 268728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 268731 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 268733 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 268735 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 268737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268744 */     GIR_RootConstrainSelectedInstOperands,
     /* 268745 */     // GIR_Coverage, 8906,
     /* 268745 */     GIR_EraseRootFromParent_Done,
     /* 268746 */   // Label 5225: @268746
     /* 268746 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(268800), // Rule ID 15 //
     /* 268751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 268756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 268762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268777 */     // MIs[1] Operand 1
     /* 268777 */     // No operand predicates
     /* 268777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268783 */     // (intrinsic_w_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 268783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 268786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 268791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268798 */     GIR_RootConstrainSelectedInstOperands,
     /* 268799 */     // GIR_Coverage, 15,
     /* 268799 */     GIR_EraseRootFromParent_Done,
     /* 268800 */   // Label 5226: @268800
     /* 268800 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(268868), // Rule ID 68 //
     /* 268805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 268810 */     // MIs[0] Operand 1
     /* 268810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 268818 */     // MIs[0] ptr
     /* 268818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268826 */     // MIs[0] accessinfo
     /* 268826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268829 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 268829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268833 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 268843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 268846 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 268848 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 268850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268866 */     GIR_RootConstrainSelectedInstOperands,
     /* 268867 */     // GIR_Coverage, 68,
     /* 268867 */     GIR_EraseRootFromParent_Done,
     /* 268868 */   // Label 5227: @268868
     /* 268868 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(268936), // Rule ID 69 //
     /* 268873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 268878 */     // MIs[0] Operand 1
     /* 268878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 268886 */     // MIs[0] ptr
     /* 268886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268894 */     // MIs[0] accessinfo
     /* 268894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268897 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 268897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268901 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 268911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 268914 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 268916 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 268918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268934 */     GIR_RootConstrainSelectedInstOperands,
     /* 268935 */     // GIR_Coverage, 69,
     /* 268935 */     GIR_EraseRootFromParent_Done,
     /* 268936 */   // Label 5228: @268936
     /* 268936 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269016), // Rule ID 7144 //
     /* 268941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268960 */     // MIs[0] addr
     /* 268960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 268972 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 269003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269008 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269014 */     GIR_RootConstrainSelectedInstOperands,
     /* 269015 */     // GIR_Coverage, 7144,
     /* 269015 */     GIR_EraseRootFromParent_Done,
     /* 269016 */   // Label 5229: @269016
     /* 269016 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269096), // Rule ID 7145 //
     /* 269021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269040 */     // MIs[0] addr
     /* 269040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 269052 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 269083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269088 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269094 */     GIR_RootConstrainSelectedInstOperands,
     /* 269095 */     // GIR_Coverage, 7145,
     /* 269095 */     GIR_EraseRootFromParent_Done,
     /* 269096 */   // Label 5230: @269096
     /* 269096 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269176), // Rule ID 7146 //
     /* 269101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269120 */     // MIs[0] addr
     /* 269120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 269132 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269144 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 269163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269168 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269174 */     GIR_RootConstrainSelectedInstOperands,
     /* 269175 */     // GIR_Coverage, 7146,
     /* 269175 */     GIR_EraseRootFromParent_Done,
     /* 269176 */   // Label 5231: @269176
     /* 269176 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269227), // Rule ID 7147 //
     /* 269181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269200 */     // MIs[0] addr
     /* 269200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 269212 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 269215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269217 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 269219 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269225 */     GIR_RootConstrainSelectedInstOperands,
     /* 269226 */     // GIR_Coverage, 7147,
     /* 269226 */     GIR_EraseRootFromParent_Done,
     /* 269227 */   // Label 5232: @269227
     /* 269227 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269307), // Rule ID 7154 //
     /* 269232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269251 */     // MIs[0] addr
     /* 269251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 269263 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 269294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269299 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269305 */     GIR_RootConstrainSelectedInstOperands,
     /* 269306 */     // GIR_Coverage, 7154,
     /* 269306 */     GIR_EraseRootFromParent_Done,
     /* 269307 */   // Label 5233: @269307
     /* 269307 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269387), // Rule ID 7155 //
     /* 269312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269331 */     // MIs[0] addr
     /* 269331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 269343 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269355 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 269374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269379 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269385 */     GIR_RootConstrainSelectedInstOperands,
     /* 269386 */     // GIR_Coverage, 7155,
     /* 269386 */     GIR_EraseRootFromParent_Done,
     /* 269387 */   // Label 5234: @269387
     /* 269387 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(269467), // Rule ID 7156 //
     /* 269392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269411 */     // MIs[0] addr
     /* 269411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 269423 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 269423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 269441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 269454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269459 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269465 */     GIR_RootConstrainSelectedInstOperands,
     /* 269466 */     // GIR_Coverage, 7156,
     /* 269466 */     GIR_EraseRootFromParent_Done,
     /* 269467 */   // Label 5235: @269467
     /* 269467 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(269518), // Rule ID 7157 //
     /* 269472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269491 */     // MIs[0] addr
     /* 269491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 269503 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 269506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269508 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 269510 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269516 */     GIR_RootConstrainSelectedInstOperands,
     /* 269517 */     // GIR_Coverage, 7157,
     /* 269517 */     GIR_EraseRootFromParent_Done,
     /* 269518 */   // Label 5236: @269518
     /* 269518 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(269567), // Rule ID 2481 //
     /* 269523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 269534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269552 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 269552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 269555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269565 */     GIR_RootConstrainSelectedInstOperands,
     /* 269566 */     // GIR_Coverage, 2481,
     /* 269566 */     GIR_EraseRootFromParent_Done,
     /* 269567 */   // Label 5237: @269567
     /* 269567 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(269616), // Rule ID 2482 //
     /* 269572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 269583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 269589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269601 */     // (intrinsic_w_chain:{ *:[v16i8] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 269601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 269604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269614 */     GIR_RootConstrainSelectedInstOperands,
     /* 269615 */     // GIR_Coverage, 2482,
     /* 269615 */     GIR_EraseRootFromParent_Done,
     /* 269616 */   // Label 5238: @269616
     /* 269616 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(269665), // Rule ID 2483 //
     /* 269621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 269629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 269632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269650 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 269650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 269653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269663 */     GIR_RootConstrainSelectedInstOperands,
     /* 269664 */     // GIR_Coverage, 2483,
     /* 269664 */     GIR_EraseRootFromParent_Done,
     /* 269665 */   // Label 5239: @269665
     /* 269665 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(269718), // Rule ID 8783 //
     /* 269670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 269678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 269681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269692 */     // MIs[0] base
     /* 269692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269700 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 269703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269707 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269716 */     GIR_RootConstrainSelectedInstOperands,
     /* 269717 */     // GIR_Coverage, 8783,
     /* 269717 */     GIR_EraseRootFromParent_Done,
     /* 269718 */   // Label 5240: @269718
     /* 269718 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(269771), // Rule ID 8786 //
     /* 269723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 269731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 269734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269745 */     // MIs[0] base
     /* 269745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269753 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 269756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269760 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269769 */     GIR_RootConstrainSelectedInstOperands,
     /* 269770 */     // GIR_Coverage, 8786,
     /* 269770 */     GIR_EraseRootFromParent_Done,
     /* 269771 */   // Label 5241: @269771
     /* 269771 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(269824), // Rule ID 8795 //
     /* 269776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 269784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 269787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269798 */     // MIs[0] base
     /* 269798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269806 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 269809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269813 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269822 */     GIR_RootConstrainSelectedInstOperands,
     /* 269823 */     // GIR_Coverage, 8795,
     /* 269823 */     GIR_EraseRootFromParent_Done,
     /* 269824 */   // Label 5242: @269824
     /* 269824 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(269877), // Rule ID 8798 //
     /* 269829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 269837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 269840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269851 */     // MIs[0] base
     /* 269851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269859 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 269862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 269864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269866 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269875 */     GIR_RootConstrainSelectedInstOperands,
     /* 269876 */     // GIR_Coverage, 8798,
     /* 269876 */     GIR_EraseRootFromParent_Done,
     /* 269877 */   // Label 5243: @269877
     /* 269877 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(269923), // Rule ID 137 //
     /* 269882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 269885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 269890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269900 */     // MIs[0] Rn
     /* 269900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269912 */     // (intrinsic_w_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 269915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269921 */     GIR_RootConstrainSelectedInstOperands,
     /* 269922 */     // GIR_Coverage, 137,
     /* 269922 */     GIR_EraseRootFromParent_Done,
     /* 269923 */   // Label 5244: @269923
     /* 269923 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(269976), // Rule ID 8789 //
     /* 269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 269936 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269950 */     // MIs[0] base
     /* 269950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269958 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 269961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 269963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269965 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 269967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269974 */     GIR_RootConstrainSelectedInstOperands,
     /* 269975 */     // GIR_Coverage, 8789,
     /* 269975 */     GIR_EraseRootFromParent_Done,
     /* 269976 */   // Label 5245: @269976
     /* 269976 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270029), // Rule ID 8792 //
     /* 269981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 269989 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270003 */     // MIs[0] base
     /* 270003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270011 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 270014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 270016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 270018 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 270020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270027 */     GIR_RootConstrainSelectedInstOperands,
     /* 270028 */     // GIR_Coverage, 8792,
     /* 270028 */     GIR_EraseRootFromParent_Done,
     /* 270029 */   // Label 5246: @270029
     /* 270029 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270082), // Rule ID 8801 //
     /* 270034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 270042 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 270045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 270048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270056 */     // MIs[0] base
     /* 270056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270064 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 270067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 270069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 270071 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 270073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270080 */     GIR_RootConstrainSelectedInstOperands,
     /* 270081 */     // GIR_Coverage, 8801,
     /* 270081 */     GIR_EraseRootFromParent_Done,
     /* 270082 */   // Label 5247: @270082
     /* 270082 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270135), // Rule ID 8804 //
     /* 270087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 270095 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 270098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 270101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270109 */     // MIs[0] base
     /* 270109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270117 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 270120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 270122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 270124 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 270126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270133 */     GIR_RootConstrainSelectedInstOperands,
     /* 270134 */     // GIR_Coverage, 8804,
     /* 270134 */     GIR_EraseRootFromParent_Done,
     /* 270135 */   // Label 5248: @270135
     /* 270135 */   GIM_Reject,
     /* 270136 */ // Label 5177: @270136
     /* 270136 */ GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(272841),
     /* 270141 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 270144 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270215), // Rule ID 3406 //
     /* 270149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 270157 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 270163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270186 */     // MIs[1] Operand 1
     /* 270186 */     // No operand predicates
     /* 270186 */     // MIs[0] prfop
     /* 270186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270196 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 270196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 270199 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270213 */     GIR_RootConstrainSelectedInstOperands,
     /* 270214 */     // GIR_Coverage, 3406,
     /* 270214 */     GIR_EraseRootFromParent_Done,
     /* 270215 */   // Label 5250: @270215
     /* 270215 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(270286), // Rule ID 3419 //
     /* 270220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 270228 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 270234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270257 */     // MIs[1] Operand 1
     /* 270257 */     // No operand predicates
     /* 270257 */     // MIs[0] prfop
     /* 270257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270267 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 270267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 270270 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 270276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270284 */     GIR_RootConstrainSelectedInstOperands,
     /* 270285 */     // GIR_Coverage, 3419,
     /* 270285 */     GIR_EraseRootFromParent_Done,
     /* 270286 */   // Label 5251: @270286
     /* 270286 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(270345), // Rule ID 3606 //
     /* 270291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 270294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 270299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 270302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 270305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 270308 */     // MIs[0] tile
     /* 270308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270328 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 270328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 270331 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270333 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270335 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270337 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270343 */     GIR_RootConstrainSelectedInstOperands,
     /* 270344 */     // GIR_Coverage, 3606,
     /* 270344 */     GIR_EraseRootFromParent_Done,
     /* 270345 */   // Label 5252: @270345
     /* 270345 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(270404), // Rule ID 3607 //
     /* 270350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 270353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 270358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 270361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 270364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 270367 */     // MIs[0] tile
     /* 270367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270387 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 270387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270392 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270394 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270396 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270402 */     GIR_RootConstrainSelectedInstOperands,
     /* 270403 */     // GIR_Coverage, 3607,
     /* 270403 */     GIR_EraseRootFromParent_Done,
     /* 270404 */   // Label 5253: @270404
     /* 270404 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(270463), // Rule ID 12636 //
     /* 270409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 270412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 270417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 270420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 270423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 270426 */     // MIs[0] tile
     /* 270426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 270434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270446 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 270446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 270449 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270451 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270453 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270455 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270461 */     GIR_RootConstrainSelectedInstOperands,
     /* 270462 */     // GIR_Coverage, 12636,
     /* 270462 */     GIR_EraseRootFromParent_Done,
     /* 270463 */   // Label 5254: @270463
     /* 270463 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(270522), // Rule ID 12637 //
     /* 270468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 270471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 270476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 270479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 270482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 270485 */     // MIs[0] tile
     /* 270485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 270488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 270493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270505 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 270505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 270508 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 270510 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 270512 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 270514 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 270516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270520 */     GIR_RootConstrainSelectedInstOperands,
     /* 270521 */     // GIR_Coverage, 12637,
     /* 270521 */     GIR_EraseRootFromParent_Done,
     /* 270522 */   // Label 5255: @270522
     /* 270522 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(270582), // Rule ID 3404 //
     /* 270527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 270535 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270545 */     // MIs[0] Rn
     /* 270545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270557 */     // MIs[0] prfop
     /* 270557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270565 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 270565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 270568 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270580 */     GIR_RootConstrainSelectedInstOperands,
     /* 270581 */     // GIR_Coverage, 3404,
     /* 270581 */     GIR_EraseRootFromParent_Done,
     /* 270582 */   // Label 5256: @270582
     /* 270582 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(270642), // Rule ID 3405 //
     /* 270587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 270595 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270605 */     // MIs[0] Rn
     /* 270605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270617 */     // MIs[0] prfop
     /* 270617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270625 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 270625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 270628 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270640 */     GIR_RootConstrainSelectedInstOperands,
     /* 270641 */     // GIR_Coverage, 3405,
     /* 270641 */     GIR_EraseRootFromParent_Done,
     /* 270642 */   // Label 5257: @270642
     /* 270642 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(270702), // Rule ID 3416 //
     /* 270647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 270655 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270665 */     // MIs[0] Rn
     /* 270665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270677 */     // MIs[0] prfop
     /* 270677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270685 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 270685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 270688 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270700 */     GIR_RootConstrainSelectedInstOperands,
     /* 270701 */     // GIR_Coverage, 3416,
     /* 270701 */     GIR_EraseRootFromParent_Done,
     /* 270702 */   // Label 5258: @270702
     /* 270702 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(270762), // Rule ID 3417 //
     /* 270707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 270715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270725 */     // MIs[0] Rn
     /* 270725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270737 */     // MIs[0] prfop
     /* 270737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270745 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 270745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 270748 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270760 */     GIR_RootConstrainSelectedInstOperands,
     /* 270761 */     // GIR_Coverage, 3417,
     /* 270761 */     GIR_EraseRootFromParent_Done,
     /* 270762 */   // Label 5259: @270762
     /* 270762 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(270822), // Rule ID 3418 //
     /* 270767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 270775 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 270781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270785 */     // MIs[0] Rn
     /* 270785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270797 */     // MIs[0] prfop
     /* 270797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270805 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 270805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 270808 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270820 */     GIR_RootConstrainSelectedInstOperands,
     /* 270821 */     // GIR_Coverage, 3418,
     /* 270821 */     GIR_EraseRootFromParent_Done,
     /* 270822 */   // Label 5260: @270822
     /* 270822 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(270882), // Rule ID 8909 //
     /* 270827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 270835 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270845 */     // MIs[0] Rn
     /* 270845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270857 */     // MIs[0] prfop
     /* 270857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270865 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 270865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 270868 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270880 */     GIR_RootConstrainSelectedInstOperands,
     /* 270881 */     // GIR_Coverage, 8909,
     /* 270881 */     GIR_EraseRootFromParent_Done,
     /* 270882 */   // Label 5261: @270882
     /* 270882 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(270942), // Rule ID 8910 //
     /* 270887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 270895 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270905 */     // MIs[0] Rn
     /* 270905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270917 */     // MIs[0] prfop
     /* 270917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270925 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 270925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 270928 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270940 */     GIR_RootConstrainSelectedInstOperands,
     /* 270941 */     // GIR_Coverage, 8910,
     /* 270941 */     GIR_EraseRootFromParent_Done,
     /* 270942 */   // Label 5262: @270942
     /* 270942 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271002), // Rule ID 8911 //
     /* 270947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 270950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 270955 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 270961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270965 */     // MIs[0] Rn
     /* 270965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270977 */     // MIs[0] prfop
     /* 270977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 270980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270985 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 270985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 270988 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 270990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 270992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 270996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271000 */     GIR_RootConstrainSelectedInstOperands,
     /* 271001 */     // GIR_Coverage, 8911,
     /* 271001 */     GIR_EraseRootFromParent_Done,
     /* 271002 */   // Label 5263: @271002
     /* 271002 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271062), // Rule ID 8912 //
     /* 271007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 271015 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271025 */     // MIs[0] Rn
     /* 271025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271037 */     // MIs[0] prfop
     /* 271037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271045 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 271045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 271048 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271060 */     GIR_RootConstrainSelectedInstOperands,
     /* 271061 */     // GIR_Coverage, 8912,
     /* 271061 */     GIR_EraseRootFromParent_Done,
     /* 271062 */   // Label 5264: @271062
     /* 271062 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271122), // Rule ID 8913 //
     /* 271067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 271075 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271085 */     // MIs[0] Rn
     /* 271085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271097 */     // MIs[0] prfop
     /* 271097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271105 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 271105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 271108 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271120 */     GIR_RootConstrainSelectedInstOperands,
     /* 271121 */     // GIR_Coverage, 8913,
     /* 271121 */     GIR_EraseRootFromParent_Done,
     /* 271122 */   // Label 5265: @271122
     /* 271122 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271182), // Rule ID 8914 //
     /* 271127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 271135 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271145 */     // MIs[0] Rn
     /* 271145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271157 */     // MIs[0] prfop
     /* 271157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271165 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 271165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 271168 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271180 */     GIR_RootConstrainSelectedInstOperands,
     /* 271181 */     // GIR_Coverage, 8914,
     /* 271181 */     GIR_EraseRootFromParent_Done,
     /* 271182 */   // Label 5266: @271182
     /* 271182 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271242), // Rule ID 8915 //
     /* 271187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 271195 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271205 */     // MIs[0] Rn
     /* 271205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271217 */     // MIs[0] prfop
     /* 271217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271225 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 271225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 271228 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271240 */     GIR_RootConstrainSelectedInstOperands,
     /* 271241 */     // GIR_Coverage, 8915,
     /* 271241 */     GIR_EraseRootFromParent_Done,
     /* 271242 */   // Label 5267: @271242
     /* 271242 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271302), // Rule ID 8916 //
     /* 271247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 271255 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271265 */     // MIs[0] Rn
     /* 271265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271277 */     // MIs[0] prfop
     /* 271277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271285 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 271285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 271288 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271300 */     GIR_RootConstrainSelectedInstOperands,
     /* 271301 */     // GIR_Coverage, 8916,
     /* 271301 */     GIR_EraseRootFromParent_Done,
     /* 271302 */   // Label 5268: @271302
     /* 271302 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(271362), // Rule ID 8917 //
     /* 271307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 271315 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271325 */     // MIs[0] Rn
     /* 271325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271337 */     // MIs[0] prfop
     /* 271337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271345 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 271345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 271348 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271360 */     GIR_RootConstrainSelectedInstOperands,
     /* 271361 */     // GIR_Coverage, 8917,
     /* 271361 */     GIR_EraseRootFromParent_Done,
     /* 271362 */   // Label 5269: @271362
     /* 271362 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(271422), // Rule ID 8918 //
     /* 271367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 271375 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271385 */     // MIs[0] Rn
     /* 271385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271397 */     // MIs[0] prfop
     /* 271397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271405 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 271405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 271408 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271420 */     GIR_RootConstrainSelectedInstOperands,
     /* 271421 */     // GIR_Coverage, 8918,
     /* 271421 */     GIR_EraseRootFromParent_Done,
     /* 271422 */   // Label 5270: @271422
     /* 271422 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(271482), // Rule ID 8919 //
     /* 271427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 271435 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271445 */     // MIs[0] Rn
     /* 271445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271457 */     // MIs[0] prfop
     /* 271457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271465 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 271465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 271468 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271480 */     GIR_RootConstrainSelectedInstOperands,
     /* 271481 */     // GIR_Coverage, 8919,
     /* 271481 */     GIR_EraseRootFromParent_Done,
     /* 271482 */   // Label 5271: @271482
     /* 271482 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(271542), // Rule ID 8920 //
     /* 271487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 271495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271505 */     // MIs[0] Rn
     /* 271505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271517 */     // MIs[0] prfop
     /* 271517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271525 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 271525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 271528 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271540 */     GIR_RootConstrainSelectedInstOperands,
     /* 271541 */     // GIR_Coverage, 8920,
     /* 271541 */     GIR_EraseRootFromParent_Done,
     /* 271542 */   // Label 5272: @271542
     /* 271542 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(271602), // Rule ID 8921 //
     /* 271547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 271555 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271565 */     // MIs[0] Rn
     /* 271565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271577 */     // MIs[0] prfop
     /* 271577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271585 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 271585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 271588 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271600 */     GIR_RootConstrainSelectedInstOperands,
     /* 271601 */     // GIR_Coverage, 8921,
     /* 271601 */     GIR_EraseRootFromParent_Done,
     /* 271602 */   // Label 5273: @271602
     /* 271602 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(271662), // Rule ID 8922 //
     /* 271607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 271615 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271625 */     // MIs[0] Rn
     /* 271625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271637 */     // MIs[0] prfop
     /* 271637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271645 */     // (intrinsic_void 1654:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 271645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 271648 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271660 */     GIR_RootConstrainSelectedInstOperands,
     /* 271661 */     // GIR_Coverage, 8922,
     /* 271661 */     GIR_EraseRootFromParent_Done,
     /* 271662 */   // Label 5274: @271662
     /* 271662 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(271722), // Rule ID 8923 //
     /* 271667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 271675 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271685 */     // MIs[0] Rn
     /* 271685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271697 */     // MIs[0] prfop
     /* 271697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271705 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 271705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 271708 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271720 */     GIR_RootConstrainSelectedInstOperands,
     /* 271721 */     // GIR_Coverage, 8923,
     /* 271721 */     GIR_EraseRootFromParent_Done,
     /* 271722 */   // Label 5275: @271722
     /* 271722 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(271780), // Rule ID 2374 //
     /* 271727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 271735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 271738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271763 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 271766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271778 */     GIR_RootConstrainSelectedInstOperands,
     /* 271779 */     // GIR_Coverage, 2374,
     /* 271779 */     GIR_EraseRootFromParent_Done,
     /* 271780 */   // Label 5276: @271780
     /* 271780 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(271838), // Rule ID 2375 //
     /* 271785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 271793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 271796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271821 */     // (intrinsic_w_chain:{ *:[v8f16] } 636:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 271824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271836 */     GIR_RootConstrainSelectedInstOperands,
     /* 271837 */     // GIR_Coverage, 2375,
     /* 271837 */     GIR_EraseRootFromParent_Done,
     /* 271838 */   // Label 5277: @271838
     /* 271838 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(271896), // Rule ID 2376 //
     /* 271843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 271851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271879 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 271882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271894 */     GIR_RootConstrainSelectedInstOperands,
     /* 271895 */     // GIR_Coverage, 2376,
     /* 271895 */     GIR_EraseRootFromParent_Done,
     /* 271896 */   // Label 5278: @271896
     /* 271896 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(271954), // Rule ID 2377 //
     /* 271901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 271909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271937 */     // (intrinsic_w_chain:{ *:[v4f32] } 630:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 271940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 271942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 271944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 271948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271952 */     GIR_RootConstrainSelectedInstOperands,
     /* 271953 */     // GIR_Coverage, 2377,
     /* 271953 */     GIR_EraseRootFromParent_Done,
     /* 271954 */   // Label 5279: @271954
     /* 271954 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272012), // Rule ID 2378 //
     /* 271959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 271962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 271967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 271976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 271979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271995 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 271995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 271998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272010 */     GIR_RootConstrainSelectedInstOperands,
     /* 272011 */     // GIR_Coverage, 2378,
     /* 272011 */     GIR_EraseRootFromParent_Done,
     /* 272012 */   // Label 5280: @272012
     /* 272012 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272070), // Rule ID 2379 //
     /* 272017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 272020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 272025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272053 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 272053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 272056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272068 */     GIR_RootConstrainSelectedInstOperands,
     /* 272069 */     // GIR_Coverage, 2379,
     /* 272069 */     GIR_EraseRootFromParent_Done,
     /* 272070 */   // Label 5281: @272070
     /* 272070 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272128), // Rule ID 2380 //
     /* 272075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 272078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 272083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 272086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 272092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 272095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272111 */     // (intrinsic_w_chain:{ *:[v4f16] } 622:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 272111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 272114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272126 */     GIR_RootConstrainSelectedInstOperands,
     /* 272127 */     // GIR_Coverage, 2380,
     /* 272127 */     GIR_EraseRootFromParent_Done,
     /* 272128 */   // Label 5282: @272128
     /* 272128 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272186), // Rule ID 2381 //
     /* 272133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 272136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 272141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 272144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272169 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 272169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 272172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272184 */     GIR_RootConstrainSelectedInstOperands,
     /* 272185 */     // GIR_Coverage, 2381,
     /* 272185 */     GIR_EraseRootFromParent_Done,
     /* 272186 */   // Label 5283: @272186
     /* 272186 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272244), // Rule ID 2382 //
     /* 272191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 272199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 272202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 272208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 272211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272227 */     // (intrinsic_w_chain:{ *:[v2f32] } 624:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 272227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 272230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272242 */     GIR_RootConstrainSelectedInstOperands,
     /* 272243 */     // GIR_Coverage, 2382,
     /* 272243 */     GIR_EraseRootFromParent_Done,
     /* 272244 */   // Label 5284: @272244
     /* 272244 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272302), // Rule ID 2383 //
     /* 272249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 272257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272285 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 272285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 272288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272300 */     GIR_RootConstrainSelectedInstOperands,
     /* 272301 */     // GIR_Coverage, 2383,
     /* 272301 */     GIR_EraseRootFromParent_Done,
     /* 272302 */   // Label 5285: @272302
     /* 272302 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272360), // Rule ID 2484 //
     /* 272307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 272310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 272315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 272318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272343 */     // (intrinsic_w_chain:{ *:[v16i8] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 272343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 272346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272348 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 272350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272358 */     GIR_RootConstrainSelectedInstOperands,
     /* 272359 */     // GIR_Coverage, 2484,
     /* 272359 */     GIR_EraseRootFromParent_Done,
     /* 272360 */   // Label 5286: @272360
     /* 272360 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(272416), // Rule ID 13195 //
     /* 272365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 272370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272391 */     // MIs[0] addr
     /* 272391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 272395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272399 */     // (intrinsic_w_chain:{ *:[i32] } 1245:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 272399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 272402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272404 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 272406 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 272408 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 272410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272414 */     GIR_RootConstrainSelectedInstOperands,
     /* 272415 */     // GIR_Coverage, 13195,
     /* 272415 */     GIR_EraseRootFromParent_Done,
     /* 272416 */   // Label 5287: @272416
     /* 272416 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(272472), // Rule ID 13196 //
     /* 272421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 272426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272447 */     // MIs[0] addr
     /* 272447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 272451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272455 */     // (intrinsic_w_chain:{ *:[i32] } 1247:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 272455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 272458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272460 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 272462 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 272464 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 272466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272470 */     GIR_RootConstrainSelectedInstOperands,
     /* 272471 */     // GIR_Coverage, 13196,
     /* 272471 */     GIR_EraseRootFromParent_Done,
     /* 272472 */   // Label 5288: @272472
     /* 272472 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(272518), // Rule ID 3452 //
     /* 272477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 272480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 272485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272501 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1510:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 272504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272516 */     GIR_RootConstrainSelectedInstOperands,
     /* 272517 */     // GIR_Coverage, 3452,
     /* 272517 */     GIR_EraseRootFromParent_Done,
     /* 272518 */   // Label 5289: @272518
     /* 272518 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(272564), // Rule ID 3574 //
     /* 272523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 272531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272547 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1512:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 272550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272562 */     GIR_RootConstrainSelectedInstOperands,
     /* 272563 */     // GIR_Coverage, 3574,
     /* 272563 */     GIR_EraseRootFromParent_Done,
     /* 272564 */   // Label 5290: @272564
     /* 272564 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(272610), // Rule ID 12623 //
     /* 272569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 272577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 272580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272593 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1522:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 272596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272608 */     GIR_RootConstrainSelectedInstOperands,
     /* 272609 */     // GIR_Coverage, 12623,
     /* 272609 */     GIR_EraseRootFromParent_Done,
     /* 272610 */   // Label 5291: @272610
     /* 272610 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(272656), // Rule ID 12627 //
     /* 272615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 272623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272639 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 272642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272654 */     GIR_RootConstrainSelectedInstOperands,
     /* 272655 */     // GIR_Coverage, 12627,
     /* 272655 */     GIR_EraseRootFromParent_Done,
     /* 272656 */   // Label 5292: @272656
     /* 272656 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(272702), // Rule ID 12628 //
     /* 272661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 272669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272685 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1516:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 272688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272700 */     GIR_RootConstrainSelectedInstOperands,
     /* 272701 */     // GIR_Coverage, 12628,
     /* 272701 */     GIR_EraseRootFromParent_Done,
     /* 272702 */   // Label 5293: @272702
     /* 272702 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(272748), // Rule ID 12629 //
     /* 272707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 272715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272731 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 272734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272746 */     GIR_RootConstrainSelectedInstOperands,
     /* 272747 */     // GIR_Coverage, 12629,
     /* 272747 */     GIR_EraseRootFromParent_Done,
     /* 272748 */   // Label 5294: @272748
     /* 272748 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(272794), // Rule ID 12630 //
     /* 272753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 272756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 272761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272777 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 272780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272792 */     GIR_RootConstrainSelectedInstOperands,
     /* 272793 */     // GIR_Coverage, 12630,
     /* 272793 */     GIR_EraseRootFromParent_Done,
     /* 272794 */   // Label 5295: @272794
     /* 272794 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(272840), // Rule ID 12631 //
     /* 272799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 272802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 272807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 272810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 272816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 272819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272823 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 272823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 272826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 272828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 272830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 272832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 272834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272838 */     GIR_RootConstrainSelectedInstOperands,
     /* 272839 */     // GIR_Coverage, 12631,
     /* 272839 */     GIR_EraseRootFromParent_Done,
     /* 272840 */   // Label 5296: @272840
     /* 272840 */   GIM_Reject,
     /* 272841 */ // Label 5249: @272841
     /* 272841 */ GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(275834),
     /* 272846 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 272849 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(272917), // Rule ID 2511 //
     /* 272854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 272857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 272862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 272865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 272890 */     // MIs[0] Idx
     /* 272890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 272898 */     // (intrinsic_w_chain:{ *:[v8f16] } 627:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 272901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272909 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272915 */     GIR_RootConstrainSelectedInstOperands,
     /* 272916 */     // GIR_Coverage, 2511,
     /* 272916 */     GIR_EraseRootFromParent_Done,
     /* 272917 */   // Label 5298: @272917
     /* 272917 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(272985), // Rule ID 2512 //
     /* 272922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 272925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 272930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 272939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 272942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 272958 */     // MIs[0] Idx
     /* 272958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 272966 */     // (intrinsic_w_chain:{ *:[v4f32] } 629:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 272966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 272969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 272971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 272973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 272977 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 272979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272983 */     GIR_RootConstrainSelectedInstOperands,
     /* 272984 */     // GIR_Coverage, 2512,
     /* 272984 */     GIR_EraseRootFromParent_Done,
     /* 272985 */   // Label 5299: @272985
     /* 272985 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273053), // Rule ID 2513 //
     /* 272990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 272993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 272998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273026 */     // MIs[0] Idx
     /* 273026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 273034 */     // (intrinsic_w_chain:{ *:[v2f32] } 625:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 273037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273045 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273051 */     GIR_RootConstrainSelectedInstOperands,
     /* 273052 */     // GIR_Coverage, 2513,
     /* 273052 */     GIR_EraseRootFromParent_Done,
     /* 273053 */   // Label 5300: @273053
     /* 273053 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273121), // Rule ID 2514 //
     /* 273058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 273066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273094 */     // MIs[0] Idx
     /* 273094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 273102 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 273105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273113 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273119 */     GIR_RootConstrainSelectedInstOperands,
     /* 273120 */     // GIR_Coverage, 2514,
     /* 273120 */     GIR_EraseRootFromParent_Done,
     /* 273121 */   // Label 5301: @273121
     /* 273121 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273189), // Rule ID 2515 //
     /* 273126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 273134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 273162 */     // MIs[0] Idx
     /* 273162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 273170 */     // (intrinsic_w_chain:{ *:[v4f16] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 273173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273181 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273187 */     GIR_RootConstrainSelectedInstOperands,
     /* 273188 */     // GIR_Coverage, 2515,
     /* 273188 */     GIR_EraseRootFromParent_Done,
     /* 273189 */   // Label 5302: @273189
     /* 273189 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273257), // Rule ID 2516 //
     /* 273194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 273202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 273230 */     // MIs[0] Idx
     /* 273230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 273238 */     // (intrinsic_w_chain:{ *:[v8f16] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 273241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273249 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273255 */     GIR_RootConstrainSelectedInstOperands,
     /* 273256 */     // GIR_Coverage, 2516,
     /* 273256 */     GIR_EraseRootFromParent_Done,
     /* 273257 */   // Label 5303: @273257
     /* 273257 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(273325), // Rule ID 7019 //
     /* 273262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 273270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273298 */     // MIs[0] Idx
     /* 273298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273306 */     // (intrinsic_w_chain:{ *:[v8f16] } 637:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 273309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273317 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273323 */     GIR_RootConstrainSelectedInstOperands,
     /* 273324 */     // GIR_Coverage, 7019,
     /* 273324 */     GIR_EraseRootFromParent_Done,
     /* 273325 */   // Label 5304: @273325
     /* 273325 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(273393), // Rule ID 7020 //
     /* 273330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 273338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273366 */     // MIs[0] Idx
     /* 273366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273374 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 273377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273391 */     GIR_RootConstrainSelectedInstOperands,
     /* 273392 */     // GIR_Coverage, 7020,
     /* 273392 */     GIR_EraseRootFromParent_Done,
     /* 273393 */   // Label 5305: @273393
     /* 273393 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(273461), // Rule ID 7021 //
     /* 273398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 273406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273434 */     // MIs[0] Idx
     /* 273434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273442 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 273445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273459 */     GIR_RootConstrainSelectedInstOperands,
     /* 273460 */     // GIR_Coverage, 7021,
     /* 273460 */     GIR_EraseRootFromParent_Done,
     /* 273461 */   // Label 5306: @273461
     /* 273461 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(273529), // Rule ID 7022 //
     /* 273466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 273474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 273502 */     // MIs[0] Idx
     /* 273502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 273510 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 273510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 273513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 273523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273527 */     GIR_RootConstrainSelectedInstOperands,
     /* 273528 */     // GIR_Coverage, 7022,
     /* 273528 */     GIR_EraseRootFromParent_Done,
     /* 273529 */   // Label 5307: @273529
     /* 273529 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(273589), // Rule ID 3586 //
     /* 273534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 273545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 273548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 273551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 273554 */     // MIs[0] tile
     /* 273554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273570 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 273570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 273573 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273581 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273587 */     GIR_RootConstrainSelectedInstOperands,
     /* 273588 */     // GIR_Coverage, 3586,
     /* 273588 */     GIR_EraseRootFromParent_Done,
     /* 273589 */   // Label 5308: @273589
     /* 273589 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(273649), // Rule ID 3587 //
     /* 273594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 273597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 273602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273614 */     // MIs[0] tile
     /* 273614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273630 */     // (intrinsic_void 887:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 273633 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273647 */     GIR_RootConstrainSelectedInstOperands,
     /* 273648 */     // GIR_Coverage, 3587,
     /* 273648 */     GIR_EraseRootFromParent_Done,
     /* 273649 */   // Label 5309: @273649
     /* 273649 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(273709), // Rule ID 3588 //
     /* 273654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 273657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 273665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 273668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 273671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 273674 */     // MIs[0] tile
     /* 273674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 273682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273690 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 273690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 273693 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273707 */     GIR_RootConstrainSelectedInstOperands,
     /* 273708 */     // GIR_Coverage, 3588,
     /* 273708 */     GIR_EraseRootFromParent_Done,
     /* 273709 */   // Label 5310: @273709
     /* 273709 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(273769), // Rule ID 3589 //
     /* 273714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 273717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 273722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273734 */     // MIs[0] tile
     /* 273734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 273742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273750 */     // (intrinsic_void 886:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 273753 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273767 */     GIR_RootConstrainSelectedInstOperands,
     /* 273768 */     // GIR_Coverage, 3589,
     /* 273768 */     GIR_EraseRootFromParent_Done,
     /* 273769 */   // Label 5311: @273769
     /* 273769 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(273829), // Rule ID 3590 //
     /* 273774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 273777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 273782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273794 */     // MIs[0] tile
     /* 273794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 273802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273810 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 273810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 273813 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273827 */     GIR_RootConstrainSelectedInstOperands,
     /* 273828 */     // GIR_Coverage, 3590,
     /* 273828 */     GIR_EraseRootFromParent_Done,
     /* 273829 */   // Label 5312: @273829
     /* 273829 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(273889), // Rule ID 3591 //
     /* 273834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 273842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 273845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 273848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 273854 */     // MIs[0] tile
     /* 273854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273870 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 273870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 273873 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273887 */     GIR_RootConstrainSelectedInstOperands,
     /* 273888 */     // GIR_Coverage, 3591,
     /* 273888 */     GIR_EraseRootFromParent_Done,
     /* 273889 */   // Label 5313: @273889
     /* 273889 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(273949), // Rule ID 3592 //
     /* 273894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 273897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 273902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273914 */     // MIs[0] tile
     /* 273914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 273922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273930 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 273930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 273933 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 273941 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 273943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273947 */     GIR_RootConstrainSelectedInstOperands,
     /* 273948 */     // GIR_Coverage, 3592,
     /* 273948 */     GIR_EraseRootFromParent_Done,
     /* 273949 */   // Label 5314: @273949
     /* 273949 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274009), // Rule ID 3593 //
     /* 273954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 273957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 273962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 273965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 273968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 273971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 273974 */     // MIs[0] tile
     /* 273974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 273982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273990 */     // (intrinsic_void 937:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 273990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 273993 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 273995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 273997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 273999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274001 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274007 */     GIR_RootConstrainSelectedInstOperands,
     /* 274008 */     // GIR_Coverage, 3593,
     /* 274008 */     GIR_EraseRootFromParent_Done,
     /* 274009 */   // Label 5315: @274009
     /* 274009 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274069), // Rule ID 3687 //
     /* 274014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 274017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 274022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274034 */     // MIs[0] tile
     /* 274034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274050 */     // (intrinsic_void 1039:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 274053 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274061 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274067 */     GIR_RootConstrainSelectedInstOperands,
     /* 274068 */     // GIR_Coverage, 3687,
     /* 274068 */     GIR_EraseRootFromParent_Done,
     /* 274069 */   // Label 5316: @274069
     /* 274069 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274129), // Rule ID 3688 //
     /* 274074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 274077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 274082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274094 */     // MIs[0] tile
     /* 274094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274110 */     // (intrinsic_void 806:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 274110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 274113 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274121 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274127 */     GIR_RootConstrainSelectedInstOperands,
     /* 274128 */     // GIR_Coverage, 3688,
     /* 274128 */     GIR_EraseRootFromParent_Done,
     /* 274129 */   // Label 5317: @274129
     /* 274129 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274189), // Rule ID 12638 //
     /* 274134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 274142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274154 */     // MIs[0] tile
     /* 274154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274170 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 274170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274181 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274187 */     GIR_RootConstrainSelectedInstOperands,
     /* 274188 */     // GIR_Coverage, 12638,
     /* 274188 */     GIR_EraseRootFromParent_Done,
     /* 274189 */   // Label 5318: @274189
     /* 274189 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274249), // Rule ID 12639 //
     /* 274194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 274197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 274202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 274205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 274208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 274211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 274214 */     // MIs[0] tile
     /* 274214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274230 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 274230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 274233 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274247 */     GIR_RootConstrainSelectedInstOperands,
     /* 274248 */     // GIR_Coverage, 12639,
     /* 274248 */     GIR_EraseRootFromParent_Done,
     /* 274249 */   // Label 5319: @274249
     /* 274249 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274309), // Rule ID 12640 //
     /* 274254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 274262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274274 */     // MIs[0] tile
     /* 274274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274290 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 274290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 274293 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274307 */     GIR_RootConstrainSelectedInstOperands,
     /* 274308 */     // GIR_Coverage, 12640,
     /* 274308 */     GIR_EraseRootFromParent_Done,
     /* 274309 */   // Label 5320: @274309
     /* 274309 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274369), // Rule ID 12641 //
     /* 274314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 274322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274334 */     // MIs[0] tile
     /* 274334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274350 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 274353 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274361 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274367 */     GIR_RootConstrainSelectedInstOperands,
     /* 274368 */     // GIR_Coverage, 12641,
     /* 274368 */     GIR_EraseRootFromParent_Done,
     /* 274369 */   // Label 5321: @274369
     /* 274369 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(274429), // Rule ID 12642 //
     /* 274374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 274382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274394 */     // MIs[0] tile
     /* 274394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274410 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 274413 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274427 */     GIR_RootConstrainSelectedInstOperands,
     /* 274428 */     // GIR_Coverage, 12642,
     /* 274428 */     GIR_EraseRootFromParent_Done,
     /* 274429 */   // Label 5322: @274429
     /* 274429 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(274489), // Rule ID 12643 //
     /* 274434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 274442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274454 */     // MIs[0] tile
     /* 274454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274470 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 274473 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274481 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274487 */     GIR_RootConstrainSelectedInstOperands,
     /* 274488 */     // GIR_Coverage, 12643,
     /* 274488 */     GIR_EraseRootFromParent_Done,
     /* 274489 */   // Label 5323: @274489
     /* 274489 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(274549), // Rule ID 12644 //
     /* 274494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 274502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274514 */     // MIs[0] tile
     /* 274514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274530 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 274533 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274547 */     GIR_RootConstrainSelectedInstOperands,
     /* 274548 */     // GIR_Coverage, 12644,
     /* 274548 */     GIR_EraseRootFromParent_Done,
     /* 274549 */   // Label 5324: @274549
     /* 274549 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(274609), // Rule ID 12645 //
     /* 274554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 274562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274574 */     // MIs[0] tile
     /* 274574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274590 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 274593 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274601 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274607 */     GIR_RootConstrainSelectedInstOperands,
     /* 274608 */     // GIR_Coverage, 12645,
     /* 274608 */     GIR_EraseRootFromParent_Done,
     /* 274609 */   // Label 5325: @274609
     /* 274609 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(274669), // Rule ID 12646 //
     /* 274614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 274622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274634 */     // MIs[0] tile
     /* 274634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274650 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 274653 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274667 */     GIR_RootConstrainSelectedInstOperands,
     /* 274668 */     // GIR_Coverage, 12646,
     /* 274668 */     GIR_EraseRootFromParent_Done,
     /* 274669 */   // Label 5326: @274669
     /* 274669 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(274729), // Rule ID 12647 //
     /* 274674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 274682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274694 */     // MIs[0] tile
     /* 274694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274710 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 274713 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274721 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274727 */     GIR_RootConstrainSelectedInstOperands,
     /* 274728 */     // GIR_Coverage, 12647,
     /* 274728 */     GIR_EraseRootFromParent_Done,
     /* 274729 */   // Label 5327: @274729
     /* 274729 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(274789), // Rule ID 12648 //
     /* 274734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 274742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274754 */     // MIs[0] tile
     /* 274754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274770 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 274773 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274781 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274787 */     GIR_RootConstrainSelectedInstOperands,
     /* 274788 */     // GIR_Coverage, 12648,
     /* 274788 */     GIR_EraseRootFromParent_Done,
     /* 274789 */   // Label 5328: @274789
     /* 274789 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(274849), // Rule ID 12649 //
     /* 274794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 274802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274814 */     // MIs[0] tile
     /* 274814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274830 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 274833 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274841 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274847 */     GIR_RootConstrainSelectedInstOperands,
     /* 274848 */     // GIR_Coverage, 12649,
     /* 274848 */     GIR_EraseRootFromParent_Done,
     /* 274849 */   // Label 5329: @274849
     /* 274849 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(274909), // Rule ID 12650 //
     /* 274854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 274862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274874 */     // MIs[0] tile
     /* 274874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274890 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 274893 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274907 */     GIR_RootConstrainSelectedInstOperands,
     /* 274908 */     // GIR_Coverage, 12650,
     /* 274908 */     GIR_EraseRootFromParent_Done,
     /* 274909 */   // Label 5330: @274909
     /* 274909 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(274969), // Rule ID 12651 //
     /* 274914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 274922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274934 */     // MIs[0] tile
     /* 274934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274950 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 274950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 274953 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274967 */     GIR_RootConstrainSelectedInstOperands,
     /* 274968 */     // GIR_Coverage, 12651,
     /* 274968 */     GIR_EraseRootFromParent_Done,
     /* 274969 */   // Label 5331: @274969
     /* 274969 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275029), // Rule ID 12652 //
     /* 274974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 274982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 274985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 274988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 274991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 274994 */     // MIs[0] tile
     /* 274994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275010 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 275013 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275021 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275027 */     GIR_RootConstrainSelectedInstOperands,
     /* 275028 */     // GIR_Coverage, 12652,
     /* 275028 */     GIR_EraseRootFromParent_Done,
     /* 275029 */   // Label 5332: @275029
     /* 275029 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275089), // Rule ID 12653 //
     /* 275034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 275042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275054 */     // MIs[0] tile
     /* 275054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275070 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 275073 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275081 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275087 */     GIR_RootConstrainSelectedInstOperands,
     /* 275088 */     // GIR_Coverage, 12653,
     /* 275088 */     GIR_EraseRootFromParent_Done,
     /* 275089 */   // Label 5333: @275089
     /* 275089 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275149), // Rule ID 12654 //
     /* 275094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 275102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275114 */     // MIs[0] tile
     /* 275114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275130 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 275133 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275141 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275147 */     GIR_RootConstrainSelectedInstOperands,
     /* 275148 */     // GIR_Coverage, 12654,
     /* 275148 */     GIR_EraseRootFromParent_Done,
     /* 275149 */   // Label 5334: @275149
     /* 275149 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275209), // Rule ID 13028 //
     /* 275154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 275162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275174 */     // MIs[0] tile
     /* 275174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275190 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 275193 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275201 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275207 */     GIR_RootConstrainSelectedInstOperands,
     /* 275208 */     // GIR_Coverage, 13028,
     /* 275208 */     GIR_EraseRootFromParent_Done,
     /* 275209 */   // Label 5335: @275209
     /* 275209 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275269), // Rule ID 13029 //
     /* 275214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 275222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275234 */     // MIs[0] tile
     /* 275234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275250 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 275253 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275267 */     GIR_RootConstrainSelectedInstOperands,
     /* 275268 */     // GIR_Coverage, 13029,
     /* 275268 */     GIR_EraseRootFromParent_Done,
     /* 275269 */   // Label 5336: @275269
     /* 275269 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275329), // Rule ID 13030 //
     /* 275274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 275282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275294 */     // MIs[0] tile
     /* 275294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275310 */     // (intrinsic_void 1174:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275313 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275321 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275327 */     GIR_RootConstrainSelectedInstOperands,
     /* 275328 */     // GIR_Coverage, 13030,
     /* 275328 */     GIR_EraseRootFromParent_Done,
     /* 275329 */   // Label 5337: @275329
     /* 275329 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275389), // Rule ID 13031 //
     /* 275334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 275342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275354 */     // MIs[0] tile
     /* 275354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275370 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 275373 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275387 */     GIR_RootConstrainSelectedInstOperands,
     /* 275388 */     // GIR_Coverage, 13031,
     /* 275388 */     GIR_EraseRootFromParent_Done,
     /* 275389 */   // Label 5338: @275389
     /* 275389 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(275449), // Rule ID 13142 //
     /* 275394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 275397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275414 */     // MIs[0] tile
     /* 275414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275430 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 275433 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275441 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275447 */     GIR_RootConstrainSelectedInstOperands,
     /* 275448 */     // GIR_Coverage, 13142,
     /* 275448 */     GIR_EraseRootFromParent_Done,
     /* 275449 */   // Label 5339: @275449
     /* 275449 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(275497), // Rule ID 3573 //
     /* 275454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 275462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275478 */     // MIs[0] Op4
     /* 275478 */     // No operand predicates
     /* 275478 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 275481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275495 */     GIR_RootConstrainSelectedInstOperands,
     /* 275496 */     // GIR_Coverage, 3573,
     /* 275496 */     GIR_EraseRootFromParent_Done,
     /* 275497 */   // Label 5340: @275497
     /* 275497 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(275545), // Rule ID 3575 //
     /* 275502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 275510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275526 */     // MIs[0] Op4
     /* 275526 */     // No operand predicates
     /* 275526 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1515:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 275529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275537 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275543 */     GIR_RootConstrainSelectedInstOperands,
     /* 275544 */     // GIR_Coverage, 3575,
     /* 275544 */     GIR_EraseRootFromParent_Done,
     /* 275545 */   // Label 5341: @275545
     /* 275545 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(275593), // Rule ID 3576 //
     /* 275550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 275553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 275558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275574 */     // MIs[0] Op4
     /* 275574 */     // No operand predicates
     /* 275574 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1511:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 275577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275585 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275591 */     GIR_RootConstrainSelectedInstOperands,
     /* 275592 */     // GIR_Coverage, 3576,
     /* 275592 */     GIR_EraseRootFromParent_Done,
     /* 275593 */   // Label 5342: @275593
     /* 275593 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(275641), // Rule ID 3577 //
     /* 275598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 275601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 275606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275622 */     // MIs[0] Op4
     /* 275622 */     // No operand predicates
     /* 275622 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 275625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275639 */     GIR_RootConstrainSelectedInstOperands,
     /* 275640 */     // GIR_Coverage, 3577,
     /* 275640 */     GIR_EraseRootFromParent_Done,
     /* 275641 */   // Label 5343: @275641
     /* 275641 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(275689), // Rule ID 12622 //
     /* 275646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 275654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 275657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275670 */     // MIs[0] Op4
     /* 275670 */     // No operand predicates
     /* 275670 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 275673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275681 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275687 */     GIR_RootConstrainSelectedInstOperands,
     /* 275688 */     // GIR_Coverage, 12622,
     /* 275688 */     GIR_EraseRootFromParent_Done,
     /* 275689 */   // Label 5344: @275689
     /* 275689 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(275737), // Rule ID 12624 //
     /* 275694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 275702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275718 */     // MIs[0] Op4
     /* 275718 */     // No operand predicates
     /* 275718 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 275721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275729 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275735 */     GIR_RootConstrainSelectedInstOperands,
     /* 275736 */     // GIR_Coverage, 12624,
     /* 275736 */     GIR_EraseRootFromParent_Done,
     /* 275737 */   // Label 5345: @275737
     /* 275737 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(275785), // Rule ID 12625 //
     /* 275742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 275750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275766 */     // MIs[0] Op4
     /* 275766 */     // No operand predicates
     /* 275766 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 275769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275777 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275783 */     GIR_RootConstrainSelectedInstOperands,
     /* 275784 */     // GIR_Coverage, 12625,
     /* 275784 */     GIR_EraseRootFromParent_Done,
     /* 275785 */   // Label 5346: @275785
     /* 275785 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(275833), // Rule ID 12626 //
     /* 275790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 275793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 275798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 275801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 275807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275814 */     // MIs[0] Op4
     /* 275814 */     // No operand predicates
     /* 275814 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 275814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 275817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 275819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 275821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 275823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 275825 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 275827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275831 */     GIR_RootConstrainSelectedInstOperands,
     /* 275832 */     // GIR_Coverage, 12626,
     /* 275832 */     GIR_EraseRootFromParent_Done,
     /* 275833 */   // Label 5347: @275833
     /* 275833 */   GIM_Reject,
     /* 275834 */ // Label 5297: @275834
     /* 275834 */ GIM_Reject,
     /* 275835 */ // Label 39: @275835
     /* 275835 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5352*/ GIMT_Encode4(276124),
     /* 275846 */ /*GILLT_s64*//*Label 5348*/ GIMT_Encode4(275878), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275858 */ /*GILLT_v2s64*//*Label 5349*/ GIMT_Encode4(275938), GIMT_Encode4(0),
     /* 275866 */ /*GILLT_v4s32*//*Label 5350*/ GIMT_Encode4(276000), GIMT_Encode4(0),
     /* 275874 */ /*GILLT_v8s16*//*Label 5351*/ GIMT_Encode4(276062),
     /* 275878 */ // Label 5348: @275878
     /* 275878 */ GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(275937), // Rule ID 6531 //
     /* 275883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275894 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 275894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 275897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 275911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275916 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 275921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 275931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 275936 */   // GIR_Coverage, 6531,
     /* 275936 */   GIR_EraseRootFromParent_Done,
     /* 275937 */ // Label 5353: @275937
     /* 275937 */ GIM_Reject,
     /* 275938 */ // Label 5349: @275938
     /* 275938 */ GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(275999),
     /* 275943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 275946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275950 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(275977), // Rule ID 6401 //
     /* 275955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 275962 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 275962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 275965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 275972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275975 */     GIR_RootConstrainSelectedInstOperands,
     /* 275976 */     // GIR_Coverage, 6401,
     /* 275976 */     GIR_EraseRootFromParent_Done,
     /* 275977 */   // Label 5355: @275977
     /* 275977 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(275998), // Rule ID 6394 //
     /* 275982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275986 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 275986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 275989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275996 */     GIR_RootConstrainSelectedInstOperands,
     /* 275997 */     // GIR_Coverage, 6394,
     /* 275997 */     GIR_EraseRootFromParent_Done,
     /* 275998 */   // Label 5356: @275998
     /* 275998 */   GIM_Reject,
     /* 275999 */ // Label 5354: @275999
     /* 275999 */ GIM_Reject,
     /* 276000 */ // Label 5350: @276000
     /* 276000 */ GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(276061),
     /* 276005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 276008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276012 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(276039), // Rule ID 6398 //
     /* 276017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 276024 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 276024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 276027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 276034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276037 */     GIR_RootConstrainSelectedInstOperands,
     /* 276038 */     // GIR_Coverage, 6398,
     /* 276038 */     GIR_EraseRootFromParent_Done,
     /* 276039 */   // Label 5358: @276039
     /* 276039 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(276060), // Rule ID 6391 //
     /* 276044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276048 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 276048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 276051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276058 */     GIR_RootConstrainSelectedInstOperands,
     /* 276059 */     // GIR_Coverage, 6391,
     /* 276059 */     GIR_EraseRootFromParent_Done,
     /* 276060 */   // Label 5359: @276060
     /* 276060 */   GIM_Reject,
     /* 276061 */ // Label 5357: @276061
     /* 276061 */ GIM_Reject,
     /* 276062 */ // Label 5351: @276062
     /* 276062 */ GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(276123),
     /* 276067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 276070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276074 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(276101), // Rule ID 6395 //
     /* 276079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 276086 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 276086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 276089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 276096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276099 */     GIR_RootConstrainSelectedInstOperands,
     /* 276100 */     // GIR_Coverage, 6395,
     /* 276100 */     GIR_EraseRootFromParent_Done,
     /* 276101 */   // Label 5361: @276101
     /* 276101 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(276122), // Rule ID 6388 //
     /* 276106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276110 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 276110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 276113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276120 */     GIR_RootConstrainSelectedInstOperands,
     /* 276121 */     // GIR_Coverage, 6388,
     /* 276121 */     GIR_EraseRootFromParent_Done,
     /* 276122 */   // Label 5362: @276122
     /* 276122 */   GIM_Reject,
     /* 276123 */ // Label 5360: @276123
     /* 276123 */ GIM_Reject,
     /* 276124 */ // Label 5352: @276124
     /* 276124 */ GIM_Reject,
     /* 276125 */ // Label 40: @276125
     /* 276125 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5367*/ GIMT_Encode4(277561),
     /* 276136 */ /*GILLT_s32*//*Label 5363*/ GIMT_Encode4(276168), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 276148 */ /*GILLT_v2s32*//*Label 5364*/ GIMT_Encode4(276207), GIMT_Encode4(0),
     /* 276156 */ /*GILLT_v4s16*//*Label 5365*/ GIMT_Encode4(276563), GIMT_Encode4(0),
     /* 276164 */ /*GILLT_v8s8*//*Label 5366*/ GIMT_Encode4(277062),
     /* 276168 */ // Label 5363: @276168
     /* 276168 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(276206), // Rule ID 6552 //
     /* 276173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 276180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 276184 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 276184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276189 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 276195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 276200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 276205 */   // GIR_Coverage, 6552,
     /* 276205 */   GIR_EraseRootFromParent_Done,
     /* 276206 */ // Label 5368: @276206
     /* 276206 */ GIM_Reject,
     /* 276207 */ // Label 5364: @276207
     /* 276207 */ GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(276562),
     /* 276212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276219 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(276297), // Rule ID 5442 //
     /* 276224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 276244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276261 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276267 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 276269 */     // MIs[1] Operand 2
     /* 276269 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276282 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 276282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 276285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276295 */     GIR_RootConstrainSelectedInstOperands,
     /* 276296 */     // GIR_Coverage, 5442,
     /* 276296 */     GIR_EraseRootFromParent_Done,
     /* 276297 */   // Label 5370: @276297
     /* 276297 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(276368), // Rule ID 5438 //
     /* 276302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 276322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276340 */     // MIs[1] Operand 2
     /* 276340 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276353 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 276356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276366 */     GIR_RootConstrainSelectedInstOperands,
     /* 276367 */     // GIR_Coverage, 5438,
     /* 276367 */     GIR_EraseRootFromParent_Done,
     /* 276368 */   // Label 5371: @276368
     /* 276368 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(276439), // Rule ID 5440 //
     /* 276373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 276401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276411 */     // MIs[1] Operand 2
     /* 276411 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 276422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276424 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 276424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 276427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276437 */     GIR_RootConstrainSelectedInstOperands,
     /* 276438 */     // GIR_Coverage, 5440,
     /* 276438 */     GIR_EraseRootFromParent_Done,
     /* 276439 */   // Label 5372: @276439
     /* 276439 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(276492), // Rule ID 2162 //
     /* 276444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 276455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276464 */     // MIs[1] imm
     /* 276464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 276476 */     // MIs[2] Operand 1
     /* 276476 */     // No operand predicates
     /* 276476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276478 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 276478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 276481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276490 */     GIR_RootConstrainSelectedInstOperands,
     /* 276491 */     // GIR_Coverage, 2162,
     /* 276491 */     GIR_EraseRootFromParent_Done,
     /* 276492 */   // Label 5373: @276492
     /* 276492 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(276542), // Rule ID 6376 //
     /* 276497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276514 */     // MIs[1] imm
     /* 276514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 276526 */     // MIs[2] Operand 1
     /* 276526 */     // No operand predicates
     /* 276526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276528 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 276528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 276531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276540 */     GIR_RootConstrainSelectedInstOperands,
     /* 276541 */     // GIR_Coverage, 6376,
     /* 276541 */     GIR_EraseRootFromParent_Done,
     /* 276542 */   // Label 5374: @276542
     /* 276542 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(276561), // Rule ID 1099 //
     /* 276547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276554 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 276554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 276559 */     GIR_RootConstrainSelectedInstOperands,
     /* 276560 */     // GIR_Coverage, 1099,
     /* 276560 */     GIR_Done,
     /* 276561 */   // Label 5375: @276561
     /* 276561 */   GIM_Reject,
     /* 276562 */ // Label 5369: @276562
     /* 276562 */ GIM_Reject,
     /* 276563 */ // Label 5365: @276563
     /* 276563 */ GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(277061),
     /* 276568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276575 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(276653), // Rule ID 5436 //
     /* 276580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 276600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276617 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276623 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 276625 */     // MIs[1] Operand 2
     /* 276625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276638 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 276641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276651 */     GIR_RootConstrainSelectedInstOperands,
     /* 276652 */     // GIR_Coverage, 5436,
     /* 276652 */     GIR_EraseRootFromParent_Done,
     /* 276653 */   // Label 5377: @276653
     /* 276653 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(276724), // Rule ID 5432 //
     /* 276658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 276678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276696 */     // MIs[1] Operand 2
     /* 276696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276709 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 276712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276722 */     GIR_RootConstrainSelectedInstOperands,
     /* 276723 */     // GIR_Coverage, 5432,
     /* 276723 */     GIR_EraseRootFromParent_Done,
     /* 276724 */   // Label 5378: @276724
     /* 276724 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(276795), // Rule ID 5434 //
     /* 276729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276767 */     // MIs[1] Operand 2
     /* 276767 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 276778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276780 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 276783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 276789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 276793 */     GIR_RootConstrainSelectedInstOperands,
     /* 276794 */     // GIR_Coverage, 5434,
     /* 276794 */     GIR_EraseRootFromParent_Done,
     /* 276795 */   // Label 5379: @276795
     /* 276795 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(276887), // Rule ID 5558 //
     /* 276800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 276808 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 276811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 276827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 276840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 276844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276848 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276855 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 276855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 276862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 276871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 276875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 276880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276885 */     GIR_RootConstrainSelectedInstOperands,
     /* 276886 */     // GIR_Coverage, 5558,
     /* 276886 */     GIR_EraseRootFromParent_Done,
     /* 276887 */   // Label 5380: @276887
     /* 276887 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(276940), // Rule ID 2161 //
     /* 276892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 276903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276912 */     // MIs[1] imm
     /* 276912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 276924 */     // MIs[2] Operand 1
     /* 276924 */     // No operand predicates
     /* 276924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276926 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 276926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 276929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276938 */     GIR_RootConstrainSelectedInstOperands,
     /* 276939 */     // GIR_Coverage, 2161,
     /* 276939 */     GIR_EraseRootFromParent_Done,
     /* 276940 */   // Label 5381: @276940
     /* 276940 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(276990), // Rule ID 6375 //
     /* 276945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 276953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276962 */     // MIs[1] imm
     /* 276962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 276974 */     // MIs[2] Operand 1
     /* 276974 */     // No operand predicates
     /* 276974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276976 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 276976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 276979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 276985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 276988 */     GIR_RootConstrainSelectedInstOperands,
     /* 276989 */     // GIR_Coverage, 6375,
     /* 276989 */     GIR_EraseRootFromParent_Done,
     /* 276990 */   // Label 5382: @276990
     /* 276990 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277041), // Rule ID 5586 //
     /* 276995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 277003 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 277014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277026 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 277026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 277029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 277035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 277039 */     GIR_RootConstrainSelectedInstOperands,
     /* 277040 */     // GIR_Coverage, 5586,
     /* 277040 */     GIR_EraseRootFromParent_Done,
     /* 277041 */   // Label 5383: @277041
     /* 277041 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(277060), // Rule ID 1098 //
     /* 277046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277053 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 277053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 277058 */     GIR_RootConstrainSelectedInstOperands,
     /* 277059 */     // GIR_Coverage, 1098,
     /* 277059 */     GIR_Done,
     /* 277060 */   // Label 5384: @277060
     /* 277060 */   GIM_Reject,
     /* 277061 */ // Label 5376: @277061
     /* 277061 */ GIM_Reject,
     /* 277062 */ // Label 5366: @277062
     /* 277062 */ GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(277560),
     /* 277067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277074 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(277152), // Rule ID 5430 //
     /* 277079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 277099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277116 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277122 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 277124 */     // MIs[1] Operand 2
     /* 277124 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 277135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277137 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 277137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 277140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277150 */     GIR_RootConstrainSelectedInstOperands,
     /* 277151 */     // GIR_Coverage, 5430,
     /* 277151 */     GIR_EraseRootFromParent_Done,
     /* 277152 */   // Label 5386: @277152
     /* 277152 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(277223), // Rule ID 5426 //
     /* 277157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277195 */     // MIs[1] Operand 2
     /* 277195 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 277206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277208 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 277211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277221 */     GIR_RootConstrainSelectedInstOperands,
     /* 277222 */     // GIR_Coverage, 5426,
     /* 277222 */     GIR_EraseRootFromParent_Done,
     /* 277223 */   // Label 5387: @277223
     /* 277223 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(277294), // Rule ID 5428 //
     /* 277228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 277248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277266 */     // MIs[1] Operand 2
     /* 277266 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 277277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277279 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 277282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277292 */     GIR_RootConstrainSelectedInstOperands,
     /* 277293 */     // GIR_Coverage, 5428,
     /* 277293 */     GIR_EraseRootFromParent_Done,
     /* 277294 */   // Label 5388: @277294
     /* 277294 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(277386), // Rule ID 5531 //
     /* 277299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 277307 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 277326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 277339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 277343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277354 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 277354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 277361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 277370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 277374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 277379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277384 */     GIR_RootConstrainSelectedInstOperands,
     /* 277385 */     // GIR_Coverage, 5531,
     /* 277385 */     GIR_EraseRootFromParent_Done,
     /* 277386 */   // Label 5389: @277386
     /* 277386 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(277439), // Rule ID 2160 //
     /* 277391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 277402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277411 */     // MIs[1] imm
     /* 277411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277419 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 277423 */     // MIs[2] Operand 1
     /* 277423 */     // No operand predicates
     /* 277423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277425 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 277425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 277428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277437 */     GIR_RootConstrainSelectedInstOperands,
     /* 277438 */     // GIR_Coverage, 2160,
     /* 277438 */     GIR_EraseRootFromParent_Done,
     /* 277439 */   // Label 5390: @277439
     /* 277439 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(277489), // Rule ID 6374 //
     /* 277444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277461 */     // MIs[1] imm
     /* 277461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 277473 */     // MIs[2] Operand 1
     /* 277473 */     // No operand predicates
     /* 277473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277475 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 277475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 277478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277487 */     GIR_RootConstrainSelectedInstOperands,
     /* 277488 */     // GIR_Coverage, 6374,
     /* 277488 */     GIR_EraseRootFromParent_Done,
     /* 277489 */   // Label 5391: @277489
     /* 277489 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(277540), // Rule ID 5585 //
     /* 277494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 277502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277525 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 277525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 277528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 277534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 277538 */     GIR_RootConstrainSelectedInstOperands,
     /* 277539 */     // GIR_Coverage, 5585,
     /* 277539 */     GIR_EraseRootFromParent_Done,
     /* 277540 */   // Label 5392: @277540
     /* 277540 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(277559), // Rule ID 1097 //
     /* 277545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277552 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 277552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 277557 */     GIR_RootConstrainSelectedInstOperands,
     /* 277558 */     // GIR_Coverage, 1097,
     /* 277558 */     GIR_Done,
     /* 277559 */   // Label 5393: @277559
     /* 277559 */   GIM_Reject,
     /* 277560 */ // Label 5385: @277560
     /* 277560 */ GIM_Reject,
     /* 277561 */ // Label 5367: @277561
     /* 277561 */ GIM_Reject,
     /* 277562 */ // Label 41: @277562
     /* 277562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5396*/ GIMT_Encode4(277681),
     /* 277573 */ /*GILLT_s32*//*Label 5394*/ GIMT_Encode4(277581),
     /* 277577 */ /*GILLT_s64*//*Label 5395*/ GIMT_Encode4(277601),
     /* 277581 */ // Label 5394: @277581
     /* 277581 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(277600), // Rule ID 81 //
     /* 277586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277590 */   // MIs[0] Operand 1
     /* 277590 */   // No operand predicates
     /* 277590 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 277590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 277593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277595 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 277598 */   GIR_RootConstrainSelectedInstOperands,
     /* 277599 */   // GIR_Coverage, 81,
     /* 277599 */   GIR_EraseRootFromParent_Done,
     /* 277600 */ // Label 5397: @277600
     /* 277600 */ GIM_Reject,
     /* 277601 */ // Label 5395: @277601
     /* 277601 */ GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(277661), // Rule ID 3902 //
     /* 277606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 277609 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 277613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277617 */   // MIs[0] Operand 1
     /* 277617 */   // No operand predicates
     /* 277617 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 277617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 277624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277629 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 277634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 277639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277660 */   // GIR_Coverage, 3902,
     /* 277660 */   GIR_EraseRootFromParent_Done,
     /* 277661 */ // Label 5398: @277661
     /* 277661 */ GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(277680), // Rule ID 82 //
     /* 277666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 277670 */   // MIs[0] Operand 1
     /* 277670 */   // No operand predicates
     /* 277670 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 277670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 277673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277675 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 277678 */   GIR_RootConstrainSelectedInstOperands,
     /* 277679 */   // GIR_Coverage, 82,
     /* 277679 */   GIR_EraseRootFromParent_Done,
     /* 277680 */ // Label 5399: @277680
     /* 277680 */ GIM_Reject,
     /* 277681 */ // Label 5396: @277681
     /* 277681 */ GIM_Reject,
     /* 277682 */ // Label 42: @277682
     /* 277682 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5403*/ GIMT_Encode4(277922),
     /* 277693 */ /*GILLT_s16*//*Label 5400*/ GIMT_Encode4(277705),
     /* 277697 */ /*GILLT_s32*//*Label 5401*/ GIMT_Encode4(277757),
     /* 277701 */ /*GILLT_s64*//*Label 5402*/ GIMT_Encode4(277870),
     /* 277705 */ // Label 5400: @277705
     /* 277705 */ GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(277728), // Rule ID 506 //
     /* 277710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277713 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277721 */   // MIs[0] Operand 1
     /* 277721 */   // No operand predicates
     /* 277721 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 277721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 277724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277726 */   GIR_RootConstrainSelectedInstOperands,
     /* 277727 */   // GIR_Coverage, 506,
     /* 277727 */   GIR_EraseRootFromParent_Done,
     /* 277728 */ // Label 5404: @277728
     /* 277728 */ GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(277756), // Rule ID 688 //
     /* 277733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 277736 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 277740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 277744 */   // MIs[0] Operand 1
     /* 277744 */   // No operand predicates
     /* 277744 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 277744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 277747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277749 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 277754 */   GIR_RootConstrainSelectedInstOperands,
     /* 277755 */   // GIR_Coverage, 688,
     /* 277755 */   GIR_EraseRootFromParent_Done,
     /* 277756 */ // Label 5405: @277756
     /* 277756 */ GIM_Reject,
     /* 277757 */ // Label 5401: @277757
     /* 277757 */ GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(277780), // Rule ID 507 //
     /* 277762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277765 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277773 */   // MIs[0] Operand 1
     /* 277773 */   // No operand predicates
     /* 277773 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 277773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 277776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277778 */   GIR_RootConstrainSelectedInstOperands,
     /* 277779 */   // GIR_Coverage, 507,
     /* 277779 */   GIR_EraseRootFromParent_Done,
     /* 277780 */ // Label 5406: @277780
     /* 277780 */ GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(277808), // Rule ID 689 //
     /* 277785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277788 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 277792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277796 */   // MIs[0] Operand 1
     /* 277796 */   // No operand predicates
     /* 277796 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 277796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 277799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277801 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 277806 */   GIR_RootConstrainSelectedInstOperands,
     /* 277807 */   // GIR_Coverage, 689,
     /* 277807 */   GIR_EraseRootFromParent_Done,
     /* 277808 */ // Label 5407: @277808
     /* 277808 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(277869), // Rule ID 6063 //
     /* 277813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277816 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 277820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277824 */   // MIs[0] Operand 1
     /* 277824 */   // No operand predicates
     /* 277824 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 277824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 277831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277836 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 277841 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 277844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277851 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 277858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277868 */   // GIR_Coverage, 6063,
     /* 277868 */   GIR_EraseRootFromParent_Done,
     /* 277869 */ // Label 5408: @277869
     /* 277869 */ GIM_Reject,
     /* 277870 */ // Label 5402: @277870
     /* 277870 */ GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(277893), // Rule ID 508 //
     /* 277875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277878 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 277882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277886 */   // MIs[0] Operand 1
     /* 277886 */   // No operand predicates
     /* 277886 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 277886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 277889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277891 */   GIR_RootConstrainSelectedInstOperands,
     /* 277892 */   // GIR_Coverage, 508,
     /* 277892 */   GIR_EraseRootFromParent_Done,
     /* 277893 */ // Label 5409: @277893
     /* 277893 */ GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(277921), // Rule ID 690 //
     /* 277898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277901 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 277905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277909 */   // MIs[0] Operand 1
     /* 277909 */   // No operand predicates
     /* 277909 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 277909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 277912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277914 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 277919 */   GIR_RootConstrainSelectedInstOperands,
     /* 277920 */   // GIR_Coverage, 690,
     /* 277920 */   GIR_EraseRootFromParent_Done,
     /* 277921 */ // Label 5410: @277921
     /* 277921 */ GIM_Reject,
     /* 277922 */ // Label 5403: @277922
     /* 277922 */ GIM_Reject,
     /* 277923 */ // Label 43: @277923
     /* 277923 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5416*/ GIMT_Encode4(279820),
     /* 277934 */ /*GILLT_s32*//*Label 5411*/ GIMT_Encode4(277970),
     /* 277938 */ /*GILLT_s64*//*Label 5412*/ GIMT_Encode4(279411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277950 */ /*GILLT_v2s64*//*Label 5413*/ GIMT_Encode4(279634), GIMT_Encode4(0),
     /* 277958 */ /*GILLT_v4s32*//*Label 5414*/ GIMT_Encode4(279696), GIMT_Encode4(0),
     /* 277966 */ /*GILLT_v8s16*//*Label 5415*/ GIMT_Encode4(279758),
     /* 277970 */ // Label 5411: @277970
     /* 277970 */ GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(278090), // Rule ID 13197 //
     /* 277975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 277978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277982 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 277990 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 277993 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 277998 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278002 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278009 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278009 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278012 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 278016 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278021 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278027 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278030 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278034 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278053 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278056 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278059 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278088 */   GIR_RootConstrainSelectedInstOperands,
     /* 278089 */   // GIR_Coverage, 13197,
     /* 278089 */   GIR_EraseRootFromParent_Done,
     /* 278090 */ // Label 5417: @278090
     /* 278090 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(278210), // Rule ID 13199 //
     /* 278095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278102 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278110 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278113 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 278118 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278122 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278129 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278129 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278132 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 278136 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278141 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278147 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278150 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278154 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278173 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278176 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278179 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278208 */   GIR_RootConstrainSelectedInstOperands,
     /* 278209 */   // GIR_Coverage, 13199,
     /* 278209 */   GIR_EraseRootFromParent_Done,
     /* 278210 */ // Label 5418: @278210
     /* 278210 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(278330), // Rule ID 13201 //
     /* 278215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278222 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278230 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278233 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 278238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278249 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278249 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278252 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 278256 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278261 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278267 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278270 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278274 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278296 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278299 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278328 */   GIR_RootConstrainSelectedInstOperands,
     /* 278329 */   // GIR_Coverage, 13201,
     /* 278329 */   GIR_EraseRootFromParent_Done,
     /* 278330 */ // Label 5419: @278330
     /* 278330 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(278450), // Rule ID 13203 //
     /* 278335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278342 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278346 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278350 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278353 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 278358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278369 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278369 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278372 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 278376 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278381 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278387 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278390 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278394 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278416 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278419 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278448 */   GIR_RootConstrainSelectedInstOperands,
     /* 278449 */   // GIR_Coverage, 13203,
     /* 278449 */   GIR_EraseRootFromParent_Done,
     /* 278450 */ // Label 5420: @278450
     /* 278450 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(278570), // Rule ID 13219 //
     /* 278455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278462 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278470 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278473 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278489 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278489 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278492 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 278496 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278501 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278533 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278539 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278568 */   GIR_RootConstrainSelectedInstOperands,
     /* 278569 */   // GIR_Coverage, 13219,
     /* 278569 */   GIR_EraseRootFromParent_Done,
     /* 278570 */ // Label 5421: @278570
     /* 278570 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(278690), // Rule ID 13221 //
     /* 278575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278582 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278590 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278593 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278609 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278609 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278612 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 278616 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278621 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278653 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278656 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278659 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 278662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 278677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 278680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278688 */   GIR_RootConstrainSelectedInstOperands,
     /* 278689 */   // GIR_Coverage, 13221,
     /* 278689 */   GIR_EraseRootFromParent_Done,
     /* 278690 */ // Label 5422: @278690
     /* 278690 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(278810), // Rule ID 13223 //
     /* 278695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278702 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278710 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278713 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278718 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278722 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278729 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278729 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278732 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 278736 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278741 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278776 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278779 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278782 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278808 */   GIR_RootConstrainSelectedInstOperands,
     /* 278809 */   // GIR_Coverage, 13223,
     /* 278809 */   GIR_EraseRootFromParent_Done,
     /* 278810 */ // Label 5423: @278810
     /* 278810 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(278930), // Rule ID 13225 //
     /* 278815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278822 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278830 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278833 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 278838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278849 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278849 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 278852 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 278856 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278861 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278867 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278870 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278874 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 278884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278899 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 278902 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 278917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 278920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278928 */   GIR_RootConstrainSelectedInstOperands,
     /* 278929 */   // GIR_Coverage, 13225,
     /* 278929 */   GIR_EraseRootFromParent_Done,
     /* 278930 */ // Label 5424: @278930
     /* 278930 */ GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(279050), // Rule ID 13229 //
     /* 278935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 278938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278942 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 278950 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278953 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 278958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278962 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278969 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278969 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 278972 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 278976 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278981 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 278985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 278990 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278994 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279016 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279019 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279048 */   GIR_RootConstrainSelectedInstOperands,
     /* 279049 */   // GIR_Coverage, 13229,
     /* 279049 */   GIR_EraseRootFromParent_Done,
     /* 279050 */ // Label 5425: @279050
     /* 279050 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(279170), // Rule ID 13231 //
     /* 279055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279062 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279070 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279073 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 279078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279089 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279089 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279092 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 279096 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279101 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279107 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279110 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279114 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279133 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279136 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279139 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279168 */   GIR_RootConstrainSelectedInstOperands,
     /* 279169 */   // GIR_Coverage, 13231,
     /* 279169 */   GIR_EraseRootFromParent_Done,
     /* 279170 */ // Label 5426: @279170
     /* 279170 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(279290), // Rule ID 13233 //
     /* 279175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279182 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279190 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279193 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 279198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279209 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279209 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279212 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 279216 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279221 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279227 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279230 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279234 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279253 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279256 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279259 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279262 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279288 */   GIR_RootConstrainSelectedInstOperands,
     /* 279289 */   // GIR_Coverage, 13233,
     /* 279289 */   GIR_EraseRootFromParent_Done,
     /* 279290 */ // Label 5427: @279290
     /* 279290 */ GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(279410), // Rule ID 13235 //
     /* 279295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279302 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279310 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279313 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 279318 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279322 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279329 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279329 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279332 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 279336 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279341 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279373 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279376 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279379 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279382 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279408 */   GIR_RootConstrainSelectedInstOperands,
     /* 279409 */   // GIR_Coverage, 13235,
     /* 279409 */   GIR_EraseRootFromParent_Done,
     /* 279410 */ // Label 5428: @279410
     /* 279410 */ GIM_Reject,
     /* 279411 */ // Label 5412: @279411
     /* 279411 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(279633),
     /* 279416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 279423 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(279477), // Rule ID 5669 //
     /* 279428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279457 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279461 */     // MIs[2] Operand 1
     /* 279461 */     // No operand predicates
     /* 279461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279463 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 279463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 279466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279475 */     GIR_RootConstrainSelectedInstOperands,
     /* 279476 */     // GIR_Coverage, 5669,
     /* 279476 */     GIR_EraseRootFromParent_Done,
     /* 279477 */   // Label 5430: @279477
     /* 279477 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(279556), // Rule ID 11278 //
     /* 279482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 279513 */     // MIs[2] Operand 1
     /* 279513 */     // No operand predicates
     /* 279513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279515 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 279515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 279518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279527 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 279533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 279546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 279554 */     GIR_RootConstrainSelectedInstOperands,
     /* 279555 */     // GIR_Coverage, 11278,
     /* 279555 */     GIR_EraseRootFromParent_Done,
     /* 279556 */   // Label 5431: @279556
     /* 279556 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(279632), // Rule ID 6533 //
     /* 279561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279565 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 279565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 279568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 279598 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 279601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 279619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 279630 */     GIR_RootConstrainSelectedInstOperands,
     /* 279631 */     // GIR_Coverage, 6533,
     /* 279631 */     GIR_EraseRootFromParent_Done,
     /* 279632 */   // Label 5432: @279632
     /* 279632 */   GIM_Reject,
     /* 279633 */ // Label 5429: @279633
     /* 279633 */ GIM_Reject,
     /* 279634 */ // Label 5413: @279634
     /* 279634 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(279695),
     /* 279639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279646 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(279673), // Rule ID 6403 //
     /* 279651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 279658 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 279658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 279661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279671 */     GIR_RootConstrainSelectedInstOperands,
     /* 279672 */     // GIR_Coverage, 6403,
     /* 279672 */     GIR_EraseRootFromParent_Done,
     /* 279673 */   // Label 5434: @279673
     /* 279673 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(279694), // Rule ID 6392 //
     /* 279678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279682 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 279682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 279685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279692 */     GIR_RootConstrainSelectedInstOperands,
     /* 279693 */     // GIR_Coverage, 6392,
     /* 279693 */     GIR_EraseRootFromParent_Done,
     /* 279694 */   // Label 5435: @279694
     /* 279694 */   GIM_Reject,
     /* 279695 */ // Label 5433: @279695
     /* 279695 */ GIM_Reject,
     /* 279696 */ // Label 5414: @279696
     /* 279696 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(279757),
     /* 279701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279708 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(279735), // Rule ID 6400 //
     /* 279713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 279720 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 279720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 279723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279733 */     GIR_RootConstrainSelectedInstOperands,
     /* 279734 */     // GIR_Coverage, 6400,
     /* 279734 */     GIR_EraseRootFromParent_Done,
     /* 279735 */   // Label 5437: @279735
     /* 279735 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(279756), // Rule ID 6389 //
     /* 279740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279744 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 279744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 279747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279754 */     GIR_RootConstrainSelectedInstOperands,
     /* 279755 */     // GIR_Coverage, 6389,
     /* 279755 */     GIR_EraseRootFromParent_Done,
     /* 279756 */   // Label 5438: @279756
     /* 279756 */   GIM_Reject,
     /* 279757 */ // Label 5436: @279757
     /* 279757 */ GIM_Reject,
     /* 279758 */ // Label 5415: @279758
     /* 279758 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(279819),
     /* 279763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 279766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279770 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(279797), // Rule ID 6397 //
     /* 279775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 279782 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 279782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 279785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279795 */     GIR_RootConstrainSelectedInstOperands,
     /* 279796 */     // GIR_Coverage, 6397,
     /* 279796 */     GIR_EraseRootFromParent_Done,
     /* 279797 */   // Label 5440: @279797
     /* 279797 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(279818), // Rule ID 6386 //
     /* 279802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279806 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 279806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 279809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279816 */     GIR_RootConstrainSelectedInstOperands,
     /* 279817 */     // GIR_Coverage, 6386,
     /* 279817 */     GIR_EraseRootFromParent_Done,
     /* 279818 */   // Label 5441: @279818
     /* 279818 */   GIM_Reject,
     /* 279819 */ // Label 5439: @279819
     /* 279819 */ GIM_Reject,
     /* 279820 */ // Label 5416: @279820
     /* 279820 */ GIM_Reject,
     /* 279821 */ // Label 44: @279821
     /* 279821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5447*/ GIMT_Encode4(281474),
     /* 279832 */ /*GILLT_s32*//*Label 5442*/ GIMT_Encode4(279912),
     /* 279836 */ /*GILLT_s64*//*Label 5443*/ GIMT_Encode4(280406), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279888 */ /*GILLT_nxv2s64*//*Label 5444*/ GIMT_Encode4(281048), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279900 */ /*GILLT_nxv4s32*//*Label 5445*/ GIMT_Encode4(281257), GIMT_Encode4(0),
     /* 279908 */ /*GILLT_nxv8s16*//*Label 5446*/ GIMT_Encode4(281401),
     /* 279912 */ // Label 5442: @279912
     /* 279912 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(280405),
     /* 279917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279924 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(279989), // Rule ID 5664 //
     /* 279929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 279941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 279962 */     // MIs[2] Operand 1
     /* 279962 */     // No operand predicates
     /* 279962 */     // MIs[0] Operand 2
     /* 279962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 279973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279975 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 279975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279987 */     GIR_RootConstrainSelectedInstOperands,
     /* 279988 */     // GIR_Coverage, 5664,
     /* 279988 */     GIR_EraseRootFromParent_Done,
     /* 279989 */   // Label 5449: @279989
     /* 279989 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(280054), // Rule ID 5666 //
     /* 279994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280027 */     // MIs[2] Operand 1
     /* 280027 */     // No operand predicates
     /* 280027 */     // MIs[0] Operand 2
     /* 280027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280040 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280052 */     GIR_RootConstrainSelectedInstOperands,
     /* 280053 */     // GIR_Coverage, 5666,
     /* 280053 */     GIR_EraseRootFromParent_Done,
     /* 280054 */   // Label 5450: @280054
     /* 280054 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(280119), // Rule ID 5668 //
     /* 280059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280092 */     // MIs[2] Operand 1
     /* 280092 */     // No operand predicates
     /* 280092 */     // MIs[0] Operand 2
     /* 280092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280105 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280117 */     GIR_RootConstrainSelectedInstOperands,
     /* 280118 */     // GIR_Coverage, 5668,
     /* 280118 */     GIR_EraseRootFromParent_Done,
     /* 280119 */   // Label 5451: @280119
     /* 280119 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(280209), // Rule ID 11274 //
     /* 280124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280155 */     // MIs[2] Operand 1
     /* 280155 */     // No operand predicates
     /* 280155 */     // MIs[0] Operand 2
     /* 280155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280168 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 280168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280180 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280207 */     GIR_RootConstrainSelectedInstOperands,
     /* 280208 */     // GIR_Coverage, 11274,
     /* 280208 */     GIR_EraseRootFromParent_Done,
     /* 280209 */   // Label 5452: @280209
     /* 280209 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(280299), // Rule ID 11276 //
     /* 280214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280245 */     // MIs[2] Operand 1
     /* 280245 */     // No operand predicates
     /* 280245 */     // MIs[0] Operand 2
     /* 280245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280258 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 280258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 280261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280297 */     GIR_RootConstrainSelectedInstOperands,
     /* 280298 */     // GIR_Coverage, 11276,
     /* 280298 */     GIR_EraseRootFromParent_Done,
     /* 280299 */   // Label 5453: @280299
     /* 280299 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(280334), // Rule ID 6538 //
     /* 280304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280308 */     // MIs[0] Operand 2
     /* 280308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280319 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 280319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 280332 */     GIR_RootConstrainSelectedInstOperands,
     /* 280333 */     // GIR_Coverage, 6538,
     /* 280333 */     GIR_EraseRootFromParent_Done,
     /* 280334 */   // Label 5454: @280334
     /* 280334 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(280369), // Rule ID 6539 //
     /* 280339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280343 */     // MIs[0] Operand 2
     /* 280343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280354 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 280354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 280367 */     GIR_RootConstrainSelectedInstOperands,
     /* 280368 */     // GIR_Coverage, 6539,
     /* 280368 */     GIR_EraseRootFromParent_Done,
     /* 280369 */   // Label 5455: @280369
     /* 280369 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(280404), // Rule ID 6540 //
     /* 280374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280378 */     // MIs[0] Operand 2
     /* 280378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 280389 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 280389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 280392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280402 */     GIR_RootConstrainSelectedInstOperands,
     /* 280403 */     // GIR_Coverage, 6540,
     /* 280403 */     GIR_EraseRootFromParent_Done,
     /* 280404 */   // Label 5456: @280404
     /* 280404 */   GIM_Reject,
     /* 280405 */ // Label 5448: @280405
     /* 280405 */ GIM_Reject,
     /* 280406 */ // Label 5443: @280406
     /* 280406 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(281047),
     /* 280411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280418 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(280495), // Rule ID 5670 //
     /* 280423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280464 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280468 */     // MIs[3] Operand 1
     /* 280468 */     // No operand predicates
     /* 280468 */     // MIs[0] Operand 2
     /* 280468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280481 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 280481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280493 */     GIR_RootConstrainSelectedInstOperands,
     /* 280494 */     // GIR_Coverage, 5670,
     /* 280494 */     GIR_EraseRootFromParent_Done,
     /* 280495 */   // Label 5458: @280495
     /* 280495 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(280572), // Rule ID 5671 //
     /* 280500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280545 */     // MIs[3] Operand 1
     /* 280545 */     // No operand predicates
     /* 280545 */     // MIs[0] Operand 2
     /* 280545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280558 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280570 */     GIR_RootConstrainSelectedInstOperands,
     /* 280571 */     // GIR_Coverage, 5671,
     /* 280571 */     GIR_EraseRootFromParent_Done,
     /* 280572 */   // Label 5459: @280572
     /* 280572 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(280674), // Rule ID 11275 //
     /* 280577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280616 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280620 */     // MIs[3] Operand 1
     /* 280620 */     // No operand predicates
     /* 280620 */     // MIs[0] Operand 2
     /* 280620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280633 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 280633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280645 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 280672 */     GIR_RootConstrainSelectedInstOperands,
     /* 280673 */     // GIR_Coverage, 11275,
     /* 280673 */     GIR_EraseRootFromParent_Done,
     /* 280674 */   // Label 5460: @280674
     /* 280674 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(280776), // Rule ID 11277 //
     /* 280679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 280690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280718 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280722 */     // MIs[3] Operand 1
     /* 280722 */     // No operand predicates
     /* 280722 */     // MIs[0] Operand 2
     /* 280722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280735 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 280735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 280738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280747 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 280774 */     GIR_RootConstrainSelectedInstOperands,
     /* 280775 */     // GIR_Coverage, 11277,
     /* 280775 */     GIR_EraseRootFromParent_Done,
     /* 280776 */   // Label 5461: @280776
     /* 280776 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(280841), // Rule ID 5665 //
     /* 280781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 280814 */     // MIs[2] Operand 1
     /* 280814 */     // No operand predicates
     /* 280814 */     // MIs[0] Operand 2
     /* 280814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280827 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 280827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 280830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280839 */     GIR_RootConstrainSelectedInstOperands,
     /* 280840 */     // GIR_Coverage, 5665,
     /* 280840 */     GIR_EraseRootFromParent_Done,
     /* 280841 */   // Label 5462: @280841
     /* 280841 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(280906), // Rule ID 5667 //
     /* 280846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280879 */     // MIs[2] Operand 1
     /* 280879 */     // No operand predicates
     /* 280879 */     // MIs[0] Operand 2
     /* 280879 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280892 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 280895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280904 */     GIR_RootConstrainSelectedInstOperands,
     /* 280905 */     // GIR_Coverage, 5667,
     /* 280905 */     GIR_EraseRootFromParent_Done,
     /* 280906 */   // Label 5463: @280906
     /* 280906 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(280941), // Rule ID 6534 //
     /* 280911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280915 */     // MIs[0] Operand 2
     /* 280915 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 280926 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 280926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 280939 */     GIR_RootConstrainSelectedInstOperands,
     /* 280940 */     // GIR_Coverage, 6534,
     /* 280940 */     GIR_EraseRootFromParent_Done,
     /* 280941 */   // Label 5464: @280941
     /* 280941 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(280976), // Rule ID 6535 //
     /* 280946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280950 */     // MIs[0] Operand 2
     /* 280950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 280961 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 280961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280966 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 280974 */     GIR_RootConstrainSelectedInstOperands,
     /* 280975 */     // GIR_Coverage, 6535,
     /* 280975 */     GIR_EraseRootFromParent_Done,
     /* 280976 */   // Label 5465: @280976
     /* 280976 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281011), // Rule ID 6536 //
     /* 280981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280985 */     // MIs[0] Operand 2
     /* 280985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 280996 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 280996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 281009 */     GIR_RootConstrainSelectedInstOperands,
     /* 281010 */     // GIR_Coverage, 6536,
     /* 281010 */     GIR_EraseRootFromParent_Done,
     /* 281011 */   // Label 5466: @281011
     /* 281011 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281046), // Rule ID 6537 //
     /* 281016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281020 */     // MIs[0] Operand 2
     /* 281020 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 281031 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 281031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 281034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281044 */     GIR_RootConstrainSelectedInstOperands,
     /* 281045 */     // GIR_Coverage, 6537,
     /* 281045 */     GIR_EraseRootFromParent_Done,
     /* 281046 */   // Label 5467: @281046
     /* 281046 */   GIM_Reject,
     /* 281047 */ // Label 5457: @281047
     /* 281047 */ GIM_Reject,
     /* 281048 */ // Label 5444: @281048
     /* 281048 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(281256),
     /* 281053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281060 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(281125), // Rule ID 10546 //
     /* 281065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281068 */     // MIs[0] Operand 2
     /* 281068 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 281079 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 281079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 281086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281091 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 281113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281123 */     GIR_RootConstrainSelectedInstOperands,
     /* 281124 */     // GIR_Coverage, 10546,
     /* 281124 */     GIR_EraseRootFromParent_Done,
     /* 281125 */   // Label 5469: @281125
     /* 281125 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281190), // Rule ID 10547 //
     /* 281130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281133 */     // MIs[0] Operand 2
     /* 281133 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281144 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 281144 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281147 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 281151 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281156 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 281178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281188 */     GIR_RootConstrainSelectedInstOperands,
     /* 281189 */     // GIR_Coverage, 10547,
     /* 281189 */     GIR_EraseRootFromParent_Done,
     /* 281190 */   // Label 5470: @281190
     /* 281190 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281255), // Rule ID 10548 //
     /* 281195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281198 */     // MIs[0] Operand 2
     /* 281198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281209 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 281209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 281216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281221 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 281243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281253 */     GIR_RootConstrainSelectedInstOperands,
     /* 281254 */     // GIR_Coverage, 10548,
     /* 281254 */     GIR_EraseRootFromParent_Done,
     /* 281255 */   // Label 5471: @281255
     /* 281255 */   GIM_Reject,
     /* 281256 */ // Label 5468: @281256
     /* 281256 */ GIM_Reject,
     /* 281257 */ // Label 5445: @281257
     /* 281257 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(281400),
     /* 281262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281269 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(281334), // Rule ID 10549 //
     /* 281274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281277 */     // MIs[0] Operand 2
     /* 281277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281288 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 281288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 281295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281300 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 281322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281332 */     GIR_RootConstrainSelectedInstOperands,
     /* 281333 */     // GIR_Coverage, 10549,
     /* 281333 */     GIR_EraseRootFromParent_Done,
     /* 281334 */   // Label 5473: @281334
     /* 281334 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(281399), // Rule ID 10550 //
     /* 281339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281342 */     // MIs[0] Operand 2
     /* 281342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281353 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 281353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 281360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281365 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 281387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281397 */     GIR_RootConstrainSelectedInstOperands,
     /* 281398 */     // GIR_Coverage, 10550,
     /* 281398 */     GIR_EraseRootFromParent_Done,
     /* 281399 */   // Label 5474: @281399
     /* 281399 */   GIM_Reject,
     /* 281400 */ // Label 5472: @281400
     /* 281400 */ GIM_Reject,
     /* 281401 */ // Label 5446: @281401
     /* 281401 */ GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(281473), // Rule ID 10551 //
     /* 281406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281416 */   // MIs[0] Operand 2
     /* 281416 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281427 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 281427 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 281430 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 281434 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281439 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 281447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 281461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281469 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 281471 */   GIR_RootConstrainSelectedInstOperands,
     /* 281472 */   // GIR_Coverage, 10551,
     /* 281472 */   GIR_EraseRootFromParent_Done,
     /* 281473 */ // Label 5475: @281473
     /* 281473 */ GIM_Reject,
     /* 281474 */ // Label 5447: @281474
     /* 281474 */ GIM_Reject,
     /* 281475 */ // Label 45: @281475
     /* 281475 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5480*/ GIMT_Encode4(284253),
     /* 281486 */ /*GILLT_s32*//*Label 5476*/ GIMT_Encode4(281522), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281502 */ /*GILLT_v2s64*//*Label 5477*/ GIMT_Encode4(283323), GIMT_Encode4(0),
     /* 281510 */ /*GILLT_v4s32*//*Label 5478*/ GIMT_Encode4(283633), GIMT_Encode4(0),
     /* 281518 */ /*GILLT_v8s16*//*Label 5479*/ GIMT_Encode4(283943),
     /* 281522 */ // Label 5476: @281522
     /* 281522 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(281672), // Rule ID 13206 //
     /* 281527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281534 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281542 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281545 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281554 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281561 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281561 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 281564 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 281568 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281573 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281579 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281582 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281586 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281593 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281596 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281600 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281605 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281608 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281611 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 281614 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281619 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281624 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281641 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281671 */   // GIR_Coverage, 13206,
     /* 281671 */   GIR_EraseRootFromParent_Done,
     /* 281672 */ // Label 5481: @281672
     /* 281672 */ GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(281822), // Rule ID 13208 //
     /* 281677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281692 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281695 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281711 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281711 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 281714 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 281718 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281723 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281729 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281732 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281736 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281743 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281746 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281750 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281755 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281758 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281761 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 281764 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281769 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281774 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281791 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281821 */   // GIR_Coverage, 13208,
     /* 281821 */   GIR_EraseRootFromParent_Done,
     /* 281822 */ // Label 5482: @281822
     /* 281822 */ GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(281972), // Rule ID 13210 //
     /* 281827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281834 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281842 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281845 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 281850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281861 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 281861 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 281864 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 281868 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281873 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281879 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 281882 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281886 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281893 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281896 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281900 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281905 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281908 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 281911 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 281914 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281919 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281924 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281941 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281971 */   // GIR_Coverage, 13210,
     /* 281971 */   GIR_EraseRootFromParent_Done,
     /* 281972 */ // Label 5483: @281972
     /* 281972 */ GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282122), // Rule ID 13212 //
     /* 281977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281984 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281992 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281995 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 282000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282004 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282011 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282011 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282014 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 282018 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282023 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282029 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282032 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282036 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282043 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282046 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282050 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282055 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282058 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282061 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282064 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282069 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282074 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282091 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282121 */   // GIR_Coverage, 13212,
     /* 282121 */   GIR_EraseRootFromParent_Done,
     /* 282122 */ // Label 5484: @282122
     /* 282122 */ GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282272), // Rule ID 13239 //
     /* 282127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282134 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282138 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282142 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282145 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282154 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282161 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282161 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282164 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 282168 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282173 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282179 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282182 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282186 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282193 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282196 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282200 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282205 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282208 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282211 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282214 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282219 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282224 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282241 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282271 */   // GIR_Coverage, 13239,
     /* 282271 */   GIR_EraseRootFromParent_Done,
     /* 282272 */ // Label 5485: @282272
     /* 282272 */ GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282422), // Rule ID 13241 //
     /* 282277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282284 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282292 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282295 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282304 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282311 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282311 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282314 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 282318 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282323 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282329 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282332 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282336 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282355 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282358 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282361 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282364 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282369 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282374 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282391 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282398 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282403 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282421 */   // GIR_Coverage, 13241,
     /* 282421 */   GIR_EraseRootFromParent_Done,
     /* 282422 */ // Label 5486: @282422
     /* 282422 */ GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(282572), // Rule ID 13243 //
     /* 282427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282434 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282442 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282445 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282461 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282461 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282464 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 282468 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282473 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282479 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282482 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282486 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282493 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282496 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282500 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282505 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282508 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282511 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282514 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282519 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282524 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282541 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282571 */   // GIR_Coverage, 13243,
     /* 282571 */   GIR_EraseRootFromParent_Done,
     /* 282572 */ // Label 5487: @282572
     /* 282572 */ GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(282722), // Rule ID 13245 //
     /* 282577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282584 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282592 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282595 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 282600 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282604 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282611 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282611 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 282614 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 282618 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282623 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282629 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282632 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282636 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282655 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282658 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282661 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 282664 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282669 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282674 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282691 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282721 */   // GIR_Coverage, 13245,
     /* 282721 */   GIR_EraseRootFromParent_Done,
     /* 282722 */ // Label 5488: @282722
     /* 282722 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(282872), // Rule ID 13249 //
     /* 282727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282734 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282742 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282745 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 282750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282761 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282761 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282764 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 282768 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282773 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282779 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282782 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282786 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282793 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282796 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282800 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282805 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282808 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282811 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282814 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282819 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282824 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282841 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282853 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282871 */   // GIR_Coverage, 13249,
     /* 282871 */   GIR_EraseRootFromParent_Done,
     /* 282872 */ // Label 5489: @282872
     /* 282872 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(283022), // Rule ID 13251 //
     /* 282877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282884 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282892 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282895 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 282900 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282904 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282911 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282911 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282914 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 282918 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282923 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282929 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282932 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282936 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282955 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282958 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282961 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282964 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282969 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282974 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282991 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283021 */   // GIR_Coverage, 13251,
     /* 283021 */   GIR_EraseRootFromParent_Done,
     /* 283022 */ // Label 5490: @283022
     /* 283022 */ GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(283172), // Rule ID 13253 //
     /* 283027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283034 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283042 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283045 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 283050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283054 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283061 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283061 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283064 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 283068 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283073 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283079 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283082 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283086 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283093 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283096 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283100 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283105 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283108 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283111 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283114 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283119 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283124 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283141 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283171 */   // GIR_Coverage, 13253,
     /* 283171 */   GIR_EraseRootFromParent_Done,
     /* 283172 */ // Label 5491: @283172
     /* 283172 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(283322), // Rule ID 13255 //
     /* 283177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283184 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283192 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283195 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 283200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283211 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283211 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283214 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 283218 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283223 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283229 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283232 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283236 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283243 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283246 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283250 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283255 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283258 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283261 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283264 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283269 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283274 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283291 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283321 */   // GIR_Coverage, 13255,
     /* 283321 */   GIR_EraseRootFromParent_Done,
     /* 283322 */ // Label 5492: @283322
     /* 283322 */ GIM_Reject,
     /* 283323 */ // Label 5477: @283323
     /* 283323 */ GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(283632),
     /* 283328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283335 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(283400), // Rule ID 702 //
     /* 283340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283351 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283354 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283383 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 283383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 283386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283398 */     GIR_RootConstrainSelectedInstOperands,
     /* 283399 */     // GIR_Coverage, 702,
     /* 283399 */     GIR_EraseRootFromParent_Done,
     /* 283400 */   // Label 5494: @283400
     /* 283400 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283465), // Rule ID 1711 //
     /* 283405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283416 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283419 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283448 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 283448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 283451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283463 */     GIR_RootConstrainSelectedInstOperands,
     /* 283464 */     // GIR_Coverage, 1711,
     /* 283464 */     GIR_EraseRootFromParent_Done,
     /* 283465 */   // Label 5495: @283465
     /* 283465 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283524), // Rule ID 700 //
     /* 283470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283481 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283484 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283509 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 283509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 283512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283522 */     GIR_RootConstrainSelectedInstOperands,
     /* 283523 */     // GIR_Coverage, 700,
     /* 283523 */     GIR_EraseRootFromParent_Done,
     /* 283524 */   // Label 5496: @283524
     /* 283524 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283583), // Rule ID 1709 //
     /* 283529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283540 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283543 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 283556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283568 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 283568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 283571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283581 */     GIR_RootConstrainSelectedInstOperands,
     /* 283582 */     // GIR_Coverage, 1709,
     /* 283582 */     GIR_EraseRootFromParent_Done,
     /* 283583 */   // Label 5497: @283583
     /* 283583 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283610), // Rule ID 6402 //
     /* 283588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283595 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 283595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 283598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283608 */     GIR_RootConstrainSelectedInstOperands,
     /* 283609 */     // GIR_Coverage, 6402,
     /* 283609 */     GIR_EraseRootFromParent_Done,
     /* 283610 */   // Label 5498: @283610
     /* 283610 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(283631), // Rule ID 6393 //
     /* 283615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283619 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 283619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 283622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283629 */     GIR_RootConstrainSelectedInstOperands,
     /* 283630 */     // GIR_Coverage, 6393,
     /* 283630 */     GIR_EraseRootFromParent_Done,
     /* 283631 */   // Label 5499: @283631
     /* 283631 */   GIM_Reject,
     /* 283632 */ // Label 5493: @283632
     /* 283632 */ GIM_Reject,
     /* 283633 */ // Label 5478: @283633
     /* 283633 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(283942),
     /* 283638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283645 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(283710), // Rule ID 698 //
     /* 283650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283661 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283664 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283673 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283693 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 283693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 283696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283708 */     GIR_RootConstrainSelectedInstOperands,
     /* 283709 */     // GIR_Coverage, 698,
     /* 283709 */     GIR_EraseRootFromParent_Done,
     /* 283710 */   // Label 5501: @283710
     /* 283710 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(283775), // Rule ID 1707 //
     /* 283715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283726 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283729 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283738 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283758 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 283758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 283761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 283773 */     GIR_RootConstrainSelectedInstOperands,
     /* 283774 */     // GIR_Coverage, 1707,
     /* 283774 */     GIR_EraseRootFromParent_Done,
     /* 283775 */   // Label 5502: @283775
     /* 283775 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(283834), // Rule ID 696 //
     /* 283780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283791 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283794 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283803 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283819 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 283819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 283822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283832 */     GIR_RootConstrainSelectedInstOperands,
     /* 283833 */     // GIR_Coverage, 696,
     /* 283833 */     GIR_EraseRootFromParent_Done,
     /* 283834 */   // Label 5503: @283834
     /* 283834 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(283893), // Rule ID 1705 //
     /* 283839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283850 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283853 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 283858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 283866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283878 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 283878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 283881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 283891 */     GIR_RootConstrainSelectedInstOperands,
     /* 283892 */     // GIR_Coverage, 1705,
     /* 283892 */     GIR_EraseRootFromParent_Done,
     /* 283893 */   // Label 5504: @283893
     /* 283893 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(283920), // Rule ID 6399 //
     /* 283898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283905 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 283905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 283908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283918 */     GIR_RootConstrainSelectedInstOperands,
     /* 283919 */     // GIR_Coverage, 6399,
     /* 283919 */     GIR_EraseRootFromParent_Done,
     /* 283920 */   // Label 5505: @283920
     /* 283920 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(283941), // Rule ID 6390 //
     /* 283925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283929 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 283929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 283932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283939 */     GIR_RootConstrainSelectedInstOperands,
     /* 283940 */     // GIR_Coverage, 6390,
     /* 283940 */     GIR_EraseRootFromParent_Done,
     /* 283941 */   // Label 5506: @283941
     /* 283941 */   GIM_Reject,
     /* 283942 */ // Label 5500: @283942
     /* 283942 */ GIM_Reject,
     /* 283943 */ // Label 5479: @283943
     /* 283943 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284252),
     /* 283948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283955 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284020), // Rule ID 694 //
     /* 283960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283971 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 283974 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 283979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 283987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 284003 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 284003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 284006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284018 */     GIR_RootConstrainSelectedInstOperands,
     /* 284019 */     // GIR_Coverage, 694,
     /* 284019 */     GIR_EraseRootFromParent_Done,
     /* 284020 */   // Label 5508: @284020
     /* 284020 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284085), // Rule ID 1703 //
     /* 284025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284036 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284039 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284048 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 284052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 284061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 284068 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 284068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 284071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284083 */     GIR_RootConstrainSelectedInstOperands,
     /* 284084 */     // GIR_Coverage, 1703,
     /* 284084 */     GIR_EraseRootFromParent_Done,
     /* 284085 */   // Label 5509: @284085
     /* 284085 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284144), // Rule ID 692 //
     /* 284090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284101 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284104 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284113 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 284117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284129 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 284129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 284132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284142 */     GIR_RootConstrainSelectedInstOperands,
     /* 284143 */     // GIR_Coverage, 692,
     /* 284143 */     GIR_EraseRootFromParent_Done,
     /* 284144 */   // Label 5510: @284144
     /* 284144 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(284203), // Rule ID 1701 //
     /* 284149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284160 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284163 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284172 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 284176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284188 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 284188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 284191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284201 */     GIR_RootConstrainSelectedInstOperands,
     /* 284202 */     // GIR_Coverage, 1701,
     /* 284202 */     GIR_EraseRootFromParent_Done,
     /* 284203 */   // Label 5511: @284203
     /* 284203 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(284230), // Rule ID 6396 //
     /* 284208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 284215 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 284215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 284218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284228 */     GIR_RootConstrainSelectedInstOperands,
     /* 284229 */     // GIR_Coverage, 6396,
     /* 284229 */     GIR_EraseRootFromParent_Done,
     /* 284230 */   // Label 5512: @284230
     /* 284230 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(284251), // Rule ID 6387 //
     /* 284235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284239 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 284239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 284242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284249 */     GIR_RootConstrainSelectedInstOperands,
     /* 284250 */     // GIR_Coverage, 6387,
     /* 284250 */     GIR_EraseRootFromParent_Done,
     /* 284251 */   // Label 5513: @284251
     /* 284251 */   GIM_Reject,
     /* 284252 */ // Label 5507: @284252
     /* 284252 */ GIM_Reject,
     /* 284253 */ // Label 5480: @284253
     /* 284253 */ GIM_Reject,
     /* 284254 */ // Label 46: @284254
     /* 284254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5519*/ GIMT_Encode4(285078),
     /* 284265 */ /*GILLT_s32*//*Label 5514*/ GIMT_Encode4(284301),
     /* 284269 */ /*GILLT_s64*//*Label 5515*/ GIMT_Encode4(284478), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284281 */ /*GILLT_v2s64*//*Label 5516*/ GIMT_Encode4(284651), GIMT_Encode4(0),
     /* 284289 */ /*GILLT_v4s32*//*Label 5517*/ GIMT_Encode4(284796), GIMT_Encode4(0),
     /* 284297 */ /*GILLT_v8s16*//*Label 5518*/ GIMT_Encode4(284937),
     /* 284301 */ // Label 5514: @284301
     /* 284301 */ GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(284477),
     /* 284306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284320 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(284357), // Rule ID 3932 //
     /* 284325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284344 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284355 */     GIR_RootConstrainSelectedInstOperands,
     /* 284356 */     // GIR_Coverage, 3932,
     /* 284356 */     GIR_EraseRootFromParent_Done,
     /* 284357 */   // Label 5521: @284357
     /* 284357 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(284394), // Rule ID 3933 //
     /* 284362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284381 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284392 */     GIR_RootConstrainSelectedInstOperands,
     /* 284393 */     // GIR_Coverage, 3933,
     /* 284393 */     GIR_EraseRootFromParent_Done,
     /* 284394 */   // Label 5522: @284394
     /* 284394 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(284431), // Rule ID 3931 //
     /* 284399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284418 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 284418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284429 */     GIR_RootConstrainSelectedInstOperands,
     /* 284430 */     // GIR_Coverage, 3931,
     /* 284430 */     GIR_EraseRootFromParent_Done,
     /* 284431 */   // Label 5523: @284431
     /* 284431 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(284476), // Rule ID 3930 //
     /* 284436 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 284436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 284454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 284467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284474 */     GIR_RootConstrainSelectedInstOperands,
     /* 284475 */     // GIR_Coverage, 3930,
     /* 284475 */     GIR_EraseRootFromParent_Done,
     /* 284476 */   // Label 5524: @284476
     /* 284476 */   GIM_Reject,
     /* 284477 */ // Label 5520: @284477
     /* 284477 */ GIM_Reject,
     /* 284478 */ // Label 5515: @284478
     /* 284478 */ GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(284650),
     /* 284483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284497 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(284565), // Rule ID 3934 //
     /* 284502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284521 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 284521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 284528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 284543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 284548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284563 */     GIR_RootConstrainSelectedInstOperands,
     /* 284564 */     // GIR_Coverage, 3934,
     /* 284564 */     GIR_EraseRootFromParent_Done,
     /* 284565 */   // Label 5526: @284565
     /* 284565 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(284633), // Rule ID 3935 //
     /* 284570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284589 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 284589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 284596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 284611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 284616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284631 */     GIR_RootConstrainSelectedInstOperands,
     /* 284632 */     // GIR_Coverage, 3935,
     /* 284632 */     GIR_EraseRootFromParent_Done,
     /* 284633 */   // Label 5527: @284633
     /* 284633 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(284649), // Rule ID 120 //
     /* 284638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284642 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 284642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 284647 */     GIR_RootConstrainSelectedInstOperands,
     /* 284648 */     // GIR_Coverage, 120,
     /* 284648 */     GIR_Done,
     /* 284649 */   // Label 5528: @284649
     /* 284649 */   GIM_Reject,
     /* 284650 */ // Label 5525: @284650
     /* 284650 */ GIM_Reject,
     /* 284651 */ // Label 5516: @284651
     /* 284651 */ GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(284795),
     /* 284656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284666 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(284730), // Rule ID 6385 //
     /* 284671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 284700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284708 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 284712 */     // MIs[3] Operand 1
     /* 284712 */     // No operand predicates
     /* 284712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284714 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 284714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 284717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284723 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 284728 */     GIR_RootConstrainSelectedInstOperands,
     /* 284729 */     // GIR_Coverage, 6385,
     /* 284729 */     GIR_EraseRootFromParent_Done,
     /* 284730 */   // Label 5530: @284730
     /* 284730 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(284794), // Rule ID 6382 //
     /* 284735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 284764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284772 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 284776 */     // MIs[3] Operand 1
     /* 284776 */     // No operand predicates
     /* 284776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284778 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 284778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 284781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284787 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 284792 */     GIR_RootConstrainSelectedInstOperands,
     /* 284793 */     // GIR_Coverage, 6382,
     /* 284793 */     GIR_EraseRootFromParent_Done,
     /* 284794 */   // Label 5531: @284794
     /* 284794 */   GIM_Reject,
     /* 284795 */ // Label 5529: @284795
     /* 284795 */ GIM_Reject,
     /* 284796 */ // Label 5517: @284796
     /* 284796 */ GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(284936),
     /* 284801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284811 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(284873), // Rule ID 6384 //
     /* 284816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 284857 */     // MIs[3] Operand 1
     /* 284857 */     // No operand predicates
     /* 284857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284859 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 284859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 284862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284871 */     GIR_RootConstrainSelectedInstOperands,
     /* 284872 */     // GIR_Coverage, 6384,
     /* 284872 */     GIR_EraseRootFromParent_Done,
     /* 284873 */   // Label 5533: @284873
     /* 284873 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(284935), // Rule ID 6381 //
     /* 284878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 284886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284915 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 284919 */     // MIs[3] Operand 1
     /* 284919 */     // No operand predicates
     /* 284919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284921 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 284921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 284924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 284933 */     GIR_RootConstrainSelectedInstOperands,
     /* 284934 */     // GIR_Coverage, 6381,
     /* 284934 */     GIR_EraseRootFromParent_Done,
     /* 284935 */   // Label 5534: @284935
     /* 284935 */   GIM_Reject,
     /* 284936 */ // Label 5532: @284936
     /* 284936 */ GIM_Reject,
     /* 284937 */ // Label 5518: @284937
     /* 284937 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(285077),
     /* 284942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284952 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(285014), // Rule ID 6383 //
     /* 284957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 284965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 284982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 284990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 284998 */     // MIs[3] Operand 1
     /* 284998 */     // No operand predicates
     /* 284998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285000 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 285000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 285003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 285012 */     GIR_RootConstrainSelectedInstOperands,
     /* 285013 */     // GIR_Coverage, 6383,
     /* 285013 */     GIR_EraseRootFromParent_Done,
     /* 285014 */   // Label 5536: @285014
     /* 285014 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285076), // Rule ID 6380 //
     /* 285019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 285044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285056 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 285060 */     // MIs[3] Operand 1
     /* 285060 */     // No operand predicates
     /* 285060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285062 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 285062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 285065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 285074 */     GIR_RootConstrainSelectedInstOperands,
     /* 285075 */     // GIR_Coverage, 6380,
     /* 285075 */     GIR_EraseRootFromParent_Done,
     /* 285076 */   // Label 5537: @285076
     /* 285076 */   GIM_Reject,
     /* 285077 */ // Label 5535: @285077
     /* 285077 */ GIM_Reject,
     /* 285078 */ // Label 5519: @285078
     /* 285078 */ GIM_Reject,
     /* 285079 */ // Label 47: @285079
     /* 285079 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5540*/ GIMT_Encode4(285516),
     /* 285090 */ /*GILLT_s32*//*Label 5538*/ GIMT_Encode4(285098),
     /* 285094 */ /*GILLT_s64*//*Label 5539*/ GIMT_Encode4(285309),
     /* 285098 */ // Label 5538: @285098
     /* 285098 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(285308),
     /* 285103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285117 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(285151), // Rule ID 4021 //
     /* 285122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 285134 */     // MIs[1] Operand 1
     /* 285134 */     // No operand predicates
     /* 285134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285136 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 285136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 285139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 285149 */     GIR_RootConstrainSelectedInstOperands,
     /* 285150 */     // GIR_Coverage, 4021,
     /* 285150 */     GIR_EraseRootFromParent_Done,
     /* 285151 */   // Label 5542: @285151
     /* 285151 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(285188), // Rule ID 3938 //
     /* 285156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285175 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285186 */     GIR_RootConstrainSelectedInstOperands,
     /* 285187 */     // GIR_Coverage, 3938,
     /* 285187 */     GIR_EraseRootFromParent_Done,
     /* 285188 */   // Label 5543: @285188
     /* 285188 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(285225), // Rule ID 3939 //
     /* 285193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285212 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285223 */     GIR_RootConstrainSelectedInstOperands,
     /* 285224 */     // GIR_Coverage, 3939,
     /* 285224 */     GIR_EraseRootFromParent_Done,
     /* 285225 */   // Label 5544: @285225
     /* 285225 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(285262), // Rule ID 3937 //
     /* 285230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285249 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285260 */     GIR_RootConstrainSelectedInstOperands,
     /* 285261 */     // GIR_Coverage, 3937,
     /* 285261 */     GIR_EraseRootFromParent_Done,
     /* 285262 */   // Label 5545: @285262
     /* 285262 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(285307), // Rule ID 3936 //
     /* 285267 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 285298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285305 */     GIR_RootConstrainSelectedInstOperands,
     /* 285306 */     // GIR_Coverage, 3936,
     /* 285306 */     GIR_EraseRootFromParent_Done,
     /* 285307 */   // Label 5546: @285307
     /* 285307 */   GIM_Reject,
     /* 285308 */ // Label 5541: @285308
     /* 285308 */ GIM_Reject,
     /* 285309 */ // Label 5539: @285309
     /* 285309 */ GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(285515),
     /* 285314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285328 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(285362), // Rule ID 4022 //
     /* 285333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 285345 */     // MIs[1] Operand 1
     /* 285345 */     // No operand predicates
     /* 285345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285347 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 285347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 285350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 285360 */     GIR_RootConstrainSelectedInstOperands,
     /* 285361 */     // GIR_Coverage, 4022,
     /* 285361 */     GIR_EraseRootFromParent_Done,
     /* 285362 */   // Label 5548: @285362
     /* 285362 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(285430), // Rule ID 3940 //
     /* 285367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285386 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285428 */     GIR_RootConstrainSelectedInstOperands,
     /* 285429 */     // GIR_Coverage, 3940,
     /* 285429 */     GIR_EraseRootFromParent_Done,
     /* 285430 */   // Label 5549: @285430
     /* 285430 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(285498), // Rule ID 3941 //
     /* 285435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285454 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285496 */     GIR_RootConstrainSelectedInstOperands,
     /* 285497 */     // GIR_Coverage, 3941,
     /* 285497 */     GIR_EraseRootFromParent_Done,
     /* 285498 */   // Label 5550: @285498
     /* 285498 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(285514), // Rule ID 121 //
     /* 285503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285507 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 285507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 285512 */     GIR_RootConstrainSelectedInstOperands,
     /* 285513 */     // GIR_Coverage, 121,
     /* 285513 */     GIR_Done,
     /* 285514 */   // Label 5551: @285514
     /* 285514 */   GIM_Reject,
     /* 285515 */ // Label 5547: @285515
     /* 285515 */ GIM_Reject,
     /* 285516 */ // Label 5540: @285516
     /* 285516 */ GIM_Reject,
     /* 285517 */ // Label 48: @285517
     /* 285517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5554*/ GIMT_Encode4(286341),
     /* 285528 */ /*GILLT_s32*//*Label 5552*/ GIMT_Encode4(285536),
     /* 285532 */ /*GILLT_s64*//*Label 5553*/ GIMT_Encode4(285891),
     /* 285536 */ // Label 5552: @285536
     /* 285536 */ GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(285890),
     /* 285541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285551 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(285615), // Rule ID 6547 //
     /* 285556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285573 */     // MIs[1] Operand 2
     /* 285573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 285584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 285596 */     // MIs[2] Operand 1
     /* 285596 */     // No operand predicates
     /* 285596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285598 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 285598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 285613 */     GIR_RootConstrainSelectedInstOperands,
     /* 285614 */     // GIR_Coverage, 6547,
     /* 285614 */     GIR_EraseRootFromParent_Done,
     /* 285615 */   // Label 5556: @285615
     /* 285615 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(285679), // Rule ID 6549 //
     /* 285620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285637 */     // MIs[1] Operand 2
     /* 285637 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 285648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 285660 */     // MIs[2] Operand 1
     /* 285660 */     // No operand predicates
     /* 285660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285662 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 285662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 285677 */     GIR_RootConstrainSelectedInstOperands,
     /* 285678 */     // GIR_Coverage, 6549,
     /* 285678 */     GIR_EraseRootFromParent_Done,
     /* 285679 */   // Label 5557: @285679
     /* 285679 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(285717), // Rule ID 4019 //
     /* 285684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 285700 */     // MIs[1] Operand 1
     /* 285700 */     // No operand predicates
     /* 285700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285702 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 285702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 285705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 285712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 285715 */     GIR_RootConstrainSelectedInstOperands,
     /* 285716 */     // GIR_Coverage, 4019,
     /* 285716 */     GIR_EraseRootFromParent_Done,
     /* 285717 */   // Label 5558: @285717
     /* 285717 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(285758), // Rule ID 2435 //
     /* 285722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285745 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285756 */     GIR_RootConstrainSelectedInstOperands,
     /* 285757 */     // GIR_Coverage, 2435,
     /* 285757 */     GIR_EraseRootFromParent_Done,
     /* 285758 */   // Label 5559: @285758
     /* 285758 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(285799), // Rule ID 2436 //
     /* 285763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285786 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285797 */     GIR_RootConstrainSelectedInstOperands,
     /* 285798 */     // GIR_Coverage, 2436,
     /* 285798 */     GIR_EraseRootFromParent_Done,
     /* 285799 */   // Label 5560: @285799
     /* 285799 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(285840), // Rule ID 2434 //
     /* 285804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285827 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285838 */     GIR_RootConstrainSelectedInstOperands,
     /* 285839 */     // GIR_Coverage, 2434,
     /* 285839 */     GIR_EraseRootFromParent_Done,
     /* 285840 */   // Label 5561: @285840
     /* 285840 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(285889), // Rule ID 2433 //
     /* 285845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285849 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 285880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285887 */     GIR_RootConstrainSelectedInstOperands,
     /* 285888 */     // GIR_Coverage, 2433,
     /* 285888 */     GIR_EraseRootFromParent_Done,
     /* 285889 */   // Label 5562: @285889
     /* 285889 */   GIM_Reject,
     /* 285890 */ // Label 5555: @285890
     /* 285890 */ GIM_Reject,
     /* 285891 */ // Label 5553: @285891
     /* 285891 */ GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(286340),
     /* 285896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285906 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(285970), // Rule ID 6548 //
     /* 285911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285928 */     // MIs[1] Operand 2
     /* 285928 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 285939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285947 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 285951 */     // MIs[2] Operand 1
     /* 285951 */     // No operand predicates
     /* 285951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285953 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 285953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 285956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 285965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 285968 */     GIR_RootConstrainSelectedInstOperands,
     /* 285969 */     // GIR_Coverage, 6548,
     /* 285969 */     GIR_EraseRootFromParent_Done,
     /* 285970 */   // Label 5564: @285970
     /* 285970 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(286034), // Rule ID 6550 //
     /* 285975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 285983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285992 */     // MIs[1] Operand 2
     /* 285992 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 286003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286011 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 286015 */     // MIs[2] Operand 1
     /* 286015 */     // No operand predicates
     /* 286015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286017 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 286017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 286020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 286029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 286032 */     GIR_RootConstrainSelectedInstOperands,
     /* 286033 */     // GIR_Coverage, 6550,
     /* 286033 */     GIR_EraseRootFromParent_Done,
     /* 286034 */   // Label 5565: @286034
     /* 286034 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(286137), // Rule ID 6551 //
     /* 286039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286068 */     // MIs[2] Operand 1
     /* 286068 */     // No operand predicates
     /* 286068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286070 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 286070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 286073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 286084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286096 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 286099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286103 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 286124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 286132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 286135 */     GIR_RootConstrainSelectedInstOperands,
     /* 286136 */     // GIR_Coverage, 6551,
     /* 286136 */     GIR_EraseRootFromParent_Done,
     /* 286137 */   // Label 5566: @286137
     /* 286137 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(286175), // Rule ID 4020 //
     /* 286142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286158 */     // MIs[1] Operand 1
     /* 286158 */     // No operand predicates
     /* 286158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286160 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 286160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 286163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 286173 */     GIR_RootConstrainSelectedInstOperands,
     /* 286174 */     // GIR_Coverage, 4020,
     /* 286174 */     GIR_EraseRootFromParent_Done,
     /* 286175 */   // Label 5567: @286175
     /* 286175 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(286247), // Rule ID 2437 //
     /* 286180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286203 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286245 */     GIR_RootConstrainSelectedInstOperands,
     /* 286246 */     // GIR_Coverage, 2437,
     /* 286246 */     GIR_EraseRootFromParent_Done,
     /* 286247 */   // Label 5568: @286247
     /* 286247 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(286319), // Rule ID 2438 //
     /* 286252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286275 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286317 */     GIR_RootConstrainSelectedInstOperands,
     /* 286318 */     // GIR_Coverage, 2438,
     /* 286318 */     GIR_EraseRootFromParent_Done,
     /* 286319 */   // Label 5569: @286319
     /* 286319 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(286339), // Rule ID 119 //
     /* 286324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286332 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 286337 */     GIR_RootConstrainSelectedInstOperands,
     /* 286338 */     // GIR_Coverage, 119,
     /* 286338 */     GIR_Done,
     /* 286339 */   // Label 5570: @286339
     /* 286339 */   GIM_Reject,
     /* 286340 */ // Label 5563: @286340
     /* 286340 */ GIM_Reject,
     /* 286341 */ // Label 5554: @286341
     /* 286341 */ GIM_Reject,
     /* 286342 */ // Label 49: @286342
     /* 286342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5573*/ GIMT_Encode4(286471),
     /* 286353 */ /*GILLT_s32*//*Label 5571*/ GIMT_Encode4(286361),
     /* 286357 */ /*GILLT_s64*//*Label 5572*/ GIMT_Encode4(286416),
     /* 286361 */ // Label 5571: @286361
     /* 286361 */ GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(286415), // Rule ID 188 //
     /* 286366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286372 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 286391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286395 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286399 */   // MIs[1] Operand 1
     /* 286399 */   // No operand predicates
     /* 286399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286401 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 286401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 286404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286406 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286408 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286410 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286413 */   GIR_RootConstrainSelectedInstOperands,
     /* 286414 */   // GIR_Coverage, 188,
     /* 286414 */   GIR_EraseRootFromParent_Done,
     /* 286415 */ // Label 5574: @286415
     /* 286415 */ GIM_Reject,
     /* 286416 */ // Label 5572: @286416
     /* 286416 */ GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(286470), // Rule ID 189 //
     /* 286421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 286446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286450 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286454 */   // MIs[1] Operand 1
     /* 286454 */   // No operand predicates
     /* 286454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286456 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 286456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 286459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286461 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286463 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286465 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286468 */   GIR_RootConstrainSelectedInstOperands,
     /* 286469 */   // GIR_Coverage, 189,
     /* 286469 */   GIR_EraseRootFromParent_Done,
     /* 286470 */ // Label 5575: @286470
     /* 286470 */ GIM_Reject,
     /* 286471 */ // Label 5573: @286471
     /* 286471 */ GIM_Reject,
     /* 286472 */ // Label 50: @286472
     /* 286472 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5578*/ GIMT_Encode4(287013),
     /* 286483 */ /*GILLT_s32*//*Label 5576*/ GIMT_Encode4(286491),
     /* 286487 */ /*GILLT_s64*//*Label 5577*/ GIMT_Encode4(286756),
     /* 286491 */ // Label 5576: @286491
     /* 286491 */ GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(286755),
     /* 286496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286506 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(286545), // Rule ID 184 //
     /* 286511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286534 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286543 */     GIR_RootConstrainSelectedInstOperands,
     /* 286544 */     // GIR_Coverage, 184,
     /* 286544 */     GIR_EraseRootFromParent_Done,
     /* 286545 */   // Label 5580: @286545
     /* 286545 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(286582), // Rule ID 4015 //
     /* 286550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286566 */     // MIs[1] Operand 1
     /* 286566 */     // No operand predicates
     /* 286566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286568 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 286568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 286571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286580 */     GIR_RootConstrainSelectedInstOperands,
     /* 286581 */     // GIR_Coverage, 4015,
     /* 286581 */     GIR_EraseRootFromParent_Done,
     /* 286582 */   // Label 5581: @286582
     /* 286582 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(286623), // Rule ID 3944 //
     /* 286587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286610 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286621 */     GIR_RootConstrainSelectedInstOperands,
     /* 286622 */     // GIR_Coverage, 3944,
     /* 286622 */     GIR_EraseRootFromParent_Done,
     /* 286623 */   // Label 5582: @286623
     /* 286623 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(286664), // Rule ID 3945 //
     /* 286628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286651 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286662 */     GIR_RootConstrainSelectedInstOperands,
     /* 286663 */     // GIR_Coverage, 3945,
     /* 286663 */     GIR_EraseRootFromParent_Done,
     /* 286664 */   // Label 5583: @286664
     /* 286664 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(286705), // Rule ID 3943 //
     /* 286669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286692 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286703 */     GIR_RootConstrainSelectedInstOperands,
     /* 286704 */     // GIR_Coverage, 3943,
     /* 286704 */     GIR_EraseRootFromParent_Done,
     /* 286705 */   // Label 5584: @286705
     /* 286705 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(286754), // Rule ID 3942 //
     /* 286710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286714 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 286745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286752 */     GIR_RootConstrainSelectedInstOperands,
     /* 286753 */     // GIR_Coverage, 3942,
     /* 286753 */     GIR_EraseRootFromParent_Done,
     /* 286754 */   // Label 5585: @286754
     /* 286754 */   GIM_Reject,
     /* 286755 */ // Label 5579: @286755
     /* 286755 */ GIM_Reject,
     /* 286756 */ // Label 5577: @286756
     /* 286756 */ GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(287012),
     /* 286761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286771 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(286810), // Rule ID 187 //
     /* 286776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 286797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286799 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 286799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 286802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286808 */     GIR_RootConstrainSelectedInstOperands,
     /* 286809 */     // GIR_Coverage, 187,
     /* 286809 */     GIR_EraseRootFromParent_Done,
     /* 286810 */   // Label 5587: @286810
     /* 286810 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(286847), // Rule ID 4016 //
     /* 286815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286831 */     // MIs[1] Operand 1
     /* 286831 */     // No operand predicates
     /* 286831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286833 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 286833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 286836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286845 */     GIR_RootConstrainSelectedInstOperands,
     /* 286846 */     // GIR_Coverage, 4016,
     /* 286846 */     GIR_EraseRootFromParent_Done,
     /* 286847 */   // Label 5588: @286847
     /* 286847 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(286919), // Rule ID 3946 //
     /* 286852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286875 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 286910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286917 */     GIR_RootConstrainSelectedInstOperands,
     /* 286918 */     // GIR_Coverage, 3946,
     /* 286918 */     GIR_EraseRootFromParent_Done,
     /* 286919 */   // Label 5589: @286919
     /* 286919 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(286991), // Rule ID 3947 //
     /* 286924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286947 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 286982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286989 */     GIR_RootConstrainSelectedInstOperands,
     /* 286990 */     // GIR_Coverage, 3947,
     /* 286990 */     GIR_EraseRootFromParent_Done,
     /* 286991 */   // Label 5590: @286991
     /* 286991 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(287011), // Rule ID 122 //
     /* 286996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287004 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 287009 */     GIR_RootConstrainSelectedInstOperands,
     /* 287010 */     // GIR_Coverage, 122,
     /* 287010 */     GIR_Done,
     /* 287011 */   // Label 5591: @287011
     /* 287011 */   GIM_Reject,
     /* 287012 */ // Label 5586: @287012
     /* 287012 */ GIM_Reject,
     /* 287013 */ // Label 5578: @287013
     /* 287013 */ GIM_Reject,
     /* 287014 */ // Label 51: @287014
     /* 287014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5600*/ GIMT_Encode4(294790),
     /* 287025 */ /*GILLT_s64*//*Label 5592*/ GIMT_Encode4(287061), GIMT_Encode4(0),
     /* 287033 */ /*GILLT_v2s32*//*Label 5593*/ GIMT_Encode4(287454),
     /* 287037 */ /*GILLT_v2s64*//*Label 5594*/ GIMT_Encode4(288502),
     /* 287041 */ /*GILLT_v4s16*//*Label 5595*/ GIMT_Encode4(289550),
     /* 287045 */ /*GILLT_v4s32*//*Label 5596*/ GIMT_Encode4(290598),
     /* 287049 */ /*GILLT_v8s8*//*Label 5597*/ GIMT_Encode4(291646),
     /* 287053 */ /*GILLT_v8s16*//*Label 5598*/ GIMT_Encode4(292694),
     /* 287057 */ /*GILLT_v16s8*//*Label 5599*/ GIMT_Encode4(293742),
     /* 287061 */ // Label 5592: @287061
     /* 287061 */ GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(287453),
     /* 287066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287069 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287076 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(287112), // Rule ID 5254 //
     /* 287081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287084 */     // MIs[0] Operand 1
     /* 287084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287103 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 287106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287110 */     GIR_RootConstrainSelectedInstOperands,
     /* 287111 */     // GIR_Coverage, 5254,
     /* 287111 */     GIR_EraseRootFromParent_Done,
     /* 287112 */   // Label 5602: @287112
     /* 287112 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(287148), // Rule ID 5255 //
     /* 287117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287120 */     // MIs[0] Operand 1
     /* 287120 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287139 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 287142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287146 */     GIR_RootConstrainSelectedInstOperands,
     /* 287147 */     // GIR_Coverage, 5255,
     /* 287147 */     GIR_EraseRootFromParent_Done,
     /* 287148 */   // Label 5603: @287148
     /* 287148 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(287184), // Rule ID 2505 //
     /* 287153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287156 */     // MIs[0] Operand 1
     /* 287156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287165 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287171 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287175 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 287178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287182 */     GIR_RootConstrainSelectedInstOperands,
     /* 287183 */     // GIR_Coverage, 2505,
     /* 287183 */     GIR_EraseRootFromParent_Done,
     /* 287184 */   // Label 5604: @287184
     /* 287184 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(287220), // Rule ID 5251 //
     /* 287189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287192 */     // MIs[0] Operand 1
     /* 287192 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287201 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287207 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287211 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 287214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287218 */     GIR_RootConstrainSelectedInstOperands,
     /* 287219 */     // GIR_Coverage, 5251,
     /* 287219 */     GIR_EraseRootFromParent_Done,
     /* 287220 */   // Label 5605: @287220
     /* 287220 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(287256), // Rule ID 5252 //
     /* 287225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287228 */     // MIs[0] Operand 1
     /* 287228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287243 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 287245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287247 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 287250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287254 */     GIR_RootConstrainSelectedInstOperands,
     /* 287255 */     // GIR_Coverage, 5252,
     /* 287255 */     GIR_EraseRootFromParent_Done,
     /* 287256 */   // Label 5606: @287256
     /* 287256 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(287292), // Rule ID 5253 //
     /* 287261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287264 */     // MIs[0] Operand 1
     /* 287264 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287283 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 287283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 287286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287290 */     GIR_RootConstrainSelectedInstOperands,
     /* 287291 */     // GIR_Coverage, 5253,
     /* 287291 */     GIR_EraseRootFromParent_Done,
     /* 287292 */   // Label 5607: @287292
     /* 287292 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(287324), // Rule ID 1608 //
     /* 287297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287300 */     // MIs[0] Operand 1
     /* 287300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287313 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 287316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287322 */     GIR_RootConstrainSelectedInstOperands,
     /* 287323 */     // GIR_Coverage, 1608,
     /* 287323 */     GIR_EraseRootFromParent_Done,
     /* 287324 */   // Label 5608: @287324
     /* 287324 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(287356), // Rule ID 1609 //
     /* 287329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287332 */     // MIs[0] Operand 1
     /* 287332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287345 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 287348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287354 */     GIR_RootConstrainSelectedInstOperands,
     /* 287355 */     // GIR_Coverage, 1609,
     /* 287355 */     GIR_EraseRootFromParent_Done,
     /* 287356 */   // Label 5609: @287356
     /* 287356 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(287388), // Rule ID 1610 //
     /* 287361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287364 */     // MIs[0] Operand 1
     /* 287364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287377 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 287380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287386 */     GIR_RootConstrainSelectedInstOperands,
     /* 287387 */     // GIR_Coverage, 1610,
     /* 287387 */     GIR_EraseRootFromParent_Done,
     /* 287388 */   // Label 5610: @287388
     /* 287388 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(287420), // Rule ID 1611 //
     /* 287393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287396 */     // MIs[0] Operand 1
     /* 287396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 287401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287409 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 287412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287418 */     GIR_RootConstrainSelectedInstOperands,
     /* 287419 */     // GIR_Coverage, 1611,
     /* 287419 */     GIR_EraseRootFromParent_Done,
     /* 287420 */   // Label 5611: @287420
     /* 287420 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(287452), // Rule ID 1612 //
     /* 287425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287428 */     // MIs[0] Operand 1
     /* 287428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 287433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287441 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 287441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 287444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 287450 */     GIR_RootConstrainSelectedInstOperands,
     /* 287451 */     // GIR_Coverage, 1612,
     /* 287451 */     GIR_EraseRootFromParent_Done,
     /* 287452 */   // Label 5612: @287452
     /* 287452 */   GIM_Reject,
     /* 287453 */ // Label 5601: @287453
     /* 287453 */ GIM_Reject,
     /* 287454 */ // Label 5593: @287454
     /* 287454 */ GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(288501),
     /* 287459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287469 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(287509), // Rule ID 754 //
     /* 287474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287477 */     // MIs[0] Operand 1
     /* 287477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287500 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 287503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287507 */     GIR_RootConstrainSelectedInstOperands,
     /* 287508 */     // GIR_Coverage, 754,
     /* 287508 */     GIR_EraseRootFromParent_Done,
     /* 287509 */   // Label 5614: @287509
     /* 287509 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(287549), // Rule ID 761 //
     /* 287514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287517 */     // MIs[0] Operand 1
     /* 287517 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287526 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287532 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287540 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 287543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287547 */     GIR_RootConstrainSelectedInstOperands,
     /* 287548 */     // GIR_Coverage, 761,
     /* 287548 */     GIR_EraseRootFromParent_Done,
     /* 287549 */   // Label 5615: @287549
     /* 287549 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(287586), // Rule ID 5188 //
     /* 287554 */     // MIs[0] Operand 1
     /* 287554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287577 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287584 */     GIR_RootConstrainSelectedInstOperands,
     /* 287585 */     // GIR_Coverage, 5188,
     /* 287585 */     GIR_EraseRootFromParent_Done,
     /* 287586 */   // Label 5616: @287586
     /* 287586 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(287623), // Rule ID 5195 //
     /* 287591 */     // MIs[0] Operand 1
     /* 287591 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287600 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287606 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287614 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 287617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287621 */     GIR_RootConstrainSelectedInstOperands,
     /* 287622 */     // GIR_Coverage, 5195,
     /* 287622 */     GIR_EraseRootFromParent_Done,
     /* 287623 */   // Label 5617: @287623
     /* 287623 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(287660), // Rule ID 5202 //
     /* 287628 */     // MIs[0] Operand 1
     /* 287628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287651 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 287654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287658 */     GIR_RootConstrainSelectedInstOperands,
     /* 287659 */     // GIR_Coverage, 5202,
     /* 287659 */     GIR_EraseRootFromParent_Done,
     /* 287660 */   // Label 5618: @287660
     /* 287660 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(287697), // Rule ID 5209 //
     /* 287665 */     // MIs[0] Operand 1
     /* 287665 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 287670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287674 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287680 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287688 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287695 */     GIR_RootConstrainSelectedInstOperands,
     /* 287696 */     // GIR_Coverage, 5209,
     /* 287696 */     GIR_EraseRootFromParent_Done,
     /* 287697 */   // Label 5619: @287697
     /* 287697 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(287734), // Rule ID 5216 //
     /* 287702 */     // MIs[0] Operand 1
     /* 287702 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 287707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287725 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 287732 */     GIR_RootConstrainSelectedInstOperands,
     /* 287733 */     // GIR_Coverage, 5216,
     /* 287733 */     GIR_EraseRootFromParent_Done,
     /* 287734 */   // Label 5620: @287734
     /* 287734 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(287774), // Rule ID 726 //
     /* 287739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287742 */     // MIs[0] Operand 1
     /* 287742 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287765 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287772 */     GIR_RootConstrainSelectedInstOperands,
     /* 287773 */     // GIR_Coverage, 726,
     /* 287773 */     GIR_EraseRootFromParent_Done,
     /* 287774 */   // Label 5621: @287774
     /* 287774 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(287814), // Rule ID 737 //
     /* 287779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287782 */     // MIs[0] Operand 1
     /* 287782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287795 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287801 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287805 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287812 */     GIR_RootConstrainSelectedInstOperands,
     /* 287813 */     // GIR_Coverage, 737,
     /* 287813 */     GIR_EraseRootFromParent_Done,
     /* 287814 */   // Label 5622: @287814
     /* 287814 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(287854), // Rule ID 738 //
     /* 287819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287822 */     // MIs[0] Operand 1
     /* 287822 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287835 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287841 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 287843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287845 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287852 */     GIR_RootConstrainSelectedInstOperands,
     /* 287853 */     // GIR_Coverage, 738,
     /* 287853 */     GIR_EraseRootFromParent_Done,
     /* 287854 */   // Label 5623: @287854
     /* 287854 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(287894), // Rule ID 747 //
     /* 287859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287862 */     // MIs[0] Operand 1
     /* 287862 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287875 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287885 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287892 */     GIR_RootConstrainSelectedInstOperands,
     /* 287893 */     // GIR_Coverage, 747,
     /* 287893 */     GIR_EraseRootFromParent_Done,
     /* 287894 */   // Label 5624: @287894
     /* 287894 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(287931), // Rule ID 5153 //
     /* 287899 */     // MIs[0] Operand 1
     /* 287899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 287904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287922 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 287925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287929 */     GIR_RootConstrainSelectedInstOperands,
     /* 287930 */     // GIR_Coverage, 5153,
     /* 287930 */     GIR_EraseRootFromParent_Done,
     /* 287931 */   // Label 5625: @287931
     /* 287931 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(287968), // Rule ID 5160 //
     /* 287936 */     // MIs[0] Operand 1
     /* 287936 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 287941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287959 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 287962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287966 */     GIR_RootConstrainSelectedInstOperands,
     /* 287967 */     // GIR_Coverage, 5160,
     /* 287967 */     GIR_EraseRootFromParent_Done,
     /* 287968 */   // Label 5626: @287968
     /* 287968 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(288005), // Rule ID 5167 //
     /* 287973 */     // MIs[0] Operand 1
     /* 287973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 287978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 287992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 287994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287996 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 287996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 287999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288003 */     GIR_RootConstrainSelectedInstOperands,
     /* 288004 */     // GIR_Coverage, 5167,
     /* 288004 */     GIR_EraseRootFromParent_Done,
     /* 288005 */   // Label 5627: @288005
     /* 288005 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(288042), // Rule ID 5174 //
     /* 288010 */     // MIs[0] Operand 1
     /* 288010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288023 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288029 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288033 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 288033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 288036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288040 */     GIR_RootConstrainSelectedInstOperands,
     /* 288041 */     // GIR_Coverage, 5174,
     /* 288041 */     GIR_EraseRootFromParent_Done,
     /* 288042 */   // Label 5628: @288042
     /* 288042 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(288079), // Rule ID 5181 //
     /* 288047 */     // MIs[0] Operand 1
     /* 288047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288070 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 288070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 288073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288077 */     GIR_RootConstrainSelectedInstOperands,
     /* 288078 */     // GIR_Coverage, 5181,
     /* 288078 */     GIR_EraseRootFromParent_Done,
     /* 288079 */   // Label 5629: @288079
     /* 288079 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(288111), // Rule ID 1125 //
     /* 288084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288087 */     // MIs[0] Operand 1
     /* 288087 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288100 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 288103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288109 */     GIR_RootConstrainSelectedInstOperands,
     /* 288110 */     // GIR_Coverage, 1125,
     /* 288110 */     GIR_EraseRootFromParent_Done,
     /* 288111 */   // Label 5630: @288111
     /* 288111 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(288143), // Rule ID 1132 //
     /* 288116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288119 */     // MIs[0] Operand 1
     /* 288119 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288132 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 288135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288141 */     GIR_RootConstrainSelectedInstOperands,
     /* 288142 */     // GIR_Coverage, 1132,
     /* 288142 */     GIR_EraseRootFromParent_Done,
     /* 288143 */   // Label 5631: @288143
     /* 288143 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(288175), // Rule ID 1139 //
     /* 288148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288151 */     // MIs[0] Operand 1
     /* 288151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288164 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 288167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288173 */     GIR_RootConstrainSelectedInstOperands,
     /* 288174 */     // GIR_Coverage, 1139,
     /* 288174 */     GIR_EraseRootFromParent_Done,
     /* 288175 */   // Label 5632: @288175
     /* 288175 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(288207), // Rule ID 1146 //
     /* 288180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288183 */     // MIs[0] Operand 1
     /* 288183 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288196 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288205 */     GIR_RootConstrainSelectedInstOperands,
     /* 288206 */     // GIR_Coverage, 1146,
     /* 288206 */     GIR_EraseRootFromParent_Done,
     /* 288207 */   // Label 5633: @288207
     /* 288207 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(288239), // Rule ID 1153 //
     /* 288212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288215 */     // MIs[0] Operand 1
     /* 288215 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288228 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288237 */     GIR_RootConstrainSelectedInstOperands,
     /* 288238 */     // GIR_Coverage, 1153,
     /* 288238 */     GIR_EraseRootFromParent_Done,
     /* 288239 */   // Label 5634: @288239
     /* 288239 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(288268), // Rule ID 5090 //
     /* 288244 */     // MIs[0] Operand 1
     /* 288244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288257 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 288260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288266 */     GIR_RootConstrainSelectedInstOperands,
     /* 288267 */     // GIR_Coverage, 5090,
     /* 288267 */     GIR_EraseRootFromParent_Done,
     /* 288268 */   // Label 5635: @288268
     /* 288268 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(288297), // Rule ID 5097 //
     /* 288273 */     // MIs[0] Operand 1
     /* 288273 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288286 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 288289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288295 */     GIR_RootConstrainSelectedInstOperands,
     /* 288296 */     // GIR_Coverage, 5097,
     /* 288296 */     GIR_EraseRootFromParent_Done,
     /* 288297 */   // Label 5636: @288297
     /* 288297 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(288326), // Rule ID 5104 //
     /* 288302 */     // MIs[0] Operand 1
     /* 288302 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288315 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 288318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288324 */     GIR_RootConstrainSelectedInstOperands,
     /* 288325 */     // GIR_Coverage, 5104,
     /* 288325 */     GIR_EraseRootFromParent_Done,
     /* 288326 */   // Label 5637: @288326
     /* 288326 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(288355), // Rule ID 5111 //
     /* 288331 */     // MIs[0] Operand 1
     /* 288331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288344 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288353 */     GIR_RootConstrainSelectedInstOperands,
     /* 288354 */     // GIR_Coverage, 5111,
     /* 288354 */     GIR_EraseRootFromParent_Done,
     /* 288355 */   // Label 5638: @288355
     /* 288355 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(288384), // Rule ID 5118 //
     /* 288360 */     // MIs[0] Operand 1
     /* 288360 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288373 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 288373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288382 */     GIR_RootConstrainSelectedInstOperands,
     /* 288383 */     // GIR_Coverage, 5118,
     /* 288383 */     GIR_EraseRootFromParent_Done,
     /* 288384 */   // Label 5639: @288384
     /* 288384 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(288413), // Rule ID 5125 //
     /* 288389 */     // MIs[0] Operand 1
     /* 288389 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288402 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 288405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288411 */     GIR_RootConstrainSelectedInstOperands,
     /* 288412 */     // GIR_Coverage, 5125,
     /* 288412 */     GIR_EraseRootFromParent_Done,
     /* 288413 */   // Label 5640: @288413
     /* 288413 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(288442), // Rule ID 5132 //
     /* 288418 */     // MIs[0] Operand 1
     /* 288418 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288431 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 288434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288440 */     GIR_RootConstrainSelectedInstOperands,
     /* 288441 */     // GIR_Coverage, 5132,
     /* 288441 */     GIR_EraseRootFromParent_Done,
     /* 288442 */   // Label 5641: @288442
     /* 288442 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(288471), // Rule ID 5139 //
     /* 288447 */     // MIs[0] Operand 1
     /* 288447 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 288452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288460 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 288463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288469 */     GIR_RootConstrainSelectedInstOperands,
     /* 288470 */     // GIR_Coverage, 5139,
     /* 288470 */     GIR_EraseRootFromParent_Done,
     /* 288471 */   // Label 5642: @288471
     /* 288471 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(288500), // Rule ID 5146 //
     /* 288476 */     // MIs[0] Operand 1
     /* 288476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 288481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288489 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 288489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 288492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288498 */     GIR_RootConstrainSelectedInstOperands,
     /* 288499 */     // GIR_Coverage, 5146,
     /* 288499 */     GIR_EraseRootFromParent_Done,
     /* 288500 */   // Label 5643: @288500
     /* 288500 */   GIM_Reject,
     /* 288501 */ // Label 5613: @288501
     /* 288501 */ GIM_Reject,
     /* 288502 */ // Label 5594: @288502
     /* 288502 */ GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(289549),
     /* 288507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288510 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 288513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288517 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(288557), // Rule ID 756 //
     /* 288522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288525 */     // MIs[0] Operand 1
     /* 288525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288548 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 288551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288555 */     GIR_RootConstrainSelectedInstOperands,
     /* 288556 */     // GIR_Coverage, 756,
     /* 288556 */     GIR_EraseRootFromParent_Done,
     /* 288557 */   // Label 5645: @288557
     /* 288557 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(288597), // Rule ID 763 //
     /* 288562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288565 */     // MIs[0] Operand 1
     /* 288565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288574 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288580 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288588 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 288591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288595 */     GIR_RootConstrainSelectedInstOperands,
     /* 288596 */     // GIR_Coverage, 763,
     /* 288596 */     GIR_EraseRootFromParent_Done,
     /* 288597 */   // Label 5646: @288597
     /* 288597 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(288634), // Rule ID 5190 //
     /* 288602 */     // MIs[0] Operand 1
     /* 288602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288625 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288632 */     GIR_RootConstrainSelectedInstOperands,
     /* 288633 */     // GIR_Coverage, 5190,
     /* 288633 */     GIR_EraseRootFromParent_Done,
     /* 288634 */   // Label 5647: @288634
     /* 288634 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(288671), // Rule ID 5197 //
     /* 288639 */     // MIs[0] Operand 1
     /* 288639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288654 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288662 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 288665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288669 */     GIR_RootConstrainSelectedInstOperands,
     /* 288670 */     // GIR_Coverage, 5197,
     /* 288670 */     GIR_EraseRootFromParent_Done,
     /* 288671 */   // Label 5648: @288671
     /* 288671 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(288708), // Rule ID 5204 //
     /* 288676 */     // MIs[0] Operand 1
     /* 288676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288685 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288691 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288699 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 288702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288706 */     GIR_RootConstrainSelectedInstOperands,
     /* 288707 */     // GIR_Coverage, 5204,
     /* 288707 */     GIR_EraseRootFromParent_Done,
     /* 288708 */   // Label 5649: @288708
     /* 288708 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(288745), // Rule ID 5211 //
     /* 288713 */     // MIs[0] Operand 1
     /* 288713 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 288718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288722 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288728 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288736 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 288739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288743 */     GIR_RootConstrainSelectedInstOperands,
     /* 288744 */     // GIR_Coverage, 5211,
     /* 288744 */     GIR_EraseRootFromParent_Done,
     /* 288745 */   // Label 5650: @288745
     /* 288745 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(288782), // Rule ID 5218 //
     /* 288750 */     // MIs[0] Operand 1
     /* 288750 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 288755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288773 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288780 */     GIR_RootConstrainSelectedInstOperands,
     /* 288781 */     // GIR_Coverage, 5218,
     /* 288781 */     GIR_EraseRootFromParent_Done,
     /* 288782 */   // Label 5651: @288782
     /* 288782 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(288822), // Rule ID 728 //
     /* 288787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288790 */     // MIs[0] Operand 1
     /* 288790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288813 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288820 */     GIR_RootConstrainSelectedInstOperands,
     /* 288821 */     // GIR_Coverage, 728,
     /* 288821 */     GIR_EraseRootFromParent_Done,
     /* 288822 */   // Label 5652: @288822
     /* 288822 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(288862), // Rule ID 741 //
     /* 288827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288830 */     // MIs[0] Operand 1
     /* 288830 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288849 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288853 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288860 */     GIR_RootConstrainSelectedInstOperands,
     /* 288861 */     // GIR_Coverage, 741,
     /* 288861 */     GIR_EraseRootFromParent_Done,
     /* 288862 */   // Label 5653: @288862
     /* 288862 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(288902), // Rule ID 742 //
     /* 288867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288870 */     // MIs[0] Operand 1
     /* 288870 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288889 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 288891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288893 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 288896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288900 */     GIR_RootConstrainSelectedInstOperands,
     /* 288901 */     // GIR_Coverage, 742,
     /* 288901 */     GIR_EraseRootFromParent_Done,
     /* 288902 */   // Label 5654: @288902
     /* 288902 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(288942), // Rule ID 749 //
     /* 288907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288910 */     // MIs[0] Operand 1
     /* 288910 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288933 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 288936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288940 */     GIR_RootConstrainSelectedInstOperands,
     /* 288941 */     // GIR_Coverage, 749,
     /* 288941 */     GIR_EraseRootFromParent_Done,
     /* 288942 */   // Label 5655: @288942
     /* 288942 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(288979), // Rule ID 5155 //
     /* 288947 */     // MIs[0] Operand 1
     /* 288947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288966 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288970 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 288970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 288973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288977 */     GIR_RootConstrainSelectedInstOperands,
     /* 288978 */     // GIR_Coverage, 5155,
     /* 288978 */     GIR_EraseRootFromParent_Done,
     /* 288979 */   // Label 5656: @288979
     /* 288979 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(289016), // Rule ID 5162 //
     /* 288984 */     // MIs[0] Operand 1
     /* 288984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289007 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 289007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 289010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289014 */     GIR_RootConstrainSelectedInstOperands,
     /* 289015 */     // GIR_Coverage, 5162,
     /* 289015 */     GIR_EraseRootFromParent_Done,
     /* 289016 */   // Label 5657: @289016
     /* 289016 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(289053), // Rule ID 5169 //
     /* 289021 */     // MIs[0] Operand 1
     /* 289021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289034 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289044 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 289044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 289047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289051 */     GIR_RootConstrainSelectedInstOperands,
     /* 289052 */     // GIR_Coverage, 5169,
     /* 289052 */     GIR_EraseRootFromParent_Done,
     /* 289053 */   // Label 5658: @289053
     /* 289053 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(289090), // Rule ID 5176 //
     /* 289058 */     // MIs[0] Operand 1
     /* 289058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289081 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 289081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 289084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289088 */     GIR_RootConstrainSelectedInstOperands,
     /* 289089 */     // GIR_Coverage, 5176,
     /* 289089 */     GIR_EraseRootFromParent_Done,
     /* 289090 */   // Label 5659: @289090
     /* 289090 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(289127), // Rule ID 5183 //
     /* 289095 */     // MIs[0] Operand 1
     /* 289095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289108 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289114 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289118 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289125 */     GIR_RootConstrainSelectedInstOperands,
     /* 289126 */     // GIR_Coverage, 5183,
     /* 289126 */     GIR_EraseRootFromParent_Done,
     /* 289127 */   // Label 5660: @289127
     /* 289127 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(289159), // Rule ID 1127 //
     /* 289132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289135 */     // MIs[0] Operand 1
     /* 289135 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289148 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 289151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289157 */     GIR_RootConstrainSelectedInstOperands,
     /* 289158 */     // GIR_Coverage, 1127,
     /* 289158 */     GIR_EraseRootFromParent_Done,
     /* 289159 */   // Label 5661: @289159
     /* 289159 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(289191), // Rule ID 1134 //
     /* 289164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289167 */     // MIs[0] Operand 1
     /* 289167 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289180 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289189 */     GIR_RootConstrainSelectedInstOperands,
     /* 289190 */     // GIR_Coverage, 1134,
     /* 289190 */     GIR_EraseRootFromParent_Done,
     /* 289191 */   // Label 5662: @289191
     /* 289191 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(289223), // Rule ID 1141 //
     /* 289196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289199 */     // MIs[0] Operand 1
     /* 289199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289212 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289221 */     GIR_RootConstrainSelectedInstOperands,
     /* 289222 */     // GIR_Coverage, 1141,
     /* 289222 */     GIR_EraseRootFromParent_Done,
     /* 289223 */   // Label 5663: @289223
     /* 289223 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(289255), // Rule ID 1148 //
     /* 289228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289231 */     // MIs[0] Operand 1
     /* 289231 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289244 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289253 */     GIR_RootConstrainSelectedInstOperands,
     /* 289254 */     // GIR_Coverage, 1148,
     /* 289254 */     GIR_EraseRootFromParent_Done,
     /* 289255 */   // Label 5664: @289255
     /* 289255 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(289287), // Rule ID 1155 //
     /* 289260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289263 */     // MIs[0] Operand 1
     /* 289263 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289276 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289285 */     GIR_RootConstrainSelectedInstOperands,
     /* 289286 */     // GIR_Coverage, 1155,
     /* 289286 */     GIR_EraseRootFromParent_Done,
     /* 289287 */   // Label 5665: @289287
     /* 289287 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(289316), // Rule ID 5092 //
     /* 289292 */     // MIs[0] Operand 1
     /* 289292 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289305 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 289308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289314 */     GIR_RootConstrainSelectedInstOperands,
     /* 289315 */     // GIR_Coverage, 5092,
     /* 289315 */     GIR_EraseRootFromParent_Done,
     /* 289316 */   // Label 5666: @289316
     /* 289316 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(289345), // Rule ID 5099 //
     /* 289321 */     // MIs[0] Operand 1
     /* 289321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289334 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289343 */     GIR_RootConstrainSelectedInstOperands,
     /* 289344 */     // GIR_Coverage, 5099,
     /* 289344 */     GIR_EraseRootFromParent_Done,
     /* 289345 */   // Label 5667: @289345
     /* 289345 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(289374), // Rule ID 5106 //
     /* 289350 */     // MIs[0] Operand 1
     /* 289350 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289363 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289372 */     GIR_RootConstrainSelectedInstOperands,
     /* 289373 */     // GIR_Coverage, 5106,
     /* 289373 */     GIR_EraseRootFromParent_Done,
     /* 289374 */   // Label 5668: @289374
     /* 289374 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(289403), // Rule ID 5113 //
     /* 289379 */     // MIs[0] Operand 1
     /* 289379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289392 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289401 */     GIR_RootConstrainSelectedInstOperands,
     /* 289402 */     // GIR_Coverage, 5113,
     /* 289402 */     GIR_EraseRootFromParent_Done,
     /* 289403 */   // Label 5669: @289403
     /* 289403 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(289432), // Rule ID 5120 //
     /* 289408 */     // MIs[0] Operand 1
     /* 289408 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289421 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 289421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289430 */     GIR_RootConstrainSelectedInstOperands,
     /* 289431 */     // GIR_Coverage, 5120,
     /* 289431 */     GIR_EraseRootFromParent_Done,
     /* 289432 */   // Label 5670: @289432
     /* 289432 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(289461), // Rule ID 5127 //
     /* 289437 */     // MIs[0] Operand 1
     /* 289437 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289450 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 289453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289459 */     GIR_RootConstrainSelectedInstOperands,
     /* 289460 */     // GIR_Coverage, 5127,
     /* 289460 */     GIR_EraseRootFromParent_Done,
     /* 289461 */   // Label 5671: @289461
     /* 289461 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(289490), // Rule ID 5134 //
     /* 289466 */     // MIs[0] Operand 1
     /* 289466 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289479 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 289482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289488 */     GIR_RootConstrainSelectedInstOperands,
     /* 289489 */     // GIR_Coverage, 5134,
     /* 289489 */     GIR_EraseRootFromParent_Done,
     /* 289490 */   // Label 5672: @289490
     /* 289490 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(289519), // Rule ID 5141 //
     /* 289495 */     // MIs[0] Operand 1
     /* 289495 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289508 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 289511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289517 */     GIR_RootConstrainSelectedInstOperands,
     /* 289518 */     // GIR_Coverage, 5141,
     /* 289518 */     GIR_EraseRootFromParent_Done,
     /* 289519 */   // Label 5673: @289519
     /* 289519 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(289548), // Rule ID 5148 //
     /* 289524 */     // MIs[0] Operand 1
     /* 289524 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 289529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289537 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 289537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 289540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289546 */     GIR_RootConstrainSelectedInstOperands,
     /* 289547 */     // GIR_Coverage, 5148,
     /* 289547 */     GIR_EraseRootFromParent_Done,
     /* 289548 */   // Label 5674: @289548
     /* 289548 */   GIM_Reject,
     /* 289549 */ // Label 5644: @289549
     /* 289549 */ GIM_Reject,
     /* 289550 */ // Label 5595: @289550
     /* 289550 */ GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(290597),
     /* 289555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 289558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 289561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289565 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(289605), // Rule ID 752 //
     /* 289570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289573 */     // MIs[0] Operand 1
     /* 289573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289582 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289588 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289596 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 289599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289603 */     GIR_RootConstrainSelectedInstOperands,
     /* 289604 */     // GIR_Coverage, 752,
     /* 289604 */     GIR_EraseRootFromParent_Done,
     /* 289605 */   // Label 5676: @289605
     /* 289605 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(289645), // Rule ID 759 //
     /* 289610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289613 */     // MIs[0] Operand 1
     /* 289613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289622 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289628 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289636 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 289639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289643 */     GIR_RootConstrainSelectedInstOperands,
     /* 289644 */     // GIR_Coverage, 759,
     /* 289644 */     GIR_EraseRootFromParent_Done,
     /* 289645 */   // Label 5677: @289645
     /* 289645 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(289682), // Rule ID 5186 //
     /* 289650 */     // MIs[0] Operand 1
     /* 289650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289673 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 289676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289680 */     GIR_RootConstrainSelectedInstOperands,
     /* 289681 */     // GIR_Coverage, 5186,
     /* 289681 */     GIR_EraseRootFromParent_Done,
     /* 289682 */   // Label 5678: @289682
     /* 289682 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(289719), // Rule ID 5193 //
     /* 289687 */     // MIs[0] Operand 1
     /* 289687 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289696 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289702 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289710 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 289713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289717 */     GIR_RootConstrainSelectedInstOperands,
     /* 289718 */     // GIR_Coverage, 5193,
     /* 289718 */     GIR_EraseRootFromParent_Done,
     /* 289719 */   // Label 5679: @289719
     /* 289719 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(289756), // Rule ID 5200 //
     /* 289724 */     // MIs[0] Operand 1
     /* 289724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289747 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 289750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289754 */     GIR_RootConstrainSelectedInstOperands,
     /* 289755 */     // GIR_Coverage, 5200,
     /* 289755 */     GIR_EraseRootFromParent_Done,
     /* 289756 */   // Label 5680: @289756
     /* 289756 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(289793), // Rule ID 5207 //
     /* 289761 */     // MIs[0] Operand 1
     /* 289761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289770 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289776 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289784 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 289787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289791 */     GIR_RootConstrainSelectedInstOperands,
     /* 289792 */     // GIR_Coverage, 5207,
     /* 289792 */     GIR_EraseRootFromParent_Done,
     /* 289793 */   // Label 5681: @289793
     /* 289793 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(289830), // Rule ID 5214 //
     /* 289798 */     // MIs[0] Operand 1
     /* 289798 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289821 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289828 */     GIR_RootConstrainSelectedInstOperands,
     /* 289829 */     // GIR_Coverage, 5214,
     /* 289829 */     GIR_EraseRootFromParent_Done,
     /* 289830 */   // Label 5682: @289830
     /* 289830 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(289870), // Rule ID 724 //
     /* 289835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289838 */     // MIs[0] Operand 1
     /* 289838 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289851 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289857 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289861 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 289864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289868 */     GIR_RootConstrainSelectedInstOperands,
     /* 289869 */     // GIR_Coverage, 724,
     /* 289869 */     GIR_EraseRootFromParent_Done,
     /* 289870 */   // Label 5683: @289870
     /* 289870 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(289910), // Rule ID 733 //
     /* 289875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289878 */     // MIs[0] Operand 1
     /* 289878 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289901 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289908 */     GIR_RootConstrainSelectedInstOperands,
     /* 289909 */     // GIR_Coverage, 733,
     /* 289909 */     GIR_EraseRootFromParent_Done,
     /* 289910 */   // Label 5684: @289910
     /* 289910 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(289950), // Rule ID 734 //
     /* 289915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289918 */     // MIs[0] Operand 1
     /* 289918 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289931 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289941 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 289944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289948 */     GIR_RootConstrainSelectedInstOperands,
     /* 289949 */     // GIR_Coverage, 734,
     /* 289949 */     GIR_EraseRootFromParent_Done,
     /* 289950 */   // Label 5685: @289950
     /* 289950 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(289990), // Rule ID 745 //
     /* 289955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289958 */     // MIs[0] Operand 1
     /* 289958 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289977 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289981 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 289981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 289984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289988 */     GIR_RootConstrainSelectedInstOperands,
     /* 289989 */     // GIR_Coverage, 745,
     /* 289989 */     GIR_EraseRootFromParent_Done,
     /* 289990 */   // Label 5686: @289990
     /* 289990 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(290027), // Rule ID 5151 //
     /* 289995 */     // MIs[0] Operand 1
     /* 289995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290018 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 290018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 290021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290025 */     GIR_RootConstrainSelectedInstOperands,
     /* 290026 */     // GIR_Coverage, 5151,
     /* 290026 */     GIR_EraseRootFromParent_Done,
     /* 290027 */   // Label 5687: @290027
     /* 290027 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(290064), // Rule ID 5158 //
     /* 290032 */     // MIs[0] Operand 1
     /* 290032 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290045 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290051 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290055 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 290055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 290058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290062 */     GIR_RootConstrainSelectedInstOperands,
     /* 290063 */     // GIR_Coverage, 5158,
     /* 290063 */     GIR_EraseRootFromParent_Done,
     /* 290064 */   // Label 5688: @290064
     /* 290064 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(290101), // Rule ID 5165 //
     /* 290069 */     // MIs[0] Operand 1
     /* 290069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290082 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290088 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290092 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 290092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 290095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290099 */     GIR_RootConstrainSelectedInstOperands,
     /* 290100 */     // GIR_Coverage, 5165,
     /* 290100 */     GIR_EraseRootFromParent_Done,
     /* 290101 */   // Label 5689: @290101
     /* 290101 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(290138), // Rule ID 5172 //
     /* 290106 */     // MIs[0] Operand 1
     /* 290106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290119 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290125 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290129 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 290129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 290132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290136 */     GIR_RootConstrainSelectedInstOperands,
     /* 290137 */     // GIR_Coverage, 5172,
     /* 290137 */     GIR_EraseRootFromParent_Done,
     /* 290138 */   // Label 5690: @290138
     /* 290138 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(290175), // Rule ID 5179 //
     /* 290143 */     // MIs[0] Operand 1
     /* 290143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290156 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290162 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290166 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 290166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 290169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290173 */     GIR_RootConstrainSelectedInstOperands,
     /* 290174 */     // GIR_Coverage, 5179,
     /* 290174 */     GIR_EraseRootFromParent_Done,
     /* 290175 */   // Label 5691: @290175
     /* 290175 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(290207), // Rule ID 1123 //
     /* 290180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290183 */     // MIs[0] Operand 1
     /* 290183 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290196 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 290199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290205 */     GIR_RootConstrainSelectedInstOperands,
     /* 290206 */     // GIR_Coverage, 1123,
     /* 290206 */     GIR_EraseRootFromParent_Done,
     /* 290207 */   // Label 5692: @290207
     /* 290207 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(290239), // Rule ID 1130 //
     /* 290212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290215 */     // MIs[0] Operand 1
     /* 290215 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290228 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290237 */     GIR_RootConstrainSelectedInstOperands,
     /* 290238 */     // GIR_Coverage, 1130,
     /* 290238 */     GIR_EraseRootFromParent_Done,
     /* 290239 */   // Label 5693: @290239
     /* 290239 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(290271), // Rule ID 1137 //
     /* 290244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290247 */     // MIs[0] Operand 1
     /* 290247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290260 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290269 */     GIR_RootConstrainSelectedInstOperands,
     /* 290270 */     // GIR_Coverage, 1137,
     /* 290270 */     GIR_EraseRootFromParent_Done,
     /* 290271 */   // Label 5694: @290271
     /* 290271 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(290303), // Rule ID 1144 //
     /* 290276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290279 */     // MIs[0] Operand 1
     /* 290279 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290292 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290301 */     GIR_RootConstrainSelectedInstOperands,
     /* 290302 */     // GIR_Coverage, 1144,
     /* 290302 */     GIR_EraseRootFromParent_Done,
     /* 290303 */   // Label 5695: @290303
     /* 290303 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(290335), // Rule ID 1151 //
     /* 290308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290311 */     // MIs[0] Operand 1
     /* 290311 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290324 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290333 */     GIR_RootConstrainSelectedInstOperands,
     /* 290334 */     // GIR_Coverage, 1151,
     /* 290334 */     GIR_EraseRootFromParent_Done,
     /* 290335 */   // Label 5696: @290335
     /* 290335 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(290364), // Rule ID 5088 //
     /* 290340 */     // MIs[0] Operand 1
     /* 290340 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290353 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 290356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290362 */     GIR_RootConstrainSelectedInstOperands,
     /* 290363 */     // GIR_Coverage, 5088,
     /* 290363 */     GIR_EraseRootFromParent_Done,
     /* 290364 */   // Label 5697: @290364
     /* 290364 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(290393), // Rule ID 5095 //
     /* 290369 */     // MIs[0] Operand 1
     /* 290369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290382 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290391 */     GIR_RootConstrainSelectedInstOperands,
     /* 290392 */     // GIR_Coverage, 5095,
     /* 290392 */     GIR_EraseRootFromParent_Done,
     /* 290393 */   // Label 5698: @290393
     /* 290393 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(290422), // Rule ID 5102 //
     /* 290398 */     // MIs[0] Operand 1
     /* 290398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290411 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290420 */     GIR_RootConstrainSelectedInstOperands,
     /* 290421 */     // GIR_Coverage, 5102,
     /* 290421 */     GIR_EraseRootFromParent_Done,
     /* 290422 */   // Label 5699: @290422
     /* 290422 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(290451), // Rule ID 5109 //
     /* 290427 */     // MIs[0] Operand 1
     /* 290427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290440 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290449 */     GIR_RootConstrainSelectedInstOperands,
     /* 290450 */     // GIR_Coverage, 5109,
     /* 290450 */     GIR_EraseRootFromParent_Done,
     /* 290451 */   // Label 5700: @290451
     /* 290451 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(290480), // Rule ID 5116 //
     /* 290456 */     // MIs[0] Operand 1
     /* 290456 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290469 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 290469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290478 */     GIR_RootConstrainSelectedInstOperands,
     /* 290479 */     // GIR_Coverage, 5116,
     /* 290479 */     GIR_EraseRootFromParent_Done,
     /* 290480 */   // Label 5701: @290480
     /* 290480 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(290509), // Rule ID 5123 //
     /* 290485 */     // MIs[0] Operand 1
     /* 290485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290498 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 290501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290507 */     GIR_RootConstrainSelectedInstOperands,
     /* 290508 */     // GIR_Coverage, 5123,
     /* 290508 */     GIR_EraseRootFromParent_Done,
     /* 290509 */   // Label 5702: @290509
     /* 290509 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(290538), // Rule ID 5130 //
     /* 290514 */     // MIs[0] Operand 1
     /* 290514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290527 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 290530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290536 */     GIR_RootConstrainSelectedInstOperands,
     /* 290537 */     // GIR_Coverage, 5130,
     /* 290537 */     GIR_EraseRootFromParent_Done,
     /* 290538 */   // Label 5703: @290538
     /* 290538 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(290567), // Rule ID 5137 //
     /* 290543 */     // MIs[0] Operand 1
     /* 290543 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290556 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 290559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290565 */     GIR_RootConstrainSelectedInstOperands,
     /* 290566 */     // GIR_Coverage, 5137,
     /* 290566 */     GIR_EraseRootFromParent_Done,
     /* 290567 */   // Label 5704: @290567
     /* 290567 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(290596), // Rule ID 5144 //
     /* 290572 */     // MIs[0] Operand 1
     /* 290572 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290585 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 290585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 290588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290594 */     GIR_RootConstrainSelectedInstOperands,
     /* 290595 */     // GIR_Coverage, 5144,
     /* 290595 */     GIR_EraseRootFromParent_Done,
     /* 290596 */   // Label 5705: @290596
     /* 290596 */   GIM_Reject,
     /* 290597 */ // Label 5675: @290597
     /* 290597 */ GIM_Reject,
     /* 290598 */ // Label 5596: @290598
     /* 290598 */ GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(291645),
     /* 290603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 290606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 290609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290613 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(290653), // Rule ID 755 //
     /* 290618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290621 */     // MIs[0] Operand 1
     /* 290621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290644 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 290647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290651 */     GIR_RootConstrainSelectedInstOperands,
     /* 290652 */     // GIR_Coverage, 755,
     /* 290652 */     GIR_EraseRootFromParent_Done,
     /* 290653 */   // Label 5707: @290653
     /* 290653 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(290693), // Rule ID 762 //
     /* 290658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290661 */     // MIs[0] Operand 1
     /* 290661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290684 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 290687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290691 */     GIR_RootConstrainSelectedInstOperands,
     /* 290692 */     // GIR_Coverage, 762,
     /* 290692 */     GIR_EraseRootFromParent_Done,
     /* 290693 */   // Label 5708: @290693
     /* 290693 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(290730), // Rule ID 5189 //
     /* 290698 */     // MIs[0] Operand 1
     /* 290698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290721 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 290724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290728 */     GIR_RootConstrainSelectedInstOperands,
     /* 290729 */     // GIR_Coverage, 5189,
     /* 290729 */     GIR_EraseRootFromParent_Done,
     /* 290730 */   // Label 5709: @290730
     /* 290730 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(290767), // Rule ID 5196 //
     /* 290735 */     // MIs[0] Operand 1
     /* 290735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290758 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 290761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290765 */     GIR_RootConstrainSelectedInstOperands,
     /* 290766 */     // GIR_Coverage, 5196,
     /* 290766 */     GIR_EraseRootFromParent_Done,
     /* 290767 */   // Label 5710: @290767
     /* 290767 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(290804), // Rule ID 5203 //
     /* 290772 */     // MIs[0] Operand 1
     /* 290772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290781 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290787 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290795 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 290798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290802 */     GIR_RootConstrainSelectedInstOperands,
     /* 290803 */     // GIR_Coverage, 5203,
     /* 290803 */     GIR_EraseRootFromParent_Done,
     /* 290804 */   // Label 5711: @290804
     /* 290804 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(290841), // Rule ID 5210 //
     /* 290809 */     // MIs[0] Operand 1
     /* 290809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290818 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290824 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290832 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 290835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290839 */     GIR_RootConstrainSelectedInstOperands,
     /* 290840 */     // GIR_Coverage, 5210,
     /* 290840 */     GIR_EraseRootFromParent_Done,
     /* 290841 */   // Label 5712: @290841
     /* 290841 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(290878), // Rule ID 5217 //
     /* 290846 */     // MIs[0] Operand 1
     /* 290846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290869 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290876 */     GIR_RootConstrainSelectedInstOperands,
     /* 290877 */     // GIR_Coverage, 5217,
     /* 290877 */     GIR_EraseRootFromParent_Done,
     /* 290878 */   // Label 5713: @290878
     /* 290878 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(290918), // Rule ID 727 //
     /* 290883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290886 */     // MIs[0] Operand 1
     /* 290886 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290899 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290905 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290909 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 290912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290916 */     GIR_RootConstrainSelectedInstOperands,
     /* 290917 */     // GIR_Coverage, 727,
     /* 290917 */     GIR_EraseRootFromParent_Done,
     /* 290918 */   // Label 5714: @290918
     /* 290918 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(290958), // Rule ID 739 //
     /* 290923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290926 */     // MIs[0] Operand 1
     /* 290926 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290949 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290956 */     GIR_RootConstrainSelectedInstOperands,
     /* 290957 */     // GIR_Coverage, 739,
     /* 290957 */     GIR_EraseRootFromParent_Done,
     /* 290958 */   // Label 5715: @290958
     /* 290958 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(290998), // Rule ID 740 //
     /* 290963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290966 */     // MIs[0] Operand 1
     /* 290966 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290989 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 290989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 290992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290996 */     GIR_RootConstrainSelectedInstOperands,
     /* 290997 */     // GIR_Coverage, 740,
     /* 290997 */     GIR_EraseRootFromParent_Done,
     /* 290998 */   // Label 5716: @290998
     /* 290998 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(291038), // Rule ID 748 //
     /* 291003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291006 */     // MIs[0] Operand 1
     /* 291006 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291029 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 291032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291036 */     GIR_RootConstrainSelectedInstOperands,
     /* 291037 */     // GIR_Coverage, 748,
     /* 291037 */     GIR_EraseRootFromParent_Done,
     /* 291038 */   // Label 5717: @291038
     /* 291038 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(291075), // Rule ID 5154 //
     /* 291043 */     // MIs[0] Operand 1
     /* 291043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291066 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 291069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291073 */     GIR_RootConstrainSelectedInstOperands,
     /* 291074 */     // GIR_Coverage, 5154,
     /* 291074 */     GIR_EraseRootFromParent_Done,
     /* 291075 */   // Label 5718: @291075
     /* 291075 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(291112), // Rule ID 5161 //
     /* 291080 */     // MIs[0] Operand 1
     /* 291080 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291103 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 291106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291110 */     GIR_RootConstrainSelectedInstOperands,
     /* 291111 */     // GIR_Coverage, 5161,
     /* 291111 */     GIR_EraseRootFromParent_Done,
     /* 291112 */   // Label 5719: @291112
     /* 291112 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(291149), // Rule ID 5168 //
     /* 291117 */     // MIs[0] Operand 1
     /* 291117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291140 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 291143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291147 */     GIR_RootConstrainSelectedInstOperands,
     /* 291148 */     // GIR_Coverage, 5168,
     /* 291148 */     GIR_EraseRootFromParent_Done,
     /* 291149 */   // Label 5720: @291149
     /* 291149 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(291186), // Rule ID 5175 //
     /* 291154 */     // MIs[0] Operand 1
     /* 291154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291177 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 291180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291184 */     GIR_RootConstrainSelectedInstOperands,
     /* 291185 */     // GIR_Coverage, 5175,
     /* 291185 */     GIR_EraseRootFromParent_Done,
     /* 291186 */   // Label 5721: @291186
     /* 291186 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(291223), // Rule ID 5182 //
     /* 291191 */     // MIs[0] Operand 1
     /* 291191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291204 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291210 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291214 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 291214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 291217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291221 */     GIR_RootConstrainSelectedInstOperands,
     /* 291222 */     // GIR_Coverage, 5182,
     /* 291222 */     GIR_EraseRootFromParent_Done,
     /* 291223 */   // Label 5722: @291223
     /* 291223 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(291255), // Rule ID 1126 //
     /* 291228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291231 */     // MIs[0] Operand 1
     /* 291231 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291244 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 291247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291253 */     GIR_RootConstrainSelectedInstOperands,
     /* 291254 */     // GIR_Coverage, 1126,
     /* 291254 */     GIR_EraseRootFromParent_Done,
     /* 291255 */   // Label 5723: @291255
     /* 291255 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(291287), // Rule ID 1133 //
     /* 291260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291263 */     // MIs[0] Operand 1
     /* 291263 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291276 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291285 */     GIR_RootConstrainSelectedInstOperands,
     /* 291286 */     // GIR_Coverage, 1133,
     /* 291286 */     GIR_EraseRootFromParent_Done,
     /* 291287 */   // Label 5724: @291287
     /* 291287 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(291319), // Rule ID 1140 //
     /* 291292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291295 */     // MIs[0] Operand 1
     /* 291295 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291308 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291317 */     GIR_RootConstrainSelectedInstOperands,
     /* 291318 */     // GIR_Coverage, 1140,
     /* 291318 */     GIR_EraseRootFromParent_Done,
     /* 291319 */   // Label 5725: @291319
     /* 291319 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(291351), // Rule ID 1147 //
     /* 291324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291327 */     // MIs[0] Operand 1
     /* 291327 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291340 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291349 */     GIR_RootConstrainSelectedInstOperands,
     /* 291350 */     // GIR_Coverage, 1147,
     /* 291350 */     GIR_EraseRootFromParent_Done,
     /* 291351 */   // Label 5726: @291351
     /* 291351 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(291383), // Rule ID 1154 //
     /* 291356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291359 */     // MIs[0] Operand 1
     /* 291359 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291372 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291381 */     GIR_RootConstrainSelectedInstOperands,
     /* 291382 */     // GIR_Coverage, 1154,
     /* 291382 */     GIR_EraseRootFromParent_Done,
     /* 291383 */   // Label 5727: @291383
     /* 291383 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(291412), // Rule ID 5091 //
     /* 291388 */     // MIs[0] Operand 1
     /* 291388 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291401 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 291404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291410 */     GIR_RootConstrainSelectedInstOperands,
     /* 291411 */     // GIR_Coverage, 5091,
     /* 291411 */     GIR_EraseRootFromParent_Done,
     /* 291412 */   // Label 5728: @291412
     /* 291412 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(291441), // Rule ID 5098 //
     /* 291417 */     // MIs[0] Operand 1
     /* 291417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291430 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291439 */     GIR_RootConstrainSelectedInstOperands,
     /* 291440 */     // GIR_Coverage, 5098,
     /* 291440 */     GIR_EraseRootFromParent_Done,
     /* 291441 */   // Label 5729: @291441
     /* 291441 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(291470), // Rule ID 5105 //
     /* 291446 */     // MIs[0] Operand 1
     /* 291446 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291459 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291468 */     GIR_RootConstrainSelectedInstOperands,
     /* 291469 */     // GIR_Coverage, 5105,
     /* 291469 */     GIR_EraseRootFromParent_Done,
     /* 291470 */   // Label 5730: @291470
     /* 291470 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(291499), // Rule ID 5112 //
     /* 291475 */     // MIs[0] Operand 1
     /* 291475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291488 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291497 */     GIR_RootConstrainSelectedInstOperands,
     /* 291498 */     // GIR_Coverage, 5112,
     /* 291498 */     GIR_EraseRootFromParent_Done,
     /* 291499 */   // Label 5731: @291499
     /* 291499 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(291528), // Rule ID 5119 //
     /* 291504 */     // MIs[0] Operand 1
     /* 291504 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291517 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 291517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291526 */     GIR_RootConstrainSelectedInstOperands,
     /* 291527 */     // GIR_Coverage, 5119,
     /* 291527 */     GIR_EraseRootFromParent_Done,
     /* 291528 */   // Label 5732: @291528
     /* 291528 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(291557), // Rule ID 5126 //
     /* 291533 */     // MIs[0] Operand 1
     /* 291533 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291546 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 291549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291555 */     GIR_RootConstrainSelectedInstOperands,
     /* 291556 */     // GIR_Coverage, 5126,
     /* 291556 */     GIR_EraseRootFromParent_Done,
     /* 291557 */   // Label 5733: @291557
     /* 291557 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(291586), // Rule ID 5133 //
     /* 291562 */     // MIs[0] Operand 1
     /* 291562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291575 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 291578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291584 */     GIR_RootConstrainSelectedInstOperands,
     /* 291585 */     // GIR_Coverage, 5133,
     /* 291585 */     GIR_EraseRootFromParent_Done,
     /* 291586 */   // Label 5734: @291586
     /* 291586 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(291615), // Rule ID 5140 //
     /* 291591 */     // MIs[0] Operand 1
     /* 291591 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291604 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 291607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291613 */     GIR_RootConstrainSelectedInstOperands,
     /* 291614 */     // GIR_Coverage, 5140,
     /* 291614 */     GIR_EraseRootFromParent_Done,
     /* 291615 */   // Label 5735: @291615
     /* 291615 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(291644), // Rule ID 5147 //
     /* 291620 */     // MIs[0] Operand 1
     /* 291620 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291633 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 291633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 291636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291642 */     GIR_RootConstrainSelectedInstOperands,
     /* 291643 */     // GIR_Coverage, 5147,
     /* 291643 */     GIR_EraseRootFromParent_Done,
     /* 291644 */   // Label 5736: @291644
     /* 291644 */   GIM_Reject,
     /* 291645 */ // Label 5706: @291645
     /* 291645 */ GIM_Reject,
     /* 291646 */ // Label 5597: @291646
     /* 291646 */ GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(292693),
     /* 291651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 291654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 291657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291661 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(291701), // Rule ID 750 //
     /* 291666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291669 */     // MIs[0] Operand 1
     /* 291669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291692 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 291695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291699 */     GIR_RootConstrainSelectedInstOperands,
     /* 291700 */     // GIR_Coverage, 750,
     /* 291700 */     GIR_EraseRootFromParent_Done,
     /* 291701 */   // Label 5738: @291701
     /* 291701 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(291741), // Rule ID 757 //
     /* 291706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291709 */     // MIs[0] Operand 1
     /* 291709 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291718 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291724 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291732 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 291735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291739 */     GIR_RootConstrainSelectedInstOperands,
     /* 291740 */     // GIR_Coverage, 757,
     /* 291740 */     GIR_EraseRootFromParent_Done,
     /* 291741 */   // Label 5739: @291741
     /* 291741 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(291778), // Rule ID 5184 //
     /* 291746 */     // MIs[0] Operand 1
     /* 291746 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291769 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291776 */     GIR_RootConstrainSelectedInstOperands,
     /* 291777 */     // GIR_Coverage, 5184,
     /* 291777 */     GIR_EraseRootFromParent_Done,
     /* 291778 */   // Label 5740: @291778
     /* 291778 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(291815), // Rule ID 5191 //
     /* 291783 */     // MIs[0] Operand 1
     /* 291783 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291792 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291798 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291806 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 291809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291813 */     GIR_RootConstrainSelectedInstOperands,
     /* 291814 */     // GIR_Coverage, 5191,
     /* 291814 */     GIR_EraseRootFromParent_Done,
     /* 291815 */   // Label 5741: @291815
     /* 291815 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(291852), // Rule ID 5198 //
     /* 291820 */     // MIs[0] Operand 1
     /* 291820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291829 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291835 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291843 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 291846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291850 */     GIR_RootConstrainSelectedInstOperands,
     /* 291851 */     // GIR_Coverage, 5198,
     /* 291851 */     GIR_EraseRootFromParent_Done,
     /* 291852 */   // Label 5742: @291852
     /* 291852 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(291889), // Rule ID 5205 //
     /* 291857 */     // MIs[0] Operand 1
     /* 291857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291866 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291880 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 291883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291887 */     GIR_RootConstrainSelectedInstOperands,
     /* 291888 */     // GIR_Coverage, 5205,
     /* 291888 */     GIR_EraseRootFromParent_Done,
     /* 291889 */   // Label 5743: @291889
     /* 291889 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(291926), // Rule ID 5212 //
     /* 291894 */     // MIs[0] Operand 1
     /* 291894 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291917 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 291920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291924 */     GIR_RootConstrainSelectedInstOperands,
     /* 291925 */     // GIR_Coverage, 5212,
     /* 291925 */     GIR_EraseRootFromParent_Done,
     /* 291926 */   // Label 5744: @291926
     /* 291926 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(291966), // Rule ID 722 //
     /* 291931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291934 */     // MIs[0] Operand 1
     /* 291934 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291957 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 291960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291964 */     GIR_RootConstrainSelectedInstOperands,
     /* 291965 */     // GIR_Coverage, 722,
     /* 291965 */     GIR_EraseRootFromParent_Done,
     /* 291966 */   // Label 5745: @291966
     /* 291966 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(292006), // Rule ID 729 //
     /* 291971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291974 */     // MIs[0] Operand 1
     /* 291974 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291997 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 291997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 292000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292004 */     GIR_RootConstrainSelectedInstOperands,
     /* 292005 */     // GIR_Coverage, 729,
     /* 292005 */     GIR_EraseRootFromParent_Done,
     /* 292006 */   // Label 5746: @292006
     /* 292006 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(292046), // Rule ID 730 //
     /* 292011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292014 */     // MIs[0] Operand 1
     /* 292014 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292033 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292037 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 292040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292044 */     GIR_RootConstrainSelectedInstOperands,
     /* 292045 */     // GIR_Coverage, 730,
     /* 292045 */     GIR_EraseRootFromParent_Done,
     /* 292046 */   // Label 5747: @292046
     /* 292046 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(292086), // Rule ID 743 //
     /* 292051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292054 */     // MIs[0] Operand 1
     /* 292054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292077 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 292080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292084 */     GIR_RootConstrainSelectedInstOperands,
     /* 292085 */     // GIR_Coverage, 743,
     /* 292085 */     GIR_EraseRootFromParent_Done,
     /* 292086 */   // Label 5748: @292086
     /* 292086 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(292123), // Rule ID 5149 //
     /* 292091 */     // MIs[0] Operand 1
     /* 292091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292114 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 292117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292121 */     GIR_RootConstrainSelectedInstOperands,
     /* 292122 */     // GIR_Coverage, 5149,
     /* 292122 */     GIR_EraseRootFromParent_Done,
     /* 292123 */   // Label 5749: @292123
     /* 292123 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(292160), // Rule ID 5156 //
     /* 292128 */     // MIs[0] Operand 1
     /* 292128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292151 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 292154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292158 */     GIR_RootConstrainSelectedInstOperands,
     /* 292159 */     // GIR_Coverage, 5156,
     /* 292159 */     GIR_EraseRootFromParent_Done,
     /* 292160 */   // Label 5750: @292160
     /* 292160 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(292197), // Rule ID 5163 //
     /* 292165 */     // MIs[0] Operand 1
     /* 292165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292188 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 292191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292195 */     GIR_RootConstrainSelectedInstOperands,
     /* 292196 */     // GIR_Coverage, 5163,
     /* 292196 */     GIR_EraseRootFromParent_Done,
     /* 292197 */   // Label 5751: @292197
     /* 292197 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(292234), // Rule ID 5170 //
     /* 292202 */     // MIs[0] Operand 1
     /* 292202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292221 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292225 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 292228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292232 */     GIR_RootConstrainSelectedInstOperands,
     /* 292233 */     // GIR_Coverage, 5170,
     /* 292233 */     GIR_EraseRootFromParent_Done,
     /* 292234 */   // Label 5752: @292234
     /* 292234 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(292271), // Rule ID 5177 //
     /* 292239 */     // MIs[0] Operand 1
     /* 292239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292262 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 292262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 292265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292269 */     GIR_RootConstrainSelectedInstOperands,
     /* 292270 */     // GIR_Coverage, 5177,
     /* 292270 */     GIR_EraseRootFromParent_Done,
     /* 292271 */   // Label 5753: @292271
     /* 292271 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(292303), // Rule ID 1121 //
     /* 292276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292279 */     // MIs[0] Operand 1
     /* 292279 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292292 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 292295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292301 */     GIR_RootConstrainSelectedInstOperands,
     /* 292302 */     // GIR_Coverage, 1121,
     /* 292302 */     GIR_EraseRootFromParent_Done,
     /* 292303 */   // Label 5754: @292303
     /* 292303 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(292335), // Rule ID 1128 //
     /* 292308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292311 */     // MIs[0] Operand 1
     /* 292311 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292324 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292333 */     GIR_RootConstrainSelectedInstOperands,
     /* 292334 */     // GIR_Coverage, 1128,
     /* 292334 */     GIR_EraseRootFromParent_Done,
     /* 292335 */   // Label 5755: @292335
     /* 292335 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(292367), // Rule ID 1135 //
     /* 292340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292343 */     // MIs[0] Operand 1
     /* 292343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292356 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292365 */     GIR_RootConstrainSelectedInstOperands,
     /* 292366 */     // GIR_Coverage, 1135,
     /* 292366 */     GIR_EraseRootFromParent_Done,
     /* 292367 */   // Label 5756: @292367
     /* 292367 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(292399), // Rule ID 1142 //
     /* 292372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292375 */     // MIs[0] Operand 1
     /* 292375 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292388 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292397 */     GIR_RootConstrainSelectedInstOperands,
     /* 292398 */     // GIR_Coverage, 1142,
     /* 292398 */     GIR_EraseRootFromParent_Done,
     /* 292399 */   // Label 5757: @292399
     /* 292399 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(292431), // Rule ID 1149 //
     /* 292404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292407 */     // MIs[0] Operand 1
     /* 292407 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292420 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292429 */     GIR_RootConstrainSelectedInstOperands,
     /* 292430 */     // GIR_Coverage, 1149,
     /* 292430 */     GIR_EraseRootFromParent_Done,
     /* 292431 */   // Label 5758: @292431
     /* 292431 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(292460), // Rule ID 5086 //
     /* 292436 */     // MIs[0] Operand 1
     /* 292436 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292449 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 292452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292458 */     GIR_RootConstrainSelectedInstOperands,
     /* 292459 */     // GIR_Coverage, 5086,
     /* 292459 */     GIR_EraseRootFromParent_Done,
     /* 292460 */   // Label 5759: @292460
     /* 292460 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(292489), // Rule ID 5093 //
     /* 292465 */     // MIs[0] Operand 1
     /* 292465 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292478 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292487 */     GIR_RootConstrainSelectedInstOperands,
     /* 292488 */     // GIR_Coverage, 5093,
     /* 292488 */     GIR_EraseRootFromParent_Done,
     /* 292489 */   // Label 5760: @292489
     /* 292489 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(292518), // Rule ID 5100 //
     /* 292494 */     // MIs[0] Operand 1
     /* 292494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292507 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292516 */     GIR_RootConstrainSelectedInstOperands,
     /* 292517 */     // GIR_Coverage, 5100,
     /* 292517 */     GIR_EraseRootFromParent_Done,
     /* 292518 */   // Label 5761: @292518
     /* 292518 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(292547), // Rule ID 5107 //
     /* 292523 */     // MIs[0] Operand 1
     /* 292523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292536 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292545 */     GIR_RootConstrainSelectedInstOperands,
     /* 292546 */     // GIR_Coverage, 5107,
     /* 292546 */     GIR_EraseRootFromParent_Done,
     /* 292547 */   // Label 5762: @292547
     /* 292547 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(292576), // Rule ID 5114 //
     /* 292552 */     // MIs[0] Operand 1
     /* 292552 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292565 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 292565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292574 */     GIR_RootConstrainSelectedInstOperands,
     /* 292575 */     // GIR_Coverage, 5114,
     /* 292575 */     GIR_EraseRootFromParent_Done,
     /* 292576 */   // Label 5763: @292576
     /* 292576 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(292605), // Rule ID 5121 //
     /* 292581 */     // MIs[0] Operand 1
     /* 292581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292594 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 292597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292603 */     GIR_RootConstrainSelectedInstOperands,
     /* 292604 */     // GIR_Coverage, 5121,
     /* 292604 */     GIR_EraseRootFromParent_Done,
     /* 292605 */   // Label 5764: @292605
     /* 292605 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(292634), // Rule ID 5128 //
     /* 292610 */     // MIs[0] Operand 1
     /* 292610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292623 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 292626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292632 */     GIR_RootConstrainSelectedInstOperands,
     /* 292633 */     // GIR_Coverage, 5128,
     /* 292633 */     GIR_EraseRootFromParent_Done,
     /* 292634 */   // Label 5765: @292634
     /* 292634 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(292663), // Rule ID 5135 //
     /* 292639 */     // MIs[0] Operand 1
     /* 292639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292652 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 292655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292661 */     GIR_RootConstrainSelectedInstOperands,
     /* 292662 */     // GIR_Coverage, 5135,
     /* 292662 */     GIR_EraseRootFromParent_Done,
     /* 292663 */   // Label 5766: @292663
     /* 292663 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(292692), // Rule ID 5142 //
     /* 292668 */     // MIs[0] Operand 1
     /* 292668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292681 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 292681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 292684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292690 */     GIR_RootConstrainSelectedInstOperands,
     /* 292691 */     // GIR_Coverage, 5142,
     /* 292691 */     GIR_EraseRootFromParent_Done,
     /* 292692 */   // Label 5767: @292692
     /* 292692 */   GIM_Reject,
     /* 292693 */ // Label 5737: @292693
     /* 292693 */ GIM_Reject,
     /* 292694 */ // Label 5598: @292694
     /* 292694 */ GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293741),
     /* 292699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 292702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 292705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292709 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(292749), // Rule ID 753 //
     /* 292714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292717 */     // MIs[0] Operand 1
     /* 292717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292726 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292732 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292740 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 292743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292747 */     GIR_RootConstrainSelectedInstOperands,
     /* 292748 */     // GIR_Coverage, 753,
     /* 292748 */     GIR_EraseRootFromParent_Done,
     /* 292749 */   // Label 5769: @292749
     /* 292749 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(292789), // Rule ID 760 //
     /* 292754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292757 */     // MIs[0] Operand 1
     /* 292757 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292780 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 292783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292787 */     GIR_RootConstrainSelectedInstOperands,
     /* 292788 */     // GIR_Coverage, 760,
     /* 292788 */     GIR_EraseRootFromParent_Done,
     /* 292789 */   // Label 5770: @292789
     /* 292789 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(292826), // Rule ID 5187 //
     /* 292794 */     // MIs[0] Operand 1
     /* 292794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292817 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 292820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292824 */     GIR_RootConstrainSelectedInstOperands,
     /* 292825 */     // GIR_Coverage, 5187,
     /* 292825 */     GIR_EraseRootFromParent_Done,
     /* 292826 */   // Label 5771: @292826
     /* 292826 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(292863), // Rule ID 5194 //
     /* 292831 */     // MIs[0] Operand 1
     /* 292831 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292854 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 292857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292861 */     GIR_RootConstrainSelectedInstOperands,
     /* 292862 */     // GIR_Coverage, 5194,
     /* 292862 */     GIR_EraseRootFromParent_Done,
     /* 292863 */   // Label 5772: @292863
     /* 292863 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(292900), // Rule ID 5201 //
     /* 292868 */     // MIs[0] Operand 1
     /* 292868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292877 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292891 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 292894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292898 */     GIR_RootConstrainSelectedInstOperands,
     /* 292899 */     // GIR_Coverage, 5201,
     /* 292899 */     GIR_EraseRootFromParent_Done,
     /* 292900 */   // Label 5773: @292900
     /* 292900 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(292937), // Rule ID 5208 //
     /* 292905 */     // MIs[0] Operand 1
     /* 292905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292928 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 292931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292935 */     GIR_RootConstrainSelectedInstOperands,
     /* 292936 */     // GIR_Coverage, 5208,
     /* 292936 */     GIR_EraseRootFromParent_Done,
     /* 292937 */   // Label 5774: @292937
     /* 292937 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(292974), // Rule ID 5215 //
     /* 292942 */     // MIs[0] Operand 1
     /* 292942 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292965 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 292965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 292968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292972 */     GIR_RootConstrainSelectedInstOperands,
     /* 292973 */     // GIR_Coverage, 5215,
     /* 292973 */     GIR_EraseRootFromParent_Done,
     /* 292974 */   // Label 5775: @292974
     /* 292974 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(293014), // Rule ID 725 //
     /* 292979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292982 */     // MIs[0] Operand 1
     /* 292982 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292995 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293001 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293005 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 293008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293012 */     GIR_RootConstrainSelectedInstOperands,
     /* 293013 */     // GIR_Coverage, 725,
     /* 293013 */     GIR_EraseRootFromParent_Done,
     /* 293014 */   // Label 5776: @293014
     /* 293014 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(293054), // Rule ID 735 //
     /* 293019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293022 */     // MIs[0] Operand 1
     /* 293022 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293035 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293041 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293045 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 293048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293052 */     GIR_RootConstrainSelectedInstOperands,
     /* 293053 */     // GIR_Coverage, 735,
     /* 293053 */     GIR_EraseRootFromParent_Done,
     /* 293054 */   // Label 5777: @293054
     /* 293054 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(293094), // Rule ID 736 //
     /* 293059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293062 */     // MIs[0] Operand 1
     /* 293062 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293085 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 293088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293092 */     GIR_RootConstrainSelectedInstOperands,
     /* 293093 */     // GIR_Coverage, 736,
     /* 293093 */     GIR_EraseRootFromParent_Done,
     /* 293094 */   // Label 5778: @293094
     /* 293094 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(293134), // Rule ID 746 //
     /* 293099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293102 */     // MIs[0] Operand 1
     /* 293102 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293125 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 293128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293132 */     GIR_RootConstrainSelectedInstOperands,
     /* 293133 */     // GIR_Coverage, 746,
     /* 293133 */     GIR_EraseRootFromParent_Done,
     /* 293134 */   // Label 5779: @293134
     /* 293134 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(293171), // Rule ID 5152 //
     /* 293139 */     // MIs[0] Operand 1
     /* 293139 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293162 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 293165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293169 */     GIR_RootConstrainSelectedInstOperands,
     /* 293170 */     // GIR_Coverage, 5152,
     /* 293170 */     GIR_EraseRootFromParent_Done,
     /* 293171 */   // Label 5780: @293171
     /* 293171 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(293208), // Rule ID 5159 //
     /* 293176 */     // MIs[0] Operand 1
     /* 293176 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293199 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 293202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293206 */     GIR_RootConstrainSelectedInstOperands,
     /* 293207 */     // GIR_Coverage, 5159,
     /* 293207 */     GIR_EraseRootFromParent_Done,
     /* 293208 */   // Label 5781: @293208
     /* 293208 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(293245), // Rule ID 5166 //
     /* 293213 */     // MIs[0] Operand 1
     /* 293213 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293226 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293236 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 293239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293243 */     GIR_RootConstrainSelectedInstOperands,
     /* 293244 */     // GIR_Coverage, 5166,
     /* 293244 */     GIR_EraseRootFromParent_Done,
     /* 293245 */   // Label 5782: @293245
     /* 293245 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(293282), // Rule ID 5173 //
     /* 293250 */     // MIs[0] Operand 1
     /* 293250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293273 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 293276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293280 */     GIR_RootConstrainSelectedInstOperands,
     /* 293281 */     // GIR_Coverage, 5173,
     /* 293281 */     GIR_EraseRootFromParent_Done,
     /* 293282 */   // Label 5783: @293282
     /* 293282 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(293319), // Rule ID 5180 //
     /* 293287 */     // MIs[0] Operand 1
     /* 293287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293310 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 293310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 293313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293317 */     GIR_RootConstrainSelectedInstOperands,
     /* 293318 */     // GIR_Coverage, 5180,
     /* 293318 */     GIR_EraseRootFromParent_Done,
     /* 293319 */   // Label 5784: @293319
     /* 293319 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(293351), // Rule ID 1124 //
     /* 293324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293327 */     // MIs[0] Operand 1
     /* 293327 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293340 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 293343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293349 */     GIR_RootConstrainSelectedInstOperands,
     /* 293350 */     // GIR_Coverage, 1124,
     /* 293350 */     GIR_EraseRootFromParent_Done,
     /* 293351 */   // Label 5785: @293351
     /* 293351 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(293383), // Rule ID 1131 //
     /* 293356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293359 */     // MIs[0] Operand 1
     /* 293359 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293372 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293381 */     GIR_RootConstrainSelectedInstOperands,
     /* 293382 */     // GIR_Coverage, 1131,
     /* 293382 */     GIR_EraseRootFromParent_Done,
     /* 293383 */   // Label 5786: @293383
     /* 293383 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(293415), // Rule ID 1138 //
     /* 293388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293391 */     // MIs[0] Operand 1
     /* 293391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293404 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293413 */     GIR_RootConstrainSelectedInstOperands,
     /* 293414 */     // GIR_Coverage, 1138,
     /* 293414 */     GIR_EraseRootFromParent_Done,
     /* 293415 */   // Label 5787: @293415
     /* 293415 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(293447), // Rule ID 1145 //
     /* 293420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293423 */     // MIs[0] Operand 1
     /* 293423 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293436 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293445 */     GIR_RootConstrainSelectedInstOperands,
     /* 293446 */     // GIR_Coverage, 1145,
     /* 293446 */     GIR_EraseRootFromParent_Done,
     /* 293447 */   // Label 5788: @293447
     /* 293447 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(293479), // Rule ID 1152 //
     /* 293452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293455 */     // MIs[0] Operand 1
     /* 293455 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293468 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293477 */     GIR_RootConstrainSelectedInstOperands,
     /* 293478 */     // GIR_Coverage, 1152,
     /* 293478 */     GIR_EraseRootFromParent_Done,
     /* 293479 */   // Label 5789: @293479
     /* 293479 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(293508), // Rule ID 5089 //
     /* 293484 */     // MIs[0] Operand 1
     /* 293484 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293497 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 293500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293506 */     GIR_RootConstrainSelectedInstOperands,
     /* 293507 */     // GIR_Coverage, 5089,
     /* 293507 */     GIR_EraseRootFromParent_Done,
     /* 293508 */   // Label 5790: @293508
     /* 293508 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(293537), // Rule ID 5096 //
     /* 293513 */     // MIs[0] Operand 1
     /* 293513 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293526 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293535 */     GIR_RootConstrainSelectedInstOperands,
     /* 293536 */     // GIR_Coverage, 5096,
     /* 293536 */     GIR_EraseRootFromParent_Done,
     /* 293537 */   // Label 5791: @293537
     /* 293537 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(293566), // Rule ID 5103 //
     /* 293542 */     // MIs[0] Operand 1
     /* 293542 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293555 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293564 */     GIR_RootConstrainSelectedInstOperands,
     /* 293565 */     // GIR_Coverage, 5103,
     /* 293565 */     GIR_EraseRootFromParent_Done,
     /* 293566 */   // Label 5792: @293566
     /* 293566 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(293595), // Rule ID 5110 //
     /* 293571 */     // MIs[0] Operand 1
     /* 293571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293584 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293593 */     GIR_RootConstrainSelectedInstOperands,
     /* 293594 */     // GIR_Coverage, 5110,
     /* 293594 */     GIR_EraseRootFromParent_Done,
     /* 293595 */   // Label 5793: @293595
     /* 293595 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(293624), // Rule ID 5117 //
     /* 293600 */     // MIs[0] Operand 1
     /* 293600 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293613 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 293613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293622 */     GIR_RootConstrainSelectedInstOperands,
     /* 293623 */     // GIR_Coverage, 5117,
     /* 293623 */     GIR_EraseRootFromParent_Done,
     /* 293624 */   // Label 5794: @293624
     /* 293624 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(293653), // Rule ID 5124 //
     /* 293629 */     // MIs[0] Operand 1
     /* 293629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293642 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 293645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293651 */     GIR_RootConstrainSelectedInstOperands,
     /* 293652 */     // GIR_Coverage, 5124,
     /* 293652 */     GIR_EraseRootFromParent_Done,
     /* 293653 */   // Label 5795: @293653
     /* 293653 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(293682), // Rule ID 5131 //
     /* 293658 */     // MIs[0] Operand 1
     /* 293658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293671 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 293674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293680 */     GIR_RootConstrainSelectedInstOperands,
     /* 293681 */     // GIR_Coverage, 5131,
     /* 293681 */     GIR_EraseRootFromParent_Done,
     /* 293682 */   // Label 5796: @293682
     /* 293682 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(293711), // Rule ID 5138 //
     /* 293687 */     // MIs[0] Operand 1
     /* 293687 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293700 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 293703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293709 */     GIR_RootConstrainSelectedInstOperands,
     /* 293710 */     // GIR_Coverage, 5138,
     /* 293710 */     GIR_EraseRootFromParent_Done,
     /* 293711 */   // Label 5797: @293711
     /* 293711 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(293740), // Rule ID 5145 //
     /* 293716 */     // MIs[0] Operand 1
     /* 293716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293729 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 293729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 293732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293738 */     GIR_RootConstrainSelectedInstOperands,
     /* 293739 */     // GIR_Coverage, 5145,
     /* 293739 */     GIR_EraseRootFromParent_Done,
     /* 293740 */   // Label 5798: @293740
     /* 293740 */   GIM_Reject,
     /* 293741 */ // Label 5768: @293741
     /* 293741 */ GIM_Reject,
     /* 293742 */ // Label 5599: @293742
     /* 293742 */ GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(294789),
     /* 293747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 293750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 293753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293757 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(293797), // Rule ID 751 //
     /* 293762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293765 */     // MIs[0] Operand 1
     /* 293765 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293788 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 293791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293795 */     GIR_RootConstrainSelectedInstOperands,
     /* 293796 */     // GIR_Coverage, 751,
     /* 293796 */     GIR_EraseRootFromParent_Done,
     /* 293797 */   // Label 5800: @293797
     /* 293797 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(293837), // Rule ID 758 //
     /* 293802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293805 */     // MIs[0] Operand 1
     /* 293805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293814 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293820 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293828 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 293831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293835 */     GIR_RootConstrainSelectedInstOperands,
     /* 293836 */     // GIR_Coverage, 758,
     /* 293836 */     GIR_EraseRootFromParent_Done,
     /* 293837 */   // Label 5801: @293837
     /* 293837 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(293874), // Rule ID 5185 //
     /* 293842 */     // MIs[0] Operand 1
     /* 293842 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293851 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293857 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293865 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 293868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293872 */     GIR_RootConstrainSelectedInstOperands,
     /* 293873 */     // GIR_Coverage, 5185,
     /* 293873 */     GIR_EraseRootFromParent_Done,
     /* 293874 */   // Label 5802: @293874
     /* 293874 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(293911), // Rule ID 5192 //
     /* 293879 */     // MIs[0] Operand 1
     /* 293879 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293902 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 293905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293909 */     GIR_RootConstrainSelectedInstOperands,
     /* 293910 */     // GIR_Coverage, 5192,
     /* 293910 */     GIR_EraseRootFromParent_Done,
     /* 293911 */   // Label 5803: @293911
     /* 293911 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(293948), // Rule ID 5199 //
     /* 293916 */     // MIs[0] Operand 1
     /* 293916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293939 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 293942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293946 */     GIR_RootConstrainSelectedInstOperands,
     /* 293947 */     // GIR_Coverage, 5199,
     /* 293947 */     GIR_EraseRootFromParent_Done,
     /* 293948 */   // Label 5804: @293948
     /* 293948 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(293985), // Rule ID 5206 //
     /* 293953 */     // MIs[0] Operand 1
     /* 293953 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293962 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293968 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293976 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 293976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 293979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293983 */     GIR_RootConstrainSelectedInstOperands,
     /* 293984 */     // GIR_Coverage, 5206,
     /* 293984 */     GIR_EraseRootFromParent_Done,
     /* 293985 */   // Label 5805: @293985
     /* 293985 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(294022), // Rule ID 5213 //
     /* 293990 */     // MIs[0] Operand 1
     /* 293990 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294013 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 294016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294020 */     GIR_RootConstrainSelectedInstOperands,
     /* 294021 */     // GIR_Coverage, 5213,
     /* 294021 */     GIR_EraseRootFromParent_Done,
     /* 294022 */   // Label 5806: @294022
     /* 294022 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(294062), // Rule ID 723 //
     /* 294027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294030 */     // MIs[0] Operand 1
     /* 294030 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294053 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 294056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294060 */     GIR_RootConstrainSelectedInstOperands,
     /* 294061 */     // GIR_Coverage, 723,
     /* 294061 */     GIR_EraseRootFromParent_Done,
     /* 294062 */   // Label 5807: @294062
     /* 294062 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(294102), // Rule ID 731 //
     /* 294067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294070 */     // MIs[0] Operand 1
     /* 294070 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294083 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294089 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294093 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 294096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294100 */     GIR_RootConstrainSelectedInstOperands,
     /* 294101 */     // GIR_Coverage, 731,
     /* 294101 */     GIR_EraseRootFromParent_Done,
     /* 294102 */   // Label 5808: @294102
     /* 294102 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(294142), // Rule ID 732 //
     /* 294107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294110 */     // MIs[0] Operand 1
     /* 294110 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294133 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 294136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294140 */     GIR_RootConstrainSelectedInstOperands,
     /* 294141 */     // GIR_Coverage, 732,
     /* 294141 */     GIR_EraseRootFromParent_Done,
     /* 294142 */   // Label 5809: @294142
     /* 294142 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(294182), // Rule ID 744 //
     /* 294147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294150 */     // MIs[0] Operand 1
     /* 294150 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294173 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 294176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294180 */     GIR_RootConstrainSelectedInstOperands,
     /* 294181 */     // GIR_Coverage, 744,
     /* 294181 */     GIR_EraseRootFromParent_Done,
     /* 294182 */   // Label 5810: @294182
     /* 294182 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(294219), // Rule ID 5150 //
     /* 294187 */     // MIs[0] Operand 1
     /* 294187 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294210 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 294213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294217 */     GIR_RootConstrainSelectedInstOperands,
     /* 294218 */     // GIR_Coverage, 5150,
     /* 294218 */     GIR_EraseRootFromParent_Done,
     /* 294219 */   // Label 5811: @294219
     /* 294219 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(294256), // Rule ID 5157 //
     /* 294224 */     // MIs[0] Operand 1
     /* 294224 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294247 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 294250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294254 */     GIR_RootConstrainSelectedInstOperands,
     /* 294255 */     // GIR_Coverage, 5157,
     /* 294255 */     GIR_EraseRootFromParent_Done,
     /* 294256 */   // Label 5812: @294256
     /* 294256 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(294293), // Rule ID 5164 //
     /* 294261 */     // MIs[0] Operand 1
     /* 294261 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294284 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 294287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294291 */     GIR_RootConstrainSelectedInstOperands,
     /* 294292 */     // GIR_Coverage, 5164,
     /* 294292 */     GIR_EraseRootFromParent_Done,
     /* 294293 */   // Label 5813: @294293
     /* 294293 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(294330), // Rule ID 5171 //
     /* 294298 */     // MIs[0] Operand 1
     /* 294298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294321 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 294324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294328 */     GIR_RootConstrainSelectedInstOperands,
     /* 294329 */     // GIR_Coverage, 5171,
     /* 294329 */     GIR_EraseRootFromParent_Done,
     /* 294330 */   // Label 5814: @294330
     /* 294330 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(294367), // Rule ID 5178 //
     /* 294335 */     // MIs[0] Operand 1
     /* 294335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294348 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294354 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294358 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 294358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 294361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294365 */     GIR_RootConstrainSelectedInstOperands,
     /* 294366 */     // GIR_Coverage, 5178,
     /* 294366 */     GIR_EraseRootFromParent_Done,
     /* 294367 */   // Label 5815: @294367
     /* 294367 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(294399), // Rule ID 1122 //
     /* 294372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294375 */     // MIs[0] Operand 1
     /* 294375 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294388 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 294391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294397 */     GIR_RootConstrainSelectedInstOperands,
     /* 294398 */     // GIR_Coverage, 1122,
     /* 294398 */     GIR_EraseRootFromParent_Done,
     /* 294399 */   // Label 5816: @294399
     /* 294399 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(294431), // Rule ID 1129 //
     /* 294404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294407 */     // MIs[0] Operand 1
     /* 294407 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294420 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294429 */     GIR_RootConstrainSelectedInstOperands,
     /* 294430 */     // GIR_Coverage, 1129,
     /* 294430 */     GIR_EraseRootFromParent_Done,
     /* 294431 */   // Label 5817: @294431
     /* 294431 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(294463), // Rule ID 1136 //
     /* 294436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294439 */     // MIs[0] Operand 1
     /* 294439 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294452 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294461 */     GIR_RootConstrainSelectedInstOperands,
     /* 294462 */     // GIR_Coverage, 1136,
     /* 294462 */     GIR_EraseRootFromParent_Done,
     /* 294463 */   // Label 5818: @294463
     /* 294463 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(294495), // Rule ID 1143 //
     /* 294468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294471 */     // MIs[0] Operand 1
     /* 294471 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294484 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294493 */     GIR_RootConstrainSelectedInstOperands,
     /* 294494 */     // GIR_Coverage, 1143,
     /* 294494 */     GIR_EraseRootFromParent_Done,
     /* 294495 */   // Label 5819: @294495
     /* 294495 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(294527), // Rule ID 1150 //
     /* 294500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294503 */     // MIs[0] Operand 1
     /* 294503 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294516 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294525 */     GIR_RootConstrainSelectedInstOperands,
     /* 294526 */     // GIR_Coverage, 1150,
     /* 294526 */     GIR_EraseRootFromParent_Done,
     /* 294527 */   // Label 5820: @294527
     /* 294527 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(294556), // Rule ID 5087 //
     /* 294532 */     // MIs[0] Operand 1
     /* 294532 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294545 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 294548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294554 */     GIR_RootConstrainSelectedInstOperands,
     /* 294555 */     // GIR_Coverage, 5087,
     /* 294555 */     GIR_EraseRootFromParent_Done,
     /* 294556 */   // Label 5821: @294556
     /* 294556 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(294585), // Rule ID 5094 //
     /* 294561 */     // MIs[0] Operand 1
     /* 294561 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294574 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294583 */     GIR_RootConstrainSelectedInstOperands,
     /* 294584 */     // GIR_Coverage, 5094,
     /* 294584 */     GIR_EraseRootFromParent_Done,
     /* 294585 */   // Label 5822: @294585
     /* 294585 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(294614), // Rule ID 5101 //
     /* 294590 */     // MIs[0] Operand 1
     /* 294590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294603 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294612 */     GIR_RootConstrainSelectedInstOperands,
     /* 294613 */     // GIR_Coverage, 5101,
     /* 294613 */     GIR_EraseRootFromParent_Done,
     /* 294614 */   // Label 5823: @294614
     /* 294614 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(294643), // Rule ID 5108 //
     /* 294619 */     // MIs[0] Operand 1
     /* 294619 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294632 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294641 */     GIR_RootConstrainSelectedInstOperands,
     /* 294642 */     // GIR_Coverage, 5108,
     /* 294642 */     GIR_EraseRootFromParent_Done,
     /* 294643 */   // Label 5824: @294643
     /* 294643 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(294672), // Rule ID 5115 //
     /* 294648 */     // MIs[0] Operand 1
     /* 294648 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294661 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 294661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294670 */     GIR_RootConstrainSelectedInstOperands,
     /* 294671 */     // GIR_Coverage, 5115,
     /* 294671 */     GIR_EraseRootFromParent_Done,
     /* 294672 */   // Label 5825: @294672
     /* 294672 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(294701), // Rule ID 5122 //
     /* 294677 */     // MIs[0] Operand 1
     /* 294677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294690 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 294693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294699 */     GIR_RootConstrainSelectedInstOperands,
     /* 294700 */     // GIR_Coverage, 5122,
     /* 294700 */     GIR_EraseRootFromParent_Done,
     /* 294701 */   // Label 5826: @294701
     /* 294701 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(294730), // Rule ID 5129 //
     /* 294706 */     // MIs[0] Operand 1
     /* 294706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294719 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 294722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294728 */     GIR_RootConstrainSelectedInstOperands,
     /* 294729 */     // GIR_Coverage, 5129,
     /* 294729 */     GIR_EraseRootFromParent_Done,
     /* 294730 */   // Label 5827: @294730
     /* 294730 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(294759), // Rule ID 5136 //
     /* 294735 */     // MIs[0] Operand 1
     /* 294735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294748 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 294751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294757 */     GIR_RootConstrainSelectedInstOperands,
     /* 294758 */     // GIR_Coverage, 5136,
     /* 294758 */     GIR_EraseRootFromParent_Done,
     /* 294759 */   // Label 5828: @294759
     /* 294759 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(294788), // Rule ID 5143 //
     /* 294764 */     // MIs[0] Operand 1
     /* 294764 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294777 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 294777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 294780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294786 */     GIR_RootConstrainSelectedInstOperands,
     /* 294787 */     // GIR_Coverage, 5143,
     /* 294787 */     GIR_EraseRootFromParent_Done,
     /* 294788 */   // Label 5829: @294788
     /* 294788 */   GIM_Reject,
     /* 294789 */ // Label 5799: @294789
     /* 294789 */ GIM_Reject,
     /* 294790 */ // Label 5600: @294790
     /* 294790 */ GIM_Reject,
     /* 294791 */ // Label 52: @294791
     /* 294791 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5842*/ GIMT_Encode4(295835),
     /* 294802 */ /*GILLT_nxv1s1*//*Label 5830*/ GIMT_Encode4(294850),
     /* 294806 */ /*GILLT_nxv2s1*//*Label 5831*/ GIMT_Encode4(294879),
     /* 294810 */ /*GILLT_nxv2s16*//*Label 5832*/ GIMT_Encode4(294908),
     /* 294814 */ /*GILLT_nxv2s32*//*Label 5833*/ GIMT_Encode4(294993),
     /* 294818 */ /*GILLT_nxv2s64*//*Label 5834*/ GIMT_Encode4(295078),
     /* 294822 */ /*GILLT_nxv4s1*//*Label 5835*/ GIMT_Encode4(295244),
     /* 294826 */ /*GILLT_nxv4s16*//*Label 5836*/ GIMT_Encode4(295273),
     /* 294830 */ /*GILLT_nxv4s32*//*Label 5837*/ GIMT_Encode4(295358),
     /* 294834 */ /*GILLT_nxv8s1*//*Label 5838*/ GIMT_Encode4(295524),
     /* 294838 */ /*GILLT_nxv8s16*//*Label 5839*/ GIMT_Encode4(295553),
     /* 294842 */ /*GILLT_nxv16s1*//*Label 5840*/ GIMT_Encode4(295719),
     /* 294846 */ /*GILLT_nxv16s8*//*Label 5841*/ GIMT_Encode4(295748),
     /* 294850 */ // Label 5830: @294850
     /* 294850 */ GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(294878), // Rule ID 8495 //
     /* 294855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 294861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 294864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 294867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 294871 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 294871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 294876 */   GIR_RootConstrainSelectedInstOperands,
     /* 294877 */   // GIR_Coverage, 8495,
     /* 294877 */   GIR_Done,
     /* 294878 */ // Label 5843: @294878
     /* 294878 */ GIM_Reject,
     /* 294879 */ // Label 5831: @294879
     /* 294879 */ GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(294907), // Rule ID 8494 //
     /* 294884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 294893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 294896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 294900 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 294900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 294905 */   GIR_RootConstrainSelectedInstOperands,
     /* 294906 */   // GIR_Coverage, 8494,
     /* 294906 */   GIR_Done,
     /* 294907 */ // Label 5844: @294907
     /* 294907 */ GIM_Reject,
     /* 294908 */ // Label 5832: @294908
     /* 294908 */ GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(294992),
     /* 294913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 294916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 294919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 294922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 294926 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(294976), // Rule ID 3154 //
     /* 294931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 294942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294954 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 294958 */     // MIs[2] Operand 1
     /* 294958 */     // No operand predicates
     /* 294958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294960 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 294960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 294963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 294965 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 294967 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 294969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 294974 */     GIR_RootConstrainSelectedInstOperands,
     /* 294975 */     // GIR_Coverage, 3154,
     /* 294975 */     GIR_EraseRootFromParent_Done,
     /* 294976 */   // Label 5846: @294976
     /* 294976 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(294991), // Rule ID 2734 //
     /* 294981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 294984 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 294984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 294989 */     GIR_RootConstrainSelectedInstOperands,
     /* 294990 */     // GIR_Coverage, 2734,
     /* 294990 */     GIR_Done,
     /* 294991 */   // Label 5847: @294991
     /* 294991 */   GIM_Reject,
     /* 294992 */ // Label 5845: @294992
     /* 294992 */ GIM_Reject,
     /* 294993 */ // Label 5833: @294993
     /* 294993 */ GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(295077),
     /* 294998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 295001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 295004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 295007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295011 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(295061), // Rule ID 3156 //
     /* 295016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295039 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 295043 */     // MIs[2] Operand 1
     /* 295043 */     // No operand predicates
     /* 295043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295045 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 295045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 295048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295050 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295052 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295054 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 295059 */     GIR_RootConstrainSelectedInstOperands,
     /* 295060 */     // GIR_Coverage, 3156,
     /* 295060 */     GIR_EraseRootFromParent_Done,
     /* 295061 */   // Label 5849: @295061
     /* 295061 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(295076), // Rule ID 2735 //
     /* 295066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295069 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 295069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 295074 */     GIR_RootConstrainSelectedInstOperands,
     /* 295075 */     // GIR_Coverage, 2735,
     /* 295075 */     GIR_Done,
     /* 295076 */   // Label 5850: @295076
     /* 295076 */   GIM_Reject,
     /* 295077 */ // Label 5848: @295077
     /* 295077 */ GIM_Reject,
     /* 295078 */ // Label 5834: @295078
     /* 295078 */ GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(295243),
     /* 295083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 295086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 295089 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(295146), // Rule ID 3157 //
     /* 295094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 295100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 295116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295124 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 295128 */     // MIs[2] Operand 1
     /* 295128 */     // No operand predicates
     /* 295128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295130 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 295130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 295133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295135 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295137 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295139 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 295144 */     GIR_RootConstrainSelectedInstOperands,
     /* 295145 */     // GIR_Coverage, 3157,
     /* 295145 */     GIR_EraseRootFromParent_Done,
     /* 295146 */   // Label 5852: @295146
     /* 295146 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(295198), // Rule ID 7541 //
     /* 295151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 295170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 295174 */     // MIs[0] Op2
     /* 295174 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295181 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 295181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 295184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295196 */     GIR_RootConstrainSelectedInstOperands,
     /* 295197 */     // GIR_Coverage, 7541,
     /* 295197 */     GIR_EraseRootFromParent_Done,
     /* 295198 */   // Label 5853: @295198
     /* 295198 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(295220), // Rule ID 2730 //
     /* 295203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 295209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295213 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 295213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 295218 */     GIR_RootConstrainSelectedInstOperands,
     /* 295219 */     // GIR_Coverage, 2730,
     /* 295219 */     GIR_Done,
     /* 295220 */   // Label 5854: @295220
     /* 295220 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(295242), // Rule ID 2736 //
     /* 295225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 295231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295235 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 295235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 295240 */     GIR_RootConstrainSelectedInstOperands,
     /* 295241 */     // GIR_Coverage, 2736,
     /* 295241 */     GIR_Done,
     /* 295242 */   // Label 5855: @295242
     /* 295242 */   GIM_Reject,
     /* 295243 */ // Label 5851: @295243
     /* 295243 */ GIM_Reject,
     /* 295244 */ // Label 5835: @295244
     /* 295244 */ GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(295272), // Rule ID 8493 //
     /* 295249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 295258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 295261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295265 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 295265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295270 */   GIR_RootConstrainSelectedInstOperands,
     /* 295271 */   // GIR_Coverage, 8493,
     /* 295271 */   GIR_Done,
     /* 295272 */ // Label 5856: @295272
     /* 295272 */ GIM_Reject,
     /* 295273 */ // Label 5836: @295273
     /* 295273 */ GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(295357),
     /* 295278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 295284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 295287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295291 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(295341), // Rule ID 3153 //
     /* 295296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295319 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 295323 */     // MIs[2] Operand 1
     /* 295323 */     // No operand predicates
     /* 295323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295325 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 295325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 295328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295330 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295332 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295334 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 295339 */     GIR_RootConstrainSelectedInstOperands,
     /* 295340 */     // GIR_Coverage, 3153,
     /* 295340 */     GIR_EraseRootFromParent_Done,
     /* 295341 */   // Label 5858: @295341
     /* 295341 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(295356), // Rule ID 2732 //
     /* 295346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295349 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 295349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295354 */     GIR_RootConstrainSelectedInstOperands,
     /* 295355 */     // GIR_Coverage, 2732,
     /* 295355 */     GIR_Done,
     /* 295356 */   // Label 5859: @295356
     /* 295356 */   GIM_Reject,
     /* 295357 */ // Label 5857: @295357
     /* 295357 */ GIM_Reject,
     /* 295358 */ // Label 5837: @295358
     /* 295358 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(295523),
     /* 295363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 295366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 295369 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(295426), // Rule ID 3155 //
     /* 295374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295404 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 295408 */     // MIs[2] Operand 1
     /* 295408 */     // No operand predicates
     /* 295408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295410 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 295410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 295413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295415 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295417 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295419 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 295424 */     GIR_RootConstrainSelectedInstOperands,
     /* 295425 */     // GIR_Coverage, 3155,
     /* 295425 */     GIR_EraseRootFromParent_Done,
     /* 295426 */   // Label 5861: @295426
     /* 295426 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(295478), // Rule ID 7539 //
     /* 295431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 295450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 295454 */     // MIs[0] Op2
     /* 295454 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295461 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 295461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 295464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295476 */     GIR_RootConstrainSelectedInstOperands,
     /* 295477 */     // GIR_Coverage, 7539,
     /* 295477 */     GIR_EraseRootFromParent_Done,
     /* 295478 */   // Label 5862: @295478
     /* 295478 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(295500), // Rule ID 2729 //
     /* 295483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295493 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 295493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295498 */     GIR_RootConstrainSelectedInstOperands,
     /* 295499 */     // GIR_Coverage, 2729,
     /* 295499 */     GIR_Done,
     /* 295500 */   // Label 5863: @295500
     /* 295500 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(295522), // Rule ID 2733 //
     /* 295505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 295511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295515 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 295515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 295520 */     GIR_RootConstrainSelectedInstOperands,
     /* 295521 */     // GIR_Coverage, 2733,
     /* 295521 */     GIR_Done,
     /* 295522 */   // Label 5864: @295522
     /* 295522 */   GIM_Reject,
     /* 295523 */ // Label 5860: @295523
     /* 295523 */ GIM_Reject,
     /* 295524 */ // Label 5838: @295524
     /* 295524 */ GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(295552), // Rule ID 8492 //
     /* 295529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 295535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 295538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 295541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295545 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 295545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295550 */   GIR_RootConstrainSelectedInstOperands,
     /* 295551 */   // GIR_Coverage, 8492,
     /* 295551 */   GIR_Done,
     /* 295552 */ // Label 5865: @295552
     /* 295552 */ GIM_Reject,
     /* 295553 */ // Label 5839: @295553
     /* 295553 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(295718),
     /* 295558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 295561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 295564 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(295621), // Rule ID 3152 //
     /* 295569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 295587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295599 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 295603 */     // MIs[2] Operand 1
     /* 295603 */     // No operand predicates
     /* 295603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295605 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 295605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 295608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 295610 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 295612 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 295614 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 295619 */     GIR_RootConstrainSelectedInstOperands,
     /* 295620 */     // GIR_Coverage, 3152,
     /* 295620 */     GIR_EraseRootFromParent_Done,
     /* 295621 */   // Label 5867: @295621
     /* 295621 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(295673), // Rule ID 7537 //
     /* 295626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 295645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 295649 */     // MIs[0] Op2
     /* 295649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295656 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 295656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 295659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295671 */     GIR_RootConstrainSelectedInstOperands,
     /* 295672 */     // GIR_Coverage, 7537,
     /* 295672 */     GIR_EraseRootFromParent_Done,
     /* 295673 */   // Label 5868: @295673
     /* 295673 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(295695), // Rule ID 2728 //
     /* 295678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295688 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 295688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 295693 */     GIR_RootConstrainSelectedInstOperands,
     /* 295694 */     // GIR_Coverage, 2728,
     /* 295694 */     GIR_Done,
     /* 295695 */   // Label 5869: @295695
     /* 295695 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(295717), // Rule ID 2731 //
     /* 295700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 295706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295710 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 295710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 295715 */     GIR_RootConstrainSelectedInstOperands,
     /* 295716 */     // GIR_Coverage, 2731,
     /* 295716 */     GIR_Done,
     /* 295717 */   // Label 5870: @295717
     /* 295717 */   GIM_Reject,
     /* 295718 */ // Label 5866: @295718
     /* 295718 */ GIM_Reject,
     /* 295719 */ // Label 5840: @295719
     /* 295719 */ GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(295747), // Rule ID 8491 //
     /* 295724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 295730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 295733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 295736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 295740 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 295740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 295745 */   GIR_RootConstrainSelectedInstOperands,
     /* 295746 */   // GIR_Coverage, 8491,
     /* 295746 */   GIR_Done,
     /* 295747 */ // Label 5871: @295747
     /* 295747 */ GIM_Reject,
     /* 295748 */ // Label 5841: @295748
     /* 295748 */ GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(295834),
     /* 295753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 295756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 295759 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(295811), // Rule ID 7535 //
     /* 295764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 295779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 295783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 295787 */     // MIs[0] Op2
     /* 295787 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 295792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295794 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 295794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 295797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 295799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 295801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 295805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 295809 */     GIR_RootConstrainSelectedInstOperands,
     /* 295810 */     // GIR_Coverage, 7535,
     /* 295810 */     GIR_EraseRootFromParent_Done,
     /* 295811 */   // Label 5873: @295811
     /* 295811 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(295833), // Rule ID 2727 //
     /* 295816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 295819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 295822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 295826 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 295826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 295831 */     GIR_RootConstrainSelectedInstOperands,
     /* 295832 */     // GIR_Coverage, 2727,
     /* 295832 */     GIR_Done,
     /* 295833 */   // Label 5874: @295833
     /* 295833 */   GIM_Reject,
     /* 295834 */ // Label 5872: @295834
     /* 295834 */ GIM_Reject,
     /* 295835 */ // Label 5842: @295835
     /* 295835 */ GIM_Reject,
     /* 295836 */ // Label 53: @295836
     /* 295836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5879*/ GIMT_Encode4(296319),
     /* 295847 */ /*GILLT_s64*//*Label 5875*/ GIMT_Encode4(295883), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 295867 */ /*GILLT_v4s32*//*Label 5876*/ GIMT_Encode4(295914), GIMT_Encode4(0),
     /* 295875 */ /*GILLT_v8s16*//*Label 5877*/ GIMT_Encode4(296049),
     /* 295879 */ /*GILLT_v16s8*//*Label 5878*/ GIMT_Encode4(296184),
     /* 295883 */ // Label 5875: @295883
     /* 295883 */ GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(295913), // Rule ID 128 //
     /* 295888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 295906 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 295906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 295911 */   GIR_RootConstrainSelectedInstOperands,
     /* 295912 */   // GIR_Coverage, 128,
     /* 295912 */   GIR_Done,
     /* 295913 */ // Label 5880: @295913
     /* 295913 */ GIM_Reject,
     /* 295914 */ // Label 5876: @295914
     /* 295914 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(296048), // Rule ID 6561 //
     /* 295919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295937 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 295937 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 295940 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 295944 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295949 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 295953 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 295957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 295959 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 295962 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295966 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295971 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295977 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295982 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 295990 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295994 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295999 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296005 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296010 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 296022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296027 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296030 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 296038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296046 */   GIR_RootConstrainSelectedInstOperands,
     /* 296047 */   // GIR_Coverage, 6561,
     /* 296047 */   GIR_EraseRootFromParent_Done,
     /* 296048 */ // Label 5881: @296048
     /* 296048 */ GIM_Reject,
     /* 296049 */ // Label 5877: @296049
     /* 296049 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(296183), // Rule ID 6560 //
     /* 296054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296072 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 296072 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296075 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 296079 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296084 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296088 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296094 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296097 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296101 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296106 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296112 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296117 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296122 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296125 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296129 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296134 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296140 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296145 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 296157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296162 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296165 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 296173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296181 */   GIR_RootConstrainSelectedInstOperands,
     /* 296182 */   // GIR_Coverage, 6560,
     /* 296182 */   GIR_EraseRootFromParent_Done,
     /* 296183 */ // Label 5882: @296183
     /* 296183 */ GIM_Reject,
     /* 296184 */ // Label 5878: @296184
     /* 296184 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(296318), // Rule ID 6559 //
     /* 296189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 296192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 296195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296207 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 296207 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296210 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 296214 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296219 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296223 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296229 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296232 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296236 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296241 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296247 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296252 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296257 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296260 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296264 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296269 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296275 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296280 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 296292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 296308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296316 */   GIR_RootConstrainSelectedInstOperands,
     /* 296317 */   // GIR_Coverage, 6559,
     /* 296317 */   GIR_EraseRootFromParent_Done,
     /* 296318 */ // Label 5883: @296318
     /* 296318 */ GIM_Reject,
     /* 296319 */ // Label 5879: @296319
     /* 296319 */ GIM_Reject,
     /* 296320 */ // Label 54: @296320
     /* 296320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5888*/ GIMT_Encode4(296803),
     /* 296331 */ /*GILLT_s64*//*Label 5884*/ GIMT_Encode4(296367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296351 */ /*GILLT_v4s32*//*Label 5885*/ GIMT_Encode4(296398), GIMT_Encode4(0),
     /* 296359 */ /*GILLT_v8s16*//*Label 5886*/ GIMT_Encode4(296533),
     /* 296363 */ /*GILLT_v16s8*//*Label 5887*/ GIMT_Encode4(296668),
     /* 296367 */ // Label 5884: @296367
     /* 296367 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(296397), // Rule ID 127 //
     /* 296372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 296375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 296378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 296390 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 296390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 296395 */   GIR_RootConstrainSelectedInstOperands,
     /* 296396 */   // GIR_Coverage, 127,
     /* 296396 */   GIR_Done,
     /* 296397 */ // Label 5889: @296397
     /* 296397 */ GIM_Reject,
     /* 296398 */ // Label 5885: @296398
     /* 296398 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(296532), // Rule ID 6558 //
     /* 296403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 296409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296421 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 296421 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296424 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 296428 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296433 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296437 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296443 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296446 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296450 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296455 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296461 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296466 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296471 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296474 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296478 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296483 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296494 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 296506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296511 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296514 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 296522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296530 */   GIR_RootConstrainSelectedInstOperands,
     /* 296531 */   // GIR_Coverage, 6558,
     /* 296531 */   GIR_EraseRootFromParent_Done,
     /* 296532 */ // Label 5890: @296532
     /* 296532 */ GIM_Reject,
     /* 296533 */ // Label 5886: @296533
     /* 296533 */ GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(296667), // Rule ID 6557 //
     /* 296538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296556 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 296556 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296559 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 296563 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296568 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296572 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296578 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296581 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296585 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296590 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296596 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296601 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296618 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296624 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296629 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 296641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296646 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296649 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 296657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296665 */   GIR_RootConstrainSelectedInstOperands,
     /* 296666 */   // GIR_Coverage, 6557,
     /* 296666 */   GIR_EraseRootFromParent_Done,
     /* 296667 */ // Label 5891: @296667
     /* 296667 */ GIM_Reject,
     /* 296668 */ // Label 5887: @296668
     /* 296668 */ GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(296802), // Rule ID 6556 //
     /* 296673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 296676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 296679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296691 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 296691 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 296694 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 296698 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296703 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296707 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296713 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 296716 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296720 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296725 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296731 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296736 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296741 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296744 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296748 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296753 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296759 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296764 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 296776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296781 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296784 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 296789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 296792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 296800 */   GIR_RootConstrainSelectedInstOperands,
     /* 296801 */   // GIR_Coverage, 6556,
     /* 296801 */   GIR_EraseRootFromParent_Done,
     /* 296802 */ // Label 5892: @296802
     /* 296802 */ GIM_Reject,
     /* 296803 */ // Label 5888: @296803
     /* 296803 */ GIM_Reject,
     /* 296804 */ // Label 55: @296804
     /* 296804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5904*/ GIMT_Encode4(297233),
     /* 296815 */ /*GILLT_v2s32*//*Label 5893*/ GIMT_Encode4(296891),
     /* 296819 */ /*GILLT_v2s64*//*Label 5894*/ GIMT_Encode4(296925),
     /* 296823 */ /*GILLT_v4s16*//*Label 5895*/ GIMT_Encode4(296959),
     /* 296827 */ /*GILLT_v4s32*//*Label 5896*/ GIMT_Encode4(296993),
     /* 296831 */ /*GILLT_v8s8*//*Label 5897*/ GIMT_Encode4(297027),
     /* 296835 */ /*GILLT_v8s16*//*Label 5898*/ GIMT_Encode4(297061),
     /* 296839 */ /*GILLT_v16s8*//*Label 5899*/ GIMT_Encode4(297095), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296859 */ /*GILLT_nxv2s64*//*Label 5900*/ GIMT_Encode4(297129), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 296871 */ /*GILLT_nxv4s32*//*Label 5901*/ GIMT_Encode4(297155), GIMT_Encode4(0),
     /* 296879 */ /*GILLT_nxv8s16*//*Label 5902*/ GIMT_Encode4(297181), GIMT_Encode4(0),
     /* 296887 */ /*GILLT_nxv16s8*//*Label 5903*/ GIMT_Encode4(297207),
     /* 296891 */ // Label 5893: @296891
     /* 296891 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(296924), // Rule ID 1543 //
     /* 296896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 296905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296917 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 296917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 296922 */   GIR_RootConstrainSelectedInstOperands,
     /* 296923 */   // GIR_Coverage, 1543,
     /* 296923 */   GIR_Done,
     /* 296924 */ // Label 5905: @296924
     /* 296924 */ GIM_Reject,
     /* 296925 */ // Label 5894: @296925
     /* 296925 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(296958), // Rule ID 1545 //
     /* 296930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 296939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296951 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 296951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 296956 */   GIR_RootConstrainSelectedInstOperands,
     /* 296957 */   // GIR_Coverage, 1545,
     /* 296957 */   GIR_Done,
     /* 296958 */ // Label 5906: @296958
     /* 296958 */ GIM_Reject,
     /* 296959 */ // Label 5895: @296959
     /* 296959 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(296992), // Rule ID 1541 //
     /* 296964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 296970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 296973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296985 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 296985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 296990 */   GIR_RootConstrainSelectedInstOperands,
     /* 296991 */   // GIR_Coverage, 1541,
     /* 296991 */   GIR_Done,
     /* 296992 */ // Label 5907: @296992
     /* 296992 */ GIM_Reject,
     /* 296993 */ // Label 5896: @296993
     /* 296993 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(297026), // Rule ID 1544 //
     /* 296998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297019 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 297019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 297024 */   GIR_RootConstrainSelectedInstOperands,
     /* 297025 */   // GIR_Coverage, 1544,
     /* 297025 */   GIR_Done,
     /* 297026 */ // Label 5908: @297026
     /* 297026 */ GIM_Reject,
     /* 297027 */ // Label 5897: @297027
     /* 297027 */ GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(297060), // Rule ID 1539 //
     /* 297032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 297038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 297041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297053 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 297053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 297058 */   GIR_RootConstrainSelectedInstOperands,
     /* 297059 */   // GIR_Coverage, 1539,
     /* 297059 */   GIR_Done,
     /* 297060 */ // Label 5909: @297060
     /* 297060 */ GIM_Reject,
     /* 297061 */ // Label 5898: @297061
     /* 297061 */ GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(297094), // Rule ID 1542 //
     /* 297066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297087 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 297092 */   GIR_RootConstrainSelectedInstOperands,
     /* 297093 */   // GIR_Coverage, 1542,
     /* 297093 */   GIR_Done,
     /* 297094 */ // Label 5910: @297094
     /* 297094 */ GIM_Reject,
     /* 297095 */ // Label 5899: @297095
     /* 297095 */ GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(297128), // Rule ID 1540 //
     /* 297100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 297106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297121 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 297121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 297126 */   GIR_RootConstrainSelectedInstOperands,
     /* 297127 */   // GIR_Coverage, 1540,
     /* 297127 */   GIR_Done,
     /* 297128 */ // Label 5911: @297128
     /* 297128 */ GIM_Reject,
     /* 297129 */ // Label 5900: @297129
     /* 297129 */ GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(297154), // Rule ID 7493 //
     /* 297134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 297140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 297143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297147 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 297147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 297152 */   GIR_RootConstrainSelectedInstOperands,
     /* 297153 */   // GIR_Coverage, 7493,
     /* 297153 */   GIR_Done,
     /* 297154 */ // Label 5912: @297154
     /* 297154 */ GIM_Reject,
     /* 297155 */ // Label 5901: @297155
     /* 297155 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(297180), // Rule ID 7492 //
     /* 297160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 297166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 297169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297173 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 297173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 297178 */   GIR_RootConstrainSelectedInstOperands,
     /* 297179 */   // GIR_Coverage, 7492,
     /* 297179 */   GIR_Done,
     /* 297180 */ // Label 5913: @297180
     /* 297180 */ GIM_Reject,
     /* 297181 */ // Label 5902: @297181
     /* 297181 */ GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(297206), // Rule ID 7491 //
     /* 297186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297199 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 297199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 297204 */   GIR_RootConstrainSelectedInstOperands,
     /* 297205 */   // GIR_Coverage, 7491,
     /* 297205 */   GIR_Done,
     /* 297206 */ // Label 5914: @297206
     /* 297206 */ GIM_Reject,
     /* 297207 */ // Label 5903: @297207
     /* 297207 */ GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(297232), // Rule ID 7490 //
     /* 297212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297225 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 297225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 297230 */   GIR_RootConstrainSelectedInstOperands,
     /* 297231 */   // GIR_Coverage, 7490,
     /* 297231 */   GIR_Done,
     /* 297232 */ // Label 5915: @297232
     /* 297232 */ GIM_Reject,
     /* 297233 */ // Label 5904: @297233
     /* 297233 */ GIM_Reject,
     /* 297234 */ // Label 56: @297234
     /* 297234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5927*/ GIMT_Encode4(299567),
     /* 297245 */ /*GILLT_v2s32*//*Label 5916*/ GIMT_Encode4(297321),
     /* 297249 */ /*GILLT_v2s64*//*Label 5917*/ GIMT_Encode4(297355),
     /* 297253 */ /*GILLT_v4s16*//*Label 5918*/ GIMT_Encode4(298341),
     /* 297257 */ /*GILLT_v4s32*//*Label 5919*/ GIMT_Encode4(298375),
     /* 297261 */ /*GILLT_v8s8*//*Label 5920*/ GIMT_Encode4(299361),
     /* 297265 */ /*GILLT_v8s16*//*Label 5921*/ GIMT_Encode4(299395),
     /* 297269 */ /*GILLT_v16s8*//*Label 5922*/ GIMT_Encode4(299429), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297289 */ /*GILLT_nxv2s64*//*Label 5923*/ GIMT_Encode4(299463), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297301 */ /*GILLT_nxv4s32*//*Label 5924*/ GIMT_Encode4(299489), GIMT_Encode4(0),
     /* 297309 */ /*GILLT_nxv8s16*//*Label 5925*/ GIMT_Encode4(299515), GIMT_Encode4(0),
     /* 297317 */ /*GILLT_nxv16s8*//*Label 5926*/ GIMT_Encode4(299541),
     /* 297321 */ // Label 5916: @297321
     /* 297321 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(297354), // Rule ID 1420 //
     /* 297326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 297332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297347 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 297347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 297352 */   GIR_RootConstrainSelectedInstOperands,
     /* 297353 */   // GIR_Coverage, 1420,
     /* 297353 */   GIR_Done,
     /* 297354 */ // Label 5928: @297354
     /* 297354 */ GIM_Reject,
     /* 297355 */ // Label 5917: @297355
     /* 297355 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298340),
     /* 297360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 297366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297370 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(297492), // Rule ID 13584 //
     /* 297375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297386 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297389 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297398 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297435 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297439 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297443 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297447 */     // MIs[4] Operand 1
     /* 297447 */     // No operand predicates
     /* 297447 */     // MIs[2] Operand 2
     /* 297447 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 297458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297471 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 297474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297490 */     GIR_RootConstrainSelectedInstOperands,
     /* 297491 */     // GIR_Coverage, 13584,
     /* 297491 */     GIR_EraseRootFromParent_Done,
     /* 297492 */   // Label 5930: @297492
     /* 297492 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(297614), // Rule ID 2060 //
     /* 297497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297512 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297515 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297556 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297569 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297573 */     // MIs[4] Operand 1
     /* 297573 */     // No operand predicates
     /* 297573 */     // MIs[2] Operand 2
     /* 297573 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 297584 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297593 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 297596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297612 */     GIR_RootConstrainSelectedInstOperands,
     /* 297613 */     // GIR_Coverage, 2060,
     /* 297613 */     GIR_EraseRootFromParent_Done,
     /* 297614 */   // Label 5931: @297614
     /* 297614 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(297733), // Rule ID 13582 //
     /* 297619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297630 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297633 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297642 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297675 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297679 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297692 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297696 */     // MIs[4] Operand 1
     /* 297696 */     // No operand predicates
     /* 297696 */     // MIs[2] Operand 2
     /* 297696 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 297707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297711 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297713 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 297716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 297724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297731 */     GIR_RootConstrainSelectedInstOperands,
     /* 297732 */     // GIR_Coverage, 13582,
     /* 297732 */     GIR_EraseRootFromParent_Done,
     /* 297733 */   // Label 5932: @297733
     /* 297733 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(297852), // Rule ID 2058 //
     /* 297738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297753 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297756 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297765 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 297778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 297782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 297794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297815 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297819 */     // MIs[4] Operand 1
     /* 297819 */     // No operand predicates
     /* 297819 */     // MIs[2] Operand 2
     /* 297819 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 297830 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297832 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 297832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 297835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 297843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297850 */     GIR_RootConstrainSelectedInstOperands,
     /* 297851 */     // GIR_Coverage, 2058,
     /* 297851 */     GIR_EraseRootFromParent_Done,
     /* 297852 */   // Label 5933: @297852
     /* 297852 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(297923), // Rule ID 13482 //
     /* 297857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297868 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297871 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297904 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 297904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 297907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 297911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 297921 */     GIR_RootConstrainSelectedInstOperands,
     /* 297922 */     // GIR_Coverage, 13482,
     /* 297922 */     GIR_EraseRootFromParent_Done,
     /* 297923 */   // Label 5934: @297923
     /* 297923 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(297994), // Rule ID 1745 //
     /* 297928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297943 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297946 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 297951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297955 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 297975 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 297975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 297978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 297982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 297987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 297992 */     GIR_RootConstrainSelectedInstOperands,
     /* 297993 */     // GIR_Coverage, 1745,
     /* 297993 */     GIR_EraseRootFromParent_Done,
     /* 297994 */   // Label 5935: @297994
     /* 297994 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(298090), // Rule ID 13583 //
     /* 297999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298010 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298013 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298022 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 298039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298060 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298064 */     // MIs[3] Operand 1
     /* 298064 */     // No operand predicates
     /* 298064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298070 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 298073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298088 */     GIR_RootConstrainSelectedInstOperands,
     /* 298089 */     // GIR_Coverage, 13583,
     /* 298089 */     GIR_EraseRootFromParent_Done,
     /* 298090 */   // Label 5936: @298090
     /* 298090 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(298186), // Rule ID 2059 //
     /* 298095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298110 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298113 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298122 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 298139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298160 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298164 */     // MIs[3] Operand 1
     /* 298164 */     // No operand predicates
     /* 298164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298166 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 298169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298184 */     GIR_RootConstrainSelectedInstOperands,
     /* 298185 */     // GIR_Coverage, 2059,
     /* 298185 */     GIR_EraseRootFromParent_Done,
     /* 298186 */   // Label 5937: @298186
     /* 298186 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(298251), // Rule ID 13481 //
     /* 298191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298202 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298205 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298214 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298234 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 298237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 298249 */     GIR_RootConstrainSelectedInstOperands,
     /* 298250 */     // GIR_Coverage, 13481,
     /* 298250 */     GIR_EraseRootFromParent_Done,
     /* 298251 */   // Label 5938: @298251
     /* 298251 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(298316), // Rule ID 1744 //
     /* 298256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298271 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298274 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298299 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 298302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 298314 */     GIR_RootConstrainSelectedInstOperands,
     /* 298315 */     // GIR_Coverage, 1744,
     /* 298315 */     GIR_EraseRootFromParent_Done,
     /* 298316 */   // Label 5939: @298316
     /* 298316 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(298339), // Rule ID 1422 //
     /* 298321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298332 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 298337 */     GIR_RootConstrainSelectedInstOperands,
     /* 298338 */     // GIR_Coverage, 1422,
     /* 298338 */     GIR_Done,
     /* 298339 */   // Label 5940: @298339
     /* 298339 */   GIM_Reject,
     /* 298340 */ // Label 5929: @298340
     /* 298340 */ GIM_Reject,
     /* 298341 */ // Label 5918: @298341
     /* 298341 */ GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(298374), // Rule ID 1418 //
     /* 298346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298367 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 298372 */   GIR_RootConstrainSelectedInstOperands,
     /* 298373 */   // GIR_Coverage, 1418,
     /* 298373 */   GIR_Done,
     /* 298374 */ // Label 5941: @298374
     /* 298374 */ GIM_Reject,
     /* 298375 */ // Label 5919: @298375
     /* 298375 */ GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(299360),
     /* 298380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298390 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(298512), // Rule ID 13581 //
     /* 298395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298406 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298409 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298442 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298450 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298463 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298467 */     // MIs[4] Operand 1
     /* 298467 */     // No operand predicates
     /* 298467 */     // MIs[2] Operand 2
     /* 298467 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 298478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298482 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298491 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 298494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298510 */     GIR_RootConstrainSelectedInstOperands,
     /* 298511 */     // GIR_Coverage, 13581,
     /* 298511 */     GIR_EraseRootFromParent_Done,
     /* 298512 */   // Label 5943: @298512
     /* 298512 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(298634), // Rule ID 2057 //
     /* 298517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298532 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298535 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298572 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298576 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298585 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298589 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298593 */     // MIs[4] Operand 1
     /* 298593 */     // No operand predicates
     /* 298593 */     // MIs[2] Operand 2
     /* 298593 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 298604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298613 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 298616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298632 */     GIR_RootConstrainSelectedInstOperands,
     /* 298633 */     // GIR_Coverage, 2057,
     /* 298633 */     GIR_EraseRootFromParent_Done,
     /* 298634 */   // Label 5944: @298634
     /* 298634 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(298753), // Rule ID 13579 //
     /* 298639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298650 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298653 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298662 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298695 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298699 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298712 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298716 */     // MIs[4] Operand 1
     /* 298716 */     // No operand predicates
     /* 298716 */     // MIs[2] Operand 2
     /* 298716 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 298727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298733 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 298736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298751 */     GIR_RootConstrainSelectedInstOperands,
     /* 298752 */     // GIR_Coverage, 13579,
     /* 298752 */     GIR_EraseRootFromParent_Done,
     /* 298753 */   // Label 5945: @298753
     /* 298753 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(298872), // Rule ID 2055 //
     /* 298758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298773 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298776 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298785 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298822 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298835 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298839 */     // MIs[4] Operand 1
     /* 298839 */     // No operand predicates
     /* 298839 */     // MIs[2] Operand 2
     /* 298839 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 298850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298852 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 298855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 298859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 298863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 298867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 298870 */     GIR_RootConstrainSelectedInstOperands,
     /* 298871 */     // GIR_Coverage, 2055,
     /* 298871 */     GIR_EraseRootFromParent_Done,
     /* 298872 */   // Label 5946: @298872
     /* 298872 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(298943), // Rule ID 13480 //
     /* 298877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298888 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298891 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298900 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298924 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 298927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 298941 */     GIR_RootConstrainSelectedInstOperands,
     /* 298942 */     // GIR_Coverage, 13480,
     /* 298942 */     GIR_EraseRootFromParent_Done,
     /* 298943 */   // Label 5947: @298943
     /* 298943 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(299014), // Rule ID 1743 //
     /* 298948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298963 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298966 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 298995 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 298998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299012 */     GIR_RootConstrainSelectedInstOperands,
     /* 299013 */     // GIR_Coverage, 1743,
     /* 299013 */     GIR_EraseRootFromParent_Done,
     /* 299014 */   // Label 5948: @299014
     /* 299014 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(299110), // Rule ID 13580 //
     /* 299019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299030 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299033 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299042 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 299059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 299072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 299084 */     // MIs[3] Operand 1
     /* 299084 */     // No operand predicates
     /* 299084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299090 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 299093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299108 */     GIR_RootConstrainSelectedInstOperands,
     /* 299109 */     // GIR_Coverage, 13580,
     /* 299109 */     GIR_EraseRootFromParent_Done,
     /* 299110 */   // Label 5949: @299110
     /* 299110 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(299206), // Rule ID 2056 //
     /* 299115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299130 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299133 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299142 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 299159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 299172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 299184 */     // MIs[3] Operand 1
     /* 299184 */     // No operand predicates
     /* 299184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299186 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 299189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299204 */     GIR_RootConstrainSelectedInstOperands,
     /* 299205 */     // GIR_Coverage, 2056,
     /* 299205 */     GIR_EraseRootFromParent_Done,
     /* 299206 */   // Label 5950: @299206
     /* 299206 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(299271), // Rule ID 13479 //
     /* 299211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299222 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299225 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299234 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299254 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 299257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299269 */     GIR_RootConstrainSelectedInstOperands,
     /* 299270 */     // GIR_Coverage, 13479,
     /* 299270 */     GIR_EraseRootFromParent_Done,
     /* 299271 */   // Label 5951: @299271
     /* 299271 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(299336), // Rule ID 1742 //
     /* 299276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299319 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 299322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299334 */     GIR_RootConstrainSelectedInstOperands,
     /* 299335 */     // GIR_Coverage, 1742,
     /* 299335 */     GIR_EraseRootFromParent_Done,
     /* 299336 */   // Label 5952: @299336
     /* 299336 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(299359), // Rule ID 1421 //
     /* 299341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299352 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 299357 */     GIR_RootConstrainSelectedInstOperands,
     /* 299358 */     // GIR_Coverage, 1421,
     /* 299358 */     GIR_Done,
     /* 299359 */   // Label 5953: @299359
     /* 299359 */   GIM_Reject,
     /* 299360 */ // Label 5942: @299360
     /* 299360 */ GIM_Reject,
     /* 299361 */ // Label 5920: @299361
     /* 299361 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299394), // Rule ID 1416 //
     /* 299366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 299372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 299375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299387 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 299387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 299392 */   GIR_RootConstrainSelectedInstOperands,
     /* 299393 */   // GIR_Coverage, 1416,
     /* 299393 */   GIR_Done,
     /* 299394 */ // Label 5954: @299394
     /* 299394 */ GIM_Reject,
     /* 299395 */ // Label 5921: @299395
     /* 299395 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299428), // Rule ID 1419 //
     /* 299400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299421 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 299421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 299426 */   GIR_RootConstrainSelectedInstOperands,
     /* 299427 */   // GIR_Coverage, 1419,
     /* 299427 */   GIR_Done,
     /* 299428 */ // Label 5955: @299428
     /* 299428 */ GIM_Reject,
     /* 299429 */ // Label 5922: @299429
     /* 299429 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(299462), // Rule ID 1417 //
     /* 299434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299455 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 299455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 299460 */   GIR_RootConstrainSelectedInstOperands,
     /* 299461 */   // GIR_Coverage, 1417,
     /* 299461 */   GIR_Done,
     /* 299462 */ // Label 5956: @299462
     /* 299462 */ GIM_Reject,
     /* 299463 */ // Label 5923: @299463
     /* 299463 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299488), // Rule ID 7489 //
     /* 299468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 299474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 299477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299481 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 299481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 299486 */   GIR_RootConstrainSelectedInstOperands,
     /* 299487 */   // GIR_Coverage, 7489,
     /* 299487 */   GIR_Done,
     /* 299488 */ // Label 5957: @299488
     /* 299488 */ GIM_Reject,
     /* 299489 */ // Label 5924: @299489
     /* 299489 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299514), // Rule ID 7488 //
     /* 299494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299507 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 299507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 299512 */   GIR_RootConstrainSelectedInstOperands,
     /* 299513 */   // GIR_Coverage, 7488,
     /* 299513 */   GIR_Done,
     /* 299514 */ // Label 5958: @299514
     /* 299514 */ GIM_Reject,
     /* 299515 */ // Label 5925: @299515
     /* 299515 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(299540), // Rule ID 7487 //
     /* 299520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299533 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 299533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 299538 */   GIR_RootConstrainSelectedInstOperands,
     /* 299539 */   // GIR_Coverage, 7487,
     /* 299539 */   GIR_Done,
     /* 299540 */ // Label 5959: @299540
     /* 299540 */ GIM_Reject,
     /* 299541 */ // Label 5926: @299541
     /* 299541 */ GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(299566), // Rule ID 7486 //
     /* 299546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299559 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 299559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 299564 */   GIR_RootConstrainSelectedInstOperands,
     /* 299565 */   // GIR_Coverage, 7486,
     /* 299565 */   GIR_Done,
     /* 299566 */ // Label 5960: @299566
     /* 299566 */ GIM_Reject,
     /* 299567 */ // Label 5927: @299567
     /* 299567 */ GIM_Reject,
     /* 299568 */ // Label 57: @299568
     /* 299568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5972*/ GIMT_Encode4(299997),
     /* 299579 */ /*GILLT_v2s32*//*Label 5961*/ GIMT_Encode4(299655),
     /* 299583 */ /*GILLT_v2s64*//*Label 5962*/ GIMT_Encode4(299689),
     /* 299587 */ /*GILLT_v4s16*//*Label 5963*/ GIMT_Encode4(299723),
     /* 299591 */ /*GILLT_v4s32*//*Label 5964*/ GIMT_Encode4(299757),
     /* 299595 */ /*GILLT_v8s8*//*Label 5965*/ GIMT_Encode4(299791),
     /* 299599 */ /*GILLT_v8s16*//*Label 5966*/ GIMT_Encode4(299825),
     /* 299603 */ /*GILLT_v16s8*//*Label 5967*/ GIMT_Encode4(299859), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299623 */ /*GILLT_nxv2s64*//*Label 5968*/ GIMT_Encode4(299893), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299635 */ /*GILLT_nxv4s32*//*Label 5969*/ GIMT_Encode4(299919), GIMT_Encode4(0),
     /* 299643 */ /*GILLT_nxv8s16*//*Label 5970*/ GIMT_Encode4(299945), GIMT_Encode4(0),
     /* 299651 */ /*GILLT_nxv16s8*//*Label 5971*/ GIMT_Encode4(299971),
     /* 299655 */ // Label 5961: @299655
     /* 299655 */ GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(299688), // Rule ID 1564 //
     /* 299660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299681 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 299686 */   GIR_RootConstrainSelectedInstOperands,
     /* 299687 */   // GIR_Coverage, 1564,
     /* 299687 */   GIR_Done,
     /* 299688 */ // Label 5973: @299688
     /* 299688 */ GIM_Reject,
     /* 299689 */ // Label 5962: @299689
     /* 299689 */ GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(299722), // Rule ID 1566 //
     /* 299694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 299703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299715 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 299715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 299720 */   GIR_RootConstrainSelectedInstOperands,
     /* 299721 */   // GIR_Coverage, 1566,
     /* 299721 */   GIR_Done,
     /* 299722 */ // Label 5974: @299722
     /* 299722 */ GIM_Reject,
     /* 299723 */ // Label 5963: @299723
     /* 299723 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(299756), // Rule ID 1562 //
     /* 299728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299749 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 299754 */   GIR_RootConstrainSelectedInstOperands,
     /* 299755 */   // GIR_Coverage, 1562,
     /* 299755 */   GIR_Done,
     /* 299756 */ // Label 5975: @299756
     /* 299756 */ GIM_Reject,
     /* 299757 */ // Label 5964: @299757
     /* 299757 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(299790), // Rule ID 1565 //
     /* 299762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299783 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 299788 */   GIR_RootConstrainSelectedInstOperands,
     /* 299789 */   // GIR_Coverage, 1565,
     /* 299789 */   GIR_Done,
     /* 299790 */ // Label 5976: @299790
     /* 299790 */ GIM_Reject,
     /* 299791 */ // Label 5965: @299791
     /* 299791 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(299824), // Rule ID 1560 //
     /* 299796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 299802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 299805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299817 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 299817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 299822 */   GIR_RootConstrainSelectedInstOperands,
     /* 299823 */   // GIR_Coverage, 1560,
     /* 299823 */   GIR_Done,
     /* 299824 */ // Label 5977: @299824
     /* 299824 */ GIM_Reject,
     /* 299825 */ // Label 5966: @299825
     /* 299825 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(299858), // Rule ID 1563 //
     /* 299830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299851 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 299851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 299856 */   GIR_RootConstrainSelectedInstOperands,
     /* 299857 */   // GIR_Coverage, 1563,
     /* 299857 */   GIR_Done,
     /* 299858 */ // Label 5978: @299858
     /* 299858 */ GIM_Reject,
     /* 299859 */ // Label 5967: @299859
     /* 299859 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(299892), // Rule ID 1561 //
     /* 299864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299885 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 299885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 299890 */   GIR_RootConstrainSelectedInstOperands,
     /* 299891 */   // GIR_Coverage, 1561,
     /* 299891 */   GIR_Done,
     /* 299892 */ // Label 5979: @299892
     /* 299892 */ GIM_Reject,
     /* 299893 */ // Label 5968: @299893
     /* 299893 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(299918), // Rule ID 7501 //
     /* 299898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 299904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 299907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299911 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 299911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 299916 */   GIR_RootConstrainSelectedInstOperands,
     /* 299917 */   // GIR_Coverage, 7501,
     /* 299917 */   GIR_Done,
     /* 299918 */ // Label 5980: @299918
     /* 299918 */ GIM_Reject,
     /* 299919 */ // Label 5969: @299919
     /* 299919 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(299944), // Rule ID 7500 //
     /* 299924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299937 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 299937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 299942 */   GIR_RootConstrainSelectedInstOperands,
     /* 299943 */   // GIR_Coverage, 7500,
     /* 299943 */   GIR_Done,
     /* 299944 */ // Label 5981: @299944
     /* 299944 */ GIM_Reject,
     /* 299945 */ // Label 5970: @299945
     /* 299945 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(299970), // Rule ID 7499 //
     /* 299950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299963 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 299963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 299968 */   GIR_RootConstrainSelectedInstOperands,
     /* 299969 */   // GIR_Coverage, 7499,
     /* 299969 */   GIR_Done,
     /* 299970 */ // Label 5982: @299970
     /* 299970 */ GIM_Reject,
     /* 299971 */ // Label 5971: @299971
     /* 299971 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(299996), // Rule ID 7498 //
     /* 299976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299989 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 299989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 299994 */   GIR_RootConstrainSelectedInstOperands,
     /* 299995 */   // GIR_Coverage, 7498,
     /* 299995 */   GIR_Done,
     /* 299996 */ // Label 5983: @299996
     /* 299996 */ GIM_Reject,
     /* 299997 */ // Label 5972: @299997
     /* 299997 */ GIM_Reject,
     /* 299998 */ // Label 58: @299998
     /* 299998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5995*/ GIMT_Encode4(301345),
     /* 300009 */ /*GILLT_v2s32*//*Label 5984*/ GIMT_Encode4(300085),
     /* 300013 */ /*GILLT_v2s64*//*Label 5985*/ GIMT_Encode4(300119),
     /* 300017 */ /*GILLT_v4s16*//*Label 5986*/ GIMT_Encode4(300612),
     /* 300021 */ /*GILLT_v4s32*//*Label 5987*/ GIMT_Encode4(300646),
     /* 300025 */ /*GILLT_v8s8*//*Label 5988*/ GIMT_Encode4(301139),
     /* 300029 */ /*GILLT_v8s16*//*Label 5989*/ GIMT_Encode4(301173),
     /* 300033 */ /*GILLT_v16s8*//*Label 5990*/ GIMT_Encode4(301207), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300053 */ /*GILLT_nxv2s64*//*Label 5991*/ GIMT_Encode4(301241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300065 */ /*GILLT_nxv4s32*//*Label 5992*/ GIMT_Encode4(301267), GIMT_Encode4(0),
     /* 300073 */ /*GILLT_nxv8s16*//*Label 5993*/ GIMT_Encode4(301293), GIMT_Encode4(0),
     /* 300081 */ /*GILLT_nxv16s8*//*Label 5994*/ GIMT_Encode4(301319),
     /* 300085 */ // Label 5984: @300085
     /* 300085 */ GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(300118), // Rule ID 1449 //
     /* 300090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300111 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 300116 */   GIR_RootConstrainSelectedInstOperands,
     /* 300117 */   // GIR_Coverage, 1449,
     /* 300117 */   GIR_Done,
     /* 300118 */ // Label 5996: @300118
     /* 300118 */ GIM_Reject,
     /* 300119 */ // Label 5985: @300119
     /* 300119 */ GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(300611),
     /* 300124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300138 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(300256), // Rule ID 2067 //
     /* 300143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300154 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300157 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300166 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300198 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300203 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300207 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300211 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300215 */     // MIs[4] Operand 1
     /* 300215 */     // No operand predicates
     /* 300215 */     // MIs[2] Operand 2
     /* 300215 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 300226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300235 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 300238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300254 */     GIR_RootConstrainSelectedInstOperands,
     /* 300255 */     // GIR_Coverage, 2067,
     /* 300255 */     GIR_EraseRootFromParent_Done,
     /* 300256 */   // Label 5998: @300256
     /* 300256 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(300371), // Rule ID 2065 //
     /* 300261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300272 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300275 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300313 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300317 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300321 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300326 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300330 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300334 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300338 */     // MIs[4] Operand 1
     /* 300338 */     // No operand predicates
     /* 300338 */     // MIs[2] Operand 2
     /* 300338 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300349 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300351 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 300354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300369 */     GIR_RootConstrainSelectedInstOperands,
     /* 300370 */     // GIR_Coverage, 2065,
     /* 300370 */     GIR_EraseRootFromParent_Done,
     /* 300371 */   // Label 5999: @300371
     /* 300371 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(300438), // Rule ID 1749 //
     /* 300376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300387 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300390 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 300419 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 300419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 300422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300436 */     GIR_RootConstrainSelectedInstOperands,
     /* 300437 */     // GIR_Coverage, 1749,
     /* 300437 */     GIR_EraseRootFromParent_Done,
     /* 300438 */   // Label 6000: @300438
     /* 300438 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(300530), // Rule ID 2066 //
     /* 300443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300454 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300457 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300466 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300508 */     // MIs[3] Operand 1
     /* 300508 */     // No operand predicates
     /* 300508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300510 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 300513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300528 */     GIR_RootConstrainSelectedInstOperands,
     /* 300529 */     // GIR_Coverage, 2066,
     /* 300529 */     GIR_EraseRootFromParent_Done,
     /* 300530 */   // Label 6001: @300530
     /* 300530 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(300591), // Rule ID 1748 //
     /* 300535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300546 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300549 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300558 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300574 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 300574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 300577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300589 */     GIR_RootConstrainSelectedInstOperands,
     /* 300590 */     // GIR_Coverage, 1748,
     /* 300590 */     GIR_EraseRootFromParent_Done,
     /* 300591 */   // Label 6002: @300591
     /* 300591 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(300610), // Rule ID 1451 //
     /* 300596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300603 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 300603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 300608 */     GIR_RootConstrainSelectedInstOperands,
     /* 300609 */     // GIR_Coverage, 1451,
     /* 300609 */     GIR_Done,
     /* 300610 */   // Label 6003: @300610
     /* 300610 */   GIM_Reject,
     /* 300611 */ // Label 5997: @300611
     /* 300611 */ GIM_Reject,
     /* 300612 */ // Label 5986: @300612
     /* 300612 */ GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(300645), // Rule ID 1447 //
     /* 300617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300638 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 300643 */   GIR_RootConstrainSelectedInstOperands,
     /* 300644 */   // GIR_Coverage, 1447,
     /* 300644 */   GIR_Done,
     /* 300645 */ // Label 6004: @300645
     /* 300645 */ GIM_Reject,
     /* 300646 */ // Label 5987: @300646
     /* 300646 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301138),
     /* 300651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300665 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(300783), // Rule ID 2064 //
     /* 300670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300681 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300684 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300693 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300721 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300738 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300742 */     // MIs[4] Operand 1
     /* 300742 */     // No operand predicates
     /* 300742 */     // MIs[2] Operand 2
     /* 300742 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300762 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 300765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300781 */     GIR_RootConstrainSelectedInstOperands,
     /* 300782 */     // GIR_Coverage, 2064,
     /* 300782 */     GIR_EraseRootFromParent_Done,
     /* 300783 */   // Label 6006: @300783
     /* 300783 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(300898), // Rule ID 2062 //
     /* 300788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300799 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300802 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300848 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300861 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300865 */     // MIs[4] Operand 1
     /* 300865 */     // No operand predicates
     /* 300865 */     // MIs[2] Operand 2
     /* 300865 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300876 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300878 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 300881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300896 */     GIR_RootConstrainSelectedInstOperands,
     /* 300897 */     // GIR_Coverage, 2062,
     /* 300897 */     GIR_EraseRootFromParent_Done,
     /* 300898 */   // Label 6007: @300898
     /* 300898 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(300965), // Rule ID 1747 //
     /* 300903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300914 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300917 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300926 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300946 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 300949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300963 */     GIR_RootConstrainSelectedInstOperands,
     /* 300964 */     // GIR_Coverage, 1747,
     /* 300964 */     GIR_EraseRootFromParent_Done,
     /* 300965 */   // Label 6008: @300965
     /* 300965 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301057), // Rule ID 2063 //
     /* 300970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300981 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300984 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300993 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301031 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301035 */     // MIs[3] Operand 1
     /* 301035 */     // No operand predicates
     /* 301035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301037 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 301040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301055 */     GIR_RootConstrainSelectedInstOperands,
     /* 301056 */     // GIR_Coverage, 2063,
     /* 301056 */     GIR_EraseRootFromParent_Done,
     /* 301057 */   // Label 6009: @301057
     /* 301057 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(301118), // Rule ID 1746 //
     /* 301062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301073 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301076 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301085 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 301089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301101 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 301104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 301116 */     GIR_RootConstrainSelectedInstOperands,
     /* 301117 */     // GIR_Coverage, 1746,
     /* 301117 */     GIR_EraseRootFromParent_Done,
     /* 301118 */   // Label 6010: @301118
     /* 301118 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(301137), // Rule ID 1450 //
     /* 301123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301130 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 301135 */     GIR_RootConstrainSelectedInstOperands,
     /* 301136 */     // GIR_Coverage, 1450,
     /* 301136 */     GIR_Done,
     /* 301137 */   // Label 6011: @301137
     /* 301137 */   GIM_Reject,
     /* 301138 */ // Label 6005: @301138
     /* 301138 */ GIM_Reject,
     /* 301139 */ // Label 5988: @301139
     /* 301139 */ GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(301172), // Rule ID 1445 //
     /* 301144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301165 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 301170 */   GIR_RootConstrainSelectedInstOperands,
     /* 301171 */   // GIR_Coverage, 1445,
     /* 301171 */   GIR_Done,
     /* 301172 */ // Label 6012: @301172
     /* 301172 */ GIM_Reject,
     /* 301173 */ // Label 5989: @301173
     /* 301173 */ GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(301206), // Rule ID 1448 //
     /* 301178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301199 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 301204 */   GIR_RootConstrainSelectedInstOperands,
     /* 301205 */   // GIR_Coverage, 1448,
     /* 301205 */   GIR_Done,
     /* 301206 */ // Label 6013: @301206
     /* 301206 */ GIM_Reject,
     /* 301207 */ // Label 5990: @301207
     /* 301207 */ GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(301240), // Rule ID 1446 //
     /* 301212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301233 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 301238 */   GIR_RootConstrainSelectedInstOperands,
     /* 301239 */   // GIR_Coverage, 1446,
     /* 301239 */   GIR_Done,
     /* 301240 */ // Label 6014: @301240
     /* 301240 */ GIM_Reject,
     /* 301241 */ // Label 5991: @301241
     /* 301241 */ GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(301266), // Rule ID 7497 //
     /* 301246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301259 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 301264 */   GIR_RootConstrainSelectedInstOperands,
     /* 301265 */   // GIR_Coverage, 7497,
     /* 301265 */   GIR_Done,
     /* 301266 */ // Label 6015: @301266
     /* 301266 */ GIM_Reject,
     /* 301267 */ // Label 5992: @301267
     /* 301267 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(301292), // Rule ID 7496 //
     /* 301272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301285 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 301290 */   GIR_RootConstrainSelectedInstOperands,
     /* 301291 */   // GIR_Coverage, 7496,
     /* 301291 */   GIR_Done,
     /* 301292 */ // Label 6016: @301292
     /* 301292 */ GIM_Reject,
     /* 301293 */ // Label 5993: @301293
     /* 301293 */ GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(301318), // Rule ID 7495 //
     /* 301298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301311 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 301316 */   GIR_RootConstrainSelectedInstOperands,
     /* 301317 */   // GIR_Coverage, 7495,
     /* 301317 */   GIR_Done,
     /* 301318 */ // Label 6017: @301318
     /* 301318 */ GIM_Reject,
     /* 301319 */ // Label 5994: @301319
     /* 301319 */ GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(301344), // Rule ID 7494 //
     /* 301324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301337 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 301342 */   GIR_RootConstrainSelectedInstOperands,
     /* 301343 */   // GIR_Coverage, 7494,
     /* 301343 */   GIR_Done,
     /* 301344 */ // Label 6018: @301344
     /* 301344 */ GIM_Reject,
     /* 301345 */ // Label 5995: @301345
     /* 301345 */ GIM_Reject,
     /* 301346 */ // Label 59: @301346
     /* 301346 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6030*/ GIMT_Encode4(303143),
     /* 301357 */ /*GILLT_s16*//*Label 6019*/ GIMT_Encode4(301441),
     /* 301361 */ /*GILLT_s32*//*Label 6020*/ GIMT_Encode4(301667),
     /* 301365 */ /*GILLT_s64*//*Label 6021*/ GIMT_Encode4(302021), GIMT_Encode4(0),
     /* 301373 */ /*GILLT_v2s32*//*Label 6022*/ GIMT_Encode4(302193),
     /* 301377 */ /*GILLT_v2s64*//*Label 6023*/ GIMT_Encode4(302231),
     /* 301381 */ /*GILLT_v4s16*//*Label 6024*/ GIMT_Encode4(302407),
     /* 301385 */ /*GILLT_v4s32*//*Label 6025*/ GIMT_Encode4(302445), GIMT_Encode4(0),
     /* 301393 */ /*GILLT_v8s16*//*Label 6026*/ GIMT_Encode4(302621), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301417 */ /*GILLT_nxv2s64*//*Label 6027*/ GIMT_Encode4(303065), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301429 */ /*GILLT_nxv4s32*//*Label 6028*/ GIMT_Encode4(303091), GIMT_Encode4(0),
     /* 301437 */ /*GILLT_nxv8s16*//*Label 6029*/ GIMT_Encode4(303117),
     /* 301441 */ // Label 6019: @301441
     /* 301441 */ GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(301666),
     /* 301446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 301452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301456 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(301547), // Rule ID 6949 //
     /* 301461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301482 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301498 */     // MIs[2] Rn
     /* 301498 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301503 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301509 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 301509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301521 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 301540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301545 */     GIR_RootConstrainSelectedInstOperands,
     /* 301546 */     // GIR_Coverage, 6949,
     /* 301546 */     GIR_EraseRootFromParent_Done,
     /* 301547 */   // Label 6032: @301547
     /* 301547 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(301638), // Rule ID 14018 //
     /* 301552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301589 */     // MIs[2] Rn
     /* 301589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301600 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 301600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 301631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301636 */     GIR_RootConstrainSelectedInstOperands,
     /* 301637 */     // GIR_Coverage, 14018,
     /* 301637 */     GIR_EraseRootFromParent_Done,
     /* 301638 */   // Label 6033: @301638
     /* 301638 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(301665), // Rule ID 584 //
     /* 301643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301654 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 301654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 301659 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301663 */     GIR_RootConstrainSelectedInstOperands,
     /* 301664 */     // GIR_Coverage, 584,
     /* 301664 */     GIR_Done,
     /* 301665 */   // Label 6034: @301665
     /* 301665 */   GIM_Reject,
     /* 301666 */ // Label 6031: @301666
     /* 301666 */ GIM_Reject,
     /* 301667 */ // Label 6020: @301667
     /* 301667 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302020),
     /* 301672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 301678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301682 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(301773), // Rule ID 6947 //
     /* 301687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301724 */     // MIs[2] Rn
     /* 301724 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301729 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301735 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 301735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301747 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301771 */     GIR_RootConstrainSelectedInstOperands,
     /* 301772 */     // GIR_Coverage, 6947,
     /* 301772 */     GIR_EraseRootFromParent_Done,
     /* 301773 */   // Label 6036: @301773
     /* 301773 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(301837), // Rule ID 13190 //
     /* 301778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 301803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301815 */     // MIs[2] Rn
     /* 301815 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 301824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301826 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 301826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301835 */     GIR_RootConstrainSelectedInstOperands,
     /* 301836 */     // GIR_Coverage, 13190,
     /* 301836 */     GIR_EraseRootFromParent_Done,
     /* 301837 */   // Label 6037: @301837
     /* 301837 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(301928), // Rule ID 14016 //
     /* 301842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301879 */     // MIs[2] Rn
     /* 301879 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301890 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 301890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 301893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 301908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301926 */     GIR_RootConstrainSelectedInstOperands,
     /* 301927 */     // GIR_Coverage, 14016,
     /* 301927 */     GIR_EraseRootFromParent_Done,
     /* 301928 */   // Label 6038: @301928
     /* 301928 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(301992), // Rule ID 15843 //
     /* 301933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301954 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 301958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 301966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301970 */     // MIs[2] Rn
     /* 301970 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 301975 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 301979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301981 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 301981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 301984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301990 */     GIR_RootConstrainSelectedInstOperands,
     /* 301991 */     // GIR_Coverage, 15843,
     /* 301991 */     GIR_EraseRootFromParent_Done,
     /* 301992 */   // Label 6039: @301992
     /* 301992 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(302019), // Rule ID 586 //
     /* 301997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302008 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 302008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 302013 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302017 */     GIR_RootConstrainSelectedInstOperands,
     /* 302018 */     // GIR_Coverage, 586,
     /* 302018 */     GIR_Done,
     /* 302019 */   // Label 6040: @302019
     /* 302019 */   GIM_Reject,
     /* 302020 */ // Label 6035: @302020
     /* 302020 */ GIM_Reject,
     /* 302021 */ // Label 6021: @302021
     /* 302021 */ GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(302192),
     /* 302026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302036 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(302100), // Rule ID 6945 //
     /* 302041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302062 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302078 */     // MIs[2] Rn
     /* 302078 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302083 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302089 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302098 */     GIR_RootConstrainSelectedInstOperands,
     /* 302099 */     // GIR_Coverage, 6945,
     /* 302099 */     GIR_EraseRootFromParent_Done,
     /* 302100 */   // Label 6042: @302100
     /* 302100 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(302164), // Rule ID 14014 //
     /* 302105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302142 */     // MIs[2] Rn
     /* 302142 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302147 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302153 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302162 */     GIR_RootConstrainSelectedInstOperands,
     /* 302163 */     // GIR_Coverage, 14014,
     /* 302163 */     GIR_EraseRootFromParent_Done,
     /* 302164 */   // Label 6043: @302164
     /* 302164 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(302191), // Rule ID 588 //
     /* 302169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302180 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 302180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 302185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302189 */     GIR_RootConstrainSelectedInstOperands,
     /* 302190 */     // GIR_Coverage, 588,
     /* 302190 */     GIR_Done,
     /* 302191 */   // Label 6044: @302191
     /* 302191 */   GIM_Reject,
     /* 302192 */ // Label 6041: @302192
     /* 302192 */ GIM_Reject,
     /* 302193 */ // Label 6022: @302193
     /* 302193 */ GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(302230), // Rule ID 1203 //
     /* 302198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302219 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 302219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 302224 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302228 */   GIR_RootConstrainSelectedInstOperands,
     /* 302229 */   // GIR_Coverage, 1203,
     /* 302229 */   GIR_Done,
     /* 302230 */ // Label 6045: @302230
     /* 302230 */ GIM_Reject,
     /* 302231 */ // Label 6023: @302231
     /* 302231 */ GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(302406),
     /* 302236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302246 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(302312), // Rule ID 6967 //
     /* 302251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 302259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 302285 */     // MIs[2] Rn
     /* 302285 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302290 */     // MIs[2] Rm
     /* 302290 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302297 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 302297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 302300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302310 */     GIR_RootConstrainSelectedInstOperands,
     /* 302311 */     // GIR_Coverage, 6967,
     /* 302311 */     GIR_EraseRootFromParent_Done,
     /* 302312 */   // Label 6047: @302312
     /* 302312 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(302378), // Rule ID 14026 //
     /* 302317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 302325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 302351 */     // MIs[2] Rn
     /* 302351 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302356 */     // MIs[2] Rm
     /* 302356 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302363 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 302363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 302366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302376 */     GIR_RootConstrainSelectedInstOperands,
     /* 302377 */     // GIR_Coverage, 14026,
     /* 302377 */     GIR_EraseRootFromParent_Done,
     /* 302378 */   // Label 6048: @302378
     /* 302378 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(302405), // Rule ID 1207 //
     /* 302383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302394 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 302399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302403 */     GIR_RootConstrainSelectedInstOperands,
     /* 302404 */     // GIR_Coverage, 1207,
     /* 302404 */     GIR_Done,
     /* 302405 */   // Label 6049: @302405
     /* 302405 */   GIM_Reject,
     /* 302406 */ // Label 6046: @302406
     /* 302406 */ GIM_Reject,
     /* 302407 */ // Label 6024: @302407
     /* 302407 */ GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(302444), // Rule ID 1199 //
     /* 302412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302433 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 302433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 302438 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302442 */   GIR_RootConstrainSelectedInstOperands,
     /* 302443 */   // GIR_Coverage, 1199,
     /* 302443 */   GIR_Done,
     /* 302444 */ // Label 6050: @302444
     /* 302444 */ GIM_Reject,
     /* 302445 */ // Label 6025: @302445
     /* 302445 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(302620),
     /* 302450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302460 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(302526), // Rule ID 6968 //
     /* 302465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 302473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 302499 */     // MIs[2] Rn
     /* 302499 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302504 */     // MIs[2] Rm
     /* 302504 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302511 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 302511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 302514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302524 */     GIR_RootConstrainSelectedInstOperands,
     /* 302525 */     // GIR_Coverage, 6968,
     /* 302525 */     GIR_EraseRootFromParent_Done,
     /* 302526 */   // Label 6052: @302526
     /* 302526 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(302592), // Rule ID 14027 //
     /* 302531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 302539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 302565 */     // MIs[2] Rn
     /* 302565 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302570 */     // MIs[2] Rm
     /* 302570 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302577 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 302577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 302580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302590 */     GIR_RootConstrainSelectedInstOperands,
     /* 302591 */     // GIR_Coverage, 14027,
     /* 302591 */     GIR_EraseRootFromParent_Done,
     /* 302592 */   // Label 6053: @302592
     /* 302592 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(302619), // Rule ID 1205 //
     /* 302597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302608 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 302608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302617 */     GIR_RootConstrainSelectedInstOperands,
     /* 302618 */     // GIR_Coverage, 1205,
     /* 302618 */     GIR_Done,
     /* 302619 */   // Label 6054: @302619
     /* 302619 */   GIM_Reject,
     /* 302620 */ // Label 6051: @302620
     /* 302620 */ GIM_Reject,
     /* 302621 */ // Label 6026: @302621
     /* 302621 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(303064),
     /* 302626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302636 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302705), // Rule ID 6969 //
     /* 302641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 302652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 302678 */     // MIs[2] Rn
     /* 302678 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302683 */     // MIs[2] Rm
     /* 302683 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302690 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 302690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 302693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302703 */     GIR_RootConstrainSelectedInstOperands,
     /* 302704 */     // GIR_Coverage, 6969,
     /* 302704 */     GIR_EraseRootFromParent_Done,
     /* 302705 */   // Label 6056: @302705
     /* 302705 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302774), // Rule ID 14028 //
     /* 302710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 302721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 302747 */     // MIs[2] Rn
     /* 302747 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302752 */     // MIs[2] Rm
     /* 302752 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 302757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302759 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 302759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 302762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 302772 */     GIR_RootConstrainSelectedInstOperands,
     /* 302773 */     // GIR_Coverage, 14028,
     /* 302773 */     GIR_EraseRootFromParent_Done,
     /* 302774 */   // Label 6057: @302774
     /* 302774 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302801), // Rule ID 1201 //
     /* 302779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302790 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 302790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 302795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302799 */     GIR_RootConstrainSelectedInstOperands,
     /* 302800 */     // GIR_Coverage, 1201,
     /* 302800 */     GIR_Done,
     /* 302801 */   // Label 6058: @302801
     /* 302801 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303063), // Rule ID 7038 //
     /* 302806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 302809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302817 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 302817 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 302820 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302824 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302829 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 302833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 302835 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 302838 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302842 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302847 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 302851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 302853 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 302856 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302860 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302865 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 302868 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 302871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 302873 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 302876 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302880 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302885 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 302891 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302896 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302901 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 302904 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302908 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302913 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 302916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302918 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 302921 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302925 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302930 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302936 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302941 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302946 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 302949 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302953 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302958 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302963 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 302966 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 302970 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302975 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302978 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 302981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 302986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 302990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302995 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 303000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303029 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303032 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303061 */     GIR_RootConstrainSelectedInstOperands,
     /* 303062 */     // GIR_Coverage, 7038,
     /* 303062 */     GIR_EraseRootFromParent_Done,
     /* 303063 */   // Label 6059: @303063
     /* 303063 */   GIM_Reject,
     /* 303064 */ // Label 6055: @303064
     /* 303064 */ GIM_Reject,
     /* 303065 */ // Label 6027: @303065
     /* 303065 */ GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(303090), // Rule ID 2817 //
     /* 303070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303083 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 303088 */   GIR_RootConstrainSelectedInstOperands,
     /* 303089 */   // GIR_Coverage, 2817,
     /* 303089 */   GIR_Done,
     /* 303090 */ // Label 6060: @303090
     /* 303090 */ GIM_Reject,
     /* 303091 */ // Label 6028: @303091
     /* 303091 */ GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303116), // Rule ID 2815 //
     /* 303096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303109 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 303109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 303114 */   GIR_RootConstrainSelectedInstOperands,
     /* 303115 */   // GIR_Coverage, 2815,
     /* 303115 */   GIR_Done,
     /* 303116 */ // Label 6061: @303116
     /* 303116 */ GIM_Reject,
     /* 303117 */ // Label 6029: @303117
     /* 303117 */ GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303142), // Rule ID 2813 //
     /* 303122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303135 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 303135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 303140 */   GIR_RootConstrainSelectedInstOperands,
     /* 303141 */   // GIR_Coverage, 2813,
     /* 303141 */   GIR_Done,
     /* 303142 */ // Label 6062: @303142
     /* 303142 */ GIM_Reject,
     /* 303143 */ // Label 6030: @303143
     /* 303143 */ GIM_Reject,
     /* 303144 */ // Label 60: @303144
     /* 303144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6074*/ GIMT_Encode4(303881),
     /* 303155 */ /*GILLT_s16*//*Label 6063*/ GIMT_Encode4(303239),
     /* 303159 */ /*GILLT_s32*//*Label 6064*/ GIMT_Encode4(303277),
     /* 303163 */ /*GILLT_s64*//*Label 6065*/ GIMT_Encode4(303315), GIMT_Encode4(0),
     /* 303171 */ /*GILLT_v2s32*//*Label 6066*/ GIMT_Encode4(303353),
     /* 303175 */ /*GILLT_v2s64*//*Label 6067*/ GIMT_Encode4(303391),
     /* 303179 */ /*GILLT_v4s16*//*Label 6068*/ GIMT_Encode4(303429),
     /* 303183 */ /*GILLT_v4s32*//*Label 6069*/ GIMT_Encode4(303467), GIMT_Encode4(0),
     /* 303191 */ /*GILLT_v8s16*//*Label 6070*/ GIMT_Encode4(303505), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303215 */ /*GILLT_nxv2s64*//*Label 6071*/ GIMT_Encode4(303803), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303227 */ /*GILLT_nxv4s32*//*Label 6072*/ GIMT_Encode4(303829), GIMT_Encode4(0),
     /* 303235 */ /*GILLT_nxv8s16*//*Label 6073*/ GIMT_Encode4(303855),
     /* 303239 */ // Label 6063: @303239
     /* 303239 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(303276), // Rule ID 632 //
     /* 303244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303265 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 303270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303274 */   GIR_RootConstrainSelectedInstOperands,
     /* 303275 */   // GIR_Coverage, 632,
     /* 303275 */   GIR_Done,
     /* 303276 */ // Label 6075: @303276
     /* 303276 */ GIM_Reject,
     /* 303277 */ // Label 6064: @303277
     /* 303277 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(303314), // Rule ID 634 //
     /* 303282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303303 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 303308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303312 */   GIR_RootConstrainSelectedInstOperands,
     /* 303313 */   // GIR_Coverage, 634,
     /* 303313 */   GIR_Done,
     /* 303314 */ // Label 6076: @303314
     /* 303314 */ GIM_Reject,
     /* 303315 */ // Label 6065: @303315
     /* 303315 */ GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(303352), // Rule ID 636 //
     /* 303320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 303329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303341 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 303346 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303350 */   GIR_RootConstrainSelectedInstOperands,
     /* 303351 */   // GIR_Coverage, 636,
     /* 303351 */   GIR_Done,
     /* 303352 */ // Label 6077: @303352
     /* 303352 */ GIM_Reject,
     /* 303353 */ // Label 6066: @303353
     /* 303353 */ GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(303390), // Rule ID 1343 //
     /* 303358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303379 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 303384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303388 */   GIR_RootConstrainSelectedInstOperands,
     /* 303389 */   // GIR_Coverage, 1343,
     /* 303389 */   GIR_Done,
     /* 303390 */ // Label 6078: @303390
     /* 303390 */ GIM_Reject,
     /* 303391 */ // Label 6067: @303391
     /* 303391 */ GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(303428), // Rule ID 1347 //
     /* 303396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303417 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 303422 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303426 */   GIR_RootConstrainSelectedInstOperands,
     /* 303427 */   // GIR_Coverage, 1347,
     /* 303427 */   GIR_Done,
     /* 303428 */ // Label 6079: @303428
     /* 303428 */ GIM_Reject,
     /* 303429 */ // Label 6068: @303429
     /* 303429 */ GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(303466), // Rule ID 1339 //
     /* 303434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303455 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 303460 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303464 */   GIR_RootConstrainSelectedInstOperands,
     /* 303465 */   // GIR_Coverage, 1339,
     /* 303465 */   GIR_Done,
     /* 303466 */ // Label 6080: @303466
     /* 303466 */ GIM_Reject,
     /* 303467 */ // Label 6069: @303467
     /* 303467 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(303504), // Rule ID 1345 //
     /* 303472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303493 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 303493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303502 */   GIR_RootConstrainSelectedInstOperands,
     /* 303503 */   // GIR_Coverage, 1345,
     /* 303503 */   GIR_Done,
     /* 303504 */ // Label 6081: @303504
     /* 303504 */ GIM_Reject,
     /* 303505 */ // Label 6070: @303505
     /* 303505 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(303802),
     /* 303510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303528 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(303547), // Rule ID 1341 //
     /* 303533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303536 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 303536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 303541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303545 */     GIR_RootConstrainSelectedInstOperands,
     /* 303546 */     // GIR_Coverage, 1341,
     /* 303546 */     GIR_Done,
     /* 303547 */   // Label 6083: @303547
     /* 303547 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(303801), // Rule ID 7044 //
     /* 303552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 303555 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 303555 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 303558 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303562 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303567 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 303571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 303573 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 303576 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303580 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303585 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 303589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 303591 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 303594 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303598 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303603 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 303606 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 303609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 303611 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 303614 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303618 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303623 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 303629 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303634 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303639 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 303642 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303646 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303651 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 303654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303656 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 303659 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303663 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303668 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303674 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303679 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303684 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 303687 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303691 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303696 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303701 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 303704 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 303708 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303713 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303716 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 303719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 303724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 303728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303733 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 303738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303799 */     GIR_RootConstrainSelectedInstOperands,
     /* 303800 */     // GIR_Coverage, 7044,
     /* 303800 */     GIR_EraseRootFromParent_Done,
     /* 303801 */   // Label 6084: @303801
     /* 303801 */   GIM_Reject,
     /* 303802 */ // Label 6082: @303802
     /* 303802 */ GIM_Reject,
     /* 303803 */ // Label 6071: @303803
     /* 303803 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(303828), // Rule ID 8244 //
     /* 303808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303821 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 303826 */   GIR_RootConstrainSelectedInstOperands,
     /* 303827 */   // GIR_Coverage, 8244,
     /* 303827 */   GIR_Done,
     /* 303828 */ // Label 6085: @303828
     /* 303828 */ GIM_Reject,
     /* 303829 */ // Label 6072: @303829
     /* 303829 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(303854), // Rule ID 8242 //
     /* 303834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 303840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 303843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303847 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 303847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 303852 */   GIR_RootConstrainSelectedInstOperands,
     /* 303853 */   // GIR_Coverage, 8242,
     /* 303853 */   GIR_Done,
     /* 303854 */ // Label 6086: @303854
     /* 303854 */ GIM_Reject,
     /* 303855 */ // Label 6073: @303855
     /* 303855 */ GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(303880), // Rule ID 8240 //
     /* 303860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303873 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 303873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 303878 */   GIR_RootConstrainSelectedInstOperands,
     /* 303879 */   // GIR_Coverage, 8240,
     /* 303879 */   GIR_Done,
     /* 303880 */ // Label 6087: @303880
     /* 303880 */ GIM_Reject,
     /* 303881 */ // Label 6074: @303881
     /* 303881 */ GIM_Reject,
     /* 303882 */ // Label 61: @303882
     /* 303882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6099*/ GIMT_Encode4(307977),
     /* 303893 */ /*GILLT_s16*//*Label 6088*/ GIMT_Encode4(303977),
     /* 303897 */ /*GILLT_s32*//*Label 6089*/ GIMT_Encode4(304619),
     /* 303901 */ /*GILLT_s64*//*Label 6090*/ GIMT_Encode4(305249), GIMT_Encode4(0),
     /* 303909 */ /*GILLT_v2s32*//*Label 6091*/ GIMT_Encode4(305879),
     /* 303913 */ /*GILLT_v2s64*//*Label 6092*/ GIMT_Encode4(306409),
     /* 303917 */ /*GILLT_v4s16*//*Label 6093*/ GIMT_Encode4(306767),
     /* 303921 */ /*GILLT_v4s32*//*Label 6094*/ GIMT_Encode4(307109), GIMT_Encode4(0),
     /* 303929 */ /*GILLT_v8s16*//*Label 6095*/ GIMT_Encode4(307467), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303953 */ /*GILLT_nxv2s64*//*Label 6096*/ GIMT_Encode4(307899), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303965 */ /*GILLT_nxv4s32*//*Label 6097*/ GIMT_Encode4(307925), GIMT_Encode4(0),
     /* 303973 */ /*GILLT_nxv8s16*//*Label 6098*/ GIMT_Encode4(307951),
     /* 303977 */ // Label 6088: @303977
     /* 303977 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(304618),
     /* 303982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303992 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(304105), // Rule ID 6277 //
     /* 303997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304058 */     // MIs[3] Operand 1
     /* 304058 */     // No operand predicates
     /* 304058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304060 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304103 */     GIR_RootConstrainSelectedInstOperands,
     /* 304104 */     // GIR_Coverage, 6277,
     /* 304104 */     GIR_EraseRootFromParent_Done,
     /* 304105 */   // Label 6101: @304105
     /* 304105 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(304218), // Rule ID 13995 //
     /* 304110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304146 */     // MIs[2] Operand 1
     /* 304146 */     // No operand predicates
     /* 304146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304154 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304158 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304162 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304167 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304173 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304216 */     GIR_RootConstrainSelectedInstOperands,
     /* 304217 */     // GIR_Coverage, 13995,
     /* 304217 */     GIR_EraseRootFromParent_Done,
     /* 304218 */   // Label 6102: @304218
     /* 304218 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(304297), // Rule ID 13929 //
     /* 304223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304247 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304257 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 304257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 304275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304295 */     GIR_RootConstrainSelectedInstOperands,
     /* 304296 */     // GIR_Coverage, 13929,
     /* 304296 */     GIR_EraseRootFromParent_Done,
     /* 304297 */   // Label 6103: @304297
     /* 304297 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(304376), // Rule ID 4836 //
     /* 304302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304330 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304336 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 304336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304348 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 304354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304374 */     GIR_RootConstrainSelectedInstOperands,
     /* 304375 */     // GIR_Coverage, 4836,
     /* 304375 */     GIR_EraseRootFromParent_Done,
     /* 304376 */   // Label 6104: @304376
     /* 304376 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(304439), // Rule ID 13538 //
     /* 304381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304413 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304417 */     // MIs[2] Operand 1
     /* 304417 */     // No operand predicates
     /* 304417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304423 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 304423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304437 */     GIR_RootConstrainSelectedInstOperands,
     /* 304438 */     // GIR_Coverage, 13538,
     /* 304438 */     GIR_EraseRootFromParent_Done,
     /* 304439 */   // Label 6105: @304439
     /* 304439 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(304502), // Rule ID 2012 //
     /* 304444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304484 */     // MIs[2] Operand 1
     /* 304484 */     // No operand predicates
     /* 304484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304486 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 304486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304500 */     GIR_RootConstrainSelectedInstOperands,
     /* 304501 */     // GIR_Coverage, 2012,
     /* 304501 */     GIR_EraseRootFromParent_Done,
     /* 304502 */   // Label 6106: @304502
     /* 304502 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(304546), // Rule ID 4841 //
     /* 304507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304533 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 304533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 304536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 304542 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 304544 */     GIR_RootConstrainSelectedInstOperands,
     /* 304545 */     // GIR_Coverage, 4841,
     /* 304545 */     GIR_EraseRootFromParent_Done,
     /* 304546 */   // Label 6107: @304546
     /* 304546 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(304590), // Rule ID 13934 //
     /* 304551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304577 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 304577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 304580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 304586 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 304588 */     GIR_RootConstrainSelectedInstOperands,
     /* 304589 */     // GIR_Coverage, 13934,
     /* 304589 */     GIR_EraseRootFromParent_Done,
     /* 304590 */   // Label 6108: @304590
     /* 304590 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(304617), // Rule ID 620 //
     /* 304595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304606 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 304611 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304615 */     GIR_RootConstrainSelectedInstOperands,
     /* 304616 */     // GIR_Coverage, 620,
     /* 304616 */     GIR_Done,
     /* 304617 */   // Label 6109: @304617
     /* 304617 */   GIM_Reject,
     /* 304618 */ // Label 6100: @304618
     /* 304618 */ GIM_Reject,
     /* 304619 */ // Label 6089: @304619
     /* 304619 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(305248),
     /* 304624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 304630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304634 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(304747), // Rule ID 6279 //
     /* 304639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304696 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304700 */     // MIs[3] Operand 1
     /* 304700 */     // No operand predicates
     /* 304700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304702 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304714 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 304733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304745 */     GIR_RootConstrainSelectedInstOperands,
     /* 304746 */     // GIR_Coverage, 6279,
     /* 304746 */     GIR_EraseRootFromParent_Done,
     /* 304747 */   // Label 6111: @304747
     /* 304747 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(304860), // Rule ID 13997 //
     /* 304752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304788 */     // MIs[2] Operand 1
     /* 304788 */     // No operand predicates
     /* 304788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304804 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304809 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304815 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 304846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304858 */     GIR_RootConstrainSelectedInstOperands,
     /* 304859 */     // GIR_Coverage, 13997,
     /* 304859 */     GIR_EraseRootFromParent_Done,
     /* 304860 */   // Label 6112: @304860
     /* 304860 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(304936), // Rule ID 13931 //
     /* 304865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304896 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 304896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304908 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 304927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304934 */     GIR_RootConstrainSelectedInstOperands,
     /* 304935 */     // GIR_Coverage, 13931,
     /* 304935 */     GIR_EraseRootFromParent_Done,
     /* 304936 */   // Label 6113: @304936
     /* 304936 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(305012), // Rule ID 4838 //
     /* 304941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304966 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304972 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 304972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305010 */     GIR_RootConstrainSelectedInstOperands,
     /* 305011 */     // GIR_Coverage, 4838,
     /* 305011 */     GIR_EraseRootFromParent_Done,
     /* 305012 */   // Label 6114: @305012
     /* 305012 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(305075), // Rule ID 13540 //
     /* 305017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305049 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305053 */     // MIs[2] Operand 1
     /* 305053 */     // No operand predicates
     /* 305053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305059 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305073 */     GIR_RootConstrainSelectedInstOperands,
     /* 305074 */     // GIR_Coverage, 13540,
     /* 305074 */     GIR_EraseRootFromParent_Done,
     /* 305075 */   // Label 6115: @305075
     /* 305075 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(305138), // Rule ID 2014 //
     /* 305080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305120 */     // MIs[2] Operand 1
     /* 305120 */     // No operand predicates
     /* 305120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305122 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305136 */     GIR_RootConstrainSelectedInstOperands,
     /* 305137 */     // GIR_Coverage, 2014,
     /* 305137 */     GIR_EraseRootFromParent_Done,
     /* 305138 */   // Label 6116: @305138
     /* 305138 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(305179), // Rule ID 4842 //
     /* 305143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305166 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305175 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305177 */     GIR_RootConstrainSelectedInstOperands,
     /* 305178 */     // GIR_Coverage, 4842,
     /* 305178 */     GIR_EraseRootFromParent_Done,
     /* 305179 */   // Label 6117: @305179
     /* 305179 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(305220), // Rule ID 13935 //
     /* 305184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305207 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 305207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 305210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305216 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305218 */     GIR_RootConstrainSelectedInstOperands,
     /* 305219 */     // GIR_Coverage, 13935,
     /* 305219 */     GIR_EraseRootFromParent_Done,
     /* 305220 */   // Label 6118: @305220
     /* 305220 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(305247), // Rule ID 622 //
     /* 305225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305236 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305241 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305245 */     GIR_RootConstrainSelectedInstOperands,
     /* 305246 */     // GIR_Coverage, 622,
     /* 305246 */     GIR_Done,
     /* 305247 */   // Label 6119: @305247
     /* 305247 */   GIM_Reject,
     /* 305248 */ // Label 6110: @305248
     /* 305248 */ GIM_Reject,
     /* 305249 */ // Label 6090: @305249
     /* 305249 */ GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(305878),
     /* 305254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305264 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(305377), // Rule ID 6281 //
     /* 305269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305326 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305330 */     // MIs[3] Operand 1
     /* 305330 */     // No operand predicates
     /* 305330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305332 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 305332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305344 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305375 */     GIR_RootConstrainSelectedInstOperands,
     /* 305376 */     // GIR_Coverage, 6281,
     /* 305376 */     GIR_EraseRootFromParent_Done,
     /* 305377 */   // Label 6121: @305377
     /* 305377 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(305490), // Rule ID 13999 //
     /* 305382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305418 */     // MIs[2] Operand 1
     /* 305418 */     // No operand predicates
     /* 305418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305434 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305439 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305445 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 305445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305457 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305488 */     GIR_RootConstrainSelectedInstOperands,
     /* 305489 */     // GIR_Coverage, 13999,
     /* 305489 */     GIR_EraseRootFromParent_Done,
     /* 305490 */   // Label 6122: @305490
     /* 305490 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(305566), // Rule ID 13933 //
     /* 305495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305526 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 305526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305538 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305564 */     GIR_RootConstrainSelectedInstOperands,
     /* 305565 */     // GIR_Coverage, 13933,
     /* 305565 */     GIR_EraseRootFromParent_Done,
     /* 305566 */   // Label 6123: @305566
     /* 305566 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(305642), // Rule ID 4840 //
     /* 305571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305602 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 305602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305640 */     GIR_RootConstrainSelectedInstOperands,
     /* 305641 */     // GIR_Coverage, 4840,
     /* 305641 */     GIR_EraseRootFromParent_Done,
     /* 305642 */   // Label 6124: @305642
     /* 305642 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305705), // Rule ID 13542 //
     /* 305647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305683 */     // MIs[2] Operand 1
     /* 305683 */     // No operand predicates
     /* 305683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305689 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305703 */     GIR_RootConstrainSelectedInstOperands,
     /* 305704 */     // GIR_Coverage, 13542,
     /* 305704 */     GIR_EraseRootFromParent_Done,
     /* 305705 */   // Label 6125: @305705
     /* 305705 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305768), // Rule ID 2016 //
     /* 305710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 305750 */     // MIs[2] Operand 1
     /* 305750 */     // No operand predicates
     /* 305750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305752 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 305755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305766 */     GIR_RootConstrainSelectedInstOperands,
     /* 305767 */     // GIR_Coverage, 2016,
     /* 305767 */     GIR_EraseRootFromParent_Done,
     /* 305768 */   // Label 6126: @305768
     /* 305768 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(305809), // Rule ID 4843 //
     /* 305773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305796 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 305796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305805 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305807 */     GIR_RootConstrainSelectedInstOperands,
     /* 305808 */     // GIR_Coverage, 4843,
     /* 305808 */     GIR_EraseRootFromParent_Done,
     /* 305809 */   // Label 6127: @305809
     /* 305809 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(305850), // Rule ID 13936 //
     /* 305814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305837 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 305837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305846 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305848 */     GIR_RootConstrainSelectedInstOperands,
     /* 305849 */     // GIR_Coverage, 13936,
     /* 305849 */     GIR_EraseRootFromParent_Done,
     /* 305850 */   // Label 6128: @305850
     /* 305850 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(305877), // Rule ID 624 //
     /* 305855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305866 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 305871 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305875 */     GIR_RootConstrainSelectedInstOperands,
     /* 305876 */     // GIR_Coverage, 624,
     /* 305876 */     GIR_Done,
     /* 305877 */   // Label 6129: @305877
     /* 305877 */   GIM_Reject,
     /* 305878 */ // Label 6120: @305878
     /* 305878 */ GIM_Reject,
     /* 305879 */ // Label 6091: @305879
     /* 305879 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(306408),
     /* 305884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 305890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305894 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(305980), // Rule ID 13531 //
     /* 305899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 305910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 305922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305943 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305947 */     // MIs[3] Operand 1
     /* 305947 */     // No operand predicates
     /* 305947 */     // MIs[1] Operand 2
     /* 305947 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 305958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305964 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 305967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305978 */     GIR_RootConstrainSelectedInstOperands,
     /* 305979 */     // GIR_Coverage, 13531,
     /* 305979 */     GIR_EraseRootFromParent_Done,
     /* 305980 */   // Label 6131: @305980
     /* 305980 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(306066), // Rule ID 2005 //
     /* 305985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306037 */     // MIs[3] Operand 1
     /* 306037 */     // No operand predicates
     /* 306037 */     // MIs[1] Operand 2
     /* 306037 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306050 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306064 */     GIR_RootConstrainSelectedInstOperands,
     /* 306065 */     // GIR_Coverage, 2005,
     /* 306065 */     GIR_EraseRootFromParent_Done,
     /* 306066 */   // Label 6132: @306066
     /* 306066 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(306129), // Rule ID 13532 //
     /* 306071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306107 */     // MIs[2] Operand 1
     /* 306107 */     // No operand predicates
     /* 306107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306113 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306127 */     GIR_RootConstrainSelectedInstOperands,
     /* 306128 */     // GIR_Coverage, 13532,
     /* 306128 */     GIR_EraseRootFromParent_Done,
     /* 306129 */   // Label 6133: @306129
     /* 306129 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306192), // Rule ID 2006 //
     /* 306134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306174 */     // MIs[2] Operand 1
     /* 306174 */     // No operand predicates
     /* 306174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306176 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306190 */     GIR_RootConstrainSelectedInstOperands,
     /* 306191 */     // GIR_Coverage, 2006,
     /* 306191 */     GIR_EraseRootFromParent_Done,
     /* 306192 */   // Label 6134: @306192
     /* 306192 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306286), // Rule ID 14001 //
     /* 306197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306220 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306253 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306284 */     GIR_RootConstrainSelectedInstOperands,
     /* 306285 */     // GIR_Coverage, 14001,
     /* 306285 */     GIR_EraseRootFromParent_Done,
     /* 306286 */   // Label 6135: @306286
     /* 306286 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306380), // Rule ID 6283 //
     /* 306291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306314 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 306350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306378 */     GIR_RootConstrainSelectedInstOperands,
     /* 306379 */     // GIR_Coverage, 6283,
     /* 306379 */     GIR_EraseRootFromParent_Done,
     /* 306380 */   // Label 6136: @306380
     /* 306380 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306407), // Rule ID 1323 //
     /* 306385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306396 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 306401 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306405 */     GIR_RootConstrainSelectedInstOperands,
     /* 306406 */     // GIR_Coverage, 1323,
     /* 306406 */     GIR_Done,
     /* 306407 */   // Label 6137: @306407
     /* 306407 */   GIM_Reject,
     /* 306408 */ // Label 6130: @306408
     /* 306408 */ GIM_Reject,
     /* 306409 */ // Label 6092: @306409
     /* 306409 */ GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306766),
     /* 306414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306424 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306487), // Rule ID 13536 //
     /* 306429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 306440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306465 */     // MIs[2] Operand 1
     /* 306465 */     // No operand predicates
     /* 306465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306471 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306485 */     GIR_RootConstrainSelectedInstOperands,
     /* 306486 */     // GIR_Coverage, 13536,
     /* 306486 */     GIR_EraseRootFromParent_Done,
     /* 306487 */   // Label 6139: @306487
     /* 306487 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306550), // Rule ID 2010 //
     /* 306492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 306507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306532 */     // MIs[2] Operand 1
     /* 306532 */     // No operand predicates
     /* 306532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306534 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306548 */     GIR_RootConstrainSelectedInstOperands,
     /* 306549 */     // GIR_Coverage, 2010,
     /* 306549 */     GIR_EraseRootFromParent_Done,
     /* 306550 */   // Label 6140: @306550
     /* 306550 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306644), // Rule ID 14005 //
     /* 306555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306578 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306611 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306642 */     GIR_RootConstrainSelectedInstOperands,
     /* 306643 */     // GIR_Coverage, 14005,
     /* 306643 */     GIR_EraseRootFromParent_Done,
     /* 306644 */   // Label 6141: @306644
     /* 306644 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306738), // Rule ID 6287 //
     /* 306649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306672 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 306675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 306689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306698 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 306726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306736 */     GIR_RootConstrainSelectedInstOperands,
     /* 306737 */     // GIR_Coverage, 6287,
     /* 306737 */     GIR_EraseRootFromParent_Done,
     /* 306738 */   // Label 6142: @306738
     /* 306738 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306765), // Rule ID 1327 //
     /* 306743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306754 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 306759 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306763 */     GIR_RootConstrainSelectedInstOperands,
     /* 306764 */     // GIR_Coverage, 1327,
     /* 306764 */     GIR_Done,
     /* 306765 */   // Label 6143: @306765
     /* 306765 */   GIM_Reject,
     /* 306766 */ // Label 6138: @306766
     /* 306766 */ GIM_Reject,
     /* 306767 */ // Label 6093: @306767
     /* 306767 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307108),
     /* 306772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306782 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(306868), // Rule ID 13525 //
     /* 306787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306835 */     // MIs[3] Operand 1
     /* 306835 */     // No operand predicates
     /* 306835 */     // MIs[1] Operand 2
     /* 306835 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306852 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 306855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306866 */     GIR_RootConstrainSelectedInstOperands,
     /* 306867 */     // GIR_Coverage, 13525,
     /* 306867 */     GIR_EraseRootFromParent_Done,
     /* 306868 */   // Label 6145: @306868
     /* 306868 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(306954), // Rule ID 1999 //
     /* 306873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306925 */     // MIs[3] Operand 1
     /* 306925 */     // No operand predicates
     /* 306925 */     // MIs[1] Operand 2
     /* 306925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306938 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 306941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306952 */     GIR_RootConstrainSelectedInstOperands,
     /* 306953 */     // GIR_Coverage, 1999,
     /* 306953 */     GIR_EraseRootFromParent_Done,
     /* 306954 */   // Label 6146: @306954
     /* 306954 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(307017), // Rule ID 13526 //
     /* 306959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306995 */     // MIs[2] Operand 1
     /* 306995 */     // No operand predicates
     /* 306995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307001 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307015 */     GIR_RootConstrainSelectedInstOperands,
     /* 307016 */     // GIR_Coverage, 13526,
     /* 307016 */     GIR_EraseRootFromParent_Done,
     /* 307017 */   // Label 6147: @307017
     /* 307017 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307080), // Rule ID 2000 //
     /* 307022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307062 */     // MIs[2] Operand 1
     /* 307062 */     // No operand predicates
     /* 307062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307064 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307078 */     GIR_RootConstrainSelectedInstOperands,
     /* 307079 */     // GIR_Coverage, 2000,
     /* 307079 */     GIR_EraseRootFromParent_Done,
     /* 307080 */   // Label 6148: @307080
     /* 307080 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(307107), // Rule ID 1319 //
     /* 307085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307096 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 307096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 307101 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307105 */     GIR_RootConstrainSelectedInstOperands,
     /* 307106 */     // GIR_Coverage, 1319,
     /* 307106 */     GIR_Done,
     /* 307107 */   // Label 6149: @307107
     /* 307107 */   GIM_Reject,
     /* 307108 */ // Label 6144: @307108
     /* 307108 */ GIM_Reject,
     /* 307109 */ // Label 6094: @307109
     /* 307109 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307466),
     /* 307114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 307120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307124 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307187), // Rule ID 13534 //
     /* 307129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307165 */     // MIs[2] Operand 1
     /* 307165 */     // No operand predicates
     /* 307165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307171 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307185 */     GIR_RootConstrainSelectedInstOperands,
     /* 307186 */     // GIR_Coverage, 13534,
     /* 307186 */     GIR_EraseRootFromParent_Done,
     /* 307187 */   // Label 6151: @307187
     /* 307187 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307250), // Rule ID 2008 //
     /* 307192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307232 */     // MIs[2] Operand 1
     /* 307232 */     // No operand predicates
     /* 307232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307234 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307248 */     GIR_RootConstrainSelectedInstOperands,
     /* 307249 */     // GIR_Coverage, 2008,
     /* 307249 */     GIR_EraseRootFromParent_Done,
     /* 307250 */   // Label 6152: @307250
     /* 307250 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307344), // Rule ID 14003 //
     /* 307255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307278 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307342 */     GIR_RootConstrainSelectedInstOperands,
     /* 307343 */     // GIR_Coverage, 14003,
     /* 307343 */     GIR_EraseRootFromParent_Done,
     /* 307344 */   // Label 6153: @307344
     /* 307344 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307438), // Rule ID 6285 //
     /* 307349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307372 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307372 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307375 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307379 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 307426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307436 */     GIR_RootConstrainSelectedInstOperands,
     /* 307437 */     // GIR_Coverage, 6285,
     /* 307437 */     GIR_EraseRootFromParent_Done,
     /* 307438 */   // Label 6154: @307438
     /* 307438 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307465), // Rule ID 1325 //
     /* 307443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307454 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307459 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307463 */     GIR_RootConstrainSelectedInstOperands,
     /* 307464 */     // GIR_Coverage, 1325,
     /* 307464 */     GIR_Done,
     /* 307465 */   // Label 6155: @307465
     /* 307465 */   GIM_Reject,
     /* 307466 */ // Label 6150: @307466
     /* 307466 */ GIM_Reject,
     /* 307467 */ // Label 6095: @307467
     /* 307467 */ GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307898),
     /* 307472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 307478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307482 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307545), // Rule ID 13528 //
     /* 307487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307523 */     // MIs[2] Operand 1
     /* 307523 */     // No operand predicates
     /* 307523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307529 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 307532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307543 */     GIR_RootConstrainSelectedInstOperands,
     /* 307544 */     // GIR_Coverage, 13528,
     /* 307544 */     GIR_EraseRootFromParent_Done,
     /* 307545 */   // Label 6157: @307545
     /* 307545 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307608), // Rule ID 2002 //
     /* 307550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307590 */     // MIs[2] Operand 1
     /* 307590 */     // No operand predicates
     /* 307590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307592 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 307595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307606 */     GIR_RootConstrainSelectedInstOperands,
     /* 307607 */     // GIR_Coverage, 2002,
     /* 307607 */     GIR_EraseRootFromParent_Done,
     /* 307608 */   // Label 6158: @307608
     /* 307608 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307635), // Rule ID 1321 //
     /* 307613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307624 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 307629 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307633 */     GIR_RootConstrainSelectedInstOperands,
     /* 307634 */     // GIR_Coverage, 1321,
     /* 307634 */     GIR_Done,
     /* 307635 */   // Label 6159: @307635
     /* 307635 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307897), // Rule ID 7042 //
     /* 307640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 307643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307651 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 307651 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 307654 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307658 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307663 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 307667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 307669 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 307672 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307676 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307681 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 307687 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 307690 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307694 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307699 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 307702 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 307705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 307707 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 307710 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307714 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307719 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307725 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307730 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307735 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 307738 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307742 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307747 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 307750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 307752 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 307755 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307759 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307764 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307770 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307775 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307780 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 307783 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307787 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307792 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 307795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 307800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 307804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307809 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307812 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 307815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307817 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 307820 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 307824 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307829 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 307887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 307895 */     GIR_RootConstrainSelectedInstOperands,
     /* 307896 */     // GIR_Coverage, 7042,
     /* 307896 */     GIR_EraseRootFromParent_Done,
     /* 307897 */   // Label 6160: @307897
     /* 307897 */   GIM_Reject,
     /* 307898 */ // Label 6156: @307898
     /* 307898 */ GIM_Reject,
     /* 307899 */ // Label 6096: @307899
     /* 307899 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(307924), // Rule ID 8250 //
     /* 307904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 307910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 307913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307917 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 307917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 307922 */   GIR_RootConstrainSelectedInstOperands,
     /* 307923 */   // GIR_Coverage, 8250,
     /* 307923 */   GIR_Done,
     /* 307924 */ // Label 6161: @307924
     /* 307924 */ GIM_Reject,
     /* 307925 */ // Label 6097: @307925
     /* 307925 */ GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(307950), // Rule ID 8248 //
     /* 307930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 307936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 307939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307943 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 307943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 307948 */   GIR_RootConstrainSelectedInstOperands,
     /* 307949 */   // GIR_Coverage, 8248,
     /* 307949 */   GIR_Done,
     /* 307950 */ // Label 6162: @307950
     /* 307950 */ GIM_Reject,
     /* 307951 */ // Label 6098: @307951
     /* 307951 */ GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(307976), // Rule ID 8246 //
     /* 307956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 307959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 307962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 307965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 307969 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 307969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 307974 */   GIR_RootConstrainSelectedInstOperands,
     /* 307975 */   // GIR_Coverage, 8246,
     /* 307975 */   GIR_Done,
     /* 307976 */ // Label 6163: @307976
     /* 307976 */ GIM_Reject,
     /* 307977 */ // Label 6099: @307977
     /* 307977 */ GIM_Reject,
     /* 307978 */ // Label 62: @307978
     /* 307978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6172*/ GIMT_Encode4(324250),
     /* 307989 */ /*GILLT_s16*//*Label 6164*/ GIMT_Encode4(308029),
     /* 307993 */ /*GILLT_s32*//*Label 6165*/ GIMT_Encode4(311033),
     /* 307997 */ /*GILLT_s64*//*Label 6166*/ GIMT_Encode4(314181), GIMT_Encode4(0),
     /* 308005 */ /*GILLT_v2s32*//*Label 6167*/ GIMT_Encode4(317329),
     /* 308009 */ /*GILLT_v2s64*//*Label 6168*/ GIMT_Encode4(318850),
     /* 308013 */ /*GILLT_v4s16*//*Label 6169*/ GIMT_Encode4(320371),
     /* 308017 */ /*GILLT_v4s32*//*Label 6170*/ GIMT_Encode4(321550), GIMT_Encode4(0),
     /* 308025 */ /*GILLT_v8s16*//*Label 6171*/ GIMT_Encode4(323071),
     /* 308029 */ // Label 6164: @308029
     /* 308029 */ GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(311032),
     /* 308034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 308043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308047 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308197), // Rule ID 4898 //
     /* 308052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 308109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 308117 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308124 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308136 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 308183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 308195 */     GIR_RootConstrainSelectedInstOperands,
     /* 308196 */     // GIR_Coverage, 4898,
     /* 308196 */     GIR_EraseRootFromParent_Done,
     /* 308197 */   // Label 6174: @308197
     /* 308197 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(308344), // Rule ID 4862 //
     /* 308202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 308246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308250 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308254 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308258 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308263 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308273 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308285 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308313 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 308332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 308342 */     GIR_RootConstrainSelectedInstOperands,
     /* 308343 */     // GIR_Coverage, 4862,
     /* 308343 */     GIR_EraseRootFromParent_Done,
     /* 308344 */   // Label 6175: @308344
     /* 308344 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308491), // Rule ID 13942 //
     /* 308349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308401 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308405 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308410 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308420 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308420 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308423 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308427 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308432 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 308479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 308489 */     GIR_RootConstrainSelectedInstOperands,
     /* 308490 */     // GIR_Coverage, 13942,
     /* 308490 */     GIR_EraseRootFromParent_Done,
     /* 308491 */   // Label 6176: @308491
     /* 308491 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(308622), // Rule ID 6115 //
     /* 308496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 308540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 308561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308565 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308569 */     // MIs[4] Operand 1
     /* 308569 */     // No operand predicates
     /* 308569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308575 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 308617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 308620 */     GIR_RootConstrainSelectedInstOperands,
     /* 308621 */     // GIR_Coverage, 6115,
     /* 308621 */     GIR_EraseRootFromParent_Done,
     /* 308622 */   // Label 6177: @308622
     /* 308622 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(308753), // Rule ID 6147 //
     /* 308627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308663 */     // MIs[2] Operand 1
     /* 308663 */     // No operand predicates
     /* 308663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 308675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 308679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308683 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308687 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 308691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308696 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 308700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308706 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308718 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308751 */     GIR_RootConstrainSelectedInstOperands,
     /* 308752 */     // GIR_Coverage, 6147,
     /* 308752 */     GIR_EraseRootFromParent_Done,
     /* 308753 */   // Label 6178: @308753
     /* 308753 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(308884), // Rule ID 6211 //
     /* 308758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 308802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 308823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308827 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308831 */     // MIs[4] Operand 1
     /* 308831 */     // No operand predicates
     /* 308831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308837 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 308872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 308879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 308882 */     GIR_RootConstrainSelectedInstOperands,
     /* 308883 */     // GIR_Coverage, 6211,
     /* 308883 */     GIR_EraseRootFromParent_Done,
     /* 308884 */   // Label 6179: @308884
     /* 308884 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309015), // Rule ID 6179 //
     /* 308889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308937 */     // MIs[3] Operand 1
     /* 308937 */     // No operand predicates
     /* 308937 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 308941 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308945 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308949 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 308953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308958 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 308962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308966 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 308968 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 308968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 308999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309013 */     GIR_RootConstrainSelectedInstOperands,
     /* 309014 */     // GIR_Coverage, 6179,
     /* 309014 */     GIR_EraseRootFromParent_Done,
     /* 309015 */   // Label 6180: @309015
     /* 309015 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309150), // Rule ID 2456 //
     /* 309020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309069 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309079 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309091 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309102 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 309138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309148 */     GIR_RootConstrainSelectedInstOperands,
     /* 309149 */     // GIR_Coverage, 2456,
     /* 309149 */     GIR_EraseRootFromParent_Done,
     /* 309150 */   // Label 6181: @309150
     /* 309150 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(309269), // Rule ID 6083 //
     /* 309155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309179 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309216 */     // MIs[3] Operand 1
     /* 309216 */     // No operand predicates
     /* 309216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309222 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 309253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309267 */     GIR_RootConstrainSelectedInstOperands,
     /* 309268 */     // GIR_Coverage, 6083,
     /* 309268 */     GIR_EraseRootFromParent_Done,
     /* 309269 */   // Label 6182: @309269
     /* 309269 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(309388), // Rule ID 2531 //
     /* 309274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309310 */     // MIs[2] Operand 1
     /* 309310 */     // No operand predicates
     /* 309310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309322 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309326 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309331 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309341 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309353 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 309372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309386 */     GIR_RootConstrainSelectedInstOperands,
     /* 309387 */     // GIR_Coverage, 2531,
     /* 309387 */     GIR_EraseRootFromParent_Done,
     /* 309388 */   // Label 6183: @309388
     /* 309388 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309488), // Rule ID 4860 //
     /* 309393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309444 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309486 */     GIR_RootConstrainSelectedInstOperands,
     /* 309487 */     // GIR_Coverage, 4860,
     /* 309487 */     GIR_EraseRootFromParent_Done,
     /* 309488 */   // Label 6184: @309488
     /* 309488 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(309588), // Rule ID 4896 //
     /* 309493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309517 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 309529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309544 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 309582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 309586 */     GIR_RootConstrainSelectedInstOperands,
     /* 309587 */     // GIR_Coverage, 4896,
     /* 309587 */     GIR_EraseRootFromParent_Done,
     /* 309588 */   // Label 6185: @309588
     /* 309588 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(309685), // Rule ID 13938 //
     /* 309593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309643 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309655 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309683 */     GIR_RootConstrainSelectedInstOperands,
     /* 309684 */     // GIR_Coverage, 13938,
     /* 309684 */     GIR_EraseRootFromParent_Done,
     /* 309685 */   // Label 6186: @309685
     /* 309685 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(309785), // Rule ID 13940 //
     /* 309690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309731 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309741 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 309741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309783 */     GIR_RootConstrainSelectedInstOperands,
     /* 309784 */     // GIR_Coverage, 13940,
     /* 309784 */     GIR_EraseRootFromParent_Done,
     /* 309785 */   // Label 6187: @309785
     /* 309785 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(309885), // Rule ID 4894 //
     /* 309790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309818 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 309826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309841 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 309883 */     GIR_RootConstrainSelectedInstOperands,
     /* 309884 */     // GIR_Coverage, 4894,
     /* 309884 */     GIR_EraseRootFromParent_Done,
     /* 309885 */   // Label 6188: @309885
     /* 309885 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(309982), // Rule ID 4858 //
     /* 309890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309930 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309940 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309980 */     GIR_RootConstrainSelectedInstOperands,
     /* 309981 */     // GIR_Coverage, 4858,
     /* 309981 */     GIR_EraseRootFromParent_Done,
     /* 309982 */   // Label 6189: @309982
     /* 309982 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(310066), // Rule ID 6145 //
     /* 309987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310023 */     // MIs[2] Operand 1
     /* 310023 */     // No operand predicates
     /* 310023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310046 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 310057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310064 */     GIR_RootConstrainSelectedInstOperands,
     /* 310065 */     // GIR_Coverage, 6145,
     /* 310065 */     GIR_EraseRootFromParent_Done,
     /* 310066 */   // Label 6190: @310066
     /* 310066 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(310147), // Rule ID 6177 //
     /* 310071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310115 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310119 */     // MIs[3] Operand 1
     /* 310119 */     // No operand predicates
     /* 310119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310129 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310145 */     GIR_RootConstrainSelectedInstOperands,
     /* 310146 */     // GIR_Coverage, 6177,
     /* 310146 */     GIR_EraseRootFromParent_Done,
     /* 310147 */   // Label 6191: @310147
     /* 310147 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(310231), // Rule ID 6209 //
     /* 310152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310205 */     // MIs[3] Operand 1
     /* 310205 */     // No operand predicates
     /* 310205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310211 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310229 */     GIR_RootConstrainSelectedInstOperands,
     /* 310230 */     // GIR_Coverage, 6209,
     /* 310230 */     GIR_EraseRootFromParent_Done,
     /* 310231 */   // Label 6192: @310231
     /* 310231 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(310312), // Rule ID 6113 //
     /* 310236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310288 */     // MIs[3] Operand 1
     /* 310288 */     // No operand predicates
     /* 310288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310294 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310310 */     GIR_RootConstrainSelectedInstOperands,
     /* 310311 */     // GIR_Coverage, 6113,
     /* 310311 */     GIR_EraseRootFromParent_Done,
     /* 310312 */   // Label 6193: @310312
     /* 310312 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(310397), // Rule ID 2454 //
     /* 310317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310355 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310367 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310395 */     GIR_RootConstrainSelectedInstOperands,
     /* 310396 */     // GIR_Coverage, 2454,
     /* 310396 */     GIR_EraseRootFromParent_Done,
     /* 310397 */   // Label 6194: @310397
     /* 310397 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(310482), // Rule ID 2452 //
     /* 310402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310440 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310480 */     GIR_RootConstrainSelectedInstOperands,
     /* 310481 */     // GIR_Coverage, 2452,
     /* 310481 */     GIR_EraseRootFromParent_Done,
     /* 310482 */   // Label 6195: @310482
     /* 310482 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(310551), // Rule ID 2529 //
     /* 310487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310523 */     // MIs[2] Operand 1
     /* 310523 */     // No operand predicates
     /* 310523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310533 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310549 */     GIR_RootConstrainSelectedInstOperands,
     /* 310550 */     // GIR_Coverage, 2529,
     /* 310550 */     GIR_EraseRootFromParent_Done,
     /* 310551 */   // Label 6196: @310551
     /* 310551 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310620), // Rule ID 6081 //
     /* 310556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310596 */     // MIs[2] Operand 1
     /* 310596 */     // No operand predicates
     /* 310596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310602 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310618 */     GIR_RootConstrainSelectedInstOperands,
     /* 310619 */     // GIR_Coverage, 6081,
     /* 310619 */     GIR_EraseRootFromParent_Done,
     /* 310620 */   // Label 6197: @310620
     /* 310620 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310685), // Rule ID 4914 //
     /* 310625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310668 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310683 */     GIR_RootConstrainSelectedInstOperands,
     /* 310684 */     // GIR_Coverage, 4914,
     /* 310684 */     GIR_EraseRootFromParent_Done,
     /* 310685 */   // Label 6198: @310685
     /* 310685 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310750), // Rule ID 13958 //
     /* 310690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310733 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 310736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 310744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310748 */     GIR_RootConstrainSelectedInstOperands,
     /* 310749 */     // GIR_Coverage, 13958,
     /* 310749 */     GIR_EraseRootFromParent_Done,
     /* 310750 */   // Label 6199: @310750
     /* 310750 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310800), // Rule ID 4911 //
     /* 310755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310785 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310798 */     GIR_RootConstrainSelectedInstOperands,
     /* 310799 */     // GIR_Coverage, 4911,
     /* 310799 */     GIR_EraseRootFromParent_Done,
     /* 310800 */   // Label 6200: @310800
     /* 310800 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310850), // Rule ID 13374 //
     /* 310805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310835 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310848 */     GIR_RootConstrainSelectedInstOperands,
     /* 310849 */     // GIR_Coverage, 13374,
     /* 310849 */     GIR_EraseRootFromParent_Done,
     /* 310850 */   // Label 6201: @310850
     /* 310850 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310900), // Rule ID 644 //
     /* 310855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310885 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310898 */     GIR_RootConstrainSelectedInstOperands,
     /* 310899 */     // GIR_Coverage, 644,
     /* 310899 */     GIR_EraseRootFromParent_Done,
     /* 310900 */   // Label 6202: @310900
     /* 310900 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310950), // Rule ID 13955 //
     /* 310905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310935 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 310946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310948 */     GIR_RootConstrainSelectedInstOperands,
     /* 310949 */     // GIR_Coverage, 13955,
     /* 310949 */     GIR_EraseRootFromParent_Done,
     /* 310950 */   // Label 6203: @310950
     /* 310950 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(311000), // Rule ID 656 //
     /* 310955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 310970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310985 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 310998 */     GIR_RootConstrainSelectedInstOperands,
     /* 310999 */     // GIR_Coverage, 656,
     /* 310999 */     GIR_EraseRootFromParent_Done,
     /* 311000 */   // Label 6204: @311000
     /* 311000 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(311031), // Rule ID 638 //
     /* 311005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311020 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311029 */     GIR_RootConstrainSelectedInstOperands,
     /* 311030 */     // GIR_Coverage, 638,
     /* 311030 */     GIR_Done,
     /* 311031 */   // Label 6205: @311031
     /* 311031 */   GIM_Reject,
     /* 311032 */ // Label 6173: @311032
     /* 311032 */ GIM_Reject,
     /* 311033 */ // Label 6165: @311033
     /* 311033 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(314180),
     /* 311038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 311047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311051 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(311201), // Rule ID 4904 //
     /* 311056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311105 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 311113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 311121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311128 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311140 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311151 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 311187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 311199 */     GIR_RootConstrainSelectedInstOperands,
     /* 311200 */     // GIR_Coverage, 4904,
     /* 311200 */     GIR_EraseRootFromParent_Done,
     /* 311201 */   // Label 6207: @311201
     /* 311201 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(311348), // Rule ID 4868 //
     /* 311206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 311246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311262 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311267 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311277 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311289 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 311336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311346 */     GIR_RootConstrainSelectedInstOperands,
     /* 311347 */     // GIR_Coverage, 4868,
     /* 311347 */     GIR_EraseRootFromParent_Done,
     /* 311348 */   // Label 6208: @311348
     /* 311348 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311495), // Rule ID 13948 //
     /* 311353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311389 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311414 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311424 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 311424 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311427 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311431 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311436 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 311442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 311483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311493 */     GIR_RootConstrainSelectedInstOperands,
     /* 311494 */     // GIR_Coverage, 13948,
     /* 311494 */     GIR_EraseRootFromParent_Done,
     /* 311495 */   // Label 6209: @311495
     /* 311495 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(311626), // Rule ID 6131 //
     /* 311500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311524 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 311540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311556 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311569 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311573 */     // MIs[4] Operand 1
     /* 311573 */     // No operand predicates
     /* 311573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311579 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311591 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311624 */     GIR_RootConstrainSelectedInstOperands,
     /* 311625 */     // GIR_Coverage, 6131,
     /* 311625 */     GIR_EraseRootFromParent_Done,
     /* 311626 */   // Label 6210: @311626
     /* 311626 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311757), // Rule ID 6163 //
     /* 311631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311667 */     // MIs[2] Operand 1
     /* 311667 */     // No operand predicates
     /* 311667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311675 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 311679 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 311683 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311687 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311691 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311695 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311700 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311708 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311710 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311722 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311755 */     GIR_RootConstrainSelectedInstOperands,
     /* 311756 */     // GIR_Coverage, 6163,
     /* 311756 */     GIR_EraseRootFromParent_Done,
     /* 311757 */   // Label 6211: @311757
     /* 311757 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311888), // Rule ID 6227 //
     /* 311762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311798 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311814 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311823 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311827 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311831 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311835 */     // MIs[4] Operand 1
     /* 311835 */     // No operand predicates
     /* 311835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311841 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 311872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311886 */     GIR_RootConstrainSelectedInstOperands,
     /* 311887 */     // GIR_Coverage, 6227,
     /* 311887 */     GIR_EraseRootFromParent_Done,
     /* 311888 */   // Label 6212: @311888
     /* 311888 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(312019), // Rule ID 6195 //
     /* 311893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311937 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 311941 */     // MIs[3] Operand 1
     /* 311941 */     // No operand predicates
     /* 311941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 311945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311949 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311953 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311957 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311962 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311972 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 311972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 311990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312017 */     GIR_RootConstrainSelectedInstOperands,
     /* 312018 */     // GIR_Coverage, 6195,
     /* 312018 */     GIR_EraseRootFromParent_Done,
     /* 312019 */   // Label 6213: @312019
     /* 312019 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(312154), // Rule ID 2462 //
     /* 312024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312073 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312083 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312095 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 312142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312152 */     GIR_RootConstrainSelectedInstOperands,
     /* 312153 */     // GIR_Coverage, 2462,
     /* 312153 */     GIR_EraseRootFromParent_Done,
     /* 312154 */   // Label 6214: @312154
     /* 312154 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(312273), // Rule ID 6099 //
     /* 312159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312216 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312220 */     // MIs[3] Operand 1
     /* 312220 */     // No operand predicates
     /* 312220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312226 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 312257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312271 */     GIR_RootConstrainSelectedInstOperands,
     /* 312272 */     // GIR_Coverage, 6099,
     /* 312272 */     GIR_EraseRootFromParent_Done,
     /* 312273 */   // Label 6215: @312273
     /* 312273 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(312392), // Rule ID 2547 //
     /* 312278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312314 */     // MIs[2] Operand 1
     /* 312314 */     // No operand predicates
     /* 312314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312330 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312335 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312345 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312357 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 312376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312390 */     GIR_RootConstrainSelectedInstOperands,
     /* 312391 */     // GIR_Coverage, 2547,
     /* 312391 */     GIR_EraseRootFromParent_Done,
     /* 312392 */   // Label 6216: @312392
     /* 312392 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(312492), // Rule ID 4866 //
     /* 312397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312448 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312490 */     GIR_RootConstrainSelectedInstOperands,
     /* 312491 */     // GIR_Coverage, 4866,
     /* 312491 */     GIR_EraseRootFromParent_Done,
     /* 312492 */   // Label 6217: @312492
     /* 312492 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(312592), // Rule ID 4902 //
     /* 312497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312548 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312590 */     GIR_RootConstrainSelectedInstOperands,
     /* 312591 */     // GIR_Coverage, 4902,
     /* 312591 */     GIR_EraseRootFromParent_Done,
     /* 312592 */   // Label 6218: @312592
     /* 312592 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(312689), // Rule ID 13944 //
     /* 312597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312633 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312647 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312659 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312687 */     GIR_RootConstrainSelectedInstOperands,
     /* 312688 */     // GIR_Coverage, 13944,
     /* 312688 */     GIR_EraseRootFromParent_Done,
     /* 312689 */   // Label 6219: @312689
     /* 312689 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(312789), // Rule ID 13946 //
     /* 312694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312745 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 312745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312787 */     GIR_RootConstrainSelectedInstOperands,
     /* 312788 */     // GIR_Coverage, 13946,
     /* 312788 */     GIR_EraseRootFromParent_Done,
     /* 312789 */   // Label 6220: @312789
     /* 312789 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(312889), // Rule ID 4900 //
     /* 312794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312845 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312857 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312887 */     GIR_RootConstrainSelectedInstOperands,
     /* 312888 */     // GIR_Coverage, 4900,
     /* 312888 */     GIR_EraseRootFromParent_Done,
     /* 312889 */   // Label 6221: @312889
     /* 312889 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312986), // Rule ID 4864 //
     /* 312894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312944 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312984 */     GIR_RootConstrainSelectedInstOperands,
     /* 312985 */     // GIR_Coverage, 4864,
     /* 312985 */     GIR_EraseRootFromParent_Done,
     /* 312986 */   // Label 6222: @312986
     /* 312986 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(313064), // Rule ID 6249 //
     /* 312991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313032 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313036 */     // MIs[3] Operand 1
     /* 313036 */     // No operand predicates
     /* 313036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313046 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313062 */     GIR_RootConstrainSelectedInstOperands,
     /* 313063 */     // GIR_Coverage, 6249,
     /* 313063 */     GIR_EraseRootFromParent_Done,
     /* 313064 */   // Label 6223: @313064
     /* 313064 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(313148), // Rule ID 6161 //
     /* 313069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313105 */     // MIs[2] Operand 1
     /* 313105 */     // No operand predicates
     /* 313105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313117 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313128 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 313139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313146 */     GIR_RootConstrainSelectedInstOperands,
     /* 313147 */     // GIR_Coverage, 6161,
     /* 313147 */     GIR_EraseRootFromParent_Done,
     /* 313148 */   // Label 6224: @313148
     /* 313148 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(313229), // Rule ID 6193 //
     /* 313153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313197 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313201 */     // MIs[3] Operand 1
     /* 313201 */     // No operand predicates
     /* 313201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313211 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313227 */     GIR_RootConstrainSelectedInstOperands,
     /* 313228 */     // GIR_Coverage, 6193,
     /* 313228 */     GIR_EraseRootFromParent_Done,
     /* 313229 */   // Label 6225: @313229
     /* 313229 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(313313), // Rule ID 6225 //
     /* 313234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313283 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313287 */     // MIs[3] Operand 1
     /* 313287 */     // No operand predicates
     /* 313287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313293 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313311 */     GIR_RootConstrainSelectedInstOperands,
     /* 313312 */     // GIR_Coverage, 6225,
     /* 313312 */     GIR_EraseRootFromParent_Done,
     /* 313313 */   // Label 6226: @313313
     /* 313313 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(313391), // Rule ID 6271 //
     /* 313318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313363 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313367 */     // MIs[3] Operand 1
     /* 313367 */     // No operand predicates
     /* 313367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313373 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313389 */     GIR_RootConstrainSelectedInstOperands,
     /* 313390 */     // GIR_Coverage, 6271,
     /* 313390 */     GIR_EraseRootFromParent_Done,
     /* 313391 */   // Label 6227: @313391
     /* 313391 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(313472), // Rule ID 6129 //
     /* 313396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313444 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313448 */     // MIs[3] Operand 1
     /* 313448 */     // No operand predicates
     /* 313448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313454 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313470 */     GIR_RootConstrainSelectedInstOperands,
     /* 313471 */     // GIR_Coverage, 6129,
     /* 313471 */     GIR_EraseRootFromParent_Done,
     /* 313472 */   // Label 6228: @313472
     /* 313472 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(313557), // Rule ID 2460 //
     /* 313477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313515 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313527 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313555 */     GIR_RootConstrainSelectedInstOperands,
     /* 313556 */     // GIR_Coverage, 2460,
     /* 313556 */     GIR_EraseRootFromParent_Done,
     /* 313557 */   // Label 6229: @313557
     /* 313557 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(313642), // Rule ID 2458 //
     /* 313562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313600 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313640 */     GIR_RootConstrainSelectedInstOperands,
     /* 313641 */     // GIR_Coverage, 2458,
     /* 313641 */     GIR_EraseRootFromParent_Done,
     /* 313642 */   // Label 6230: @313642
     /* 313642 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(313711), // Rule ID 2545 //
     /* 313647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313683 */     // MIs[2] Operand 1
     /* 313683 */     // No operand predicates
     /* 313683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313693 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313709 */     GIR_RootConstrainSelectedInstOperands,
     /* 313710 */     // GIR_Coverage, 2545,
     /* 313710 */     GIR_EraseRootFromParent_Done,
     /* 313711 */   // Label 6231: @313711
     /* 313711 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313780), // Rule ID 6097 //
     /* 313716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313756 */     // MIs[2] Operand 1
     /* 313756 */     // No operand predicates
     /* 313756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313762 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313778 */     GIR_RootConstrainSelectedInstOperands,
     /* 313779 */     // GIR_Coverage, 6097,
     /* 313779 */     GIR_EraseRootFromParent_Done,
     /* 313780 */   // Label 6232: @313780
     /* 313780 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313842), // Rule ID 4915 //
     /* 313785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313825 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 313828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313840 */     GIR_RootConstrainSelectedInstOperands,
     /* 313841 */     // GIR_Coverage, 4915,
     /* 313841 */     GIR_EraseRootFromParent_Done,
     /* 313842 */   // Label 6233: @313842
     /* 313842 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313904), // Rule ID 13959 //
     /* 313847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313887 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 313890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 313898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313902 */     GIR_RootConstrainSelectedInstOperands,
     /* 313903 */     // GIR_Coverage, 13959,
     /* 313903 */     GIR_EraseRootFromParent_Done,
     /* 313904 */   // Label 6234: @313904
     /* 313904 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313951), // Rule ID 4912 //
     /* 313909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313936 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313949 */     GIR_RootConstrainSelectedInstOperands,
     /* 313950 */     // GIR_Coverage, 4912,
     /* 313950 */     GIR_EraseRootFromParent_Done,
     /* 313951 */   // Label 6235: @313951
     /* 313951 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(314001), // Rule ID 13376 //
     /* 313956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313986 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313999 */     GIR_RootConstrainSelectedInstOperands,
     /* 314000 */     // GIR_Coverage, 13376,
     /* 314000 */     GIR_EraseRootFromParent_Done,
     /* 314001 */   // Label 6236: @314001
     /* 314001 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(314051), // Rule ID 646 //
     /* 314006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314036 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314049 */     GIR_RootConstrainSelectedInstOperands,
     /* 314050 */     // GIR_Coverage, 646,
     /* 314050 */     GIR_EraseRootFromParent_Done,
     /* 314051 */   // Label 6237: @314051
     /* 314051 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(314098), // Rule ID 13956 //
     /* 314056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314083 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314096 */     GIR_RootConstrainSelectedInstOperands,
     /* 314097 */     // GIR_Coverage, 13956,
     /* 314097 */     GIR_EraseRootFromParent_Done,
     /* 314098 */   // Label 6238: @314098
     /* 314098 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(314148), // Rule ID 658 //
     /* 314103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 314118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314133 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 314146 */     GIR_RootConstrainSelectedInstOperands,
     /* 314147 */     // GIR_Coverage, 658,
     /* 314147 */     GIR_EraseRootFromParent_Done,
     /* 314148 */   // Label 6239: @314148
     /* 314148 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(314179), // Rule ID 640 //
     /* 314153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314168 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314173 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314177 */     GIR_RootConstrainSelectedInstOperands,
     /* 314178 */     // GIR_Coverage, 640,
     /* 314178 */     GIR_Done,
     /* 314179 */   // Label 6240: @314179
     /* 314179 */   GIM_Reject,
     /* 314180 */ // Label 6206: @314180
     /* 314180 */ GIM_Reject,
     /* 314181 */ // Label 6166: @314181
     /* 314181 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(317328),
     /* 314186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 314195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314199 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(314349), // Rule ID 4910 //
     /* 314204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314253 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 314261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 314269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314276 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314276 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314279 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314283 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314288 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314316 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 314335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 314347 */     GIR_RootConstrainSelectedInstOperands,
     /* 314348 */     // GIR_Coverage, 4910,
     /* 314348 */     GIR_EraseRootFromParent_Done,
     /* 314349 */   // Label 6242: @314349
     /* 314349 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(314496), // Rule ID 4874 //
     /* 314354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 314394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314410 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314415 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314425 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314437 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314465 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 314484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314494 */     GIR_RootConstrainSelectedInstOperands,
     /* 314495 */     // GIR_Coverage, 4874,
     /* 314495 */     GIR_EraseRootFromParent_Done,
     /* 314496 */   // Label 6243: @314496
     /* 314496 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314643), // Rule ID 13954 //
     /* 314501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314562 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314572 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 314572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314584 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 314590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 314631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314641 */     GIR_RootConstrainSelectedInstOperands,
     /* 314642 */     // GIR_Coverage, 13954,
     /* 314642 */     GIR_EraseRootFromParent_Done,
     /* 314643 */   // Label 6244: @314643
     /* 314643 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(314774), // Rule ID 6135 //
     /* 314648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 314688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314696 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314700 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314704 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314717 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314721 */     // MIs[4] Operand 1
     /* 314721 */     // No operand predicates
     /* 314721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314725 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314727 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314739 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 314758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 314769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 314772 */     GIR_RootConstrainSelectedInstOperands,
     /* 314773 */     // GIR_Coverage, 6135,
     /* 314773 */     GIR_EraseRootFromParent_Done,
     /* 314774 */   // Label 6245: @314774
     /* 314774 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314905), // Rule ID 6167 //
     /* 314779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314815 */     // MIs[2] Operand 1
     /* 314815 */     // No operand predicates
     /* 314815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 314827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 314831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 314843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314848 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 314852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314858 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 314889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314903 */     GIR_RootConstrainSelectedInstOperands,
     /* 314904 */     // GIR_Coverage, 6167,
     /* 314904 */     GIR_EraseRootFromParent_Done,
     /* 314905 */   // Label 6246: @314905
     /* 314905 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(315036), // Rule ID 6231 //
     /* 314910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 314925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314979 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 314983 */     // MIs[4] Operand 1
     /* 314983 */     // No operand predicates
     /* 314983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314987 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314989 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 314989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315001 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315034 */     GIR_RootConstrainSelectedInstOperands,
     /* 315035 */     // GIR_Coverage, 6231,
     /* 315035 */     GIR_EraseRootFromParent_Done,
     /* 315036 */   // Label 6247: @315036
     /* 315036 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(315167), // Rule ID 6199 //
     /* 315041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315085 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315089 */     // MIs[3] Operand 1
     /* 315089 */     // No operand predicates
     /* 315089 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 315093 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315097 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315101 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 315105 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315110 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 315114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315120 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315132 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315165 */     GIR_RootConstrainSelectedInstOperands,
     /* 315166 */     // GIR_Coverage, 6199,
     /* 315166 */     GIR_EraseRootFromParent_Done,
     /* 315167 */   // Label 6248: @315167
     /* 315167 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(315302), // Rule ID 2468 //
     /* 315172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315221 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315231 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315231 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315234 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315238 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315243 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315249 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315254 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315271 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 315290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315300 */     GIR_RootConstrainSelectedInstOperands,
     /* 315301 */     // GIR_Coverage, 2468,
     /* 315301 */     GIR_EraseRootFromParent_Done,
     /* 315302 */   // Label 6249: @315302
     /* 315302 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(315421), // Rule ID 6103 //
     /* 315307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315364 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315368 */     // MIs[3] Operand 1
     /* 315368 */     // No operand predicates
     /* 315368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315374 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315386 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 315405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315419 */     GIR_RootConstrainSelectedInstOperands,
     /* 315420 */     // GIR_Coverage, 6103,
     /* 315420 */     GIR_EraseRootFromParent_Done,
     /* 315421 */   // Label 6250: @315421
     /* 315421 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(315540), // Rule ID 2551 //
     /* 315426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315462 */     // MIs[2] Operand 1
     /* 315462 */     // No operand predicates
     /* 315462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315474 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315478 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315483 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315493 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315505 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 315524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315538 */     GIR_RootConstrainSelectedInstOperands,
     /* 315539 */     // GIR_Coverage, 2551,
     /* 315539 */     GIR_EraseRootFromParent_Done,
     /* 315540 */   // Label 6251: @315540
     /* 315540 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(315640), // Rule ID 4872 //
     /* 315545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315596 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315608 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315638 */     GIR_RootConstrainSelectedInstOperands,
     /* 315639 */     // GIR_Coverage, 4872,
     /* 315639 */     GIR_EraseRootFromParent_Done,
     /* 315640 */   // Label 6252: @315640
     /* 315640 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(315740), // Rule ID 4908 //
     /* 315645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315696 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315708 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 315727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315738 */     GIR_RootConstrainSelectedInstOperands,
     /* 315739 */     // GIR_Coverage, 4908,
     /* 315739 */     GIR_EraseRootFromParent_Done,
     /* 315740 */   // Label 6253: @315740
     /* 315740 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(315837), // Rule ID 13950 //
     /* 315745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315795 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315835 */     GIR_RootConstrainSelectedInstOperands,
     /* 315836 */     // GIR_Coverage, 13950,
     /* 315836 */     GIR_EraseRootFromParent_Done,
     /* 315837 */   // Label 6254: @315837
     /* 315837 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(315937), // Rule ID 13952 //
     /* 315842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315893 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 315893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315905 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315935 */     GIR_RootConstrainSelectedInstOperands,
     /* 315936 */     // GIR_Coverage, 13952,
     /* 315936 */     GIR_EraseRootFromParent_Done,
     /* 315937 */   // Label 6255: @315937
     /* 315937 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(316037), // Rule ID 4906 //
     /* 315942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315970 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315993 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316005 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316035 */     GIR_RootConstrainSelectedInstOperands,
     /* 316036 */     // GIR_Coverage, 4906,
     /* 316036 */     GIR_EraseRootFromParent_Done,
     /* 316037 */   // Label 6256: @316037
     /* 316037 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(316134), // Rule ID 4870 //
     /* 316042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316082 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316092 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316132 */     GIR_RootConstrainSelectedInstOperands,
     /* 316133 */     // GIR_Coverage, 4870,
     /* 316133 */     GIR_EraseRootFromParent_Done,
     /* 316134 */   // Label 6257: @316134
     /* 316134 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(316212), // Rule ID 6253 //
     /* 316139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316184 */     // MIs[3] Operand 1
     /* 316184 */     // No operand predicates
     /* 316184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316194 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316210 */     GIR_RootConstrainSelectedInstOperands,
     /* 316211 */     // GIR_Coverage, 6253,
     /* 316211 */     GIR_EraseRootFromParent_Done,
     /* 316212 */   // Label 6258: @316212
     /* 316212 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(316296), // Rule ID 6165 //
     /* 316217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316253 */     // MIs[2] Operand 1
     /* 316253 */     // No operand predicates
     /* 316253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316276 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 316287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316294 */     GIR_RootConstrainSelectedInstOperands,
     /* 316295 */     // GIR_Coverage, 6165,
     /* 316295 */     GIR_EraseRootFromParent_Done,
     /* 316296 */   // Label 6259: @316296
     /* 316296 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(316377), // Rule ID 6197 //
     /* 316301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316349 */     // MIs[3] Operand 1
     /* 316349 */     // No operand predicates
     /* 316349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316359 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316375 */     GIR_RootConstrainSelectedInstOperands,
     /* 316376 */     // GIR_Coverage, 6197,
     /* 316376 */     GIR_EraseRootFromParent_Done,
     /* 316377 */   // Label 6260: @316377
     /* 316377 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(316461), // Rule ID 6229 //
     /* 316382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316431 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316435 */     // MIs[3] Operand 1
     /* 316435 */     // No operand predicates
     /* 316435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316441 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316459 */     GIR_RootConstrainSelectedInstOperands,
     /* 316460 */     // GIR_Coverage, 6229,
     /* 316460 */     GIR_EraseRootFromParent_Done,
     /* 316461 */   // Label 6261: @316461
     /* 316461 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(316539), // Rule ID 6275 //
     /* 316466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 316515 */     // MIs[3] Operand 1
     /* 316515 */     // No operand predicates
     /* 316515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316521 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 316521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316537 */     GIR_RootConstrainSelectedInstOperands,
     /* 316538 */     // GIR_Coverage, 6275,
     /* 316538 */     GIR_EraseRootFromParent_Done,
     /* 316539 */   // Label 6262: @316539
     /* 316539 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(316620), // Rule ID 6133 //
     /* 316544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316596 */     // MIs[3] Operand 1
     /* 316596 */     // No operand predicates
     /* 316596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316602 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316618 */     GIR_RootConstrainSelectedInstOperands,
     /* 316619 */     // GIR_Coverage, 6133,
     /* 316619 */     GIR_EraseRootFromParent_Done,
     /* 316620 */   // Label 6263: @316620
     /* 316620 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(316705), // Rule ID 2466 //
     /* 316625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316649 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316663 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316703 */     GIR_RootConstrainSelectedInstOperands,
     /* 316704 */     // GIR_Coverage, 2466,
     /* 316704 */     GIR_EraseRootFromParent_Done,
     /* 316705 */   // Label 6264: @316705
     /* 316705 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(316790), // Rule ID 2464 //
     /* 316710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316748 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316760 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316788 */     GIR_RootConstrainSelectedInstOperands,
     /* 316789 */     // GIR_Coverage, 2464,
     /* 316789 */     GIR_EraseRootFromParent_Done,
     /* 316790 */   // Label 6265: @316790
     /* 316790 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(316859), // Rule ID 2549 //
     /* 316795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316831 */     // MIs[2] Operand 1
     /* 316831 */     // No operand predicates
     /* 316831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316841 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316857 */     GIR_RootConstrainSelectedInstOperands,
     /* 316858 */     // GIR_Coverage, 2549,
     /* 316858 */     GIR_EraseRootFromParent_Done,
     /* 316859 */   // Label 6266: @316859
     /* 316859 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(316928), // Rule ID 6101 //
     /* 316864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316904 */     // MIs[2] Operand 1
     /* 316904 */     // No operand predicates
     /* 316904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316910 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316926 */     GIR_RootConstrainSelectedInstOperands,
     /* 316927 */     // GIR_Coverage, 6101,
     /* 316927 */     GIR_EraseRootFromParent_Done,
     /* 316928 */   // Label 6267: @316928
     /* 316928 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316990), // Rule ID 4916 //
     /* 316933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316973 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 316976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316988 */     GIR_RootConstrainSelectedInstOperands,
     /* 316989 */     // GIR_Coverage, 4916,
     /* 316989 */     GIR_EraseRootFromParent_Done,
     /* 316990 */   // Label 6268: @316990
     /* 316990 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(317052), // Rule ID 13960 //
     /* 316995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317035 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317050 */     GIR_RootConstrainSelectedInstOperands,
     /* 317051 */     // GIR_Coverage, 13960,
     /* 317051 */     GIR_EraseRootFromParent_Done,
     /* 317052 */   // Label 6269: @317052
     /* 317052 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(317099), // Rule ID 4913 //
     /* 317057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317084 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317097 */     GIR_RootConstrainSelectedInstOperands,
     /* 317098 */     // GIR_Coverage, 4913,
     /* 317098 */     GIR_EraseRootFromParent_Done,
     /* 317099 */   // Label 6270: @317099
     /* 317099 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(317149), // Rule ID 13378 //
     /* 317104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317134 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317147 */     GIR_RootConstrainSelectedInstOperands,
     /* 317148 */     // GIR_Coverage, 13378,
     /* 317148 */     GIR_EraseRootFromParent_Done,
     /* 317149 */   // Label 6271: @317149
     /* 317149 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(317199), // Rule ID 648 //
     /* 317154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317184 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317197 */     GIR_RootConstrainSelectedInstOperands,
     /* 317198 */     // GIR_Coverage, 648,
     /* 317198 */     GIR_EraseRootFromParent_Done,
     /* 317199 */   // Label 6272: @317199
     /* 317199 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(317246), // Rule ID 13957 //
     /* 317204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317231 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317244 */     GIR_RootConstrainSelectedInstOperands,
     /* 317245 */     // GIR_Coverage, 13957,
     /* 317245 */     GIR_EraseRootFromParent_Done,
     /* 317246 */   // Label 6273: @317246
     /* 317246 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(317296), // Rule ID 660 //
     /* 317251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 317266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317281 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 317294 */     GIR_RootConstrainSelectedInstOperands,
     /* 317295 */     // GIR_Coverage, 660,
     /* 317295 */     GIR_EraseRootFromParent_Done,
     /* 317296 */   // Label 6274: @317296
     /* 317296 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(317327), // Rule ID 642 //
     /* 317301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317316 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317321 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317325 */     GIR_RootConstrainSelectedInstOperands,
     /* 317326 */     // GIR_Coverage, 642,
     /* 317326 */     GIR_Done,
     /* 317327 */   // Label 6275: @317327
     /* 317327 */   GIM_Reject,
     /* 317328 */ // Label 6241: @317328
     /* 317328 */ GIM_Reject,
     /* 317329 */ // Label 6167: @317329
     /* 317329 */ GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(318849),
     /* 317334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 317340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 317343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317347 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317425), // Rule ID 6233 //
     /* 317352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317397 */     // MIs[3] Operand 1
     /* 317397 */     // No operand predicates
     /* 317397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317407 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317423 */     GIR_RootConstrainSelectedInstOperands,
     /* 317424 */     // GIR_Coverage, 6233,
     /* 317424 */     GIR_EraseRootFromParent_Done,
     /* 317425 */   // Label 6277: @317425
     /* 317425 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317509), // Rule ID 6149 //
     /* 317430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317466 */     // MIs[2] Operand 1
     /* 317466 */     // No operand predicates
     /* 317466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317478 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317489 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 317500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317507 */     GIR_RootConstrainSelectedInstOperands,
     /* 317508 */     // GIR_Coverage, 6149,
     /* 317508 */     GIR_EraseRootFromParent_Done,
     /* 317509 */   // Label 6278: @317509
     /* 317509 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317590), // Rule ID 6181 //
     /* 317514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317558 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317562 */     // MIs[3] Operand 1
     /* 317562 */     // No operand predicates
     /* 317562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317572 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317588 */     GIR_RootConstrainSelectedInstOperands,
     /* 317589 */     // GIR_Coverage, 6181,
     /* 317589 */     GIR_EraseRootFromParent_Done,
     /* 317590 */   // Label 6279: @317590
     /* 317590 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(317674), // Rule ID 6213 //
     /* 317595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317644 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317648 */     // MIs[3] Operand 1
     /* 317648 */     // No operand predicates
     /* 317648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317654 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317672 */     GIR_RootConstrainSelectedInstOperands,
     /* 317673 */     // GIR_Coverage, 6213,
     /* 317673 */     GIR_EraseRootFromParent_Done,
     /* 317674 */   // Label 6280: @317674
     /* 317674 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317752), // Rule ID 6255 //
     /* 317679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317724 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317728 */     // MIs[3] Operand 1
     /* 317728 */     // No operand predicates
     /* 317728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317734 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317750 */     GIR_RootConstrainSelectedInstOperands,
     /* 317751 */     // GIR_Coverage, 6255,
     /* 317751 */     GIR_EraseRootFromParent_Done,
     /* 317752 */   // Label 6281: @317752
     /* 317752 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(317833), // Rule ID 6117 //
     /* 317757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317809 */     // MIs[3] Operand 1
     /* 317809 */     // No operand predicates
     /* 317809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317815 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 317818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317831 */     GIR_RootConstrainSelectedInstOperands,
     /* 317832 */     // GIR_Coverage, 6117,
     /* 317832 */     GIR_EraseRootFromParent_Done,
     /* 317833 */   // Label 6282: @317833
     /* 317833 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(317902), // Rule ID 2533 //
     /* 317838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317874 */     // MIs[2] Operand 1
     /* 317874 */     // No operand predicates
     /* 317874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317884 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 317887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317900 */     GIR_RootConstrainSelectedInstOperands,
     /* 317901 */     // GIR_Coverage, 2533,
     /* 317901 */     GIR_EraseRootFromParent_Done,
     /* 317902 */   // Label 6283: @317902
     /* 317902 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(317971), // Rule ID 6085 //
     /* 317907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 317922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317943 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317947 */     // MIs[2] Operand 1
     /* 317947 */     // No operand predicates
     /* 317947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317953 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 317956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317969 */     GIR_RootConstrainSelectedInstOperands,
     /* 317970 */     // GIR_Coverage, 6085,
     /* 317970 */     GIR_EraseRootFromParent_Done,
     /* 317971 */   // Label 6284: @317971
     /* 317971 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(318064), // Rule ID 6237 //
     /* 317976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 317984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318015 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318062 */     GIR_RootConstrainSelectedInstOperands,
     /* 318063 */     // GIR_Coverage, 6237,
     /* 318063 */     GIR_EraseRootFromParent_Done,
     /* 318064 */   // Label 6285: @318064
     /* 318064 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(318163), // Rule ID 6151 //
     /* 318069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318112 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 318155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318161 */     GIR_RootConstrainSelectedInstOperands,
     /* 318162 */     // GIR_Coverage, 6151,
     /* 318162 */     GIR_EraseRootFromParent_Done,
     /* 318163 */   // Label 6286: @318163
     /* 318163 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(318259), // Rule ID 6183 //
     /* 318168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318210 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318257 */     GIR_RootConstrainSelectedInstOperands,
     /* 318258 */     // GIR_Coverage, 6183,
     /* 318258 */     GIR_EraseRootFromParent_Done,
     /* 318259 */   // Label 6287: @318259
     /* 318259 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(318358), // Rule ID 6215 //
     /* 318264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318307 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318319 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318326 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318356 */     GIR_RootConstrainSelectedInstOperands,
     /* 318357 */     // GIR_Coverage, 6215,
     /* 318357 */     GIR_EraseRootFromParent_Done,
     /* 318358 */   // Label 6288: @318358
     /* 318358 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(318451), // Rule ID 6259 //
     /* 318363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318402 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318449 */     GIR_RootConstrainSelectedInstOperands,
     /* 318450 */     // GIR_Coverage, 6259,
     /* 318450 */     GIR_EraseRootFromParent_Done,
     /* 318451 */   // Label 6289: @318451
     /* 318451 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(318547), // Rule ID 6119 //
     /* 318456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 318483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318498 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318517 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318545 */     GIR_RootConstrainSelectedInstOperands,
     /* 318546 */     // GIR_Coverage, 6119,
     /* 318546 */     GIR_EraseRootFromParent_Done,
     /* 318547 */   // Label 6290: @318547
     /* 318547 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318631), // Rule ID 2535 //
     /* 318552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318582 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318629 */     GIR_RootConstrainSelectedInstOperands,
     /* 318630 */     // GIR_Coverage, 2535,
     /* 318630 */     GIR_EraseRootFromParent_Done,
     /* 318631 */   // Label 6291: @318631
     /* 318631 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318681), // Rule ID 13408 //
     /* 318636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318666 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 318669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318679 */     GIR_RootConstrainSelectedInstOperands,
     /* 318680 */     // GIR_Coverage, 13408,
     /* 318680 */     GIR_EraseRootFromParent_Done,
     /* 318681 */   // Label 6292: @318681
     /* 318681 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318765), // Rule ID 6087 //
     /* 318686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318716 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318763 */     GIR_RootConstrainSelectedInstOperands,
     /* 318764 */     // GIR_Coverage, 6087,
     /* 318764 */     GIR_EraseRootFromParent_Done,
     /* 318765 */   // Label 6293: @318765
     /* 318765 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318815), // Rule ID 1308 //
     /* 318770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318800 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 318803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318813 */     GIR_RootConstrainSelectedInstOperands,
     /* 318814 */     // GIR_Coverage, 1308,
     /* 318814 */     GIR_EraseRootFromParent_Done,
     /* 318815 */   // Label 6294: @318815
     /* 318815 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318848), // Rule ID 1298 //
     /* 318820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318835 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 318838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318846 */     GIR_RootConstrainSelectedInstOperands,
     /* 318847 */     // GIR_Coverage, 1298,
     /* 318847 */     GIR_EraseRootFromParent_Done,
     /* 318848 */   // Label 6295: @318848
     /* 318848 */   GIM_Reject,
     /* 318849 */ // Label 6276: @318849
     /* 318849 */ GIM_Reject,
     /* 318850 */ // Label 6168: @318850
     /* 318850 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(320370),
     /* 318855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 318861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 318864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318868 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318946), // Rule ID 6245 //
     /* 318873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 318881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318914 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318918 */     // MIs[3] Operand 1
     /* 318918 */     // No operand predicates
     /* 318918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318928 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 318931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318944 */     GIR_RootConstrainSelectedInstOperands,
     /* 318945 */     // GIR_Coverage, 6245,
     /* 318945 */     GIR_EraseRootFromParent_Done,
     /* 318946 */   // Label 6297: @318946
     /* 318946 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(319030), // Rule ID 6157 //
     /* 318951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 318962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318987 */     // MIs[2] Operand 1
     /* 318987 */     // No operand predicates
     /* 318987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318999 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319010 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319028 */     GIR_RootConstrainSelectedInstOperands,
     /* 319029 */     // GIR_Coverage, 6157,
     /* 319029 */     GIR_EraseRootFromParent_Done,
     /* 319030 */   // Label 6298: @319030
     /* 319030 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(319111), // Rule ID 6189 //
     /* 319035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319079 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319083 */     // MIs[3] Operand 1
     /* 319083 */     // No operand predicates
     /* 319083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319093 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319109 */     GIR_RootConstrainSelectedInstOperands,
     /* 319110 */     // GIR_Coverage, 6189,
     /* 319110 */     GIR_EraseRootFromParent_Done,
     /* 319111 */   // Label 6299: @319111
     /* 319111 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(319195), // Rule ID 6221 //
     /* 319116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319165 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319169 */     // MIs[3] Operand 1
     /* 319169 */     // No operand predicates
     /* 319169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319175 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319193 */     GIR_RootConstrainSelectedInstOperands,
     /* 319194 */     // GIR_Coverage, 6221,
     /* 319194 */     GIR_EraseRootFromParent_Done,
     /* 319195 */   // Label 6300: @319195
     /* 319195 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(319273), // Rule ID 6267 //
     /* 319200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319245 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319249 */     // MIs[3] Operand 1
     /* 319249 */     // No operand predicates
     /* 319249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319255 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319271 */     GIR_RootConstrainSelectedInstOperands,
     /* 319272 */     // GIR_Coverage, 6267,
     /* 319272 */     GIR_EraseRootFromParent_Done,
     /* 319273 */   // Label 6301: @319273
     /* 319273 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(319354), // Rule ID 6125 //
     /* 319278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319326 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319330 */     // MIs[3] Operand 1
     /* 319330 */     // No operand predicates
     /* 319330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319336 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319352 */     GIR_RootConstrainSelectedInstOperands,
     /* 319353 */     // GIR_Coverage, 6125,
     /* 319353 */     GIR_EraseRootFromParent_Done,
     /* 319354 */   // Label 6302: @319354
     /* 319354 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319423), // Rule ID 2541 //
     /* 319359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319395 */     // MIs[2] Operand 1
     /* 319395 */     // No operand predicates
     /* 319395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319405 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 319408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319421 */     GIR_RootConstrainSelectedInstOperands,
     /* 319422 */     // GIR_Coverage, 2541,
     /* 319422 */     GIR_EraseRootFromParent_Done,
     /* 319423 */   // Label 6303: @319423
     /* 319423 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319492), // Rule ID 6093 //
     /* 319428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319468 */     // MIs[2] Operand 1
     /* 319468 */     // No operand predicates
     /* 319468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319474 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 319477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319490 */     GIR_RootConstrainSelectedInstOperands,
     /* 319491 */     // GIR_Coverage, 6093,
     /* 319491 */     GIR_EraseRootFromParent_Done,
     /* 319492 */   // Label 6304: @319492
     /* 319492 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319585), // Rule ID 6247 //
     /* 319497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319536 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319583 */     GIR_RootConstrainSelectedInstOperands,
     /* 319584 */     // GIR_Coverage, 6247,
     /* 319584 */     GIR_EraseRootFromParent_Done,
     /* 319585 */   // Label 6305: @319585
     /* 319585 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319684), // Rule ID 6159 //
     /* 319590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319633 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 319676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319682 */     GIR_RootConstrainSelectedInstOperands,
     /* 319683 */     // GIR_Coverage, 6159,
     /* 319683 */     GIR_EraseRootFromParent_Done,
     /* 319684 */   // Label 6306: @319684
     /* 319684 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319780), // Rule ID 6191 //
     /* 319689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319731 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319778 */     GIR_RootConstrainSelectedInstOperands,
     /* 319779 */     // GIR_Coverage, 6191,
     /* 319779 */     GIR_EraseRootFromParent_Done,
     /* 319780 */   // Label 6307: @319780
     /* 319780 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319879), // Rule ID 6223 //
     /* 319785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319828 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319877 */     GIR_RootConstrainSelectedInstOperands,
     /* 319878 */     // GIR_Coverage, 6223,
     /* 319878 */     GIR_EraseRootFromParent_Done,
     /* 319879 */   // Label 6308: @319879
     /* 319879 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319972), // Rule ID 6269 //
     /* 319884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319923 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 319945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319970 */     GIR_RootConstrainSelectedInstOperands,
     /* 319971 */     // GIR_Coverage, 6269,
     /* 319971 */     GIR_EraseRootFromParent_Done,
     /* 319972 */   // Label 6309: @319972
     /* 319972 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(320068), // Rule ID 6127 //
     /* 319977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320019 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320066 */     GIR_RootConstrainSelectedInstOperands,
     /* 320067 */     // GIR_Coverage, 6127,
     /* 320067 */     GIR_EraseRootFromParent_Done,
     /* 320068 */   // Label 6310: @320068
     /* 320068 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(320152), // Rule ID 2543 //
     /* 320073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320103 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320122 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320150 */     GIR_RootConstrainSelectedInstOperands,
     /* 320151 */     // GIR_Coverage, 2543,
     /* 320151 */     GIR_EraseRootFromParent_Done,
     /* 320152 */   // Label 6311: @320152
     /* 320152 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(320202), // Rule ID 13412 //
     /* 320157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320187 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 320190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320200 */     GIR_RootConstrainSelectedInstOperands,
     /* 320201 */     // GIR_Coverage, 13412,
     /* 320201 */     GIR_EraseRootFromParent_Done,
     /* 320202 */   // Label 6312: @320202
     /* 320202 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(320286), // Rule ID 6095 //
     /* 320207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320237 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320284 */     GIR_RootConstrainSelectedInstOperands,
     /* 320285 */     // GIR_Coverage, 6095,
     /* 320285 */     GIR_EraseRootFromParent_Done,
     /* 320286 */   // Label 6313: @320286
     /* 320286 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(320336), // Rule ID 1312 //
     /* 320291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320321 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 320324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320334 */     GIR_RootConstrainSelectedInstOperands,
     /* 320335 */     // GIR_Coverage, 1312,
     /* 320335 */     GIR_EraseRootFromParent_Done,
     /* 320336 */   // Label 6314: @320336
     /* 320336 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(320369), // Rule ID 1302 //
     /* 320341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320356 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 320359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 320367 */     GIR_RootConstrainSelectedInstOperands,
     /* 320368 */     // GIR_Coverage, 1302,
     /* 320368 */     GIR_EraseRootFromParent_Done,
     /* 320369 */   // Label 6315: @320369
     /* 320369 */   GIM_Reject,
     /* 320370 */ // Label 6296: @320370
     /* 320370 */ GIM_Reject,
     /* 320371 */ // Label 6169: @320371
     /* 320371 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(321549),
     /* 320376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 320382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 320385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320389 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(320473), // Rule ID 6141 //
     /* 320394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320430 */     // MIs[2] Operand 1
     /* 320430 */     // No operand predicates
     /* 320430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 320434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320442 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320453 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 320464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320471 */     GIR_RootConstrainSelectedInstOperands,
     /* 320472 */     // GIR_Coverage, 6141,
     /* 320472 */     GIR_EraseRootFromParent_Done,
     /* 320473 */   // Label 6317: @320473
     /* 320473 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(320554), // Rule ID 6173 //
     /* 320478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320526 */     // MIs[3] Operand 1
     /* 320526 */     // No operand predicates
     /* 320526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320536 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320552 */     GIR_RootConstrainSelectedInstOperands,
     /* 320553 */     // GIR_Coverage, 6173,
     /* 320553 */     GIR_EraseRootFromParent_Done,
     /* 320554 */   // Label 6318: @320554
     /* 320554 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320638), // Rule ID 6205 //
     /* 320559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320608 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320612 */     // MIs[3] Operand 1
     /* 320612 */     // No operand predicates
     /* 320612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320618 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320636 */     GIR_RootConstrainSelectedInstOperands,
     /* 320637 */     // GIR_Coverage, 6205,
     /* 320637 */     GIR_EraseRootFromParent_Done,
     /* 320638 */   // Label 6319: @320638
     /* 320638 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(320719), // Rule ID 6109 //
     /* 320643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320695 */     // MIs[3] Operand 1
     /* 320695 */     // No operand predicates
     /* 320695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320701 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320717 */     GIR_RootConstrainSelectedInstOperands,
     /* 320718 */     // GIR_Coverage, 6109,
     /* 320718 */     GIR_EraseRootFromParent_Done,
     /* 320719 */   // Label 6320: @320719
     /* 320719 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320788), // Rule ID 2525 //
     /* 320724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320756 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320760 */     // MIs[2] Operand 1
     /* 320760 */     // No operand predicates
     /* 320760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320770 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 320773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320786 */     GIR_RootConstrainSelectedInstOperands,
     /* 320787 */     // GIR_Coverage, 2525,
     /* 320787 */     GIR_EraseRootFromParent_Done,
     /* 320788 */   // Label 6321: @320788
     /* 320788 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320857), // Rule ID 6077 //
     /* 320793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 320808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 320821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 320833 */     // MIs[2] Operand 1
     /* 320833 */     // No operand predicates
     /* 320833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320839 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 320839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 320842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320855 */     GIR_RootConstrainSelectedInstOperands,
     /* 320856 */     // GIR_Coverage, 6077,
     /* 320856 */     GIR_EraseRootFromParent_Done,
     /* 320857 */   // Label 6322: @320857
     /* 320857 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320956), // Rule ID 6143 //
     /* 320862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320905 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 320908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 320940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320954 */     GIR_RootConstrainSelectedInstOperands,
     /* 320955 */     // GIR_Coverage, 6143,
     /* 320955 */     GIR_EraseRootFromParent_Done,
     /* 320956 */   // Label 6323: @320956
     /* 320956 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(321052), // Rule ID 6175 //
     /* 320961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 320993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321003 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321050 */     GIR_RootConstrainSelectedInstOperands,
     /* 321051 */     // GIR_Coverage, 6175,
     /* 321051 */     GIR_EraseRootFromParent_Done,
     /* 321052 */   // Label 6324: @321052
     /* 321052 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(321151), // Rule ID 6207 //
     /* 321057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321100 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321119 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321149 */     GIR_RootConstrainSelectedInstOperands,
     /* 321150 */     // GIR_Coverage, 6207,
     /* 321150 */     GIR_EraseRootFromParent_Done,
     /* 321151 */   // Label 6325: @321151
     /* 321151 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(321247), // Rule ID 6111 //
     /* 321156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321198 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321245 */     GIR_RootConstrainSelectedInstOperands,
     /* 321246 */     // GIR_Coverage, 6111,
     /* 321246 */     GIR_EraseRootFromParent_Done,
     /* 321247 */   // Label 6326: @321247
     /* 321247 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(321331), // Rule ID 2527 //
     /* 321252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321282 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321329 */     GIR_RootConstrainSelectedInstOperands,
     /* 321330 */     // GIR_Coverage, 2527,
     /* 321330 */     GIR_EraseRootFromParent_Done,
     /* 321331 */   // Label 6327: @321331
     /* 321331 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(321381), // Rule ID 13404 //
     /* 321336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321366 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 321369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321379 */     GIR_RootConstrainSelectedInstOperands,
     /* 321380 */     // GIR_Coverage, 13404,
     /* 321380 */     GIR_EraseRootFromParent_Done,
     /* 321381 */   // Label 6328: @321381
     /* 321381 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(321465), // Rule ID 6079 //
     /* 321386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321416 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321463 */     GIR_RootConstrainSelectedInstOperands,
     /* 321464 */     // GIR_Coverage, 6079,
     /* 321464 */     GIR_EraseRootFromParent_Done,
     /* 321465 */   // Label 6329: @321465
     /* 321465 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(321515), // Rule ID 1304 //
     /* 321470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321500 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 321503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321513 */     GIR_RootConstrainSelectedInstOperands,
     /* 321514 */     // GIR_Coverage, 1304,
     /* 321514 */     GIR_EraseRootFromParent_Done,
     /* 321515 */   // Label 6330: @321515
     /* 321515 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321548), // Rule ID 1294 //
     /* 321520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321535 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 321538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321546 */     GIR_RootConstrainSelectedInstOperands,
     /* 321547 */     // GIR_Coverage, 1294,
     /* 321547 */     GIR_EraseRootFromParent_Done,
     /* 321548 */   // Label 6331: @321548
     /* 321548 */   GIM_Reject,
     /* 321549 */ // Label 6316: @321549
     /* 321549 */ GIM_Reject,
     /* 321550 */ // Label 6170: @321550
     /* 321550 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(323070),
     /* 321555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 321561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 321564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321568 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321646), // Rule ID 6239 //
     /* 321573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321614 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321618 */     // MIs[3] Operand 1
     /* 321618 */     // No operand predicates
     /* 321618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321628 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321644 */     GIR_RootConstrainSelectedInstOperands,
     /* 321645 */     // GIR_Coverage, 6239,
     /* 321645 */     GIR_EraseRootFromParent_Done,
     /* 321646 */   // Label 6333: @321646
     /* 321646 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321730), // Rule ID 6153 //
     /* 321651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321687 */     // MIs[2] Operand 1
     /* 321687 */     // No operand predicates
     /* 321687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321699 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321710 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321728 */     GIR_RootConstrainSelectedInstOperands,
     /* 321729 */     // GIR_Coverage, 6153,
     /* 321729 */     GIR_EraseRootFromParent_Done,
     /* 321730 */   // Label 6334: @321730
     /* 321730 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321811), // Rule ID 6185 //
     /* 321735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321783 */     // MIs[3] Operand 1
     /* 321783 */     // No operand predicates
     /* 321783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321793 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321809 */     GIR_RootConstrainSelectedInstOperands,
     /* 321810 */     // GIR_Coverage, 6185,
     /* 321810 */     GIR_EraseRootFromParent_Done,
     /* 321811 */   // Label 6335: @321811
     /* 321811 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321895), // Rule ID 6217 //
     /* 321816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321869 */     // MIs[3] Operand 1
     /* 321869 */     // No operand predicates
     /* 321869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321875 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321893 */     GIR_RootConstrainSelectedInstOperands,
     /* 321894 */     // GIR_Coverage, 6217,
     /* 321894 */     GIR_EraseRootFromParent_Done,
     /* 321895 */   // Label 6336: @321895
     /* 321895 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321973), // Rule ID 6261 //
     /* 321900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 321912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 321949 */     // MIs[3] Operand 1
     /* 321949 */     // No operand predicates
     /* 321949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321955 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 321958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321971 */     GIR_RootConstrainSelectedInstOperands,
     /* 321972 */     // GIR_Coverage, 6261,
     /* 321972 */     GIR_EraseRootFromParent_Done,
     /* 321973 */   // Label 6337: @321973
     /* 321973 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(322054), // Rule ID 6121 //
     /* 321978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322026 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322030 */     // MIs[3] Operand 1
     /* 322030 */     // No operand predicates
     /* 322030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322036 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322052 */     GIR_RootConstrainSelectedInstOperands,
     /* 322053 */     // GIR_Coverage, 6121,
     /* 322053 */     GIR_EraseRootFromParent_Done,
     /* 322054 */   // Label 6338: @322054
     /* 322054 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(322123), // Rule ID 2537 //
     /* 322059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322091 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322095 */     // MIs[2] Operand 1
     /* 322095 */     // No operand predicates
     /* 322095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322105 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322121 */     GIR_RootConstrainSelectedInstOperands,
     /* 322122 */     // GIR_Coverage, 2537,
     /* 322122 */     GIR_EraseRootFromParent_Done,
     /* 322123 */   // Label 6339: @322123
     /* 322123 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(322192), // Rule ID 6089 //
     /* 322128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322168 */     // MIs[2] Operand 1
     /* 322168 */     // No operand predicates
     /* 322168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322174 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322190 */     GIR_RootConstrainSelectedInstOperands,
     /* 322191 */     // GIR_Coverage, 6089,
     /* 322191 */     GIR_EraseRootFromParent_Done,
     /* 322192 */   // Label 6340: @322192
     /* 322192 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(322285), // Rule ID 6243 //
     /* 322197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322236 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322248 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322283 */     GIR_RootConstrainSelectedInstOperands,
     /* 322284 */     // GIR_Coverage, 6243,
     /* 322284 */     GIR_EraseRootFromParent_Done,
     /* 322285 */   // Label 6341: @322285
     /* 322285 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(322384), // Rule ID 6155 //
     /* 322290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322333 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 322376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322382 */     GIR_RootConstrainSelectedInstOperands,
     /* 322383 */     // GIR_Coverage, 6155,
     /* 322383 */     GIR_EraseRootFromParent_Done,
     /* 322384 */   // Label 6342: @322384
     /* 322384 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(322480), // Rule ID 6187 //
     /* 322389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322431 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322478 */     GIR_RootConstrainSelectedInstOperands,
     /* 322479 */     // GIR_Coverage, 6187,
     /* 322479 */     GIR_EraseRootFromParent_Done,
     /* 322480 */   // Label 6343: @322480
     /* 322480 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(322579), // Rule ID 6219 //
     /* 322485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322528 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322577 */     GIR_RootConstrainSelectedInstOperands,
     /* 322578 */     // GIR_Coverage, 6219,
     /* 322578 */     GIR_EraseRootFromParent_Done,
     /* 322579 */   // Label 6344: @322579
     /* 322579 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322672), // Rule ID 6265 //
     /* 322584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322623 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322670 */     GIR_RootConstrainSelectedInstOperands,
     /* 322671 */     // GIR_Coverage, 6265,
     /* 322671 */     GIR_EraseRootFromParent_Done,
     /* 322672 */   // Label 6345: @322672
     /* 322672 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322768), // Rule ID 6123 //
     /* 322677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 322708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322719 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322766 */     GIR_RootConstrainSelectedInstOperands,
     /* 322767 */     // GIR_Coverage, 6123,
     /* 322767 */     GIR_EraseRootFromParent_Done,
     /* 322768 */   // Label 6346: @322768
     /* 322768 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322852), // Rule ID 2539 //
     /* 322773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322803 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322850 */     GIR_RootConstrainSelectedInstOperands,
     /* 322851 */     // GIR_Coverage, 2539,
     /* 322851 */     GIR_EraseRootFromParent_Done,
     /* 322852 */   // Label 6347: @322852
     /* 322852 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322902), // Rule ID 13410 //
     /* 322857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322887 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 322890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322900 */     GIR_RootConstrainSelectedInstOperands,
     /* 322901 */     // GIR_Coverage, 13410,
     /* 322901 */     GIR_EraseRootFromParent_Done,
     /* 322902 */   // Label 6348: @322902
     /* 322902 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322986), // Rule ID 6091 //
     /* 322907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322937 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 322959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 322972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322984 */     GIR_RootConstrainSelectedInstOperands,
     /* 322985 */     // GIR_Coverage, 6091,
     /* 322985 */     GIR_EraseRootFromParent_Done,
     /* 322986 */   // Label 6349: @322986
     /* 322986 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(323036), // Rule ID 1310 //
     /* 322991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323021 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323034 */     GIR_RootConstrainSelectedInstOperands,
     /* 323035 */     // GIR_Coverage, 1310,
     /* 323035 */     GIR_EraseRootFromParent_Done,
     /* 323036 */   // Label 6350: @323036
     /* 323036 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(323069), // Rule ID 1300 //
     /* 323041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323056 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 323059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323067 */     GIR_RootConstrainSelectedInstOperands,
     /* 323068 */     // GIR_Coverage, 1300,
     /* 323068 */     GIR_EraseRootFromParent_Done,
     /* 323069 */   // Label 6351: @323069
     /* 323069 */   GIM_Reject,
     /* 323070 */ // Label 6332: @323070
     /* 323070 */ GIM_Reject,
     /* 323071 */ // Label 6171: @323071
     /* 323071 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(324249),
     /* 323076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 323085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323089 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(323173), // Rule ID 6137 //
     /* 323094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323130 */     // MIs[2] Operand 1
     /* 323130 */     // No operand predicates
     /* 323130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323153 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323171 */     GIR_RootConstrainSelectedInstOperands,
     /* 323172 */     // GIR_Coverage, 6137,
     /* 323172 */     GIR_EraseRootFromParent_Done,
     /* 323173 */   // Label 6353: @323173
     /* 323173 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(323254), // Rule ID 6169 //
     /* 323178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323222 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323226 */     // MIs[3] Operand 1
     /* 323226 */     // No operand predicates
     /* 323226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323236 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323252 */     GIR_RootConstrainSelectedInstOperands,
     /* 323253 */     // GIR_Coverage, 6169,
     /* 323253 */     GIR_EraseRootFromParent_Done,
     /* 323254 */   // Label 6354: @323254
     /* 323254 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(323338), // Rule ID 6201 //
     /* 323259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323312 */     // MIs[3] Operand 1
     /* 323312 */     // No operand predicates
     /* 323312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323318 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323336 */     GIR_RootConstrainSelectedInstOperands,
     /* 323337 */     // GIR_Coverage, 6201,
     /* 323337 */     GIR_EraseRootFromParent_Done,
     /* 323338 */   // Label 6355: @323338
     /* 323338 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(323419), // Rule ID 6105 //
     /* 323343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323395 */     // MIs[3] Operand 1
     /* 323395 */     // No operand predicates
     /* 323395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323401 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323417 */     GIR_RootConstrainSelectedInstOperands,
     /* 323418 */     // GIR_Coverage, 6105,
     /* 323418 */     GIR_EraseRootFromParent_Done,
     /* 323419 */   // Label 6356: @323419
     /* 323419 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(323488), // Rule ID 2521 //
     /* 323424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323456 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323460 */     // MIs[2] Operand 1
     /* 323460 */     // No operand predicates
     /* 323460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323470 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 323473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323486 */     GIR_RootConstrainSelectedInstOperands,
     /* 323487 */     // GIR_Coverage, 2521,
     /* 323487 */     GIR_EraseRootFromParent_Done,
     /* 323488 */   // Label 6357: @323488
     /* 323488 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(323557), // Rule ID 6073 //
     /* 323493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323533 */     // MIs[2] Operand 1
     /* 323533 */     // No operand predicates
     /* 323533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323539 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 323542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323555 */     GIR_RootConstrainSelectedInstOperands,
     /* 323556 */     // GIR_Coverage, 6073,
     /* 323556 */     GIR_EraseRootFromParent_Done,
     /* 323557 */   // Label 6358: @323557
     /* 323557 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323656), // Rule ID 6139 //
     /* 323562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323605 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323617 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323624 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323654 */     GIR_RootConstrainSelectedInstOperands,
     /* 323655 */     // GIR_Coverage, 6139,
     /* 323655 */     GIR_EraseRootFromParent_Done,
     /* 323656 */   // Label 6359: @323656
     /* 323656 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323752), // Rule ID 6171 //
     /* 323661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323703 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323750 */     GIR_RootConstrainSelectedInstOperands,
     /* 323751 */     // GIR_Coverage, 6171,
     /* 323751 */     GIR_EraseRootFromParent_Done,
     /* 323752 */   // Label 6360: @323752
     /* 323752 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323851), // Rule ID 6203 //
     /* 323757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323800 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323812 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323849 */     GIR_RootConstrainSelectedInstOperands,
     /* 323850 */     // GIR_Coverage, 6203,
     /* 323850 */     GIR_EraseRootFromParent_Done,
     /* 323851 */   // Label 6361: @323851
     /* 323851 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323947), // Rule ID 6107 //
     /* 323856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323898 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323910 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 323933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323945 */     GIR_RootConstrainSelectedInstOperands,
     /* 323946 */     // GIR_Coverage, 6107,
     /* 323946 */     GIR_EraseRootFromParent_Done,
     /* 323947 */   // Label 6362: @323947
     /* 323947 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(324031), // Rule ID 2523 //
     /* 323952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323982 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324029 */     GIR_RootConstrainSelectedInstOperands,
     /* 324030 */     // GIR_Coverage, 2523,
     /* 324030 */     GIR_EraseRootFromParent_Done,
     /* 324031 */   // Label 6363: @324031
     /* 324031 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(324081), // Rule ID 13406 //
     /* 324036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324066 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324079 */     GIR_RootConstrainSelectedInstOperands,
     /* 324080 */     // GIR_Coverage, 13406,
     /* 324080 */     GIR_EraseRootFromParent_Done,
     /* 324081 */   // Label 6364: @324081
     /* 324081 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(324165), // Rule ID 6075 //
     /* 324086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324116 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324135 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324163 */     GIR_RootConstrainSelectedInstOperands,
     /* 324164 */     // GIR_Coverage, 6075,
     /* 324164 */     GIR_EraseRootFromParent_Done,
     /* 324165 */   // Label 6365: @324165
     /* 324165 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(324215), // Rule ID 1306 //
     /* 324170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324200 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324213 */     GIR_RootConstrainSelectedInstOperands,
     /* 324214 */     // GIR_Coverage, 1306,
     /* 324214 */     GIR_EraseRootFromParent_Done,
     /* 324215 */   // Label 6366: @324215
     /* 324215 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(324248), // Rule ID 1296 //
     /* 324220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324235 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 324238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324246 */     GIR_RootConstrainSelectedInstOperands,
     /* 324247 */     // GIR_Coverage, 1296,
     /* 324247 */     GIR_EraseRootFromParent_Done,
     /* 324248 */   // Label 6367: @324248
     /* 324248 */   GIM_Reject,
     /* 324249 */ // Label 6352: @324249
     /* 324249 */ GIM_Reject,
     /* 324250 */ // Label 6172: @324250
     /* 324250 */ GIM_Reject,
     /* 324251 */ // Label 63: @324251
     /* 324251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6376*/ GIMT_Encode4(324866),
     /* 324262 */ /*GILLT_s16*//*Label 6368*/ GIMT_Encode4(324302),
     /* 324266 */ /*GILLT_s32*//*Label 6369*/ GIMT_Encode4(324340),
     /* 324270 */ /*GILLT_s64*//*Label 6370*/ GIMT_Encode4(324378), GIMT_Encode4(0),
     /* 324278 */ /*GILLT_v2s32*//*Label 6371*/ GIMT_Encode4(324416),
     /* 324282 */ /*GILLT_v2s64*//*Label 6372*/ GIMT_Encode4(324454),
     /* 324286 */ /*GILLT_v4s16*//*Label 6373*/ GIMT_Encode4(324492),
     /* 324290 */ /*GILLT_v4s32*//*Label 6374*/ GIMT_Encode4(324530), GIMT_Encode4(0),
     /* 324298 */ /*GILLT_v8s16*//*Label 6375*/ GIMT_Encode4(324568),
     /* 324302 */ // Label 6368: @324302
     /* 324302 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324339), // Rule ID 590 //
     /* 324307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324328 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 324333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324337 */   GIR_RootConstrainSelectedInstOperands,
     /* 324338 */   // GIR_Coverage, 590,
     /* 324338 */   GIR_Done,
     /* 324339 */ // Label 6377: @324339
     /* 324339 */ GIM_Reject,
     /* 324340 */ // Label 6369: @324340
     /* 324340 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324377), // Rule ID 592 //
     /* 324345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324366 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 324371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324375 */   GIR_RootConstrainSelectedInstOperands,
     /* 324376 */   // GIR_Coverage, 592,
     /* 324376 */   GIR_Done,
     /* 324377 */ // Label 6378: @324377
     /* 324377 */ GIM_Reject,
     /* 324378 */ // Label 6370: @324378
     /* 324378 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(324415), // Rule ID 594 //
     /* 324383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324404 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 324409 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324413 */   GIR_RootConstrainSelectedInstOperands,
     /* 324414 */   // GIR_Coverage, 594,
     /* 324414 */   GIR_Done,
     /* 324415 */ // Label 6379: @324415
     /* 324415 */ GIM_Reject,
     /* 324416 */ // Label 6371: @324416
     /* 324416 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(324453), // Rule ID 1228 //
     /* 324421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324442 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 324447 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324451 */   GIR_RootConstrainSelectedInstOperands,
     /* 324452 */   // GIR_Coverage, 1228,
     /* 324452 */   GIR_Done,
     /* 324453 */ // Label 6380: @324453
     /* 324453 */ GIM_Reject,
     /* 324454 */ // Label 6372: @324454
     /* 324454 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324491), // Rule ID 1232 //
     /* 324459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324480 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 324485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324489 */   GIR_RootConstrainSelectedInstOperands,
     /* 324490 */   // GIR_Coverage, 1232,
     /* 324490 */   GIR_Done,
     /* 324491 */ // Label 6381: @324491
     /* 324491 */ GIM_Reject,
     /* 324492 */ // Label 6373: @324492
     /* 324492 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(324529), // Rule ID 1224 //
     /* 324497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324518 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 324523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324527 */   GIR_RootConstrainSelectedInstOperands,
     /* 324528 */   // GIR_Coverage, 1224,
     /* 324528 */   GIR_Done,
     /* 324529 */ // Label 6382: @324529
     /* 324529 */ GIM_Reject,
     /* 324530 */ // Label 6374: @324530
     /* 324530 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(324567), // Rule ID 1230 //
     /* 324535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324556 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324565 */   GIR_RootConstrainSelectedInstOperands,
     /* 324566 */   // GIR_Coverage, 1230,
     /* 324566 */   GIR_Done,
     /* 324567 */ // Label 6383: @324567
     /* 324567 */ GIM_Reject,
     /* 324568 */ // Label 6375: @324568
     /* 324568 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(324865),
     /* 324573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324591 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(324610), // Rule ID 1226 //
     /* 324596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324599 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 324604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324608 */     GIR_RootConstrainSelectedInstOperands,
     /* 324609 */     // GIR_Coverage, 1226,
     /* 324609 */     GIR_Done,
     /* 324610 */   // Label 6385: @324610
     /* 324610 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(324864), // Rule ID 7040 //
     /* 324615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 324618 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 324618 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 324621 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 324625 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324630 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 324634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 324636 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 324639 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 324643 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324648 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 324654 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 324657 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324661 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324666 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 324669 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 324672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 324674 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 324677 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324681 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324686 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 324692 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324697 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324702 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 324705 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 324709 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324714 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 324717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 324719 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 324722 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324726 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324731 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 324737 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324742 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324747 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 324750 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 324754 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324759 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 324762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 324764 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 324767 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 324771 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324776 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 324779 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 324782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 324784 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 324787 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 324791 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324796 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 324799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 324801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 324804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 324808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 324815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 324822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 324830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 324833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 324836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 324854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 324862 */     GIR_RootConstrainSelectedInstOperands,
     /* 324863 */     // GIR_Coverage, 7040,
     /* 324863 */     GIR_EraseRootFromParent_Done,
     /* 324864 */   // Label 6386: @324864
     /* 324864 */   GIM_Reject,
     /* 324865 */ // Label 6384: @324865
     /* 324865 */ GIM_Reject,
     /* 324866 */ // Label 6376: @324866
     /* 324866 */ GIM_Reject,
     /* 324867 */ // Label 64: @324867
     /* 324867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6395*/ GIMT_Encode4(328373),
     /* 324878 */ /*GILLT_s16*//*Label 6387*/ GIMT_Encode4(324918),
     /* 324882 */ /*GILLT_s32*//*Label 6388*/ GIMT_Encode4(326086),
     /* 324886 */ /*GILLT_s64*//*Label 6389*/ GIMT_Encode4(327109), GIMT_Encode4(0),
     /* 324894 */ /*GILLT_v2s32*//*Label 6390*/ GIMT_Encode4(328132),
     /* 324898 */ /*GILLT_v2s64*//*Label 6391*/ GIMT_Encode4(328159),
     /* 324902 */ /*GILLT_v4s16*//*Label 6392*/ GIMT_Encode4(328186),
     /* 324906 */ /*GILLT_v4s32*//*Label 6393*/ GIMT_Encode4(328266), GIMT_Encode4(0),
     /* 324914 */ /*GILLT_v8s16*//*Label 6394*/ GIMT_Encode4(328293),
     /* 324918 */ // Label 6387: @324918
     /* 324918 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(326085),
     /* 324923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324930 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(325088), // Rule ID 4880 //
     /* 324935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 324946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324954 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 324958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 324966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324979 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 324983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 324987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 324991 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324995 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 324999 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325004 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325015 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325027 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325086 */     GIR_RootConstrainSelectedInstOperands,
     /* 325087 */     // GIR_Coverage, 4880,
     /* 325087 */     GIR_EraseRootFromParent_Done,
     /* 325088 */   // Label 6397: @325088
     /* 325088 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325246), // Rule ID 4879 //
     /* 325093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325137 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 325145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 325157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325162 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325173 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325185 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325244 */     GIR_RootConstrainSelectedInstOperands,
     /* 325245 */     // GIR_Coverage, 4879,
     /* 325245 */     GIR_EraseRootFromParent_Done,
     /* 325246 */   // Label 6398: @325246
     /* 325246 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(325357), // Rule ID 4878 //
     /* 325251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325270 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325311 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325355 */     GIR_RootConstrainSelectedInstOperands,
     /* 325356 */     // GIR_Coverage, 4878,
     /* 325356 */     GIR_EraseRootFromParent_Done,
     /* 325357 */   // Label 6399: @325357
     /* 325357 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(325468), // Rule ID 4876 //
     /* 325362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325381 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325422 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325434 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325466 */     GIR_RootConstrainSelectedInstOperands,
     /* 325467 */     // GIR_Coverage, 4876,
     /* 325467 */     GIR_EraseRootFromParent_Done,
     /* 325468 */   // Label 6400: @325468
     /* 325468 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(325579), // Rule ID 4877 //
     /* 325473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325517 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325533 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325545 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325577 */     GIR_RootConstrainSelectedInstOperands,
     /* 325578 */     // GIR_Coverage, 4877,
     /* 325578 */     GIR_EraseRootFromParent_Done,
     /* 325579 */   // Label 6401: @325579
     /* 325579 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(325690), // Rule ID 4875 //
     /* 325584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325603 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325633 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325644 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325688 */     GIR_RootConstrainSelectedInstOperands,
     /* 325689 */     // GIR_Coverage, 4875,
     /* 325689 */     GIR_EraseRootFromParent_Done,
     /* 325690 */   // Label 6402: @325690
     /* 325690 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(325754), // Rule ID 650 //
     /* 325695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325735 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325752 */     GIR_RootConstrainSelectedInstOperands,
     /* 325753 */     // GIR_Coverage, 650,
     /* 325753 */     GIR_EraseRootFromParent_Done,
     /* 325754 */   // Label 6403: @325754
     /* 325754 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(325818), // Rule ID 649 //
     /* 325759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 325770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325778 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325799 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 325799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325816 */     GIR_RootConstrainSelectedInstOperands,
     /* 325817 */     // GIR_Coverage, 649,
     /* 325817 */     GIR_EraseRootFromParent_Done,
     /* 325818 */   // Label 6404: @325818
     /* 325818 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(325869), // Rule ID 626 //
     /* 325823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 325834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325854 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 325857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325867 */     GIR_RootConstrainSelectedInstOperands,
     /* 325868 */     // GIR_Coverage, 626,
     /* 325868 */     GIR_EraseRootFromParent_Done,
     /* 325869 */   // Label 6405: @325869
     /* 325869 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(325920), // Rule ID 625 //
     /* 325874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 325885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325905 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 325908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 325918 */     GIR_RootConstrainSelectedInstOperands,
     /* 325919 */     // GIR_Coverage, 625,
     /* 325919 */     GIR_EraseRootFromParent_Done,
     /* 325920 */   // Label 6406: @325920
     /* 325920 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(325939), // Rule ID 524 //
     /* 325925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325932 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 325932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 325937 */     GIR_RootConstrainSelectedInstOperands,
     /* 325938 */     // GIR_Coverage, 524,
     /* 325938 */     GIR_Done,
     /* 325939 */   // Label 6407: @325939
     /* 325939 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(326084), // Rule ID 6405 //
     /* 325944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325948 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 325948 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 325951 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325955 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 325962 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 325965 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325969 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325974 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 325977 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325981 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 325984 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325989 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325994 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325999 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 326002 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326006 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326011 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326014 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 326026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326031 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326034 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 326039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326066 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 326073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326083 */     // GIR_Coverage, 6405,
     /* 326083 */     GIR_EraseRootFromParent_Done,
     /* 326084 */   // Label 6408: @326084
     /* 326084 */   GIM_Reject,
     /* 326085 */ // Label 6396: @326085
     /* 326085 */ GIM_Reject,
     /* 326086 */ // Label 6388: @326086
     /* 326086 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(327108),
     /* 326091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326098 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(326256), // Rule ID 4886 //
     /* 326103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326122 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326147 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326172 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326183 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326195 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326201 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326254 */     GIR_RootConstrainSelectedInstOperands,
     /* 326255 */     // GIR_Coverage, 4886,
     /* 326255 */     GIR_EraseRootFromParent_Done,
     /* 326256 */   // Label 6410: @326256
     /* 326256 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(326414), // Rule ID 4885 //
     /* 326261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326280 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326305 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326317 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326321 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326325 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326330 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326341 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326353 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326381 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326412 */     GIR_RootConstrainSelectedInstOperands,
     /* 326413 */     // GIR_Coverage, 4885,
     /* 326413 */     GIR_EraseRootFromParent_Done,
     /* 326414 */   // Label 6411: @326414
     /* 326414 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(326525), // Rule ID 4884 //
     /* 326419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326438 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326463 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326479 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326491 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326523 */     GIR_RootConstrainSelectedInstOperands,
     /* 326524 */     // GIR_Coverage, 4884,
     /* 326524 */     GIR_EraseRootFromParent_Done,
     /* 326525 */   // Label 6412: @326525
     /* 326525 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(326636), // Rule ID 4882 //
     /* 326530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326579 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326590 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326602 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326634 */     GIR_RootConstrainSelectedInstOperands,
     /* 326635 */     // GIR_Coverage, 4882,
     /* 326635 */     GIR_EraseRootFromParent_Done,
     /* 326636 */   // Label 6413: @326636
     /* 326636 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(326747), // Rule ID 4883 //
     /* 326641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326660 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326701 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 326719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326745 */     GIR_RootConstrainSelectedInstOperands,
     /* 326746 */     // GIR_Coverage, 4883,
     /* 326746 */     GIR_EraseRootFromParent_Done,
     /* 326747 */   // Label 6414: @326747
     /* 326747 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(326858), // Rule ID 4881 //
     /* 326752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326812 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 326812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326824 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 326830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326856 */     GIR_RootConstrainSelectedInstOperands,
     /* 326857 */     // GIR_Coverage, 4881,
     /* 326857 */     GIR_EraseRootFromParent_Done,
     /* 326858 */   // Label 6415: @326858
     /* 326858 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(326922), // Rule ID 652 //
     /* 326863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326882 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326903 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326920 */     GIR_RootConstrainSelectedInstOperands,
     /* 326921 */     // GIR_Coverage, 652,
     /* 326921 */     GIR_EraseRootFromParent_Done,
     /* 326922 */   // Label 6416: @326922
     /* 326922 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(326986), // Rule ID 651 //
     /* 326927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 326946 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 326950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326967 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 326967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 326970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326984 */     GIR_RootConstrainSelectedInstOperands,
     /* 326985 */     // GIR_Coverage, 651,
     /* 326985 */     GIR_EraseRootFromParent_Done,
     /* 326986 */   // Label 6417: @326986
     /* 326986 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(327037), // Rule ID 628 //
     /* 326991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 327002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327022 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327035 */     GIR_RootConstrainSelectedInstOperands,
     /* 327036 */     // GIR_Coverage, 628,
     /* 327036 */     GIR_EraseRootFromParent_Done,
     /* 327037 */   // Label 6418: @327037
     /* 327037 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(327088), // Rule ID 627 //
     /* 327042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327073 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327086 */     GIR_RootConstrainSelectedInstOperands,
     /* 327087 */     // GIR_Coverage, 627,
     /* 327087 */     GIR_EraseRootFromParent_Done,
     /* 327088 */   // Label 6419: @327088
     /* 327088 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(327107), // Rule ID 525 //
     /* 327093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327100 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 327100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 327105 */     GIR_RootConstrainSelectedInstOperands,
     /* 327106 */     // GIR_Coverage, 525,
     /* 327106 */     GIR_Done,
     /* 327107 */   // Label 6420: @327107
     /* 327107 */   GIM_Reject,
     /* 327108 */ // Label 6409: @327108
     /* 327108 */ GIM_Reject,
     /* 327109 */ // Label 6389: @327109
     /* 327109 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(328131),
     /* 327114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327121 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(327279), // Rule ID 4892 //
     /* 327126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327145 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327170 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327186 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327190 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327195 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327206 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 327209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327218 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327246 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327277 */     GIR_RootConstrainSelectedInstOperands,
     /* 327278 */     // GIR_Coverage, 4892,
     /* 327278 */     GIR_EraseRootFromParent_Done,
     /* 327279 */   // Label 6422: @327279
     /* 327279 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327437), // Rule ID 4891 //
     /* 327284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327328 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327348 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327353 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327364 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327364 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 327367 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327371 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327376 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327404 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327435 */     GIR_RootConstrainSelectedInstOperands,
     /* 327436 */     // GIR_Coverage, 4891,
     /* 327436 */     GIR_EraseRootFromParent_Done,
     /* 327437 */   // Label 6423: @327437
     /* 327437 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327548), // Rule ID 4890 //
     /* 327442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327461 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327486 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327502 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327514 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327546 */     GIR_RootConstrainSelectedInstOperands,
     /* 327547 */     // GIR_Coverage, 4890,
     /* 327547 */     GIR_EraseRootFromParent_Done,
     /* 327548 */   // Label 6424: @327548
     /* 327548 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(327659), // Rule ID 4888 //
     /* 327553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327602 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327613 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327657 */     GIR_RootConstrainSelectedInstOperands,
     /* 327658 */     // GIR_Coverage, 4888,
     /* 327658 */     GIR_EraseRootFromParent_Done,
     /* 327659 */   // Label 6425: @327659
     /* 327659 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327770), // Rule ID 4889 //
     /* 327664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327724 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 327742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327768 */     GIR_RootConstrainSelectedInstOperands,
     /* 327769 */     // GIR_Coverage, 4889,
     /* 327769 */     GIR_EraseRootFromParent_Done,
     /* 327770 */   // Label 6426: @327770
     /* 327770 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327881), // Rule ID 4887 //
     /* 327775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327824 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327835 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 327835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 327853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327879 */     GIR_RootConstrainSelectedInstOperands,
     /* 327880 */     // GIR_Coverage, 4887,
     /* 327880 */     GIR_EraseRootFromParent_Done,
     /* 327881 */   // Label 6427: @327881
     /* 327881 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327945), // Rule ID 654 //
     /* 327886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327905 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327926 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327943 */     GIR_RootConstrainSelectedInstOperands,
     /* 327944 */     // GIR_Coverage, 654,
     /* 327944 */     GIR_EraseRootFromParent_Done,
     /* 327945 */   // Label 6428: @327945
     /* 327945 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(328009), // Rule ID 653 //
     /* 327950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 327965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 327969 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 327973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327990 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 327990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 327993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328007 */     GIR_RootConstrainSelectedInstOperands,
     /* 328008 */     // GIR_Coverage, 653,
     /* 328008 */     GIR_EraseRootFromParent_Done,
     /* 328009 */   // Label 6429: @328009
     /* 328009 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(328060), // Rule ID 630 //
     /* 328014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328045 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328058 */     GIR_RootConstrainSelectedInstOperands,
     /* 328059 */     // GIR_Coverage, 630,
     /* 328059 */     GIR_EraseRootFromParent_Done,
     /* 328060 */   // Label 6430: @328060
     /* 328060 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(328111), // Rule ID 629 //
     /* 328065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328096 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328109 */     GIR_RootConstrainSelectedInstOperands,
     /* 328110 */     // GIR_Coverage, 629,
     /* 328110 */     GIR_EraseRootFromParent_Done,
     /* 328111 */   // Label 6431: @328111
     /* 328111 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(328130), // Rule ID 526 //
     /* 328116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328123 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 328123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 328128 */     GIR_RootConstrainSelectedInstOperands,
     /* 328129 */     // GIR_Coverage, 526,
     /* 328129 */     GIR_Done,
     /* 328130 */   // Label 6432: @328130
     /* 328130 */   GIM_Reject,
     /* 328131 */ // Label 6421: @328131
     /* 328131 */ GIM_Reject,
     /* 328132 */ // Label 6390: @328132
     /* 328132 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(328158), // Rule ID 860 //
     /* 328137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328151 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 328151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 328156 */   GIR_RootConstrainSelectedInstOperands,
     /* 328157 */   // GIR_Coverage, 860,
     /* 328157 */   GIR_Done,
     /* 328158 */ // Label 6433: @328158
     /* 328158 */ GIM_Reject,
     /* 328159 */ // Label 6391: @328159
     /* 328159 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(328185), // Rule ID 862 //
     /* 328164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328178 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 328178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 328183 */   GIR_RootConstrainSelectedInstOperands,
     /* 328184 */   // GIR_Coverage, 862,
     /* 328184 */   GIR_Done,
     /* 328185 */ // Label 6434: @328185
     /* 328185 */ GIM_Reject,
     /* 328186 */ // Label 6392: @328186
     /* 328186 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(328265),
     /* 328191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328202 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(328217), // Rule ID 858 //
     /* 328207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328210 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 328210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 328215 */     GIR_RootConstrainSelectedInstOperands,
     /* 328216 */     // GIR_Coverage, 858,
     /* 328216 */     GIR_Done,
     /* 328217 */   // Label 6436: @328217
     /* 328217 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(328264), // Rule ID 6408 //
     /* 328222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328225 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 328225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 328232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328237 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 328247 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 328255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328262 */     GIR_RootConstrainSelectedInstOperands,
     /* 328263 */     // GIR_Coverage, 6408,
     /* 328263 */     GIR_EraseRootFromParent_Done,
     /* 328264 */   // Label 6437: @328264
     /* 328264 */   GIM_Reject,
     /* 328265 */ // Label 6435: @328265
     /* 328265 */ GIM_Reject,
     /* 328266 */ // Label 6393: @328266
     /* 328266 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(328292), // Rule ID 861 //
     /* 328271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328285 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 328285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 328290 */   GIR_RootConstrainSelectedInstOperands,
     /* 328291 */   // GIR_Coverage, 861,
     /* 328291 */   GIR_Done,
     /* 328292 */ // Label 6438: @328292
     /* 328292 */ GIM_Reject,
     /* 328293 */ // Label 6394: @328293
     /* 328293 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(328372),
     /* 328298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328309 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328324), // Rule ID 859 //
     /* 328314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 328317 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 328317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 328322 */     GIR_RootConstrainSelectedInstOperands,
     /* 328323 */     // GIR_Coverage, 859,
     /* 328323 */     GIR_Done,
     /* 328324 */   // Label 6440: @328324
     /* 328324 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(328371), // Rule ID 6409 //
     /* 328329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328332 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 328332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 328339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328344 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 328354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 328362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328369 */     GIR_RootConstrainSelectedInstOperands,
     /* 328370 */     // GIR_Coverage, 6409,
     /* 328370 */     GIR_EraseRootFromParent_Done,
     /* 328371 */   // Label 6441: @328371
     /* 328371 */   GIM_Reject,
     /* 328372 */ // Label 6439: @328372
     /* 328372 */ GIM_Reject,
     /* 328373 */ // Label 6395: @328373
     /* 328373 */ GIM_Reject,
     /* 328374 */ // Label 65: @328374
     /* 328374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6446*/ GIMT_Encode4(328621),
     /* 328385 */ /*GILLT_s32*//*Label 6442*/ GIMT_Encode4(328413),
     /* 328389 */ /*GILLT_s64*//*Label 6443*/ GIMT_Encode4(328444), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328401 */ /*GILLT_v2s64*//*Label 6444*/ GIMT_Encode4(328505), GIMT_Encode4(0),
     /* 328409 */ /*GILLT_v4s32*//*Label 6445*/ GIMT_Encode4(328563),
     /* 328413 */ // Label 6442: @328413
     /* 328413 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(328443), // Rule ID 516 //
     /* 328418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328432 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 328432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 328437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328441 */   GIR_RootConstrainSelectedInstOperands,
     /* 328442 */   // GIR_Coverage, 516,
     /* 328442 */   GIR_Done,
     /* 328443 */ // Label 6447: @328443
     /* 328443 */ GIM_Reject,
     /* 328444 */ // Label 6443: @328444
     /* 328444 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(328474), // Rule ID 514 //
     /* 328449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328463 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 328463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 328468 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328472 */   GIR_RootConstrainSelectedInstOperands,
     /* 328473 */   // GIR_Coverage, 514,
     /* 328473 */   GIR_Done,
     /* 328474 */ // Label 6448: @328474
     /* 328474 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(328504), // Rule ID 518 //
     /* 328479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328493 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 328493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 328498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328502 */   GIR_RootConstrainSelectedInstOperands,
     /* 328503 */   // GIR_Coverage, 518,
     /* 328503 */   GIR_Done,
     /* 328504 */ // Label 6449: @328504
     /* 328504 */ GIM_Reject,
     /* 328505 */ // Label 6444: @328505
     /* 328505 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(328562),
     /* 328510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328517 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(328541), // Rule ID 4935 //
     /* 328522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 328529 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 328529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 328532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328539 */     GIR_RootConstrainSelectedInstOperands,
     /* 328540 */     // GIR_Coverage, 4935,
     /* 328540 */     GIR_EraseRootFromParent_Done,
     /* 328541 */   // Label 6451: @328541
     /* 328541 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(328561), // Rule ID 4933 //
     /* 328546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328550 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 328550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 328555 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328559 */     GIR_RootConstrainSelectedInstOperands,
     /* 328560 */     // GIR_Coverage, 4933,
     /* 328560 */     GIR_Done,
     /* 328561 */   // Label 6452: @328561
     /* 328561 */   GIM_Reject,
     /* 328562 */ // Label 6450: @328562
     /* 328562 */ GIM_Reject,
     /* 328563 */ // Label 6445: @328563
     /* 328563 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(328620),
     /* 328568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328575 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(328599), // Rule ID 4939 //
     /* 328580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 328587 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 328587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 328590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328597 */     GIR_RootConstrainSelectedInstOperands,
     /* 328598 */     // GIR_Coverage, 4939,
     /* 328598 */     GIR_EraseRootFromParent_Done,
     /* 328599 */   // Label 6454: @328599
     /* 328599 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(328619), // Rule ID 4937 //
     /* 328604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328608 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 328608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 328613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328617 */     GIR_RootConstrainSelectedInstOperands,
     /* 328618 */     // GIR_Coverage, 4937,
     /* 328618 */     GIR_Done,
     /* 328619 */   // Label 6455: @328619
     /* 328619 */   GIM_Reject,
     /* 328620 */ // Label 6453: @328620
     /* 328620 */ GIM_Reject,
     /* 328621 */ // Label 6446: @328621
     /* 328621 */ GIM_Reject,
     /* 328622 */ // Label 66: @328622
     /* 328622 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6460*/ GIMT_Encode4(328809),
     /* 328633 */ /*GILLT_s16*//*Label 6456*/ GIMT_Encode4(328661),
     /* 328637 */ /*GILLT_s32*//*Label 6457*/ GIMT_Encode4(328722), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328649 */ /*GILLT_v2s32*//*Label 6458*/ GIMT_Encode4(328753), GIMT_Encode4(0),
     /* 328657 */ /*GILLT_v4s16*//*Label 6459*/ GIMT_Encode4(328781),
     /* 328661 */ // Label 6456: @328661
     /* 328661 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(328691), // Rule ID 510 //
     /* 328666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328680 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 328680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 328685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328689 */   GIR_RootConstrainSelectedInstOperands,
     /* 328690 */   // GIR_Coverage, 510,
     /* 328690 */   GIR_Done,
     /* 328691 */ // Label 6461: @328691
     /* 328691 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(328721), // Rule ID 520 //
     /* 328696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328710 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 328710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 328715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328719 */   GIR_RootConstrainSelectedInstOperands,
     /* 328720 */   // GIR_Coverage, 520,
     /* 328720 */   GIR_Done,
     /* 328721 */ // Label 6462: @328721
     /* 328721 */ GIM_Reject,
     /* 328722 */ // Label 6457: @328722
     /* 328722 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(328752), // Rule ID 512 //
     /* 328727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328741 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 328741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 328746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328750 */   GIR_RootConstrainSelectedInstOperands,
     /* 328751 */   // GIR_Coverage, 512,
     /* 328751 */   GIR_Done,
     /* 328752 */ // Label 6463: @328752
     /* 328752 */ GIM_Reject,
     /* 328753 */ // Label 6458: @328753
     /* 328753 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(328780), // Rule ID 4943 //
     /* 328758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328769 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 328769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 328774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328778 */   GIR_RootConstrainSelectedInstOperands,
     /* 328779 */   // GIR_Coverage, 4943,
     /* 328779 */   GIR_Done,
     /* 328780 */ // Label 6464: @328780
     /* 328780 */ GIM_Reject,
     /* 328781 */ // Label 6459: @328781
     /* 328781 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(328808), // Rule ID 4945 //
     /* 328786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328797 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 328797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 328802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328806 */   GIR_RootConstrainSelectedInstOperands,
     /* 328807 */   // GIR_Coverage, 4945,
     /* 328807 */   GIR_Done,
     /* 328808 */ // Label 6465: @328808
     /* 328808 */ GIM_Reject,
     /* 328809 */ // Label 6460: @328809
     /* 328809 */ GIM_Reject,
     /* 328810 */ // Label 67: @328810
     /* 328810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6473*/ GIMT_Encode4(329786),
     /* 328821 */ /*GILLT_s32*//*Label 6466*/ GIMT_Encode4(328857),
     /* 328825 */ /*GILLT_s64*//*Label 6467*/ GIMT_Encode4(329244), GIMT_Encode4(0),
     /* 328833 */ /*GILLT_v2s32*//*Label 6468*/ GIMT_Encode4(329631),
     /* 328837 */ /*GILLT_v2s64*//*Label 6469*/ GIMT_Encode4(329662),
     /* 328841 */ /*GILLT_v4s16*//*Label 6470*/ GIMT_Encode4(329693),
     /* 328845 */ /*GILLT_v4s32*//*Label 6471*/ GIMT_Encode4(329724), GIMT_Encode4(0),
     /* 328853 */ /*GILLT_v8s16*//*Label 6472*/ GIMT_Encode4(329755),
     /* 328857 */ // Label 6466: @328857
     /* 328857 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(328894), // Rule ID 4682 //
     /* 328862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328869 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 328877 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328883 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 328883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 328886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328888 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328892 */   GIR_RootConstrainSelectedInstOperands,
     /* 328893 */   // GIR_Coverage, 4682,
     /* 328893 */   GIR_EraseRootFromParent_Done,
     /* 328894 */ // Label 6474: @328894
     /* 328894 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(328931), // Rule ID 4684 //
     /* 328899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 328914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328920 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 328920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 328923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328925 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328929 */   GIR_RootConstrainSelectedInstOperands,
     /* 328930 */   // GIR_Coverage, 4684,
     /* 328930 */   GIR_EraseRootFromParent_Done,
     /* 328931 */ // Label 6475: @328931
     /* 328931 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(328968), // Rule ID 4702 //
     /* 328936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 328951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328957 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 328957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 328960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328962 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328966 */   GIR_RootConstrainSelectedInstOperands,
     /* 328967 */   // GIR_Coverage, 4702,
     /* 328967 */   GIR_EraseRootFromParent_Done,
     /* 328968 */ // Label 6476: @328968
     /* 328968 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(329005), // Rule ID 4704 //
     /* 328973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 328988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328994 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 328994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 328997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328999 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329003 */   GIR_RootConstrainSelectedInstOperands,
     /* 329004 */   // GIR_Coverage, 4704,
     /* 329004 */   GIR_EraseRootFromParent_Done,
     /* 329005 */ // Label 6477: @329005
     /* 329005 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(329042), // Rule ID 4742 //
     /* 329010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329031 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 329034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329040 */   GIR_RootConstrainSelectedInstOperands,
     /* 329041 */   // GIR_Coverage, 4742,
     /* 329041 */   GIR_EraseRootFromParent_Done,
     /* 329042 */ // Label 6478: @329042
     /* 329042 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(329079), // Rule ID 4744 //
     /* 329047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329062 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329068 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 329071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329077 */   GIR_RootConstrainSelectedInstOperands,
     /* 329078 */   // GIR_Coverage, 4744,
     /* 329078 */   GIR_EraseRootFromParent_Done,
     /* 329079 */ // Label 6479: @329079
     /* 329079 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(329116), // Rule ID 4722 //
     /* 329084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329105 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329114 */   GIR_RootConstrainSelectedInstOperands,
     /* 329115 */   // GIR_Coverage, 4722,
     /* 329115 */   GIR_EraseRootFromParent_Done,
     /* 329116 */ // Label 6480: @329116
     /* 329116 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(329153), // Rule ID 4724 //
     /* 329121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329142 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329151 */   GIR_RootConstrainSelectedInstOperands,
     /* 329152 */   // GIR_Coverage, 4724,
     /* 329152 */   GIR_EraseRootFromParent_Done,
     /* 329153 */ // Label 6481: @329153
     /* 329153 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(329183), // Rule ID 395 //
     /* 329158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329172 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 329172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 329177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329181 */   GIR_RootConstrainSelectedInstOperands,
     /* 329182 */   // GIR_Coverage, 395,
     /* 329182 */   GIR_Done,
     /* 329183 */ // Label 6482: @329183
     /* 329183 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(329213), // Rule ID 399 //
     /* 329188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329202 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 329202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 329207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329211 */   GIR_RootConstrainSelectedInstOperands,
     /* 329212 */   // GIR_Coverage, 399,
     /* 329212 */   GIR_Done,
     /* 329213 */ // Label 6483: @329213
     /* 329213 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(329243), // Rule ID 403 //
     /* 329218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329232 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 329232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 329237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329241 */   GIR_RootConstrainSelectedInstOperands,
     /* 329242 */   // GIR_Coverage, 403,
     /* 329242 */   GIR_Done,
     /* 329243 */ // Label 6484: @329243
     /* 329243 */ GIM_Reject,
     /* 329244 */ // Label 6467: @329244
     /* 329244 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(329281), // Rule ID 4683 //
     /* 329249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329264 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329270 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 329273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329275 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329279 */   GIR_RootConstrainSelectedInstOperands,
     /* 329280 */   // GIR_Coverage, 4683,
     /* 329280 */   GIR_EraseRootFromParent_Done,
     /* 329281 */ // Label 6485: @329281
     /* 329281 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(329318), // Rule ID 4685 //
     /* 329286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329301 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329307 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 329310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329312 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329316 */   GIR_RootConstrainSelectedInstOperands,
     /* 329317 */   // GIR_Coverage, 4685,
     /* 329317 */   GIR_EraseRootFromParent_Done,
     /* 329318 */ // Label 6486: @329318
     /* 329318 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(329355), // Rule ID 4703 //
     /* 329323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329344 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 329347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329349 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329353 */   GIR_RootConstrainSelectedInstOperands,
     /* 329354 */   // GIR_Coverage, 4703,
     /* 329354 */   GIR_EraseRootFromParent_Done,
     /* 329355 */ // Label 6487: @329355
     /* 329355 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(329392), // Rule ID 4705 //
     /* 329360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329375 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329381 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 329384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329386 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329390 */   GIR_RootConstrainSelectedInstOperands,
     /* 329391 */   // GIR_Coverage, 4705,
     /* 329391 */   GIR_EraseRootFromParent_Done,
     /* 329392 */ // Label 6488: @329392
     /* 329392 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(329429), // Rule ID 4743 //
     /* 329397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329412 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329418 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 329421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329423 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329427 */   GIR_RootConstrainSelectedInstOperands,
     /* 329428 */   // GIR_Coverage, 4743,
     /* 329428 */   GIR_EraseRootFromParent_Done,
     /* 329429 */ // Label 6489: @329429
     /* 329429 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(329466), // Rule ID 4745 //
     /* 329434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329455 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 329458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329460 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329464 */   GIR_RootConstrainSelectedInstOperands,
     /* 329465 */   // GIR_Coverage, 4745,
     /* 329465 */   GIR_EraseRootFromParent_Done,
     /* 329466 */ // Label 6490: @329466
     /* 329466 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(329503), // Rule ID 4723 //
     /* 329471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329486 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329490 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329492 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 329495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329497 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329501 */   GIR_RootConstrainSelectedInstOperands,
     /* 329502 */   // GIR_Coverage, 4723,
     /* 329502 */   GIR_EraseRootFromParent_Done,
     /* 329503 */ // Label 6491: @329503
     /* 329503 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(329540), // Rule ID 4725 //
     /* 329508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 329523 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329527 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329529 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 329532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329534 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329538 */   GIR_RootConstrainSelectedInstOperands,
     /* 329539 */   // GIR_Coverage, 4725,
     /* 329539 */   GIR_EraseRootFromParent_Done,
     /* 329540 */ // Label 6492: @329540
     /* 329540 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(329570), // Rule ID 397 //
     /* 329545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329559 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 329559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 329564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329568 */   GIR_RootConstrainSelectedInstOperands,
     /* 329569 */   // GIR_Coverage, 397,
     /* 329569 */   GIR_Done,
     /* 329570 */ // Label 6493: @329570
     /* 329570 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(329600), // Rule ID 401 //
     /* 329575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329589 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 329589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 329594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329598 */   GIR_RootConstrainSelectedInstOperands,
     /* 329599 */   // GIR_Coverage, 401,
     /* 329599 */   GIR_Done,
     /* 329600 */ // Label 6494: @329600
     /* 329600 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(329630), // Rule ID 405 //
     /* 329605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329619 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 329619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 329624 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329628 */   GIR_RootConstrainSelectedInstOperands,
     /* 329629 */   // GIR_Coverage, 405,
     /* 329629 */   GIR_Done,
     /* 329630 */ // Label 6495: @329630
     /* 329630 */ GIM_Reject,
     /* 329631 */ // Label 6468: @329631
     /* 329631 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(329661), // Rule ID 843 //
     /* 329636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329650 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 329650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 329655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329659 */   GIR_RootConstrainSelectedInstOperands,
     /* 329660 */   // GIR_Coverage, 843,
     /* 329660 */   GIR_Done,
     /* 329661 */ // Label 6496: @329661
     /* 329661 */ GIM_Reject,
     /* 329662 */ // Label 6469: @329662
     /* 329662 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(329692), // Rule ID 847 //
     /* 329667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329681 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 329681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 329686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329690 */   GIR_RootConstrainSelectedInstOperands,
     /* 329691 */   // GIR_Coverage, 847,
     /* 329691 */   GIR_Done,
     /* 329692 */ // Label 6497: @329692
     /* 329692 */ GIM_Reject,
     /* 329693 */ // Label 6470: @329693
     /* 329693 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(329723), // Rule ID 839 //
     /* 329698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329712 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 329712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 329717 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329721 */   GIR_RootConstrainSelectedInstOperands,
     /* 329722 */   // GIR_Coverage, 839,
     /* 329722 */   GIR_Done,
     /* 329723 */ // Label 6498: @329723
     /* 329723 */ GIM_Reject,
     /* 329724 */ // Label 6471: @329724
     /* 329724 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(329754), // Rule ID 845 //
     /* 329729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329743 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 329743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 329748 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329752 */   GIR_RootConstrainSelectedInstOperands,
     /* 329753 */   // GIR_Coverage, 845,
     /* 329753 */   GIR_Done,
     /* 329754 */ // Label 6499: @329754
     /* 329754 */ GIM_Reject,
     /* 329755 */ // Label 6472: @329755
     /* 329755 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(329785), // Rule ID 841 //
     /* 329760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329774 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 329774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 329779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329783 */   GIR_RootConstrainSelectedInstOperands,
     /* 329784 */   // GIR_Coverage, 841,
     /* 329784 */   GIR_Done,
     /* 329785 */ // Label 6500: @329785
     /* 329785 */ GIM_Reject,
     /* 329786 */ // Label 6473: @329786
     /* 329786 */ GIM_Reject,
     /* 329787 */ // Label 68: @329787
     /* 329787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6508*/ GIMT_Encode4(330763),
     /* 329798 */ /*GILLT_s32*//*Label 6501*/ GIMT_Encode4(329834),
     /* 329802 */ /*GILLT_s64*//*Label 6502*/ GIMT_Encode4(330221), GIMT_Encode4(0),
     /* 329810 */ /*GILLT_v2s32*//*Label 6503*/ GIMT_Encode4(330608),
     /* 329814 */ /*GILLT_v2s64*//*Label 6504*/ GIMT_Encode4(330639),
     /* 329818 */ /*GILLT_v4s16*//*Label 6505*/ GIMT_Encode4(330670),
     /* 329822 */ /*GILLT_v4s32*//*Label 6506*/ GIMT_Encode4(330701), GIMT_Encode4(0),
     /* 329830 */ /*GILLT_v8s16*//*Label 6507*/ GIMT_Encode4(330732),
     /* 329834 */ // Label 6501: @329834
     /* 329834 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(329871), // Rule ID 4692 //
     /* 329839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329846 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329854 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329858 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329860 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 329863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329865 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329869 */   GIR_RootConstrainSelectedInstOperands,
     /* 329870 */   // GIR_Coverage, 4692,
     /* 329870 */   GIR_EraseRootFromParent_Done,
     /* 329871 */ // Label 6509: @329871
     /* 329871 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(329908), // Rule ID 4694 //
     /* 329876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329897 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 329900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329902 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329906 */   GIR_RootConstrainSelectedInstOperands,
     /* 329907 */   // GIR_Coverage, 4694,
     /* 329907 */   GIR_EraseRootFromParent_Done,
     /* 329908 */ // Label 6510: @329908
     /* 329908 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(329945), // Rule ID 4712 //
     /* 329913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329934 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 329937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329943 */   GIR_RootConstrainSelectedInstOperands,
     /* 329944 */   // GIR_Coverage, 4712,
     /* 329944 */   GIR_EraseRootFromParent_Done,
     /* 329945 */ // Label 6511: @329945
     /* 329945 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(329982), // Rule ID 4714 //
     /* 329950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329971 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 329974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329976 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329980 */   GIR_RootConstrainSelectedInstOperands,
     /* 329981 */   // GIR_Coverage, 4714,
     /* 329981 */   GIR_EraseRootFromParent_Done,
     /* 329982 */ // Label 6512: @329982
     /* 329982 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(330019), // Rule ID 4752 //
     /* 329987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329994 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329998 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330002 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330006 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330008 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 330011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330013 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330017 */   GIR_RootConstrainSelectedInstOperands,
     /* 330018 */   // GIR_Coverage, 4752,
     /* 330018 */   GIR_EraseRootFromParent_Done,
     /* 330019 */ // Label 6513: @330019
     /* 330019 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(330056), // Rule ID 4754 //
     /* 330024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330031 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330039 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330045 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 330048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330054 */   GIR_RootConstrainSelectedInstOperands,
     /* 330055 */   // GIR_Coverage, 4754,
     /* 330055 */   GIR_EraseRootFromParent_Done,
     /* 330056 */ // Label 6514: @330056
     /* 330056 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(330093), // Rule ID 4732 //
     /* 330061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330076 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330082 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330087 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330091 */   GIR_RootConstrainSelectedInstOperands,
     /* 330092 */   // GIR_Coverage, 4732,
     /* 330092 */   GIR_EraseRootFromParent_Done,
     /* 330093 */ // Label 6515: @330093
     /* 330093 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(330130), // Rule ID 4734 //
     /* 330098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330113 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330119 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330128 */   GIR_RootConstrainSelectedInstOperands,
     /* 330129 */   // GIR_Coverage, 4734,
     /* 330129 */   GIR_EraseRootFromParent_Done,
     /* 330130 */ // Label 6516: @330130
     /* 330130 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(330160), // Rule ID 407 //
     /* 330135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330149 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 330154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330158 */   GIR_RootConstrainSelectedInstOperands,
     /* 330159 */   // GIR_Coverage, 407,
     /* 330159 */   GIR_Done,
     /* 330160 */ // Label 6517: @330160
     /* 330160 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(330190), // Rule ID 411 //
     /* 330165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330179 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330188 */   GIR_RootConstrainSelectedInstOperands,
     /* 330189 */   // GIR_Coverage, 411,
     /* 330189 */   GIR_Done,
     /* 330190 */ // Label 6518: @330190
     /* 330190 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(330220), // Rule ID 415 //
     /* 330195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330209 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 330214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330218 */   GIR_RootConstrainSelectedInstOperands,
     /* 330219 */   // GIR_Coverage, 415,
     /* 330219 */   GIR_Done,
     /* 330220 */ // Label 6519: @330220
     /* 330220 */ GIM_Reject,
     /* 330221 */ // Label 6502: @330221
     /* 330221 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(330258), // Rule ID 4693 //
     /* 330226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330247 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 330250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330252 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330256 */   GIR_RootConstrainSelectedInstOperands,
     /* 330257 */   // GIR_Coverage, 4693,
     /* 330257 */   GIR_EraseRootFromParent_Done,
     /* 330258 */ // Label 6520: @330258
     /* 330258 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(330295), // Rule ID 4695 //
     /* 330263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330278 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330284 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 330287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330293 */   GIR_RootConstrainSelectedInstOperands,
     /* 330294 */   // GIR_Coverage, 4695,
     /* 330294 */   GIR_EraseRootFromParent_Done,
     /* 330295 */ // Label 6521: @330295
     /* 330295 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(330332), // Rule ID 4713 //
     /* 330300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330315 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330321 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 330324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330326 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330330 */   GIR_RootConstrainSelectedInstOperands,
     /* 330331 */   // GIR_Coverage, 4713,
     /* 330331 */   GIR_EraseRootFromParent_Done,
     /* 330332 */ // Label 6522: @330332
     /* 330332 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(330369), // Rule ID 4715 //
     /* 330337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330358 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 330361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330367 */   GIR_RootConstrainSelectedInstOperands,
     /* 330368 */   // GIR_Coverage, 4715,
     /* 330368 */   GIR_EraseRootFromParent_Done,
     /* 330369 */ // Label 6523: @330369
     /* 330369 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(330406), // Rule ID 4753 //
     /* 330374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330389 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330393 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330395 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 330398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330400 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330404 */   GIR_RootConstrainSelectedInstOperands,
     /* 330405 */   // GIR_Coverage, 4753,
     /* 330405 */   GIR_EraseRootFromParent_Done,
     /* 330406 */ // Label 6524: @330406
     /* 330406 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(330443), // Rule ID 4755 //
     /* 330411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330418 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330422 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330426 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330432 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 330435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330437 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330441 */   GIR_RootConstrainSelectedInstOperands,
     /* 330442 */   // GIR_Coverage, 4755,
     /* 330442 */   GIR_EraseRootFromParent_Done,
     /* 330443 */ // Label 6525: @330443
     /* 330443 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(330480), // Rule ID 4733 //
     /* 330448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330463 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330469 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 330472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330474 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330478 */   GIR_RootConstrainSelectedInstOperands,
     /* 330479 */   // GIR_Coverage, 4733,
     /* 330479 */   GIR_EraseRootFromParent_Done,
     /* 330480 */ // Label 6526: @330480
     /* 330480 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(330517), // Rule ID 4735 //
     /* 330485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330500 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330506 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 330509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330511 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330515 */   GIR_RootConstrainSelectedInstOperands,
     /* 330516 */   // GIR_Coverage, 4735,
     /* 330516 */   GIR_EraseRootFromParent_Done,
     /* 330517 */ // Label 6527: @330517
     /* 330517 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(330547), // Rule ID 409 //
     /* 330522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330536 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 330536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 330541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330545 */   GIR_RootConstrainSelectedInstOperands,
     /* 330546 */   // GIR_Coverage, 409,
     /* 330546 */   GIR_Done,
     /* 330547 */ // Label 6528: @330547
     /* 330547 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(330577), // Rule ID 413 //
     /* 330552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330566 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 330566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 330571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330575 */   GIR_RootConstrainSelectedInstOperands,
     /* 330576 */   // GIR_Coverage, 413,
     /* 330576 */   GIR_Done,
     /* 330577 */ // Label 6529: @330577
     /* 330577 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(330607), // Rule ID 417 //
     /* 330582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330596 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 330596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 330601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330605 */   GIR_RootConstrainSelectedInstOperands,
     /* 330606 */   // GIR_Coverage, 417,
     /* 330606 */   GIR_Done,
     /* 330607 */ // Label 6530: @330607
     /* 330607 */ GIM_Reject,
     /* 330608 */ // Label 6503: @330608
     /* 330608 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(330638), // Rule ID 853 //
     /* 330613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330627 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 330627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 330632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330636 */   GIR_RootConstrainSelectedInstOperands,
     /* 330637 */   // GIR_Coverage, 853,
     /* 330637 */   GIR_Done,
     /* 330638 */ // Label 6531: @330638
     /* 330638 */ GIM_Reject,
     /* 330639 */ // Label 6504: @330639
     /* 330639 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(330669), // Rule ID 857 //
     /* 330644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330658 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 330658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 330663 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330667 */   GIR_RootConstrainSelectedInstOperands,
     /* 330668 */   // GIR_Coverage, 857,
     /* 330668 */   GIR_Done,
     /* 330669 */ // Label 6532: @330669
     /* 330669 */ GIM_Reject,
     /* 330670 */ // Label 6505: @330670
     /* 330670 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(330700), // Rule ID 849 //
     /* 330675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330689 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 330689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 330694 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330698 */   GIR_RootConstrainSelectedInstOperands,
     /* 330699 */   // GIR_Coverage, 849,
     /* 330699 */   GIR_Done,
     /* 330700 */ // Label 6533: @330700
     /* 330700 */ GIM_Reject,
     /* 330701 */ // Label 6506: @330701
     /* 330701 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(330731), // Rule ID 855 //
     /* 330706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330720 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 330720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 330725 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330729 */   GIR_RootConstrainSelectedInstOperands,
     /* 330730 */   // GIR_Coverage, 855,
     /* 330730 */   GIR_Done,
     /* 330731 */ // Label 6534: @330731
     /* 330731 */ GIM_Reject,
     /* 330732 */ // Label 6507: @330732
     /* 330732 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(330762), // Rule ID 851 //
     /* 330737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330751 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 330751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 330756 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330760 */   GIR_RootConstrainSelectedInstOperands,
     /* 330761 */   // GIR_Coverage, 851,
     /* 330761 */   GIR_Done,
     /* 330762 */ // Label 6535: @330762
     /* 330762 */ GIM_Reject,
     /* 330763 */ // Label 6508: @330763
     /* 330763 */ GIM_Reject,
     /* 330764 */ // Label 69: @330764
     /* 330764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6544*/ GIMT_Encode4(335391),
     /* 330775 */ /*GILLT_s16*//*Label 6536*/ GIMT_Encode4(330815),
     /* 330779 */ /*GILLT_s32*//*Label 6537*/ GIMT_Encode4(331256),
     /* 330783 */ /*GILLT_s64*//*Label 6538*/ GIMT_Encode4(333252), GIMT_Encode4(0),
     /* 330791 */ /*GILLT_v2s32*//*Label 6539*/ GIMT_Encode4(335236),
     /* 330795 */ /*GILLT_v2s64*//*Label 6540*/ GIMT_Encode4(335267),
     /* 330799 */ /*GILLT_v4s16*//*Label 6541*/ GIMT_Encode4(335298),
     /* 330803 */ /*GILLT_v4s32*//*Label 6542*/ GIMT_Encode4(335329), GIMT_Encode4(0),
     /* 330811 */ /*GILLT_v8s16*//*Label 6543*/ GIMT_Encode4(335360),
     /* 330815 */ // Label 6536: @330815
     /* 330815 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(330918), // Rule ID 5335 //
     /* 330820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 330823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 330838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330842 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330846 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330850 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330854 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330858 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330863 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330867 */   // MIs[1] Operand 2
     /* 330867 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 330878 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330880 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 330880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330892 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 330898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 330911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330916 */   GIR_RootConstrainSelectedInstOperands,
     /* 330917 */   // GIR_Coverage, 5335,
     /* 330917 */   GIR_EraseRootFromParent_Done,
     /* 330918 */ // Label 6545: @330918
     /* 330918 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(330998), // Rule ID 2444 //
     /* 330923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 330926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330941 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330945 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330949 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330954 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 330958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330960 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 330960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 330978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 330991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330996 */   GIR_RootConstrainSelectedInstOperands,
     /* 330997 */   // GIR_Coverage, 2444,
     /* 330997 */   GIR_EraseRootFromParent_Done,
     /* 330998 */ // Label 6546: @330998
     /* 330998 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(331078), // Rule ID 2448 //
     /* 331003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331021 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331029 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331034 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331040 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 331040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331052 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331076 */   GIR_RootConstrainSelectedInstOperands,
     /* 331077 */   // GIR_Coverage, 2448,
     /* 331077 */   GIR_EraseRootFromParent_Done,
     /* 331078 */ // Label 6547: @331078
     /* 331078 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(331135), // Rule ID 5326 //
     /* 331083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 331101 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331107 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 331107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 331114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331119 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 331128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331133 */   GIR_RootConstrainSelectedInstOperands,
     /* 331134 */   // GIR_Coverage, 5326,
     /* 331134 */   GIR_EraseRootFromParent_Done,
     /* 331135 */ // Label 6548: @331135
     /* 331135 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(331165), // Rule ID 443 //
     /* 331140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331154 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 331154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 331159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331163 */   GIR_RootConstrainSelectedInstOperands,
     /* 331164 */   // GIR_Coverage, 443,
     /* 331164 */   GIR_Done,
     /* 331165 */ // Label 6549: @331165
     /* 331165 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(331195), // Rule ID 449 //
     /* 331170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331184 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 331184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 331189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331193 */   GIR_RootConstrainSelectedInstOperands,
     /* 331194 */   // GIR_Coverage, 449,
     /* 331194 */   GIR_Done,
     /* 331195 */ // Label 6550: @331195
     /* 331195 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(331225), // Rule ID 491 //
     /* 331200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331214 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 331214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 331219 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331223 */   GIR_RootConstrainSelectedInstOperands,
     /* 331224 */   // GIR_Coverage, 491,
     /* 331224 */   GIR_Done,
     /* 331225 */ // Label 6551: @331225
     /* 331225 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(331255), // Rule ID 495 //
     /* 331230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331244 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 331244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331253 */   GIR_RootConstrainSelectedInstOperands,
     /* 331254 */   // GIR_Coverage, 495,
     /* 331254 */   GIR_Done,
     /* 331255 */ // Label 6552: @331255
     /* 331255 */ GIM_Reject,
     /* 331256 */ // Label 6537: @331256
     /* 331256 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(331494), // Rule ID 6410 //
     /* 331261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331279 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331282 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331289 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331295 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 331302 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331302 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 331305 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 331309 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331329 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 331336 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 331339 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331343 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 331350 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 331353 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331357 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331362 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 331365 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 331368 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 331371 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331376 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331381 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 331386 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 331389 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 331393 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331398 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 331401 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 331404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331406 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331409 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331413 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331418 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331425 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331430 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331447 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331450 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331467 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331492 */   GIR_RootConstrainSelectedInstOperands,
     /* 331493 */   // GIR_Coverage, 6410,
     /* 331493 */   GIR_EraseRootFromParent_Done,
     /* 331494 */ // Label 6553: @331494
     /* 331494 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(331732), // Rule ID 6411 //
     /* 331499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331509 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331517 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331520 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331527 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331533 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 331540 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331540 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 331543 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 331547 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331567 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 331574 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 331577 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331581 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 331588 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 331591 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331595 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331600 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 331603 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 331606 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 331609 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331614 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331619 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 331624 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 331627 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 331631 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331636 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 331639 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 331642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331644 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331647 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331651 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331656 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331663 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331668 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331673 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331676 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331680 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331685 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331688 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331705 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331730 */   GIR_RootConstrainSelectedInstOperands,
     /* 331731 */   // GIR_Coverage, 6411,
     /* 331731 */   GIR_EraseRootFromParent_Done,
     /* 331732 */ // Label 6554: @331732
     /* 331732 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(331921), // Rule ID 6414 //
     /* 331737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331755 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331758 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331765 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331771 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 331778 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331778 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 331781 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 331785 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331805 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 331812 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 331815 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331819 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 331826 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 331829 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 331833 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331838 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 331841 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 331844 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 331847 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331852 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331857 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 331869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331874 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331877 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331894 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 331901 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 331914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331919 */   GIR_RootConstrainSelectedInstOperands,
     /* 331920 */   // GIR_Coverage, 6414,
     /* 331920 */   GIR_EraseRootFromParent_Done,
     /* 331921 */ // Label 6555: @331921
     /* 331921 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(332110), // Rule ID 6415 //
     /* 331926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 331929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331936 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331940 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 331944 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331947 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331954 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 331958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331960 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 331967 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 331967 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 331970 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 331974 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 331994 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 331999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332001 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332004 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332008 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332015 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332018 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332022 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332027 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332030 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332033 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332036 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332041 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332046 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332051 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332054 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332058 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332063 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332066 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332083 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332108 */   GIR_RootConstrainSelectedInstOperands,
     /* 332109 */   // GIR_Coverage, 6415,
     /* 332109 */   GIR_EraseRootFromParent_Done,
     /* 332110 */ // Label 6556: @332110
     /* 332110 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(332343), // Rule ID 6412 //
     /* 332115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332133 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332136 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332143 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332149 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 332156 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332156 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332159 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 332163 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332178 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332185 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332188 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332192 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332199 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332202 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332206 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332211 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332214 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332217 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332220 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332225 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332230 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332235 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332238 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332242 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332247 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332250 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332255 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332258 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332262 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332267 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332274 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332279 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332284 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332287 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332291 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332296 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332299 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332316 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332341 */   GIR_RootConstrainSelectedInstOperands,
     /* 332342 */   // GIR_Coverage, 6412,
     /* 332342 */   GIR_EraseRootFromParent_Done,
     /* 332343 */ // Label 6557: @332343
     /* 332343 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(332576), // Rule ID 6413 //
     /* 332348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332366 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332369 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332376 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332382 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 332389 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332389 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332392 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 332396 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332411 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332418 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332421 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332425 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332432 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332435 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332439 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332444 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332447 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332450 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332453 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332458 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332463 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332468 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332471 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332475 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332480 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332483 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332488 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332491 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332495 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332500 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332507 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332512 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332517 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332520 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332524 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332529 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332532 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332549 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332574 */   GIR_RootConstrainSelectedInstOperands,
     /* 332575 */   // GIR_Coverage, 6413,
     /* 332575 */   GIR_EraseRootFromParent_Done,
     /* 332576 */ // Label 6558: @332576
     /* 332576 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(332760), // Rule ID 6416 //
     /* 332581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332599 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332602 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332609 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332615 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 332622 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332622 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332625 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 332629 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332644 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332651 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332654 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332658 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332665 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332668 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332672 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332677 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332680 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332683 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332686 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332691 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332696 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332701 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332704 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332708 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332713 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332716 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332733 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332740 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332745 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332758 */   GIR_RootConstrainSelectedInstOperands,
     /* 332759 */   // GIR_Coverage, 6416,
     /* 332759 */   GIR_EraseRootFromParent_Done,
     /* 332760 */ // Label 6559: @332760
     /* 332760 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(332944), // Rule ID 6417 //
     /* 332765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332775 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332783 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332786 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332793 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332799 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 332806 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332806 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332809 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 332813 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332828 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332835 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332838 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332842 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332849 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332852 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332856 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332861 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332864 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332867 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332870 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332875 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332880 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332885 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332888 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332892 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332897 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332900 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332917 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332942 */   GIR_RootConstrainSelectedInstOperands,
     /* 332943 */   // GIR_Coverage, 6417,
     /* 332943 */   GIR_EraseRootFromParent_Done,
     /* 332944 */ // Label 6560: @332944
     /* 332944 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(333024), // Rule ID 2450 //
     /* 332949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332967 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332971 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332980 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332986 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 332986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 332989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332998 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 333004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333022 */   GIR_RootConstrainSelectedInstOperands,
     /* 333023 */   // GIR_Coverage, 2450,
     /* 333023 */   GIR_EraseRootFromParent_Done,
     /* 333024 */ // Label 6561: @333024
     /* 333024 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(333104), // Rule ID 5331 //
     /* 333029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333051 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333055 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333060 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333066 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333078 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333102 */   GIR_RootConstrainSelectedInstOperands,
     /* 333103 */   // GIR_Coverage, 5331,
     /* 333103 */   GIR_EraseRootFromParent_Done,
     /* 333104 */ // Label 6562: @333104
     /* 333104 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(333161), // Rule ID 5314 //
     /* 333109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333119 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 333127 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333133 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 333133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 333140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333145 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333159 */   GIR_RootConstrainSelectedInstOperands,
     /* 333160 */   // GIR_Coverage, 5314,
     /* 333160 */   GIR_EraseRootFromParent_Done,
     /* 333161 */ // Label 6563: @333161
     /* 333161 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(333191), // Rule ID 445 //
     /* 333166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333180 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 333180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 333185 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333189 */   GIR_RootConstrainSelectedInstOperands,
     /* 333190 */   // GIR_Coverage, 445,
     /* 333190 */   GIR_Done,
     /* 333191 */ // Label 6564: @333191
     /* 333191 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(333221), // Rule ID 451 //
     /* 333196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 333199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333210 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 333210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 333215 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333219 */   GIR_RootConstrainSelectedInstOperands,
     /* 333220 */   // GIR_Coverage, 451,
     /* 333220 */   GIR_Done,
     /* 333221 */ // Label 6565: @333221
     /* 333221 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(333251), // Rule ID 497 //
     /* 333226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333240 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 333240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333249 */   GIR_RootConstrainSelectedInstOperands,
     /* 333250 */   // GIR_Coverage, 497,
     /* 333250 */   GIR_Done,
     /* 333251 */ // Label 6566: @333251
     /* 333251 */ GIM_Reject,
     /* 333252 */ // Label 6538: @333252
     /* 333252 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(333438), // Rule ID 6422 //
     /* 333257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333275 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333282 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333288 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333295 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333295 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 333298 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333302 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333322 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333329 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333332 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333336 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333343 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333346 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333350 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333355 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333358 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333361 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 333364 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333369 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333374 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333379 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333382 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333386 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333391 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333394 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333411 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333436 */   GIR_RootConstrainSelectedInstOperands,
     /* 333437 */   // GIR_Coverage, 6422,
     /* 333437 */   GIR_EraseRootFromParent_Done,
     /* 333438 */ // Label 6567: @333438
     /* 333438 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(333624), // Rule ID 6423 //
     /* 333443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333461 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333468 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333474 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333481 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333481 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 333484 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333488 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333508 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333515 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333518 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333522 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333541 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333544 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333547 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 333550 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333555 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333560 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333580 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333597 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333622 */   GIR_RootConstrainSelectedInstOperands,
     /* 333623 */   // GIR_Coverage, 6423,
     /* 333623 */   GIR_EraseRootFromParent_Done,
     /* 333624 */ // Label 6568: @333624
     /* 333624 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(333862), // Rule ID 6418 //
     /* 333629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333647 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333650 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333657 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333663 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333670 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333670 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 333673 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333677 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333697 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333704 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333707 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333711 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333718 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333721 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333725 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333730 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333733 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333736 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 333739 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333744 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333749 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333754 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333757 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333761 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333766 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333769 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333774 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333777 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333781 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333786 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333793 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333798 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333803 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333806 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 333810 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333815 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333818 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333835 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333847 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 333855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333860 */   GIR_RootConstrainSelectedInstOperands,
     /* 333861 */   // GIR_Coverage, 6418,
     /* 333861 */   GIR_EraseRootFromParent_Done,
     /* 333862 */ // Label 6569: @333862
     /* 333862 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(334100), // Rule ID 6419 //
     /* 333867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333885 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333888 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333895 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333901 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333908 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 333908 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 333911 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333915 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333935 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333942 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333945 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333949 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333956 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333959 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333963 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333968 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333971 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333974 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 333977 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333982 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333987 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333992 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333995 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333999 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334004 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334007 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334012 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334015 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334019 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334024 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334031 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334036 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334041 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334044 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334048 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334053 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334056 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334073 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334080 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334085 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334098 */   GIR_RootConstrainSelectedInstOperands,
     /* 334099 */   // GIR_Coverage, 6419,
     /* 334099 */   GIR_EraseRootFromParent_Done,
     /* 334100 */ // Label 6570: @334100
     /* 334100 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(334281), // Rule ID 6424 //
     /* 334105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334123 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334130 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334136 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334143 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334143 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334146 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334150 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334165 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334172 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334175 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334179 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334186 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334189 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334193 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334198 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334201 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334204 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334212 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334217 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334222 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334225 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334229 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334234 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334237 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334254 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334279 */   GIR_RootConstrainSelectedInstOperands,
     /* 334280 */   // GIR_Coverage, 6424,
     /* 334280 */   GIR_EraseRootFromParent_Done,
     /* 334281 */ // Label 6571: @334281
     /* 334281 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(334462), // Rule ID 6425 //
     /* 334286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334304 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334311 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334317 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334324 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334324 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334327 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334331 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334346 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334353 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334356 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334360 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334367 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334370 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334374 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334379 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334382 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334385 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334388 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334393 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334398 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334415 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334418 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334435 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334460 */   GIR_RootConstrainSelectedInstOperands,
     /* 334461 */   // GIR_Coverage, 6425,
     /* 334461 */   GIR_EraseRootFromParent_Done,
     /* 334462 */ // Label 6572: @334462
     /* 334462 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(334695), // Rule ID 6420 //
     /* 334467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334477 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334481 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334485 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334488 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334495 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334501 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334508 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334508 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334511 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334515 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334530 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334537 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334540 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334544 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334551 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334554 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334558 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334563 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334566 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334569 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334572 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334577 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334582 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334587 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334590 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334594 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334599 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334602 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334607 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334610 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334614 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334619 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334626 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334631 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334636 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334639 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334643 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334648 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334651 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334668 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334693 */   GIR_RootConstrainSelectedInstOperands,
     /* 334694 */   // GIR_Coverage, 6420,
     /* 334694 */   GIR_EraseRootFromParent_Done,
     /* 334695 */ // Label 6573: @334695
     /* 334695 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(334928), // Rule ID 6421 //
     /* 334700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334718 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334721 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334728 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334734 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334741 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334741 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334744 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334748 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334763 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334770 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334773 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334777 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334784 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334787 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334791 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334796 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334799 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334802 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334805 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334810 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334815 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334820 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334823 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334827 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334832 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334835 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334840 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334843 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334847 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334852 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334859 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334864 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334869 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334872 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334876 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334881 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334884 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334901 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334926 */   GIR_RootConstrainSelectedInstOperands,
     /* 334927 */   // GIR_Coverage, 6421,
     /* 334927 */   GIR_EraseRootFromParent_Done,
     /* 334928 */ // Label 6574: @334928
     /* 334928 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(335008), // Rule ID 2446 //
     /* 334933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334955 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334959 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334964 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334970 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 334970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334982 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 334988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335006 */   GIR_RootConstrainSelectedInstOperands,
     /* 335007 */   // GIR_Coverage, 2446,
     /* 335007 */   GIR_EraseRootFromParent_Done,
     /* 335008 */ // Label 6575: @335008
     /* 335008 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(335088), // Rule ID 5333 //
     /* 335013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335031 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335035 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335044 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335050 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335062 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335086 */   GIR_RootConstrainSelectedInstOperands,
     /* 335087 */   // GIR_Coverage, 5333,
     /* 335087 */   GIR_EraseRootFromParent_Done,
     /* 335088 */ // Label 6576: @335088
     /* 335088 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(335145), // Rule ID 5310 //
     /* 335093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 335111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335117 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 335117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 335124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335143 */   GIR_RootConstrainSelectedInstOperands,
     /* 335144 */   // GIR_Coverage, 5310,
     /* 335144 */   GIR_EraseRootFromParent_Done,
     /* 335145 */ // Label 6577: @335145
     /* 335145 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(335175), // Rule ID 447 //
     /* 335150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335164 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 335164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 335169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335173 */   GIR_RootConstrainSelectedInstOperands,
     /* 335174 */   // GIR_Coverage, 447,
     /* 335174 */   GIR_Done,
     /* 335175 */ // Label 6578: @335175
     /* 335175 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(335205), // Rule ID 453 //
     /* 335180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335194 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 335194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 335199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335203 */   GIR_RootConstrainSelectedInstOperands,
     /* 335204 */   // GIR_Coverage, 453,
     /* 335204 */   GIR_Done,
     /* 335205 */ // Label 6579: @335205
     /* 335205 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(335235), // Rule ID 493 //
     /* 335210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335224 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 335224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335233 */   GIR_RootConstrainSelectedInstOperands,
     /* 335234 */   // GIR_Coverage, 493,
     /* 335234 */   GIR_Done,
     /* 335235 */ // Label 6580: @335235
     /* 335235 */ GIM_Reject,
     /* 335236 */ // Label 6539: @335236
     /* 335236 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(335266), // Rule ID 1017 //
     /* 335241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335255 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 335255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 335260 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335264 */   GIR_RootConstrainSelectedInstOperands,
     /* 335265 */   // GIR_Coverage, 1017,
     /* 335265 */   GIR_Done,
     /* 335266 */ // Label 6581: @335266
     /* 335266 */ GIM_Reject,
     /* 335267 */ // Label 6540: @335267
     /* 335267 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(335297), // Rule ID 1021 //
     /* 335272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335286 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 335286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 335291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335295 */   GIR_RootConstrainSelectedInstOperands,
     /* 335296 */   // GIR_Coverage, 1021,
     /* 335296 */   GIR_Done,
     /* 335297 */ // Label 6582: @335297
     /* 335297 */ GIM_Reject,
     /* 335298 */ // Label 6541: @335298
     /* 335298 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(335328), // Rule ID 1013 //
     /* 335303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 335306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 335309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335317 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 335317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 335322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335326 */   GIR_RootConstrainSelectedInstOperands,
     /* 335327 */   // GIR_Coverage, 1013,
     /* 335327 */   GIR_Done,
     /* 335328 */ // Label 6583: @335328
     /* 335328 */ GIM_Reject,
     /* 335329 */ // Label 6542: @335329
     /* 335329 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(335359), // Rule ID 1019 //
     /* 335334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335348 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 335348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 335353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335357 */   GIR_RootConstrainSelectedInstOperands,
     /* 335358 */   // GIR_Coverage, 1019,
     /* 335358 */   GIR_Done,
     /* 335359 */ // Label 6584: @335359
     /* 335359 */ GIM_Reject,
     /* 335360 */ // Label 6543: @335360
     /* 335360 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(335390), // Rule ID 1015 //
     /* 335365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 335368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 335371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335379 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 335379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 335384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335388 */   GIR_RootConstrainSelectedInstOperands,
     /* 335389 */   // GIR_Coverage, 1015,
     /* 335389 */   GIR_Done,
     /* 335390 */ // Label 6585: @335390
     /* 335390 */ GIM_Reject,
     /* 335391 */ // Label 6544: @335391
     /* 335391 */ GIM_Reject,
     /* 335392 */ // Label 70: @335392
     /* 335392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6594*/ GIMT_Encode4(339397),
     /* 335403 */ /*GILLT_s16*//*Label 6586*/ GIMT_Encode4(335443),
     /* 335407 */ /*GILLT_s32*//*Label 6587*/ GIMT_Encode4(335888),
     /* 335411 */ /*GILLT_s64*//*Label 6588*/ GIMT_Encode4(337296), GIMT_Encode4(0),
     /* 335419 */ /*GILLT_v2s32*//*Label 6589*/ GIMT_Encode4(339242),
     /* 335423 */ /*GILLT_v2s64*//*Label 6590*/ GIMT_Encode4(339273),
     /* 335427 */ /*GILLT_v4s16*//*Label 6591*/ GIMT_Encode4(339304),
     /* 335431 */ /*GILLT_v4s32*//*Label 6592*/ GIMT_Encode4(339335), GIMT_Encode4(0),
     /* 335439 */ /*GILLT_v8s16*//*Label 6593*/ GIMT_Encode4(339366),
     /* 335443 */ // Label 6586: @335443
     /* 335443 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(335550), // Rule ID 5336 //
     /* 335448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 335451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 335466 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335470 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 335474 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335478 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335482 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 335486 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 335490 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335495 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 335499 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 335510 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335512 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 335512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 335515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335524 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 335530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 335543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335548 */   GIR_RootConstrainSelectedInstOperands,
     /* 335549 */   // GIR_Coverage, 5336,
     /* 335549 */   GIR_EraseRootFromParent_Done,
     /* 335550 */ // Label 6595: @335550
     /* 335550 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(335630), // Rule ID 4781 //
     /* 335555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335592 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335604 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 335623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335628 */   GIR_RootConstrainSelectedInstOperands,
     /* 335629 */   // GIR_Coverage, 4781,
     /* 335629 */   GIR_EraseRootFromParent_Done,
     /* 335630 */ // Label 6596: @335630
     /* 335630 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(335710), // Rule ID 4785 //
     /* 335635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335653 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335657 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335661 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335666 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335672 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335684 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 335703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335708 */   GIR_RootConstrainSelectedInstOperands,
     /* 335709 */   // GIR_Coverage, 4785,
     /* 335709 */   GIR_EraseRootFromParent_Done,
     /* 335710 */ // Label 6597: @335710
     /* 335710 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(335767), // Rule ID 5330 //
     /* 335715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 335718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 335733 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335739 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 335739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 335742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 335746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335751 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 335760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335765 */   GIR_RootConstrainSelectedInstOperands,
     /* 335766 */   // GIR_Coverage, 5330,
     /* 335766 */   GIR_EraseRootFromParent_Done,
     /* 335767 */ // Label 6598: @335767
     /* 335767 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(335797), // Rule ID 467 //
     /* 335772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 335775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335786 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 335786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 335791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335795 */   GIR_RootConstrainSelectedInstOperands,
     /* 335796 */   // GIR_Coverage, 467,
     /* 335796 */   GIR_Done,
     /* 335797 */ // Label 6599: @335797
     /* 335797 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(335827), // Rule ID 473 //
     /* 335802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 335805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335816 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 335816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 335821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335825 */   GIR_RootConstrainSelectedInstOperands,
     /* 335826 */   // GIR_Coverage, 473,
     /* 335826 */   GIR_Done,
     /* 335827 */ // Label 6600: @335827
     /* 335827 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(335857), // Rule ID 499 //
     /* 335832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335846 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 335846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 335851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335855 */   GIR_RootConstrainSelectedInstOperands,
     /* 335856 */   // GIR_Coverage, 499,
     /* 335856 */   GIR_Done,
     /* 335857 */ // Label 6601: @335857
     /* 335857 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(335887), // Rule ID 503 //
     /* 335862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335876 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 335876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 335881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335885 */   GIR_RootConstrainSelectedInstOperands,
     /* 335886 */   // GIR_Coverage, 503,
     /* 335886 */   GIR_Done,
     /* 335887 */ // Label 6602: @335887
     /* 335887 */ GIM_Reject,
     /* 335888 */ // Label 6587: @335888
     /* 335888 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(336028), // Rule ID 5337 //
     /* 335893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335903 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 335911 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335914 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 335921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 335934 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 335934 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 335937 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 335941 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335961 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 335968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 335971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335994 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335997 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336000 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336008 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336026 */   GIR_RootConstrainSelectedInstOperands,
     /* 336027 */   // GIR_Coverage, 5337,
     /* 336027 */   GIR_EraseRootFromParent_Done,
     /* 336028 */ // Label 6603: @336028
     /* 336028 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(336168), // Rule ID 5338 //
     /* 336033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336051 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336054 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336061 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336067 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336074 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336074 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336077 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336081 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336101 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336134 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336140 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336166 */   GIR_RootConstrainSelectedInstOperands,
     /* 336167 */   // GIR_Coverage, 5338,
     /* 336167 */   GIR_EraseRootFromParent_Done,
     /* 336168 */ // Label 6604: @336168
     /* 336168 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(336308), // Rule ID 5341 //
     /* 336173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336191 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336194 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336201 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336207 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 336214 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 336214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 336221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336241 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336248 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336251 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336255 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336274 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336277 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336280 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336306 */   GIR_RootConstrainSelectedInstOperands,
     /* 336307 */   // GIR_Coverage, 5341,
     /* 336307 */   GIR_EraseRootFromParent_Done,
     /* 336308 */ // Label 6605: @336308
     /* 336308 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(336448), // Rule ID 5342 //
     /* 336313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336334 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336341 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336347 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 336354 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 336354 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336357 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 336361 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336381 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336388 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336391 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336395 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336414 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336420 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336446 */   GIR_RootConstrainSelectedInstOperands,
     /* 336447 */   // GIR_Coverage, 5342,
     /* 336447 */   GIR_EraseRootFromParent_Done,
     /* 336448 */ // Label 6606: @336448
     /* 336448 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(336583), // Rule ID 5339 //
     /* 336453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336471 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336474 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336481 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336487 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336494 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 336494 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336497 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336501 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336516 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336523 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336526 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336530 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336549 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336552 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336555 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336563 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336581 */   GIR_RootConstrainSelectedInstOperands,
     /* 336582 */   // GIR_Coverage, 5339,
     /* 336582 */   GIR_EraseRootFromParent_Done,
     /* 336583 */ // Label 6607: @336583
     /* 336583 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(336718), // Rule ID 5340 //
     /* 336588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336606 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336609 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336616 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336622 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336629 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 336629 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336632 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336636 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336651 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336658 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336661 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336665 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336690 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336716 */   GIR_RootConstrainSelectedInstOperands,
     /* 336717 */   // GIR_Coverage, 5340,
     /* 336717 */   GIR_EraseRootFromParent_Done,
     /* 336718 */ // Label 6608: @336718
     /* 336718 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(336853), // Rule ID 5343 //
     /* 336723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336741 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336744 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336751 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336757 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 336764 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 336764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 336771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336786 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336793 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336796 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336800 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336822 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336825 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336851 */   GIR_RootConstrainSelectedInstOperands,
     /* 336852 */   // GIR_Coverage, 5343,
     /* 336852 */   GIR_EraseRootFromParent_Done,
     /* 336853 */ // Label 6609: @336853
     /* 336853 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(336988), // Rule ID 5344 //
     /* 336858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336876 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336879 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336886 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336892 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 336899 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 336899 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 336902 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 336906 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336921 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336954 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336957 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336960 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 336963 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336986 */   GIR_RootConstrainSelectedInstOperands,
     /* 336987 */   // GIR_Coverage, 5344,
     /* 336987 */   GIR_EraseRootFromParent_Done,
     /* 336988 */ // Label 6610: @336988
     /* 336988 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(337068), // Rule ID 4787 //
     /* 336993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337015 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337024 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337030 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337042 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337048 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337066 */   GIR_RootConstrainSelectedInstOperands,
     /* 337067 */   // GIR_Coverage, 4787,
     /* 337067 */   GIR_EraseRootFromParent_Done,
     /* 337068 */ // Label 6611: @337068
     /* 337068 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(337148), // Rule ID 5332 //
     /* 337073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337091 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337099 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337104 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337108 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337110 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337122 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337146 */   GIR_RootConstrainSelectedInstOperands,
     /* 337147 */   // GIR_Coverage, 5332,
     /* 337147 */   GIR_EraseRootFromParent_Done,
     /* 337148 */ // Label 6612: @337148
     /* 337148 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(337205), // Rule ID 5322 //
     /* 337153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337177 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 337177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 337184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337203 */   GIR_RootConstrainSelectedInstOperands,
     /* 337204 */   // GIR_Coverage, 5322,
     /* 337204 */   GIR_EraseRootFromParent_Done,
     /* 337205 */ // Label 6613: @337205
     /* 337205 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(337235), // Rule ID 469 //
     /* 337210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337224 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 337224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 337229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337233 */   GIR_RootConstrainSelectedInstOperands,
     /* 337234 */   // GIR_Coverage, 469,
     /* 337234 */   GIR_Done,
     /* 337235 */ // Label 6614: @337235
     /* 337235 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(337265), // Rule ID 475 //
     /* 337240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337254 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 337254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 337259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337263 */   GIR_RootConstrainSelectedInstOperands,
     /* 337264 */   // GIR_Coverage, 475,
     /* 337264 */   GIR_Done,
     /* 337265 */ // Label 6615: @337265
     /* 337265 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(337295), // Rule ID 505 //
     /* 337270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337284 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 337284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337293 */   GIR_RootConstrainSelectedInstOperands,
     /* 337294 */   // GIR_Coverage, 505,
     /* 337294 */   GIR_Done,
     /* 337295 */ // Label 6616: @337295
     /* 337295 */ GIM_Reject,
     /* 337296 */ // Label 6588: @337296
     /* 337296 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(337433), // Rule ID 5353 //
     /* 337301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337319 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337322 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337326 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337332 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 337339 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 337339 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 337342 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 337346 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337366 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337373 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337376 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337380 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337399 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337402 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337405 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 337408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337431 */   GIR_RootConstrainSelectedInstOperands,
     /* 337432 */   // GIR_Coverage, 5353,
     /* 337432 */   GIR_EraseRootFromParent_Done,
     /* 337433 */ // Label 6617: @337433
     /* 337433 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(337570), // Rule ID 5354 //
     /* 337438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337456 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337463 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337469 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 337476 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 337476 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 337479 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 337483 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337503 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337510 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337513 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337517 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337539 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337542 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 337545 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337568 */   GIR_RootConstrainSelectedInstOperands,
     /* 337569 */   // GIR_Coverage, 5354,
     /* 337569 */   GIR_EraseRootFromParent_Done,
     /* 337570 */ // Label 6618: @337570
     /* 337570 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337710), // Rule ID 5345 //
     /* 337575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337593 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337596 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337603 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337609 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 337616 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337616 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337619 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 337623 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337643 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337650 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337653 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337657 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337676 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337679 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337682 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337685 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337708 */   GIR_RootConstrainSelectedInstOperands,
     /* 337709 */   // GIR_Coverage, 5345,
     /* 337709 */   GIR_EraseRootFromParent_Done,
     /* 337710 */ // Label 6619: @337710
     /* 337710 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337850), // Rule ID 5346 //
     /* 337715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337733 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337736 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337743 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337749 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 337756 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337756 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337759 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 337763 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337783 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337848 */   GIR_RootConstrainSelectedInstOperands,
     /* 337849 */   // GIR_Coverage, 5346,
     /* 337849 */   GIR_EraseRootFromParent_Done,
     /* 337850 */ // Label 6620: @337850
     /* 337850 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337990), // Rule ID 5349 //
     /* 337855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337876 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337883 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337889 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337896 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337896 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337899 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337903 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337923 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 337933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337956 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337959 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337962 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 337983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337988 */   GIR_RootConstrainSelectedInstOperands,
     /* 337989 */   // GIR_Coverage, 5349,
     /* 337989 */   GIR_EraseRootFromParent_Done,
     /* 337990 */ // Label 6621: @337990
     /* 337990 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(338130), // Rule ID 5350 //
     /* 337995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338013 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338016 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338023 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338029 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338036 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338036 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338039 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338043 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338063 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338070 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338073 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338077 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338096 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338099 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338102 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338105 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338110 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338128 */   GIR_RootConstrainSelectedInstOperands,
     /* 338129 */   // GIR_Coverage, 5350,
     /* 338129 */   GIR_EraseRootFromParent_Done,
     /* 338130 */ // Label 6622: @338130
     /* 338130 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(338262), // Rule ID 5355 //
     /* 338135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338153 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338160 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338164 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338166 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 338173 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 338173 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338176 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 338180 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338195 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338202 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338205 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338209 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338231 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338234 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338260 */   GIR_RootConstrainSelectedInstOperands,
     /* 338261 */   // GIR_Coverage, 5355,
     /* 338261 */   GIR_EraseRootFromParent_Done,
     /* 338262 */ // Label 6623: @338262
     /* 338262 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(338394), // Rule ID 5356 //
     /* 338267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338285 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338292 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338298 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 338305 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 338305 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338308 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 338312 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338327 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338334 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338337 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338341 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338360 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338363 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338366 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338369 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338392 */   GIR_RootConstrainSelectedInstOperands,
     /* 338393 */   // GIR_Coverage, 5356,
     /* 338393 */   GIR_EraseRootFromParent_Done,
     /* 338394 */ // Label 6624: @338394
     /* 338394 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(338529), // Rule ID 5347 //
     /* 338399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338417 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338420 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338427 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338433 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 338440 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 338440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 338447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338462 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338495 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338498 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338501 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338527 */   GIR_RootConstrainSelectedInstOperands,
     /* 338528 */   // GIR_Coverage, 5347,
     /* 338528 */   GIR_EraseRootFromParent_Done,
     /* 338529 */ // Label 6625: @338529
     /* 338529 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(338664), // Rule ID 5348 //
     /* 338534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338552 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338555 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338562 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338568 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 338575 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 338575 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338578 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 338582 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338597 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338604 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338607 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338611 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338630 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338633 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338636 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338662 */   GIR_RootConstrainSelectedInstOperands,
     /* 338663 */   // GIR_Coverage, 5348,
     /* 338663 */   GIR_EraseRootFromParent_Done,
     /* 338664 */ // Label 6626: @338664
     /* 338664 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(338799), // Rule ID 5351 //
     /* 338669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338679 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338687 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338690 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338697 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338703 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338710 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 338710 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338713 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338717 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338732 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338765 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338768 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338771 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338797 */   GIR_RootConstrainSelectedInstOperands,
     /* 338798 */   // GIR_Coverage, 5351,
     /* 338798 */   GIR_EraseRootFromParent_Done,
     /* 338799 */ // Label 6627: @338799
     /* 338799 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(338934), // Rule ID 5352 //
     /* 338804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338822 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338825 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338845 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 338845 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338848 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338852 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338867 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338874 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338877 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338881 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338900 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338903 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338906 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338932 */   GIR_RootConstrainSelectedInstOperands,
     /* 338933 */   // GIR_Coverage, 5352,
     /* 338933 */   GIR_EraseRootFromParent_Done,
     /* 338934 */ // Label 6628: @338934
     /* 338934 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(339014), // Rule ID 4783 //
     /* 338939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338957 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338965 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338970 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338976 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338988 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339012 */   GIR_RootConstrainSelectedInstOperands,
     /* 339013 */   // GIR_Coverage, 4783,
     /* 339013 */   GIR_EraseRootFromParent_Done,
     /* 339014 */ // Label 6629: @339014
     /* 339014 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(339094), // Rule ID 5334 //
     /* 339019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339045 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339050 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339056 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339068 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339074 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339092 */   GIR_RootConstrainSelectedInstOperands,
     /* 339093 */   // GIR_Coverage, 5334,
     /* 339093 */   GIR_EraseRootFromParent_Done,
     /* 339094 */ // Label 6630: @339094
     /* 339094 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(339151), // Rule ID 5318 //
     /* 339099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 339117 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339123 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 339123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 339130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339135 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339149 */   GIR_RootConstrainSelectedInstOperands,
     /* 339150 */   // GIR_Coverage, 5318,
     /* 339150 */   GIR_EraseRootFromParent_Done,
     /* 339151 */ // Label 6631: @339151
     /* 339151 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(339181), // Rule ID 471 //
     /* 339156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339170 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 339170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 339175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339179 */   GIR_RootConstrainSelectedInstOperands,
     /* 339180 */   // GIR_Coverage, 471,
     /* 339180 */   GIR_Done,
     /* 339181 */ // Label 6632: @339181
     /* 339181 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(339211), // Rule ID 477 //
     /* 339186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339200 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 339200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 339205 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339209 */   GIR_RootConstrainSelectedInstOperands,
     /* 339210 */   // GIR_Coverage, 477,
     /* 339210 */   GIR_Done,
     /* 339211 */ // Label 6633: @339211
     /* 339211 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(339241), // Rule ID 501 //
     /* 339216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339230 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 339230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339239 */   GIR_RootConstrainSelectedInstOperands,
     /* 339240 */   // GIR_Coverage, 501,
     /* 339240 */   GIR_Done,
     /* 339241 */ // Label 6634: @339241
     /* 339241 */ GIM_Reject,
     /* 339242 */ // Label 6589: @339242
     /* 339242 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(339272), // Rule ID 1078 //
     /* 339247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339261 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 339261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 339266 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339270 */   GIR_RootConstrainSelectedInstOperands,
     /* 339271 */   // GIR_Coverage, 1078,
     /* 339271 */   GIR_Done,
     /* 339272 */ // Label 6635: @339272
     /* 339272 */ GIM_Reject,
     /* 339273 */ // Label 6590: @339273
     /* 339273 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(339303), // Rule ID 1082 //
     /* 339278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339292 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 339292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 339297 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339301 */   GIR_RootConstrainSelectedInstOperands,
     /* 339302 */   // GIR_Coverage, 1082,
     /* 339302 */   GIR_Done,
     /* 339303 */ // Label 6636: @339303
     /* 339303 */ GIM_Reject,
     /* 339304 */ // Label 6591: @339304
     /* 339304 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(339334), // Rule ID 1074 //
     /* 339309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 339312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339323 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 339323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 339328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339332 */   GIR_RootConstrainSelectedInstOperands,
     /* 339333 */   // GIR_Coverage, 1074,
     /* 339333 */   GIR_Done,
     /* 339334 */ // Label 6637: @339334
     /* 339334 */ GIM_Reject,
     /* 339335 */ // Label 6592: @339335
     /* 339335 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(339365), // Rule ID 1080 //
     /* 339340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339354 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 339354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 339359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339363 */   GIR_RootConstrainSelectedInstOperands,
     /* 339364 */   // GIR_Coverage, 1080,
     /* 339364 */   GIR_Done,
     /* 339365 */ // Label 6638: @339365
     /* 339365 */ GIM_Reject,
     /* 339366 */ // Label 6593: @339366
     /* 339366 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(339396), // Rule ID 1076 //
     /* 339371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 339374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339385 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 339385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 339390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339394 */   GIR_RootConstrainSelectedInstOperands,
     /* 339395 */   // GIR_Coverage, 1076,
     /* 339395 */   GIR_Done,
     /* 339396 */ // Label 6639: @339396
     /* 339396 */ GIM_Reject,
     /* 339397 */ // Label 6594: @339397
     /* 339397 */ GIM_Reject,
     /* 339398 */ // Label 71: @339398
     /* 339398 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6647*/ GIMT_Encode4(339717),
     /* 339409 */ /*GILLT_s32*//*Label 6640*/ GIMT_Encode4(339445),
     /* 339413 */ /*GILLT_s64*//*Label 6641*/ GIMT_Encode4(339518), GIMT_Encode4(0),
     /* 339421 */ /*GILLT_v2s32*//*Label 6642*/ GIMT_Encode4(339591),
     /* 339425 */ /*GILLT_v2s64*//*Label 6643*/ GIMT_Encode4(339615),
     /* 339429 */ /*GILLT_v4s16*//*Label 6644*/ GIMT_Encode4(339639),
     /* 339433 */ /*GILLT_v4s32*//*Label 6645*/ GIMT_Encode4(339666), GIMT_Encode4(0),
     /* 339441 */ /*GILLT_v8s16*//*Label 6646*/ GIMT_Encode4(339690),
     /* 339445 */ // Label 6640: @339445
     /* 339445 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(339471), // Rule ID 4616 //
     /* 339450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339460 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 339460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 339465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339469 */   GIR_RootConstrainSelectedInstOperands,
     /* 339470 */   // GIR_Coverage, 4616,
     /* 339470 */   GIR_Done,
     /* 339471 */ // Label 6648: @339471
     /* 339471 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(339494), // Rule ID 4618 //
     /* 339476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339483 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 339483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 339488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339492 */   GIR_RootConstrainSelectedInstOperands,
     /* 339493 */   // GIR_Coverage, 4618,
     /* 339493 */   GIR_Done,
     /* 339494 */ // Label 6649: @339494
     /* 339494 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(339517), // Rule ID 4620 //
     /* 339499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339506 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 339506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 339511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339515 */   GIR_RootConstrainSelectedInstOperands,
     /* 339516 */   // GIR_Coverage, 4620,
     /* 339516 */   GIR_Done,
     /* 339517 */ // Label 6650: @339517
     /* 339517 */ GIM_Reject,
     /* 339518 */ // Label 6641: @339518
     /* 339518 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(339544), // Rule ID 4617 //
     /* 339523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339533 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 339533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 339538 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339542 */   GIR_RootConstrainSelectedInstOperands,
     /* 339543 */   // GIR_Coverage, 4617,
     /* 339543 */   GIR_Done,
     /* 339544 */ // Label 6651: @339544
     /* 339544 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(339567), // Rule ID 4619 //
     /* 339549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339556 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 339556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 339561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339565 */   GIR_RootConstrainSelectedInstOperands,
     /* 339566 */   // GIR_Coverage, 4619,
     /* 339566 */   GIR_Done,
     /* 339567 */ // Label 6652: @339567
     /* 339567 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(339590), // Rule ID 4621 //
     /* 339572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339579 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 339579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 339584 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339588 */   GIR_RootConstrainSelectedInstOperands,
     /* 339589 */   // GIR_Coverage, 4621,
     /* 339589 */   GIR_Done,
     /* 339590 */ // Label 6653: @339590
     /* 339590 */ GIM_Reject,
     /* 339591 */ // Label 6642: @339591
     /* 339591 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(339614), // Rule ID 4957 //
     /* 339596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339603 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 339603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 339608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339612 */   GIR_RootConstrainSelectedInstOperands,
     /* 339613 */   // GIR_Coverage, 4957,
     /* 339613 */   GIR_Done,
     /* 339614 */ // Label 6654: @339614
     /* 339614 */ GIM_Reject,
     /* 339615 */ // Label 6643: @339615
     /* 339615 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(339638), // Rule ID 4959 //
     /* 339620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339627 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 339627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 339632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339636 */   GIR_RootConstrainSelectedInstOperands,
     /* 339637 */   // GIR_Coverage, 4959,
     /* 339637 */   GIR_Done,
     /* 339638 */ // Label 6655: @339638
     /* 339638 */ GIM_Reject,
     /* 339639 */ // Label 6644: @339639
     /* 339639 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(339665), // Rule ID 4952 //
     /* 339644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339654 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 339654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 339659 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339663 */   GIR_RootConstrainSelectedInstOperands,
     /* 339664 */   // GIR_Coverage, 4952,
     /* 339664 */   GIR_Done,
     /* 339665 */ // Label 6656: @339665
     /* 339665 */ GIM_Reject,
     /* 339666 */ // Label 6645: @339666
     /* 339666 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(339689), // Rule ID 4958 //
     /* 339671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339678 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 339678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 339683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339687 */   GIR_RootConstrainSelectedInstOperands,
     /* 339688 */   // GIR_Coverage, 4958,
     /* 339688 */   GIR_Done,
     /* 339689 */ // Label 6657: @339689
     /* 339689 */ GIM_Reject,
     /* 339690 */ // Label 6646: @339690
     /* 339690 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(339716), // Rule ID 4953 //
     /* 339695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339705 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 339705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 339710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339714 */   GIR_RootConstrainSelectedInstOperands,
     /* 339715 */   // GIR_Coverage, 4953,
     /* 339715 */   GIR_Done,
     /* 339716 */ // Label 6658: @339716
     /* 339716 */ GIM_Reject,
     /* 339717 */ // Label 6647: @339717
     /* 339717 */ GIM_Reject,
     /* 339718 */ // Label 72: @339718
     /* 339718 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6666*/ GIMT_Encode4(340037),
     /* 339729 */ /*GILLT_s32*//*Label 6659*/ GIMT_Encode4(339765),
     /* 339733 */ /*GILLT_s64*//*Label 6660*/ GIMT_Encode4(339838), GIMT_Encode4(0),
     /* 339741 */ /*GILLT_v2s32*//*Label 6661*/ GIMT_Encode4(339911),
     /* 339745 */ /*GILLT_v2s64*//*Label 6662*/ GIMT_Encode4(339935),
     /* 339749 */ /*GILLT_v4s16*//*Label 6663*/ GIMT_Encode4(339959),
     /* 339753 */ /*GILLT_v4s32*//*Label 6664*/ GIMT_Encode4(339986), GIMT_Encode4(0),
     /* 339761 */ /*GILLT_v8s16*//*Label 6665*/ GIMT_Encode4(340010),
     /* 339765 */ // Label 6659: @339765
     /* 339765 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(339791), // Rule ID 4640 //
     /* 339770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339780 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 339780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 339785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339789 */   GIR_RootConstrainSelectedInstOperands,
     /* 339790 */   // GIR_Coverage, 4640,
     /* 339790 */   GIR_Done,
     /* 339791 */ // Label 6667: @339791
     /* 339791 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(339814), // Rule ID 4642 //
     /* 339796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339803 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 339803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 339808 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339812 */   GIR_RootConstrainSelectedInstOperands,
     /* 339813 */   // GIR_Coverage, 4642,
     /* 339813 */   GIR_Done,
     /* 339814 */ // Label 6668: @339814
     /* 339814 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(339837), // Rule ID 4644 //
     /* 339819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339826 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 339826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 339831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339835 */   GIR_RootConstrainSelectedInstOperands,
     /* 339836 */   // GIR_Coverage, 4644,
     /* 339836 */   GIR_Done,
     /* 339837 */ // Label 6669: @339837
     /* 339837 */ GIM_Reject,
     /* 339838 */ // Label 6660: @339838
     /* 339838 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(339864), // Rule ID 4641 //
     /* 339843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 339849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339853 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 339853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 339858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339862 */   GIR_RootConstrainSelectedInstOperands,
     /* 339863 */   // GIR_Coverage, 4641,
     /* 339863 */   GIR_Done,
     /* 339864 */ // Label 6670: @339864
     /* 339864 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(339887), // Rule ID 4643 //
     /* 339869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339876 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 339876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 339881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339885 */   GIR_RootConstrainSelectedInstOperands,
     /* 339886 */   // GIR_Coverage, 4643,
     /* 339886 */   GIR_Done,
     /* 339887 */ // Label 6671: @339887
     /* 339887 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(339910), // Rule ID 4645 //
     /* 339892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339899 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 339899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 339904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339908 */   GIR_RootConstrainSelectedInstOperands,
     /* 339909 */   // GIR_Coverage, 4645,
     /* 339909 */   GIR_Done,
     /* 339910 */ // Label 6672: @339910
     /* 339910 */ GIM_Reject,
     /* 339911 */ // Label 6661: @339911
     /* 339911 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(339934), // Rule ID 4967 //
     /* 339916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 339919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339923 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 339923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 339928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339932 */   GIR_RootConstrainSelectedInstOperands,
     /* 339933 */   // GIR_Coverage, 4967,
     /* 339933 */   GIR_Done,
     /* 339934 */ // Label 6673: @339934
     /* 339934 */ GIM_Reject,
     /* 339935 */ // Label 6662: @339935
     /* 339935 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(339958), // Rule ID 4969 //
     /* 339940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339947 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 339947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 339952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339956 */   GIR_RootConstrainSelectedInstOperands,
     /* 339957 */   // GIR_Coverage, 4969,
     /* 339957 */   GIR_Done,
     /* 339958 */ // Label 6674: @339958
     /* 339958 */ GIM_Reject,
     /* 339959 */ // Label 6663: @339959
     /* 339959 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(339985), // Rule ID 4962 //
     /* 339964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 339967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339974 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 339974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 339979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339983 */   GIR_RootConstrainSelectedInstOperands,
     /* 339984 */   // GIR_Coverage, 4962,
     /* 339984 */   GIR_Done,
     /* 339985 */ // Label 6675: @339985
     /* 339985 */ GIM_Reject,
     /* 339986 */ // Label 6664: @339986
     /* 339986 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(340009), // Rule ID 4968 //
     /* 339991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339998 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 339998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 340003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340007 */   GIR_RootConstrainSelectedInstOperands,
     /* 340008 */   // GIR_Coverage, 4968,
     /* 340008 */   GIR_Done,
     /* 340009 */ // Label 6676: @340009
     /* 340009 */ GIM_Reject,
     /* 340010 */ // Label 6665: @340010
     /* 340010 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(340036), // Rule ID 4963 //
     /* 340015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340025 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 340030 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340034 */   GIR_RootConstrainSelectedInstOperands,
     /* 340035 */   // GIR_Coverage, 4963,
     /* 340035 */   GIR_Done,
     /* 340036 */ // Label 6677: @340036
     /* 340036 */ GIM_Reject,
     /* 340037 */ // Label 6666: @340037
     /* 340037 */ GIM_Reject,
     /* 340038 */ // Label 73: @340038
     /* 340038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6686*/ GIMT_Encode4(340894),
     /* 340049 */ /*GILLT_s16*//*Label 6678*/ GIMT_Encode4(340089),
     /* 340053 */ /*GILLT_s32*//*Label 6679*/ GIMT_Encode4(340308),
     /* 340057 */ /*GILLT_s64*//*Label 6680*/ GIMT_Encode4(340382), GIMT_Encode4(0),
     /* 340065 */ /*GILLT_v2s32*//*Label 6681*/ GIMT_Encode4(340456),
     /* 340069 */ /*GILLT_v2s64*//*Label 6682*/ GIMT_Encode4(340530),
     /* 340073 */ /*GILLT_v4s16*//*Label 6683*/ GIMT_Encode4(340604),
     /* 340077 */ /*GILLT_v4s32*//*Label 6684*/ GIMT_Encode4(340712), GIMT_Encode4(0),
     /* 340085 */ /*GILLT_v8s16*//*Label 6685*/ GIMT_Encode4(340786),
     /* 340089 */ // Label 6678: @340089
     /* 340089 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(340307),
     /* 340094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340101 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(340142), // Rule ID 5220 //
     /* 340106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340127 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 340127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 340130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340140 */     GIR_RootConstrainSelectedInstOperands,
     /* 340141 */     // GIR_Coverage, 5220,
     /* 340141 */     GIR_EraseRootFromParent_Done,
     /* 340142 */   // Label 6688: @340142
     /* 340142 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(340161), // Rule ID 521 //
     /* 340147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340154 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 340154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 340159 */     GIR_RootConstrainSelectedInstOperands,
     /* 340160 */     // GIR_Coverage, 521,
     /* 340160 */     GIR_Done,
     /* 340161 */   // Label 6689: @340161
     /* 340161 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(340306), // Rule ID 6404 //
     /* 340166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340170 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 340170 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 340173 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340177 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340184 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 340187 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340191 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340196 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340199 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340203 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 340206 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340211 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340216 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340221 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340224 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340228 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340233 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 340236 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340241 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 340244 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 340248 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340253 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340256 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 340261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340275 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340288 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 340295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340305 */     // GIR_Coverage, 6404,
     /* 340305 */     GIR_EraseRootFromParent_Done,
     /* 340306 */   // Label 6690: @340306
     /* 340306 */   GIM_Reject,
     /* 340307 */ // Label 6687: @340307
     /* 340307 */ GIM_Reject,
     /* 340308 */ // Label 6679: @340308
     /* 340308 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(340381),
     /* 340313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340320 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(340361), // Rule ID 5221 //
     /* 340325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 340340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 340344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340346 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 340346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 340349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340359 */     GIR_RootConstrainSelectedInstOperands,
     /* 340360 */     // GIR_Coverage, 5221,
     /* 340360 */     GIR_EraseRootFromParent_Done,
     /* 340361 */   // Label 6692: @340361
     /* 340361 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(340380), // Rule ID 522 //
     /* 340366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340373 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 340373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 340378 */     GIR_RootConstrainSelectedInstOperands,
     /* 340379 */     // GIR_Coverage, 522,
     /* 340379 */     GIR_Done,
     /* 340380 */   // Label 6693: @340380
     /* 340380 */   GIM_Reject,
     /* 340381 */ // Label 6691: @340381
     /* 340381 */ GIM_Reject,
     /* 340382 */ // Label 6680: @340382
     /* 340382 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(340455),
     /* 340387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340394 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(340435), // Rule ID 5222 //
     /* 340399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340420 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 340420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 340423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340433 */     GIR_RootConstrainSelectedInstOperands,
     /* 340434 */     // GIR_Coverage, 5222,
     /* 340434 */     GIR_EraseRootFromParent_Done,
     /* 340435 */   // Label 6695: @340435
     /* 340435 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(340454), // Rule ID 523 //
     /* 340440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340447 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 340447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 340452 */     GIR_RootConstrainSelectedInstOperands,
     /* 340453 */     // GIR_Coverage, 523,
     /* 340453 */     GIR_Done,
     /* 340454 */   // Label 6696: @340454
     /* 340454 */   GIM_Reject,
     /* 340455 */ // Label 6694: @340455
     /* 340455 */ GIM_Reject,
     /* 340456 */ // Label 6681: @340456
     /* 340456 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(340529),
     /* 340461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340468 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(340509), // Rule ID 5034 //
     /* 340473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 340492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340494 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 340494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 340497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340507 */     GIR_RootConstrainSelectedInstOperands,
     /* 340508 */     // GIR_Coverage, 5034,
     /* 340508 */     GIR_EraseRootFromParent_Done,
     /* 340509 */   // Label 6698: @340509
     /* 340509 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(340528), // Rule ID 768 //
     /* 340514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340521 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 340521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 340526 */     GIR_RootConstrainSelectedInstOperands,
     /* 340527 */     // GIR_Coverage, 768,
     /* 340527 */     GIR_Done,
     /* 340528 */   // Label 6699: @340528
     /* 340528 */   GIM_Reject,
     /* 340529 */ // Label 6697: @340529
     /* 340529 */ GIM_Reject,
     /* 340530 */ // Label 6682: @340530
     /* 340530 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(340603),
     /* 340535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340542 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(340583), // Rule ID 5036 //
     /* 340547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 340566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340568 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 340568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 340571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340581 */     GIR_RootConstrainSelectedInstOperands,
     /* 340582 */     // GIR_Coverage, 5036,
     /* 340582 */     GIR_EraseRootFromParent_Done,
     /* 340583 */   // Label 6701: @340583
     /* 340583 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(340602), // Rule ID 770 //
     /* 340588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340595 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 340595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 340600 */     GIR_RootConstrainSelectedInstOperands,
     /* 340601 */     // GIR_Coverage, 770,
     /* 340601 */     GIR_Done,
     /* 340602 */   // Label 6702: @340602
     /* 340602 */   GIM_Reject,
     /* 340603 */ // Label 6700: @340603
     /* 340603 */ GIM_Reject,
     /* 340604 */ // Label 6683: @340604
     /* 340604 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(340711),
     /* 340609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340616 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(340657), // Rule ID 5037 //
     /* 340621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 340640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340642 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 340642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 340645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340655 */     GIR_RootConstrainSelectedInstOperands,
     /* 340656 */     // GIR_Coverage, 5037,
     /* 340656 */     GIR_EraseRootFromParent_Done,
     /* 340657 */   // Label 6704: @340657
     /* 340657 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(340676), // Rule ID 766 //
     /* 340662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340669 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 340669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 340674 */     GIR_RootConstrainSelectedInstOperands,
     /* 340675 */     // GIR_Coverage, 766,
     /* 340675 */     GIR_Done,
     /* 340676 */   // Label 6705: @340676
     /* 340676 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(340710), // Rule ID 6406 //
     /* 340681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340688 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 340688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 340691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340695 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 340705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 340708 */     GIR_RootConstrainSelectedInstOperands,
     /* 340709 */     // GIR_Coverage, 6406,
     /* 340709 */     GIR_EraseRootFromParent_Done,
     /* 340710 */   // Label 6706: @340710
     /* 340710 */   GIM_Reject,
     /* 340711 */ // Label 6703: @340711
     /* 340711 */ GIM_Reject,
     /* 340712 */ // Label 6684: @340712
     /* 340712 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(340785),
     /* 340717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340724 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(340765), // Rule ID 5035 //
     /* 340729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 340748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340750 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 340750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 340753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340763 */     GIR_RootConstrainSelectedInstOperands,
     /* 340764 */     // GIR_Coverage, 5035,
     /* 340764 */     GIR_EraseRootFromParent_Done,
     /* 340765 */   // Label 6708: @340765
     /* 340765 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(340784), // Rule ID 769 //
     /* 340770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340777 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 340777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 340782 */     GIR_RootConstrainSelectedInstOperands,
     /* 340783 */     // GIR_Coverage, 769,
     /* 340783 */     GIR_Done,
     /* 340784 */   // Label 6709: @340784
     /* 340784 */   GIM_Reject,
     /* 340785 */ // Label 6707: @340785
     /* 340785 */ GIM_Reject,
     /* 340786 */ // Label 6685: @340786
     /* 340786 */ GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(340893),
     /* 340791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340798 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(340839), // Rule ID 5038 //
     /* 340803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 340814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 340822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340824 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 340824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 340827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 340837 */     GIR_RootConstrainSelectedInstOperands,
     /* 340838 */     // GIR_Coverage, 5038,
     /* 340838 */     GIR_EraseRootFromParent_Done,
     /* 340839 */   // Label 6711: @340839
     /* 340839 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(340858), // Rule ID 767 //
     /* 340844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340851 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 340851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 340856 */     GIR_RootConstrainSelectedInstOperands,
     /* 340857 */     // GIR_Coverage, 767,
     /* 340857 */     GIR_Done,
     /* 340858 */   // Label 6712: @340858
     /* 340858 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(340892), // Rule ID 6407 //
     /* 340863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340870 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 340870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 340873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340877 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 340887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 340890 */     GIR_RootConstrainSelectedInstOperands,
     /* 340891 */     // GIR_Coverage, 6407,
     /* 340891 */     GIR_EraseRootFromParent_Done,
     /* 340892 */   // Label 6713: @340892
     /* 340892 */   GIM_Reject,
     /* 340893 */ // Label 6710: @340893
     /* 340893 */ GIM_Reject,
     /* 340894 */ // Label 6686: @340894
     /* 340894 */ GIM_Reject,
     /* 340895 */ // Label 74: @340895
     /* 340895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6722*/ GIMT_Encode4(341176),
     /* 340906 */ /*GILLT_s16*//*Label 6714*/ GIMT_Encode4(340946),
     /* 340910 */ /*GILLT_s32*//*Label 6715*/ GIMT_Encode4(340973),
     /* 340914 */ /*GILLT_s64*//*Label 6716*/ GIMT_Encode4(340997), GIMT_Encode4(0),
     /* 340922 */ /*GILLT_v2s32*//*Label 6717*/ GIMT_Encode4(341021),
     /* 340926 */ /*GILLT_v2s64*//*Label 6718*/ GIMT_Encode4(341052),
     /* 340930 */ /*GILLT_v4s16*//*Label 6719*/ GIMT_Encode4(341083),
     /* 340934 */ /*GILLT_v4s32*//*Label 6720*/ GIMT_Encode4(341114), GIMT_Encode4(0),
     /* 340942 */ /*GILLT_v8s16*//*Label 6721*/ GIMT_Encode4(341145),
     /* 340946 */ // Label 6714: @340946
     /* 340946 */ GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(340972), // Rule ID 4856 //
     /* 340951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340961 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 340961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 340964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340966 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340968 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340970 */   GIR_RootConstrainSelectedInstOperands,
     /* 340971 */   // GIR_Coverage, 4856,
     /* 340971 */   GIR_EraseRootFromParent_Done,
     /* 340972 */ // Label 6723: @340972
     /* 340972 */ GIM_Reject,
     /* 340973 */ // Label 6715: @340973
     /* 340973 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(340996), // Rule ID 4853 //
     /* 340978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340985 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 340985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 340988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340990 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340992 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 340994 */   GIR_RootConstrainSelectedInstOperands,
     /* 340995 */   // GIR_Coverage, 4853,
     /* 340995 */   GIR_EraseRootFromParent_Done,
     /* 340996 */ // Label 6724: @340996
     /* 340996 */ GIM_Reject,
     /* 340997 */ // Label 6716: @340997
     /* 340997 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(341020), // Rule ID 4850 //
     /* 341002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341009 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 341009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341014 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341016 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341018 */   GIR_RootConstrainSelectedInstOperands,
     /* 341019 */   // GIR_Coverage, 4850,
     /* 341019 */   GIR_EraseRootFromParent_Done,
     /* 341020 */ // Label 6725: @341020
     /* 341020 */ GIM_Reject,
     /* 341021 */ // Label 6717: @341021
     /* 341021 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(341051), // Rule ID 5047 //
     /* 341026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341040 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 341040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341045 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341047 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341049 */   GIR_RootConstrainSelectedInstOperands,
     /* 341050 */   // GIR_Coverage, 5047,
     /* 341050 */   GIR_EraseRootFromParent_Done,
     /* 341051 */ // Label 6726: @341051
     /* 341051 */ GIM_Reject,
     /* 341052 */ // Label 6718: @341052
     /* 341052 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(341082), // Rule ID 5041 //
     /* 341057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341071 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 341071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341076 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341078 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341080 */   GIR_RootConstrainSelectedInstOperands,
     /* 341081 */   // GIR_Coverage, 5041,
     /* 341081 */   GIR_EraseRootFromParent_Done,
     /* 341082 */ // Label 6727: @341082
     /* 341082 */ GIM_Reject,
     /* 341083 */ // Label 6719: @341083
     /* 341083 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(341113), // Rule ID 5053 //
     /* 341088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341102 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 341102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 341105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341107 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341109 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341111 */   GIR_RootConstrainSelectedInstOperands,
     /* 341112 */   // GIR_Coverage, 5053,
     /* 341112 */   GIR_EraseRootFromParent_Done,
     /* 341113 */ // Label 6728: @341113
     /* 341113 */ GIM_Reject,
     /* 341114 */ // Label 6720: @341114
     /* 341114 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(341144), // Rule ID 5044 //
     /* 341119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341133 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 341133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 341136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341138 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341140 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341142 */   GIR_RootConstrainSelectedInstOperands,
     /* 341143 */   // GIR_Coverage, 5044,
     /* 341143 */   GIR_EraseRootFromParent_Done,
     /* 341144 */ // Label 6729: @341144
     /* 341144 */ GIM_Reject,
     /* 341145 */ // Label 6721: @341145
     /* 341145 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(341175), // Rule ID 5050 //
     /* 341150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341164 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 341164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 341167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341169 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341171 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341173 */   GIR_RootConstrainSelectedInstOperands,
     /* 341174 */   // GIR_Coverage, 5050,
     /* 341174 */   GIR_EraseRootFromParent_Done,
     /* 341175 */ // Label 6730: @341175
     /* 341175 */ GIM_Reject,
     /* 341176 */ // Label 6722: @341176
     /* 341176 */ GIM_Reject,
     /* 341177 */ // Label 75: @341177
     /* 341177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6739*/ GIMT_Encode4(341554),
     /* 341188 */ /*GILLT_s16*//*Label 6731*/ GIMT_Encode4(341228),
     /* 341192 */ /*GILLT_s32*//*Label 6732*/ GIMT_Encode4(341266),
     /* 341196 */ /*GILLT_s64*//*Label 6733*/ GIMT_Encode4(341304), GIMT_Encode4(0),
     /* 341204 */ /*GILLT_v2s32*//*Label 6734*/ GIMT_Encode4(341364),
     /* 341208 */ /*GILLT_v2s64*//*Label 6735*/ GIMT_Encode4(341402),
     /* 341212 */ /*GILLT_v4s16*//*Label 6736*/ GIMT_Encode4(341440),
     /* 341216 */ /*GILLT_v4s32*//*Label 6737*/ GIMT_Encode4(341478), GIMT_Encode4(0),
     /* 341224 */ /*GILLT_v8s16*//*Label 6738*/ GIMT_Encode4(341516),
     /* 341228 */ // Label 6731: @341228
     /* 341228 */ GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(341265), // Rule ID 608 //
     /* 341233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341254 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 341254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 341259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341263 */   GIR_RootConstrainSelectedInstOperands,
     /* 341264 */   // GIR_Coverage, 608,
     /* 341264 */   GIR_Done,
     /* 341265 */ // Label 6740: @341265
     /* 341265 */ GIM_Reject,
     /* 341266 */ // Label 6732: @341266
     /* 341266 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(341303), // Rule ID 610 //
     /* 341271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341292 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 341292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 341297 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341301 */   GIR_RootConstrainSelectedInstOperands,
     /* 341302 */   // GIR_Coverage, 610,
     /* 341302 */   GIR_Done,
     /* 341303 */ // Label 6741: @341303
     /* 341303 */ GIM_Reject,
     /* 341304 */ // Label 6733: @341304
     /* 341304 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(341363),
     /* 341309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 341315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341327 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(341346), // Rule ID 612 //
     /* 341332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341335 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 341335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341344 */     GIR_RootConstrainSelectedInstOperands,
     /* 341345 */     // GIR_Coverage, 612,
     /* 341345 */     GIR_Done,
     /* 341346 */   // Label 6743: @341346
     /* 341346 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(341362), // Rule ID 4847 //
     /* 341351 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 341351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341356 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341360 */     GIR_RootConstrainSelectedInstOperands,
     /* 341361 */     // GIR_Coverage, 4847,
     /* 341361 */     GIR_Done,
     /* 341362 */   // Label 6744: @341362
     /* 341362 */   GIM_Reject,
     /* 341363 */ // Label 6742: @341363
     /* 341363 */ GIM_Reject,
     /* 341364 */ // Label 6734: @341364
     /* 341364 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(341401), // Rule ID 1273 //
     /* 341369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341390 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 341390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341395 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341399 */   GIR_RootConstrainSelectedInstOperands,
     /* 341400 */   // GIR_Coverage, 1273,
     /* 341400 */   GIR_Done,
     /* 341401 */ // Label 6745: @341401
     /* 341401 */ GIM_Reject,
     /* 341402 */ // Label 6735: @341402
     /* 341402 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(341439), // Rule ID 1277 //
     /* 341407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341428 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 341428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341433 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341437 */   GIR_RootConstrainSelectedInstOperands,
     /* 341438 */   // GIR_Coverage, 1277,
     /* 341438 */   GIR_Done,
     /* 341439 */ // Label 6746: @341439
     /* 341439 */ GIM_Reject,
     /* 341440 */ // Label 6736: @341440
     /* 341440 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(341477), // Rule ID 1269 //
     /* 341445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341466 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 341466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 341471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341475 */   GIR_RootConstrainSelectedInstOperands,
     /* 341476 */   // GIR_Coverage, 1269,
     /* 341476 */   GIR_Done,
     /* 341477 */ // Label 6747: @341477
     /* 341477 */ GIM_Reject,
     /* 341478 */ // Label 6737: @341478
     /* 341478 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(341515), // Rule ID 1275 //
     /* 341483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341504 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 341504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 341509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341513 */   GIR_RootConstrainSelectedInstOperands,
     /* 341514 */   // GIR_Coverage, 1275,
     /* 341514 */   GIR_Done,
     /* 341515 */ // Label 6748: @341515
     /* 341515 */ GIM_Reject,
     /* 341516 */ // Label 6738: @341516
     /* 341516 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(341553), // Rule ID 1271 //
     /* 341521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341542 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 341542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 341547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341551 */   GIR_RootConstrainSelectedInstOperands,
     /* 341552 */   // GIR_Coverage, 1271,
     /* 341552 */   GIR_Done,
     /* 341553 */ // Label 6749: @341553
     /* 341553 */ GIM_Reject,
     /* 341554 */ // Label 6739: @341554
     /* 341554 */ GIM_Reject,
     /* 341555 */ // Label 76: @341555
     /* 341555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6758*/ GIMT_Encode4(341932),
     /* 341566 */ /*GILLT_s16*//*Label 6750*/ GIMT_Encode4(341606),
     /* 341570 */ /*GILLT_s32*//*Label 6751*/ GIMT_Encode4(341644),
     /* 341574 */ /*GILLT_s64*//*Label 6752*/ GIMT_Encode4(341682), GIMT_Encode4(0),
     /* 341582 */ /*GILLT_v2s32*//*Label 6753*/ GIMT_Encode4(341742),
     /* 341586 */ /*GILLT_v2s64*//*Label 6754*/ GIMT_Encode4(341780),
     /* 341590 */ /*GILLT_v4s16*//*Label 6755*/ GIMT_Encode4(341818),
     /* 341594 */ /*GILLT_v4s32*//*Label 6756*/ GIMT_Encode4(341856), GIMT_Encode4(0),
     /* 341602 */ /*GILLT_v8s16*//*Label 6757*/ GIMT_Encode4(341894),
     /* 341606 */ // Label 6750: @341606
     /* 341606 */ GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(341643), // Rule ID 596 //
     /* 341611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341632 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 341632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 341637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341641 */   GIR_RootConstrainSelectedInstOperands,
     /* 341642 */   // GIR_Coverage, 596,
     /* 341642 */   GIR_Done,
     /* 341643 */ // Label 6759: @341643
     /* 341643 */ GIM_Reject,
     /* 341644 */ // Label 6751: @341644
     /* 341644 */ GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(341681), // Rule ID 598 //
     /* 341649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341670 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 341670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 341675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341679 */   GIR_RootConstrainSelectedInstOperands,
     /* 341680 */   // GIR_Coverage, 598,
     /* 341680 */   GIR_Done,
     /* 341681 */ // Label 6760: @341681
     /* 341681 */ GIM_Reject,
     /* 341682 */ // Label 6752: @341682
     /* 341682 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(341741),
     /* 341687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 341693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341705 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(341724), // Rule ID 600 //
     /* 341710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341713 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 341713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 341718 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341722 */     GIR_RootConstrainSelectedInstOperands,
     /* 341723 */     // GIR_Coverage, 600,
     /* 341723 */     GIR_Done,
     /* 341724 */   // Label 6762: @341724
     /* 341724 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(341740), // Rule ID 4846 //
     /* 341729 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 341729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 341734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341738 */     GIR_RootConstrainSelectedInstOperands,
     /* 341739 */     // GIR_Coverage, 4846,
     /* 341739 */     GIR_Done,
     /* 341740 */   // Label 6763: @341740
     /* 341740 */   GIM_Reject,
     /* 341741 */ // Label 6761: @341741
     /* 341741 */ GIM_Reject,
     /* 341742 */ // Label 6753: @341742
     /* 341742 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(341779), // Rule ID 1243 //
     /* 341747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341768 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 341768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 341773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341777 */   GIR_RootConstrainSelectedInstOperands,
     /* 341778 */   // GIR_Coverage, 1243,
     /* 341778 */   GIR_Done,
     /* 341779 */ // Label 6764: @341779
     /* 341779 */ GIM_Reject,
     /* 341780 */ // Label 6754: @341780
     /* 341780 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(341817), // Rule ID 1247 //
     /* 341785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341806 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 341806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 341811 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341815 */   GIR_RootConstrainSelectedInstOperands,
     /* 341816 */   // GIR_Coverage, 1247,
     /* 341816 */   GIR_Done,
     /* 341817 */ // Label 6765: @341817
     /* 341817 */ GIM_Reject,
     /* 341818 */ // Label 6755: @341818
     /* 341818 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(341855), // Rule ID 1239 //
     /* 341823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341844 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 341844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 341849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341853 */   GIR_RootConstrainSelectedInstOperands,
     /* 341854 */   // GIR_Coverage, 1239,
     /* 341854 */   GIR_Done,
     /* 341855 */ // Label 6766: @341855
     /* 341855 */ GIM_Reject,
     /* 341856 */ // Label 6756: @341856
     /* 341856 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(341893), // Rule ID 1245 //
     /* 341861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341882 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 341882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 341887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341891 */   GIR_RootConstrainSelectedInstOperands,
     /* 341892 */   // GIR_Coverage, 1245,
     /* 341892 */   GIR_Done,
     /* 341893 */ // Label 6767: @341893
     /* 341893 */ GIM_Reject,
     /* 341894 */ // Label 6757: @341894
     /* 341894 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(341931), // Rule ID 1241 //
     /* 341899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341920 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 341920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 341925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341929 */   GIR_RootConstrainSelectedInstOperands,
     /* 341930 */   // GIR_Coverage, 1241,
     /* 341930 */   GIR_Done,
     /* 341931 */ // Label 6768: @341931
     /* 341931 */ GIM_Reject,
     /* 341932 */ // Label 6758: @341932
     /* 341932 */ GIM_Reject,
     /* 341933 */ // Label 77: @341933
     /* 341933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6777*/ GIMT_Encode4(342282),
     /* 341944 */ /*GILLT_s16*//*Label 6769*/ GIMT_Encode4(341984),
     /* 341948 */ /*GILLT_s32*//*Label 6770*/ GIMT_Encode4(342022),
     /* 341952 */ /*GILLT_s64*//*Label 6771*/ GIMT_Encode4(342057), GIMT_Encode4(0),
     /* 341960 */ /*GILLT_v2s32*//*Label 6772*/ GIMT_Encode4(342092),
     /* 341964 */ /*GILLT_v2s64*//*Label 6773*/ GIMT_Encode4(342130),
     /* 341968 */ /*GILLT_v4s16*//*Label 6774*/ GIMT_Encode4(342168),
     /* 341972 */ /*GILLT_v4s32*//*Label 6775*/ GIMT_Encode4(342206), GIMT_Encode4(0),
     /* 341980 */ /*GILLT_v8s16*//*Label 6776*/ GIMT_Encode4(342244),
     /* 341984 */ // Label 6769: @341984
     /* 341984 */ GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(342021), // Rule ID 4854 //
     /* 341989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342010 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 342010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342015 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342019 */   GIR_RootConstrainSelectedInstOperands,
     /* 342020 */   // GIR_Coverage, 4854,
     /* 342020 */   GIR_Done,
     /* 342021 */ // Label 6778: @342021
     /* 342021 */ GIM_Reject,
     /* 342022 */ // Label 6770: @342022
     /* 342022 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(342056), // Rule ID 4851 //
     /* 342027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342045 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342054 */   GIR_RootConstrainSelectedInstOperands,
     /* 342055 */   // GIR_Coverage, 4851,
     /* 342055 */   GIR_Done,
     /* 342056 */ // Label 6779: @342056
     /* 342056 */ GIM_Reject,
     /* 342057 */ // Label 6771: @342057
     /* 342057 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(342091), // Rule ID 4848 //
     /* 342062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342080 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342085 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342089 */   GIR_RootConstrainSelectedInstOperands,
     /* 342090 */   // GIR_Coverage, 4848,
     /* 342090 */   GIR_Done,
     /* 342091 */ // Label 6780: @342091
     /* 342091 */ GIM_Reject,
     /* 342092 */ // Label 6772: @342092
     /* 342092 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(342129), // Rule ID 5045 //
     /* 342097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342118 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342127 */   GIR_RootConstrainSelectedInstOperands,
     /* 342128 */   // GIR_Coverage, 5045,
     /* 342128 */   GIR_Done,
     /* 342129 */ // Label 6781: @342129
     /* 342129 */ GIM_Reject,
     /* 342130 */ // Label 6773: @342130
     /* 342130 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(342167), // Rule ID 5039 //
     /* 342135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342156 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342165 */   GIR_RootConstrainSelectedInstOperands,
     /* 342166 */   // GIR_Coverage, 5039,
     /* 342166 */   GIR_Done,
     /* 342167 */ // Label 6782: @342167
     /* 342167 */ GIM_Reject,
     /* 342168 */ // Label 6774: @342168
     /* 342168 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(342205), // Rule ID 5051 //
     /* 342173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342194 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342203 */   GIR_RootConstrainSelectedInstOperands,
     /* 342204 */   // GIR_Coverage, 5051,
     /* 342204 */   GIR_Done,
     /* 342205 */ // Label 6783: @342205
     /* 342205 */ GIM_Reject,
     /* 342206 */ // Label 6775: @342206
     /* 342206 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(342243), // Rule ID 5042 //
     /* 342211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342232 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342241 */   GIR_RootConstrainSelectedInstOperands,
     /* 342242 */   // GIR_Coverage, 5042,
     /* 342242 */   GIR_Done,
     /* 342243 */ // Label 6784: @342243
     /* 342243 */ GIM_Reject,
     /* 342244 */ // Label 6776: @342244
     /* 342244 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(342281), // Rule ID 5048 //
     /* 342249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342270 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342279 */   GIR_RootConstrainSelectedInstOperands,
     /* 342280 */   // GIR_Coverage, 5048,
     /* 342280 */   GIR_Done,
     /* 342281 */ // Label 6785: @342281
     /* 342281 */ GIM_Reject,
     /* 342282 */ // Label 6777: @342282
     /* 342282 */ GIM_Reject,
     /* 342283 */ // Label 78: @342283
     /* 342283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6794*/ GIMT_Encode4(342632),
     /* 342294 */ /*GILLT_s16*//*Label 6786*/ GIMT_Encode4(342334),
     /* 342298 */ /*GILLT_s32*//*Label 6787*/ GIMT_Encode4(342372),
     /* 342302 */ /*GILLT_s64*//*Label 6788*/ GIMT_Encode4(342407), GIMT_Encode4(0),
     /* 342310 */ /*GILLT_v2s32*//*Label 6789*/ GIMT_Encode4(342442),
     /* 342314 */ /*GILLT_v2s64*//*Label 6790*/ GIMT_Encode4(342480),
     /* 342318 */ /*GILLT_v4s16*//*Label 6791*/ GIMT_Encode4(342518),
     /* 342322 */ /*GILLT_v4s32*//*Label 6792*/ GIMT_Encode4(342556), GIMT_Encode4(0),
     /* 342330 */ /*GILLT_v8s16*//*Label 6793*/ GIMT_Encode4(342594),
     /* 342334 */ // Label 6786: @342334
     /* 342334 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(342371), // Rule ID 4855 //
     /* 342339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342360 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 342360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 342365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342369 */   GIR_RootConstrainSelectedInstOperands,
     /* 342370 */   // GIR_Coverage, 4855,
     /* 342370 */   GIR_Done,
     /* 342371 */ // Label 6795: @342371
     /* 342371 */ GIM_Reject,
     /* 342372 */ // Label 6787: @342372
     /* 342372 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(342406), // Rule ID 4852 //
     /* 342377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342395 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 342400 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342404 */   GIR_RootConstrainSelectedInstOperands,
     /* 342405 */   // GIR_Coverage, 4852,
     /* 342405 */   GIR_Done,
     /* 342406 */ // Label 6796: @342406
     /* 342406 */ GIM_Reject,
     /* 342407 */ // Label 6788: @342407
     /* 342407 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(342441), // Rule ID 4849 //
     /* 342412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342430 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342439 */   GIR_RootConstrainSelectedInstOperands,
     /* 342440 */   // GIR_Coverage, 4849,
     /* 342440 */   GIR_Done,
     /* 342441 */ // Label 6797: @342441
     /* 342441 */ GIM_Reject,
     /* 342442 */ // Label 6789: @342442
     /* 342442 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(342479), // Rule ID 5046 //
     /* 342447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342468 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 342473 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342477 */   GIR_RootConstrainSelectedInstOperands,
     /* 342478 */   // GIR_Coverage, 5046,
     /* 342478 */   GIR_Done,
     /* 342479 */ // Label 6798: @342479
     /* 342479 */ GIM_Reject,
     /* 342480 */ // Label 6790: @342480
     /* 342480 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(342517), // Rule ID 5040 //
     /* 342485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342506 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 342511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342515 */   GIR_RootConstrainSelectedInstOperands,
     /* 342516 */   // GIR_Coverage, 5040,
     /* 342516 */   GIR_Done,
     /* 342517 */ // Label 6799: @342517
     /* 342517 */ GIM_Reject,
     /* 342518 */ // Label 6791: @342518
     /* 342518 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(342555), // Rule ID 5052 //
     /* 342523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342544 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 342549 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342553 */   GIR_RootConstrainSelectedInstOperands,
     /* 342554 */   // GIR_Coverage, 5052,
     /* 342554 */   GIR_Done,
     /* 342555 */ // Label 6800: @342555
     /* 342555 */ GIM_Reject,
     /* 342556 */ // Label 6792: @342556
     /* 342556 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(342593), // Rule ID 5043 //
     /* 342561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342582 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 342587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342591 */   GIR_RootConstrainSelectedInstOperands,
     /* 342592 */   // GIR_Coverage, 5043,
     /* 342592 */   GIR_Done,
     /* 342593 */ // Label 6801: @342593
     /* 342593 */ GIM_Reject,
     /* 342594 */ // Label 6793: @342594
     /* 342594 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(342631), // Rule ID 5049 //
     /* 342599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342620 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 342625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342629 */   GIR_RootConstrainSelectedInstOperands,
     /* 342630 */   // GIR_Coverage, 5049,
     /* 342630 */   GIR_Done,
     /* 342631 */ // Label 6802: @342631
     /* 342631 */ GIM_Reject,
     /* 342632 */ // Label 6794: @342632
     /* 342632 */ GIM_Reject,
     /* 342633 */ // Label 79: @342633
     /* 342633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6811*/ GIMT_Encode4(343335),
     /* 342644 */ /*GILLT_s16*//*Label 6803*/ GIMT_Encode4(342684),
     /* 342648 */ /*GILLT_s32*//*Label 6804*/ GIMT_Encode4(342722),
     /* 342652 */ /*GILLT_s64*//*Label 6805*/ GIMT_Encode4(342760), GIMT_Encode4(0),
     /* 342660 */ /*GILLT_v2s32*//*Label 6806*/ GIMT_Encode4(342820),
     /* 342664 */ /*GILLT_v2s64*//*Label 6807*/ GIMT_Encode4(342923),
     /* 342668 */ /*GILLT_v4s16*//*Label 6808*/ GIMT_Encode4(343026),
     /* 342672 */ /*GILLT_v4s32*//*Label 6809*/ GIMT_Encode4(343129), GIMT_Encode4(0),
     /* 342680 */ /*GILLT_v8s16*//*Label 6810*/ GIMT_Encode4(343232),
     /* 342684 */ // Label 6803: @342684
     /* 342684 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(342721), // Rule ID 614 //
     /* 342689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342710 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 342715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342719 */   GIR_RootConstrainSelectedInstOperands,
     /* 342720 */   // GIR_Coverage, 614,
     /* 342720 */   GIR_Done,
     /* 342721 */ // Label 6812: @342721
     /* 342721 */ GIM_Reject,
     /* 342722 */ // Label 6804: @342722
     /* 342722 */ GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(342759), // Rule ID 616 //
     /* 342727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342748 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 342753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342757 */   GIR_RootConstrainSelectedInstOperands,
     /* 342758 */   // GIR_Coverage, 616,
     /* 342758 */   GIR_Done,
     /* 342759 */ // Label 6813: @342759
     /* 342759 */ GIM_Reject,
     /* 342760 */ // Label 6805: @342760
     /* 342760 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(342819),
     /* 342765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342783 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(342802), // Rule ID 618 //
     /* 342788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342791 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 342796 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342800 */     GIR_RootConstrainSelectedInstOperands,
     /* 342801 */     // GIR_Coverage, 618,
     /* 342801 */     GIR_Done,
     /* 342802 */   // Label 6815: @342802
     /* 342802 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(342818), // Rule ID 4845 //
     /* 342807 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 342812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342816 */     GIR_RootConstrainSelectedInstOperands,
     /* 342817 */     // GIR_Coverage, 4845,
     /* 342817 */     GIR_Done,
     /* 342818 */   // Label 6816: @342818
     /* 342818 */   GIM_Reject,
     /* 342819 */ // Label 6814: @342819
     /* 342819 */ GIM_Reject,
     /* 342820 */ // Label 6806: @342820
     /* 342820 */ GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(342922),
     /* 342825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342835 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(342894), // Rule ID 2366 //
     /* 342840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 342843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342879 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 342882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 342892 */     GIR_RootConstrainSelectedInstOperands,
     /* 342893 */     // GIR_Coverage, 2366,
     /* 342893 */     GIR_EraseRootFromParent_Done,
     /* 342894 */   // Label 6818: @342894
     /* 342894 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(342921), // Rule ID 1288 //
     /* 342899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342910 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 342915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342919 */     GIR_RootConstrainSelectedInstOperands,
     /* 342920 */     // GIR_Coverage, 1288,
     /* 342920 */     GIR_Done,
     /* 342921 */   // Label 6819: @342921
     /* 342921 */   GIM_Reject,
     /* 342922 */ // Label 6817: @342922
     /* 342922 */ GIM_Reject,
     /* 342923 */ // Label 6807: @342923
     /* 342923 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(343025),
     /* 342928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342938 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(342997), // Rule ID 2372 //
     /* 342943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 342946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 342971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342982 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 342985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 342995 */     GIR_RootConstrainSelectedInstOperands,
     /* 342996 */     // GIR_Coverage, 2372,
     /* 342996 */     GIR_EraseRootFromParent_Done,
     /* 342997 */   // Label 6821: @342997
     /* 342997 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(343024), // Rule ID 1292 //
     /* 343002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343013 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 343018 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343022 */     GIR_RootConstrainSelectedInstOperands,
     /* 343023 */     // GIR_Coverage, 1292,
     /* 343023 */     GIR_Done,
     /* 343024 */   // Label 6822: @343024
     /* 343024 */   GIM_Reject,
     /* 343025 */ // Label 6820: @343025
     /* 343025 */ GIM_Reject,
     /* 343026 */ // Label 6808: @343026
     /* 343026 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(343128),
     /* 343031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343041 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(343100), // Rule ID 2360 //
     /* 343046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343085 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 343088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343098 */     GIR_RootConstrainSelectedInstOperands,
     /* 343099 */     // GIR_Coverage, 2360,
     /* 343099 */     GIR_EraseRootFromParent_Done,
     /* 343100 */   // Label 6824: @343100
     /* 343100 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(343127), // Rule ID 1284 //
     /* 343105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343116 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 343121 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343125 */     GIR_RootConstrainSelectedInstOperands,
     /* 343126 */     // GIR_Coverage, 1284,
     /* 343126 */     GIR_Done,
     /* 343127 */   // Label 6825: @343127
     /* 343127 */   GIM_Reject,
     /* 343128 */ // Label 6823: @343128
     /* 343128 */ GIM_Reject,
     /* 343129 */ // Label 6809: @343129
     /* 343129 */ GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(343231),
     /* 343134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343144 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(343203), // Rule ID 2369 //
     /* 343149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343188 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 343191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343201 */     GIR_RootConstrainSelectedInstOperands,
     /* 343202 */     // GIR_Coverage, 2369,
     /* 343202 */     GIR_EraseRootFromParent_Done,
     /* 343203 */   // Label 6827: @343203
     /* 343203 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(343230), // Rule ID 1290 //
     /* 343208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343219 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 343224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343228 */     GIR_RootConstrainSelectedInstOperands,
     /* 343229 */     // GIR_Coverage, 1290,
     /* 343229 */     GIR_Done,
     /* 343230 */   // Label 6828: @343230
     /* 343230 */   GIM_Reject,
     /* 343231 */ // Label 6826: @343231
     /* 343231 */ GIM_Reject,
     /* 343232 */ // Label 6810: @343232
     /* 343232 */ GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(343334),
     /* 343237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343247 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(343306), // Rule ID 2363 //
     /* 343252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343291 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 343294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343304 */     GIR_RootConstrainSelectedInstOperands,
     /* 343305 */     // GIR_Coverage, 2363,
     /* 343305 */     GIR_EraseRootFromParent_Done,
     /* 343306 */   // Label 6830: @343306
     /* 343306 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(343333), // Rule ID 1286 //
     /* 343311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343322 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 343327 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343331 */     GIR_RootConstrainSelectedInstOperands,
     /* 343332 */     // GIR_Coverage, 1286,
     /* 343332 */     GIR_Done,
     /* 343333 */   // Label 6831: @343333
     /* 343333 */   GIM_Reject,
     /* 343334 */ // Label 6829: @343334
     /* 343334 */ GIM_Reject,
     /* 343335 */ // Label 6811: @343335
     /* 343335 */ GIM_Reject,
     /* 343336 */ // Label 80: @343336
     /* 343336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6840*/ GIMT_Encode4(344038),
     /* 343347 */ /*GILLT_s16*//*Label 6832*/ GIMT_Encode4(343387),
     /* 343351 */ /*GILLT_s32*//*Label 6833*/ GIMT_Encode4(343425),
     /* 343355 */ /*GILLT_s64*//*Label 6834*/ GIMT_Encode4(343463), GIMT_Encode4(0),
     /* 343363 */ /*GILLT_v2s32*//*Label 6835*/ GIMT_Encode4(343523),
     /* 343367 */ /*GILLT_v2s64*//*Label 6836*/ GIMT_Encode4(343626),
     /* 343371 */ /*GILLT_v4s16*//*Label 6837*/ GIMT_Encode4(343729),
     /* 343375 */ /*GILLT_v4s32*//*Label 6838*/ GIMT_Encode4(343832), GIMT_Encode4(0),
     /* 343383 */ /*GILLT_v8s16*//*Label 6839*/ GIMT_Encode4(343935),
     /* 343387 */ // Label 6832: @343387
     /* 343387 */ GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(343424), // Rule ID 602 //
     /* 343392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343413 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 343418 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343422 */   GIR_RootConstrainSelectedInstOperands,
     /* 343423 */   // GIR_Coverage, 602,
     /* 343423 */   GIR_Done,
     /* 343424 */ // Label 6841: @343424
     /* 343424 */ GIM_Reject,
     /* 343425 */ // Label 6833: @343425
     /* 343425 */ GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(343462), // Rule ID 604 //
     /* 343430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343451 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 343456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343460 */   GIR_RootConstrainSelectedInstOperands,
     /* 343461 */   // GIR_Coverage, 604,
     /* 343461 */   GIR_Done,
     /* 343462 */ // Label 6842: @343462
     /* 343462 */ GIM_Reject,
     /* 343463 */ // Label 6834: @343463
     /* 343463 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(343522),
     /* 343468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343486 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(343505), // Rule ID 606 //
     /* 343491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343494 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 343499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343503 */     GIR_RootConstrainSelectedInstOperands,
     /* 343504 */     // GIR_Coverage, 606,
     /* 343504 */     GIR_Done,
     /* 343505 */   // Label 6844: @343505
     /* 343505 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(343521), // Rule ID 4844 //
     /* 343510 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 343515 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343519 */     GIR_RootConstrainSelectedInstOperands,
     /* 343520 */     // GIR_Coverage, 4844,
     /* 343520 */     GIR_Done,
     /* 343521 */   // Label 6845: @343521
     /* 343521 */   GIM_Reject,
     /* 343522 */ // Label 6843: @343522
     /* 343522 */ GIM_Reject,
     /* 343523 */ // Label 6835: @343523
     /* 343523 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(343625),
     /* 343528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343538 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(343597), // Rule ID 2351 //
     /* 343543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343582 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 343585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343595 */     GIR_RootConstrainSelectedInstOperands,
     /* 343596 */     // GIR_Coverage, 2351,
     /* 343596 */     GIR_EraseRootFromParent_Done,
     /* 343597 */   // Label 6847: @343597
     /* 343597 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(343624), // Rule ID 1258 //
     /* 343602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343613 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 343618 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343622 */     GIR_RootConstrainSelectedInstOperands,
     /* 343623 */     // GIR_Coverage, 1258,
     /* 343623 */     GIR_Done,
     /* 343624 */   // Label 6848: @343624
     /* 343624 */   GIM_Reject,
     /* 343625 */ // Label 6846: @343625
     /* 343625 */ GIM_Reject,
     /* 343626 */ // Label 6836: @343626
     /* 343626 */ GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(343728),
     /* 343631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343641 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(343700), // Rule ID 2357 //
     /* 343646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343685 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 343688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343698 */     GIR_RootConstrainSelectedInstOperands,
     /* 343699 */     // GIR_Coverage, 2357,
     /* 343699 */     GIR_EraseRootFromParent_Done,
     /* 343700 */   // Label 6850: @343700
     /* 343700 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(343727), // Rule ID 1262 //
     /* 343705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343716 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 343721 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343725 */     GIR_RootConstrainSelectedInstOperands,
     /* 343726 */     // GIR_Coverage, 1262,
     /* 343726 */     GIR_Done,
     /* 343727 */   // Label 6851: @343727
     /* 343727 */   GIM_Reject,
     /* 343728 */ // Label 6849: @343728
     /* 343728 */ GIM_Reject,
     /* 343729 */ // Label 6837: @343729
     /* 343729 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(343831),
     /* 343734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343744 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(343803), // Rule ID 2345 //
     /* 343749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343788 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 343791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343801 */     GIR_RootConstrainSelectedInstOperands,
     /* 343802 */     // GIR_Coverage, 2345,
     /* 343802 */     GIR_EraseRootFromParent_Done,
     /* 343803 */   // Label 6853: @343803
     /* 343803 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(343830), // Rule ID 1254 //
     /* 343808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343819 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 343824 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343828 */     GIR_RootConstrainSelectedInstOperands,
     /* 343829 */     // GIR_Coverage, 1254,
     /* 343829 */     GIR_Done,
     /* 343830 */   // Label 6854: @343830
     /* 343830 */   GIM_Reject,
     /* 343831 */ // Label 6852: @343831
     /* 343831 */ GIM_Reject,
     /* 343832 */ // Label 6838: @343832
     /* 343832 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(343934),
     /* 343837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343847 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(343906), // Rule ID 2354 //
     /* 343852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343891 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 343894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343904 */     GIR_RootConstrainSelectedInstOperands,
     /* 343905 */     // GIR_Coverage, 2354,
     /* 343905 */     GIR_EraseRootFromParent_Done,
     /* 343906 */   // Label 6856: @343906
     /* 343906 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(343933), // Rule ID 1260 //
     /* 343911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343922 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 343927 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343931 */     GIR_RootConstrainSelectedInstOperands,
     /* 343932 */     // GIR_Coverage, 1260,
     /* 343932 */     GIR_Done,
     /* 343933 */   // Label 6857: @343933
     /* 343933 */   GIM_Reject,
     /* 343934 */ // Label 6855: @343934
     /* 343934 */ GIM_Reject,
     /* 343935 */ // Label 6839: @343935
     /* 343935 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(344037),
     /* 343940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343950 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(344009), // Rule ID 2348 //
     /* 343955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343994 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 343997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344007 */     GIR_RootConstrainSelectedInstOperands,
     /* 344008 */     // GIR_Coverage, 2348,
     /* 344008 */     GIR_EraseRootFromParent_Done,
     /* 344009 */   // Label 6859: @344009
     /* 344009 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(344036), // Rule ID 1256 //
     /* 344014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344025 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 344030 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344034 */     GIR_RootConstrainSelectedInstOperands,
     /* 344035 */     // GIR_Coverage, 1256,
     /* 344035 */     GIR_Done,
     /* 344036 */   // Label 6860: @344036
     /* 344036 */   GIM_Reject,
     /* 344037 */ // Label 6858: @344037
     /* 344037 */ GIM_Reject,
     /* 344038 */ // Label 6840: @344038
     /* 344038 */ GIM_Reject,
     /* 344039 */ // Label 81: @344039
     /* 344039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6869*/ GIMT_Encode4(344442),
     /* 344050 */ /*GILLT_s32*//*Label 6861*/ GIMT_Encode4(344090),
     /* 344054 */ /*GILLT_s64*//*Label 6862*/ GIMT_Encode4(344164), GIMT_Encode4(0),
     /* 344062 */ /*GILLT_v2s32*//*Label 6863*/ GIMT_Encode4(344238), GIMT_Encode4(0),
     /* 344070 */ /*GILLT_v4s16*//*Label 6864*/ GIMT_Encode4(344272),
     /* 344074 */ /*GILLT_v4s32*//*Label 6865*/ GIMT_Encode4(344306),
     /* 344078 */ /*GILLT_v8s8*//*Label 6866*/ GIMT_Encode4(344340),
     /* 344082 */ /*GILLT_v8s16*//*Label 6867*/ GIMT_Encode4(344374),
     /* 344086 */ /*GILLT_v16s8*//*Label 6868*/ GIMT_Encode4(344408),
     /* 344090 */ // Label 6861: @344090
     /* 344090 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(344163),
     /* 344095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344109 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(344143), // Rule ID 2328 //
     /* 344114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 344129 */     // MIs[1] Operand 1
     /* 344129 */     // No operand predicates
     /* 344129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344131 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 344134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344141 */     GIR_RootConstrainSelectedInstOperands,
     /* 344142 */     // GIR_Coverage, 2328,
     /* 344142 */     GIR_EraseRootFromParent_Done,
     /* 344143 */   // Label 6871: @344143
     /* 344143 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(344162), // Rule ID 2327 //
     /* 344148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344155 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 344160 */     GIR_RootConstrainSelectedInstOperands,
     /* 344161 */     // GIR_Coverage, 2327,
     /* 344161 */     GIR_Done,
     /* 344162 */   // Label 6872: @344162
     /* 344162 */   GIM_Reject,
     /* 344163 */ // Label 6870: @344163
     /* 344163 */ GIM_Reject,
     /* 344164 */ // Label 6862: @344164
     /* 344164 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(344237),
     /* 344169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344183 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(344217), // Rule ID 2330 //
     /* 344188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 344203 */     // MIs[1] Operand 1
     /* 344203 */     // No operand predicates
     /* 344203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344205 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 344205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 344208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344215 */     GIR_RootConstrainSelectedInstOperands,
     /* 344216 */     // GIR_Coverage, 2330,
     /* 344216 */     GIR_EraseRootFromParent_Done,
     /* 344217 */   // Label 6874: @344217
     /* 344217 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(344236), // Rule ID 2329 //
     /* 344222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344229 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 344229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 344234 */     GIR_RootConstrainSelectedInstOperands,
     /* 344235 */     // GIR_Coverage, 2329,
     /* 344235 */     GIR_Done,
     /* 344236 */   // Label 6875: @344236
     /* 344236 */   GIM_Reject,
     /* 344237 */ // Label 6873: @344237
     /* 344237 */ GIM_Reject,
     /* 344238 */ // Label 6863: @344238
     /* 344238 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(344271), // Rule ID 1414 //
     /* 344243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344264 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 344264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 344269 */   GIR_RootConstrainSelectedInstOperands,
     /* 344270 */   // GIR_Coverage, 1414,
     /* 344270 */   GIR_Done,
     /* 344271 */ // Label 6876: @344271
     /* 344271 */ GIM_Reject,
     /* 344272 */ // Label 6864: @344272
     /* 344272 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(344305), // Rule ID 1412 //
     /* 344277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344298 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 344298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 344303 */   GIR_RootConstrainSelectedInstOperands,
     /* 344304 */   // GIR_Coverage, 1412,
     /* 344304 */   GIR_Done,
     /* 344305 */ // Label 6877: @344305
     /* 344305 */ GIM_Reject,
     /* 344306 */ // Label 6865: @344306
     /* 344306 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(344339), // Rule ID 1415 //
     /* 344311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344332 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 344332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 344337 */   GIR_RootConstrainSelectedInstOperands,
     /* 344338 */   // GIR_Coverage, 1415,
     /* 344338 */   GIR_Done,
     /* 344339 */ // Label 6878: @344339
     /* 344339 */ GIM_Reject,
     /* 344340 */ // Label 6866: @344340
     /* 344340 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(344373), // Rule ID 1410 //
     /* 344345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 344354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344366 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 344366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 344371 */   GIR_RootConstrainSelectedInstOperands,
     /* 344372 */   // GIR_Coverage, 1410,
     /* 344372 */   GIR_Done,
     /* 344373 */ // Label 6879: @344373
     /* 344373 */ GIM_Reject,
     /* 344374 */ // Label 6867: @344374
     /* 344374 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(344407), // Rule ID 1413 //
     /* 344379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344400 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 344400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 344405 */   GIR_RootConstrainSelectedInstOperands,
     /* 344406 */   // GIR_Coverage, 1413,
     /* 344406 */   GIR_Done,
     /* 344407 */ // Label 6880: @344407
     /* 344407 */ GIM_Reject,
     /* 344408 */ // Label 6868: @344408
     /* 344408 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(344441), // Rule ID 1411 //
     /* 344413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 344422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344434 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 344434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 344439 */   GIR_RootConstrainSelectedInstOperands,
     /* 344440 */   // GIR_Coverage, 1411,
     /* 344440 */   GIR_Done,
     /* 344441 */ // Label 6881: @344441
     /* 344441 */ GIM_Reject,
     /* 344442 */ // Label 6869: @344442
     /* 344442 */ GIM_Reject,
     /* 344443 */ // Label 82: @344443
     /* 344443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6890*/ GIMT_Encode4(344846),
     /* 344454 */ /*GILLT_s32*//*Label 6882*/ GIMT_Encode4(344494),
     /* 344458 */ /*GILLT_s64*//*Label 6883*/ GIMT_Encode4(344568), GIMT_Encode4(0),
     /* 344466 */ /*GILLT_v2s32*//*Label 6884*/ GIMT_Encode4(344642), GIMT_Encode4(0),
     /* 344474 */ /*GILLT_v4s16*//*Label 6885*/ GIMT_Encode4(344676),
     /* 344478 */ /*GILLT_v4s32*//*Label 6886*/ GIMT_Encode4(344710),
     /* 344482 */ /*GILLT_v8s8*//*Label 6887*/ GIMT_Encode4(344744),
     /* 344486 */ /*GILLT_v8s16*//*Label 6888*/ GIMT_Encode4(344778),
     /* 344490 */ /*GILLT_v16s8*//*Label 6889*/ GIMT_Encode4(344812),
     /* 344494 */ // Label 6882: @344494
     /* 344494 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(344567),
     /* 344499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344513 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(344547), // Rule ID 2324 //
     /* 344518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 344533 */     // MIs[1] Operand 1
     /* 344533 */     // No operand predicates
     /* 344533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344535 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 344538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344545 */     GIR_RootConstrainSelectedInstOperands,
     /* 344546 */     // GIR_Coverage, 2324,
     /* 344546 */     GIR_EraseRootFromParent_Done,
     /* 344547 */   // Label 6892: @344547
     /* 344547 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(344566), // Rule ID 2323 //
     /* 344552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344559 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 344564 */     GIR_RootConstrainSelectedInstOperands,
     /* 344565 */     // GIR_Coverage, 2323,
     /* 344565 */     GIR_Done,
     /* 344566 */   // Label 6893: @344566
     /* 344566 */   GIM_Reject,
     /* 344567 */ // Label 6891: @344567
     /* 344567 */ GIM_Reject,
     /* 344568 */ // Label 6883: @344568
     /* 344568 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(344641),
     /* 344573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344587 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(344621), // Rule ID 2326 //
     /* 344592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 344607 */     // MIs[1] Operand 1
     /* 344607 */     // No operand predicates
     /* 344607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344609 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 344609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 344612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344619 */     GIR_RootConstrainSelectedInstOperands,
     /* 344620 */     // GIR_Coverage, 2326,
     /* 344620 */     GIR_EraseRootFromParent_Done,
     /* 344621 */   // Label 6895: @344621
     /* 344621 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(344640), // Rule ID 2325 //
     /* 344626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344633 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 344633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 344638 */     GIR_RootConstrainSelectedInstOperands,
     /* 344639 */     // GIR_Coverage, 2325,
     /* 344639 */     GIR_Done,
     /* 344640 */   // Label 6896: @344640
     /* 344640 */   GIM_Reject,
     /* 344641 */ // Label 6894: @344641
     /* 344641 */ GIM_Reject,
     /* 344642 */ // Label 6884: @344642
     /* 344642 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(344675), // Rule ID 1402 //
     /* 344647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344668 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 344668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 344673 */   GIR_RootConstrainSelectedInstOperands,
     /* 344674 */   // GIR_Coverage, 1402,
     /* 344674 */   GIR_Done,
     /* 344675 */ // Label 6897: @344675
     /* 344675 */ GIM_Reject,
     /* 344676 */ // Label 6885: @344676
     /* 344676 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(344709), // Rule ID 1400 //
     /* 344681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344702 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 344702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 344707 */   GIR_RootConstrainSelectedInstOperands,
     /* 344708 */   // GIR_Coverage, 1400,
     /* 344708 */   GIR_Done,
     /* 344709 */ // Label 6898: @344709
     /* 344709 */ GIM_Reject,
     /* 344710 */ // Label 6886: @344710
     /* 344710 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(344743), // Rule ID 1403 //
     /* 344715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344736 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 344736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 344741 */   GIR_RootConstrainSelectedInstOperands,
     /* 344742 */   // GIR_Coverage, 1403,
     /* 344742 */   GIR_Done,
     /* 344743 */ // Label 6899: @344743
     /* 344743 */ GIM_Reject,
     /* 344744 */ // Label 6887: @344744
     /* 344744 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(344777), // Rule ID 1398 //
     /* 344749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 344758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344770 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 344770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 344775 */   GIR_RootConstrainSelectedInstOperands,
     /* 344776 */   // GIR_Coverage, 1398,
     /* 344776 */   GIR_Done,
     /* 344777 */ // Label 6900: @344777
     /* 344777 */ GIM_Reject,
     /* 344778 */ // Label 6888: @344778
     /* 344778 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(344811), // Rule ID 1401 //
     /* 344783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344804 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 344804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 344809 */   GIR_RootConstrainSelectedInstOperands,
     /* 344810 */   // GIR_Coverage, 1401,
     /* 344810 */   GIR_Done,
     /* 344811 */ // Label 6901: @344811
     /* 344811 */ GIM_Reject,
     /* 344812 */ // Label 6889: @344812
     /* 344812 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(344845), // Rule ID 1399 //
     /* 344817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 344826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344838 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 344838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 344843 */   GIR_RootConstrainSelectedInstOperands,
     /* 344844 */   // GIR_Coverage, 1399,
     /* 344844 */   GIR_Done,
     /* 344845 */ // Label 6902: @344845
     /* 344845 */ GIM_Reject,
     /* 344846 */ // Label 6890: @344846
     /* 344846 */ GIM_Reject,
     /* 344847 */ // Label 83: @344847
     /* 344847 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6911*/ GIMT_Encode4(345250),
     /* 344858 */ /*GILLT_s32*//*Label 6903*/ GIMT_Encode4(344898),
     /* 344862 */ /*GILLT_s64*//*Label 6904*/ GIMT_Encode4(344972), GIMT_Encode4(0),
     /* 344870 */ /*GILLT_v2s32*//*Label 6905*/ GIMT_Encode4(345046), GIMT_Encode4(0),
     /* 344878 */ /*GILLT_v4s16*//*Label 6906*/ GIMT_Encode4(345080),
     /* 344882 */ /*GILLT_v4s32*//*Label 6907*/ GIMT_Encode4(345114),
     /* 344886 */ /*GILLT_v8s8*//*Label 6908*/ GIMT_Encode4(345148),
     /* 344890 */ /*GILLT_v8s16*//*Label 6909*/ GIMT_Encode4(345182),
     /* 344894 */ /*GILLT_v16s8*//*Label 6910*/ GIMT_Encode4(345216),
     /* 344898 */ // Label 6903: @344898
     /* 344898 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(344971),
     /* 344903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344917 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(344951), // Rule ID 2336 //
     /* 344922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 344937 */     // MIs[1] Operand 1
     /* 344937 */     // No operand predicates
     /* 344937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344939 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 344939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 344942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 344946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 344949 */     GIR_RootConstrainSelectedInstOperands,
     /* 344950 */     // GIR_Coverage, 2336,
     /* 344950 */     GIR_EraseRootFromParent_Done,
     /* 344951 */   // Label 6913: @344951
     /* 344951 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(344970), // Rule ID 2335 //
     /* 344956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344963 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 344963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 344968 */     GIR_RootConstrainSelectedInstOperands,
     /* 344969 */     // GIR_Coverage, 2335,
     /* 344969 */     GIR_Done,
     /* 344970 */   // Label 6914: @344970
     /* 344970 */   GIM_Reject,
     /* 344971 */ // Label 6912: @344971
     /* 344971 */ GIM_Reject,
     /* 344972 */ // Label 6904: @344972
     /* 344972 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(345045),
     /* 344977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344991 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(345025), // Rule ID 2338 //
     /* 344996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 344999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 345011 */     // MIs[1] Operand 1
     /* 345011 */     // No operand predicates
     /* 345011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345013 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 345016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345023 */     GIR_RootConstrainSelectedInstOperands,
     /* 345024 */     // GIR_Coverage, 2338,
     /* 345024 */     GIR_EraseRootFromParent_Done,
     /* 345025 */   // Label 6916: @345025
     /* 345025 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(345044), // Rule ID 2337 //
     /* 345030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345037 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 345042 */     GIR_RootConstrainSelectedInstOperands,
     /* 345043 */     // GIR_Coverage, 2337,
     /* 345043 */     GIR_Done,
     /* 345044 */   // Label 6917: @345044
     /* 345044 */   GIM_Reject,
     /* 345045 */ // Label 6915: @345045
     /* 345045 */ GIM_Reject,
     /* 345046 */ // Label 6905: @345046
     /* 345046 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(345079), // Rule ID 1537 //
     /* 345051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345072 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 345077 */   GIR_RootConstrainSelectedInstOperands,
     /* 345078 */   // GIR_Coverage, 1537,
     /* 345078 */   GIR_Done,
     /* 345079 */ // Label 6918: @345079
     /* 345079 */ GIM_Reject,
     /* 345080 */ // Label 6906: @345080
     /* 345080 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(345113), // Rule ID 1535 //
     /* 345085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345106 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 345111 */   GIR_RootConstrainSelectedInstOperands,
     /* 345112 */   // GIR_Coverage, 1535,
     /* 345112 */   GIR_Done,
     /* 345113 */ // Label 6919: @345113
     /* 345113 */ GIM_Reject,
     /* 345114 */ // Label 6907: @345114
     /* 345114 */ GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(345147), // Rule ID 1538 //
     /* 345119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345140 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 345145 */   GIR_RootConstrainSelectedInstOperands,
     /* 345146 */   // GIR_Coverage, 1538,
     /* 345146 */   GIR_Done,
     /* 345147 */ // Label 6920: @345147
     /* 345147 */ GIM_Reject,
     /* 345148 */ // Label 6908: @345148
     /* 345148 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(345181), // Rule ID 1533 //
     /* 345153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345174 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 345179 */   GIR_RootConstrainSelectedInstOperands,
     /* 345180 */   // GIR_Coverage, 1533,
     /* 345180 */   GIR_Done,
     /* 345181 */ // Label 6921: @345181
     /* 345181 */ GIM_Reject,
     /* 345182 */ // Label 6909: @345182
     /* 345182 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(345215), // Rule ID 1536 //
     /* 345187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345208 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 345213 */   GIR_RootConstrainSelectedInstOperands,
     /* 345214 */   // GIR_Coverage, 1536,
     /* 345214 */   GIR_Done,
     /* 345215 */ // Label 6922: @345215
     /* 345215 */ GIM_Reject,
     /* 345216 */ // Label 6910: @345216
     /* 345216 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(345249), // Rule ID 1534 //
     /* 345221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345242 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 345247 */   GIR_RootConstrainSelectedInstOperands,
     /* 345248 */   // GIR_Coverage, 1534,
     /* 345248 */   GIR_Done,
     /* 345249 */ // Label 6923: @345249
     /* 345249 */ GIM_Reject,
     /* 345250 */ // Label 6911: @345250
     /* 345250 */ GIM_Reject,
     /* 345251 */ // Label 84: @345251
     /* 345251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6932*/ GIMT_Encode4(345654),
     /* 345262 */ /*GILLT_s32*//*Label 6924*/ GIMT_Encode4(345302),
     /* 345266 */ /*GILLT_s64*//*Label 6925*/ GIMT_Encode4(345376), GIMT_Encode4(0),
     /* 345274 */ /*GILLT_v2s32*//*Label 6926*/ GIMT_Encode4(345450), GIMT_Encode4(0),
     /* 345282 */ /*GILLT_v4s16*//*Label 6927*/ GIMT_Encode4(345484),
     /* 345286 */ /*GILLT_v4s32*//*Label 6928*/ GIMT_Encode4(345518),
     /* 345290 */ /*GILLT_v8s8*//*Label 6929*/ GIMT_Encode4(345552),
     /* 345294 */ /*GILLT_v8s16*//*Label 6930*/ GIMT_Encode4(345586),
     /* 345298 */ /*GILLT_v16s8*//*Label 6931*/ GIMT_Encode4(345620),
     /* 345302 */ // Label 6924: @345302
     /* 345302 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(345375),
     /* 345307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345321 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(345355), // Rule ID 2332 //
     /* 345326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 345341 */     // MIs[1] Operand 1
     /* 345341 */     // No operand predicates
     /* 345341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345343 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 345346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345353 */     GIR_RootConstrainSelectedInstOperands,
     /* 345354 */     // GIR_Coverage, 2332,
     /* 345354 */     GIR_EraseRootFromParent_Done,
     /* 345355 */   // Label 6934: @345355
     /* 345355 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(345374), // Rule ID 2331 //
     /* 345360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345367 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 345372 */     GIR_RootConstrainSelectedInstOperands,
     /* 345373 */     // GIR_Coverage, 2331,
     /* 345373 */     GIR_Done,
     /* 345374 */   // Label 6935: @345374
     /* 345374 */   GIM_Reject,
     /* 345375 */ // Label 6933: @345375
     /* 345375 */ GIM_Reject,
     /* 345376 */ // Label 6925: @345376
     /* 345376 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(345449),
     /* 345381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345395 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(345429), // Rule ID 2334 //
     /* 345400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 345415 */     // MIs[1] Operand 1
     /* 345415 */     // No operand predicates
     /* 345415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345417 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 345420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345427 */     GIR_RootConstrainSelectedInstOperands,
     /* 345428 */     // GIR_Coverage, 2334,
     /* 345428 */     GIR_EraseRootFromParent_Done,
     /* 345429 */   // Label 6937: @345429
     /* 345429 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(345448), // Rule ID 2333 //
     /* 345434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345441 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 345446 */     GIR_RootConstrainSelectedInstOperands,
     /* 345447 */     // GIR_Coverage, 2333,
     /* 345447 */     GIR_Done,
     /* 345448 */   // Label 6938: @345448
     /* 345448 */   GIM_Reject,
     /* 345449 */ // Label 6936: @345449
     /* 345449 */ GIM_Reject,
     /* 345450 */ // Label 6926: @345450
     /* 345450 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(345483), // Rule ID 1525 //
     /* 345455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345476 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 345481 */   GIR_RootConstrainSelectedInstOperands,
     /* 345482 */   // GIR_Coverage, 1525,
     /* 345482 */   GIR_Done,
     /* 345483 */ // Label 6939: @345483
     /* 345483 */ GIM_Reject,
     /* 345484 */ // Label 6927: @345484
     /* 345484 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(345517), // Rule ID 1523 //
     /* 345489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345510 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 345515 */   GIR_RootConstrainSelectedInstOperands,
     /* 345516 */   // GIR_Coverage, 1523,
     /* 345516 */   GIR_Done,
     /* 345517 */ // Label 6940: @345517
     /* 345517 */ GIM_Reject,
     /* 345518 */ // Label 6928: @345518
     /* 345518 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(345551), // Rule ID 1526 //
     /* 345523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345544 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 345549 */   GIR_RootConstrainSelectedInstOperands,
     /* 345550 */   // GIR_Coverage, 1526,
     /* 345550 */   GIR_Done,
     /* 345551 */ // Label 6941: @345551
     /* 345551 */ GIM_Reject,
     /* 345552 */ // Label 6929: @345552
     /* 345552 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(345585), // Rule ID 1521 //
     /* 345557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345578 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 345583 */   GIR_RootConstrainSelectedInstOperands,
     /* 345584 */   // GIR_Coverage, 1521,
     /* 345584 */   GIR_Done,
     /* 345585 */ // Label 6942: @345585
     /* 345585 */ GIM_Reject,
     /* 345586 */ // Label 6930: @345586
     /* 345586 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(345619), // Rule ID 1524 //
     /* 345591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345612 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 345617 */   GIR_RootConstrainSelectedInstOperands,
     /* 345618 */   // GIR_Coverage, 1524,
     /* 345618 */   GIR_Done,
     /* 345619 */ // Label 6943: @345619
     /* 345619 */ GIM_Reject,
     /* 345620 */ // Label 6931: @345620
     /* 345620 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(345653), // Rule ID 1522 //
     /* 345625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345646 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 345651 */   GIR_RootConstrainSelectedInstOperands,
     /* 345652 */   // GIR_Coverage, 1522,
     /* 345652 */   GIR_Done,
     /* 345653 */ // Label 6944: @345653
     /* 345653 */ GIM_Reject,
     /* 345654 */ // Label 6932: @345654
     /* 345654 */ GIM_Reject,
     /* 345655 */ // Label 85: @345655
     /* 345655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6954*/ GIMT_Encode4(346469),
     /* 345666 */ /*GILLT_s32*//*Label 6945*/ GIMT_Encode4(345706),
     /* 345670 */ /*GILLT_s64*//*Label 6946*/ GIMT_Encode4(345733), GIMT_Encode4(0),
     /* 345678 */ /*GILLT_v2s32*//*Label 6947*/ GIMT_Encode4(345812),
     /* 345682 */ /*GILLT_v2s64*//*Label 6948*/ GIMT_Encode4(345839),
     /* 345686 */ /*GILLT_v4s16*//*Label 6949*/ GIMT_Encode4(346022),
     /* 345690 */ /*GILLT_v4s32*//*Label 6950*/ GIMT_Encode4(346049),
     /* 345694 */ /*GILLT_v8s8*//*Label 6951*/ GIMT_Encode4(346232),
     /* 345698 */ /*GILLT_v8s16*//*Label 6952*/ GIMT_Encode4(346259),
     /* 345702 */ /*GILLT_v16s8*//*Label 6953*/ GIMT_Encode4(346442),
     /* 345706 */ // Label 6945: @345706
     /* 345706 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(345732), // Rule ID 2317 //
     /* 345711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345725 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 345725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 345730 */   GIR_RootConstrainSelectedInstOperands,
     /* 345731 */   // GIR_Coverage, 2317,
     /* 345731 */   GIR_Done,
     /* 345732 */ // Label 6955: @345732
     /* 345732 */ GIM_Reject,
     /* 345733 */ // Label 6946: @345733
     /* 345733 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(345811),
     /* 345738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345741 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(345764), // Rule ID 1652 //
     /* 345746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345757 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 345757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 345762 */     GIR_RootConstrainSelectedInstOperands,
     /* 345763 */     // GIR_Coverage, 1652,
     /* 345763 */     GIR_Done,
     /* 345764 */   // Label 6957: @345764
     /* 345764 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(345787), // Rule ID 2318 //
     /* 345769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345780 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 345780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 345785 */     GIR_RootConstrainSelectedInstOperands,
     /* 345786 */     // GIR_Coverage, 2318,
     /* 345786 */     GIR_Done,
     /* 345787 */   // Label 6958: @345787
     /* 345787 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(345810), // Rule ID 2507 //
     /* 345792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 345795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345803 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 345803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 345808 */     GIR_RootConstrainSelectedInstOperands,
     /* 345809 */     // GIR_Coverage, 2507,
     /* 345809 */     GIR_Done,
     /* 345810 */   // Label 6959: @345810
     /* 345810 */   GIM_Reject,
     /* 345811 */ // Label 6956: @345811
     /* 345811 */ GIM_Reject,
     /* 345812 */ // Label 6947: @345812
     /* 345812 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(345838), // Rule ID 707 //
     /* 345817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345831 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 345831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 345836 */   GIR_RootConstrainSelectedInstOperands,
     /* 345837 */   // GIR_Coverage, 707,
     /* 345837 */   GIR_Done,
     /* 345838 */ // Label 6960: @345838
     /* 345838 */ GIM_Reject,
     /* 345839 */ // Label 6948: @345839
     /* 345839 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(346021),
     /* 345844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345851 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(345929), // Rule ID 4922 //
     /* 345856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 345864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 345876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 345888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 345905 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 345912 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 345912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 345915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 345922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 345927 */     GIR_RootConstrainSelectedInstOperands,
     /* 345928 */     // GIR_Coverage, 4922,
     /* 345928 */     GIR_EraseRootFromParent_Done,
     /* 345929 */   // Label 6962: @345929
     /* 345929 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(346001), // Rule ID 4921 //
     /* 345934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 345942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 345954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 345971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 345975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345986 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 345986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 345989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 345995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 345999 */     GIR_RootConstrainSelectedInstOperands,
     /* 346000 */     // GIR_Coverage, 4921,
     /* 346000 */     GIR_EraseRootFromParent_Done,
     /* 346001 */   // Label 6963: @346001
     /* 346001 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(346020), // Rule ID 709 //
     /* 346006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346013 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 346013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 346018 */     GIR_RootConstrainSelectedInstOperands,
     /* 346019 */     // GIR_Coverage, 709,
     /* 346019 */     GIR_Done,
     /* 346020 */   // Label 6964: @346020
     /* 346020 */   GIM_Reject,
     /* 346021 */ // Label 6961: @346021
     /* 346021 */ GIM_Reject,
     /* 346022 */ // Label 6949: @346022
     /* 346022 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(346048), // Rule ID 705 //
     /* 346027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346041 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 346041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 346046 */   GIR_RootConstrainSelectedInstOperands,
     /* 346047 */   // GIR_Coverage, 705,
     /* 346047 */   GIR_Done,
     /* 346048 */ // Label 6965: @346048
     /* 346048 */ GIM_Reject,
     /* 346049 */ // Label 6950: @346049
     /* 346049 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(346231),
     /* 346054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346061 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(346139), // Rule ID 4920 //
     /* 346066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346102 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346115 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 346122 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 346122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 346125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346137 */     GIR_RootConstrainSelectedInstOperands,
     /* 346138 */     // GIR_Coverage, 4920,
     /* 346138 */     GIR_EraseRootFromParent_Done,
     /* 346139 */   // Label 6967: @346139
     /* 346139 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(346211), // Rule ID 4919 //
     /* 346144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346189 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346196 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 346196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 346199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346209 */     GIR_RootConstrainSelectedInstOperands,
     /* 346210 */     // GIR_Coverage, 4919,
     /* 346210 */     GIR_EraseRootFromParent_Done,
     /* 346211 */   // Label 6968: @346211
     /* 346211 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(346230), // Rule ID 708 //
     /* 346216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346223 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 346223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 346228 */     GIR_RootConstrainSelectedInstOperands,
     /* 346229 */     // GIR_Coverage, 708,
     /* 346229 */     GIR_Done,
     /* 346230 */   // Label 6969: @346230
     /* 346230 */   GIM_Reject,
     /* 346231 */ // Label 6966: @346231
     /* 346231 */ GIM_Reject,
     /* 346232 */ // Label 6951: @346232
     /* 346232 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(346258), // Rule ID 703 //
     /* 346237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346251 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 346251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 346256 */   GIR_RootConstrainSelectedInstOperands,
     /* 346257 */   // GIR_Coverage, 703,
     /* 346257 */   GIR_Done,
     /* 346258 */ // Label 6970: @346258
     /* 346258 */ GIM_Reject,
     /* 346259 */ // Label 6952: @346259
     /* 346259 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(346441),
     /* 346264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346271 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(346349), // Rule ID 4918 //
     /* 346276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 346325 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 346332 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 346332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 346335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346347 */     GIR_RootConstrainSelectedInstOperands,
     /* 346348 */     // GIR_Coverage, 4918,
     /* 346348 */     GIR_EraseRootFromParent_Done,
     /* 346349 */   // Label 6972: @346349
     /* 346349 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(346421), // Rule ID 4917 //
     /* 346354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346399 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346406 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 346406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 346409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346419 */     GIR_RootConstrainSelectedInstOperands,
     /* 346420 */     // GIR_Coverage, 4917,
     /* 346420 */     GIR_EraseRootFromParent_Done,
     /* 346421 */   // Label 6973: @346421
     /* 346421 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(346440), // Rule ID 706 //
     /* 346426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346433 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 346433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 346438 */     GIR_RootConstrainSelectedInstOperands,
     /* 346439 */     // GIR_Coverage, 706,
     /* 346439 */     GIR_Done,
     /* 346440 */   // Label 6974: @346440
     /* 346440 */   GIM_Reject,
     /* 346441 */ // Label 6971: @346441
     /* 346441 */ GIM_Reject,
     /* 346442 */ // Label 6953: @346442
     /* 346442 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(346468), // Rule ID 704 //
     /* 346447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346461 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 346461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 346466 */   GIR_RootConstrainSelectedInstOperands,
     /* 346467 */   // GIR_Coverage, 704,
     /* 346467 */   GIR_Done,
     /* 346468 */ // Label 6975: @346468
     /* 346468 */ GIM_Reject,
     /* 346469 */ // Label 6954: @346469
     /* 346469 */ GIM_Reject,
     /* 346470 */ // Label 86: @346470
     /* 346470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6978*/ GIMT_Encode4(346635),
     /* 346481 */ /*GILLT_s32*//*Label 6976*/ GIMT_Encode4(346489),
     /* 346485 */ /*GILLT_s64*//*Label 6977*/ GIMT_Encode4(346562),
     /* 346489 */ // Label 6976: @346489
     /* 346489 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(346515), // Rule ID 4763 //
     /* 346494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 346500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346504 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 346504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 346509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346513 */   GIR_RootConstrainSelectedInstOperands,
     /* 346514 */   // GIR_Coverage, 4763,
     /* 346514 */   GIR_Done,
     /* 346515 */ // Label 6979: @346515
     /* 346515 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(346538), // Rule ID 4769 //
     /* 346520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346527 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 346527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 346532 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346536 */   GIR_RootConstrainSelectedInstOperands,
     /* 346537 */   // GIR_Coverage, 4769,
     /* 346537 */   GIR_Done,
     /* 346538 */ // Label 6980: @346538
     /* 346538 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(346561), // Rule ID 4771 //
     /* 346543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346550 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 346550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 346555 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346559 */   GIR_RootConstrainSelectedInstOperands,
     /* 346560 */   // GIR_Coverage, 4771,
     /* 346560 */   GIR_Done,
     /* 346561 */ // Label 6981: @346561
     /* 346561 */ GIM_Reject,
     /* 346562 */ // Label 6977: @346562
     /* 346562 */ GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(346588), // Rule ID 4765 //
     /* 346567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 346573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346577 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 346577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 346582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346586 */   GIR_RootConstrainSelectedInstOperands,
     /* 346587 */   // GIR_Coverage, 4765,
     /* 346587 */   GIR_Done,
     /* 346588 */ // Label 6982: @346588
     /* 346588 */ GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(346611), // Rule ID 4773 //
     /* 346593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346600 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 346600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 346605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346609 */   GIR_RootConstrainSelectedInstOperands,
     /* 346610 */   // GIR_Coverage, 4773,
     /* 346610 */   GIR_Done,
     /* 346611 */ // Label 6983: @346611
     /* 346611 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(346634), // Rule ID 4775 //
     /* 346616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346623 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 346623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 346628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346632 */   GIR_RootConstrainSelectedInstOperands,
     /* 346633 */   // GIR_Coverage, 4775,
     /* 346633 */   GIR_Done,
     /* 346634 */ // Label 6984: @346634
     /* 346634 */ GIM_Reject,
     /* 346635 */ // Label 6978: @346635
     /* 346635 */ GIM_Reject,
     /* 346636 */ // Label 87: @346636
     /* 346636 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(346734),
     /* 346641 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 346644 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6989*/ GIMT_Encode4(346733),
     /* 346655 */   /*GILLT_s16*//*Label 6986*/ GIMT_Encode4(346667),
     /* 346659 */   /*GILLT_s32*//*Label 6987*/ GIMT_Encode4(346691),
     /* 346663 */   /*GILLT_s64*//*Label 6988*/ GIMT_Encode4(346712),
     /* 346667 */   // Label 6986: @346667
     /* 346667 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(346690), // Rule ID 4767 //
     /* 346672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 346675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346679 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 346679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 346684 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346688 */     GIR_RootConstrainSelectedInstOperands,
     /* 346689 */     // GIR_Coverage, 4767,
     /* 346689 */     GIR_Done,
     /* 346690 */   // Label 6990: @346690
     /* 346690 */   GIM_Reject,
     /* 346691 */   // Label 6987: @346691
     /* 346691 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(346711), // Rule ID 4777 //
     /* 346696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346700 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 346700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 346705 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346709 */     GIR_RootConstrainSelectedInstOperands,
     /* 346710 */     // GIR_Coverage, 4777,
     /* 346710 */     GIR_Done,
     /* 346711 */   // Label 6991: @346711
     /* 346711 */   GIM_Reject,
     /* 346712 */   // Label 6988: @346712
     /* 346712 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(346732), // Rule ID 4779 //
     /* 346717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346721 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 346721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 346726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346730 */     GIR_RootConstrainSelectedInstOperands,
     /* 346731 */     // GIR_Coverage, 4779,
     /* 346731 */     GIR_Done,
     /* 346732 */   // Label 6992: @346732
     /* 346732 */   GIM_Reject,
     /* 346733 */   // Label 6989: @346733
     /* 346733 */   GIM_Reject,
     /* 346734 */ // Label 6985: @346734
     /* 346734 */ GIM_Reject,
     /* 346735 */ // Label 88: @346735
     /* 346735 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(346750), // Rule ID 225 //
     /* 346740 */   // MIs[0] addr
     /* 346740 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 346743 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 346743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 346748 */   GIR_RootConstrainSelectedInstOperands,
     /* 346749 */   // GIR_Coverage, 225,
     /* 346749 */   GIR_Done,
     /* 346750 */ // Label 6993: @346750
     /* 346750 */ GIM_Reject,
     /* 346751 */ // Label 89: @346751
     /* 346751 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7005*/ GIMT_Encode4(352122),
     /* 346762 */ /*GILLT_s64*//*Label 6994*/ GIMT_Encode4(346834), GIMT_Encode4(0),
     /* 346770 */ /*GILLT_v2s32*//*Label 6995*/ GIMT_Encode4(347236), GIMT_Encode4(0),
     /* 346778 */ /*GILLT_v4s16*//*Label 6996*/ GIMT_Encode4(347638), GIMT_Encode4(0),
     /* 346786 */ /*GILLT_v8s8*//*Label 6997*/ GIMT_Encode4(348040), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 346798 */ /*GILLT_nxv1s1*//*Label 6998*/ GIMT_Encode4(348220),
     /* 346802 */ /*GILLT_nxv2s1*//*Label 6999*/ GIMT_Encode4(350483),
     /* 346806 */ /*GILLT_nxv2s16*//*Label 7000*/ GIMT_Encode4(351338),
     /* 346810 */ /*GILLT_nxv2s32*//*Label 7001*/ GIMT_Encode4(351625), GIMT_Encode4(0),
     /* 346818 */ /*GILLT_nxv4s1*//*Label 7002*/ GIMT_Encode4(351695),
     /* 346822 */ /*GILLT_nxv4s16*//*Label 7003*/ GIMT_Encode4(351982), GIMT_Encode4(0),
     /* 346830 */ /*GILLT_nxv8s1*//*Label 7004*/ GIMT_Encode4(352052),
     /* 346834 */ // Label 6994: @346834
     /* 346834 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(347235),
     /* 346839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346846 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(346898), // Rule ID 5592 //
     /* 346851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 346859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346863 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 346865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346870 */     // MIs[0] Operand 2
     /* 346870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 346881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346883 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 346883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 346886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346896 */     GIR_RootConstrainSelectedInstOperands,
     /* 346897 */     // GIR_Coverage, 5592,
     /* 346897 */     GIR_EraseRootFromParent_Done,
     /* 346898 */   // Label 7007: @346898
     /* 346898 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(346950), // Rule ID 5595 //
     /* 346903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 346911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346915 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 346917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346922 */     // MIs[0] Operand 2
     /* 346922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 346933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346935 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 346935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 346938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 346948 */     GIR_RootConstrainSelectedInstOperands,
     /* 346949 */     // GIR_Coverage, 5595,
     /* 346949 */     GIR_EraseRootFromParent_Done,
     /* 346950 */   // Label 7008: @346950
     /* 346950 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(347018), // Rule ID 5471 //
     /* 346955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346959 */     // MIs[0] Operand 2
     /* 346959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 346970 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 346970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 346977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 346993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347000 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347017 */     // GIR_Coverage, 5471,
     /* 347017 */     GIR_EraseRootFromParent_Done,
     /* 347018 */   // Label 7009: @347018
     /* 347018 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(347086), // Rule ID 5476 //
     /* 347023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347027 */     // MIs[0] Operand 2
     /* 347027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347038 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347068 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347085 */     // GIR_Coverage, 5476,
     /* 347085 */     GIR_EraseRootFromParent_Done,
     /* 347086 */   // Label 7010: @347086
     /* 347086 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(347128), // Rule ID 6923 //
     /* 347091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347095 */     // MIs[0] Operand 2
     /* 347095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347106 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 347106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347111 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347127 */     // GIR_Coverage, 6923,
     /* 347127 */     GIR_EraseRootFromParent_Done,
     /* 347128 */   // Label 7011: @347128
     /* 347128 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(347170), // Rule ID 6924 //
     /* 347133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347137 */     // MIs[0] Operand 2
     /* 347137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347148 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 347148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347153 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347169 */     // GIR_Coverage, 6924,
     /* 347169 */     GIR_EraseRootFromParent_Done,
     /* 347170 */   // Label 7012: @347170
     /* 347170 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(347234), // Rule ID 6928 //
     /* 347175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347179 */     // MIs[0] Operand 2
     /* 347179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347190 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 347209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347233 */     // GIR_Coverage, 6928,
     /* 347233 */     GIR_EraseRootFromParent_Done,
     /* 347234 */   // Label 7013: @347234
     /* 347234 */   GIM_Reject,
     /* 347235 */ // Label 7006: @347235
     /* 347235 */ GIM_Reject,
     /* 347236 */ // Label 6995: @347236
     /* 347236 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(347637),
     /* 347241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347248 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(347300), // Rule ID 5591 //
     /* 347253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347265 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347272 */     // MIs[0] Operand 2
     /* 347272 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347285 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 347285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 347288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347298 */     GIR_RootConstrainSelectedInstOperands,
     /* 347299 */     // GIR_Coverage, 5591,
     /* 347299 */     GIR_EraseRootFromParent_Done,
     /* 347300 */   // Label 7015: @347300
     /* 347300 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(347352), // Rule ID 5594 //
     /* 347305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347317 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347324 */     // MIs[0] Operand 2
     /* 347324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347337 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 347337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 347340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347350 */     GIR_RootConstrainSelectedInstOperands,
     /* 347351 */     // GIR_Coverage, 5594,
     /* 347351 */     GIR_EraseRootFromParent_Done,
     /* 347352 */   // Label 7016: @347352
     /* 347352 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(347420), // Rule ID 5461 //
     /* 347357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347361 */     // MIs[0] Operand 2
     /* 347361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347372 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347402 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347419 */     // GIR_Coverage, 5461,
     /* 347419 */     GIR_EraseRootFromParent_Done,
     /* 347420 */   // Label 7017: @347420
     /* 347420 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(347488), // Rule ID 5466 //
     /* 347425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347429 */     // MIs[0] Operand 2
     /* 347429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 347440 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347470 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347487 */     // GIR_Coverage, 5466,
     /* 347487 */     GIR_EraseRootFromParent_Done,
     /* 347488 */   // Label 7018: @347488
     /* 347488 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(347530), // Rule ID 6920 //
     /* 347493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347497 */     // MIs[0] Operand 2
     /* 347497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347508 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 347508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347513 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347529 */     // GIR_Coverage, 6920,
     /* 347529 */     GIR_EraseRootFromParent_Done,
     /* 347530 */   // Label 7019: @347530
     /* 347530 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(347572), // Rule ID 6922 //
     /* 347535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347539 */     // MIs[0] Operand 2
     /* 347539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347550 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 347550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347555 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347571 */     // GIR_Coverage, 6922,
     /* 347571 */     GIR_EraseRootFromParent_Done,
     /* 347572 */   // Label 7020: @347572
     /* 347572 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(347636), // Rule ID 6927 //
     /* 347577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347581 */     // MIs[0] Operand 2
     /* 347581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347592 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 347599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 347611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347618 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347635 */     // GIR_Coverage, 6927,
     /* 347635 */     GIR_EraseRootFromParent_Done,
     /* 347636 */   // Label 7021: @347636
     /* 347636 */   GIM_Reject,
     /* 347637 */ // Label 7014: @347637
     /* 347637 */ GIM_Reject,
     /* 347638 */ // Label 6996: @347638
     /* 347638 */ GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(348039),
     /* 347643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347650 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(347702), // Rule ID 5590 //
     /* 347655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347667 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347674 */     // MIs[0] Operand 2
     /* 347674 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347687 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 347687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 347690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347700 */     GIR_RootConstrainSelectedInstOperands,
     /* 347701 */     // GIR_Coverage, 5590,
     /* 347701 */     GIR_EraseRootFromParent_Done,
     /* 347702 */   // Label 7023: @347702
     /* 347702 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(347754), // Rule ID 5593 //
     /* 347707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347719 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347726 */     // MIs[0] Operand 2
     /* 347726 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347739 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 347739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 347742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347752 */     GIR_RootConstrainSelectedInstOperands,
     /* 347753 */     // GIR_Coverage, 5593,
     /* 347753 */     GIR_EraseRootFromParent_Done,
     /* 347754 */   // Label 7024: @347754
     /* 347754 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(347822), // Rule ID 5451 //
     /* 347759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347763 */     // MIs[0] Operand 2
     /* 347763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347774 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347804 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347821 */     // GIR_Coverage, 5451,
     /* 347821 */     GIR_EraseRootFromParent_Done,
     /* 347822 */   // Label 7025: @347822
     /* 347822 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(347890), // Rule ID 5456 //
     /* 347827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347831 */     // MIs[0] Operand 2
     /* 347831 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 347842 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347872 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347889 */     // GIR_Coverage, 5456,
     /* 347889 */     GIR_EraseRootFromParent_Done,
     /* 347890 */   // Label 7026: @347890
     /* 347890 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(347932), // Rule ID 6918 //
     /* 347895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347899 */     // MIs[0] Operand 2
     /* 347899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347910 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 347910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347915 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347931 */     // GIR_Coverage, 6918,
     /* 347931 */     GIR_EraseRootFromParent_Done,
     /* 347932 */   // Label 7027: @347932
     /* 347932 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(347974), // Rule ID 6921 //
     /* 347937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347941 */     // MIs[0] Operand 2
     /* 347941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347952 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 347952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347957 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 347963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347973 */     // GIR_Coverage, 6921,
     /* 347973 */     GIR_EraseRootFromParent_Done,
     /* 347974 */   // Label 7028: @347974
     /* 347974 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(348038), // Rule ID 6926 //
     /* 347979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347983 */     // MIs[0] Operand 2
     /* 347983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347994 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 347994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348037 */     // GIR_Coverage, 6926,
     /* 348037 */     GIR_EraseRootFromParent_Done,
     /* 348038 */   // Label 7029: @348038
     /* 348038 */   GIM_Reject,
     /* 348039 */ // Label 7022: @348039
     /* 348039 */ GIM_Reject,
     /* 348040 */ // Label 6997: @348040
     /* 348040 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(348219),
     /* 348045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348056 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(348120), // Rule ID 5446 //
     /* 348061 */     // MIs[0] Operand 2
     /* 348061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 348072 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348092 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348102 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348119 */     // GIR_Coverage, 5446,
     /* 348119 */     GIR_EraseRootFromParent_Done,
     /* 348120 */   // Label 7031: @348120
     /* 348120 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(348158), // Rule ID 6919 //
     /* 348125 */     // MIs[0] Operand 2
     /* 348125 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348136 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 348136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348141 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348157 */     // GIR_Coverage, 6919,
     /* 348157 */     GIR_EraseRootFromParent_Done,
     /* 348158 */   // Label 7032: @348158
     /* 348158 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348218), // Rule ID 6925 //
     /* 348163 */     // MIs[0] Operand 2
     /* 348163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348174 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348200 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348217 */     // GIR_Coverage, 6925,
     /* 348217 */     GIR_EraseRootFromParent_Done,
     /* 348218 */   // Label 7033: @348218
     /* 348218 */   GIM_Reject,
     /* 348219 */ // Label 7030: @348219
     /* 348219 */ GIM_Reject,
     /* 348220 */ // Label 6998: @348220
     /* 348220 */ GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348255), // Rule ID 9017 //
     /* 348225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348235 */   // MIs[0] Operand 2
     /* 348235 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348246 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348251 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348253 */   GIR_RootConstrainSelectedInstOperands,
     /* 348254 */   // GIR_Coverage, 9017,
     /* 348254 */   GIR_EraseRootFromParent_Done,
     /* 348255 */ // Label 7034: @348255
     /* 348255 */ GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(348290), // Rule ID 9018 //
     /* 348260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 348266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348270 */   // MIs[0] Operand 2
     /* 348270 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348281 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 348281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348286 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 348288 */   GIR_RootConstrainSelectedInstOperands,
     /* 348289 */   // GIR_Coverage, 9018,
     /* 348289 */   GIR_EraseRootFromParent_Done,
     /* 348290 */ // Label 7035: @348290
     /* 348290 */ GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348344), // Rule ID 9025 //
     /* 348295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348305 */   // MIs[0] Operand 2
     /* 348305 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348316 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348342 */   GIR_RootConstrainSelectedInstOperands,
     /* 348343 */   // GIR_Coverage, 9025,
     /* 348343 */   GIR_EraseRootFromParent_Done,
     /* 348344 */ // Label 7036: @348344
     /* 348344 */ GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348398), // Rule ID 9026 //
     /* 348349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348359 */   // MIs[0] Operand 2
     /* 348359 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348370 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348396 */   GIR_RootConstrainSelectedInstOperands,
     /* 348397 */   // GIR_Coverage, 9026,
     /* 348397 */   GIR_EraseRootFromParent_Done,
     /* 348398 */ // Label 7037: @348398
     /* 348398 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(348452), // Rule ID 9027 //
     /* 348403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348413 */   // MIs[0] Operand 2
     /* 348413 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348424 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348450 */   GIR_RootConstrainSelectedInstOperands,
     /* 348451 */   // GIR_Coverage, 9027,
     /* 348451 */   GIR_EraseRootFromParent_Done,
     /* 348452 */ // Label 7038: @348452
     /* 348452 */ GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(348506), // Rule ID 9028 //
     /* 348457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 348463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348467 */   // MIs[0] Operand 2
     /* 348467 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 348478 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 348478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348504 */   GIR_RootConstrainSelectedInstOperands,
     /* 348505 */   // GIR_Coverage, 9028,
     /* 348505 */   GIR_EraseRootFromParent_Done,
     /* 348506 */ // Label 7039: @348506
     /* 348506 */ GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(348577), // Rule ID 9037 //
     /* 348511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348521 */   // MIs[0] Operand 2
     /* 348521 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348532 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348532 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348535 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348539 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348544 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348562 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348575 */   GIR_RootConstrainSelectedInstOperands,
     /* 348576 */   // GIR_Coverage, 9037,
     /* 348576 */   GIR_EraseRootFromParent_Done,
     /* 348577 */ // Label 7040: @348577
     /* 348577 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(348648), // Rule ID 9038 //
     /* 348582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348592 */   // MIs[0] Operand 2
     /* 348592 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348603 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348603 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348606 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348610 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348615 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348633 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348646 */   GIR_RootConstrainSelectedInstOperands,
     /* 348647 */   // GIR_Coverage, 9038,
     /* 348647 */   GIR_EraseRootFromParent_Done,
     /* 348648 */ // Label 7041: @348648
     /* 348648 */ GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(348719), // Rule ID 9039 //
     /* 348653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348663 */   // MIs[0] Operand 2
     /* 348663 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348674 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348674 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348677 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348681 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348686 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348704 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348717 */   GIR_RootConstrainSelectedInstOperands,
     /* 348718 */   // GIR_Coverage, 9039,
     /* 348718 */   GIR_EraseRootFromParent_Done,
     /* 348719 */ // Label 7042: @348719
     /* 348719 */ GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(348790), // Rule ID 9040 //
     /* 348724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348734 */   // MIs[0] Operand 2
     /* 348734 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 348745 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348745 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348748 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348752 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348757 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348788 */   GIR_RootConstrainSelectedInstOperands,
     /* 348789 */   // GIR_Coverage, 9040,
     /* 348789 */   GIR_EraseRootFromParent_Done,
     /* 348790 */ // Label 7043: @348790
     /* 348790 */ GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(348861), // Rule ID 9041 //
     /* 348795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348805 */   // MIs[0] Operand 2
     /* 348805 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348816 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348816 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348819 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348823 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348828 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348846 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348859 */   GIR_RootConstrainSelectedInstOperands,
     /* 348860 */   // GIR_Coverage, 9041,
     /* 348860 */   GIR_EraseRootFromParent_Done,
     /* 348861 */ // Label 7044: @348861
     /* 348861 */ GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(348932), // Rule ID 9042 //
     /* 348866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348876 */   // MIs[0] Operand 2
     /* 348876 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 348887 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348887 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348890 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348894 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348899 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348917 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348930 */   GIR_RootConstrainSelectedInstOperands,
     /* 348931 */   // GIR_Coverage, 9042,
     /* 348931 */   GIR_EraseRootFromParent_Done,
     /* 348932 */ // Label 7045: @348932
     /* 348932 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(349003), // Rule ID 9043 //
     /* 348937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 348943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 348947 */   // MIs[0] Operand 2
     /* 348947 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 348958 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 348958 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348961 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348965 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348970 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 348974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 348983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348988 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 348996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 348998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349001 */   GIR_RootConstrainSelectedInstOperands,
     /* 349002 */   // GIR_Coverage, 9043,
     /* 349002 */   GIR_EraseRootFromParent_Done,
     /* 349003 */ // Label 7046: @349003
     /* 349003 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(349074), // Rule ID 9044 //
     /* 349008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349018 */   // MIs[0] Operand 2
     /* 349018 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349029 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349029 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349032 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349036 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349041 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349072 */   GIR_RootConstrainSelectedInstOperands,
     /* 349073 */   // GIR_Coverage, 9044,
     /* 349073 */   GIR_EraseRootFromParent_Done,
     /* 349074 */ // Label 7047: @349074
     /* 349074 */ GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(349162), // Rule ID 9053 //
     /* 349079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349089 */   // MIs[0] Operand 2
     /* 349089 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349100 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349100 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349103 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349107 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349112 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349130 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349160 */   GIR_RootConstrainSelectedInstOperands,
     /* 349161 */   // GIR_Coverage, 9053,
     /* 349161 */   GIR_EraseRootFromParent_Done,
     /* 349162 */ // Label 7048: @349162
     /* 349162 */ GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(349250), // Rule ID 9054 //
     /* 349167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349177 */   // MIs[0] Operand 2
     /* 349177 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349188 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349188 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349191 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349195 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349200 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349206 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349209 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349213 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349218 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349235 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349248 */   GIR_RootConstrainSelectedInstOperands,
     /* 349249 */   // GIR_Coverage, 9054,
     /* 349249 */   GIR_EraseRootFromParent_Done,
     /* 349250 */ // Label 7049: @349250
     /* 349250 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(349338), // Rule ID 9055 //
     /* 349255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349265 */   // MIs[0] Operand 2
     /* 349265 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349276 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349276 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349279 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349283 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349288 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349306 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349323 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349336 */   GIR_RootConstrainSelectedInstOperands,
     /* 349337 */   // GIR_Coverage, 9055,
     /* 349337 */   GIR_EraseRootFromParent_Done,
     /* 349338 */ // Label 7050: @349338
     /* 349338 */ GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349426), // Rule ID 9056 //
     /* 349343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349353 */   // MIs[0] Operand 2
     /* 349353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349364 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349364 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349367 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349371 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349376 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349382 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349385 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349389 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349394 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349411 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349424 */   GIR_RootConstrainSelectedInstOperands,
     /* 349425 */   // GIR_Coverage, 9056,
     /* 349425 */   GIR_EraseRootFromParent_Done,
     /* 349426 */ // Label 7051: @349426
     /* 349426 */ GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349514), // Rule ID 9057 //
     /* 349431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349441 */   // MIs[0] Operand 2
     /* 349441 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349452 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349452 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349455 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349459 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349464 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349470 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349473 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349477 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349482 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349512 */   GIR_RootConstrainSelectedInstOperands,
     /* 349513 */   // GIR_Coverage, 9057,
     /* 349513 */   GIR_EraseRootFromParent_Done,
     /* 349514 */ // Label 7052: @349514
     /* 349514 */ GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349602), // Rule ID 9058 //
     /* 349519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349529 */   // MIs[0] Operand 2
     /* 349529 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 349540 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349540 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349543 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349547 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349552 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349558 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349561 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349565 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349570 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349587 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349600 */   GIR_RootConstrainSelectedInstOperands,
     /* 349601 */   // GIR_Coverage, 9058,
     /* 349601 */   GIR_EraseRootFromParent_Done,
     /* 349602 */ // Label 7053: @349602
     /* 349602 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349690), // Rule ID 9059 //
     /* 349607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349617 */   // MIs[0] Operand 2
     /* 349617 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 349628 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349628 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349631 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349635 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349640 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349658 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349675 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349688 */   GIR_RootConstrainSelectedInstOperands,
     /* 349689 */   // GIR_Coverage, 9059,
     /* 349689 */   GIR_EraseRootFromParent_Done,
     /* 349690 */ // Label 7054: @349690
     /* 349690 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349778), // Rule ID 9060 //
     /* 349695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349705 */   // MIs[0] Operand 2
     /* 349705 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349716 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349716 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349719 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349723 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349728 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349746 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349776 */   GIR_RootConstrainSelectedInstOperands,
     /* 349777 */   // GIR_Coverage, 9060,
     /* 349777 */   GIR_EraseRootFromParent_Done,
     /* 349778 */ // Label 7055: @349778
     /* 349778 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349866), // Rule ID 9061 //
     /* 349783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349793 */   // MIs[0] Operand 2
     /* 349793 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 349804 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349804 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349807 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349811 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349816 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349822 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349825 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349829 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349834 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349851 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349864 */   GIR_RootConstrainSelectedInstOperands,
     /* 349865 */   // GIR_Coverage, 9061,
     /* 349865 */   GIR_EraseRootFromParent_Done,
     /* 349866 */ // Label 7056: @349866
     /* 349866 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349954), // Rule ID 9062 //
     /* 349871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349881 */   // MIs[0] Operand 2
     /* 349881 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 349892 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349892 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349895 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349899 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349904 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349910 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349913 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349917 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349922 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349939 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349952 */   GIR_RootConstrainSelectedInstOperands,
     /* 349953 */   // GIR_Coverage, 9062,
     /* 349953 */   GIR_EraseRootFromParent_Done,
     /* 349954 */ // Label 7057: @349954
     /* 349954 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(350042), // Rule ID 9063 //
     /* 349959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349969 */   // MIs[0] Operand 2
     /* 349969 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 349980 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 349980 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 349983 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349987 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349992 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349998 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350001 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350005 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350010 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350027 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350040 */   GIR_RootConstrainSelectedInstOperands,
     /* 350041 */   // GIR_Coverage, 9063,
     /* 350041 */   GIR_EraseRootFromParent_Done,
     /* 350042 */ // Label 7058: @350042
     /* 350042 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(350130), // Rule ID 9064 //
     /* 350047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350057 */   // MIs[0] Operand 2
     /* 350057 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 350068 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350068 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350071 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350075 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350080 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350086 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350089 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350093 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350098 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350115 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350128 */   GIR_RootConstrainSelectedInstOperands,
     /* 350129 */   // GIR_Coverage, 9064,
     /* 350129 */   GIR_EraseRootFromParent_Done,
     /* 350130 */ // Label 7059: @350130
     /* 350130 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(350218), // Rule ID 9065 //
     /* 350135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350145 */   // MIs[0] Operand 2
     /* 350145 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 350156 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350156 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350159 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350163 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350168 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350174 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350177 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350181 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350186 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350203 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350216 */   GIR_RootConstrainSelectedInstOperands,
     /* 350217 */   // GIR_Coverage, 9065,
     /* 350217 */   GIR_EraseRootFromParent_Done,
     /* 350218 */ // Label 7060: @350218
     /* 350218 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(350306), // Rule ID 9066 //
     /* 350223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350233 */   // MIs[0] Operand 2
     /* 350233 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 350244 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350244 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350247 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350251 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350256 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350262 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350265 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350269 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350274 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350304 */   GIR_RootConstrainSelectedInstOperands,
     /* 350305 */   // GIR_Coverage, 9066,
     /* 350305 */   GIR_EraseRootFromParent_Done,
     /* 350306 */ // Label 7061: @350306
     /* 350306 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350394), // Rule ID 9067 //
     /* 350311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350321 */   // MIs[0] Operand 2
     /* 350321 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 350332 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350332 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350335 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350339 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350344 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350350 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350353 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350357 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350362 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350379 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350392 */   GIR_RootConstrainSelectedInstOperands,
     /* 350393 */   // GIR_Coverage, 9067,
     /* 350393 */   GIR_EraseRootFromParent_Done,
     /* 350394 */ // Label 7062: @350394
     /* 350394 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350482), // Rule ID 9068 //
     /* 350399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350409 */   // MIs[0] Operand 2
     /* 350409 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 350420 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350420 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350423 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350427 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350432 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350438 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350441 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350445 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350450 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350467 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350480 */   GIR_RootConstrainSelectedInstOperands,
     /* 350481 */   // GIR_Coverage, 9068,
     /* 350481 */   GIR_EraseRootFromParent_Done,
     /* 350482 */ // Label 7063: @350482
     /* 350482 */ GIM_Reject,
     /* 350483 */ // Label 6999: @350483
     /* 350483 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350518), // Rule ID 9019 //
     /* 350488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350498 */   // MIs[0] Operand 2
     /* 350498 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350509 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 350509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350514 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 350516 */   GIR_RootConstrainSelectedInstOperands,
     /* 350517 */   // GIR_Coverage, 9019,
     /* 350517 */   GIR_EraseRootFromParent_Done,
     /* 350518 */ // Label 7064: @350518
     /* 350518 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350553), // Rule ID 9020 //
     /* 350523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350533 */   // MIs[0] Operand 2
     /* 350533 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350544 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 350544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 350551 */   GIR_RootConstrainSelectedInstOperands,
     /* 350552 */   // GIR_Coverage, 9020,
     /* 350552 */   GIR_EraseRootFromParent_Done,
     /* 350553 */ // Label 7065: @350553
     /* 350553 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350607), // Rule ID 9029 //
     /* 350558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350568 */   // MIs[0] Operand 2
     /* 350568 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350579 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350605 */   GIR_RootConstrainSelectedInstOperands,
     /* 350606 */   // GIR_Coverage, 9029,
     /* 350606 */   GIR_EraseRootFromParent_Done,
     /* 350607 */ // Label 7066: @350607
     /* 350607 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350661), // Rule ID 9030 //
     /* 350612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350622 */   // MIs[0] Operand 2
     /* 350622 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350633 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350659 */   GIR_RootConstrainSelectedInstOperands,
     /* 350660 */   // GIR_Coverage, 9030,
     /* 350660 */   GIR_EraseRootFromParent_Done,
     /* 350661 */ // Label 7067: @350661
     /* 350661 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350715), // Rule ID 9031 //
     /* 350666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350676 */   // MIs[0] Operand 2
     /* 350676 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350687 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350699 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350713 */   GIR_RootConstrainSelectedInstOperands,
     /* 350714 */   // GIR_Coverage, 9031,
     /* 350714 */   GIR_EraseRootFromParent_Done,
     /* 350715 */ // Label 7068: @350715
     /* 350715 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350769), // Rule ID 9032 //
     /* 350720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350730 */   // MIs[0] Operand 2
     /* 350730 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350741 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 350741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350767 */   GIR_RootConstrainSelectedInstOperands,
     /* 350768 */   // GIR_Coverage, 9032,
     /* 350768 */   GIR_EraseRootFromParent_Done,
     /* 350769 */ // Label 7069: @350769
     /* 350769 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350840), // Rule ID 9045 //
     /* 350774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350784 */   // MIs[0] Operand 2
     /* 350784 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350795 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350807 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350825 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350838 */   GIR_RootConstrainSelectedInstOperands,
     /* 350839 */   // GIR_Coverage, 9045,
     /* 350839 */   GIR_EraseRootFromParent_Done,
     /* 350840 */ // Label 7070: @350840
     /* 350840 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350911), // Rule ID 9046 //
     /* 350845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350855 */   // MIs[0] Operand 2
     /* 350855 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350866 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350866 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350869 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350873 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350878 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350909 */   GIR_RootConstrainSelectedInstOperands,
     /* 350910 */   // GIR_Coverage, 9046,
     /* 350910 */   GIR_EraseRootFromParent_Done,
     /* 350911 */ // Label 7071: @350911
     /* 350911 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350982), // Rule ID 9047 //
     /* 350916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350926 */   // MIs[0] Operand 2
     /* 350926 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350937 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 350937 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350940 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350944 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350949 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350980 */   GIR_RootConstrainSelectedInstOperands,
     /* 350981 */   // GIR_Coverage, 9047,
     /* 350981 */   GIR_EraseRootFromParent_Done,
     /* 350982 */ // Label 7072: @350982
     /* 350982 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(351053), // Rule ID 9048 //
     /* 350987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350997 */   // MIs[0] Operand 2
     /* 350997 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351008 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351008 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351011 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351015 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351020 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351051 */   GIR_RootConstrainSelectedInstOperands,
     /* 351052 */   // GIR_Coverage, 9048,
     /* 351052 */   GIR_EraseRootFromParent_Done,
     /* 351053 */ // Label 7073: @351053
     /* 351053 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(351124), // Rule ID 9049 //
     /* 351058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351068 */   // MIs[0] Operand 2
     /* 351068 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351079 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351079 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351082 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351086 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351091 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351109 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351122 */   GIR_RootConstrainSelectedInstOperands,
     /* 351123 */   // GIR_Coverage, 9049,
     /* 351123 */   GIR_EraseRootFromParent_Done,
     /* 351124 */ // Label 7074: @351124
     /* 351124 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(351195), // Rule ID 9050 //
     /* 351129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351139 */   // MIs[0] Operand 2
     /* 351139 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 351150 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351150 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351153 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351157 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351162 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351180 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351193 */   GIR_RootConstrainSelectedInstOperands,
     /* 351194 */   // GIR_Coverage, 9050,
     /* 351194 */   GIR_EraseRootFromParent_Done,
     /* 351195 */ // Label 7075: @351195
     /* 351195 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(351266), // Rule ID 9051 //
     /* 351200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351210 */   // MIs[0] Operand 2
     /* 351210 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351221 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351221 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351224 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351228 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351233 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351251 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351264 */   GIR_RootConstrainSelectedInstOperands,
     /* 351265 */   // GIR_Coverage, 9051,
     /* 351265 */   GIR_EraseRootFromParent_Done,
     /* 351266 */ // Label 7076: @351266
     /* 351266 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(351337), // Rule ID 9052 //
     /* 351271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351281 */   // MIs[0] Operand 2
     /* 351281 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351292 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351292 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351295 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351299 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351304 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351322 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351335 */   GIR_RootConstrainSelectedInstOperands,
     /* 351336 */   // GIR_Coverage, 9052,
     /* 351336 */   GIR_EraseRootFromParent_Done,
     /* 351337 */ // Label 7077: @351337
     /* 351337 */ GIM_Reject,
     /* 351338 */ // Label 7000: @351338
     /* 351338 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351373), // Rule ID 9069 //
     /* 351343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 351349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351353 */   // MIs[0] Operand 2
     /* 351353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351364 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 351364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351369 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351371 */   GIR_RootConstrainSelectedInstOperands,
     /* 351372 */   // GIR_Coverage, 9069,
     /* 351372 */   GIR_EraseRootFromParent_Done,
     /* 351373 */ // Label 7078: @351373
     /* 351373 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351408), // Rule ID 9070 //
     /* 351378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 351384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351388 */   // MIs[0] Operand 2
     /* 351388 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351399 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 351399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351404 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351406 */   GIR_RootConstrainSelectedInstOperands,
     /* 351407 */   // GIR_Coverage, 9070,
     /* 351407 */   GIR_EraseRootFromParent_Done,
     /* 351408 */ // Label 7079: @351408
     /* 351408 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351462), // Rule ID 9075 //
     /* 351413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351423 */   // MIs[0] Operand 2
     /* 351423 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351434 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 351441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351446 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351460 */   GIR_RootConstrainSelectedInstOperands,
     /* 351461 */   // GIR_Coverage, 9075,
     /* 351461 */   GIR_EraseRootFromParent_Done,
     /* 351462 */ // Label 7080: @351462
     /* 351462 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351516), // Rule ID 9076 //
     /* 351467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351477 */   // MIs[0] Operand 2
     /* 351477 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351488 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 351495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351500 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351514 */   GIR_RootConstrainSelectedInstOperands,
     /* 351515 */   // GIR_Coverage, 9076,
     /* 351515 */   GIR_EraseRootFromParent_Done,
     /* 351516 */ // Label 7081: @351516
     /* 351516 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351570), // Rule ID 9077 //
     /* 351521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351531 */   // MIs[0] Operand 2
     /* 351531 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351542 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 351549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351554 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351568 */   GIR_RootConstrainSelectedInstOperands,
     /* 351569 */   // GIR_Coverage, 9077,
     /* 351569 */   GIR_EraseRootFromParent_Done,
     /* 351570 */ // Label 7082: @351570
     /* 351570 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351624), // Rule ID 9078 //
     /* 351575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351585 */   // MIs[0] Operand 2
     /* 351585 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351596 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 351596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 351603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351608 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 351612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351622 */   GIR_RootConstrainSelectedInstOperands,
     /* 351623 */   // GIR_Coverage, 9078,
     /* 351623 */   GIR_EraseRootFromParent_Done,
     /* 351624 */ // Label 7083: @351624
     /* 351624 */ GIM_Reject,
     /* 351625 */ // Label 7001: @351625
     /* 351625 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351694),
     /* 351630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351637 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351665), // Rule ID 9073 //
     /* 351642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351645 */     // MIs[0] Operand 2
     /* 351645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351656 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 351656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 351659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351663 */     GIR_RootConstrainSelectedInstOperands,
     /* 351664 */     // GIR_Coverage, 9073,
     /* 351664 */     GIR_EraseRootFromParent_Done,
     /* 351665 */   // Label 7085: @351665
     /* 351665 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351693), // Rule ID 9074 //
     /* 351670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351673 */     // MIs[0] Operand 2
     /* 351673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351684 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 351684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 351687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 351691 */     GIR_RootConstrainSelectedInstOperands,
     /* 351692 */     // GIR_Coverage, 9074,
     /* 351692 */     GIR_EraseRootFromParent_Done,
     /* 351693 */   // Label 7086: @351693
     /* 351693 */   GIM_Reject,
     /* 351694 */ // Label 7084: @351694
     /* 351694 */ GIM_Reject,
     /* 351695 */ // Label 7002: @351695
     /* 351695 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351730), // Rule ID 9021 //
     /* 351700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351710 */   // MIs[0] Operand 2
     /* 351710 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351721 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 351721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351726 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351728 */   GIR_RootConstrainSelectedInstOperands,
     /* 351729 */   // GIR_Coverage, 9021,
     /* 351729 */   GIR_EraseRootFromParent_Done,
     /* 351730 */ // Label 7087: @351730
     /* 351730 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351765), // Rule ID 9022 //
     /* 351735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351745 */   // MIs[0] Operand 2
     /* 351745 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351756 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 351756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351761 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351763 */   GIR_RootConstrainSelectedInstOperands,
     /* 351764 */   // GIR_Coverage, 9022,
     /* 351764 */   GIR_EraseRootFromParent_Done,
     /* 351765 */ // Label 7088: @351765
     /* 351765 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351819), // Rule ID 9033 //
     /* 351770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351780 */   // MIs[0] Operand 2
     /* 351780 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351791 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351817 */   GIR_RootConstrainSelectedInstOperands,
     /* 351818 */   // GIR_Coverage, 9033,
     /* 351818 */   GIR_EraseRootFromParent_Done,
     /* 351819 */ // Label 7089: @351819
     /* 351819 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351873), // Rule ID 9034 //
     /* 351824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351834 */   // MIs[0] Operand 2
     /* 351834 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351845 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351857 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351871 */   GIR_RootConstrainSelectedInstOperands,
     /* 351872 */   // GIR_Coverage, 9034,
     /* 351872 */   GIR_EraseRootFromParent_Done,
     /* 351873 */ // Label 7090: @351873
     /* 351873 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351927), // Rule ID 9035 //
     /* 351878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351888 */   // MIs[0] Operand 2
     /* 351888 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351899 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351911 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351925 */   GIR_RootConstrainSelectedInstOperands,
     /* 351926 */   // GIR_Coverage, 9035,
     /* 351926 */   GIR_EraseRootFromParent_Done,
     /* 351927 */ // Label 7091: @351927
     /* 351927 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351981), // Rule ID 9036 //
     /* 351932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351942 */   // MIs[0] Operand 2
     /* 351942 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351953 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 351953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351965 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351979 */   GIR_RootConstrainSelectedInstOperands,
     /* 351980 */   // GIR_Coverage, 9036,
     /* 351980 */   GIR_EraseRootFromParent_Done,
     /* 351981 */ // Label 7092: @351981
     /* 351981 */ GIM_Reject,
     /* 351982 */ // Label 7003: @351982
     /* 351982 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(352051),
     /* 351987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351994 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(352022), // Rule ID 9071 //
     /* 351999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352002 */     // MIs[0] Operand 2
     /* 352002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352013 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352020 */     GIR_RootConstrainSelectedInstOperands,
     /* 352021 */     // GIR_Coverage, 9071,
     /* 352021 */     GIR_EraseRootFromParent_Done,
     /* 352022 */   // Label 7094: @352022
     /* 352022 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(352050), // Rule ID 9072 //
     /* 352027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352030 */     // MIs[0] Operand 2
     /* 352030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352041 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352048 */     GIR_RootConstrainSelectedInstOperands,
     /* 352049 */     // GIR_Coverage, 9072,
     /* 352049 */     GIR_EraseRootFromParent_Done,
     /* 352050 */   // Label 7095: @352050
     /* 352050 */   GIM_Reject,
     /* 352051 */ // Label 7093: @352051
     /* 352051 */ GIM_Reject,
     /* 352052 */ // Label 7004: @352052
     /* 352052 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(352121),
     /* 352057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352064 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352092), // Rule ID 9023 //
     /* 352069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352072 */     // MIs[0] Operand 2
     /* 352072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352083 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352090 */     GIR_RootConstrainSelectedInstOperands,
     /* 352091 */     // GIR_Coverage, 9023,
     /* 352091 */     GIR_EraseRootFromParent_Done,
     /* 352092 */   // Label 7097: @352092
     /* 352092 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352120), // Rule ID 9024 //
     /* 352097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352100 */     // MIs[0] Operand 2
     /* 352100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352111 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352118 */     GIR_RootConstrainSelectedInstOperands,
     /* 352119 */     // GIR_Coverage, 9024,
     /* 352119 */     GIR_EraseRootFromParent_Done,
     /* 352120 */   // Label 7098: @352120
     /* 352120 */   GIM_Reject,
     /* 352121 */ // Label 7096: @352121
     /* 352121 */ GIM_Reject,
     /* 352122 */ // Label 7005: @352122
     /* 352122 */ GIM_Reject,
     /* 352123 */ // Label 90: @352123
     /* 352123 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7114*/ GIMT_Encode4(385044),
     /* 352134 */ /*GILLT_s64*//*Label 7099*/ GIMT_Encode4(352218), GIMT_Encode4(0),
     /* 352142 */ /*GILLT_v2s32*//*Label 7100*/ GIMT_Encode4(352928),
     /* 352146 */ /*GILLT_v2s64*//*Label 7101*/ GIMT_Encode4(356459),
     /* 352150 */ /*GILLT_v4s16*//*Label 7102*/ GIMT_Encode4(359700),
     /* 352154 */ /*GILLT_v4s32*//*Label 7103*/ GIMT_Encode4(363340),
     /* 352158 */ /*GILLT_v8s8*//*Label 7104*/ GIMT_Encode4(366408),
     /* 352162 */ /*GILLT_v8s16*//*Label 7105*/ GIMT_Encode4(369621),
     /* 352166 */ /*GILLT_v16s8*//*Label 7106*/ GIMT_Encode4(373040), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 352178 */ /*GILLT_nxv2s16*//*Label 7107*/ GIMT_Encode4(376244),
     /* 352182 */ /*GILLT_nxv2s32*//*Label 7108*/ GIMT_Encode4(376369),
     /* 352186 */ /*GILLT_nxv2s64*//*Label 7109*/ GIMT_Encode4(376494), GIMT_Encode4(0),
     /* 352194 */ /*GILLT_nxv4s16*//*Label 7110*/ GIMT_Encode4(378472),
     /* 352198 */ /*GILLT_nxv4s32*//*Label 7111*/ GIMT_Encode4(378624), GIMT_Encode4(0),
     /* 352206 */ /*GILLT_nxv8s16*//*Label 7112*/ GIMT_Encode4(380656), GIMT_Encode4(0),
     /* 352214 */ /*GILLT_nxv16s8*//*Label 7113*/ GIMT_Encode4(382924),
     /* 352218 */ // Label 7099: @352218
     /* 352218 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(352927),
     /* 352223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 352226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352236 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(352366), // Rule ID 5746 //
     /* 352241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352274 */     // MIs[2] Operand 1
     /* 352274 */     // No operand predicates
     /* 352274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352282 */     // MIs[3] Operand 1
     /* 352282 */     // No operand predicates
     /* 352282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352284 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 352287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352303 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352311 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352365 */     // GIR_Coverage, 5746,
     /* 352365 */     GIR_EraseRootFromParent_Done,
     /* 352366 */   // Label 7116: @352366
     /* 352366 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(352527), // Rule ID 5747 //
     /* 352371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 352387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352404 */     // MIs[2] Operand 1
     /* 352404 */     // No operand predicates
     /* 352404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352412 */     // MIs[3] Operand 1
     /* 352412 */     // No operand predicates
     /* 352412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352414 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352414 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352417 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352421 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352426 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352429 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352433 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352436 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352441 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352458 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352461 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352465 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352526 */     // GIR_Coverage, 5747,
     /* 352526 */     GIR_EraseRootFromParent_Done,
     /* 352527 */   // Label 7117: @352527
     /* 352527 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(352657), // Rule ID 5786 //
     /* 352532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352565 */     // MIs[2] Operand 1
     /* 352565 */     // No operand predicates
     /* 352565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352573 */     // MIs[3] Operand 1
     /* 352573 */     // No operand predicates
     /* 352573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352575 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 352578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352587 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352656 */     // GIR_Coverage, 5786,
     /* 352656 */     GIR_EraseRootFromParent_Done,
     /* 352657 */   // Label 7118: @352657
     /* 352657 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(352818), // Rule ID 5787 //
     /* 352662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 352678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352695 */     // MIs[2] Operand 1
     /* 352695 */     // No operand predicates
     /* 352695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352703 */     // MIs[3] Operand 1
     /* 352703 */     // No operand predicates
     /* 352703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352705 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 352705 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 352708 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352712 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352717 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 352720 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352724 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 352727 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352732 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 352740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352749 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 352752 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 352756 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 352759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 352772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 352776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 352787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 352790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 352793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352817 */     // GIR_Coverage, 5787,
     /* 352817 */     GIR_EraseRootFromParent_Done,
     /* 352818 */   // Label 7119: @352818
     /* 352818 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(352854), // Rule ID 6699 //
     /* 352823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352841 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 352841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352853 */     // GIR_Coverage, 6699,
     /* 352853 */     GIR_EraseRootFromParent_Done,
     /* 352854 */   // Label 7120: @352854
     /* 352854 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(352890), // Rule ID 6701 //
     /* 352859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352877 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 352877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352889 */     // GIR_Coverage, 6701,
     /* 352889 */     GIR_EraseRootFromParent_Done,
     /* 352890 */   // Label 7121: @352890
     /* 352890 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(352926), // Rule ID 6703 //
     /* 352895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352913 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 352913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352916 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 352918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 352920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352925 */     // GIR_Coverage, 6703,
     /* 352925 */     GIR_EraseRootFromParent_Done,
     /* 352926 */   // Label 7122: @352926
     /* 352926 */   GIM_Reject,
     /* 352927 */ // Label 7115: @352927
     /* 352927 */ GIM_Reject,
     /* 352928 */ // Label 7100: @352928
     /* 352928 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(356458),
     /* 352933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 352936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352946 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353055), // Rule ID 4305 //
     /* 352951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352955 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352961 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352971 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352978 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 352995 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353022 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353054 */     // GIR_Coverage, 4305,
     /* 353054 */     GIR_EraseRootFromParent_Done,
     /* 353055 */   // Label 7124: @353055
     /* 353055 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(353164), // Rule ID 4306 //
     /* 353060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353080 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353087 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353104 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353163 */     // GIR_Coverage, 4306,
     /* 353163 */     GIR_EraseRootFromParent_Done,
     /* 353164 */   // Label 7125: @353164
     /* 353164 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(353273), // Rule ID 4413 //
     /* 353169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353173 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353179 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353196 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353213 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353240 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353272 */     // GIR_Coverage, 4413,
     /* 353272 */     GIR_EraseRootFromParent_Done,
     /* 353273 */   // Label 7126: @353273
     /* 353273 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(353382), // Rule ID 4414 //
     /* 353278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353322 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353381 */     // GIR_Coverage, 4414,
     /* 353381 */     GIR_EraseRootFromParent_Done,
     /* 353382 */   // Label 7127: @353382
     /* 353382 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(353487), // Rule ID 4311 //
     /* 353387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353427 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353454 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353486 */     // GIR_Coverage, 4311,
     /* 353486 */     GIR_EraseRootFromParent_Done,
     /* 353487 */   // Label 7128: @353487
     /* 353487 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(353592), // Rule ID 4313 //
     /* 353492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353508 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353515 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353532 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353559 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353591 */     // GIR_Coverage, 4313,
     /* 353591 */     GIR_EraseRootFromParent_Done,
     /* 353592 */   // Label 7129: @353592
     /* 353592 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(353697), // Rule ID 4419 //
     /* 353597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353613 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353620 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353637 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353664 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353696 */     // GIR_Coverage, 4419,
     /* 353696 */     GIR_EraseRootFromParent_Done,
     /* 353697 */   // Label 7130: @353697
     /* 353697 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(353802), // Rule ID 4421 //
     /* 353702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353718 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353725 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 353742 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 353749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353769 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353801 */     // GIR_Coverage, 4421,
     /* 353801 */     GIR_EraseRootFromParent_Done,
     /* 353802 */   // Label 7131: @353802
     /* 353802 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(353906), // Rule ID 4303 //
     /* 353807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353811 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353817 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353827 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353834 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 353851 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 353851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 353858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353873 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353905 */     // GIR_Coverage, 4303,
     /* 353905 */     GIR_EraseRootFromParent_Done,
     /* 353906 */   // Label 7132: @353906
     /* 353906 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354010), // Rule ID 4304 //
     /* 353911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353938 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 353955 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 353955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 353962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353977 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354009 */     // GIR_Coverage, 4304,
     /* 354009 */     GIR_EraseRootFromParent_Done,
     /* 354010 */   // Label 7133: @354010
     /* 354010 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(354114), // Rule ID 4411 //
     /* 354015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354059 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354081 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354113 */     // GIR_Coverage, 4411,
     /* 354113 */     GIR_EraseRootFromParent_Done,
     /* 354114 */   // Label 7134: @354114
     /* 354114 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(354218), // Rule ID 4412 //
     /* 354119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354129 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354139 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354146 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354163 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354185 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354217 */     // GIR_Coverage, 4412,
     /* 354217 */     GIR_EraseRootFromParent_Done,
     /* 354218 */   // Label 7135: @354218
     /* 354218 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354318), // Rule ID 4307 //
     /* 354223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354239 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354263 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354317 */     // GIR_Coverage, 4307,
     /* 354317 */     GIR_EraseRootFromParent_Done,
     /* 354318 */   // Label 7136: @354318
     /* 354318 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(354418), // Rule ID 4309 //
     /* 354323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354363 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354385 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354417 */     // GIR_Coverage, 4309,
     /* 354417 */     GIR_EraseRootFromParent_Done,
     /* 354418 */   // Label 7137: @354418
     /* 354418 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354518), // Rule ID 4415 //
     /* 354423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354442 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354446 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354463 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354485 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354517 */     // GIR_Coverage, 4415,
     /* 354517 */     GIR_EraseRootFromParent_Done,
     /* 354518 */   // Label 7138: @354518
     /* 354518 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354618), // Rule ID 4417 //
     /* 354523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354539 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354563 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354617 */     // GIR_Coverage, 4417,
     /* 354617 */     GIR_EraseRootFromParent_Done,
     /* 354618 */   // Label 7139: @354618
     /* 354618 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354738), // Rule ID 6477 //
     /* 354623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354642 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354645 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354649 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354656 */     // MIs[2] Rn
     /* 354656 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 354660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354671 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 354671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 354674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 354692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354700 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 354703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354707 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354720 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354737 */     // GIR_Coverage, 6477,
     /* 354737 */     GIR_EraseRootFromParent_Done,
     /* 354738 */   // Label 7140: @354738
     /* 354738 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354858), // Rule ID 6479 //
     /* 354743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354762 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354765 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354769 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 354776 */     // MIs[2] Rn
     /* 354776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 354780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354791 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 354791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 354794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 354812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 354823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 354827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354857 */     // GIR_Coverage, 6479,
     /* 354857 */     GIR_EraseRootFromParent_Done,
     /* 354858 */   // Label 7141: @354858
     /* 354858 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354988), // Rule ID 5738 //
     /* 354863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 354879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354896 */     // MIs[2] Operand 1
     /* 354896 */     // No operand predicates
     /* 354896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354904 */     // MIs[3] Operand 1
     /* 354904 */     // No operand predicates
     /* 354904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354906 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 354909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354918 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354921 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354925 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 354945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354970 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354987 */     // GIR_Coverage, 5738,
     /* 354987 */     GIR_EraseRootFromParent_Done,
     /* 354988 */   // Label 7142: @354988
     /* 354988 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(355149), // Rule ID 5739 //
     /* 354993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355026 */     // MIs[2] Operand 1
     /* 355026 */     // No operand predicates
     /* 355026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355034 */     // MIs[3] Operand 1
     /* 355034 */     // No operand predicates
     /* 355034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355036 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355036 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355039 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355043 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355048 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355051 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355055 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355058 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355063 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355131 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355148 */     // GIR_Coverage, 5739,
     /* 355148 */     GIR_EraseRootFromParent_Done,
     /* 355149 */   // Label 7143: @355149
     /* 355149 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(355279), // Rule ID 5778 //
     /* 355154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355187 */     // MIs[2] Operand 1
     /* 355187 */     // No operand predicates
     /* 355187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355195 */     // MIs[3] Operand 1
     /* 355195 */     // No operand predicates
     /* 355195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355197 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355209 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355278 */     // GIR_Coverage, 5778,
     /* 355278 */     GIR_EraseRootFromParent_Done,
     /* 355279 */   // Label 7144: @355279
     /* 355279 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(355440), // Rule ID 5779 //
     /* 355284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355317 */     // MIs[2] Operand 1
     /* 355317 */     // No operand predicates
     /* 355317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355325 */     // MIs[3] Operand 1
     /* 355325 */     // No operand predicates
     /* 355325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355327 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355339 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355342 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355346 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355349 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355354 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355422 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355439 */     // GIR_Coverage, 5779,
     /* 355439 */     GIR_EraseRootFromParent_Done,
     /* 355440 */   // Label 7145: @355440
     /* 355440 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(355506), // Rule ID 5689 //
     /* 355445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355463 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 355463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 355466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355505 */     // GIR_Coverage, 5689,
     /* 355505 */     GIR_EraseRootFromParent_Done,
     /* 355506 */   // Label 7146: @355506
     /* 355506 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(355572), // Rule ID 5701 //
     /* 355511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355529 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 355529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 355532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 355553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355571 */     // GIR_Coverage, 5701,
     /* 355571 */     GIR_EraseRootFromParent_Done,
     /* 355572 */   // Label 7147: @355572
     /* 355572 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(355707), // Rule ID 5709 //
     /* 355577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 355589 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 355593 */     // MIs[1] Operand 1
     /* 355593 */     // No operand predicates
     /* 355593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355605 */     // MIs[2] Operand 1
     /* 355605 */     // No operand predicates
     /* 355605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355607 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 355607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 355610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 355636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 355640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 355665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 355676 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 355682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355706 */     // GIR_Coverage, 5709,
     /* 355706 */     GIR_EraseRootFromParent_Done,
     /* 355707 */   // Label 7148: @355707
     /* 355707 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(355839), // Rule ID 6486 //
     /* 355712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355731 */     // MIs[1] Rn
     /* 355731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355748 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355752 */     // MIs[2] Operand 1
     /* 355752 */     // No operand predicates
     /* 355752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355754 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355754 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355757 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355761 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355766 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355769 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 355773 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355781 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 355793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 355804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355808 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355838 */     // GIR_Coverage, 6486,
     /* 355838 */     GIR_EraseRootFromParent_Done,
     /* 355839 */   // Label 7149: @355839
     /* 355839 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355971), // Rule ID 6487 //
     /* 355844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 355863 */     // MIs[1] Rn
     /* 355863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 355867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 355884 */     // MIs[2] Operand 1
     /* 355884 */     // No operand predicates
     /* 355884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355886 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355898 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 355905 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 355925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 355936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355970 */     // GIR_Coverage, 6487,
     /* 355970 */     GIR_EraseRootFromParent_Done,
     /* 355971 */   // Label 7150: @355971
     /* 355971 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(356154), // Rule ID 5789 //
     /* 355976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 355984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 355997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356001 */     // MIs[2] Operand 1
     /* 356001 */     // No operand predicates
     /* 356001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356003 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356003 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 356006 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356010 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 356020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356029 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356032 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 356036 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356039 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356044 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356049 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356080 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 356123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356153 */     // GIR_Coverage, 5789,
     /* 356153 */     GIR_EraseRootFromParent_Done,
     /* 356154 */   // Label 7151: @356154
     /* 356154 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(356332), // Rule ID 5712 //
     /* 356159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356179 */     // MIs[1] Operand 1
     /* 356179 */     // No operand predicates
     /* 356179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356181 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356181 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356184 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356188 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356195 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356198 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356202 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356207 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356210 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356214 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356217 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356222 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356227 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356232 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356235 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356239 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356261 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356265 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 356301 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356314 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356331 */     // GIR_Coverage, 5712,
     /* 356331 */     GIR_EraseRootFromParent_Done,
     /* 356332 */   // Label 7152: @356332
     /* 356332 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(356457), // Rule ID 5715 //
     /* 356337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356357 */     // MIs[1] Operand 1
     /* 356357 */     // No operand predicates
     /* 356357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356359 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 356359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 356417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 356428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356456 */     // GIR_Coverage, 5715,
     /* 356456 */     GIR_EraseRootFromParent_Done,
     /* 356457 */   // Label 7153: @356457
     /* 356457 */   GIM_Reject,
     /* 356458 */ // Label 7123: @356458
     /* 356458 */ GIM_Reject,
     /* 356459 */ // Label 7101: @356459
     /* 356459 */ GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(359699),
     /* 356464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 356470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356477 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(356586), // Rule ID 4329 //
     /* 356482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356502 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356509 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356526 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356553 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356585 */     // GIR_Coverage, 4329,
     /* 356585 */     GIR_EraseRootFromParent_Done,
     /* 356586 */   // Label 7155: @356586
     /* 356586 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(356695), // Rule ID 4330 //
     /* 356591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356618 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 356635 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 356642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356662 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356694 */     // GIR_Coverage, 4330,
     /* 356694 */     GIR_EraseRootFromParent_Done,
     /* 356695 */   // Label 7156: @356695
     /* 356695 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(356804), // Rule ID 4437 //
     /* 356700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356744 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356803 */     // GIR_Coverage, 4437,
     /* 356803 */     GIR_EraseRootFromParent_Done,
     /* 356804 */   // Label 7157: @356804
     /* 356804 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356913), // Rule ID 4438 //
     /* 356809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356829 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356836 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 356853 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 356860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356880 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356912 */     // GIR_Coverage, 4438,
     /* 356912 */     GIR_EraseRootFromParent_Done,
     /* 356913 */   // Label 7158: @356913
     /* 356913 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(357018), // Rule ID 4335 //
     /* 356918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356934 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356937 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356941 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356958 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356985 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357017 */     // GIR_Coverage, 4335,
     /* 357017 */     GIR_EraseRootFromParent_Done,
     /* 357018 */   // Label 7159: @357018
     /* 357018 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(357123), // Rule ID 4337 //
     /* 357023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357039 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357046 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357063 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357090 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357122 */     // GIR_Coverage, 4337,
     /* 357122 */     GIR_EraseRootFromParent_Done,
     /* 357123 */   // Label 7160: @357123
     /* 357123 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357228), // Rule ID 4443 //
     /* 357128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357144 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357168 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357195 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357227 */     // GIR_Coverage, 4443,
     /* 357227 */     GIR_EraseRootFromParent_Done,
     /* 357228 */   // Label 7161: @357228
     /* 357228 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(357333), // Rule ID 4445 //
     /* 357233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357249 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357273 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357300 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357332 */     // GIR_Coverage, 4445,
     /* 357332 */     GIR_EraseRootFromParent_Done,
     /* 357333 */   // Label 7162: @357333
     /* 357333 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(357437), // Rule ID 4327 //
     /* 357338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357358 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357382 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357436 */     // GIR_Coverage, 4327,
     /* 357436 */     GIR_EraseRootFromParent_Done,
     /* 357437 */   // Label 7163: @357437
     /* 357437 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(357541), // Rule ID 4328 //
     /* 357442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357446 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357462 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357469 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357486 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357508 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357540 */     // GIR_Coverage, 4328,
     /* 357540 */     GIR_EraseRootFromParent_Done,
     /* 357541 */   // Label 7164: @357541
     /* 357541 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(357645), // Rule ID 4435 //
     /* 357546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357550 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357556 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357566 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357573 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357590 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357612 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357644 */     // GIR_Coverage, 4435,
     /* 357644 */     GIR_EraseRootFromParent_Done,
     /* 357645 */   // Label 7165: @357645
     /* 357645 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357749), // Rule ID 4436 //
     /* 357650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357654 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357660 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357670 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357677 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357694 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357716 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357748 */     // GIR_Coverage, 4436,
     /* 357748 */     GIR_EraseRootFromParent_Done,
     /* 357749 */   // Label 7166: @357749
     /* 357749 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357849), // Rule ID 4331 //
     /* 357754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357770 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357777 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357794 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357816 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357848 */     // GIR_Coverage, 4331,
     /* 357848 */     GIR_EraseRootFromParent_Done,
     /* 357849 */   // Label 7167: @357849
     /* 357849 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(357949), // Rule ID 4333 //
     /* 357854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357877 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357894 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357916 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357948 */     // GIR_Coverage, 4333,
     /* 357948 */     GIR_EraseRootFromParent_Done,
     /* 357949 */   // Label 7168: @357949
     /* 357949 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(358049), // Rule ID 4439 //
     /* 357954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357970 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357977 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357994 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358016 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358048 */     // GIR_Coverage, 4439,
     /* 358048 */     GIR_EraseRootFromParent_Done,
     /* 358049 */   // Label 7169: @358049
     /* 358049 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(358149), // Rule ID 4441 //
     /* 358054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358070 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358077 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358094 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358148 */     // GIR_Coverage, 4441,
     /* 358148 */     GIR_EraseRootFromParent_Done,
     /* 358149 */   // Label 7170: @358149
     /* 358149 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(358262), // Rule ID 5744 //
     /* 358154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358191 */     // MIs[3] Operand 1
     /* 358191 */     // No operand predicates
     /* 358191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358197 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 358200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 358204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358209 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 358216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 358243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358261 */     // GIR_Coverage, 5744,
     /* 358261 */     GIR_EraseRootFromParent_Done,
     /* 358262 */   // Label 7171: @358262
     /* 358262 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(358375), // Rule ID 5784 //
     /* 358267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358304 */     // MIs[3] Operand 1
     /* 358304 */     // No operand predicates
     /* 358304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358310 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 358313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 358317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358322 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 358329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 358356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358374 */     // GIR_Coverage, 5784,
     /* 358374 */     GIR_EraseRootFromParent_Done,
     /* 358375 */   // Label 7172: @358375
     /* 358375 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(358453), // Rule ID 1941 //
     /* 358380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358420 */     // MIs[2] Operand 1
     /* 358420 */     // No operand predicates
     /* 358420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358428 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358432 */     // MIs[3] Operand 1
     /* 358432 */     // No operand predicates
     /* 358432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358434 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 358434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 358441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 358444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 358451 */     GIR_RootConstrainSelectedInstOperands,
     /* 358452 */     // GIR_Coverage, 1941,
     /* 358452 */     GIR_EraseRootFromParent_Done,
     /* 358453 */   // Label 7173: @358453
     /* 358453 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(358548), // Rule ID 7466 //
     /* 358458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 358461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 358473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358485 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 358488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358492 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 358499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 358502 */     // MIs[2] Rn
     /* 358502 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 358506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358519 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358523 */     // MIs[3] Operand 1
     /* 358523 */     // No operand predicates
     /* 358523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358525 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15830>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 358525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 358528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 358532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 358535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 358539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 358546 */     GIR_RootConstrainSelectedInstOperands,
     /* 358547 */     // GIR_Coverage, 7466,
     /* 358547 */     GIR_EraseRootFromParent_Done,
     /* 358548 */   // Label 7174: @358548
     /* 358548 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(358637), // Rule ID 5741 //
     /* 358553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358577 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358581 */     // MIs[2] Operand 1
     /* 358581 */     // No operand predicates
     /* 358581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358589 */     // MIs[3] Operand 1
     /* 358589 */     // No operand predicates
     /* 358589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358591 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 358591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358603 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 358609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358635 */     GIR_RootConstrainSelectedInstOperands,
     /* 358636 */     // GIR_Coverage, 5741,
     /* 358636 */     GIR_EraseRootFromParent_Done,
     /* 358637 */   // Label 7175: @358637
     /* 358637 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358726), // Rule ID 5781 //
     /* 358642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 358670 */     // MIs[2] Operand 1
     /* 358670 */     // No operand predicates
     /* 358670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358678 */     // MIs[3] Operand 1
     /* 358678 */     // No operand predicates
     /* 358678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358680 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 358680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358692 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 358698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358724 */     GIR_RootConstrainSelectedInstOperands,
     /* 358725 */     // GIR_Coverage, 5781,
     /* 358725 */     GIR_EraseRootFromParent_Done,
     /* 358726 */   // Label 7176: @358726
     /* 358726 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358793), // Rule ID 5743 //
     /* 358731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358764 */     // MIs[2] Operand 1
     /* 358764 */     // No operand predicates
     /* 358764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358772 */     // MIs[3] Operand 1
     /* 358772 */     // No operand predicates
     /* 358772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358774 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 358774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358779 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358791 */     GIR_RootConstrainSelectedInstOperands,
     /* 358792 */     // GIR_Coverage, 5743,
     /* 358792 */     GIR_EraseRootFromParent_Done,
     /* 358793 */   // Label 7177: @358793
     /* 358793 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358891), // Rule ID 5745 //
     /* 358798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358831 */     // MIs[2] Operand 1
     /* 358831 */     // No operand predicates
     /* 358831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358839 */     // MIs[3] Operand 1
     /* 358839 */     // No operand predicates
     /* 358839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358841 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 358841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 358844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 358856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358889 */     GIR_RootConstrainSelectedInstOperands,
     /* 358890 */     // GIR_Coverage, 5745,
     /* 358890 */     GIR_EraseRootFromParent_Done,
     /* 358891 */   // Label 7178: @358891
     /* 358891 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358958), // Rule ID 5783 //
     /* 358896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358929 */     // MIs[2] Operand 1
     /* 358929 */     // No operand predicates
     /* 358929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358937 */     // MIs[3] Operand 1
     /* 358937 */     // No operand predicates
     /* 358937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358939 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 358939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 358942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 358946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 358949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 358956 */     GIR_RootConstrainSelectedInstOperands,
     /* 358957 */     // GIR_Coverage, 5783,
     /* 358957 */     GIR_EraseRootFromParent_Done,
     /* 358958 */   // Label 7179: @358958
     /* 358958 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(359056), // Rule ID 5785 //
     /* 358963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 358979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358996 */     // MIs[2] Operand 1
     /* 358996 */     // No operand predicates
     /* 358996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359004 */     // MIs[3] Operand 1
     /* 359004 */     // No operand predicates
     /* 359004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359006 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 359006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359018 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359054 */     GIR_RootConstrainSelectedInstOperands,
     /* 359055 */     // GIR_Coverage, 5785,
     /* 359055 */     GIR_EraseRootFromParent_Done,
     /* 359056 */   // Label 7180: @359056
     /* 359056 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(359122), // Rule ID 5693 //
     /* 359061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359079 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 359079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359121 */     // GIR_Coverage, 5693,
     /* 359121 */     GIR_EraseRootFromParent_Done,
     /* 359122 */   // Label 7181: @359122
     /* 359122 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(359188), // Rule ID 5703 //
     /* 359127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359145 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 359145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359187 */     // GIR_Coverage, 5703,
     /* 359187 */     GIR_EraseRootFromParent_Done,
     /* 359188 */   // Label 7182: @359188
     /* 359188 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(359257), // Rule ID 6468 //
     /* 359193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359212 */     // MIs[1] Rn
     /* 359212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359233 */     // MIs[2] Operand 1
     /* 359233 */     // No operand predicates
     /* 359233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359235 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359255 */     GIR_RootConstrainSelectedInstOperands,
     /* 359256 */     // GIR_Coverage, 6468,
     /* 359256 */     GIR_EraseRootFromParent_Done,
     /* 359257 */   // Label 7183: @359257
     /* 359257 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(359326), // Rule ID 6469 //
     /* 359262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359281 */     // MIs[1] Rn
     /* 359281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359302 */     // MIs[2] Operand 1
     /* 359302 */     // No operand predicates
     /* 359302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359304 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 359307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359324 */     GIR_RootConstrainSelectedInstOperands,
     /* 359325 */     // GIR_Coverage, 6469,
     /* 359325 */     GIR_EraseRootFromParent_Done,
     /* 359326 */   // Label 7184: @359326
     /* 359326 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(359408), // Rule ID 7465 //
     /* 359331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 359334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359346 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 359349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 359353 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 359360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 359363 */     // MIs[1] Rn
     /* 359363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 359367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359384 */     // MIs[2] Operand 1
     /* 359384 */     // No operand predicates
     /* 359384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359386 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15830>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 359389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 359396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359406 */     GIR_RootConstrainSelectedInstOperands,
     /* 359407 */     // GIR_Coverage, 7465,
     /* 359407 */     GIR_EraseRootFromParent_Done,
     /* 359408 */   // Label 7185: @359408
     /* 359408 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359457), // Rule ID 5710 //
     /* 359413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 359421 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 359425 */     // MIs[1] Operand 1
     /* 359425 */     // No operand predicates
     /* 359425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359433 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359437 */     // MIs[2] Operand 1
     /* 359437 */     // No operand predicates
     /* 359437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359439 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 359439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 359442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 359449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359455 */     GIR_RootConstrainSelectedInstOperands,
     /* 359456 */     // GIR_Coverage, 5710,
     /* 359456 */     GIR_EraseRootFromParent_Done,
     /* 359457 */   // Label 7186: @359457
     /* 359457 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359558), // Rule ID 5790 //
     /* 359462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 359470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 359483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359487 */     // MIs[2] Operand 1
     /* 359487 */     // No operand predicates
     /* 359487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359489 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 359489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 359522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 359550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359556 */     GIR_RootConstrainSelectedInstOperands,
     /* 359557 */     // GIR_Coverage, 5790,
     /* 359557 */     GIR_EraseRootFromParent_Done,
     /* 359558 */   // Label 7187: @359558
     /* 359558 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359602), // Rule ID 1937 //
     /* 359563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359586 */     // MIs[1] Operand 1
     /* 359586 */     // No operand predicates
     /* 359586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359588 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 359588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 359591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 359598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 359600 */     GIR_RootConstrainSelectedInstOperands,
     /* 359601 */     // GIR_Coverage, 1937,
     /* 359601 */     GIR_EraseRootFromParent_Done,
     /* 359602 */   // Label 7188: @359602
     /* 359602 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(359698), // Rule ID 5714 //
     /* 359607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359627 */     // MIs[1] Operand 1
     /* 359627 */     // No operand predicates
     /* 359627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359629 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 359629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 359632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359662 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 359690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359696 */     GIR_RootConstrainSelectedInstOperands,
     /* 359697 */     // GIR_Coverage, 5714,
     /* 359697 */     GIR_EraseRootFromParent_Done,
     /* 359698 */   // Label 7189: @359698
     /* 359698 */   GIM_Reject,
     /* 359699 */ // Label 7154: @359699
     /* 359699 */ GIM_Reject,
     /* 359700 */ // Label 7102: @359700
     /* 359700 */ GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(363339),
     /* 359705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359708 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359834), // Rule ID 4269 //
     /* 359713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359746 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359750 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359757 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 359774 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 359781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359801 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359833 */     // GIR_Coverage, 4269,
     /* 359833 */     GIR_EraseRootFromParent_Done,
     /* 359834 */   // Label 7191: @359834
     /* 359834 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359960), // Rule ID 4270 //
     /* 359839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359853 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359859 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359869 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359872 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359876 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359883 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 359900 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 359907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359927 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359959 */     // GIR_Coverage, 4270,
     /* 359959 */     GIR_EraseRootFromParent_Done,
     /* 359960 */   // Label 7192: @359960
     /* 359960 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(360079), // Rule ID 4377 //
     /* 359965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359985 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359995 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360019 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360078 */     // GIR_Coverage, 4377,
     /* 360078 */     GIR_EraseRootFromParent_Done,
     /* 360079 */   // Label 7193: @360079
     /* 360079 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(360198), // Rule ID 4378 //
     /* 360084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360098 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360104 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360114 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360138 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360197 */     // GIR_Coverage, 4378,
     /* 360197 */     GIR_EraseRootFromParent_Done,
     /* 360198 */   // Label 7194: @360198
     /* 360198 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360320), // Rule ID 4275 //
     /* 360203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360229 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360232 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360236 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360243 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360260 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360319 */     // GIR_Coverage, 4275,
     /* 360319 */     GIR_EraseRootFromParent_Done,
     /* 360320 */   // Label 7195: @360320
     /* 360320 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(360442), // Rule ID 4277 //
     /* 360325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360351 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360354 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360358 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360382 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360441 */     // GIR_Coverage, 4277,
     /* 360441 */     GIR_EraseRootFromParent_Done,
     /* 360442 */   // Label 7196: @360442
     /* 360442 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(360557), // Rule ID 4383 //
     /* 360447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360497 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360524 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360556 */     // GIR_Coverage, 4383,
     /* 360556 */     GIR_EraseRootFromParent_Done,
     /* 360557 */   // Label 7197: @360557
     /* 360557 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360672), // Rule ID 4385 //
     /* 360562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360588 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360595 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360612 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360639 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360671 */     // GIR_Coverage, 4385,
     /* 360671 */     GIR_EraseRootFromParent_Done,
     /* 360672 */   // Label 7198: @360672
     /* 360672 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(360793), // Rule ID 4267 //
     /* 360677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360707 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360710 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360714 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360721 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360738 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360792 */     // GIR_Coverage, 4267,
     /* 360792 */     GIR_EraseRootFromParent_Done,
     /* 360793 */   // Label 7199: @360793
     /* 360793 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(360914), // Rule ID 4268 //
     /* 360798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360812 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360818 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360831 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360835 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 360859 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 360859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 360866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360913 */     // GIR_Coverage, 4268,
     /* 360913 */     GIR_EraseRootFromParent_Done,
     /* 360914 */   // Label 7200: @360914
     /* 360914 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(361028), // Rule ID 4375 //
     /* 360919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360933 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360939 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360949 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360956 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360973 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360995 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361027 */     // GIR_Coverage, 4375,
     /* 361027 */     GIR_EraseRootFromParent_Done,
     /* 361028 */   // Label 7201: @361028
     /* 361028 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(361142), // Rule ID 4376 //
     /* 361033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361053 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361063 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361070 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361087 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361109 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361141 */     // GIR_Coverage, 4376,
     /* 361141 */     GIR_EraseRootFromParent_Done,
     /* 361142 */   // Label 7202: @361142
     /* 361142 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(361259), // Rule ID 4271 //
     /* 361147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361176 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361180 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361187 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361204 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361226 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361258 */     // GIR_Coverage, 4271,
     /* 361258 */     GIR_EraseRootFromParent_Done,
     /* 361259 */   // Label 7203: @361259
     /* 361259 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(361376), // Rule ID 4273 //
     /* 361264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361290 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361293 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361297 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361304 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361321 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361375 */     // GIR_Coverage, 4273,
     /* 361375 */     GIR_EraseRootFromParent_Done,
     /* 361376 */   // Label 7204: @361376
     /* 361376 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(361486), // Rule ID 4379 //
     /* 361381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361407 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361414 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361431 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361453 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361485 */     // GIR_Coverage, 4379,
     /* 361485 */     GIR_EraseRootFromParent_Done,
     /* 361486 */   // Label 7205: @361486
     /* 361486 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361596), // Rule ID 4381 //
     /* 361491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361517 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361541 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361595 */     // GIR_Coverage, 4381,
     /* 361595 */     GIR_EraseRootFromParent_Done,
     /* 361596 */   // Label 7206: @361596
     /* 361596 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361726), // Rule ID 6481 //
     /* 361601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361630 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361633 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361637 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361644 */     // MIs[2] Rn
     /* 361644 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 361648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361659 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 361659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 361662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 361680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 361691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361695 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 361715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361725 */     // GIR_Coverage, 6481,
     /* 361725 */     GIR_EraseRootFromParent_Done,
     /* 361726 */   // Label 7207: @361726
     /* 361726 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361866), // Rule ID 5730 //
     /* 361731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361774 */     // MIs[2] Operand 1
     /* 361774 */     // No operand predicates
     /* 361774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361782 */     // MIs[3] Operand 1
     /* 361782 */     // No operand predicates
     /* 361782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361784 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 361787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 361799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 361806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 361823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 361834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 361841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 361855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361865 */     // GIR_Coverage, 5730,
     /* 361865 */     GIR_EraseRootFromParent_Done,
     /* 361866 */   // Label 7208: @361866
     /* 361866 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(362037), // Rule ID 5731 //
     /* 361871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 361897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361914 */     // MIs[2] Operand 1
     /* 361914 */     // No operand predicates
     /* 361914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361922 */     // MIs[3] Operand 1
     /* 361922 */     // No operand predicates
     /* 361922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361924 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361924 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 361927 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361931 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361936 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 361939 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361943 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 361946 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361951 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 361959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 361971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361975 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 361978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 361995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362036 */     // GIR_Coverage, 5731,
     /* 362036 */     GIR_EraseRootFromParent_Done,
     /* 362037 */   // Label 7209: @362037
     /* 362037 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(362177), // Rule ID 5770 //
     /* 362042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362085 */     // MIs[2] Operand 1
     /* 362085 */     // No operand predicates
     /* 362085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362093 */     // MIs[3] Operand 1
     /* 362093 */     // No operand predicates
     /* 362093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362095 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362107 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362114 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362176 */     // GIR_Coverage, 5770,
     /* 362176 */     GIR_EraseRootFromParent_Done,
     /* 362177 */   // Label 7210: @362177
     /* 362177 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(362348), // Rule ID 5771 //
     /* 362182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362225 */     // MIs[2] Operand 1
     /* 362225 */     // No operand predicates
     /* 362225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362233 */     // MIs[3] Operand 1
     /* 362233 */     // No operand predicates
     /* 362233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362235 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362235 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 362238 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362242 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362247 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362250 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 362257 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362262 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362279 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362286 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362330 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362347 */     // GIR_Coverage, 5771,
     /* 362347 */     GIR_EraseRootFromParent_Done,
     /* 362348 */   // Label 7211: @362348
     /* 362348 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(362427), // Rule ID 5683 //
     /* 362353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362381 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 362381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 362384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 362397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 362416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362426 */     // GIR_Coverage, 5683,
     /* 362426 */     GIR_EraseRootFromParent_Done,
     /* 362427 */   // Label 7212: @362427
     /* 362427 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(362503), // Rule ID 5685 //
     /* 362432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362460 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 362460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 362463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362502 */     // GIR_Coverage, 5685,
     /* 362502 */     GIR_EraseRootFromParent_Done,
     /* 362503 */   // Label 7213: @362503
     /* 362503 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(362579), // Rule ID 5695 //
     /* 362508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362536 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 362536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 362539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362578 */     // GIR_Coverage, 5695,
     /* 362578 */     GIR_EraseRootFromParent_Done,
     /* 362579 */   // Label 7214: @362579
     /* 362579 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(362724), // Rule ID 5707 //
     /* 362584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 362606 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 362610 */     // MIs[1] Operand 1
     /* 362610 */     // No operand predicates
     /* 362610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362618 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362622 */     // MIs[2] Operand 1
     /* 362622 */     // No operand predicates
     /* 362622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362624 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 362624 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 362627 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362631 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362650 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 362653 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 362657 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 362682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 362693 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362706 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362723 */     // GIR_Coverage, 5707,
     /* 362723 */     GIR_EraseRootFromParent_Done,
     /* 362724 */   // Label 7215: @362724
     /* 362724 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362873), // Rule ID 6485 //
     /* 362729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362751 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362754 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362758 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362765 */     // MIs[1] Rn
     /* 362765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362786 */     // MIs[2] Operand 1
     /* 362786 */     // No operand predicates
     /* 362786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362788 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 362807 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 362827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 362838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362842 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362855 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362872 */     // GIR_Coverage, 6485,
     /* 362872 */     GIR_EraseRootFromParent_Done,
     /* 362873 */   // Label 7216: @362873
     /* 362873 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(363015), // Rule ID 6488 //
     /* 362878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362907 */     // MIs[1] Rn
     /* 362907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362924 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362928 */     // MIs[2] Operand 1
     /* 362928 */     // No operand predicates
     /* 362928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362930 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362942 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362945 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 362949 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 362969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 362980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362997 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363014 */     // GIR_Coverage, 6488,
     /* 363014 */     GIR_EraseRootFromParent_Done,
     /* 363015 */   // Label 7217: @363015
     /* 363015 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(363203), // Rule ID 5705 //
     /* 363020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363050 */     // MIs[1] Operand 1
     /* 363050 */     // No operand predicates
     /* 363050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363052 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 363052 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 363055 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363059 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363066 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 363069 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363073 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363078 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363081 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363085 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 363088 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363093 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363098 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363103 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363106 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363110 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363129 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363136 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363139 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363144 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363172 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 363175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363202 */     // GIR_Coverage, 5705,
     /* 363202 */     GIR_EraseRootFromParent_Done,
     /* 363203 */   // Label 7218: @363203
     /* 363203 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(363338), // Rule ID 5716 //
     /* 363208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363238 */     // MIs[1] Operand 1
     /* 363238 */     // No operand predicates
     /* 363238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363240 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 363240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 363298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 363309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363337 */     // GIR_Coverage, 5716,
     /* 363337 */     GIR_EraseRootFromParent_Done,
     /* 363338 */   // Label 7219: @363338
     /* 363338 */   GIM_Reject,
     /* 363339 */ // Label 7190: @363339
     /* 363339 */ GIM_Reject,
     /* 363340 */ // Label 7103: @363340
     /* 363340 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(366407),
     /* 363345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363358 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(363467), // Rule ID 4293 //
     /* 363363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363373 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363383 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363390 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363407 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363434 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363466 */     // GIR_Coverage, 4293,
     /* 363466 */     GIR_EraseRootFromParent_Done,
     /* 363467 */   // Label 7221: @363467
     /* 363467 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(363576), // Rule ID 4294 //
     /* 363472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363476 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363482 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363492 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363499 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363516 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363543 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363575 */     // GIR_Coverage, 4294,
     /* 363575 */     GIR_EraseRootFromParent_Done,
     /* 363576 */   // Label 7222: @363576
     /* 363576 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(363685), // Rule ID 4401 //
     /* 363581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363601 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363625 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363652 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363684 */     // GIR_Coverage, 4401,
     /* 363684 */     GIR_EraseRootFromParent_Done,
     /* 363685 */   // Label 7223: @363685
     /* 363685 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(363794), // Rule ID 4402 //
     /* 363690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363694 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363700 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363710 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363734 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363761 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363793 */     // GIR_Coverage, 4402,
     /* 363793 */     GIR_EraseRootFromParent_Done,
     /* 363794 */   // Label 7224: @363794
     /* 363794 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(363899), // Rule ID 4299 //
     /* 363799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363822 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 363839 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 363846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363866 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363898 */     // GIR_Coverage, 4299,
     /* 363898 */     GIR_EraseRootFromParent_Done,
     /* 363899 */   // Label 7225: @363899
     /* 363899 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(364004), // Rule ID 4301 //
     /* 363904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 363944 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 363944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 363951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363971 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364003 */     // GIR_Coverage, 4301,
     /* 364003 */     GIR_EraseRootFromParent_Done,
     /* 364004 */   // Label 7226: @364004
     /* 364004 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(364109), // Rule ID 4407 //
     /* 364009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364025 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364032 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364049 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364108 */     // GIR_Coverage, 4407,
     /* 364108 */     GIR_EraseRootFromParent_Done,
     /* 364109 */   // Label 7227: @364109
     /* 364109 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(364214), // Rule ID 4409 //
     /* 364114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364130 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364137 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364154 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364181 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364213 */     // GIR_Coverage, 4409,
     /* 364213 */     GIR_EraseRootFromParent_Done,
     /* 364214 */   // Label 7228: @364214
     /* 364214 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(364318), // Rule ID 4291 //
     /* 364219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364239 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364263 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364317 */     // GIR_Coverage, 4291,
     /* 364317 */     GIR_EraseRootFromParent_Done,
     /* 364318 */   // Label 7229: @364318
     /* 364318 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(364422), // Rule ID 4292 //
     /* 364323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364327 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364333 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364343 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364350 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364367 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364389 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364421 */     // GIR_Coverage, 4292,
     /* 364421 */     GIR_EraseRootFromParent_Done,
     /* 364422 */   // Label 7230: @364422
     /* 364422 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(364526), // Rule ID 4399 //
     /* 364427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364447 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364454 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364471 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364493 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364525 */     // GIR_Coverage, 4399,
     /* 364525 */     GIR_EraseRootFromParent_Done,
     /* 364526 */   // Label 7231: @364526
     /* 364526 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(364630), // Rule ID 4400 //
     /* 364531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364575 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364597 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364629 */     // GIR_Coverage, 4400,
     /* 364629 */     GIR_EraseRootFromParent_Done,
     /* 364630 */   // Label 7232: @364630
     /* 364630 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(364730), // Rule ID 4295 //
     /* 364635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364651 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364658 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364675 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364697 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364729 */     // GIR_Coverage, 4295,
     /* 364729 */     GIR_EraseRootFromParent_Done,
     /* 364730 */   // Label 7233: @364730
     /* 364730 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(364830), // Rule ID 4297 //
     /* 364735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364751 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364758 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364775 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364829 */     // GIR_Coverage, 4297,
     /* 364829 */     GIR_EraseRootFromParent_Done,
     /* 364830 */   // Label 7234: @364830
     /* 364830 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364930), // Rule ID 4403 //
     /* 364835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 364875 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 364875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 364882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364929 */     // GIR_Coverage, 4403,
     /* 364929 */     GIR_EraseRootFromParent_Done,
     /* 364930 */   // Label 7235: @364930
     /* 364930 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(365030), // Rule ID 4405 //
     /* 364935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 364975 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 364975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 364982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365029 */     // GIR_Coverage, 4405,
     /* 365029 */     GIR_EraseRootFromParent_Done,
     /* 365030 */   // Label 7236: @365030
     /* 365030 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(365143), // Rule ID 5736 //
     /* 365035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365072 */     // MIs[3] Operand 1
     /* 365072 */     // No operand predicates
     /* 365072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365078 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365142 */     // GIR_Coverage, 5736,
     /* 365142 */     GIR_EraseRootFromParent_Done,
     /* 365143 */   // Label 7237: @365143
     /* 365143 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(365256), // Rule ID 5776 //
     /* 365148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365185 */     // MIs[3] Operand 1
     /* 365185 */     // No operand predicates
     /* 365185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365191 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 365210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365255 */     // GIR_Coverage, 5776,
     /* 365255 */     GIR_EraseRootFromParent_Done,
     /* 365256 */   // Label 7238: @365256
     /* 365256 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(365334), // Rule ID 1940 //
     /* 365261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365301 */     // MIs[2] Operand 1
     /* 365301 */     // No operand predicates
     /* 365301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365313 */     // MIs[3] Operand 1
     /* 365313 */     // No operand predicates
     /* 365313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365315 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 365315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 365322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 365332 */     GIR_RootConstrainSelectedInstOperands,
     /* 365333 */     // GIR_Coverage, 1940,
     /* 365333 */     GIR_EraseRootFromParent_Done,
     /* 365334 */   // Label 7239: @365334
     /* 365334 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(365423), // Rule ID 5733 //
     /* 365339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365363 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365367 */     // MIs[2] Operand 1
     /* 365367 */     // No operand predicates
     /* 365367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365375 */     // MIs[3] Operand 1
     /* 365375 */     // No operand predicates
     /* 365375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365377 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 365377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365389 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 365395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365421 */     GIR_RootConstrainSelectedInstOperands,
     /* 365422 */     // GIR_Coverage, 5733,
     /* 365422 */     GIR_EraseRootFromParent_Done,
     /* 365423 */   // Label 7240: @365423
     /* 365423 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(365512), // Rule ID 5773 //
     /* 365428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365456 */     // MIs[2] Operand 1
     /* 365456 */     // No operand predicates
     /* 365456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365464 */     // MIs[3] Operand 1
     /* 365464 */     // No operand predicates
     /* 365464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365466 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 365466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365478 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 365484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365510 */     GIR_RootConstrainSelectedInstOperands,
     /* 365511 */     // GIR_Coverage, 5773,
     /* 365511 */     GIR_EraseRootFromParent_Done,
     /* 365512 */   // Label 7241: @365512
     /* 365512 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(365579), // Rule ID 5735 //
     /* 365517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365550 */     // MIs[2] Operand 1
     /* 365550 */     // No operand predicates
     /* 365550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365558 */     // MIs[3] Operand 1
     /* 365558 */     // No operand predicates
     /* 365558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365560 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 365560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365577 */     GIR_RootConstrainSelectedInstOperands,
     /* 365578 */     // GIR_Coverage, 5735,
     /* 365578 */     GIR_EraseRootFromParent_Done,
     /* 365579 */   // Label 7242: @365579
     /* 365579 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365677), // Rule ID 5737 //
     /* 365584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 365600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365617 */     // MIs[2] Operand 1
     /* 365617 */     // No operand predicates
     /* 365617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365625 */     // MIs[3] Operand 1
     /* 365625 */     // No operand predicates
     /* 365625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365627 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 365627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365675 */     GIR_RootConstrainSelectedInstOperands,
     /* 365676 */     // GIR_Coverage, 5737,
     /* 365676 */     GIR_EraseRootFromParent_Done,
     /* 365677 */   // Label 7243: @365677
     /* 365677 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(365744), // Rule ID 5775 //
     /* 365682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365715 */     // MIs[2] Operand 1
     /* 365715 */     // No operand predicates
     /* 365715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365723 */     // MIs[3] Operand 1
     /* 365723 */     // No operand predicates
     /* 365723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365725 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 365725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365742 */     GIR_RootConstrainSelectedInstOperands,
     /* 365743 */     // GIR_Coverage, 5775,
     /* 365743 */     GIR_EraseRootFromParent_Done,
     /* 365744 */   // Label 7244: @365744
     /* 365744 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365842), // Rule ID 5777 //
     /* 365749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 365765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365782 */     // MIs[2] Operand 1
     /* 365782 */     // No operand predicates
     /* 365782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 365786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365790 */     // MIs[3] Operand 1
     /* 365790 */     // No operand predicates
     /* 365790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365792 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 365792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 365827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 365831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 365834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 365840 */     GIR_RootConstrainSelectedInstOperands,
     /* 365841 */     // GIR_Coverage, 5777,
     /* 365841 */     GIR_EraseRootFromParent_Done,
     /* 365842 */   // Label 7245: @365842
     /* 365842 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365908), // Rule ID 5691 //
     /* 365847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365865 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 365865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365907 */     // GIR_Coverage, 5691,
     /* 365907 */     GIR_EraseRootFromParent_Done,
     /* 365908 */   // Label 7246: @365908
     /* 365908 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365974), // Rule ID 5699 //
     /* 365913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365931 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 365931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365973 */     // GIR_Coverage, 5699,
     /* 365973 */     GIR_EraseRootFromParent_Done,
     /* 365974 */   // Label 7247: @365974
     /* 365974 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(366027), // Rule ID 5708 //
     /* 365979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365991 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365995 */     // MIs[1] Operand 1
     /* 365995 */     // No operand predicates
     /* 365995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366007 */     // MIs[2] Operand 1
     /* 366007 */     // No operand predicates
     /* 366007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366009 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 366009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 366019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366025 */     GIR_RootConstrainSelectedInstOperands,
     /* 366026 */     // GIR_Coverage, 5708,
     /* 366026 */     GIR_EraseRootFromParent_Done,
     /* 366027 */   // Label 7248: @366027
     /* 366027 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(366096), // Rule ID 6466 //
     /* 366032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366051 */     // MIs[1] Rn
     /* 366051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366072 */     // MIs[2] Operand 1
     /* 366072 */     // No operand predicates
     /* 366072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366074 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366094 */     GIR_RootConstrainSelectedInstOperands,
     /* 366095 */     // GIR_Coverage, 6466,
     /* 366095 */     GIR_EraseRootFromParent_Done,
     /* 366096 */   // Label 7249: @366096
     /* 366096 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(366165), // Rule ID 6467 //
     /* 366101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366120 */     // MIs[1] Rn
     /* 366120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366141 */     // MIs[2] Operand 1
     /* 366141 */     // No operand predicates
     /* 366141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366143 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366163 */     GIR_RootConstrainSelectedInstOperands,
     /* 366164 */     // GIR_Coverage, 6467,
     /* 366164 */     GIR_EraseRootFromParent_Done,
     /* 366165 */   // Label 7250: @366165
     /* 366165 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(366266), // Rule ID 5788 //
     /* 366170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 366178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366195 */     // MIs[2] Operand 1
     /* 366195 */     // No operand predicates
     /* 366195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366197 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 366230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 366258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366264 */     GIR_RootConstrainSelectedInstOperands,
     /* 366265 */     // GIR_Coverage, 5788,
     /* 366265 */     GIR_EraseRootFromParent_Done,
     /* 366266 */   // Label 7251: @366266
     /* 366266 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(366310), // Rule ID 1936 //
     /* 366271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366294 */     // MIs[1] Operand 1
     /* 366294 */     // No operand predicates
     /* 366294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366296 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 366296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366308 */     GIR_RootConstrainSelectedInstOperands,
     /* 366309 */     // GIR_Coverage, 1936,
     /* 366309 */     GIR_EraseRootFromParent_Done,
     /* 366310 */   // Label 7252: @366310
     /* 366310 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(366406), // Rule ID 5713 //
     /* 366315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 366327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366335 */     // MIs[1] Operand 1
     /* 366335 */     // No operand predicates
     /* 366335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366337 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 366340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 366398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366404 */     GIR_RootConstrainSelectedInstOperands,
     /* 366405 */     // GIR_Coverage, 5713,
     /* 366405 */     GIR_EraseRootFromParent_Done,
     /* 366406 */   // Label 7253: @366406
     /* 366406 */   GIM_Reject,
     /* 366407 */ // Label 7220: @366407
     /* 366407 */ GIM_Reject,
     /* 366408 */ // Label 7104: @366408
     /* 366408 */ GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(369620),
     /* 366413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 366416 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(366535), // Rule ID 4197 //
     /* 366421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366441 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366451 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366458 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366475 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366502 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366534 */     // GIR_Coverage, 4197,
     /* 366534 */     GIR_EraseRootFromParent_Done,
     /* 366535 */   // Label 7255: @366535
     /* 366535 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(366654), // Rule ID 4198 //
     /* 366540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366554 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366560 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366570 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366577 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 366594 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 366601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366621 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366653 */     // GIR_Coverage, 4198,
     /* 366653 */     GIR_EraseRootFromParent_Done,
     /* 366654 */   // Label 7256: @366654
     /* 366654 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366780), // Rule ID 4233 //
     /* 366659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366689 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366692 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366696 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 366703 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366720 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366747 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366779 */     // GIR_Coverage, 4233,
     /* 366779 */     GIR_EraseRootFromParent_Done,
     /* 366780 */   // Label 7257: @366780
     /* 366780 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366906), // Rule ID 4234 //
     /* 366785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366818 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366822 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 366829 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 366846 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 366853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366873 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 366895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 366905 */     // GIR_Coverage, 4234,
     /* 366905 */     GIR_EraseRootFromParent_Done,
     /* 366906 */   // Label 7258: @366906
     /* 366906 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(367021), // Rule ID 4203 //
     /* 366911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 366914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366937 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 366961 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 366961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 366964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 366968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366988 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367020 */     // GIR_Coverage, 4203,
     /* 367020 */     GIR_EraseRootFromParent_Done,
     /* 367021 */   // Label 7259: @367021
     /* 367021 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(367136), // Rule ID 4205 //
     /* 367026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367052 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367059 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367076 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367103 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367135 */     // GIR_Coverage, 4205,
     /* 367135 */     GIR_EraseRootFromParent_Done,
     /* 367136 */   // Label 7260: @367136
     /* 367136 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(367258), // Rule ID 4239 //
     /* 367141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367170 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367174 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367181 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367198 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367225 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367257 */     // GIR_Coverage, 4239,
     /* 367257 */     GIR_EraseRootFromParent_Done,
     /* 367258 */   // Label 7261: @367258
     /* 367258 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(367380), // Rule ID 4241 //
     /* 367263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367289 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367292 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367296 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367303 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367320 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367379 */     // GIR_Coverage, 4241,
     /* 367379 */     GIR_EraseRootFromParent_Done,
     /* 367380 */   // Label 7262: @367380
     /* 367380 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(367494), // Rule ID 4195 //
     /* 367385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367399 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367405 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367415 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367422 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367439 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367493 */     // GIR_Coverage, 4195,
     /* 367493 */     GIR_EraseRootFromParent_Done,
     /* 367494 */   // Label 7263: @367494
     /* 367494 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(367608), // Rule ID 4196 //
     /* 367499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 367553 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 367553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 367560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367607 */     // GIR_Coverage, 4196,
     /* 367607 */     GIR_EraseRootFromParent_Done,
     /* 367608 */   // Label 7264: @367608
     /* 367608 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(367729), // Rule ID 4231 //
     /* 367613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367646 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367650 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367657 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367674 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367696 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367728 */     // GIR_Coverage, 4231,
     /* 367728 */     GIR_EraseRootFromParent_Done,
     /* 367729 */   // Label 7265: @367729
     /* 367729 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367850), // Rule ID 4232 //
     /* 367734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367767 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367771 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367778 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 367795 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 367795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 367802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367817 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367849 */     // GIR_Coverage, 4232,
     /* 367849 */     GIR_EraseRootFromParent_Done,
     /* 367850 */   // Label 7266: @367850
     /* 367850 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(367960), // Rule ID 4199 //
     /* 367855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367881 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367888 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 367905 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 367905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 367912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367927 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367959 */     // GIR_Coverage, 4199,
     /* 367959 */     GIR_EraseRootFromParent_Done,
     /* 367960 */   // Label 7267: @367960
     /* 367960 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(368070), // Rule ID 4201 //
     /* 367965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367991 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367998 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368015 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368069 */     // GIR_Coverage, 4201,
     /* 368069 */     GIR_EraseRootFromParent_Done,
     /* 368070 */   // Label 7268: @368070
     /* 368070 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(368187), // Rule ID 4235 //
     /* 368075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368101 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368104 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368108 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368115 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368132 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368154 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368186 */     // GIR_Coverage, 4235,
     /* 368186 */     GIR_EraseRootFromParent_Done,
     /* 368187 */   // Label 7269: @368187
     /* 368187 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(368304), // Rule ID 4237 //
     /* 368192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368221 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368225 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368232 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368249 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368303 */     // GIR_Coverage, 4237,
     /* 368303 */     GIR_EraseRootFromParent_Done,
     /* 368304 */   // Label 7270: @368304
     /* 368304 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(368444), // Rule ID 5754 //
     /* 368309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368352 */     // MIs[2] Operand 1
     /* 368352 */     // No operand predicates
     /* 368352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368360 */     // MIs[3] Operand 1
     /* 368360 */     // No operand predicates
     /* 368360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368362 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 368365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368374 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368426 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368443 */     // GIR_Coverage, 5754,
     /* 368443 */     GIR_EraseRootFromParent_Done,
     /* 368444 */   // Label 7271: @368444
     /* 368444 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(368615), // Rule ID 5755 //
     /* 368449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368492 */     // MIs[2] Operand 1
     /* 368492 */     // No operand predicates
     /* 368492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368500 */     // MIs[3] Operand 1
     /* 368500 */     // No operand predicates
     /* 368500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368502 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368502 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 368505 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368509 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368514 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 368517 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368521 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 368524 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368529 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368546 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368549 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368553 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368597 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368614 */     // GIR_Coverage, 5755,
     /* 368614 */     GIR_EraseRootFromParent_Done,
     /* 368615 */   // Label 7272: @368615
     /* 368615 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(368755), // Rule ID 5762 //
     /* 368620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368663 */     // MIs[2] Operand 1
     /* 368663 */     // No operand predicates
     /* 368663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368671 */     // MIs[3] Operand 1
     /* 368671 */     // No operand predicates
     /* 368671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368673 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 368676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368688 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368692 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368717 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368754 */     // GIR_Coverage, 5762,
     /* 368754 */     GIR_EraseRootFromParent_Done,
     /* 368755 */   // Label 7273: @368755
     /* 368755 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(368926), // Rule ID 5763 //
     /* 368760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368803 */     // MIs[2] Operand 1
     /* 368803 */     // No operand predicates
     /* 368803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368811 */     // MIs[3] Operand 1
     /* 368811 */     // No operand predicates
     /* 368811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368813 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 368813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 368816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368825 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 368828 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368832 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 368835 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368840 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368845 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368848 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368852 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 368860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368864 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 368867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 368884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 368895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 368901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368908 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 368915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368925 */     // GIR_Coverage, 5763,
     /* 368925 */     GIR_EraseRootFromParent_Done,
     /* 368926 */   // Label 7274: @368926
     /* 368926 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(369005), // Rule ID 5678 //
     /* 368931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368959 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 368959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 368975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369004 */     // GIR_Coverage, 5678,
     /* 369004 */     GIR_EraseRootFromParent_Done,
     /* 369005 */   // Label 7275: @369005
     /* 369005 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(369147), // Rule ID 6483 //
     /* 369010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369039 */     // MIs[1] Rn
     /* 369039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369060 */     // MIs[2] Operand 1
     /* 369060 */     // No operand predicates
     /* 369060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369062 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369081 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369146 */     // GIR_Coverage, 6483,
     /* 369146 */     GIR_EraseRootFromParent_Done,
     /* 369147 */   // Label 7276: @369147
     /* 369147 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(369296), // Rule ID 6484 //
     /* 369152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369177 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369181 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369188 */     // MIs[1] Rn
     /* 369188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369209 */     // MIs[2] Operand 1
     /* 369209 */     // No operand predicates
     /* 369209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369211 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369223 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369230 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 369250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 369261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369265 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369278 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369295 */     // GIR_Coverage, 6484,
     /* 369295 */     GIR_EraseRootFromParent_Done,
     /* 369296 */   // Label 7277: @369296
     /* 369296 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(369431), // Rule ID 5717 //
     /* 369301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369331 */     // MIs[1] Operand 1
     /* 369331 */     // No operand predicates
     /* 369331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369333 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 369333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 369336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369359 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 369362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 369391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 369402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369430 */     // GIR_Coverage, 5717,
     /* 369430 */     GIR_EraseRootFromParent_Done,
     /* 369431 */   // Label 7278: @369431
     /* 369431 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(369619), // Rule ID 5718 //
     /* 369436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369466 */     // MIs[1] Operand 1
     /* 369466 */     // No operand predicates
     /* 369466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369468 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 369468 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 369471 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369475 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369482 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 369485 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369489 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369494 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369497 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 369504 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369509 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369514 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369519 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 369522 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369526 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369545 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 369548 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369552 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 369588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 369591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369618 */     // GIR_Coverage, 5718,
     /* 369618 */     GIR_EraseRootFromParent_Done,
     /* 369619 */   // Label 7279: @369619
     /* 369619 */   GIM_Reject,
     /* 369620 */ // Label 7254: @369620
     /* 369620 */ GIM_Reject,
     /* 369621 */ // Label 7105: @369621
     /* 369621 */ GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(373039),
     /* 369626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369629 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(369755), // Rule ID 4257 //
     /* 369634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369654 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369664 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369667 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369671 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 369678 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 369695 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 369702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369722 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369754 */     // GIR_Coverage, 4257,
     /* 369754 */     GIR_EraseRootFromParent_Done,
     /* 369755 */   // Label 7281: @369755
     /* 369755 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(369881), // Rule ID 4258 //
     /* 369760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369793 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369797 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 369804 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 369821 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 369828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369848 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369880 */     // GIR_Coverage, 4258,
     /* 369880 */     GIR_EraseRootFromParent_Done,
     /* 369881 */   // Label 7282: @369881
     /* 369881 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(370000), // Rule ID 4365 //
     /* 369886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 369889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369900 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369906 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369916 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369923 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 369940 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 369940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 369943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 369947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 369989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369999 */     // GIR_Coverage, 4365,
     /* 369999 */     GIR_EraseRootFromParent_Done,
     /* 370000 */   // Label 7283: @370000
     /* 370000 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(370119), // Rule ID 4366 //
     /* 370005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370059 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370118 */     // GIR_Coverage, 4366,
     /* 370118 */     GIR_EraseRootFromParent_Done,
     /* 370119 */   // Label 7284: @370119
     /* 370119 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(370241), // Rule ID 4263 //
     /* 370124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370153 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370157 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370181 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370240 */     // GIR_Coverage, 4263,
     /* 370240 */     GIR_EraseRootFromParent_Done,
     /* 370241 */   // Label 7285: @370241
     /* 370241 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(370363), // Rule ID 4265 //
     /* 370246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370272 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370275 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370279 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370303 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370362 */     // GIR_Coverage, 4265,
     /* 370362 */     GIR_EraseRootFromParent_Done,
     /* 370363 */   // Label 7286: @370363
     /* 370363 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(370478), // Rule ID 4371 //
     /* 370368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370394 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370401 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370418 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370477 */     // GIR_Coverage, 4371,
     /* 370477 */     GIR_EraseRootFromParent_Done,
     /* 370478 */   // Label 7287: @370478
     /* 370478 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(370593), // Rule ID 4373 //
     /* 370483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370516 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370533 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370560 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370592 */     // GIR_Coverage, 4373,
     /* 370592 */     GIR_EraseRootFromParent_Done,
     /* 370593 */   // Label 7288: @370593
     /* 370593 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(370714), // Rule ID 4255 //
     /* 370598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370628 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370631 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370635 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370642 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 370659 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 370659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 370666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370681 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370713 */     // GIR_Coverage, 4255,
     /* 370713 */     GIR_EraseRootFromParent_Done,
     /* 370714 */   // Label 7289: @370714
     /* 370714 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(370835), // Rule ID 4256 //
     /* 370719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370749 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370752 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370756 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 370780 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 370780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 370787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370834 */     // GIR_Coverage, 4256,
     /* 370834 */     GIR_EraseRootFromParent_Done,
     /* 370835 */   // Label 7290: @370835
     /* 370835 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(370949), // Rule ID 4363 //
     /* 370840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370854 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370877 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 370894 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 370894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 370901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370916 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370948 */     // GIR_Coverage, 4363,
     /* 370948 */     GIR_EraseRootFromParent_Done,
     /* 370949 */   // Label 7291: @370949
     /* 370949 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(371063), // Rule ID 4364 //
     /* 370954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370984 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370991 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371008 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371030 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371062 */     // GIR_Coverage, 4364,
     /* 371062 */     GIR_EraseRootFromParent_Done,
     /* 371063 */   // Label 7292: @371063
     /* 371063 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(371180), // Rule ID 4259 //
     /* 371068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371094 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371097 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371101 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371125 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371147 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371179 */     // GIR_Coverage, 4259,
     /* 371179 */     GIR_EraseRootFromParent_Done,
     /* 371180 */   // Label 7293: @371180
     /* 371180 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(371297), // Rule ID 4261 //
     /* 371185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371214 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371218 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371242 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371296 */     // GIR_Coverage, 4261,
     /* 371296 */     GIR_EraseRootFromParent_Done,
     /* 371297 */   // Label 7294: @371297
     /* 371297 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(371407), // Rule ID 4367 //
     /* 371302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371352 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371406 */     // GIR_Coverage, 4367,
     /* 371406 */     GIR_EraseRootFromParent_Done,
     /* 371407 */   // Label 7295: @371407
     /* 371407 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(371517), // Rule ID 4369 //
     /* 371412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371438 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371445 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371462 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371516 */     // GIR_Coverage, 4369,
     /* 371516 */     GIR_EraseRootFromParent_Done,
     /* 371517 */   // Label 7296: @371517
     /* 371517 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(371640), // Rule ID 5728 //
     /* 371522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371569 */     // MIs[3] Operand 1
     /* 371569 */     // No operand predicates
     /* 371569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371575 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 371575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 371582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 371591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 371594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371639 */     // GIR_Coverage, 5728,
     /* 371639 */     GIR_EraseRootFromParent_Done,
     /* 371640 */   // Label 7297: @371640
     /* 371640 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(371763), // Rule ID 5768 //
     /* 371645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371692 */     // MIs[3] Operand 1
     /* 371692 */     // No operand predicates
     /* 371692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371698 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 371698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 371705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 371714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 371717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371762 */     // GIR_Coverage, 5768,
     /* 371762 */     GIR_EraseRootFromParent_Done,
     /* 371763 */   // Label 7298: @371763
     /* 371763 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(371851), // Rule ID 1939 //
     /* 371768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371818 */     // MIs[2] Operand 1
     /* 371818 */     // No operand predicates
     /* 371818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371826 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371830 */     // MIs[3] Operand 1
     /* 371830 */     // No operand predicates
     /* 371830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371832 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 371832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 371835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 371839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 371849 */     GIR_RootConstrainSelectedInstOperands,
     /* 371850 */     // GIR_Coverage, 1939,
     /* 371850 */     GIR_EraseRootFromParent_Done,
     /* 371851 */   // Label 7299: @371851
     /* 371851 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(371950), // Rule ID 5725 //
     /* 371856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 371878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371894 */     // MIs[2] Operand 1
     /* 371894 */     // No operand predicates
     /* 371894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371902 */     // MIs[3] Operand 1
     /* 371902 */     // No operand predicates
     /* 371902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371904 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 371904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 371907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 371922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 371932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 371935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 371942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 371948 */     GIR_RootConstrainSelectedInstOperands,
     /* 371949 */     // GIR_Coverage, 5725,
     /* 371949 */     GIR_EraseRootFromParent_Done,
     /* 371950 */   // Label 7300: @371950
     /* 371950 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(372049), // Rule ID 5765 //
     /* 371955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 371977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371993 */     // MIs[2] Operand 1
     /* 371993 */     // No operand predicates
     /* 371993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372001 */     // MIs[3] Operand 1
     /* 372001 */     // No operand predicates
     /* 372001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372003 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 372003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372047 */     GIR_RootConstrainSelectedInstOperands,
     /* 372048 */     // GIR_Coverage, 5765,
     /* 372048 */     GIR_EraseRootFromParent_Done,
     /* 372049 */   // Label 7301: @372049
     /* 372049 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(372126), // Rule ID 5727 //
     /* 372054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372097 */     // MIs[2] Operand 1
     /* 372097 */     // No operand predicates
     /* 372097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372105 */     // MIs[3] Operand 1
     /* 372105 */     // No operand predicates
     /* 372105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372107 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372124 */     GIR_RootConstrainSelectedInstOperands,
     /* 372125 */     // GIR_Coverage, 5727,
     /* 372125 */     GIR_EraseRootFromParent_Done,
     /* 372126 */   // Label 7302: @372126
     /* 372126 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(372234), // Rule ID 5729 //
     /* 372131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372174 */     // MIs[2] Operand 1
     /* 372174 */     // No operand predicates
     /* 372174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372182 */     // MIs[3] Operand 1
     /* 372182 */     // No operand predicates
     /* 372182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372184 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 372184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372232 */     GIR_RootConstrainSelectedInstOperands,
     /* 372233 */     // GIR_Coverage, 5729,
     /* 372233 */     GIR_EraseRootFromParent_Done,
     /* 372234 */   // Label 7303: @372234
     /* 372234 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(372311), // Rule ID 5767 //
     /* 372239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372282 */     // MIs[2] Operand 1
     /* 372282 */     // No operand predicates
     /* 372282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372290 */     // MIs[3] Operand 1
     /* 372290 */     // No operand predicates
     /* 372290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372292 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 372292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372309 */     GIR_RootConstrainSelectedInstOperands,
     /* 372310 */     // GIR_Coverage, 5767,
     /* 372310 */     GIR_EraseRootFromParent_Done,
     /* 372311 */   // Label 7304: @372311
     /* 372311 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(372419), // Rule ID 5769 //
     /* 372316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372359 */     // MIs[2] Operand 1
     /* 372359 */     // No operand predicates
     /* 372359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372367 */     // MIs[3] Operand 1
     /* 372367 */     // No operand predicates
     /* 372367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372369 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 372369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 372408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372417 */     GIR_RootConstrainSelectedInstOperands,
     /* 372418 */     // GIR_Coverage, 5769,
     /* 372418 */     GIR_EraseRootFromParent_Done,
     /* 372419 */   // Label 7305: @372419
     /* 372419 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(372498), // Rule ID 5681 //
     /* 372424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372452 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 372452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 372468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 372487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372497 */     // GIR_Coverage, 5681,
     /* 372497 */     GIR_EraseRootFromParent_Done,
     /* 372498 */   // Label 7306: @372498
     /* 372498 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(372574), // Rule ID 5687 //
     /* 372503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372531 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 372531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372573 */     // GIR_Coverage, 5687,
     /* 372573 */     GIR_EraseRootFromParent_Done,
     /* 372574 */   // Label 7307: @372574
     /* 372574 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(372650), // Rule ID 5697 //
     /* 372579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372607 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 372607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372649 */     // GIR_Coverage, 5697,
     /* 372649 */     GIR_EraseRootFromParent_Done,
     /* 372650 */   // Label 7308: @372650
     /* 372650 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(372713), // Rule ID 5706 //
     /* 372655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 372677 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 372681 */     // MIs[1] Operand 1
     /* 372681 */     // No operand predicates
     /* 372681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372693 */     // MIs[2] Operand 1
     /* 372693 */     // No operand predicates
     /* 372693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372695 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 372695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 372698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 372705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 372711 */     GIR_RootConstrainSelectedInstOperands,
     /* 372712 */     // GIR_Coverage, 5706,
     /* 372712 */     GIR_EraseRootFromParent_Done,
     /* 372713 */   // Label 7309: @372713
     /* 372713 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(372799), // Rule ID 6465 //
     /* 372718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372743 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372747 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372754 */     // MIs[1] Rn
     /* 372754 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372775 */     // MIs[2] Operand 1
     /* 372775 */     // No operand predicates
     /* 372775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372777 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 372777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 372780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372797 */     GIR_RootConstrainSelectedInstOperands,
     /* 372798 */     // GIR_Coverage, 6465,
     /* 372798 */     GIR_EraseRootFromParent_Done,
     /* 372799 */   // Label 7310: @372799
     /* 372799 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(372878), // Rule ID 6470 //
     /* 372804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 372833 */     // MIs[1] Rn
     /* 372833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 372837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 372842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372850 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372854 */     // MIs[2] Operand 1
     /* 372854 */     // No operand predicates
     /* 372854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372856 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 372856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 372859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372876 */     GIR_RootConstrainSelectedInstOperands,
     /* 372877 */     // GIR_Coverage, 6470,
     /* 372877 */     GIR_EraseRootFromParent_Done,
     /* 372878 */   // Label 7311: @372878
     /* 372878 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(372932), // Rule ID 1935 //
     /* 372883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372916 */     // MIs[1] Operand 1
     /* 372916 */     // No operand predicates
     /* 372916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372918 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 372918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 372921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 372928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372930 */     GIR_RootConstrainSelectedInstOperands,
     /* 372931 */     // GIR_Coverage, 1935,
     /* 372931 */     GIR_EraseRootFromParent_Done,
     /* 372932 */   // Label 7312: @372932
     /* 372932 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(373038), // Rule ID 5711 //
     /* 372937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372967 */     // MIs[1] Operand 1
     /* 372967 */     // No operand predicates
     /* 372967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372969 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 372969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 372972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 373002 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 373005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 373030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373036 */     GIR_RootConstrainSelectedInstOperands,
     /* 373037 */     // GIR_Coverage, 5711,
     /* 373037 */     GIR_EraseRootFromParent_Done,
     /* 373038 */   // Label 7313: @373038
     /* 373038 */   GIM_Reject,
     /* 373039 */ // Label 7280: @373039
     /* 373039 */ GIM_Reject,
     /* 373040 */ // Label 7106: @373040
     /* 373040 */ GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(376243),
     /* 373045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 373048 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(373167), // Rule ID 4185 //
     /* 373053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373083 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373090 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373107 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373134 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373166 */     // GIR_Coverage, 4185,
     /* 373166 */     GIR_EraseRootFromParent_Done,
     /* 373167 */   // Label 7315: @373167
     /* 373167 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(373286), // Rule ID 4186 //
     /* 373172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373202 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373226 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373285 */     // GIR_Coverage, 4186,
     /* 373285 */     GIR_EraseRootFromParent_Done,
     /* 373286 */   // Label 7316: @373286
     /* 373286 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(373412), // Rule ID 4221 //
     /* 373291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373321 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373324 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373328 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373352 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373411 */     // GIR_Coverage, 4221,
     /* 373411 */     GIR_EraseRootFromParent_Done,
     /* 373412 */   // Label 7317: @373412
     /* 373412 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(373538), // Rule ID 4222 //
     /* 373417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373447 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373450 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373454 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373461 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373478 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373505 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373537 */     // GIR_Coverage, 4222,
     /* 373537 */     GIR_EraseRootFromParent_Done,
     /* 373538 */   // Label 7318: @373538
     /* 373538 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(373653), // Rule ID 4191 //
     /* 373543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373569 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373576 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373593 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373620 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373652 */     // GIR_Coverage, 4191,
     /* 373652 */     GIR_EraseRootFromParent_Done,
     /* 373653 */   // Label 7319: @373653
     /* 373653 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(373768), // Rule ID 4193 //
     /* 373658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373684 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373691 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373708 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373767 */     // GIR_Coverage, 4193,
     /* 373767 */     GIR_EraseRootFromParent_Done,
     /* 373768 */   // Label 7320: @373768
     /* 373768 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(373890), // Rule ID 4227 //
     /* 373773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373799 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373802 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373806 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373813 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 373830 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 373837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373857 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 373879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 373889 */     // GIR_Coverage, 4227,
     /* 373889 */     GIR_EraseRootFromParent_Done,
     /* 373890 */   // Label 7321: @373890
     /* 373890 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(374012), // Rule ID 4229 //
     /* 373895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373921 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373924 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373928 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 373935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 373952 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 373952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 373955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 373959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374011 */     // GIR_Coverage, 4229,
     /* 374011 */     GIR_EraseRootFromParent_Done,
     /* 374012 */   // Label 7322: @374012
     /* 374012 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(374126), // Rule ID 4183 //
     /* 374017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374031 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374037 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374047 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374054 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374071 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374093 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374125 */     // GIR_Coverage, 4183,
     /* 374125 */     GIR_EraseRootFromParent_Done,
     /* 374126 */   // Label 7323: @374126
     /* 374126 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(374240), // Rule ID 4184 //
     /* 374131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374145 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374151 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374161 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374168 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374185 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374207 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374239 */     // GIR_Coverage, 4184,
     /* 374239 */     GIR_EraseRootFromParent_Done,
     /* 374240 */   // Label 7324: @374240
     /* 374240 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(374361), // Rule ID 4219 //
     /* 374245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374275 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374278 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374282 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374289 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374306 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374328 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374360 */     // GIR_Coverage, 4219,
     /* 374360 */     GIR_EraseRootFromParent_Done,
     /* 374361 */   // Label 7325: @374361
     /* 374361 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(374482), // Rule ID 4220 //
     /* 374366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374380 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374386 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374396 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374399 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374403 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374427 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374481 */     // GIR_Coverage, 4220,
     /* 374481 */     GIR_EraseRootFromParent_Done,
     /* 374482 */   // Label 7326: @374482
     /* 374482 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(374592), // Rule ID 4187 //
     /* 374487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374520 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374537 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374559 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374591 */     // GIR_Coverage, 4187,
     /* 374591 */     GIR_EraseRootFromParent_Done,
     /* 374592 */   // Label 7327: @374592
     /* 374592 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(374702), // Rule ID 4189 //
     /* 374597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374623 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374630 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374647 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374701 */     // GIR_Coverage, 4189,
     /* 374701 */     GIR_EraseRootFromParent_Done,
     /* 374702 */   // Label 7328: @374702
     /* 374702 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(374819), // Rule ID 4223 //
     /* 374707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374733 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374736 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374740 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374747 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374764 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374786 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374818 */     // GIR_Coverage, 4223,
     /* 374818 */     GIR_EraseRootFromParent_Done,
     /* 374819 */   // Label 7329: @374819
     /* 374819 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(374936), // Rule ID 4225 //
     /* 374824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374850 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374853 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374857 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374864 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 374881 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 374881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 374888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374935 */     // GIR_Coverage, 4225,
     /* 374935 */     GIR_EraseRootFromParent_Done,
     /* 374936 */   // Label 7330: @374936
     /* 374936 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(375059), // Rule ID 5752 //
     /* 374941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 374971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374988 */     // MIs[3] Operand 1
     /* 374988 */     // No operand predicates
     /* 374988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374994 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 374994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 374997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375058 */     // GIR_Coverage, 5752,
     /* 375058 */     GIR_EraseRootFromParent_Done,
     /* 375059 */   // Label 7331: @375059
     /* 375059 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(375182), // Rule ID 5760 //
     /* 375064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375111 */     // MIs[3] Operand 1
     /* 375111 */     // No operand predicates
     /* 375111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375117 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 375117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 375120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375181 */     // GIR_Coverage, 5760,
     /* 375181 */     GIR_EraseRootFromParent_Done,
     /* 375182 */   // Label 7332: @375182
     /* 375182 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(375270), // Rule ID 1938 //
     /* 375187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375237 */     // MIs[2] Operand 1
     /* 375237 */     // No operand predicates
     /* 375237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375245 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375249 */     // MIs[3] Operand 1
     /* 375249 */     // No operand predicates
     /* 375249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375251 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 375251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 375268 */     GIR_RootConstrainSelectedInstOperands,
     /* 375269 */     // GIR_Coverage, 1938,
     /* 375269 */     GIR_EraseRootFromParent_Done,
     /* 375270 */   // Label 7333: @375270
     /* 375270 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(375369), // Rule ID 5749 //
     /* 375275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 375297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375313 */     // MIs[2] Operand 1
     /* 375313 */     // No operand predicates
     /* 375313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375321 */     // MIs[3] Operand 1
     /* 375321 */     // No operand predicates
     /* 375321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375323 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 375323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375367 */     GIR_RootConstrainSelectedInstOperands,
     /* 375368 */     // GIR_Coverage, 5749,
     /* 375368 */     GIR_EraseRootFromParent_Done,
     /* 375369 */   // Label 7334: @375369
     /* 375369 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(375468), // Rule ID 5757 //
     /* 375374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 375396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375412 */     // MIs[2] Operand 1
     /* 375412 */     // No operand predicates
     /* 375412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375420 */     // MIs[3] Operand 1
     /* 375420 */     // No operand predicates
     /* 375420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375422 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 375422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375434 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 375440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 375450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375466 */     GIR_RootConstrainSelectedInstOperands,
     /* 375467 */     // GIR_Coverage, 5757,
     /* 375467 */     GIR_EraseRootFromParent_Done,
     /* 375468 */   // Label 7335: @375468
     /* 375468 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(375545), // Rule ID 5751 //
     /* 375473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375516 */     // MIs[2] Operand 1
     /* 375516 */     // No operand predicates
     /* 375516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375524 */     // MIs[3] Operand 1
     /* 375524 */     // No operand predicates
     /* 375524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375526 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375543 */     GIR_RootConstrainSelectedInstOperands,
     /* 375544 */     // GIR_Coverage, 5751,
     /* 375544 */     GIR_EraseRootFromParent_Done,
     /* 375545 */   // Label 7336: @375545
     /* 375545 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(375653), // Rule ID 5753 //
     /* 375550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 375576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375593 */     // MIs[2] Operand 1
     /* 375593 */     // No operand predicates
     /* 375593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375601 */     // MIs[3] Operand 1
     /* 375601 */     // No operand predicates
     /* 375601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375603 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375651 */     GIR_RootConstrainSelectedInstOperands,
     /* 375652 */     // GIR_Coverage, 5753,
     /* 375652 */     GIR_EraseRootFromParent_Done,
     /* 375653 */   // Label 7337: @375653
     /* 375653 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(375730), // Rule ID 5759 //
     /* 375658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375701 */     // MIs[2] Operand 1
     /* 375701 */     // No operand predicates
     /* 375701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375709 */     // MIs[3] Operand 1
     /* 375709 */     // No operand predicates
     /* 375709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375711 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375728 */     GIR_RootConstrainSelectedInstOperands,
     /* 375729 */     // GIR_Coverage, 5759,
     /* 375729 */     GIR_EraseRootFromParent_Done,
     /* 375730 */   // Label 7338: @375730
     /* 375730 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(375838), // Rule ID 5761 //
     /* 375735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 375761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375778 */     // MIs[2] Operand 1
     /* 375778 */     // No operand predicates
     /* 375778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375786 */     // MIs[3] Operand 1
     /* 375786 */     // No operand predicates
     /* 375786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375788 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 375823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375836 */     GIR_RootConstrainSelectedInstOperands,
     /* 375837 */     // GIR_Coverage, 5761,
     /* 375837 */     GIR_EraseRootFromParent_Done,
     /* 375838 */   // Label 7339: @375838
     /* 375838 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(375917), // Rule ID 5676 //
     /* 375843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 375865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375871 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 375871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 375887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 375906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375916 */     // GIR_Coverage, 5676,
     /* 375916 */     GIR_EraseRootFromParent_Done,
     /* 375917 */   // Label 7340: @375917
     /* 375917 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(375996), // Rule ID 6463 //
     /* 375922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375951 */     // MIs[1] Rn
     /* 375951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 375972 */     // MIs[2] Operand 1
     /* 375972 */     // No operand predicates
     /* 375972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375974 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 375977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375994 */     GIR_RootConstrainSelectedInstOperands,
     /* 375995 */     // GIR_Coverage, 6463,
     /* 375995 */     GIR_EraseRootFromParent_Done,
     /* 375996 */   // Label 7341: @375996
     /* 375996 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(376082), // Rule ID 6464 //
     /* 376001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376026 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376030 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376037 */     // MIs[1] Rn
     /* 376037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376058 */     // MIs[2] Operand 1
     /* 376058 */     // No operand predicates
     /* 376058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376060 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376080 */     GIR_RootConstrainSelectedInstOperands,
     /* 376081 */     // GIR_Coverage, 6464,
     /* 376081 */     GIR_EraseRootFromParent_Done,
     /* 376082 */   // Label 7342: @376082
     /* 376082 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(376136), // Rule ID 1934 //
     /* 376087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376120 */     // MIs[1] Operand 1
     /* 376120 */     // No operand predicates
     /* 376120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376122 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 376122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 376125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 376132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376134 */     GIR_RootConstrainSelectedInstOperands,
     /* 376135 */     // GIR_Coverage, 1934,
     /* 376135 */     GIR_EraseRootFromParent_Done,
     /* 376136 */   // Label 7343: @376136
     /* 376136 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(376242), // Rule ID 5719 //
     /* 376141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 376163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376171 */     // MIs[1] Operand 1
     /* 376171 */     // No operand predicates
     /* 376171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376173 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 376176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 376209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 376234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376240 */     GIR_RootConstrainSelectedInstOperands,
     /* 376241 */     // GIR_Coverage, 5719,
     /* 376241 */     GIR_EraseRootFromParent_Done,
     /* 376242 */   // Label 7344: @376242
     /* 376242 */   GIM_Reject,
     /* 376243 */ // Label 7314: @376243
     /* 376243 */ GIM_Reject,
     /* 376244 */ // Label 7107: @376244
     /* 376244 */ GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(376368), // Rule ID 11238 //
     /* 376249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 376252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 376255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376269 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 376273 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 376273 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 376276 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 376280 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376285 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 376289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376291 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 376294 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 376298 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376303 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 376306 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 376309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376311 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 376314 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 376318 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376323 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 376326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 376331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 376335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376340 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376343 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376346 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 376349 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 376352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 376357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 376359 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 376361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376364 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 376366 */   GIR_RootConstrainSelectedInstOperands,
     /* 376367 */   // GIR_Coverage, 11238,
     /* 376367 */   GIR_EraseRootFromParent_Done,
     /* 376368 */ // Label 7345: @376368
     /* 376368 */ GIM_Reject,
     /* 376369 */ // Label 7108: @376369
     /* 376369 */ GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(376493), // Rule ID 11241 //
     /* 376374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 376377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 376380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 376398 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 376398 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 376401 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 376405 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376410 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 376414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 376419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 376423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376428 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 376431 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 376434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376436 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 376439 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 376443 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376448 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 376451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 376456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 376460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376468 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376471 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 376474 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 376477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 376482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 376484 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 376486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376489 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 376491 */   GIR_RootConstrainSelectedInstOperands,
     /* 376492 */   // GIR_Coverage, 11241,
     /* 376492 */   GIR_EraseRootFromParent_Done,
     /* 376493 */ // Label 7346: @376493
     /* 376493 */ GIM_Reject,
     /* 376494 */ // Label 7109: @376494
     /* 376494 */ GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(378471),
     /* 376499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 376502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 376505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376512 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(376621), // Rule ID 4353 //
     /* 376517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376537 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376544 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376561 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 376568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376588 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376620 */     // GIR_Coverage, 4353,
     /* 376620 */     GIR_EraseRootFromParent_Done,
     /* 376621 */   // Label 7348: @376621
     /* 376621 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(376730), // Rule ID 4354 //
     /* 376626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376646 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376653 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 376670 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 376677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376697 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376729 */     // GIR_Coverage, 4354,
     /* 376729 */     GIR_EraseRootFromParent_Done,
     /* 376730 */   // Label 7349: @376730
     /* 376730 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(376839), // Rule ID 4461 //
     /* 376735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376779 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 376786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376838 */     // GIR_Coverage, 4461,
     /* 376838 */     GIR_EraseRootFromParent_Done,
     /* 376839 */   // Label 7350: @376839
     /* 376839 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(376948), // Rule ID 4462 //
     /* 376844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 376888 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 376895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 376937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376947 */     // GIR_Coverage, 4462,
     /* 376947 */     GIR_EraseRootFromParent_Done,
     /* 376948 */   // Label 7351: @376948
     /* 376948 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(377053), // Rule ID 4359 //
     /* 376953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376969 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 376993 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 376993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377052 */     // GIR_Coverage, 4359,
     /* 377052 */     GIR_EraseRootFromParent_Done,
     /* 377053 */   // Label 7352: @377053
     /* 377053 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(377158), // Rule ID 4361 //
     /* 377058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377074 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377081 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377098 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377157 */     // GIR_Coverage, 4361,
     /* 377157 */     GIR_EraseRootFromParent_Done,
     /* 377158 */   // Label 7353: @377158
     /* 377158 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(377263), // Rule ID 4467 //
     /* 377163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377179 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377186 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377203 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377230 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377262 */     // GIR_Coverage, 4467,
     /* 377262 */     GIR_EraseRootFromParent_Done,
     /* 377263 */   // Label 7354: @377263
     /* 377263 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(377368), // Rule ID 4469 //
     /* 377268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377284 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377291 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377308 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377335 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377367 */     // GIR_Coverage, 4469,
     /* 377367 */     GIR_EraseRootFromParent_Done,
     /* 377368 */   // Label 7355: @377368
     /* 377368 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(377472), // Rule ID 4351 //
     /* 377373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377393 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377400 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377417 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377439 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377471 */     // GIR_Coverage, 4351,
     /* 377471 */     GIR_EraseRootFromParent_Done,
     /* 377472 */   // Label 7356: @377472
     /* 377472 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(377576), // Rule ID 4352 //
     /* 377477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377497 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377504 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377521 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377543 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377575 */     // GIR_Coverage, 4352,
     /* 377575 */     GIR_EraseRootFromParent_Done,
     /* 377576 */   // Label 7357: @377576
     /* 377576 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(377680), // Rule ID 4459 //
     /* 377581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377601 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377625 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377647 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377679 */     // GIR_Coverage, 4459,
     /* 377679 */     GIR_EraseRootFromParent_Done,
     /* 377680 */   // Label 7358: @377680
     /* 377680 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(377784), // Rule ID 4460 //
     /* 377685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377689 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377695 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377705 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377712 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377729 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377751 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377783 */     // GIR_Coverage, 4460,
     /* 377783 */     GIR_EraseRootFromParent_Done,
     /* 377784 */   // Label 7359: @377784
     /* 377784 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(377884), // Rule ID 4355 //
     /* 377789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377805 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377812 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 377829 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 377829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 377836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377851 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377883 */     // GIR_Coverage, 4355,
     /* 377883 */     GIR_EraseRootFromParent_Done,
     /* 377884 */   // Label 7360: @377884
     /* 377884 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(377984), // Rule ID 4357 //
     /* 377889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377905 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377912 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 377929 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 377929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 377936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377951 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377983 */     // GIR_Coverage, 4357,
     /* 377983 */     GIR_EraseRootFromParent_Done,
     /* 377984 */   // Label 7361: @377984
     /* 377984 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(378084), // Rule ID 4463 //
     /* 377989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378029 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378083 */     // GIR_Coverage, 4463,
     /* 378083 */     GIR_EraseRootFromParent_Done,
     /* 378084 */   // Label 7362: @378084
     /* 378084 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(378184), // Rule ID 4465 //
     /* 378089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378129 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378183 */     // GIR_Coverage, 4465,
     /* 378183 */     GIR_EraseRootFromParent_Done,
     /* 378184 */   // Label 7363: @378184
     /* 378184 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(378248), // Rule ID 11296 //
     /* 378189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 378212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378224 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 378228 */     // MIs[3] Operand 1
     /* 378228 */     // No operand predicates
     /* 378228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378234 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 378234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 378237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 378243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 378246 */     GIR_RootConstrainSelectedInstOperands,
     /* 378247 */     // GIR_Coverage, 11296,
     /* 378247 */     GIR_EraseRootFromParent_Done,
     /* 378248 */   // Label 7364: @378248
     /* 378248 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(378359), // Rule ID 11237 //
     /* 378253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378264 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 378264 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378267 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378271 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378276 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378294 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378297 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378314 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378331 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378340 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 378348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378350 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378357 */     GIR_RootConstrainSelectedInstOperands,
     /* 378358 */     // GIR_Coverage, 11237,
     /* 378358 */     GIR_EraseRootFromParent_Done,
     /* 378359 */   // Label 7365: @378359
     /* 378359 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(378470), // Rule ID 11243 //
     /* 378364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378375 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 378375 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378378 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378382 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378387 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378405 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378408 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378413 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378416 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378420 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378425 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378451 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 378459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378461 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378468 */     GIR_RootConstrainSelectedInstOperands,
     /* 378469 */     // GIR_Coverage, 11243,
     /* 378469 */     GIR_EraseRootFromParent_Done,
     /* 378470 */   // Label 7366: @378470
     /* 378470 */   GIM_Reject,
     /* 378471 */ // Label 7347: @378471
     /* 378471 */ GIM_Reject,
     /* 378472 */ // Label 7110: @378472
     /* 378472 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(378623), // Rule ID 11239 //
     /* 378477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 378483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 378486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378497 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378501 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 378501 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 378504 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378508 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378513 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 378519 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 378524 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 378536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378541 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 378544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378546 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378549 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 378553 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378558 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378561 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378566 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378569 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 378573 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378578 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 378590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378598 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378604 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 378612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378614 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378619 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378621 */   GIR_RootConstrainSelectedInstOperands,
     /* 378622 */   // GIR_Coverage, 11239,
     /* 378622 */   GIR_EraseRootFromParent_Done,
     /* 378623 */ // Label 7367: @378623
     /* 378623 */ GIM_Reject,
     /* 378624 */ // Label 7111: @378624
     /* 378624 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(380655),
     /* 378629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 378632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378642 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(378751), // Rule ID 4317 //
     /* 378647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378667 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378674 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 378691 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 378698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378718 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378750 */     // GIR_Coverage, 4317,
     /* 378750 */     GIR_EraseRootFromParent_Done,
     /* 378751 */   // Label 7369: @378751
     /* 378751 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(378860), // Rule ID 4318 //
     /* 378756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378783 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 378800 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 378807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378859 */     // GIR_Coverage, 4318,
     /* 378859 */     GIR_EraseRootFromParent_Done,
     /* 378860 */   // Label 7370: @378860
     /* 378860 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(378969), // Rule ID 4425 //
     /* 378865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 378909 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 378909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 378916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378936 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378968 */     // GIR_Coverage, 4425,
     /* 378968 */     GIR_EraseRootFromParent_Done,
     /* 378969 */   // Label 7371: @378969
     /* 378969 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(379078), // Rule ID 4426 //
     /* 378974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379001 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379018 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379045 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379077 */     // GIR_Coverage, 4426,
     /* 379077 */     GIR_EraseRootFromParent_Done,
     /* 379078 */   // Label 7372: @379078
     /* 379078 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(379183), // Rule ID 4323 //
     /* 379083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379099 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379123 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379182 */     // GIR_Coverage, 4323,
     /* 379182 */     GIR_EraseRootFromParent_Done,
     /* 379183 */   // Label 7373: @379183
     /* 379183 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(379288), // Rule ID 4325 //
     /* 379188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379204 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379211 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379228 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379287 */     // GIR_Coverage, 4325,
     /* 379287 */     GIR_EraseRootFromParent_Done,
     /* 379288 */   // Label 7374: @379288
     /* 379288 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(379393), // Rule ID 4431 //
     /* 379293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379309 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379316 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379333 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379392 */     // GIR_Coverage, 4431,
     /* 379392 */     GIR_EraseRootFromParent_Done,
     /* 379393 */   // Label 7375: @379393
     /* 379393 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(379498), // Rule ID 4433 //
     /* 379398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379414 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379421 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379438 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379465 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379497 */     // GIR_Coverage, 4433,
     /* 379497 */     GIR_EraseRootFromParent_Done,
     /* 379498 */   // Label 7376: @379498
     /* 379498 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(379602), // Rule ID 4315 //
     /* 379503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379513 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379523 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379530 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379547 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379601 */     // GIR_Coverage, 4315,
     /* 379601 */     GIR_EraseRootFromParent_Done,
     /* 379602 */   // Label 7377: @379602
     /* 379602 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(379706), // Rule ID 4316 //
     /* 379607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379627 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379634 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 379651 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 379651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 379658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379673 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379705 */     // GIR_Coverage, 4316,
     /* 379705 */     GIR_EraseRootFromParent_Done,
     /* 379706 */   // Label 7378: @379706
     /* 379706 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(379810), // Rule ID 4423 //
     /* 379711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379738 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379755 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379809 */     // GIR_Coverage, 4423,
     /* 379809 */     GIR_EraseRootFromParent_Done,
     /* 379810 */   // Label 7379: @379810
     /* 379810 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(379914), // Rule ID 4424 //
     /* 379815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 379859 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 379859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 379866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379913 */     // GIR_Coverage, 4424,
     /* 379913 */     GIR_EraseRootFromParent_Done,
     /* 379914 */   // Label 7380: @379914
     /* 379914 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(380014), // Rule ID 4319 //
     /* 379919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379935 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 379959 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 379959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 379966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379981 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380013 */     // GIR_Coverage, 4319,
     /* 380013 */     GIR_EraseRootFromParent_Done,
     /* 380014 */   // Label 7381: @380014
     /* 380014 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(380114), // Rule ID 4321 //
     /* 380019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380059 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380081 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380113 */     // GIR_Coverage, 4321,
     /* 380113 */     GIR_EraseRootFromParent_Done,
     /* 380114 */   // Label 7382: @380114
     /* 380114 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(380214), // Rule ID 4427 //
     /* 380119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380135 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380142 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380159 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380181 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380213 */     // GIR_Coverage, 4427,
     /* 380213 */     GIR_EraseRootFromParent_Done,
     /* 380214 */   // Label 7383: @380214
     /* 380214 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(380314), // Rule ID 4429 //
     /* 380219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380235 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380242 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380259 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380281 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380313 */     // GIR_Coverage, 4429,
     /* 380313 */     GIR_EraseRootFromParent_Done,
     /* 380314 */   // Label 7384: @380314
     /* 380314 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(380378), // Rule ID 11294 //
     /* 380319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 380342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 380358 */     // MIs[3] Operand 1
     /* 380358 */     // No operand predicates
     /* 380358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380364 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 380364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 380367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 380373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 380376 */     GIR_RootConstrainSelectedInstOperands,
     /* 380377 */     // GIR_Coverage, 11294,
     /* 380377 */     GIR_EraseRootFromParent_Done,
     /* 380378 */   // Label 7385: @380378
     /* 380378 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(380516), // Rule ID 11236 //
     /* 380383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380394 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 380394 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380397 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380401 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380406 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380412 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380417 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380422 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380425 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380429 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380434 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380439 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380442 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380446 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380451 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380454 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380471 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380497 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 380505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380507 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380514 */     GIR_RootConstrainSelectedInstOperands,
     /* 380515 */     // GIR_Coverage, 11236,
     /* 380515 */     GIR_EraseRootFromParent_Done,
     /* 380516 */   // Label 7386: @380516
     /* 380516 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(380654), // Rule ID 11242 //
     /* 380521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380532 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 380532 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380535 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380539 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380544 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380550 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380555 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380560 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380563 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380567 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380572 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380589 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380592 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380635 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 380643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380645 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380652 */     GIR_RootConstrainSelectedInstOperands,
     /* 380653 */     // GIR_Coverage, 11242,
     /* 380653 */     GIR_EraseRootFromParent_Done,
     /* 380654 */   // Label 7387: @380654
     /* 380654 */   GIM_Reject,
     /* 380655 */ // Label 7368: @380655
     /* 380655 */ GIM_Reject,
     /* 380656 */ // Label 7112: @380656
     /* 380656 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(382923),
     /* 380661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 380664 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(380790), // Rule ID 4281 //
     /* 380669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380689 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380699 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380702 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380706 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 380713 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 380730 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 380737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380757 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 380779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380789 */     // GIR_Coverage, 4281,
     /* 380789 */     GIR_EraseRootFromParent_Done,
     /* 380790 */   // Label 7389: @380790
     /* 380790 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(380916), // Rule ID 4282 //
     /* 380795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380809 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380815 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380825 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380828 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380832 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 380839 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 380856 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 380863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380883 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 380905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380915 */     // GIR_Coverage, 4282,
     /* 380915 */     GIR_EraseRootFromParent_Done,
     /* 380916 */   // Label 7390: @380916
     /* 380916 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(381035), // Rule ID 4389 //
     /* 380921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380935 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380941 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 380975 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 380975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 380982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381002 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381034 */     // GIR_Coverage, 4389,
     /* 381034 */     GIR_EraseRootFromParent_Done,
     /* 381035 */   // Label 7391: @381035
     /* 381035 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(381154), // Rule ID 4390 //
     /* 381040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381054 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381060 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381070 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381077 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381094 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381121 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381153 */     // GIR_Coverage, 4390,
     /* 381153 */     GIR_EraseRootFromParent_Done,
     /* 381154 */   // Label 7392: @381154
     /* 381154 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(381276), // Rule ID 4287 //
     /* 381159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381185 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381188 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381192 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381199 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381216 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381275 */     // GIR_Coverage, 4287,
     /* 381275 */     GIR_EraseRootFromParent_Done,
     /* 381276 */   // Label 7393: @381276
     /* 381276 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(381398), // Rule ID 4289 //
     /* 381281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381310 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381314 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381321 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381338 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381365 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381397 */     // GIR_Coverage, 4289,
     /* 381397 */     GIR_EraseRootFromParent_Done,
     /* 381398 */   // Label 7394: @381398
     /* 381398 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(381513), // Rule ID 4395 //
     /* 381403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381429 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381436 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381453 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381480 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381512 */     // GIR_Coverage, 4395,
     /* 381512 */     GIR_EraseRootFromParent_Done,
     /* 381513 */   // Label 7395: @381513
     /* 381513 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(381628), // Rule ID 4397 //
     /* 381518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381544 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381551 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381568 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381627 */     // GIR_Coverage, 4397,
     /* 381627 */     GIR_EraseRootFromParent_Done,
     /* 381628 */   // Label 7396: @381628
     /* 381628 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(381749), // Rule ID 4279 //
     /* 381633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381653 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381663 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381666 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381670 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381677 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 381694 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 381694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 381701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381716 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381748 */     // GIR_Coverage, 4279,
     /* 381748 */     GIR_EraseRootFromParent_Done,
     /* 381749 */   // Label 7397: @381749
     /* 381749 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(381870), // Rule ID 4280 //
     /* 381754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381768 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381774 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381784 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381787 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381791 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381798 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 381815 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 381815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 381822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381837 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381869 */     // GIR_Coverage, 4280,
     /* 381869 */     GIR_EraseRootFromParent_Done,
     /* 381870 */   // Label 7398: @381870
     /* 381870 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(381984), // Rule ID 4387 //
     /* 381875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381889 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381895 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381905 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381912 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 381929 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 381929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 381936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381951 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381983 */     // GIR_Coverage, 4387,
     /* 381983 */     GIR_EraseRootFromParent_Done,
     /* 381984 */   // Label 7399: @381984
     /* 381984 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(382098), // Rule ID 4388 //
     /* 381989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382003 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382009 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382019 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382022 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382026 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382043 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382065 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382097 */     // GIR_Coverage, 4388,
     /* 382097 */     GIR_EraseRootFromParent_Done,
     /* 382098 */   // Label 7400: @382098
     /* 382098 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(382215), // Rule ID 4283 //
     /* 382103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382129 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382132 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382136 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382143 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382160 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382182 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382214 */     // GIR_Coverage, 4283,
     /* 382214 */     GIR_EraseRootFromParent_Done,
     /* 382215 */   // Label 7401: @382215
     /* 382215 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(382332), // Rule ID 4285 //
     /* 382220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382249 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382253 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382260 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382277 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382299 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382331 */     // GIR_Coverage, 4285,
     /* 382331 */     GIR_EraseRootFromParent_Done,
     /* 382332 */   // Label 7402: @382332
     /* 382332 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(382442), // Rule ID 4391 //
     /* 382337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382363 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382370 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382387 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382441 */     // GIR_Coverage, 4391,
     /* 382441 */     GIR_EraseRootFromParent_Done,
     /* 382442 */   // Label 7403: @382442
     /* 382442 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(382552), // Rule ID 4393 //
     /* 382447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382497 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382519 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382551 */     // GIR_Coverage, 4393,
     /* 382551 */     GIR_EraseRootFromParent_Done,
     /* 382552 */   // Label 7404: @382552
     /* 382552 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(382626), // Rule ID 11292 //
     /* 382557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 382590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382602 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 382606 */     // MIs[3] Operand 1
     /* 382606 */     // No operand predicates
     /* 382606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382612 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 382612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 382615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 382621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 382624 */     GIR_RootConstrainSelectedInstOperands,
     /* 382625 */     // GIR_Coverage, 11292,
     /* 382625 */     GIR_EraseRootFromParent_Done,
     /* 382626 */   // Label 7405: @382626
     /* 382626 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(382774), // Rule ID 11235 //
     /* 382631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382652 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 382652 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382655 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382659 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382664 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382670 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382675 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382680 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382683 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 382687 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382692 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382697 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382700 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 382704 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382709 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382712 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 382724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382729 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 382741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382752 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382755 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 382763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382765 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382770 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382772 */     GIR_RootConstrainSelectedInstOperands,
     /* 382773 */     // GIR_Coverage, 11235,
     /* 382773 */     GIR_EraseRootFromParent_Done,
     /* 382774 */   // Label 7406: @382774
     /* 382774 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(382922), // Rule ID 11240 //
     /* 382779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382800 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 382800 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382803 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382807 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382812 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382818 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382823 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382828 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382831 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 382835 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382840 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382845 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382848 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 382852 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382857 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382860 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 382872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382877 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 382889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382903 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 382911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382913 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382920 */     GIR_RootConstrainSelectedInstOperands,
     /* 382921 */     // GIR_Coverage, 11240,
     /* 382921 */     GIR_EraseRootFromParent_Done,
     /* 382922 */   // Label 7407: @382922
     /* 382922 */   GIM_Reject,
     /* 382923 */ // Label 7388: @382923
     /* 382923 */ GIM_Reject,
     /* 382924 */ // Label 7113: @382924
     /* 382924 */ GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(385043),
     /* 382929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 382932 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(383051), // Rule ID 4209 //
     /* 382937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 382940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382967 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382974 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 382991 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 382991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 382994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 382998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383018 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383050 */     // GIR_Coverage, 4209,
     /* 383050 */     GIR_EraseRootFromParent_Done,
     /* 383051 */   // Label 7409: @383051
     /* 383051 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(383170), // Rule ID 4210 //
     /* 383056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383070 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383076 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383086 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383093 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383110 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383137 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383169 */     // GIR_Coverage, 4210,
     /* 383169 */     GIR_EraseRootFromParent_Done,
     /* 383170 */   // Label 7410: @383170
     /* 383170 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(383296), // Rule ID 4245 //
     /* 383175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383205 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383208 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383212 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383219 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383236 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383263 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383295 */     // GIR_Coverage, 4245,
     /* 383295 */     GIR_EraseRootFromParent_Done,
     /* 383296 */   // Label 7411: @383296
     /* 383296 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(383422), // Rule ID 4246 //
     /* 383301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383334 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383338 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383345 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383362 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383389 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383421 */     // GIR_Coverage, 4246,
     /* 383421 */     GIR_EraseRootFromParent_Done,
     /* 383422 */   // Label 7412: @383422
     /* 383422 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(383537), // Rule ID 4215 //
     /* 383427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383453 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383460 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383477 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383504 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383536 */     // GIR_Coverage, 4215,
     /* 383536 */     GIR_EraseRootFromParent_Done,
     /* 383537 */   // Label 7413: @383537
     /* 383537 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(383652), // Rule ID 4217 //
     /* 383542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383568 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383575 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383592 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383619 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383651 */     // GIR_Coverage, 4217,
     /* 383651 */     GIR_EraseRootFromParent_Done,
     /* 383652 */   // Label 7414: @383652
     /* 383652 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(383774), // Rule ID 4251 //
     /* 383657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383683 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383686 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383690 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383697 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383714 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383773 */     // GIR_Coverage, 4251,
     /* 383773 */     GIR_EraseRootFromParent_Done,
     /* 383774 */   // Label 7415: @383774
     /* 383774 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(383896), // Rule ID 4253 //
     /* 383779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383805 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383808 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383812 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 383819 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 383836 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 383843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383895 */     // GIR_Coverage, 4253,
     /* 383895 */     GIR_EraseRootFromParent_Done,
     /* 383896 */   // Label 7416: @383896
     /* 383896 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(384010), // Rule ID 4207 //
     /* 383901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383938 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 383955 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 383955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 383962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383977 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384009 */     // GIR_Coverage, 4207,
     /* 384009 */     GIR_EraseRootFromParent_Done,
     /* 384010 */   // Label 7417: @384010
     /* 384010 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(384124), // Rule ID 4208 //
     /* 384015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384029 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384035 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384045 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384052 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384069 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384091 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384123 */     // GIR_Coverage, 4208,
     /* 384123 */     GIR_EraseRootFromParent_Done,
     /* 384124 */   // Label 7418: @384124
     /* 384124 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(384245), // Rule ID 4243 //
     /* 384129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384149 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384159 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384162 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384166 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384173 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384190 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384212 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384244 */     // GIR_Coverage, 4243,
     /* 384244 */     GIR_EraseRootFromParent_Done,
     /* 384245 */   // Label 7419: @384245
     /* 384245 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(384366), // Rule ID 4244 //
     /* 384250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384264 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384270 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384280 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384283 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384287 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384294 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384311 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384333 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384365 */     // GIR_Coverage, 4244,
     /* 384365 */     GIR_EraseRootFromParent_Done,
     /* 384366 */   // Label 7420: @384366
     /* 384366 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(384476), // Rule ID 4211 //
     /* 384371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384404 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384421 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384443 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384475 */     // GIR_Coverage, 4211,
     /* 384475 */     GIR_EraseRootFromParent_Done,
     /* 384476 */   // Label 7421: @384476
     /* 384476 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(384586), // Rule ID 4213 //
     /* 384481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384507 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384514 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384531 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384553 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384585 */     // GIR_Coverage, 4213,
     /* 384585 */     GIR_EraseRootFromParent_Done,
     /* 384586 */   // Label 7422: @384586
     /* 384586 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(384703), // Rule ID 4247 //
     /* 384591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384617 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384620 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384624 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384631 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384648 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384670 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384702 */     // GIR_Coverage, 4247,
     /* 384702 */     GIR_EraseRootFromParent_Done,
     /* 384703 */   // Label 7423: @384703
     /* 384703 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(384820), // Rule ID 4249 //
     /* 384708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384734 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384737 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384741 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384748 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384765 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384819 */     // GIR_Coverage, 4249,
     /* 384819 */     GIR_EraseRootFromParent_Done,
     /* 384820 */   // Label 7424: @384820
     /* 384820 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(384894), // Rule ID 11290 //
     /* 384825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 384858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 384874 */     // MIs[3] Operand 1
     /* 384874 */     // No operand predicates
     /* 384874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384880 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 384880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 384883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 384889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 384892 */     GIR_RootConstrainSelectedInstOperands,
     /* 384893 */     // GIR_Coverage, 11290,
     /* 384893 */     GIR_EraseRootFromParent_Done,
     /* 384894 */   // Label 7425: @384894
     /* 384894 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(385042), // Rule ID 11234 //
     /* 384899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384920 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 384920 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384923 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384927 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384932 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384938 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384943 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384948 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384951 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 384955 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384960 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 384972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384977 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384980 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 384992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384997 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 385009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385023 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 385031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385033 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385040 */     GIR_RootConstrainSelectedInstOperands,
     /* 385041 */     // GIR_Coverage, 11234,
     /* 385041 */     GIR_EraseRootFromParent_Done,
     /* 385042 */   // Label 7426: @385042
     /* 385042 */   GIM_Reject,
     /* 385043 */ // Label 7408: @385043
     /* 385043 */ GIM_Reject,
     /* 385044 */ // Label 7114: @385044
     /* 385044 */ GIM_Reject,
     /* 385045 */ // Label 91: @385045
     /* 385045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7430*/ GIMT_Encode4(387962),
     /* 385056 */ /*GILLT_s16*//*Label 7427*/ GIMT_Encode4(385068),
     /* 385060 */ /*GILLT_s32*//*Label 7428*/ GIMT_Encode4(385702),
     /* 385064 */ /*GILLT_s64*//*Label 7429*/ GIMT_Encode4(387295),
     /* 385068 */ // Label 7427: @385068
     /* 385068 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(385112), // Rule ID 11283 //
     /* 385073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385086 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385090 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 385090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385095 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385111 */   // GIR_Coverage, 11283,
     /* 385111 */   GIR_EraseRootFromParent_Done,
     /* 385112 */ // Label 7431: @385112
     /* 385112 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(385156), // Rule ID 11284 //
     /* 385117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385130 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385134 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 385134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385139 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385155 */   // GIR_Coverage, 11284,
     /* 385155 */   GIR_EraseRootFromParent_Done,
     /* 385156 */ // Label 7432: @385156
     /* 385156 */ GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(385200), // Rule ID 11285 //
     /* 385161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385174 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385178 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 385178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385183 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 385189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385199 */   // GIR_Coverage, 11285,
     /* 385199 */   GIR_EraseRootFromParent_Done,
     /* 385200 */ // Label 7433: @385200
     /* 385200 */ GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(385245), // Rule ID 5813 //
     /* 385205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385219 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385223 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 385223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385228 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 385234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385244 */   // GIR_Coverage, 5813,
     /* 385244 */   GIR_EraseRootFromParent_Done,
     /* 385245 */ // Label 7434: @385245
     /* 385245 */ GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(385290), // Rule ID 5816 //
     /* 385250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385272 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385276 */   // MIs[1] Operand 1
     /* 385276 */   // No operand predicates
     /* 385276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385278 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 385278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 385281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385283 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385285 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385288 */   GIR_RootConstrainSelectedInstOperands,
     /* 385289 */   // GIR_Coverage, 5816,
     /* 385289 */   GIR_EraseRootFromParent_Done,
     /* 385290 */ // Label 7435: @385290
     /* 385290 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385366), // Rule ID 11258 //
     /* 385295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385316 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 385320 */   // MIs[1] Operand 1
     /* 385320 */   // No operand predicates
     /* 385320 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385322 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 385322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 385329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385338 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385348 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385365 */   // GIR_Coverage, 11258,
     /* 385365 */   GIR_EraseRootFromParent_Done,
     /* 385366 */ // Label 7436: @385366
     /* 385366 */ GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(385442), // Rule ID 11259 //
     /* 385371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385392 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 385396 */   // MIs[1] Operand 1
     /* 385396 */   // No operand predicates
     /* 385396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385398 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 385398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 385405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385410 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385414 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385424 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385436 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385441 */   // GIR_Coverage, 11259,
     /* 385441 */   GIR_EraseRootFromParent_Done,
     /* 385442 */ // Label 7437: @385442
     /* 385442 */ GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385518), // Rule ID 11260 //
     /* 385447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385468 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 385472 */   // MIs[1] Operand 1
     /* 385472 */   // No operand predicates
     /* 385472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385474 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 385474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 385477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 385481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 385490 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 385493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385500 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 385507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385517 */   // GIR_Coverage, 11260,
     /* 385517 */   GIR_EraseRootFromParent_Done,
     /* 385518 */ // Label 7438: @385518
     /* 385518 */ GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385579), // Rule ID 11248 //
     /* 385523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385540 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 385540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 385547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385552 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385562 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385575 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385577 */   GIR_RootConstrainSelectedInstOperands,
     /* 385578 */   // GIR_Coverage, 11248,
     /* 385578 */   GIR_EraseRootFromParent_Done,
     /* 385579 */ // Label 7439: @385579
     /* 385579 */ GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385640), // Rule ID 11249 //
     /* 385584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 385590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385601 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 385601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 385608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385613 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385623 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385636 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385638 */   GIR_RootConstrainSelectedInstOperands,
     /* 385639 */   // GIR_Coverage, 11249,
     /* 385639 */   GIR_EraseRootFromParent_Done,
     /* 385640 */ // Label 7440: @385640
     /* 385640 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(385701), // Rule ID 11250 //
     /* 385645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 385651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385662 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 385662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 385669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385674 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 385680 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 385684 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 385692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 385694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385697 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385699 */   GIR_RootConstrainSelectedInstOperands,
     /* 385700 */   // GIR_Coverage, 11250,
     /* 385700 */   GIR_EraseRootFromParent_Done,
     /* 385701 */ // Label 7441: @385701
     /* 385701 */ GIM_Reject,
     /* 385702 */ // Label 7428: @385702
     /* 385702 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(385747), // Rule ID 6992 //
     /* 385707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385721 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385725 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 385725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385730 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 385736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385746 */   // GIR_Coverage, 6992,
     /* 385746 */   GIR_EraseRootFromParent_Done,
     /* 385747 */ // Label 7442: @385747
     /* 385747 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(385792), // Rule ID 6993 //
     /* 385752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385766 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385770 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 385770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385775 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 385781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385791 */   // GIR_Coverage, 6993,
     /* 385791 */   GIR_EraseRootFromParent_Done,
     /* 385792 */ // Label 7443: @385792
     /* 385792 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(385836), // Rule ID 11279 //
     /* 385797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 385803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385810 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385814 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 385814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385819 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385830 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385835 */   // GIR_Coverage, 11279,
     /* 385835 */   GIR_EraseRootFromParent_Done,
     /* 385836 */ // Label 7444: @385836
     /* 385836 */ GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(385880), // Rule ID 11280 //
     /* 385841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385854 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385858 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 385858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385863 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385879 */   // GIR_Coverage, 11280,
     /* 385879 */   GIR_EraseRootFromParent_Done,
     /* 385880 */ // Label 7445: @385880
     /* 385880 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(385924), // Rule ID 11281 //
     /* 385885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 385891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385898 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385902 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 385902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385907 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385923 */   // GIR_Coverage, 11281,
     /* 385923 */   GIR_EraseRootFromParent_Done,
     /* 385924 */ // Label 7446: @385924
     /* 385924 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(385968), // Rule ID 11286 //
     /* 385929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 385935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385942 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385946 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 385946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385951 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 385957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385967 */   // GIR_Coverage, 11286,
     /* 385967 */   GIR_EraseRootFromParent_Done,
     /* 385968 */ // Label 7447: @385968
     /* 385968 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(386012), // Rule ID 11287 //
     /* 385973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 385979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385986 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385990 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 385990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385995 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386011 */   // GIR_Coverage, 11287,
     /* 386011 */   GIR_EraseRootFromParent_Done,
     /* 386012 */ // Label 7448: @386012
     /* 386012 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(386057), // Rule ID 5812 //
     /* 386017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386031 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386035 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 386035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386040 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386056 */   // GIR_Coverage, 5812,
     /* 386056 */   GIR_EraseRootFromParent_Done,
     /* 386057 */ // Label 7449: @386057
     /* 386057 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(386130), // Rule ID 11264 //
     /* 386062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386083 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386087 */   // MIs[1] Operand 1
     /* 386087 */   // No operand predicates
     /* 386087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386089 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 386089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386101 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 386120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386125 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386128 */   GIR_RootConstrainSelectedInstOperands,
     /* 386129 */   // GIR_Coverage, 11264,
     /* 386129 */   GIR_EraseRootFromParent_Done,
     /* 386130 */ // Label 7450: @386130
     /* 386130 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(386203), // Rule ID 11265 //
     /* 386135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386156 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386160 */   // MIs[1] Operand 1
     /* 386160 */   // No operand predicates
     /* 386160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386162 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 386162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 386165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386174 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386180 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 386193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386198 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386201 */   GIR_RootConstrainSelectedInstOperands,
     /* 386202 */   // GIR_Coverage, 11265,
     /* 386202 */   GIR_EraseRootFromParent_Done,
     /* 386203 */ // Label 7451: @386203
     /* 386203 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(386276), // Rule ID 11266 //
     /* 386208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386229 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386233 */   // MIs[1] Operand 1
     /* 386233 */   // No operand predicates
     /* 386233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386235 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 386235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 386238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386247 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 386253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 386266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386271 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 386274 */   GIR_RootConstrainSelectedInstOperands,
     /* 386275 */   // GIR_Coverage, 11266,
     /* 386275 */   GIR_EraseRootFromParent_Done,
     /* 386276 */ // Label 7452: @386276
     /* 386276 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(386324), // Rule ID 1926 //
     /* 386281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386306 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386310 */   // MIs[1] Operand 1
     /* 386310 */   // No operand predicates
     /* 386310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386312 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 386315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386319 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386322 */   GIR_RootConstrainSelectedInstOperands,
     /* 386323 */   // GIR_Coverage, 1926,
     /* 386323 */   GIR_EraseRootFromParent_Done,
     /* 386324 */ // Label 7453: @386324
     /* 386324 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(386372), // Rule ID 1927 //
     /* 386329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386354 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386358 */   // MIs[1] Operand 1
     /* 386358 */   // No operand predicates
     /* 386358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386360 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 386363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386365 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386370 */   GIR_RootConstrainSelectedInstOperands,
     /* 386371 */   // GIR_Coverage, 1927,
     /* 386371 */   GIR_EraseRootFromParent_Done,
     /* 386372 */ // Label 7454: @386372
     /* 386372 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386420), // Rule ID 1928 //
     /* 386377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 386380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386402 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 386406 */   // MIs[1] Operand 1
     /* 386406 */   // No operand predicates
     /* 386406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386408 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 386411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386413 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386415 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386418 */   GIR_RootConstrainSelectedInstOperands,
     /* 386419 */   // GIR_Coverage, 1928,
     /* 386419 */   GIR_EraseRootFromParent_Done,
     /* 386420 */ // Label 7455: @386420
     /* 386420 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386468), // Rule ID 1930 //
     /* 386425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386450 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386454 */   // MIs[1] Operand 1
     /* 386454 */   // No operand predicates
     /* 386454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386456 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 386459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386461 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386466 */   GIR_RootConstrainSelectedInstOperands,
     /* 386467 */   // GIR_Coverage, 1930,
     /* 386467 */   GIR_EraseRootFromParent_Done,
     /* 386468 */ // Label 7456: @386468
     /* 386468 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386516), // Rule ID 1931 //
     /* 386473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386498 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386502 */   // MIs[1] Operand 1
     /* 386502 */   // No operand predicates
     /* 386502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386504 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 386507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386509 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386511 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386514 */   GIR_RootConstrainSelectedInstOperands,
     /* 386515 */   // GIR_Coverage, 1931,
     /* 386515 */   GIR_EraseRootFromParent_Done,
     /* 386516 */ // Label 7457: @386516
     /* 386516 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(386564), // Rule ID 1932 //
     /* 386521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386538 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386546 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386550 */   // MIs[1] Operand 1
     /* 386550 */   // No operand predicates
     /* 386550 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386552 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 386555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386557 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386559 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386562 */   GIR_RootConstrainSelectedInstOperands,
     /* 386563 */   // GIR_Coverage, 1932,
     /* 386563 */   GIR_EraseRootFromParent_Done,
     /* 386564 */ // Label 7458: @386564
     /* 386564 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386609), // Rule ID 5815 //
     /* 386569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386591 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386595 */   // MIs[1] Operand 1
     /* 386595 */   // No operand predicates
     /* 386595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386597 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 386600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386602 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386604 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386607 */   GIR_RootConstrainSelectedInstOperands,
     /* 386608 */   // GIR_Coverage, 5815,
     /* 386608 */   GIR_EraseRootFromParent_Done,
     /* 386609 */ // Label 7459: @386609
     /* 386609 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(386685), // Rule ID 11254 //
     /* 386614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386635 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 386639 */   // MIs[1] Operand 1
     /* 386639 */   // No operand predicates
     /* 386639 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386641 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 386641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 386648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386653 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386657 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386667 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386684 */   // GIR_Coverage, 11254,
     /* 386684 */   GIR_EraseRootFromParent_Done,
     /* 386685 */ // Label 7460: @386685
     /* 386685 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386761), // Rule ID 11255 //
     /* 386690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386711 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 386715 */   // MIs[1] Operand 1
     /* 386715 */   // No operand predicates
     /* 386715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386717 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 386717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 386724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386733 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386743 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386760 */   // GIR_Coverage, 11255,
     /* 386760 */   GIR_EraseRootFromParent_Done,
     /* 386761 */ // Label 7461: @386761
     /* 386761 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(386837), // Rule ID 11256 //
     /* 386766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386779 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386787 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386791 */   // MIs[1] Operand 1
     /* 386791 */   // No operand predicates
     /* 386791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386793 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 386793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386805 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386809 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386819 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386836 */   // GIR_Coverage, 11256,
     /* 386836 */   GIR_EraseRootFromParent_Done,
     /* 386837 */ // Label 7462: @386837
     /* 386837 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386913), // Rule ID 11261 //
     /* 386842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386863 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386867 */   // MIs[1] Operand 1
     /* 386867 */   // No operand predicates
     /* 386867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386869 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 386869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386881 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386885 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386895 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386912 */   // GIR_Coverage, 11261,
     /* 386912 */   GIR_EraseRootFromParent_Done,
     /* 386913 */ // Label 7463: @386913
     /* 386913 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386989), // Rule ID 11262 //
     /* 386918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 386924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386939 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 386943 */   // MIs[1] Operand 1
     /* 386943 */   // No operand predicates
     /* 386943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386945 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 386945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 386952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386957 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386971 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 386978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386988 */   // GIR_Coverage, 11262,
     /* 386988 */   GIR_EraseRootFromParent_Done,
     /* 386989 */ // Label 7464: @386989
     /* 386989 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(387050), // Rule ID 11244 //
     /* 386994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387011 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 387011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 387018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387023 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387029 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387033 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 387041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387046 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387048 */   GIR_RootConstrainSelectedInstOperands,
     /* 387049 */   // GIR_Coverage, 11244,
     /* 387049 */   GIR_EraseRootFromParent_Done,
     /* 387050 */ // Label 7465: @387050
     /* 387050 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(387111), // Rule ID 11245 //
     /* 387055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387072 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 387072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387084 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387090 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387094 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 387102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387107 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387109 */   GIR_RootConstrainSelectedInstOperands,
     /* 387110 */   // GIR_Coverage, 11245,
     /* 387110 */   GIR_EraseRootFromParent_Done,
     /* 387111 */ // Label 7466: @387111
     /* 387111 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(387172), // Rule ID 11246 //
     /* 387116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387133 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 387133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387145 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387151 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387155 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 387163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387168 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387170 */   GIR_RootConstrainSelectedInstOperands,
     /* 387171 */   // GIR_Coverage, 11246,
     /* 387171 */   GIR_EraseRootFromParent_Done,
     /* 387172 */ // Label 7467: @387172
     /* 387172 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(387233), // Rule ID 11251 //
     /* 387177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387194 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 387194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387212 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387216 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387229 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387231 */   GIR_RootConstrainSelectedInstOperands,
     /* 387232 */   // GIR_Coverage, 11251,
     /* 387232 */   GIR_EraseRootFromParent_Done,
     /* 387233 */ // Label 7468: @387233
     /* 387233 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387294), // Rule ID 11252 //
     /* 387238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387255 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 387255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387267 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387277 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 387285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387290 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387292 */   GIR_RootConstrainSelectedInstOperands,
     /* 387293 */   // GIR_Coverage, 11252,
     /* 387293 */   GIR_EraseRootFromParent_Done,
     /* 387294 */ // Label 7469: @387294
     /* 387294 */ GIM_Reject,
     /* 387295 */ // Label 7429: @387295
     /* 387295 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387340), // Rule ID 6991 //
     /* 387300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387314 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387318 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 387318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387323 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 387329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387339 */   // GIR_Coverage, 6991,
     /* 387339 */   GIR_EraseRootFromParent_Done,
     /* 387340 */ // Label 7470: @387340
     /* 387340 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387384), // Rule ID 11282 //
     /* 387345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387358 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387362 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 387362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387367 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 387373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387383 */   // GIR_Coverage, 11282,
     /* 387383 */   GIR_EraseRootFromParent_Done,
     /* 387384 */ // Label 7471: @387384
     /* 387384 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387428), // Rule ID 11288 //
     /* 387389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387402 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387406 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 387406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387411 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 387417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387427 */   // GIR_Coverage, 11288,
     /* 387427 */   GIR_EraseRootFromParent_Done,
     /* 387428 */ // Label 7472: @387428
     /* 387428 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387473), // Rule ID 5811 //
     /* 387433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387447 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387451 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 387451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387456 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387472 */   // GIR_Coverage, 5811,
     /* 387472 */   GIR_EraseRootFromParent_Done,
     /* 387473 */ // Label 7473: @387473
     /* 387473 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387546), // Rule ID 11267 //
     /* 387478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387499 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387503 */   // MIs[1] Operand 1
     /* 387503 */   // No operand predicates
     /* 387503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387505 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 387505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 387508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387517 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 387536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387541 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387544 */   GIR_RootConstrainSelectedInstOperands,
     /* 387545 */   // GIR_Coverage, 11267,
     /* 387545 */   GIR_EraseRootFromParent_Done,
     /* 387546 */ // Label 7474: @387546
     /* 387546 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387594), // Rule ID 1929 //
     /* 387551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387576 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387580 */   // MIs[1] Operand 1
     /* 387580 */   // No operand predicates
     /* 387580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387582 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 387585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387587 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387589 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387592 */   GIR_RootConstrainSelectedInstOperands,
     /* 387593 */   // GIR_Coverage, 1929,
     /* 387593 */   GIR_EraseRootFromParent_Done,
     /* 387594 */ // Label 7475: @387594
     /* 387594 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387642), // Rule ID 1933 //
     /* 387599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387624 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387628 */   // MIs[1] Operand 1
     /* 387628 */   // No operand predicates
     /* 387628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387630 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 387633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387637 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387640 */   GIR_RootConstrainSelectedInstOperands,
     /* 387641 */   // GIR_Coverage, 1933,
     /* 387641 */   GIR_EraseRootFromParent_Done,
     /* 387642 */ // Label 7476: @387642
     /* 387642 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(387687), // Rule ID 5814 //
     /* 387647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387669 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387673 */   // MIs[1] Operand 1
     /* 387673 */   // No operand predicates
     /* 387673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387675 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 387678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387680 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387682 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387685 */   GIR_RootConstrainSelectedInstOperands,
     /* 387686 */   // GIR_Coverage, 5814,
     /* 387686 */   GIR_EraseRootFromParent_Done,
     /* 387687 */ // Label 7477: @387687
     /* 387687 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(387763), // Rule ID 11257 //
     /* 387692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387705 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387709 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387713 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387717 */   // MIs[1] Operand 1
     /* 387717 */   // No operand predicates
     /* 387717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387719 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 387719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387731 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387735 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387745 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387762 */   // GIR_Coverage, 11257,
     /* 387762 */   GIR_EraseRootFromParent_Done,
     /* 387763 */ // Label 7478: @387763
     /* 387763 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(387839), // Rule ID 11263 //
     /* 387768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387789 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387793 */   // MIs[1] Operand 1
     /* 387793 */   // No operand predicates
     /* 387793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387795 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 387795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387811 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387821 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387833 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387838 */   // GIR_Coverage, 11263,
     /* 387838 */   GIR_EraseRootFromParent_Done,
     /* 387839 */ // Label 7479: @387839
     /* 387839 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(387900), // Rule ID 11247 //
     /* 387844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387861 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 387861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387873 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387883 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 387891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387896 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387898 */   GIR_RootConstrainSelectedInstOperands,
     /* 387899 */   // GIR_Coverage, 11247,
     /* 387899 */   GIR_EraseRootFromParent_Done,
     /* 387900 */ // Label 7480: @387900
     /* 387900 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(387961), // Rule ID 11253 //
     /* 387905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 387911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387922 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 387922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387934 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387940 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387944 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 387952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387957 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387959 */   GIR_RootConstrainSelectedInstOperands,
     /* 387960 */   // GIR_Coverage, 11253,
     /* 387960 */   GIR_EraseRootFromParent_Done,
     /* 387961 */ // Label 7481: @387961
     /* 387961 */ GIM_Reject,
     /* 387962 */ // Label 7430: @387962
     /* 387962 */ GIM_Reject,
     /* 387963 */ // Label 92: @387963
     /* 387963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7489*/ GIMT_Encode4(390282),
     /* 387974 */ /*GILLT_nxv2s16*//*Label 7482*/ GIMT_Encode4(388014),
     /* 387978 */ /*GILLT_nxv2s32*//*Label 7483*/ GIMT_Encode4(388373),
     /* 387982 */ /*GILLT_nxv2s64*//*Label 7484*/ GIMT_Encode4(388675), GIMT_Encode4(0),
     /* 387990 */ /*GILLT_nxv4s16*//*Label 7485*/ GIMT_Encode4(389050),
     /* 387994 */ /*GILLT_nxv4s32*//*Label 7486*/ GIMT_Encode4(389352), GIMT_Encode4(0),
     /* 388002 */ /*GILLT_nxv8s16*//*Label 7487*/ GIMT_Encode4(389727), GIMT_Encode4(0),
     /* 388010 */ /*GILLT_nxv16s8*//*Label 7488*/ GIMT_Encode4(390138),
     /* 388014 */ // Label 7482: @388014
     /* 388014 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388372),
     /* 388019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388026 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388090), // Rule ID 6045 //
     /* 388031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388042 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388046 */     // MIs[1] Operand 1
     /* 388046 */     // No operand predicates
     /* 388046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388048 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388089 */     // GIR_Coverage, 6045,
     /* 388089 */     GIR_EraseRootFromParent_Done,
     /* 388090 */   // Label 7491: @388090
     /* 388090 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388147), // Rule ID 2668 //
     /* 388095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388131 */     // MIs[2] Operand 1
     /* 388131 */     // No operand predicates
     /* 388131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388133 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 388133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388145 */     GIR_RootConstrainSelectedInstOperands,
     /* 388146 */     // GIR_Coverage, 2668,
     /* 388146 */     GIR_EraseRootFromParent_Done,
     /* 388147 */   // Label 7492: @388147
     /* 388147 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(388204), // Rule ID 2670 //
     /* 388152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388184 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388188 */     // MIs[2] Operand 1
     /* 388188 */     // No operand predicates
     /* 388188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388190 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388202 */     GIR_RootConstrainSelectedInstOperands,
     /* 388203 */     // GIR_Coverage, 2670,
     /* 388203 */     GIR_EraseRootFromParent_Done,
     /* 388204 */   // Label 7493: @388204
     /* 388204 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388261), // Rule ID 8387 //
     /* 388209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388245 */     // MIs[2] Operand 1
     /* 388245 */     // No operand predicates
     /* 388245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388247 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 388247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388259 */     GIR_RootConstrainSelectedInstOperands,
     /* 388260 */     // GIR_Coverage, 8387,
     /* 388260 */     GIR_EraseRootFromParent_Done,
     /* 388261 */   // Label 7494: @388261
     /* 388261 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388295), // Rule ID 8430 //
     /* 388266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388277 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 388281 */     // MIs[1] Operand 1
     /* 388281 */     // No operand predicates
     /* 388281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388283 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 388283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 388286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388288 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 388293 */     GIR_RootConstrainSelectedInstOperands,
     /* 388294 */     // GIR_Coverage, 8430,
     /* 388294 */     GIR_EraseRootFromParent_Done,
     /* 388295 */   // Label 7495: @388295
     /* 388295 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(388371), // Rule ID 8408 //
     /* 388300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388307 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 388340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388369 */     GIR_RootConstrainSelectedInstOperands,
     /* 388370 */     // GIR_Coverage, 8408,
     /* 388370 */     GIR_EraseRootFromParent_Done,
     /* 388371 */   // Label 7496: @388371
     /* 388371 */   GIM_Reject,
     /* 388372 */ // Label 7490: @388372
     /* 388372 */ GIM_Reject,
     /* 388373 */ // Label 7483: @388373
     /* 388373 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(388674),
     /* 388378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388385 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(388449), // Rule ID 6043 //
     /* 388390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388401 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388405 */     // MIs[1] Operand 1
     /* 388405 */     // No operand predicates
     /* 388405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388407 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388448 */     // GIR_Coverage, 6043,
     /* 388448 */     GIR_EraseRootFromParent_Done,
     /* 388449 */   // Label 7498: @388449
     /* 388449 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(388506), // Rule ID 8396 //
     /* 388454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388490 */     // MIs[2] Operand 1
     /* 388490 */     // No operand predicates
     /* 388490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388492 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 388492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388504 */     GIR_RootConstrainSelectedInstOperands,
     /* 388505 */     // GIR_Coverage, 8396,
     /* 388505 */     GIR_EraseRootFromParent_Done,
     /* 388506 */   // Label 7499: @388506
     /* 388506 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(388563), // Rule ID 8405 //
     /* 388511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388547 */     // MIs[2] Operand 1
     /* 388547 */     // No operand predicates
     /* 388547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388549 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388561 */     GIR_RootConstrainSelectedInstOperands,
     /* 388562 */     // GIR_Coverage, 8405,
     /* 388562 */     GIR_EraseRootFromParent_Done,
     /* 388563 */   // Label 7500: @388563
     /* 388563 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(388597), // Rule ID 8432 //
     /* 388568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388579 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 388583 */     // MIs[1] Operand 1
     /* 388583 */     // No operand predicates
     /* 388583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388585 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 388585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 388588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388590 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 388595 */     GIR_RootConstrainSelectedInstOperands,
     /* 388596 */     // GIR_Coverage, 8432,
     /* 388596 */     GIR_EraseRootFromParent_Done,
     /* 388597 */   // Label 7501: @388597
     /* 388597 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(388673), // Rule ID 8410 //
     /* 388602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388609 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 388630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 388638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 388642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388671 */     GIR_RootConstrainSelectedInstOperands,
     /* 388672 */     // GIR_Coverage, 8410,
     /* 388672 */     GIR_EraseRootFromParent_Done,
     /* 388673 */   // Label 7502: @388673
     /* 388673 */   GIM_Reject,
     /* 388674 */ // Label 7497: @388674
     /* 388674 */ GIM_Reject,
     /* 388675 */ // Label 7484: @388675
     /* 388675 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(389049),
     /* 388680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388687 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(388741), // Rule ID 6038 //
     /* 388692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 388699 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388740 */     // GIR_Coverage, 6038,
     /* 388740 */     GIR_EraseRootFromParent_Done,
     /* 388741 */   // Label 7504: @388741
     /* 388741 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(388805), // Rule ID 6042 //
     /* 388746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388757 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388761 */     // MIs[1] Operand 1
     /* 388761 */     // No operand predicates
     /* 388761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388763 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388804 */     // GIR_Coverage, 6042,
     /* 388804 */     GIR_EraseRootFromParent_Done,
     /* 388805 */   // Label 7505: @388805
     /* 388805 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(388862), // Rule ID 2665 //
     /* 388810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388846 */     // MIs[2] Operand 1
     /* 388846 */     // No operand predicates
     /* 388846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388848 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388860 */     GIR_RootConstrainSelectedInstOperands,
     /* 388861 */     // GIR_Coverage, 2665,
     /* 388861 */     GIR_EraseRootFromParent_Done,
     /* 388862 */   // Label 7506: @388862
     /* 388862 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(388919), // Rule ID 8402 //
     /* 388867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 388878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388903 */     // MIs[2] Operand 1
     /* 388903 */     // No operand predicates
     /* 388903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388905 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 388905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 388914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 388917 */     GIR_RootConstrainSelectedInstOperands,
     /* 388918 */     // GIR_Coverage, 8402,
     /* 388918 */     GIR_EraseRootFromParent_Done,
     /* 388919 */   // Label 7507: @388919
     /* 388919 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(388953), // Rule ID 8433 //
     /* 388924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388935 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 388939 */     // MIs[1] Operand 1
     /* 388939 */     // No operand predicates
     /* 388939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388941 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 388941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 388944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 388946 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 388951 */     GIR_RootConstrainSelectedInstOperands,
     /* 388952 */     // GIR_Coverage, 8433,
     /* 388952 */     GIR_EraseRootFromParent_Done,
     /* 388953 */   // Label 7508: @388953
     /* 388953 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(388972), // Rule ID 2391 //
     /* 388958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 388965 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 388965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 388970 */     GIR_RootConstrainSelectedInstOperands,
     /* 388971 */     // GIR_Coverage, 2391,
     /* 388971 */     GIR_Done,
     /* 388972 */   // Label 7509: @388972
     /* 388972 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(389048), // Rule ID 8411 //
     /* 388977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388984 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388984 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 388987 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 388991 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 388998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 389020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389046 */     GIR_RootConstrainSelectedInstOperands,
     /* 389047 */     // GIR_Coverage, 8411,
     /* 389047 */     GIR_EraseRootFromParent_Done,
     /* 389048 */   // Label 7510: @389048
     /* 389048 */   GIM_Reject,
     /* 389049 */ // Label 7503: @389049
     /* 389049 */ GIM_Reject,
     /* 389050 */ // Label 7485: @389050
     /* 389050 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(389351),
     /* 389055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389062 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389126), // Rule ID 6046 //
     /* 389067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389078 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389082 */     // MIs[1] Operand 1
     /* 389082 */     // No operand predicates
     /* 389082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389084 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389125 */     // GIR_Coverage, 6046,
     /* 389125 */     GIR_EraseRootFromParent_Done,
     /* 389126 */   // Label 7512: @389126
     /* 389126 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389183), // Rule ID 2669 //
     /* 389131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389167 */     // MIs[2] Operand 1
     /* 389167 */     // No operand predicates
     /* 389167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389169 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389181 */     GIR_RootConstrainSelectedInstOperands,
     /* 389182 */     // GIR_Coverage, 2669,
     /* 389182 */     GIR_EraseRootFromParent_Done,
     /* 389183 */   // Label 7513: @389183
     /* 389183 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389240), // Rule ID 8390 //
     /* 389188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389224 */     // MIs[2] Operand 1
     /* 389224 */     // No operand predicates
     /* 389224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389226 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389238 */     GIR_RootConstrainSelectedInstOperands,
     /* 389239 */     // GIR_Coverage, 8390,
     /* 389239 */     GIR_EraseRootFromParent_Done,
     /* 389240 */   // Label 7514: @389240
     /* 389240 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389274), // Rule ID 8429 //
     /* 389245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389256 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389260 */     // MIs[1] Operand 1
     /* 389260 */     // No operand predicates
     /* 389260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389262 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389267 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 389272 */     GIR_RootConstrainSelectedInstOperands,
     /* 389273 */     // GIR_Coverage, 8429,
     /* 389273 */     GIR_EraseRootFromParent_Done,
     /* 389274 */   // Label 7515: @389274
     /* 389274 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389350), // Rule ID 8407 //
     /* 389279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389286 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389312 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389319 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389348 */     GIR_RootConstrainSelectedInstOperands,
     /* 389349 */     // GIR_Coverage, 8407,
     /* 389349 */     GIR_EraseRootFromParent_Done,
     /* 389350 */   // Label 7516: @389350
     /* 389350 */   GIM_Reject,
     /* 389351 */ // Label 7511: @389351
     /* 389351 */ GIM_Reject,
     /* 389352 */ // Label 7486: @389352
     /* 389352 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389726),
     /* 389357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389364 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(389418), // Rule ID 6039 //
     /* 389369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389376 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389417 */     // GIR_Coverage, 6039,
     /* 389417 */     GIR_EraseRootFromParent_Done,
     /* 389418 */   // Label 7518: @389418
     /* 389418 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(389482), // Rule ID 6044 //
     /* 389423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389434 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389438 */     // MIs[1] Operand 1
     /* 389438 */     // No operand predicates
     /* 389438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389440 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389481 */     // GIR_Coverage, 6044,
     /* 389481 */     GIR_EraseRootFromParent_Done,
     /* 389482 */   // Label 7519: @389482
     /* 389482 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(389539), // Rule ID 2662 //
     /* 389487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389523 */     // MIs[2] Operand 1
     /* 389523 */     // No operand predicates
     /* 389523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389525 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389537 */     GIR_RootConstrainSelectedInstOperands,
     /* 389538 */     // GIR_Coverage, 2662,
     /* 389538 */     GIR_EraseRootFromParent_Done,
     /* 389539 */   // Label 7520: @389539
     /* 389539 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(389596), // Rule ID 8399 //
     /* 389544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389580 */     // MIs[2] Operand 1
     /* 389580 */     // No operand predicates
     /* 389580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389582 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389594 */     GIR_RootConstrainSelectedInstOperands,
     /* 389595 */     // GIR_Coverage, 8399,
     /* 389595 */     GIR_EraseRootFromParent_Done,
     /* 389596 */   // Label 7521: @389596
     /* 389596 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(389630), // Rule ID 8431 //
     /* 389601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389612 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 389616 */     // MIs[1] Operand 1
     /* 389616 */     // No operand predicates
     /* 389616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389618 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 389618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 389621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389623 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 389628 */     GIR_RootConstrainSelectedInstOperands,
     /* 389629 */     // GIR_Coverage, 8431,
     /* 389629 */     GIR_EraseRootFromParent_Done,
     /* 389630 */   // Label 7522: @389630
     /* 389630 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(389649), // Rule ID 2390 //
     /* 389635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 389642 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 389642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 389647 */     GIR_RootConstrainSelectedInstOperands,
     /* 389648 */     // GIR_Coverage, 2390,
     /* 389648 */     GIR_Done,
     /* 389649 */   // Label 7523: @389649
     /* 389649 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(389725), // Rule ID 8409 //
     /* 389654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389661 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389723 */     GIR_RootConstrainSelectedInstOperands,
     /* 389724 */     // GIR_Coverage, 8409,
     /* 389724 */     GIR_EraseRootFromParent_Done,
     /* 389725 */   // Label 7524: @389725
     /* 389725 */   GIM_Reject,
     /* 389726 */ // Label 7517: @389726
     /* 389726 */ GIM_Reject,
     /* 389727 */ // Label 7487: @389727
     /* 389727 */ GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(389788), // Rule ID 6040 //
     /* 389732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389742 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389746 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389758 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389787 */   // GIR_Coverage, 6040,
     /* 389787 */   GIR_EraseRootFromParent_Done,
     /* 389788 */ // Label 7525: @389788
     /* 389788 */ GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(389859), // Rule ID 6047 //
     /* 389793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389811 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389815 */   // MIs[1] Operand 1
     /* 389815 */   // No operand predicates
     /* 389815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389817 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389829 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389858 */   // GIR_Coverage, 6047,
     /* 389858 */   GIR_EraseRootFromParent_Done,
     /* 389859 */ // Label 7526: @389859
     /* 389859 */ GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(389923), // Rule ID 2659 //
     /* 389864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389895 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389899 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389903 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389907 */   // MIs[2] Operand 1
     /* 389907 */   // No operand predicates
     /* 389907 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389909 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389914 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389918 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389921 */   GIR_RootConstrainSelectedInstOperands,
     /* 389922 */   // GIR_Coverage, 2659,
     /* 389922 */   GIR_EraseRootFromParent_Done,
     /* 389923 */ // Label 7527: @389923
     /* 389923 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(389987), // Rule ID 8393 //
     /* 389928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389946 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389950 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389954 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389959 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389963 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389967 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389971 */   // MIs[2] Operand 1
     /* 389971 */   // No operand predicates
     /* 389971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389973 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389978 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389982 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389985 */   GIR_RootConstrainSelectedInstOperands,
     /* 389986 */   // GIR_Coverage, 8393,
     /* 389986 */   GIR_EraseRootFromParent_Done,
     /* 389987 */ // Label 7528: @389987
     /* 389987 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(390028), // Rule ID 8428 //
     /* 389992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390010 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390014 */   // MIs[1] Operand 1
     /* 390014 */   // No operand predicates
     /* 390014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390016 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390021 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390026 */   GIR_RootConstrainSelectedInstOperands,
     /* 390027 */   // GIR_Coverage, 8428,
     /* 390027 */   GIR_EraseRootFromParent_Done,
     /* 390028 */ // Label 7529: @390028
     /* 390028 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(390054), // Rule ID 2389 //
     /* 390033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390047 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 390052 */   GIR_RootConstrainSelectedInstOperands,
     /* 390053 */   // GIR_Coverage, 2389,
     /* 390053 */   GIR_Done,
     /* 390054 */ // Label 7530: @390054
     /* 390054 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390137), // Rule ID 8406 //
     /* 390059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390073 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390073 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390076 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390080 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390099 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390102 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390106 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390119 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390135 */   GIR_RootConstrainSelectedInstOperands,
     /* 390136 */   // GIR_Coverage, 8406,
     /* 390136 */   GIR_EraseRootFromParent_Done,
     /* 390137 */ // Label 7531: @390137
     /* 390137 */ GIM_Reject,
     /* 390138 */ // Label 7488: @390138
     /* 390138 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390281),
     /* 390143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390150 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390204), // Rule ID 6041 //
     /* 390155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390162 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390203 */     // GIR_Coverage, 6041,
     /* 390203 */     GIR_EraseRootFromParent_Done,
     /* 390204 */   // Label 7533: @390204
     /* 390204 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390261), // Rule ID 2656 //
     /* 390209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 390224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 390245 */     // MIs[2] Operand 1
     /* 390245 */     // No operand predicates
     /* 390245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390247 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 390247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 390250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390259 */     GIR_RootConstrainSelectedInstOperands,
     /* 390260 */     // GIR_Coverage, 2656,
     /* 390260 */     GIR_EraseRootFromParent_Done,
     /* 390261 */   // Label 7534: @390261
     /* 390261 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390280), // Rule ID 2388 //
     /* 390266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390273 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 390278 */     GIR_RootConstrainSelectedInstOperands,
     /* 390279 */     // GIR_Coverage, 2388,
     /* 390279 */     GIR_Done,
     /* 390280 */   // Label 7535: @390280
     /* 390280 */   GIM_Reject,
     /* 390281 */ // Label 7532: @390281
     /* 390281 */ GIM_Reject,
     /* 390282 */ // Label 7489: @390282
     /* 390282 */ GIM_Reject,
     /* 390283 */ // Label 93: @390283
     /* 390283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7538*/ GIMT_Encode4(390434),
     /* 390294 */ /*GILLT_s32*//*Label 7536*/ GIMT_Encode4(390302),
     /* 390298 */ /*GILLT_s64*//*Label 7537*/ GIMT_Encode4(390368),
     /* 390302 */ // Label 7536: @390302
     /* 390302 */ GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390367),
     /* 390307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390318 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(390333), // Rule ID 2321 //
     /* 390323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 390326 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 390331 */     GIR_RootConstrainSelectedInstOperands,
     /* 390332 */     // GIR_Coverage, 2321,
     /* 390332 */     GIR_Done,
     /* 390333 */   // Label 7540: @390333
     /* 390333 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(390366), // Rule ID 4002 //
     /* 390338 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 390338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 390341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 390345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 390359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390364 */     GIR_RootConstrainSelectedInstOperands,
     /* 390365 */     // GIR_Coverage, 4002,
     /* 390365 */     GIR_EraseRootFromParent_Done,
     /* 390366 */   // Label 7541: @390366
     /* 390366 */   GIM_Reject,
     /* 390367 */ // Label 7539: @390367
     /* 390367 */ GIM_Reject,
     /* 390368 */ // Label 7537: @390368
     /* 390368 */ GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(390433),
     /* 390373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390384 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(390399), // Rule ID 2322 //
     /* 390389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 390392 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 390397 */     GIR_RootConstrainSelectedInstOperands,
     /* 390398 */     // GIR_Coverage, 2322,
     /* 390398 */     GIR_Done,
     /* 390399 */   // Label 7543: @390399
     /* 390399 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(390432), // Rule ID 4003 //
     /* 390404 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 390404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 390407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 390411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 390425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390430 */     GIR_RootConstrainSelectedInstOperands,
     /* 390431 */     // GIR_Coverage, 4003,
     /* 390431 */     GIR_EraseRootFromParent_Done,
     /* 390432 */   // Label 7544: @390432
     /* 390432 */   GIM_Reject,
     /* 390433 */ // Label 7542: @390433
     /* 390433 */ GIM_Reject,
     /* 390434 */ // Label 7538: @390434
     /* 390434 */ GIM_Reject,
     /* 390435 */ // Label 94: @390435
     /* 390435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7553*/ GIMT_Encode4(391108),
     /* 390446 */ /*GILLT_s32*//*Label 7545*/ GIMT_Encode4(390486),
     /* 390450 */ /*GILLT_s64*//*Label 7546*/ GIMT_Encode4(390716), GIMT_Encode4(0),
     /* 390458 */ /*GILLT_v2s32*//*Label 7547*/ GIMT_Encode4(390946), GIMT_Encode4(0),
     /* 390466 */ /*GILLT_v4s16*//*Label 7548*/ GIMT_Encode4(390973),
     /* 390470 */ /*GILLT_v4s32*//*Label 7549*/ GIMT_Encode4(391000),
     /* 390474 */ /*GILLT_v8s8*//*Label 7550*/ GIMT_Encode4(391027),
     /* 390478 */ /*GILLT_v8s16*//*Label 7551*/ GIMT_Encode4(391054),
     /* 390482 */ /*GILLT_v16s8*//*Label 7552*/ GIMT_Encode4(391081),
     /* 390486 */ // Label 7545: @390486
     /* 390486 */ GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(390715),
     /* 390491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390498 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(390598), // Rule ID 4004 //
     /* 390503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 390519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 390547 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 390551 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390555 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 390559 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390563 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390568 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 390572 */     // MIs[3] Rn
     /* 390572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 390577 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390581 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390585 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390587 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 390590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 390596 */     GIR_RootConstrainSelectedInstOperands,
     /* 390597 */     // GIR_Coverage, 4004,
     /* 390597 */     GIR_EraseRootFromParent_Done,
     /* 390598 */   // Label 7555: @390598
     /* 390598 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(390698), // Rule ID 13879 //
     /* 390603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 390619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 390647 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 390651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 390660 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390664 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390668 */     // MIs[4] Rn
     /* 390668 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 390673 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 390677 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390681 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390687 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 390690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390696 */     GIR_RootConstrainSelectedInstOperands,
     /* 390697 */     // GIR_Coverage, 13879,
     /* 390697 */     GIR_EraseRootFromParent_Done,
     /* 390698 */   // Label 7556: @390698
     /* 390698 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(390714), // Rule ID 180 //
     /* 390703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 390707 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 390707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 390712 */     GIR_RootConstrainSelectedInstOperands,
     /* 390713 */     // GIR_Coverage, 180,
     /* 390713 */     GIR_Done,
     /* 390714 */   // Label 7557: @390714
     /* 390714 */   GIM_Reject,
     /* 390715 */ // Label 7554: @390715
     /* 390715 */ GIM_Reject,
     /* 390716 */ // Label 7546: @390716
     /* 390716 */ GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(390945),
     /* 390721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390728 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(390828), // Rule ID 4005 //
     /* 390733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 390777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 390781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390785 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 390789 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390793 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390798 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 390802 */     // MIs[3] Rn
     /* 390802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 390807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390811 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390815 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390817 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 390820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 390826 */     GIR_RootConstrainSelectedInstOperands,
     /* 390827 */     // GIR_Coverage, 4005,
     /* 390827 */     GIR_EraseRootFromParent_Done,
     /* 390828 */   // Label 7559: @390828
     /* 390828 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(390928), // Rule ID 13880 //
     /* 390833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 390841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 390857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 390873 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 390877 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 390881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390886 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 390890 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 390894 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 390898 */     // MIs[4] Rn
     /* 390898 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 390903 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 390907 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 390911 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 390915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 390917 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 390920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390926 */     GIR_RootConstrainSelectedInstOperands,
     /* 390927 */     // GIR_Coverage, 13880,
     /* 390927 */     GIR_EraseRootFromParent_Done,
     /* 390928 */   // Label 7560: @390928
     /* 390928 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(390944), // Rule ID 181 //
     /* 390933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390937 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 390937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 390942 */     GIR_RootConstrainSelectedInstOperands,
     /* 390943 */     // GIR_Coverage, 181,
     /* 390943 */     GIR_Done,
     /* 390944 */   // Label 7561: @390944
     /* 390944 */   GIM_Reject,
     /* 390945 */ // Label 7558: @390945
     /* 390945 */ GIM_Reject,
     /* 390946 */ // Label 7547: @390946
     /* 390946 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(390972), // Rule ID 720 //
     /* 390951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390965 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 390965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 390970 */   GIR_RootConstrainSelectedInstOperands,
     /* 390971 */   // GIR_Coverage, 720,
     /* 390971 */   GIR_Done,
     /* 390972 */ // Label 7562: @390972
     /* 390972 */ GIM_Reject,
     /* 390973 */ // Label 7548: @390973
     /* 390973 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(390999), // Rule ID 718 //
     /* 390978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390992 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 390992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 390997 */   GIR_RootConstrainSelectedInstOperands,
     /* 390998 */   // GIR_Coverage, 718,
     /* 390998 */   GIR_Done,
     /* 390999 */ // Label 7563: @390999
     /* 390999 */ GIM_Reject,
     /* 391000 */ // Label 7549: @391000
     /* 391000 */ GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(391026), // Rule ID 721 //
     /* 391005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391019 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 391024 */   GIR_RootConstrainSelectedInstOperands,
     /* 391025 */   // GIR_Coverage, 721,
     /* 391025 */   GIR_Done,
     /* 391026 */ // Label 7564: @391026
     /* 391026 */ GIM_Reject,
     /* 391027 */ // Label 7550: @391027
     /* 391027 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(391053), // Rule ID 716 //
     /* 391032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391046 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 391051 */   GIR_RootConstrainSelectedInstOperands,
     /* 391052 */   // GIR_Coverage, 716,
     /* 391052 */   GIR_Done,
     /* 391053 */ // Label 7565: @391053
     /* 391053 */ GIM_Reject,
     /* 391054 */ // Label 7551: @391054
     /* 391054 */ GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(391080), // Rule ID 719 //
     /* 391059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391073 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 391078 */   GIR_RootConstrainSelectedInstOperands,
     /* 391079 */   // GIR_Coverage, 719,
     /* 391079 */   GIR_Done,
     /* 391080 */ // Label 7566: @391080
     /* 391080 */ GIM_Reject,
     /* 391081 */ // Label 7552: @391081
     /* 391081 */ GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(391107), // Rule ID 717 //
     /* 391086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391100 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 391105 */   GIR_RootConstrainSelectedInstOperands,
     /* 391106 */   // GIR_Coverage, 717,
     /* 391106 */   GIR_Done,
     /* 391107 */ // Label 7567: @391107
     /* 391107 */ GIM_Reject,
     /* 391108 */ // Label 7553: @391108
     /* 391108 */ GIM_Reject,
     /* 391109 */ // Label 95: @391109
     /* 391109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7572*/ GIMT_Encode4(391268),
     /* 391120 */ /*GILLT_s32*//*Label 7568*/ GIMT_Encode4(391160),
     /* 391124 */ /*GILLT_s64*//*Label 7569*/ GIMT_Encode4(391187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391148 */ /*GILLT_v8s8*//*Label 7570*/ GIMT_Encode4(391214), GIMT_Encode4(0),
     /* 391156 */ /*GILLT_v16s8*//*Label 7571*/ GIMT_Encode4(391241),
     /* 391160 */ // Label 7568: @391160
     /* 391160 */ GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(391186), // Rule ID 2319 //
     /* 391165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391179 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 391184 */   GIR_RootConstrainSelectedInstOperands,
     /* 391185 */   // GIR_Coverage, 2319,
     /* 391185 */   GIR_Done,
     /* 391186 */ // Label 7573: @391186
     /* 391186 */ GIM_Reject,
     /* 391187 */ // Label 7569: @391187
     /* 391187 */ GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(391213), // Rule ID 2320 //
     /* 391192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391206 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 391211 */   GIR_RootConstrainSelectedInstOperands,
     /* 391212 */   // GIR_Coverage, 2320,
     /* 391212 */   GIR_Done,
     /* 391213 */ // Label 7574: @391213
     /* 391213 */ GIM_Reject,
     /* 391214 */ // Label 7570: @391214
     /* 391214 */ GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(391240), // Rule ID 764 //
     /* 391219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391233 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 391238 */   GIR_RootConstrainSelectedInstOperands,
     /* 391239 */   // GIR_Coverage, 764,
     /* 391239 */   GIR_Done,
     /* 391240 */ // Label 7575: @391240
     /* 391240 */ GIM_Reject,
     /* 391241 */ // Label 7571: @391241
     /* 391241 */ GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(391267), // Rule ID 765 //
     /* 391246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391260 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 391265 */   GIR_RootConstrainSelectedInstOperands,
     /* 391266 */   // GIR_Coverage, 765,
     /* 391266 */   GIR_Done,
     /* 391267 */ // Label 7576: @391267
     /* 391267 */ GIM_Reject,
     /* 391268 */ // Label 7572: @391268
     /* 391268 */ GIM_Reject,
     /* 391269 */ // Label 96: @391269
     /* 391269 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7584*/ GIMT_Encode4(391582),
     /* 391280 */ /*GILLT_s32*//*Label 7577*/ GIMT_Encode4(391316),
     /* 391284 */ /*GILLT_s64*//*Label 7578*/ GIMT_Encode4(391389), GIMT_Encode4(0),
     /* 391292 */ /*GILLT_v2s32*//*Label 7579*/ GIMT_Encode4(391462),
     /* 391296 */ /*GILLT_v2s64*//*Label 7580*/ GIMT_Encode4(391486),
     /* 391300 */ /*GILLT_v4s16*//*Label 7581*/ GIMT_Encode4(391510),
     /* 391304 */ /*GILLT_v4s32*//*Label 7582*/ GIMT_Encode4(391534), GIMT_Encode4(0),
     /* 391312 */ /*GILLT_v8s16*//*Label 7583*/ GIMT_Encode4(391558),
     /* 391316 */ // Label 7577: @391316
     /* 391316 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(391388),
     /* 391321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391328 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(391371), // Rule ID 4008 //
     /* 391333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 391341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 391358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391360 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 391363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391369 */     GIR_RootConstrainSelectedInstOperands,
     /* 391370 */     // GIR_Coverage, 4008,
     /* 391370 */     GIR_EraseRootFromParent_Done,
     /* 391371 */   // Label 7586: @391371
     /* 391371 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(391387), // Rule ID 185 //
     /* 391376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391380 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 391385 */     GIR_RootConstrainSelectedInstOperands,
     /* 391386 */     // GIR_Coverage, 185,
     /* 391386 */     GIR_Done,
     /* 391387 */   // Label 7587: @391387
     /* 391387 */   GIM_Reject,
     /* 391388 */ // Label 7585: @391388
     /* 391388 */ GIM_Reject,
     /* 391389 */ // Label 7578: @391389
     /* 391389 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(391461),
     /* 391394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391401 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(391444), // Rule ID 4009 //
     /* 391406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 391414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391427 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 391431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391433 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 391436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391442 */     GIR_RootConstrainSelectedInstOperands,
     /* 391443 */     // GIR_Coverage, 4009,
     /* 391443 */     GIR_EraseRootFromParent_Done,
     /* 391444 */   // Label 7589: @391444
     /* 391444 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(391460), // Rule ID 186 //
     /* 391449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391453 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 391458 */     GIR_RootConstrainSelectedInstOperands,
     /* 391459 */     // GIR_Coverage, 186,
     /* 391459 */     GIR_Done,
     /* 391460 */   // Label 7590: @391460
     /* 391460 */   GIM_Reject,
     /* 391461 */ // Label 7588: @391461
     /* 391461 */ GIM_Reject,
     /* 391462 */ // Label 7579: @391462
     /* 391462 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(391485), // Rule ID 5021 //
     /* 391467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391478 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 391483 */   GIR_RootConstrainSelectedInstOperands,
     /* 391484 */   // GIR_Coverage, 5021,
     /* 391484 */   GIR_Done,
     /* 391485 */ // Label 7591: @391485
     /* 391485 */ GIM_Reject,
     /* 391486 */ // Label 7580: @391486
     /* 391486 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(391509), // Rule ID 5023 //
     /* 391491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391502 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 391502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 391507 */   GIR_RootConstrainSelectedInstOperands,
     /* 391508 */   // GIR_Coverage, 5023,
     /* 391508 */   GIR_Done,
     /* 391509 */ // Label 7592: @391509
     /* 391509 */ GIM_Reject,
     /* 391510 */ // Label 7581: @391510
     /* 391510 */ GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(391533), // Rule ID 5019 //
     /* 391515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391526 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 391531 */   GIR_RootConstrainSelectedInstOperands,
     /* 391532 */   // GIR_Coverage, 5019,
     /* 391532 */   GIR_Done,
     /* 391533 */ // Label 7593: @391533
     /* 391533 */ GIM_Reject,
     /* 391534 */ // Label 7582: @391534
     /* 391534 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(391557), // Rule ID 5022 //
     /* 391539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391550 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 391555 */   GIR_RootConstrainSelectedInstOperands,
     /* 391556 */   // GIR_Coverage, 5022,
     /* 391556 */   GIR_Done,
     /* 391557 */ // Label 7594: @391557
     /* 391557 */ GIM_Reject,
     /* 391558 */ // Label 7583: @391558
     /* 391558 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(391581), // Rule ID 5020 //
     /* 391563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391574 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 391579 */   GIR_RootConstrainSelectedInstOperands,
     /* 391580 */   // GIR_Coverage, 5020,
     /* 391580 */   GIR_Done,
     /* 391581 */ // Label 7595: @391581
     /* 391581 */ GIM_Reject,
     /* 391582 */ // Label 7584: @391582
     /* 391582 */ GIM_Reject,
     /* 391583 */ // Label 97: @391583
     /* 391583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7600*/ GIMT_Encode4(391736),
     /* 391594 */ /*GILLT_s32*//*Label 7596*/ GIMT_Encode4(391634),
     /* 391598 */ /*GILLT_s64*//*Label 7597*/ GIMT_Encode4(391658), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391622 */ /*GILLT_v8s8*//*Label 7598*/ GIMT_Encode4(391682), GIMT_Encode4(0),
     /* 391630 */ /*GILLT_v16s8*//*Label 7599*/ GIMT_Encode4(391709),
     /* 391634 */ // Label 7596: @391634
     /* 391634 */ GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(391657), // Rule ID 182 //
     /* 391639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391650 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 391655 */   GIR_RootConstrainSelectedInstOperands,
     /* 391656 */   // GIR_Coverage, 182,
     /* 391656 */   GIR_Done,
     /* 391657 */ // Label 7601: @391657
     /* 391657 */ GIM_Reject,
     /* 391658 */ // Label 7597: @391658
     /* 391658 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(391681), // Rule ID 183 //
     /* 391663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391674 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 391679 */   GIR_RootConstrainSelectedInstOperands,
     /* 391680 */   // GIR_Coverage, 183,
     /* 391680 */   GIR_Done,
     /* 391681 */ // Label 7602: @391681
     /* 391681 */ GIM_Reject,
     /* 391682 */ // Label 7598: @391682
     /* 391682 */ GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(391708), // Rule ID 974 //
     /* 391687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391701 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 391706 */   GIR_RootConstrainSelectedInstOperands,
     /* 391707 */   // GIR_Coverage, 974,
     /* 391707 */   GIR_Done,
     /* 391708 */ // Label 7603: @391708
     /* 391708 */ GIM_Reject,
     /* 391709 */ // Label 7599: @391709
     /* 391709 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(391735), // Rule ID 975 //
     /* 391714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391728 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 391733 */   GIR_RootConstrainSelectedInstOperands,
     /* 391734 */   // GIR_Coverage, 975,
     /* 391734 */   GIR_Done,
     /* 391735 */ // Label 7604: @391735
     /* 391735 */ GIM_Reject,
     /* 391736 */ // Label 7600: @391736
     /* 391736 */ GIM_Reject,
     /* 391737 */ // Label 98: @391737
     /* 391737 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7613*/ GIMT_Encode4(392227),
     /* 391748 */ /*GILLT_s16*//*Label 7605*/ GIMT_Encode4(391788),
     /* 391752 */ /*GILLT_s32*//*Label 7606*/ GIMT_Encode4(391819),
     /* 391756 */ /*GILLT_s64*//*Label 7607*/ GIMT_Encode4(391850), GIMT_Encode4(0),
     /* 391764 */ /*GILLT_v2s32*//*Label 7608*/ GIMT_Encode4(391881),
     /* 391768 */ /*GILLT_v2s64*//*Label 7609*/ GIMT_Encode4(391912),
     /* 391772 */ /*GILLT_v4s16*//*Label 7610*/ GIMT_Encode4(391943),
     /* 391776 */ /*GILLT_v4s32*//*Label 7611*/ GIMT_Encode4(391974), GIMT_Encode4(0),
     /* 391784 */ /*GILLT_v8s16*//*Label 7612*/ GIMT_Encode4(392005),
     /* 391788 */ // Label 7605: @391788
     /* 391788 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(391818), // Rule ID 552 //
     /* 391793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391807 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 391807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 391812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391816 */   GIR_RootConstrainSelectedInstOperands,
     /* 391817 */   // GIR_Coverage, 552,
     /* 391817 */   GIR_Done,
     /* 391818 */ // Label 7614: @391818
     /* 391818 */ GIM_Reject,
     /* 391819 */ // Label 7606: @391819
     /* 391819 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(391849), // Rule ID 554 //
     /* 391824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391838 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 391838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 391843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391847 */   GIR_RootConstrainSelectedInstOperands,
     /* 391848 */   // GIR_Coverage, 554,
     /* 391848 */   GIR_Done,
     /* 391849 */ // Label 7615: @391849
     /* 391849 */ GIM_Reject,
     /* 391850 */ // Label 7607: @391850
     /* 391850 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(391880), // Rule ID 556 //
     /* 391855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391869 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 391869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 391874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391878 */   GIR_RootConstrainSelectedInstOperands,
     /* 391879 */   // GIR_Coverage, 556,
     /* 391879 */   GIR_Done,
     /* 391880 */ // Label 7616: @391880
     /* 391880 */ GIM_Reject,
     /* 391881 */ // Label 7608: @391881
     /* 391881 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(391911), // Rule ID 913 //
     /* 391886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391900 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 391905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391909 */   GIR_RootConstrainSelectedInstOperands,
     /* 391910 */   // GIR_Coverage, 913,
     /* 391910 */   GIR_Done,
     /* 391911 */ // Label 7617: @391911
     /* 391911 */ GIM_Reject,
     /* 391912 */ // Label 7609: @391912
     /* 391912 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(391942), // Rule ID 917 //
     /* 391917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391931 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 391931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 391936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391940 */   GIR_RootConstrainSelectedInstOperands,
     /* 391941 */   // GIR_Coverage, 917,
     /* 391941 */   GIR_Done,
     /* 391942 */ // Label 7618: @391942
     /* 391942 */ GIM_Reject,
     /* 391943 */ // Label 7610: @391943
     /* 391943 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(391973), // Rule ID 909 //
     /* 391948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391962 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 391967 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391971 */   GIR_RootConstrainSelectedInstOperands,
     /* 391972 */   // GIR_Coverage, 909,
     /* 391972 */   GIR_Done,
     /* 391973 */ // Label 7619: @391973
     /* 391973 */ GIM_Reject,
     /* 391974 */ // Label 7611: @391974
     /* 391974 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(392004), // Rule ID 915 //
     /* 391979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391993 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 391998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392002 */   GIR_RootConstrainSelectedInstOperands,
     /* 392003 */   // GIR_Coverage, 915,
     /* 392003 */   GIR_Done,
     /* 392004 */ // Label 7620: @392004
     /* 392004 */ GIM_Reject,
     /* 392005 */ // Label 7612: @392005
     /* 392005 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(392226),
     /* 392010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392021 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(392040), // Rule ID 911 //
     /* 392026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392029 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 392034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392038 */     GIR_RootConstrainSelectedInstOperands,
     /* 392039 */     // GIR_Coverage, 911,
     /* 392039 */     GIR_Done,
     /* 392040 */   // Label 7622: @392040
     /* 392040 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(392225), // Rule ID 7024 //
     /* 392045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392048 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392048 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392051 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392055 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392060 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392066 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392069 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392073 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392078 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392083 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392086 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392090 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392095 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 392101 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392106 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392111 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 392114 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 392118 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392123 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 392126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 392128 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 392131 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392135 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392140 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 392143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 392145 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 392148 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 392152 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392157 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 392160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 392194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 392215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 392223 */     GIR_RootConstrainSelectedInstOperands,
     /* 392224 */     // GIR_Coverage, 7024,
     /* 392224 */     GIR_EraseRootFromParent_Done,
     /* 392225 */   // Label 7623: @392225
     /* 392225 */   GIM_Reject,
     /* 392226 */ // Label 7621: @392226
     /* 392226 */ GIM_Reject,
     /* 392227 */ // Label 7613: @392227
     /* 392227 */ GIM_Reject,
     /* 392228 */ // Label 99: @392228
     /* 392228 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7632*/ GIMT_Encode4(392527),
     /* 392239 */ /*GILLT_s16*//*Label 7624*/ GIMT_Encode4(392279),
     /* 392243 */ /*GILLT_s32*//*Label 7625*/ GIMT_Encode4(392310),
     /* 392247 */ /*GILLT_s64*//*Label 7626*/ GIMT_Encode4(392341), GIMT_Encode4(0),
     /* 392255 */ /*GILLT_v2s32*//*Label 7627*/ GIMT_Encode4(392372),
     /* 392259 */ /*GILLT_v2s64*//*Label 7628*/ GIMT_Encode4(392403),
     /* 392263 */ /*GILLT_v4s16*//*Label 7629*/ GIMT_Encode4(392434),
     /* 392267 */ /*GILLT_v4s32*//*Label 7630*/ GIMT_Encode4(392465), GIMT_Encode4(0),
     /* 392275 */ /*GILLT_v8s16*//*Label 7631*/ GIMT_Encode4(392496),
     /* 392279 */ // Label 7624: @392279
     /* 392279 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(392309), // Rule ID 570 //
     /* 392284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392298 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 392303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392307 */   GIR_RootConstrainSelectedInstOperands,
     /* 392308 */   // GIR_Coverage, 570,
     /* 392308 */   GIR_Done,
     /* 392309 */ // Label 7633: @392309
     /* 392309 */ GIM_Reject,
     /* 392310 */ // Label 7625: @392310
     /* 392310 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(392340), // Rule ID 572 //
     /* 392315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392329 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 392334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392338 */   GIR_RootConstrainSelectedInstOperands,
     /* 392339 */   // GIR_Coverage, 572,
     /* 392339 */   GIR_Done,
     /* 392340 */ // Label 7634: @392340
     /* 392340 */ GIM_Reject,
     /* 392341 */ // Label 7626: @392341
     /* 392341 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(392371), // Rule ID 574 //
     /* 392346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392360 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 392365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392369 */   GIR_RootConstrainSelectedInstOperands,
     /* 392370 */   // GIR_Coverage, 574,
     /* 392370 */   GIR_Done,
     /* 392371 */ // Label 7635: @392371
     /* 392371 */ GIM_Reject,
     /* 392372 */ // Label 7627: @392372
     /* 392372 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(392402), // Rule ID 960 //
     /* 392377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392391 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 392396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392400 */   GIR_RootConstrainSelectedInstOperands,
     /* 392401 */   // GIR_Coverage, 960,
     /* 392401 */   GIR_Done,
     /* 392402 */ // Label 7636: @392402
     /* 392402 */ GIM_Reject,
     /* 392403 */ // Label 7628: @392403
     /* 392403 */ GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(392433), // Rule ID 964 //
     /* 392408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392422 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 392427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392431 */   GIR_RootConstrainSelectedInstOperands,
     /* 392432 */   // GIR_Coverage, 964,
     /* 392432 */   GIR_Done,
     /* 392433 */ // Label 7637: @392433
     /* 392433 */ GIM_Reject,
     /* 392434 */ // Label 7629: @392434
     /* 392434 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(392464), // Rule ID 956 //
     /* 392439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392453 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 392458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392462 */   GIR_RootConstrainSelectedInstOperands,
     /* 392463 */   // GIR_Coverage, 956,
     /* 392463 */   GIR_Done,
     /* 392464 */ // Label 7638: @392464
     /* 392464 */ GIM_Reject,
     /* 392465 */ // Label 7630: @392465
     /* 392465 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(392495), // Rule ID 962 //
     /* 392470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392484 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 392489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392493 */   GIR_RootConstrainSelectedInstOperands,
     /* 392494 */   // GIR_Coverage, 962,
     /* 392494 */   GIR_Done,
     /* 392495 */ // Label 7639: @392495
     /* 392495 */ GIM_Reject,
     /* 392496 */ // Label 7631: @392496
     /* 392496 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(392526), // Rule ID 958 //
     /* 392501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392515 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 392520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392524 */   GIR_RootConstrainSelectedInstOperands,
     /* 392525 */   // GIR_Coverage, 958,
     /* 392525 */   GIR_Done,
     /* 392526 */ // Label 7640: @392526
     /* 392526 */ GIM_Reject,
     /* 392527 */ // Label 7632: @392527
     /* 392527 */ GIM_Reject,
     /* 392528 */ // Label 100: @392528
     /* 392528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7649*/ GIMT_Encode4(393018),
     /* 392539 */ /*GILLT_s16*//*Label 7641*/ GIMT_Encode4(392579),
     /* 392543 */ /*GILLT_s32*//*Label 7642*/ GIMT_Encode4(392610),
     /* 392547 */ /*GILLT_s64*//*Label 7643*/ GIMT_Encode4(392641), GIMT_Encode4(0),
     /* 392555 */ /*GILLT_v2s32*//*Label 7644*/ GIMT_Encode4(392672),
     /* 392559 */ /*GILLT_v2s64*//*Label 7645*/ GIMT_Encode4(392703),
     /* 392563 */ /*GILLT_v4s16*//*Label 7646*/ GIMT_Encode4(392734),
     /* 392567 */ /*GILLT_v4s32*//*Label 7647*/ GIMT_Encode4(392765), GIMT_Encode4(0),
     /* 392575 */ /*GILLT_v8s16*//*Label 7648*/ GIMT_Encode4(392796),
     /* 392579 */ // Label 7641: @392579
     /* 392579 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(392609), // Rule ID 540 //
     /* 392584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392598 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 392603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392607 */   GIR_RootConstrainSelectedInstOperands,
     /* 392608 */   // GIR_Coverage, 540,
     /* 392608 */   GIR_Done,
     /* 392609 */ // Label 7650: @392609
     /* 392609 */ GIM_Reject,
     /* 392610 */ // Label 7642: @392610
     /* 392610 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(392640), // Rule ID 542 //
     /* 392615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392629 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 392634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392638 */   GIR_RootConstrainSelectedInstOperands,
     /* 392639 */   // GIR_Coverage, 542,
     /* 392639 */   GIR_Done,
     /* 392640 */ // Label 7651: @392640
     /* 392640 */ GIM_Reject,
     /* 392641 */ // Label 7643: @392641
     /* 392641 */ GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(392671), // Rule ID 544 //
     /* 392646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392660 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 392665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392669 */   GIR_RootConstrainSelectedInstOperands,
     /* 392670 */   // GIR_Coverage, 544,
     /* 392670 */   GIR_Done,
     /* 392671 */ // Label 7652: @392671
     /* 392671 */ GIM_Reject,
     /* 392672 */ // Label 7644: @392672
     /* 392672 */ GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(392702), // Rule ID 893 //
     /* 392677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392691 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 392696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392700 */   GIR_RootConstrainSelectedInstOperands,
     /* 392701 */   // GIR_Coverage, 893,
     /* 392701 */   GIR_Done,
     /* 392702 */ // Label 7653: @392702
     /* 392702 */ GIM_Reject,
     /* 392703 */ // Label 7645: @392703
     /* 392703 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(392733), // Rule ID 897 //
     /* 392708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392722 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 392727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392731 */   GIR_RootConstrainSelectedInstOperands,
     /* 392732 */   // GIR_Coverage, 897,
     /* 392732 */   GIR_Done,
     /* 392733 */ // Label 7654: @392733
     /* 392733 */ GIM_Reject,
     /* 392734 */ // Label 7646: @392734
     /* 392734 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(392764), // Rule ID 889 //
     /* 392739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392753 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 392758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392762 */   GIR_RootConstrainSelectedInstOperands,
     /* 392763 */   // GIR_Coverage, 889,
     /* 392763 */   GIR_Done,
     /* 392764 */ // Label 7655: @392764
     /* 392764 */ GIM_Reject,
     /* 392765 */ // Label 7647: @392765
     /* 392765 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(392795), // Rule ID 895 //
     /* 392770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392784 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392793 */   GIR_RootConstrainSelectedInstOperands,
     /* 392794 */   // GIR_Coverage, 895,
     /* 392794 */   GIR_Done,
     /* 392795 */ // Label 7656: @392795
     /* 392795 */ GIM_Reject,
     /* 392796 */ // Label 7648: @392796
     /* 392796 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(393017),
     /* 392801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392812 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(392831), // Rule ID 891 //
     /* 392817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392820 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 392825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392829 */     GIR_RootConstrainSelectedInstOperands,
     /* 392830 */     // GIR_Coverage, 891,
     /* 392830 */     GIR_Done,
     /* 392831 */   // Label 7658: @392831
     /* 392831 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(393016), // Rule ID 7026 //
     /* 392836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392839 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392839 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392842 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392846 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392851 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392857 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392860 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392864 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392869 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392874 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392877 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392881 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392886 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 392892 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392897 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392902 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 392905 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 392909 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392914 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 392917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 392919 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 392922 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 392926 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392931 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 392934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 392936 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 392939 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 392943 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392948 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 392951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 392985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 392988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393014 */     GIR_RootConstrainSelectedInstOperands,
     /* 393015 */     // GIR_Coverage, 7026,
     /* 393015 */     GIR_EraseRootFromParent_Done,
     /* 393016 */   // Label 7659: @393016
     /* 393016 */   GIM_Reject,
     /* 393017 */ // Label 7657: @393017
     /* 393017 */ GIM_Reject,
     /* 393018 */ // Label 7649: @393018
     /* 393018 */ GIM_Reject,
     /* 393019 */ // Label 101: @393019
     /* 393019 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7668*/ GIMT_Encode4(393509),
     /* 393030 */ /*GILLT_s16*//*Label 7660*/ GIMT_Encode4(393070),
     /* 393034 */ /*GILLT_s32*//*Label 7661*/ GIMT_Encode4(393101),
     /* 393038 */ /*GILLT_s64*//*Label 7662*/ GIMT_Encode4(393132), GIMT_Encode4(0),
     /* 393046 */ /*GILLT_v2s32*//*Label 7663*/ GIMT_Encode4(393163),
     /* 393050 */ /*GILLT_v2s64*//*Label 7664*/ GIMT_Encode4(393194),
     /* 393054 */ /*GILLT_v4s16*//*Label 7665*/ GIMT_Encode4(393225),
     /* 393058 */ /*GILLT_v4s32*//*Label 7666*/ GIMT_Encode4(393256), GIMT_Encode4(0),
     /* 393066 */ /*GILLT_v8s16*//*Label 7667*/ GIMT_Encode4(393287),
     /* 393070 */ // Label 7660: @393070
     /* 393070 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(393100), // Rule ID 558 //
     /* 393075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393089 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 393094 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393098 */   GIR_RootConstrainSelectedInstOperands,
     /* 393099 */   // GIR_Coverage, 558,
     /* 393099 */   GIR_Done,
     /* 393100 */ // Label 7669: @393100
     /* 393100 */ GIM_Reject,
     /* 393101 */ // Label 7661: @393101
     /* 393101 */ GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(393131), // Rule ID 560 //
     /* 393106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393120 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 393125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393129 */   GIR_RootConstrainSelectedInstOperands,
     /* 393130 */   // GIR_Coverage, 560,
     /* 393130 */   GIR_Done,
     /* 393131 */ // Label 7670: @393131
     /* 393131 */ GIM_Reject,
     /* 393132 */ // Label 7662: @393132
     /* 393132 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(393162), // Rule ID 562 //
     /* 393137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393151 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 393156 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393160 */   GIR_RootConstrainSelectedInstOperands,
     /* 393161 */   // GIR_Coverage, 562,
     /* 393161 */   GIR_Done,
     /* 393162 */ // Label 7671: @393162
     /* 393162 */ GIM_Reject,
     /* 393163 */ // Label 7663: @393163
     /* 393163 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(393193), // Rule ID 923 //
     /* 393168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393182 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 393187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393191 */   GIR_RootConstrainSelectedInstOperands,
     /* 393192 */   // GIR_Coverage, 923,
     /* 393192 */   GIR_Done,
     /* 393193 */ // Label 7672: @393193
     /* 393193 */ GIM_Reject,
     /* 393194 */ // Label 7664: @393194
     /* 393194 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(393224), // Rule ID 927 //
     /* 393199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393213 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 393218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393222 */   GIR_RootConstrainSelectedInstOperands,
     /* 393223 */   // GIR_Coverage, 927,
     /* 393223 */   GIR_Done,
     /* 393224 */ // Label 7673: @393224
     /* 393224 */ GIM_Reject,
     /* 393225 */ // Label 7665: @393225
     /* 393225 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(393255), // Rule ID 919 //
     /* 393230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393244 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 393249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393253 */   GIR_RootConstrainSelectedInstOperands,
     /* 393254 */   // GIR_Coverage, 919,
     /* 393254 */   GIR_Done,
     /* 393255 */ // Label 7674: @393255
     /* 393255 */ GIM_Reject,
     /* 393256 */ // Label 7666: @393256
     /* 393256 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(393286), // Rule ID 925 //
     /* 393261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393275 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393280 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393284 */   GIR_RootConstrainSelectedInstOperands,
     /* 393285 */   // GIR_Coverage, 925,
     /* 393285 */   GIR_Done,
     /* 393286 */ // Label 7675: @393286
     /* 393286 */ GIM_Reject,
     /* 393287 */ // Label 7667: @393287
     /* 393287 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(393508),
     /* 393292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393303 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(393322), // Rule ID 921 //
     /* 393308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393311 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 393316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393320 */     GIR_RootConstrainSelectedInstOperands,
     /* 393321 */     // GIR_Coverage, 921,
     /* 393321 */     GIR_Done,
     /* 393322 */   // Label 7677: @393322
     /* 393322 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(393507), // Rule ID 7034 //
     /* 393327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393330 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393330 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393333 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393337 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393342 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393348 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393351 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393355 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393360 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393365 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393368 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393372 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393377 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393383 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393388 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393393 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393396 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393400 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393405 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 393417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393427 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393430 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393434 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393439 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393505 */     GIR_RootConstrainSelectedInstOperands,
     /* 393506 */     // GIR_Coverage, 7034,
     /* 393506 */     GIR_EraseRootFromParent_Done,
     /* 393507 */   // Label 7678: @393507
     /* 393507 */   GIM_Reject,
     /* 393508 */ // Label 7676: @393508
     /* 393508 */ GIM_Reject,
     /* 393509 */ // Label 7668: @393509
     /* 393509 */ GIM_Reject,
     /* 393510 */ // Label 102: @393510
     /* 393510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7687*/ GIMT_Encode4(394000),
     /* 393521 */ /*GILLT_s16*//*Label 7679*/ GIMT_Encode4(393561),
     /* 393525 */ /*GILLT_s32*//*Label 7680*/ GIMT_Encode4(393592),
     /* 393529 */ /*GILLT_s64*//*Label 7681*/ GIMT_Encode4(393623), GIMT_Encode4(0),
     /* 393537 */ /*GILLT_v2s32*//*Label 7682*/ GIMT_Encode4(393654),
     /* 393541 */ /*GILLT_v2s64*//*Label 7683*/ GIMT_Encode4(393685),
     /* 393545 */ /*GILLT_v4s16*//*Label 7684*/ GIMT_Encode4(393716),
     /* 393549 */ /*GILLT_v4s32*//*Label 7685*/ GIMT_Encode4(393747), GIMT_Encode4(0),
     /* 393557 */ /*GILLT_v8s16*//*Label 7686*/ GIMT_Encode4(393778),
     /* 393561 */ // Label 7679: @393561
     /* 393561 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(393591), // Rule ID 534 //
     /* 393566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393580 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 393585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393589 */   GIR_RootConstrainSelectedInstOperands,
     /* 393590 */   // GIR_Coverage, 534,
     /* 393590 */   GIR_Done,
     /* 393591 */ // Label 7688: @393591
     /* 393591 */ GIM_Reject,
     /* 393592 */ // Label 7680: @393592
     /* 393592 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(393622), // Rule ID 536 //
     /* 393597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393611 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 393616 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393620 */   GIR_RootConstrainSelectedInstOperands,
     /* 393621 */   // GIR_Coverage, 536,
     /* 393621 */   GIR_Done,
     /* 393622 */ // Label 7689: @393622
     /* 393622 */ GIM_Reject,
     /* 393623 */ // Label 7681: @393623
     /* 393623 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(393653), // Rule ID 538 //
     /* 393628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393642 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 393647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393651 */   GIR_RootConstrainSelectedInstOperands,
     /* 393652 */   // GIR_Coverage, 538,
     /* 393652 */   GIR_Done,
     /* 393653 */ // Label 7690: @393653
     /* 393653 */ GIM_Reject,
     /* 393654 */ // Label 7682: @393654
     /* 393654 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(393684), // Rule ID 883 //
     /* 393659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393673 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 393678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393682 */   GIR_RootConstrainSelectedInstOperands,
     /* 393683 */   // GIR_Coverage, 883,
     /* 393683 */   GIR_Done,
     /* 393684 */ // Label 7691: @393684
     /* 393684 */ GIM_Reject,
     /* 393685 */ // Label 7683: @393685
     /* 393685 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(393715), // Rule ID 887 //
     /* 393690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393704 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 393709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393713 */   GIR_RootConstrainSelectedInstOperands,
     /* 393714 */   // GIR_Coverage, 887,
     /* 393714 */   GIR_Done,
     /* 393715 */ // Label 7692: @393715
     /* 393715 */ GIM_Reject,
     /* 393716 */ // Label 7684: @393716
     /* 393716 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(393746), // Rule ID 879 //
     /* 393721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393735 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 393740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393744 */   GIR_RootConstrainSelectedInstOperands,
     /* 393745 */   // GIR_Coverage, 879,
     /* 393745 */   GIR_Done,
     /* 393746 */ // Label 7693: @393746
     /* 393746 */ GIM_Reject,
     /* 393747 */ // Label 7685: @393747
     /* 393747 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(393777), // Rule ID 885 //
     /* 393752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393766 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393775 */   GIR_RootConstrainSelectedInstOperands,
     /* 393776 */   // GIR_Coverage, 885,
     /* 393776 */   GIR_Done,
     /* 393777 */ // Label 7694: @393777
     /* 393777 */ GIM_Reject,
     /* 393778 */ // Label 7686: @393778
     /* 393778 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(393999),
     /* 393783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393794 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(393813), // Rule ID 881 //
     /* 393799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393802 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 393807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393811 */     GIR_RootConstrainSelectedInstOperands,
     /* 393812 */     // GIR_Coverage, 881,
     /* 393812 */     GIR_Done,
     /* 393813 */   // Label 7696: @393813
     /* 393813 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(393998), // Rule ID 7028 //
     /* 393818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393821 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393821 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393824 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393828 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393833 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393839 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393842 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393846 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393851 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393856 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393859 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393863 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393868 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393874 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393879 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393884 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393887 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393891 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393896 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393901 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393904 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 393908 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393913 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393930 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393935 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393938 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393942 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393964 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393996 */     GIR_RootConstrainSelectedInstOperands,
     /* 393997 */     // GIR_Coverage, 7028,
     /* 393997 */     GIR_EraseRootFromParent_Done,
     /* 393998 */   // Label 7697: @393998
     /* 393998 */   GIM_Reject,
     /* 393999 */ // Label 7695: @393999
     /* 393999 */ GIM_Reject,
     /* 394000 */ // Label 7687: @394000
     /* 394000 */ GIM_Reject,
     /* 394001 */ // Label 103: @394001
     /* 394001 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7706*/ GIMT_Encode4(395126),
     /* 394012 */ /*GILLT_s16*//*Label 7698*/ GIMT_Encode4(394052),
     /* 394016 */ /*GILLT_s32*//*Label 7699*/ GIMT_Encode4(394278),
     /* 394020 */ /*GILLT_s64*//*Label 7700*/ GIMT_Encode4(394504), GIMT_Encode4(0),
     /* 394028 */ /*GILLT_v2s32*//*Label 7701*/ GIMT_Encode4(394676),
     /* 394032 */ /*GILLT_v2s64*//*Label 7702*/ GIMT_Encode4(394714),
     /* 394036 */ /*GILLT_v4s16*//*Label 7703*/ GIMT_Encode4(394752),
     /* 394040 */ /*GILLT_v4s32*//*Label 7704*/ GIMT_Encode4(394790), GIMT_Encode4(0),
     /* 394048 */ /*GILLT_v8s16*//*Label 7705*/ GIMT_Encode4(394828),
     /* 394052 */ // Label 7698: @394052
     /* 394052 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(394277),
     /* 394057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 394063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394067 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(394158), // Rule ID 6948 //
     /* 394072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394109 */     // MIs[2] Rn
     /* 394109 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394120 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394132 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394156 */     GIR_RootConstrainSelectedInstOperands,
     /* 394157 */     // GIR_Coverage, 6948,
     /* 394157 */     GIR_EraseRootFromParent_Done,
     /* 394158 */   // Label 7708: @394158
     /* 394158 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(394249), // Rule ID 14017 //
     /* 394163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394200 */     // MIs[2] Rn
     /* 394200 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394205 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394211 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 394211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 394242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394247 */     GIR_RootConstrainSelectedInstOperands,
     /* 394248 */     // GIR_Coverage, 14017,
     /* 394248 */     GIR_EraseRootFromParent_Done,
     /* 394249 */   // Label 7709: @394249
     /* 394249 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(394276), // Rule ID 583 //
     /* 394254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394265 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 394265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 394270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394274 */     GIR_RootConstrainSelectedInstOperands,
     /* 394275 */     // GIR_Coverage, 583,
     /* 394275 */     GIR_Done,
     /* 394276 */   // Label 7710: @394276
     /* 394276 */   GIM_Reject,
     /* 394277 */ // Label 7707: @394277
     /* 394277 */ GIM_Reject,
     /* 394278 */ // Label 7699: @394278
     /* 394278 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(394503),
     /* 394283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 394289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394293 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(394384), // Rule ID 6946 //
     /* 394298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394335 */     // MIs[2] Rn
     /* 394335 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394340 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394346 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 394346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394358 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 394377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394382 */     GIR_RootConstrainSelectedInstOperands,
     /* 394383 */     // GIR_Coverage, 6946,
     /* 394383 */     GIR_EraseRootFromParent_Done,
     /* 394384 */   // Label 7712: @394384
     /* 394384 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(394475), // Rule ID 14015 //
     /* 394389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394426 */     // MIs[2] Rn
     /* 394426 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394431 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394437 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 394437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394449 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 394468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394473 */     GIR_RootConstrainSelectedInstOperands,
     /* 394474 */     // GIR_Coverage, 14015,
     /* 394474 */     GIR_EraseRootFromParent_Done,
     /* 394475 */   // Label 7713: @394475
     /* 394475 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(394502), // Rule ID 585 //
     /* 394480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394491 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 394491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 394496 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394500 */     GIR_RootConstrainSelectedInstOperands,
     /* 394501 */     // GIR_Coverage, 585,
     /* 394501 */     GIR_Done,
     /* 394502 */   // Label 7714: @394502
     /* 394502 */   GIM_Reject,
     /* 394503 */ // Label 7711: @394503
     /* 394503 */ GIM_Reject,
     /* 394504 */ // Label 7700: @394504
     /* 394504 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(394675),
     /* 394509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 394515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394519 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(394583), // Rule ID 6944 //
     /* 394524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394545 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 394549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394561 */     // MIs[2] Rn
     /* 394561 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 394570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394572 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 394572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 394575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394581 */     GIR_RootConstrainSelectedInstOperands,
     /* 394582 */     // GIR_Coverage, 6944,
     /* 394582 */     GIR_EraseRootFromParent_Done,
     /* 394583 */   // Label 7716: @394583
     /* 394583 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(394647), // Rule ID 14013 //
     /* 394588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394609 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 394613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394625 */     // MIs[2] Rn
     /* 394625 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394630 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 394634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394636 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 394636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 394639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394645 */     GIR_RootConstrainSelectedInstOperands,
     /* 394646 */     // GIR_Coverage, 14013,
     /* 394646 */     GIR_EraseRootFromParent_Done,
     /* 394647 */   // Label 7717: @394647
     /* 394647 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(394674), // Rule ID 587 //
     /* 394652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394663 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 394663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 394668 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394672 */     GIR_RootConstrainSelectedInstOperands,
     /* 394673 */     // GIR_Coverage, 587,
     /* 394673 */     GIR_Done,
     /* 394674 */   // Label 7718: @394674
     /* 394674 */   GIM_Reject,
     /* 394675 */ // Label 7715: @394675
     /* 394675 */ GIM_Reject,
     /* 394676 */ // Label 7701: @394676
     /* 394676 */ GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(394713), // Rule ID 1202 //
     /* 394681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394702 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 394707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394711 */   GIR_RootConstrainSelectedInstOperands,
     /* 394712 */   // GIR_Coverage, 1202,
     /* 394712 */   GIR_Done,
     /* 394713 */ // Label 7719: @394713
     /* 394713 */ GIM_Reject,
     /* 394714 */ // Label 7702: @394714
     /* 394714 */ GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(394751), // Rule ID 1206 //
     /* 394719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394740 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 394745 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394749 */   GIR_RootConstrainSelectedInstOperands,
     /* 394750 */   // GIR_Coverage, 1206,
     /* 394750 */   GIR_Done,
     /* 394751 */ // Label 7720: @394751
     /* 394751 */ GIM_Reject,
     /* 394752 */ // Label 7703: @394752
     /* 394752 */ GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(394789), // Rule ID 1198 //
     /* 394757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394778 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 394783 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394787 */   GIR_RootConstrainSelectedInstOperands,
     /* 394788 */   // GIR_Coverage, 1198,
     /* 394788 */   GIR_Done,
     /* 394789 */ // Label 7721: @394789
     /* 394789 */ GIM_Reject,
     /* 394790 */ // Label 7704: @394790
     /* 394790 */ GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(394827), // Rule ID 1204 //
     /* 394795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394816 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 394821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394825 */   GIR_RootConstrainSelectedInstOperands,
     /* 394826 */   // GIR_Coverage, 1204,
     /* 394826 */   GIR_Done,
     /* 394827 */ // Label 7722: @394827
     /* 394827 */ GIM_Reject,
     /* 394828 */ // Label 7705: @394828
     /* 394828 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(395125),
     /* 394833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394851 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(394870), // Rule ID 1200 //
     /* 394856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394859 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 394864 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394868 */     GIR_RootConstrainSelectedInstOperands,
     /* 394869 */     // GIR_Coverage, 1200,
     /* 394869 */     GIR_Done,
     /* 394870 */   // Label 7724: @394870
     /* 394870 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(395124), // Rule ID 7037 //
     /* 394875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394878 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 394878 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 394881 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394885 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394890 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 394894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 394896 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 394899 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394903 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394908 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 394914 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 394917 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 394921 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394926 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 394929 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 394932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 394934 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 394937 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394941 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394946 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 394952 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394957 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394962 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394965 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394969 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394974 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394979 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394982 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394986 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394991 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394997 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395002 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395007 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395010 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395014 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395019 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395036 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395039 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395044 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395047 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395051 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395056 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 395122 */     GIR_RootConstrainSelectedInstOperands,
     /* 395123 */     // GIR_Coverage, 7037,
     /* 395123 */     GIR_EraseRootFromParent_Done,
     /* 395124 */   // Label 7725: @395124
     /* 395124 */   GIM_Reject,
     /* 395125 */ // Label 7723: @395125
     /* 395125 */ GIM_Reject,
     /* 395126 */ // Label 7706: @395126
     /* 395126 */ GIM_Reject,
     /* 395127 */ // Label 104: @395127
     /* 395127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7734*/ GIMT_Encode4(395742),
     /* 395138 */ /*GILLT_s16*//*Label 7726*/ GIMT_Encode4(395178),
     /* 395142 */ /*GILLT_s32*//*Label 7727*/ GIMT_Encode4(395216),
     /* 395146 */ /*GILLT_s64*//*Label 7728*/ GIMT_Encode4(395254), GIMT_Encode4(0),
     /* 395154 */ /*GILLT_v2s32*//*Label 7729*/ GIMT_Encode4(395292),
     /* 395158 */ /*GILLT_v2s64*//*Label 7730*/ GIMT_Encode4(395330),
     /* 395162 */ /*GILLT_v4s16*//*Label 7731*/ GIMT_Encode4(395368),
     /* 395166 */ /*GILLT_v4s32*//*Label 7732*/ GIMT_Encode4(395406), GIMT_Encode4(0),
     /* 395174 */ /*GILLT_v8s16*//*Label 7733*/ GIMT_Encode4(395444),
     /* 395178 */ // Label 7726: @395178
     /* 395178 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(395215), // Rule ID 631 //
     /* 395183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395204 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 395209 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395213 */   GIR_RootConstrainSelectedInstOperands,
     /* 395214 */   // GIR_Coverage, 631,
     /* 395214 */   GIR_Done,
     /* 395215 */ // Label 7735: @395215
     /* 395215 */ GIM_Reject,
     /* 395216 */ // Label 7727: @395216
     /* 395216 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(395253), // Rule ID 633 //
     /* 395221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395242 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 395247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395251 */   GIR_RootConstrainSelectedInstOperands,
     /* 395252 */   // GIR_Coverage, 633,
     /* 395252 */   GIR_Done,
     /* 395253 */ // Label 7736: @395253
     /* 395253 */ GIM_Reject,
     /* 395254 */ // Label 7728: @395254
     /* 395254 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(395291), // Rule ID 635 //
     /* 395259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395280 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 395285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395289 */   GIR_RootConstrainSelectedInstOperands,
     /* 395290 */   // GIR_Coverage, 635,
     /* 395290 */   GIR_Done,
     /* 395291 */ // Label 7737: @395291
     /* 395291 */ GIM_Reject,
     /* 395292 */ // Label 7729: @395292
     /* 395292 */ GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(395329), // Rule ID 1342 //
     /* 395297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395318 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 395323 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395327 */   GIR_RootConstrainSelectedInstOperands,
     /* 395328 */   // GIR_Coverage, 1342,
     /* 395328 */   GIR_Done,
     /* 395329 */ // Label 7738: @395329
     /* 395329 */ GIM_Reject,
     /* 395330 */ // Label 7730: @395330
     /* 395330 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(395367), // Rule ID 1346 //
     /* 395335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395356 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 395361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395365 */   GIR_RootConstrainSelectedInstOperands,
     /* 395366 */   // GIR_Coverage, 1346,
     /* 395366 */   GIR_Done,
     /* 395367 */ // Label 7739: @395367
     /* 395367 */ GIM_Reject,
     /* 395368 */ // Label 7731: @395368
     /* 395368 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(395405), // Rule ID 1338 //
     /* 395373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395394 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 395399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395403 */   GIR_RootConstrainSelectedInstOperands,
     /* 395404 */   // GIR_Coverage, 1338,
     /* 395404 */   GIR_Done,
     /* 395405 */ // Label 7740: @395405
     /* 395405 */ GIM_Reject,
     /* 395406 */ // Label 7732: @395406
     /* 395406 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(395443), // Rule ID 1344 //
     /* 395411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395432 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395441 */   GIR_RootConstrainSelectedInstOperands,
     /* 395442 */   // GIR_Coverage, 1344,
     /* 395442 */   GIR_Done,
     /* 395443 */ // Label 7741: @395443
     /* 395443 */ GIM_Reject,
     /* 395444 */ // Label 7733: @395444
     /* 395444 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(395741),
     /* 395449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395467 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(395486), // Rule ID 1340 //
     /* 395472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395475 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 395480 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395484 */     GIR_RootConstrainSelectedInstOperands,
     /* 395485 */     // GIR_Coverage, 1340,
     /* 395485 */     GIR_Done,
     /* 395486 */   // Label 7743: @395486
     /* 395486 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(395740), // Rule ID 7043 //
     /* 395491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395494 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 395494 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 395497 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395501 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395506 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 395510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 395512 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 395515 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395519 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395524 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 395530 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 395533 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395537 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395542 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 395545 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 395548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 395550 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 395553 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395557 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395562 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 395568 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395573 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395578 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395581 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395585 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395590 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395595 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395598 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395602 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395607 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395613 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395618 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395623 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395626 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395630 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395635 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 395647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395652 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395655 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395660 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395663 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395667 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395672 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395709 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 395738 */     GIR_RootConstrainSelectedInstOperands,
     /* 395739 */     // GIR_Coverage, 7043,
     /* 395739 */     GIR_EraseRootFromParent_Done,
     /* 395740 */   // Label 7744: @395740
     /* 395740 */   GIM_Reject,
     /* 395741 */ // Label 7742: @395741
     /* 395741 */ GIM_Reject,
     /* 395742 */ // Label 7734: @395742
     /* 395742 */ GIM_Reject,
     /* 395743 */ // Label 105: @395743
     /* 395743 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7753*/ GIMT_Encode4(399464),
     /* 395754 */ /*GILLT_s16*//*Label 7745*/ GIMT_Encode4(395794),
     /* 395758 */ /*GILLT_s32*//*Label 7746*/ GIMT_Encode4(396348),
     /* 395762 */ /*GILLT_s64*//*Label 7747*/ GIMT_Encode4(396896), GIMT_Encode4(0),
     /* 395770 */ /*GILLT_v2s32*//*Label 7748*/ GIMT_Encode4(397444),
     /* 395774 */ /*GILLT_v2s64*//*Label 7749*/ GIMT_Encode4(397974),
     /* 395778 */ /*GILLT_v4s16*//*Label 7750*/ GIMT_Encode4(398332),
     /* 395782 */ /*GILLT_v4s32*//*Label 7751*/ GIMT_Encode4(398674), GIMT_Encode4(0),
     /* 395790 */ /*GILLT_v8s16*//*Label 7752*/ GIMT_Encode4(399032),
     /* 395794 */ // Label 7745: @395794
     /* 395794 */ GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(396347),
     /* 395799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395809 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(395922), // Rule ID 6276 //
     /* 395814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395838 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 395867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395871 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395875 */     // MIs[3] Operand 1
     /* 395875 */     // No operand predicates
     /* 395875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395877 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 395880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 395895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 395908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 395917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 395920 */     GIR_RootConstrainSelectedInstOperands,
     /* 395921 */     // GIR_Coverage, 6276,
     /* 395921 */     GIR_EraseRootFromParent_Done,
     /* 395922 */   // Label 7755: @395922
     /* 395922 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(396035), // Rule ID 13994 //
     /* 395927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 395963 */     // MIs[2] Operand 1
     /* 395963 */     // No operand predicates
     /* 395963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 395979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395984 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 395988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395990 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 395990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 395993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 396008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396033 */     GIR_RootConstrainSelectedInstOperands,
     /* 396034 */     // GIR_Coverage, 13994,
     /* 396034 */     GIR_EraseRootFromParent_Done,
     /* 396035 */   // Label 7756: @396035
     /* 396035 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(396114), // Rule ID 13928 //
     /* 396040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396074 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396112 */     GIR_RootConstrainSelectedInstOperands,
     /* 396113 */     // GIR_Coverage, 13928,
     /* 396113 */     GIR_EraseRootFromParent_Done,
     /* 396114 */   // Label 7757: @396114
     /* 396114 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(396193), // Rule ID 4835 //
     /* 396119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396153 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396191 */     GIR_RootConstrainSelectedInstOperands,
     /* 396192 */     // GIR_Coverage, 4835,
     /* 396192 */     GIR_EraseRootFromParent_Done,
     /* 396193 */   // Label 7758: @396193
     /* 396193 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(396256), // Rule ID 13537 //
     /* 396198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396234 */     // MIs[2] Operand 1
     /* 396234 */     // No operand predicates
     /* 396234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396240 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396254 */     GIR_RootConstrainSelectedInstOperands,
     /* 396255 */     // GIR_Coverage, 13537,
     /* 396255 */     GIR_EraseRootFromParent_Done,
     /* 396256 */   // Label 7759: @396256
     /* 396256 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(396319), // Rule ID 2011 //
     /* 396261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 396289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396301 */     // MIs[2] Operand 1
     /* 396301 */     // No operand predicates
     /* 396301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396303 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396317 */     GIR_RootConstrainSelectedInstOperands,
     /* 396318 */     // GIR_Coverage, 2011,
     /* 396318 */     GIR_EraseRootFromParent_Done,
     /* 396319 */   // Label 7760: @396319
     /* 396319 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(396346), // Rule ID 619 //
     /* 396324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396335 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 396340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396344 */     GIR_RootConstrainSelectedInstOperands,
     /* 396345 */     // GIR_Coverage, 619,
     /* 396345 */     GIR_Done,
     /* 396346 */   // Label 7761: @396346
     /* 396346 */   GIM_Reject,
     /* 396347 */ // Label 7754: @396347
     /* 396347 */ GIM_Reject,
     /* 396348 */ // Label 7746: @396348
     /* 396348 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(396895),
     /* 396353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396363 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(396476), // Rule ID 6278 //
     /* 396368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396392 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396429 */     // MIs[3] Operand 1
     /* 396429 */     // No operand predicates
     /* 396429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396431 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 396431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 396449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396474 */     GIR_RootConstrainSelectedInstOperands,
     /* 396475 */     // GIR_Coverage, 6278,
     /* 396475 */     GIR_EraseRootFromParent_Done,
     /* 396476 */   // Label 7763: @396476
     /* 396476 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(396589), // Rule ID 13996 //
     /* 396481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396517 */     // MIs[2] Operand 1
     /* 396517 */     // No operand predicates
     /* 396517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396525 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396529 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 396533 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396538 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 396542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396544 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 396544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 396562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396587 */     GIR_RootConstrainSelectedInstOperands,
     /* 396588 */     // GIR_Coverage, 13996,
     /* 396588 */     GIR_EraseRootFromParent_Done,
     /* 396589 */   // Label 7764: @396589
     /* 396589 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(396665), // Rule ID 13930 //
     /* 396594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396615 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396625 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 396625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396637 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 396643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396663 */     GIR_RootConstrainSelectedInstOperands,
     /* 396664 */     // GIR_Coverage, 13930,
     /* 396664 */     GIR_EraseRootFromParent_Done,
     /* 396665 */   // Label 7765: @396665
     /* 396665 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(396741), // Rule ID 4837 //
     /* 396670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396701 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 396701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 396719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396739 */     GIR_RootConstrainSelectedInstOperands,
     /* 396740 */     // GIR_Coverage, 4837,
     /* 396740 */     GIR_EraseRootFromParent_Done,
     /* 396741 */   // Label 7766: @396741
     /* 396741 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(396804), // Rule ID 13539 //
     /* 396746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396778 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396782 */     // MIs[2] Operand 1
     /* 396782 */     // No operand predicates
     /* 396782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396788 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396802 */     GIR_RootConstrainSelectedInstOperands,
     /* 396803 */     // GIR_Coverage, 13539,
     /* 396803 */     GIR_EraseRootFromParent_Done,
     /* 396804 */   // Label 7767: @396804
     /* 396804 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(396867), // Rule ID 2013 //
     /* 396809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 396820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396845 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396849 */     // MIs[2] Operand 1
     /* 396849 */     // No operand predicates
     /* 396849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396851 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 396854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 396858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396865 */     GIR_RootConstrainSelectedInstOperands,
     /* 396866 */     // GIR_Coverage, 2013,
     /* 396866 */     GIR_EraseRootFromParent_Done,
     /* 396867 */   // Label 7768: @396867
     /* 396867 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(396894), // Rule ID 621 //
     /* 396872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396883 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 396888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396892 */     GIR_RootConstrainSelectedInstOperands,
     /* 396893 */     // GIR_Coverage, 621,
     /* 396893 */     GIR_Done,
     /* 396894 */   // Label 7769: @396894
     /* 396894 */   GIM_Reject,
     /* 396895 */ // Label 7762: @396895
     /* 396895 */ GIM_Reject,
     /* 396896 */ // Label 7747: @396896
     /* 396896 */ GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(397443),
     /* 396901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396911 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(397024), // Rule ID 6280 //
     /* 396916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396940 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 396977 */     // MIs[3] Operand 1
     /* 396977 */     // No operand predicates
     /* 396977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396979 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 396979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397022 */     GIR_RootConstrainSelectedInstOperands,
     /* 397023 */     // GIR_Coverage, 6280,
     /* 397023 */     GIR_EraseRootFromParent_Done,
     /* 397024 */   // Label 7771: @397024
     /* 397024 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(397137), // Rule ID 13998 //
     /* 397029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397061 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397065 */     // MIs[2] Operand 1
     /* 397065 */     // No operand predicates
     /* 397065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397073 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397077 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397081 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397086 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397092 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397104 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397135 */     GIR_RootConstrainSelectedInstOperands,
     /* 397136 */     // GIR_Coverage, 13998,
     /* 397136 */     GIR_EraseRootFromParent_Done,
     /* 397137 */   // Label 7772: @397137
     /* 397137 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(397213), // Rule ID 13932 //
     /* 397142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397163 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397173 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397211 */     GIR_RootConstrainSelectedInstOperands,
     /* 397212 */     // GIR_Coverage, 13932,
     /* 397212 */     GIR_EraseRootFromParent_Done,
     /* 397213 */   // Label 7773: @397213
     /* 397213 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(397289), // Rule ID 4839 //
     /* 397218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397249 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 397249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397287 */     GIR_RootConstrainSelectedInstOperands,
     /* 397288 */     // GIR_Coverage, 4839,
     /* 397288 */     GIR_EraseRootFromParent_Done,
     /* 397289 */   // Label 7774: @397289
     /* 397289 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(397352), // Rule ID 13541 //
     /* 397294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397330 */     // MIs[2] Operand 1
     /* 397330 */     // No operand predicates
     /* 397330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397336 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397350 */     GIR_RootConstrainSelectedInstOperands,
     /* 397351 */     // GIR_Coverage, 13541,
     /* 397351 */     GIR_EraseRootFromParent_Done,
     /* 397352 */   // Label 7775: @397352
     /* 397352 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(397415), // Rule ID 2015 //
     /* 397357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397397 */     // MIs[2] Operand 1
     /* 397397 */     // No operand predicates
     /* 397397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397399 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397413 */     GIR_RootConstrainSelectedInstOperands,
     /* 397414 */     // GIR_Coverage, 2015,
     /* 397414 */     GIR_EraseRootFromParent_Done,
     /* 397415 */   // Label 7776: @397415
     /* 397415 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(397442), // Rule ID 623 //
     /* 397420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397431 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 397431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 397436 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397440 */     GIR_RootConstrainSelectedInstOperands,
     /* 397441 */     // GIR_Coverage, 623,
     /* 397441 */     GIR_Done,
     /* 397442 */   // Label 7777: @397442
     /* 397442 */   GIM_Reject,
     /* 397443 */ // Label 7770: @397443
     /* 397443 */ GIM_Reject,
     /* 397444 */ // Label 7748: @397444
     /* 397444 */ GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397973),
     /* 397449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397459 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397545), // Rule ID 13529 //
     /* 397464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397508 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397512 */     // MIs[3] Operand 1
     /* 397512 */     // No operand predicates
     /* 397512 */     // MIs[1] Operand 2
     /* 397512 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397529 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397543 */     GIR_RootConstrainSelectedInstOperands,
     /* 397544 */     // GIR_Coverage, 13529,
     /* 397544 */     GIR_EraseRootFromParent_Done,
     /* 397545 */   // Label 7779: @397545
     /* 397545 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397631), // Rule ID 2003 //
     /* 397550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397598 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397602 */     // MIs[3] Operand 1
     /* 397602 */     // No operand predicates
     /* 397602 */     // MIs[1] Operand 2
     /* 397602 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397615 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397629 */     GIR_RootConstrainSelectedInstOperands,
     /* 397630 */     // GIR_Coverage, 2003,
     /* 397630 */     GIR_EraseRootFromParent_Done,
     /* 397631 */   // Label 7780: @397631
     /* 397631 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397694), // Rule ID 13530 //
     /* 397636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397672 */     // MIs[2] Operand 1
     /* 397672 */     // No operand predicates
     /* 397672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397678 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397692 */     GIR_RootConstrainSelectedInstOperands,
     /* 397693 */     // GIR_Coverage, 13530,
     /* 397693 */     GIR_EraseRootFromParent_Done,
     /* 397694 */   // Label 7781: @397694
     /* 397694 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397757), // Rule ID 2004 //
     /* 397699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397739 */     // MIs[2] Operand 1
     /* 397739 */     // No operand predicates
     /* 397739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397741 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397755 */     GIR_RootConstrainSelectedInstOperands,
     /* 397756 */     // GIR_Coverage, 2004,
     /* 397756 */     GIR_EraseRootFromParent_Done,
     /* 397757 */   // Label 7782: @397757
     /* 397757 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397851), // Rule ID 14000 //
     /* 397762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 397770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 397774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397785 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397785 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397788 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397792 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397849 */     GIR_RootConstrainSelectedInstOperands,
     /* 397850 */     // GIR_Coverage, 14000,
     /* 397850 */     GIR_EraseRootFromParent_Done,
     /* 397851 */   // Label 7783: @397851
     /* 397851 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(397945), // Rule ID 6282 //
     /* 397856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 397868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 397872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397879 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 397933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397943 */     GIR_RootConstrainSelectedInstOperands,
     /* 397944 */     // GIR_Coverage, 6282,
     /* 397944 */     GIR_EraseRootFromParent_Done,
     /* 397945 */   // Label 7784: @397945
     /* 397945 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(397972), // Rule ID 1322 //
     /* 397950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397961 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 397966 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397970 */     GIR_RootConstrainSelectedInstOperands,
     /* 397971 */     // GIR_Coverage, 1322,
     /* 397971 */     GIR_Done,
     /* 397972 */   // Label 7785: @397972
     /* 397972 */   GIM_Reject,
     /* 397973 */ // Label 7778: @397973
     /* 397973 */ GIM_Reject,
     /* 397974 */ // Label 7749: @397974
     /* 397974 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(398331),
     /* 397979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397989 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(398052), // Rule ID 13535 //
     /* 397994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398030 */     // MIs[2] Operand 1
     /* 398030 */     // No operand predicates
     /* 398030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398036 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398050 */     GIR_RootConstrainSelectedInstOperands,
     /* 398051 */     // GIR_Coverage, 13535,
     /* 398051 */     GIR_EraseRootFromParent_Done,
     /* 398052 */   // Label 7787: @398052
     /* 398052 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(398115), // Rule ID 2009 //
     /* 398057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398097 */     // MIs[2] Operand 1
     /* 398097 */     // No operand predicates
     /* 398097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398099 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398113 */     GIR_RootConstrainSelectedInstOperands,
     /* 398114 */     // GIR_Coverage, 2009,
     /* 398114 */     GIR_EraseRootFromParent_Done,
     /* 398115 */   // Label 7788: @398115
     /* 398115 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398209), // Rule ID 14004 //
     /* 398120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398143 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398169 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398176 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398207 */     GIR_RootConstrainSelectedInstOperands,
     /* 398208 */     // GIR_Coverage, 14004,
     /* 398208 */     GIR_EraseRootFromParent_Done,
     /* 398209 */   // Label 7789: @398209
     /* 398209 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398303), // Rule ID 6286 //
     /* 398214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 398230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398237 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398301 */     GIR_RootConstrainSelectedInstOperands,
     /* 398302 */     // GIR_Coverage, 6286,
     /* 398302 */     GIR_EraseRootFromParent_Done,
     /* 398303 */   // Label 7790: @398303
     /* 398303 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398330), // Rule ID 1326 //
     /* 398308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398319 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 398324 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398328 */     GIR_RootConstrainSelectedInstOperands,
     /* 398329 */     // GIR_Coverage, 1326,
     /* 398329 */     GIR_Done,
     /* 398330 */   // Label 7791: @398330
     /* 398330 */   GIM_Reject,
     /* 398331 */ // Label 7786: @398331
     /* 398331 */ GIM_Reject,
     /* 398332 */ // Label 7750: @398332
     /* 398332 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398673),
     /* 398337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398347 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398433), // Rule ID 13523 //
     /* 398352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398400 */     // MIs[3] Operand 1
     /* 398400 */     // No operand predicates
     /* 398400 */     // MIs[1] Operand 2
     /* 398400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398417 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398431 */     GIR_RootConstrainSelectedInstOperands,
     /* 398432 */     // GIR_Coverage, 13523,
     /* 398432 */     GIR_EraseRootFromParent_Done,
     /* 398433 */   // Label 7793: @398433
     /* 398433 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398519), // Rule ID 1997 //
     /* 398438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398486 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398490 */     // MIs[3] Operand 1
     /* 398490 */     // No operand predicates
     /* 398490 */     // MIs[1] Operand 2
     /* 398490 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398503 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398517 */     GIR_RootConstrainSelectedInstOperands,
     /* 398518 */     // GIR_Coverage, 1997,
     /* 398518 */     GIR_EraseRootFromParent_Done,
     /* 398519 */   // Label 7794: @398519
     /* 398519 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398582), // Rule ID 13524 //
     /* 398524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398560 */     // MIs[2] Operand 1
     /* 398560 */     // No operand predicates
     /* 398560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398566 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398580 */     GIR_RootConstrainSelectedInstOperands,
     /* 398581 */     // GIR_Coverage, 13524,
     /* 398581 */     GIR_EraseRootFromParent_Done,
     /* 398582 */   // Label 7795: @398582
     /* 398582 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398645), // Rule ID 1998 //
     /* 398587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398623 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398627 */     // MIs[2] Operand 1
     /* 398627 */     // No operand predicates
     /* 398627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398629 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 398632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398643 */     GIR_RootConstrainSelectedInstOperands,
     /* 398644 */     // GIR_Coverage, 1998,
     /* 398644 */     GIR_EraseRootFromParent_Done,
     /* 398645 */   // Label 7796: @398645
     /* 398645 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398672), // Rule ID 1318 //
     /* 398650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398661 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 398666 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398670 */     GIR_RootConstrainSelectedInstOperands,
     /* 398671 */     // GIR_Coverage, 1318,
     /* 398671 */     GIR_Done,
     /* 398672 */   // Label 7797: @398672
     /* 398672 */   GIM_Reject,
     /* 398673 */ // Label 7792: @398673
     /* 398673 */ GIM_Reject,
     /* 398674 */ // Label 7751: @398674
     /* 398674 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(399031),
     /* 398679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398689 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(398752), // Rule ID 13533 //
     /* 398694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398730 */     // MIs[2] Operand 1
     /* 398730 */     // No operand predicates
     /* 398730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398736 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398750 */     GIR_RootConstrainSelectedInstOperands,
     /* 398751 */     // GIR_Coverage, 13533,
     /* 398751 */     GIR_EraseRootFromParent_Done,
     /* 398752 */   // Label 7799: @398752
     /* 398752 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(398815), // Rule ID 2007 //
     /* 398757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398797 */     // MIs[2] Operand 1
     /* 398797 */     // No operand predicates
     /* 398797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398799 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398813 */     GIR_RootConstrainSelectedInstOperands,
     /* 398814 */     // GIR_Coverage, 2007,
     /* 398814 */     GIR_EraseRootFromParent_Done,
     /* 398815 */   // Label 7800: @398815
     /* 398815 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(398909), // Rule ID 14002 //
     /* 398820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398843 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398869 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398907 */     GIR_RootConstrainSelectedInstOperands,
     /* 398908 */     // GIR_Coverage, 14002,
     /* 398908 */     GIR_EraseRootFromParent_Done,
     /* 398909 */   // Label 7801: @398909
     /* 398909 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(399003), // Rule ID 6284 //
     /* 398914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398937 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 398991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399001 */     GIR_RootConstrainSelectedInstOperands,
     /* 399002 */     // GIR_Coverage, 6284,
     /* 399002 */     GIR_EraseRootFromParent_Done,
     /* 399003 */   // Label 7802: @399003
     /* 399003 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(399030), // Rule ID 1324 //
     /* 399008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399019 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399024 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399028 */     GIR_RootConstrainSelectedInstOperands,
     /* 399029 */     // GIR_Coverage, 1324,
     /* 399029 */     GIR_Done,
     /* 399030 */   // Label 7803: @399030
     /* 399030 */   GIM_Reject,
     /* 399031 */ // Label 7798: @399031
     /* 399031 */ GIM_Reject,
     /* 399032 */ // Label 7752: @399032
     /* 399032 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(399463),
     /* 399037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399047 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(399110), // Rule ID 13527 //
     /* 399052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399088 */     // MIs[2] Operand 1
     /* 399088 */     // No operand predicates
     /* 399088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399094 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399108 */     GIR_RootConstrainSelectedInstOperands,
     /* 399109 */     // GIR_Coverage, 13527,
     /* 399109 */     GIR_EraseRootFromParent_Done,
     /* 399110 */   // Label 7805: @399110
     /* 399110 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(399173), // Rule ID 2001 //
     /* 399115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399155 */     // MIs[2] Operand 1
     /* 399155 */     // No operand predicates
     /* 399155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399157 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 399160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399171 */     GIR_RootConstrainSelectedInstOperands,
     /* 399172 */     // GIR_Coverage, 2001,
     /* 399172 */     GIR_EraseRootFromParent_Done,
     /* 399173 */   // Label 7806: @399173
     /* 399173 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(399200), // Rule ID 1320 //
     /* 399178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399189 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 399194 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399198 */     GIR_RootConstrainSelectedInstOperands,
     /* 399199 */     // GIR_Coverage, 1320,
     /* 399199 */     GIR_Done,
     /* 399200 */   // Label 7807: @399200
     /* 399200 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399462), // Rule ID 7041 //
     /* 399205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 399208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399216 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 399216 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 399219 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399223 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399228 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 399232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 399234 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 399237 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399241 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399246 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 399252 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 399255 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399259 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399264 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 399267 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 399270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 399272 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 399275 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399279 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399284 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399290 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399295 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399300 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 399303 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399307 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399312 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 399315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 399317 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 399320 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399324 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399329 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399335 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399340 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399345 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 399348 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399352 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399357 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 399360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 399362 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 399365 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399369 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399374 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 399377 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 399380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 399382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 399385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 399389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399394 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 399397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 399399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 399402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 399431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 399452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 399460 */     GIR_RootConstrainSelectedInstOperands,
     /* 399461 */     // GIR_Coverage, 7041,
     /* 399461 */     GIR_EraseRootFromParent_Done,
     /* 399462 */   // Label 7808: @399462
     /* 399462 */   GIM_Reject,
     /* 399463 */ // Label 7804: @399463
     /* 399463 */ GIM_Reject,
     /* 399464 */ // Label 7753: @399464
     /* 399464 */ GIM_Reject,
     /* 399465 */ // Label 106: @399465
     /* 399465 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7817*/ GIMT_Encode4(400080),
     /* 399476 */ /*GILLT_s16*//*Label 7809*/ GIMT_Encode4(399516),
     /* 399480 */ /*GILLT_s32*//*Label 7810*/ GIMT_Encode4(399554),
     /* 399484 */ /*GILLT_s64*//*Label 7811*/ GIMT_Encode4(399592), GIMT_Encode4(0),
     /* 399492 */ /*GILLT_v2s32*//*Label 7812*/ GIMT_Encode4(399630),
     /* 399496 */ /*GILLT_v2s64*//*Label 7813*/ GIMT_Encode4(399668),
     /* 399500 */ /*GILLT_v4s16*//*Label 7814*/ GIMT_Encode4(399706),
     /* 399504 */ /*GILLT_v4s32*//*Label 7815*/ GIMT_Encode4(399744), GIMT_Encode4(0),
     /* 399512 */ /*GILLT_v8s16*//*Label 7816*/ GIMT_Encode4(399782),
     /* 399516 */ // Label 7809: @399516
     /* 399516 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(399553), // Rule ID 589 //
     /* 399521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 399530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399542 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 399542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 399547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399551 */   GIR_RootConstrainSelectedInstOperands,
     /* 399552 */   // GIR_Coverage, 589,
     /* 399552 */   GIR_Done,
     /* 399553 */ // Label 7818: @399553
     /* 399553 */ GIM_Reject,
     /* 399554 */ // Label 7810: @399554
     /* 399554 */ GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(399591), // Rule ID 591 //
     /* 399559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399580 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 399585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399589 */   GIR_RootConstrainSelectedInstOperands,
     /* 399590 */   // GIR_Coverage, 591,
     /* 399590 */   GIR_Done,
     /* 399591 */ // Label 7819: @399591
     /* 399591 */ GIM_Reject,
     /* 399592 */ // Label 7811: @399592
     /* 399592 */ GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(399629), // Rule ID 593 //
     /* 399597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399618 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 399623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399627 */   GIR_RootConstrainSelectedInstOperands,
     /* 399628 */   // GIR_Coverage, 593,
     /* 399628 */   GIR_Done,
     /* 399629 */ // Label 7820: @399629
     /* 399629 */ GIM_Reject,
     /* 399630 */ // Label 7812: @399630
     /* 399630 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(399667), // Rule ID 1227 //
     /* 399635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399656 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 399661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399665 */   GIR_RootConstrainSelectedInstOperands,
     /* 399666 */   // GIR_Coverage, 1227,
     /* 399666 */   GIR_Done,
     /* 399667 */ // Label 7821: @399667
     /* 399667 */ GIM_Reject,
     /* 399668 */ // Label 7813: @399668
     /* 399668 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(399705), // Rule ID 1231 //
     /* 399673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399694 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 399699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399703 */   GIR_RootConstrainSelectedInstOperands,
     /* 399704 */   // GIR_Coverage, 1231,
     /* 399704 */   GIR_Done,
     /* 399705 */ // Label 7822: @399705
     /* 399705 */ GIM_Reject,
     /* 399706 */ // Label 7814: @399706
     /* 399706 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(399743), // Rule ID 1223 //
     /* 399711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399732 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 399737 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399741 */   GIR_RootConstrainSelectedInstOperands,
     /* 399742 */   // GIR_Coverage, 1223,
     /* 399742 */   GIR_Done,
     /* 399743 */ // Label 7823: @399743
     /* 399743 */ GIM_Reject,
     /* 399744 */ // Label 7815: @399744
     /* 399744 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(399781), // Rule ID 1229 //
     /* 399749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399770 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399775 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399779 */   GIR_RootConstrainSelectedInstOperands,
     /* 399780 */   // GIR_Coverage, 1229,
     /* 399780 */   GIR_Done,
     /* 399781 */ // Label 7824: @399781
     /* 399781 */ GIM_Reject,
     /* 399782 */ // Label 7816: @399782
     /* 399782 */ GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(400079),
     /* 399787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399805 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(399824), // Rule ID 1225 //
     /* 399810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399813 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 399818 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399822 */     GIR_RootConstrainSelectedInstOperands,
     /* 399823 */     // GIR_Coverage, 1225,
     /* 399823 */     GIR_Done,
     /* 399824 */   // Label 7826: @399824
     /* 399824 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400078), // Rule ID 7039 //
     /* 399829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 399832 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 399832 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 399835 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399839 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399844 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 399848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 399850 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 399853 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 399857 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399862 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 399868 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 399871 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399875 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399880 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 399883 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 399886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 399888 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 399891 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399895 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399900 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399906 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399911 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399916 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 399919 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399923 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399928 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 399931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 399933 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 399936 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399940 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399945 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399951 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399956 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399961 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 399964 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 399968 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399973 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 399976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 399978 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 399981 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 399985 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399990 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 399993 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 399996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 399998 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400001 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400005 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400010 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400047 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400076 */     GIR_RootConstrainSelectedInstOperands,
     /* 400077 */     // GIR_Coverage, 7039,
     /* 400077 */     GIR_EraseRootFromParent_Done,
     /* 400078 */   // Label 7827: @400078
     /* 400078 */   GIM_Reject,
     /* 400079 */ // Label 7825: @400079
     /* 400079 */ GIM_Reject,
     /* 400080 */ // Label 7817: @400080
     /* 400080 */ GIM_Reject,
     /* 400081 */ // Label 107: @400081
     /* 400081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7836*/ GIMT_Encode4(415687),
     /* 400092 */ /*GILLT_s16*//*Label 7828*/ GIMT_Encode4(400132),
     /* 400096 */ /*GILLT_s32*//*Label 7829*/ GIMT_Encode4(402906),
     /* 400100 */ /*GILLT_s64*//*Label 7830*/ GIMT_Encode4(405836), GIMT_Encode4(0),
     /* 400108 */ /*GILLT_v2s32*//*Label 7831*/ GIMT_Encode4(408766),
     /* 400112 */ /*GILLT_v2s64*//*Label 7832*/ GIMT_Encode4(410287),
     /* 400116 */ /*GILLT_v4s16*//*Label 7833*/ GIMT_Encode4(411808),
     /* 400120 */ /*GILLT_v4s32*//*Label 7834*/ GIMT_Encode4(412987), GIMT_Encode4(0),
     /* 400128 */ /*GILLT_v8s16*//*Label 7835*/ GIMT_Encode4(414508),
     /* 400132 */ // Label 7828: @400132
     /* 400132 */ GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(402905),
     /* 400137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 400143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 400146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400150 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(400300), // Rule ID 4897 //
     /* 400155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400179 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 400220 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400227 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400239 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 400286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 400298 */     GIR_RootConstrainSelectedInstOperands,
     /* 400299 */     // GIR_Coverage, 4897,
     /* 400299 */     GIR_EraseRootFromParent_Done,
     /* 400300 */   // Label 7838: @400300
     /* 400300 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(400447), // Rule ID 4861 //
     /* 400305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 400349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400353 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400357 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400361 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400366 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 400370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400376 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400388 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 400435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 400445 */     GIR_RootConstrainSelectedInstOperands,
     /* 400446 */     // GIR_Coverage, 4861,
     /* 400446 */     GIR_EraseRootFromParent_Done,
     /* 400447 */   // Label 7839: @400447
     /* 400447 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(400594), // Rule ID 13941 //
     /* 400452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400488 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400500 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400504 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400508 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400513 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 400517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400523 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 400523 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 400526 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400530 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400535 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 400541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 400582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 400590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 400592 */     GIR_RootConstrainSelectedInstOperands,
     /* 400593 */     // GIR_Coverage, 13941,
     /* 400593 */     GIR_EraseRootFromParent_Done,
     /* 400594 */   // Label 7840: @400594
     /* 400594 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(400725), // Rule ID 6114 //
     /* 400599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 400627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 400643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400651 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400655 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 400664 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400668 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400672 */     // MIs[4] Operand 1
     /* 400672 */     // No operand predicates
     /* 400672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400676 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400678 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400690 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 400720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 400723 */     GIR_RootConstrainSelectedInstOperands,
     /* 400724 */     // GIR_Coverage, 6114,
     /* 400724 */     GIR_EraseRootFromParent_Done,
     /* 400725 */   // Label 7841: @400725
     /* 400725 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(400856), // Rule ID 6146 //
     /* 400730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400762 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400766 */     // MIs[2] Operand 1
     /* 400766 */     // No operand predicates
     /* 400766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 400778 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 400782 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400786 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400790 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 400794 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400799 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 400803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400809 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400854 */     GIR_RootConstrainSelectedInstOperands,
     /* 400855 */     // GIR_Coverage, 6146,
     /* 400855 */     GIR_EraseRootFromParent_Done,
     /* 400856 */   // Label 7842: @400856
     /* 400856 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(400987), // Rule ID 6210 //
     /* 400861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 400872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 400901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400913 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 400917 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 400926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400930 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400934 */     // MIs[4] Operand 1
     /* 400934 */     // No operand predicates
     /* 400934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 400940 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 400940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 400943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 400958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 400971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 400975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 400982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 400985 */     GIR_RootConstrainSelectedInstOperands,
     /* 400986 */     // GIR_Coverage, 6210,
     /* 400986 */     GIR_EraseRootFromParent_Done,
     /* 400987 */   // Label 7843: @400987
     /* 400987 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(401118), // Rule ID 6178 //
     /* 400992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401040 */     // MIs[3] Operand 1
     /* 401040 */     // No operand predicates
     /* 401040 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 401044 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401048 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401052 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401056 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401061 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401071 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401116 */     GIR_RootConstrainSelectedInstOperands,
     /* 401117 */     // GIR_Coverage, 6178,
     /* 401117 */     GIR_EraseRootFromParent_Done,
     /* 401118 */   // Label 7844: @401118
     /* 401118 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(401253), // Rule ID 2455 //
     /* 401123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401182 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401194 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 401241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401251 */     GIR_RootConstrainSelectedInstOperands,
     /* 401252 */     // GIR_Coverage, 2455,
     /* 401252 */     GIR_EraseRootFromParent_Done,
     /* 401253 */   // Label 7845: @401253
     /* 401253 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(401372), // Rule ID 6082 //
     /* 401258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401319 */     // MIs[3] Operand 1
     /* 401319 */     // No operand predicates
     /* 401319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401325 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401337 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 401356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401370 */     GIR_RootConstrainSelectedInstOperands,
     /* 401371 */     // GIR_Coverage, 6082,
     /* 401371 */     GIR_EraseRootFromParent_Done,
     /* 401372 */   // Label 7846: @401372
     /* 401372 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(401491), // Rule ID 2530 //
     /* 401377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401413 */     // MIs[2] Operand 1
     /* 401413 */     // No operand predicates
     /* 401413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401421 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401425 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401429 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401434 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401444 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 401475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401489 */     GIR_RootConstrainSelectedInstOperands,
     /* 401490 */     // GIR_Coverage, 2530,
     /* 401490 */     GIR_EraseRootFromParent_Done,
     /* 401491 */   // Label 7847: @401491
     /* 401491 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401591), // Rule ID 4859 //
     /* 401496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401547 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401559 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401589 */     GIR_RootConstrainSelectedInstOperands,
     /* 401590 */     // GIR_Coverage, 4859,
     /* 401590 */     GIR_EraseRootFromParent_Done,
     /* 401591 */   // Label 7848: @401591
     /* 401591 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(401691), // Rule ID 4895 //
     /* 401596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 401632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401647 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401659 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 401685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 401689 */     GIR_RootConstrainSelectedInstOperands,
     /* 401690 */     // GIR_Coverage, 4895,
     /* 401690 */     GIR_EraseRootFromParent_Done,
     /* 401691 */   // Label 7849: @401691
     /* 401691 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(401788), // Rule ID 13937 //
     /* 401696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401732 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401746 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401758 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401786 */     GIR_RootConstrainSelectedInstOperands,
     /* 401787 */     // GIR_Coverage, 13937,
     /* 401787 */     GIR_EraseRootFromParent_Done,
     /* 401788 */   // Label 7850: @401788
     /* 401788 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(401888), // Rule ID 13939 //
     /* 401793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401834 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401844 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 401844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401856 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401886 */     GIR_RootConstrainSelectedInstOperands,
     /* 401887 */     // GIR_Coverage, 13939,
     /* 401887 */     GIR_EraseRootFromParent_Done,
     /* 401888 */   // Label 7851: @401888
     /* 401888 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(401988), // Rule ID 4893 //
     /* 401893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 401929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401944 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 401986 */     GIR_RootConstrainSelectedInstOperands,
     /* 401987 */     // GIR_Coverage, 4893,
     /* 401987 */     GIR_EraseRootFromParent_Done,
     /* 401988 */   // Label 7852: @401988
     /* 401988 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(402085), // Rule ID 4857 //
     /* 401993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402033 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402043 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402083 */     GIR_RootConstrainSelectedInstOperands,
     /* 402084 */     // GIR_Coverage, 4857,
     /* 402084 */     GIR_EraseRootFromParent_Done,
     /* 402085 */   // Label 7853: @402085
     /* 402085 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(402169), // Rule ID 6144 //
     /* 402090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402126 */     // MIs[2] Operand 1
     /* 402126 */     // No operand predicates
     /* 402126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402138 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402149 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 402160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402167 */     GIR_RootConstrainSelectedInstOperands,
     /* 402168 */     // GIR_Coverage, 6144,
     /* 402168 */     GIR_EraseRootFromParent_Done,
     /* 402169 */   // Label 7854: @402169
     /* 402169 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(402250), // Rule ID 6176 //
     /* 402174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402218 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402222 */     // MIs[3] Operand 1
     /* 402222 */     // No operand predicates
     /* 402222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402232 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402248 */     GIR_RootConstrainSelectedInstOperands,
     /* 402249 */     // GIR_Coverage, 6176,
     /* 402249 */     GIR_EraseRootFromParent_Done,
     /* 402250 */   // Label 7855: @402250
     /* 402250 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(402334), // Rule ID 6208 //
     /* 402255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402308 */     // MIs[3] Operand 1
     /* 402308 */     // No operand predicates
     /* 402308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402314 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402332 */     GIR_RootConstrainSelectedInstOperands,
     /* 402333 */     // GIR_Coverage, 6208,
     /* 402333 */     GIR_EraseRootFromParent_Done,
     /* 402334 */   // Label 7856: @402334
     /* 402334 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(402415), // Rule ID 6112 //
     /* 402339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402391 */     // MIs[3] Operand 1
     /* 402391 */     // No operand predicates
     /* 402391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402397 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402413 */     GIR_RootConstrainSelectedInstOperands,
     /* 402414 */     // GIR_Coverage, 6112,
     /* 402414 */     GIR_EraseRootFromParent_Done,
     /* 402415 */   // Label 7857: @402415
     /* 402415 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(402500), // Rule ID 2453 //
     /* 402420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402444 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402458 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402470 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402498 */     GIR_RootConstrainSelectedInstOperands,
     /* 402499 */     // GIR_Coverage, 2453,
     /* 402499 */     GIR_EraseRootFromParent_Done,
     /* 402500 */   // Label 7858: @402500
     /* 402500 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(402585), // Rule ID 2451 //
     /* 402505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402533 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402543 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402555 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402583 */     GIR_RootConstrainSelectedInstOperands,
     /* 402584 */     // GIR_Coverage, 2451,
     /* 402584 */     GIR_EraseRootFromParent_Done,
     /* 402585 */   // Label 7859: @402585
     /* 402585 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(402654), // Rule ID 2528 //
     /* 402590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402626 */     // MIs[2] Operand 1
     /* 402626 */     // No operand predicates
     /* 402626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402636 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402652 */     GIR_RootConstrainSelectedInstOperands,
     /* 402653 */     // GIR_Coverage, 2528,
     /* 402653 */     GIR_EraseRootFromParent_Done,
     /* 402654 */   // Label 7860: @402654
     /* 402654 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(402723), // Rule ID 6080 //
     /* 402659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402699 */     // MIs[2] Operand 1
     /* 402699 */     // No operand predicates
     /* 402699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402705 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402721 */     GIR_RootConstrainSelectedInstOperands,
     /* 402722 */     // GIR_Coverage, 6080,
     /* 402722 */     GIR_EraseRootFromParent_Done,
     /* 402723 */   // Label 7861: @402723
     /* 402723 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402773), // Rule ID 13373 //
     /* 402728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402758 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402771 */     GIR_RootConstrainSelectedInstOperands,
     /* 402772 */     // GIR_Coverage, 13373,
     /* 402772 */     GIR_EraseRootFromParent_Done,
     /* 402773 */   // Label 7862: @402773
     /* 402773 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(402823), // Rule ID 643 //
     /* 402778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402808 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402821 */     GIR_RootConstrainSelectedInstOperands,
     /* 402822 */     // GIR_Coverage, 643,
     /* 402822 */     GIR_EraseRootFromParent_Done,
     /* 402823 */   // Label 7863: @402823
     /* 402823 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402873), // Rule ID 655 //
     /* 402828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402858 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 402871 */     GIR_RootConstrainSelectedInstOperands,
     /* 402872 */     // GIR_Coverage, 655,
     /* 402872 */     GIR_EraseRootFromParent_Done,
     /* 402873 */   // Label 7864: @402873
     /* 402873 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402904), // Rule ID 637 //
     /* 402878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402893 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402898 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402902 */     GIR_RootConstrainSelectedInstOperands,
     /* 402903 */     // GIR_Coverage, 637,
     /* 402903 */     GIR_Done,
     /* 402904 */   // Label 7865: @402904
     /* 402904 */   GIM_Reject,
     /* 402905 */ // Label 7837: @402905
     /* 402905 */ GIM_Reject,
     /* 402906 */ // Label 7829: @402906
     /* 402906 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(405835),
     /* 402911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 402917 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 402920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402924 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(403074), // Rule ID 4903 //
     /* 402929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 402994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403001 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403013 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403041 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 403060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403072 */     GIR_RootConstrainSelectedInstOperands,
     /* 403073 */     // GIR_Coverage, 4903,
     /* 403073 */     GIR_EraseRootFromParent_Done,
     /* 403074 */   // Label 7867: @403074
     /* 403074 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(403221), // Rule ID 4867 //
     /* 403079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403103 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 403119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403131 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403140 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403150 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403162 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403190 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 403209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403219 */     GIR_RootConstrainSelectedInstOperands,
     /* 403220 */     // GIR_Coverage, 4867,
     /* 403220 */     GIR_EraseRootFromParent_Done,
     /* 403221 */   // Label 7868: @403221
     /* 403221 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(403368), // Rule ID 13947 //
     /* 403226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403262 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403287 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403297 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403309 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403337 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 403356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403366 */     GIR_RootConstrainSelectedInstOperands,
     /* 403367 */     // GIR_Coverage, 13947,
     /* 403367 */     GIR_EraseRootFromParent_Done,
     /* 403368 */   // Label 7869: @403368
     /* 403368 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(403499), // Rule ID 6130 //
     /* 403373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 403413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403421 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403425 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403429 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403442 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403446 */     // MIs[4] Operand 1
     /* 403446 */     // No operand predicates
     /* 403446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403452 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403497 */     GIR_RootConstrainSelectedInstOperands,
     /* 403498 */     // GIR_Coverage, 6130,
     /* 403498 */     GIR_EraseRootFromParent_Done,
     /* 403499 */   // Label 7870: @403499
     /* 403499 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(403630), // Rule ID 6162 //
     /* 403504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403536 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403540 */     // MIs[2] Operand 1
     /* 403540 */     // No operand predicates
     /* 403540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 403552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 403556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403560 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403564 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403568 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403573 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403581 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403583 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403628 */     GIR_RootConstrainSelectedInstOperands,
     /* 403629 */     // GIR_Coverage, 6162,
     /* 403629 */     GIR_EraseRootFromParent_Done,
     /* 403630 */   // Label 7871: @403630
     /* 403630 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(403761), // Rule ID 6226 //
     /* 403635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403708 */     // MIs[4] Operand 1
     /* 403708 */     // No operand predicates
     /* 403708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403714 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403759 */     GIR_RootConstrainSelectedInstOperands,
     /* 403760 */     // GIR_Coverage, 6226,
     /* 403760 */     GIR_EraseRootFromParent_Done,
     /* 403761 */   // Label 7872: @403761
     /* 403761 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(403892), // Rule ID 6194 //
     /* 403766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 403781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403814 */     // MIs[3] Operand 1
     /* 403814 */     // No operand predicates
     /* 403814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 403818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403822 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403826 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403830 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403835 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403843 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403845 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 403845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403857 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 403876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403890 */     GIR_RootConstrainSelectedInstOperands,
     /* 403891 */     // GIR_Coverage, 6194,
     /* 403891 */     GIR_EraseRootFromParent_Done,
     /* 403892 */   // Label 7873: @403892
     /* 403892 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(404027), // Rule ID 2461 //
     /* 403897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403956 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403968 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 404015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404025 */     GIR_RootConstrainSelectedInstOperands,
     /* 404026 */     // GIR_Coverage, 2461,
     /* 404026 */     GIR_EraseRootFromParent_Done,
     /* 404027 */   // Label 7874: @404027
     /* 404027 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(404146), // Rule ID 6098 //
     /* 404032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404056 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404089 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404093 */     // MIs[3] Operand 1
     /* 404093 */     // No operand predicates
     /* 404093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404099 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404111 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404144 */     GIR_RootConstrainSelectedInstOperands,
     /* 404145 */     // GIR_Coverage, 6098,
     /* 404145 */     GIR_EraseRootFromParent_Done,
     /* 404146 */   // Label 7875: @404146
     /* 404146 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(404265), // Rule ID 2546 //
     /* 404151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404187 */     // MIs[2] Operand 1
     /* 404187 */     // No operand predicates
     /* 404187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404199 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404203 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404208 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404218 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 404249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404263 */     GIR_RootConstrainSelectedInstOperands,
     /* 404264 */     // GIR_Coverage, 2546,
     /* 404264 */     GIR_EraseRootFromParent_Done,
     /* 404265 */   // Label 7876: @404265
     /* 404265 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(404365), // Rule ID 4865 //
     /* 404270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404294 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404321 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404333 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404363 */     GIR_RootConstrainSelectedInstOperands,
     /* 404364 */     // GIR_Coverage, 4865,
     /* 404364 */     GIR_EraseRootFromParent_Done,
     /* 404365 */   // Label 7877: @404365
     /* 404365 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(404465), // Rule ID 4901 //
     /* 404370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404421 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404433 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404463 */     GIR_RootConstrainSelectedInstOperands,
     /* 404464 */     // GIR_Coverage, 4901,
     /* 404464 */     GIR_EraseRootFromParent_Done,
     /* 404465 */   // Label 7878: @404465
     /* 404465 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(404562), // Rule ID 13943 //
     /* 404470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404506 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404520 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404560 */     GIR_RootConstrainSelectedInstOperands,
     /* 404561 */     // GIR_Coverage, 13943,
     /* 404561 */     GIR_EraseRootFromParent_Done,
     /* 404562 */   // Label 7879: @404562
     /* 404562 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(404662), // Rule ID 13945 //
     /* 404567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404618 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 404618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404630 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404660 */     GIR_RootConstrainSelectedInstOperands,
     /* 404661 */     // GIR_Coverage, 13945,
     /* 404661 */     GIR_EraseRootFromParent_Done,
     /* 404662 */   // Label 7880: @404662
     /* 404662 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(404762), // Rule ID 4899 //
     /* 404667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404718 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404760 */     GIR_RootConstrainSelectedInstOperands,
     /* 404761 */     // GIR_Coverage, 4899,
     /* 404761 */     GIR_EraseRootFromParent_Done,
     /* 404762 */   // Label 7881: @404762
     /* 404762 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(404859), // Rule ID 4863 //
     /* 404767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404817 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404829 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404857 */     GIR_RootConstrainSelectedInstOperands,
     /* 404858 */     // GIR_Coverage, 4863,
     /* 404858 */     GIR_EraseRootFromParent_Done,
     /* 404859 */   // Label 7882: @404859
     /* 404859 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404937), // Rule ID 6248 //
     /* 404864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 404901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404909 */     // MIs[3] Operand 1
     /* 404909 */     // No operand predicates
     /* 404909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404919 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404935 */     GIR_RootConstrainSelectedInstOperands,
     /* 404936 */     // GIR_Coverage, 6248,
     /* 404936 */     GIR_EraseRootFromParent_Done,
     /* 404937 */   // Label 7883: @404937
     /* 404937 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(405021), // Rule ID 6160 //
     /* 404942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404974 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404978 */     // MIs[2] Operand 1
     /* 404978 */     // No operand predicates
     /* 404978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404990 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405001 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 405012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405019 */     GIR_RootConstrainSelectedInstOperands,
     /* 405020 */     // GIR_Coverage, 6160,
     /* 405020 */     GIR_EraseRootFromParent_Done,
     /* 405021 */   // Label 7884: @405021
     /* 405021 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(405102), // Rule ID 6192 //
     /* 405026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405074 */     // MIs[3] Operand 1
     /* 405074 */     // No operand predicates
     /* 405074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405084 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405100 */     GIR_RootConstrainSelectedInstOperands,
     /* 405101 */     // GIR_Coverage, 6192,
     /* 405101 */     GIR_EraseRootFromParent_Done,
     /* 405102 */   // Label 7885: @405102
     /* 405102 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(405186), // Rule ID 6224 //
     /* 405107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405156 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405160 */     // MIs[3] Operand 1
     /* 405160 */     // No operand predicates
     /* 405160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405166 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405184 */     GIR_RootConstrainSelectedInstOperands,
     /* 405185 */     // GIR_Coverage, 6224,
     /* 405185 */     GIR_EraseRootFromParent_Done,
     /* 405186 */   // Label 7886: @405186
     /* 405186 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(405264), // Rule ID 6270 //
     /* 405191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 405232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405236 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405240 */     // MIs[3] Operand 1
     /* 405240 */     // No operand predicates
     /* 405240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405246 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405262 */     GIR_RootConstrainSelectedInstOperands,
     /* 405263 */     // GIR_Coverage, 6270,
     /* 405263 */     GIR_EraseRootFromParent_Done,
     /* 405264 */   // Label 7887: @405264
     /* 405264 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(405345), // Rule ID 6128 //
     /* 405269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405317 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405321 */     // MIs[3] Operand 1
     /* 405321 */     // No operand predicates
     /* 405321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405327 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405343 */     GIR_RootConstrainSelectedInstOperands,
     /* 405344 */     // GIR_Coverage, 6128,
     /* 405344 */     GIR_EraseRootFromParent_Done,
     /* 405345 */   // Label 7888: @405345
     /* 405345 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(405430), // Rule ID 2459 //
     /* 405350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405388 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405400 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405428 */     GIR_RootConstrainSelectedInstOperands,
     /* 405429 */     // GIR_Coverage, 2459,
     /* 405429 */     GIR_EraseRootFromParent_Done,
     /* 405430 */   // Label 7889: @405430
     /* 405430 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(405515), // Rule ID 2457 //
     /* 405435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405473 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405485 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405513 */     GIR_RootConstrainSelectedInstOperands,
     /* 405514 */     // GIR_Coverage, 2457,
     /* 405514 */     GIR_EraseRootFromParent_Done,
     /* 405515 */   // Label 7890: @405515
     /* 405515 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(405584), // Rule ID 2544 //
     /* 405520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405556 */     // MIs[2] Operand 1
     /* 405556 */     // No operand predicates
     /* 405556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405566 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405582 */     GIR_RootConstrainSelectedInstOperands,
     /* 405583 */     // GIR_Coverage, 2544,
     /* 405583 */     GIR_EraseRootFromParent_Done,
     /* 405584 */   // Label 7891: @405584
     /* 405584 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(405653), // Rule ID 6096 //
     /* 405589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405629 */     // MIs[2] Operand 1
     /* 405629 */     // No operand predicates
     /* 405629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405635 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405651 */     GIR_RootConstrainSelectedInstOperands,
     /* 405652 */     // GIR_Coverage, 6096,
     /* 405652 */     GIR_EraseRootFromParent_Done,
     /* 405653 */   // Label 7892: @405653
     /* 405653 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(405703), // Rule ID 13375 //
     /* 405658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405688 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405701 */     GIR_RootConstrainSelectedInstOperands,
     /* 405702 */     // GIR_Coverage, 13375,
     /* 405702 */     GIR_EraseRootFromParent_Done,
     /* 405703 */   // Label 7893: @405703
     /* 405703 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405753), // Rule ID 645 //
     /* 405708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405738 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405751 */     GIR_RootConstrainSelectedInstOperands,
     /* 405752 */     // GIR_Coverage, 645,
     /* 405752 */     GIR_EraseRootFromParent_Done,
     /* 405753 */   // Label 7894: @405753
     /* 405753 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405803), // Rule ID 657 //
     /* 405758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 405773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405788 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 405801 */     GIR_RootConstrainSelectedInstOperands,
     /* 405802 */     // GIR_Coverage, 657,
     /* 405802 */     GIR_EraseRootFromParent_Done,
     /* 405803 */   // Label 7895: @405803
     /* 405803 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405834), // Rule ID 639 //
     /* 405808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405823 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405828 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405832 */     GIR_RootConstrainSelectedInstOperands,
     /* 405833 */     // GIR_Coverage, 639,
     /* 405833 */     GIR_Done,
     /* 405834 */   // Label 7896: @405834
     /* 405834 */   GIM_Reject,
     /* 405835 */ // Label 7866: @405835
     /* 405835 */ GIM_Reject,
     /* 405836 */ // Label 7830: @405836
     /* 405836 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(408765),
     /* 405841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 405847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 405850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405854 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(406004), // Rule ID 4909 //
     /* 405859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405883 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 405916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 405924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405931 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 405931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 405934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405943 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 405949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 405962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405971 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 405977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 405990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 406002 */     GIR_RootConstrainSelectedInstOperands,
     /* 406003 */     // GIR_Coverage, 4909,
     /* 406003 */     GIR_EraseRootFromParent_Done,
     /* 406004 */   // Label 7898: @406004
     /* 406004 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(406151), // Rule ID 4873 //
     /* 406009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406057 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406061 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406065 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406070 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406080 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406080 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406083 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406087 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406092 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406149 */     GIR_RootConstrainSelectedInstOperands,
     /* 406150 */     // GIR_Coverage, 4873,
     /* 406150 */     GIR_EraseRootFromParent_Done,
     /* 406151 */   // Label 7899: @406151
     /* 406151 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(406298), // Rule ID 13953 //
     /* 406156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406217 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406227 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406239 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406245 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 406286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406296 */     GIR_RootConstrainSelectedInstOperands,
     /* 406297 */     // GIR_Coverage, 13953,
     /* 406297 */     GIR_EraseRootFromParent_Done,
     /* 406298 */   // Label 7900: @406298
     /* 406298 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(406429), // Rule ID 6134 //
     /* 406303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406327 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406355 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406359 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406372 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406376 */     // MIs[4] Operand 1
     /* 406376 */     // No operand predicates
     /* 406376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406382 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406394 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406427 */     GIR_RootConstrainSelectedInstOperands,
     /* 406428 */     // GIR_Coverage, 6134,
     /* 406428 */     GIR_EraseRootFromParent_Done,
     /* 406429 */   // Label 7901: @406429
     /* 406429 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(406560), // Rule ID 6166 //
     /* 406434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406470 */     // MIs[2] Operand 1
     /* 406470 */     // No operand predicates
     /* 406470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 406482 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 406486 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406490 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406494 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406498 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406503 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406511 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406513 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406525 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406558 */     GIR_RootConstrainSelectedInstOperands,
     /* 406559 */     // GIR_Coverage, 6166,
     /* 406559 */     GIR_EraseRootFromParent_Done,
     /* 406560 */   // Label 7902: @406560
     /* 406560 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(406691), // Rule ID 6230 //
     /* 406565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406601 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406621 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406630 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406634 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406638 */     // MIs[4] Operand 1
     /* 406638 */     // No operand predicates
     /* 406638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406642 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406644 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406689 */     GIR_RootConstrainSelectedInstOperands,
     /* 406690 */     // GIR_Coverage, 6230,
     /* 406690 */     GIR_EraseRootFromParent_Done,
     /* 406691 */   // Label 7903: @406691
     /* 406691 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(406822), // Rule ID 6198 //
     /* 406696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 406711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 406744 */     // MIs[3] Operand 1
     /* 406744 */     // No operand predicates
     /* 406744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 406748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406752 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406756 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406760 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406765 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406775 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 406775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 406806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406820 */     GIR_RootConstrainSelectedInstOperands,
     /* 406821 */     // GIR_Coverage, 6198,
     /* 406821 */     GIR_EraseRootFromParent_Done,
     /* 406822 */   // Label 7904: @406822
     /* 406822 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406957), // Rule ID 2467 //
     /* 406827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406851 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406876 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406886 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406898 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406926 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 406945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406955 */     GIR_RootConstrainSelectedInstOperands,
     /* 406956 */     // GIR_Coverage, 2467,
     /* 406956 */     GIR_EraseRootFromParent_Done,
     /* 406957 */   // Label 7905: @406957
     /* 406957 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(407076), // Rule ID 6102 //
     /* 406962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406986 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407023 */     // MIs[3] Operand 1
     /* 407023 */     // No operand predicates
     /* 407023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407029 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407041 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407074 */     GIR_RootConstrainSelectedInstOperands,
     /* 407075 */     // GIR_Coverage, 6102,
     /* 407075 */     GIR_EraseRootFromParent_Done,
     /* 407076 */   // Label 7906: @407076
     /* 407076 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(407195), // Rule ID 2550 //
     /* 407081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407117 */     // MIs[2] Operand 1
     /* 407117 */     // No operand predicates
     /* 407117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407138 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407148 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407160 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407193 */     GIR_RootConstrainSelectedInstOperands,
     /* 407194 */     // GIR_Coverage, 2550,
     /* 407194 */     GIR_EraseRootFromParent_Done,
     /* 407195 */   // Label 7907: @407195
     /* 407195 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(407295), // Rule ID 4871 //
     /* 407200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407224 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407251 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407263 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407293 */     GIR_RootConstrainSelectedInstOperands,
     /* 407294 */     // GIR_Coverage, 4871,
     /* 407294 */     GIR_EraseRootFromParent_Done,
     /* 407295 */   // Label 7908: @407295
     /* 407295 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(407395), // Rule ID 4907 //
     /* 407300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407351 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407363 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407393 */     GIR_RootConstrainSelectedInstOperands,
     /* 407394 */     // GIR_Coverage, 4907,
     /* 407394 */     GIR_EraseRootFromParent_Done,
     /* 407395 */   // Label 7909: @407395
     /* 407395 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(407492), // Rule ID 13949 //
     /* 407400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407436 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407450 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407462 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407490 */     GIR_RootConstrainSelectedInstOperands,
     /* 407491 */     // GIR_Coverage, 13949,
     /* 407491 */     GIR_EraseRootFromParent_Done,
     /* 407492 */   // Label 7910: @407492
     /* 407492 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(407592), // Rule ID 13951 //
     /* 407497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407538 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407548 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 407548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407590 */     GIR_RootConstrainSelectedInstOperands,
     /* 407591 */     // GIR_Coverage, 13951,
     /* 407591 */     GIR_EraseRootFromParent_Done,
     /* 407592 */   // Label 7911: @407592
     /* 407592 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(407692), // Rule ID 4905 //
     /* 407597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407625 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407648 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407660 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407690 */     GIR_RootConstrainSelectedInstOperands,
     /* 407691 */     // GIR_Coverage, 4905,
     /* 407691 */     GIR_EraseRootFromParent_Done,
     /* 407692 */   // Label 7912: @407692
     /* 407692 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(407789), // Rule ID 4869 //
     /* 407697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407737 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407747 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407759 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407787 */     GIR_RootConstrainSelectedInstOperands,
     /* 407788 */     // GIR_Coverage, 4869,
     /* 407788 */     GIR_EraseRootFromParent_Done,
     /* 407789 */   // Label 7913: @407789
     /* 407789 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(407867), // Rule ID 6252 //
     /* 407794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 407831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407839 */     // MIs[3] Operand 1
     /* 407839 */     // No operand predicates
     /* 407839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407849 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407865 */     GIR_RootConstrainSelectedInstOperands,
     /* 407866 */     // GIR_Coverage, 6252,
     /* 407866 */     GIR_EraseRootFromParent_Done,
     /* 407867 */   // Label 7914: @407867
     /* 407867 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(407951), // Rule ID 6164 //
     /* 407872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407908 */     // MIs[2] Operand 1
     /* 407908 */     // No operand predicates
     /* 407908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407920 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407931 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 407942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407949 */     GIR_RootConstrainSelectedInstOperands,
     /* 407950 */     // GIR_Coverage, 6164,
     /* 407950 */     GIR_EraseRootFromParent_Done,
     /* 407951 */   // Label 7915: @407951
     /* 407951 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(408032), // Rule ID 6196 //
     /* 407956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408000 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408004 */     // MIs[3] Operand 1
     /* 408004 */     // No operand predicates
     /* 408004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408014 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408030 */     GIR_RootConstrainSelectedInstOperands,
     /* 408031 */     // GIR_Coverage, 6196,
     /* 408031 */     GIR_EraseRootFromParent_Done,
     /* 408032 */   // Label 7916: @408032
     /* 408032 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(408116), // Rule ID 6228 //
     /* 408037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408090 */     // MIs[3] Operand 1
     /* 408090 */     // No operand predicates
     /* 408090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408096 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 408107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408114 */     GIR_RootConstrainSelectedInstOperands,
     /* 408115 */     // GIR_Coverage, 6228,
     /* 408115 */     GIR_EraseRootFromParent_Done,
     /* 408116 */   // Label 7917: @408116
     /* 408116 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(408194), // Rule ID 6274 //
     /* 408121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408170 */     // MIs[3] Operand 1
     /* 408170 */     // No operand predicates
     /* 408170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408176 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408192 */     GIR_RootConstrainSelectedInstOperands,
     /* 408193 */     // GIR_Coverage, 6274,
     /* 408193 */     GIR_EraseRootFromParent_Done,
     /* 408194 */   // Label 7918: @408194
     /* 408194 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(408275), // Rule ID 6132 //
     /* 408199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408247 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408251 */     // MIs[3] Operand 1
     /* 408251 */     // No operand predicates
     /* 408251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408257 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408273 */     GIR_RootConstrainSelectedInstOperands,
     /* 408274 */     // GIR_Coverage, 6132,
     /* 408274 */     GIR_EraseRootFromParent_Done,
     /* 408275 */   // Label 7919: @408275
     /* 408275 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(408360), // Rule ID 2465 //
     /* 408280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408318 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408330 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408358 */     GIR_RootConstrainSelectedInstOperands,
     /* 408359 */     // GIR_Coverage, 2465,
     /* 408359 */     GIR_EraseRootFromParent_Done,
     /* 408360 */   // Label 7920: @408360
     /* 408360 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(408445), // Rule ID 2463 //
     /* 408365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408393 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408403 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408415 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408443 */     GIR_RootConstrainSelectedInstOperands,
     /* 408444 */     // GIR_Coverage, 2463,
     /* 408444 */     GIR_EraseRootFromParent_Done,
     /* 408445 */   // Label 7921: @408445
     /* 408445 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(408514), // Rule ID 2548 //
     /* 408450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408482 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408486 */     // MIs[2] Operand 1
     /* 408486 */     // No operand predicates
     /* 408486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408496 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408512 */     GIR_RootConstrainSelectedInstOperands,
     /* 408513 */     // GIR_Coverage, 2548,
     /* 408513 */     GIR_EraseRootFromParent_Done,
     /* 408514 */   // Label 7922: @408514
     /* 408514 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(408583), // Rule ID 6100 //
     /* 408519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408559 */     // MIs[2] Operand 1
     /* 408559 */     // No operand predicates
     /* 408559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408565 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408581 */     GIR_RootConstrainSelectedInstOperands,
     /* 408582 */     // GIR_Coverage, 6100,
     /* 408582 */     GIR_EraseRootFromParent_Done,
     /* 408583 */   // Label 7923: @408583
     /* 408583 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(408633), // Rule ID 13377 //
     /* 408588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408618 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408631 */     GIR_RootConstrainSelectedInstOperands,
     /* 408632 */     // GIR_Coverage, 13377,
     /* 408632 */     GIR_EraseRootFromParent_Done,
     /* 408633 */   // Label 7924: @408633
     /* 408633 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(408683), // Rule ID 647 //
     /* 408638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408668 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408681 */     GIR_RootConstrainSelectedInstOperands,
     /* 408682 */     // GIR_Coverage, 647,
     /* 408682 */     GIR_EraseRootFromParent_Done,
     /* 408683 */   // Label 7925: @408683
     /* 408683 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(408733), // Rule ID 659 //
     /* 408688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408718 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 408731 */     GIR_RootConstrainSelectedInstOperands,
     /* 408732 */     // GIR_Coverage, 659,
     /* 408732 */     GIR_EraseRootFromParent_Done,
     /* 408733 */   // Label 7926: @408733
     /* 408733 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408764), // Rule ID 641 //
     /* 408738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408753 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408758 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408762 */     GIR_RootConstrainSelectedInstOperands,
     /* 408763 */     // GIR_Coverage, 641,
     /* 408763 */     GIR_Done,
     /* 408764 */   // Label 7927: @408764
     /* 408764 */   GIM_Reject,
     /* 408765 */ // Label 7897: @408765
     /* 408765 */ GIM_Reject,
     /* 408766 */ // Label 7831: @408766
     /* 408766 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(410286),
     /* 408771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 408780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408784 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408862), // Rule ID 6232 //
     /* 408789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408830 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408834 */     // MIs[3] Operand 1
     /* 408834 */     // No operand predicates
     /* 408834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408844 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 408847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408860 */     GIR_RootConstrainSelectedInstOperands,
     /* 408861 */     // GIR_Coverage, 6232,
     /* 408861 */     GIR_EraseRootFromParent_Done,
     /* 408862 */   // Label 7929: @408862
     /* 408862 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408946), // Rule ID 6148 //
     /* 408867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408903 */     // MIs[2] Operand 1
     /* 408903 */     // No operand predicates
     /* 408903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408915 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408926 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 408929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 408937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408944 */     GIR_RootConstrainSelectedInstOperands,
     /* 408945 */     // GIR_Coverage, 6148,
     /* 408945 */     GIR_EraseRootFromParent_Done,
     /* 408946 */   // Label 7930: @408946
     /* 408946 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(409027), // Rule ID 6180 //
     /* 408951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408995 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408999 */     // MIs[3] Operand 1
     /* 408999 */     // No operand predicates
     /* 408999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409009 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409025 */     GIR_RootConstrainSelectedInstOperands,
     /* 409026 */     // GIR_Coverage, 6180,
     /* 409026 */     GIR_EraseRootFromParent_Done,
     /* 409027 */   // Label 7931: @409027
     /* 409027 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(409111), // Rule ID 6212 //
     /* 409032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409085 */     // MIs[3] Operand 1
     /* 409085 */     // No operand predicates
     /* 409085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409091 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409109 */     GIR_RootConstrainSelectedInstOperands,
     /* 409110 */     // GIR_Coverage, 6212,
     /* 409110 */     GIR_EraseRootFromParent_Done,
     /* 409111 */   // Label 7932: @409111
     /* 409111 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(409189), // Rule ID 6254 //
     /* 409116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409161 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409165 */     // MIs[3] Operand 1
     /* 409165 */     // No operand predicates
     /* 409165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409171 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409187 */     GIR_RootConstrainSelectedInstOperands,
     /* 409188 */     // GIR_Coverage, 6254,
     /* 409188 */     GIR_EraseRootFromParent_Done,
     /* 409189 */   // Label 7933: @409189
     /* 409189 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(409270), // Rule ID 6116 //
     /* 409194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409242 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409246 */     // MIs[3] Operand 1
     /* 409246 */     // No operand predicates
     /* 409246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409252 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409268 */     GIR_RootConstrainSelectedInstOperands,
     /* 409269 */     // GIR_Coverage, 6116,
     /* 409269 */     GIR_EraseRootFromParent_Done,
     /* 409270 */   // Label 7934: @409270
     /* 409270 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(409339), // Rule ID 2532 //
     /* 409275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409311 */     // MIs[2] Operand 1
     /* 409311 */     // No operand predicates
     /* 409311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409321 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 409324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409337 */     GIR_RootConstrainSelectedInstOperands,
     /* 409338 */     // GIR_Coverage, 2532,
     /* 409338 */     GIR_EraseRootFromParent_Done,
     /* 409339 */   // Label 7935: @409339
     /* 409339 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(409408), // Rule ID 6084 //
     /* 409344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409384 */     // MIs[2] Operand 1
     /* 409384 */     // No operand predicates
     /* 409384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409390 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 409393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409406 */     GIR_RootConstrainSelectedInstOperands,
     /* 409407 */     // GIR_Coverage, 6084,
     /* 409407 */     GIR_EraseRootFromParent_Done,
     /* 409408 */   // Label 7936: @409408
     /* 409408 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409501), // Rule ID 6236 //
     /* 409413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409452 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409499 */     GIR_RootConstrainSelectedInstOperands,
     /* 409500 */     // GIR_Coverage, 6236,
     /* 409500 */     GIR_EraseRootFromParent_Done,
     /* 409501 */   // Label 7937: @409501
     /* 409501 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409600), // Rule ID 6150 //
     /* 409506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409549 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409561 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 409592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409598 */     GIR_RootConstrainSelectedInstOperands,
     /* 409599 */     // GIR_Coverage, 6150,
     /* 409599 */     GIR_EraseRootFromParent_Done,
     /* 409600 */   // Label 7938: @409600
     /* 409600 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409696), // Rule ID 6182 //
     /* 409605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409647 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409694 */     GIR_RootConstrainSelectedInstOperands,
     /* 409695 */     // GIR_Coverage, 6182,
     /* 409695 */     GIR_EraseRootFromParent_Done,
     /* 409696 */   // Label 7939: @409696
     /* 409696 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409795), // Rule ID 6214 //
     /* 409701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409744 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409793 */     GIR_RootConstrainSelectedInstOperands,
     /* 409794 */     // GIR_Coverage, 6214,
     /* 409794 */     GIR_EraseRootFromParent_Done,
     /* 409795 */   // Label 7940: @409795
     /* 409795 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409888), // Rule ID 6258 //
     /* 409800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 409812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 409816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409839 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409886 */     GIR_RootConstrainSelectedInstOperands,
     /* 409887 */     // GIR_Coverage, 6258,
     /* 409887 */     GIR_EraseRootFromParent_Done,
     /* 409888 */   // Label 7941: @409888
     /* 409888 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(409984), // Rule ID 6118 //
     /* 409893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 409920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 409924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409935 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 409935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 409938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409947 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 409950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409954 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 409957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409982 */     GIR_RootConstrainSelectedInstOperands,
     /* 409983 */     // GIR_Coverage, 6118,
     /* 409983 */     GIR_EraseRootFromParent_Done,
     /* 409984 */   // Label 7942: @409984
     /* 409984 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(410068), // Rule ID 2534 //
     /* 409989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410019 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410066 */     GIR_RootConstrainSelectedInstOperands,
     /* 410067 */     // GIR_Coverage, 2534,
     /* 410067 */     GIR_EraseRootFromParent_Done,
     /* 410068 */   // Label 7943: @410068
     /* 410068 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(410118), // Rule ID 13407 //
     /* 410073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410103 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410116 */     GIR_RootConstrainSelectedInstOperands,
     /* 410117 */     // GIR_Coverage, 13407,
     /* 410117 */     GIR_EraseRootFromParent_Done,
     /* 410118 */   // Label 7944: @410118
     /* 410118 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(410202), // Rule ID 6086 //
     /* 410123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410153 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410200 */     GIR_RootConstrainSelectedInstOperands,
     /* 410201 */     // GIR_Coverage, 6086,
     /* 410201 */     GIR_EraseRootFromParent_Done,
     /* 410202 */   // Label 7945: @410202
     /* 410202 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(410252), // Rule ID 1307 //
     /* 410207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410237 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 410240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410250 */     GIR_RootConstrainSelectedInstOperands,
     /* 410251 */     // GIR_Coverage, 1307,
     /* 410251 */     GIR_EraseRootFromParent_Done,
     /* 410252 */   // Label 7946: @410252
     /* 410252 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(410285), // Rule ID 1297 //
     /* 410257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410272 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 410275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 410283 */     GIR_RootConstrainSelectedInstOperands,
     /* 410284 */     // GIR_Coverage, 1297,
     /* 410284 */     GIR_EraseRootFromParent_Done,
     /* 410285 */   // Label 7947: @410285
     /* 410285 */   GIM_Reject,
     /* 410286 */ // Label 7928: @410286
     /* 410286 */ GIM_Reject,
     /* 410287 */ // Label 7832: @410287
     /* 410287 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(411807),
     /* 410292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 410301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410305 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(410383), // Rule ID 6244 //
     /* 410310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410351 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410355 */     // MIs[3] Operand 1
     /* 410355 */     // No operand predicates
     /* 410355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410365 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410381 */     GIR_RootConstrainSelectedInstOperands,
     /* 410382 */     // GIR_Coverage, 6244,
     /* 410382 */     GIR_EraseRootFromParent_Done,
     /* 410383 */   // Label 7949: @410383
     /* 410383 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(410467), // Rule ID 6156 //
     /* 410388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410424 */     // MIs[2] Operand 1
     /* 410424 */     // No operand predicates
     /* 410424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410436 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410447 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 410458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410465 */     GIR_RootConstrainSelectedInstOperands,
     /* 410466 */     // GIR_Coverage, 6156,
     /* 410466 */     GIR_EraseRootFromParent_Done,
     /* 410467 */   // Label 7950: @410467
     /* 410467 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(410548), // Rule ID 6188 //
     /* 410472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410516 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410520 */     // MIs[3] Operand 1
     /* 410520 */     // No operand predicates
     /* 410520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410530 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410546 */     GIR_RootConstrainSelectedInstOperands,
     /* 410547 */     // GIR_Coverage, 6188,
     /* 410547 */     GIR_EraseRootFromParent_Done,
     /* 410548 */   // Label 7951: @410548
     /* 410548 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(410632), // Rule ID 6220 //
     /* 410553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410602 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410606 */     // MIs[3] Operand 1
     /* 410606 */     // No operand predicates
     /* 410606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410612 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410630 */     GIR_RootConstrainSelectedInstOperands,
     /* 410631 */     // GIR_Coverage, 6220,
     /* 410631 */     GIR_EraseRootFromParent_Done,
     /* 410632 */   // Label 7952: @410632
     /* 410632 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410710), // Rule ID 6266 //
     /* 410637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410682 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410686 */     // MIs[3] Operand 1
     /* 410686 */     // No operand predicates
     /* 410686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410692 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410708 */     GIR_RootConstrainSelectedInstOperands,
     /* 410709 */     // GIR_Coverage, 6266,
     /* 410709 */     GIR_EraseRootFromParent_Done,
     /* 410710 */   // Label 7953: @410710
     /* 410710 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410791), // Rule ID 6124 //
     /* 410715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410767 */     // MIs[3] Operand 1
     /* 410767 */     // No operand predicates
     /* 410767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410773 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 410776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410789 */     GIR_RootConstrainSelectedInstOperands,
     /* 410790 */     // GIR_Coverage, 6124,
     /* 410790 */     GIR_EraseRootFromParent_Done,
     /* 410791 */   // Label 7954: @410791
     /* 410791 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410860), // Rule ID 2540 //
     /* 410796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410832 */     // MIs[2] Operand 1
     /* 410832 */     // No operand predicates
     /* 410832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410842 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 410845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410858 */     GIR_RootConstrainSelectedInstOperands,
     /* 410859 */     // GIR_Coverage, 2540,
     /* 410859 */     GIR_EraseRootFromParent_Done,
     /* 410860 */   // Label 7955: @410860
     /* 410860 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410929), // Rule ID 6092 //
     /* 410865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 410880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410905 */     // MIs[2] Operand 1
     /* 410905 */     // No operand predicates
     /* 410905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410911 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 410914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410927 */     GIR_RootConstrainSelectedInstOperands,
     /* 410928 */     // GIR_Coverage, 6092,
     /* 410928 */     GIR_EraseRootFromParent_Done,
     /* 410929 */   // Label 7956: @410929
     /* 410929 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(411022), // Rule ID 6246 //
     /* 410934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410973 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410992 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 410995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411020 */     GIR_RootConstrainSelectedInstOperands,
     /* 411021 */     // GIR_Coverage, 6246,
     /* 411021 */     GIR_EraseRootFromParent_Done,
     /* 411022 */   // Label 7957: @411022
     /* 411022 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(411121), // Rule ID 6158 //
     /* 411027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411070 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 411113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411119 */     GIR_RootConstrainSelectedInstOperands,
     /* 411120 */     // GIR_Coverage, 6158,
     /* 411120 */     GIR_EraseRootFromParent_Done,
     /* 411121 */   // Label 7958: @411121
     /* 411121 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(411217), // Rule ID 6190 //
     /* 411126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411168 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411215 */     GIR_RootConstrainSelectedInstOperands,
     /* 411216 */     // GIR_Coverage, 6190,
     /* 411216 */     GIR_EraseRootFromParent_Done,
     /* 411217 */   // Label 7959: @411217
     /* 411217 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(411316), // Rule ID 6222 //
     /* 411222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411265 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411314 */     GIR_RootConstrainSelectedInstOperands,
     /* 411315 */     // GIR_Coverage, 6222,
     /* 411315 */     GIR_EraseRootFromParent_Done,
     /* 411316 */   // Label 7960: @411316
     /* 411316 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(411409), // Rule ID 6268 //
     /* 411321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411360 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411407 */     GIR_RootConstrainSelectedInstOperands,
     /* 411408 */     // GIR_Coverage, 6268,
     /* 411408 */     GIR_EraseRootFromParent_Done,
     /* 411409 */   // Label 7961: @411409
     /* 411409 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(411505), // Rule ID 6126 //
     /* 411414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411456 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411503 */     GIR_RootConstrainSelectedInstOperands,
     /* 411504 */     // GIR_Coverage, 6126,
     /* 411504 */     GIR_EraseRootFromParent_Done,
     /* 411505 */   // Label 7962: @411505
     /* 411505 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(411589), // Rule ID 2542 //
     /* 411510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411540 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411587 */     GIR_RootConstrainSelectedInstOperands,
     /* 411588 */     // GIR_Coverage, 2542,
     /* 411588 */     GIR_EraseRootFromParent_Done,
     /* 411589 */   // Label 7963: @411589
     /* 411589 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411639), // Rule ID 13411 //
     /* 411594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411624 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 411627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411637 */     GIR_RootConstrainSelectedInstOperands,
     /* 411638 */     // GIR_Coverage, 13411,
     /* 411638 */     GIR_EraseRootFromParent_Done,
     /* 411639 */   // Label 7964: @411639
     /* 411639 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411723), // Rule ID 6094 //
     /* 411644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411674 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411721 */     GIR_RootConstrainSelectedInstOperands,
     /* 411722 */     // GIR_Coverage, 6094,
     /* 411722 */     GIR_EraseRootFromParent_Done,
     /* 411723 */   // Label 7965: @411723
     /* 411723 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411773), // Rule ID 1311 //
     /* 411728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411758 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 411761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411771 */     GIR_RootConstrainSelectedInstOperands,
     /* 411772 */     // GIR_Coverage, 1311,
     /* 411772 */     GIR_EraseRootFromParent_Done,
     /* 411773 */   // Label 7966: @411773
     /* 411773 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411806), // Rule ID 1301 //
     /* 411778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411793 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 411796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 411804 */     GIR_RootConstrainSelectedInstOperands,
     /* 411805 */     // GIR_Coverage, 1301,
     /* 411805 */     GIR_EraseRootFromParent_Done,
     /* 411806 */   // Label 7967: @411806
     /* 411806 */   GIM_Reject,
     /* 411807 */ // Label 7948: @411807
     /* 411807 */ GIM_Reject,
     /* 411808 */ // Label 7833: @411808
     /* 411808 */ GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(412986),
     /* 411813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 411822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411826 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411910), // Rule ID 6140 //
     /* 411831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 411842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 411855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 411867 */     // MIs[2] Operand 1
     /* 411867 */     // No operand predicates
     /* 411867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411879 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411890 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 411890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 411893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411908 */     GIR_RootConstrainSelectedInstOperands,
     /* 411909 */     // GIR_Coverage, 6140,
     /* 411909 */     GIR_EraseRootFromParent_Done,
     /* 411910 */   // Label 7969: @411910
     /* 411910 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411991), // Rule ID 6172 //
     /* 411915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 411938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 411951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 411963 */     // MIs[3] Operand 1
     /* 411963 */     // No operand predicates
     /* 411963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411973 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 411973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 411976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411989 */     GIR_RootConstrainSelectedInstOperands,
     /* 411990 */     // GIR_Coverage, 6172,
     /* 411990 */     GIR_EraseRootFromParent_Done,
     /* 411991 */   // Label 7970: @411991
     /* 411991 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(412075), // Rule ID 6204 //
     /* 411996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 411999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412049 */     // MIs[3] Operand 1
     /* 412049 */     // No operand predicates
     /* 412049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412055 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412073 */     GIR_RootConstrainSelectedInstOperands,
     /* 412074 */     // GIR_Coverage, 6204,
     /* 412074 */     GIR_EraseRootFromParent_Done,
     /* 412075 */   // Label 7971: @412075
     /* 412075 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(412156), // Rule ID 6108 //
     /* 412080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412128 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412132 */     // MIs[3] Operand 1
     /* 412132 */     // No operand predicates
     /* 412132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412138 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412154 */     GIR_RootConstrainSelectedInstOperands,
     /* 412155 */     // GIR_Coverage, 6108,
     /* 412155 */     GIR_EraseRootFromParent_Done,
     /* 412156 */   // Label 7972: @412156
     /* 412156 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(412225), // Rule ID 2524 //
     /* 412161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412197 */     // MIs[2] Operand 1
     /* 412197 */     // No operand predicates
     /* 412197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412207 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412223 */     GIR_RootConstrainSelectedInstOperands,
     /* 412224 */     // GIR_Coverage, 2524,
     /* 412224 */     GIR_EraseRootFromParent_Done,
     /* 412225 */   // Label 7973: @412225
     /* 412225 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(412294), // Rule ID 6076 //
     /* 412230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412270 */     // MIs[2] Operand 1
     /* 412270 */     // No operand predicates
     /* 412270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412276 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412292 */     GIR_RootConstrainSelectedInstOperands,
     /* 412293 */     // GIR_Coverage, 6076,
     /* 412293 */     GIR_EraseRootFromParent_Done,
     /* 412294 */   // Label 7974: @412294
     /* 412294 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(412393), // Rule ID 6142 //
     /* 412299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412342 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412391 */     GIR_RootConstrainSelectedInstOperands,
     /* 412392 */     // GIR_Coverage, 6142,
     /* 412392 */     GIR_EraseRootFromParent_Done,
     /* 412393 */   // Label 7975: @412393
     /* 412393 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(412489), // Rule ID 6174 //
     /* 412398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412440 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412487 */     GIR_RootConstrainSelectedInstOperands,
     /* 412488 */     // GIR_Coverage, 6174,
     /* 412488 */     GIR_EraseRootFromParent_Done,
     /* 412489 */   // Label 7976: @412489
     /* 412489 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(412588), // Rule ID 6206 //
     /* 412494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412537 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412586 */     GIR_RootConstrainSelectedInstOperands,
     /* 412587 */     // GIR_Coverage, 6206,
     /* 412587 */     GIR_EraseRootFromParent_Done,
     /* 412588 */   // Label 7977: @412588
     /* 412588 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412684), // Rule ID 6110 //
     /* 412593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412635 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412682 */     GIR_RootConstrainSelectedInstOperands,
     /* 412683 */     // GIR_Coverage, 6110,
     /* 412683 */     GIR_EraseRootFromParent_Done,
     /* 412684 */   // Label 7978: @412684
     /* 412684 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412768), // Rule ID 2526 //
     /* 412689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412719 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412766 */     GIR_RootConstrainSelectedInstOperands,
     /* 412767 */     // GIR_Coverage, 2526,
     /* 412767 */     GIR_EraseRootFromParent_Done,
     /* 412768 */   // Label 7979: @412768
     /* 412768 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412818), // Rule ID 13403 //
     /* 412773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412803 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 412806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412816 */     GIR_RootConstrainSelectedInstOperands,
     /* 412817 */     // GIR_Coverage, 13403,
     /* 412817 */     GIR_EraseRootFromParent_Done,
     /* 412818 */   // Label 7980: @412818
     /* 412818 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412902), // Rule ID 6078 //
     /* 412823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412853 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 412856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412872 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 412875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 412885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 412888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412900 */     GIR_RootConstrainSelectedInstOperands,
     /* 412901 */     // GIR_Coverage, 6078,
     /* 412901 */     GIR_EraseRootFromParent_Done,
     /* 412902 */   // Label 7981: @412902
     /* 412902 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(412952), // Rule ID 1303 //
     /* 412907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412937 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 412940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412950 */     GIR_RootConstrainSelectedInstOperands,
     /* 412951 */     // GIR_Coverage, 1303,
     /* 412951 */     GIR_EraseRootFromParent_Done,
     /* 412952 */   // Label 7982: @412952
     /* 412952 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412985), // Rule ID 1293 //
     /* 412957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412972 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 412975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 412983 */     GIR_RootConstrainSelectedInstOperands,
     /* 412984 */     // GIR_Coverage, 1293,
     /* 412984 */     GIR_EraseRootFromParent_Done,
     /* 412985 */   // Label 7983: @412985
     /* 412985 */   GIM_Reject,
     /* 412986 */ // Label 7968: @412986
     /* 412986 */ GIM_Reject,
     /* 412987 */ // Label 7834: @412987
     /* 412987 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(414507),
     /* 412992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 412998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 413001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413005 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(413083), // Rule ID 6238 //
     /* 413010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413051 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413055 */     // MIs[3] Operand 1
     /* 413055 */     // No operand predicates
     /* 413055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413065 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413081 */     GIR_RootConstrainSelectedInstOperands,
     /* 413082 */     // GIR_Coverage, 6238,
     /* 413082 */     GIR_EraseRootFromParent_Done,
     /* 413083 */   // Label 7985: @413083
     /* 413083 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(413167), // Rule ID 6152 //
     /* 413088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413120 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413124 */     // MIs[2] Operand 1
     /* 413124 */     // No operand predicates
     /* 413124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413147 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413165 */     GIR_RootConstrainSelectedInstOperands,
     /* 413166 */     // GIR_Coverage, 6152,
     /* 413166 */     GIR_EraseRootFromParent_Done,
     /* 413167 */   // Label 7986: @413167
     /* 413167 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(413248), // Rule ID 6184 //
     /* 413172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413216 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413220 */     // MIs[3] Operand 1
     /* 413220 */     // No operand predicates
     /* 413220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413230 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413246 */     GIR_RootConstrainSelectedInstOperands,
     /* 413247 */     // GIR_Coverage, 6184,
     /* 413247 */     GIR_EraseRootFromParent_Done,
     /* 413248 */   // Label 7987: @413248
     /* 413248 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(413332), // Rule ID 6216 //
     /* 413253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413302 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413306 */     // MIs[3] Operand 1
     /* 413306 */     // No operand predicates
     /* 413306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413312 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413330 */     GIR_RootConstrainSelectedInstOperands,
     /* 413331 */     // GIR_Coverage, 6216,
     /* 413331 */     GIR_EraseRootFromParent_Done,
     /* 413332 */   // Label 7988: @413332
     /* 413332 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(413410), // Rule ID 6260 //
     /* 413337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413386 */     // MIs[3] Operand 1
     /* 413386 */     // No operand predicates
     /* 413386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413392 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413408 */     GIR_RootConstrainSelectedInstOperands,
     /* 413409 */     // GIR_Coverage, 6260,
     /* 413409 */     GIR_EraseRootFromParent_Done,
     /* 413410 */   // Label 7989: @413410
     /* 413410 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413491), // Rule ID 6120 //
     /* 413415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413463 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413467 */     // MIs[3] Operand 1
     /* 413467 */     // No operand predicates
     /* 413467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413473 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413489 */     GIR_RootConstrainSelectedInstOperands,
     /* 413490 */     // GIR_Coverage, 6120,
     /* 413490 */     GIR_EraseRootFromParent_Done,
     /* 413491 */   // Label 7990: @413491
     /* 413491 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413560), // Rule ID 2536 //
     /* 413496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413532 */     // MIs[2] Operand 1
     /* 413532 */     // No operand predicates
     /* 413532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413542 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 413545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413558 */     GIR_RootConstrainSelectedInstOperands,
     /* 413559 */     // GIR_Coverage, 2536,
     /* 413559 */     GIR_EraseRootFromParent_Done,
     /* 413560 */   // Label 7991: @413560
     /* 413560 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413629), // Rule ID 6088 //
     /* 413565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413605 */     // MIs[2] Operand 1
     /* 413605 */     // No operand predicates
     /* 413605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413611 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 413614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413627 */     GIR_RootConstrainSelectedInstOperands,
     /* 413628 */     // GIR_Coverage, 6088,
     /* 413628 */     GIR_EraseRootFromParent_Done,
     /* 413629 */   // Label 7992: @413629
     /* 413629 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413722), // Rule ID 6242 //
     /* 413634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413673 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413720 */     GIR_RootConstrainSelectedInstOperands,
     /* 413721 */     // GIR_Coverage, 6242,
     /* 413721 */     GIR_EraseRootFromParent_Done,
     /* 413722 */   // Label 7993: @413722
     /* 413722 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413821), // Rule ID 6154 //
     /* 413727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 413742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413770 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413819 */     GIR_RootConstrainSelectedInstOperands,
     /* 413820 */     // GIR_Coverage, 6154,
     /* 413820 */     GIR_EraseRootFromParent_Done,
     /* 413821 */   // Label 7994: @413821
     /* 413821 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413917), // Rule ID 6186 //
     /* 413826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413868 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413915 */     GIR_RootConstrainSelectedInstOperands,
     /* 413916 */     // GIR_Coverage, 6186,
     /* 413916 */     GIR_EraseRootFromParent_Done,
     /* 413917 */   // Label 7995: @413917
     /* 413917 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(414016), // Rule ID 6218 //
     /* 413922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 413954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413965 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 413987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 413997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414014 */     GIR_RootConstrainSelectedInstOperands,
     /* 414015 */     // GIR_Coverage, 6218,
     /* 414015 */     GIR_EraseRootFromParent_Done,
     /* 414016 */   // Label 7996: @414016
     /* 414016 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(414109), // Rule ID 6264 //
     /* 414021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414060 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414107 */     GIR_RootConstrainSelectedInstOperands,
     /* 414108 */     // GIR_Coverage, 6264,
     /* 414108 */     GIR_EraseRootFromParent_Done,
     /* 414109 */   // Label 7997: @414109
     /* 414109 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(414205), // Rule ID 6122 //
     /* 414114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414156 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414203 */     GIR_RootConstrainSelectedInstOperands,
     /* 414204 */     // GIR_Coverage, 6122,
     /* 414204 */     GIR_EraseRootFromParent_Done,
     /* 414205 */   // Label 7998: @414205
     /* 414205 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(414289), // Rule ID 2538 //
     /* 414210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414240 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414287 */     GIR_RootConstrainSelectedInstOperands,
     /* 414288 */     // GIR_Coverage, 2538,
     /* 414288 */     GIR_EraseRootFromParent_Done,
     /* 414289 */   // Label 7999: @414289
     /* 414289 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(414339), // Rule ID 13409 //
     /* 414294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414324 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 414327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414337 */     GIR_RootConstrainSelectedInstOperands,
     /* 414338 */     // GIR_Coverage, 13409,
     /* 414338 */     GIR_EraseRootFromParent_Done,
     /* 414339 */   // Label 8000: @414339
     /* 414339 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(414423), // Rule ID 6090 //
     /* 414344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414374 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414386 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414421 */     GIR_RootConstrainSelectedInstOperands,
     /* 414422 */     // GIR_Coverage, 6090,
     /* 414422 */     GIR_EraseRootFromParent_Done,
     /* 414423 */   // Label 8001: @414423
     /* 414423 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414473), // Rule ID 1309 //
     /* 414428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414458 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 414461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414471 */     GIR_RootConstrainSelectedInstOperands,
     /* 414472 */     // GIR_Coverage, 1309,
     /* 414472 */     GIR_EraseRootFromParent_Done,
     /* 414473 */   // Label 8002: @414473
     /* 414473 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(414506), // Rule ID 1299 //
     /* 414478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414493 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 414496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414504 */     GIR_RootConstrainSelectedInstOperands,
     /* 414505 */     // GIR_Coverage, 1299,
     /* 414505 */     GIR_EraseRootFromParent_Done,
     /* 414506 */   // Label 8003: @414506
     /* 414506 */   GIM_Reject,
     /* 414507 */ // Label 7984: @414507
     /* 414507 */ GIM_Reject,
     /* 414508 */ // Label 7835: @414508
     /* 414508 */ GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(415686),
     /* 414513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 414519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 414522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414526 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(414610), // Rule ID 6136 //
     /* 414531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414567 */     // MIs[2] Operand 1
     /* 414567 */     // No operand predicates
     /* 414567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414590 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414608 */     GIR_RootConstrainSelectedInstOperands,
     /* 414609 */     // GIR_Coverage, 6136,
     /* 414609 */     GIR_EraseRootFromParent_Done,
     /* 414610 */   // Label 8005: @414610
     /* 414610 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414691), // Rule ID 6168 //
     /* 414615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414659 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414663 */     // MIs[3] Operand 1
     /* 414663 */     // No operand predicates
     /* 414663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414673 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414689 */     GIR_RootConstrainSelectedInstOperands,
     /* 414690 */     // GIR_Coverage, 6168,
     /* 414690 */     GIR_EraseRootFromParent_Done,
     /* 414691 */   // Label 8006: @414691
     /* 414691 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414775), // Rule ID 6200 //
     /* 414696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414745 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414749 */     // MIs[3] Operand 1
     /* 414749 */     // No operand predicates
     /* 414749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414755 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414773 */     GIR_RootConstrainSelectedInstOperands,
     /* 414774 */     // GIR_Coverage, 6200,
     /* 414774 */     GIR_EraseRootFromParent_Done,
     /* 414775 */   // Label 8007: @414775
     /* 414775 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(414856), // Rule ID 6104 //
     /* 414780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414832 */     // MIs[3] Operand 1
     /* 414832 */     // No operand predicates
     /* 414832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414838 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 414841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414854 */     GIR_RootConstrainSelectedInstOperands,
     /* 414855 */     // GIR_Coverage, 6104,
     /* 414855 */     GIR_EraseRootFromParent_Done,
     /* 414856 */   // Label 8008: @414856
     /* 414856 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414925), // Rule ID 2520 //
     /* 414861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414897 */     // MIs[2] Operand 1
     /* 414897 */     // No operand predicates
     /* 414897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414907 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 414910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414923 */     GIR_RootConstrainSelectedInstOperands,
     /* 414924 */     // GIR_Coverage, 2520,
     /* 414924 */     GIR_EraseRootFromParent_Done,
     /* 414925 */   // Label 8009: @414925
     /* 414925 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414994), // Rule ID 6072 //
     /* 414930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414966 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414970 */     // MIs[2] Operand 1
     /* 414970 */     // No operand predicates
     /* 414970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414976 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 414979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414992 */     GIR_RootConstrainSelectedInstOperands,
     /* 414993 */     // GIR_Coverage, 6072,
     /* 414993 */     GIR_EraseRootFromParent_Done,
     /* 414994 */   // Label 8010: @414994
     /* 414994 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(415093), // Rule ID 6138 //
     /* 414999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415042 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415091 */     GIR_RootConstrainSelectedInstOperands,
     /* 415092 */     // GIR_Coverage, 6138,
     /* 415092 */     GIR_EraseRootFromParent_Done,
     /* 415093 */   // Label 8011: @415093
     /* 415093 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(415189), // Rule ID 6170 //
     /* 415098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415140 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415187 */     GIR_RootConstrainSelectedInstOperands,
     /* 415188 */     // GIR_Coverage, 6170,
     /* 415188 */     GIR_EraseRootFromParent_Done,
     /* 415189 */   // Label 8012: @415189
     /* 415189 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(415288), // Rule ID 6202 //
     /* 415194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415237 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415286 */     GIR_RootConstrainSelectedInstOperands,
     /* 415287 */     // GIR_Coverage, 6202,
     /* 415287 */     GIR_EraseRootFromParent_Done,
     /* 415288 */   // Label 8013: @415288
     /* 415288 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(415384), // Rule ID 6106 //
     /* 415293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415335 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415382 */     GIR_RootConstrainSelectedInstOperands,
     /* 415383 */     // GIR_Coverage, 6106,
     /* 415383 */     GIR_EraseRootFromParent_Done,
     /* 415384 */   // Label 8014: @415384
     /* 415384 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(415468), // Rule ID 2522 //
     /* 415389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415419 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415466 */     GIR_RootConstrainSelectedInstOperands,
     /* 415467 */     // GIR_Coverage, 2522,
     /* 415467 */     GIR_EraseRootFromParent_Done,
     /* 415468 */   // Label 8015: @415468
     /* 415468 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415518), // Rule ID 13405 //
     /* 415473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415503 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 415506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415516 */     GIR_RootConstrainSelectedInstOperands,
     /* 415517 */     // GIR_Coverage, 13405,
     /* 415517 */     GIR_EraseRootFromParent_Done,
     /* 415518 */   // Label 8016: @415518
     /* 415518 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415602), // Rule ID 6074 //
     /* 415523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415553 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415572 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415600 */     GIR_RootConstrainSelectedInstOperands,
     /* 415601 */     // GIR_Coverage, 6074,
     /* 415601 */     GIR_EraseRootFromParent_Done,
     /* 415602 */   // Label 8017: @415602
     /* 415602 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(415652), // Rule ID 1305 //
     /* 415607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415637 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 415640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415650 */     GIR_RootConstrainSelectedInstOperands,
     /* 415651 */     // GIR_Coverage, 1305,
     /* 415651 */     GIR_EraseRootFromParent_Done,
     /* 415652 */   // Label 8018: @415652
     /* 415652 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415685), // Rule ID 1295 //
     /* 415657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415672 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 415672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 415675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 415683 */     GIR_RootConstrainSelectedInstOperands,
     /* 415684 */     // GIR_Coverage, 1295,
     /* 415684 */     GIR_EraseRootFromParent_Done,
     /* 415685 */   // Label 8019: @415685
     /* 415685 */   GIM_Reject,
     /* 415686 */ // Label 8004: @415686
     /* 415686 */ GIM_Reject,
     /* 415687 */ // Label 7836: @415687
     /* 415687 */ GIM_Reject,
     /* 415688 */ // Label 108: @415688
     /* 415688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8028*/ GIMT_Encode4(415987),
     /* 415699 */ /*GILLT_s16*//*Label 8020*/ GIMT_Encode4(415739),
     /* 415703 */ /*GILLT_s32*//*Label 8021*/ GIMT_Encode4(415770),
     /* 415707 */ /*GILLT_s64*//*Label 8022*/ GIMT_Encode4(415801), GIMT_Encode4(0),
     /* 415715 */ /*GILLT_v2s32*//*Label 8023*/ GIMT_Encode4(415832),
     /* 415719 */ /*GILLT_v2s64*//*Label 8024*/ GIMT_Encode4(415863),
     /* 415723 */ /*GILLT_v4s16*//*Label 8025*/ GIMT_Encode4(415894),
     /* 415727 */ /*GILLT_v4s32*//*Label 8026*/ GIMT_Encode4(415925), GIMT_Encode4(0),
     /* 415735 */ /*GILLT_v8s16*//*Label 8027*/ GIMT_Encode4(415956),
     /* 415739 */ // Label 8020: @415739
     /* 415739 */ GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(415769), // Rule ID 569 //
     /* 415744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 415747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 415750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 415754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 415758 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 415758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 415763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415767 */   GIR_RootConstrainSelectedInstOperands,
     /* 415768 */   // GIR_Coverage, 569,
     /* 415768 */   GIR_Done,
     /* 415769 */ // Label 8029: @415769
     /* 415769 */ GIM_Reject,
     /* 415770 */ // Label 8021: @415770
     /* 415770 */ GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(415800), // Rule ID 571 //
     /* 415775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 415778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 415781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415789 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 415789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 415794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415798 */   GIR_RootConstrainSelectedInstOperands,
     /* 415799 */   // GIR_Coverage, 571,
     /* 415799 */   GIR_Done,
     /* 415800 */ // Label 8030: @415800
     /* 415800 */ GIM_Reject,
     /* 415801 */ // Label 8022: @415801
     /* 415801 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(415831), // Rule ID 573 //
     /* 415806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 415809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 415812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415820 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 415820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 415825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415829 */   GIR_RootConstrainSelectedInstOperands,
     /* 415830 */   // GIR_Coverage, 573,
     /* 415830 */   GIR_Done,
     /* 415831 */ // Label 8031: @415831
     /* 415831 */ GIM_Reject,
     /* 415832 */ // Label 8023: @415832
     /* 415832 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(415862), // Rule ID 959 //
     /* 415837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415851 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 415851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 415856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415860 */   GIR_RootConstrainSelectedInstOperands,
     /* 415861 */   // GIR_Coverage, 959,
     /* 415861 */   GIR_Done,
     /* 415862 */ // Label 8032: @415862
     /* 415862 */ GIM_Reject,
     /* 415863 */ // Label 8024: @415863
     /* 415863 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(415893), // Rule ID 963 //
     /* 415868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 415874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415882 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 415882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 415887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415891 */   GIR_RootConstrainSelectedInstOperands,
     /* 415892 */   // GIR_Coverage, 963,
     /* 415892 */   GIR_Done,
     /* 415893 */ // Label 8033: @415893
     /* 415893 */ GIM_Reject,
     /* 415894 */ // Label 8025: @415894
     /* 415894 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(415924), // Rule ID 955 //
     /* 415899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415913 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 415913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 415918 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415922 */   GIR_RootConstrainSelectedInstOperands,
     /* 415923 */   // GIR_Coverage, 955,
     /* 415923 */   GIR_Done,
     /* 415924 */ // Label 8034: @415924
     /* 415924 */ GIM_Reject,
     /* 415925 */ // Label 8026: @415925
     /* 415925 */ GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(415955), // Rule ID 961 //
     /* 415930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415944 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 415944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 415949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415953 */   GIR_RootConstrainSelectedInstOperands,
     /* 415954 */   // GIR_Coverage, 961,
     /* 415954 */   GIR_Done,
     /* 415955 */ // Label 8035: @415955
     /* 415955 */ GIM_Reject,
     /* 415956 */ // Label 8027: @415956
     /* 415956 */ GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(415986), // Rule ID 957 //
     /* 415961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415975 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 415975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 415980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 415984 */   GIR_RootConstrainSelectedInstOperands,
     /* 415985 */   // GIR_Coverage, 957,
     /* 415985 */   GIR_Done,
     /* 415986 */ // Label 8036: @415986
     /* 415986 */ GIM_Reject,
     /* 415987 */ // Label 8028: @415987
     /* 415987 */ GIM_Reject,
     /* 415988 */ // Label 109: @415988
     /* 415988 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(416001), // Rule ID 6553 //
     /* 415993 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 415993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 415996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 415999 */   GIR_RootConstrainSelectedInstOperands,
     /* 416000 */   // GIR_Coverage, 6553,
     /* 416000 */   GIR_EraseRootFromParent_Done,
     /* 416001 */ // Label 8037: @416001
     /* 416001 */ GIM_Reject,
     /* 416002 */ // Label 110: @416002
     /* 416002 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(416022), // Rule ID 6554 //
     /* 416007 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 416007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416010 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 416020 */   GIR_RootConstrainSelectedInstOperands,
     /* 416021 */   // GIR_Coverage, 6554,
     /* 416021 */   GIR_EraseRootFromParent_Done,
     /* 416022 */ // Label 8038: @416022
     /* 416022 */ GIM_Reject,
     /* 416023 */ // Label 111: @416023
     /* 416023 */ GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(416047), // Rule ID 6555 //
     /* 416028 */   // MIs[0] kind
     /* 416028 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 416031 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 416036 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 416036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416039 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 416045 */   GIR_RootConstrainSelectedInstOperands,
     /* 416046 */   // GIR_Coverage, 6555,
     /* 416046 */   GIR_EraseRootFromParent_Done,
     /* 416047 */ // Label 8039: @416047
     /* 416047 */ GIM_Reject,
     /* 416048 */ // Label 112: @416048
     /* 416048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8043*/ GIMT_Encode4(416357),
     /* 416059 */ /*GILLT_s16*//*Label 8040*/ GIMT_Encode4(416071),
     /* 416063 */ /*GILLT_s32*//*Label 8041*/ GIMT_Encode4(416224),
     /* 416067 */ /*GILLT_s64*//*Label 8042*/ GIMT_Encode4(416329),
     /* 416071 */ // Label 8040: @416071
     /* 416071 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(416172), // Rule ID 5618 //
     /* 416076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416090 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 416090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 416093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416102 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416106 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 416112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 416119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416124 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 416127 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416145 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416157 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416170 */   GIR_RootConstrainSelectedInstOperands,
     /* 416171 */   // GIR_Coverage, 5618,
     /* 416171 */   GIR_EraseRootFromParent_Done,
     /* 416172 */ // Label 8044: @416172
     /* 416172 */ GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(416223), // Rule ID 5619 //
     /* 416177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416191 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 416191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 416198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 416213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 416216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416221 */   GIR_RootConstrainSelectedInstOperands,
     /* 416222 */   // GIR_Coverage, 5619,
     /* 416222 */   GIR_EraseRootFromParent_Done,
     /* 416223 */ // Label 8045: @416223
     /* 416223 */ GIM_Reject,
     /* 416224 */ // Label 8041: @416224
     /* 416224 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(416301), // Rule ID 5620 //
     /* 416229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416240 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 416240 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 416243 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 416247 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416252 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416256 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 416260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 416262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 416265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 416269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416274 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 416281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 416294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 416296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416299 */   GIR_RootConstrainSelectedInstOperands,
     /* 416300 */   // GIR_Coverage, 5620,
     /* 416300 */   GIR_EraseRootFromParent_Done,
     /* 416301 */ // Label 8046: @416301
     /* 416301 */ GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(416328), // Rule ID 5621 //
     /* 416306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416317 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 416322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416326 */   GIR_RootConstrainSelectedInstOperands,
     /* 416327 */   // GIR_Coverage, 5621,
     /* 416327 */   GIR_Done,
     /* 416328 */ // Label 8047: @416328
     /* 416328 */ GIM_Reject,
     /* 416329 */ // Label 8042: @416329
     /* 416329 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(416356), // Rule ID 5622 //
     /* 416334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416345 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 416350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416354 */   GIR_RootConstrainSelectedInstOperands,
     /* 416355 */   // GIR_Coverage, 5622,
     /* 416355 */   GIR_Done,
     /* 416356 */ // Label 8048: @416356
     /* 416356 */ GIM_Reject,
     /* 416357 */ // Label 8043: @416357
     /* 416357 */ GIM_Reject,
     /* 416358 */ // Label 113: @416358
     /* 416358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8052*/ GIMT_Encode4(416528),
     /* 416369 */ /*GILLT_s16*//*Label 8049*/ GIMT_Encode4(416381),
     /* 416373 */ /*GILLT_s32*//*Label 8050*/ GIMT_Encode4(416442),
     /* 416377 */ /*GILLT_s64*//*Label 8051*/ GIMT_Encode4(416500),
     /* 416381 */ // Label 8049: @416381
     /* 416381 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(416411), // Rule ID 1942 //
     /* 416386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416400 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 416405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416409 */   GIR_RootConstrainSelectedInstOperands,
     /* 416410 */   // GIR_Coverage, 1942,
     /* 416410 */   GIR_Done,
     /* 416411 */ // Label 8053: @416411
     /* 416411 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(416441), // Rule ID 1944 //
     /* 416416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416430 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 416435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416439 */   GIR_RootConstrainSelectedInstOperands,
     /* 416440 */   // GIR_Coverage, 1944,
     /* 416440 */   GIR_Done,
     /* 416441 */ // Label 8054: @416441
     /* 416441 */ GIM_Reject,
     /* 416442 */ // Label 8050: @416442
     /* 416442 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(416472), // Rule ID 1946 //
     /* 416447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416461 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 416466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416470 */   GIR_RootConstrainSelectedInstOperands,
     /* 416471 */   // GIR_Coverage, 1946,
     /* 416471 */   GIR_Done,
     /* 416472 */ // Label 8055: @416472
     /* 416472 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(416499), // Rule ID 5628 //
     /* 416477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416488 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 416493 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416497 */   GIR_RootConstrainSelectedInstOperands,
     /* 416498 */   // GIR_Coverage, 5628,
     /* 416498 */   GIR_Done,
     /* 416499 */ // Label 8056: @416499
     /* 416499 */ GIM_Reject,
     /* 416500 */ // Label 8051: @416500
     /* 416500 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(416527), // Rule ID 5630 //
     /* 416505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416516 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 416521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416525 */   GIR_RootConstrainSelectedInstOperands,
     /* 416526 */   // GIR_Coverage, 5630,
     /* 416526 */   GIR_Done,
     /* 416527 */ // Label 8057: @416527
     /* 416527 */ GIM_Reject,
     /* 416528 */ // Label 8052: @416528
     /* 416528 */ GIM_Reject,
     /* 416529 */ // Label 114: @416529
     /* 416529 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8061*/ GIMT_Encode4(416699),
     /* 416540 */ /*GILLT_s16*//*Label 8058*/ GIMT_Encode4(416552),
     /* 416544 */ /*GILLT_s32*//*Label 8059*/ GIMT_Encode4(416613),
     /* 416548 */ /*GILLT_s64*//*Label 8060*/ GIMT_Encode4(416671),
     /* 416552 */ // Label 8058: @416552
     /* 416552 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(416582), // Rule ID 1954 //
     /* 416557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416571 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 416576 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416580 */   GIR_RootConstrainSelectedInstOperands,
     /* 416581 */   // GIR_Coverage, 1954,
     /* 416581 */   GIR_Done,
     /* 416582 */ // Label 8062: @416582
     /* 416582 */ GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(416612), // Rule ID 1956 //
     /* 416587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416601 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 416606 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416610 */   GIR_RootConstrainSelectedInstOperands,
     /* 416611 */   // GIR_Coverage, 1956,
     /* 416611 */   GIR_Done,
     /* 416612 */ // Label 8063: @416612
     /* 416612 */ GIM_Reject,
     /* 416613 */ // Label 8059: @416613
     /* 416613 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(416643), // Rule ID 1958 //
     /* 416618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416632 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 416637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416641 */   GIR_RootConstrainSelectedInstOperands,
     /* 416642 */   // GIR_Coverage, 1958,
     /* 416642 */   GIR_Done,
     /* 416643 */ // Label 8064: @416643
     /* 416643 */ GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(416670), // Rule ID 5636 //
     /* 416648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416659 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 416664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416668 */   GIR_RootConstrainSelectedInstOperands,
     /* 416669 */   // GIR_Coverage, 5636,
     /* 416669 */   GIR_Done,
     /* 416670 */ // Label 8065: @416670
     /* 416670 */ GIM_Reject,
     /* 416671 */ // Label 8060: @416671
     /* 416671 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(416698), // Rule ID 5638 //
     /* 416676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416687 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 416692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416696 */   GIR_RootConstrainSelectedInstOperands,
     /* 416697 */   // GIR_Coverage, 5638,
     /* 416697 */   GIR_Done,
     /* 416698 */ // Label 8066: @416698
     /* 416698 */ GIM_Reject,
     /* 416699 */ // Label 8061: @416699
     /* 416699 */ GIM_Reject,
     /* 416700 */ // Label 115: @416700
     /* 416700 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8070*/ GIMT_Encode4(416870),
     /* 416711 */ /*GILLT_s16*//*Label 8067*/ GIMT_Encode4(416723),
     /* 416715 */ /*GILLT_s32*//*Label 8068*/ GIMT_Encode4(416784),
     /* 416719 */ /*GILLT_s64*//*Label 8069*/ GIMT_Encode4(416842),
     /* 416723 */ // Label 8067: @416723
     /* 416723 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(416753), // Rule ID 1948 //
     /* 416728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416742 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 416747 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416751 */   GIR_RootConstrainSelectedInstOperands,
     /* 416752 */   // GIR_Coverage, 1948,
     /* 416752 */   GIR_Done,
     /* 416753 */ // Label 8071: @416753
     /* 416753 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(416783), // Rule ID 1950 //
     /* 416758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416772 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 416777 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416781 */   GIR_RootConstrainSelectedInstOperands,
     /* 416782 */   // GIR_Coverage, 1950,
     /* 416782 */   GIR_Done,
     /* 416783 */ // Label 8072: @416783
     /* 416783 */ GIM_Reject,
     /* 416784 */ // Label 8068: @416784
     /* 416784 */ GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(416814), // Rule ID 1952 //
     /* 416789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416803 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 416808 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416812 */   GIR_RootConstrainSelectedInstOperands,
     /* 416813 */   // GIR_Coverage, 1952,
     /* 416813 */   GIR_Done,
     /* 416814 */ // Label 8073: @416814
     /* 416814 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(416841), // Rule ID 5632 //
     /* 416819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416830 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 416835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416839 */   GIR_RootConstrainSelectedInstOperands,
     /* 416840 */   // GIR_Coverage, 5632,
     /* 416840 */   GIR_Done,
     /* 416841 */ // Label 8074: @416841
     /* 416841 */ GIM_Reject,
     /* 416842 */ // Label 8069: @416842
     /* 416842 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(416869), // Rule ID 5634 //
     /* 416847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416858 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 416863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416867 */   GIR_RootConstrainSelectedInstOperands,
     /* 416868 */   // GIR_Coverage, 5634,
     /* 416868 */   GIR_Done,
     /* 416869 */ // Label 8075: @416869
     /* 416869 */ GIM_Reject,
     /* 416870 */ // Label 8070: @416870
     /* 416870 */ GIM_Reject,
     /* 416871 */ // Label 116: @416871
     /* 416871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8079*/ GIMT_Encode4(417041),
     /* 416882 */ /*GILLT_s16*//*Label 8076*/ GIMT_Encode4(416894),
     /* 416886 */ /*GILLT_s32*//*Label 8077*/ GIMT_Encode4(416955),
     /* 416890 */ /*GILLT_s64*//*Label 8078*/ GIMT_Encode4(417013),
     /* 416894 */ // Label 8076: @416894
     /* 416894 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(416924), // Rule ID 1960 //
     /* 416899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416913 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 416918 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416922 */   GIR_RootConstrainSelectedInstOperands,
     /* 416923 */   // GIR_Coverage, 1960,
     /* 416923 */   GIR_Done,
     /* 416924 */ // Label 8080: @416924
     /* 416924 */ GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(416954), // Rule ID 1962 //
     /* 416929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416943 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 416948 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416952 */   GIR_RootConstrainSelectedInstOperands,
     /* 416953 */   // GIR_Coverage, 1962,
     /* 416953 */   GIR_Done,
     /* 416954 */ // Label 8081: @416954
     /* 416954 */ GIM_Reject,
     /* 416955 */ // Label 8077: @416955
     /* 416955 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(416985), // Rule ID 1964 //
     /* 416960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416974 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 416979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416983 */   GIR_RootConstrainSelectedInstOperands,
     /* 416984 */   // GIR_Coverage, 1964,
     /* 416984 */   GIR_Done,
     /* 416985 */ // Label 8082: @416985
     /* 416985 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(417012), // Rule ID 5640 //
     /* 416990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417001 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 417006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417010 */   GIR_RootConstrainSelectedInstOperands,
     /* 417011 */   // GIR_Coverage, 5640,
     /* 417011 */   GIR_Done,
     /* 417012 */ // Label 8083: @417012
     /* 417012 */ GIM_Reject,
     /* 417013 */ // Label 8078: @417013
     /* 417013 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(417040), // Rule ID 5642 //
     /* 417018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417029 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 417034 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417038 */   GIR_RootConstrainSelectedInstOperands,
     /* 417039 */   // GIR_Coverage, 5642,
     /* 417039 */   GIR_Done,
     /* 417040 */ // Label 8084: @417040
     /* 417040 */ GIM_Reject,
     /* 417041 */ // Label 8079: @417041
     /* 417041 */ GIM_Reject,
     /* 417042 */ // Label 117: @417042
     /* 417042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8089*/ GIMT_Encode4(418170),
     /* 417053 */ /*GILLT_s8*//*Label 8085*/ GIMT_Encode4(417069),
     /* 417057 */ /*GILLT_s16*//*Label 8086*/ GIMT_Encode4(417116),
     /* 417061 */ /*GILLT_s32*//*Label 8087*/ GIMT_Encode4(417531),
     /* 417065 */ /*GILLT_s64*//*Label 8088*/ GIMT_Encode4(417984),
     /* 417069 */ // Label 8085: @417069
     /* 417069 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(417092), // Rule ID 5925 //
     /* 417074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417085 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 417085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 417090 */   GIR_RootConstrainSelectedInstOperands,
     /* 417091 */   // GIR_Coverage, 5925,
     /* 417091 */   GIR_Done,
     /* 417092 */ // Label 8090: @417092
     /* 417092 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(417115), // Rule ID 5926 //
     /* 417097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417108 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 417108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 417113 */   GIR_RootConstrainSelectedInstOperands,
     /* 417114 */   // GIR_Coverage, 5926,
     /* 417114 */   GIR_Done,
     /* 417115 */ // Label 8091: @417115
     /* 417115 */ GIM_Reject,
     /* 417116 */ // Label 8086: @417116
     /* 417116 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(417166), // Rule ID 5872 //
     /* 417121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417136 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417139 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417148 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417155 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 417158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417160 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417164 */   GIR_RootConstrainSelectedInstOperands,
     /* 417165 */   // GIR_Coverage, 5872,
     /* 417165 */   GIR_EraseRootFromParent_Done,
     /* 417166 */ // Label 8092: @417166
     /* 417166 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(417216), // Rule ID 5874 //
     /* 417171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417186 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417189 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417194 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417198 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417205 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 417208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417210 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417214 */   GIR_RootConstrainSelectedInstOperands,
     /* 417215 */   // GIR_Coverage, 5874,
     /* 417215 */   GIR_EraseRootFromParent_Done,
     /* 417216 */ // Label 8093: @417216
     /* 417216 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(417266), // Rule ID 5882 //
     /* 417221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417236 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417239 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 417248 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417255 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 417258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417260 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417264 */   GIR_RootConstrainSelectedInstOperands,
     /* 417265 */   // GIR_Coverage, 5882,
     /* 417265 */   GIR_EraseRootFromParent_Done,
     /* 417266 */ // Label 8094: @417266
     /* 417266 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(417316), // Rule ID 5884 //
     /* 417271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417286 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417289 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417294 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417298 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417305 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 417308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417310 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417314 */   GIR_RootConstrainSelectedInstOperands,
     /* 417315 */   // GIR_Coverage, 5884,
     /* 417315 */   GIR_EraseRootFromParent_Done,
     /* 417316 */ // Label 8095: @417316
     /* 417316 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(417358), // Rule ID 5881 //
     /* 417321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417336 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417347 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 417350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417352 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417356 */   GIR_RootConstrainSelectedInstOperands,
     /* 417357 */   // GIR_Coverage, 5881,
     /* 417357 */   GIR_EraseRootFromParent_Done,
     /* 417358 */ // Label 8096: @417358
     /* 417358 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(417400), // Rule ID 5883 //
     /* 417363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417382 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417389 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 417392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417394 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417398 */   GIR_RootConstrainSelectedInstOperands,
     /* 417399 */   // GIR_Coverage, 5883,
     /* 417399 */   GIR_EraseRootFromParent_Done,
     /* 417400 */ // Label 8097: @417400
     /* 417400 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(417442), // Rule ID 5871 //
     /* 417405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417420 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417424 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417431 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 417431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 417434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417436 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417440 */   GIR_RootConstrainSelectedInstOperands,
     /* 417441 */   // GIR_Coverage, 5871,
     /* 417441 */   GIR_EraseRootFromParent_Done,
     /* 417442 */ // Label 8098: @417442
     /* 417442 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(417484), // Rule ID 5873 //
     /* 417447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417466 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417473 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 417473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 417476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417482 */   GIR_RootConstrainSelectedInstOperands,
     /* 417483 */   // GIR_Coverage, 5873,
     /* 417483 */   GIR_EraseRootFromParent_Done,
     /* 417484 */ // Label 8099: @417484
     /* 417484 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(417507), // Rule ID 5927 //
     /* 417489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417500 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 417500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 417505 */   GIR_RootConstrainSelectedInstOperands,
     /* 417506 */   // GIR_Coverage, 5927,
     /* 417506 */   GIR_Done,
     /* 417507 */ // Label 8100: @417507
     /* 417507 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(417530), // Rule ID 5928 //
     /* 417512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417523 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 417523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 417528 */   GIR_RootConstrainSelectedInstOperands,
     /* 417529 */   // GIR_Coverage, 5928,
     /* 417529 */   GIR_Done,
     /* 417530 */ // Label 8101: @417530
     /* 417530 */ GIM_Reject,
     /* 417531 */ // Label 8087: @417531
     /* 417531 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(417581), // Rule ID 5876 //
     /* 417536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417551 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417554 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417570 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 417573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417579 */   GIR_RootConstrainSelectedInstOperands,
     /* 417580 */   // GIR_Coverage, 5876,
     /* 417580 */   GIR_EraseRootFromParent_Done,
     /* 417581 */ // Label 8102: @417581
     /* 417581 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(417631), // Rule ID 5878 //
     /* 417586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417601 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417604 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 417609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417613 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417620 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 417623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417625 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417629 */   GIR_RootConstrainSelectedInstOperands,
     /* 417630 */   // GIR_Coverage, 5878,
     /* 417630 */   GIR_EraseRootFromParent_Done,
     /* 417631 */ // Label 8103: @417631
     /* 417631 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(417681), // Rule ID 5886 //
     /* 417636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417651 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417654 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417659 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417663 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417670 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 417673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417675 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417679 */   GIR_RootConstrainSelectedInstOperands,
     /* 417680 */   // GIR_Coverage, 5886,
     /* 417680 */   GIR_EraseRootFromParent_Done,
     /* 417681 */ // Label 8104: @417681
     /* 417681 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(417731), // Rule ID 5888 //
     /* 417686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 417701 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 417704 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 417709 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 417713 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417720 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 417723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 417729 */   GIR_RootConstrainSelectedInstOperands,
     /* 417730 */   // GIR_Coverage, 5888,
     /* 417730 */   GIR_EraseRootFromParent_Done,
     /* 417731 */ // Label 8105: @417731
     /* 417731 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(417773), // Rule ID 5885 //
     /* 417736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417751 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417755 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417762 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 417765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417767 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417771 */   GIR_RootConstrainSelectedInstOperands,
     /* 417772 */   // GIR_Coverage, 5885,
     /* 417772 */   GIR_EraseRootFromParent_Done,
     /* 417773 */ // Label 8106: @417773
     /* 417773 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(417815), // Rule ID 5887 //
     /* 417778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 417793 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417804 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 417807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417809 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417813 */   GIR_RootConstrainSelectedInstOperands,
     /* 417814 */   // GIR_Coverage, 5887,
     /* 417814 */   GIR_EraseRootFromParent_Done,
     /* 417815 */ // Label 8107: @417815
     /* 417815 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(417857), // Rule ID 5875 //
     /* 417820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417835 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417839 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417846 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 417846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 417849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417851 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417855 */   GIR_RootConstrainSelectedInstOperands,
     /* 417856 */   // GIR_Coverage, 5875,
     /* 417856 */   GIR_EraseRootFromParent_Done,
     /* 417857 */ // Label 8108: @417857
     /* 417857 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(417899), // Rule ID 5877 //
     /* 417862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417869 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 417877 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417888 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 417888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 417891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417893 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417897 */   GIR_RootConstrainSelectedInstOperands,
     /* 417898 */   // GIR_Coverage, 5877,
     /* 417898 */   GIR_EraseRootFromParent_Done,
     /* 417899 */ // Label 8109: @417899
     /* 417899 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(417960), // Rule ID 5929 //
     /* 417904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417915 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 417915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 417922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417931 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 417937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417942 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 417949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417959 */   // GIR_Coverage, 5929,
     /* 417959 */   GIR_EraseRootFromParent_Done,
     /* 417960 */ // Label 8110: @417960
     /* 417960 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(417983), // Rule ID 5930 //
     /* 417965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417976 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 417976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 417981 */   GIR_RootConstrainSelectedInstOperands,
     /* 417982 */   // GIR_Coverage, 5930,
     /* 417982 */   GIR_Done,
     /* 417983 */ // Label 8111: @417983
     /* 417983 */ GIM_Reject,
     /* 417984 */ // Label 8088: @417984
     /* 417984 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(418169),
     /* 417989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417996 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(418039), // Rule ID 5880 //
     /* 418001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418009 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418012 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418028 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418037 */     GIR_RootConstrainSelectedInstOperands,
     /* 418038 */     // GIR_Coverage, 5880,
     /* 418038 */     GIR_EraseRootFromParent_Done,
     /* 418039 */   // Label 8113: @418039
     /* 418039 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(418082), // Rule ID 5890 //
     /* 418044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418052 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418055 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418071 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418080 */     GIR_RootConstrainSelectedInstOperands,
     /* 418081 */     // GIR_Coverage, 5890,
     /* 418081 */     GIR_EraseRootFromParent_Done,
     /* 418082 */   // Label 8114: @418082
     /* 418082 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(418117), // Rule ID 5889 //
     /* 418087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418106 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418115 */     GIR_RootConstrainSelectedInstOperands,
     /* 418116 */     // GIR_Coverage, 5889,
     /* 418116 */     GIR_EraseRootFromParent_Done,
     /* 418117 */   // Label 8115: @418117
     /* 418117 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418152), // Rule ID 5879 //
     /* 418122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418141 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418150 */     GIR_RootConstrainSelectedInstOperands,
     /* 418151 */     // GIR_Coverage, 5879,
     /* 418151 */     GIR_EraseRootFromParent_Done,
     /* 418152 */   // Label 8116: @418152
     /* 418152 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418168), // Rule ID 5931 //
     /* 418157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418161 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 418161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 418166 */     GIR_RootConstrainSelectedInstOperands,
     /* 418167 */     // GIR_Coverage, 5931,
     /* 418167 */     GIR_Done,
     /* 418168 */   // Label 8117: @418168
     /* 418168 */   GIM_Reject,
     /* 418169 */ // Label 8112: @418169
     /* 418169 */ GIM_Reject,
     /* 418170 */ // Label 8089: @418170
     /* 418170 */ GIM_Reject,
     /* 418171 */ // Label 118: @418171
     /* 418171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8121*/ GIMT_Encode4(418373),
     /* 418182 */ /*GILLT_s8*//*Label 8118*/ GIMT_Encode4(418194),
     /* 418186 */ /*GILLT_s16*//*Label 8119*/ GIMT_Encode4(418241),
     /* 418190 */ /*GILLT_s32*//*Label 8120*/ GIMT_Encode4(418288),
     /* 418194 */ // Label 8118: @418194
     /* 418194 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(418217), // Rule ID 6022 //
     /* 418199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418210 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 418215 */   GIR_RootConstrainSelectedInstOperands,
     /* 418216 */   // GIR_Coverage, 6022,
     /* 418216 */   GIR_Done,
     /* 418217 */ // Label 8122: @418217
     /* 418217 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(418240), // Rule ID 6023 //
     /* 418222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418233 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 418238 */   GIR_RootConstrainSelectedInstOperands,
     /* 418239 */   // GIR_Coverage, 6023,
     /* 418239 */   GIR_Done,
     /* 418240 */ // Label 8123: @418240
     /* 418240 */ GIM_Reject,
     /* 418241 */ // Label 8119: @418241
     /* 418241 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(418264), // Rule ID 6024 //
     /* 418246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418257 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 418262 */   GIR_RootConstrainSelectedInstOperands,
     /* 418263 */   // GIR_Coverage, 6024,
     /* 418263 */   GIR_Done,
     /* 418264 */ // Label 8124: @418264
     /* 418264 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(418287), // Rule ID 6025 //
     /* 418269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418280 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 418285 */   GIR_RootConstrainSelectedInstOperands,
     /* 418286 */   // GIR_Coverage, 6025,
     /* 418286 */   GIR_Done,
     /* 418287 */ // Label 8125: @418287
     /* 418287 */ GIM_Reject,
     /* 418288 */ // Label 8120: @418288
     /* 418288 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(418311), // Rule ID 6026 //
     /* 418293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418304 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 418309 */   GIR_RootConstrainSelectedInstOperands,
     /* 418310 */   // GIR_Coverage, 6026,
     /* 418310 */   GIR_Done,
     /* 418311 */ // Label 8126: @418311
     /* 418311 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(418372), // Rule ID 6027 //
     /* 418316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418327 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 418334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418339 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418354 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418371 */   // GIR_Coverage, 6027,
     /* 418371 */   GIR_EraseRootFromParent_Done,
     /* 418372 */ // Label 8127: @418372
     /* 418372 */ GIM_Reject,
     /* 418373 */ // Label 8121: @418373
     /* 418373 */ GIM_Reject,
     /* 418374 */ // Label 119: @418374
     /* 418374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8131*/ GIMT_Encode4(418576),
     /* 418385 */ /*GILLT_s8*//*Label 8128*/ GIMT_Encode4(418397),
     /* 418389 */ /*GILLT_s16*//*Label 8129*/ GIMT_Encode4(418444),
     /* 418393 */ /*GILLT_s32*//*Label 8130*/ GIMT_Encode4(418491),
     /* 418397 */ // Label 8128: @418397
     /* 418397 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(418420), // Rule ID 6016 //
     /* 418402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418413 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 418418 */   GIR_RootConstrainSelectedInstOperands,
     /* 418419 */   // GIR_Coverage, 6016,
     /* 418419 */   GIR_Done,
     /* 418420 */ // Label 8132: @418420
     /* 418420 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(418443), // Rule ID 6017 //
     /* 418425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418436 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 418441 */   GIR_RootConstrainSelectedInstOperands,
     /* 418442 */   // GIR_Coverage, 6017,
     /* 418442 */   GIR_Done,
     /* 418443 */ // Label 8133: @418443
     /* 418443 */ GIM_Reject,
     /* 418444 */ // Label 8129: @418444
     /* 418444 */ GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(418467), // Rule ID 6018 //
     /* 418449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418460 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 418465 */   GIR_RootConstrainSelectedInstOperands,
     /* 418466 */   // GIR_Coverage, 6018,
     /* 418466 */   GIR_Done,
     /* 418467 */ // Label 8134: @418467
     /* 418467 */ GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(418490), // Rule ID 6019 //
     /* 418472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418483 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 418488 */   GIR_RootConstrainSelectedInstOperands,
     /* 418489 */   // GIR_Coverage, 6019,
     /* 418489 */   GIR_Done,
     /* 418490 */ // Label 8135: @418490
     /* 418490 */ GIM_Reject,
     /* 418491 */ // Label 8130: @418491
     /* 418491 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(418514), // Rule ID 6020 //
     /* 418496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418507 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 418512 */   GIR_RootConstrainSelectedInstOperands,
     /* 418513 */   // GIR_Coverage, 6020,
     /* 418513 */   GIR_Done,
     /* 418514 */ // Label 8136: @418514
     /* 418514 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(418575), // Rule ID 6021 //
     /* 418519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418530 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 418537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418557 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418574 */   // GIR_Coverage, 6021,
     /* 418574 */   GIR_EraseRootFromParent_Done,
     /* 418575 */ // Label 8137: @418575
     /* 418575 */ GIM_Reject,
     /* 418576 */ // Label 8131: @418576
     /* 418576 */ GIM_Reject,
     /* 418577 */ // Label 120: @418577
     /* 418577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8141*/ GIMT_Encode4(418779),
     /* 418588 */ /*GILLT_s8*//*Label 8138*/ GIMT_Encode4(418600),
     /* 418592 */ /*GILLT_s16*//*Label 8139*/ GIMT_Encode4(418647),
     /* 418596 */ /*GILLT_s32*//*Label 8140*/ GIMT_Encode4(418694),
     /* 418600 */ // Label 8138: @418600
     /* 418600 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(418623), // Rule ID 6010 //
     /* 418605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418616 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 418621 */   GIR_RootConstrainSelectedInstOperands,
     /* 418622 */   // GIR_Coverage, 6010,
     /* 418622 */   GIR_Done,
     /* 418623 */ // Label 8142: @418623
     /* 418623 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(418646), // Rule ID 6011 //
     /* 418628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418639 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 418644 */   GIR_RootConstrainSelectedInstOperands,
     /* 418645 */   // GIR_Coverage, 6011,
     /* 418645 */   GIR_Done,
     /* 418646 */ // Label 8143: @418646
     /* 418646 */ GIM_Reject,
     /* 418647 */ // Label 8139: @418647
     /* 418647 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(418670), // Rule ID 6012 //
     /* 418652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418663 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 418668 */   GIR_RootConstrainSelectedInstOperands,
     /* 418669 */   // GIR_Coverage, 6012,
     /* 418669 */   GIR_Done,
     /* 418670 */ // Label 8144: @418670
     /* 418670 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(418693), // Rule ID 6013 //
     /* 418675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418686 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 418691 */   GIR_RootConstrainSelectedInstOperands,
     /* 418692 */   // GIR_Coverage, 6013,
     /* 418692 */   GIR_Done,
     /* 418693 */ // Label 8145: @418693
     /* 418693 */ GIM_Reject,
     /* 418694 */ // Label 8140: @418694
     /* 418694 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(418717), // Rule ID 6014 //
     /* 418699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418710 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 418715 */   GIR_RootConstrainSelectedInstOperands,
     /* 418716 */   // GIR_Coverage, 6014,
     /* 418716 */   GIR_Done,
     /* 418717 */ // Label 8146: @418717
     /* 418717 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(418778), // Rule ID 6015 //
     /* 418722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418733 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 418740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418760 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418777 */   // GIR_Coverage, 6015,
     /* 418777 */   GIR_EraseRootFromParent_Done,
     /* 418778 */ // Label 8147: @418778
     /* 418778 */ GIM_Reject,
     /* 418779 */ // Label 8141: @418779
     /* 418779 */ GIM_Reject,
     /* 418780 */ // Label 121: @418780
     /* 418780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8151*/ GIMT_Encode4(418982),
     /* 418791 */ /*GILLT_s8*//*Label 8148*/ GIMT_Encode4(418803),
     /* 418795 */ /*GILLT_s16*//*Label 8149*/ GIMT_Encode4(418850),
     /* 418799 */ /*GILLT_s32*//*Label 8150*/ GIMT_Encode4(418897),
     /* 418803 */ // Label 8148: @418803
     /* 418803 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(418826), // Rule ID 6004 //
     /* 418808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418819 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 418819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 418824 */   GIR_RootConstrainSelectedInstOperands,
     /* 418825 */   // GIR_Coverage, 6004,
     /* 418825 */   GIR_Done,
     /* 418826 */ // Label 8152: @418826
     /* 418826 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(418849), // Rule ID 6005 //
     /* 418831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418842 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 418842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 418847 */   GIR_RootConstrainSelectedInstOperands,
     /* 418848 */   // GIR_Coverage, 6005,
     /* 418848 */   GIR_Done,
     /* 418849 */ // Label 8153: @418849
     /* 418849 */ GIM_Reject,
     /* 418850 */ // Label 8149: @418850
     /* 418850 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(418873), // Rule ID 6006 //
     /* 418855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418866 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 418866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 418871 */   GIR_RootConstrainSelectedInstOperands,
     /* 418872 */   // GIR_Coverage, 6006,
     /* 418872 */   GIR_Done,
     /* 418873 */ // Label 8154: @418873
     /* 418873 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(418896), // Rule ID 6007 //
     /* 418878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418889 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 418889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 418894 */   GIR_RootConstrainSelectedInstOperands,
     /* 418895 */   // GIR_Coverage, 6007,
     /* 418895 */   GIR_Done,
     /* 418896 */ // Label 8155: @418896
     /* 418896 */ GIM_Reject,
     /* 418897 */ // Label 8150: @418897
     /* 418897 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(418920), // Rule ID 6008 //
     /* 418902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418913 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 418918 */   GIR_RootConstrainSelectedInstOperands,
     /* 418919 */   // GIR_Coverage, 6008,
     /* 418919 */   GIR_Done,
     /* 418920 */ // Label 8156: @418920
     /* 418920 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(418981), // Rule ID 6009 //
     /* 418925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418936 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 418943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418948 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418952 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418963 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418980 */   // GIR_Coverage, 6009,
     /* 418980 */   GIR_EraseRootFromParent_Done,
     /* 418981 */ // Label 8157: @418981
     /* 418981 */ GIM_Reject,
     /* 418982 */ // Label 8151: @418982
     /* 418982 */ GIM_Reject,
     /* 418983 */ // Label 122: @418983
     /* 418983 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(419122),
     /* 418988 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 418991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 418995 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(419029), // Rule ID 257 //
     /* 419000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 419007 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 419007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 419010 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419027 */     GIR_RootConstrainSelectedInstOperands,
     /* 419028 */     // GIR_Coverage, 257,
     /* 419028 */     GIR_EraseRootFromParent_Done,
     /* 419029 */   // Label 8159: @419029
     /* 419029 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(419063), // Rule ID 258 //
     /* 419034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 419041 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 419041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 419044 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419061 */     GIR_RootConstrainSelectedInstOperands,
     /* 419062 */     // GIR_Coverage, 258,
     /* 419062 */     GIR_EraseRootFromParent_Done,
     /* 419063 */   // Label 8160: @419063
     /* 419063 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(419092), // Rule ID 273 //
     /* 419068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 419075 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 419075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 419078 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419090 */     GIR_RootConstrainSelectedInstOperands,
     /* 419091 */     // GIR_Coverage, 273,
     /* 419091 */     GIR_EraseRootFromParent_Done,
     /* 419092 */   // Label 8161: @419092
     /* 419092 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(419121), // Rule ID 294 //
     /* 419097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 419104 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 419104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 419107 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419119 */     GIR_RootConstrainSelectedInstOperands,
     /* 419120 */     // GIR_Coverage, 294,
     /* 419120 */     GIR_EraseRootFromParent_Done,
     /* 419121 */   // Label 8162: @419121
     /* 419121 */   GIM_Reject,
     /* 419122 */ // Label 8158: @419122
     /* 419122 */ GIM_Reject,
     /* 419123 */ // Label 123: @419123
     /* 419123 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8175*/ GIMT_Encode4(420110),
     /* 419134 */ /*GILLT_s64*//*Label 8163*/ GIMT_Encode4(419218), GIMT_Encode4(0),
     /* 419142 */ /*GILLT_v2s32*//*Label 8164*/ GIMT_Encode4(419256),
     /* 419146 */ /*GILLT_v2s64*//*Label 8165*/ GIMT_Encode4(419294),
     /* 419150 */ /*GILLT_v4s16*//*Label 8166*/ GIMT_Encode4(419332),
     /* 419154 */ /*GILLT_v4s32*//*Label 8167*/ GIMT_Encode4(419370),
     /* 419158 */ /*GILLT_v8s8*//*Label 8168*/ GIMT_Encode4(419408),
     /* 419162 */ /*GILLT_v8s16*//*Label 8169*/ GIMT_Encode4(419446),
     /* 419166 */ /*GILLT_v16s8*//*Label 8170*/ GIMT_Encode4(419484), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419186 */ /*GILLT_nxv2s64*//*Label 8171*/ GIMT_Encode4(419522), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 419198 */ /*GILLT_nxv4s32*//*Label 8172*/ GIMT_Encode4(419669), GIMT_Encode4(0),
     /* 419206 */ /*GILLT_nxv8s16*//*Label 8173*/ GIMT_Encode4(419816), GIMT_Encode4(0),
     /* 419214 */ /*GILLT_nxv16s8*//*Label 8174*/ GIMT_Encode4(419963),
     /* 419218 */ // Label 8163: @419218
     /* 419218 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(419255), // Rule ID 5081 //
     /* 419223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 419226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 419229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 419232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419248 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 419248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419253 */   GIR_RootConstrainSelectedInstOperands,
     /* 419254 */   // GIR_Coverage, 5081,
     /* 419254 */   GIR_Done,
     /* 419255 */ // Label 8176: @419255
     /* 419255 */ GIM_Reject,
     /* 419256 */ // Label 8164: @419256
     /* 419256 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(419293), // Rule ID 5080 //
     /* 419261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 419267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 419270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419282 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419286 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 419286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419291 */   GIR_RootConstrainSelectedInstOperands,
     /* 419292 */   // GIR_Coverage, 5080,
     /* 419292 */   GIR_Done,
     /* 419293 */ // Label 8177: @419293
     /* 419293 */ GIM_Reject,
     /* 419294 */ // Label 8165: @419294
     /* 419294 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(419331), // Rule ID 5085 //
     /* 419299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 419305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 419308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419324 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 419324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419329 */   GIR_RootConstrainSelectedInstOperands,
     /* 419330 */   // GIR_Coverage, 5085,
     /* 419330 */   GIR_Done,
     /* 419331 */ // Label 8178: @419331
     /* 419331 */ GIM_Reject,
     /* 419332 */ // Label 8166: @419332
     /* 419332 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(419369), // Rule ID 5079 //
     /* 419337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 419346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419358 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419362 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 419362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419367 */   GIR_RootConstrainSelectedInstOperands,
     /* 419368 */   // GIR_Coverage, 5079,
     /* 419368 */   GIR_Done,
     /* 419369 */ // Label 8179: @419369
     /* 419369 */ GIM_Reject,
     /* 419370 */ // Label 8167: @419370
     /* 419370 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(419407), // Rule ID 5084 //
     /* 419375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 419384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419400 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 419400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419405 */   GIR_RootConstrainSelectedInstOperands,
     /* 419406 */   // GIR_Coverage, 5084,
     /* 419406 */   GIR_Done,
     /* 419407 */ // Label 8180: @419407
     /* 419407 */ GIM_Reject,
     /* 419408 */ // Label 8168: @419408
     /* 419408 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(419445), // Rule ID 5078 //
     /* 419413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 419419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 419422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419438 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 419438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 419443 */   GIR_RootConstrainSelectedInstOperands,
     /* 419444 */   // GIR_Coverage, 5078,
     /* 419444 */   GIR_Done,
     /* 419445 */ // Label 8181: @419445
     /* 419445 */ GIM_Reject,
     /* 419446 */ // Label 8169: @419446
     /* 419446 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(419483), // Rule ID 5083 //
     /* 419451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 419460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419476 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 419476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419481 */   GIR_RootConstrainSelectedInstOperands,
     /* 419482 */   // GIR_Coverage, 5083,
     /* 419482 */   GIR_Done,
     /* 419483 */ // Label 8182: @419483
     /* 419483 */ GIM_Reject,
     /* 419484 */ // Label 8170: @419484
     /* 419484 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(419521), // Rule ID 5082 //
     /* 419489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 419495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 419498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419514 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 419514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 419519 */   GIR_RootConstrainSelectedInstOperands,
     /* 419520 */   // GIR_Coverage, 5082,
     /* 419520 */   GIR_Done,
     /* 419521 */ // Label 8183: @419521
     /* 419521 */ GIM_Reject,
     /* 419522 */ // Label 8171: @419522
     /* 419522 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(419668),
     /* 419527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419533 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 419536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419540 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(419593), // Rule ID 11947 //
     /* 419545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419568 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419574 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419578 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419591 */     GIR_RootConstrainSelectedInstOperands,
     /* 419592 */     // GIR_Coverage, 11947,
     /* 419592 */     GIR_EraseRootFromParent_Done,
     /* 419593 */   // Label 8185: @419593
     /* 419593 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(419646), // Rule ID 11958 //
     /* 419598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 419613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 419617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419621 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419631 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419644 */     GIR_RootConstrainSelectedInstOperands,
     /* 419645 */     // GIR_Coverage, 11958,
     /* 419645 */     GIR_EraseRootFromParent_Done,
     /* 419646 */   // Label 8186: @419646
     /* 419646 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(419667), // Rule ID 11939 //
     /* 419651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419654 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 419654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419665 */     GIR_RootConstrainSelectedInstOperands,
     /* 419666 */     // GIR_Coverage, 11939,
     /* 419666 */     GIR_EraseRootFromParent_Done,
     /* 419667 */   // Label 8187: @419667
     /* 419667 */   GIM_Reject,
     /* 419668 */ // Label 8184: @419668
     /* 419668 */ GIM_Reject,
     /* 419669 */ // Label 8172: @419669
     /* 419669 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(419815),
     /* 419674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 419683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419687 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(419740), // Rule ID 11945 //
     /* 419692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419715 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419725 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419738 */     GIR_RootConstrainSelectedInstOperands,
     /* 419739 */     // GIR_Coverage, 11945,
     /* 419739 */     GIR_EraseRootFromParent_Done,
     /* 419740 */   // Label 8189: @419740
     /* 419740 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(419793), // Rule ID 11955 //
     /* 419745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 419760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 419764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419768 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419778 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419791 */     GIR_RootConstrainSelectedInstOperands,
     /* 419792 */     // GIR_Coverage, 11955,
     /* 419792 */     GIR_EraseRootFromParent_Done,
     /* 419793 */   // Label 8190: @419793
     /* 419793 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(419814), // Rule ID 11937 //
     /* 419798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419801 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 419801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419812 */     GIR_RootConstrainSelectedInstOperands,
     /* 419813 */     // GIR_Coverage, 11937,
     /* 419813 */     GIR_EraseRootFromParent_Done,
     /* 419814 */   // Label 8191: @419814
     /* 419814 */   GIM_Reject,
     /* 419815 */ // Label 8188: @419815
     /* 419815 */ GIM_Reject,
     /* 419816 */ // Label 8173: @419816
     /* 419816 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(419962),
     /* 419821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 419830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419834 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(419887), // Rule ID 11943 //
     /* 419839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419862 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419868 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419872 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 419875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 419881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419885 */     GIR_RootConstrainSelectedInstOperands,
     /* 419886 */     // GIR_Coverage, 11943,
     /* 419886 */     GIR_EraseRootFromParent_Done,
     /* 419887 */   // Label 8193: @419887
     /* 419887 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(419940), // Rule ID 11952 //
     /* 419892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 419899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 419907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 419911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419915 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 419921 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 419923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 419925 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 419928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 419936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419938 */     GIR_RootConstrainSelectedInstOperands,
     /* 419939 */     // GIR_Coverage, 11952,
     /* 419939 */     GIR_EraseRootFromParent_Done,
     /* 419940 */   // Label 8194: @419940
     /* 419940 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(419961), // Rule ID 11935 //
     /* 419945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419948 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 419948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 419951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 419953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 419955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 419957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 419959 */     GIR_RootConstrainSelectedInstOperands,
     /* 419960 */     // GIR_Coverage, 11935,
     /* 419960 */     GIR_EraseRootFromParent_Done,
     /* 419961 */   // Label 8195: @419961
     /* 419961 */   GIM_Reject,
     /* 419962 */ // Label 8192: @419962
     /* 419962 */ GIM_Reject,
     /* 419963 */ // Label 8174: @419963
     /* 419963 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(420109),
     /* 419968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 419971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 419974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 419977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 419981 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(420034), // Rule ID 11941 //
     /* 419986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 419989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 419993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 419997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420009 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420019 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420032 */     GIR_RootConstrainSelectedInstOperands,
     /* 420033 */     // GIR_Coverage, 11941,
     /* 420033 */     GIR_EraseRootFromParent_Done,
     /* 420034 */   // Label 8197: @420034
     /* 420034 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(420087), // Rule ID 11949 //
     /* 420039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420062 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420072 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420085 */     GIR_RootConstrainSelectedInstOperands,
     /* 420086 */     // GIR_Coverage, 11949,
     /* 420086 */     GIR_EraseRootFromParent_Done,
     /* 420087 */   // Label 8198: @420087
     /* 420087 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(420108), // Rule ID 11933 //
     /* 420092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420095 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420106 */     GIR_RootConstrainSelectedInstOperands,
     /* 420107 */     // GIR_Coverage, 11933,
     /* 420107 */     GIR_EraseRootFromParent_Done,
     /* 420108 */   // Label 8199: @420108
     /* 420108 */   GIM_Reject,
     /* 420109 */ // Label 8196: @420109
     /* 420109 */ GIM_Reject,
     /* 420110 */ // Label 8175: @420110
     /* 420110 */ GIM_Reject,
     /* 420111 */ // Label 124: @420111
     /* 420111 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8208*/ GIMT_Encode4(421933),
     /* 420122 */ /*GILLT_s64*//*Label 8200*/ GIMT_Encode4(420158), GIMT_Encode4(0),
     /* 420130 */ /*GILLT_v2s32*//*Label 8201*/ GIMT_Encode4(420353),
     /* 420134 */ /*GILLT_v2s64*//*Label 8202*/ GIMT_Encode4(420600),
     /* 420138 */ /*GILLT_v4s16*//*Label 8203*/ GIMT_Encode4(420847),
     /* 420142 */ /*GILLT_v4s32*//*Label 8204*/ GIMT_Encode4(421123),
     /* 420146 */ /*GILLT_v8s8*//*Label 8205*/ GIMT_Encode4(421370),
     /* 420150 */ /*GILLT_v8s16*//*Label 8206*/ GIMT_Encode4(421515),
     /* 420154 */ /*GILLT_v16s8*//*Label 8207*/ GIMT_Encode4(421791),
     /* 420158 */ // Label 8200: @420158
     /* 420158 */ GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(420352),
     /* 420163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420170 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(420217), // Rule ID 6449 //
     /* 420175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420190 */     // MIs[1] Rn
     /* 420190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420201 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420215 */     GIR_RootConstrainSelectedInstOperands,
     /* 420216 */     // GIR_Coverage, 6449,
     /* 420216 */     GIR_EraseRootFromParent_Done,
     /* 420217 */   // Label 8210: @420217
     /* 420217 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(420264), // Rule ID 6460 //
     /* 420222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420237 */     // MIs[1] Rn
     /* 420237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420248 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420262 */     GIR_RootConstrainSelectedInstOperands,
     /* 420263 */     // GIR_Coverage, 6460,
     /* 420263 */     GIR_EraseRootFromParent_Done,
     /* 420264 */   // Label 8211: @420264
     /* 420264 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(420311), // Rule ID 13276 //
     /* 420269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420284 */     // MIs[1] Rn
     /* 420284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420295 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 420298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420309 */     GIR_RootConstrainSelectedInstOperands,
     /* 420310 */     // GIR_Coverage, 13276,
     /* 420310 */     GIR_EraseRootFromParent_Done,
     /* 420311 */   // Label 8212: @420311
     /* 420311 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(420331), // Rule ID 5644 //
     /* 420316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 420320 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 420320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420330 */     // GIR_Coverage, 5644,
     /* 420330 */     GIR_Done,
     /* 420331 */   // Label 8213: @420331
     /* 420331 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(420351), // Rule ID 5645 //
     /* 420336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420340 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 420340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420350 */     // GIR_Coverage, 5645,
     /* 420350 */     GIR_Done,
     /* 420351 */   // Label 8214: @420351
     /* 420351 */   GIM_Reject,
     /* 420352 */ // Label 8209: @420352
     /* 420352 */ GIM_Reject,
     /* 420353 */ // Label 8201: @420353
     /* 420353 */ GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(420599),
     /* 420358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 420361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420365 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(420412), // Rule ID 6446 //
     /* 420370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420385 */     // MIs[1] Rn
     /* 420385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420396 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420410 */     GIR_RootConstrainSelectedInstOperands,
     /* 420411 */     // GIR_Coverage, 6446,
     /* 420411 */     GIR_EraseRootFromParent_Done,
     /* 420412 */   // Label 8216: @420412
     /* 420412 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(420459), // Rule ID 6457 //
     /* 420417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420432 */     // MIs[1] Rn
     /* 420432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420443 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420457 */     GIR_RootConstrainSelectedInstOperands,
     /* 420458 */     // GIR_Coverage, 6457,
     /* 420458 */     GIR_EraseRootFromParent_Done,
     /* 420459 */   // Label 8217: @420459
     /* 420459 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(420506), // Rule ID 13273 //
     /* 420464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420479 */     // MIs[1] Rn
     /* 420479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420490 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 420493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420504 */     GIR_RootConstrainSelectedInstOperands,
     /* 420505 */     // GIR_Coverage, 13273,
     /* 420505 */     GIR_EraseRootFromParent_Done,
     /* 420506 */   // Label 8218: @420506
     /* 420506 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(420525), // Rule ID 1916 //
     /* 420511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 420514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 420518 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 420518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 420523 */     GIR_RootConstrainSelectedInstOperands,
     /* 420524 */     // GIR_Coverage, 1916,
     /* 420524 */     GIR_Done,
     /* 420525 */   // Label 8219: @420525
     /* 420525 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(420598), // Rule ID 5646 //
     /* 420530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420534 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 420534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 420537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 420541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 420548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 420551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 420555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420560 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 420563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 420570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 420588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 420593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420596 */     GIR_RootConstrainSelectedInstOperands,
     /* 420597 */     // GIR_Coverage, 5646,
     /* 420597 */     GIR_EraseRootFromParent_Done,
     /* 420598 */   // Label 8220: @420598
     /* 420598 */   GIM_Reject,
     /* 420599 */ // Label 8215: @420599
     /* 420599 */ GIM_Reject,
     /* 420600 */ // Label 8202: @420600
     /* 420600 */ GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(420846),
     /* 420605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420612 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(420659), // Rule ID 6448 //
     /* 420617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420632 */     // MIs[1] Rn
     /* 420632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420643 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420657 */     GIR_RootConstrainSelectedInstOperands,
     /* 420658 */     // GIR_Coverage, 6448,
     /* 420658 */     GIR_EraseRootFromParent_Done,
     /* 420659 */   // Label 8222: @420659
     /* 420659 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(420706), // Rule ID 6459 //
     /* 420664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420679 */     // MIs[1] Rn
     /* 420679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420690 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420704 */     GIR_RootConstrainSelectedInstOperands,
     /* 420705 */     // GIR_Coverage, 6459,
     /* 420705 */     GIR_EraseRootFromParent_Done,
     /* 420706 */   // Label 8223: @420706
     /* 420706 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(420753), // Rule ID 13275 //
     /* 420711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420719 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420726 */     // MIs[1] Rn
     /* 420726 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420737 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 420740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420751 */     GIR_RootConstrainSelectedInstOperands,
     /* 420752 */     // GIR_Coverage, 13275,
     /* 420752 */     GIR_EraseRootFromParent_Done,
     /* 420753 */   // Label 8224: @420753
     /* 420753 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(420772), // Rule ID 1918 //
     /* 420758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 420761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 420765 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 420765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 420770 */     GIR_RootConstrainSelectedInstOperands,
     /* 420771 */     // GIR_Coverage, 1918,
     /* 420771 */     GIR_Done,
     /* 420772 */   // Label 8225: @420772
     /* 420772 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(420845), // Rule ID 5648 //
     /* 420777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420781 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 420781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 420784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 420788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 420795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 420798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 420802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 420810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 420817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 420835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 420840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420843 */     GIR_RootConstrainSelectedInstOperands,
     /* 420844 */     // GIR_Coverage, 5648,
     /* 420844 */     GIR_EraseRootFromParent_Done,
     /* 420845 */   // Label 8226: @420845
     /* 420845 */   GIM_Reject,
     /* 420846 */ // Label 8221: @420846
     /* 420846 */ GIM_Reject,
     /* 420847 */ // Label 8203: @420847
     /* 420847 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(420908), // Rule ID 6444 //
     /* 420852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 420855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420867 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420870 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420874 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 420881 */   // MIs[1] Rn
     /* 420881 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420885 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420892 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 420895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420906 */   GIR_RootConstrainSelectedInstOperands,
     /* 420907 */   // GIR_Coverage, 6444,
     /* 420907 */   GIR_EraseRootFromParent_Done,
     /* 420908 */ // Label 8227: @420908
     /* 420908 */ GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(420962), // Rule ID 6461 //
     /* 420913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 420916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420928 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420935 */   // MIs[1] Rn
     /* 420935 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420939 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420944 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420946 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 420946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 420949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 420951 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 420960 */   GIR_RootConstrainSelectedInstOperands,
     /* 420961 */   // GIR_Coverage, 6461,
     /* 420961 */   GIR_EraseRootFromParent_Done,
     /* 420962 */ // Label 8228: @420962
     /* 420962 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(421016), // Rule ID 13271 //
     /* 420967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 420970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 420982 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 420985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 420989 */   // MIs[1] Rn
     /* 420989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 420993 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 420998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421000 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421005 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421014 */   GIR_RootConstrainSelectedInstOperands,
     /* 421015 */   // GIR_Coverage, 13271,
     /* 421015 */   GIR_EraseRootFromParent_Done,
     /* 421016 */ // Label 8229: @421016
     /* 421016 */ GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(421042), // Rule ID 1914 //
     /* 421021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421035 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 421040 */   GIR_RootConstrainSelectedInstOperands,
     /* 421041 */   // GIR_Coverage, 1914,
     /* 421041 */   GIR_Done,
     /* 421042 */ // Label 8230: @421042
     /* 421042 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(421122), // Rule ID 5649 //
     /* 421047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421058 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421058 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421061 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421065 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421084 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421087 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421091 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421094 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421099 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421104 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 421112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421120 */   GIR_RootConstrainSelectedInstOperands,
     /* 421121 */   // GIR_Coverage, 5649,
     /* 421121 */   GIR_EraseRootFromParent_Done,
     /* 421122 */ // Label 8231: @421122
     /* 421122 */ GIM_Reject,
     /* 421123 */ // Label 8204: @421123
     /* 421123 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(421369),
     /* 421128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421135 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(421182), // Rule ID 6447 //
     /* 421140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421155 */     // MIs[1] Rn
     /* 421155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421166 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421180 */     GIR_RootConstrainSelectedInstOperands,
     /* 421181 */     // GIR_Coverage, 6447,
     /* 421181 */     GIR_EraseRootFromParent_Done,
     /* 421182 */   // Label 8233: @421182
     /* 421182 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421229), // Rule ID 6458 //
     /* 421187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421202 */     // MIs[1] Rn
     /* 421202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421213 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421227 */     GIR_RootConstrainSelectedInstOperands,
     /* 421228 */     // GIR_Coverage, 6458,
     /* 421228 */     GIR_EraseRootFromParent_Done,
     /* 421229 */   // Label 8234: @421229
     /* 421229 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421276), // Rule ID 13274 //
     /* 421234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421249 */     // MIs[1] Rn
     /* 421249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421260 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 421263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421274 */     GIR_RootConstrainSelectedInstOperands,
     /* 421275 */     // GIR_Coverage, 13274,
     /* 421275 */     GIR_EraseRootFromParent_Done,
     /* 421276 */   // Label 8235: @421276
     /* 421276 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(421295), // Rule ID 1917 //
     /* 421281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421288 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 421288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 421293 */     GIR_RootConstrainSelectedInstOperands,
     /* 421294 */     // GIR_Coverage, 1917,
     /* 421294 */     GIR_Done,
     /* 421295 */   // Label 8236: @421295
     /* 421295 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(421368), // Rule ID 5647 //
     /* 421300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421304 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421330 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 421340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 421358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421366 */     GIR_RootConstrainSelectedInstOperands,
     /* 421367 */     // GIR_Coverage, 5647,
     /* 421367 */     GIR_EraseRootFromParent_Done,
     /* 421368 */   // Label 8237: @421368
     /* 421368 */   GIM_Reject,
     /* 421369 */ // Label 8232: @421369
     /* 421369 */ GIM_Reject,
     /* 421370 */ // Label 8205: @421370
     /* 421370 */ GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(421427), // Rule ID 13269 //
     /* 421375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 421378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421390 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421393 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421397 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 421401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421403 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 421410 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 421413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421425 */   GIR_RootConstrainSelectedInstOperands,
     /* 421426 */   // GIR_Coverage, 13269,
     /* 421426 */   GIR_EraseRootFromParent_Done,
     /* 421427 */ // Label 8238: @421427
     /* 421427 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(421488), // Rule ID 6442 //
     /* 421432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421447 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421450 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421454 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 421461 */   // MIs[1] Rn
     /* 421461 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421465 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421472 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 421475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421477 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421486 */   GIR_RootConstrainSelectedInstOperands,
     /* 421487 */   // GIR_Coverage, 6442,
     /* 421487 */   GIR_EraseRootFromParent_Done,
     /* 421488 */ // Label 8239: @421488
     /* 421488 */ GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(421514), // Rule ID 1912 //
     /* 421493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421507 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 421507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 421512 */   GIR_RootConstrainSelectedInstOperands,
     /* 421513 */   // GIR_Coverage, 1912,
     /* 421513 */   GIR_Done,
     /* 421514 */ // Label 8240: @421514
     /* 421514 */ GIM_Reject,
     /* 421515 */ // Label 8206: @421515
     /* 421515 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(421576), // Rule ID 6445 //
     /* 421520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421535 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421538 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421542 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 421549 */   // MIs[1] Rn
     /* 421549 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421560 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421565 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421574 */   GIR_RootConstrainSelectedInstOperands,
     /* 421575 */   // GIR_Coverage, 6445,
     /* 421575 */   GIR_EraseRootFromParent_Done,
     /* 421576 */ // Label 8241: @421576
     /* 421576 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(421630), // Rule ID 6462 //
     /* 421581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421596 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421603 */   // MIs[1] Rn
     /* 421603 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421614 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421619 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421628 */   GIR_RootConstrainSelectedInstOperands,
     /* 421629 */   // GIR_Coverage, 6462,
     /* 421629 */   GIR_EraseRootFromParent_Done,
     /* 421630 */ // Label 8242: @421630
     /* 421630 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(421684), // Rule ID 13272 //
     /* 421635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421650 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421657 */   // MIs[1] Rn
     /* 421657 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421661 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421668 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 421671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421682 */   GIR_RootConstrainSelectedInstOperands,
     /* 421683 */   // GIR_Coverage, 13272,
     /* 421683 */   GIR_EraseRootFromParent_Done,
     /* 421684 */ // Label 8243: @421684
     /* 421684 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(421710), // Rule ID 1915 //
     /* 421689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421703 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 421708 */   GIR_RootConstrainSelectedInstOperands,
     /* 421709 */   // GIR_Coverage, 1915,
     /* 421709 */   GIR_Done,
     /* 421710 */ // Label 8244: @421710
     /* 421710 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(421790), // Rule ID 5650 //
     /* 421715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421726 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421726 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421729 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421733 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421759 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 421780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421788 */   GIR_RootConstrainSelectedInstOperands,
     /* 421789 */   // GIR_Coverage, 5650,
     /* 421789 */   GIR_EraseRootFromParent_Done,
     /* 421790 */ // Label 8245: @421790
     /* 421790 */ GIM_Reject,
     /* 421791 */ // Label 8207: @421791
     /* 421791 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(421852), // Rule ID 6443 //
     /* 421796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421811 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421814 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421818 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 421825 */   // MIs[1] Rn
     /* 421825 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421829 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421836 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 421839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421841 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421850 */   GIR_RootConstrainSelectedInstOperands,
     /* 421851 */   // GIR_Coverage, 6443,
     /* 421851 */   GIR_EraseRootFromParent_Done,
     /* 421852 */ // Label 8246: @421852
     /* 421852 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(421906), // Rule ID 13270 //
     /* 421857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 421860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421872 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421879 */   // MIs[1] Rn
     /* 421879 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421883 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421890 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 421893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421895 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421904 */   GIR_RootConstrainSelectedInstOperands,
     /* 421905 */   // GIR_Coverage, 13270,
     /* 421905 */   GIR_EraseRootFromParent_Done,
     /* 421906 */ // Label 8247: @421906
     /* 421906 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(421932), // Rule ID 1913 //
     /* 421911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421925 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 421925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 421930 */   GIR_RootConstrainSelectedInstOperands,
     /* 421931 */   // GIR_Coverage, 1913,
     /* 421931 */   GIR_Done,
     /* 421932 */ // Label 8248: @421932
     /* 421932 */ GIM_Reject,
     /* 421933 */ // Label 8208: @421933
     /* 421933 */ GIM_Reject,
     /* 421934 */ // Label 125: @421934
     /* 421934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8251*/ GIMT_Encode4(422188),
     /* 421945 */ /*GILLT_v4s16*//*Label 8249*/ GIMT_Encode4(421961), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 421957 */ /*GILLT_v8s16*//*Label 8250*/ GIMT_Encode4(422047),
     /* 421961 */ // Label 8249: @421961
     /* 421961 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(422046),
     /* 421966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 421972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421980 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422014), // Rule ID 1922 //
     /* 421985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 421996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422000 */     // MIs[1] Operand 1
     /* 422000 */     // No operand predicates
     /* 422000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422002 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422012 */     GIR_RootConstrainSelectedInstOperands,
     /* 422013 */     // GIR_Coverage, 1922,
     /* 422013 */     GIR_EraseRootFromParent_Done,
     /* 422014 */   // Label 8253: @422014
     /* 422014 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422045), // Rule ID 5651 //
     /* 422019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422031 */     // MIs[1] Operand 1
     /* 422031 */     // No operand predicates
     /* 422031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422033 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422043 */     GIR_RootConstrainSelectedInstOperands,
     /* 422044 */     // GIR_Coverage, 5651,
     /* 422044 */     GIR_EraseRootFromParent_Done,
     /* 422045 */   // Label 8254: @422045
     /* 422045 */   GIM_Reject,
     /* 422046 */ // Label 8252: @422046
     /* 422046 */ GIM_Reject,
     /* 422047 */ // Label 8250: @422047
     /* 422047 */ GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(422187),
     /* 422052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422062 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(422113), // Rule ID 6453 //
     /* 422067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422082 */     // MIs[1] Rn
     /* 422082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422097 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422111 */     GIR_RootConstrainSelectedInstOperands,
     /* 422112 */     // GIR_Coverage, 6453,
     /* 422112 */     GIR_EraseRootFromParent_Done,
     /* 422113 */   // Label 8256: @422113
     /* 422113 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(422151), // Rule ID 1923 //
     /* 422118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422137 */     // MIs[1] Operand 1
     /* 422137 */     // No operand predicates
     /* 422137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422139 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422149 */     GIR_RootConstrainSelectedInstOperands,
     /* 422150 */     // GIR_Coverage, 1923,
     /* 422150 */     GIR_EraseRootFromParent_Done,
     /* 422151 */   // Label 8257: @422151
     /* 422151 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422186), // Rule ID 5652 //
     /* 422156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422172 */     // MIs[1] Operand 1
     /* 422172 */     // No operand predicates
     /* 422172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422174 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422184 */     GIR_RootConstrainSelectedInstOperands,
     /* 422185 */     // GIR_Coverage, 5652,
     /* 422185 */     GIR_EraseRootFromParent_Done,
     /* 422186 */   // Label 8258: @422186
     /* 422186 */   GIM_Reject,
     /* 422187 */ // Label 8255: @422187
     /* 422187 */ GIM_Reject,
     /* 422188 */ // Label 8251: @422188
     /* 422188 */ GIM_Reject,
     /* 422189 */ // Label 126: @422189
     /* 422189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8261*/ GIMT_Encode4(422443),
     /* 422200 */ /*GILLT_v2s32*//*Label 8259*/ GIMT_Encode4(422216), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422212 */ /*GILLT_v4s32*//*Label 8260*/ GIMT_Encode4(422302),
     /* 422216 */ // Label 8259: @422216
     /* 422216 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(422301),
     /* 422221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422235 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(422269), // Rule ID 1920 //
     /* 422240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422255 */     // MIs[1] Operand 1
     /* 422255 */     // No operand predicates
     /* 422255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422257 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422267 */     GIR_RootConstrainSelectedInstOperands,
     /* 422268 */     // GIR_Coverage, 1920,
     /* 422268 */     GIR_EraseRootFromParent_Done,
     /* 422269 */   // Label 8263: @422269
     /* 422269 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(422300), // Rule ID 5653 //
     /* 422274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422286 */     // MIs[1] Operand 1
     /* 422286 */     // No operand predicates
     /* 422286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422288 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 422288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422298 */     GIR_RootConstrainSelectedInstOperands,
     /* 422299 */     // GIR_Coverage, 5653,
     /* 422299 */     GIR_EraseRootFromParent_Done,
     /* 422300 */   // Label 8264: @422300
     /* 422300 */   GIM_Reject,
     /* 422301 */ // Label 8262: @422301
     /* 422301 */ GIM_Reject,
     /* 422302 */ // Label 8260: @422302
     /* 422302 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(422442),
     /* 422307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422317 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(422368), // Rule ID 6455 //
     /* 422322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422337 */     // MIs[1] Rn
     /* 422337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422352 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422366 */     GIR_RootConstrainSelectedInstOperands,
     /* 422367 */     // GIR_Coverage, 6455,
     /* 422367 */     GIR_EraseRootFromParent_Done,
     /* 422368 */   // Label 8266: @422368
     /* 422368 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(422406), // Rule ID 1921 //
     /* 422373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422392 */     // MIs[1] Operand 1
     /* 422392 */     // No operand predicates
     /* 422392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422394 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422404 */     GIR_RootConstrainSelectedInstOperands,
     /* 422405 */     // GIR_Coverage, 1921,
     /* 422405 */     GIR_EraseRootFromParent_Done,
     /* 422406 */   // Label 8267: @422406
     /* 422406 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(422441), // Rule ID 5654 //
     /* 422411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 422427 */     // MIs[1] Operand 1
     /* 422427 */     // No operand predicates
     /* 422427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422429 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 422429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422439 */     GIR_RootConstrainSelectedInstOperands,
     /* 422440 */     // GIR_Coverage, 5654,
     /* 422440 */     GIR_EraseRootFromParent_Done,
     /* 422441 */   // Label 8268: @422441
     /* 422441 */   GIM_Reject,
     /* 422442 */ // Label 8265: @422442
     /* 422442 */ GIM_Reject,
     /* 422443 */ // Label 8261: @422443
     /* 422443 */ GIM_Reject,
     /* 422444 */ // Label 127: @422444
     /* 422444 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(422589),
     /* 422449 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 422452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 422455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422462 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(422513), // Rule ID 6456 //
     /* 422467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422482 */     // MIs[1] Rn
     /* 422482 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422497 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422511 */     GIR_RootConstrainSelectedInstOperands,
     /* 422512 */     // GIR_Coverage, 6456,
     /* 422512 */     GIR_EraseRootFromParent_Done,
     /* 422513 */   // Label 8270: @422513
     /* 422513 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(422588),
     /* 422518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422522 */     GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(422556), // Rule ID 1919 //
     /* 422527 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422530 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422534 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422538 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 422542 */       // MIs[1] Operand 1
     /* 422542 */       // No operand predicates
     /* 422542 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422544 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422544 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422547 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422549 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422551 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422554 */       GIR_RootConstrainSelectedInstOperands,
     /* 422555 */       // GIR_Coverage, 1919,
     /* 422555 */       GIR_EraseRootFromParent_Done,
     /* 422556 */     // Label 8272: @422556
     /* 422556 */     GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(422587), // Rule ID 5655 //
     /* 422561 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422565 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422569 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 422573 */       // MIs[1] Operand 1
     /* 422573 */       // No operand predicates
     /* 422573 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422575 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 422575 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422578 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422580 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422582 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422585 */       GIR_RootConstrainSelectedInstOperands,
     /* 422586 */       // GIR_Coverage, 5655,
     /* 422586 */       GIR_EraseRootFromParent_Done,
     /* 422587 */     // Label 8273: @422587
     /* 422587 */     GIM_Reject,
     /* 422588 */   // Label 8271: @422588
     /* 422588 */   GIM_Reject,
     /* 422589 */ // Label 8269: @422589
     /* 422589 */ GIM_Reject,
     /* 422590 */ // Label 128: @422590
     /* 422590 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8276*/ GIMT_Encode4(422768),
     /* 422601 */ /*GILLT_v8s8*//*Label 8274*/ GIMT_Encode4(422613), GIMT_Encode4(0),
     /* 422609 */ /*GILLT_v16s8*//*Label 8275*/ GIMT_Encode4(422662),
     /* 422613 */ // Label 8274: @422613
     /* 422613 */ GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(422661), // Rule ID 1924 //
     /* 422618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422635 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422639 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422643 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 422647 */   // MIs[1] Operand 1
     /* 422647 */   // No operand predicates
     /* 422647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422649 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 422652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422654 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422656 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422659 */   GIR_RootConstrainSelectedInstOperands,
     /* 422660 */   // GIR_Coverage, 1924,
     /* 422660 */   GIR_EraseRootFromParent_Done,
     /* 422661 */ // Label 8277: @422661
     /* 422661 */ GIM_Reject,
     /* 422662 */ // Label 8275: @422662
     /* 422662 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(422767),
     /* 422667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422677 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(422728), // Rule ID 6451 //
     /* 422682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422697 */     // MIs[1] Rn
     /* 422697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422712 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422726 */     GIR_RootConstrainSelectedInstOperands,
     /* 422727 */     // GIR_Coverage, 6451,
     /* 422727 */     GIR_EraseRootFromParent_Done,
     /* 422728 */   // Label 8279: @422728
     /* 422728 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(422766), // Rule ID 1925 //
     /* 422733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 422752 */     // MIs[1] Operand 1
     /* 422752 */     // No operand predicates
     /* 422752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422754 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 422757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422764 */     GIR_RootConstrainSelectedInstOperands,
     /* 422765 */     // GIR_Coverage, 1925,
     /* 422765 */     GIR_EraseRootFromParent_Done,
     /* 422766 */   // Label 8280: @422766
     /* 422766 */   GIM_Reject,
     /* 422767 */ // Label 8278: @422767
     /* 422767 */ GIM_Reject,
     /* 422768 */ // Label 8276: @422768
     /* 422768 */ GIM_Reject,
     /* 422769 */ // Label 129: @422769
     /* 422769 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8290*/ GIMT_Encode4(424418),
     /* 422780 */ /*GILLT_s64*//*Label 8281*/ GIMT_Encode4(422864), GIMT_Encode4(0),
     /* 422788 */ /*GILLT_v2s32*//*Label 8282*/ GIMT_Encode4(423185),
     /* 422792 */ /*GILLT_v2s64*//*Label 8283*/ GIMT_Encode4(423506),
     /* 422796 */ /*GILLT_v4s16*//*Label 8284*/ GIMT_Encode4(423589),
     /* 422800 */ /*GILLT_v4s32*//*Label 8285*/ GIMT_Encode4(423910),
     /* 422804 */ /*GILLT_v8s8*//*Label 8286*/ GIMT_Encode4(423993),
     /* 422808 */ /*GILLT_v8s16*//*Label 8287*/ GIMT_Encode4(424202),
     /* 422812 */ /*GILLT_v16s8*//*Label 8288*/ GIMT_Encode4(424285), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422860 */ /*GILLT_nxv16s8*//*Label 8289*/ GIMT_Encode4(424371),
     /* 422864 */ // Label 8281: @422864
     /* 422864 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(423184),
     /* 422869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 422872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422879 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(422994), // Rule ID 5472 //
     /* 422884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 422892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 422896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422901 */     // MIs[1] Operand 2
     /* 422901 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 422912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 422920 */     // MIs[2] Rn
     /* 422920 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422925 */     // MIs[2] Operand 2
     /* 422925 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 422936 */     // MIs[0] imm
     /* 422936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 422940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422944 */     // MIs[3] Operand 1
     /* 422944 */     // No operand predicates
     /* 422944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422946 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 422946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 422949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 422953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 422969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 422971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 422974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 422976 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 422983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422993 */     // GIR_Coverage, 5472,
     /* 422993 */     GIR_EraseRootFromParent_Done,
     /* 422994 */   // Label 8292: @422994
     /* 422994 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(423109), // Rule ID 5477 //
     /* 422999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423016 */     // MIs[1] Operand 2
     /* 423016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423035 */     // MIs[2] Rn
     /* 423035 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423040 */     // MIs[2] Operand 2
     /* 423040 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423051 */     // MIs[0] imm
     /* 423051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423059 */     // MIs[3] Operand 1
     /* 423059 */     // No operand predicates
     /* 423059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423061 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423091 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423108 */     // GIR_Coverage, 5477,
     /* 423108 */     GIR_EraseRootFromParent_Done,
     /* 423109 */   // Label 8293: @423109
     /* 423109 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(423146), // Rule ID 5469 //
     /* 423114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423122 */     // MIs[0] imm
     /* 423122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423130 */     // MIs[1] Operand 1
     /* 423130 */     // No operand predicates
     /* 423130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423132 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423144 */     GIR_RootConstrainSelectedInstOperands,
     /* 423145 */     // GIR_Coverage, 5469,
     /* 423145 */     GIR_EraseRootFromParent_Done,
     /* 423146 */   // Label 8294: @423146
     /* 423146 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(423183), // Rule ID 5474 //
     /* 423151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423159 */     // MIs[0] imm
     /* 423159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423167 */     // MIs[1] Operand 1
     /* 423167 */     // No operand predicates
     /* 423167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423169 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423181 */     GIR_RootConstrainSelectedInstOperands,
     /* 423182 */     // GIR_Coverage, 5474,
     /* 423182 */     GIR_EraseRootFromParent_Done,
     /* 423183 */   // Label 8295: @423183
     /* 423183 */   GIM_Reject,
     /* 423184 */ // Label 8291: @423184
     /* 423184 */ GIM_Reject,
     /* 423185 */ // Label 8282: @423185
     /* 423185 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(423505),
     /* 423190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 423193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 423196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423200 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(423315), // Rule ID 5462 //
     /* 423205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423222 */     // MIs[1] Operand 2
     /* 423222 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423241 */     // MIs[2] Rn
     /* 423241 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423246 */     // MIs[2] Operand 2
     /* 423246 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 423257 */     // MIs[0] imm
     /* 423257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423265 */     // MIs[3] Operand 1
     /* 423265 */     // No operand predicates
     /* 423265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423267 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423297 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423314 */     // GIR_Coverage, 5462,
     /* 423314 */     GIR_EraseRootFromParent_Done,
     /* 423315 */   // Label 8297: @423315
     /* 423315 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(423430), // Rule ID 5467 //
     /* 423320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423337 */     // MIs[1] Operand 2
     /* 423337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423356 */     // MIs[2] Rn
     /* 423356 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423361 */     // MIs[2] Operand 2
     /* 423361 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 423372 */     // MIs[0] imm
     /* 423372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423380 */     // MIs[3] Operand 1
     /* 423380 */     // No operand predicates
     /* 423380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423382 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423429 */     // GIR_Coverage, 5467,
     /* 423429 */     GIR_EraseRootFromParent_Done,
     /* 423430 */   // Label 8298: @423430
     /* 423430 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(423467), // Rule ID 5459 //
     /* 423435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423443 */     // MIs[0] imm
     /* 423443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423451 */     // MIs[1] Operand 1
     /* 423451 */     // No operand predicates
     /* 423451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423453 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423465 */     GIR_RootConstrainSelectedInstOperands,
     /* 423466 */     // GIR_Coverage, 5459,
     /* 423466 */     GIR_EraseRootFromParent_Done,
     /* 423467 */   // Label 8299: @423467
     /* 423467 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(423504), // Rule ID 5464 //
     /* 423472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423480 */     // MIs[0] imm
     /* 423480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423488 */     // MIs[1] Operand 1
     /* 423488 */     // No operand predicates
     /* 423488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423490 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423502 */     GIR_RootConstrainSelectedInstOperands,
     /* 423503 */     // GIR_Coverage, 5464,
     /* 423503 */     GIR_EraseRootFromParent_Done,
     /* 423504 */   // Label 8300: @423504
     /* 423504 */   GIM_Reject,
     /* 423505 */ // Label 8296: @423505
     /* 423505 */ GIM_Reject,
     /* 423506 */ // Label 8283: @423506
     /* 423506 */ GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(423588),
     /* 423511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 423517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423529 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(423558), // Rule ID 5470 //
     /* 423534 */     // MIs[0] imm
     /* 423534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423542 */     // MIs[1] Operand 1
     /* 423542 */     // No operand predicates
     /* 423542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423544 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423556 */     GIR_RootConstrainSelectedInstOperands,
     /* 423557 */     // GIR_Coverage, 5470,
     /* 423557 */     GIR_EraseRootFromParent_Done,
     /* 423558 */   // Label 8302: @423558
     /* 423558 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(423587), // Rule ID 5475 //
     /* 423563 */     // MIs[0] imm
     /* 423563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423571 */     // MIs[1] Operand 1
     /* 423571 */     // No operand predicates
     /* 423571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423573 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423585 */     GIR_RootConstrainSelectedInstOperands,
     /* 423586 */     // GIR_Coverage, 5475,
     /* 423586 */     GIR_EraseRootFromParent_Done,
     /* 423587 */   // Label 8303: @423587
     /* 423587 */   GIM_Reject,
     /* 423588 */ // Label 8301: @423588
     /* 423588 */ GIM_Reject,
     /* 423589 */ // Label 8284: @423589
     /* 423589 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(423909),
     /* 423594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 423597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 423600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423604 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(423719), // Rule ID 5452 //
     /* 423609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423626 */     // MIs[1] Operand 2
     /* 423626 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423645 */     // MIs[2] Rn
     /* 423645 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423650 */     // MIs[2] Operand 2
     /* 423650 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 423661 */     // MIs[0] imm
     /* 423661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423669 */     // MIs[3] Operand 1
     /* 423669 */     // No operand predicates
     /* 423669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423671 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423718 */     // GIR_Coverage, 5452,
     /* 423718 */     GIR_EraseRootFromParent_Done,
     /* 423719 */   // Label 8305: @423719
     /* 423719 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(423834), // Rule ID 5457 //
     /* 423724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423741 */     // MIs[1] Operand 2
     /* 423741 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423760 */     // MIs[2] Rn
     /* 423760 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423765 */     // MIs[2] Operand 2
     /* 423765 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 423776 */     // MIs[0] imm
     /* 423776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423784 */     // MIs[3] Operand 1
     /* 423784 */     // No operand predicates
     /* 423784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423786 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423816 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423833 */     // GIR_Coverage, 5457,
     /* 423833 */     GIR_EraseRootFromParent_Done,
     /* 423834 */   // Label 8306: @423834
     /* 423834 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(423871), // Rule ID 5449 //
     /* 423839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423847 */     // MIs[0] imm
     /* 423847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423855 */     // MIs[1] Operand 1
     /* 423855 */     // No operand predicates
     /* 423855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423857 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423869 */     GIR_RootConstrainSelectedInstOperands,
     /* 423870 */     // GIR_Coverage, 5449,
     /* 423870 */     GIR_EraseRootFromParent_Done,
     /* 423871 */   // Label 8307: @423871
     /* 423871 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(423908), // Rule ID 5454 //
     /* 423876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423884 */     // MIs[0] imm
     /* 423884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423892 */     // MIs[1] Operand 1
     /* 423892 */     // No operand predicates
     /* 423892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423894 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 423897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423906 */     GIR_RootConstrainSelectedInstOperands,
     /* 423907 */     // GIR_Coverage, 5454,
     /* 423907 */     GIR_EraseRootFromParent_Done,
     /* 423908 */   // Label 8308: @423908
     /* 423908 */   GIM_Reject,
     /* 423909 */ // Label 8304: @423909
     /* 423909 */ GIM_Reject,
     /* 423910 */ // Label 8285: @423910
     /* 423910 */ GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(423992),
     /* 423915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 423921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423933 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(423962), // Rule ID 5460 //
     /* 423938 */     // MIs[0] imm
     /* 423938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423946 */     // MIs[1] Operand 1
     /* 423946 */     // No operand predicates
     /* 423946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423948 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423960 */     GIR_RootConstrainSelectedInstOperands,
     /* 423961 */     // GIR_Coverage, 5460,
     /* 423961 */     GIR_EraseRootFromParent_Done,
     /* 423962 */   // Label 8310: @423962
     /* 423962 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(423991), // Rule ID 5465 //
     /* 423967 */     // MIs[0] imm
     /* 423967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 423971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423975 */     // MIs[1] Operand 1
     /* 423975 */     // No operand predicates
     /* 423975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423977 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 423977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 423986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423989 */     GIR_RootConstrainSelectedInstOperands,
     /* 423990 */     // GIR_Coverage, 5465,
     /* 423990 */     GIR_EraseRootFromParent_Done,
     /* 423991 */   // Label 8311: @423991
     /* 423991 */   GIM_Reject,
     /* 423992 */ // Label 8309: @423992
     /* 423992 */ GIM_Reject,
     /* 423993 */ // Label 8286: @423993
     /* 423993 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(424201),
     /* 423998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 424001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 424004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424008 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(424123), // Rule ID 5447 //
     /* 424013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424030 */     // MIs[1] Operand 2
     /* 424030 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424049 */     // MIs[2] Rn
     /* 424049 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424054 */     // MIs[2] Operand 2
     /* 424054 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 424065 */     // MIs[0] imm
     /* 424065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424073 */     // MIs[3] Operand 1
     /* 424073 */     // No operand predicates
     /* 424073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424075 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424122 */     // GIR_Coverage, 5447,
     /* 424122 */     GIR_EraseRootFromParent_Done,
     /* 424123 */   // Label 8313: @424123
     /* 424123 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(424163), // Rule ID 1868 //
     /* 424128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424139 */     // MIs[0] imm
     /* 424139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424147 */     // MIs[1] Operand 1
     /* 424147 */     // No operand predicates
     /* 424147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424149 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424161 */     GIR_RootConstrainSelectedInstOperands,
     /* 424162 */     // GIR_Coverage, 1868,
     /* 424162 */     GIR_EraseRootFromParent_Done,
     /* 424163 */   // Label 8314: @424163
     /* 424163 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(424200), // Rule ID 5444 //
     /* 424168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424176 */     // MIs[0] imm
     /* 424176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424184 */     // MIs[1] Operand 1
     /* 424184 */     // No operand predicates
     /* 424184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424186 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424198 */     GIR_RootConstrainSelectedInstOperands,
     /* 424199 */     // GIR_Coverage, 5444,
     /* 424199 */     GIR_EraseRootFromParent_Done,
     /* 424200 */   // Label 8315: @424200
     /* 424200 */   GIM_Reject,
     /* 424201 */ // Label 8312: @424201
     /* 424201 */ GIM_Reject,
     /* 424202 */ // Label 8287: @424202
     /* 424202 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(424284),
     /* 424207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 424213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424225 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(424254), // Rule ID 5450 //
     /* 424230 */     // MIs[0] imm
     /* 424230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424238 */     // MIs[1] Operand 1
     /* 424238 */     // No operand predicates
     /* 424238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424240 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424252 */     GIR_RootConstrainSelectedInstOperands,
     /* 424253 */     // GIR_Coverage, 5450,
     /* 424253 */     GIR_EraseRootFromParent_Done,
     /* 424254 */   // Label 8317: @424254
     /* 424254 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424283), // Rule ID 5455 //
     /* 424259 */     // MIs[0] imm
     /* 424259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424267 */     // MIs[1] Operand 1
     /* 424267 */     // No operand predicates
     /* 424267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424269 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424281 */     GIR_RootConstrainSelectedInstOperands,
     /* 424282 */     // GIR_Coverage, 5455,
     /* 424282 */     GIR_EraseRootFromParent_Done,
     /* 424283 */   // Label 8318: @424283
     /* 424283 */   GIM_Reject,
     /* 424284 */ // Label 8316: @424284
     /* 424284 */ GIM_Reject,
     /* 424285 */ // Label 8288: @424285
     /* 424285 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(424370),
     /* 424290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 424296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424308 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(424340), // Rule ID 1869 //
     /* 424313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424316 */     // MIs[0] imm
     /* 424316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424324 */     // MIs[1] Operand 1
     /* 424324 */     // No operand predicates
     /* 424324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424326 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424338 */     GIR_RootConstrainSelectedInstOperands,
     /* 424339 */     // GIR_Coverage, 1869,
     /* 424339 */     GIR_EraseRootFromParent_Done,
     /* 424340 */   // Label 8320: @424340
     /* 424340 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(424369), // Rule ID 5445 //
     /* 424345 */     // MIs[0] imm
     /* 424345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424353 */     // MIs[1] Operand 1
     /* 424353 */     // No operand predicates
     /* 424353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424355 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424367 */     GIR_RootConstrainSelectedInstOperands,
     /* 424368 */     // GIR_Coverage, 5445,
     /* 424368 */     GIR_EraseRootFromParent_Done,
     /* 424369 */   // Label 8321: @424369
     /* 424369 */   GIM_Reject,
     /* 424370 */ // Label 8319: @424370
     /* 424370 */ GIM_Reject,
     /* 424371 */ // Label 8289: @424371
     /* 424371 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(424417), // Rule ID 2726 //
     /* 424376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 424379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 424382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 424385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 424389 */   // MIs[0] Op3
     /* 424389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424397 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 424401 */   // MIs[1] Operand 1
     /* 424401 */   // No operand predicates
     /* 424401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424403 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 424403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 424406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 424408 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 424410 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 424412 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 424415 */   GIR_RootConstrainSelectedInstOperands,
     /* 424416 */   // GIR_Coverage, 2726,
     /* 424416 */   GIR_EraseRootFromParent_Done,
     /* 424417 */ // Label 8322: @424417
     /* 424417 */ GIM_Reject,
     /* 424418 */ // Label 8290: @424418
     /* 424418 */ GIM_Reject,
     /* 424419 */ // Label 130: @424419
     /* 424419 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8330*/ GIMT_Encode4(424977),
     /* 424430 */ /*GILLT_s32*//*Label 8323*/ GIMT_Encode4(424466),
     /* 424434 */ /*GILLT_s64*//*Label 8324*/ GIMT_Encode4(424504), GIMT_Encode4(0),
     /* 424442 */ /*GILLT_v2s32*//*Label 8325*/ GIMT_Encode4(424602),
     /* 424446 */ /*GILLT_v2s64*//*Label 8326*/ GIMT_Encode4(424677),
     /* 424450 */ /*GILLT_v4s16*//*Label 8327*/ GIMT_Encode4(424752),
     /* 424454 */ /*GILLT_v4s32*//*Label 8328*/ GIMT_Encode4(424827), GIMT_Encode4(0),
     /* 424462 */ /*GILLT_v8s16*//*Label 8329*/ GIMT_Encode4(424902),
     /* 424466 */ // Label 8323: @424466
     /* 424466 */ GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(424503), // Rule ID 1622 //
     /* 424471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 424480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424492 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 424492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 424497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424501 */   GIR_RootConstrainSelectedInstOperands,
     /* 424502 */   // GIR_Coverage, 1622,
     /* 424502 */   GIR_Done,
     /* 424503 */ // Label 8331: @424503
     /* 424503 */ GIM_Reject,
     /* 424504 */ // Label 8324: @424504
     /* 424504 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(424601),
     /* 424509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 424512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424523 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(424554), // Rule ID 2506 //
     /* 424528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424545 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 424545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 424548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424552 */     GIR_RootConstrainSelectedInstOperands,
     /* 424553 */     // GIR_Coverage, 2506,
     /* 424553 */     GIR_EraseRootFromParent_Done,
     /* 424554 */   // Label 8333: @424554
     /* 424554 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(424577), // Rule ID 1621 //
     /* 424559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424566 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 424566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 424571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424575 */     GIR_RootConstrainSelectedInstOperands,
     /* 424576 */     // GIR_Coverage, 1621,
     /* 424576 */     GIR_Done,
     /* 424577 */   // Label 8334: @424577
     /* 424577 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(424600), // Rule ID 5224 //
     /* 424582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424589 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 424589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 424594 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424598 */     GIR_RootConstrainSelectedInstOperands,
     /* 424599 */     // GIR_Coverage, 5224,
     /* 424599 */     GIR_Done,
     /* 424600 */   // Label 8335: @424600
     /* 424600 */   GIM_Reject,
     /* 424601 */ // Label 8332: @424601
     /* 424601 */ GIM_Reject,
     /* 424602 */ // Label 8325: @424602
     /* 424602 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(424676),
     /* 424607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 424610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 424613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424621 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(424652), // Rule ID 773 //
     /* 424626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424633 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424639 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424643 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 424643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 424646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424650 */     GIR_RootConstrainSelectedInstOperands,
     /* 424651 */     // GIR_Coverage, 773,
     /* 424651 */     GIR_EraseRootFromParent_Done,
     /* 424652 */   // Label 8337: @424652
     /* 424652 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(424675), // Rule ID 1210 //
     /* 424657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424664 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 424664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 424669 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424673 */     GIR_RootConstrainSelectedInstOperands,
     /* 424674 */     // GIR_Coverage, 1210,
     /* 424674 */     GIR_Done,
     /* 424675 */   // Label 8338: @424675
     /* 424675 */   GIM_Reject,
     /* 424676 */ // Label 8336: @424676
     /* 424676 */ GIM_Reject,
     /* 424677 */ // Label 8326: @424677
     /* 424677 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(424751),
     /* 424682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 424688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424696 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(424727), // Rule ID 775 //
     /* 424701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424718 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 424718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 424721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424725 */     GIR_RootConstrainSelectedInstOperands,
     /* 424726 */     // GIR_Coverage, 775,
     /* 424726 */     GIR_EraseRootFromParent_Done,
     /* 424727 */   // Label 8340: @424727
     /* 424727 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(424750), // Rule ID 1212 //
     /* 424732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424739 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 424739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 424744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424748 */     GIR_RootConstrainSelectedInstOperands,
     /* 424749 */     // GIR_Coverage, 1212,
     /* 424749 */     GIR_Done,
     /* 424750 */   // Label 8341: @424750
     /* 424750 */   GIM_Reject,
     /* 424751 */ // Label 8339: @424751
     /* 424751 */ GIM_Reject,
     /* 424752 */ // Label 8327: @424752
     /* 424752 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(424826),
     /* 424757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 424760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 424763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424771 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(424802), // Rule ID 771 //
     /* 424776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424793 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 424793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 424796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424800 */     GIR_RootConstrainSelectedInstOperands,
     /* 424801 */     // GIR_Coverage, 771,
     /* 424801 */     GIR_EraseRootFromParent_Done,
     /* 424802 */   // Label 8343: @424802
     /* 424802 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(424825), // Rule ID 1208 //
     /* 424807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424814 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 424814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 424819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424823 */     GIR_RootConstrainSelectedInstOperands,
     /* 424824 */     // GIR_Coverage, 1208,
     /* 424824 */     GIR_Done,
     /* 424825 */   // Label 8344: @424825
     /* 424825 */   GIM_Reject,
     /* 424826 */ // Label 8342: @424826
     /* 424826 */ GIM_Reject,
     /* 424827 */ // Label 8328: @424827
     /* 424827 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(424901),
     /* 424832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 424838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424846 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(424877), // Rule ID 774 //
     /* 424851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424858 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424868 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 424868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 424871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424875 */     GIR_RootConstrainSelectedInstOperands,
     /* 424876 */     // GIR_Coverage, 774,
     /* 424876 */     GIR_EraseRootFromParent_Done,
     /* 424877 */   // Label 8346: @424877
     /* 424877 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(424900), // Rule ID 1211 //
     /* 424882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424889 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 424889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 424894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424898 */     GIR_RootConstrainSelectedInstOperands,
     /* 424899 */     // GIR_Coverage, 1211,
     /* 424899 */     GIR_Done,
     /* 424900 */   // Label 8347: @424900
     /* 424900 */   GIM_Reject,
     /* 424901 */ // Label 8345: @424901
     /* 424901 */ GIM_Reject,
     /* 424902 */ // Label 8329: @424902
     /* 424902 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(424976),
     /* 424907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 424913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424921 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(424952), // Rule ID 772 //
     /* 424926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424933 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 424939 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 424941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424943 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 424943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 424946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424950 */     GIR_RootConstrainSelectedInstOperands,
     /* 424951 */     // GIR_Coverage, 772,
     /* 424951 */     GIR_EraseRootFromParent_Done,
     /* 424952 */   // Label 8349: @424952
     /* 424952 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(424975), // Rule ID 1209 //
     /* 424957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 424960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424964 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 424964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 424969 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 424973 */     GIR_RootConstrainSelectedInstOperands,
     /* 424974 */     // GIR_Coverage, 1209,
     /* 424974 */     GIR_Done,
     /* 424975 */   // Label 8350: @424975
     /* 424975 */   GIM_Reject,
     /* 424976 */ // Label 8348: @424976
     /* 424976 */ GIM_Reject,
     /* 424977 */ // Label 8330: @424977
     /* 424977 */ GIM_Reject,
     /* 424978 */ // Label 131: @424978
     /* 424978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8358*/ GIMT_Encode4(426069),
     /* 424989 */ /*GILLT_s32*//*Label 8351*/ GIMT_Encode4(425025),
     /* 424993 */ /*GILLT_s64*//*Label 8352*/ GIMT_Encode4(425063), GIMT_Encode4(0),
     /* 425001 */ /*GILLT_v2s32*//*Label 8353*/ GIMT_Encode4(425204),
     /* 425005 */ /*GILLT_v2s64*//*Label 8354*/ GIMT_Encode4(425377),
     /* 425009 */ /*GILLT_v4s16*//*Label 8355*/ GIMT_Encode4(425550),
     /* 425013 */ /*GILLT_v4s32*//*Label 8356*/ GIMT_Encode4(425723), GIMT_Encode4(0),
     /* 425021 */ /*GILLT_v8s16*//*Label 8357*/ GIMT_Encode4(425896),
     /* 425025 */ // Label 8351: @425025
     /* 425025 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(425062), // Rule ID 1624 //
     /* 425030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425051 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 425056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425060 */   GIR_RootConstrainSelectedInstOperands,
     /* 425061 */   // GIR_Coverage, 1624,
     /* 425061 */   GIR_Done,
     /* 425062 */ // Label 8359: @425062
     /* 425062 */ GIM_Reject,
     /* 425063 */ // Label 8352: @425063
     /* 425063 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(425203),
     /* 425068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425078 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(425113), // Rule ID 5258 //
     /* 425083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425104 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 425107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425111 */     GIR_RootConstrainSelectedInstOperands,
     /* 425112 */     // GIR_Coverage, 5258,
     /* 425112 */     GIR_EraseRootFromParent_Done,
     /* 425113 */   // Label 8361: @425113
     /* 425113 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(425148), // Rule ID 5256 //
     /* 425118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425139 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 425142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425146 */     GIR_RootConstrainSelectedInstOperands,
     /* 425147 */     // GIR_Coverage, 5256,
     /* 425147 */     GIR_EraseRootFromParent_Done,
     /* 425148 */   // Label 8362: @425148
     /* 425148 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(425175), // Rule ID 1623 //
     /* 425153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425164 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 425164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425169 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425173 */     GIR_RootConstrainSelectedInstOperands,
     /* 425174 */     // GIR_Coverage, 1623,
     /* 425174 */     GIR_Done,
     /* 425175 */   // Label 8363: @425175
     /* 425175 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(425202), // Rule ID 5225 //
     /* 425180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425191 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 425191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 425196 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425200 */     GIR_RootConstrainSelectedInstOperands,
     /* 425201 */     // GIR_Coverage, 5225,
     /* 425201 */     GIR_Done,
     /* 425202 */   // Label 8364: @425202
     /* 425202 */   GIM_Reject,
     /* 425203 */ // Label 8360: @425203
     /* 425203 */ GIM_Reject,
     /* 425204 */ // Label 8353: @425204
     /* 425204 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(425376),
     /* 425209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425219 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(425278), // Rule ID 1172 //
     /* 425224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425263 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 425266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425276 */     GIR_RootConstrainSelectedInstOperands,
     /* 425277 */     // GIR_Coverage, 1172,
     /* 425277 */     GIR_EraseRootFromParent_Done,
     /* 425278 */   // Label 8366: @425278
     /* 425278 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(425313), // Rule ID 788 //
     /* 425283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425290 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425296 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425304 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 425307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425311 */     GIR_RootConstrainSelectedInstOperands,
     /* 425312 */     // GIR_Coverage, 788,
     /* 425312 */     GIR_EraseRootFromParent_Done,
     /* 425313 */   // Label 8367: @425313
     /* 425313 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(425348), // Rule ID 778 //
     /* 425318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425329 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425335 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425339 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 425342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425346 */     GIR_RootConstrainSelectedInstOperands,
     /* 425347 */     // GIR_Coverage, 778,
     /* 425347 */     GIR_EraseRootFromParent_Done,
     /* 425348 */   // Label 8368: @425348
     /* 425348 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(425375), // Rule ID 1215 //
     /* 425353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425364 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 425369 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425373 */     GIR_RootConstrainSelectedInstOperands,
     /* 425374 */     // GIR_Coverage, 1215,
     /* 425374 */     GIR_Done,
     /* 425375 */   // Label 8369: @425375
     /* 425375 */   GIM_Reject,
     /* 425376 */ // Label 8365: @425376
     /* 425376 */ GIM_Reject,
     /* 425377 */ // Label 8354: @425377
     /* 425377 */ GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(425549),
     /* 425382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425392 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(425451), // Rule ID 1176 //
     /* 425397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425436 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 425439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425449 */     GIR_RootConstrainSelectedInstOperands,
     /* 425450 */     // GIR_Coverage, 1176,
     /* 425450 */     GIR_EraseRootFromParent_Done,
     /* 425451 */   // Label 8371: @425451
     /* 425451 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(425486), // Rule ID 790 //
     /* 425456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425477 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 425480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425484 */     GIR_RootConstrainSelectedInstOperands,
     /* 425485 */     // GIR_Coverage, 790,
     /* 425485 */     GIR_EraseRootFromParent_Done,
     /* 425486 */   // Label 8372: @425486
     /* 425486 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(425521), // Rule ID 780 //
     /* 425491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425502 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425508 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425512 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 425515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425519 */     GIR_RootConstrainSelectedInstOperands,
     /* 425520 */     // GIR_Coverage, 780,
     /* 425520 */     GIR_EraseRootFromParent_Done,
     /* 425521 */   // Label 8373: @425521
     /* 425521 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(425548), // Rule ID 1217 //
     /* 425526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425537 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 425542 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425546 */     GIR_RootConstrainSelectedInstOperands,
     /* 425547 */     // GIR_Coverage, 1217,
     /* 425547 */     GIR_Done,
     /* 425548 */   // Label 8374: @425548
     /* 425548 */   GIM_Reject,
     /* 425549 */ // Label 8370: @425549
     /* 425549 */ GIM_Reject,
     /* 425550 */ // Label 8355: @425550
     /* 425550 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(425722),
     /* 425555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425565 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(425624), // Rule ID 1168 //
     /* 425570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425609 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 425612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425622 */     GIR_RootConstrainSelectedInstOperands,
     /* 425623 */     // GIR_Coverage, 1168,
     /* 425623 */     GIR_EraseRootFromParent_Done,
     /* 425624 */   // Label 8376: @425624
     /* 425624 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(425659), // Rule ID 786 //
     /* 425629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425650 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 425653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425657 */     GIR_RootConstrainSelectedInstOperands,
     /* 425658 */     // GIR_Coverage, 786,
     /* 425658 */     GIR_EraseRootFromParent_Done,
     /* 425659 */   // Label 8377: @425659
     /* 425659 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(425694), // Rule ID 776 //
     /* 425664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425681 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425685 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 425688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425692 */     GIR_RootConstrainSelectedInstOperands,
     /* 425693 */     // GIR_Coverage, 776,
     /* 425693 */     GIR_EraseRootFromParent_Done,
     /* 425694 */   // Label 8378: @425694
     /* 425694 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(425721), // Rule ID 1213 //
     /* 425699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425710 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 425715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425719 */     GIR_RootConstrainSelectedInstOperands,
     /* 425720 */     // GIR_Coverage, 1213,
     /* 425720 */     GIR_Done,
     /* 425721 */   // Label 8379: @425721
     /* 425721 */   GIM_Reject,
     /* 425722 */ // Label 8375: @425722
     /* 425722 */ GIM_Reject,
     /* 425723 */ // Label 8356: @425723
     /* 425723 */ GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(425895),
     /* 425728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425738 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(425797), // Rule ID 1174 //
     /* 425743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425782 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 425785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425795 */     GIR_RootConstrainSelectedInstOperands,
     /* 425796 */     // GIR_Coverage, 1174,
     /* 425796 */     GIR_EraseRootFromParent_Done,
     /* 425797 */   // Label 8381: @425797
     /* 425797 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(425832), // Rule ID 789 //
     /* 425802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425809 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425815 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425823 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 425826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 425830 */     GIR_RootConstrainSelectedInstOperands,
     /* 425831 */     // GIR_Coverage, 789,
     /* 425831 */     GIR_EraseRootFromParent_Done,
     /* 425832 */   // Label 8382: @425832
     /* 425832 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(425867), // Rule ID 779 //
     /* 425837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425858 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 425861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425865 */     GIR_RootConstrainSelectedInstOperands,
     /* 425866 */     // GIR_Coverage, 779,
     /* 425866 */     GIR_EraseRootFromParent_Done,
     /* 425867 */   // Label 8383: @425867
     /* 425867 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(425894), // Rule ID 1216 //
     /* 425872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425883 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 425888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425892 */     GIR_RootConstrainSelectedInstOperands,
     /* 425893 */     // GIR_Coverage, 1216,
     /* 425893 */     GIR_Done,
     /* 425894 */   // Label 8384: @425894
     /* 425894 */   GIM_Reject,
     /* 425895 */ // Label 8380: @425895
     /* 425895 */ GIM_Reject,
     /* 425896 */ // Label 8357: @425896
     /* 425896 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(426068),
     /* 425901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425911 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(425970), // Rule ID 1170 //
     /* 425916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 425944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 425955 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 425955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 425958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 425968 */     GIR_RootConstrainSelectedInstOperands,
     /* 425969 */     // GIR_Coverage, 1170,
     /* 425969 */     GIR_EraseRootFromParent_Done,
     /* 425970 */   // Label 8386: @425970
     /* 425970 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(426005), // Rule ID 787 //
     /* 425975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425996 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 425996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 425999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426003 */     GIR_RootConstrainSelectedInstOperands,
     /* 426004 */     // GIR_Coverage, 787,
     /* 426004 */     GIR_EraseRootFromParent_Done,
     /* 426005 */   // Label 8387: @426005
     /* 426005 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(426040), // Rule ID 777 //
     /* 426010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426021 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426027 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426031 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 426034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426038 */     GIR_RootConstrainSelectedInstOperands,
     /* 426039 */     // GIR_Coverage, 777,
     /* 426039 */     GIR_EraseRootFromParent_Done,
     /* 426040 */   // Label 8388: @426040
     /* 426040 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(426067), // Rule ID 1214 //
     /* 426045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426056 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 426061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426065 */     GIR_RootConstrainSelectedInstOperands,
     /* 426066 */     // GIR_Coverage, 1214,
     /* 426066 */     GIR_Done,
     /* 426067 */   // Label 8389: @426067
     /* 426067 */   GIM_Reject,
     /* 426068 */ // Label 8385: @426068
     /* 426068 */ GIM_Reject,
     /* 426069 */ // Label 8358: @426069
     /* 426069 */ GIM_Reject,
     /* 426070 */ // Label 132: @426070
     /* 426070 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8397*/ GIMT_Encode4(427161),
     /* 426081 */ /*GILLT_s32*//*Label 8390*/ GIMT_Encode4(426117),
     /* 426085 */ /*GILLT_s64*//*Label 8391*/ GIMT_Encode4(426155), GIMT_Encode4(0),
     /* 426093 */ /*GILLT_v2s32*//*Label 8392*/ GIMT_Encode4(426296),
     /* 426097 */ /*GILLT_v2s64*//*Label 8393*/ GIMT_Encode4(426469),
     /* 426101 */ /*GILLT_v4s16*//*Label 8394*/ GIMT_Encode4(426642),
     /* 426105 */ /*GILLT_v4s32*//*Label 8395*/ GIMT_Encode4(426815), GIMT_Encode4(0),
     /* 426113 */ /*GILLT_v8s16*//*Label 8396*/ GIMT_Encode4(426988),
     /* 426117 */ // Label 8390: @426117
     /* 426117 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(426154), // Rule ID 1626 //
     /* 426122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426143 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 426148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426152 */   GIR_RootConstrainSelectedInstOperands,
     /* 426153 */   // GIR_Coverage, 1626,
     /* 426153 */   GIR_Done,
     /* 426154 */ // Label 8398: @426154
     /* 426154 */ GIM_Reject,
     /* 426155 */ // Label 8391: @426155
     /* 426155 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(426295),
     /* 426160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426170 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(426205), // Rule ID 5259 //
     /* 426175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426182 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426188 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426196 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 426199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426203 */     GIR_RootConstrainSelectedInstOperands,
     /* 426204 */     // GIR_Coverage, 5259,
     /* 426204 */     GIR_EraseRootFromParent_Done,
     /* 426205 */   // Label 8400: @426205
     /* 426205 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(426240), // Rule ID 5257 //
     /* 426210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426221 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426227 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426231 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 426234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426238 */     GIR_RootConstrainSelectedInstOperands,
     /* 426239 */     // GIR_Coverage, 5257,
     /* 426239 */     GIR_EraseRootFromParent_Done,
     /* 426240 */   // Label 8401: @426240
     /* 426240 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(426267), // Rule ID 1625 //
     /* 426245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426256 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426261 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426265 */     GIR_RootConstrainSelectedInstOperands,
     /* 426266 */     // GIR_Coverage, 1625,
     /* 426266 */     GIR_Done,
     /* 426267 */   // Label 8402: @426267
     /* 426267 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(426294), // Rule ID 5226 //
     /* 426272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426283 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 426288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426292 */     GIR_RootConstrainSelectedInstOperands,
     /* 426293 */     // GIR_Coverage, 5226,
     /* 426293 */     GIR_Done,
     /* 426294 */   // Label 8403: @426294
     /* 426294 */   GIM_Reject,
     /* 426295 */ // Label 8399: @426295
     /* 426295 */ GIM_Reject,
     /* 426296 */ // Label 8392: @426296
     /* 426296 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(426468),
     /* 426301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426311 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(426370), // Rule ID 1182 //
     /* 426316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426355 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 426358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426368 */     GIR_RootConstrainSelectedInstOperands,
     /* 426369 */     // GIR_Coverage, 1182,
     /* 426369 */     GIR_EraseRootFromParent_Done,
     /* 426370 */   // Label 8405: @426370
     /* 426370 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(426405), // Rule ID 793 //
     /* 426375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426382 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426388 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426396 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 426399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426403 */     GIR_RootConstrainSelectedInstOperands,
     /* 426404 */     // GIR_Coverage, 793,
     /* 426404 */     GIR_EraseRootFromParent_Done,
     /* 426405 */   // Label 8406: @426405
     /* 426405 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(426440), // Rule ID 783 //
     /* 426410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426421 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426427 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426431 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 426434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426438 */     GIR_RootConstrainSelectedInstOperands,
     /* 426439 */     // GIR_Coverage, 783,
     /* 426439 */     GIR_EraseRootFromParent_Done,
     /* 426440 */   // Label 8407: @426440
     /* 426440 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(426467), // Rule ID 1220 //
     /* 426445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426456 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 426461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426465 */     GIR_RootConstrainSelectedInstOperands,
     /* 426466 */     // GIR_Coverage, 1220,
     /* 426466 */     GIR_Done,
     /* 426467 */   // Label 8408: @426467
     /* 426467 */   GIM_Reject,
     /* 426468 */ // Label 8404: @426468
     /* 426468 */ GIM_Reject,
     /* 426469 */ // Label 8393: @426469
     /* 426469 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(426641),
     /* 426474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426484 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(426543), // Rule ID 1186 //
     /* 426489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426528 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 426531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426541 */     GIR_RootConstrainSelectedInstOperands,
     /* 426542 */     // GIR_Coverage, 1186,
     /* 426542 */     GIR_EraseRootFromParent_Done,
     /* 426543 */   // Label 8410: @426543
     /* 426543 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(426578), // Rule ID 795 //
     /* 426548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426569 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 426572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426576 */     GIR_RootConstrainSelectedInstOperands,
     /* 426577 */     // GIR_Coverage, 795,
     /* 426577 */     GIR_EraseRootFromParent_Done,
     /* 426578 */   // Label 8411: @426578
     /* 426578 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(426613), // Rule ID 785 //
     /* 426583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426604 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 426607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426611 */     GIR_RootConstrainSelectedInstOperands,
     /* 426612 */     // GIR_Coverage, 785,
     /* 426612 */     GIR_EraseRootFromParent_Done,
     /* 426613 */   // Label 8412: @426613
     /* 426613 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(426640), // Rule ID 1222 //
     /* 426618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426629 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 426634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426638 */     GIR_RootConstrainSelectedInstOperands,
     /* 426639 */     // GIR_Coverage, 1222,
     /* 426639 */     GIR_Done,
     /* 426640 */   // Label 8413: @426640
     /* 426640 */   GIM_Reject,
     /* 426641 */ // Label 8409: @426641
     /* 426641 */ GIM_Reject,
     /* 426642 */ // Label 8394: @426642
     /* 426642 */ GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(426814),
     /* 426647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426657 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(426716), // Rule ID 1178 //
     /* 426662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426701 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 426704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426714 */     GIR_RootConstrainSelectedInstOperands,
     /* 426715 */     // GIR_Coverage, 1178,
     /* 426715 */     GIR_EraseRootFromParent_Done,
     /* 426716 */   // Label 8415: @426716
     /* 426716 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(426751), // Rule ID 791 //
     /* 426721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426728 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426734 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426742 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 426745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426749 */     GIR_RootConstrainSelectedInstOperands,
     /* 426750 */     // GIR_Coverage, 791,
     /* 426750 */     GIR_EraseRootFromParent_Done,
     /* 426751 */   // Label 8416: @426751
     /* 426751 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(426786), // Rule ID 781 //
     /* 426756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426777 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 426780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426784 */     GIR_RootConstrainSelectedInstOperands,
     /* 426785 */     // GIR_Coverage, 781,
     /* 426785 */     GIR_EraseRootFromParent_Done,
     /* 426786 */   // Label 8417: @426786
     /* 426786 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(426813), // Rule ID 1218 //
     /* 426791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426802 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 426807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426811 */     GIR_RootConstrainSelectedInstOperands,
     /* 426812 */     // GIR_Coverage, 1218,
     /* 426812 */     GIR_Done,
     /* 426813 */   // Label 8418: @426813
     /* 426813 */   GIM_Reject,
     /* 426814 */ // Label 8414: @426814
     /* 426814 */ GIM_Reject,
     /* 426815 */ // Label 8395: @426815
     /* 426815 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(426987),
     /* 426820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426830 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(426889), // Rule ID 1184 //
     /* 426835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426874 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 426877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426887 */     GIR_RootConstrainSelectedInstOperands,
     /* 426888 */     // GIR_Coverage, 1184,
     /* 426888 */     GIR_EraseRootFromParent_Done,
     /* 426889 */   // Label 8420: @426889
     /* 426889 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(426924), // Rule ID 794 //
     /* 426894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426901 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426907 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426915 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 426918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426922 */     GIR_RootConstrainSelectedInstOperands,
     /* 426923 */     // GIR_Coverage, 794,
     /* 426923 */     GIR_EraseRootFromParent_Done,
     /* 426924 */   // Label 8421: @426924
     /* 426924 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(426959), // Rule ID 784 //
     /* 426929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426950 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 426953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426957 */     GIR_RootConstrainSelectedInstOperands,
     /* 426958 */     // GIR_Coverage, 784,
     /* 426958 */     GIR_EraseRootFromParent_Done,
     /* 426959 */   // Label 8422: @426959
     /* 426959 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(426986), // Rule ID 1221 //
     /* 426964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426975 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 426980 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426984 */     GIR_RootConstrainSelectedInstOperands,
     /* 426985 */     // GIR_Coverage, 1221,
     /* 426985 */     GIR_Done,
     /* 426986 */   // Label 8423: @426986
     /* 426986 */   GIM_Reject,
     /* 426987 */ // Label 8419: @426987
     /* 426987 */ GIM_Reject,
     /* 426988 */ // Label 8396: @426988
     /* 426988 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(427160),
     /* 426993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427003 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(427062), // Rule ID 1180 //
     /* 427008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427047 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 427050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427060 */     GIR_RootConstrainSelectedInstOperands,
     /* 427061 */     // GIR_Coverage, 1180,
     /* 427061 */     GIR_EraseRootFromParent_Done,
     /* 427062 */   // Label 8425: @427062
     /* 427062 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(427097), // Rule ID 792 //
     /* 427067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427074 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427080 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427088 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 427091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427095 */     GIR_RootConstrainSelectedInstOperands,
     /* 427096 */     // GIR_Coverage, 792,
     /* 427096 */     GIR_EraseRootFromParent_Done,
     /* 427097 */   // Label 8426: @427097
     /* 427097 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(427132), // Rule ID 782 //
     /* 427102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427113 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427119 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427123 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 427126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427130 */     GIR_RootConstrainSelectedInstOperands,
     /* 427131 */     // GIR_Coverage, 782,
     /* 427131 */     GIR_EraseRootFromParent_Done,
     /* 427132 */   // Label 8427: @427132
     /* 427132 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(427159), // Rule ID 1219 //
     /* 427137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427148 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 427153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427157 */     GIR_RootConstrainSelectedInstOperands,
     /* 427158 */     // GIR_Coverage, 1219,
     /* 427158 */     GIR_Done,
     /* 427159 */   // Label 8428: @427159
     /* 427159 */   GIM_Reject,
     /* 427160 */ // Label 8424: @427160
     /* 427160 */ GIM_Reject,
     /* 427161 */ // Label 8397: @427161
     /* 427161 */ GIM_Reject,
     /* 427162 */ // Label 133: @427162
     /* 427162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8433*/ GIMT_Encode4(427315),
     /* 427173 */ /*GILLT_s32*//*Label 8429*/ GIMT_Encode4(427213),
     /* 427177 */ /*GILLT_s64*//*Label 8430*/ GIMT_Encode4(427237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 427201 */ /*GILLT_v8s8*//*Label 8431*/ GIMT_Encode4(427261), GIMT_Encode4(0),
     /* 427209 */ /*GILLT_v16s8*//*Label 8432*/ GIMT_Encode4(427288),
     /* 427213 */ // Label 8429: @427213
     /* 427213 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(427236), // Rule ID 4012 //
     /* 427218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 427229 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 427229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 427234 */   GIR_RootConstrainSelectedInstOperands,
     /* 427235 */   // GIR_Coverage, 4012,
     /* 427235 */   GIR_Done,
     /* 427236 */ // Label 8434: @427236
     /* 427236 */ GIM_Reject,
     /* 427237 */ // Label 8430: @427237
     /* 427237 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(427260), // Rule ID 4013 //
     /* 427242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 427253 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 427253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 427258 */   GIR_RootConstrainSelectedInstOperands,
     /* 427259 */   // GIR_Coverage, 4013,
     /* 427259 */   GIR_Done,
     /* 427260 */ // Label 8435: @427260
     /* 427260 */ GIM_Reject,
     /* 427261 */ // Label 8431: @427261
     /* 427261 */ GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(427287), // Rule ID 976 //
     /* 427266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427280 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 427285 */   GIR_RootConstrainSelectedInstOperands,
     /* 427286 */   // GIR_Coverage, 976,
     /* 427286 */   GIR_Done,
     /* 427287 */ // Label 8436: @427287
     /* 427287 */ GIM_Reject,
     /* 427288 */ // Label 8432: @427288
     /* 427288 */ GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(427314), // Rule ID 977 //
     /* 427293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427307 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 427312 */   GIR_RootConstrainSelectedInstOperands,
     /* 427313 */   // GIR_Coverage, 977,
     /* 427313 */   GIR_Done,
     /* 427314 */ // Label 8437: @427314
     /* 427314 */ GIM_Reject,
     /* 427315 */ // Label 8433: @427315
     /* 427315 */ GIM_Reject,
     /* 427316 */ // Label 134: @427316
     /* 427316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8442*/ GIMT_Encode4(427491),
     /* 427327 */ /*GILLT_v4s16*//*Label 8438*/ GIMT_Encode4(427347), GIMT_Encode4(0),
     /* 427335 */ /*GILLT_v8s8*//*Label 8439*/ GIMT_Encode4(427392),
     /* 427339 */ /*GILLT_v8s16*//*Label 8440*/ GIMT_Encode4(427419),
     /* 427343 */ /*GILLT_v16s8*//*Label 8441*/ GIMT_Encode4(427464),
     /* 427347 */ // Label 8438: @427347
     /* 427347 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(427391),
     /* 427352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427363 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(427378), // Rule ID 980 //
     /* 427368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427371 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 427371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 427376 */     GIR_RootConstrainSelectedInstOperands,
     /* 427377 */     // GIR_Coverage, 980,
     /* 427377 */     GIR_Done,
     /* 427378 */   // Label 8444: @427378
     /* 427378 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(427390), // Rule ID 4995 //
     /* 427383 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 427383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 427388 */     GIR_RootConstrainSelectedInstOperands,
     /* 427389 */     // GIR_Coverage, 4995,
     /* 427389 */     GIR_Done,
     /* 427390 */   // Label 8445: @427390
     /* 427390 */   GIM_Reject,
     /* 427391 */ // Label 8443: @427391
     /* 427391 */ GIM_Reject,
     /* 427392 */ // Label 8439: @427392
     /* 427392 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(427418), // Rule ID 978 //
     /* 427397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427411 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 427416 */   GIR_RootConstrainSelectedInstOperands,
     /* 427417 */   // GIR_Coverage, 978,
     /* 427417 */   GIR_Done,
     /* 427418 */ // Label 8446: @427418
     /* 427418 */ GIM_Reject,
     /* 427419 */ // Label 8440: @427419
     /* 427419 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(427463),
     /* 427424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427435 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(427450), // Rule ID 981 //
     /* 427440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427443 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 427443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 427448 */     GIR_RootConstrainSelectedInstOperands,
     /* 427449 */     // GIR_Coverage, 981,
     /* 427449 */     GIR_Done,
     /* 427450 */   // Label 8448: @427450
     /* 427450 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(427462), // Rule ID 4997 //
     /* 427455 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 427455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 427460 */     GIR_RootConstrainSelectedInstOperands,
     /* 427461 */     // GIR_Coverage, 4997,
     /* 427461 */     GIR_Done,
     /* 427462 */   // Label 8449: @427462
     /* 427462 */   GIM_Reject,
     /* 427463 */ // Label 8447: @427463
     /* 427463 */ GIM_Reject,
     /* 427464 */ // Label 8441: @427464
     /* 427464 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(427490), // Rule ID 979 //
     /* 427469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427483 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 427488 */   GIR_RootConstrainSelectedInstOperands,
     /* 427489 */   // GIR_Coverage, 979,
     /* 427489 */   GIR_Done,
     /* 427490 */ // Label 8450: @427490
     /* 427490 */ GIM_Reject,
     /* 427491 */ // Label 8442: @427491
     /* 427491 */ GIM_Reject,
     /* 427492 */ // Label 135: @427492
     /* 427492 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8457*/ GIMT_Encode4(427765),
     /* 427503 */ /*GILLT_v2s32*//*Label 8451*/ GIMT_Encode4(427531), GIMT_Encode4(0),
     /* 427511 */ /*GILLT_v4s16*//*Label 8452*/ GIMT_Encode4(427576),
     /* 427515 */ /*GILLT_v4s32*//*Label 8453*/ GIMT_Encode4(427621),
     /* 427519 */ /*GILLT_v8s8*//*Label 8454*/ GIMT_Encode4(427666),
     /* 427523 */ /*GILLT_v8s16*//*Label 8455*/ GIMT_Encode4(427693),
     /* 427527 */ /*GILLT_v16s8*//*Label 8456*/ GIMT_Encode4(427738),
     /* 427531 */ // Label 8451: @427531
     /* 427531 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(427575),
     /* 427536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427547 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(427562), // Rule ID 986 //
     /* 427552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427555 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 427555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 427560 */     GIR_RootConstrainSelectedInstOperands,
     /* 427561 */     // GIR_Coverage, 986,
     /* 427561 */     GIR_Done,
     /* 427562 */   // Label 8459: @427562
     /* 427562 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(427574), // Rule ID 4999 //
     /* 427567 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 427567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 427572 */     GIR_RootConstrainSelectedInstOperands,
     /* 427573 */     // GIR_Coverage, 4999,
     /* 427573 */     GIR_Done,
     /* 427574 */   // Label 8460: @427574
     /* 427574 */   GIM_Reject,
     /* 427575 */ // Label 8458: @427575
     /* 427575 */ GIM_Reject,
     /* 427576 */ // Label 8452: @427576
     /* 427576 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(427620),
     /* 427581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427592 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(427607), // Rule ID 984 //
     /* 427597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427600 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 427600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 427605 */     GIR_RootConstrainSelectedInstOperands,
     /* 427606 */     // GIR_Coverage, 984,
     /* 427606 */     GIR_Done,
     /* 427607 */   // Label 8462: @427607
     /* 427607 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(427619), // Rule ID 4996 //
     /* 427612 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 427612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 427617 */     GIR_RootConstrainSelectedInstOperands,
     /* 427618 */     // GIR_Coverage, 4996,
     /* 427618 */     GIR_Done,
     /* 427619 */   // Label 8463: @427619
     /* 427619 */   GIM_Reject,
     /* 427620 */ // Label 8461: @427620
     /* 427620 */ GIM_Reject,
     /* 427621 */ // Label 8453: @427621
     /* 427621 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(427665),
     /* 427626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427637 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(427652), // Rule ID 987 //
     /* 427642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427645 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 427645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 427650 */     GIR_RootConstrainSelectedInstOperands,
     /* 427651 */     // GIR_Coverage, 987,
     /* 427651 */     GIR_Done,
     /* 427652 */   // Label 8465: @427652
     /* 427652 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(427664), // Rule ID 5000 //
     /* 427657 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 427657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 427662 */     GIR_RootConstrainSelectedInstOperands,
     /* 427663 */     // GIR_Coverage, 5000,
     /* 427663 */     GIR_Done,
     /* 427664 */   // Label 8466: @427664
     /* 427664 */   GIM_Reject,
     /* 427665 */ // Label 8464: @427665
     /* 427665 */ GIM_Reject,
     /* 427666 */ // Label 8454: @427666
     /* 427666 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(427692), // Rule ID 982 //
     /* 427671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427685 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 427685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 427690 */   GIR_RootConstrainSelectedInstOperands,
     /* 427691 */   // GIR_Coverage, 982,
     /* 427691 */   GIR_Done,
     /* 427692 */ // Label 8467: @427692
     /* 427692 */ GIM_Reject,
     /* 427693 */ // Label 8455: @427693
     /* 427693 */ GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(427737),
     /* 427698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427709 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(427724), // Rule ID 985 //
     /* 427714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427717 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 427717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 427722 */     GIR_RootConstrainSelectedInstOperands,
     /* 427723 */     // GIR_Coverage, 985,
     /* 427723 */     GIR_Done,
     /* 427724 */   // Label 8469: @427724
     /* 427724 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(427736), // Rule ID 4998 //
     /* 427729 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 427729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 427734 */     GIR_RootConstrainSelectedInstOperands,
     /* 427735 */     // GIR_Coverage, 4998,
     /* 427735 */     GIR_Done,
     /* 427736 */   // Label 8470: @427736
     /* 427736 */   GIM_Reject,
     /* 427737 */ // Label 8468: @427737
     /* 427737 */ GIM_Reject,
     /* 427738 */ // Label 8456: @427738
     /* 427738 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(427764), // Rule ID 983 //
     /* 427743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427757 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 427757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 427762 */   GIR_RootConstrainSelectedInstOperands,
     /* 427763 */   // GIR_Coverage, 983,
     /* 427763 */   GIR_Done,
     /* 427764 */ // Label 8471: @427764
     /* 427764 */ GIM_Reject,
     /* 427765 */ // Label 8457: @427765
     /* 427765 */ GIM_Reject,
     /* 427766 */ // Label 136: @427766
     /* 427766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8478*/ GIMT_Encode4(427971),
     /* 427777 */ /*GILLT_s64*//*Label 8472*/ GIMT_Encode4(427809), GIMT_Encode4(0),
     /* 427785 */ /*GILLT_v2s32*//*Label 8473*/ GIMT_Encode4(427836),
     /* 427789 */ /*GILLT_v2s64*//*Label 8474*/ GIMT_Encode4(427863),
     /* 427793 */ /*GILLT_v4s16*//*Label 8475*/ GIMT_Encode4(427890),
     /* 427797 */ /*GILLT_v4s32*//*Label 8476*/ GIMT_Encode4(427917), GIMT_Encode4(0),
     /* 427805 */ /*GILLT_v8s16*//*Label 8477*/ GIMT_Encode4(427944),
     /* 427809 */ // Label 8472: @427809
     /* 427809 */ GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(427835), // Rule ID 1008 //
     /* 427814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427828 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 427828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 427833 */   GIR_RootConstrainSelectedInstOperands,
     /* 427834 */   // GIR_Coverage, 1008,
     /* 427834 */   GIR_Done,
     /* 427835 */ // Label 8479: @427835
     /* 427835 */ GIM_Reject,
     /* 427836 */ // Label 8473: @427836
     /* 427836 */ GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(427862), // Rule ID 1004 //
     /* 427841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427855 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 427855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 427860 */   GIR_RootConstrainSelectedInstOperands,
     /* 427861 */   // GIR_Coverage, 1004,
     /* 427861 */   GIR_Done,
     /* 427862 */ // Label 8480: @427862
     /* 427862 */ GIM_Reject,
     /* 427863 */ // Label 8474: @427863
     /* 427863 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(427889), // Rule ID 1010 //
     /* 427868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427882 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 427882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 427887 */   GIR_RootConstrainSelectedInstOperands,
     /* 427888 */   // GIR_Coverage, 1010,
     /* 427888 */   GIR_Done,
     /* 427889 */ // Label 8481: @427889
     /* 427889 */ GIM_Reject,
     /* 427890 */ // Label 8475: @427890
     /* 427890 */ GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(427916), // Rule ID 1000 //
     /* 427895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 427901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427909 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 427909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 427914 */   GIR_RootConstrainSelectedInstOperands,
     /* 427915 */   // GIR_Coverage, 1000,
     /* 427915 */   GIR_Done,
     /* 427916 */ // Label 8482: @427916
     /* 427916 */ GIM_Reject,
     /* 427917 */ // Label 8476: @427917
     /* 427917 */ GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(427943), // Rule ID 1006 //
     /* 427922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427936 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 427936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 427941 */   GIR_RootConstrainSelectedInstOperands,
     /* 427942 */   // GIR_Coverage, 1006,
     /* 427942 */   GIR_Done,
     /* 427943 */ // Label 8483: @427943
     /* 427943 */ GIM_Reject,
     /* 427944 */ // Label 8477: @427944
     /* 427944 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(427970), // Rule ID 1002 //
     /* 427949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427963 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 427963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 427968 */   GIR_RootConstrainSelectedInstOperands,
     /* 427969 */   // GIR_Coverage, 1002,
     /* 427969 */   GIR_Done,
     /* 427970 */ // Label 8484: @427970
     /* 427970 */ GIM_Reject,
     /* 427971 */ // Label 8478: @427971
     /* 427971 */ GIM_Reject,
     /* 427972 */ // Label 137: @427972
     /* 427972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8487*/ GIMT_Encode4(428370),
     /* 427983 */ /*GILLT_v2s64*//*Label 8485*/ GIMT_Encode4(427995), GIMT_Encode4(0),
     /* 427991 */ /*GILLT_v4s32*//*Label 8486*/ GIMT_Encode4(428133),
     /* 427995 */ // Label 8485: @427995
     /* 427995 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(428054), // Rule ID 5906 //
     /* 428000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428011 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 428011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 428014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 428018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428053 */   // GIR_Coverage, 5906,
     /* 428053 */   GIR_EraseRootFromParent_Done,
     /* 428054 */ // Label 8488: @428054
     /* 428054 */ GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(428132), // Rule ID 6028 //
     /* 428059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428070 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 428070 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 428073 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428077 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428082 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 428088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 428091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 428095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 428105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 428113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428131 */   // GIR_Coverage, 6028,
     /* 428131 */   GIR_EraseRootFromParent_Done,
     /* 428132 */ // Label 8489: @428132
     /* 428132 */ GIM_Reject,
     /* 428133 */ // Label 8486: @428133
     /* 428133 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(428192), // Rule ID 5902 //
     /* 428138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428149 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 428149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 428156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428161 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428191 */   // GIR_Coverage, 5902,
     /* 428191 */   GIR_EraseRootFromParent_Done,
     /* 428192 */ // Label 8490: @428192
     /* 428192 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(428251), // Rule ID 5903 //
     /* 428197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428208 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 428208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 428211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 428215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428220 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 428240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428250 */   // GIR_Coverage, 5903,
     /* 428250 */   GIR_EraseRootFromParent_Done,
     /* 428251 */ // Label 8491: @428251
     /* 428251 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(428310), // Rule ID 5904 //
     /* 428256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428267 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 428267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 428270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 428274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 428299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428309 */   // GIR_Coverage, 5904,
     /* 428309 */   GIR_EraseRootFromParent_Done,
     /* 428310 */ // Label 8492: @428310
     /* 428310 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(428369), // Rule ID 5905 //
     /* 428315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428326 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 428326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 428329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 428333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428338 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 428358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428368 */   // GIR_Coverage, 5905,
     /* 428368 */   GIR_EraseRootFromParent_Done,
     /* 428369 */ // Label 8493: @428369
     /* 428369 */ GIM_Reject,
     /* 428370 */ // Label 8487: @428370
     /* 428370 */ GIM_Reject,
     /* 428371 */ // Label 138: @428371
     /* 428371 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8498*/ GIMT_Encode4(428740),
     /* 428382 */ /*GILLT_v2s32*//*Label 8494*/ GIMT_Encode4(428442), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428394 */ /*GILLT_v4s32*//*Label 8495*/ GIMT_Encode4(428562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428426 */ /*GILLT_nxv2s64*//*Label 8496*/ GIMT_Encode4(428682), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428438 */ /*GILLT_nxv4s32*//*Label 8497*/ GIMT_Encode4(428711),
     /* 428442 */ // Label 8494: @428442
     /* 428442 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(428561),
     /* 428447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 428453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 428456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428468 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(428541), // Rule ID 26 //
     /* 428473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 428480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 428484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 428496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 428504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 428513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 428517 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 428521 */     // MIs[3] Operand 1
     /* 428521 */     // No operand predicates
     /* 428521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428523 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 428523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 428526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 428530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 428539 */     GIR_RootConstrainSelectedInstOperands,
     /* 428540 */     // GIR_Coverage, 26,
     /* 428540 */     GIR_EraseRootFromParent_Done,
     /* 428541 */   // Label 8500: @428541
     /* 428541 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(428560), // Rule ID 22 //
     /* 428546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428553 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 428553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 428558 */     GIR_RootConstrainSelectedInstOperands,
     /* 428559 */     // GIR_Coverage, 22,
     /* 428559 */     GIR_Done,
     /* 428560 */   // Label 8501: @428560
     /* 428560 */   GIM_Reject,
     /* 428561 */ // Label 8499: @428561
     /* 428561 */ GIM_Reject,
     /* 428562 */ // Label 8495: @428562
     /* 428562 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(428681),
     /* 428567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 428573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 428576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428588 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(428661), // Rule ID 27 //
     /* 428593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 428600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 428604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 428616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 428624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 428633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 428637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 428641 */     // MIs[3] Operand 1
     /* 428641 */     // No operand predicates
     /* 428641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428643 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 428643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 428646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 428650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 428659 */     GIR_RootConstrainSelectedInstOperands,
     /* 428660 */     // GIR_Coverage, 27,
     /* 428660 */     GIR_EraseRootFromParent_Done,
     /* 428661 */   // Label 8503: @428661
     /* 428661 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(428680), // Rule ID 23 //
     /* 428666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 428669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428673 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 428673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 428678 */     GIR_RootConstrainSelectedInstOperands,
     /* 428679 */     // GIR_Coverage, 23,
     /* 428679 */     GIR_Done,
     /* 428680 */   // Label 8504: @428680
     /* 428680 */   GIM_Reject,
     /* 428681 */ // Label 8502: @428681
     /* 428681 */ GIM_Reject,
     /* 428682 */ // Label 8496: @428682
     /* 428682 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(428710), // Rule ID 2979 //
     /* 428687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 428690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 428693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 428696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 428699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 428703 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 428703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 428708 */   GIR_RootConstrainSelectedInstOperands,
     /* 428709 */   // GIR_Coverage, 2979,
     /* 428709 */   GIR_Done,
     /* 428710 */ // Label 8505: @428710
     /* 428710 */ GIM_Reject,
     /* 428711 */ // Label 8497: @428711
     /* 428711 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(428739), // Rule ID 2978 //
     /* 428716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 428719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 428722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 428725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 428728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 428732 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 428732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 428737 */   GIR_RootConstrainSelectedInstOperands,
     /* 428738 */   // GIR_Coverage, 2978,
     /* 428738 */   GIR_Done,
     /* 428739 */ // Label 8506: @428739
     /* 428739 */ GIM_Reject,
     /* 428740 */ // Label 8498: @428740
     /* 428740 */ GIM_Reject,
     /* 428741 */ // Label 139: @428741
     /* 428741 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8510*/ GIMT_Encode4(428857),
     /* 428752 */ /*GILLT_s16*//*Label 8507*/ GIMT_Encode4(428764),
     /* 428756 */ /*GILLT_s32*//*Label 8508*/ GIMT_Encode4(428795),
     /* 428760 */ /*GILLT_s64*//*Label 8509*/ GIMT_Encode4(428826),
     /* 428764 */ // Label 8507: @428764
     /* 428764 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(428794), // Rule ID 1658 //
     /* 428769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 428772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 428775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 428783 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 428783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 428788 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428792 */   GIR_RootConstrainSelectedInstOperands,
     /* 428793 */   // GIR_Coverage, 1658,
     /* 428793 */   GIR_Done,
     /* 428794 */ // Label 8511: @428794
     /* 428794 */ GIM_Reject,
     /* 428795 */ // Label 8508: @428795
     /* 428795 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(428825), // Rule ID 1657 //
     /* 428800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 428803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 428806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428814 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 428814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 428819 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428823 */   GIR_RootConstrainSelectedInstOperands,
     /* 428824 */   // GIR_Coverage, 1657,
     /* 428824 */   GIR_Done,
     /* 428825 */ // Label 8512: @428825
     /* 428825 */ GIM_Reject,
     /* 428826 */ // Label 8509: @428826
     /* 428826 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(428856), // Rule ID 1656 //
     /* 428831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 428834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 428837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428845 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 428845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 428850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428854 */   GIR_RootConstrainSelectedInstOperands,
     /* 428855 */   // GIR_Coverage, 1656,
     /* 428855 */   GIR_Done,
     /* 428856 */ // Label 8513: @428856
     /* 428856 */ GIM_Reject,
     /* 428857 */ // Label 8510: @428857
     /* 428857 */ GIM_Reject,
     /* 428858 */ // Label 140: @428858
     /* 428858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8517*/ GIMT_Encode4(430090),
     /* 428869 */ /*GILLT_v2s64*//*Label 8514*/ GIMT_Encode4(428889), GIMT_Encode4(0),
     /* 428877 */ /*GILLT_v4s32*//*Label 8515*/ GIMT_Encode4(429450), GIMT_Encode4(0),
     /* 428885 */ /*GILLT_v8s16*//*Label 8516*/ GIMT_Encode4(430011),
     /* 428889 */ // Label 8514: @428889
     /* 428889 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(429449),
     /* 428894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 428900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428904 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(428996), // Rule ID 2054 //
     /* 428909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 428920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 428932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 428940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 428949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 428953 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 428957 */     // MIs[3] Operand 1
     /* 428957 */     // No operand predicates
     /* 428957 */     // MIs[1] Operand 2
     /* 428957 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 428968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 428977 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 428977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 428980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 428987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 428994 */     GIR_RootConstrainSelectedInstOperands,
     /* 428995 */     // GIR_Coverage, 2054,
     /* 428995 */     GIR_EraseRootFromParent_Done,
     /* 428996 */   // Label 8519: @428996
     /* 428996 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(429088), // Rule ID 13578 //
     /* 429001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429049 */     // MIs[3] Operand 1
     /* 429049 */     // No operand predicates
     /* 429049 */     // MIs[1] Operand 2
     /* 429049 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429069 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429086 */     GIR_RootConstrainSelectedInstOperands,
     /* 429087 */     // GIR_Coverage, 13578,
     /* 429087 */     GIR_EraseRootFromParent_Done,
     /* 429088 */   // Label 8520: @429088
     /* 429088 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(429174), // Rule ID 13576 //
     /* 429093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429141 */     // MIs[3] Operand 1
     /* 429141 */     // No operand predicates
     /* 429141 */     // MIs[1] Operand 2
     /* 429141 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429158 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429172 */     GIR_RootConstrainSelectedInstOperands,
     /* 429173 */     // GIR_Coverage, 13576,
     /* 429173 */     GIR_EraseRootFromParent_Done,
     /* 429174 */   // Label 8521: @429174
     /* 429174 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(429260), // Rule ID 2052 //
     /* 429179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429231 */     // MIs[3] Operand 1
     /* 429231 */     // No operand predicates
     /* 429231 */     // MIs[1] Operand 2
     /* 429231 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429244 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429258 */     GIR_RootConstrainSelectedInstOperands,
     /* 429259 */     // GIR_Coverage, 2052,
     /* 429259 */     GIR_EraseRootFromParent_Done,
     /* 429260 */   // Label 8522: @429260
     /* 429260 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(429299), // Rule ID 1741 //
     /* 429265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429282 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 429282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 429285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 429297 */     GIR_RootConstrainSelectedInstOperands,
     /* 429298 */     // GIR_Coverage, 1741,
     /* 429298 */     GIR_EraseRootFromParent_Done,
     /* 429299 */   // Label 8523: @429299
     /* 429299 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(429362), // Rule ID 13577 //
     /* 429304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429336 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429340 */     // MIs[2] Operand 1
     /* 429340 */     // No operand predicates
     /* 429340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429346 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429360 */     GIR_RootConstrainSelectedInstOperands,
     /* 429361 */     // GIR_Coverage, 13577,
     /* 429361 */     GIR_EraseRootFromParent_Done,
     /* 429362 */   // Label 8524: @429362
     /* 429362 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(429425), // Rule ID 2053 //
     /* 429367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429407 */     // MIs[2] Operand 1
     /* 429407 */     // No operand predicates
     /* 429407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429409 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 429412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429423 */     GIR_RootConstrainSelectedInstOperands,
     /* 429424 */     // GIR_Coverage, 2053,
     /* 429424 */     GIR_EraseRootFromParent_Done,
     /* 429425 */   // Label 8525: @429425
     /* 429425 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(429448), // Rule ID 1740 //
     /* 429430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429441 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 429441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 429446 */     GIR_RootConstrainSelectedInstOperands,
     /* 429447 */     // GIR_Coverage, 1740,
     /* 429447 */     GIR_Done,
     /* 429448 */   // Label 8526: @429448
     /* 429448 */   GIM_Reject,
     /* 429449 */ // Label 8518: @429449
     /* 429449 */ GIM_Reject,
     /* 429450 */ // Label 8515: @429450
     /* 429450 */ GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(430010),
     /* 429455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 429461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429465 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(429557), // Rule ID 2051 //
     /* 429470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429514 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429518 */     // MIs[3] Operand 1
     /* 429518 */     // No operand predicates
     /* 429518 */     // MIs[1] Operand 2
     /* 429518 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 429529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429538 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 429541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429555 */     GIR_RootConstrainSelectedInstOperands,
     /* 429556 */     // GIR_Coverage, 2051,
     /* 429556 */     GIR_EraseRootFromParent_Done,
     /* 429557 */   // Label 8528: @429557
     /* 429557 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(429649), // Rule ID 13575 //
     /* 429562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429610 */     // MIs[3] Operand 1
     /* 429610 */     // No operand predicates
     /* 429610 */     // MIs[1] Operand 2
     /* 429610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 429621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429630 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 429633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429647 */     GIR_RootConstrainSelectedInstOperands,
     /* 429648 */     // GIR_Coverage, 13575,
     /* 429648 */     GIR_EraseRootFromParent_Done,
     /* 429649 */   // Label 8529: @429649
     /* 429649 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(429735), // Rule ID 13573 //
     /* 429654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429702 */     // MIs[3] Operand 1
     /* 429702 */     // No operand predicates
     /* 429702 */     // MIs[1] Operand 2
     /* 429702 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429719 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429733 */     GIR_RootConstrainSelectedInstOperands,
     /* 429734 */     // GIR_Coverage, 13573,
     /* 429734 */     GIR_EraseRootFromParent_Done,
     /* 429735 */   // Label 8530: @429735
     /* 429735 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(429821), // Rule ID 2049 //
     /* 429740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429792 */     // MIs[3] Operand 1
     /* 429792 */     // No operand predicates
     /* 429792 */     // MIs[1] Operand 2
     /* 429792 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 429803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429805 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429819 */     GIR_RootConstrainSelectedInstOperands,
     /* 429820 */     // GIR_Coverage, 2049,
     /* 429820 */     GIR_EraseRootFromParent_Done,
     /* 429821 */   // Label 8531: @429821
     /* 429821 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(429860), // Rule ID 1739 //
     /* 429826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 429843 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 429843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 429846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 429858 */     GIR_RootConstrainSelectedInstOperands,
     /* 429859 */     // GIR_Coverage, 1739,
     /* 429859 */     GIR_EraseRootFromParent_Done,
     /* 429860 */   // Label 8532: @429860
     /* 429860 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(429923), // Rule ID 13574 //
     /* 429865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429897 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429901 */     // MIs[2] Operand 1
     /* 429901 */     // No operand predicates
     /* 429901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429907 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429921 */     GIR_RootConstrainSelectedInstOperands,
     /* 429922 */     // GIR_Coverage, 13574,
     /* 429922 */     GIR_EraseRootFromParent_Done,
     /* 429923 */   // Label 8533: @429923
     /* 429923 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(429986), // Rule ID 2050 //
     /* 429928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 429943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 429951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 429956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429964 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 429968 */     // MIs[2] Operand 1
     /* 429968 */     // No operand predicates
     /* 429968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429970 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 429973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 429981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 429984 */     GIR_RootConstrainSelectedInstOperands,
     /* 429985 */     // GIR_Coverage, 2050,
     /* 429985 */     GIR_EraseRootFromParent_Done,
     /* 429986 */   // Label 8534: @429986
     /* 429986 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(430009), // Rule ID 1738 //
     /* 429991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430002 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 430007 */     GIR_RootConstrainSelectedInstOperands,
     /* 430008 */     // GIR_Coverage, 1738,
     /* 430008 */     GIR_Done,
     /* 430009 */   // Label 8535: @430009
     /* 430009 */   GIM_Reject,
     /* 430010 */ // Label 8527: @430010
     /* 430010 */ GIM_Reject,
     /* 430011 */ // Label 8516: @430011
     /* 430011 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(430089),
     /* 430016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430026 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(430065), // Rule ID 1737 //
     /* 430031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430048 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 430051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430063 */     GIR_RootConstrainSelectedInstOperands,
     /* 430064 */     // GIR_Coverage, 1737,
     /* 430064 */     GIR_EraseRootFromParent_Done,
     /* 430065 */   // Label 8537: @430065
     /* 430065 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430088), // Rule ID 1736 //
     /* 430070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430081 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 430086 */     GIR_RootConstrainSelectedInstOperands,
     /* 430087 */     // GIR_Coverage, 1736,
     /* 430087 */     GIR_Done,
     /* 430088 */   // Label 8538: @430088
     /* 430088 */   GIM_Reject,
     /* 430089 */ // Label 8536: @430089
     /* 430089 */ GIM_Reject,
     /* 430090 */ // Label 8517: @430090
     /* 430090 */ GIM_Reject,
     /* 430091 */ // Label 141: @430091
     /* 430091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8557*/ GIMT_Encode4(430870),
     /* 430102 */ /*GILLT_v2s32*//*Label 8539*/ GIMT_Encode4(430178),
     /* 430106 */ /*GILLT_v2s64*//*Label 8540*/ GIMT_Encode4(430233),
     /* 430110 */ /*GILLT_v4s16*//*Label 8541*/ GIMT_Encode4(430288),
     /* 430114 */ /*GILLT_v4s32*//*Label 8542*/ GIMT_Encode4(430343),
     /* 430118 */ /*GILLT_v8s8*//*Label 8543*/ GIMT_Encode4(430398),
     /* 430122 */ /*GILLT_v8s16*//*Label 8544*/ GIMT_Encode4(430432),
     /* 430126 */ /*GILLT_v16s8*//*Label 8545*/ GIMT_Encode4(430487), GIMT_Encode4(0),
     /* 430134 */ /*GILLT_nxv2s1*//*Label 8546*/ GIMT_Encode4(430521),
     /* 430138 */ /*GILLT_nxv2s16*//*Label 8547*/ GIMT_Encode4(430547),
     /* 430142 */ /*GILLT_nxv2s32*//*Label 8548*/ GIMT_Encode4(430573),
     /* 430146 */ /*GILLT_nxv2s64*//*Label 8549*/ GIMT_Encode4(430599),
     /* 430150 */ /*GILLT_nxv4s1*//*Label 8550*/ GIMT_Encode4(430646),
     /* 430154 */ /*GILLT_nxv4s16*//*Label 8551*/ GIMT_Encode4(430672),
     /* 430158 */ /*GILLT_nxv4s32*//*Label 8552*/ GIMT_Encode4(430698),
     /* 430162 */ /*GILLT_nxv8s1*//*Label 8553*/ GIMT_Encode4(430745),
     /* 430166 */ /*GILLT_nxv8s16*//*Label 8554*/ GIMT_Encode4(430771),
     /* 430170 */ /*GILLT_nxv16s1*//*Label 8555*/ GIMT_Encode4(430818),
     /* 430174 */ /*GILLT_nxv16s8*//*Label 8556*/ GIMT_Encode4(430844),
     /* 430178 */ // Label 8539: @430178
     /* 430178 */ GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(430232),
     /* 430183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430201 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(430216), // Rule ID 1874 //
     /* 430206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430209 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430214 */     GIR_RootConstrainSelectedInstOperands,
     /* 430215 */     // GIR_Coverage, 1874,
     /* 430215 */     GIR_Done,
     /* 430216 */   // Label 8559: @430216
     /* 430216 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(430231), // Rule ID 2498 //
     /* 430221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430224 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 430224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 430229 */     GIR_RootConstrainSelectedInstOperands,
     /* 430230 */     // GIR_Coverage, 2498,
     /* 430230 */     GIR_Done,
     /* 430231 */   // Label 8560: @430231
     /* 430231 */   GIM_Reject,
     /* 430232 */ // Label 8558: @430232
     /* 430232 */ GIM_Reject,
     /* 430233 */ // Label 8540: @430233
     /* 430233 */ GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(430287),
     /* 430238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 430241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 430244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430256 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(430271), // Rule ID 1876 //
     /* 430261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430264 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 430264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430269 */     GIR_RootConstrainSelectedInstOperands,
     /* 430270 */     // GIR_Coverage, 1876,
     /* 430270 */     GIR_Done,
     /* 430271 */   // Label 8562: @430271
     /* 430271 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(430286), // Rule ID 2500 //
     /* 430276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430279 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 430279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 430284 */     GIR_RootConstrainSelectedInstOperands,
     /* 430285 */     // GIR_Coverage, 2500,
     /* 430285 */     GIR_Done,
     /* 430286 */   // Label 8563: @430286
     /* 430286 */   GIM_Reject,
     /* 430287 */ // Label 8561: @430287
     /* 430287 */ GIM_Reject,
     /* 430288 */ // Label 8541: @430288
     /* 430288 */ GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(430342),
     /* 430293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 430299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430311 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(430326), // Rule ID 1872 //
     /* 430316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430319 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 430324 */     GIR_RootConstrainSelectedInstOperands,
     /* 430325 */     // GIR_Coverage, 1872,
     /* 430325 */     GIR_Done,
     /* 430326 */   // Label 8565: @430326
     /* 430326 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(430341), // Rule ID 2496 //
     /* 430331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430334 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 430334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 430339 */     GIR_RootConstrainSelectedInstOperands,
     /* 430340 */     // GIR_Coverage, 2496,
     /* 430340 */     GIR_Done,
     /* 430341 */   // Label 8566: @430341
     /* 430341 */   GIM_Reject,
     /* 430342 */ // Label 8564: @430342
     /* 430342 */ GIM_Reject,
     /* 430343 */ // Label 8542: @430343
     /* 430343 */ GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(430397),
     /* 430348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 430354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430366 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(430381), // Rule ID 1875 //
     /* 430371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430374 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 430374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 430379 */     GIR_RootConstrainSelectedInstOperands,
     /* 430380 */     // GIR_Coverage, 1875,
     /* 430380 */     GIR_Done,
     /* 430381 */   // Label 8568: @430381
     /* 430381 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(430396), // Rule ID 2499 //
     /* 430386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430389 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 430389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 430394 */     GIR_RootConstrainSelectedInstOperands,
     /* 430395 */     // GIR_Coverage, 2499,
     /* 430395 */     GIR_Done,
     /* 430396 */   // Label 8569: @430396
     /* 430396 */   GIM_Reject,
     /* 430397 */ // Label 8567: @430397
     /* 430397 */ GIM_Reject,
     /* 430398 */ // Label 8543: @430398
     /* 430398 */ GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(430431), // Rule ID 1870 //
     /* 430403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430424 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 430429 */   GIR_RootConstrainSelectedInstOperands,
     /* 430430 */   // GIR_Coverage, 1870,
     /* 430430 */   GIR_Done,
     /* 430431 */ // Label 8570: @430431
     /* 430431 */ GIM_Reject,
     /* 430432 */ // Label 8544: @430432
     /* 430432 */ GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(430486),
     /* 430437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 430443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430455 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(430470), // Rule ID 1873 //
     /* 430460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430463 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 430463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 430468 */     GIR_RootConstrainSelectedInstOperands,
     /* 430469 */     // GIR_Coverage, 1873,
     /* 430469 */     GIR_Done,
     /* 430470 */   // Label 8572: @430470
     /* 430470 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(430485), // Rule ID 2497 //
     /* 430475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430478 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 430478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 430483 */     GIR_RootConstrainSelectedInstOperands,
     /* 430484 */     // GIR_Coverage, 2497,
     /* 430484 */     GIR_Done,
     /* 430485 */   // Label 8573: @430485
     /* 430485 */   GIM_Reject,
     /* 430486 */ // Label 8571: @430486
     /* 430486 */ GIM_Reject,
     /* 430487 */ // Label 8545: @430487
     /* 430487 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(430520), // Rule ID 1871 //
     /* 430492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 430501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430513 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 430518 */   GIR_RootConstrainSelectedInstOperands,
     /* 430519 */   // GIR_Coverage, 1871,
     /* 430519 */   GIR_Done,
     /* 430520 */ // Label 8574: @430520
     /* 430520 */ GIM_Reject,
     /* 430521 */ // Label 8546: @430521
     /* 430521 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(430546), // Rule ID 9013 //
     /* 430526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 430532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 430535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430539 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 430539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 430544 */   GIR_RootConstrainSelectedInstOperands,
     /* 430545 */   // GIR_Coverage, 9013,
     /* 430545 */   GIR_Done,
     /* 430546 */ // Label 8575: @430546
     /* 430546 */ GIM_Reject,
     /* 430547 */ // Label 8547: @430547
     /* 430547 */ GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(430572), // Rule ID 8989 //
     /* 430552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 430558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 430561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430565 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 430565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430570 */   GIR_RootConstrainSelectedInstOperands,
     /* 430571 */   // GIR_Coverage, 8989,
     /* 430571 */   GIR_Done,
     /* 430572 */ // Label 8576: @430572
     /* 430572 */ GIM_Reject,
     /* 430573 */ // Label 8548: @430573
     /* 430573 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(430598), // Rule ID 8990 //
     /* 430578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 430584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 430587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430591 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 430591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430596 */   GIR_RootConstrainSelectedInstOperands,
     /* 430597 */   // GIR_Coverage, 8990,
     /* 430597 */   GIR_Done,
     /* 430598 */ // Label 8577: @430598
     /* 430598 */ GIM_Reject,
     /* 430599 */ // Label 8549: @430599
     /* 430599 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(430645),
     /* 430604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 430607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 430610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430614 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(430629), // Rule ID 8985 //
     /* 430619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430622 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 430622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430627 */     GIR_RootConstrainSelectedInstOperands,
     /* 430628 */     // GIR_Coverage, 8985,
     /* 430628 */     GIR_Done,
     /* 430629 */   // Label 8579: @430629
     /* 430629 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(430644), // Rule ID 8991 //
     /* 430634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430637 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 430637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 430642 */     GIR_RootConstrainSelectedInstOperands,
     /* 430643 */     // GIR_Coverage, 8991,
     /* 430643 */     GIR_Done,
     /* 430644 */   // Label 8580: @430644
     /* 430644 */   GIM_Reject,
     /* 430645 */ // Label 8578: @430645
     /* 430645 */ GIM_Reject,
     /* 430646 */ // Label 8550: @430646
     /* 430646 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(430671), // Rule ID 9012 //
     /* 430651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 430657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 430660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430664 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 430664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 430669 */   GIR_RootConstrainSelectedInstOperands,
     /* 430670 */   // GIR_Coverage, 9012,
     /* 430670 */   GIR_Done,
     /* 430671 */ // Label 8581: @430671
     /* 430671 */ GIM_Reject,
     /* 430672 */ // Label 8551: @430672
     /* 430672 */ GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(430697), // Rule ID 8987 //
     /* 430677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 430683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 430686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430690 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 430690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430695 */   GIR_RootConstrainSelectedInstOperands,
     /* 430696 */   // GIR_Coverage, 8987,
     /* 430696 */   GIR_Done,
     /* 430697 */ // Label 8582: @430697
     /* 430697 */ GIM_Reject,
     /* 430698 */ // Label 8552: @430698
     /* 430698 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(430744),
     /* 430703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 430706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 430709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430713 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(430728), // Rule ID 8984 //
     /* 430718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430721 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 430721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430726 */     GIR_RootConstrainSelectedInstOperands,
     /* 430727 */     // GIR_Coverage, 8984,
     /* 430727 */     GIR_Done,
     /* 430728 */   // Label 8584: @430728
     /* 430728 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(430743), // Rule ID 8988 //
     /* 430733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430736 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 430736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 430741 */     GIR_RootConstrainSelectedInstOperands,
     /* 430742 */     // GIR_Coverage, 8988,
     /* 430742 */     GIR_Done,
     /* 430743 */   // Label 8585: @430743
     /* 430743 */   GIM_Reject,
     /* 430744 */ // Label 8583: @430744
     /* 430744 */ GIM_Reject,
     /* 430745 */ // Label 8553: @430745
     /* 430745 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(430770), // Rule ID 9011 //
     /* 430750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 430756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 430759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430763 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 430763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 430768 */   GIR_RootConstrainSelectedInstOperands,
     /* 430769 */   // GIR_Coverage, 9011,
     /* 430769 */   GIR_Done,
     /* 430770 */ // Label 8586: @430770
     /* 430770 */ GIM_Reject,
     /* 430771 */ // Label 8554: @430771
     /* 430771 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(430817),
     /* 430776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 430779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 430782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430786 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(430801), // Rule ID 8983 //
     /* 430791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430794 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 430794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 430799 */     GIR_RootConstrainSelectedInstOperands,
     /* 430800 */     // GIR_Coverage, 8983,
     /* 430800 */     GIR_Done,
     /* 430801 */   // Label 8588: @430801
     /* 430801 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(430816), // Rule ID 8986 //
     /* 430806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430809 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 430809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 430814 */     GIR_RootConstrainSelectedInstOperands,
     /* 430815 */     // GIR_Coverage, 8986,
     /* 430815 */     GIR_Done,
     /* 430816 */   // Label 8589: @430816
     /* 430816 */   GIM_Reject,
     /* 430817 */ // Label 8587: @430817
     /* 430817 */ GIM_Reject,
     /* 430818 */ // Label 8555: @430818
     /* 430818 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(430843), // Rule ID 2414 //
     /* 430823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 430829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 430832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 430836 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 430836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 430841 */   GIR_RootConstrainSelectedInstOperands,
     /* 430842 */   // GIR_Coverage, 2414,
     /* 430842 */   GIR_Done,
     /* 430843 */ // Label 8590: @430843
     /* 430843 */ GIM_Reject,
     /* 430844 */ // Label 8556: @430844
     /* 430844 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(430869), // Rule ID 8982 //
     /* 430849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 430855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 430858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430862 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 430862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 430867 */   GIR_RootConstrainSelectedInstOperands,
     /* 430868 */   // GIR_Coverage, 8982,
     /* 430868 */   GIR_Done,
     /* 430869 */ // Label 8591: @430869
     /* 430869 */ GIM_Reject,
     /* 430870 */ // Label 8557: @430870
     /* 430870 */ GIM_Reject,
     /* 430871 */ // Label 142: @430871
     /* 430871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8610*/ GIMT_Encode4(431650),
     /* 430882 */ /*GILLT_v2s32*//*Label 8592*/ GIMT_Encode4(430958),
     /* 430886 */ /*GILLT_v2s64*//*Label 8593*/ GIMT_Encode4(431013),
     /* 430890 */ /*GILLT_v4s16*//*Label 8594*/ GIMT_Encode4(431068),
     /* 430894 */ /*GILLT_v4s32*//*Label 8595*/ GIMT_Encode4(431123),
     /* 430898 */ /*GILLT_v8s8*//*Label 8596*/ GIMT_Encode4(431178),
     /* 430902 */ /*GILLT_v8s16*//*Label 8597*/ GIMT_Encode4(431212),
     /* 430906 */ /*GILLT_v16s8*//*Label 8598*/ GIMT_Encode4(431267), GIMT_Encode4(0),
     /* 430914 */ /*GILLT_nxv2s1*//*Label 8599*/ GIMT_Encode4(431301),
     /* 430918 */ /*GILLT_nxv2s16*//*Label 8600*/ GIMT_Encode4(431327),
     /* 430922 */ /*GILLT_nxv2s32*//*Label 8601*/ GIMT_Encode4(431353),
     /* 430926 */ /*GILLT_nxv2s64*//*Label 8602*/ GIMT_Encode4(431379),
     /* 430930 */ /*GILLT_nxv4s1*//*Label 8603*/ GIMT_Encode4(431426),
     /* 430934 */ /*GILLT_nxv4s16*//*Label 8604*/ GIMT_Encode4(431452),
     /* 430938 */ /*GILLT_nxv4s32*//*Label 8605*/ GIMT_Encode4(431478),
     /* 430942 */ /*GILLT_nxv8s1*//*Label 8606*/ GIMT_Encode4(431525),
     /* 430946 */ /*GILLT_nxv8s16*//*Label 8607*/ GIMT_Encode4(431551),
     /* 430950 */ /*GILLT_nxv16s1*//*Label 8608*/ GIMT_Encode4(431598),
     /* 430954 */ /*GILLT_nxv16s8*//*Label 8609*/ GIMT_Encode4(431624),
     /* 430958 */ // Label 8592: @430958
     /* 430958 */ GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(431012),
     /* 430963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430981 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(430996), // Rule ID 1881 //
     /* 430986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430989 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 430994 */     GIR_RootConstrainSelectedInstOperands,
     /* 430995 */     // GIR_Coverage, 1881,
     /* 430995 */     GIR_Done,
     /* 430996 */   // Label 8612: @430996
     /* 430996 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(431011), // Rule ID 5481 //
     /* 431001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431004 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431009 */     GIR_RootConstrainSelectedInstOperands,
     /* 431010 */     // GIR_Coverage, 5481,
     /* 431010 */     GIR_Done,
     /* 431011 */   // Label 8613: @431011
     /* 431011 */   GIM_Reject,
     /* 431012 */ // Label 8611: @431012
     /* 431012 */ GIM_Reject,
     /* 431013 */ // Label 8593: @431013
     /* 431013 */ GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(431067),
     /* 431018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 431024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431036 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(431051), // Rule ID 1883 //
     /* 431041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431044 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 431044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431049 */     GIR_RootConstrainSelectedInstOperands,
     /* 431050 */     // GIR_Coverage, 1883,
     /* 431050 */     GIR_Done,
     /* 431051 */   // Label 8615: @431051
     /* 431051 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(431066), // Rule ID 5483 //
     /* 431056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431059 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 431059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431064 */     GIR_RootConstrainSelectedInstOperands,
     /* 431065 */     // GIR_Coverage, 5483,
     /* 431065 */     GIR_Done,
     /* 431066 */   // Label 8616: @431066
     /* 431066 */   GIM_Reject,
     /* 431067 */ // Label 8614: @431067
     /* 431067 */ GIM_Reject,
     /* 431068 */ // Label 8594: @431068
     /* 431068 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(431122),
     /* 431073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431091 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(431106), // Rule ID 1879 //
     /* 431096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431099 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431104 */     GIR_RootConstrainSelectedInstOperands,
     /* 431105 */     // GIR_Coverage, 1879,
     /* 431105 */     GIR_Done,
     /* 431106 */   // Label 8618: @431106
     /* 431106 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(431121), // Rule ID 5479 //
     /* 431111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431114 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 431114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 431119 */     GIR_RootConstrainSelectedInstOperands,
     /* 431120 */     // GIR_Coverage, 5479,
     /* 431120 */     GIR_Done,
     /* 431121 */   // Label 8619: @431121
     /* 431121 */   GIM_Reject,
     /* 431122 */ // Label 8617: @431122
     /* 431122 */ GIM_Reject,
     /* 431123 */ // Label 8595: @431123
     /* 431123 */ GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(431177),
     /* 431128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 431134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431146 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(431161), // Rule ID 1882 //
     /* 431151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431154 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431159 */     GIR_RootConstrainSelectedInstOperands,
     /* 431160 */     // GIR_Coverage, 1882,
     /* 431160 */     GIR_Done,
     /* 431161 */   // Label 8621: @431161
     /* 431161 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(431176), // Rule ID 5482 //
     /* 431166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431169 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 431169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 431174 */     GIR_RootConstrainSelectedInstOperands,
     /* 431175 */     // GIR_Coverage, 5482,
     /* 431175 */     GIR_Done,
     /* 431176 */   // Label 8622: @431176
     /* 431176 */   GIM_Reject,
     /* 431177 */ // Label 8620: @431177
     /* 431177 */ GIM_Reject,
     /* 431178 */ // Label 8596: @431178
     /* 431178 */ GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(431211), // Rule ID 1877 //
     /* 431183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431204 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 431209 */   GIR_RootConstrainSelectedInstOperands,
     /* 431210 */   // GIR_Coverage, 1877,
     /* 431210 */   GIR_Done,
     /* 431211 */ // Label 8623: @431211
     /* 431211 */ GIM_Reject,
     /* 431212 */ // Label 8597: @431212
     /* 431212 */ GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(431266),
     /* 431217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431235 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(431250), // Rule ID 1880 //
     /* 431240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431243 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431248 */     GIR_RootConstrainSelectedInstOperands,
     /* 431249 */     // GIR_Coverage, 1880,
     /* 431249 */     GIR_Done,
     /* 431250 */   // Label 8625: @431250
     /* 431250 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(431265), // Rule ID 5480 //
     /* 431255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431258 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 431258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 431263 */     GIR_RootConstrainSelectedInstOperands,
     /* 431264 */     // GIR_Coverage, 5480,
     /* 431264 */     GIR_Done,
     /* 431265 */   // Label 8626: @431265
     /* 431265 */   GIM_Reject,
     /* 431266 */ // Label 8624: @431266
     /* 431266 */ GIM_Reject,
     /* 431267 */ // Label 8598: @431267
     /* 431267 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(431300), // Rule ID 1878 //
     /* 431272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431293 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 431298 */   GIR_RootConstrainSelectedInstOperands,
     /* 431299 */   // GIR_Coverage, 1878,
     /* 431299 */   GIR_Done,
     /* 431300 */ // Label 8627: @431300
     /* 431300 */ GIM_Reject,
     /* 431301 */ // Label 8599: @431301
     /* 431301 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(431326), // Rule ID 9016 //
     /* 431306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 431312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 431315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431319 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 431319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 431324 */   GIR_RootConstrainSelectedInstOperands,
     /* 431325 */   // GIR_Coverage, 9016,
     /* 431325 */   GIR_Done,
     /* 431326 */ // Label 8628: @431326
     /* 431326 */ GIM_Reject,
     /* 431327 */ // Label 8600: @431327
     /* 431327 */ GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(431352), // Rule ID 8999 //
     /* 431332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 431338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 431341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431345 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 431345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431350 */   GIR_RootConstrainSelectedInstOperands,
     /* 431351 */   // GIR_Coverage, 8999,
     /* 431351 */   GIR_Done,
     /* 431352 */ // Label 8629: @431352
     /* 431352 */ GIM_Reject,
     /* 431353 */ // Label 8601: @431353
     /* 431353 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(431378), // Rule ID 9000 //
     /* 431358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 431364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 431367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431371 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 431371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431376 */   GIR_RootConstrainSelectedInstOperands,
     /* 431377 */   // GIR_Coverage, 9000,
     /* 431377 */   GIR_Done,
     /* 431378 */ // Label 8630: @431378
     /* 431378 */ GIM_Reject,
     /* 431379 */ // Label 8602: @431379
     /* 431379 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(431425),
     /* 431384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 431390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431394 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(431409), // Rule ID 8995 //
     /* 431399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431402 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 431402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431407 */     GIR_RootConstrainSelectedInstOperands,
     /* 431408 */     // GIR_Coverage, 8995,
     /* 431408 */     GIR_Done,
     /* 431409 */   // Label 8632: @431409
     /* 431409 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(431424), // Rule ID 9001 //
     /* 431414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431417 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 431417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 431422 */     GIR_RootConstrainSelectedInstOperands,
     /* 431423 */     // GIR_Coverage, 9001,
     /* 431423 */     GIR_Done,
     /* 431424 */   // Label 8633: @431424
     /* 431424 */   GIM_Reject,
     /* 431425 */ // Label 8631: @431425
     /* 431425 */ GIM_Reject,
     /* 431426 */ // Label 8603: @431426
     /* 431426 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(431451), // Rule ID 9015 //
     /* 431431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 431437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 431440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431444 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 431444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 431449 */   GIR_RootConstrainSelectedInstOperands,
     /* 431450 */   // GIR_Coverage, 9015,
     /* 431450 */   GIR_Done,
     /* 431451 */ // Label 8634: @431451
     /* 431451 */ GIM_Reject,
     /* 431452 */ // Label 8604: @431452
     /* 431452 */ GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(431477), // Rule ID 8997 //
     /* 431457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 431463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 431466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431470 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 431470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431475 */   GIR_RootConstrainSelectedInstOperands,
     /* 431476 */   // GIR_Coverage, 8997,
     /* 431476 */   GIR_Done,
     /* 431477 */ // Label 8635: @431477
     /* 431477 */ GIM_Reject,
     /* 431478 */ // Label 8605: @431478
     /* 431478 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(431524),
     /* 431483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 431489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431493 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(431508), // Rule ID 8994 //
     /* 431498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431501 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 431501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431506 */     GIR_RootConstrainSelectedInstOperands,
     /* 431507 */     // GIR_Coverage, 8994,
     /* 431507 */     GIR_Done,
     /* 431508 */   // Label 8637: @431508
     /* 431508 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(431523), // Rule ID 8998 //
     /* 431513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431516 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 431516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 431521 */     GIR_RootConstrainSelectedInstOperands,
     /* 431522 */     // GIR_Coverage, 8998,
     /* 431522 */     GIR_Done,
     /* 431523 */   // Label 8638: @431523
     /* 431523 */   GIM_Reject,
     /* 431524 */ // Label 8636: @431524
     /* 431524 */ GIM_Reject,
     /* 431525 */ // Label 8606: @431525
     /* 431525 */ GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(431550), // Rule ID 9014 //
     /* 431530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 431536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 431539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431543 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 431543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 431548 */   GIR_RootConstrainSelectedInstOperands,
     /* 431549 */   // GIR_Coverage, 9014,
     /* 431549 */   GIR_Done,
     /* 431550 */ // Label 8639: @431550
     /* 431550 */ GIM_Reject,
     /* 431551 */ // Label 8607: @431551
     /* 431551 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(431597),
     /* 431556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 431559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431566 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(431581), // Rule ID 8993 //
     /* 431571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431574 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 431574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 431579 */     GIR_RootConstrainSelectedInstOperands,
     /* 431580 */     // GIR_Coverage, 8993,
     /* 431580 */     GIR_Done,
     /* 431581 */   // Label 8641: @431581
     /* 431581 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(431596), // Rule ID 8996 //
     /* 431586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431589 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 431589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 431594 */     GIR_RootConstrainSelectedInstOperands,
     /* 431595 */     // GIR_Coverage, 8996,
     /* 431595 */     GIR_Done,
     /* 431596 */   // Label 8642: @431596
     /* 431596 */   GIM_Reject,
     /* 431597 */ // Label 8640: @431597
     /* 431597 */ GIM_Reject,
     /* 431598 */ // Label 8608: @431598
     /* 431598 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(431623), // Rule ID 2418 //
     /* 431603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 431609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 431612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431616 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 431616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 431621 */   GIR_RootConstrainSelectedInstOperands,
     /* 431622 */   // GIR_Coverage, 2418,
     /* 431622 */   GIR_Done,
     /* 431623 */ // Label 8643: @431623
     /* 431623 */ GIM_Reject,
     /* 431624 */ // Label 8609: @431624
     /* 431624 */ GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(431649), // Rule ID 8992 //
     /* 431629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 431635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431642 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 431642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 431647 */   GIR_RootConstrainSelectedInstOperands,
     /* 431648 */   // GIR_Coverage, 8992,
     /* 431648 */   GIR_Done,
     /* 431649 */ // Label 8644: @431649
     /* 431649 */ GIM_Reject,
     /* 431650 */ // Label 8610: @431650
     /* 431650 */ GIM_Reject,
     /* 431651 */ // Label 143: @431651
     /* 431651 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8651*/ GIMT_Encode4(431856),
     /* 431662 */ /*GILLT_s64*//*Label 8645*/ GIMT_Encode4(431694), GIMT_Encode4(0),
     /* 431670 */ /*GILLT_v2s32*//*Label 8646*/ GIMT_Encode4(431721),
     /* 431674 */ /*GILLT_v2s64*//*Label 8647*/ GIMT_Encode4(431748),
     /* 431678 */ /*GILLT_v4s16*//*Label 8648*/ GIMT_Encode4(431775),
     /* 431682 */ /*GILLT_v4s32*//*Label 8649*/ GIMT_Encode4(431802), GIMT_Encode4(0),
     /* 431690 */ /*GILLT_v8s16*//*Label 8650*/ GIMT_Encode4(431829),
     /* 431694 */ // Label 8645: @431694
     /* 431694 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(431720), // Rule ID 1069 //
     /* 431699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431713 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 431713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 431718 */   GIR_RootConstrainSelectedInstOperands,
     /* 431719 */   // GIR_Coverage, 1069,
     /* 431719 */   GIR_Done,
     /* 431720 */ // Label 8652: @431720
     /* 431720 */ GIM_Reject,
     /* 431721 */ // Label 8646: @431721
     /* 431721 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(431747), // Rule ID 1065 //
     /* 431726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431740 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 431740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 431745 */   GIR_RootConstrainSelectedInstOperands,
     /* 431746 */   // GIR_Coverage, 1065,
     /* 431746 */   GIR_Done,
     /* 431747 */ // Label 8653: @431747
     /* 431747 */ GIM_Reject,
     /* 431748 */ // Label 8647: @431748
     /* 431748 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(431774), // Rule ID 1071 //
     /* 431753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431767 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 431767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 431772 */   GIR_RootConstrainSelectedInstOperands,
     /* 431773 */   // GIR_Coverage, 1071,
     /* 431773 */   GIR_Done,
     /* 431774 */ // Label 8654: @431774
     /* 431774 */ GIM_Reject,
     /* 431775 */ // Label 8648: @431775
     /* 431775 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(431801), // Rule ID 1061 //
     /* 431780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431794 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 431794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 431799 */   GIR_RootConstrainSelectedInstOperands,
     /* 431800 */   // GIR_Coverage, 1061,
     /* 431800 */   GIR_Done,
     /* 431801 */ // Label 8655: @431801
     /* 431801 */ GIM_Reject,
     /* 431802 */ // Label 8649: @431802
     /* 431802 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(431828), // Rule ID 1067 //
     /* 431807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431821 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 431821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 431826 */   GIR_RootConstrainSelectedInstOperands,
     /* 431827 */   // GIR_Coverage, 1067,
     /* 431827 */   GIR_Done,
     /* 431828 */ // Label 8656: @431828
     /* 431828 */ GIM_Reject,
     /* 431829 */ // Label 8650: @431829
     /* 431829 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(431855), // Rule ID 1063 //
     /* 431834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431848 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 431848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 431853 */   GIR_RootConstrainSelectedInstOperands,
     /* 431854 */   // GIR_Coverage, 1063,
     /* 431854 */   GIR_Done,
     /* 431855 */ // Label 8657: @431855
     /* 431855 */ GIM_Reject,
     /* 431856 */ // Label 8651: @431856
     /* 431856 */ GIM_Reject,
     /* 431857 */ // Label 144: @431857
     /* 431857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8660*/ GIMT_Encode4(432723),
     /* 431868 */ /*GILLT_v2s64*//*Label 8658*/ GIMT_Encode4(431880), GIMT_Encode4(0),
     /* 431876 */ /*GILLT_v4s32*//*Label 8659*/ GIMT_Encode4(432174),
     /* 431880 */ // Label 8658: @431880
     /* 431880 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(431962), // Rule ID 5892 //
     /* 431885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 431900 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 431903 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 431908 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431912 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 431919 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 431919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 431926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431931 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 431935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 431951 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431961 */   // GIR_Coverage, 5892,
     /* 431961 */   GIR_EraseRootFromParent_Done,
     /* 431962 */ // Label 8661: @431962
     /* 431962 */ GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(432036), // Rule ID 5891 //
     /* 431967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 431982 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431986 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 431993 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 431993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432005 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432035 */   // GIR_Coverage, 5891,
     /* 432035 */   GIR_EraseRootFromParent_Done,
     /* 432036 */ // Label 8662: @432036
     /* 432036 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(432095), // Rule ID 5901 //
     /* 432041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432052 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 432052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 432055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 432059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432094 */   // GIR_Coverage, 5901,
     /* 432094 */   GIR_EraseRootFromParent_Done,
     /* 432095 */ // Label 8663: @432095
     /* 432095 */ GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(432173), // Rule ID 6029 //
     /* 432100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432111 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 432111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 432114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 432118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432123 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 432129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 432132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 432136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 432146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 432154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432172 */   // GIR_Coverage, 6029,
     /* 432172 */   GIR_EraseRootFromParent_Done,
     /* 432173 */ // Label 8664: @432173
     /* 432173 */ GIM_Reject,
     /* 432174 */ // Label 8659: @432174
     /* 432174 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(432256), // Rule ID 5894 //
     /* 432179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432194 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432197 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432202 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432206 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432213 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 432213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432250 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432255 */   // GIR_Coverage, 5894,
     /* 432255 */   GIR_EraseRootFromParent_Done,
     /* 432256 */ // Label 8665: @432256
     /* 432256 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(432338), // Rule ID 5896 //
     /* 432261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432276 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432279 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432284 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432288 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432295 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 432295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432307 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432337 */   // GIR_Coverage, 5896,
     /* 432337 */   GIR_EraseRootFromParent_Done,
     /* 432338 */ // Label 8666: @432338
     /* 432338 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(432412), // Rule ID 5893 //
     /* 432343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432358 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432369 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 432369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432381 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432411 */   // GIR_Coverage, 5893,
     /* 432411 */   GIR_EraseRootFromParent_Done,
     /* 432412 */ // Label 8667: @432412
     /* 432412 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(432486), // Rule ID 5895 //
     /* 432417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432432 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432436 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432443 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 432443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432485 */   // GIR_Coverage, 5895,
     /* 432485 */   GIR_EraseRootFromParent_Done,
     /* 432486 */ // Label 8668: @432486
     /* 432486 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(432545), // Rule ID 5897 //
     /* 432491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432502 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 432502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 432509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432544 */   // GIR_Coverage, 5897,
     /* 432544 */   GIR_EraseRootFromParent_Done,
     /* 432545 */ // Label 8669: @432545
     /* 432545 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(432604), // Rule ID 5898 //
     /* 432550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432561 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 432561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 432568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432573 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432603 */   // GIR_Coverage, 5898,
     /* 432603 */   GIR_EraseRootFromParent_Done,
     /* 432604 */ // Label 8670: @432604
     /* 432604 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(432663), // Rule ID 5899 //
     /* 432609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432620 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 432620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 432623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 432627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432632 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 432652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 432662 */   // GIR_Coverage, 5899,
     /* 432662 */   GIR_EraseRootFromParent_Done,
     /* 432663 */ // Label 8671: @432663
     /* 432663 */ GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(432722), // Rule ID 5900 //
     /* 432668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432679 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 432679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432691 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432721 */   // GIR_Coverage, 5900,
     /* 432721 */   GIR_EraseRootFromParent_Done,
     /* 432722 */ // Label 8672: @432722
     /* 432722 */ GIM_Reject,
     /* 432723 */ // Label 8660: @432723
     /* 432723 */ GIM_Reject,
     /* 432724 */ // Label 145: @432724
     /* 432724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8677*/ GIMT_Encode4(433093),
     /* 432735 */ /*GILLT_v2s32*//*Label 8673*/ GIMT_Encode4(432795), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432747 */ /*GILLT_v4s32*//*Label 8674*/ GIMT_Encode4(432915), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432779 */ /*GILLT_nxv2s64*//*Label 8675*/ GIMT_Encode4(433035), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 432791 */ /*GILLT_nxv4s32*//*Label 8676*/ GIMT_Encode4(433064),
     /* 432795 */ // Label 8673: @432795
     /* 432795 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(432914),
     /* 432800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 432809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432821 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(432894), // Rule ID 28 //
     /* 432826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 432829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 432833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 432837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432874 */     // MIs[3] Operand 1
     /* 432874 */     // No operand predicates
     /* 432874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432876 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 432879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 432883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432892 */     GIR_RootConstrainSelectedInstOperands,
     /* 432893 */     // GIR_Coverage, 28,
     /* 432893 */     GIR_EraseRootFromParent_Done,
     /* 432894 */   // Label 8679: @432894
     /* 432894 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(432913), // Rule ID 24 //
     /* 432899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 432902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432906 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 432911 */     GIR_RootConstrainSelectedInstOperands,
     /* 432912 */     // GIR_Coverage, 24,
     /* 432912 */     GIR_Done,
     /* 432913 */   // Label 8680: @432913
     /* 432913 */   GIM_Reject,
     /* 432914 */ // Label 8678: @432914
     /* 432914 */ GIM_Reject,
     /* 432915 */ // Label 8674: @432915
     /* 432915 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(433034),
     /* 432920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 432929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432941 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(433014), // Rule ID 29 //
     /* 432946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 432949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 432953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 432957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432990 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432994 */     // MIs[3] Operand 1
     /* 432994 */     // No operand predicates
     /* 432994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432996 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 432999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433012 */     GIR_RootConstrainSelectedInstOperands,
     /* 433013 */     // GIR_Coverage, 29,
     /* 433013 */     GIR_EraseRootFromParent_Done,
     /* 433014 */   // Label 8682: @433014
     /* 433014 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(433033), // Rule ID 25 //
     /* 433019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433026 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 433031 */     GIR_RootConstrainSelectedInstOperands,
     /* 433032 */     // GIR_Coverage, 25,
     /* 433032 */     GIR_Done,
     /* 433033 */   // Label 8683: @433033
     /* 433033 */   GIM_Reject,
     /* 433034 */ // Label 8681: @433034
     /* 433034 */ GIM_Reject,
     /* 433035 */ // Label 8675: @433035
     /* 433035 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(433063), // Rule ID 7699 //
     /* 433040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 433052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433056 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 433056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 433061 */   GIR_RootConstrainSelectedInstOperands,
     /* 433062 */   // GIR_Coverage, 7699,
     /* 433062 */   GIR_Done,
     /* 433063 */ // Label 8684: @433063
     /* 433063 */ GIM_Reject,
     /* 433064 */ // Label 8676: @433064
     /* 433064 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(433092), // Rule ID 7698 //
     /* 433069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433078 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 433081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433085 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 433085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 433090 */   GIR_RootConstrainSelectedInstOperands,
     /* 433091 */   // GIR_Coverage, 7698,
     /* 433091 */   GIR_Done,
     /* 433092 */ // Label 8685: @433092
     /* 433092 */ GIM_Reject,
     /* 433093 */ // Label 8677: @433093
     /* 433093 */ GIM_Reject,
     /* 433094 */ // Label 146: @433094
     /* 433094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8689*/ GIMT_Encode4(433210),
     /* 433105 */ /*GILLT_s16*//*Label 8686*/ GIMT_Encode4(433117),
     /* 433109 */ /*GILLT_s32*//*Label 8687*/ GIMT_Encode4(433148),
     /* 433113 */ /*GILLT_s64*//*Label 8688*/ GIMT_Encode4(433179),
     /* 433117 */ // Label 8686: @433117
     /* 433117 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(433147), // Rule ID 1669 //
     /* 433122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 433125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 433128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433136 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 433136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 433141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433145 */   GIR_RootConstrainSelectedInstOperands,
     /* 433146 */   // GIR_Coverage, 1669,
     /* 433146 */   GIR_Done,
     /* 433147 */ // Label 8690: @433147
     /* 433147 */ GIM_Reject,
     /* 433148 */ // Label 8687: @433148
     /* 433148 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(433178), // Rule ID 1668 //
     /* 433153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 433159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433167 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 433167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 433172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433176 */   GIR_RootConstrainSelectedInstOperands,
     /* 433177 */   // GIR_Coverage, 1668,
     /* 433177 */   GIR_Done,
     /* 433178 */ // Label 8691: @433178
     /* 433178 */ GIM_Reject,
     /* 433179 */ // Label 8688: @433179
     /* 433179 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(433209), // Rule ID 1667 //
     /* 433184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 433187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 433190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433198 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 433198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 433203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 433207 */   GIR_RootConstrainSelectedInstOperands,
     /* 433208 */   // GIR_Coverage, 1667,
     /* 433208 */   GIR_Done,
     /* 433209 */ // Label 8692: @433209
     /* 433209 */ GIM_Reject,
     /* 433210 */ // Label 8689: @433210
     /* 433210 */ GIM_Reject,
     /* 433211 */ // Label 147: @433211
     /* 433211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8696*/ GIMT_Encode4(434443),
     /* 433222 */ /*GILLT_v2s64*//*Label 8693*/ GIMT_Encode4(433242), GIMT_Encode4(0),
     /* 433230 */ /*GILLT_v4s32*//*Label 8694*/ GIMT_Encode4(433803), GIMT_Encode4(0),
     /* 433238 */ /*GILLT_v8s16*//*Label 8695*/ GIMT_Encode4(434364),
     /* 433242 */ // Label 8693: @433242
     /* 433242 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(433802),
     /* 433247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433257 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(433349), // Rule ID 2106 //
     /* 433262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433306 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433310 */     // MIs[3] Operand 1
     /* 433310 */     // No operand predicates
     /* 433310 */     // MIs[1] Operand 2
     /* 433310 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 433321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433330 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 433333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433347 */     GIR_RootConstrainSelectedInstOperands,
     /* 433348 */     // GIR_Coverage, 2106,
     /* 433348 */     GIR_EraseRootFromParent_Done,
     /* 433349 */   // Label 8698: @433349
     /* 433349 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(433441), // Rule ID 13614 //
     /* 433354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433398 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433402 */     // MIs[3] Operand 1
     /* 433402 */     // No operand predicates
     /* 433402 */     // MIs[1] Operand 2
     /* 433402 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 433413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433422 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 433425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433439 */     GIR_RootConstrainSelectedInstOperands,
     /* 433440 */     // GIR_Coverage, 13614,
     /* 433440 */     GIR_EraseRootFromParent_Done,
     /* 433441 */   // Label 8699: @433441
     /* 433441 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(433527), // Rule ID 13612 //
     /* 433446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433490 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433494 */     // MIs[3] Operand 1
     /* 433494 */     // No operand predicates
     /* 433494 */     // MIs[1] Operand 2
     /* 433494 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 433505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433511 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433525 */     GIR_RootConstrainSelectedInstOperands,
     /* 433526 */     // GIR_Coverage, 13612,
     /* 433526 */     GIR_EraseRootFromParent_Done,
     /* 433527 */   // Label 8700: @433527
     /* 433527 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(433613), // Rule ID 2104 //
     /* 433532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433584 */     // MIs[3] Operand 1
     /* 433584 */     // No operand predicates
     /* 433584 */     // MIs[1] Operand 2
     /* 433584 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 433595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433597 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433611 */     GIR_RootConstrainSelectedInstOperands,
     /* 433612 */     // GIR_Coverage, 2104,
     /* 433612 */     GIR_EraseRootFromParent_Done,
     /* 433613 */   // Label 8701: @433613
     /* 433613 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(433652), // Rule ID 1831 //
     /* 433618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 433635 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 433635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 433638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 433650 */     GIR_RootConstrainSelectedInstOperands,
     /* 433651 */     // GIR_Coverage, 1831,
     /* 433651 */     GIR_EraseRootFromParent_Done,
     /* 433652 */   // Label 8702: @433652
     /* 433652 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(433715), // Rule ID 13613 //
     /* 433657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433693 */     // MIs[2] Operand 1
     /* 433693 */     // No operand predicates
     /* 433693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433699 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433713 */     GIR_RootConstrainSelectedInstOperands,
     /* 433714 */     // GIR_Coverage, 13613,
     /* 433714 */     GIR_EraseRootFromParent_Done,
     /* 433715 */   // Label 8703: @433715
     /* 433715 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(433778), // Rule ID 2105 //
     /* 433720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 433743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 433752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433756 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433760 */     // MIs[2] Operand 1
     /* 433760 */     // No operand predicates
     /* 433760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433762 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 433765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 433769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 433773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 433776 */     GIR_RootConstrainSelectedInstOperands,
     /* 433777 */     // GIR_Coverage, 2105,
     /* 433777 */     GIR_EraseRootFromParent_Done,
     /* 433778 */   // Label 8704: @433778
     /* 433778 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(433801), // Rule ID 1830 //
     /* 433783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433794 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 433794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 433799 */     GIR_RootConstrainSelectedInstOperands,
     /* 433800 */     // GIR_Coverage, 1830,
     /* 433800 */     GIR_Done,
     /* 433801 */   // Label 8705: @433801
     /* 433801 */   GIM_Reject,
     /* 433802 */ // Label 8697: @433802
     /* 433802 */ GIM_Reject,
     /* 433803 */ // Label 8694: @433803
     /* 433803 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(434363),
     /* 433808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 433814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433818 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(433910), // Rule ID 2103 //
     /* 433823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 433859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433867 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 433871 */     // MIs[3] Operand 1
     /* 433871 */     // No operand predicates
     /* 433871 */     // MIs[1] Operand 2
     /* 433871 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 433882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 433891 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 433894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433908 */     GIR_RootConstrainSelectedInstOperands,
     /* 433909 */     // GIR_Coverage, 2103,
     /* 433909 */     GIR_EraseRootFromParent_Done,
     /* 433910 */   // Label 8707: @433910
     /* 433910 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(434002), // Rule ID 13611 //
     /* 433915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 433926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 433938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 433951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 433963 */     // MIs[3] Operand 1
     /* 433963 */     // No operand predicates
     /* 433963 */     // MIs[1] Operand 2
     /* 433963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 433974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 433983 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 433986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 433988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 433993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434000 */     GIR_RootConstrainSelectedInstOperands,
     /* 434001 */     // GIR_Coverage, 13611,
     /* 434001 */     GIR_EraseRootFromParent_Done,
     /* 434002 */   // Label 8708: @434002
     /* 434002 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(434088), // Rule ID 13609 //
     /* 434007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434051 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434055 */     // MIs[3] Operand 1
     /* 434055 */     // No operand predicates
     /* 434055 */     // MIs[1] Operand 2
     /* 434055 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434072 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434086 */     GIR_RootConstrainSelectedInstOperands,
     /* 434087 */     // GIR_Coverage, 13609,
     /* 434087 */     GIR_EraseRootFromParent_Done,
     /* 434088 */   // Label 8709: @434088
     /* 434088 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(434174), // Rule ID 2101 //
     /* 434093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434145 */     // MIs[3] Operand 1
     /* 434145 */     // No operand predicates
     /* 434145 */     // MIs[1] Operand 2
     /* 434145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434158 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434172 */     GIR_RootConstrainSelectedInstOperands,
     /* 434173 */     // GIR_Coverage, 2101,
     /* 434173 */     GIR_EraseRootFromParent_Done,
     /* 434174 */   // Label 8710: @434174
     /* 434174 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(434213), // Rule ID 1829 //
     /* 434179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434196 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 434199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434211 */     GIR_RootConstrainSelectedInstOperands,
     /* 434212 */     // GIR_Coverage, 1829,
     /* 434212 */     GIR_EraseRootFromParent_Done,
     /* 434213 */   // Label 8711: @434213
     /* 434213 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(434276), // Rule ID 13610 //
     /* 434218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434254 */     // MIs[2] Operand 1
     /* 434254 */     // No operand predicates
     /* 434254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434260 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434274 */     GIR_RootConstrainSelectedInstOperands,
     /* 434275 */     // GIR_Coverage, 13610,
     /* 434275 */     GIR_EraseRootFromParent_Done,
     /* 434276 */   // Label 8712: @434276
     /* 434276 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(434339), // Rule ID 2102 //
     /* 434281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434321 */     // MIs[2] Operand 1
     /* 434321 */     // No operand predicates
     /* 434321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434323 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434337 */     GIR_RootConstrainSelectedInstOperands,
     /* 434338 */     // GIR_Coverage, 2102,
     /* 434338 */     GIR_EraseRootFromParent_Done,
     /* 434339 */   // Label 8713: @434339
     /* 434339 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(434362), // Rule ID 1828 //
     /* 434344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434355 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 434355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 434360 */     GIR_RootConstrainSelectedInstOperands,
     /* 434361 */     // GIR_Coverage, 1828,
     /* 434361 */     GIR_Done,
     /* 434362 */   // Label 8714: @434362
     /* 434362 */   GIM_Reject,
     /* 434363 */ // Label 8706: @434363
     /* 434363 */ GIM_Reject,
     /* 434364 */ // Label 8695: @434364
     /* 434364 */ GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(434442),
     /* 434369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434379 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(434418), // Rule ID 1827 //
     /* 434384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 434394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 434401 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 434404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434416 */     GIR_RootConstrainSelectedInstOperands,
     /* 434417 */     // GIR_Coverage, 1827,
     /* 434417 */     GIR_EraseRootFromParent_Done,
     /* 434418 */   // Label 8716: @434418
     /* 434418 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(434441), // Rule ID 1826 //
     /* 434423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434434 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 434439 */     GIR_RootConstrainSelectedInstOperands,
     /* 434440 */     // GIR_Coverage, 1826,
     /* 434440 */     GIR_Done,
     /* 434441 */   // Label 8717: @434441
     /* 434441 */   GIM_Reject,
     /* 434442 */ // Label 8715: @434442
     /* 434442 */ GIM_Reject,
     /* 434443 */ // Label 8696: @434443
     /* 434443 */ GIM_Reject,
     /* 434444 */ // Label 148: @434444
     /* 434444 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8736*/ GIMT_Encode4(435223),
     /* 434455 */ /*GILLT_v2s32*//*Label 8718*/ GIMT_Encode4(434531),
     /* 434459 */ /*GILLT_v2s64*//*Label 8719*/ GIMT_Encode4(434586),
     /* 434463 */ /*GILLT_v4s16*//*Label 8720*/ GIMT_Encode4(434641),
     /* 434467 */ /*GILLT_v4s32*//*Label 8721*/ GIMT_Encode4(434696),
     /* 434471 */ /*GILLT_v8s8*//*Label 8722*/ GIMT_Encode4(434751),
     /* 434475 */ /*GILLT_v8s16*//*Label 8723*/ GIMT_Encode4(434785),
     /* 434479 */ /*GILLT_v16s8*//*Label 8724*/ GIMT_Encode4(434840), GIMT_Encode4(0),
     /* 434487 */ /*GILLT_nxv2s1*//*Label 8725*/ GIMT_Encode4(434874),
     /* 434491 */ /*GILLT_nxv2s16*//*Label 8726*/ GIMT_Encode4(434900),
     /* 434495 */ /*GILLT_nxv2s32*//*Label 8727*/ GIMT_Encode4(434926),
     /* 434499 */ /*GILLT_nxv2s64*//*Label 8728*/ GIMT_Encode4(434952),
     /* 434503 */ /*GILLT_nxv4s1*//*Label 8729*/ GIMT_Encode4(434999),
     /* 434507 */ /*GILLT_nxv4s16*//*Label 8730*/ GIMT_Encode4(435025),
     /* 434511 */ /*GILLT_nxv4s32*//*Label 8731*/ GIMT_Encode4(435051),
     /* 434515 */ /*GILLT_nxv8s1*//*Label 8732*/ GIMT_Encode4(435098),
     /* 434519 */ /*GILLT_nxv8s16*//*Label 8733*/ GIMT_Encode4(435124),
     /* 434523 */ /*GILLT_nxv16s1*//*Label 8734*/ GIMT_Encode4(435171),
     /* 434527 */ /*GILLT_nxv16s8*//*Label 8735*/ GIMT_Encode4(435197),
     /* 434531 */ // Label 8718: @434531
     /* 434531 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(434585),
     /* 434536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 434542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434554 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(434569), // Rule ID 1888 //
     /* 434559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434562 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 434562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 434567 */     GIR_RootConstrainSelectedInstOperands,
     /* 434568 */     // GIR_Coverage, 1888,
     /* 434568 */     GIR_Done,
     /* 434569 */   // Label 8738: @434569
     /* 434569 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(434584), // Rule ID 5486 //
     /* 434574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434577 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 434577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 434582 */     GIR_RootConstrainSelectedInstOperands,
     /* 434583 */     // GIR_Coverage, 5486,
     /* 434583 */     GIR_Done,
     /* 434584 */   // Label 8739: @434584
     /* 434584 */   GIM_Reject,
     /* 434585 */ // Label 8737: @434585
     /* 434585 */ GIM_Reject,
     /* 434586 */ // Label 8719: @434586
     /* 434586 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(434640),
     /* 434591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 434594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 434597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434609 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(434624), // Rule ID 1890 //
     /* 434614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434617 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 434617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 434622 */     GIR_RootConstrainSelectedInstOperands,
     /* 434623 */     // GIR_Coverage, 1890,
     /* 434623 */     GIR_Done,
     /* 434624 */   // Label 8741: @434624
     /* 434624 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(434639), // Rule ID 5488 //
     /* 434629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434632 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 434632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 434637 */     GIR_RootConstrainSelectedInstOperands,
     /* 434638 */     // GIR_Coverage, 5488,
     /* 434638 */     GIR_Done,
     /* 434639 */   // Label 8742: @434639
     /* 434639 */   GIM_Reject,
     /* 434640 */ // Label 8740: @434640
     /* 434640 */ GIM_Reject,
     /* 434641 */ // Label 8720: @434641
     /* 434641 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(434695),
     /* 434646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 434652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434664 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(434679), // Rule ID 1886 //
     /* 434669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434672 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 434672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 434677 */     GIR_RootConstrainSelectedInstOperands,
     /* 434678 */     // GIR_Coverage, 1886,
     /* 434678 */     GIR_Done,
     /* 434679 */   // Label 8744: @434679
     /* 434679 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(434694), // Rule ID 5484 //
     /* 434684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434687 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 434687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 434692 */     GIR_RootConstrainSelectedInstOperands,
     /* 434693 */     // GIR_Coverage, 5484,
     /* 434693 */     GIR_Done,
     /* 434694 */   // Label 8745: @434694
     /* 434694 */   GIM_Reject,
     /* 434695 */ // Label 8743: @434695
     /* 434695 */ GIM_Reject,
     /* 434696 */ // Label 8721: @434696
     /* 434696 */ GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(434750),
     /* 434701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 434707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434719 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(434734), // Rule ID 1889 //
     /* 434724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434727 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 434732 */     GIR_RootConstrainSelectedInstOperands,
     /* 434733 */     // GIR_Coverage, 1889,
     /* 434733 */     GIR_Done,
     /* 434734 */   // Label 8747: @434734
     /* 434734 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(434749), // Rule ID 5487 //
     /* 434739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434742 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 434742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 434747 */     GIR_RootConstrainSelectedInstOperands,
     /* 434748 */     // GIR_Coverage, 5487,
     /* 434748 */     GIR_Done,
     /* 434749 */   // Label 8748: @434749
     /* 434749 */   GIM_Reject,
     /* 434750 */ // Label 8746: @434750
     /* 434750 */ GIM_Reject,
     /* 434751 */ // Label 8722: @434751
     /* 434751 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(434784), // Rule ID 1884 //
     /* 434756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434777 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 434782 */   GIR_RootConstrainSelectedInstOperands,
     /* 434783 */   // GIR_Coverage, 1884,
     /* 434783 */   GIR_Done,
     /* 434784 */ // Label 8749: @434784
     /* 434784 */ GIM_Reject,
     /* 434785 */ // Label 8723: @434785
     /* 434785 */ GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(434839),
     /* 434790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 434796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434808 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(434823), // Rule ID 1887 //
     /* 434813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434816 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 434821 */     GIR_RootConstrainSelectedInstOperands,
     /* 434822 */     // GIR_Coverage, 1887,
     /* 434822 */     GIR_Done,
     /* 434823 */   // Label 8751: @434823
     /* 434823 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(434838), // Rule ID 5485 //
     /* 434828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434831 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 434831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 434836 */     GIR_RootConstrainSelectedInstOperands,
     /* 434837 */     // GIR_Coverage, 5485,
     /* 434837 */     GIR_Done,
     /* 434838 */   // Label 8752: @434838
     /* 434838 */   GIM_Reject,
     /* 434839 */ // Label 8750: @434839
     /* 434839 */ GIM_Reject,
     /* 434840 */ // Label 8724: @434840
     /* 434840 */ GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(434873), // Rule ID 1885 //
     /* 434845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434866 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 434871 */   GIR_RootConstrainSelectedInstOperands,
     /* 434872 */   // GIR_Coverage, 1885,
     /* 434872 */   GIR_Done,
     /* 434873 */ // Label 8753: @434873
     /* 434873 */ GIM_Reject,
     /* 434874 */ // Label 8725: @434874
     /* 434874 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(434899), // Rule ID 9007 //
     /* 434879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 434885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 434888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434892 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 434892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 434897 */   GIR_RootConstrainSelectedInstOperands,
     /* 434898 */   // GIR_Coverage, 9007,
     /* 434898 */   GIR_Done,
     /* 434899 */ // Label 8754: @434899
     /* 434899 */ GIM_Reject,
     /* 434900 */ // Label 8726: @434900
     /* 434900 */ GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(434925), // Rule ID 8969 //
     /* 434905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 434911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 434914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434918 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 434918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 434923 */   GIR_RootConstrainSelectedInstOperands,
     /* 434924 */   // GIR_Coverage, 8969,
     /* 434924 */   GIR_Done,
     /* 434925 */ // Label 8755: @434925
     /* 434925 */ GIM_Reject,
     /* 434926 */ // Label 8727: @434926
     /* 434926 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(434951), // Rule ID 8970 //
     /* 434931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 434937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 434940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434944 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 434944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 434949 */   GIR_RootConstrainSelectedInstOperands,
     /* 434950 */   // GIR_Coverage, 8970,
     /* 434950 */   GIR_Done,
     /* 434951 */ // Label 8756: @434951
     /* 434951 */ GIM_Reject,
     /* 434952 */ // Label 8728: @434952
     /* 434952 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(434998),
     /* 434957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 434960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 434963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434967 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(434982), // Rule ID 8965 //
     /* 434972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434975 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 434975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 434980 */     GIR_RootConstrainSelectedInstOperands,
     /* 434981 */     // GIR_Coverage, 8965,
     /* 434981 */     GIR_Done,
     /* 434982 */   // Label 8758: @434982
     /* 434982 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(434997), // Rule ID 8971 //
     /* 434987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434990 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 434990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 434995 */     GIR_RootConstrainSelectedInstOperands,
     /* 434996 */     // GIR_Coverage, 8971,
     /* 434996 */     GIR_Done,
     /* 434997 */   // Label 8759: @434997
     /* 434997 */   GIM_Reject,
     /* 434998 */ // Label 8757: @434998
     /* 434998 */ GIM_Reject,
     /* 434999 */ // Label 8729: @434999
     /* 434999 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(435024), // Rule ID 9006 //
     /* 435004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435017 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 435022 */   GIR_RootConstrainSelectedInstOperands,
     /* 435023 */   // GIR_Coverage, 9006,
     /* 435023 */   GIR_Done,
     /* 435024 */ // Label 8760: @435024
     /* 435024 */ GIM_Reject,
     /* 435025 */ // Label 8730: @435025
     /* 435025 */ GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(435050), // Rule ID 8967 //
     /* 435030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435043 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435048 */   GIR_RootConstrainSelectedInstOperands,
     /* 435049 */   // GIR_Coverage, 8967,
     /* 435049 */   GIR_Done,
     /* 435050 */ // Label 8761: @435050
     /* 435050 */ GIM_Reject,
     /* 435051 */ // Label 8731: @435051
     /* 435051 */ GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(435097),
     /* 435056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435066 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(435081), // Rule ID 8964 //
     /* 435071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435074 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 435074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435079 */     GIR_RootConstrainSelectedInstOperands,
     /* 435080 */     // GIR_Coverage, 8964,
     /* 435080 */     GIR_Done,
     /* 435081 */   // Label 8763: @435081
     /* 435081 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(435096), // Rule ID 8968 //
     /* 435086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435089 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 435089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435094 */     GIR_RootConstrainSelectedInstOperands,
     /* 435095 */     // GIR_Coverage, 8968,
     /* 435095 */     GIR_Done,
     /* 435096 */   // Label 8764: @435096
     /* 435096 */   GIM_Reject,
     /* 435097 */ // Label 8762: @435097
     /* 435097 */ GIM_Reject,
     /* 435098 */ // Label 8732: @435098
     /* 435098 */ GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(435123), // Rule ID 9005 //
     /* 435103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 435109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 435112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435116 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 435116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 435121 */   GIR_RootConstrainSelectedInstOperands,
     /* 435122 */   // GIR_Coverage, 9005,
     /* 435122 */   GIR_Done,
     /* 435123 */ // Label 8765: @435123
     /* 435123 */ GIM_Reject,
     /* 435124 */ // Label 8733: @435124
     /* 435124 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(435170),
     /* 435129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 435132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 435135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435139 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(435154), // Rule ID 8963 //
     /* 435144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435147 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 435147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435152 */     GIR_RootConstrainSelectedInstOperands,
     /* 435153 */     // GIR_Coverage, 8963,
     /* 435153 */     GIR_Done,
     /* 435154 */   // Label 8767: @435154
     /* 435154 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(435169), // Rule ID 8966 //
     /* 435159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435162 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 435162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 435167 */     GIR_RootConstrainSelectedInstOperands,
     /* 435168 */     // GIR_Coverage, 8966,
     /* 435168 */     GIR_Done,
     /* 435169 */   // Label 8768: @435169
     /* 435169 */   GIM_Reject,
     /* 435170 */ // Label 8766: @435170
     /* 435170 */ GIM_Reject,
     /* 435171 */ // Label 8734: @435171
     /* 435171 */ GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(435196), // Rule ID 2406 //
     /* 435176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 435182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 435185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435189 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 435189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 435194 */   GIR_RootConstrainSelectedInstOperands,
     /* 435195 */   // GIR_Coverage, 2406,
     /* 435195 */   GIR_Done,
     /* 435196 */ // Label 8769: @435196
     /* 435196 */ GIM_Reject,
     /* 435197 */ // Label 8735: @435197
     /* 435197 */ GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(435222), // Rule ID 8962 //
     /* 435202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 435208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 435211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435215 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 435215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 435220 */   GIR_RootConstrainSelectedInstOperands,
     /* 435221 */   // GIR_Coverage, 8962,
     /* 435221 */   GIR_Done,
     /* 435222 */ // Label 8770: @435222
     /* 435222 */ GIM_Reject,
     /* 435223 */ // Label 8736: @435223
     /* 435223 */ GIM_Reject,
     /* 435224 */ // Label 149: @435224
     /* 435224 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8789*/ GIMT_Encode4(436003),
     /* 435235 */ /*GILLT_v2s32*//*Label 8771*/ GIMT_Encode4(435311),
     /* 435239 */ /*GILLT_v2s64*//*Label 8772*/ GIMT_Encode4(435366),
     /* 435243 */ /*GILLT_v4s16*//*Label 8773*/ GIMT_Encode4(435421),
     /* 435247 */ /*GILLT_v4s32*//*Label 8774*/ GIMT_Encode4(435476),
     /* 435251 */ /*GILLT_v8s8*//*Label 8775*/ GIMT_Encode4(435531),
     /* 435255 */ /*GILLT_v8s16*//*Label 8776*/ GIMT_Encode4(435565),
     /* 435259 */ /*GILLT_v16s8*//*Label 8777*/ GIMT_Encode4(435620), GIMT_Encode4(0),
     /* 435267 */ /*GILLT_nxv2s1*//*Label 8778*/ GIMT_Encode4(435654),
     /* 435271 */ /*GILLT_nxv2s16*//*Label 8779*/ GIMT_Encode4(435680),
     /* 435275 */ /*GILLT_nxv2s32*//*Label 8780*/ GIMT_Encode4(435706),
     /* 435279 */ /*GILLT_nxv2s64*//*Label 8781*/ GIMT_Encode4(435732),
     /* 435283 */ /*GILLT_nxv4s1*//*Label 8782*/ GIMT_Encode4(435779),
     /* 435287 */ /*GILLT_nxv4s16*//*Label 8783*/ GIMT_Encode4(435805),
     /* 435291 */ /*GILLT_nxv4s32*//*Label 8784*/ GIMT_Encode4(435831),
     /* 435295 */ /*GILLT_nxv8s1*//*Label 8785*/ GIMT_Encode4(435878),
     /* 435299 */ /*GILLT_nxv8s16*//*Label 8786*/ GIMT_Encode4(435904),
     /* 435303 */ /*GILLT_nxv16s1*//*Label 8787*/ GIMT_Encode4(435951),
     /* 435307 */ /*GILLT_nxv16s8*//*Label 8788*/ GIMT_Encode4(435977),
     /* 435311 */ // Label 8771: @435311
     /* 435311 */ GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(435365),
     /* 435316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435334 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(435349), // Rule ID 1895 //
     /* 435339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435342 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 435347 */     GIR_RootConstrainSelectedInstOperands,
     /* 435348 */     // GIR_Coverage, 1895,
     /* 435348 */     GIR_Done,
     /* 435349 */   // Label 8791: @435349
     /* 435349 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(435364), // Rule ID 5491 //
     /* 435354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435357 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 435357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 435362 */     GIR_RootConstrainSelectedInstOperands,
     /* 435363 */     // GIR_Coverage, 5491,
     /* 435363 */     GIR_Done,
     /* 435364 */   // Label 8792: @435364
     /* 435364 */   GIM_Reject,
     /* 435365 */ // Label 8790: @435365
     /* 435365 */ GIM_Reject,
     /* 435366 */ // Label 8772: @435366
     /* 435366 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(435420),
     /* 435371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 435374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 435377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435389 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(435404), // Rule ID 1897 //
     /* 435394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435397 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 435397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 435402 */     GIR_RootConstrainSelectedInstOperands,
     /* 435403 */     // GIR_Coverage, 1897,
     /* 435403 */     GIR_Done,
     /* 435404 */   // Label 8794: @435404
     /* 435404 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(435419), // Rule ID 5493 //
     /* 435409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435412 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 435412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 435417 */     GIR_RootConstrainSelectedInstOperands,
     /* 435418 */     // GIR_Coverage, 5493,
     /* 435418 */     GIR_Done,
     /* 435419 */   // Label 8795: @435419
     /* 435419 */   GIM_Reject,
     /* 435420 */ // Label 8793: @435420
     /* 435420 */ GIM_Reject,
     /* 435421 */ // Label 8773: @435421
     /* 435421 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(435475),
     /* 435426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435444 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(435459), // Rule ID 1893 //
     /* 435449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435452 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 435457 */     GIR_RootConstrainSelectedInstOperands,
     /* 435458 */     // GIR_Coverage, 1893,
     /* 435458 */     GIR_Done,
     /* 435459 */   // Label 8797: @435459
     /* 435459 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(435474), // Rule ID 5489 //
     /* 435464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435467 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 435467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 435472 */     GIR_RootConstrainSelectedInstOperands,
     /* 435473 */     // GIR_Coverage, 5489,
     /* 435473 */     GIR_Done,
     /* 435474 */   // Label 8798: @435474
     /* 435474 */   GIM_Reject,
     /* 435475 */ // Label 8796: @435475
     /* 435475 */ GIM_Reject,
     /* 435476 */ // Label 8774: @435476
     /* 435476 */ GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(435530),
     /* 435481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 435487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435499 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(435514), // Rule ID 1896 //
     /* 435504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435507 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 435512 */     GIR_RootConstrainSelectedInstOperands,
     /* 435513 */     // GIR_Coverage, 1896,
     /* 435513 */     GIR_Done,
     /* 435514 */   // Label 8800: @435514
     /* 435514 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(435529), // Rule ID 5492 //
     /* 435519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435522 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 435522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 435527 */     GIR_RootConstrainSelectedInstOperands,
     /* 435528 */     // GIR_Coverage, 5492,
     /* 435528 */     GIR_Done,
     /* 435529 */   // Label 8801: @435529
     /* 435529 */   GIM_Reject,
     /* 435530 */ // Label 8799: @435530
     /* 435530 */ GIM_Reject,
     /* 435531 */ // Label 8775: @435531
     /* 435531 */ GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(435564), // Rule ID 1891 //
     /* 435536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435557 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 435562 */   GIR_RootConstrainSelectedInstOperands,
     /* 435563 */   // GIR_Coverage, 1891,
     /* 435563 */   GIR_Done,
     /* 435564 */ // Label 8802: @435564
     /* 435564 */ GIM_Reject,
     /* 435565 */ // Label 8776: @435565
     /* 435565 */ GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(435619),
     /* 435570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 435576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435588 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(435603), // Rule ID 1894 //
     /* 435593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435596 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 435601 */     GIR_RootConstrainSelectedInstOperands,
     /* 435602 */     // GIR_Coverage, 1894,
     /* 435602 */     GIR_Done,
     /* 435603 */   // Label 8804: @435603
     /* 435603 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(435618), // Rule ID 5490 //
     /* 435608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435611 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 435611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 435616 */     GIR_RootConstrainSelectedInstOperands,
     /* 435617 */     // GIR_Coverage, 5490,
     /* 435617 */     GIR_Done,
     /* 435618 */   // Label 8805: @435618
     /* 435618 */   GIM_Reject,
     /* 435619 */ // Label 8803: @435619
     /* 435619 */ GIM_Reject,
     /* 435620 */ // Label 8777: @435620
     /* 435620 */ GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(435653), // Rule ID 1892 //
     /* 435625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435646 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 435651 */   GIR_RootConstrainSelectedInstOperands,
     /* 435652 */   // GIR_Coverage, 1892,
     /* 435652 */   GIR_Done,
     /* 435653 */ // Label 8806: @435653
     /* 435653 */ GIM_Reject,
     /* 435654 */ // Label 8778: @435654
     /* 435654 */ GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(435679), // Rule ID 9010 //
     /* 435659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 435665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 435668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435672 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 435672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 435677 */   GIR_RootConstrainSelectedInstOperands,
     /* 435678 */   // GIR_Coverage, 9010,
     /* 435678 */   GIR_Done,
     /* 435679 */ // Label 8807: @435679
     /* 435679 */ GIM_Reject,
     /* 435680 */ // Label 8779: @435680
     /* 435680 */ GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(435705), // Rule ID 8979 //
     /* 435685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 435691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 435694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435698 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 435698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435703 */   GIR_RootConstrainSelectedInstOperands,
     /* 435704 */   // GIR_Coverage, 8979,
     /* 435704 */   GIR_Done,
     /* 435705 */ // Label 8808: @435705
     /* 435705 */ GIM_Reject,
     /* 435706 */ // Label 8780: @435706
     /* 435706 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(435731), // Rule ID 8980 //
     /* 435711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 435717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 435720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435724 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 435724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435729 */   GIR_RootConstrainSelectedInstOperands,
     /* 435730 */   // GIR_Coverage, 8980,
     /* 435730 */   GIR_Done,
     /* 435731 */ // Label 8809: @435731
     /* 435731 */ GIM_Reject,
     /* 435732 */ // Label 8781: @435732
     /* 435732 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(435778),
     /* 435737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 435743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435747 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(435762), // Rule ID 8975 //
     /* 435752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435755 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 435755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435760 */     GIR_RootConstrainSelectedInstOperands,
     /* 435761 */     // GIR_Coverage, 8975,
     /* 435761 */     GIR_Done,
     /* 435762 */   // Label 8811: @435762
     /* 435762 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(435777), // Rule ID 8981 //
     /* 435767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435770 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 435770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 435775 */     GIR_RootConstrainSelectedInstOperands,
     /* 435776 */     // GIR_Coverage, 8981,
     /* 435776 */     GIR_Done,
     /* 435777 */   // Label 8812: @435777
     /* 435777 */   GIM_Reject,
     /* 435778 */ // Label 8810: @435778
     /* 435778 */ GIM_Reject,
     /* 435779 */ // Label 8782: @435779
     /* 435779 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(435804), // Rule ID 9009 //
     /* 435784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435797 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 435802 */   GIR_RootConstrainSelectedInstOperands,
     /* 435803 */   // GIR_Coverage, 9009,
     /* 435803 */   GIR_Done,
     /* 435804 */ // Label 8813: @435804
     /* 435804 */ GIM_Reject,
     /* 435805 */ // Label 8783: @435805
     /* 435805 */ GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(435830), // Rule ID 8977 //
     /* 435810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435823 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 435828 */   GIR_RootConstrainSelectedInstOperands,
     /* 435829 */   // GIR_Coverage, 8977,
     /* 435829 */   GIR_Done,
     /* 435830 */ // Label 8814: @435830
     /* 435830 */ GIM_Reject,
     /* 435831 */ // Label 8784: @435831
     /* 435831 */ GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(435877),
     /* 435836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435846 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(435861), // Rule ID 8974 //
     /* 435851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435854 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 435854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 435859 */     GIR_RootConstrainSelectedInstOperands,
     /* 435860 */     // GIR_Coverage, 8974,
     /* 435860 */     GIR_Done,
     /* 435861 */   // Label 8816: @435861
     /* 435861 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(435876), // Rule ID 8978 //
     /* 435866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435869 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 435869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 435874 */     GIR_RootConstrainSelectedInstOperands,
     /* 435875 */     // GIR_Coverage, 8978,
     /* 435875 */     GIR_Done,
     /* 435876 */   // Label 8817: @435876
     /* 435876 */   GIM_Reject,
     /* 435877 */ // Label 8815: @435877
     /* 435877 */ GIM_Reject,
     /* 435878 */ // Label 8785: @435878
     /* 435878 */ GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(435903), // Rule ID 9008 //
     /* 435883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 435889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 435892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435896 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 435896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 435901 */   GIR_RootConstrainSelectedInstOperands,
     /* 435902 */   // GIR_Coverage, 9008,
     /* 435902 */   GIR_Done,
     /* 435903 */ // Label 8818: @435903
     /* 435903 */ GIM_Reject,
     /* 435904 */ // Label 8786: @435904
     /* 435904 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(435950),
     /* 435909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 435912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 435915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435919 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(435934), // Rule ID 8973 //
     /* 435924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435927 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 435927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 435932 */     GIR_RootConstrainSelectedInstOperands,
     /* 435933 */     // GIR_Coverage, 8973,
     /* 435933 */     GIR_Done,
     /* 435934 */   // Label 8820: @435934
     /* 435934 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(435949), // Rule ID 8976 //
     /* 435939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435942 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 435942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 435947 */     GIR_RootConstrainSelectedInstOperands,
     /* 435948 */     // GIR_Coverage, 8976,
     /* 435948 */     GIR_Done,
     /* 435949 */   // Label 8821: @435949
     /* 435949 */   GIM_Reject,
     /* 435950 */ // Label 8819: @435950
     /* 435950 */ GIM_Reject,
     /* 435951 */ // Label 8787: @435951
     /* 435951 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(435976), // Rule ID 2410 //
     /* 435956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 435962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 435965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435969 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 435969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 435974 */   GIR_RootConstrainSelectedInstOperands,
     /* 435975 */   // GIR_Coverage, 2410,
     /* 435975 */   GIR_Done,
     /* 435976 */ // Label 8822: @435976
     /* 435976 */ GIM_Reject,
     /* 435977 */ // Label 8788: @435977
     /* 435977 */ GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(436002), // Rule ID 8972 //
     /* 435982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 435988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 435991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435995 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 435995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 436000 */   GIR_RootConstrainSelectedInstOperands,
     /* 436001 */   // GIR_Coverage, 8972,
     /* 436001 */   GIR_Done,
     /* 436002 */ // Label 8823: @436002
     /* 436002 */ GIM_Reject,
     /* 436003 */ // Label 8789: @436003
     /* 436003 */ GIM_Reject,
     /* 436004 */ // Label 150: @436004
     /* 436004 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8832*/ GIMT_Encode4(436701),
     /* 436015 */ /*GILLT_s64*//*Label 8824*/ GIMT_Encode4(436051), GIMT_Encode4(0),
     /* 436023 */ /*GILLT_v2s32*//*Label 8825*/ GIMT_Encode4(436162),
     /* 436027 */ /*GILLT_v2s64*//*Label 8826*/ GIMT_Encode4(436239),
     /* 436031 */ /*GILLT_v4s16*//*Label 8827*/ GIMT_Encode4(436316),
     /* 436035 */ /*GILLT_v4s32*//*Label 8828*/ GIMT_Encode4(436393),
     /* 436039 */ /*GILLT_v8s8*//*Label 8829*/ GIMT_Encode4(436470),
     /* 436043 */ /*GILLT_v8s16*//*Label 8830*/ GIMT_Encode4(436547),
     /* 436047 */ /*GILLT_v16s8*//*Label 8831*/ GIMT_Encode4(436624),
     /* 436051 */ // Label 8824: @436051
     /* 436051 */ GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(436161),
     /* 436056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436067 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(436092), // Rule ID 5263 //
     /* 436072 */     // MIs[0] Operand 2
     /* 436072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436083 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 436083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 436086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436090 */     GIR_RootConstrainSelectedInstOperands,
     /* 436091 */     // GIR_Coverage, 5263,
     /* 436091 */     GIR_EraseRootFromParent_Done,
     /* 436092 */   // Label 8834: @436092
     /* 436092 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(436126), // Rule ID 2120 //
     /* 436097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436100 */     // MIs[0] imm
     /* 436100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436112 */     // MIs[1] Operand 1
     /* 436112 */     // No operand predicates
     /* 436112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436114 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436124 */     GIR_RootConstrainSelectedInstOperands,
     /* 436125 */     // GIR_Coverage, 2120,
     /* 436125 */     GIR_EraseRootFromParent_Done,
     /* 436126 */   // Label 8835: @436126
     /* 436126 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(436160), // Rule ID 6325 //
     /* 436131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436134 */     // MIs[0] imm
     /* 436134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436146 */     // MIs[1] Operand 1
     /* 436146 */     // No operand predicates
     /* 436146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436148 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 436148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 436151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436158 */     GIR_RootConstrainSelectedInstOperands,
     /* 436159 */     // GIR_Coverage, 6325,
     /* 436159 */     GIR_EraseRootFromParent_Done,
     /* 436160 */   // Label 8836: @436160
     /* 436160 */   GIM_Reject,
     /* 436161 */ // Label 8833: @436161
     /* 436161 */ GIM_Reject,
     /* 436162 */ // Label 8825: @436162
     /* 436162 */ GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(436238),
     /* 436167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436178 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(436203), // Rule ID 4925 //
     /* 436183 */     // MIs[0] Operand 2
     /* 436183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 436194 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 436194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 436197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436201 */     GIR_RootConstrainSelectedInstOperands,
     /* 436202 */     // GIR_Coverage, 4925,
     /* 436202 */     GIR_EraseRootFromParent_Done,
     /* 436203 */   // Label 8838: @436203
     /* 436203 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(436237), // Rule ID 2227 //
     /* 436208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436211 */     // MIs[0] imm
     /* 436211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436223 */     // MIs[1] Operand 1
     /* 436223 */     // No operand predicates
     /* 436223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436225 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 436228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436235 */     GIR_RootConstrainSelectedInstOperands,
     /* 436236 */     // GIR_Coverage, 2227,
     /* 436236 */     GIR_EraseRootFromParent_Done,
     /* 436237 */   // Label 8839: @436237
     /* 436237 */   GIM_Reject,
     /* 436238 */ // Label 8837: @436238
     /* 436238 */ GIM_Reject,
     /* 436239 */ // Label 8826: @436239
     /* 436239 */ GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(436315),
     /* 436244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436255 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(436280), // Rule ID 4929 //
     /* 436260 */     // MIs[0] Operand 2
     /* 436260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436271 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 436271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 436274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436278 */     GIR_RootConstrainSelectedInstOperands,
     /* 436279 */     // GIR_Coverage, 4929,
     /* 436279 */     GIR_EraseRootFromParent_Done,
     /* 436280 */   // Label 8841: @436280
     /* 436280 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(436314), // Rule ID 2229 //
     /* 436285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436288 */     // MIs[0] imm
     /* 436288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436300 */     // MIs[1] Operand 1
     /* 436300 */     // No operand predicates
     /* 436300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436302 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 436305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436312 */     GIR_RootConstrainSelectedInstOperands,
     /* 436313 */     // GIR_Coverage, 2229,
     /* 436313 */     GIR_EraseRootFromParent_Done,
     /* 436314 */   // Label 8842: @436314
     /* 436314 */   GIM_Reject,
     /* 436315 */ // Label 8840: @436315
     /* 436315 */ GIM_Reject,
     /* 436316 */ // Label 8827: @436316
     /* 436316 */ GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(436392),
     /* 436321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436332 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(436357), // Rule ID 4924 //
     /* 436337 */     // MIs[0] Operand 2
     /* 436337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 436348 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 436348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 436351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436355 */     GIR_RootConstrainSelectedInstOperands,
     /* 436356 */     // GIR_Coverage, 4924,
     /* 436356 */     GIR_EraseRootFromParent_Done,
     /* 436357 */   // Label 8844: @436357
     /* 436357 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(436391), // Rule ID 2225 //
     /* 436362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436365 */     // MIs[0] imm
     /* 436365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 436377 */     // MIs[1] Operand 1
     /* 436377 */     // No operand predicates
     /* 436377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436379 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 436382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436389 */     GIR_RootConstrainSelectedInstOperands,
     /* 436390 */     // GIR_Coverage, 2225,
     /* 436390 */     GIR_EraseRootFromParent_Done,
     /* 436391 */   // Label 8845: @436391
     /* 436391 */   GIM_Reject,
     /* 436392 */ // Label 8843: @436392
     /* 436392 */ GIM_Reject,
     /* 436393 */ // Label 8828: @436393
     /* 436393 */ GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(436469),
     /* 436398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436409 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(436434), // Rule ID 4928 //
     /* 436414 */     // MIs[0] Operand 2
     /* 436414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 436425 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 436425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 436428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436432 */     GIR_RootConstrainSelectedInstOperands,
     /* 436433 */     // GIR_Coverage, 4928,
     /* 436433 */     GIR_EraseRootFromParent_Done,
     /* 436434 */   // Label 8847: @436434
     /* 436434 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(436468), // Rule ID 2228 //
     /* 436439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436442 */     // MIs[0] imm
     /* 436442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436454 */     // MIs[1] Operand 1
     /* 436454 */     // No operand predicates
     /* 436454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436456 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 436459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436466 */     GIR_RootConstrainSelectedInstOperands,
     /* 436467 */     // GIR_Coverage, 2228,
     /* 436467 */     GIR_EraseRootFromParent_Done,
     /* 436468 */   // Label 8848: @436468
     /* 436468 */   GIM_Reject,
     /* 436469 */ // Label 8846: @436469
     /* 436469 */ GIM_Reject,
     /* 436470 */ // Label 8829: @436470
     /* 436470 */ GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(436546),
     /* 436475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436486 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(436511), // Rule ID 4923 //
     /* 436491 */     // MIs[0] Operand 2
     /* 436491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 436502 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 436502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 436505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436509 */     GIR_RootConstrainSelectedInstOperands,
     /* 436510 */     // GIR_Coverage, 4923,
     /* 436510 */     GIR_EraseRootFromParent_Done,
     /* 436511 */   // Label 8850: @436511
     /* 436511 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(436545), // Rule ID 2223 //
     /* 436516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436519 */     // MIs[0] imm
     /* 436519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 436531 */     // MIs[1] Operand 1
     /* 436531 */     // No operand predicates
     /* 436531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436533 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 436536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436543 */     GIR_RootConstrainSelectedInstOperands,
     /* 436544 */     // GIR_Coverage, 2223,
     /* 436544 */     GIR_EraseRootFromParent_Done,
     /* 436545 */   // Label 8851: @436545
     /* 436545 */   GIM_Reject,
     /* 436546 */ // Label 8849: @436546
     /* 436546 */ GIM_Reject,
     /* 436547 */ // Label 8830: @436547
     /* 436547 */ GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(436623),
     /* 436552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436563 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(436588), // Rule ID 4927 //
     /* 436568 */     // MIs[0] Operand 2
     /* 436568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 436579 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 436579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 436582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436586 */     GIR_RootConstrainSelectedInstOperands,
     /* 436587 */     // GIR_Coverage, 4927,
     /* 436587 */     GIR_EraseRootFromParent_Done,
     /* 436588 */   // Label 8853: @436588
     /* 436588 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(436622), // Rule ID 2226 //
     /* 436593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436596 */     // MIs[0] imm
     /* 436596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 436608 */     // MIs[1] Operand 1
     /* 436608 */     // No operand predicates
     /* 436608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436610 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 436613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436620 */     GIR_RootConstrainSelectedInstOperands,
     /* 436621 */     // GIR_Coverage, 2226,
     /* 436621 */     GIR_EraseRootFromParent_Done,
     /* 436622 */   // Label 8854: @436622
     /* 436622 */   GIM_Reject,
     /* 436623 */ // Label 8852: @436623
     /* 436623 */ GIM_Reject,
     /* 436624 */ // Label 8831: @436624
     /* 436624 */ GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(436700),
     /* 436629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436640 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(436665), // Rule ID 4926 //
     /* 436645 */     // MIs[0] Operand 2
     /* 436645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 436656 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 436656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 436659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436663 */     GIR_RootConstrainSelectedInstOperands,
     /* 436664 */     // GIR_Coverage, 4926,
     /* 436664 */     GIR_EraseRootFromParent_Done,
     /* 436665 */   // Label 8856: @436665
     /* 436665 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(436699), // Rule ID 2224 //
     /* 436670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436673 */     // MIs[0] imm
     /* 436673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 436685 */     // MIs[1] Operand 1
     /* 436685 */     // No operand predicates
     /* 436685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436687 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 436690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436697 */     GIR_RootConstrainSelectedInstOperands,
     /* 436698 */     // GIR_Coverage, 2224,
     /* 436698 */     GIR_EraseRootFromParent_Done,
     /* 436699 */   // Label 8857: @436699
     /* 436699 */   GIM_Reject,
     /* 436700 */ // Label 8855: @436700
     /* 436700 */ GIM_Reject,
     /* 436701 */ // Label 8832: @436701
     /* 436701 */ GIM_Reject,
     /* 436702 */ // Label 151: @436702
     /* 436702 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8866*/ GIMT_Encode4(437157),
     /* 436713 */ /*GILLT_s64*//*Label 8858*/ GIMT_Encode4(436749), GIMT_Encode4(0),
     /* 436721 */ /*GILLT_v2s32*//*Label 8859*/ GIMT_Encode4(436835),
     /* 436725 */ /*GILLT_v2s64*//*Label 8860*/ GIMT_Encode4(436881),
     /* 436729 */ /*GILLT_v4s16*//*Label 8861*/ GIMT_Encode4(436927),
     /* 436733 */ /*GILLT_v4s32*//*Label 8862*/ GIMT_Encode4(436973),
     /* 436737 */ /*GILLT_v8s8*//*Label 8863*/ GIMT_Encode4(437019),
     /* 436741 */ /*GILLT_v8s16*//*Label 8864*/ GIMT_Encode4(437065),
     /* 436745 */ /*GILLT_v16s8*//*Label 8865*/ GIMT_Encode4(437111),
     /* 436749 */ // Label 8858: @436749
     /* 436749 */ GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(436834),
     /* 436754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436765 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(436799), // Rule ID 2129 //
     /* 436770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436773 */     // MIs[0] imm
     /* 436773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436785 */     // MIs[1] Operand 1
     /* 436785 */     // No operand predicates
     /* 436785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436787 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 436790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436797 */     GIR_RootConstrainSelectedInstOperands,
     /* 436798 */     // GIR_Coverage, 2129,
     /* 436798 */     GIR_EraseRootFromParent_Done,
     /* 436799 */   // Label 8868: @436799
     /* 436799 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(436833), // Rule ID 6328 //
     /* 436804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436807 */     // MIs[0] imm
     /* 436807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436819 */     // MIs[1] Operand 1
     /* 436819 */     // No operand predicates
     /* 436819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436821 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 436821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 436824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436831 */     GIR_RootConstrainSelectedInstOperands,
     /* 436832 */     // GIR_Coverage, 6328,
     /* 436832 */     GIR_EraseRootFromParent_Done,
     /* 436833 */   // Label 8869: @436833
     /* 436833 */   GIM_Reject,
     /* 436834 */ // Label 8867: @436834
     /* 436834 */ GIM_Reject,
     /* 436835 */ // Label 8859: @436835
     /* 436835 */ GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(436880), // Rule ID 2286 //
     /* 436840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436854 */   // MIs[0] imm
     /* 436854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436862 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 436866 */   // MIs[1] Operand 1
     /* 436866 */   // No operand predicates
     /* 436866 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436868 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 436871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436873 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436875 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436878 */   GIR_RootConstrainSelectedInstOperands,
     /* 436879 */   // GIR_Coverage, 2286,
     /* 436879 */   GIR_EraseRootFromParent_Done,
     /* 436880 */ // Label 8870: @436880
     /* 436880 */ GIM_Reject,
     /* 436881 */ // Label 8860: @436881
     /* 436881 */ GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(436926), // Rule ID 2288 //
     /* 436886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436900 */   // MIs[0] imm
     /* 436900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436908 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 436912 */   // MIs[1] Operand 1
     /* 436912 */   // No operand predicates
     /* 436912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436914 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 436917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436919 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436921 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436924 */   GIR_RootConstrainSelectedInstOperands,
     /* 436925 */   // GIR_Coverage, 2288,
     /* 436925 */   GIR_EraseRootFromParent_Done,
     /* 436926 */ // Label 8871: @436926
     /* 436926 */ GIM_Reject,
     /* 436927 */ // Label 8861: @436927
     /* 436927 */ GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(436972), // Rule ID 2284 //
     /* 436932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436946 */   // MIs[0] imm
     /* 436946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436954 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 436958 */   // MIs[1] Operand 1
     /* 436958 */   // No operand predicates
     /* 436958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 436960 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 436960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 436963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436965 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436967 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 436970 */   GIR_RootConstrainSelectedInstOperands,
     /* 436971 */   // GIR_Coverage, 2284,
     /* 436971 */   GIR_EraseRootFromParent_Done,
     /* 436972 */ // Label 8872: @436972
     /* 436972 */ GIM_Reject,
     /* 436973 */ // Label 8862: @436973
     /* 436973 */ GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(437018), // Rule ID 2287 //
     /* 436978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436992 */   // MIs[0] imm
     /* 436992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437000 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437004 */   // MIs[1] Operand 1
     /* 437004 */   // No operand predicates
     /* 437004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437006 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 437009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437011 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437013 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437016 */   GIR_RootConstrainSelectedInstOperands,
     /* 437017 */   // GIR_Coverage, 2287,
     /* 437017 */   GIR_EraseRootFromParent_Done,
     /* 437018 */ // Label 8873: @437018
     /* 437018 */ GIM_Reject,
     /* 437019 */ // Label 8863: @437019
     /* 437019 */ GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(437064), // Rule ID 2282 //
     /* 437024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437038 */   // MIs[0] imm
     /* 437038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437046 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437050 */   // MIs[1] Operand 1
     /* 437050 */   // No operand predicates
     /* 437050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437052 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 437055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437059 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437062 */   GIR_RootConstrainSelectedInstOperands,
     /* 437063 */   // GIR_Coverage, 2282,
     /* 437063 */   GIR_EraseRootFromParent_Done,
     /* 437064 */ // Label 8874: @437064
     /* 437064 */ GIM_Reject,
     /* 437065 */ // Label 8864: @437065
     /* 437065 */ GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(437110), // Rule ID 2285 //
     /* 437070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437084 */   // MIs[0] imm
     /* 437084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437092 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437096 */   // MIs[1] Operand 1
     /* 437096 */   // No operand predicates
     /* 437096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437098 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 437101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437103 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437108 */   GIR_RootConstrainSelectedInstOperands,
     /* 437109 */   // GIR_Coverage, 2285,
     /* 437109 */   GIR_EraseRootFromParent_Done,
     /* 437110 */ // Label 8875: @437110
     /* 437110 */ GIM_Reject,
     /* 437111 */ // Label 8865: @437111
     /* 437111 */ GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(437156), // Rule ID 2283 //
     /* 437116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437130 */   // MIs[0] imm
     /* 437130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437138 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437142 */   // MIs[1] Operand 1
     /* 437142 */   // No operand predicates
     /* 437142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437144 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 437147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437149 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437151 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437154 */   GIR_RootConstrainSelectedInstOperands,
     /* 437155 */   // GIR_Coverage, 2283,
     /* 437155 */   GIR_EraseRootFromParent_Done,
     /* 437156 */ // Label 8876: @437156
     /* 437156 */ GIM_Reject,
     /* 437157 */ // Label 8866: @437157
     /* 437157 */ GIM_Reject,
     /* 437158 */ // Label 152: @437158
     /* 437158 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8895*/ GIMT_Encode4(437937),
     /* 437169 */ /*GILLT_v2s32*//*Label 8877*/ GIMT_Encode4(437245),
     /* 437173 */ /*GILLT_v2s64*//*Label 8878*/ GIMT_Encode4(437300),
     /* 437177 */ /*GILLT_v4s16*//*Label 8879*/ GIMT_Encode4(437355),
     /* 437181 */ /*GILLT_v4s32*//*Label 8880*/ GIMT_Encode4(437410),
     /* 437185 */ /*GILLT_v8s8*//*Label 8881*/ GIMT_Encode4(437465),
     /* 437189 */ /*GILLT_v8s16*//*Label 8882*/ GIMT_Encode4(437499),
     /* 437193 */ /*GILLT_v16s8*//*Label 8883*/ GIMT_Encode4(437554), GIMT_Encode4(0),
     /* 437201 */ /*GILLT_nxv2s1*//*Label 8884*/ GIMT_Encode4(437588),
     /* 437205 */ /*GILLT_nxv2s16*//*Label 8885*/ GIMT_Encode4(437614),
     /* 437209 */ /*GILLT_nxv2s32*//*Label 8886*/ GIMT_Encode4(437640),
     /* 437213 */ /*GILLT_nxv2s64*//*Label 8887*/ GIMT_Encode4(437666),
     /* 437217 */ /*GILLT_nxv4s1*//*Label 8888*/ GIMT_Encode4(437713),
     /* 437221 */ /*GILLT_nxv4s16*//*Label 8889*/ GIMT_Encode4(437739),
     /* 437225 */ /*GILLT_nxv4s32*//*Label 8890*/ GIMT_Encode4(437765),
     /* 437229 */ /*GILLT_nxv8s1*//*Label 8891*/ GIMT_Encode4(437812),
     /* 437233 */ /*GILLT_nxv8s16*//*Label 8892*/ GIMT_Encode4(437838),
     /* 437237 */ /*GILLT_nxv16s1*//*Label 8893*/ GIMT_Encode4(437885),
     /* 437241 */ /*GILLT_nxv16s8*//*Label 8894*/ GIMT_Encode4(437911),
     /* 437245 */ // Label 8877: @437245
     /* 437245 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(437299),
     /* 437250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437268 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(437283), // Rule ID 1902 //
     /* 437273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437276 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437281 */     GIR_RootConstrainSelectedInstOperands,
     /* 437282 */     // GIR_Coverage, 1902,
     /* 437282 */     GIR_Done,
     /* 437283 */   // Label 8897: @437283
     /* 437283 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(437298), // Rule ID 5496 //
     /* 437288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437291 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 437296 */     GIR_RootConstrainSelectedInstOperands,
     /* 437297 */     // GIR_Coverage, 5496,
     /* 437297 */     GIR_Done,
     /* 437298 */   // Label 8898: @437298
     /* 437298 */   GIM_Reject,
     /* 437299 */ // Label 8896: @437299
     /* 437299 */ GIM_Reject,
     /* 437300 */ // Label 8878: @437300
     /* 437300 */ GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(437354),
     /* 437305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437323 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(437338), // Rule ID 1904 //
     /* 437328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437331 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 437336 */     GIR_RootConstrainSelectedInstOperands,
     /* 437337 */     // GIR_Coverage, 1904,
     /* 437337 */     GIR_Done,
     /* 437338 */   // Label 8900: @437338
     /* 437338 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(437353), // Rule ID 5498 //
     /* 437343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437346 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 437351 */     GIR_RootConstrainSelectedInstOperands,
     /* 437352 */     // GIR_Coverage, 5498,
     /* 437352 */     GIR_Done,
     /* 437353 */   // Label 8901: @437353
     /* 437353 */   GIM_Reject,
     /* 437354 */ // Label 8899: @437354
     /* 437354 */ GIM_Reject,
     /* 437355 */ // Label 8879: @437355
     /* 437355 */ GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(437409),
     /* 437360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437378 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(437393), // Rule ID 1900 //
     /* 437383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437386 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 437391 */     GIR_RootConstrainSelectedInstOperands,
     /* 437392 */     // GIR_Coverage, 1900,
     /* 437392 */     GIR_Done,
     /* 437393 */   // Label 8903: @437393
     /* 437393 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(437408), // Rule ID 5494 //
     /* 437398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437401 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 437406 */     GIR_RootConstrainSelectedInstOperands,
     /* 437407 */     // GIR_Coverage, 5494,
     /* 437407 */     GIR_Done,
     /* 437408 */   // Label 8904: @437408
     /* 437408 */   GIM_Reject,
     /* 437409 */ // Label 8902: @437409
     /* 437409 */ GIM_Reject,
     /* 437410 */ // Label 8880: @437410
     /* 437410 */ GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(437464),
     /* 437415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437433 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(437448), // Rule ID 1903 //
     /* 437438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437441 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 437441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 437446 */     GIR_RootConstrainSelectedInstOperands,
     /* 437447 */     // GIR_Coverage, 1903,
     /* 437447 */     GIR_Done,
     /* 437448 */   // Label 8906: @437448
     /* 437448 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(437463), // Rule ID 5497 //
     /* 437453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437456 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 437456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 437461 */     GIR_RootConstrainSelectedInstOperands,
     /* 437462 */     // GIR_Coverage, 5497,
     /* 437462 */     GIR_Done,
     /* 437463 */   // Label 8907: @437463
     /* 437463 */   GIM_Reject,
     /* 437464 */ // Label 8905: @437464
     /* 437464 */ GIM_Reject,
     /* 437465 */ // Label 8881: @437465
     /* 437465 */ GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(437498), // Rule ID 1898 //
     /* 437470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437491 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 437496 */   GIR_RootConstrainSelectedInstOperands,
     /* 437497 */   // GIR_Coverage, 1898,
     /* 437497 */   GIR_Done,
     /* 437498 */ // Label 8908: @437498
     /* 437498 */ GIM_Reject,
     /* 437499 */ // Label 8882: @437499
     /* 437499 */ GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(437553),
     /* 437504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 437510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437522 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(437537), // Rule ID 1901 //
     /* 437527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437530 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 437535 */     GIR_RootConstrainSelectedInstOperands,
     /* 437536 */     // GIR_Coverage, 1901,
     /* 437536 */     GIR_Done,
     /* 437537 */   // Label 8910: @437537
     /* 437537 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(437552), // Rule ID 5495 //
     /* 437542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437545 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 437545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 437550 */     GIR_RootConstrainSelectedInstOperands,
     /* 437551 */     // GIR_Coverage, 5495,
     /* 437551 */     GIR_Done,
     /* 437552 */   // Label 8911: @437552
     /* 437552 */   GIM_Reject,
     /* 437553 */ // Label 8909: @437553
     /* 437553 */ GIM_Reject,
     /* 437554 */ // Label 8883: @437554
     /* 437554 */ GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(437587), // Rule ID 1899 //
     /* 437559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 437568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437580 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 437585 */   GIR_RootConstrainSelectedInstOperands,
     /* 437586 */   // GIR_Coverage, 1899,
     /* 437586 */   GIR_Done,
     /* 437587 */ // Label 8912: @437587
     /* 437587 */ GIM_Reject,
     /* 437588 */ // Label 8884: @437588
     /* 437588 */ GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(437613), // Rule ID 3341 //
     /* 437593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 437599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 437602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437606 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 437606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 437611 */   GIR_RootConstrainSelectedInstOperands,
     /* 437612 */   // GIR_Coverage, 3341,
     /* 437612 */   GIR_Done,
     /* 437613 */ // Label 8913: @437613
     /* 437613 */ GIM_Reject,
     /* 437614 */ // Label 8885: @437614
     /* 437614 */ GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(437639), // Rule ID 2872 //
     /* 437619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 437625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 437628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437632 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 437632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437637 */   GIR_RootConstrainSelectedInstOperands,
     /* 437638 */   // GIR_Coverage, 2872,
     /* 437638 */   GIR_Done,
     /* 437639 */ // Label 8914: @437639
     /* 437639 */ GIM_Reject,
     /* 437640 */ // Label 8886: @437640
     /* 437640 */ GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(437665), // Rule ID 2873 //
     /* 437645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 437651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 437654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437658 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 437658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437663 */   GIR_RootConstrainSelectedInstOperands,
     /* 437664 */   // GIR_Coverage, 2873,
     /* 437664 */   GIR_Done,
     /* 437665 */ // Label 8915: @437665
     /* 437665 */ GIM_Reject,
     /* 437666 */ // Label 8887: @437666
     /* 437666 */ GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(437712),
     /* 437671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 437674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 437677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437681 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(437696), // Rule ID 2868 //
     /* 437686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437689 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 437689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437694 */     GIR_RootConstrainSelectedInstOperands,
     /* 437695 */     // GIR_Coverage, 2868,
     /* 437695 */     GIR_Done,
     /* 437696 */   // Label 8917: @437696
     /* 437696 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(437711), // Rule ID 2874 //
     /* 437701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437704 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 437704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 437709 */     GIR_RootConstrainSelectedInstOperands,
     /* 437710 */     // GIR_Coverage, 2874,
     /* 437710 */     GIR_Done,
     /* 437711 */   // Label 8918: @437711
     /* 437711 */   GIM_Reject,
     /* 437712 */ // Label 8916: @437712
     /* 437712 */ GIM_Reject,
     /* 437713 */ // Label 8888: @437713
     /* 437713 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(437738), // Rule ID 3340 //
     /* 437718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 437724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 437727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437731 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 437731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 437736 */   GIR_RootConstrainSelectedInstOperands,
     /* 437737 */   // GIR_Coverage, 3340,
     /* 437737 */   GIR_Done,
     /* 437738 */ // Label 8919: @437738
     /* 437738 */ GIM_Reject,
     /* 437739 */ // Label 8889: @437739
     /* 437739 */ GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(437764), // Rule ID 2870 //
     /* 437744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 437750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 437753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437757 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 437757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437762 */   GIR_RootConstrainSelectedInstOperands,
     /* 437763 */   // GIR_Coverage, 2870,
     /* 437763 */   GIR_Done,
     /* 437764 */ // Label 8920: @437764
     /* 437764 */ GIM_Reject,
     /* 437765 */ // Label 8890: @437765
     /* 437765 */ GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(437811),
     /* 437770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 437773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 437776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437780 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(437795), // Rule ID 2867 //
     /* 437785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437788 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 437788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437793 */     GIR_RootConstrainSelectedInstOperands,
     /* 437794 */     // GIR_Coverage, 2867,
     /* 437794 */     GIR_Done,
     /* 437795 */   // Label 8922: @437795
     /* 437795 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(437810), // Rule ID 2871 //
     /* 437800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437803 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 437803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 437808 */     GIR_RootConstrainSelectedInstOperands,
     /* 437809 */     // GIR_Coverage, 2871,
     /* 437809 */     GIR_Done,
     /* 437810 */   // Label 8923: @437810
     /* 437810 */   GIM_Reject,
     /* 437811 */ // Label 8921: @437811
     /* 437811 */ GIM_Reject,
     /* 437812 */ // Label 8891: @437812
     /* 437812 */ GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(437837), // Rule ID 3339 //
     /* 437817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 437823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 437826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437830 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 437830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 437835 */   GIR_RootConstrainSelectedInstOperands,
     /* 437836 */   // GIR_Coverage, 3339,
     /* 437836 */   GIR_Done,
     /* 437837 */ // Label 8924: @437837
     /* 437837 */ GIM_Reject,
     /* 437838 */ // Label 8892: @437838
     /* 437838 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(437884),
     /* 437843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 437846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 437849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437853 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(437868), // Rule ID 2866 //
     /* 437858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437861 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 437861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 437866 */     GIR_RootConstrainSelectedInstOperands,
     /* 437867 */     // GIR_Coverage, 2866,
     /* 437867 */     GIR_Done,
     /* 437868 */   // Label 8926: @437868
     /* 437868 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(437883), // Rule ID 2869 //
     /* 437873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437876 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 437876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 437881 */     GIR_RootConstrainSelectedInstOperands,
     /* 437882 */     // GIR_Coverage, 2869,
     /* 437882 */     GIR_Done,
     /* 437883 */   // Label 8927: @437883
     /* 437883 */   GIM_Reject,
     /* 437884 */ // Label 8925: @437884
     /* 437884 */ GIM_Reject,
     /* 437885 */ // Label 8893: @437885
     /* 437885 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(437910), // Rule ID 2398 //
     /* 437890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 437896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 437899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437903 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 437903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 437908 */   GIR_RootConstrainSelectedInstOperands,
     /* 437909 */   // GIR_Coverage, 2398,
     /* 437909 */   GIR_Done,
     /* 437910 */ // Label 8928: @437910
     /* 437910 */ GIM_Reject,
     /* 437911 */ // Label 8894: @437911
     /* 437911 */ GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(437936), // Rule ID 2865 //
     /* 437916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 437922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 437925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437929 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 437929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 437934 */   GIR_RootConstrainSelectedInstOperands,
     /* 437935 */   // GIR_Coverage, 2865,
     /* 437935 */   GIR_Done,
     /* 437936 */ // Label 8929: @437936
     /* 437936 */ GIM_Reject,
     /* 437937 */ // Label 8895: @437937
     /* 437937 */ GIM_Reject,
     /* 437938 */ // Label 153: @437938
     /* 437938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8948*/ GIMT_Encode4(438717),
     /* 437949 */ /*GILLT_v2s32*//*Label 8930*/ GIMT_Encode4(438025),
     /* 437953 */ /*GILLT_v2s64*//*Label 8931*/ GIMT_Encode4(438080),
     /* 437957 */ /*GILLT_v4s16*//*Label 8932*/ GIMT_Encode4(438135),
     /* 437961 */ /*GILLT_v4s32*//*Label 8933*/ GIMT_Encode4(438190),
     /* 437965 */ /*GILLT_v8s8*//*Label 8934*/ GIMT_Encode4(438245),
     /* 437969 */ /*GILLT_v8s16*//*Label 8935*/ GIMT_Encode4(438279),
     /* 437973 */ /*GILLT_v16s8*//*Label 8936*/ GIMT_Encode4(438334), GIMT_Encode4(0),
     /* 437981 */ /*GILLT_nxv2s1*//*Label 8937*/ GIMT_Encode4(438368),
     /* 437985 */ /*GILLT_nxv2s16*//*Label 8938*/ GIMT_Encode4(438394),
     /* 437989 */ /*GILLT_nxv2s32*//*Label 8939*/ GIMT_Encode4(438420),
     /* 437993 */ /*GILLT_nxv2s64*//*Label 8940*/ GIMT_Encode4(438446),
     /* 437997 */ /*GILLT_nxv4s1*//*Label 8941*/ GIMT_Encode4(438493),
     /* 438001 */ /*GILLT_nxv4s16*//*Label 8942*/ GIMT_Encode4(438519),
     /* 438005 */ /*GILLT_nxv4s32*//*Label 8943*/ GIMT_Encode4(438545),
     /* 438009 */ /*GILLT_nxv8s1*//*Label 8944*/ GIMT_Encode4(438592),
     /* 438013 */ /*GILLT_nxv8s16*//*Label 8945*/ GIMT_Encode4(438618),
     /* 438017 */ /*GILLT_nxv16s1*//*Label 8946*/ GIMT_Encode4(438665),
     /* 438021 */ /*GILLT_nxv16s8*//*Label 8947*/ GIMT_Encode4(438691),
     /* 438025 */ // Label 8930: @438025
     /* 438025 */ GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(438079),
     /* 438030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438048 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(438063), // Rule ID 1909 //
     /* 438053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438056 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438061 */     GIR_RootConstrainSelectedInstOperands,
     /* 438062 */     // GIR_Coverage, 1909,
     /* 438062 */     GIR_Done,
     /* 438063 */   // Label 8950: @438063
     /* 438063 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(438078), // Rule ID 5501 //
     /* 438068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438071 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438076 */     GIR_RootConstrainSelectedInstOperands,
     /* 438077 */     // GIR_Coverage, 5501,
     /* 438077 */     GIR_Done,
     /* 438078 */   // Label 8951: @438078
     /* 438078 */   GIM_Reject,
     /* 438079 */ // Label 8949: @438079
     /* 438079 */ GIM_Reject,
     /* 438080 */ // Label 8931: @438080
     /* 438080 */ GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(438134),
     /* 438085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438103 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(438118), // Rule ID 1911 //
     /* 438108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438111 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438116 */     GIR_RootConstrainSelectedInstOperands,
     /* 438117 */     // GIR_Coverage, 1911,
     /* 438117 */     GIR_Done,
     /* 438118 */   // Label 8953: @438118
     /* 438118 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(438133), // Rule ID 5503 //
     /* 438123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438126 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 438131 */     GIR_RootConstrainSelectedInstOperands,
     /* 438132 */     // GIR_Coverage, 5503,
     /* 438132 */     GIR_Done,
     /* 438133 */   // Label 8954: @438133
     /* 438133 */   GIM_Reject,
     /* 438134 */ // Label 8952: @438134
     /* 438134 */ GIM_Reject,
     /* 438135 */ // Label 8932: @438135
     /* 438135 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(438189),
     /* 438140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438158 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(438173), // Rule ID 1907 //
     /* 438163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438166 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438171 */     GIR_RootConstrainSelectedInstOperands,
     /* 438172 */     // GIR_Coverage, 1907,
     /* 438172 */     GIR_Done,
     /* 438173 */   // Label 8956: @438173
     /* 438173 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(438188), // Rule ID 5499 //
     /* 438178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438181 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 438186 */     GIR_RootConstrainSelectedInstOperands,
     /* 438187 */     // GIR_Coverage, 5499,
     /* 438187 */     GIR_Done,
     /* 438188 */   // Label 8957: @438188
     /* 438188 */   GIM_Reject,
     /* 438189 */ // Label 8955: @438189
     /* 438189 */ GIM_Reject,
     /* 438190 */ // Label 8933: @438190
     /* 438190 */ GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(438244),
     /* 438195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438213 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(438228), // Rule ID 1910 //
     /* 438218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438221 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438226 */     GIR_RootConstrainSelectedInstOperands,
     /* 438227 */     // GIR_Coverage, 1910,
     /* 438227 */     GIR_Done,
     /* 438228 */   // Label 8959: @438228
     /* 438228 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(438243), // Rule ID 5502 //
     /* 438233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438236 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 438241 */     GIR_RootConstrainSelectedInstOperands,
     /* 438242 */     // GIR_Coverage, 5502,
     /* 438242 */     GIR_Done,
     /* 438243 */   // Label 8960: @438243
     /* 438243 */   GIM_Reject,
     /* 438244 */ // Label 8958: @438244
     /* 438244 */ GIM_Reject,
     /* 438245 */ // Label 8934: @438245
     /* 438245 */ GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(438278), // Rule ID 1905 //
     /* 438250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438271 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 438276 */   GIR_RootConstrainSelectedInstOperands,
     /* 438277 */   // GIR_Coverage, 1905,
     /* 438277 */   GIR_Done,
     /* 438278 */ // Label 8961: @438278
     /* 438278 */ GIM_Reject,
     /* 438279 */ // Label 8935: @438279
     /* 438279 */ GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(438333),
     /* 438284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438302 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(438317), // Rule ID 1908 //
     /* 438307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438310 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 438315 */     GIR_RootConstrainSelectedInstOperands,
     /* 438316 */     // GIR_Coverage, 1908,
     /* 438316 */     GIR_Done,
     /* 438317 */   // Label 8963: @438317
     /* 438317 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(438332), // Rule ID 5500 //
     /* 438322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438325 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 438330 */     GIR_RootConstrainSelectedInstOperands,
     /* 438331 */     // GIR_Coverage, 5500,
     /* 438331 */     GIR_Done,
     /* 438332 */   // Label 8964: @438332
     /* 438332 */   GIM_Reject,
     /* 438333 */ // Label 8962: @438333
     /* 438333 */ GIM_Reject,
     /* 438334 */ // Label 8936: @438334
     /* 438334 */ GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(438367), // Rule ID 1906 //
     /* 438339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438360 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 438365 */   GIR_RootConstrainSelectedInstOperands,
     /* 438366 */   // GIR_Coverage, 1906,
     /* 438366 */   GIR_Done,
     /* 438367 */ // Label 8965: @438367
     /* 438367 */ GIM_Reject,
     /* 438368 */ // Label 8937: @438368
     /* 438368 */ GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(438393), // Rule ID 9004 //
     /* 438373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438386 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 438391 */   GIR_RootConstrainSelectedInstOperands,
     /* 438392 */   // GIR_Coverage, 9004,
     /* 438392 */   GIR_Done,
     /* 438393 */ // Label 8966: @438393
     /* 438393 */ GIM_Reject,
     /* 438394 */ // Label 8938: @438394
     /* 438394 */ GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(438419), // Rule ID 8959 //
     /* 438399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438412 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438417 */   GIR_RootConstrainSelectedInstOperands,
     /* 438418 */   // GIR_Coverage, 8959,
     /* 438418 */   GIR_Done,
     /* 438419 */ // Label 8967: @438419
     /* 438419 */ GIM_Reject,
     /* 438420 */ // Label 8939: @438420
     /* 438420 */ GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(438445), // Rule ID 8960 //
     /* 438425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438438 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438443 */   GIR_RootConstrainSelectedInstOperands,
     /* 438444 */   // GIR_Coverage, 8960,
     /* 438444 */   GIR_Done,
     /* 438445 */ // Label 8968: @438445
     /* 438445 */ GIM_Reject,
     /* 438446 */ // Label 8940: @438446
     /* 438446 */ GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(438492),
     /* 438451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438461 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(438476), // Rule ID 8955 //
     /* 438466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438469 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438474 */     GIR_RootConstrainSelectedInstOperands,
     /* 438475 */     // GIR_Coverage, 8955,
     /* 438475 */     GIR_Done,
     /* 438476 */   // Label 8970: @438476
     /* 438476 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(438491), // Rule ID 8961 //
     /* 438481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438484 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 438489 */     GIR_RootConstrainSelectedInstOperands,
     /* 438490 */     // GIR_Coverage, 8961,
     /* 438490 */     GIR_Done,
     /* 438491 */   // Label 8971: @438491
     /* 438491 */   GIM_Reject,
     /* 438492 */ // Label 8969: @438492
     /* 438492 */ GIM_Reject,
     /* 438493 */ // Label 8941: @438493
     /* 438493 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(438518), // Rule ID 9003 //
     /* 438498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438511 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 438516 */   GIR_RootConstrainSelectedInstOperands,
     /* 438517 */   // GIR_Coverage, 9003,
     /* 438517 */   GIR_Done,
     /* 438518 */ // Label 8972: @438518
     /* 438518 */ GIM_Reject,
     /* 438519 */ // Label 8942: @438519
     /* 438519 */ GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(438544), // Rule ID 8957 //
     /* 438524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438537 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438542 */   GIR_RootConstrainSelectedInstOperands,
     /* 438543 */   // GIR_Coverage, 8957,
     /* 438543 */   GIR_Done,
     /* 438544 */ // Label 8973: @438544
     /* 438544 */ GIM_Reject,
     /* 438545 */ // Label 8943: @438545
     /* 438545 */ GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(438591),
     /* 438550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438560 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(438575), // Rule ID 8954 //
     /* 438565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438568 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438573 */     GIR_RootConstrainSelectedInstOperands,
     /* 438574 */     // GIR_Coverage, 8954,
     /* 438574 */     GIR_Done,
     /* 438575 */   // Label 8975: @438575
     /* 438575 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(438590), // Rule ID 8958 //
     /* 438580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438583 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 438588 */     GIR_RootConstrainSelectedInstOperands,
     /* 438589 */     // GIR_Coverage, 8958,
     /* 438589 */     GIR_Done,
     /* 438590 */   // Label 8976: @438590
     /* 438590 */   GIM_Reject,
     /* 438591 */ // Label 8974: @438591
     /* 438591 */ GIM_Reject,
     /* 438592 */ // Label 8944: @438592
     /* 438592 */ GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(438617), // Rule ID 9002 //
     /* 438597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438610 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 438615 */   GIR_RootConstrainSelectedInstOperands,
     /* 438616 */   // GIR_Coverage, 9002,
     /* 438616 */   GIR_Done,
     /* 438617 */ // Label 8977: @438617
     /* 438617 */ GIM_Reject,
     /* 438618 */ // Label 8945: @438618
     /* 438618 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(438664),
     /* 438623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438633 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(438648), // Rule ID 8953 //
     /* 438638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438641 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 438646 */     GIR_RootConstrainSelectedInstOperands,
     /* 438647 */     // GIR_Coverage, 8953,
     /* 438647 */     GIR_Done,
     /* 438648 */   // Label 8979: @438648
     /* 438648 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(438663), // Rule ID 8956 //
     /* 438653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438656 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 438661 */     GIR_RootConstrainSelectedInstOperands,
     /* 438662 */     // GIR_Coverage, 8956,
     /* 438662 */     GIR_Done,
     /* 438663 */   // Label 8980: @438663
     /* 438663 */   GIM_Reject,
     /* 438664 */ // Label 8978: @438664
     /* 438664 */ GIM_Reject,
     /* 438665 */ // Label 8946: @438665
     /* 438665 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(438690), // Rule ID 2402 //
     /* 438670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438683 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 438688 */   GIR_RootConstrainSelectedInstOperands,
     /* 438689 */   // GIR_Coverage, 2402,
     /* 438689 */   GIR_Done,
     /* 438690 */ // Label 8981: @438690
     /* 438690 */ GIM_Reject,
     /* 438691 */ // Label 8947: @438691
     /* 438691 */ GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(438716), // Rule ID 8952 //
     /* 438696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438709 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 438714 */   GIR_RootConstrainSelectedInstOperands,
     /* 438715 */   // GIR_Coverage, 8952,
     /* 438715 */   GIR_Done,
     /* 438716 */ // Label 8982: @438716
     /* 438716 */ GIM_Reject,
     /* 438717 */ // Label 8948: @438717
     /* 438717 */ GIM_Reject,
     /* 438718 */ // Label 154: @438718
     /* 438718 */ GIM_Reject,
     /* 438719 */ }; // Size: 438719 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
